/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","@vscode/policy-watcher","https","zlib","vs/code/electron-main/main"],ee=function(x){for(var e=[],I=0,M=x.length;I<M;I++)e[I]=Z[x[I]];return e};define(Z[128],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(P,g){const h=Math.pow(10,g);return Math.round(P*h)/h}class M{constructor(g,h,w,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=I(Math.max(Math.min(1,v),0),3)}static equals(g,h){return g.r===h.r&&g.g===h.g&&g.b===h.b&&g.a===h.a}}e.RGBA=M;class r{constructor(g,h,w,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=I(Math.max(Math.min(1,h),0),3),this.l=I(Math.max(Math.min(1,w),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(g,h){return g.h===h.h&&g.s===h.s&&g.l===h.l&&g.a===h.a}static fromRGBA(g){const h=g.r/255,w=g.g/255,v=g.b/255,S=g.a,l=Math.max(h,w,v),y=Math.min(h,w,v);let m=0,a=0;const f=(y+l)/2,p=l-y;if(p>0){switch(a=Math.min(f<=.5?p/(2*f):p/(2-2*f),1),l){case h:m=(w-v)/p+(w<v?6:0);break;case w:m=(v-h)/p+2;break;case v:m=(h-w)/p+4;break}m*=60,m=Math.round(m)}return new r(m,a,f,S)}static _hue2rgb(g,h,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?g+(h-g)*6*w:w<1/2?h:w<2/3?g+(h-g)*(2/3-w)*6:g}static toRGBA(g){const h=g.h/360,{s:w,l:v,a:S}=g;let l,y,m;if(w===0)l=y=m=v;else{const a=v<.5?v*(1+w):v+w-v*w,f=2*v-a;l=r._hue2rgb(f,a,h+1/3),y=r._hue2rgb(f,a,h),m=r._hue2rgb(f,a,h-1/3)}return new M(Math.round(l*255),Math.round(y*255),Math.round(m*255),S)}}e.HSLA=r;class R{constructor(g,h,w,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=I(Math.max(Math.min(1,h),0),3),this.v=I(Math.max(Math.min(1,w),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(g,h){return g.h===h.h&&g.s===h.s&&g.v===h.v&&g.a===h.a}static fromRGBA(g){const h=g.r/255,w=g.g/255,v=g.b/255,S=Math.max(h,w,v),l=Math.min(h,w,v),y=S-l,m=S===0?0:y/S;let a;return y===0?a=0:S===h?a=((w-v)/y%6+6)%6:S===w?a=(v-h)/y+2:a=(h-w)/y+4,new R(Math.round(a*60),m,S,g.a)}static toRGBA(g){const{h,s:w,v,a:S}=g,l=v*w,y=l*(1-Math.abs(h/60%2-1)),m=v-l;let[a,f,p]=[0,0,0];return h<60?(a=l,f=y):h<120?(a=y,f=l):h<180?(f=l,p=y):h<240?(f=y,p=l):h<300?(a=y,p=l):h<=360&&(a=l,p=y),a=Math.round((a+m)*255),f=Math.round((f+m)*255),p=Math.round((p+m)*255),new M(a,f,p,S)}}e.HSVA=R;class D{static fromHex(g){return D.Format.CSS.parseHex(g)||D.red}static equals(g,h){return!g&&!h?!0:!g||!h?!1:g.equals(h)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof M)this.rgba=g;else if(g instanceof r)this._hsla=g,this.rgba=r.toRGBA(g);else if(g instanceof R)this._hsva=g,this.rgba=R.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&M.equals(this.rgba,g.rgba)&&r.equals(this.hsla,g.hsla)&&R.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=D._relativeLuminanceForComponent(this.rgba.r),h=D._relativeLuminanceForComponent(this.rgba.g),w=D._relativeLuminanceForComponent(this.rgba.b),v=.2126*g+.7152*h+.0722*w;return I(v,4)}static _relativeLuminanceForComponent(g){const h=g/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(g){const h=this.getRelativeLuminance(),w=g.getRelativeLuminance();return h>w?(h+.05)/(w+.05):(w+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const h=this.getRelativeLuminance(),w=g.getRelativeLuminance();return h>w}isDarkerThan(g){const h=this.getRelativeLuminance(),w=g.getRelativeLuminance();return h<w}lighten(g){return new D(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new D(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:h,g:w,b:v,a:S}=this.rgba;return new D(new M(h,w,v,S*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const h=g.rgba,w=this.rgba.a,v=h.a,S=w+v*(1-w);if(S<1e-6)return D.transparent;const l=this.rgba.r*w/S+h.r*v*(1-w)/S,y=this.rgba.g*w/S+h.g*v*(1-w)/S,m=this.rgba.b*w/S+h.b*v*(1-w)/S;return new D(new M(l,y,m,S))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:h,g:w,b:v,a:S}=this.rgba;return new D(new M(g.rgba.r-S*(g.rgba.r-h),g.rgba.g-S*(g.rgba.g-w),g.rgba.b-S*(g.rgba.b-v),1))}flatten(...g){const h=g.reduceRight((w,v)=>D._flatten(v,w));return D._flatten(this,h)}static _flatten(g,h){const w=1-g.rgba.a;return new D(new M(w*h.rgba.r+g.rgba.a*g.rgba.r,w*h.rgba.g+g.rgba.a*g.rgba.g,w*h.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(g,h,w){if(g.isLighterThan(h))return g;w=w||.5;const v=g.getRelativeLuminance(),S=h.getRelativeLuminance();return w=w*(S-v)/S,g.lighten(w)}static getDarkerColor(g,h,w){if(g.isDarkerThan(h))return g;w=w||.5;const v=g.getRelativeLuminance(),S=h.getRelativeLuminance();return w=w*(v-S)/v,g.darken(w)}}D.white=new D(new M(255,255,255,1)),D.black=new D(new M(0,0,0,1)),D.red=new D(new M(255,0,0,1)),D.blue=new D(new M(0,0,255,1)),D.green=new D(new M(0,255,0,1)),D.cyan=new D(new M(0,255,255,1)),D.lightgrey=new D(new M(211,211,211,1)),D.transparent=new D(new M(0,0,0,0)),e.Color=D,function(P){let g;(function(h){let w;(function(v){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=S;function l(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=l;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=y;function m(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=m;function a(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function f(t){return`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}`}v.formatHex=f;function p(t,c=!1){return c&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}${a(Math.round(t.rgba.a*255))}`}v.formatHexA=p;function b(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=b;function E(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const i=16*k(t.charCodeAt(1))+k(t.charCodeAt(2)),n=16*k(t.charCodeAt(3))+k(t.charCodeAt(4)),o=16*k(t.charCodeAt(5))+k(t.charCodeAt(6));return new P(new M(i,n,o,1))}if(c===9){const i=16*k(t.charCodeAt(1))+k(t.charCodeAt(2)),n=16*k(t.charCodeAt(3))+k(t.charCodeAt(4)),o=16*k(t.charCodeAt(5))+k(t.charCodeAt(6)),u=16*k(t.charCodeAt(7))+k(t.charCodeAt(8));return new P(new M(i,n,o,u/255))}if(c===4){const i=k(t.charCodeAt(1)),n=k(t.charCodeAt(2)),o=k(t.charCodeAt(3));return new P(new M(16*i+i,16*n+n,16*o+o))}if(c===5){const i=k(t.charCodeAt(1)),n=k(t.charCodeAt(2)),o=k(t.charCodeAt(3)),u=k(t.charCodeAt(4));return new P(new M(16*i+i,16*n+n,16*o+o,(16*u+u)/255))}return null}v.parseHex=E;function k(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=h.CSS||(h.CSS={}))})(g=P.Format||(P.Format={}))}(D=e.Color||(e.Color={})),e.Color=D}),define(Z[54],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(D){return(P,g,h)=>{let w=null,v=null;if(typeof h.value=="function"?(w="value",v=h.value):typeof h.get=="function"&&(w="get",v=h.get),!v)throw new Error("not supported");h[w]=D(v,g)}}function M(D,P,g){let h=null,w=null;if(typeof g.value=="function"?(h="value",w=g.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(h="get",w=g.get),!w)throw new Error("not supported");const v=`$memoize$${P}`;g[h]=function(...S){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,S)}),this[v]}}e.memoize=M;function r(D,P,g){return I((h,w)=>{const v=`$debounce$${w}`,S=`$debounce$result$${w}`;return function(...l){this[S]||(this[S]=g?g():void 0),clearTimeout(this[v]),P&&(this[S]=P(this[S],...l),l=[this[S]]),this[v]=setTimeout(()=>{h.apply(this,l),this[S]=g?g():void 0},D)}})}e.debounce=r;function R(D,P,g){return I((h,w)=>{const v=`$throttle$timer$${w}`,S=`$throttle$result$${w}`,l=`$throttle$lastRun$${w}`,y=`$throttle$pending$${w}`;return function(...m){if(this[S]||(this[S]=g?g():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),P&&(this[S]=P(this[S],...m)),this[y])return;const a=this[l]+D;a<=Date.now()?(this[l]=Date.now(),h.apply(this,[this[S]]),this[S]=g?g():void 0):(this[y]=!0,this[v]=setTimeout(()=>{this[y]=!1,this[l]=Date.now(),h.apply(this,[this[S]]),this[S]=g?g():void 0},a-Date.now()))}})}e.throttle=R}),define(Z[13],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?E.isErrorNoTelemetry(c)?new E(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(i=>{i(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=I,e.errorHandler=new I;function M(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=M;function r(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function R(t){h(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function D(t){h(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function P(t){if(t instanceof Error){const{name:c,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:c,message:i,stack:n,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const g="Canceled";function h(t){return t instanceof w?!0:t instanceof Error&&t.name===g&&t.message===g}e.isCancellationError=h;class w extends Error{constructor(){super(g),this.name=this.message}}e.CancellationError=w;function v(){const t=new Error(g);return t.name=t.message,t}e.canceled=v;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function l(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=l;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function m(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=m;function a(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=a;class f extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=f;class p extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=p;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class E extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof E)return c;const i=new E;return i.message=c.message,i.stack=c.stack,i}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class k extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype);debugger}}e.BugIndicatingError=k}),define(Z[25],ee([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function M(N,j=0){return N[N.length-(1+j)]}e.tail=M;function r(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=r;function R(N,j,G=(re,ue)=>re===ue){if(N===j)return!0;if(!N||!j||N.length!==j.length)return!1;for(let re=0,ue=N.length;re<ue;re++)if(!G(N[re],j[re]))return!1;return!0}e.equals=R;function D(N,j){const G=N.length-1;j<G&&(N[j]=N[G]),N.pop()}e.removeFastWithoutKeepingOrder=D;function P(N,j,G){return g(N.length,re=>G(N[re],j))}e.binarySearch=P;function g(N,j){let G=0,re=N-1;for(;G<=re;){const ue=(G+re)/2|0,ye=j(ue);if(ye<0)G=ue+1;else if(ye>0)re=ue-1;else return ue}return-(G+1)}e.binarySearch2=g;function h(N,j){let G=0,re=N.length;if(re===0)return 0;for(;G<re;){const ue=Math.floor((G+re)/2);j(N[ue])?re=ue:G=ue+1}return G}e.findFirstInSorted=h;function w(N,j,G){if(N=N|0,N>=j.length)throw new TypeError("invalid index");const re=j[Math.floor(j.length*Math.random())],ue=[],ye=[],Me=[];for(const Te of j){const Ae=G(Te,re);Ae<0?ue.push(Te):Ae>0?ye.push(Te):Me.push(Te)}return N<ue.length?w(N,ue,G):N<ue.length+Me.length?Me[0]:w(N-(ue.length+Me.length),ye,G)}e.quickSelect=w;function v(N,j){const G=[];let re;for(const ue of N.slice(0).sort(j))!re||j(re[0],ue)!==0?(re=[ue],G.push(re)):re.push(ue);return G}e.groupBy=v;function S(N,j,G){const re=[];function ue(Te,Ae,We){if(Ae===0&&We.length===0)return;const me=re[re.length-1];me&&me.start+me.deleteCount===Te?(me.deleteCount+=Ae,me.toInsert.push(...We)):re.push({start:Te,deleteCount:Ae,toInsert:We})}let ye=0,Me=0;for(;;){if(ye===N.length){ue(ye,0,j.slice(Me));break}if(Me===j.length){ue(ye,N.length-ye,[]);break}const Te=N[ye],Ae=j[Me],We=G(Te,Ae);We===0?(ye+=1,Me+=1):We<0?(ue(ye,1,[]),ye+=1):We>0&&(ue(ye,0,[Ae]),Me+=1)}return re}e.sortedDiff=S;function l(N,j,G){const re=S(N,j,G),ue=[],ye=[];for(const Me of re)ue.push(...N.slice(Me.start,Me.start+Me.deleteCount)),ye.push(...Me.toInsert);return{removed:ue,added:ye}}e.delta=l;function y(N,j,G){if(G===0)return[];const re=N.slice(0,G).sort(j);return a(N,j,re,G,N.length),re}e.top=y;function m(N,j,G,re,ue){return G===0?Promise.resolve([]):new Promise((ye,Me)=>{(async()=>{const Te=N.length,Ae=N.slice(0,G).sort(j);for(let We=G,me=Math.min(G+re,Te);We<Te;We=me,me=Math.min(me+re,Te)){if(We>G&&await new Promise(pe=>setTimeout(pe)),ue&&ue.isCancellationRequested)throw new I.CancellationError;a(N,j,Ae,We,me)}return Ae})().then(ye,Me)})}e.topAsync=m;function a(N,j,G,re,ue){for(const ye=G.length;re<ue;re++){const Me=N[re];if(j(Me,G[ye-1])<0){G.pop();const Te=h(G,Ae=>j(Me,Ae)<0);G.splice(Te,0,Me)}}}function f(N){return N.filter(j=>!!j)}e.coalesce=f;function p(N){let j=0;for(let G=0;G<N.length;G++)N[G]&&(N[j]=N[G],j+=1);N.length=j}e.coalesceInPlace=p;function b(N,j,G){N.splice(G,0,N.splice(j,1)[0])}e.move=b;function E(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=E;function k(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=k;function t(N,j=G=>G){const G=new Set;return N.filter(re=>{const ue=j(re);return G.has(ue)?!1:(G.add(ue),!0)})}e.distinct=t;function c(N){const j=new Set;return G=>{const re=N(G);return j.has(re)?!1:(j.add(re),!0)}}e.uniqueFilter=c;function i(N,j){const G=n(N,j);if(G!==-1)return N[G]}e.findLast=i;function n(N,j){for(let G=N.length-1;G>=0;G--){const re=N[G];if(j(re))return G}return-1}e.lastIndex=n;function o(N,j){return N.length>0?N[0]:j}e.firstOrDefault=o;function u(N,j){return N.length>0?N[N.length-1]:j}e.lastOrDefault=u;function s(N,j,G=(re,ue)=>re===ue){let re=0;for(let ue=0,ye=Math.min(N.length,j.length);ue<ye&&G(N[ue],j[ue]);ue++)re++;return re}e.commonPrefixLength=s;function d(N){return[].concat(...N)}e.flatten=d;function C(N,j){let G=typeof j=="number"?N:0;typeof j=="number"?G=N:(G=0,j=N);const re=[];if(G<=j)for(let ue=G;ue<j;ue++)re.push(ue);else for(let ue=G;ue>j;ue--)re.push(ue);return re}e.range=C;function L(N,j,G){return N.reduce((re,ue)=>(re[j(ue)]=G?G(ue):ue,re),Object.create(null))}e.index=L;function O(N,j){return N.push(j),()=>F(N,j)}e.insert=O;function F(N,j){const G=N.indexOf(j);if(G>-1)return N.splice(G,1),j}e.remove=F;function z(N,j,G){const re=N.slice(0,j),ue=N.slice(j);return re.concat(G,ue)}e.arrayInsert=z;function q(N,j){let G;if(typeof j=="number"){let re=j;G=()=>{const ue=Math.sin(re++)*179426549;return ue-Math.floor(ue)}}else G=Math.random;for(let re=N.length-1;re>0;re-=1){const ue=Math.floor(G()*(re+1)),ye=N[re];N[re]=N[ue],N[ue]=ye}}e.shuffle=q;function ie(N,j){const G=N.indexOf(j);G>-1&&(N.splice(G,1),N.unshift(j))}e.pushToStart=ie;function se(N,j){const G=N.indexOf(j);G>-1&&(N.splice(G,1),N.push(j))}e.pushToEnd=se;function oe(N,j){for(const G of j)N.push(G)}e.pushMany=oe;function he(N,j){return Array.isArray(N)?N.map(j):j(N)}e.mapArrayOrNot=he;function le(N){return Array.isArray(N)?N:[N]}e.asArray=le;function ge(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=ge;function V(N,j){for(const G of N){const re=j(G);if(re!==void 0)return re}}e.mapFind=V;function B(N,j,G){const re=H(N,j),ue=N.length,ye=G.length;N.length=ue+ye;for(let Me=ue-1;Me>=re;Me--)N[Me+ye]=N[Me];for(let Me=0;Me<ye;Me++)N[Me+re]=G[Me]}e.insertInto=B;function T(N,j,G,re){const ue=H(N,j),ye=N.splice(ue,G);return B(N,ue,re),ye}e.splice=T;function H(N,j){return j<0?Math.max(j+N.length,0):Math.min(j,N.length)}var Y;(function(N){function j(ue){return ue<0}N.isLessThan=j;function G(ue){return ue>0}N.isGreaterThan=G;function re(ue){return ue===0}N.isNeitherLessOrGreaterThan=re,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function te(N,j){return(G,re)=>j(N(G),N(re))}e.compareBy=te;function ne(...N){return(j,G)=>{for(const re of N){const ue=re(j,G);if(!Y.isNeitherLessOrGreaterThan(ue))return ue}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=ne;const U=(N,j)=>N-j;e.numberComparator=U;function A(N,j){if(N.length===0)return;let G=N[0];for(let re=1;re<N.length;re++){const ue=N[re];j(ue,G)>0&&(G=ue)}return G}e.findMaxBy=A;function W(N,j){if(N.length===0)return;let G=N[0];for(let re=1;re<N.length;re++){const ue=N[re];j(ue,G)>=0&&(G=ue)}return G}e.findLastMaxBy=W;function _(N,j){return A(N,(G,re)=>-j(G,re))}e.findMinBy=_;class ${constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let G=this.firstIdx;for(;G<this.items.length&&j(this.items[G]);)G++;const re=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,re}takeFromEndWhile(j){let G=this.lastIdx;for(;G>=0&&j(this.items[G]);)G--;const re=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,re}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}removeLast(){const j=this.items[this.lastIdx];return this.lastIdx--,j}takeCount(j){const G=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,G}}e.ArrayQueue=$;class Q{constructor(j){this.iterate=j}forEach(j){this.iterate(G=>(j(G),!0))}toArray(){const j=[];return this.iterate(G=>(j.push(G),!0)),j}filter(j){return new Q(G=>this.iterate(re=>j(re)?G(re):!0))}map(j){return new Q(G=>this.iterate(re=>G(j(re))))}some(j){let G=!1;return this.iterate(re=>(G=j(re),!G)),G}findFirst(j){let G;return this.iterate(re=>j(re)?(G=re,!1):!0),G}findLast(j){let G;return this.iterate(re=>(j(re)&&(G=re),!0)),G}findLastMaxBy(j){let G,re=!0;return this.iterate(ue=>((re||Y.isGreaterThan(j(ue,G)))&&(re=!1,G=ue),!0)),G}}Q.empty=new Q(N=>{}),e.CallbackIterable=Q}),define(Z[129],ee([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function M(g,h){if(!g)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=M;function r(g,h="Unreachable"){throw new Error(h)}e.assertNever=r;function R(g){if(!g)throw new I.BugIndicatingError("Assertion Failed")}e.assert=R;function D(g){if(!g()){debugger;g(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(g,h){let w=0;for(;w<g.length-1;){const v=g[w],S=g[w+1];if(!h(v,S))return!1;w++}return!0}e.checkAdjacentItems=P}),define(Z[50],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(M){const r=this;let R=!1,D;return function(){return R||(R=!0,D=M.apply(r,arguments)),D}}e.once=I}),define(Z[70],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(M){function r(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}M.is=r;const R=Object.freeze([]);function D(){return R}M.empty=D;function*P(E){yield E}M.single=P;function g(E){return r(E)?E:P(E)}M.wrap=g;function h(E){return E||R}M.from=h;function w(E){return!E||E[Symbol.iterator]().next().done===!0}M.isEmpty=w;function v(E){return E[Symbol.iterator]().next().value}M.first=v;function S(E,k){for(const t of E)if(k(t))return!0;return!1}M.some=S;function l(E,k){for(const t of E)if(k(t))return t}M.find=l;function*y(E,k){for(const t of E)k(t)&&(yield t)}M.filter=y;function*m(E,k){let t=0;for(const c of E)yield k(c,t++)}M.map=m;function*a(...E){for(const k of E)for(const t of k)yield t}M.concat=a;function f(E,k,t){let c=t;for(const i of E)c=k(c,i);return c}M.reduce=f;function*p(E,k,t=E.length){for(k<0&&(k+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);k<t;k++)yield E[k]}M.slice=p;function b(E,k=Number.POSITIVE_INFINITY){const t=[];if(k===0)return[t,E];const c=E[Symbol.iterator]();for(let i=0;i<k;i++){const n=c.next();if(n.done)return[t,M.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return c}}]}M.consume=b})(I=e.Iterable||(e.Iterable={}))}),define(Z[43],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(t,c=!1){let i=0;const n=t.length;let o="",u=0,s=16,d=0;function C(se){let oe=0,he=0;for(;oe<se;){const le=t.charCodeAt(i);if(le>=48&&le<=57)he=he*16+le-48;else if(le>=65&&le<=70)he=he*16+le-65+10;else if(le>=97&&le<=102)he=he*16+le-97+10;else break;i++,oe++}return oe<se&&(he=-1),he}function L(se){i=se,o="",u=0,s=16,d=0}function O(){const se=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&h(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&h(t.charCodeAt(i)))for(i++;i<t.length&&h(t.charCodeAt(i));)i++;else return d=3,t.substring(se,i);let oe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&h(t.charCodeAt(i))){for(i++;i<t.length&&h(t.charCodeAt(i));)i++;oe=i}else d=3;return t.substring(se,oe)}function F(){let se="",oe=i;for(;;){if(i>=n){se+=t.substring(oe,i),d=2;break}const he=t.charCodeAt(i);if(he===34){se+=t.substring(oe,i),i++;break}if(he===92){if(se+=t.substring(oe,i),i++,i>=n){d=2;break}switch(t.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const ge=C(4);ge>=0?se+=String.fromCharCode(ge):d=4;break}default:d=5}oe=i;continue}if(he>=0&&he<=31)if(g(he)){se+=t.substring(oe,i),d=2;break}else d=6;i++}return se}function z(){if(o="",d=0,u=i,i>=n)return u=n,s=17;let se=t.charCodeAt(i);if(P(se)){do i++,o+=String.fromCharCode(se),se=t.charCodeAt(i);while(P(se));return s=15}if(g(se))return i++,o+=String.fromCharCode(se),se===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),s=14;switch(se){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,o=F(),s=10;case 47:{const oe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return o=t.substring(oe,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const he=n-1;let le=!1;for(;i<he;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,le=!0;break}i++}return le||(i++,d=1),o=t.substring(oe,i),s=13}return o+=String.fromCharCode(se),i++,s=16}case 45:if(o+=String.fromCharCode(se),i++,i===n||!h(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),s=11;default:for(;i<n&&q(se);)i++,se=t.charCodeAt(i);if(u!==i){switch(o=t.substring(u,i),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(se),i++,s=16}}function q(se){if(P(se)||g(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let se;do se=z();while(se>=12&&se<=15);return se}return{setPosition:L,getPosition:()=>i,scan:c?ie:z,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>d}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function h(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function v(t,c){const i=[],n=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function d(C,L,O,F){u.value=C,u.offset=L,u.length=O,u.type=F,u.colonOffset=void 0,o=u}try{b(t,{onObjectBegin:(C,L)=>{if(c<=C)throw n;o=void 0,s=c>C,i.push("")},onObjectProperty:(C,L,O)=>{if(c<L||(d(C,L,O,"property"),i[i.length-1]=C,c<=L+O))throw n},onObjectEnd:(C,L)=>{if(c<=C)throw n;o=void 0,i.pop()},onArrayBegin:(C,L)=>{if(c<=C)throw n;o=void 0,i.push(0)},onArrayEnd:(C,L)=>{if(c<=C)throw n;o=void 0,i.pop()},onLiteralValue:(C,L,O)=>{if(c<L||(d(C,L,O,k(C)),c<=L+O))throw n},onSeparator:(C,L,O)=>{if(c<=L)throw n;if(C===":"&&o&&o.type==="property")o.colonOffset=L,s=!1,o=void 0;else if(C===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(s=!0,i[i.length-1]=""),o=void 0}}})}catch(C){if(C!==n)throw C}return{path:i,previousNode:o,isAtPropertyKey:s,matches:C=>{let L=0;for(let O=0;L<C.length&&O<i.length;O++)if(C[L]===i[O]||C[L]==="*")L++;else if(C[L]!=="**")return!1;return L===C.length}}}e.getLocation=v;function S(t,c=[],i=R.DEFAULT){let n=null,o=[];const u=[];function s(C){Array.isArray(o)?o.push(C):n!==null&&(o[n]=C)}return b(t,{onObjectBegin:()=>{const C={};s(C),u.push(o),o=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const C=[];s(C),u.push(o),o=C,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:s,onError:(C,L,O)=>{c.push({error:C,offset:L,length:O})}},i),o[0]}e.parse=S;function l(t,c=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(C){n.type==="property"&&(n.length=C-n.offset,n=n.parent)}function u(C){return n.children.push(C),C}b(t,{onObjectBegin:C=>{n=u({type:"object",offset:C,length:-1,parent:n,children:[]})},onObjectProperty:(C,L,O)=>{n=u({type:"property",offset:L,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:C,offset:L,length:O,parent:n})},onObjectEnd:(C,L)=>{n.length=C+L-n.offset,n=n.parent,o(C+L)},onArrayBegin:(C,L)=>{n=u({type:"array",offset:C,length:-1,parent:n,children:[]})},onArrayEnd:(C,L)=>{n.length=C+L-n.offset,n=n.parent,o(C+L)},onLiteralValue:(C,L,O)=>{u({type:k(C),offset:L,length:O,parent:n,value:C}),o(L+O)},onSeparator:(C,L,O)=>{n.type==="property"&&(C===":"?n.colonOffset=L:C===","&&o(L))},onError:(C,L,O)=>{c.push({error:C,offset:L,length:O})}},i);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=l;function y(t,c){if(!t)return;let i=t;for(const n of c)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===n){i=u.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=y;function m(t){if(!t.parent||!t.parent.children)return[];const c=m(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=m;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const c=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(c[i.children[0].value]=a(n))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=a;function f(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=f;function p(t,c,i=!1){if(f(t,c,i)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=c;o++){const u=p(n[o],c,i);if(u)return u}return t}}e.findNodeAtOffset=p;function b(t,c,i=R.DEFAULT){const n=D(t,!1);function o(te){return te?()=>te(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(te){return te?ne=>te(ne,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=o(c.onObjectBegin),d=u(c.onObjectProperty),C=o(c.onObjectEnd),L=o(c.onArrayBegin),O=o(c.onArrayEnd),F=u(c.onLiteralValue),z=u(c.onSeparator),q=o(c.onComment),ie=u(c.onError),se=i&&i.disallowComments,oe=i&&i.allowTrailingComma;function he(){for(;;){const te=n.scan();switch(n.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:se||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(te){case 12:case 13:se?le(10):q();break;case 16:le(1);break;case 15:case 14:break;default:return te}}}function le(te,ne=[],U=[]){if(ie(te),ne.length+U.length>0){let A=n.getToken();for(;A!==17;){if(ne.indexOf(A)!==-1){he();break}else if(U.indexOf(A)!==-1)break;A=he()}}}function ge(te){const ne=n.getTokenValue();return te?F(ne):d(ne),he(),!0}function V(){switch(n.getToken()){case 11:{let te=0;try{te=JSON.parse(n.getTokenValue()),typeof te!="number"&&(le(2),te=0)}catch{le(2)}F(te);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return he(),!0}function B(){return n.getToken()!==10?(le(3,[],[2,5]),!1):(ge(!1),n.getToken()===6?(z(":"),he(),Y()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function T(){s(),he();let te=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(te||le(4,[],[]),z(","),he(),n.getToken()===2&&oe)break}else te&&le(6,[],[]);B()||le(4,[],[2,5]),te=!0}return C(),n.getToken()!==2?le(7,[2],[]):he(),!0}function H(){L(),he();let te=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(te||le(4,[],[]),z(","),he(),n.getToken()===4&&oe)break}else te&&le(6,[],[]);Y()||le(4,[],[4,5]),te=!0}return O(),n.getToken()!==4?le(8,[4],[]):he(),!0}function Y(){switch(n.getToken()){case 3:return H();case 1:return T();case 10:return ge(!0);default:return V()}}return he(),n.getToken()===17?i.allowEmptyContent?!0:(le(4,[],[]),!1):Y()?(n.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=b;function E(t,c){const i=D(t),n=[];let o,u=0,s;do switch(s=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:u!==s&&n.push(t.substring(u,s)),c!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,c)),u=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=E;function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(Z[130],ee([0,1,43]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function M(h,w,v){let S,l,y,m,a;if(w){for(m=w.offset,a=m+w.length,y=m;y>0&&!g(h,y-1);)y--;let s=a;for(;s<h.length&&!g(h,s);)s++;l=h.substring(y,s),S=D(l,v)}else l=h,S=0,y=0,m=0,a=h.length;const f=P(v,h);let p=!1,b=0,E;v.insertSpaces?E=R(" ",v.tabSize||4):E="	";const k=(0,I.createScanner)(l,!1);let t=!1;function c(){return f+R(E,S+b)}function i(){let s=k.scan();for(p=!1;s===15||s===14;)p=p||s===14,s=k.scan();return t=s===16||k.getTokenError()!==0,s}const n=[];function o(s,d,C){!t&&d<a&&C>m&&h.substring(d,C)!==s&&n.push({offset:d,length:C-d,content:s})}let u=i();if(u!==17){const s=k.getTokenOffset()+y,d=R(E,S);o(d,y,s)}for(;u!==17;){let s=k.getTokenOffset()+k.getTokenLength()+y,d=i(),C="";for(;!p&&(d===12||d===13);){const O=k.getTokenOffset()+y;o(" ",s,O),s=k.getTokenOffset()+k.getTokenLength()+y,C=d===12?c():"",d=i()}if(d===2)u!==1&&(b--,C=c());else if(d===4)u!==3&&(b--,C=c());else{switch(u){case 3:case 1:b++,C=c();break;case 5:case 12:C=c();break;case 13:p?C=c():C=" ";break;case 6:C=" ";break;case 10:if(d===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?C=" ":d!==5&&d!==17&&(t=!0);break;case 16:t=!0;break}p&&(d===12||d===13)&&(C=c())}const L=k.getTokenOffset()+y;o(C,s,L),u=d}return n}e.format=M;function r(h,w){const v=JSON.stringify(h,void 0,w.insertSpaces?w.tabSize||4:"	");return w.eol!==void 0?v.replace(/\r\n|\r|\n/g,w.eol):v}e.toFormattedString=r;function R(h,w){let v="";for(let S=0;S<w;S++)v+=h;return v}function D(h,w){let v=0,S=0;const l=w.tabSize||4;for(;v<h.length;){const y=h.charAt(v);if(y===" ")S++;else if(y==="	")S+=l;else break;v++}return Math.floor(S/l)}function P(h,w){for(let v=0;v<w.length;v++){const S=w.charAt(v);if(S==="\r")return v+1<w.length&&w.charAt(v+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=P;function g(h,w){return`\r
`.indexOf(h.charAt(w))!==-1}e.isEOL=g}),define(Z[131],ee([0,1,43,130]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(h,w,v){return R(h,w,void 0,v)}e.removeProperty=r;function R(h,w,v,S,l){const y=w.slice(),m=[],a=(0,I.parseTree)(h,m);let f,p;for(;y.length>0&&(p=y.pop(),f=(0,I.findNodeAtLocation)(a,y),f===void 0&&v!==void 0);)typeof p=="string"?v={[p]:v}:v=[v];if(f)if(f.type==="object"&&typeof p=="string"&&Array.isArray(f.children)){const b=(0,I.findNodeAtLocation)(f,[p]);if(b!==void 0)if(v===void 0){if(!b.parent)throw new Error("Malformed AST");const E=f.children.indexOf(b.parent);let k,t=b.parent.offset+b.parent.length;if(E>0){const c=f.children[E-1];k=c.offset+c.length}else k=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return D(h,{offset:k,length:t-k,content:""},S)}else return D(h,{offset:b.offset,length:b.length,content:JSON.stringify(v)},S);else{if(v===void 0)return[];const E=`${JSON.stringify(p)}: ${JSON.stringify(v)}`,k=l?l(f.children.map(c=>c.children[0].value)):f.children.length;let t;if(k>0){const c=f.children[k-1];t={offset:c.offset+c.length,length:0,content:","+E}}else f.children.length===0?t={offset:f.offset+1,length:0,content:E}:t={offset:f.offset+1,length:0,content:E+","};return D(h,t,S)}}else if(f.type==="array"&&typeof p=="number"&&Array.isArray(f.children))if(v!==void 0){const b=`${JSON.stringify(v)}`;let E;if(f.children.length===0||p===0)E={offset:f.offset+1,length:0,content:f.children.length===0?b:b+","};else{const k=p===-1||p>f.children.length?f.children.length:p,t=f.children[k-1];E={offset:t.offset+t.length,length:0,content:","+b}}return D(h,E,S)}else{const b=p,E=f.children[b];let k;if(f.children.length===1)k={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===b){const t=f.children[b-1],c=t.offset+t.length,i=f.offset+f.length;k={offset:c,length:i-2-c,content:""}}else k={offset:E.offset,length:f.children[b+1].offset-E.offset,content:""};return D(h,k,S)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${f.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(h,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(v)},S)}}e.setProperty=R;function D(h,w,v){let S=P(h,w),l=w.offset,y=w.offset+w.content.length;if(w.length===0||w.content.length===0){for(;l>0&&!(0,M.isEOL)(S,l-1);)l--;for(;y<S.length&&!(0,M.isEOL)(S,y);)y++}const m=(0,M.format)(S,{offset:l,length:y-l},v);for(let f=m.length-1;f>=0;f--){const p=m[f];S=P(S,p),l=Math.min(l,p.offset),y=Math.max(y,p.offset+p.length),y+=p.content.length-p.length}const a=h.length-(S.length-y)-l;return[{offset:l,length:a,content:S.substring(l,y)}]}e.withFormatting=D;function P(h,w){return h.substring(0,w.offset)+w.content+h.substring(w.offset+w.length)}e.applyEdit=P;function g(h,w){const v=w.slice(0).sort((l,y)=>{const m=l.offset-y.offset;return m===0?l.length-y.length:m});let S=h.length;for(let l=v.length-1;l>=0;l--){const y=v[l];if(y.offset+y.length<=S)h=P(h,y);else throw new Error("Overlapping edit");S=y.offset}return h}e.applyEdits=g}),define(Z[132],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(Z[2],ee([0,1,50,70]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const r=!1;let R=null;function D(u){R=u}if(e.setDisposableTracker=D,r){const u="__is_disposable_tracked__";D(new class{trackDisposable(s){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[u]||console.log(d)},3e3)}setParent(s,d){if(s&&s!==p.None)try{s[u]=!0}catch{}}markAsDisposed(s){if(s&&s!==p.None)try{s[u]=!0}catch{}}markAsSingleton(s){}})}function P(u){return R?.trackDisposable(u),u}function g(u){R?.markAsDisposed(u)}function h(u,s){R?.setParent(u,s)}function w(u,s){if(!!R)for(const d of u)R.setParent(d,s)}function v(u){return R?.markAsSingleton(u),u}e.markAsSingleton=v;function S(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=S;function l(u){if(M.Iterable.is(u)){const s=[];for(const d of u)if(d)try{d.dispose()}catch(C){s.push(C)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=l;function y(u){for(const s of u)S(s)&&s.dispose();return[]}e.disposeIfDisposable=y;function m(...u){const s=a(()=>l(u));return w(u,s),s}e.combinedDisposable=m;function a(u){const s=P({dispose:(0,I.once)(()=>{g(s),u()})});return s}e.toDisposable=a;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{l(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return h(s,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}f.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=f;class p{constructor(){this._store=new f,P(this),h(this._store,this)}dispose(){g(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}p.None=Object.freeze({dispose(){}}),e.Disposable=p;class b{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&h(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&h(s,null),s}}e.MutableDisposable=b;class E{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=E;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(s){let d=s;return this.unset=()=>d=void 0,this.isset=()=>d!==void 0,this.dispose=()=>{d&&(d(),d=void 0,g(this))},this}}e.SafeDisposable=k;class t{constructor(){this.references=new Map}acquire(s,...d){let C=this.references.get(s);C||(C={counter:0,object:this.createReferencedObject(s,...d)},this.references.set(s,C));const{object:L}=C,O=(0,I.once)(()=>{--C.counter===0&&(this.destroyReferencedObject(s,C.object),this.references.delete(s))});return C.counter++,{object:L,dispose:O}}}e.ReferenceCollection=t;class c{constructor(s){this.referenceCollection=s}async acquire(s,...d){const C=this.referenceCollection.acquire(s,...d);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(L){throw C.dispose(),L}}}e.AsyncReferenceCollection=c;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function n(u){const s=new f;try{u(s)}finally{s.dispose()}}e.disposeOnReturn=n;class o{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{l(this._store.values())}finally{this._store.clear()}}has(s){return this._store.has(s)}get(s){return this._store.get(s)}set(s,d,C=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this._store.get(s)?.dispose(),this._store.set(s,d)}deleteAndDispose(s){this._store.get(s)?.dispose(),this._store.delete(s)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=o}),define(Z[100],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(R){this.element=R,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class M{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let R=this._first;for(;R!==I.Undefined;){const D=R.next;R.prev=I.Undefined,R.next=I.Undefined,R=D}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const P=new I(R);if(this._first===I.Undefined)this._first=P,this._last=P;else if(D){const h=this._last;this._last=P,P.prev=h,h.next=P}else{const h=this._first;this._first=P,P.next=h,h.prev=P}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(P))}}shift(){if(this._first!==I.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==I.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==I.Undefined&&R.next!==I.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===I.Undefined&&R.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):R.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):R.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==I.Undefined;)yield R.element,R=R.next}}e.LinkedList=M}),define(Z[35],ee([0,1]),function(x,e){"use strict";var I,M,r;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(y,m,a){let f=y.get(m);return f===void 0&&(f=a,y.set(m,f)),f}e.getOrSet=R;function D(y){const m=[];return y.forEach((a,f)=>{m.push(`${f} => ${a}`)}),`Map(${y.size}) {${m.join(", ")}}`}e.mapToString=D;function P(y){const m=[];return y.forEach(a=>{m.push(a)}),`Set(${y.size}) {${m.join(", ")}}`}e.setToString=P;class g{constructor(m,a){this.uri=m,this.value=a}}class h{constructor(m,a){this[I]="ResourceMap",m instanceof h?(this.map=new Map(m.map),this.toKey=a??h.defaultToKey):(this.map=new Map,this.toKey=m??h.defaultToKey)}set(m,a){return this.map.set(this.toKey(m),new g(m,a)),this}get(m){return this.map.get(this.toKey(m))?.value}has(m){return this.map.has(this.toKey(m))}get size(){return this.map.size}clear(){this.map.clear()}delete(m){return this.map.delete(this.toKey(m))}forEach(m,a){typeof a<"u"&&(m=m.bind(a));for(const[f,p]of this.map)m(p.value,p.uri,this)}*values(){for(const m of this.map.values())yield m.value}*keys(){for(const m of this.map.values())yield m.uri}*entries(){for(const m of this.map.values())yield[m.uri,m.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.map)yield[m.uri,m.value]}}h.defaultToKey=y=>y.toString(),e.ResourceMap=h;class w{constructor(m,a){this[M]="ResourceSet",!m||typeof m=="function"?this._map=new h(m):(this._map=new h(a),m.forEach(this.add,this))}get size(){return this._map.size}add(m){return this._map.set(m,m),this}clear(){this._map.clear()}delete(m){return this._map.delete(m)}forEach(m,a){this._map.forEach((f,p)=>m.call(a,p,p,this))}has(m){return this._map.has(m)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var v;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class S{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(m){return this._map.has(m)}get(m,a=0){const f=this._map.get(m);if(!!f)return a!==0&&this.touch(f,a),f.value}set(m,a,f=0){let p=this._map.get(m);if(p)p.value=a,f!==0&&this.touch(p,f);else{switch(p={key:m,value:a,next:void 0,previous:void 0},f){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(m,p),this._size++}return this}delete(m){return!!this.remove(m)}remove(m){const a=this._map.get(m);if(!!a)return this._map.delete(m),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const m=this._head;return this._map.delete(m.key),this.removeItem(m),this._size--,m.value}forEach(m,a){const f=this._state;let p=this._head;for(;p;){if(a?m.bind(a)(p.value,p.key,this):m(p.value,p.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const m=this,a=this._state;let f=this._head;const p={[Symbol.iterator](){return p},next(){if(m._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.key,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}values(){const m=this,a=this._state;let f=this._head;const p={[Symbol.iterator](){return p},next(){if(m._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.value,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}entries(){const m=this,a=this._state;let f=this._head;const p={[Symbol.iterator](){return p},next(){if(m._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:[f.key,f.value],done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(m){if(m>=this.size)return;if(m===0){this.clear();return}let a=this._head,f=this.size;for(;a&&f>m;)this._map.delete(a.key),a=a.next,f--;this._head=a,this._size=f,a&&(a.previous=void 0),this._state++}addItemFirst(m){if(!this._head&&!this._tail)this._tail=m;else if(this._head)m.next=this._head,this._head.previous=m;else throw new Error("Invalid list");this._head=m,this._state++}addItemLast(m){if(!this._head&&!this._tail)this._head=m;else if(this._tail)m.previous=this._tail,this._tail.next=m;else throw new Error("Invalid list");this._tail=m,this._state++}removeItem(m){if(m===this._head&&m===this._tail)this._head=void 0,this._tail=void 0;else if(m===this._head){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this._head=m.next}else if(m===this._tail){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this._tail=m.previous}else{const a=m.next,f=m.previous;if(!a||!f)throw new Error("Invalid list");a.previous=f,f.next=a}m.next=void 0,m.previous=void 0,this._state++}touch(m,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(m===this._head)return;const f=m.next,p=m.previous;m===this._tail?(p.next=void 0,this._tail=p):(f.previous=p,p.next=f),m.previous=void 0,m.next=this._head,this._head.previous=m,this._head=m,this._state++}else if(a===2){if(m===this._tail)return;const f=m.next,p=m.previous;m===this._head?(f.previous=void 0,this._head=f):(f.previous=p,p.next=f),m.next=void 0,m.previous=this._tail,this._tail.next=m,this._tail=m,this._state++}}}toJSON(){const m=[];return this.forEach((a,f)=>{m.push([f,a])}),m}fromJSON(m){this.clear();for(const[a,f]of m)this.set(a,f)}}e.LinkedMap=S;class l extends S{constructor(m,a=1){super(),this._limit=m,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(m){this._limit=m,this.checkTrim()}get ratio(){return this._ratio}set ratio(m){this._ratio=Math.min(Math.max(0,m),1),this.checkTrim()}get(m,a=2){return super.get(m,a)}peek(m){return super.get(m,0)}set(m,a){return super.set(m,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l}),define(Z[81],ee([0,1,35]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new I.LRUCache(1e4);function r(h){return g(h,"NFC",M)}e.normalizeNFC=r;const R=new I.LRUCache(1e4);function D(h){return g(h,"NFD",R)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function g(h,w,v){if(!h)return h;const S=v.get(h);if(S)return S;let l;return P.test(h)?l=h.normalize(w):l=h,v.set(h,l),l}e.removeAccents=function(){const h=/[\u0300-\u036f]/g;return function(w){return D(w).replace(h,"")}}()}),define(Z[133],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(P,g,h){return Math.min(Math.max(P,g),h)}e.clamp=I;function M(P,g){return(g+P%g)%g}e.rot=M;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class R{constructor(){this._n=1,this._val=0}update(g){return this._val=this._val+(g-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class D{constructor(g){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(g),this._values.fill(0,0,g)}update(g){const h=this._values[this._index];return this._values[this._index]=g,this._index=(this._index+1)%this._values.length,this._sum-=h,this._sum+=g,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function x(r){const R=[];typeof r=="number"&&R.push("code/timeOrigin",r);function D(g){R.push(g,Date.now())}function P(){const g=[];for(let h=0;h<R.length;h+=2)g.push({name:R[h],startTime:R[h+1]});return g}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(r+D.startTime)});return R}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function I(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=I(M))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var M in I)(typeof exports=="object"?exports:x)[M]=I[M]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function I(M){if(e[M])return e[M].exports;var r=e[M]={i:M,l:!1,exports:{}};return x[M].call(r.exports,r,r.exports,I),r.l=!0,r.exports}return I.m=x,I.c=e,I.d=function(M,r,R){I.o(M,r)||Object.defineProperty(M,r,{enumerable:!0,get:R})},I.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},I.t=function(M,r){if(1&r&&(M=I(M)),8&r||4&r&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&r&&typeof M!="string")for(var D in M)I.d(R,D,function(P){return M[P]}.bind(null,D));return R},I.n=function(M){var r=M&&M.__esModule?function(){return M.default}:function(){return M};return I.d(r,"a",r),r},I.o=function(M,r){return Object.prototype.hasOwnProperty.call(M,r)},I.p="",I(I.s=0)}([function(x,e,I){(function(M){var r;e=x.exports=U,r=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],h=0,w=h++;g[w]="0|[1-9]\\d*";var v=h++;g[v]="[0-9]+";var S=h++;g[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=h++;g[l]="("+g[w]+")\\.("+g[w]+")\\.("+g[w]+")";var y=h++;g[y]="("+g[v]+")\\.("+g[v]+")\\.("+g[v]+")";var m=h++;g[m]="(?:"+g[w]+"|"+g[S]+")";var a=h++;g[a]="(?:"+g[v]+"|"+g[S]+")";var f=h++;g[f]="(?:-("+g[m]+"(?:\\."+g[m]+")*))";var p=h++;g[p]="(?:-?("+g[a]+"(?:\\."+g[a]+")*))";var b=h++;g[b]="[0-9A-Za-z-]+";var E=h++;g[E]="(?:\\+("+g[b]+"(?:\\."+g[b]+")*))";var k=h++,t="v?"+g[l]+g[f]+"?"+g[E]+"?";g[k]="^"+t+"$";var c="[v=\\s]*"+g[y]+g[p]+"?"+g[E]+"?",i=h++;g[i]="^"+c+"$";var n=h++;g[n]="((?:<|>)?=?)";var o=h++;g[o]=g[v]+"|x|X|\\*";var u=h++;g[u]=g[w]+"|x|X|\\*";var s=h++;g[s]="[v=\\s]*("+g[u]+")(?:\\.("+g[u]+")(?:\\.("+g[u]+")(?:"+g[f]+")?"+g[E]+"?)?)?";var d=h++;g[d]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[p]+")?"+g[E]+"?)?)?";var C=h++;g[C]="^"+g[n]+"\\s*"+g[s]+"$";var L=h++;g[L]="^"+g[n]+"\\s*"+g[d]+"$";var O=h++;g[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=h++;g[F]="(?:~>?)";var z=h++;g[z]="(\\s*)"+g[F]+"\\s+",P[z]=new RegExp(g[z],"g");var q=h++;g[q]="^"+g[F]+g[s]+"$";var ie=h++;g[ie]="^"+g[F]+g[d]+"$";var se=h++;g[se]="(?:\\^)";var oe=h++;g[oe]="(\\s*)"+g[se]+"\\s+",P[oe]=new RegExp(g[oe],"g");var he=h++;g[he]="^"+g[se]+g[s]+"$";var le=h++;g[le]="^"+g[se]+g[d]+"$";var ge=h++;g[ge]="^"+g[n]+"\\s*("+c+")$|^$";var V=h++;g[V]="^"+g[n]+"\\s*("+t+")$|^$";var B=h++;g[B]="(\\s*)"+g[n]+"\\s*("+c+"|"+g[s]+")",P[B]=new RegExp(g[B],"g");var T=h++;g[T]="^\\s*("+g[s]+")\\s+-\\s+("+g[s]+")\\s*$";var H=h++;g[H]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var Y=h++;g[Y]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)r(te,g[te]),P[te]||(P[te]=new RegExp(g[te]));function ne(J,ae){if(J instanceof U)return J;if(typeof J!="string"||J.length>R||!(ae?P[i]:P[k]).test(J))return null;try{return new U(J,ae)}catch{return null}}function U(J,ae){if(J instanceof U){if(J.loose===ae)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof U))return new U(J,ae);r("SemVer",J,ae),this.loose=ae;var de=J.trim().match(ae?P[i]:P[k]);if(!de)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<D)return Re}return Pe}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ne,e.valid=function(J,ae){var de=ne(J,ae);return de?de.version:null},e.clean=function(J,ae){var de=ne(J.trim().replace(/^[=v]+/,""),ae);return de?de.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(J){return r("SemVer.compare",this.version,this.loose,J),J instanceof U||(J=new U(J,this.loose)),this.compareMain(J)||this.comparePre(J)},U.prototype.compareMain=function(J){return J instanceof U||(J=new U(J,this.loose)),W(this.major,J.major)||W(this.minor,J.minor)||W(this.patch,J.patch)},U.prototype.comparePre=function(J){if(J instanceof U||(J=new U(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ae=0;do{var de=this.prerelease[ae],Pe=J.prerelease[ae];if(r("prerelease compare",ae,de,Pe),de===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(de===void 0)return-1;if(de!==Pe)return W(de,Pe)}while(++ae)},U.prototype.inc=function(J,ae){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ae,de,Pe){typeof de=="string"&&(Pe=de,de=void 0);try{return new U(J,de).inc(ae,Pe).version}catch{return null}},e.diff=function(J,ae){if(N(J,ae))return null;var de=ne(J),Pe=ne(ae);if(de.prerelease.length||Pe.prerelease.length){for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Pe[Re])return Re},e.compareIdentifiers=W;var A=/^[0-9]+$/;function W(J,ae){var de=A.test(J),Pe=A.test(ae);return de&&Pe&&(J=+J,ae=+ae),de&&!Pe?-1:Pe&&!de?1:J<ae?-1:J>ae?1:0}function _(J,ae,de){return new U(J,de).compare(new U(ae,de))}function $(J,ae,de){return _(J,ae,de)>0}function Q(J,ae,de){return _(J,ae,de)<0}function N(J,ae,de){return _(J,ae,de)===0}function j(J,ae,de){return _(J,ae,de)!==0}function G(J,ae,de){return _(J,ae,de)>=0}function re(J,ae,de){return _(J,ae,de)<=0}function ue(J,ae,de,Pe){var Re;switch(ae){case"===":typeof J=="object"&&(J=J.version),typeof de=="object"&&(de=de.version),Re=J===de;break;case"!==":typeof J=="object"&&(J=J.version),typeof de=="object"&&(de=de.version),Re=J!==de;break;case"":case"=":case"==":Re=N(J,de,Pe);break;case"!=":Re=j(J,de,Pe);break;case">":Re=$(J,de,Pe);break;case">=":Re=G(J,de,Pe);break;case"<":Re=Q(J,de,Pe);break;case"<=":Re=re(J,de,Pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Re}function ye(J,ae){if(J instanceof ye){if(J.loose===ae)return J;J=J.value}if(!(this instanceof ye))return new ye(J,ae);r("comparator",J,ae),this.loose=ae,this.parse(J),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(J,ae){return W(ae,J)},e.major=function(J,ae){return new U(J,ae).major},e.minor=function(J,ae){return new U(J,ae).minor},e.patch=function(J,ae){return new U(J,ae).patch},e.compare=_,e.compareLoose=function(J,ae){return _(J,ae,!0)},e.rcompare=function(J,ae,de){return _(ae,J,de)},e.sort=function(J,ae){return J.sort(function(de,Pe){return e.compare(de,Pe,ae)})},e.rsort=function(J,ae){return J.sort(function(de,Pe){return e.rcompare(de,Pe,ae)})},e.gt=$,e.lt=Q,e.eq=N,e.neq=j,e.gte=G,e.lte=re,e.cmp=ue,e.Comparator=ye;var Me={};function Te(J,ae){if(J instanceof Te)return J.loose===ae?J:new Te(J.raw,ae);if(J instanceof ye)return new Te(J.value,ae);if(!(this instanceof Te))return new Te(J,ae);if(this.loose=ae,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function We(J,ae,de,Pe,Re,Oe,_e,Be,ze,Fe,qe,K,ce){return((ae=Ae(de)?"":Ae(Pe)?">="+de+".0.0":Ae(Re)?">="+de+"."+Pe+".0":">="+ae)+" "+(Be=Ae(ze)?"":Ae(Fe)?"<"+(+ze+1)+".0.0":Ae(qe)?"<"+ze+"."+(+Fe+1)+".0":K?"<="+ze+"."+Fe+"."+qe+"-"+K:"<="+Be)).trim()}function me(J,ae){for(var de=0;de<J.length;de++)if(!J[de].test(ae))return!1;if(ae.prerelease.length){for(de=0;de<J.length;de++)if(r(J[de].semver),J[de].semver!==Me&&J[de].semver.prerelease.length>0){var Pe=J[de].semver;if(Pe.major===ae.major&&Pe.minor===ae.minor&&Pe.patch===ae.patch)return!0}return!1}return!0}function pe(J,ae,de){try{ae=new Te(ae,de)}catch{return!1}return ae.test(J)}function ke(J,ae,de,Pe){var Re,Oe,_e,Be,ze;switch(J=new U(J,Pe),ae=new Te(ae,Pe),de){case">":Re=$,Oe=re,_e=Q,Be=">",ze=">=";break;case"<":Re=Q,Oe=G,_e=$,Be="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(J,ae,Pe))return!1;for(var Fe=0;Fe<ae.set.length;++Fe){var qe=ae.set[Fe],K=null,ce=null;if(qe.forEach(function(fe){fe.semver===Me&&(fe=new ye(">=0.0.0")),K=K||fe,ce=ce||fe,Re(fe.semver,K.semver,Pe)?K=fe:_e(fe.semver,ce.semver,Pe)&&(ce=fe)}),K.operator===Be||K.operator===ze||(!ce.operator||ce.operator===Be)&&Oe(J,ce.semver)||ce.operator===ze&&_e(J,ce.semver))return!1}return!0}ye.prototype.parse=function(J){var ae=this.loose?P[ge]:P[V],de=J.match(ae);if(!de)throw new TypeError("Invalid comparator: "+J);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new U(de[2],this.loose):this.semver=Me},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(J){return r("Comparator.test",J,this.loose),this.semver===Me||(typeof J=="string"&&(J=new U(J,this.loose)),ue(J,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(J,ae){if(!(J instanceof ye))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Te(J.value,ae),pe(this.value,de,ae);if(J.operator==="")return de=new Te(this.value,ae),pe(J.semver,de,ae);var Pe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Oe=this.semver.version===J.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Be=ue(this.semver,"<",J.semver,ae)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),ze=ue(this.semver,">",J.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Pe||Re||Oe&&_e||Be||ze},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(J){var ae=this.loose;J=J.trim(),r("range",J,ae);var de=ae?P[H]:P[T];J=J.replace(de,We),r("hyphen replace",J),J=J.replace(P[B],"$1$2$3"),r("comparator trim",J,P[B]),J=(J=(J=J.replace(P[z],"$1~")).replace(P[oe],"$1^")).split(/\s+/).join(" ");var Pe=ae?P[ge]:P[V],Re=J.split(" ").map(function(Oe){return function(_e,Be){return r("comp",_e),_e=function(ze,Fe){return ze.trim().split(/\s+/).map(function(qe){return function(K,ce){r("caret",K,ce);var fe=ce?P[le]:P[he];return K.replace(fe,function(Se,ve,Le,Ue,je){var Ve;return r("caret",K,Se,ve,Le,Ue,je),Ae(ve)?Ve="":Ae(Le)?Ve=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ae(Ue)?Ve=ve==="0"?">="+ve+"."+Le+".0 <"+ve+"."+(+Le+1)+".0":">="+ve+"."+Le+".0 <"+(+ve+1)+".0.0":je?(r("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ve=ve==="0"?Le==="0"?">="+ve+"."+Le+"."+Ue+je+" <"+ve+"."+Le+"."+(+Ue+1):">="+ve+"."+Le+"."+Ue+je+" <"+ve+"."+(+Le+1)+".0":">="+ve+"."+Le+"."+Ue+je+" <"+(+ve+1)+".0.0"):(r("no pr"),Ve=ve==="0"?Le==="0"?">="+ve+"."+Le+"."+Ue+" <"+ve+"."+Le+"."+(+Ue+1):">="+ve+"."+Le+"."+Ue+" <"+ve+"."+(+Le+1)+".0":">="+ve+"."+Le+"."+Ue+" <"+(+ve+1)+".0.0"),r("caret return",Ve),Ve})}(qe,Fe)}).join(" ")}(_e,Be),r("caret",_e),_e=function(ze,Fe){return ze.trim().split(/\s+/).map(function(qe){return function(K,ce){var fe=ce?P[ie]:P[q];return K.replace(fe,function(Se,ve,Le,Ue,je){var Ve;return r("tilde",K,Se,ve,Le,Ue,je),Ae(ve)?Ve="":Ae(Le)?Ve=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ae(Ue)?Ve=">="+ve+"."+Le+".0 <"+ve+"."+(+Le+1)+".0":je?(r("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ve=">="+ve+"."+Le+"."+Ue+je+" <"+ve+"."+(+Le+1)+".0"):Ve=">="+ve+"."+Le+"."+Ue+" <"+ve+"."+(+Le+1)+".0",r("tilde return",Ve),Ve})}(qe,Fe)}).join(" ")}(_e,Be),r("tildes",_e),_e=function(ze,Fe){return r("replaceXRanges",ze,Fe),ze.split(/\s+/).map(function(qe){return function(K,ce){K=K.trim();var fe=ce?P[L]:P[C];return K.replace(fe,function(Se,ve,Le,Ue,je,Ve){r("xRange",K,Se,ve,Le,Ue,je,Ve);var Ke=Ae(Le),Ye=Ke||Ae(Ue),Je=Ye||Ae(je);return ve==="="&&Je&&(ve=""),Ke?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Je?(Ye&&(Ue=0),Je&&(je=0),ve===">"?(ve=">=",Ye?(Le=+Le+1,Ue=0,je=0):Je&&(Ue=+Ue+1,je=0)):ve==="<="&&(ve="<",Ye?Le=+Le+1:Ue=+Ue+1),Se=ve+Le+"."+Ue+"."+je):Ye?Se=">="+Le+".0.0 <"+(+Le+1)+".0.0":Je&&(Se=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0"),r("xRange return",Se),Se})}(qe,Fe)}).join(" ")}(_e,Be),r("xrange",_e),_e=function(ze,Fe){return r("replaceStars",ze,Fe),ze.trim().replace(P[Y],"")}(_e,Be),r("stars",_e),_e}(Oe,ae)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Oe){return!!Oe.match(Pe)})),Re=Re.map(function(Oe){return new ye(Oe,ae)})},Te.prototype.intersects=function(J,ae){if(!(J instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Pe){return J.set.some(function(Re){return Re.every(function(Oe){return Pe.intersects(Oe,ae)})})})})},e.toComparators=function(J,ae){return new Te(J,ae).set.map(function(de){return de.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new U(J,this.loose));for(var ae=0;ae<this.set.length;ae++)if(me(this.set[ae],J))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(J,ae,de){var Pe=null,Re=null;try{var Oe=new Te(ae,de)}catch{return null}return J.forEach(function(_e){Oe.test(_e)&&(Pe&&Re.compare(_e)!==-1||(Re=new U(Pe=_e,de)))}),Pe},e.minSatisfying=function(J,ae,de){var Pe=null,Re=null;try{var Oe=new Te(ae,de)}catch{return null}return J.forEach(function(_e){Oe.test(_e)&&(Pe&&Re.compare(_e)!==1||(Re=new U(Pe=_e,de)))}),Pe},e.validRange=function(J,ae){try{return new Te(J,ae).range||"*"}catch{return null}},e.ltr=function(J,ae,de){return ke(J,ae,"<",de)},e.gtr=function(J,ae,de){return ke(J,ae,">",de)},e.outside=ke,e.prerelease=function(J,ae){var de=ne(J,ae);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(J,ae,de){return J=new Te(J,de),ae=new Te(ae,de),J.intersects(ae)},e.coerce=function(J){if(J instanceof U)return J;if(typeof J!="string")return null;var ae=J.match(P[O]);return ae==null?null:ne((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,I(1))},function(x,e){var I,M,r=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(a){if(I===setTimeout)return setTimeout(a,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(a,0);try{return I(a,0)}catch{try{return I.call(null,a,0)}catch{return I.call(this,a,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{M=typeof clearTimeout=="function"?clearTimeout:D}catch{M=D}})();var g,h=[],w=!1,v=-1;function S(){w&&g&&(w=!1,g.length?h=g.concat(h):v=-1,h.length&&l())}function l(){if(!w){var a=P(S);w=!0;for(var f=h.length;f;){for(g=h,h=[];++v<f;)g&&g[v].run();v=-1,f=h.length}g=null,w=!1,function(p){if(M===clearTimeout)return clearTimeout(p);if((M===D||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(p);try{M(p)}catch{try{return M.call(null,p)}catch{return M.call(this,p)}}}(a)}}function y(a,f){this.fun=a,this.array=f}function m(){}r.nextTick=function(a){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];h.push(new y(a,f)),h.length!==1||w||P(l)},y.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=m,r.addListener=m,r.once=m,r.off=m,r.removeListener=m,r.removeAllListeners=m,r.emit=m,r.prependListener=m,r.prependOnceListener=m,r.listeners=function(a){return[]},r.binding=function(a){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(a){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(Z[134],ee([0,1]),function(x,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(P,g,h){this.level=P,this.key=g,this.value=h,this.forward=[]}}const r=void 0;class R{constructor(P,g=2**16){this.comparator=P,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(g)|0),this._header=new M(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,r,r)}has(P){return Boolean(R._search(this,P,this.comparator))}get(P){return R._search(this,P,this.comparator)?.value}set(P,g){return R._insert(this,P,g,this.comparator)&&(this._size+=1),this}delete(P){const g=R._delete(this,P,this.comparator);return g&&(this._size-=1),g}forEach(P,g){let h=this._header.forward[0];for(;h;)P.call(g,h.value,h.key,this),h=h.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",g=this._header.forward[0];for(;g;)P+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return P}static _search(P,g,h){let w=P._header;for(let v=P._level-1;v>=0;v--)for(;w.forward[v]&&h(w.forward[v].key,g)<0;)w=w.forward[v];if(w=w.forward[0],w&&h(w.key,g)===0)return w}static _insert(P,g,h,w){const v=[];let S=P._header;for(let l=P._level-1;l>=0;l--){for(;S.forward[l]&&w(S.forward[l].key,g)<0;)S=S.forward[l];v[l]=S}if(S=S.forward[0],S&&w(S.key,g)===0)return S.value=h,!1;{const l=R._randomLevel(P);if(l>P._level){for(let y=P._level;y<l;y++)v[y]=P._header;P._level=l}S=new M(l,g,h);for(let y=0;y<l;y++)S.forward[y]=v[y].forward[y],v[y].forward[y]=S;return!0}}static _randomLevel(P,g=.5){let h=1;for(;Math.random()<g&&h<P._maxLevel;)h+=1;return h}static _delete(P,g,h){const w=[];let v=P._header;for(let S=P._level-1;S>=0;S--){for(;v.forward[S]&&h(v.forward[S].key,g)<0;)v=v.forward[S];w[S]=v}if(v=v.forward[0],!v||h(v.key,g)!==0)return!1;for(let S=0;S<P._level&&w[S].forward[S]===v;S++)w[S].forward[S]=v.forward[S];for(;P._level>0&&P._header.forward[P._level-1]===r;)P._level-=1;return!0}}e.SkipList=R}),define(Z[59],ee([0,1,13,2]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(E){const k=E;return k?typeof k.read=="function":!1}e.isReadable=r;function R(E){const k=E;return k?[k.on,k.pause,k.resume,k.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function D(E){const k=E;return k?R(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(E,k){return new g(E,k)}e.newWriteableStream=P;class g{constructor(k,t){this.reducer=k,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(k){if(!this.state.destroyed){if(this.state.flowing)this.emitData(k);else if(this.buffer.data.push(k),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(k){this.state.destroyed||(this.state.flowing?this.emitError(k):this.buffer.error.push(k))}end(k){this.state.destroyed||(typeof k<"u"&&this.write(k),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(k){this.listeners.data.slice(0).forEach(t=>t(k))}emitError(k){this.listeners.error.length===0?(0,I.onUnexpectedError)(k):this.listeners.error.slice(0).forEach(t=>t(k))}emitEnd(){this.listeners.end.slice(0).forEach(k=>k())}on(k,t){if(!this.state.destroyed)switch(k){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(k,t){if(this.state.destroyed)return;let c;switch(k){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const k=this.reducer(this.buffer.data);this.emitData(k),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const k of this.buffer.error)this.emitError(k);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(E,k){const t=[];let c;for(;(c=E.read())!==null;)t.push(c);return k(t)}e.consumeReadable=h;function w(E,k,t){const c=[];let i;for(;(i=E.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?k(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return E.read()}}}e.peekReadable=w;function v(E,k){return new Promise((t,c)=>{const i=[];S(E,{onData:n=>{k&&i.push(n)},onError:n=>{k?c(n):t(void 0)},onEnd:()=>{t(k?k(i):void 0)}})})}e.consumeStream=v;function S(E,k){let t=!1;return E.on("error",c=>{t||k.onError(c)}),E.on("end",()=>{t||k.onEnd()}),E.on("data",c=>{t||k.onData(c)}),(0,M.toDisposable)(()=>t=!0)}e.listenStream=S;function l(E,k){return new Promise((t,c)=>{const i=new M.DisposableStore,n=[],o=d=>{if(n.push(d),n.length>k)return i.dispose(),E.pause(),t({stream:E,buffer:n,ended:!1})},u=d=>c(d),s=()=>t({stream:E,buffer:n,ended:!0});i.add((0,M.toDisposable)(()=>E.removeListener("error",u))),E.on("error",u),i.add((0,M.toDisposable)(()=>E.removeListener("end",s))),E.on("end",s),i.add((0,M.toDisposable)(()=>E.removeListener("data",o))),E.on("data",o)})}e.peekStream=l;function y(E,k){const t=P(k);return t.end(E),t}e.toStream=y;function m(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=m;function a(E){let k=!1;return{read:()=>k?null:(k=!0,E)}}e.toReadable=a;function f(E,k,t){const c=P(t);return S(E,{onData:i=>c.write(k.data(i)),onError:i=>c.error(k.error?k.error(i):i),onEnd:()=>c.end()}),c}e.transform=f;function p(E,k,t){let c=!1;return{read:()=>{const i=k.read();return c?i:(c=!0,i!==null?t([E,i]):E)}}}e.prefixedReadable=p;function b(E,k,t){let c=!1;const i=P(t);return S(k,{onData:n=>c?i.write(n):(c=!0,i.write(t([E,n]))),onError:n=>i.error(n),onEnd:()=>{c||(c=!0,i.write(E)),i.end()}}),i}e.prefixedStream=b}),define(Z[17],ee([0,1,59]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer<"u";let r,R;class D{static alloc(d){return M?new D(Buffer.allocUnsafe(d)):new D(new Uint8Array(d))}static wrap(d){return M&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new D(d)}static fromString(d,C){return!(C?.dontUseNodeBuffer||!1)&&M?new D(Buffer.from(d)):(r||(r=new TextEncoder),new D(r.encode(d)))}static fromByteArray(d){const C=D.alloc(d.length);for(let L=0,O=d.length;L<O;L++)C.buffer[L]=d[L];return C}static concat(d,C){if(typeof C>"u"){C=0;for(let F=0,z=d.length;F<z;F++)C+=d[F].byteLength}const L=D.alloc(C);let O=0;for(let F=0,z=d.length;F<z;F++){const q=d[F];L.set(q,O),O+=q.byteLength}return L}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=D.alloc(this.byteLength);return d.set(this),d}toString(){return M?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(d,C){return new D(this.buffer.subarray(d,C))}set(d,C){if(d instanceof D)this.buffer.set(d.buffer,C);else if(d instanceof Uint8Array)this.buffer.set(d,C);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),C);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return h(this.buffer,d)}writeUInt32BE(d,C){w(this.buffer,d,C)}readUInt32LE(d){return v(this.buffer,d)}writeUInt32LE(d,C){S(this.buffer,d,C)}readUInt8(d){return l(this.buffer,d)}writeUInt8(d,C){y(this.buffer,d,C)}}e.VSBuffer=D;function P(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0}e.readUInt16LE=P;function g(s,d,C){s[C+0]=d&255,d=d>>>8,s[C+1]=d&255}e.writeUInt16LE=g;function h(s,d){return s[d]*2**24+s[d+1]*2**16+s[d+2]*2**8+s[d+3]}e.readUInt32BE=h;function w(s,d,C){s[C+3]=d,d=d>>>8,s[C+2]=d,d=d>>>8,s[C+1]=d,d=d>>>8,s[C]=d}e.writeUInt32BE=w;function v(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0|s[d+2]<<16>>>0|s[d+3]<<24>>>0}e.readUInt32LE=v;function S(s,d,C){s[C+0]=d&255,d=d>>>8,s[C+1]=d&255,d=d>>>8,s[C+2]=d&255,d=d>>>8,s[C+3]=d&255}e.writeUInt32LE=S;function l(s,d){return s[d]}e.readUInt8=l;function y(s,d,C){s[C]=d}e.writeUInt8=y;function m(s){return I.consumeReadable(s,d=>D.concat(d))}e.readableToBuffer=m;function a(s){return I.toReadable(s)}e.bufferToReadable=a;function f(s){return I.consumeStream(s,d=>D.concat(d))}e.streamToBuffer=f;async function p(s){return s.ended?D.concat(s.buffer):D.concat([...s.buffer,await f(s.stream)])}e.bufferedStreamToBuffer=p;function b(s){return I.toStream(s,d=>D.concat(d))}e.bufferToStream=b;function E(s){return I.transform(s,{data:d=>typeof d=="string"?D.fromString(d):D.wrap(d)},d=>D.concat(d))}e.streamToBufferReadableStream=E;function k(s){return I.newWriteableStream(d=>D.concat(d),s)}e.newWriteableBufferStream=k;function t(s,d){return I.prefixedReadable(s,d,C=>D.concat(C))}e.prefixedBufferReadable=t;function c(s,d){return I.prefixedStream(s,d,C=>D.concat(C))}e.prefixedBufferStream=c;function i(s){let d=0,C=0,L=0;const O=new Uint8Array(Math.floor(s.length/4*3)),F=q=>{switch(C){case 3:O[L++]=d|q,C=0;break;case 2:O[L++]=d|q>>>2,d=q<<6,C=3;break;case 1:O[L++]=d|q>>>4,d=q<<4,C=2;break;default:d=q<<2,C=1}};for(let q=0;q<s.length;q++){const ie=s.charCodeAt(q);if(ie>=65&&ie<=90)F(ie-65);else if(ie>=97&&ie<=122)F(ie-97+26);else if(ie>=48&&ie<=57)F(ie-48+52);else if(ie===43||ie===45)F(62);else if(ie===47||ie===95)F(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${s[q]}`)}}const z=L;for(;C>0;)F(0);return D.wrap(O).slice(0,z)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:s},d=!0,C=!1){const L=C?o:n;let O="";const F=s.byteLength%3;let z=0;for(;z<s.byteLength-F;z+=3){const q=s[z+0],ie=s[z+1],se=s[z+2];O+=L[q>>>2],O+=L[(q<<4|ie>>>4)&63],O+=L[(ie<<2|se>>>6)&63],O+=L[se&63]}if(F===1){const q=s[z+0];O+=L[q>>>2],O+=L[q<<4&63],d&&(O+="==")}else if(F===2){const q=s[z+0],ie=s[z+1];O+=L[q>>>2],O+=L[(q<<4|ie>>>4)&63],O+=L[ie<<2&63],d&&(O+="=")}return O}e.encodeBase64=u}),define(Z[135],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Z[10],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(c){return typeof c=="string"}e.isString=I;function M(c){return Array.isArray(c)&&c.every(i=>I(i))}e.isStringArray=M;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=r;function R(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=R;function D(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=D;function P(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=P;function g(c){return c===!0||c===!1}e.isBoolean=g;function h(c){return typeof c>"u"}e.isUndefined=h;function w(c){return!v(c)}e.isDefined=w;function v(c){return h(c)||c===null}e.isUndefinedOrNull=v;function S(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function l(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=l;function y(...c){const i=[];for(let n=0;n<c.length;n++){const o=c[n];if(v(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=y;const m=Object.prototype.hasOwnProperty;function a(c){if(!r(c))return!1;for(const i in c)if(m.call(c,i))return!1;return!0}e.isEmptyObject=a;function f(c){return typeof c=="function"}e.isFunction=f;function p(...c){return c.length>0&&c.every(f)}e.areFunctions=p;function b(c,i){const n=Math.min(c.length,i.length);for(let o=0;o<n;o++)E(c[o],i[o])}e.validateConstraints=b;function E(c,i){if(I(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(f(i)){try{if(c instanceof i)return}catch{}if(!v(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function k(c){return c===null?void 0:c}e.withNullAsUndefined=k;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(Z[136],ee([0,1,10]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const M=Object.create(null);function r(P,g){if((0,I.isString)(g)){const h=M[g];if(h===void 0)throw new Error(`${P} references an unknown codicon: ${g}`);g=h}return M[P]=g,{id:P}}function R(){return M}e.getCodiconFontCharacters=R;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(Z[37],ee([0,1,10]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,E])=>{p[b]=E&&typeof E=="object"?M(E):E}),p}e.deepClone=M;function r(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const E in b)if(R.call(b,E)){const k=b[E];typeof k=="object"&&!Object.isFrozen(k)&&!(0,I.isTypedArray)(k)&&p.push(k)}}return f}e.deepFreeze=r;const R=Object.prototype.hasOwnProperty;function D(f,p){return P(f,p,new Set)}e.cloneAndChange=D;function P(f,p,b){if((0,I.isUndefinedOrNull)(f))return f;const E=p(f);if(typeof E<"u")return E;if(Array.isArray(f)){const k=[];for(const t of f)k.push(P(t,p,b));return k}if((0,I.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const k={};for(const t in f)R.call(f,t)&&(k[t]=P(f[t],p,b));return b.delete(f),k}return f}function g(f,p,b=!0){return(0,I.isObject)(f)?((0,I.isObject)(p)&&Object.keys(p).forEach(E=>{E in f?b&&((0,I.isObject)(f[E])&&(0,I.isObject)(p[E])?g(f[E],p[E],b):f[E]=p[E]):f[E]=p[E]}),f):p}e.mixin=g;function h(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let b,E;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(b=0;b<f.length;b++)if(!h(f[b],p[b]))return!1}else{const k=[];for(E in f)k.push(E);k.sort();const t=[];for(E in p)t.push(E);if(t.sort(),!h(k,t))return!1;for(b=0;b<k.length;b++)if(!h(f[k[b]],p[k[b]]))return!1}return!0}e.equals=h;function w(f){const p=new Set;return JSON.stringify(f,(b,E)=>{if((0,I.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=w;function v(f,p){const b=Object.create(null);return!f||!p||Object.keys(p).forEach(k=>{const t=f[k],c=p[k];h(t,c)||(b[k]=c)}),b}e.distinct=v;function S(f,p){const b=p.toLowerCase(),E=Object.keys(f).find(k=>k.toLowerCase()===b);return E?f[E]:f[p]}e.getCaseInsensitive=S;function l(f,p){const b=Object.create(null);for(const[E,k]of Object.entries(f))p(E,k)&&(b[E]=k);return b}e.filter=l;function y(f){let p=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=y;function m(f){const p=[];for(const b of y(f))typeof f[b]=="function"&&p.push(b);return p}e.getAllMethodNames=m;function a(f,p){const b=k=>function(){const t=Array.prototype.slice.call(arguments,0);return p(k,t)},E={};for(const k of f)E[k]=b(k);return E}e.createProxyObject=a}),define(Z[137],ee([0,1,136]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var M;(function(D){function P(g){return g&&typeof g=="object"&&typeof g.id=="string"}D.isThemeColor=P})(M=e.ThemeColor||(e.ThemeColor={}));function r(D){return{id:D}}e.themeColorFromId=r;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function g(p){const b=P.exec(p.id);if(!b)return g(I.Codicon.error);const[,E,k]=b,t=["codicon","codicon-"+E];return k&&t.push("codicon-modifier-"+k.substring(1)),t}D.asClassNameArray=g;function h(p){return g(p).join(" ")}D.asClassName=h;function w(p){return"."+g(p).join(".")}D.asCSSSelector=w;function v(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||M.isThemeColor(p.color))}D.isThemeIcon=v;const S=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function l(p){const b=S.exec(p);if(!b)return;const[,E]=b;return{id:E}}D.fromString=l;function y(p){return{id:p}}D.fromId=y;function m(p,b){let E=p.id;const k=E.lastIndexOf("~");return k!==-1&&(E=E.substring(0,k)),b&&(E=`${E}~${b}`),{id:E}}D.modify=m;function a(p){const b=p.id.lastIndexOf("~");if(b!==-1)return p.id.substring(b+1)}D.getModifier=a;function f(p,b){return p.id===b.id&&p.color?.id===b.color?.id}D.isEqual=f})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(Z[31],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(r){return I.test(r)}e.isUUID=M,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){r(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let g=0,h="";return h+=D[R[g++]],h+=D[R[g++]],h+=D[R[g++]],h+=D[R[g++]],h+="-",h+=D[R[g++]],h+=D[R[g++]],h+="-",h+=D[R[g++]],h+=D[R[g++]],h+="-",h+=D[R[g++]],h+=D[R[g++]],h+="-",h+=D[R[g++]],h+=D[R[g++]],h+=D[R[g++]],h+=D[R[g++]],h+=D[R[g++]],h+=D[R[g++]],h}}()}),define(Z[138],ee([0,1,82,41,50]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,P){if(await new Promise((w,v)=>{const S=M.createReadStream(D),l=I.createHash("sha1");S.pipe(l);const y=(0,r.once)((m,a)=>{S.removeAllListeners(),l.removeAllListeners(),m?v(m):w(a)});S.once("error",y),S.once("end",y),l.once("error",y),l.once("data",m=>y(void 0,m.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[139],ee([0,1,26]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(D){const P=D.replace(/\-/g,":").toLowerCase();return!M.has(P)}function R(){const D=(0,I.networkInterfaces)();for(const P in D){const g=D[P];if(g){for(const{mac:h}of g)if(r(h))return h}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[101],ee([0,1,83]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function M(P,g,h,w=1){let v=!1;return new Promise(S=>{const l=setTimeout(()=>{if(!v)return v=!0,S(0)},h);r(P,g,w,y=>{if(!v)return v=!0,clearTimeout(l),S(y)})})}e.findFreePort=M;function r(P,g,h,w){if(g===0)return w(0);const v=new I.Socket;v.once("connect",()=>(D(v),r(P+h,g-1,h,w))),v.once("data",()=>{}),v.once("error",S=>(D(v),S.code!=="ECONNREFUSED"?r(P+h,g-1,h,w):w(P))),v.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,g,h,w="127.0.0.1"){let v=!1,S,l=1;const y=I.createServer({pauseOnConnect:!0});function m(a,f){v||(v=!0,y.removeAllListeners(),y.close(),S&&clearTimeout(S),f(a))}return new Promise(a=>{S=setTimeout(()=>{m(0,a)},h),y.on("listening",()=>{m(P,a)}),y.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&l<g?(P++,l++,y.listen(P,w)):m(0,a)}),y.on("close",()=>{m(0,a)}),y.listen(P,w)})}e.findFreePortFaster=R;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(g){console.error(g)}}}),define(Z[140],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[141],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(r,R){this.sender=r,this.onMessage=R}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=I}),define(Z[42],ee([0,1,15,13]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class r{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,P){const g=(h,...w)=>{this.validateEvent(D,h)&&P(h,...w)};return this.mapListenerToWrapper.set(P,g),I.ipcMain.on(D,g),this}once(D,P){return I.ipcMain.once(D,(g,...h)=>{this.validateEvent(D,g)&&P(g,...h)}),this}handle(D,P){return I.ipcMain.handle(D,(g,...h)=>this.validateEvent(D,g)?P(g,...h):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return I.ipcMain.removeHandler(D),this}removeListener(D,P){const g=this.mapListenerToWrapper.get(P);return g&&(I.ipcMain.removeListener(D,g),this.mapListenerToWrapper.delete(P)),this}validateEvent(D,P){if(!D||!D.startsWith("vscode:"))return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const g=P.senderFrame,h=g.url;if(!h)return!0;let w="unknown";try{w=new URL(h).host}catch{return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${h}'.`),!1}return w!=="vscode-app"?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${w}'.`),!1):g.parent!==null?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new r}),define(Z[142],ee([0,1,15,42,10,140]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){M.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(g,h,w,v,S)=>{const l=P(g,v,w);l.popup({window:(0,r.withNullAsUndefined)(I.BrowserWindow.fromWebContents(g.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{l&&g.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=D;function P(g,h,w){const v=new I.Menu;return w.forEach(S=>{let l;S.type==="separator"?l=new I.MenuItem({type:S.type}):Array.isArray(S.submenu)?l=new I.MenuItem({submenu:P(g,h,S.submenu),label:S.label}):l=new I.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(y,m,a)=>g.sender.send(h,S.id,a)}),v.append(l)}),v}}),define(Z[71],ee([0,1,15]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=I.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(Z[143],ee([12,11]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[144],ee([0,1,143]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,r=M*60,R=r*24,D=R*7,P=R*30,g=R*365;function h(v,S,l,y){typeof v!="number"&&(v=v.getTime());const m=Math.round((new Date().getTime()-v)/1e3);if(m<-30)return(0,I.localize)(0,null,h(new Date().getTime()+m*1e3,!1));if(!y&&m<30)return(0,I.localize)(1,null);let a;return m<M?(a=m,S?a===1?l?(0,I.localize)(2,null,a):(0,I.localize)(3,null,a):l?(0,I.localize)(4,null,a):(0,I.localize)(5,null,a):a===1?l?(0,I.localize)(6,null,a):(0,I.localize)(7,null,a):l?(0,I.localize)(8,null,a):(0,I.localize)(9,null,a)):m<r?(a=Math.floor(m/M),S?a===1?l?(0,I.localize)(10,null,a):(0,I.localize)(11,null,a):l?(0,I.localize)(12,null,a):(0,I.localize)(13,null,a):a===1?l?(0,I.localize)(14,null,a):(0,I.localize)(15,null,a):l?(0,I.localize)(16,null,a):(0,I.localize)(17,null,a)):m<R?(a=Math.floor(m/r),S?a===1?l?(0,I.localize)(18,null,a):(0,I.localize)(19,null,a):l?(0,I.localize)(20,null,a):(0,I.localize)(21,null,a):a===1?l?(0,I.localize)(22,null,a):(0,I.localize)(23,null,a):l?(0,I.localize)(24,null,a):(0,I.localize)(25,null,a)):m<D?(a=Math.floor(m/R),S?a===1?(0,I.localize)(26,null,a):(0,I.localize)(27,null,a):a===1?(0,I.localize)(28,null,a):(0,I.localize)(29,null,a)):m<P?(a=Math.floor(m/D),S?a===1?l?(0,I.localize)(30,null,a):(0,I.localize)(31,null,a):l?(0,I.localize)(32,null,a):(0,I.localize)(33,null,a):a===1?l?(0,I.localize)(34,null,a):(0,I.localize)(35,null,a):l?(0,I.localize)(36,null,a):(0,I.localize)(37,null,a)):m<g?(a=Math.floor(m/P),S?a===1?l?(0,I.localize)(38,null,a):(0,I.localize)(39,null,a):l?(0,I.localize)(40,null,a):(0,I.localize)(41,null,a):a===1?l?(0,I.localize)(42,null,a):(0,I.localize)(43,null,a):l?(0,I.localize)(44,null,a):(0,I.localize)(45,null,a)):(a=Math.floor(m/g),S?a===1?l?(0,I.localize)(46,null,a):(0,I.localize)(47,null,a):l?(0,I.localize)(48,null,a):(0,I.localize)(49,null,a):a===1?l?(0,I.localize)(50,null,a):(0,I.localize)(51,null,a):l?(0,I.localize)(52,null,a):(0,I.localize)(53,null,a))}e.fromNow=h;function w(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=w}),define(Z[145],ee([12,11]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,25,10,145]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(v,S){return S&&(v.stack||v.stacktrace)?r.localize(0,null,P(v),D(v.stack)||D(v.stacktrace)):P(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?r.localize(1,null,v.message):v.message||r.localize(2,null)}function g(v=null,S=!1){if(!v)return r.localize(3,null);if(Array.isArray(v)){const l=I.coalesce(v),y=g(l[0],S);return l.length>1?r.localize(4,null,y,l.length):y}if(M.isString(v))return v;if(v.detail){const l=v.detail;if(l.error)return R(l.error,S);if(l.exception)return R(l.exception,S)}return v.stack?R(v,S):v.message?v.message:r.localize(5,null)}e.toErrorMessage=g;function h(v){const S=v;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=h;function w(v,S){let l;return typeof v=="string"?l=new Error(v):l=v,l.actions=S,l}e.createErrorWithActions=w}),define(Z[146],ee([12,11]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[147],ee([0,1,146]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function M(r){switch(r){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=M}),define(Z[148],ee([12,11]),function(x,e){return x.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,148]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let M=!1,r=!1,R=!1,D=!1,P=!1,g=!1,h=!1,w=!1,v=!1,S=!1,l,y=e.LANGUAGE_DEFAULT,m,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const p=typeof f?.versions?.electron=="string",b=p&&f?.type==="renderer";if(typeof navigator=="object"&&!b)a=navigator.userAgent,M=a.indexOf("Windows")>=0,r=a.indexOf("Macintosh")>=0,w=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,S=a?.indexOf("Mobi")>=0,g=!0,l=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,y=l;else if(typeof f=="object"){M=f.platform==="win32",r=f.platform==="darwin",R=f.platform==="linux",D=R&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,h=p,v=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const d=JSON.parse(s),C=d.availableLanguages["*"];l=d.locale,y=C||e.LANGUAGE_DEFAULT,m=d._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function k(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=k;let t=0;r?t=1:M?t=3:R&&(t=2),e.isWindows=M,e.isMacintosh=r,e.isLinux=R,e.isLinuxSnap=D,e.isNative=P,e.isElectron=h,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isMobile=S,e.isCI=v,e.platform=t,e.userAgent=a,e.language=y;var c;(function(s){function d(){return e.language}s.value=d;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=C;function L(){return e.language==="en"}s.isDefault=L})(c=e.Language||(e.Language={})),e.locale=l,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let L=0,O=s.length;L<O;L++){const F=s[L];if(F.id===C.data.vscodeScheduleAsyncWork){s.splice(L,1),F.callback();return}}});let d=0;return C=>{const L=++d;s.push({id:L,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=r||w?2:M?1:3;let n=!0,o=!1;function u(){if(!o){o=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let M;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const r=I.globals.vscode.process;M={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.arch=M.arch}),define(Z[9],ee([0,1,36]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,r=97,R=90,D=122,P=46,g=47,h=92,w=58,v=63;class S extends Error{constructor(c,i,n){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const u=c.indexOf(".")!==-1?"property":"argument";let s=`The "${c}" ${u} ${o} of type ${i}`;s+=`. Received type ${typeof n}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,c){if(t===null||typeof t!="object")throw new S(c,"Object",t)}function y(t,c){if(typeof t!="string")throw new S(c,"string",t)}const m=I.platform==="win32";function a(t){return t===g||t===h}function f(t){return t===g}function p(t){return t>=M&&t<=R||t>=r&&t<=D}function b(t,c,i,n){let o="",u=0,s=-1,d=0,C=0;for(let L=0;L<=t.length;++L){if(L<t.length)C=t.charCodeAt(L);else{if(n(C))break;C=g}if(n(C)){if(!(s===L-1||d===1))if(d===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const O=o.lastIndexOf(i);O===-1?(o="",u=0):(o=o.slice(0,O),u=o.length-1-o.lastIndexOf(i)),s=L,d=0;continue}else if(o.length!==0){o="",u=0,s=L,d=0;continue}}c&&(o+=o.length>0?`${i}..`:"..",u=2)}else o.length>0?o+=`${i}${t.slice(s+1,L)}`:o=t.slice(s+1,L),u=L-s-1;s=L,d=0}else C===P&&d!==-1?++d:d=-1}return o}function E(t,c){l(c,"pathObject");const i=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return i?i===c.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let c="",i="",n=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],y(u,"path"),u.length===0)continue}else c.length===0?u=I.cwd():(u=I.env[`=${c}`]||I.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==c.toLowerCase()&&u.charCodeAt(2)===h)&&(u=`${c}\\`));const s=u.length;let d=0,C="",L=!1;const O=u.charCodeAt(0);if(s===1)a(O)&&(d=1,L=!0);else if(a(O))if(L=!0,a(u.charCodeAt(1))){let F=2,z=F;for(;F<s&&!a(u.charCodeAt(F));)F++;if(F<s&&F!==z){const q=u.slice(z,F);for(z=F;F<s&&a(u.charCodeAt(F));)F++;if(F<s&&F!==z){for(z=F;F<s&&!a(u.charCodeAt(F));)F++;(F===s||F!==z)&&(C=`\\\\${q}\\${u.slice(z,F)}`,d=F)}}}else d=1;else p(O)&&u.charCodeAt(1)===w&&(C=u.slice(0,2),d=2,s>2&&a(u.charCodeAt(2))&&(L=!0,d=3));if(C.length>0)if(c.length>0){if(C.toLowerCase()!==c.toLowerCase())continue}else c=C;if(n){if(c.length>0)break}else if(i=`${u.slice(d)}\\${i}`,n=L,L&&c.length>0)break}return i=b(i,!n,"\\",a),n?`${c}\\${i}`:`${c}${i}`||"."},normalize(t){y(t,"path");const c=t.length;if(c===0)return".";let i=0,n,o=!1;const u=t.charCodeAt(0);if(c===1)return f(u)?"\\":t;if(a(u))if(o=!0,a(t.charCodeAt(1))){let d=2,C=d;for(;d<c&&!a(t.charCodeAt(d));)d++;if(d<c&&d!==C){const L=t.slice(C,d);for(C=d;d<c&&a(t.charCodeAt(d));)d++;if(d<c&&d!==C){for(C=d;d<c&&!a(t.charCodeAt(d));)d++;if(d===c)return`\\\\${L}\\${t.slice(C)}\\`;d!==C&&(n=`\\\\${L}\\${t.slice(C,d)}`,i=d)}}}else i=1;else p(u)&&t.charCodeAt(1)===w&&(n=t.slice(0,2),i=2,c>2&&a(t.charCodeAt(2))&&(o=!0,i=3));let s=i<c?b(t.slice(i),!o,"\\",a):"";return s.length===0&&!o&&(s="."),s.length>0&&a(t.charCodeAt(c-1))&&(s+="\\"),n===void 0?o?`\\${s}`:s:o?`${n}\\${s}`:`${n}${s}`},isAbsolute(t){y(t,"path");const c=t.length;if(c===0)return!1;const i=t.charCodeAt(0);return a(i)||c>2&&p(i)&&t.charCodeAt(1)===w&&a(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,i;for(let u=0;u<t.length;++u){const s=t[u];y(s,"path"),s.length>0&&(c===void 0?c=i=s:c+=`\\${s}`)}if(c===void 0)return".";let n=!0,o=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++o;const u=i.length;u>1&&a(i.charCodeAt(1))&&(++o,u>2&&(a(i.charCodeAt(2))?++o:n=!1))}if(n){for(;o<c.length&&a(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(t,c){if(y(t,"from"),y(c,"to"),t===c)return"";const i=e.win32.resolve(t),n=e.win32.resolve(c);if(i===n||(t=i.toLowerCase(),c=n.toLowerCase(),t===c))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===h;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===h;)u--;const s=u-o;let d=0;for(;d<c.length&&c.charCodeAt(d)===h;)d++;let C=c.length;for(;C-1>d&&c.charCodeAt(C-1)===h;)C--;const L=C-d,O=s<L?s:L;let F=-1,z=0;for(;z<O;z++){const ie=t.charCodeAt(o+z);if(ie!==c.charCodeAt(d+z))break;ie===h&&(F=z)}if(z!==O){if(F===-1)return n}else{if(L>O){if(c.charCodeAt(d+z)===h)return n.slice(d+z+1);if(z===2)return n.slice(d+z)}s>O&&(t.charCodeAt(o+z)===h?F=z:z===2&&(F=3)),F===-1&&(F=0)}let q="";for(z=o+F+1;z<=u;++z)(z===u||t.charCodeAt(z)===h)&&(q+=q.length===0?"..":"\\..");return d+=F,q.length>0?`${q}${n.slice(d,C)}`:(n.charCodeAt(d)===h&&++d,n.slice(d,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===h){if(c.charCodeAt(1)===h){const i=c.charCodeAt(2);if(i!==v&&i!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===w&&c.charCodeAt(2)===h)return`\\\\?\\${c}`;return t},dirname(t){y(t,"path");const c=t.length;if(c===0)return".";let i=-1,n=0;const o=t.charCodeAt(0);if(c===1)return a(o)?t:".";if(a(o)){if(i=n=1,a(t.charCodeAt(1))){let d=2,C=d;for(;d<c&&!a(t.charCodeAt(d));)d++;if(d<c&&d!==C){for(C=d;d<c&&a(t.charCodeAt(d));)d++;if(d<c&&d!==C){for(C=d;d<c&&!a(t.charCodeAt(d));)d++;if(d===c)return t;d!==C&&(i=n=d+1)}}}}else p(o)&&t.charCodeAt(1)===w&&(i=c>2&&a(t.charCodeAt(2))?3:2,n=i);let u=-1,s=!0;for(let d=c-1;d>=n;--d)if(a(t.charCodeAt(d))){if(!s){u=d;break}}else s=!1;if(u===-1){if(i===-1)return".";u=i}return t.slice(0,u)},basename(t,c){c!==void 0&&y(c,"ext"),y(t,"path");let i=0,n=-1,o=!0,u;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===w&&(i=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let s=c.length-1,d=-1;for(u=t.length-1;u>=i;--u){const C=t.charCodeAt(u);if(a(C)){if(!o){i=u+1;break}}else d===-1&&(o=!1,d=u+1),s>=0&&(C===c.charCodeAt(s)?--s===-1&&(n=u):(s=-1,n=d))}return i===n?n=d:n===-1&&(n=t.length),t.slice(i,n)}for(u=t.length-1;u>=i;--u)if(a(t.charCodeAt(u))){if(!o){i=u+1;break}}else n===-1&&(o=!1,n=u+1);return n===-1?"":t.slice(i,n)},extname(t){y(t,"path");let c=0,i=-1,n=0,o=-1,u=!0,s=0;t.length>=2&&t.charCodeAt(1)===w&&p(t.charCodeAt(0))&&(c=n=2);for(let d=t.length-1;d>=c;--d){const C=t.charCodeAt(d);if(a(C)){if(!u){n=d+1;break}continue}o===-1&&(u=!1,o=d+1),C===P?i===-1?i=d:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||o===-1||s===0||s===1&&i===o-1&&i===n+1?"":t.slice(i,o)},format:E.bind(null,"\\"),parse(t){y(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.length;let n=0,o=t.charCodeAt(0);if(i===1)return a(o)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(a(o)){if(n=1,a(t.charCodeAt(1))){let F=2,z=F;for(;F<i&&!a(t.charCodeAt(F));)F++;if(F<i&&F!==z){for(z=F;F<i&&a(t.charCodeAt(F));)F++;if(F<i&&F!==z){for(z=F;F<i&&!a(t.charCodeAt(F));)F++;F===i?n=F:F!==z&&(n=F+1)}}}}else if(p(o)&&t.charCodeAt(1)===w){if(i<=2)return c.root=c.dir=t,c;if(n=2,a(t.charCodeAt(2))){if(i===3)return c.root=c.dir=t,c;n=3}}n>0&&(c.root=t.slice(0,n));let u=-1,s=n,d=-1,C=!0,L=t.length-1,O=0;for(;L>=n;--L){if(o=t.charCodeAt(L),a(o)){if(!C){s=L+1;break}continue}d===-1&&(C=!1,d=L+1),o===P?u===-1?u=L:O!==1&&(O=1):u!==-1&&(O=-1)}return d!==-1&&(u===-1||O===0||O===1&&u===d-1&&u===s+1?c.base=c.name=t.slice(s,d):(c.name=t.slice(s,u),c.base=t.slice(s,d),c.ext=t.slice(u,d))),s>0&&s!==n?c.dir=t.slice(0,s-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(m){const t=/\\/g;return()=>{const c=I.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let c="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const o=n>=0?t[n]:k();y(o,"path"),o.length!==0&&(c=`${o}/${c}`,i=o.charCodeAt(0)===g)}return c=b(c,!i,"/",f),i?`/${c}`:c.length>0?c:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g,i=t.charCodeAt(t.length-1)===g;return t=b(t,!c,"/",f),t.length===0?c?"/":i?"./":".":(i&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let c;for(let i=0;i<t.length;++i){const n=t[i];y(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(y(t,"from"),y(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const i=1,n=t.length,o=n-i,u=1,s=c.length-u,d=o<s?o:s;let C=-1,L=0;for(;L<d;L++){const F=t.charCodeAt(i+L);if(F!==c.charCodeAt(u+L))break;F===g&&(C=L)}if(L===d)if(s>d){if(c.charCodeAt(u+L)===g)return c.slice(u+L+1);if(L===0)return c.slice(u+L)}else o>d&&(t.charCodeAt(i+L)===g?C=L:L===0&&(C=0));let O="";for(L=i+C+1;L<=n;++L)(L===n||t.charCodeAt(L)===g)&&(O+=O.length===0?"..":"/..");return`${O}${c.slice(u+C)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g;let i=-1,n=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===g){if(!n){i=o;break}}else n=!1;return i===-1?c?"/":".":c&&i===1?"//":t.slice(0,i)},basename(t,c){c!==void 0&&y(c,"ext"),y(t,"path");let i=0,n=-1,o=!0,u;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let s=c.length-1,d=-1;for(u=t.length-1;u>=0;--u){const C=t.charCodeAt(u);if(C===g){if(!o){i=u+1;break}}else d===-1&&(o=!1,d=u+1),s>=0&&(C===c.charCodeAt(s)?--s===-1&&(n=u):(s=-1,n=d))}return i===n?n=d:n===-1&&(n=t.length),t.slice(i,n)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===g){if(!o){i=u+1;break}}else n===-1&&(o=!1,n=u+1);return n===-1?"":t.slice(i,n)},extname(t){y(t,"path");let c=-1,i=0,n=-1,o=!0,u=0;for(let s=t.length-1;s>=0;--s){const d=t.charCodeAt(s);if(d===g){if(!o){i=s+1;break}continue}n===-1&&(o=!1,n=s+1),d===P?c===-1?c=s:u!==1&&(u=1):c!==-1&&(u=-1)}return c===-1||n===-1||u===0||u===1&&c===n-1&&c===i+1?"":t.slice(c,n)},format:E.bind(null,"/"),parse(t){y(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.charCodeAt(0)===g;let n;i?(c.root="/",n=1):n=0;let o=-1,u=0,s=-1,d=!0,C=t.length-1,L=0;for(;C>=n;--C){const O=t.charCodeAt(C);if(O===g){if(!d){u=C+1;break}continue}s===-1&&(d=!1,s=C+1),O===P?o===-1?o=C:L!==1&&(L=1):o!==-1&&(L=-1)}if(s!==-1){const O=u===0&&i?1:u;o===-1||L===0||L===1&&o===s-1&&o===u+1?c.base=c.name=t.slice(O,s):(c.name=t.slice(O,o),c.base=t.slice(O,s),c.ext=t.slice(o,s))}return u>0?c.dir=t.slice(0,u-1):i&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(Z[72],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var M;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(M=e.Source||(e.Source={}));var r;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(r=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...g){const h=g.reduce((S,l)=>(S[l]=!0,S),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(S=>!h[S]).forEach(S=>{for(let l=0;l<w.length;l++)if(S.search(w[l])!==-1){delete P[S];break}})}e.sanitizeProcessEnvironment=R;function D(P){!P||(delete P.DEBUG,I.isMacintosh&&delete P.DYLD_LIBRARY_PATH,I.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Z[73],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=I.globals.performance&&typeof I.globals.performance.now=="function";class r{static create(D=!0){return new r(D)}constructor(D){this._highResolution=M&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?I.globals.performance.now():Date.now()}}e.StopWatch=r}),define(Z[3],ee([0,1,13,50,2,100,73]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,g=!1;var h;(function(u){u.None=()=>r.Disposable.None;function s(_){if(g){const{onDidAddListener:$}=_,Q=y.create();let N=0;_.onDidAddListener=()=>{++N===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),$?.()}}}function d(_,$){return oe(_,()=>{},0,void 0,!0,void 0,$)}u.defer=d;function C(_){return($,Q=null,N)=>{let j=!1,G;return G=_(re=>{if(!j)return G?G.dispose():j=!0,$.call(Q,re)},null,N),j&&G.dispose(),G}}u.once=C;function L(_,$,Q){return se((N,j=null,G)=>_(re=>N.call(j,$(re)),null,G),Q)}u.map=L;function O(_,$,Q){return se((N,j=null,G)=>_(re=>{$(re),N.call(j,re)},null,G),Q)}u.forEach=O;function F(_,$,Q){return se((N,j=null,G)=>_(re=>$(re)&&N.call(j,re),null,G),Q)}u.filter=F;function z(_){return _}u.signal=z;function q(..._){return($,Q=null,N)=>(0,r.combinedDisposable)(..._.map(j=>j(G=>$.call(Q,G),null,N)))}u.any=q;function ie(_,$,Q,N){let j=Q;return L(_,G=>(j=$(j,G),j),N)}u.reduce=ie;function se(_,$){let Q;const N={onWillAddFirstListener(){Q=_(j.fire,j)},onDidRemoveLastListener(){Q?.dispose()}};$||s(N);const j=new a(N);return $?.add(j),j.event}function oe(_,$,Q=100,N=!1,j=!1,G,re){let ue,ye,Me,Te=0,Ae;const We={leakWarningThreshold:G,onWillAddFirstListener(){ue=_(pe=>{Te++,ye=$(ye,pe),N&&!Me&&(me.fire(ye),ye=void 0),Ae=()=>{const ke=ye;ye=void 0,Me=void 0,(!N||Te>1)&&me.fire(ke),Te=0},typeof Q=="number"?(clearTimeout(Me),Me=setTimeout(Ae,Q)):Me===void 0&&(Me=0,queueMicrotask(Ae))})},onWillRemoveListener(){j&&Te>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,ue.dispose()}};re||s(We);const me=new a(We);return re?.add(me),me.event}u.debounce=oe;function he(_,$=0,Q){return u.debounce(_,(N,j)=>N?(N.push(j),N):[j],$,void 0,!0,void 0,Q)}u.accumulate=he;function le(_,$=(N,j)=>N===j,Q){let N=!0,j;return F(_,G=>{const re=N||!$(G,j);return N=!1,j=G,re},Q)}u.latch=le;function ge(_,$,Q){return[u.filter(_,$,Q),u.filter(_,N=>!$(N),Q)]}u.split=ge;function V(_,$=!1,Q=[]){let N=Q.slice(),j=_(ue=>{N?N.push(ue):re.fire(ue)});const G=()=>{N?.forEach(ue=>re.fire(ue)),N=null},re=new a({onWillAddFirstListener(){j||(j=_(ue=>re.fire(ue)))},onDidAddFirstListener(){N&&($?setTimeout(G):G())},onDidRemoveLastListener(){j&&j.dispose(),j=null}});return re.event}u.buffer=V;class B{constructor($){this.event=$,this.disposables=new r.DisposableStore}map($){return new B(L(this.event,$,this.disposables))}forEach($){return new B(O(this.event,$,this.disposables))}filter($){return new B(F(this.event,$,this.disposables))}reduce($,Q){return new B(ie(this.event,$,Q,this.disposables))}latch(){return new B(le(this.event,void 0,this.disposables))}debounce($,Q=100,N=!1,j=!1,G){return new B(oe(this.event,$,Q,N,j,G,this.disposables))}on($,Q,N){return this.event($,Q,N)}once($,Q,N){return C(this.event)($,Q,N)}dispose(){this.disposables.dispose()}}function T(_){return new B(_)}u.chain=T;function H(_,$,Q=N=>N){const N=(...ue)=>re.fire(Q(...ue)),j=()=>_.on($,N),G=()=>_.removeListener($,N),re=new a({onWillAddFirstListener:j,onDidRemoveLastListener:G});return re.event}u.fromNodeEventEmitter=H;function Y(_,$,Q=N=>N){const N=(...ue)=>re.fire(Q(...ue)),j=()=>_.addEventListener($,N),G=()=>_.removeEventListener($,N),re=new a({onWillAddFirstListener:j,onDidRemoveLastListener:G});return re.event}u.fromDOMEventEmitter=Y;function te(_){return new Promise($=>C(_)($))}u.toPromise=te;function ne(_,$){return $(void 0),_(Q=>$(Q))}u.runAndSubscribe=ne;function U(_,$){let Q=null;function N(G){Q?.dispose(),Q=new r.DisposableStore,$(G,Q)}N(void 0);const j=_(G=>N(G));return(0,r.toDisposable)(()=>{j.dispose(),Q?.dispose()})}u.runAndSubscribeWithStore=U;class A{constructor($,Q){this.obs=$,this._counter=0,this._hasChanged=!1;const N={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Q||s(N),this.emitter=new a(N),Q&&Q.add(this.emitter)}beginUpdate($){this._counter++}handleChange($,Q){this._hasChanged=!0}endUpdate($){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function W(_,$){return new A(_,$).emitter.event}u.fromObservable=W})(h=e.Event||(e.Event={}));class w{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${w._idPool++}`,w.all.add(this)}start(s){this._stopWatch=new D.StopWatch(!0),this.listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this._stopWatch=void 0}}}w.all=new Set,w._idPool=0,e.EventProfiling=w;let v=-1;function S(u){const s=v;return v=u,{dispose(){v=s}}}e.setGlobalLeakWarningThreshold=S;class l{constructor(s,d=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=d,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(s,d){const C=this.threshold;if(C<=0||d<C)return;this._stacks||(this._stacks=new Map);const L=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=C*.5;let O,F=0;for(const[z,q]of this._stacks)(!O||F<q)&&(O=z,F=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${F}):`),console.warn(O)}return()=>{const O=this._stacks.get(s.value)||0;this._stacks.set(s.value,O-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(s,d,C){this.callback=s,this.callbackThis=d,this.stack=C,this.subscription=new r.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class a{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=v>0||this._options?.leakWarningThreshold?new l(this._options?.leakWarningThreshold??v):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const d of s)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,d,C)=>{if(this._listeners||(this._listeners=new R.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;const L=this._listeners.isEmpty();L&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let O,F;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(F=y.create(),O=this._leakageMon.check(F,this._listeners.size+1)),P&&(F=F??y.create());const z=new m(s,d,F),q=this._listeners.push(z);L&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,s,d);const ie=z.subscription.set(()=>{O?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),q(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return C instanceof r.DisposableStore?C.add(ie):Array.isArray(C)&&C.push(ie),ie}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const d of this._listeners)this._deliveryQueue.push(this,d,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=a;class f{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(s,d,C){this._queue.push(new b(s,d,C))}clear(s){const d=new R.LinkedList;for(const C of this._queue)C.emitter!==s&&d.push(C);this._queue=d}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(d){(0,I.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=f;class p extends f{clear(s){this._queue.clear()}}class b{constructor(s,d,C){this.emitter=s,this.listener=d,this.event=C}}class E extends a{async fireAsync(s,d,C){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const L of this._listeners)this._asyncDeliveryQueue.push([L,s]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[L,O]=this._asyncDeliveryQueue.shift(),F=[],z={...O,token:d,waitUntil:q=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");C&&(q=C(q,L.callback)),F.push(q)}};try{L.invoke(z)}catch(q){(0,I.onUnexpectedError)(q);continue}Object.freeze(F),await Promise.allSettled(F).then(q=>{for(const ie of q)ie.status==="rejected"&&(0,I.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=E;class k extends a{constructor(s){super(s),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=k;class t extends k{constructor(s){super(s),this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=t;class c extends a{constructor(s){super(s),this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){!this.hasListeners()||(this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=c;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const d={event:s,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const C=()=>{this.hasListeners&&this.unhook(d);const L=this.events.indexOf(d);this.events.splice(L,1)};return(0,r.toDisposable)((0,M.once)(C))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(d=>this.emitter.fire(d))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(s){return(d,C,L)=>s(O=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>d.call(C,O)):d.call(C,O)},void 0,L)}bufferEvents(s){const d=[];this.buffers.push(d);const C=s();return this.buffers.pop(),d.forEach(L=>L()),C}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=r.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(Z[22],ee([0,1,3]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(P,g){const h=setTimeout(P.bind(g),0);return{dispose(){clearTimeout(h)}}});var r;(function(P){function g(h){return h===P.None||h===P.Cancelled||h instanceof R?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}P.isCancellationToken=g,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(r=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=r.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=D}),define(Z[149],ee([0,1,22]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class M{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new I.CancellationTokenSource,g=this.task(P.token);return this.result={promise:g,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=M;class r{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const g=JSON.stringify(P);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=r;class R{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const g=this.fn(P);return this._map.set(P,g),g}}e.CachedFunction=R}),define(Z[27],ee([0,1,149,132]),function(x,e,I,M){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function P(K,...ce){return ce.length===0?K:K.replace(D,function(fe,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=ce.length?fe:ce[ve]})}e.format=P;const g=/{([^}]+)}/g;function h(K,ce){return K.replace(g,(fe,Se)=>ce[Se]??fe)}e.format2=h;function w(K){return K.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=w;function v(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function S(K,ce){let fe=0;const Se=ce.charCodeAt(0);for(let ve=K.length-1;ve>=0;ve--)K.charCodeAt(ve)===Se&&fe++;return fe}e.count=S;function l(K,ce,fe="\u2026"){return K.length<=ce?K:`${K.substr(0,ce)}${fe}`}e.truncate=l;function y(K,ce=" "){const fe=m(K,ce);return a(fe,ce)}e.trim=y;function m(K,ce){if(!K||!ce)return K;const fe=ce.length;if(fe===0||K.length===0)return K;let Se=0;for(;K.indexOf(ce,Se)===Se;)Se=Se+fe;return K.substring(Se)}e.ltrim=m;function a(K,ce){if(!K||!ce)return K;const fe=ce.length,Se=K.length;if(fe===0||Se===0)return K;let ve=Se,Le=-1;for(;Le=K.lastIndexOf(ce,ve-1),!(Le===-1||Le+fe!==ve);){if(Le===0)return"";ve=Le}return K.substring(0,ve)}e.rtrim=a;function f(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p(K){return K.replace(/\*/g,"")}e.stripWildcards=p;function b(K,ce,fe={}){if(!K)throw new Error("Cannot create regex from empty string");ce||(K=v(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Se="";return fe.global&&(Se+="g"),fe.matchCase||(Se+="i"),fe.multiline&&(Se+="m"),fe.unicode&&(Se+="u"),new RegExp(K,Se)}e.createRegExp=b;function E(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function k(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function t(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=t;function c(K){return K.split(/\r\n|\r|\n/)}e.splitLines=c;function i(K){for(let ce=0,fe=K.length;ce<fe;ce++){const Se=K.charCodeAt(ce);if(Se!==32&&Se!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function n(K,ce=0,fe=K.length){for(let Se=ce;Se<fe;Se++){const ve=K.charCodeAt(Se);if(ve!==32&&ve!==9)return K.substring(ce,Se)}return K.substring(ce,fe)}e.getLeadingWhitespace=n;function o(K,ce=K.length-1){for(let fe=ce;fe>=0;fe--){const Se=K.charCodeAt(fe);if(Se!==32&&Se!==9)return fe}return-1}e.lastNonWhitespaceIndex=o;function u(K,ce,fe){const Se=[];let ve=0;for(const Le of K.matchAll(ce)){if(Se.push(K.slice(ve,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");ve=Le.index+Le[0].length,Se.push(fe(Le[0],...Le.slice(1),Le.index,K,Le.groups))}return Se.push(K.slice(ve)),Promise.all(Se).then(Le=>Le.join(""))}e.replaceAsync=u;function s(K,ce){return K<ce?-1:K>ce?1:0}e.compare=s;function d(K,ce,fe=0,Se=K.length,ve=0,Le=ce.length){for(;fe<Se&&ve<Le;fe++,ve++){const Ve=K.charCodeAt(fe),Ke=ce.charCodeAt(ve);if(Ve<Ke)return-1;if(Ve>Ke)return 1}const Ue=Se-fe,je=Le-ve;return Ue<je?-1:Ue>je?1:0}e.compareSubstring=d;function C(K,ce){return L(K,ce,0,K.length,0,ce.length)}e.compareIgnoreCase=C;function L(K,ce,fe=0,Se=K.length,ve=0,Le=ce.length){for(;fe<Se&&ve<Le;fe++,ve++){let Ve=K.charCodeAt(fe),Ke=ce.charCodeAt(ve);if(Ve===Ke)continue;if(Ve>=128||Ke>=128)return d(K.toLowerCase(),ce.toLowerCase(),fe,Se,ve,Le);F(Ve)&&(Ve-=32),F(Ke)&&(Ke-=32);const Ye=Ve-Ke;if(Ye!==0)return Ye}const Ue=Se-fe,je=Le-ve;return Ue<je?-1:Ue>je?1:0}e.compareSubstringIgnoreCase=L;function O(K){return K>=48&&K<=57}e.isAsciiDigit=O;function F(K){return K>=97&&K<=122}e.isLowerAsciiLetter=F;function z(K){return K>=65&&K<=90}e.isUpperAsciiLetter=z;function q(K,ce){return K.length===ce.length&&L(K,ce)===0}e.equalsIgnoreCase=q;function ie(K,ce){const fe=ce.length;return ce.length>K.length?!1:L(K,ce,0,fe)===0}e.startsWithIgnoreCase=ie;function se(K,ce){const fe=Math.min(K.length,ce.length);let Se;for(Se=0;Se<fe;Se++)if(K.charCodeAt(Se)!==ce.charCodeAt(Se))return Se;return fe}e.commonPrefixLength=se;function oe(K,ce){const fe=Math.min(K.length,ce.length);let Se;const ve=K.length-1,Le=ce.length-1;for(Se=0;Se<fe;Se++)if(K.charCodeAt(ve-Se)!==ce.charCodeAt(Le-Se))return Se;return fe}e.commonSuffixLength=oe;function he(K){return 55296<=K&&K<=56319}e.isHighSurrogate=he;function le(K){return 56320<=K&&K<=57343}e.isLowSurrogate=le;function ge(K,ce){return(K-55296<<10)+(ce-56320)+65536}e.computeCodePoint=ge;function V(K,ce,fe){const Se=K.charCodeAt(fe);if(he(Se)&&fe+1<ce){const ve=K.charCodeAt(fe+1);if(le(ve))return ge(Se,ve)}return Se}e.getNextCodePoint=V;function B(K,ce){const fe=K.charCodeAt(ce-1);if(le(fe)&&ce>1){const Se=K.charCodeAt(ce-2);if(he(Se))return ge(Se,fe)}return fe}class T{get offset(){return this._offset}constructor(ce,fe=0){this._str=ce,this._len=ce.length,this._offset=fe}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=B(this._str,this._offset);return this._offset-=ce>=65536?2:1,ce}nextCodePoint(){const ce=V(this._str,this._len,this._offset);return this._offset+=ce>=65536?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=T;class H{get offset(){return this._iterator.offset}constructor(ce,fe=0){this._iterator=new T(ce,fe)}nextGraphemeLength(){const ce=Pe.getInstance(),fe=this._iterator,Se=fe.offset;let ve=ce.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Le=fe.offset,Ue=ce.getGraphemeBreakType(fe.nextCodePoint());if(ae(ve,Ue)){fe.setOffset(Le);break}ve=Ue}return fe.offset-Se}prevGraphemeLength(){const ce=Pe.getInstance(),fe=this._iterator,Se=fe.offset;let ve=ce.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Le=fe.offset,Ue=ce.getGraphemeBreakType(fe.prevCodePoint());if(ae(Ue,ve)){fe.setOffset(Le);break}ve=Ue}return Se-fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function Y(K,ce){return new H(K,ce).nextGraphemeLength()}e.nextCharLength=Y;function te(K,ce){return new H(K,ce).prevGraphemeLength()}e.prevCharLength=te;function ne(K,ce){ce>0&&le(K.charCodeAt(ce))&&ce--;const fe=ce+Y(K,ce);return[fe-te(K,fe),fe]}e.getCharContainingOffset=ne;function U(K){const ce=new H(K);let fe=0;for(;!ce.eol();)fe++,ce.nextGraphemeLength();return fe}e.charCount=U;let A;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(K){return A||(A=W()),A.test(K)}e.containsRTL=_;const $=/^[\t\n\r\x20-\x7E]*$/;function Q(K){return $.test(K)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=N;function j(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=j;function G(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=G;function re(K,ce){if(K.length<ce)return K;const fe=/\b/g;let Se=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<ce);)Se=fe.lastIndex,fe.lastIndex+=1;return K.substring(Se).replace(/^\s/,"")}e.lcut=re;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ye(K){return K&&(K=K.replace(ue,"")),K}e.removeAnsiEscapeCodes=ye,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function Te(K){return Me(K)?K.substr(1):K}e.stripUTF8BOM=Te;function Ae(K,ce){if(!K||!ce||K.length<ce.length)return!1;const fe=ce.length,Se=K.toLowerCase();let ve=0,Le=-1;for(;ve<fe;){const Ue=Se.indexOf(ce[ve],Le+1);if(Ue<0)return!1;Le=Ue,ve++}return!0}e.fuzzyContains=Ae;function We(K,ce=!1){return K?(ce&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=We;function me(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=me;function pe(K,ce=1){if(ce===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),ce--;while(ce>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=pe;function ke(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=ke;function J(K){return Pe.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=J;function ae(K,ce){return K===0?ce!==5&&ce!==7:K===2&&ce===3?!1:K===4||K===2||K===3||ce===4||ce===2||ce===3?!0:!(K===8&&(ce===8||ce===9||ce===11||ce===12)||(K===11||K===9)&&(ce===9||ce===10)||(K===12||K===10)&&ce===10||ce===5||ce===13||ce===7||K===1||K===13&&ce===14||K===6&&ce===6)}var de;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Pe{static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const fe=this._data,Se=fe.length/3;let ve=1;for(;ve<=Se;)if(ce<fe[3*ve])ve=2*ve;else if(ce>fe[3*ve+1])ve=2*ve+1;else return fe[3*ve+2];return 0}}Pe._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(K,ce){if(K===0)return 0;const fe=_e(K,ce);if(fe!==void 0)return fe;const Se=new T(ce,K);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Oe;function _e(K,ce){const fe=new T(ce,K);let Se=fe.prevCodePoint();for(;Be(Se)||Se===65039||Se===8419;){if(fe.offset===0)return;Se=fe.prevCodePoint()}if(!G(Se))return;let ve=fe.offset;return ve>0&&fe.prevCodePoint()===8205&&(ve=fe.offset),ve}function Be(K){return 127995<=K&&K<=127999}var ze;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(ce){return Fe.cache.get(Array.from(ce))}static getLocales(){return Fe._locales.value}constructor(ce){this.confusableDictionary=ce}isAmbiguous(ce){return this.confusableDictionary.has(ce)}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}r=Fe,Fe.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.cache=new I.LRUCachedFunction(K=>{function ce(Ke){const Ye=new Map;for(let Je=0;Je<Ke.length;Je+=2)Ye.set(Ke[Je],Ke[Je+1]);return Ye}function fe(Ke,Ye){const Je=new Map(Ke);for(const[st,ct]of Ye)Je.set(st,ct);return Je}function Se(Ke,Ye){if(!Ke)return Ye;const Je=new Map;for(const[st,ct]of Ke)Ye.has(st)&&Je.set(st,ct);return Je}const ve=r.ambiguousCharacterData.value;let Le=K.filter(Ke=>!Ke.startsWith("_")&&Ke in ve);Le.length===0&&(Le=["_default"]);let Ue;for(const Ke of Le){const Ye=ce(ve[Ke]);Ue=Se(Ue,Ye)}const je=ce(ve._common),Ve=fe(je,Ue);return new Fe(Ve)}),Fe._locales=new M.Lazy(()=>Object.keys(Fe.ambiguousCharacterData.value).filter(K=>!K.startsWith("_"))),e.AmbiguousCharacters=Fe;class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(ce){return qe.getData().has(ce)}static get codePoints(){return qe.getData()}}qe._data=void 0,e.InvisibleCharacters=qe}),define(Z[32],ee([0,1,9,4,27,10]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function P(o){return o.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=P;function g(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=g;function h(o,u=I.posix.sep){if(!o)return"";const s=o.length,d=o.charCodeAt(0);if(D(d)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let L=3;const O=L;for(;L<s&&!D(o.charCodeAt(L));L++);if(O!==L&&!D(o.charCodeAt(L+1))){for(L+=1;L<s;L++)if(D(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,u)}}return u}else if(f(d)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let C=o.indexOf("://");if(C!==-1){for(C+=3;C<s;C++)if(D(o.charCodeAt(C)))return o.slice(0,C+1)}return""}e.getRoot=h;function w(o){if(!M.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let s=2;const d=s;for(;s<o.length&&(u=o.charCodeAt(s),u!==92);s++);return!(d===s||(u=o.charCodeAt(s+1),isNaN(u)||u===92))}e.isUNC=w;const v=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,u=M.isWindows){const s=u?v:S;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||u&&l.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=y;function m(o,u,s){const d=o===u;return!s||d?d:!o||!u?!1:(0,r.equalsIgnoreCase)(o,u)}e.isEqual=m;function a(o,u,s,d=I.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(s){if(!(0,r.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let L=u.length;return u.charAt(u.length-1)===d&&L--,o.charAt(L)===d}return u.charAt(u.length-1)!==d&&(u+=d),o.indexOf(u)===0}e.isEqualOrParent=a;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function p(o,u){return M.isWindows&&o.endsWith(":")&&(o+=I.sep),(0,I.isAbsolute)(o)||(o=(0,I.join)(u,o)),o=(0,I.normalize)(o),M.isWindows?(o=(0,r.rtrim)(o,I.sep),o.endsWith(":")&&(o+=I.sep)):(o=(0,r.rtrim)(o,I.sep),o||(o=I.sep)),o}e.sanitizeFilePath=p;function b(o){const u=(0,I.normalize)(o);return M.isWindows?o.length>3?!1:E(u)&&(o.length===2||u.charCodeAt(2)===92):u===I.posix.sep}e.isRootOrDriveLetter=b;function E(o,u=M.isWindows){return u?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function k(o){return E(o)?o[0]:void 0}e.getDriveLetter=k;function t(o,u,s){return u.length>o.length?-1:o===u?0:(s&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=t;function c(o){const u=o.split(":");let s,d,C;for(const L of u){const O=Number(L);(0,R.isNumber)(O)?d===void 0?d=O:C===void 0&&(C=O):s=s?[s,L].join(":"):L}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:C!==void 0?C:d!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,u,s=8){let d="";for(let L=0;L<s;L++)d+=i.charAt(Math.floor(Math.random()*i.length));let C;return u?C=`${u}-${d}`:C=d,o?(0,I.join)(o,C):C}e.randomPath=n}),define(Z[60],ee([0,1,27]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function M(f){return r(f,0)}e.hash=M;function r(f,p){switch(typeof f){case"object":return f===null?R(349,p):Array.isArray(f)?g(f,p):h(f,p);case"string":return P(f,p);case"boolean":return D(f,p);case"number":return R(f,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=r;function R(f,p){return(p<<5)-p+f|0}e.numberHash=R;function D(f,p){return R(f?433:863,p)}function P(f,p){p=R(149417,p);for(let b=0,E=f.length;b<E;b++)p=R(f.charCodeAt(b),p);return p}e.stringHash=P;function g(f,p){return p=R(104579,p),f.reduce((b,E)=>r(E,b),p)}function h(f,p){return p=R(181387,p),Object.keys(f).sort().reduce((b,E)=>(b=P(E,b),r(f[E],b)),p)}class w{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=r(p,this._value),this._value}}e.Hasher=w;var v;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function S(f,p,b=32){const E=b-p,k=~((1<<E)-1);return(f<<p|(k&f)>>>E)>>>0}function l(f,p=0,b=f.byteLength,E=0){for(let k=0;k<b;k++)f[p+k]=E}function y(f,p,b="0"){for(;f.length<p;)f=b+f;return f}function m(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):y((f>>>0).toString(16),p/4)}e.toHexString=m;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const b=p.length;if(b===0)return;const E=this._buff;let k=this._buffLen,t=this._leftoverHighSurrogate,c,i;for(t!==0?(c=t,i=-1,t=0):(c=p.charCodeAt(0),i=0);;){let n=c;if(I.isHighSurrogate(c))if(i+1<b){const o=p.charCodeAt(i+1);I.isLowSurrogate(o)?(i++,n=I.computeCodePoint(c,o)):n=65533}else{t=c;break}else I.isLowSurrogate(c)&&(n=65533);if(k=this._push(E,k,n),i++,i<b)c=p.charCodeAt(i);else break}this._buffLen=k,this._leftoverHighSurrogate=t}_push(p,b,E){return E<128?p[b++]=E:E<2048?(p[b++]=192|(E&1984)>>>6,p[b++]=128|(E&63)>>>0):E<65536?(p[b++]=224|(E&61440)>>>12,p[b++]=128|(E&4032)>>>6,p[b++]=128|(E&63)>>>0):(p[b++]=240|(E&1835008)>>>18,p[b++]=128|(E&258048)>>>12,p[b++]=128|(E&4032)>>>6,p[b++]=128|(E&63)>>>0),b>=64&&(this._step(),b-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,l(this._buff,this._buffLen),this._buffLen>56&&(this._step(),l(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=a._bigBlock32,b=this._buffDV;for(let s=0;s<64;s+=4)p.setUint32(s,b.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)p.setUint32(s,S(p.getUint32(s-12,!1)^p.getUint32(s-32,!1)^p.getUint32(s-56,!1)^p.getUint32(s-64,!1),1),!1);let E=this._h0,k=this._h1,t=this._h2,c=this._h3,i=this._h4,n,o,u;for(let s=0;s<80;s++)s<20?(n=k&t|~k&c,o=1518500249):s<40?(n=k^t^c,o=1859775393):s<60?(n=k&t|k&c|t&c,o=2400959708):(n=k^t^c,o=3395469782),u=S(E,5)+n+i+o+p.getUint32(s*4,!1)&4294967295,i=c,c=t,t=S(k,30),k=E,E=u;this._h0=this._h0+E&4294967295,this._h1=this._h1+k&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}a._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=a}),define(Z[74],ee([0,1,27]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(M||(M={})),function(r){const R="error",D="warning",P="warn",g="info",h="ignore";function w(S){return S?I.equalsIgnoreCase(R,S)?r.Error:I.equalsIgnoreCase(D,S)||I.equalsIgnoreCase(P,S)?r.Warning:I.equalsIgnoreCase(g,S)?r.Info:r.Ignore:r.Ignore}r.fromValue=w;function v(S){switch(S){case r.Error:return R;case r.Warning:return D;case r.Info:return g;default:return h}}r.toString=v}(M||(M={})),e.default=M}),define(Z[61],ee([0,1,25,27]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const y=l.charCodeAt(0),m=this._value.charCodeAt(this._pos);return y-m}value(){return this._value[this._pos]}}e.StringIterator=r;class R{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,M.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class D{constructor(l=!0,y=!0){this._splitOnBackslash=l,this._caseSensitive=y}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let y=l.length-1;y>=0;y--,this._valueLen--){const m=this._value.charCodeAt(y);if(!(m===47||this._splitOnBackslash&&m===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,M.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var P;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(P||(P={}));class g{constructor(l,y){this._ignorePathCasing=l,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,M.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(w||(w={}));class v{static forUris(l=()=>!1,y=()=>!1){return new v(new g(l,y))}static forPaths(l=!1){return new v(new D(void 0,!l))}static forStrings(){return new v(new r)}static forConfigKeys(){return new v(new R)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,y){if(y){const m=y.slice(0);(0,I.shuffle)(m);for(const a of m)this.set(a,l)}else{const m=l.slice(0);(0,I.shuffle)(m);for(const a of m)this.set(a[0],a[1])}}set(l,y){const m=this._iter.reset(l);let a;this._root||(this._root=new h,this._root.segment=m.value());const f=[];for(a=this._root;;){const b=m.cmp(a.segment);if(b>0)a.left||(a.left=new h,a.left.segment=m.value()),f.push([-1,a]),a=a.left;else if(b<0)a.right||(a.right=new h,a.right.segment=m.value()),f.push([1,a]),a=a.right;else if(m.hasNext())m.next(),a.mid||(a.mid=new h,a.mid.segment=m.value()),f.push([0,a]),a=a.mid;else break}const p=a.value;a.value=y,a.key=l;for(let b=f.length-1;b>=0;b--){const E=f[b][1];E.updateHeight();const k=E.balanceFactor();if(k<-1||k>1){const t=f[b][0],c=f[b+1][0];if(t===1&&c===1)f[b][1]=E.rotateLeft();else if(t===-1&&c===-1)f[b][1]=E.rotateRight();else if(t===1&&c===-1)E.right=f[b+1][1]=f[b+1][1].rotateRight(),f[b][1]=E.rotateLeft();else if(t===-1&&c===1)E.left=f[b+1][1]=f[b+1][1].rotateLeft(),f[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(f[b-1][0]){case-1:f[b-1][1].left=f[b][1];break;case 1:f[b-1][1].right=f[b][1];break;case 0:f[b-1][1].mid=f[b][1];break}else this._root=f[0][1]}}return p}get(l){return this._getNode(l)?.value}_getNode(l){const y=this._iter.reset(l);let m=this._root;for(;m;){const a=y.cmp(m.segment);if(a>0)m=m.left;else if(a<0)m=m.right;else if(y.hasNext())y.next(),m=m.mid;else break}return m}has(l){const y=this._getNode(l);return!(y?.value===void 0&&y?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,y){const m=this._iter.reset(l),a=[];let f=this._root;for(;f;){const p=m.cmp(f.segment);if(p>0)a.push([-1,f]),f=f.left;else if(p<0)a.push([1,f]),f=f.right;else if(m.hasNext())m.next(),a.push([0,f]),f=f.mid;else break}if(!!f){if(y?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this._min(f.right);if(p.key){const{key:b,value:E,segment:k}=p;this._delete(p.key,!1),f.key=b,f.value=E,f.segment=k}}else{const p=f.left??f.right;if(a.length>0){const[b,E]=a[a.length-1];switch(b){case-1:E.left=p;break;case 0:E.mid=p;break;case 1:E.right=p;break}}else this._root=p}for(let p=a.length-1;p>=0;p--){const b=a[p][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),a[p][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),a[p][1]=b.rotateRight()),p>0)switch(a[p-1][0]){case-1:a[p-1][1].left=a[p][1];break;case 1:a[p-1][1].right=a[p][1];break;case 0:a[p-1][1].mid=a[p][1];break}else this._root=a[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const y=this._iter.reset(l);let m=this._root,a;for(;m;){const f=y.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(y.hasNext())y.next(),a=m.value||a,m=m.mid;else break}return m&&m.value||a}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,y){const m=this._iter.reset(l);let a=this._root;for(;a;){const f=m.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(m.hasNext())m.next(),a=a.mid;else return a.mid?this._entries(a.mid):y?a.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[y,m]of this)l(m,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const y=[];return this._dfsEntries(l,y),y[Symbol.iterator]()}_dfsEntries(l,y){!l||(l.left&&this._dfsEntries(l.left,y),l.value&&y.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,y),l.right&&this._dfsEntries(l.right,y))}_isBalanced(){const l=y=>{if(!y)return!0;const m=y.balanceFactor();return m<-1||m>1?!1:l(y.left)&&l(y.right)};return l(this._root)}}e.TernarySearchTree=v}),define(Z[8],ee([0,1,9,4]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,n){return!i&&!n?"file":i}function h(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const w="",v="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(n){return n instanceof l?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,u,s,d,C=!1){typeof n=="object"?(this.scheme=n.scheme||w,this.authority=n.authority||w,this.path=n.path||w,this.query=n.query||w,this.fragment=n.fragment||w):(this.scheme=g(n,C),this.authority=o||w,this.path=h(this.scheme,u||w),this.query=s||w,this.fragment=d||w,P(this,C))}get fsPath(){return b(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:u,path:s,query:d,fragment:C}=n;return o===void 0?o=this.scheme:o===null&&(o=w),u===void 0?u=this.authority:u===null&&(u=w),s===void 0?s=this.path:s===null&&(s=w),d===void 0?d=this.query:d===null&&(d=w),C===void 0?C=this.fragment:C===null&&(C=w),o===this.scheme&&u===this.authority&&s===this.path&&d===this.query&&C===this.fragment?this:new m(o,u,s,d,C)}static parse(n,o=!1){const u=S.exec(n);return u?new m(u[2]||w,c(u[4]||w),c(u[5]||w),c(u[7]||w),c(u[9]||w),o):new m(w,w,w,w,w)}static file(n){let o=w;if(M.isWindows&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const u=n.indexOf(v,2);u===-1?(o=n.substring(2),n=v):(o=n.substring(2,u),n=n.substring(u)||v)}return new m("file",o,n,w,w)}static from(n){const o=new m(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return M.isWindows&&n.scheme==="file"?u=l.file(I.win32.join(b(n,!0),...o)).path:u=I.posix.join(n.path,...o),n.with({path:u})}toString(n=!1){return E(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof l)return n;{const o=new m(n);return o._formatted=n.external,o._fsPath=n._sep===y?n.fsPath:null,o}}else return n}}e.URI=l;const y=M.isWindows?1:void 0;class m extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(n=!1){return n?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=y),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,n,o){let u,s=-1;for(let d=0;d<i.length;d++){const C=i.charCodeAt(d);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||n&&C===47||o&&C===91||o&&C===93||o&&C===58)s!==-1&&(u+=encodeURIComponent(i.substring(s,d)),s=-1),u!==void 0&&(u+=i.charAt(d));else{u===void 0&&(u=i.substr(0,d));const L=a[C];L!==void 0?(s!==-1&&(u+=encodeURIComponent(i.substring(s,d)),s=-1),u+=L):s===-1&&(s=d)}}return s!==-1&&(u+=encodeURIComponent(i.substring(s))),u!==void 0?u:i}function p(i){let n;for(let o=0;o<i.length;o++){const u=i.charCodeAt(o);u===35||u===63?(n===void 0&&(n=i.substr(0,o)),n+=a[u]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function b(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,M.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=b;function E(i,n){const o=n?p:f;let u="",{scheme:s,authority:d,path:C,query:L,fragment:O}=i;if(s&&(u+=s,u+=":"),(d||s==="file")&&(u+=v,u+=v),d){let F=d.indexOf("@");if(F!==-1){const z=d.substr(0,F);d=d.substr(F+1),F=z.lastIndexOf(":"),F===-1?u+=o(z,!1,!1):(u+=o(z.substr(0,F),!1,!1),u+=":",u+=o(z.substr(F+1),!1,!0)),u+="@"}d=d.toLowerCase(),F=d.lastIndexOf(":"),F===-1?u+=o(d,!1,!0):(u+=o(d.substr(0,F),!1,!0),u+=d.substr(F))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const F=C.charCodeAt(1);F>=65&&F<=90&&(C=`/${String.fromCharCode(F+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const F=C.charCodeAt(0);F>=65&&F<=90&&(C=`${String.fromCharCode(F+32)}:${C.substr(2)}`)}u+=o(C,!0,!1)}return L&&(u+="?",u+=o(L,!1,!1)),O&&(u+="#",u+=n?O:f(O,!1,!1)),u}function k(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+k(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,n=>k(n)):i}}),define(Z[150],ee([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(h){const w=h;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.isRemoteConsoleLog=M;function r(h){const w=[];let v;try{const S=JSON.parse(h.arguments),l=S[S.length-1];l&&l.__$stack&&(S.pop(),v=l.__$stack),w.push(...S)}catch{w.push("Unable to log remote console arguments",h.arguments)}return{args:w,stack:v}}e.parse=r;function R(h){if(typeof h!="string")return R(r(h).stack);const w=h;if(w){const v=D(w),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(S&&S.length===4)return{uri:I.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=R;function D(h){if(!h)return h;const w=h.indexOf(`
`);return w===-1?h:h.substring(0,w)}function P(h,w){const{args:v,stack:S}=r(h),l=typeof v[0]=="string"&&v.length===1;let y=D(S);y&&(y=`(${y.trim()})`);let m=[];if(typeof v[0]=="string"?y&&l?m=[`%c[${w}] %c${v[0]} %c${y}`,g("blue"),g(""),g("grey")]:m=[`%c[${w}] %c${v[0]}`,g("blue"),g(""),...v.slice(1)]:m=[`%c[${w}]%`,g("blue"),...v],y&&!l&&m.push(y),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,m)}e.log=P;function g(h){return`color: ${h}`}}),define(Z[84],ee([0,1,17,27,8]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(h){return JSON.stringify(h,P)}e.stringify=R;function D(h){let w=JSON.parse(h);return w=g(w),w}e.parse=D;function P(h,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,M.regExpFlags)(w)}:w}function g(h,w=0){if(!h||w>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return r.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof I.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let v=0;v<h.length;++v)h[v]=g(h[v],w+1);else for(const v in h)Object.hasOwnProperty.call(h,v)&&(h[v]=g(h[v],w+1))}return h}e.revive=g}),define(Z[14],ee([0,1,13,4,8]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${R.vscodeRemoteResource}`}set(w,v,S){this._hosts[w]=v,this._ports[w]=S}setConnectionToken(w,v){this._connectionTokens[w]=v}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)try{return this._delegate(w)}catch(a){return I.onUnexpectedError(a),w}const v=w.authority;let S=this._hosts[v];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const l=this._ports[v],y=this._connectionTokens[v];let m=`path=${encodeURIComponent(w.path)}`;return typeof y=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),r.URI.from({scheme:M.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${S}:${l}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(w){const v=this.toUri(w,x);return this.uriToBrowserUri(v)}uriToBrowserUri(w){return w.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===R.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${R.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?w.with({scheme:R.vscodeFileResource,authority:w.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(w){const v=this.toUri(w,x);return this.uriToFileUri(v)}uriToFileUri(w){return w.scheme===R.vscodeFileResource?w.with({scheme:R.file,authority:w.authority!==P.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(w,v){return r.URI.isUri(w)?w:r.URI.parse(v.toUrl(w))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var g;(function(h){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(w.get("3"));const v="vscode-coi";function S(y){let m;typeof y=="string"?m=new URL(y).searchParams:y instanceof URL?m=y.searchParams:r.URI.isUri(y)&&(m=new URL(y.toString(!0)).searchParams);const a=m?.get(v);if(!!a)return w.get(a)}h.getHeadersFromQuery=S;function l(y,m,a){if(!globalThis.crossOriginIsolated)return;const f=m&&a?"3":a?"2":"1";y instanceof URLSearchParams?y.set(v,f):y[v]=f}h.addSearchParam=l})(g=e.COI||(e.COI={}))}),define(Z[19],ee([0,1,32,14,9,4,27,8]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(l){return(0,P.uriToFsPath)(l,!0)}e.originalFSPath=g;class h{constructor(y){this._ignorePathCasing=y}compare(y,m,a=!1){return y===m?0:(0,D.compare)(this.getComparisonKey(y,a),this.getComparisonKey(m,a))}isEqual(y,m,a=!1){return y===m?!0:!y||!m?!1:this.getComparisonKey(y,a)===this.getComparisonKey(m,a)}getComparisonKey(y,m=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,m,a=!1){if(y.scheme===m.scheme){if(y.scheme===M.Schemas.file)return I.isEqualOrParent(g(y),g(m),this._ignorePathCasing(y))&&y.query===m.query&&(a||y.fragment===m.fragment);if((0,e.isEqualAuthority)(y.authority,m.authority))return I.isEqualOrParent(y.path,m.path,this._ignorePathCasing(y),"/")&&y.query===m.query&&(a||y.fragment===m.fragment)}return!1}joinPath(y,...m){return P.URI.joinPath(y,...m)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return r.posix.basename(y.path)}extname(y){return r.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let m;return y.scheme===M.Schemas.file?m=P.URI.file(r.dirname(g(y))).path:(m=r.posix.dirname(y.path),y.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),m="/")),y.with({path:m})}normalizePath(y){if(!y.path.length)return y;let m;return y.scheme===M.Schemas.file?m=P.URI.file(r.normalize(g(y))).path:m=r.posix.normalize(y.path),y.with({path:m})}relativePath(y,m){if(y.scheme!==m.scheme||!(0,e.isEqualAuthority)(y.authority,m.authority))return;if(y.scheme===M.Schemas.file){const p=r.relative(g(y),g(m));return R.isWindows?I.toSlashes(p):p}let a=y.path||"/";const f=m.path||"/";if(this._ignorePathCasing(y)){let p=0;for(const b=Math.min(a.length,f.length);p<b&&!(a.charCodeAt(p)!==f.charCodeAt(p)&&a.charAt(p).toLowerCase()!==f.charAt(p).toLowerCase());p++);a=f.substr(0,p)+a.substr(p)}return r.posix.relative(a,f)}resolvePath(y,m){if(y.scheme===M.Schemas.file){const a=P.URI.file(r.resolve(g(y),m));return y.with({authority:a.authority,path:a.path})}return m=I.toPosixPath(m),y.with({path:r.posix.resolve(y.path,m)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,m){return y===m||y!==void 0&&m!==void 0&&(0,D.equalsIgnoreCase)(y,m)}hasTrailingPathSeparator(y,m=r.sep){if(y.scheme===M.Schemas.file){const a=g(y);return a.length>I.getRoot(a).length&&a[a.length-1]===m}else{const a=y.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,m=r.sep){return(0,e.hasTrailingPathSeparator)(y,m)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,m=r.sep){let a=!1;if(y.scheme===M.Schemas.file){const f=g(y);a=f!==void 0&&f.length===I.getRoot(f).length&&f[f.length-1]===m}else{m="/";const f=y.path;a=f.length===1&&f.charCodeAt(f.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(y,m)?y.with({path:y.path+"/"}):y}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(l=>l.scheme===M.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new h(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(l,y){const m=[];for(let a=0;a<l.length;a++){const f=y(l[a]);l.some((p,b)=>b===a?!1:(0,e.isEqualOrParent)(f,y(p)))||m.push(l[a])}return m}e.distinctParents=w;var v;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function y(m){const a=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,k]=b.split(":");E&&k&&a.set(E,k)});const p=m.path.substring(0,m.path.indexOf(";"));return p&&a.set(l.META_DATA_MIME,p),a}l.parseMetaData=y})(v=e.DataUri||(e.DataUri={}));function S(l,y,m){if(y){let a=l.path;return a&&a[0]!==r.posix.sep&&(a=r.posix.sep+a),l.with({scheme:m,authority:y,path:a})}return l.with({scheme:m})}e.toLocalResource=S}),define(Z[7],ee([0,1,22,13,3,2,19,4,135]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(U){return!!U&&typeof U.then=="function"}e.isThenable=h;function w(U){const A=new I.CancellationTokenSource,W=U(A.token),_=new Promise(($,Q)=>{const N=A.token.onCancellationRequested(()=>{N.dispose(),A.dispose(),Q(new M.CancellationError)});Promise.resolve(W).then(j=>{N.dispose(),A.dispose(),$(j)},j=>{N.dispose(),A.dispose(),Q(j)})});return new class{cancel(){A.cancel()}then($,Q){return _.then($,Q)}catch($){return this.then(void 0,$)}finally($){return _.finally($)}}}e.createCancelablePromise=w;function v(U,A,W){return new Promise((_,$)=>{const Q=A.onCancellationRequested(()=>{Q.dispose(),_(W)});U.then(_,$).finally(()=>Q.dispose())})}e.raceCancellation=v;function S(U,A){return new Promise((W,_)=>{const $=A.onCancellationRequested(()=>{$.dispose(),_(new M.CancellationError)});U.then(W,_).finally(()=>$.dispose())})}e.raceCancellationError=S;async function l(U){let A=-1;const W=U.map(($,Q)=>$.then(N=>(A=Q,N))),_=await Promise.race(W);return U.forEach(($,Q)=>{Q!==A&&$.cancel()}),_}e.raceCancellablePromises=l;function y(U,A,W){let _;const $=setTimeout(()=>{_?.(void 0),W?.()},A);return Promise.race([U.finally(()=>clearTimeout($)),new Promise(Q=>_=Q)])}e.raceTimeout=y;function m(U){return new Promise((A,W)=>{const _=U();h(_)?_.then(A,W):A(_)})}e.asPromise=m;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(W,W).then(_)})}return new Promise((W,_)=>{this.queuedPromise.then(W,_)})}return this.activePromise=A(),new Promise((W,_)=>{this.activePromise.then($=>{this.activePromise=null,W($)},$=>{this.activePromise=null,_($)})})}}e.Throttler=a;class f{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=f;class p{constructor(){this.promiseMap=new Map}queue(A,W){const $=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(A)===$&&this.promiseMap.delete(A)});return this.promiseMap.set(A,$),$}}e.SequencerByKey=p;const b=(U,A)=>{let W=!0;const _=setTimeout(()=>{W=!1,A()},U);return{isTriggered:()=>W,dispose:()=>{clearTimeout(_),W=!1}}},E=U=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,U())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};class k{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,W=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,Q)=>{this.doResolve=$,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===g.MicrotaskDelay?E(_):b(W,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new M.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=k;class t{constructor(A){this.delayer=new k(A),this.throttler=new a}trigger(A,W){return this.delayer.trigger(()=>this.throttler.queue(A),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this._isOpen=!1,this._promise=new Promise((A,W)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class i extends c{constructor(A){super(),this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function n(U,A){return A?new Promise((W,_)=>{const $=setTimeout(()=>{Q.dispose(),W()},U),Q=A.onCancellationRequested(()=>{clearTimeout($),Q.dispose(),_(new M.CancellationError)})}):w(W=>n(U,W))}e.timeout=n;function o(U,A=0){const W=setTimeout(U,A);return(0,R.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function u(U){const A=[];let W=0;const _=U.length;function $(){return W<_?U[W++]():null}function Q(N){N!=null&&A.push(N);const j=$();return j?j.then(Q):Promise.resolve(A)}return Promise.resolve(null).then(Q)}e.sequence=u;function s(U,A=_=>!!_,W=null){let _=0;const $=U.length,Q=()=>{if(_>=$)return Promise.resolve(W);const N=U[_++];return Promise.resolve(N()).then(G=>A(G)?Promise.resolve(G):Q())};return Q()}e.first=s;function d(U,A=_=>!!_,W=null){if(U.length===0)return Promise.resolve(W);let _=U.length;const $=()=>{_=-1;for(const Q of U)Q.cancel?.()};return new Promise((Q,N)=>{for(const j of U)j.then(G=>{--_>=0&&A(G)?($(),Q(G)):_===0&&Q(W)}).catch(G=>{--_>=0&&($(),N(G))})})}e.firstParallel=d;class C{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(A){return this._size++,new Promise((W,_)=>{this.outstandingPromises.push({factory:A,c:W,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const W=A.factory();W.then(A.c,A.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=C;class L extends C{constructor(){super(1)}}e.Queue=L;class O{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new B;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,W=D.extUri){const _=W.getComparisonKey(A);let $=this.queues.get(_);return $||($=new L,r.Event.once($.onDrained)(()=>{$?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,$)),$}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=O;class F{constructor(A,W){this._token=-1,typeof A=="function"&&typeof W=="number"&&this.setIfNotSet(A,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},W)}setIfNotSet(A,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},W))}}e.TimeoutTimer=F;class z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,W){this.cancel(),this._token=setInterval(()=>{A()},W)}}e.IntervalTimer=z;class q{constructor(A,W){this.timeoutToken=-1,this.runner=A,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class ie{constructor(A,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ie;class se extends q{constructor(A,W){super(A,W),this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner?.(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=se;class oe extends R.Disposable{constructor(A,W){super(),this.options=A,this.handler=W,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const W of A)this.pendingWork.push(W);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,P.setTimeout0)(()=>{if(A)return;const W=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(U,A)=>{const W=requestIdleCallback(U,typeof A=="number"?{timeout:A}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(W))}}}}();class he{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=he;async function le(U,A,W){let _;for(let $=0;$<W;$++)try{return await U()}catch(Q){_=Q,await n(A)}throw _}e.retry=le;class ge{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(A,W,_){return this._pending={taskId:A,cancel:()=>_?.(),promise:W},W.then(()=>this.donePending(A),()=>this.donePending(A)),W}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let W,_;const $=new Promise((Q,N)=>{W=Q,_=N});this._next={run:A,promise:$,promiseResolve:W,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=ge;class V{constructor(A,W=()=>Date.now()){this.interval=A,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class B{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,W)=>{this.completeCallback=A,this.errorCallback=W})}complete(A){return new Promise(W=>{this.completeCallback(A),this.resolved=!0,W()})}error(A){return new Promise(W=>{this.errorCallback(A),this.rejected=!0,W()})}cancel(){new Promise(A=>{this.errorCallback(new M.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=B;var T;(function(U){async function A(_){let $;const Q=await Promise.all(_.map(N=>N.then(j=>j,j=>{$||($=j)})));if(typeof $<"u")throw $;return Q}U.settled=A;function W(_){return new Promise(async($,Q)=>{try{await _($,Q)}catch(N){Q(N)}})}U.withAsyncBody=W})(T=e.Promises||(e.Promises={}));var H;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(H||(H={}));class Y{static fromArray(A){return new Y(W=>{W.emitMany(A)})}static fromPromise(A){return new Y(async W=>{W.emitMany(await A)})}static fromPromises(A){return new Y(async W=>{await Promise.all(A.map(async _=>W.emitOne(await _)))})}static merge(A){return new Y(async W=>{await Promise.all(A.map(async _=>{for await(const $ of _)W.emitOne($)}))})}constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const W={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(A(W)),this.resolve()}catch(_){this.reject(_)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,W){return new Y(async _=>{for await(const $ of A)_.emitOne(W($))})}map(A){return Y.map(this,A)}static filter(A,W){return new Y(async _=>{for await(const $ of A)W($)&&_.emitOne($)})}filter(A){return Y.filter(this,A)}static coalesce(A){return Y.filter(A,W=>!!W)}coalesce(){return Y.coalesce(this)}static async toPromise(A){const W=[];for await(const _ of A)W.push(_);return W}toPromise(){return Y.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}Y.EMPTY=Y.fromArray([]),e.AsyncIterableObject=Y;class te extends Y{constructor(A,W){super(W),this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function ne(U){const A=new I.CancellationTokenSource,W=U(A.token);return new te(A,async _=>{const $=A.token.onCancellationRequested(()=>{$.dispose(),A.dispose(),_.reject(new M.CancellationError)});try{for await(const Q of W){if(A.token.isCancellationRequested)return;_.emitOne(Q)}$.dispose(),A.dispose()}catch(Q){$.dispose(),A.dispose(),_.reject(Q)}})}e.createCancelableAsyncIterable=ne}),define(Z[102],ee([0,1,25,7,32,35,9,4,27]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",v="[^/\\\\]",S=/\//g;function l(V,B){switch(V){case 0:return"";case 1:return`${v}*?`;default:return`(?:${w}|${v}+${w}${B?`|${w}${v}+`:""})*?`}}function y(V,B){if(!V)return[];const T=[];let H=!1,Y=!1,te="";for(const ne of V){switch(ne){case B:if(!H&&!Y){T.push(te),te="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}te+=ne}return te&&T.push(te),T}e.splitGlobAware=y;function m(V){if(!V)return"";let B="";const T=y(V,e.GLOB_SPLIT);if(T.every(H=>H===e.GLOBSTAR))B=".*";else{let H=!1;T.forEach((Y,te)=>{if(Y===e.GLOBSTAR){if(H)return;B+=l(2,te===T.length-1)}else{let ne=!1,U="",A=!1,W="";for(const _ of Y){if(_!=="}"&&ne){U+=_;continue}if(A&&(_!=="]"||!W)){let $;_==="-"?$=_:(_==="^"||_==="!")&&!W?$="^":_===e.GLOB_SPLIT?$="":$=(0,g.escapeRegExpCharacters)(_),W+=$;continue}switch(_){case"{":ne=!0;continue;case"[":A=!0;continue;case"}":{B+=`(?:${y(U,",").map(N=>m(N)).join("|")})`,ne=!1,U="";break}case"]":{B+="["+W+"]",A=!1,W="";break}case"?":B+=v;continue;case"*":B+=l(1);continue;default:B+=(0,g.escapeRegExpCharacters)(_)}}te<T.length-1&&(T[te+1]!==e.GLOBSTAR||te+2<T.length)&&(B+=w)}H=Y===e.GLOBSTAR})}return B}const a=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),c=function(){return!1},i=function(){return null};function n(V,B){if(!V)return i;let T;typeof V!="string"?T=V.pattern:T=V,T=T.trim();const H=`${T}_${!!B.trimForExclusions}`;let Y=t.get(H);if(Y)return o(Y,V);let te;return a.test(T)?Y=s(T.substr(4),T):(te=f.exec(u(T,B)))?Y=d(te[1],T):(B.trimForExclusions?b:p).test(T)?Y=C(T,B):(te=E.exec(u(T,B)))?Y=L(te[1].substr(1),T,!0):(te=k.exec(u(T,B)))?Y=L(te[1],T,!1):Y=O(T),t.set(H,Y),o(Y,V)}function o(V,B){if(typeof B=="string")return V;const T=function(H,Y){return(0,r.isEqualOrParent)(H,B.base,!P.isLinux)?V((0,g.ltrim)(H.substr(B.base.length),D.sep),Y):null};return T.allBasenames=V.allBasenames,T.allPaths=V.allPaths,T.basenames=V.basenames,T.patterns=V.patterns,T}function u(V,B){return B.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function s(V,B){return function(T,H){return typeof T=="string"&&T.endsWith(V)?B:null}}function d(V,B){const T=`/${V}`,H=`\\${V}`,Y=function(ne,U){return typeof ne!="string"?null:U?U===V?B:null:ne===V||ne.endsWith(T)||ne.endsWith(H)?B:null},te=[V];return Y.basenames=te,Y.patterns=[B],Y.allBasenames=te,Y}function C(V,B){const T=le(V.slice(1,-1).split(",").map(U=>n(U,B)).filter(U=>U!==i),V),H=T.length;if(!H)return i;if(H===1)return T[0];const Y=function(U,A){for(let W=0,_=T.length;W<_;W++)if(T[W](U,A))return V;return null},te=T.find(U=>!!U.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=T.reduce((U,A)=>A.allPaths?U.concat(A.allPaths):U,[]);return ne.length&&(Y.allPaths=ne),Y}function L(V,B,T){const H=D.sep===D.posix.sep,Y=H?V:V.replace(S,D.sep),te=D.sep+Y,ne=D.posix.sep+V;let U;return T?U=function(A,W){return typeof A=="string"&&(A===Y||A.endsWith(te)||!H&&(A===V||A.endsWith(ne)))?B:null}:U=function(A,W){return typeof A=="string"&&(A===Y||!H&&A===V)?B:null},U.allPaths=[(T?"*/":"./")+V],U}function O(V){try{const B=new RegExp(`^${m(V)}$`);return function(T){return B.lastIndex=0,typeof T=="string"&&B.test(T)?V:null}}catch{return i}}function F(V,B,T){return!V||typeof B!="string"?!1:z(V)(B,void 0,T)}e.match=F;function z(V,B={}){if(!V)return c;if(typeof V=="string"||q(V)){const T=n(V,B);if(T===i)return c;const H=function(Y,te){return!!T(Y,te)};return T.allBasenames&&(H.allBasenames=T.allBasenames),T.allPaths&&(H.allPaths=T.allPaths),H}return oe(V,B)}e.parse=z;function q(V){const B=V;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=q;function ie(V){return V.allBasenames||[]}e.getBasenameTerms=ie;function se(V){return V.allPaths||[]}e.getPathTerms=se;function oe(V,B){const T=le(Object.getOwnPropertyNames(V).map(U=>he(U,V[U],B)).filter(U=>U!==i)),H=T.length;if(!H)return i;if(!T.some(U=>!!U.requiresSiblings)){if(H===1)return T[0];const U=function(_,$){let Q;for(let N=0,j=T.length;N<j;N++){const G=T[N](_,$);if(typeof G=="string")return G;(0,M.isThenable)(G)&&(Q||(Q=[]),Q.push(G))}return Q?(async()=>{for(const N of Q){const j=await N;if(typeof j=="string")return j}return null})():null},A=T.find(_=>!!_.allBasenames);A&&(U.allBasenames=A.allBasenames);const W=T.reduce((_,$)=>$.allPaths?_.concat($.allPaths):_,[]);return W.length&&(U.allPaths=W),U}const Y=function(U,A,W){let _,$;for(let Q=0,N=T.length;Q<N;Q++){const j=T[Q];j.requiresSiblings&&W&&(A||(A=(0,D.basename)(U)),_||(_=A.substr(0,A.length-(0,D.extname)(U).length)));const G=j(U,A,_,W);if(typeof G=="string")return G;(0,M.isThenable)(G)&&($||($=[]),$.push(G))}return $?(async()=>{for(const Q of $){const N=await Q;if(typeof N=="string")return N}return null})():null},te=T.find(U=>!!U.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=T.reduce((U,A)=>A.allPaths?U.concat(A.allPaths):U,[]);return ne.length&&(Y.allPaths=ne),Y}function he(V,B,T){if(B===!1)return i;const H=n(V,T);if(H===i)return i;if(typeof B=="boolean")return H;if(B){const Y=B.when;if(typeof Y=="string"){const te=(ne,U,A,W)=>{if(!W||!H(ne,U))return null;const _=Y.replace("$(basename)",()=>A),$=W(_);return(0,M.isThenable)($)?$.then(Q=>Q?V:null):$?V:null};return te.requiresSiblings=!0,te}}return H}function le(V,B){const T=V.filter(U=>!!U.basenames);if(T.length<2)return V;const H=T.reduce((U,A)=>{const W=A.basenames;return W?U.concat(W):U},[]);let Y;if(B){Y=[];for(let U=0,A=H.length;U<A;U++)Y.push(B)}else Y=T.reduce((U,A)=>{const W=A.patterns;return W?U.concat(W):U},[]);const te=function(U,A){if(typeof U!="string")return null;if(!A){let _;for(_=U.length;_>0;_--){const $=U.charCodeAt(_-1);if($===47||$===92)break}A=U.substr(_)}const W=H.indexOf(A);return W!==-1?Y[W]:null};te.basenames=H,te.patterns=Y,te.allBasenames=H;const ne=V.filter(U=>!U.basenames);return ne.push(te),ne}function ge(V,B){return(0,I.equals)(V,B,(T,H)=>typeof T=="string"&&typeof H=="string"?T===H:typeof T!="string"&&typeof H!="string"?T.base===H.base&&T.pattern===H.pattern:!1)}e.patternsEquals=ge}),define(Z[45],ee([0,1,25,32,9,4,19,27]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(i,n){const{os:o,tildify:u,relative:s}=n;if(s){const L=h(i,s,o);if(typeof L=="string")return L}let d=i.fsPath;if(o===1&&!R.isWindows?d=d.replace(/\//g,"\\"):o!==1&&R.isWindows&&(d=d.replace(/\\/g,"/")),o!==1&&u?.userHome){const L=u.userHome.fsPath;let O;i.scheme!==u.userHome.scheme&&i.path.startsWith(r.posix.sep)?O=u.userHome.with({path:i.path}).fsPath:O=i.fsPath,d=S(O,L,o)}return(o===1?r.win32:r.posix).normalize(w(d,o===1))}e.getPathLabel=g;function h(i,n,o){const u=o===1?r.win32:r.posix,s=o===3?D.extUri:D.extUriIgnorePathCase,d=n.getWorkspace(),C=(0,I.firstOrDefault)(d.folders);if(!C)return;i.scheme!==C.uri.scheme&&i.path.startsWith(r.posix.sep)&&(i=C.uri.with({path:i.path}));const L=n.getWorkspaceFolder(i);if(!L)return;let O;if(s.isEqual(L.uri,i)?O="":O=s.relativePath(L.uri,i)??"",O&&(O=u.normalize(O)),d.folders.length>1&&!n.noPrefix){const F=L.name?L.name:s.basenameOrAuthority(L.uri);O=O?`${F} \u2022 ${O}`:F}return O}function w(i,n=R.isWindows){return(0,M.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=w;let v=Object.create(null);function S(i,n,o=R.OS){if(o===1||!i||!n)return i;let u=v.original===n?v.normalized:void 0;u||(u=n,R.isWindows&&(u=(0,M.toSlashes)(u)),u=`${(0,P.rtrim)(u,r.posix.sep)}${r.posix.sep}`,v={original:n,normalized:u});let s=i;return R.isWindows&&(s=(0,M.toSlashes)(s)),(o===3?s.startsWith(u):(0,P.startsWithIgnoreCase)(s,u))?`~/${s.substr(u.length)}`:i}e.tildify=S;function l(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=l;const y="\u2026",m="\\\\",a="~";function f(i,n=r.sep){const o=new Array(i.length);let u=!1;for(let s=0;s<i.length;s++){const d=i[s];if(d===""){o[s]=`.${n}`;continue}if(!d){o[s]=d;continue}u=!0;let C="",L=d;L.indexOf(m)===0?(C=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length)):L.indexOf(n)===0?(C=L.substr(0,L.indexOf(n)+n.length),L=L.substr(L.indexOf(n)+n.length)):L.indexOf(a)===0&&(C=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length));const O=L.split(n);for(let F=1;u&&F<=O.length;F++)for(let z=O.length-F;u&&z>=0;z--){u=!1;let q=O.slice(z,z+F).join(n);for(let ie=0;!u&&ie<i.length;ie++)if(ie!==s&&i[ie]&&i[ie].indexOf(q)>-1){const se=z+F===O.length,oe=z>0&&i[ie].indexOf(n)>-1?n+q:q,he=i[ie].endsWith(oe);u=!se||he}if(!u){let ie="";(O[0].endsWith(":")||C!=="")&&(z===1&&(z=0,F++,q=O[0]+n+q),z>0&&(ie=O[0]+n),ie=C+ie),z>0&&(ie=ie+y+n),ie=ie+q,z+F<O.length&&(ie=ie+n+y),o[s]=ie}}u&&(o[s]=d)}return o}e.shorten=f;var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(i,n=Object.create(null)){const o=[];let u=!1,s="";for(const d of i)if(d==="$"||u&&d==="{")s&&o.push({value:s,type:p.TEXT}),s="",u=!0;else if(d==="}"&&u){const C=n[s];if(typeof C=="string")C.length&&o.push({value:C,type:p.VARIABLE});else if(C){const L=o[o.length-1];(!L||L.type!==p.SEPARATOR)&&o.push({value:C.label,type:p.SEPARATOR})}s="",u=!1}else s+=d;return s&&!u&&o.push({value:s,type:p.TEXT}),o.filter((d,C)=>{if(d.type===p.SEPARATOR){const L=o[C-1],O=o[C+1];return[L,O].every(F=>F&&(F.type===p.VARIABLE||F.type===p.TEXT)&&F.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=b;function E(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function k(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=k;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const n=i.indexOf("/")!==-1?r.posix:r.win32,o=n.basename(i),u=n.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=c}),define(Z[151],ee([0,1,17,8]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(v){return v.toJSON()}class R{constructor(S){this._uriTransformer=S}transformIncoming(S){const l=this._uriTransformer.transformIncoming(S);return l===S?S:r(M.URI.from(l))}transformOutgoing(S){const l=this._uriTransformer.transformOutgoing(S);return l===S?S:r(M.URI.from(l))}transformOutgoingURI(S){const l=this._uriTransformer.transformOutgoing(S);return l===S?S:M.URI.from(l)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,S,l){if(!v||l>200)return null;if(typeof v=="object"){if(v instanceof M.URI)return S.transformOutgoing(v);for(const y in v)if(Object.hasOwnProperty.call(v,y)){const m=D(v[y],S,l+1);m!==null&&(v[y]=m)}}return null}function P(v,S){const l=D(v,S,0);return l===null?v:l}e.transformOutgoingURIs=P;function g(v,S,l,y){if(!v||y>200)return null;if(typeof v=="object"){if(v.$mid===1)return l?M.URI.revive(S.transformIncoming(v)):S.transformIncoming(v);if(v instanceof I.VSBuffer)return null;for(const m in v)if(Object.hasOwnProperty.call(v,m)){const a=g(v[m],S,l,y+1);a!==null&&(v[m]=a)}}return null}function h(v,S){const l=g(v,S,!1,0);return l===null?v:l}e.transformIncomingURIs=h;function w(v,S){const l=g(v,S,!0,0);return l===null?v:l}e.transformAndReviveIncomingURIs=w}),define(Z[85],ee([0,1,26,13,61,31,139]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(w){return this._virtualMachineOUIs||(this._virtualMachineOUIs=r.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(w)}value(){if(this._value===void 0){let w=0,v=0;const S=(0,I.networkInterfaces)();for(const l in S){const y=S[l];if(y)for(const{mac:m,internal:a}of y)a||(v+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(w+=1))}this._value=v>0?w/v:0}return this._value}};let P;async function g(){return P||(P=(async()=>await h()||R.generateUuid())()),P}e.getMachineId=g;async function h(){try{const w=await new Promise((S,l)=>{x(["crypto"],S,l)}),v=(0,D.getMac)();return w.createHash("sha256").update(v,"utf8").digest("hex")}catch(w){M.onUnexpectedError(w);return}}}),define(Z[23],ee([0,1,41,26,152,7,32,81,9,4,19,8]),function(x,e,I,M,r,R,D,P,g,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function l(oe,he=S.UNLINK){if((0,D.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");return he===S.UNLINK?m(oe):y(oe)}async function y(oe){try{const he=(0,D.randomPath)((0,M.tmpdir)());try{await I.promises.rename(oe,he)}catch(le){return le.code==="ENOENT"?void 0:m(oe)}m(he).catch(le=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function m(oe){return(0,r.promisify)(I.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function a(oe){if((0,D.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function f(oe,he){return E(await(he?p(oe):(0,r.promisify)(I.readdir)(oe)))}async function p(oe){try{return await(0,r.promisify)(I.readdir)(oe,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const he=[],le=await f(oe);for(const ge of le){let V=!1,B=!1,T=!1;try{const H=await e.Promises.lstat((0,g.join)(oe,ge));V=H.isFile(),B=H.isDirectory(),T=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}he.push({name:ge,isFile:()=>V,isDirectory:()=>B,isSymbolicLink:()=>T})}return he}function b(oe){return E(I.readdirSync(oe))}e.readdirSync=b;function E(oe){return oe.map(he=>typeof he=="string"?h.isMacintosh?(0,P.normalizeNFC)(he):he:(he.name=h.isMacintosh?(0,P.normalizeNFC)(he.name):he.name,he))}async function k(oe){const he=await f(oe),le=[];for(const ge of he)await c.existsDirectory((0,g.join)(oe,ge))&&le.push(ge);return le}function t(oe,he=1e3){return new Promise(le=>{let ge=!1;const V=setInterval(()=>{ge||(ge=!0,I.access(oe,B=>{ge=!1,B&&(clearInterval(V),le(void 0))}))},he)})}e.whenDeleted=t;var c;(function(oe){async function he(V){let B;try{if(B=await e.Promises.lstat(V),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(h.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw H}throw T}}oe.stat=he;async function le(V){try{const{stat:B,symbolicLink:T}=await oe.stat(V);return B.isFile()&&T?.dangling!==!0}catch{}return!1}oe.existsFile=le;async function ge(V){try{const{stat:B,symbolicLink:T}=await oe.stat(V);return B.isDirectory()&&T?.dangling!==!0}catch{}return!1}oe.existsDirectory=ge})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function n(oe,he,le){return i.queueFor(v.URI.file(oe),w.extUriBiasedIgnorePathCase).queue(()=>{const ge=C(le);return new Promise((V,B)=>s(oe,he,ge,T=>T?B(T):V()))})}let o=!0;function u(oe){o=oe}e.configureFlushOnWrite=u;function s(oe,he,le,ge){if(!o)return I.writeFile(oe,he,{mode:le.mode,flag:le.flag},ge);I.open(oe,le.flag,le.mode,(V,B)=>{if(V)return ge(V);I.writeFile(B,he,T=>{if(T)return I.close(B,()=>ge(T));I.fdatasync(B,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),u(!1)),I.close(B,Y=>ge(Y))))})})}function d(oe,he,le){const ge=C(le);if(!o)return I.writeFileSync(oe,he,{mode:ge.mode,flag:ge.flag});const V=I.openSync(oe,ge.flag,ge.mode);try{I.writeFileSync(V,he);try{I.fdatasyncSync(V)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),u(!1)}}finally{I.closeSync(V)}}e.writeFileSync=d;function C(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function L(oe,he){if(oe!==he)try{await e.Promises.rename(oe,he)}catch(le){if(oe.toLowerCase()!==he.toLowerCase()&&le.code==="EXDEV"||oe.endsWith("."))await O(oe,he,{preserveSymlinks:!1}),await l(oe,S.MOVE);else throw le}}async function O(oe,he,le){return z(oe,he,{root:{source:oe,target:he},options:le,handledSourcePaths:new Set})}const F=511;async function z(oe,he,le){if(le.handledSourcePaths.has(oe))return;le.handledSourcePaths.add(oe);const{stat:ge,symbolicLink:V}=await c.stat(oe);if(V){if(le.options.preserveSymlinks)try{return await se(oe,he,le)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(V.dangling)return}return ge.isDirectory()?q(oe,he,ge.mode&F,le):ie(oe,he,ge.mode&F)}async function q(oe,he,le,ge){await e.Promises.mkdir(he,{recursive:!0,mode:le});const V=await f(oe);for(const B of V)await z((0,g.join)(oe,B),(0,g.join)(he,B),ge)}async function ie(oe,he,le){await e.Promises.copyFile(oe,he),await e.Promises.chmod(he,le)}async function se(oe,he,le){let ge=await e.Promises.readlink(oe);(0,D.isEqualOrParent)(ge,le.root.source,!h.isLinux)&&(ge=(0,g.join)(le.root.target,ge.substr(le.root.source.length+1))),await e.Promises.symlink(ge,he)}e.Promises=new class{get access(){return(0,r.promisify)(I.access)}get stat(){return(0,r.promisify)(I.stat)}get lstat(){return(0,r.promisify)(I.lstat)}get utimes(){return(0,r.promisify)(I.utimes)}get read(){return(oe,he,le,ge,V)=>new Promise((B,T)=>{I.read(oe,he,le,ge,V,(H,Y,te)=>H?T(H):B({bytesRead:Y,buffer:te}))})}get readFile(){return(0,r.promisify)(I.readFile)}get write(){return(oe,he,le,ge,V)=>new Promise((B,T)=>{I.write(oe,he,le,ge,V,(H,Y,te)=>H?T(H):B({bytesWritten:Y,buffer:te}))})}get appendFile(){return(0,r.promisify)(I.appendFile)}get fdatasync(){return(0,r.promisify)(I.fdatasync)}get truncate(){return(0,r.promisify)(I.truncate)}get rename(){return(0,r.promisify)(I.rename)}get copyFile(){return(0,r.promisify)(I.copyFile)}get open(){return(0,r.promisify)(I.open)}get close(){return(0,r.promisify)(I.close)}get symlink(){return(0,r.promisify)(I.symlink)}get readlink(){return(0,r.promisify)(I.readlink)}get chmod(){return(0,r.promisify)(I.chmod)}get mkdir(){return(0,r.promisify)(I.mkdir)}get unlink(){return(0,r.promisify)(I.unlink)}get rmdir(){return(0,r.promisify)(I.rmdir)}get realpath(){return(0,r.promisify)(I.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return k}get writeFile(){return n}get rm(){return l}get move(){return L}get copy(){return O}}}),define(Z[103],ee([0,1,41,9,4,27,23]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(S){if(r.isLinux)return S;const l=(0,M.dirname)(S);if(S===l)return S;const y=((0,M.basename)(S)||S).toLowerCase();try{const a=(0,D.readdirSync)(l).filter(f=>f.toLowerCase()===y);if(a.length===1){const f=P(l);if(f)return(0,M.join)(f,a[0])}else if(a.length>1){const f=a.indexOf(y);if(f>=0){const p=P(l);if(p)return(0,M.join)(p,a[f])}}}catch{}return null}e.realcaseSync=P;async function g(S){if(r.isLinux)return S;const l=(0,M.dirname)(S);if(S===l)return S;const y=((0,M.basename)(S)||S).toLowerCase();try{const a=(await D.Promises.readdir(l)).filter(f=>f.toLowerCase()===y);if(a.length===1){const f=await g(l);if(f)return(0,M.join)(f,a[0])}else if(a.length>1){const f=a.indexOf(y);if(f>=0){const p=await g(l);if(p)return(0,M.join)(p,a[f])}}}catch{}return null}e.realcase=g;async function h(S){try{return await D.Promises.realpath(S)}catch{const y=v(S);return await D.Promises.access(y,I.constants.R_OK),y}}e.realpath=h;function w(S){try{return I.realpathSync(S)}catch{const y=v(S);return I.accessSync(y,I.constants.R_OK),y}}e.realpathSync=w;function v(S){return(0,R.rtrim)((0,M.normalize)(S),M.sep)}}),define(Z[153],ee([0,1,26,9,23]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(g||(g={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class v{constructor(k,t,c){this.exePath=k,this.displayName=t,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:E=!1}={}){return E?h===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:E=!1,findPreview:k=!1}={}){const t=S({useAlternateBitness:E});if(!t)return null;const c=M.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(c))return null;let i=-1,n=null;for(const s of await r.Promises.readdir(c)){let d=-1;if(k){const L=s.indexOf("-");if(L<0)continue;const O=s.substring(0,L);if(!R.test(O)||s.substring(L+1)!=="preview")continue;d=parseInt(O,10)}else{if(!R.test(s))continue;d=parseInt(s,10)}if(d<=i)continue;const C=M.join(c,s,"pwsh.exe");!await r.SymlinkSupport.existsFile(C)||(n=C,i=d)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",u=k?" Preview":"";return new v(n,`PowerShell${u}${o}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const k=M.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await r.Promises.readdir(k))if(t.test(i)){const n=M.join(k,i,"pwsh.exe");return new v(n,c)}return null}function m(){const E=M.join(I.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function a(){const E=M.join(process.env.windir,h===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*f(){let E=await l();E&&(yield E),E=await l({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=m(),E&&(yield E),E=await l({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await l({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=a(),E&&(yield E)}async function*p(){for await(const E of f())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=p;async function b(){for await(const E of p())return E;return null}e.getFirstAvailablePowerShellInstallation=b}),define(Z[86],ee([0,1,9,4,36,72,10,23]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(v=r.env){return v.comspec||"cmd.exe"}e.getWindowsShell=g;function h(v){let S=[],l=!1;const y=function(m){if(l){S.push(m);return}(!v.send(m,f=>{if(f&&console.error(f),l=!1,S.length>0){const p=S.slice(0);S=[],p.forEach(b=>y(b))}})||M.isWindows)&&(l=!0)};return{send:y}}e.createQueuedSender=h;var w;(function(v){async function S(l,y,m){if(I.isAbsolute(l))return l;if(y===void 0&&(y=r.cwd()),I.dirname(l)!=="."||(m===void 0&&D.isString(r.env.PATH)&&(m=r.env.PATH.split(I.delimiter)),m===void 0||m.length===0))return I.join(y,l);async function f(p){if(await P.Promises.exists(p)){let b;try{b=await P.Promises.stat(p)}catch(E){E.message.startsWith("EACCES")&&(b=await P.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of m){let b;if(I.isAbsolute(p)?b=I.join(p,l):b=I.join(y,p,l),await f(b))return b;let E=b+".com";if(await f(E)||(E=b+".exe",await f(E)))return E}return I.join(y,l)}v.findExecutable=S})(w=e.win32||(e.win32={}))}),define(Z[104],ee([0,1,46,14]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(D){return new Promise((P,g)=>{let h;const w=new Map;function v(l,y,m,a,f){const p=w.get(y);if(l===D||p){const b={name:S(m),cmd:m,pid:l,ppid:y,load:a,mem:f};w.set(l,b),l===D&&(h=b),p&&(p.children||(p.children=[]),p.children.push(b),p.children.length>1&&(p.children=p.children.sort((E,k)=>E.pid-k.pid)))}}function S(l){const y=/--vscode-window-kind=shared-process/i,m=/--vscode-window-kind=issue-reporter/i,a=/--vscode-window-kind=process-explorer/i,f=/--utility-sub-type=network/i,p=/--vscode-utility-kind=extensionHost/i,b=/--vscode-utility-kind=fileWatcher/i,E=/--vscode-utility-kind=shared-process/i,k=/--ms-enable-electron-run-as-node/i,t=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,i=/conhost\.exe/i,n=/--type=([a-zA-Z-]+)/;if(t.exec(l))return"electron-crash-reporter";if(c.exec(l))return"winpty-process";if(i.exec(l))return"console-window-host (Windows internal process)";let o=n.exec(l);if(o&&o.length===2)return o[1]==="renderer"?y.exec(l)?"shared-process":m.exec(l)?"issue-reporter":a.exec(l)?"process-explorer":"window":o[1]==="utility"?f.exec(l)?"utility-network-service":p.exec(l)?"extension-host":b.exec(l)?"file-watcher":E.exec(l)?"shared-process":"utility-process":o[1]==="extensionHost"?"extension-host":o[1];const u=/[a-zA-Z-]+\.js/g;let s="";do o=u.exec(l),o&&(s+=o+" ");while(o);return s&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${s})`:k.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substr(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substr(5):y;new Promise((y,m)=>{x(["windows-process-tree"],y,m)}).then(y=>{y.getProcessList(D,m=>{if(!m){g(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(m,a=>{const f=new Map;a.forEach(p=>{const b=l(p.commandLine||"");f.set(p.pid,{name:S(b),cmd:b,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),h=f.get(D),h?(f.forEach(p=>{const b=f.get(p.ppid);b&&(b.children||(b.children=[]),b.children.push(p))}),f.forEach(p=>{p.children&&(p.children=p.children.sort((b,E)=>b.pid-E.pid))}),P(h)):g(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let l=function(){let y=[h];const m=[];for(;y.length;){const f=y.shift();f&&(m.push(f.pid),f.children&&(y=y.concat(f.children)))}let a=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+m.join(" "),(0,I.exec)(a,{},(f,p,b)=>{if(f||b)g(f||new Error(b.toString()));else{const E=p.toString().split(`
`);for(let k=0;k<m.length;k++){const t=w.get(m[k]);t.load=parseFloat(E[k])}if(!h){g(new Error(`Root process ${D} not found`));return}P(h)}})};(0,I.exec)("which ps",{},(y,m,a)=>{if(y||a)if(process.platform!=="linux")g(y||new Error(a.toString()));else{const f=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(f,{},(p,b,E)=>{p||E?g(p||new Error(E.toString())):(R(b,v),l())})}else{const f=m.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${f} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,E,k)=>{b||k&&!k.includes("screen size is bogus")?g(b||new Error(k.toString())):(R(E,v),process.platform==="linux"?l():h?P(h):g(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=r;function R(D,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,h=D.toString().split(`
`);for(const w of h){const v=g.exec(w.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(Z[154],ee([0,1,26,4,153,86]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(v,S){return v===1?M.isWindows?w():R.getWindowsShell(S):g(v,S)}e.getSystemShell=D;let P=null;function g(v,S){if(M.isLinux&&v===2||M.isMacintosh&&v===3)return"/bin/bash";if(!P){let l;if(M.isWindows)l="/bin/bash";else{if(l=S.SHELL,!l)try{l=(0,I.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}P=l}return P}let h=null;async function w(){return h||(h=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),h}});var we=this&&this.__decorate||function(x,e,I,M){var r=arguments.length,R=r<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,I):M,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,e,I,M);else for(var P=x.length-1;P>=0;P--)(D=x[P])&&(R=(r<3?D(R):r>3?D(e,I,R):D(e,I))||R);return r>3&&R&&Object.defineProperty(e,I,R),R};define(Z[47],ee([0,1,25,7,17,22,54,13,3,2,84,27,10]),function(x,e,I,M,r,R,D,P,g,h,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var l;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(l||(l={}));function y(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(m||(m={}));function a(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function p(B){let T=0;for(let H=0;;H+=7){const Y=B.read(1);if(T|=(Y.buffer[0]&127)<<H,!(Y.buffer[0]&128))return T}}const b=i(0);function E(B,T){if(T===0){B.write(b);return}let H=0;for(let te=T;te!==0;te=te>>>7)H++;const Y=r.VSBuffer.alloc(H);for(let te=0;T!==0;te++)Y.buffer[te]=T&127,T=T>>>7,T>0&&(Y.buffer[te]|=128);B.write(Y)}class k{constructor(T){this.buffer=T,this.pos=0}read(T){const H=this.buffer.slice(this.pos,this.pos+T);return this.pos+=H.byteLength,H}}e.BufferReader=k;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}e.BufferWriter=t;var c;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(c||(c={}));function i(B){const T=r.VSBuffer.alloc(1);return T.writeUInt8(B,0),T}const n={Undefined:i(c.Undefined),String:i(c.String),Buffer:i(c.Buffer),VSBuffer:i(c.VSBuffer),Array:i(c.Array),Object:i(c.Object),Uint:i(c.Int)},o=typeof Buffer<"u";function u(B,T){if(typeof T>"u")B.write(n.Undefined);else if(typeof T=="string"){const H=r.VSBuffer.fromString(T);B.write(n.String),E(B,H.byteLength),B.write(H)}else if(o&&Buffer.isBuffer(T)){const H=r.VSBuffer.wrap(T);B.write(n.Buffer),E(B,H.byteLength),B.write(H)}else if(T instanceof r.VSBuffer)B.write(n.VSBuffer),E(B,T.byteLength),B.write(T);else if(Array.isArray(T)){B.write(n.Array),E(B,T.length);for(const H of T)u(B,H)}else if(typeof T=="number"&&(T|0)===T)B.write(n.Uint),E(B,T);else{const H=r.VSBuffer.fromString(JSON.stringify(T));B.write(n.Object),E(B,H.byteLength),B.write(H)}}e.serialize=u;function s(B){switch(B.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return B.read(p(B)).toString();case c.Buffer:return B.read(p(B)).buffer;case c.VSBuffer:return B.read(p(B));case c.Array:{const H=p(B),Y=[];for(let te=0;te<H;te++)Y.push(s(B));return Y}case c.Object:return JSON.parse(B.read(p(B)).toString());case c.Int:return p(B)}}e.deserialize=s;class d{constructor(T,H,Y=null,te=1e3){this.protocol=T,this.ctx=H,this.logger=Y,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:200})}registerChannel(T,H){this.channels.set(T,H),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const H=this.send([T.type]);this.logger?.logOutgoing(H,0,1,a(T.type));return}case 201:case 202:case 204:case 203:{const H=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(H,T.id,1,a(T.type),T.data);return}}}send(T,H=void 0){const Y=new t;return u(Y,T),u(Y,H),this.sendBuffer(Y.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const H=new k(T),Y=s(H),te=s(H),ne=Y[0];switch(ne){case 100:return this.logger?.logIncoming(T.byteLength,Y[1],1,`${y(ne)}: ${Y[2]}.${Y[3]}`,te),this.onPromise({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case 102:return this.logger?.logIncoming(T.byteLength,Y[1],1,`${y(ne)}: ${Y[2]}.${Y[3]}`,te),this.onEventListen({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case 101:return this.logger?.logIncoming(T.byteLength,Y[1],1,`${y(ne)}`),this.disposeActiveRequest({type:ne,id:Y[1]});case 103:return this.logger?.logIncoming(T.byteLength,Y[1],1,`${y(ne)}`),this.disposeActiveRequest({type:ne,id:Y[1]})}}onPromise(T){const H=this.channels.get(T.channelName);if(!H){this.collectPendingRequest(T);return}const Y=new R.CancellationTokenSource;let te;try{te=H.call(this.ctx,T.name,T.arg,Y.token)}catch(A){te=Promise.reject(A)}const ne=T.id;te.then(A=>{this.sendResponse({id:ne,data:A,type:201}),this.activeRequests.delete(T.id)},A=>{A instanceof Error?this.sendResponse({id:ne,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:ne,data:A,type:203}),this.activeRequests.delete(T.id)});const U=(0,h.toDisposable)(()=>Y.cancel());this.activeRequests.set(T.id,U)}onEventListen(T){const H=this.channels.get(T.channelName);if(!H){this.collectPendingRequest(T);return}const Y=T.id,ne=H.listen(this.ctx,T.name,T.arg)(U=>this.sendResponse({id:Y,data:U,type:204}));this.activeRequests.set(T.id,ne)}disposeActiveRequest(T){const H=this.activeRequests.get(T.id);H&&(H.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let H=this.pendingRequests.get(T.channelName);H||(H=[],this.pendingRequests.set(T.channelName,H));const Y=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:T,timeoutTimer:Y})}flushPendingRequests(T){const H=this.pendingRequests.get(T);if(H){for(const Y of H)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=d;var C;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(T,H=null){this.protocol=T,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=H}getChannel(T){const H=this;return{call(Y,te,ne){return H.isDisposed?Promise.reject(new P.CancellationError):H.requestPromise(T,Y,te,ne)},listen(Y,te){return H.isDisposed?g.Event.None:H.requestEvent(T,Y,te)}}}requestPromise(T,H,Y,te=R.CancellationToken.None){const ne=this.lastRequestId++,A={id:ne,type:100,channelName:T,name:H,arg:Y};if(te.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise(($,Q)=>{if(te.isCancellationRequested)return Q(new P.CancellationError);const N=()=>{const ue=ye=>{switch(ye.type){case 201:this.handlers.delete(ne),$(ye.data);break;case 202:{this.handlers.delete(ne);const Me=new Error(ye.data.message);Me.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,Me.name=ye.data.name,Q(Me);break}case 203:this.handlers.delete(ne),Q(ye.data);break}};this.handlers.set(ne,ue),this.sendRequest(A)};let j=null;this.state===f.Idle?N():(j=(0,M.createCancelablePromise)(ue=>this.whenInitialized()),j.then(()=>{j=null,N()}));const G=()=>{j?(j.cancel(),j=null):this.sendRequest({id:ne,type:101}),Q(new P.CancellationError)},re=te.onCancellationRequested(G);W=(0,h.combinedDisposable)((0,h.toDisposable)(G),re),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent(T,H,Y){const te=this.lastRequestId++,U={id:te,type:102,channelName:T,name:H,arg:Y};let A=null;const W=new g.Emitter({onWillAddFirstListener:()=>{A=(0,M.createCancelablePromise)($=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(W),this.sendRequest(U)})},onDidRemoveLastListener:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(W),this.sendRequest({id:te,type:103}))}}),_=$=>W.fire($.data);return this.handlers.set(te,_),W.event}sendRequest(T){switch(T.type){case 100:case 102:{const H=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger?.logOutgoing(H,T.id,0,`${y(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const H=this.send([T.type,T.id]);this.logger?.logOutgoing(H,T.id,0,y(T.type));return}}}send(T,H=void 0){const Y=new t;return u(Y,T),u(Y,H),this.sendBuffer(Y.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const H=new k(T),Y=s(H),te=s(H),ne=Y[0];switch(ne){case 200:return this.logger?.logIncoming(T.byteLength,0,0,a(ne)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(T.byteLength,Y[1],0,a(ne),te),this.onResponse({type:Y[0],id:Y[1],data:te})}}onResponse(T){if(T.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(T.id)?.(T)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}we([D.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class O{get connections(){const T=[];return this._connections.forEach(H=>T.push(H)),T}constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:H,onDidClientDisconnect:Y})=>{g.Event.once(H.onMessage)(ne=>{const U=new k(ne),A=s(U),W=new d(H,A),_=new L(H);this.channels.forEach((Q,N)=>W.registerChannel(N,Q));const $={channelServer:W,channelClient:_,ctx:A};this._connections.add($),this._onDidAddConnection.fire($),Y(()=>{W.dispose(),_.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)})})})}getChannel(T,H){const Y=this;return{call(te,ne,U){let A;if((0,S.isFunction)(H)){const _=(0,I.getRandomElement)(Y.connections.filter(H));A=_?Promise.resolve(_):g.Event.toPromise(g.Event.filter(Y.onDidAddConnection,H))}else A=H.routeCall(Y,te,ne);const W=A.then(_=>_.channelClient.getChannel(T));return z(W).call(te,ne,U)},listen(te,ne){if((0,S.isFunction)(H))return Y.getMulticastEvent(T,H,te,ne);const U=H.routeEvent(Y,te,ne).then(A=>A.channelClient.getChannel(T));return z(U).listen(te,ne)}}}getMulticastEvent(T,H,Y,te){const ne=this;let U=new h.DisposableStore;const A=new g.Emitter({onWillAddFirstListener:()=>{U=new h.DisposableStore;const W=new g.EventMultiplexer,_=new Map,$=N=>{const G=N.channelClient.getChannel(T).listen(Y,te),re=W.add(G);_.set(N,re)},Q=N=>{const j=_.get(N);!j||(j.dispose(),_.delete(N))};ne.connections.filter(H).forEach($),g.Event.filter(ne.onDidAddConnection,H)($,void 0,U),ne.onDidRemoveConnection(Q,void 0,U),W.event(A.fire,A,U),U.add(W)},onDidRemoveLastListener:()=>{U.dispose()}});return A.event}registerChannel(T,H){this.channels.set(T,H),this._connections.forEach(Y=>{Y.channelServer.registerChannel(T,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class F{constructor(T,H,Y=null){const te=new t;u(te,H),T.send(te.buffer),this.channelClient=new L(T,Y),this.channelServer=new d(T,H,Y)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,H){this.channelServer.registerChannel(T,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function z(B){return{call(T,H,Y){return B.then(te=>te.call(T,H,Y))},listen(T,H){const Y=new g.Relay;return B.then(te=>Y.input=te.listen(T,H)),Y.event}}}e.getDelayedChannel=z;function q(B){let T=!1;return{call(H,Y,te){return T?B.call(H,Y,te):(0,M.timeout)(0).then(()=>T=!0).then(()=>B.call(H,Y,te))},listen(H,Y){if(T)return B.listen(H,Y);const te=new g.Relay;return(0,M.timeout)(0).then(()=>T=!0).then(()=>te.input=B.listen(H,Y)),te.event}}}e.getNextTickChannel=q;class ie{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const H of T.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await g.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=ie;var se;(function(B){function T(ne,U){const A=ne,W=U&&U.disableMarshalling,_=new Map;for(const $ in A)Y($)&&_.set($,g.Event.buffer(A[$],!0));return new class{listen($,Q,N){const j=_.get(Q);if(j)return j;if(te(Q)){const G=A[Q];if(typeof G=="function")return G.call(A,N)}throw new Error(`Event not found: ${Q}`)}call($,Q,N){const j=A[Q];if(typeof j=="function"){if(!W&&Array.isArray(N))for(let G=0;G<N.length;G++)N[G]=(0,w.revive)(N[G]);return j.apply(A,N)}throw new Error(`Method not found: ${Q}`)}}}B.fromService=T;function H(ne,U){const A=U&&U.disableMarshalling;return new Proxy({},{get(W,_){if(typeof _=="string")return U?.properties?.has(_)?U.properties.get(_):te(_)?function($){return ne.listen(_,$)}:Y(_)?ne.listen(_):async function(...$){let Q;U&&!(0,S.isUndefinedOrNull)(U.context)?Q=[U.context,...$]:Q=$;const N=await ne.call(_,Q);return A?N:(0,w.revive)(N)};throw new Error(`Property not found: ${String(_)}`)}})}B.toService=H;function Y(ne){return ne[0]==="o"&&ne[1]==="n"&&v.isUpperAsciiLetter(ne.charCodeAt(2))}function te(ne){return/^onDynamic/.test(ne)&&v.isUpperAsciiLetter(ne.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const T=B.toString();if(T!=="[object Object]")return T}return B}function le(B){return Array.isArray(B)?B.map(he):he(B)}function ge(B,T,H,Y,te,ne,U){U=le(U);const A=oe[te],W=A[Y%A.length];let _=[`%c[${B}]%c[${String(T).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ne)?(_=_.concat(U),_.push(")")):_.push(U),console.log.apply(console,_)}class V{constructor(T,H){this._outgoingPrefix=T,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,H,Y,te,ne){this._totalOutgoing+=T,ge(this._outgoingPrefix,this._totalOutgoing,T,H,Y,te,ne)}logIncoming(T,H,Y,te,ne){this._totalIncoming+=T,ge(this._incomingPrefix,this._totalIncoming,T,H,Y,te,ne)}}e.IPCLogger=V}),define(Z[155],ee([0,1,17,3,47]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.port=g,this.onMessage=M.Event.fromDOMEventEmitter(this.port,"message",h=>I.VSBuffer.wrap(h.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends r.IPCClient{constructor(g,h){const w=new R(g);super(w,h),this.protocol=w}dispose(){this.protocol.disconnect()}}e.Client=D}),define(Z[105],ee([0,1,7,17,3,2,47]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var g;(function(L){L.enableDiagnostics=!1,L.records=[];const O=new WeakMap;let F=0;function z(ie,se){if(!O.has(ie)){const oe=String(++F);O.set(ie,oe)}return O.get(ie)}function q(ie,se,oe,he){if(!L.enableDiagnostics)return;const le=z(ie,se);if(he instanceof M.VSBuffer||he instanceof Uint8Array||he instanceof ArrayBuffer||ArrayBuffer.isView(he)){const ge=M.VSBuffer.alloc(he.byteLength);ge.set(he),L.records.push({timestamp:Date.now(),id:le,label:se,type:oe,buff:ge})}else L.records.push({timestamp:Date.now(),id:le,label:se,type:oe,data:he})}L.traceSocketEvent=q})(g=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function v(){return w||(w=M.VSBuffer.alloc(0)),w}class S{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(O){this._chunks.push(O),this._totalLength+=O.byteLength}read(O){return this._read(O,!0)}peek(O){return this._read(O,!1)}_read(O,F){if(O===0)return v();if(O>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===O){const se=this._chunks[0];return F&&(this._chunks.shift(),this._totalLength-=O),se}if(this._chunks[0].byteLength>O){const se=this._chunks[0].slice(0,O);return F&&(this._chunks[0]=this._chunks[0].slice(O),this._totalLength-=O),se}const z=M.VSBuffer.alloc(O);let q=0,ie=0;for(;O>0;){const se=this._chunks[ie];if(se.byteLength>O){const oe=se.slice(0,O);z.set(oe,q),q+=O,F&&(this._chunks[ie]=se.slice(O),this._totalLength-=O),O-=O}else z.set(se,q),q+=se.byteLength,F?(this._chunks.shift(),this._totalLength-=se.byteLength):ie++,O-=se.byteLength}return z}}e.ChunkStream=S;var l;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(l||(l={}));function y(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var m;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(O,F,z,q){this.type=O,this.id=F,this.ack=z,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends R.Disposable{constructor(O){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=O,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(O);this._incomingData.byteLength>=this._state.readLen;){const F=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=F.readUInt32BE(9),this._state.messageType=F.readUInt8(0),this._state.id=F.readUInt32BE(1),this._state.ack=F.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const z=this._state.messageType,q=this._state.id,ie=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",F),this._onMessage.fire(new a(z,q,ie,F)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(O){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=O,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(O){if(this._isDisposed)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=M.VSBuffer.alloc(13);F.writeUInt8(O.type,0),F.writeUInt32BE(O.id,1),F.writeUInt32BE(O.ack,5),F.writeUInt32BE(O.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",O.data),this._writeSoon(F,O.data)}_bufferAdd(O,F){const z=this._totalLength===0;return this._data.push(O,F),this._totalLength+=O.byteLength+F.byteLength,z}_bufferTake(){const O=M.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,O}_writeSoon(O,F){this._bufferAdd(O,F)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const O=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this._socket.write(O)}}class b extends R.Disposable{constructor(O){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=O,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(F=>{F.type===1&&this._onMessage.fire(F.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(O){this._socketWriter.write(new a(1,0,0,O))}}e.Protocol=b;class E extends D.IPCClient{static fromSocket(O,F){return new E(new b(O),F)}get onDidDispose(){return this.protocol.onDidDispose}constructor(O,F,z=null){super(O,F,z),this.protocol=O}dispose(){super.dispose();const O=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),O.end()}}e.Client=E;class k{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(O){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(O):this._emitter.fire(O):this._bufferedMessages.push(O)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=k;class t{constructor(O){this.data=O,this.next=null}}class c{constructor(){this._first=null,this._last=null}length(){let O=0,F=this._first;for(;F;)F=F.next,O++;return O}peek(){return this._first?this._first.data:null}toArray(){const O=[];let F=0,z=this._first;for(;z;)O[F++]=z.data,z=z.next;return O}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(O){const F=new t(O);if(!this._first){this._first=F,this._last=F;return}this._last.next=F,this._last=F}}class i{static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const O=Date.now();for(let F=0;F<i._HISTORY_LENGTH;F++)this.lastRuns[F]=O-1e3*F;setInterval(()=>{for(let F=i._HISTORY_LENGTH;F>=1;F--)this.lastRuns[F]=this.lastRuns[F-1];this.lastRuns[0]=Date.now()},1e3)}load(){const O=Date.now(),F=(1+i._HISTORY_LENGTH)*1e3;let z=0;for(let q=0;q<i._HISTORY_LENGTH;q++)O-this.lastRuns[q]<=F&&z++;return 1-z/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;var n;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function o(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class u{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=u;class s{constructor(O,F){this.roundTripTime=O,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=s;class d{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(O){this._onControlMessage=new k,this.onControlMessage=this._onControlMessage.event,this._onMessage=new k,this.onMessage=this._onMessage.event,this._onDidDispose=new k,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new k,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new k,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new k,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new k,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=O.loadEstimator??i.getInstance(),this._measureRoundTripTime=O.measureRoundTripTime??!1,this._shouldSendKeepAlive=O.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new R.DisposableStore,this._socket=O.socket,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(F=>this._receiveMessage(F))),this._socketDisposables.add(this._socket.onClose(F=>this._onSocketClose.fire(F))),this._socketLatencyMonitor=this._socketDisposables.add(new C),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(F=>this._sendLatencyMeasurementRequest(F))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(F=>this._onHighRoundTripTime.fire(F))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(F=>this._onDidChangeConnectionHealth.fire(F))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),O.initialChunk&&this._socketReader.acceptChunk(O.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const O=new a(5,0,0,v());this._socketWriter.write(O),this._socketWriter.flush()}sendPause(){const O=new a(7,0,0,v());this._socketWriter.write(O)}sendResume(){const O=new a(8,0,0,v());this._socketWriter.write(O)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(O,F){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new R.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=O,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(z=>this._receiveMessage(z))),this._socketDisposables.add(this._socket.onClose(z=>this._onSocketClose.fire(z))),this._socketLatencyMonitor=this._socketDisposables.add(new C),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(z=>this._sendLatencyMeasurementRequest(z))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(z=>this._onHighRoundTripTime.fire(z))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(z=>this._onDidChangeConnectionHealth.fire(z))),this._socketReader.acceptChunk(F)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const O=new a(3,0,this._incomingAckId,v());this._socketWriter.write(O);const F=this._outgoingUnackMsg.toArray();for(let z=0,q=F.length;z<q;z++)this._socketWriter.write(F[z]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(O){if(O.ack>this._outgoingAckId){this._outgoingAckId=O.ack;do{const F=this._outgoingUnackMsg.peek();if(F&&F.id<=O.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this._incomingMsgId)if(O.id!==this._incomingMsgId+1){const F=Date.now();F-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=F,this._socketWriter.write(new a(6,0,0,v())))}else this._incomingMsgId=O.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(O.data);break}case 2:{this._onControlMessage.fire(O.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const F=this._outgoingUnackMsg.toArray();for(let z=0,q=F.length;z<q;z++)this._socketWriter.write(F[z]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(O.data);break}case 11:{this._socketLatencyMonitor.handleResponse(O.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(O){const F=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const z=new a(1,F,this._incomingAckId,O);this._outgoingUnackMsg.push(z),this._isReconnecting||(this._socketWriter.write(z),this._recvAckCheck())}sendControl(O){const F=new a(2,0,0,O);this._socketWriter.write(F)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const O=Date.now()-this._incomingMsgLastTime;if(O>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-O+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const O=this._outgoingUnackMsg.peek(),F=Date.now()-O.writtenTime,z=Date.now()-this._socketReader.lastReadTime,q=Date.now()-this._lastSocketTimeoutTime;if(F>=2e4&&z>=2e4&&q>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:z});return}const ie=Math.max(2e4-F,2e4-z,2e4-q,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},ie)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const O=new a(3,0,this._incomingAckId,v());this._socketWriter.write(O)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const O=new a(9,0,this._incomingAckId,v());this._socketWriter.write(O)}_sendLatencyMeasurementRequest(O){this._incomingAckId=this._incomingMsgId;const F=new a(10,0,this._incomingAckId,O);this._socketWriter.write(F)}_sendLatencyMeasurementResponse(O){this._incomingAckId=this._incomingMsgId;const F=new a(11,0,this._incomingAckId,O);this._socketWriter.write(F)}}e.PersistentProtocol=d;class C extends R.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new r.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new r.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new r.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new I.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},O=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const O=++this._lastLatencyMeasurementId,F=M.VSBuffer.alloc(4);F.writeUInt32BE(O,0),this._onSendLatencyRequest.fire(F)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const F=O.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||F!==this._lastLatencyMeasurementId)return;const z=Date.now()-this._lastLatencyMeasurementSent,q=this._latencySampleIndex++;this._latencySamples[q%this._latencySamples.length]=z;const ie=this._connectionHealth,se=this._latencySamples.filter(oe=>oe>=1e3).length;this._connectionHealth=se>=3?1:0,z>1e3&&this._onHighRoundTripTime.fire(new s(z,se)),ie!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(Z[156],ee([0,1,42,17,3,2,47,141]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(w,v){const S=r.Event.fromNodeEventEmitter(I.validatedIpcMain,v,(y,m)=>({event:y,message:m})),l=r.Event.filter(S,({event:y})=>y.sender.id===w);return r.Event.map(l,({message:y})=>y&&M.VSBuffer.wrap(y))}class h extends D.IPCServer{static getOnDidClientConnect(){const v=r.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:S})=>S);return r.Event.map(v,S=>{const l=S.id;h.Clients.get(l)?.dispose();const m=new r.Emitter;h.Clients.set(l,(0,R.toDisposable)(()=>m.fire()));const a=g(l,"vscode:message"),f=r.Event.any(r.Event.signal(g(l,"vscode:disconnect")),m.event);return{protocol:new P.Protocol(S,a),onDidClientDisconnect:f}})}constructor(){super(h.getOnDidClientConnect())}}h.Clients=new Map,e.Server=h}),define(Z[106],ee([0,1,42,3,31,155]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(h,w){super({addEventListener:(v,S)=>h.addListener(v,S),removeEventListener:(v,S)=>h.removeListener(v,S),postMessage:v=>h.postMessage(v),start:()=>h.start(),close:()=>h.close()},w)}}e.Client=D;async function P(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const h=(0,r.generateUuid)();g.webContents.send("vscode:createMessageChannel",h);const w=M.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(S,l)=>({nonce:l,port:S.ports[0]})),{port:v}=await M.Event.toPromise(M.Event.once(M.Event.filter(w,S=>S.nonce===h)));return v}e.connect=P}),define(Z[157],ee([0,1,46,7,17,22,150,13,3,2,37,86,72,47]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends l.ChannelServer{constructor(f){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",p=>r.VSBuffer.wrap(Buffer.from(p,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=y;class m{constructor(f,p){this.modulePath=f,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new M.Delayer(b),this.child=null,this._client=null}getChannel(f){const p=this;return{call(b,E,k){return p.requestPromise(f,b,E,k)},listen(b,E){return p.requestEvent(f,b,E)}}}requestPromise(f,p,b,E=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const k=this.getCachedChannel(f),t=(0,M.createCancelablePromise)(n=>k.call(p,b,n)),c=E.onCancellationRequested(()=>t.cancel()),i=(0,h.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{c.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(f,p,b){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let E;const k=new g.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(f).listen(p,b)(k.fire,k),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return k.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(p.env),this.child=(0,I.fork)(this.modulePath,f,p);const b=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.options.serverName}`);return}b.fire(r.VSBuffer.wrap(Buffer.from(o,"base64")))});const k=this.options.useQueue?(0,v.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&k.send(o.buffer.toString("base64")),c=b.event,i={send:t,onMessage:c};this._client=new l.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",n),this.activeRequests.forEach(s=>(0,h.dispose)(s)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(f){let p=this.channels.get(f);return p||(p=this.client.getChannel(f),this.channels.set(f,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(Z[87],ee([0,1,17,13,3,2,9,4,31,47,105]),function(x,e,I,M,r,R,D,P,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class S{traceSocketEvent(s,d){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,d)}constructor(s,d=""){this._canWrite=!0,this.debugLabel=d,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,M.onUnexpectedError)(C)}},this.socket.on("error",this._errorListener),this._closeListener=C=>{this.traceSocketEvent("close",{hadError:C}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(s){const d=C=>{this.traceSocketEvent("read",C),s(I.VSBuffer.wrap(C))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(s){const d=C=>{s({type:0,hadError:C,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(s){const d=()=>{s()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(s){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,M.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,M.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=S;var l;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize",u[u.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(l||(l={}));var y;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(y||(y={}));class m extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(s,d){this.socket.traceSocketEvent(s,d)}constructor(s,d,C,L){super(),this._onData=this._register(new r.Emitter),this._onClose=this._register(new r.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:C?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new a(this,d,C,L,this._onData,(O,F)=>this._write(O,F))),this._register(this._flowManager.onError(O=>{console.error(O),(0,M.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(async O=>{this._flowManager.isProcessingReadQueue()&&await r.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(O)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this._onData.event(s)}onClose(s){return this._onClose.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){let d=0;for(;d<s.byteLength;)this._flowManager.writeMessage(s.slice(d,Math.min(d+262144,s.byteLength))),d+=262144}_write(s,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let C=2;s.byteLength<126?C+=0:s.byteLength<2**16?C+=2:C+=8;const L=I.VSBuffer.alloc(C);if(d?L.writeUInt8(194,0):L.writeUInt8(130,0),s.byteLength<126)L.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){L.writeUInt8(126,1);let O=1;L.writeUInt8(s.byteLength>>>8&255,++O),L.writeUInt8(s.byteLength>>>0&255,++O)}else{L.writeUInt8(127,1);let O=1;L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(s.byteLength>>>24&255,++O),L.writeUInt8(s.byteLength>>>16&255,++O),L.writeUInt8(s.byteLength>>>8&255,++O),L.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(I.VSBuffer.concat([L,s]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(s){if(s.byteLength!==0){for(this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),C=d.readUInt8(0),L=(C&128)>>>7,O=(C&64)>>>6,F=d.readUInt8(1),z=(F&128)>>>7,q=F&127;this._state.state=2,this._state.readLen=2+(z?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),C=d.readUInt8(1),L=(C&128)>>>7;let O=C&127,F=1;O===126?O=d.readUInt8(++F)*2**8+d.readUInt8(++F):O===127&&(O=d.readUInt8(++F)*0+d.readUInt8(++F)*0+d.readUInt8(++F)*0+d.readUInt8(++F)*0+d.readUInt8(++F)*2**24+d.readUInt8(++F)*2**16+d.readUInt8(++F)*2**8+d.readUInt8(++F));let z=0;L&&(z=d.readUInt8(++F)*2**24+d.readUInt8(++F)*2**16+d.readUInt8(++F)*2**8+d.readUInt8(++F)),this._state.state=3,this._state.readLen=O,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),b(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await r.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class a extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(s,d,C,L,O,F){super(),this._tracer=s,this._onData=O,this._writeFn=F,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new r.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new r.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new f(this._tracer,L,C,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(s){this._writeQueue.push(s),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const s=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,s);this._writeFn(d,!0)}else this._writeFn(s,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(s,d){return new Promise((C,L)=>{s.write(d),s.flush(O=>C(O))})}acceptFrame(s,d,C){this._readQueue.push({data:s,isCompressed:d,isLastFrameOfMessage:C}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const s=this._readQueue.shift();if(this._zlibInflateStream&&s.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,s.data,s.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(s.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(s,d,C){return new Promise((L,O)=>{s.write(d),C&&s.write(I.VSBuffer.fromByteArray([0,0,255,255])),s.flush(F=>L(F))})}}class f extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.concat(this._recordedInflateBytes):I.VSBuffer.alloc(0)}constructor(s,d,C,L){super(),this._tracer=s,this._recordInflateBytes=d,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=v().zlib.createInflateRaw(L),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(I.VSBuffer.wrap(O))}),C&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this._zlibInflate.write(C.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(s){this._recordInflateBytes&&this._recordedInflateBytes.push(s.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",s),this._zlibInflate.write(s.buffer)}flush(s){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=I.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,s(d)})}}class p extends R.Disposable{constructor(s,d){super(),this._tracer=s,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=v().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this._onError.fire(C)}),this._zlibDeflate.on("data",C=>{this._tracer.traceSocketEvent("zlibDeflateData",C),this._pendingDeflateData.push(I.VSBuffer.wrap(C))})}write(s){this._tracer.traceSocketEvent("zlibDeflateWrite",s.buffer),this._zlibDeflate.write(s.buffer)}flush(s){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=I.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),s(d)})}}function b(u,s){if(s===0)return;const d=u.byteLength>>>2;for(let q=0;q<d;q++){const ie=u.readUInt32BE(q*4);u.writeUInt32BE(ie^s,q*4)}const C=d*4,L=u.byteLength-C,O=s>>>24&255,F=s>>>16&255,z=s>>>8&255;L>=1&&u.writeUInt8(u.readUInt8(C)^O,C),L>=2&&u.writeUInt8(u.readUInt8(C+1)^F,C+1),L>=3&&u.writeUInt8(u.readUInt8(C+2)^z,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function k(){const u=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):s=(0,D.join)(v().os.tmpdir(),`vscode-ipc-${u}.sock`),c(s),s}e.createRandomIPCHandle=k;function t(u,s,d){const C=v().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${d}-${s}-sock`;const L=d.substr(0,4),O=s.substr(0,6),F=C.substr(0,8);let z;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${L}-${O}.sock`):z=(0,D.join)(u,`${L}-${O}.sock`),c(z),z}e.createStaticIPCHandle=t;function c(u){const s=E[P.platform];typeof s=="number"&&u.length>=s&&console.warn(`WARNING: IPC handle "${u}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends h.IPCServer{static toClientConnectionEvent(s){const d=r.Event.fromNodeEventEmitter(s,"connection");return r.Event.map(d,C=>({protocol:new w.Protocol(new S(C,"ipc-server-connection")),onDidClientDisconnect:r.Event.once(r.Event.fromNodeEventEmitter(C,"close"))}))}constructor(s){super(i.toClientConnectionEvent(s)),this.server=s}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(u){return new Promise((s,d)=>{const C=v().net.createServer();C.on("error",d),C.listen(u,()=>{C.removeListener("error",d),s(new i(C))})})}e.serve=n;function o(u,s){return new Promise((d,C)=>{const L=v().net.createConnection(u,()=>{L.removeListener("error",C),d(w.Client.fromSocket(new S(L,`ipc-client${s}`),s))});L.once("error",C)})}e.connect=o}),define(Z[107],ee([0,1,7,3,2,10]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function P(v){const S=v;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var g;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class h extends r.Disposable{constructor(S,l=Object.create(null)){super(),this.database=S,this.options=l,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((l,y)=>this.accept(y,l)),S.deleted?.forEach(l=>this.accept(l,void 0))}accept(S,l){if(this.state===g.Closed)return;let y=!1;(0,R.isUndefinedOrNull)(l)?y=this.cache.delete(S):this.cache.get(S)!==l&&(this.cache.set(S,l),y=!0),y&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,l){const y=this.cache.get(S);return(0,R.isUndefinedOrNull)(y)?l:y}getBoolean(S,l){const y=this.get(S);return(0,R.isUndefinedOrNull)(y)?l:y==="true"}getNumber(S,l){const y=this.get(S);return(0,R.isUndefinedOrNull)(y)?l:parseInt(y,10)}async set(S,l){if(this.state===g.Closed)return;if((0,R.isUndefinedOrNull)(l))return this.delete(S);const y=String(l);if(this.cache.get(S)!==y)return this.cache.set(S,y),this.pendingInserts.set(S,y),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===g.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}h.DEFAULT_FLUSH_DELAY=100,e.Storage=h;class w{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((l,y)=>this.items.set(y,l)),S.delete?.forEach(l=>this.items.delete(l))}async close(){}}e.InMemoryStorageDatabase=w}),define(Z[158],ee([0,1,7,3,35,9,23]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return M.Event.None}constructor(w,v=Object.create(null)){this.path=w,this.options=v,this.name=(0,R.basename)(this.path),this.logger=new g(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const w=await this.whenConnected,v=new Map;return(await this.all(w,"SELECT * FROM ItemTable")).forEach(l=>v.set(l.key,l.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${v.size} rows`),v}async updateItems(w){const v=await this.whenConnected;return this.doUpdateItems(v,w)}doUpdateItems(w,v){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${v.insert?(0,r.mapToString)(v.insert):"0"}), delete(${v.delete?(0,r.setToString)(v.delete):"0"})`),this.transaction(w,()=>{const S=v.insert,l=v.delete;if(S&&S.size>0){const y=[];y.push([]);let m=0;S.forEach((a,f)=>{let p=y[m];p.length>P.MAX_HOST_PARAMETERS&&(m++,p=[],y.push(p)),p.push(f,a)}),y.forEach(a=>{this.prepare(w,`INSERT INTO ItemTable VALUES ${new Array(a.length/2).fill("(?,?)").join(",")}`,f=>f.run(a),()=>{const f=[];let p=0;return S.forEach((b,E)=>{f.push(E),p+=b.length}),`Keys: ${f.join(", ")} Length: ${p}`})})}if(l&&l.size){const y=[];y.push([]);let m=0;l.forEach(a=>{let f=y[m];f.length>P.MAX_HOST_PARAMETERS&&(m++,f=[],y.push(f)),f.push(a)}),y.forEach(a=>{this.prepare(w,`DELETE FROM ItemTable WHERE key IN (${new Array(a.length).fill("?").join(",")})`,f=>f.run(a),()=>{const f=[];return l.forEach(p=>{f.push(p)}),`Keys: ${f.join(", ")}`})})}})}async close(w){this.logger.trace(`[storage ${this.name}] close()`);const v=await this.whenConnected;return this.doClose(v,w)}doClose(w,v){return new Promise((S,l)=>{w.db.close(y=>(y&&this.handleSQLiteError(w,`[storage ${this.name}] close(): ${y}`),this.path===P.IN_MEMORY_PATH?S():!w.isErroneous&&!w.isInMemory?this.backup().then(S,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),S())):typeof v=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const a=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:v()}).then(()=>a(),f=>(a(),Promise.reject(f)))})).then(S,l):l(y||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const w=this.toBackupPath(this.path);return D.Promises.copy(this.path,w,{preserveSymlinks:!1})}toBackupPath(w){return`${w}.backup`}async checkIntegrity(w){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${w})`);const v=await this.whenConnected,S=await this.get(v,w?"PRAGMA integrity_check":"PRAGMA quick_check"),l=w?S.integrity_check:S.quick_check;return v.isErroneous?`${l} (last error: ${v.lastError})`:v.isInMemory?`${l} (in-memory!)`:l}async connect(w,v=!0){this.logger.trace(`[storage ${this.name}] open(${w}, retryOnBusy: ${v})`);try{return await this.doConnect(w)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&v)return await(0,I.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(w,!1);try{await D.Promises.unlink(w);try{await D.Promises.rename(this.toBackupPath(w),w)}catch{}return await this.doConnect(w)}catch(l){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${l}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(w,v){w.isErroneous=!0,w.lastError=v,this.logger.error(v)}doConnect(w){return new Promise((v,S)=>{new Promise((l,y)=>{x(["@vscode/sqlite3"],l,y)}).then(l=>{const y={db:new(this.logger.isTracing?l.verbose().Database:l.Database)(w,m=>m?y.db&&m.code!=="SQLITE_CANTOPEN"?y.db.close(()=>S(m)):S(m):this.exec(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(y),a=>y.db.close(()=>S(a)))),isInMemory:w===P.IN_MEMORY_PATH};y.db.on("error",m=>this.handleSQLiteError(y,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&y.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},S)})}exec(w,v){return new Promise((S,l)=>{w.db.exec(v,y=>y?(this.handleSQLiteError(w,`[storage ${this.name}] exec(): ${y}`),l(y)):S())})}get(w,v){return new Promise((S,l)=>{w.db.get(v,(y,m)=>y?(this.handleSQLiteError(w,`[storage ${this.name}] get(): ${y}`),l(y)):S(m))})}all(w,v){return new Promise((S,l)=>{w.db.all(v,(y,m)=>y?(this.handleSQLiteError(w,`[storage ${this.name}] all(): ${y}`),l(y)):S(m))})}transaction(w,v){return new Promise((S,l)=>{w.db.serialize(()=>{w.db.run("BEGIN TRANSACTION"),v(),w.db.run("END TRANSACTION",y=>y?(this.handleSQLiteError(w,`[storage ${this.name}] transaction(): ${y}`),l(y)):S())})})}prepare(w,v,S,l){const y=w.db.prepare(v),m=a=>{this.handleSQLiteError(w,`[storage ${this.name}] prepare(): ${a} (${v}). Details: ${l()}`)};y.on("error",m),S(y),y.finalize(a=>{a&&m(a),y.removeListener("error",m)})}}P.IN_MEMORY_PATH=":memory:",P.BUSY_OPEN_TIMEOUT=2e3,P.MAX_HOST_PARAMETERS=256,e.SQLiteStorageDatabase=P;class g{constructor(w){w&&typeof w.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.logTrace=w.logTrace),w&&typeof w.logError=="function"&&(this.logError=w.logError)}get isTracing(){return!!this.logTrace}trace(w){this.logTrace?.(w)}error(w){this.logError?.(w)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[159],ee([12,11]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(Z[160],ee([12,11]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[161],ee([12,11]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(Z[162],ee([12,11]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[163],ee([12,11]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(Z[164],ee([12,11]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(Z[165],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[166],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[167],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[168],ee([12,11]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[169],ee([12,11]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[170],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[171],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(Z[172],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[173],ee([12,11]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[174],ee([12,11]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[175],ee([12,11]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[176],ee([12,11]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[177],ee([12,11]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[178],ee([12,11]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[179],ee([12,11]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[180],ee([12,11]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[181],ee([12,11]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[182],ee([12,11]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[183],ee([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[184],ee([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[185],ee([12,11]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[186],ee([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[187],ee([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[188],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function M(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=M}),define(Z[189],ee([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function M(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=M;function r(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(g=>({workspace:{id:g.id,configPath:I.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=r;function R(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(g=>({folderUri:I.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=R}),define(Z[190],ee([0,1,3,2]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}call(P,g,h){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:h[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:h[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:h[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:h[0],port:h[1],subId:h[2]}))}throw new Error("Method not implemented.")}listen(P,g,h){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}r.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=r;class R extends M.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,g,h){this.channel.call("attach",[P,g,h])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,g){this.channel.call("terminate",[P,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,g){return this.channel.call("openExtensionDevelopmentHostWindow",[P,g])}}e.ExtensionHostDebugChannelClient=R}),define(Z[191],ee([0,1,144,54,14,9,36,19,8]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,R.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(g.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?g.URI.file((0,R.join)(l,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,R.resolve)(l):(0,R.normalize)((0,R.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?g.URI.file((0,R.resolve)(l)):g.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,R.resolve)(l);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const m=D.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(y=>/^[^:/?#]+?:\/\//.test(y)?g.URI.parse(y):g.URI.file((0,R.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?g.URI.parse(l):g.URI.file((0,R.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(l))}get extensionLogLevel(){const l=[];for(const y of this.args.log||[]){const m=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);m&&m[1]&&m[2]&&l.push([m[1],m[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=D.env.VSCODE_PORTABLE;return l?g.URI.file((0,R.join)(l,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this._args}constructor(l,y,m){this._args=l,this.paths=y,this.productService=m,this.editSessionId=this.args.editSessionId}}we([M.memoize],h.prototype,"appRoot",null),we([M.memoize],h.prototype,"userHome",null),we([M.memoize],h.prototype,"userDataPath",null),we([M.memoize],h.prototype,"appSettingsHome",null),we([M.memoize],h.prototype,"tmpDir",null),we([M.memoize],h.prototype,"cacheHome",null),we([M.memoize],h.prototype,"stateResource",null),we([M.memoize],h.prototype,"userRoamingDataHome",null),we([M.memoize],h.prototype,"userDataSyncHome",null),we([M.memoize],h.prototype,"userDataSyncLogResource",null),we([M.memoize],h.prototype,"editSessionsLogResource",null),we([M.memoize],h.prototype,"sync",null),we([M.memoize],h.prototype,"machineSettingsResource",null),we([M.memoize],h.prototype,"workspaceStorageHome",null),we([M.memoize],h.prototype,"localHistoryHome",null),we([M.memoize],h.prototype,"keyboardLayoutResource",null),we([M.memoize],h.prototype,"argvResource",null),we([M.memoize],h.prototype,"isExtensionDevelopment",null),we([M.memoize],h.prototype,"untitledWorkspacesHome",null),we([M.memoize],h.prototype,"installSourcePath",null),we([M.memoize],h.prototype,"builtinExtensionsPath",null),we([M.memoize],h.prototype,"extensionsPath",null),we([M.memoize],h.prototype,"extensionDevelopmentLocationURI",null),we([M.memoize],h.prototype,"extensionDevelopmentKind",null),we([M.memoize],h.prototype,"extensionTestsLocationURI",null),we([M.memoize],h.prototype,"debugExtensionHost",null),we([M.memoize],h.prototype,"logLevel",null),we([M.memoize],h.prototype,"extensionLogLevel",null),we([M.memoize],h.prototype,"serviceMachineIdResource",null),we([M.memoize],h.prototype,"telemetryLogResource",null),we([M.memoize],h.prototype,"disableWorkspaceTrust",null),we([M.memoize],h.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=h;function w(S,l){return v(S["inspect-extensions"],S["inspect-brk-extensions"],5870,l,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=w;function v(S,l,y,m,a,f){const b=Number(l||S)||(m?null:y),E=b?Boolean(!!l):!1;let k;if(f)try{k=JSON.parse(f)}catch{}return{port:b,break:E,debugId:a,env:k}}e.parseDebugParams=v}),define(Z[108],ee([0,1,288,4,163]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,r.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,a,f=D){const p=m.find(u=>u.length>0&&u[0]!=="-"),b={},E=["_"],k=[],t={};let c;for(const u in a){const s=a[u];s.type==="subcommand"?u===p&&(c=s):(s.alias&&(b[u]=s.alias),s.type==="string"||s.type==="string[]"?(E.push(u),s.deprecates&&E.push(...s.deprecates)):s.type==="boolean"&&(k.push(u),s.deprecates&&k.push(...s.deprecates)),s.global&&(t[u]=s))}if(c&&p){const u=t;for(const L in c.options)u[L]=c.options[L];const s=m.filter(L=>L!==p),d=f.getSubcommandReporter?f.getSubcommandReporter(p):void 0,C=P(s,u,d);return{[p]:C,_:[]}}const i=I(m,{string:E,boolean:k,alias:b}),n={},o=i;n._=i._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in a){const s=a[u];if(s.type==="subcommand")continue;s.alias&&delete o[s.alias];let d=o[u];if(s.deprecates)for(const C of s.deprecates)o.hasOwnProperty(C)&&(d||(d=o[C],d&&f.onDeprecatedOption(C,s.deprecationMessage||(0,r.localize)(36,null,u))),delete o[C]);if(typeof d<"u"){if(s.type==="string[]"){if(Array.isArray(d)||(d=[d]),!s.allowEmptyValue){const C=d.filter(L=>L.length>0);C.length!==d.length&&(f.onEmptyValue(u),d=C.length>0?C:void 0)}}else s.type==="string"&&(Array.isArray(d)?(d=d.pop(),f.onMultipleValues(u,d)):!d&&!s.allowEmptyValue&&(f.onEmptyValue(u),d=void 0));n[u]=d,s.deprecationMessage&&f.onDeprecatedOption(u,s.deprecationMessage)}delete o[u]}for(const u in o)f.onUnknownOption(u);return n}e.parseArgs=P;function g(m,a){let f="";return a.args&&(Array.isArray(a.args)?f=` <${a.args.join("> <")}>`:f=` <${a.args}>`),a.alias?`-${a.alias} --${m}${f}`:`--${m}${f}`}function h(m,a){const f=[];for(const p in m){const b=m[p],E=g(p,b);f.push([E,b.description])}return w(f,a)}e.formatOptions=h;function w(m,a){const p=m.reduce((k,t)=>Math.max(k,t[0].length),12)+2+1;if(a-p<25)return m.reduce((k,t)=>k.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const b=a-p-1,E=[];for(const k of m){const t=k[0],c=S(k[1],b),i=v(p-t.length-2);E.push("  "+t+i+c[0]);for(let n=1;n<c.length;n++)E.push(v(p)+c[n])}return E}function v(m){return" ".repeat(m)}function S(m,a){const f=[];for(;m.length;){const p=m.length<a?m.length:m.lastIndexOf(" ",a),b=m.slice(0,p).trim();m=m.slice(p),f.push(b)}return f}function l(m,a,f,p,b){const E=process.stdout.isTTY&&process.stdout.columns||80,k=b?.noInputFiles!==!0?`[${(0,r.localize)(37,null)}...]`:"",t=[`${m} ${f}`];t.push(""),t.push(`${(0,r.localize)(38,null)}: ${a} [${(0,r.localize)(39,null)}]${k}`),t.push(""),b?.noPipe!==!0&&(M.isWindows?t.push((0,r.localize)(40,null,a)):t.push((0,r.localize)(41,null,a)),t.push(""));const c={},i=[];for(const n in p){const o=p[n];if(o.type==="subcommand")o.description&&i.push({command:n,description:o.description});else if(o.description&&o.cat){let u=c[o.cat];u||(c[o.cat]=u={}),u[n]=o}}for(const n in c){const o=n,u=c[o];u&&(t.push(R[o]),t.push(...h(u,E)),t.push(""))}return i.length&&(t.push((0,r.localize)(42,null)),t.push(...w(i.map(n=>[n.command,n.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=l;function y(m,a){return`${m||(0,r.localize)(43,null)}
${a||(0,r.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Z[192],ee([0,1,83,190,108]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends M.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.windowsMainService=P}call(P,g,h){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(h[0],h[1]):super.call(P,g,h)}async openExtensionDevelopmentHostWindow(P,g){const h=(0,r.parseArgs)(P,r.OPTIONS);h.debugRenderer=g;const w=h.extensionDevelopmentPath;if(!w)return{success:!1};const[v]=await this.windowsMainService.openExtensionDevelopmentHostWindow(w,{context:5,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!g)return{success:!0};const S=v.win;if(!S)return{success:!0};const l=S.webContents.debugger;let y=l.isAttached()?1/0:0;const m=(0,I.createServer)(a=>{y++===0&&l.attach();let f=!1;const p=k=>{f||a.write(JSON.stringify(k)+"\0")},b=(k,t,c,i)=>p({method:t,params:c,sessionId:i});S.on("close",()=>{l.removeListener("message",b),a.end(),f=!0}),l.addListener("message",b);let E=Buffer.alloc(0);a.on("data",k=>{E=Buffer.concat([E,k]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let c;try{const i=E.slice(0,t).toString("utf8");E=E.slice(t+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}l.sendCommand(c.method,c.params,c.sessionId).then(i=>p({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>p({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),a.on("error",k=>{console.error("error on cdp pipe:",k)}),a.on("close",()=>{f=!0,--y===0&&l.detach()})});return await new Promise(a=>m.listen(0,a)),S.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[62],ee([0,1,289,164,108]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(S,l){const y=(E,k)=>{console.warn((0,M.localize)(0,null,E,k))},m=E=>{console.warn((0,M.localize)(1,null,E))},a=(E,k)=>{console.warn((0,M.localize)(2,null,E,k))},f=E=>({onUnknownOption:k=>{E!=="tunnel"&&console.warn((0,M.localize)(3,null,k,E))},onMultipleValues:y,onEmptyValue:m,onDeprecatedOption:a,getSubcommandReporter:E!=="tunnel"?f:void 0}),p={onUnknownOption:E=>{console.warn((0,M.localize)(4,null,E))},onMultipleValues:y,onEmptyValue:m,onDeprecatedOption:a,getSubcommandReporter:f},b=(0,r.parseArgs)(S,r.OPTIONS,l?p:void 0);return b.goto&&b._.forEach(E=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,M.localize)(5,null))),b["max-memory"]&&I(parseInt(b["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),b}function P(S){const l=S.findIndex(y=>!/^-/.test(y));if(l>-1)return[...S.slice(0,l),...S.slice(l+1)]}function g(S){let[,...l]=S;process.env.VSCODE_DEV&&(l=P(l)||[]);const y=!v(process.env);return D(l,y)}e.parseMainProcessArgv=g;function h(S){let[,,...l]=S;return process.env.VSCODE_DEV&&(l=P(l)||[]),D(l,!0)}e.parseCLIProcessArgv=h;function w(S,...l){const y=S.indexOf("--");return y===-1?S.push(...l):S.splice(y,0,...l),S}e.addArg=w;function v(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function x(e,I,M){function r(D,P){const g=R(D,P),h=[g];return e.isAbsolute(g)||h.unshift(M),e.resolve(...h)}function R(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,P);const w=D["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(v,"AppData","Roaming")}break;case"darwin":h=e.join(I.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,P)}return{getUserDataPath:r}}if(typeof define=="function")define(Z[109],ee([193,26,36]),function(e,I,M){return x(e,I,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=x(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[110],ee([0,1,26,191,109]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class R extends M.AbstractNativeEnvironmentService{constructor(h,w){super(h,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,r.getUserDataPath)(h,w.nameShort)},w)}}e.NativeEnvironmentService=R;function D(g,h){return(0,M.parseDebugParams)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,h,g.extensionEnvironment)}e.parsePtyHostDebugPort=D;function P(g,h){return(0,M.parseDebugParams)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,h,g.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(Z[194],ee([0,1,41,26,32]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const P=(0,r.randomPath)((0,M.tmpdir)());try{return(0,I.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(g){D&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=R}),define(Z[195],ee([0,1,10,166]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(D,P,g){try{R(D,P,g)}catch(h){console.error(h?.message??h)}return D}e.localizeManifest=r;function R(D,P,g){const h=(w,v,S)=>{const l=w[v];if((0,I.isString)(l)){const y=l,m=y.length;if(m>1&&y[0]==="%"&&y[m-1]==="%"){const a=y.substr(1,m-2);let f=P[a];f===void 0&&g&&(f=g[a]);const p=typeof f=="string"?f:f?.message,b=g?.[a],E=typeof b=="string"?b:b?.message;if(!p){E||console.warn(`[${D.name}]: ${(0,M.localize)(0,null,a)}`);return}if(S&&(v==="title"||v==="category")&&E&&E!==p){const k={value:p,original:E};w[v]=k}else w[v]=p}}else if((0,I.isObject)(l))for(const y in l)l.hasOwnProperty(y)&&(y==="commands"?h(l,y,!0):h(l,y,S));else if(Array.isArray(l))for(let y=0;y<l.length;y++)h(l,y,S)};for(const w in D)D.hasOwnProperty(w)&&h(D,w)}}),define(Z[196],ee([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class M{constructor(){this._generators=new Map}register(R,D){this._generators.set(R,D)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const D in R.contributes){const P=this._generators.get(D);if(!P)continue;const g=R.contributes[D],h=Array.isArray(g)?g:[g];try{P(h,R.activationEvents)}catch(w){(0,I.onUnexpectedError)(w)}}}}e.ImplicitActivationEventsImpl=M,e.ImplicitActivationEvents=new M}),define(Z[197],ee([0,1,19,74,168,198]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||D.test(f)}e.isValidVersionStr=g;function h(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(D);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=h;function w(f){if(!f)return null;const p=f.majorBase,b=f.majorMustEqual,E=f.minorBase;let k=f.minorMustEqual;const t=f.patchBase;let c=f.patchMustEqual;f.hasCaret&&(p===0||(k=!1),c=!1);let i=0;if(f.preRelease){const n=P.exec(f.preRelease);if(n){const[,o,u,s]=n;i=Date.UTC(Number(o),Number(u)-1,Number(s))}}return{majorBase:p,majorMustEqual:b,minorBase:E,minorMustEqual:k,patchBase:t,patchMustEqual:c,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=w;function v(f,p,b){let E;typeof f=="string"?E=w(h(f)):E=f;let k;p instanceof Date?k=p.getTime():typeof p=="string"&&(k=new Date(p).getTime());let t;if(typeof b=="string"?t=w(h(b)):t=b,!E||!t)return!1;const c=E.majorBase,i=E.minorBase,n=E.patchBase;let o=t.majorBase,u=t.minorBase,s=t.patchBase;const d=t.notBefore;let C=t.majorMustEqual,L=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?c>o?!0:c<o?!1:i>u?!0:i<u||k&&k<d?!1:n>=s:(c===1&&o===0&&(!C||!L||!O)&&(o=1,u=0,s=0,C=!0,L=!1,O=!1),c<o?!1:c>o?!C:i<u?!1:i>u?!L:n<s?!1:n>s?!O:!(k&&k<d))}e.isValidVersion=v;function S(f,p,b,E,k){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([M.default.Error,r.localize(0,null)]),t;if(typeof E.name!="string")return t.push([M.default.Error,r.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([M.default.Error,r.localize(2,null,"version")]),t;if(!E.engines)return t.push([M.default.Error,r.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([M.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!a(E.extensionDependencies))return t.push([M.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!a(E.activationEvents))return t.push([M.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([M.default.Error,r.localize(7,null,"activationEvents","main")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([M.default.Warning,r.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([M.default.Error,r.localize(9,null,"main")]),t;{const n=(0,I.joinPath)(b,E.main);(0,I.isEqualOrParent)(n,b)||t.push([M.default.Warning,r.localize(10,null,n.path,b.path)])}if(typeof E.activationEvents>"u")return t.push([M.default.Error,r.localize(11,null,"activationEvents","main")]),t}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([M.default.Error,r.localize(12,null,"browser")]),t;{const n=(0,I.joinPath)(b,E.browser);(0,I.isEqualOrParent)(n,b)||t.push([M.default.Warning,r.localize(13,null,n.path,b.path)])}if(typeof E.activationEvents>"u")return t.push([M.default.Error,r.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(E.version))return t.push([M.default.Error,r.localize(15,null)]),t;const c=[];if(!l(f,p,E,k,c))for(const n of c)t.push([M.default.Error,n]);return t}e.validateExtensionManifest=S;function l(f,p,b,E,k){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:m(f,p,b.engines.vscode,k)}e.isValidExtensionVersion=l;function y(f,p,b){return f==="*"||m(p,b,f)}e.isEngineValid=y;function m(f,p,b,E=[]){const k=w(h(b));if(!k)return E.push(r.localize(16,null,b)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return E.push(r.localize(17,null,b)),!1}else if(!k.majorMustEqual)return E.push(r.localize(18,null,b)),!1;return v(f,p,k)?!0:(E.push(r.localize(19,null,f,b)),!1)}function a(f){if(!Array.isArray(f))return!1;for(let p=0,b=f.length;p<b;p++)if(typeof f[p]!="string")return!1;return!0}}),define(Z[199],ee([0,1,17,31]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(R,D,P){let g=P&&P.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const w=(await D.readFile(R.serviceMachineIdResource)).value.toString();g=(0,M.isUUID)(w)?w:null}catch{g=null}if(!g){g=(0,M.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,I.VSBuffer.fromString(g))}catch{}}return P?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=r}),define(Z[75],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(r,R=[],D=!1){this.ctor=r,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=I}),define(Z[200],ee([0,1,75]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const M=[];var r;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(r=e.InstantiationType||(e.InstantiationType={}));function R(P,g,h){g instanceof I.SyncDescriptor||(g=new I.SyncDescriptor(g,[],Boolean(h))),M.push([P,g])}e.registerSingleton=R;function D(){return M}e.getSingletonServiceDescriptors=D}),define(Z[201],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class M{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const P=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(D);P.outgoing.set(g.key,g),g.incoming.set(P.key,P)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let P=this._nodes.get(D);return P||(P=new I(D,R),this._nodes.set(D,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,P]of this._nodes)R.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const P=new Set([R]),g=this._findCycle(D,P);if(g)return g}}_findCycle(R,D){for(const[P,g]of R.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const h=this._findCycle(g,D);if(h)return h;D.delete(P)}}}e.Graph=M}),define(Z[6],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(g){return g[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(I=e._util||(e._util={})),e.IInstantiationService=r("instantiationService");function M(D,P,g){P[I.DI_TARGET]===P?P[I.DI_DEPENDENCIES].push({id:D,index:g}):(P[I.DI_DEPENDENCIES]=[{id:D,index:g}],P[I.DI_TARGET]=P)}function r(D){if(I.serviceIds.has(D))return I.serviceIds.get(D);const P=function(g,h,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(P,g,w)};return P.toString=()=>D,I.serviceIds.set(D,P),P}e.createDecorator=r;function R(D){return D}e.refineServiceDecorator=R}),define(Z[63],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(Z[18],ee([0,1,10,8,6]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationOverrides=R;function D(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function h(a,f){const p=Object.create(null);for(const b in a)w(p,b,a[b],f);return p}e.toValuesTree=h;function w(a,f,p,b){const E=f.split("."),k=E.pop();let t=a;for(let c=0;c<E.length;c++){const i=E[c];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${f} as ${E.slice(0,c+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[k]=p}catch{b(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(t)}`)}else b(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=w;function v(a,f){const p=f.split(".");S(a,p)}e.removeFromValueTree=v;function S(a,f){const p=f.shift();if(f.length===0){delete a[p];return}if(Object.keys(a).indexOf(p)!==-1){const b=a[p];typeof b=="object"&&!Array.isArray(b)&&(S(b,f),Object.keys(b).length===0&&delete a[p])}}function l(a,f,p){function b(t,c){let i=t;for(const n of c){if(typeof i!="object"||i===null)return;i=i[n]}return i}const E=f.split("."),k=b(a,E);return typeof k>"u"?p:k}e.getConfigurationValue=l;function y(a,f,p){Object.keys(f).forEach(b=>{b!=="__proto__"&&(b in a?I.isObject(a[b])&&I.isObject(f[b])?y(a[b],f[b],p):p&&(a[b]=f[b]):a[b]=f[b])})}e.merge=y;function m(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(Z[76],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class M{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,P){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=P}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const P of Object.keys(this.secretVault[R]||{}))D.push({account:P,password:this.secretVault[R][P]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=M}),define(Z[88],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function M(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=M;class r{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=r}),define(Z[89],ee([0,1,19,74,161,6,45,4,37]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var h;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(h||(h={}));class w{getConfirmationButtons(a){return this.getButtons(a,h.Confirmation)}getPromptButtons(a){return this.getButtons(a,h.Prompt)}getInputButtons(a){return this.getButtons(a,h.Input)}getButtons(a,f){const p=[];switch(f){case h.Confirmation:{const b=a;b.primaryButton?p.push(b.primaryButton):p.push((0,r.localize)(0,null)),b.cancelButton?p.push(b.cancelButton):p.push((0,r.localize)(1,null));break}case h.Prompt:{const b=a;Array.isArray(b.buttons)&&b.buttons.length>0&&p.push(...b.buttons.map(E=>E.label)),b.cancelButton&&(b.cancelButton===!0?p.push((0,r.localize)(2,null)):typeof b.cancelButton=="string"?p.push(b.cancelButton):b.cancelButton.label?p.push(b.cancelButton.label):p.push((0,r.localize)(3,null))),p.length===0&&p.push((0,r.localize)(4,null));break}case h.Input:{const b=a;b.primaryButton?p.push(b.primaryButton):p.push((0,r.localize)(5,null)),b.cancelButton?p.push(b.cancelButton):p.push((0,r.localize)(6,null));break}}return p}getDialogType(a){if(typeof a=="string")return a;if(typeof a=="number")return a===M.default.Info?"info":a===M.default.Error?"error":a===M.default.Warning?"warning":"none"}async getPromptResult(a,f,p){const b=[...a.buttons??[]];return a.cancelButton&&typeof a.cancelButton!="string"&&typeof a.cancelButton!="boolean"&&b.push(a.cancelButton),{result:await b[f]?.run({checkboxChecked:p}),checkboxChecked:p}}}e.AbstractDialogHandler=w,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var v;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(v=e.ConfirmResult||(e.ConfirmResult={}));const S=10;function l(m){const a=[];return a.push(...m.slice(0,S).map(f=>typeof f=="string"?f:(0,I.basename)(f))),m.length>S&&(m.length-S===1?a.push((0,r.localize)(7,null)):a.push((0,r.localize)(8,null,m.length-S))),a.push(""),a.join(`
`)}e.getFileNamesMessage=l;function y(m,a){const f=(0,g.deepClone)(m);let p=(f.buttons??[]).map(t=>(0,D.mnemonicButtonLabel)(t)),b=(m.buttons||[]).map((t,c)=>c),E=0,k=f.cancelId??p.length-1;if(p.length>1){const t=typeof k=="number"?p[k]:void 0;if(P.isLinux||P.isMacintosh){if(typeof t=="string"&&p.length>1&&k!==1){p.splice(k,1),p.splice(1,0,t);const c=b[k];b.splice(k,1),b.splice(1,0,c),k=1}P.isLinux&&p.length>1&&(p=p.reverse(),b=b.reverse(),E=p.length-1,typeof t=="string"&&(k=E-1))}else if(P.isWindows&&typeof t=="string"&&p.length>1&&k!==p.length-1){p.splice(k,1),p.push(t);const c=b[k];b.splice(k,1),b.push(c),k=p.length-1}}return f.buttons=p,f.defaultId=E,f.cancelId=k,f.noLink=!0,f.title=f.title||a.nameLong,{options:f,buttonIndeces:b}}e.massageMessageBoxOptions=y}),define(Z[111],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(Z[34],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],ee([0,1,54,9,87,34,110,6]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(R.IEnvironmentService);class g extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,M.join)(this.userDataPath,"clp")}get backupHome(){return(0,M.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,M.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([I.memoize],g.prototype,"cachedLanguagesPath",null),we([I.memoize],g.prototype,"backupHome",null),we([I.memoize],g.prototype,"mainIPCHandle",null),we([I.memoize],g.prototype,"mainLockfile",null),we([I.memoize],g.prototype,"disableUpdates",null),we([I.memoize],g.prototype,"disableKeytar",null),we([I.memoize],g.prototype,"crossOriginIsolated",null),we([I.memoize],g.prototype,"codeCachePath",null),we([I.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(Z[112],ee([0,1,165,6]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function r(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function g(f,p,b){return P(p,b)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===b?!0:h(b).includes(f)}e.isTargetPlatformCompatible=g;function h(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function w(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=w;var v;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var S;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var l;(function(f){f.Install="install",f.Uninstall="uninstall"})(l=e.StatisticType||(e.StatisticType={}));var y;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(Z[202],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(Z[203],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[113],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(Z[204],ee([0,1,46,14,9,4,72,23,86,169,113]),function(x,e,I,M,r,R,D,P,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=h.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:l.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class l extends S{openTerminal(E,k){return this.spawnTerminal(I,E,g.getWindowsShell(),k)}spawnTerminal(E,k,t,c){const i=k.windowsExec||l.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const n=r.basename(i,".exe").toLowerCase();if(n==="cmder")return E.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),n==="wt"&&o.push("-d ."),new Promise((u,s)=>{const d=a(process),C=E.spawn(t,o,{cwd:c,env:d});C.on("error",s),C.on("exit",()=>u())})}runInTerminal(E,k,t,c,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:l.getDefaultTerminalWindows();return new Promise((o,u)=>{const s=`"${k} - ${v}"`,d=`""${t.join('" "')}" & pause"`,C=Object.assign({},a(process),c);Object.keys(C).filter(q=>C[q]===null).forEach(q=>delete C[q]);const L={cwd:k,env:C,windowsVerbatimArguments:!0};let O,F;r.basename(n,".exe")==="wt"?(O=n,F=["-d",".",l.CMD,"/c",d]):(O=l.CMD,F=["/c","start",s,"/wait",n,"/c",d]),I.spawn(O,F,L).on("error",q=>{u(f(q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!l._DEFAULT_TERMINAL_WINDOWS){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");l._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return l._DEFAULT_TERMINAL_WINDOWS}}l.CMD="cmd.exe",e.WindowsExternalTerminalService=l;class y extends S{openTerminal(E,k){return this.spawnTerminal(I,E,k)}runInTerminal(E,k,t,c,i){const n=i.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((o,u)=>{if(n===w.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const s=n===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",C=[M.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",E||v,"-w",k];for(const F of t)C.push("-a"),C.push(F);if(c){const F=Object.assign({},a(process),c);for(const z in F){const q=F[z];q===null?(C.push("-u"),C.push(z)):(C.push("-e"),C.push(`${z}=${q}`))}}let L="";const O=I.spawn(y.OSASCRIPT,C);O.on("error",F=>{u(f(F))}),O.stderr.on("data",F=>{L+=F.toString()}),O.on("exit",F=>{if(F===0)o(void 0);else if(L){const z=L.split(`
`,1);u(new Error(z[0]))}else u(new Error(h.localize(1,null,s,F)))})}else u(new Error(h.localize(2,null,n)))})}spawnTerminal(E,k,t){const c=k.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",c];t&&o.push(t);const u=a(process),s=E.spawn("/usr/bin/open",o,{cwd:t,env:u});s.on("error",n),s.on("exit",()=>i())})}}y.OSASCRIPT="/usr/bin/osascript",e.MacExternalTerminalService=y;class m extends S{openTerminal(E,k){return this.spawnTerminal(I,E,k)}runInTerminal(E,k,t,c,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,u)=>{const s=[];n.then(d=>{d.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const C=`${p(t)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;s.push(`''${C}''`);const L=Object.assign({},a(process),c);Object.keys(L).filter(q=>L[q]===null).forEach(q=>delete L[q]);const O={cwd:k,env:L};let F="";const z=I.spawn(d,s,O);z.on("error",q=>{u(f(q))}),z.stderr.on("data",q=>{F+=q.toString()}),z.on("exit",q=>{if(q===0)o(void 0);else if(F){const ie=F.split(`
`,1);u(new Error(ie[0]))}else u(new Error(h.localize(4,null,d,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(k=>{E?k("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?k("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?k("konsole"):process.env.COLORTERM?k(process.env.COLORTERM):process.env.TERM?k(process.env.TERM):k("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(E,k,t){const c=k.linuxExec?Promise.resolve(k.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{c.then(o=>{const u=a(process),s=E.spawn(o,[],{cwd:t,env:u});s.on("error",n),s.on("exit",()=>i())})})}}m.WAIT_MESSAGE=h.localize(3,null),e.LinuxExternalTerminalService=m;function a(b){const E={...b.env};return(0,D.sanitizeProcessEnvironment)(E),E}function f(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(h.localize(5,null,b.path)):b}function p(b){let E="";for(const k of b)k.indexOf(" ")>=0?E+='"'+k+'"':E+=k,E+=" ";return E}}),define(Z[16],ee([0,1,61,9,27,10,8,171,6,4,14]),function(x,e,I,M,r,R,D,P,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function v(T){return T.create===!0}e.isFileOpenForWriteOptions=v;var S;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var l;(function(T){T[T.Readonly=1]="Readonly"})(l=e.FilePermission||(e.FilePermission={}));var y;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=m;function a(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=a;function f(T){return!!(T.capabilities&32768)}e.hasFileCloneCapability=f;function p(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function b(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=b;function E(T){return m(T)?!!(T.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var k;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(H,Y){const te=new t(H.toString(),Y);return n(te,Y),te}constructor(H,Y){super(H),this.code=Y}}e.FileSystemProviderError=t;function c(T,H){return t.create(T,H)}e.createFileSystemProviderError=c;function i(T){return T||c((0,P.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=i;function n(T,H){return T.name=H?`${H} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=n;function o(T){if(!T)return k.Unknown;if(T instanceof t)return T.code;const H=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!H)return k.Unknown;switch(H[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=o;function u(T){if(T instanceof F)return T.fileOperationResult;switch(o(T)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var s;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class d{constructor(H,Y,te){this.resource=H,this.operation=Y,this.target=te}isOperation(H){return this.operation===H}}e.FileOperationEvent=d;var C;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(C=e.FileChangeType||(e.FileChangeType={}));class L{constructor(H,Y){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const ne of H){const U=te.get(ne.type);switch(U?U.push([ne.resource,ne]):te.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,U]of te)switch(ne){case 1:this.added=I.TernarySearchTree.forUris(()=>Y),this.added.fill(U);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>Y),this.updated.fill(U);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>Y),this.deleted.fill(U);break}}contains(H,...Y){return this.doContains(H,{includeChildren:!1},...Y)}affects(H,...Y){return this.doContains(H,{includeChildren:!0},...Y)}doContains(H,Y,...te){if(!H)return!1;const ne=te.length>0;return!!((!ne||te.includes(1))&&(this.added?.get(H)||Y.includeChildren&&this.added?.findSuperstr(H))||(!ne||te.includes(0))&&(this.updated?.get(H)||Y.includeChildren&&this.updated?.findSuperstr(H))||(!ne||te.includes(2))&&(this.deleted?.findSubstr(H)||Y.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=L;function O(T,H,Y){return!T||!H||T===H||H.length>T.length?!1:(H.charAt(H.length-1)!==M.sep&&(H+=M.sep),Y?(0,r.startsWithIgnoreCase)(T,H):T.indexOf(H)===0)}e.isParent=O;class F extends Error{constructor(H,Y,te){super(H),this.fileOperationResult=Y,this.options=te}}e.FileOperationError=F;class z extends F{constructor(H,Y,te,ne){super(H,Y,ne),this.fileOperationResult=Y,this.size=te}}e.TooLargeFileOperationError=z;class q extends F{constructor(H,Y,te){super(H,2,te),this.stat=Y}}e.NotModifiedSinceFileOperationError=q;var ie;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var se;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(se=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function oe(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=oe;async function he(T,H){if(!H.hasProvider(D.URI.from({scheme:T.scheme})))return new Promise(Y=>{const te=H.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===T.scheme&&ne.added&&(te.dispose(),Y())})})}e.whenProviderRegistered=he,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(H){return(0,R.isNumber)(H)||(H=0),H<le.KB?(0,P.localize)(1,null,H.toFixed(0)):H<le.MB?(0,P.localize)(2,null,(H/le.KB).toFixed(2)):H<le.GB?(0,P.localize)(3,null,(H/le.MB).toFixed(2)):H<le.TB?(0,P.localize)(4,null,(H/le.GB).toFixed(2)):(0,P.localize)(5,null,(H/le.TB).toFixed(2))}}le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB,e.ByteSize=le;var ge;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(ge=e.Arch||(e.Arch={}));function V(T){return{maxFileSize:T===0?300*le.MB:16*le.GB,maxHeapSize:T===0?700*le.MB:2*700*le.MB}}e.getPlatformFileLimits=V;function B(T){const H=typeof T=="string"||T?.scheme===w.Schemas.vscodeRemote;return typeof T!="string"&&T?.scheme===w.Schemas.file?1024*le.MB:H?10*le.MB:h.isWeb?50*le.MB:1024*le.MB}e.getLargeFileConfirmationLimit=B}),define(Z[205],ee([0,1,17,44,13,3,2,59,8,31,16]),function(x,e,I,M,r,R,D,P,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends D.Disposable{constructor(l,y){super(),this.channel=l,this.extraCapabilities=y,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,h.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(l){return this.channel.call("stat",[l])}readdir(l){return this.channel.call("readdir",[l])}async readFile(l,y){const{buffer:m}=await this.channel.call("readFile",[l,y]);return m}readFileStream(l,y,m){const a=(0,P.newWriteableStream)(p=>I.VSBuffer.concat(p.map(b=>I.VSBuffer.wrap(b))).buffer),f=this.channel.listen("readFileStream",[l,y])(p=>{if(p instanceof I.VSBuffer)a.write(p.buffer);else{if(p==="end")a.end();else{let b;if(p instanceof Error)b=p;else{const E=p;b=(0,w.createFileSystemProviderError)(E.message??(0,M.toErrorMessage)(E),E.code??w.FileSystemProviderErrorCode.Unknown)}a.error(b),a.end()}f.dispose()}});return m.onCancellationRequested(()=>{a.error((0,r.canceled)()),a.end(),f.dispose()}),a}writeFile(l,y,m){return this.channel.call("writeFile",[l,I.VSBuffer.wrap(y),m])}open(l,y){return this.channel.call("open",[l,y])}close(l){return this.channel.call("close",[l])}async read(l,y,m,a,f){const[p,b]=await this.channel.call("read",[l,y,f]);return m.set(p.buffer.slice(0,b),a),b}write(l,y,m,a,f){return this.channel.call("write",[l,y,I.VSBuffer.wrap(m),a,f])}mkdir(l){return this.channel.call("mkdir",[l])}delete(l,y){return this.channel.call("delete",[l,y])}rename(l,y,m){return this.channel.call("rename",[l,y,m])}copy(l,y,m){return this.channel.call("copy",[l,y,m])}cloneFile(l,y){return this.channel.call("cloneFile",[l,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(l=>{if(Array.isArray(l)){const y=l;this._onDidChange.fire(y.map(m=>({resource:g.URI.revive(m.resource),type:m.type})))}else{const y=l;this._onDidWatchError.fire(y)}}))}watch(l,y){const m=(0,h.generateUuid)();return this.channel.call("watch",[this.sessionId,m,l,y]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,m]))}}e.DiskFileSystemProviderClient=v}),define(Z[114],ee([0,1,17,13,172,16]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(w,v,S,l,y,m){let a;try{await P(w,v,S,l,y,m)}catch(f){a=f}finally{a&&y.errorTransformer&&(a=y.errorTransformer(a)),typeof a<"u"&&S.error(a),S.end()}}e.readFileIntoStream=D;async function P(w,v,S,l,y,m){g(m);const a=await w.open(v,{create:!1});try{g(m);let f=0,p=0,b=y&&typeof y.length=="number"?y.length:void 0,E=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),k=y&&typeof y.position=="number"?y.position:0,t=0;do p=await w.read(a,k,E.buffer,t,E.byteLength-t),k+=p,t+=p,f+=p,typeof b=="number"&&(b-=p),t===E.byteLength&&(await S.write(l(E)),E=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),t=0);while(p>0&&(typeof b!="number"||b>0)&&g(m)&&h(f,y));if(t>0){let c=t;typeof b=="number"&&(c=Math.min(t,b)),S.write(l(E.slice(0,c)))}}catch(f){throw(0,R.ensureFileSystemProviderError)(f)}finally{await w.close(a)}}function g(w){if(w.isCancellationRequested)throw(0,M.canceled)();return!0}function h(w,v){if(v?.limits){if(typeof v.limits.memory=="number"&&w>v.limits.memory)throw(0,R.createFileSystemProviderError)((0,r.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&w>v.limits.size)throw(0,R.createFileSystemProviderError)((0,r.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[77],ee([0,1,102,2,9,4,8,16]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(f){return f.recursive===!0}e.isRecursiveWatchRequest=g;class h extends M.Disposable{constructor(p,b,E,k){super(),this.onFileChanges=p,this.onLogMessage=b,this.verboseLogging=E,this.options=k,this.watcherDisposables=this._register(new M.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new M.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(b=>this.onFileChanges(b))),p.add(this.watcher.onDidLogMessage(b=>this.onLogMessage(b))),p.add(this.watcher.onDidError(b=>this.onError(b)))}onError(p){this.options.restartOnError?this.restartCounter<h.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}trace(p){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}h.MAX_RESTARTS=5,e.AbstractWatcherClient=h;class w extends h{constructor(p,b,E){super(p,b,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class v extends h{constructor(p,b,E){super(p,b,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function S(f){return f.map(p=>({type:p.type,resource:D.URI.file(p.path)}))}e.toFileChanges=S;function l(f){const p=new a;for(const b of f)p.processEvent(b);return p.coalesce()}e.coalesceEvents=l;function y(f,p){return typeof p=="string"&&!p.startsWith(I.GLOBSTAR)&&!(0,r.isAbsolute)(p)?{base:f,pattern:p}:p}e.normalizeWatcherPattern=y;function m(f,p){const b=[];for(const E of p)b.push((0,I.parse)(y(f,E)));return b}e.parseWatcherPatterns=m;class a{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return R.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const b=this.mapPathToChange.get(this.toKey(p));let E=!1;if(b){const k=b.type,t=p.type;b.path!==p.path&&(p.type===2||p.type===1)?E=!0:k===1&&t===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(b)):k===2&&t===1?b.type=0:k===1&&t===0||(b.type=t)}else E=!0;E&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],b=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(p.push(E),!1):!0).sort((E,k)=>E.path.length-k.path.length).filter(E=>b.some(k=>(0,P.isParent)(E.path,k,!R.isLinux))?!1:(b.push(E.path),!0)).concat(p)}}}),define(Z[206],ee([0,1,41,7,22,32,2,81,9,4,103,23,77]),function(x,e,I,M,r,R,D,P,g,h,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class l extends D.Disposable{constructor(a,f,p,b){super(),this.request=a,this.onDidFilesChange=f,this.onLogMessage=p,this.verboseLogging=b,this.throttledFileChangesEmitter=this._register(new M.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.onDidFilesChange(E))),this.fileChangesAggregator=this._register(new M.RunOnceWorker(E=>this.handleFileChanges(E),l.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const a=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const f=await v.Promises.stat(a);this._register(await this.doWatch(a,f.isDirectory()))}catch(a){a.code!=="ENOENT"?this.error(a):this.trace(a)}}async normalizePath(a){let f=a.path;try{f=await v.Promises.realpath(a.path),a.path===f&&(f=await(0,w.realcase)(a.path)??a.path),a.path!==f&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${f})`)}catch{}return f}async doWatch(a,f){if(h.isMacintosh&&(0,R.isEqualOrParent)(a,"/Volumes/",!0))return this.error(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const p=new r.CancellationTokenSource(this.cts.token),b=new D.DisposableStore;try{const E=(0,g.basename)(a),k=(0,I.watch)(a);b.add((0,D.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.trace(`Started watching: '${a}'`);const t=new Set;if(f)try{for(const i of await v.Promises.readdir(a))t.add(i)}catch(i){this.error(i)}const c=new Map;b.add((0,D.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),k.on("error",(i,n)=>{this.error(`Failed to watch ${a} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),k.on("change",(i,n)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),h.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(f)if(i==="rename"){c.get(o)?.dispose();const u=setTimeout(async()=>{if(c.delete(o),o===E&&!await v.Promises.exists(a)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.existsChildStrictCase((0,g.join)(a,o));if(p.token.isCancellationRequested)return;let d;s?t.has(o)?d=0:(d=1,t.add(o)):(t.delete(o),d=2),this.onFileChange({path:(0,g.join)(this.request.path,o),type:d})},l.FILE_DELETE_HANDLER_DELAY);c.set(o,(0,D.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(o)?u=0:(u=1,t.add(o)),this.onFileChange({path:(0,g.join)(this.request.path,o),type:u})}else if(i==="rename"||o!==E){const u=setTimeout(async()=>{const s=await v.Promises.exists(a);p.token.isCancellationRequested||(s?(this.onFileChange({path:this.request.path,type:0},!0),b.add(await this.doWatch(a,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},l.FILE_DELETE_HANDLER_DELAY);b.clear(),b.add((0,D.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(E){await v.Promises.exists(a)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${a} for changes using fs.watch() (${E.toString()})`)}return(0,D.toDisposable)(()=>{p.dispose(!0),b.dispose()})}onFileChange(a,f=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!f&&this.excludes.some(p=>p(a.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${a.path}`):!f&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(a.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${a.path}`):this.fileChangesAggregator.work(a))}handleFileChanges(a){const f=(0,S.coalesceEvents)(a);if(f.length>0){if(this.verboseLogging)for(const b of f)this.trace(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.throttledFileChangesEmitter.work(f)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(a){if(h.isLinux)return v.Promises.exists(a);try{const f=(0,g.basename)(a);return(await v.Promises.readdir((0,g.dirname)(a))).some(b=>b===f)}catch(f){return this.trace(f),!1}}setVerboseLogging(a){this.verboseLogging=a}error(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}warn(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}trace(a){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}l.FILE_DELETE_HANDLER_DELAY=100,l.FILE_CHANGES_HANDLER_DELAY=75,e.NodeJSFileWatcherLibrary=l;async function y(m,a,f,p,b=512){const E=await v.Promises.open(m,"r"),k=Buffer.allocUnsafe(b),t=new r.CancellationTokenSource(p);let c,i=!1;const n={path:m,excludes:[],recursive:!1},o=new l(n,u=>{(async()=>{for(const{type:s}of u)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:d}=await v.Promises.read(E,k,0,b,null);if(!d||t.token.isCancellationRequested)break;a(k.slice(0,d))}}catch(d){c=new Error(d),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,f(),new Promise((u,s)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await v.Promises.close(E)}catch(d){c=new Error(d)}c?s(c):u()})})}e.watchFileContents=y}),define(Z[207],ee([0,1,3,102,2,4,206]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(h){const w=this.normalizeRequests(h),v=w.filter(l=>{const y=this.watchers.get(l.path);return y?!(0,M.patternsEquals)(y.request.excludes,l.excludes)||!(0,M.patternsEquals)(y.request.includes,l.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:l})=>!w.find(y=>y.path===l.path&&(0,M.patternsEquals)(y.excludes,l.excludes)&&(0,M.patternsEquals)(y.includes,l.includes))).map(({request:l})=>l.path);v.length&&this.trace(`Request to start watching: ${v.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const l of S)this.stopWatching(l);for(const l of v)this.startWatching(l)}startWatching(h){const w=new D.NodeJSFileWatcherLibrary(h,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),v={request:h,instance:w};this.watchers.set(h.path,v)}async stop(){for(const[h]of this.watchers)this.stopWatching(h);this.watchers.clear()}stopWatching(h){const w=this.watchers.get(h);w&&(this.watchers.delete(h),w.instance.dispose())}normalizeRequests(h){const w=new Map;for(const v of h){const S=R.isLinux?v.path:v.path.toLowerCase();w.set(S,v)}return Array.from(w.values())}async setVerboseLogging(h){this.verboseLogging=h;for(const[,w]of this.watchers)w.instance.setVerboseLogging(h)}trace(h){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h)})}toMessage(h,w){return w?`[File Watcher (node.js)] ${h} (path: ${w.request.path})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=P}),define(Z[208],ee([0,1,77,207]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends I.AbstractNonRecursiveWatcherClient{constructor(D,P,g){super(D,P,g),this.init()}createWatcher(){return new M.NodeJSWatcher}}e.NodeJSWatcherClient=r}),define(Z[209],ee([0,1,14,47,157,77]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(g,h,w){super(g,h,w),this.init()}createWatcher(g){const h=g.add(new r.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(h.onDidProcessExit(({code:w,signal:v})=>this.onError(`terminated by itself with code ${w}, signal: ${v}`))),M.ProxyChannel.toService((0,M.getNextTickChannel)(h.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(Z[90],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...r){this._entries=new Map;for(const[R,D]of r)this.set(R,D)}set(r,R){const D=this._entries.get(r);return this._entries.set(r,R),D}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=I}),define(Z[210],ee([0,1,7,13,2,75,201,6,90,100]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class v extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class S{constructor(a=new g.ServiceCollection,f=!1,p,b=w){this._services=a,this._strict=f,this._parent=p,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new D.Graph(E=>E):void 0}createChild(a){return new S(a,this._strict,this,this._enableTracing)}invokeFunction(a,...f){const p=y.traceInvocation(this._enableTracing,a);let b=!1;try{return a({get:k=>{if(b)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(k,p);if(!t)throw new Error(`[invokeFunction] unknown service '${k}'`);return t}},...f)}finally{b=!0,p.stop()}}createInstance(a,...f){let p,b;return a instanceof R.SyncDescriptor?(p=y.traceCreation(this._enableTracing,a.ctor),b=this._createInstance(a.ctor,a.staticArguments.concat(f),p)):(p=y.traceCreation(this._enableTracing,a),b=this._createInstance(a,f,p)),p.stop(),b}_createInstance(a,f=[],p){const b=P._util.getServiceDependencies(a).sort((t,c)=>t.index-c.index),E=[];for(const t of b){const c=this._getOrCreateServiceInstance(t.id,p);c||this._throwIfStrict(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(c)}const k=b.length>0?b[0].index:f.length;if(f.length!==k){console.trace(`[createInstance] First service dependency of ${a.name} at position ${k+1} conflicts with ${f.length} static arguments`);const t=k-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,k)}return Reflect.construct(a,f.concat(E))}_setServiceInstance(a,f){if(this._services.get(a)instanceof R.SyncDescriptor)this._services.set(a,f);else if(this._parent)this._parent._setServiceInstance(a,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){const f=this._services.get(a);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):f}_getOrCreateServiceInstance(a,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(a));const p=this._getServiceInstanceOrDescriptor(a);return p instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,p,f.branch(a,!0)):(f.branch(a,!1),p)}_safeCreateAndCacheServiceInstance(a,f,p){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,f,p)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,f,p){const b=new D.Graph(t=>t.id.toString());let E=0;const k=[{id:a,desc:f,_trace:p}];for(;k.length;){const t=k.pop();if(b.lookupOrInsertNode(t),E++>1e3)throw new v(b);for(const c of P._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(c.id);if(i||this._throwIfStrict(`[createInstance] ${a} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof R.SyncDescriptor){const n={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};b.insertEdge(t,n),k.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new v(b);break}for(const{data:c}of t){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const n=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,n)}b.removeNode(c)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,f,p=[],b,E){if(this._services.get(a)instanceof R.SyncDescriptor)return this._createServiceInstance(a,f,p,b,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,f,p,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(a,f,p=[],b,E){if(b){const k=new S(void 0,this._strict,this,this._enableTracing);k._globalGraphImplicitDependency=String(a);const t=new Map,c=new I.IdleValue(()=>{const i=k._createInstance(f,p,E);for(const[n,o]of t){const u=i[n];if(typeof u=="function")for(const s of o)u.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!c.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=t.get(n);return s||(s=new h.LinkedList,t.set(n,s)),(C,L,O)=>{const F=s.push([C,L,O]);return(0,r.toDisposable)(F)}}if(n in i)return i[n];const o=c.value;let u=o[n];return typeof u!="function"||(u=u.bind(o),i[n]=u),u},set(i,n,o){return c.value[n]=o,!0},getPrototypeOf(i){return f.prototype}})}else return this._createInstance(f,p,E)}_throwIfStrict(a,f){if(f&&console.warn(a),this._strict)throw new Error(a)}}e.InstantiationService=S;var l;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(l||(l={}));class y{static traceInvocation(a,f){return a?new y(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(a,f){return a?new y(1,f.name):y._None}constructor(a,f){this.type=a,this.name=f,this._start=Date.now(),this._dep=[]}branch(a,f){const p=new y(3,a.toString());return this._dep.push([a,f,p]),p}stop(){const a=Date.now()-this._start;y._totals+=a;let f=!1;function p(E,k){const t=[],c=new Array(E+1).join("	");for(const[i,n,o]of k._dep)if(n&&o){f=!0,t.push(`${c}CREATES -> ${i}`);const u=p(E+1,o);u&&t.push(u)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(a>2||f)&&y.all.add(b.join(`
`))}}y.all=new Set,y._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y._totals=0,e.Trace=y}),define(Z[5],ee([0,1,44,3,2,35,4,10,8,6]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function w(){return new Date().toISOString()}function v(s){return(0,P.isNumber)(s)}e.isLogLevel=v;var S;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function l(s,d,C){switch(d){case S.Trace:s.trace(C);break;case S.Debug:s.debug(C);break;case S.Info:s.info(C);break;case S.Warning:s.warn(C);break;case S.Error:s.error(C);break;case S.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=l;function y(s){let d="";for(let C=0;C<s.length;C++){let L=s[C];if(typeof L=="object")try{L=JSON.stringify(L)}catch{}d+=(C>0?" ":"")+L}return d}e.format=y;class m extends r.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(d){this.level!==d&&(this.level=d,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(d){return this.level!==S.Off&&this.level<=d}}e.AbstractLogger=m;class a extends m{constructor(d){super(),this.logAlways=d}checkLogLevel(d){return this.logAlways||super.checkLogLevel(d)}trace(d,...C){this.checkLogLevel(S.Trace)&&this.log(S.Trace,y([d,...C]))}debug(d,...C){this.checkLogLevel(S.Debug)&&this.log(S.Debug,y([d,...C]))}info(d,...C){this.checkLogLevel(S.Info)&&this.log(S.Info,y([d,...C]))}warn(d,...C){this.checkLogLevel(S.Warning)&&this.log(S.Warning,y([d,...C]))}error(d,...C){if(this.checkLogLevel(S.Error))if(d instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=d.stack,this.log(S.Error,y(L))}else this.log(S.Error,y([d,...C]))}flush(){}}e.AbstractMessageLogger=a;class f extends m{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.useColors=!D.isWindows}trace(d,...C){this.checkLogLevel(S.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,d,...C):console.log(`[main ${w()}]`,d,...C))}debug(d,...C){this.checkLogLevel(S.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,d,...C):console.log(`[main ${w()}]`,d,...C))}info(d,...C){this.checkLogLevel(S.Info)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,d,...C):console.log(`[main ${w()}]`,d,...C))}warn(d,...C){this.checkLogLevel(S.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,d,...C):console.warn(`[main ${w()}]`,d,...C))}error(d,...C){this.checkLogLevel(S.Error)&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,d,...C):console.error(`[main ${w()}]`,d,...C))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class p extends m{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d)}trace(d,...C){this.checkLogLevel(S.Trace)&&console.log("%cTRACE","color: #888",d,...C)}debug(d,...C){this.checkLogLevel(S.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",d,...C)}info(d,...C){this.checkLogLevel(S.Info)&&console.log("%c INFO","color: #33f",d,...C)}warn(d,...C){this.checkLogLevel(S.Warning)&&console.log("%c WARN","color: #993",d,...C)}error(d,...C){this.checkLogLevel(S.Error)&&console.log("%c  ERR","color: #f33",d,...C)}dispose(){}flush(){}}e.ConsoleLogger=p;class b extends m{constructor(d,C=e.DEFAULT_LOG_LEVEL){super(),this.adapter=d,this.setLevel(C)}trace(d,...C){this.checkLogLevel(S.Trace)&&this.adapter.log(S.Trace,[this.extractMessage(d),...C])}debug(d,...C){this.checkLogLevel(S.Debug)&&this.adapter.log(S.Debug,[this.extractMessage(d),...C])}info(d,...C){this.checkLogLevel(S.Info)&&this.adapter.log(S.Info,[this.extractMessage(d),...C])}warn(d,...C){this.checkLogLevel(S.Warning)&&this.adapter.log(S.Warning,[this.extractMessage(d),...C])}error(d,...C){this.checkLogLevel(S.Error)&&this.adapter.log(S.Error,[this.extractMessage(d),...C])}extractMessage(d){return typeof d=="string"?d:(0,I.toErrorMessage)(d,this.checkLogLevel(S.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class E extends m{constructor(d){super(),this.loggers=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const C of this.loggers)C.setLevel(d);super.setLevel(d)}trace(d,...C){for(const L of this.loggers)L.trace(d,...C)}debug(d,...C){for(const L of this.loggers)L.debug(d,...C)}info(d,...C){for(const L of this.loggers)L.info(d,...C)}warn(d,...C){for(const L of this.loggers)L.warn(d,...C)}error(d,...C){for(const L of this.loggers)L.error(d,...C)}flush(){for(const d of this.loggers)d.flush()}dispose(){for(const d of this.loggers)d.dispose()}}e.MultiplexLogger=E;class k extends r.Disposable{constructor(d,C){if(super(),this.logLevel=d,this._loggers=new R.ResourceMap,this._loggerResources=new R.ResourceMap,this._onDidChangeLoggers=this._register(new M.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new M.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,C)for(const L of C)this._loggerResources.set(L.resource,L)}getLogger(d){return this._loggers.get(d)}createLogger(d,C){let L=this._loggers.get(d);const O=C?.logLevel==="always"?S.Trace:C?.logLevel;return L||(L=this.doCreateLogger(d,O??this.getLogLevel(d)??this.logLevel,C),this._loggers.set(d,L)),this.registerLogger({resource:d,id:C?.id??d.toString(),logLevel:O,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId}),L}setLogLevel(d,C){if(g.URI.isUri(d)){const L=d,O=C,F=this._loggerResources.get(L);F&&O!==F.logLevel&&(F.logLevel=O===this.logLevel?void 0:O,this._loggers.get(L)?.setLevel(O),this._loggerResources.set(F.resource,F),this._onDidChangeLogLevel.fire([L,O]))}else{this.logLevel=d;for(const[L,O]of this._loggers.entries())this._loggerResources.get(L)?.logLevel===void 0&&O.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(d,C){const L=this._loggerResources.get(d);L&&C!==!L.hidden&&(L.hidden=!C,this._loggerResources.set(L.resource,L),this._onDidChangeVisibility.fire([d,C]))}getLogLevel(d){let C;return d&&(C=this._loggerResources.get(d)?.logLevel),C??this.logLevel}registerLogger(d){const C=this._loggerResources.get(d.resource);C?C.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this._loggerResources.set(d.resource,d),this._onDidChangeLoggers.fire({added:[d],removed:[]}))}deregisterLogger(d){const C=this._loggerResources.get(d);if(C){this._loggerResources.delete(d);const L=this._loggers.get(d);L&&(this._loggers.delete(d),L.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[C]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(d){return this._loggerResources.get(d)}dispose(){this._loggers.forEach(d=>d.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=k;class t{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(d){}getLevel(){return S.Info}trace(d,...C){}debug(d,...C){}info(d,...C){}warn(d,...C){}error(d,...C){}critical(d,...C){}dispose(){}flush(){}}e.NullLogger=t;class c extends t{}e.NullLogService=c;class i extends k{constructor(){super(S.Info)}doCreateLogger(d,C,L){return new t}}e.NullLoggerService=i;function n(s){if(s.verbose)return S.Trace;if(typeof s.logLevel=="string"){const d=u(s.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function o(s){switch(s){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.LogLevelToString=o;function u(s){switch(s){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.parseLogLevel=u});var X=this&&this.__param||function(x,e){return function(I,M){e(I,M,x)}};define(Z[211],ee([0,1,76,3,2,5,4,7]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let g=class ut extends r.Disposable{constructor(w){super(),this.logService=w,this._onDidChangePassword=this._register(new M.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(w,v){this.logService.trace("Getting password from keytar:",w,v);let S;try{S=await this.withKeytar()}catch{return null}const l=await(0,P.retry)(()=>S.getPassword(w,v),50,3);if(!l)return this.logService.trace("Did not get a password from keytar for account:",v),l;let y,m;try{const a=JSON.parse(l);y=a.content,m=a.hasNextChunk}catch{}if(!y||!m)return this.logService.trace("Got password from keytar for account:",v),l;try{let a=1;for(;m;){const f=await(0,P.retry)(()=>S.getPassword(w,`${v}-${a}`),50,3),p=JSON.parse(f);y+=p.content,m=p.hasNextChunk,a++}return this.logService.trace(`Got ${a}-chunked password from keytar for account:`,v),y}catch(a){return this.logService.error(a),l}}async setPassword(w,v,S){this.logService.trace("Setting password using keytar:",w,v);let l;try{l=await this.withKeytar()}catch(y){throw this.surfaceKeytarLoadError?.(y),y}if(D.isWindows&&S.length>ut.MAX_PASSWORD_LENGTH){let y=0,m=0,a=!0;for(;a;){const f=S.substring(y,y+ut.PASSWORD_CHUNK_SIZE);y+=ut.PASSWORD_CHUNK_SIZE,a=S.length-y>0;const p={content:f,hasNextChunk:a};await(0,P.retry)(()=>l.setPassword(w,m?`${v}-${m}`:v,JSON.stringify(p)),50,3),m++}this.logService.trace(`Got${m?` ${m}-chunked`:""} password from keytar for account:`,v)}else await(0,P.retry)(()=>l.setPassword(w,v,S),50,3),this.logService.trace("Got password from keytar for account:",v);this._onDidChangePassword.fire({service:w,account:v})}async deletePassword(w,v){this.logService.trace("Deleting password using keytar:",w,v);let S;try{S=await this.withKeytar()}catch(f){throw this.surfaceKeytarLoadError?.(f),f}const l=await S.getPassword(w,v);if(!l)return this.logService.trace("Did not get a password to delete from keytar for account:",v),!1;let y,m;try{const f=JSON.parse(l);y=f.content,m=f.hasNextChunk}catch{}let a=0;if(y&&m)try{for(a++;m;){const f=`${v}-${a}`,p=await S.getPassword(w,f);await S.deletePassword(w,f),m=JSON.parse(p).hasNextChunk,a++}}catch(f){this.logService.error(f)}return await S.deletePassword(w,v)?(this._onDidChangePassword.fire({service:w,account:v}),this.logService.trace(`Deleted${a?` ${a}-chunked`:""} password from keytar for account:`,v),!0):(this.logService.trace(`Keytar failed to delete${a?` ${a}-chunked`:""} password for account:`,v),!1)}async findPassword(w){let v;try{v=await this.withKeytar()}catch{return null}return await v.findPassword(w)}async findCredentials(w){let v;try{v=await this.withKeytar()}catch{return[]}return await v.findCredentials(w)}clear(){return this._keytarCache instanceof I.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};g.MAX_PASSWORD_LENGTH=2500,g.PASSWORD_CHUNK_SIZE=g.MAX_PASSWORD_LENGTH-100,g=we([X(0,R.ILogService)],g),e.BaseCredentialsMainService=g}),define(Z[212],ee([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let M=class{constructor(R,D){this.machineId=R,this.logService=D}encryption(){return new Promise((R,D)=>x(["vscode-encrypt"],R,D))}async encrypt(R){let D;try{D=await this.encryption()}catch{return R}try{return D.encrypt(this.machineId,R)}catch(P){return this.logService.error(P),R}}async decrypt(R){let D;try{D=await this.encryption()}catch{return R}try{return D.decrypt(this.machineId,R)}catch(P){return this.logService.error(P),R}}};M=we([X(1,I.ILogService)],M),e.EncryptionMainService=M}),define(Z[213],ee([0,1,25,7,13,3,2,9,77,5]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class w extends D.Disposable{constructor(S,l){super(),this.logService=S,this.options=l,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new M.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new M.ThrottledDelayer(0))}watch(S,l){return l.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,l):this.watchNonRecursive(S,l)}watchUniversal(S,l){const y={path:this.toFilePath(S),excludes:l.excludes,includes:l.includes,recursive:l.recursive},m=(0,I.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(l=>this._onDidChangeFile.fire((0,g.toFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const l of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(l)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const l of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(l)&&S.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,l){const y={path:this.toFilePath(S),excludes:l.excludes,includes:l.includes,recursive:!1},m=(0,I.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,r.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,g.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,P.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=w}),define(Z[214],ee([0,1,25,7,17,22,3,60,70,2,61,14,64,19,59,170,16,114,5,13]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends h.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new M.ResourceQueue)}registerProvider(t,c){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const i=new h.DisposableStore;return this.provider.set(t,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:c}),i.add(c.onDidChangeFile(n=>this._onDidFilesChange.fire(new a.FileChangesEvent(n,!this.isPathCaseSensitive(c))))),typeof c.onDidWatchError=="function"&&i.add(c.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:t}))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:c}),this.provider.delete(t),(0,h.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){c.push(i)}}),!this.provider.has(t)&&await M.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,c){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return g.Iterable.map(this.provider,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async withProvider(t){if(!(0,l.isAbsolutePath)(t))throw new a.FileOperationError((0,m.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const c=this.provider.get(t.scheme);if(!c){const i=new b.ErrorNoTelemetry;throw i.message=(0,m.localize)(1,null,t.toString()),i}return c}async withReadProvider(t){const c=await this.withProvider(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c)||(0,a.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const c=await this.withProvider(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.doResolveFile(t,c)}catch(i){throw(0,a.toFileSystemProviderErrorCode)(i)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,m.localize)(2,null,this.resourceForError(t)),1):(0,a.ensureFileSystemProviderError)(i)}}async doResolveFile(t,c){const i=await this.withProvider(t),n=this.isPathCaseSensitive(i),o=c?.resolveTo,u=c?.resolveSingleChildDescendants,s=c?.resolveMetadata,d=await i.stat(t);let C;return this.toFileStat(i,t,d,void 0,!!s,(L,O)=>(C||(C=w.TernarySearchTree.forUris(()=>!n),C.set(t,!0),o&&C.fill(!0,o)),C.get(L.resource)||C.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&u?O===1:!1))}async toFileStat(t,c,i,n,o,u){const{providerExtUri:s}=this.getExtUri(t),d={resource:c,name:s.basename(c),isFile:(i.type&a.FileType.File)!==0,isDirectory:(i.type&a.FileType.Directory)!==0,isSymbolicLink:(i.type&a.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&a.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,a.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(d.isDirectory&&u(d,n)){try{const C=await t.readdir(c),L=await M.Promises.settled(C.map(async([O,F])=>{try{const z=s.joinPath(c,O),q=o?await t.stat(z):{type:F};return await this.toFileStat(t,z,q,C.length,o,u)}catch(z){return this.logService.trace(z),null}}));d.children=(0,I.coalesce)(L)}catch(C){this.logService.trace(C),d.children=[]}return d}return d}async resolveAll(t){return M.Promises.settled(t.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.withProvider(t),i=await c.stat(t);return this.toFileStat(c,t,i,void 0,!0,()=>!1)}async exists(t){const c=await this.withProvider(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.doValidateCreateFile(t,c)}catch(i){return i}return!0}async doValidateCreateFile(t,c){if(!c?.overwrite&&await this.exists(t))throw new a.FileOperationError((0,m.localize)(3,null,this.resourceForError(t)),3,c)}async createFile(t,c=r.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const n=await this.writeFile(t,c);return this._onDidRunOperation.fire(new a.FileOperationEvent(t,0,n)),n}async writeFile(t,c,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:o}=this.getExtUri(n);try{await this.validateWriteFile(n,t,i)||await this.mkdirp(n,o.dirname(t));let s;if((0,a.hasReadWriteCapability)(n)&&!(c instanceof r.VSBuffer))if((0,y.isReadableStream)(c)){const d=await(0,y.peekStream)(c,3);d.ended?s=r.VSBuffer.concat(d.buffer):s=d}else s=(0,y.peekReadable)(c,d=>r.VSBuffer.concat(d),3);else s=c;!(0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasReadWriteCapability)(n)&&s instanceof r.VSBuffer?await this.doWriteUnbuffered(n,t,i,s):await this.doWriteBuffered(n,t,i,s instanceof r.VSBuffer?(0,r.bufferToReadable)(s):s),this._onDidRunOperation.fire(new a.FileOperationEvent(t,4))}catch(u){throw new a.FileOperationError((0,m.localize)(4,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(u).toString()),(0,a.toFileOperationResult)(u),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,c,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(c)));let o;try{o=await t.stat(c)}catch{return}if((o.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,m.localize)(6,null,this.resourceForError(c)),0,i);if(this.throwIfFileIsReadonly(c,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,a.etag)({mtime:i.mtime,size:o.size}))throw new a.FileOperationError((0,m.localize)(7,null),3,i);return o}async readFile(t,c,i){const n=await this.withReadProvider(t);return c?.atomic?this.doReadFileAtomic(n,t,c,i):this.doReadFile(n,t,c,i)}async doReadFileAtomic(t,c,i,n){return new Promise((o,u)=>{this.writeQueue.queueFor(c,this.getExtUri(t).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(t,c,i,n);o(s)}catch(s){u(s)}})})}async doReadFile(t,c,i,n){const o=await this.doReadFileStream(t,c,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,r.streamToBuffer)(o.value)}}async readFileStream(t,c,i){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,c,i)}async doReadFileStream(t,c,i,n){const o=new R.CancellationTokenSource(n),u=this.validateReadFile(c,i).then(d=>d,d=>{throw o.cancel(),d});let s;try{return typeof i?.etag=="string"&&i.etag!==a.ETAG_DISABLED&&await u,i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)||!((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasFileReadStreamCapability)(t))||(0,a.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.readFileUnbuffered(t,c,i):(0,a.hasFileReadStreamCapability)(t)?s=this.readFileStreamed(t,c,o.token,i):s=this.readFileBuffered(t,c,o.token,i),{...await u,value:s}}catch(d){throw s&&await(0,y.consumeStream)(s),this.restoreReadError(d,c,i)}}restoreReadError(t,c,i){const n=(0,m.localize)(8,null,this.resourceForError(c),(0,a.ensureFileSystemProviderError)(t).toString());return t instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new a.FileOperationError(n,(0,a.toFileOperationResult)(t),i)}readFileStreamed(t,c,i,n=Object.create(null)){const o=t.readFileStream(c,n,i);return(0,y.transform)(o,{data:u=>u instanceof r.VSBuffer?u:r.VSBuffer.wrap(u),error:u=>this.restoreReadError(u,c,n)},u=>r.VSBuffer.concat(u))}readFileBuffered(t,c,i,n=Object.create(null)){const o=(0,r.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,c,o,u=>u,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:u=>this.restoreReadError(u,c,n)},i),o}readFileUnbuffered(t,c,i){const n=(0,y.newWriteableStream)(o=>r.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)?o=await t.readFile(c,{atomic:!0}):o=await t.readFile(c),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.validateReadFileLimits(c,o.byteLength,i),n.end(r.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(t,c){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new a.FileOperationError((0,m.localize)(9,null,this.resourceForError(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==a.ETAG_DISABLED&&c.etag===i.etag)throw new a.NotModifiedSinceFileOperationError((0,m.localize)(10,null),i,c);return this.validateReadFileLimits(t,i.size,c),i}validateReadFileLimits(t,c,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&c>i.limits.size&&(n=7),typeof n=="number")throw new a.TooLargeFileOperationError((0,m.localize)(11,null,this.resourceForError(t)),n,c,i)}}async canMove(t,c,i){return this.doCanMoveCopy(t,c,"move",i)}async canCopy(t,c,i){return this.doCanMoveCopy(t,c,"copy",i)}async doCanMoveCopy(t,c,i,n){if(t.toString()!==c.toString())try{const o=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(o,t,u,c,i,n)}catch(o){return o}return!0}async move(t,c,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),u=await this.doMoveCopy(n,t,o,c,"move",!!i),s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(t,u==="move"?2:3,s)),s}async copy(t,c,i){const n=await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),u=await this.doMoveCopy(n,t,o,c,"copy",!!i),s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(t,u==="copy"?3:2,s)),s}async doMoveCopy(t,c,i,n,o,u){if(c.toString()===n.toString())return o;const{exists:s,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(t,c,i,n,o,u);if(s&&!d&&u&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),o==="copy"){if(t===i&&(0,a.hasFileFolderCopyCapability)(t))await t.copy(c,n,{overwrite:u});else{const C=await this.resolve(c);C.isDirectory?await this.doCopyFolder(t,C,i,n):await this.doCopyFile(t,c,i,n)}return o}else return t===i?(await t.rename(c,n,{overwrite:u}),o):(await this.doMoveCopy(t,c,i,n,"copy",u),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(t,c,i,n){if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,c,i,n);if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,c,i,n);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,c,i,n);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,c,i,n)}async doCopyFolder(t,c,i,n){await i.mkdir(n),Array.isArray(c.children)&&await M.Promises.settled(c.children.map(async o=>{const u=this.getExtUri(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(t,await this.resolve(o.resource),i,u):this.doCopyFile(t,o.resource,i,u)}))}async doValidateMoveCopy(t,c,i,n,o,u){let s=!1;if(t===i){const{providerExtUri:C,isPathCaseSensitive:L}=this.getExtUri(t);if(L||(s=C.isEqual(c,n)),s&&o==="copy")throw new Error((0,m.localize)(12,null,this.resourceForError(c),this.resourceForError(n)));if(!s&&C.isEqualOrParent(n,c))throw new Error((0,m.localize)(13,null,this.resourceForError(c),this.resourceForError(n)))}const d=await this.exists(n);if(d&&!s){if(!u)throw new a.FileOperationError((0,m.localize)(14,null,this.resourceForError(c),this.resourceForError(n)),4);if(t===i){const{providerExtUri:C}=this.getExtUri(t);if(C.isEqualOrParent(c,n))throw new Error((0,m.localize)(15,null,this.resourceForError(c),this.resourceForError(n)))}}return{exists:d,isSameResourceWithDifferentPathCase:s}}getExtUri(t){const c=this.isPathCaseSensitive(t);return{providerExtUri:c?l.extUri:l.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(c,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(t,0,i)),i}async mkdirp(t,c){const i=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(c,n.dirname(c));)try{if(((await t.stat(c)).type&a.FileType.Directory)===0)throw new Error((0,m.localize)(16,null,this.resourceForError(c)));break}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(c)),c=n.dirname(c)}for(let o=i.length-1;o>=0;o--){c=n.joinPath(c,i[o]);try{await t.mkdir(c)}catch(u){if((0,a.toFileSystemProviderErrorCode)(u)!==a.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,c){try{await this.doValidateDelete(t,c)}catch(i){return i}return!0}async doValidateDelete(t,c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,m.localize)(17,null,this.resourceForError(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.throwIfFileIsReadonly(t,o);else throw new a.FileOperationError((0,m.localize)(18,null,this.resourceForError(t)),1);if(!!!c?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,m.localize)(19,null,this.resourceForError(t)))}return i}async del(t,c){const i=await this.doValidateDelete(t,c),n=!!c?.useTrash,o=!!c?.recursive;await i.delete(t,{recursive:o,useTrash:n}),this._onDidRunOperation.fire(new a.FileOperationEvent(t,1))}async cloneFile(t,c){const i=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(t,c))return;if(i===n&&(0,a.hasFileCloneCapability)(i))return i.cloneFile(t,c);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(c));const o=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===n&&(0,a.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,c,{overwrite:!0})):o.queue(()=>this.doCopyFile(i,t,n,c))}watch(t,c={recursive:!1,excludes:[]}){const i=new h.DisposableStore;let n=!1,o=()=>{n=!0};return i.add((0,h.toDisposable)(()=>o())),(async()=>{try{const u=await this.doWatch(t,c);n?(0,h.dispose)(u):o=()=>(0,h.dispose)(u)}catch(u){this.logService.error(u)}})(),i}async doWatch(t,c){const i=await this.withProvider(t),n=(0,P.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),c]);let o=this.activeWatchers.get(n);return o||(o={count:0,disposable:i.watch(t,c)},this.activeWatchers.set(n,o)),o.count+=1,(0,h.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,h.dispose)(o.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,h.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,c,i,n){return this.writeQueue.queueFor(c,this.getExtUri(t).providerExtUri).queue(async()=>{const o=await t.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(n)||(0,y.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,o,n):await this.doWriteReadableBufferedQueued(t,o,n)}catch(u){throw(0,a.ensureFileSystemProviderError)(u)}finally{await t.close(o)}})}async doWriteStreamBufferedQueued(t,c,i){let n=0,o;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=r.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,c,u,u.byteLength,n,0),n+=u.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((u,s)=>{(0,y.listenStream)(o,{onData:async d=>{o.pause();try{await this.doWriteBuffer(t,c,d,d.byteLength,n,0)}catch(C){return s(C)}n+=d.byteLength,setTimeout(()=>o.resume())},onError:d=>s(d),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(t,c,i){let n=0,o;for(;(o=i.read())!==null;)await this.doWriteBuffer(t,c,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(t,c,i,n,o,u){let s=0;for(;s<n;)s+=await t.write(c,o+s,i.buffer,u+s,n-s)}async doWriteUnbuffered(t,c,i,n){return this.writeQueue.queueFor(c,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,c,i,n))}async doWriteUnbufferedQueued(t,c,i,n){let o;n instanceof r.VSBuffer?o=n:(0,y.isReadableStream)(n)?o=await(0,r.streamToBuffer)(n):(0,y.isReadableBufferedStream)(n)?o=await(0,r.bufferedStreamToBuffer)(n):o=(0,r.readableToBuffer)(n),await t.writeFile(c,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(t,c,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,c,i,n))}async doPipeBufferedQueued(t,c,i,n){let o,u;try{o=await t.open(c,{create:!1}),u=await i.open(n,{create:!0,unlock:!1});const s=r.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,C=0,L=0;do L=await t.read(o,d,s.buffer,C,s.byteLength-C),await this.doWriteBuffer(i,u,s,L,d,C),d+=L,C+=L,C===s.byteLength&&(C=0);while(L>0)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await M.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async doPipeUnbuffered(t,c,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,c,i,n))}async doPipeUnbufferedQueued(t,c,i,n){return i.writeFile(n,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(t,c,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,c,i,n))}async doPipeUnbufferedToBufferedQueued(t,c,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const u=await t.readFile(c);await this.doWriteBuffer(i,o,r.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,a.ensureFileSystemProviderError)(u)}finally{await i.close(o)}}async doPipeBufferedToUnbuffered(t,c,i,n){const o=await(0,r.streamToBuffer)(this.readFileBuffered(t,c,R.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,o)}throwIfFileSystemIsReadonly(t,c){if(t.capabilities&2048)throw new a.FileOperationError((0,m.localize)(20,null,this.resourceForError(c)),6);return t}throwIfFileIsReadonly(t,c){if((c.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,m.localize)(21,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};E=we([X(0,p.ILogService)],E),e.FileService=E}),define(Z[91],ee([0,1,41,290,7,35,17,3,32,2,9,4,19,59,23,174,16,114,213,44,209,208]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,M.gracefulify)(I)}catch(c){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(c)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new R.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,v.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await y.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await y.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async u=>{try{let s;u.isSymbolicLink()?s=(await this.stat((0,S.joinPath)(i,u.name))).type:s=this.toType(u),o.push([u.name,s])}catch(s){this.logService.trace(s)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=a.FileType.Unknown:i.isFile()?o=a.FileType.File:i.isDirectory()?o=a.FileType.Directory:o=a.FileType.Unknown,n&&(o|=a.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const u=new r.Barrier;return this.resourceLocks.set(i,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,h.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const u=this.toFilePath(i);return await y.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,o){const u=(0,l.newWriteableStream)(s=>D.VSBuffer.concat(s.map(d=>D.VSBuffer.wrap(d))).buffer);return(0,f.readFileIntoStream)(this,i,u,s=>s.buffer,{...n,bufferSize:256*1024},o),u}async writeFile(i,n,o){let u;try{const s=this.toFilePath(i);if(!o.create||!o.overwrite){if(await y.Promises.exists(s)){if(!o.overwrite)throw(0,a.createFileSystemProviderError)((0,m.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,a.createFileSystemProviderError)((0,m.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,n,0,n.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(i,s)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,n){const o=this.toFilePath(i);let u;(0,a.isFileOpenForWriteOptions)(n)&&(u=await this.createResourceLock(i));let s;try{if((0,a.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:C}=await y.SymlinkSupport.stat(o);C.mode&128||await y.Promises.chmod(o,C.mode|128)}catch(C){this.logService.trace(C)}let d;if((0,a.isFileOpenForWriteOptions)(n)){if(v.isWindows)try{await y.Promises.truncate(o,0),d="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}d||(d="w")}else d="r";s=await y.Promises.open(o,d)}catch(d){throw u?.dispose(),(0,a.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(s,0),(0,a.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(s,i),u){const d=this.mapHandleToLock.get(s);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${o})`),this.mapHandleToLock.set(s,u),d&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${o})`),d.dispose())}return s}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await y.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.logService.error(o)}return await y.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,u,s){const d=this.normalizePos(i,n);let C=null;try{C=(await y.Promises.read(i,o,u,s,d)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(i,d,C)}return C}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const u=this.mapHandleToPos.get(i);typeof u=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,u+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,u,s){return(0,r.retry)(()=>this.doWrite(i,n,o,u,s),100,3)}async doWrite(i,n,o,u,s){const d=this.normalizePos(i,n);let C=null;try{C=(await y.Promises.write(i,o,u,s,d)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),L)}finally{this.updatePos(i,d,C)}return C}async mkdir(i){try{await y.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await y.Promises.rm(o,y.RimRafMode.MOVE):await y.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const u=this.toFilePath(i),s=this.toFilePath(n);if(u!==s)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await y.Promises.move(u,s)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,m.localize)(2,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(s)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(i,n,o){const u=this.toFilePath(i),s=this.toFilePath(n);if(u!==s)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await y.Promises.copy(u,s,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,m.localize)(3,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(s)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(i,n,o,u){const s=this.toFilePath(i),d=this.toFilePath(n);let C=!1;if(!!(this.capabilities&1024)||(C=(0,g.isEqual)(s,d,!0)),C&&o==="copy")throw(0,a.createFileSystemProviderError)((0,m.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!C&&await y.Promises.exists(d)){if(!u)throw(0,a.createFileSystemProviderError)((0,m.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const u=this.toFilePath(i),s=this.toFilePath(n),d=!!(this.capabilities&1024);if((0,g.isEqual)(u,s,!d))return;const C=new h.DisposableStore;try{const[L,O]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);C.add(L),C.add(O),o&&await y.Promises.mkdir((0,w.dirname)(s),{recursive:!0}),await y.Promises.copyFile(u,s)}catch(L){if(L.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(L)}finally{C.dispose()}}createUniversalWatcher(i,n,o){return new E.UniversalWatcherClient(u=>i(u),u=>n(u),o)}createNonRecursiveWatcher(i,n,o){return new k.NodeJSWatcherClient(u=>i(u),u=>n(u),o)}toFileSystemProviderError(i){if(i instanceof a.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=a.FileSystemProviderErrorCode.NoPermissions;break;default:n=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await y.SymlinkSupport.stat(this.toFilePath(i));u.mode&128||(o=(0,a.createFileSystemProviderError)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0,e.DiskFileSystemProvider=t}),define(Z[215],ee([0,1,3,91,2,17,59,22]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends r.Disposable{constructor(v,S){super(),this.provider=v,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(v,S,l){const y=this.getUriTransformer(v);switch(S){case"stat":return this.stat(y,l[0]);case"readdir":return this.readdir(y,l[0]);case"open":return this.open(y,l[0],l[1]);case"close":return this.close(l[0]);case"read":return this.read(l[0],l[1],l[2]);case"readFile":return this.readFile(y,l[0],l[1]);case"write":return this.write(l[0],l[1],l[2],l[3],l[4]);case"writeFile":return this.writeFile(y,l[0],l[1],l[2]);case"rename":return this.rename(y,l[0],l[1],l[2]);case"copy":return this.copy(y,l[0],l[1],l[2]);case"cloneFile":return this.cloneFile(y,l[0],l[1]);case"mkdir":return this.mkdir(y,l[0]);case"delete":return this.delete(y,l[0],l[1]);case"watch":return this.watch(y,l[0],l[1],l[2],l[3]);case"unwatch":return this.unwatch(l[0],l[1])}throw new Error(`IPC Command ${S} not found`)}listen(v,S,l){const y=this.getUriTransformer(v);switch(S){case"fileChange":return this.onFileChange(y,l[0]);case"readFileStream":return this.onReadFileStream(y,l[0],l[1])}throw new Error(`Unknown event ${S}`)}stat(v,S){const l=this.transformIncoming(v,S,!0);return this.provider.stat(l)}readdir(v,S){const l=this.transformIncoming(v,S);return this.provider.readdir(l)}async readFile(v,S,l){const y=this.transformIncoming(v,S,!0),m=await this.provider.readFile(y,l);return R.VSBuffer.wrap(m)}onReadFileStream(v,S,l){const y=this.transformIncoming(v,S,!0),m=new P.CancellationTokenSource,a=new I.Emitter({onDidRemoveLastListener:()=>{m.cancel()}}),f=this.provider.readFileStream(y,l,m.token);return(0,D.listenStream)(f,{onData:p=>a.fire(R.VSBuffer.wrap(p)),onError:p=>a.fire(p),onEnd:()=>{a.fire("end"),a.dispose(),m.dispose()}}),a.event}writeFile(v,S,l,y){const m=this.transformIncoming(v,S);return this.provider.writeFile(m,l.buffer,y)}open(v,S,l){const y=this.transformIncoming(v,S,!0);return this.provider.open(y,l)}close(v){return this.provider.close(v)}async read(v,S,l){const y=R.VSBuffer.alloc(l),m=0,a=await this.provider.read(v,S,y.buffer,m,l);return[y,a]}write(v,S,l,y,m){return this.provider.write(v,S,l.buffer,y,m)}mkdir(v,S){const l=this.transformIncoming(v,S);return this.provider.mkdir(l)}delete(v,S,l){const y=this.transformIncoming(v,S);return this.provider.delete(y,l)}rename(v,S,l,y){const m=this.transformIncoming(v,S),a=this.transformIncoming(v,l);return this.provider.rename(m,a,y)}copy(v,S,l,y){const m=this.transformIncoming(v,S),a=this.transformIncoming(v,l);return this.provider.copy(m,a,y)}cloneFile(v,S,l){const y=this.transformIncoming(v,S),m=this.transformIncoming(v,l);return this.provider.cloneFile(y,m)}onFileChange(v,S){const l=new I.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(v,l))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return l.event}async watch(v,S,l,y,m){const a=this.sessionToWatcher.get(S);if(a){const f=this.transformIncoming(v,y),p=a.watch(l,f,m);this.watchRequests.set(S+l,p)}}async unwatch(v,S){const l=v+S,y=this.watchRequests.get(l);y&&((0,r.dispose)(y),this.watchRequests.delete(l))}dispose(){super.dispose();for(const[,v]of this.watchRequests)v.dispose();this.watchRequests.clear();for(const[,v]of this.sessionToWatcher)v.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class h extends r.Disposable{constructor(v,S,l,y){super(),this.uriTransformer=v,this.logService=l,this.environmentService=y,this.watcherRequests=new Map,this.fileWatcher=this._register(new M.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(v){const S=this._register(new I.Emitter);this._register(S.event(l=>{v.fire(l.map(y=>({resource:this.uriTransformer.transformOutgoingURI(y.resource),type:y.type})))})),this._register(this.fileWatcher.onDidChangeFile(l=>S.fire(l))),this._register(this.fileWatcher.onDidWatchError(l=>v.fire(l)))}getRecursiveWatcherOptions(v){}getExtraExcludes(v){}watch(v,S,l){const y=this.getExtraExcludes(this.environmentService);return Array.isArray(y)&&(l.excludes=[...l.excludes,...y]),this.watcherRequests.set(v,this.fileWatcher.watch(S,l)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(v)),this.watcherRequests.delete(v)})}dispose(){super.dispose();for(const[,v]of this.watcherRequests)v.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=h}),define(Z[216],ee([0,1,15,173,4,8,16,9,215,151]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class w extends g.AbstractDiskFileSystemProviderChannel{constructor(l,y,m){super(l,y),this.environmentService=m}getUriTransformer(l){return h.DefaultURITransformer}transformIncoming(l,y){return R.URI.revive(y)}async delete(l,y,m){if(!m.useTrash)return super.delete(l,y,m);const a=this.transformIncoming(l,y),f=(0,P.normalize)(a.fsPath);try{await I.shell.trashItem(f)}catch{throw(0,D.createFileSystemProviderError)(r.isWindows?(0,M.localize)(0,null,(0,P.basename)(f)):(0,M.localize)(1,null,(0,P.basename)(f)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(l,y){return new v(l,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=w;class v extends g.AbstractSessionFileWatcher{watch(l,y,m){if(m.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(l,y,m)}}}),define(Z[217],ee([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class M extends I.AbstractMessageLogger{constructor(R=I.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(R),this._register(this.onDidChangeLogLevel(D=>{this._logger?.setLevel(D)}))}set logger(R){this._logger=R;for(const{level:D,message:P}of this.buffer)(0,I.log)(R,D,P);this.buffer=[]}log(R,D){this._logger?(0,I.log)(this._logger,R,D):this.getLevel()<=R&&this.buffer.push({level:R,message:D})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=M}),define(Z[218],ee([0,1,2,5]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends I.Disposable{constructor(D,P=[]){super(),this.logger=new M.MultiplexLogger([D,...P]),this._register(D.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(D){this.logger.setLevel(D)}getLevel(){return this.logger.getLevel()}trace(D,...P){this.logger.trace(D,...P)}debug(D,...P){this.logger.debug(D,...P)}info(D,...P){this.logger.info(D,...P)}warn(D,...P){this.logger.warn(D,...P)}error(D,...P){this.logger.error(D,...P)}flush(){this.logger.flush()}}e.LogService=r}),define(Z[219],ee([0,1,35,8,5]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class R{constructor(P){this.loggerService=P,this.loggers=new I.ResourceMap}listen(P,g,h){switch(g){case"onDidChangeLoggers":return h?this.loggerService.getOnDidChangeLoggersEvent(h):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return h?this.loggerService.getOnDidChangeLogLevelEvent(h):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return h?this.loggerService.getOnDidChangeVisibilityEvent(h):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(P,g,h){switch(g){case"createLogger":this.createLogger(M.URI.revive(h[0]),h[1],h[2]);return;case"log":return this.log(M.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1]);case"setLogLevel":return(0,r.isLogLevel)(h[0])?this.loggerService.setLogLevel(h[0]):this.loggerService.setLogLevel(M.URI.revive(h[0]),h[1]);case"setVisibility":return this.loggerService.setVisibility(M.URI.revive(h[0]),h[1]);case"registerLogger":return this.loggerService.registerLogger({...h[0],resource:M.URI.revive(h[0].resource)},h[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(M.URI.revive(h[0]))}throw new Error(`Call not found: ${g}`)}createLogger(P,g,h){this.loggers.set(P,this.loggerService.createLogger(P,g,h))}consoleLog(P,g){let h=console.log;switch(P){case r.LogLevel.Error:h=console.error;break;case r.LogLevel.Warning:h=console.warn;break;case r.LogLevel.Info:h=console.info;break}h.call(console,...g)}log(P,g){const h=this.loggers.get(P);if(!h)throw new Error("Create the logger before logging");for(const[w,v]of g)(0,r.log)(h,w,v)}}e.LoggerChannel=R}),define(Z[220],ee([0,1,16,5]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(r||(r={}));async function R(h,w,v,S,l){try{const y=await new Promise((a,f)=>{x(["spdlog"],a,f)});y.setFlushOn(r.Trace);const m=await y.createAsyncRotatingLogger(h,w,v,S);return l?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(y){console.error(y)}return null}function D(h,w,v){switch(w){case M.LogLevel.Trace:h.trace(v);break;case M.LogLevel.Debug:h.debug(v);break;case M.LogLevel.Info:h.info(v);break;case M.LogLevel.Warning:h.warn(v);break;case M.LogLevel.Error:h.error(v);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function P(h,w){switch(w){case M.LogLevel.Trace:h.setLevel(r.Trace);break;case M.LogLevel.Debug:h.setLevel(r.Debug);break;case M.LogLevel.Info:h.setLevel(r.Info);break;case M.LogLevel.Warning:h.setLevel(r.Warning);break;case M.LogLevel.Error:h.setLevel(r.Error);break;case M.LogLevel.Off:h.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class g extends M.AbstractMessageLogger{constructor(w,v,S,l,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(w,v,S,l),this._register(this.onDidChangeLogLevel(m=>{this._logger&&P(this._logger,m)}))}async _createSpdLogLogger(w,v,S,l){const y=S?6:1,m=30/y*I.ByteSize.MB,a=await R(w,v,m,y,l);if(a){this._logger=a,P(this._logger,this.getLevel());for(const{level:f,message:p}of this.buffer)D(this._logger,f,p);this.buffer=[]}}log(w,v){this._logger?D(this._logger,w,v):this.getLevel()<=w&&this.buffer.push({level:w,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=g}),define(Z[221],ee([0,1,31,5,220]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends M.AbstractLoggerService{doCreateLogger(P,g,h){return new r.SpdLogLogger((0,I.generateUuid)(),P.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,g)}}e.LoggerService=R}),define(Z[65],ee([0,1,35,3,6,5,221]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(R.ILoggerService);class P extends D.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new I.ResourceMap}createLogger(h,w,v){v!==void 0&&this.loggerResourcesByWindow.set(h,v);try{return super.createLogger(h,w)}catch(S){throw this.loggerResourcesByWindow.delete(h),S}}registerLogger(h,w){w!==void 0&&this.loggerResourcesByWindow.set(h.resource,w),super.registerLogger(h)}deregisterLogger(h){this.loggerResourcesByWindow.delete(h),super.deregisterLogger(h)}getRegisteredLoggers(h){const w=[];for(const v of super.getRegisteredLoggers())h===this.loggerResourcesByWindow.get(v.resource)&&w.push(v);return w}getOnDidChangeLogLevelEvent(h){return M.Event.filter(this.onDidChangeLogLevel,w=>(0,R.isLogLevel)(w)||this.isInterestedLoggerResource(w[0],h))}getOnDidChangeVisibilityEvent(h){return M.Event.filter(this.onDidChangeVisibility,([w])=>this.isInterestedLoggerResource(w,h))}getOnDidChangeLoggersEvent(h){return M.Event.filter(M.Event.map(this.onDidChangeLoggers,w=>({added:[...w.added].filter(S=>this.isInterestedLoggerResource(S.resource,h)),removed:[...w.removed].filter(S=>this.isInterestedLoggerResource(S.resource,h))})),w=>w.added.length>0||w.removed.length>0)}deregisterLoggers(h){for(const[w,v]of this.loggerResourcesByWindow)v===h&&this.deregisterLogger(w)}isInterestedLoggerResource(h,w){const v=this.loggerResourcesByWindow.get(h);return v===void 0||v===w}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=P}),define(Z[222],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function M(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function r(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function R(D){return!I(D)&&!M(D)&&!r(D)}e.isMenubarMenuItemAction=R}),define(Z[38],ee([0,1,3,70,2,6]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(h){const w=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...h,...this.policyDefinitions},w!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(h),M.Iterable.reduce(this.policies.entries(),(v,[S,l])=>({...v,[S]:l}),{})}getPolicyValue(h){return this.policies.get(h)}serialize(){return M.Iterable.reduce(Object.entries(this.policyDefinitions),(h,[w,v])=>({...h,[w]:{definition:v,value:this.policies.get(w)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(Z[223],ee([0,1,7,3,70,10,16,5,38]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function h(v,S){const l=[];for(const y of new Set(r.Iterable.concat(v.keys(),S.keys())))v.get(y)!==S.get(y)&&l.push(y);return l}let w=class extends g.AbstractPolicyService{constructor(S,l,y){super(),this.file=S,this.fileService=l,this.logService=y,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const m=M.Event.filter(l.onDidFilesChange,a=>a.affects(S));this._register(l.watch(S)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const S=new Map;try{const l=await this.fileService.readFile(this.file),y=JSON.parse(l.value.toString());if(!(0,R.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(y))this.policyDefinitions[m]&&S.set(m,y[m])}catch(l){l.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",l)}return S}async refresh(){const S=await this.read(),l=h(this.policies,S);this.policies=S,l.length>0&&this._onDidChange.fire(l)}};w=we([X(1,D.IFileService),X(2,P.ILogService)],w),e.FilePolicyService=w}),define(Z[224],ee([0,1,3,2,38]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(g){this.service=g,this.disposables=new M.DisposableStore}listen(g,h){switch(h){case"onDidChange":return I.Event.map(this.service.onDidChange,w=>w.reduce((v,S)=>({...v,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${h}`)}call(g,h,w){switch(h){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(w)}throw new Error(`Call not found: ${h}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends r.AbstractPolicyService{constructor(g,h){super(),this.channel=h;for(const w in g){const{definition:v,value:S}=g[w];this.policyDefinitions[w]=v,S!==void 0&&this.policies.set(w,S)}this.channel.listen("onDidChange")(w=>{for(const v in w){const S=w[v];S===null?this.policies.delete(v):this.policies.set(v,S)}this._onDidChange.fire(Object.keys(w))})}async _updatePolicyDefinitions(g){const h=await this.channel.call("updatePolicyDefinitions",g);for(const w in h)this.policies.set(w,h[w])}}e.PolicyChannelClient=D}),define(Z[225],ee([0,1,38,7,291,2,5]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends I.AbstractPolicyService{constructor(h,w){super(),this.logService=h,this.productName=w,this.throttler=new M.Throttler,this.watcher=this._register(new R.MutableDisposable)}async _updatePolicyDefinitions(h){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`),await this.throttler.queue(()=>new Promise((w,v)=>{try{this.watcher.value=(0,r.createWatcher)(this.productName,h,S=>{this._onDidPolicyChange(S),w()})}catch(S){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),v(S)}}))}_onDidPolicyChange(h){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const w in h){const v=h[w];v===void 0?this.policies.delete(w):this.policies.set(w,v)}this._onDidChange.fire(Object.keys(h))}};P=we([X(0,D.ILogService)],P),e.NativePolicyService=P}),define(Z[66],ee([0,1,14,4,36,109]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof M.globals.vscode<"u"&&typeof M.globals.vscode.context<"u"){const P=M.globals.vscode.context.configuration();if(P)D=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){D=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:P,searchUrl:g,itemUrl:h,controlUrl:w}=D.extensionsGallery||{};Object.assign(D,{extensionsGallery:{serviceUrl:r.env.VSCODE_GALLERY_SERVICE_URL||P,searchUrl:r.env.VSCODE_GALLERY_SEARCH_URL||g,itemUrl:r.env.VSCODE_GALLERY_ITEM_URL||h,controlUrl:r.env.VSCODE_GALLERY_CONTROL_URL||w}});try{const v=(...m)=>m.reduce((a,f)=>(Object.keys(f).forEach(p=>{Array.isArray(a[p])&&Array.isArray(f[p])?a[p]=f[p]:typeof a[p]=="object"&&typeof f[p]=="object"?a[p]=v(a[p],f[p]):a[p]=f[p]}),a),{}),S=(0,R.getUserDataPath)({},D.nameShort),l=M.isWindows?`file:///${S}/product.json`:`file://${S}/product.json`,y=x.__$__nodeRequire(I.FileAccess.asFileUri(l).fsPath);D=v(D,y)}catch{}if(r.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const v=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:v.version,release:v.release})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(Z[21],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[226],ee([0,1,82,5,21]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(P,g){this.productService=P,this.logService=g,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,g){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const h=/^(.*)#([^#]+)$/.exec(g);if(!h)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,w,v]=h;let S=this.trustedExtensionUrlPublicKeys.get(P);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[P],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...S])}const l=Buffer.from(decodeURIComponent(v),"base64");if(l.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const y=l.slice(0,6),m=l.readUIntBE(0,6),a=Date.now()-m;if(a<0||a>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const f=l.slice(6),p=I.createVerify("SHA256");p.write(y),p.write(Buffer.from(w)),p.end();for(let b=0;b<S.length;b++){let E=S[b];if(E!==null){if(typeof E=="string")try{E=I.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),S[b]=E}catch(k){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${b+1} for ${P}:`,k),S[b]=null;continue}if(p.verify(E,f))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};R=we([X(0,r.IProductService),X(1,M.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[227],ee([0,1,7,5]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(D,P,g){this._window=D,this._sessionId=P,this._logService=g}async inspect(D){await this._connect();const P=this._window.webContents.debugger;await P.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,I.timeout)(D);const g=await P.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),g.profile}async _connect(){const D=this._window.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async _disconnect(){const D=this._window.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};r=we([X(2,M.ILogService)],r),e.WindowProfiler=r}),define(Z[67],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(Z[51],ee([0,1,129,10]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(D,P){I.ok(M.isString(D)),I.ok(M.isObject(P)),I.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new r}),define(Z[228],ee([0,1,3,51]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,h){this.schemasById[r(g)]=h,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;M.Registry.add(e.Extensions.JSONContribution,D)}),define(Z[68],ee([0,1,25,3,10,160,18,228,51]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=g.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=new Set;this.doRegisterConfigurations(t,c,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const c=new Set;this.doDeregisterConfigurations(t,c),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=new Set;this.doDeregisterConfigurations(c,i),this.doRegisterConfigurations(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const c=new Set;this.doRegisterDefaultConfigurations(t,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,c){const i=[];for(const{overrides:n,source:o}of t)for(const u in n)if(c.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const s=this.configurationDefaultsOverrides.get(u),d=s?.valuesSources??new Map;if(o)for(const F of Object.keys(n[u]))d.set(F,o);const C={...s?.value||{},...n[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:C,valuesSources:d});const L=(0,D.getLanguageTagSettingPlainKey)(u),O={type:"object",default:C,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:r.isString(o)?void 0:o,defaultValueSource:o};i.push(...m(u)),this.configurationProperties[u]=O,this.defaultLanguageConfigurationOverridesNode.properties[u]=O}else{this.configurationDefaultsOverrides.set(u,{value:n[u],source:o});const s=this.configurationProperties[u];s&&(this.updatePropertyDefaultValue(u,s),this.updateSchema(u,s))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const c=new Set;this.doDeregisterDefaultConfigurations(t,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,c){for(const{overrides:i,source:n}of t)for(const o in i){const u=this.configurationDefaultsOverrides.get(o),s=r.isString(n)?n:n?.id,d=r.isString(u?.source)?u?.source:u?.source?.id;if(s===d)if(c.add(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const C=this.configurationProperties[o];C&&(this.updatePropertyDefaultValue(o,C),this.updateSchema(o,C))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let c=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),c=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),c=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const c of t)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,c,i){t.forEach(n=>{this.validateAndRegisterProperties(n,c,n.extensionInfo,n.restrictedProperties,void 0,i),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,c){const i=n=>{if(n.properties)for(const o in n.properties){c.add(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of t){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}}validateAndRegisterProperties(t,c=!0,i,n,o=3,u){o=r.isUndefinedOrNull(t.scope)?o:t.scope;const s=t.properties;if(s)for(const C in s){const L=s[C];if(c&&b(C,L)){delete s[C];continue}if(L.source=i,L.defaultDefaultValue=s[C].default,this.updatePropertyDefaultValue(C,L),e.OVERRIDE_PROPERTY_REGEX.test(C)?L.scope=void 0:(L.scope=r.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=r.isUndefinedOrNull(L.restricted)?!!n?.includes(C):L.restricted),s[C].hasOwnProperty("included")&&!s[C].included){this.excludedConfigurationProperties[C]=s[C],delete s[C];continue}else this.configurationProperties[C]=s[C],s[C].policy?.name&&this.policyConfigurations.set(s[C].policy.name,C);!s[C].deprecationMessage&&s[C].markdownDeprecationMessage&&(s[C].deprecationMessage=s[C].markdownDeprecationMessage),u.add(C)}const d=t.allOf;if(d)for(const C of d)this.validateAndRegisterProperties(C,c,i,n,o,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const c=i=>{const n=i.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);i.allOf?.forEach(c)};c(t)}updateSchema(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.resourceLanguageSettingsSchema.properties[t]=c;break}}removeFromSchema(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const c=`[${t}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,c){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,o=i?.source;r.isUndefined(n)&&(n=c.defaultDefaultValue,o=void 0),r.isUndefined(n)&&(n=f(c.type)),c.default=n,c.defaultValueSource=o}}const l="\\[([^\\]]+)\\]",y=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(k){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let c=y.exec(k);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=y.exec(k)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=m;function a(k){return k.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=a;function f(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new S;g.Registry.add(e.Extensions.Configuration,p);function b(k,t){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?R.localize(7,null,k):p.getConfigurationProperties()[k]!==void 0?R.localize(8,null,k):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,k,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function E(){const k=[],t=p.getConfigurationProperties();for(const c of Object.keys(t))k.push([c,t[c].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=E}),define(Z[115],ee([0,1,25,3,43,2,35,37,10,8,18,68,51]),function(x,e,I,M,r,R,D,P,g,h,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function l(c){return Object.isFrozen(c)?c:P.deepFreeze(c)}class y{constructor(i={},n=[],o=[],u){this._contents=i,this._keys=n,this._overrides=o,this.raw=u,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof y)return n;const o=new m("");return o.parseRaw(n),o.configurationModel});this._rawConfiguration=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,w.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const o=this.rawConfiguration.getValue(i),u=n?this.rawConfiguration.getOverrideValue(i,n):void 0,s=n?this.rawConfiguration.override(n).getValue(i):o;return{value:o,override:u,merged:s}}getOverrideValue(i,n){const o=this.getContentsForOverrideIdentifer(n);return o?i?(0,w.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return I.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=P.deepClone(this.contents),o=P.deepClone(this.overrides),u=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const d of i)if(s.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.mergeContents(n,d.contents);for(const C of d.overrides){const[L]=o.filter(O=>I.equals(O.identifiers,C.identifiers));L?(this.mergeContents(L.contents,C.contents),L.keys.push(...C.keys),L.keys=I.distinct(L.keys)):o.push(P.deepClone(C))}for(const C of d.keys)u.indexOf(C)===-1&&u.push(C)}return new y(n,u,o,s.every(d=>d instanceof y)?void 0:s)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const u of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[u];const d=n[u];d&&(typeof s=="object"&&typeof d=="object"?(s=P.deepClone(s),this.mergeContents(s,d)):s=d),o[u]=s}return new y(o,this.keys,this.overrides)}mergeContents(i,n){for(const o of Object.keys(n)){if(o in i&&g.isObject(i[o])&&g.isObject(n[o])){this.mergeContents(i[o],n[o]);continue}i[o]=P.deepClone(n[o])}}getContentsForOverrideIdentifer(i){let n=null,o=null;const u=s=>{s&&(o?this.mergeContents(o,s):o=P.deepClone(s))};for(const s of this.overrides)I.equals(s.identifiers,[i])?n=s.contents:s.identifiers.includes(i)&&u(s.contents);return u(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,w.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>I.equals(o.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,o){(0,w.addToValueTree)(this.contents,i,n,u=>console.error(u)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,w.toValuesTree)(this.contents[i],u=>console.error(u))})}}e.ConfigurationModel=y;class m{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!g.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:o,keys:u,overrides:s,restricted:d,hasExcludedProperties:C}=this.doParseRaw(i,n);this._configurationModel=new y(o,u,s,C?[i]:void 0),this._restrictedConfigurations=d||[]}doParseContent(i){let n={},o=null,u=[];const s=[],d=[];function C(O){Array.isArray(u)?u.push(O):o!==null&&(u[o]=O)}const L={onObjectBegin:()=>{const O={};C(O),s.push(u),u=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{u=s.pop()},onArrayBegin:()=>{const O=[];C(O),s.push(u),u=O,o=null},onArrayEnd:()=>{u=s.pop()},onLiteralValue:C,onError:(O,F,z)=>{d.push({error:O,offset:F,length:z})}};if(i)try{r.visit(i,L),n=u[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(i,n){const o=S.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),u=this.filter(i,o,!0,n);i=u.raw;const s=(0,w.toValuesTree)(i,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),d=Object.keys(i),C=this.toOverrides(i,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:s,keys:d,overrides:C,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(i,n,o,u){let s=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const d={},C=[];for(const L in i)if(v.OVERRIDE_PROPERTY_REGEX.test(L)&&o){const O=this.filter(i[L],n,!1,u);d[L]=O.raw,s=s||O.hasExcludedProperties,C.push(...O.restricted)}else{const O=n[L],F=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&C.push(L),(F===void 0||u.scopes===void 0||u.scopes.includes(F))&&!(u.skipRestricted&&O?.restricted)?d[L]=i[L]:s=!0}return{raw:d,restricted:C,hasExcludedProperties:s}}toOverrides(i,n){const o=[];for(const u of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(u)){const s={};for(const d in i[u])s[d]=i[u][d];o.push({identifiers:(0,v.overrideIdentifiersFromKey)(u),keys:Object.keys(s),contents:(0,w.toValuesTree)(s,n)})}return o}}e.ConfigurationModelParser=m;class a extends R.Disposable{constructor(i,n,o,u){super(),this.userSettingsResource=i,this.scopes=n,this.fileService=u,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.any(M.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),M.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&o.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class f{constructor(i,n,o,u,s,d,C,L,O,F,z,q,ie){this.key=i,this.overrides=n,this._value=o,this.overrideIdentifiers=u,this.defaultConfiguration=s,this.policyConfiguration=d,this.applicationConfiguration=C,this.userConfiguration=L,this.localUserConfiguration=O,this.remoteUserConfiguration=F,this.workspaceConfiguration=z,this.folderConfigurationModel=q,this.memoryConfigurationModel=ie}get value(){return l(this._value)}inspect(i,n,o){const u=i.inspect(n,o);return{get value(){return l(u.value)},get override(){return l(u.override)},get merged(){return l(u.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class p{constructor(i,n,o,u,s=new y,d=new y,C=new D.ResourceMap,L=new y,O=new D.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=o,this._localUserConfiguration=u,this._remoteUserConfiguration=s,this._workspaceConfiguration=d,this._folderConfigurations=C,this._memoryConfiguration=L,this._memoryConfigurationByResource=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,n,o){return this.getConsolidatedConfigurationModel(i,n,o).getValue(i)}updateValue(i,n,o={}){let u;o.resource?(u=this._memoryConfigurationByResource.get(o.resource),u||(u=new y,this._memoryConfigurationByResource.set(o.resource,u))):u=this._memoryConfiguration,n===void 0?u.removeValue(i):u.setValue(i,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,o){const u=this.getConsolidatedConfigurationModel(i,n,o),s=this.getFolderConfigurationModelForResource(n.resource,o),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,C=new Set;for(const L of u.overrides)for(const O of L.identifiers)u.getOverrideValue(i,O)!==void 0&&C.add(O);return new f(i,n,u.getValue(i),C.size?[...C]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,s||void 0,d)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:u,updated:s,removed:d}=k(this._defaultConfiguration,i);n=[...u,...s,...d]}for(const u of n)for(const s of(0,v.overrideIdentifiersFromKey)(u)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(s),C=i.getKeysForOverrideIdentifier(s),L=[...C.filter(O=>d.indexOf(O)===-1),...d.filter(O=>C.indexOf(O)===-1),...d.filter(O=>!P.equals(this._defaultConfiguration.override(s).getValue(O),i.override(s).getValue(O)))];o.push([s,L])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:u}=k(this._policyConfiguration,i),s=[...n,...o,...u];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:u,overrides:s}=k(this.applicationConfiguration,i),d=[...n,...o,...u];return d.length&&this.updateApplicationConfiguration(i),{keys:d,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:u,overrides:s}=k(this.localUserConfiguration,i),d=[...n,...o,...u];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:u,overrides:s}=k(this.remoteUserConfiguration,i),d=[...n,...o,...u];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:u,overrides:s}=k(this.workspaceConfiguration,i),d=[...n,...o,...u];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:s}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:u,updated:s,removed:d,overrides:C}=k(o,n),L=[...u,...s,...d];return(L.length||!o)&&this.updateFolderConfiguration(i,n),{keys:L,overrides:C}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:u,removed:s,overrides:d}=k(n,void 0);return{keys:[...o,...u,...s],overrides:d}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,o){let u=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier&&(u=u.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:i},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const u=n.getFolder(i);u&&(o=this.getFolderConsolidatedConfiguration(u.uri)||o);const s=this._memoryConfigurationByResource.get(i);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(i);u?(n=o.merge(u),this._foldersConsolidatedConfigurations.set(i,n)):n=o}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:o,overrides:u,keys:s}=this._folderConfigurations.get(n);return i.push([n,{contents:o,overrides:u,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(u=>n.add(u))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.policy),u=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),d=this.parseConfigurationModel(i.workspace),C=i.folders.reduce((L,O)=>(L.set(h.URI.revive(O[0]),this.parseConfigurationModel(O[1])),L),new D.ResourceMap);return new p(n,o,u,s,new y,d,C,new y,new D.ResourceMap)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides)}}e.Configuration=p;function b(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,n=new Map;for(const u of c)u.keys.forEach(s=>i.add(s)),u.overrides.forEach(([s,d])=>{const C=(0,D.getOrSet)(n,s,new Set);d.forEach(L=>C.add(L))});const o=[];return n.forEach((u,s)=>o.push([s,[...u.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=b;class E{constructor(i,n,o,u){this.change=i,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=u,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const d of s)this.affectedKeys.add(d);this._affectsConfigStr=this._marker;for(const s of this.affectedKeys)this._affectsConfigStr+=s+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){const o=this._marker+i,u=this._affectsConfigStr.indexOf(o);if(u<0)return!1;const s=u+o.length;if(s>=this._affectsConfigStr.length)return!1;const d=this._affectsConfigStr.charCodeAt(s);if(d!==this._markerCode1&&d!==this._markerCode2)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,L=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!P.equals(C,L)}return!0}}e.ConfigurationChangeEvent=E;function k(c,i){const{added:n,removed:o,updated:u}=t(i?.rawConfiguration,c?.rawConfiguration),s=[],d=c?.getAllOverrideIdentifiers()||[],C=i?.getAllOverrideIdentifiers()||[];if(i){const L=C.filter(O=>!d.includes(O));for(const O of L)s.push([O,i.getKeysForOverrideIdentifier(O)])}if(c){const L=d.filter(O=>!C.includes(O));for(const O of L)s.push([O,c.getKeysForOverrideIdentifier(O)])}if(i&&c){for(const L of d)if(C.includes(L)){const O=t({contents:c.getOverrideValue(void 0,L)||{},keys:c.getKeysForOverrideIdentifier(L)},{contents:i.getOverrideValue(void 0,L)||{},keys:i.getKeysForOverrideIdentifier(L)});s.push([L,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:o,updated:u,overrides:s}}function t(c,i){const n=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],o=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],u=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const d=(0,w.getConfigurationValue)(i.contents,s),C=(0,w.getConfigurationValue)(c.contents,s);P.equals(d,C)||u.push(s)}}return{added:n,removed:o,updated:u}}}),define(Z[229],ee([0,1,25,3,2,37,10,115,68,5,38,51]),function(x,e,I,M,r,R,D,P,g,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new M.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(v.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(a),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(a,f){this.updateConfigurationModel(a,v.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:a})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new P.ConfigurationModel;const a=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(a),a)}updateConfigurationModel(a,f){const p=this.getConfigurationDefaultOverrides();for(const b of a){const E=p[b],k=f[b];E!==void 0?this._configurationModel.addValue(b,E):k?this._configurationModel.addValue(b,k.default):this._configurationModel.removeValue(b)}}}e.DefaultConfiguration=S;class l{constructor(){this.onDidChangeConfiguration=M.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=l;let y=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(a,f,p){super(),this.defaultConfiguration=a,this.policyService=f,this.logService=p,this._onDidChangeConfiguration=this._register(new M.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(a=>this.onDidChangePolicies(a))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:a})=>this.update(await this.updatePolicyDefinitions(a),!0))),this._configurationModel}async updatePolicyDefinitions(a){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",a);const f={},p=[],b=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const E of a){const k=b[E];if(!k){p.push(E);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.logService.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}p.push(E),f[k.policy.name]={type:k.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),p}onDidChangePolicies(a){this.logService.trace("PolicyConfiguration#onDidChangePolicies",a);const f=v.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),p=(0,I.coalesce)(a.map(b=>f.get(b)));this.update(p,!0)}update(a,f){this.logService.trace("PolicyConfiguration#update",a);const p=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),b=[],E=this._configurationModel.isEmpty();for(const k of a){const t=p[k]?.policy?.name;if(t){const c=this.policyService.getPolicyValue(t);(E?c!==void 0:!(0,R.equals)(this._configurationModel.getValue(k),c))&&b.push([k,c])}else this._configurationModel.getValue(k)!==void 0&&b.push([k,void 0])}if(b.length){this.logService.trace("PolicyConfiguration#changed",b);const k=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of k.keys)this._configurationModel.setValue(t,k.getValue(t));for(const[t,c]of b)c===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,c);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=we([X(1,w.IPolicyService),X(2,h.ILogService)],y),e.PolicyConfiguration=y}),define(Z[230],ee([0,1,7,3,2,19,18,115,229,38]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class w extends r.Disposable{constructor(S,l,y,m){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new M.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration),this.policyConfiguration=y instanceof h.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,y,m)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,l)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:a,properties:f})=>this.onDidDefaultConfigurationChange(a,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(a=>this.onDidPolicyConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,l,y]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(S,l,new P.ConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(S,l){const y=typeof S=="string"?S:void 0,m=(0,D.isConfigurationOverrides)(S)?S:(0,D.isConfigurationOverrides)(l)?l:{};return this.configuration.getValue(y,m,void 0)}updateValue(S,l,y,m){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const l=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(y,l,2)}onDidDefaultConfigurationChange(S,l){const y=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(S,l);this.trigger(m,y,7)}onDidPolicyConfigurationChange(S){const l=this.configuration.toData(),y=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(y,l,7)}trigger(S,l,y){const m=new P.ConfigurationChangeEvent(S,{data:l},this.configuration);m.source=y,m.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=w}),define(Z[231],ee([0,1,13,6]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,M.createDecorator)("remoteAuthorityResolverService");var r;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(r=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends I.ErrorNoTelemetry{static isNotAvailable(g){return g instanceof R&&g._code===r.NotAvailable}static isTemporarilyNotAvailable(g){return g instanceof R&&g._code===r.TemporarilyNotAvailable}static isNoResolverFound(g){return g instanceof R&&g._code===r.NoResolverFound}static isHandled(g){return g instanceof R&&g.isHandled}constructor(g,h=r.Unknown,w){super(g),this._message=g,this._code=h,this._detail=w,this.isHandled=h===r.NotAvailable&&w===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function D(P){const g=P.indexOf("+");return g===-1?P:P.substring(0,g)}e.getRemoteAuthorityPrefix=D}),define(Z[55],ee([0,1,14]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function M(h){return h.scheme===I.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=M;function r(h){if(!h)return;const w=h.indexOf("+");return w<0?h:h.substr(0,w)}e.getRemoteName=r;function R(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(h){const{host:w,port:v}=g(h);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:v}}e.parseAuthorityWithPort=D;function P(h,w){let{host:v,port:S}=g(h);return typeof S>"u"&&(S=w),{host:v,port:S}}e.parseAuthorityWithOptionalPort=P;function g(h){const w=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const v=h.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const S=h.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:h,port:void 0}}}),define(Z[116],ee([0,1,27,6,55]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var P;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,m){if(typeof y>"u"||y===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof y=="string"||typeof m=="string"){const a=typeof y=="string"?y:y.value,f=typeof m=="string"?m:m.value;return I.equalsIgnoreCase(a,f)}return y._lower===m._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=g;function h(l){return w(l)}e.isApplicationScopedExtension=h;function w(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function v(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function S(l,y){if(y){const m=`onResolveRemoteAuthority:${(0,r.getRemoteName)(y)}`;return!!l.activationEvents?.includes(m)}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[232],ee([0,1,7,17,22,13,3,2,64,73,31,105,231,55]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var m;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function a(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(W){const _=new r.CancellationTokenSource;return setTimeout(()=>_.cancel(),W),_.token}function p(W,_){if(W.isCancellationRequested||_.isCancellationRequested)return r.CancellationToken.Cancelled;const $=new r.CancellationTokenSource;return W.onCancellationRequested(()=>$.cancel()),_.onCancellationRequested(()=>$.cancel()),$.token}class b{get didTimeout(){return this._state==="timedout"}constructor(_){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise(($,Q)=>{this._resolvePromise=$,this._rejectPromise=Q}),_.isCancellationRequested?this._timeout():this._disposables.add(_.onCancellationRequested(()=>this._timeout()))}registerDisposable(_){this._state==="pending"?this._disposables.add(_):_.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(_))}reject(_){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(_))}}function E(W,_){const $=new b(_);return $.registerDisposable(W.onControlMessage(Q=>{const N=JSON.parse(Q.toString()),j=H(N);j?$.reject(j):$.resolve(N)})),$.promise}function k(W,_,$,Q,N,j,G,re,ue){const ye=new b(ue),Me=h.StopWatch.create(!1);return W.info(`Creating a socket (${re})...`),g.mark(`code/willCreateSocket/${G}`),_.connect($,Q,N,j,re,(Te,Ae)=>{ye.didTimeout?(g.mark(`code/didCreateSocketError/${G}`),W.info(`Creating a socket (${re}) finished after ${Me.elapsed()} ms, but this is too late and has timed out already.`),Te&&W.error(Te),Ae?.dispose()):Te||!Ae?(g.mark(`code/didCreateSocketError/${G}`),W.info(`Creating a socket (${re}) returned an error after ${Me.elapsed()} ms.`),ye.reject(Te)):(g.mark(`code/didCreateSocketOK/${G}`),W.info(`Creating a socket (${re}) was successful after ${Me.elapsed()} ms.`),ye.resolve(Ae))}),ye.promise}function t(W,_){const $=new b(_);return W.then(Q=>{$.didTimeout||$.resolve(Q)},Q=>{$.didTimeout||$.reject(Q)}),$.promise}async function c(W,_,$,Q){const N=U(W,_);W.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let j;try{j=await k(W.logService,W.socketFactory,W.host,W.port,(0,l.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,a(_),`renderer-${a(_)}-${W.reconnectionToken}`,Q)}catch(Me){throw W.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),W.logService.error(Me),Me}W.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let G,re;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(j,null),G=W.reconnectionProtocol,re=!1):(G=new v.PersistentProtocol({socket:j,measureRoundTripTime:!0}),re=!0),W.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ue=await t(W.signService.createNewMessage((0,w.generateUuid)()),Q),ye={type:"auth",auth:W.connectionToken||"00000000000000000000",data:ue.data};G.sendControl(M.VSBuffer.fromString(JSON.stringify(ye)));try{const Me=await E(G,p(Q,f(1e4)));if(Me.type!=="sign"||typeof Me.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(W.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(W.signService.validate(ue,Me.signedData),Q)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const Ae=await t(W.signService.sign(Me.data),Q),We={type:"connectionType",commit:W.commit,signedData:Ae,desiredConnectionType:_};return $&&(We.args=$),W.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(M.VSBuffer.fromString(JSON.stringify(We))),{protocol:G,ownsProtocol:re}}catch(Me){throw Me&&Me.code==="ETIMEDOUT"&&(W.logService.error(`${N} the handshake timed out. Error:`),W.logService.error(Me)),Me&&Me.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${N} received error control message when negotiating connection. Error:`),W.logService.error(Me)),re&&T(G),Me}}async function i(W,_,$,Q){const N=Date.now(),j=U(W,_),{protocol:G,ownsProtocol:re}=await c(W,_,$,Q),ue=new b(Q);return ue.registerDisposable(G.onControlMessage(ye=>{const Me=JSON.parse(ye.toString()),Te=H(Me);Te?(W.logService.error(`${j} received error control message when negotiating connection. Error:`),W.logService.error(Te),re&&T(G),ue.reject(Te)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${A(N)}!`),ue.resolve({protocol:G,firstMessage:Me}))})),ue.promise}async function n(W,_){const{protocol:$}=await i(W,1,void 0,_);return{protocol:$}}async function o(W,_,$){const{protocol:Q,firstMessage:N}=await i(W,2,_,$),j=N&&N.debugPort;return{protocol:Q,debugPort:j}}async function u(W,_,$){const Q=Date.now(),N=U(W,3),{protocol:j}=await c(W,3,_,$);return W.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${A(Q)}!`),j}async function s(W,_,$){const{host:Q,port:N,connectionToken:j}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:Q,port:N,connectionToken:j,reconnectionToken:_,reconnectionProtocol:$,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function d(W,_,$){return L(W,async Q=>{const{protocol:N}=await n(Q,r.CancellationToken.None);return new V(W,_,$,Q.reconnectionToken,N)})}e.connectRemoteAgentManagement=d;async function C(W,_){return L(W,async $=>{const{protocol:Q,debugPort:N}=await o($,_,r.CancellationToken.None);return new B(W,_,$.reconnectionToken,Q,N)})}e.connectRemoteAgentExtensionHost=C;async function L(W,_){for(let Q=1;;Q++)try{const N=(0,w.generateUuid)(),j=await s(W,N,null);return await _(j)}catch(N){if(Q<5)W.logService.error(`[remote-connection][attempt ${Q}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(N);else throw W.logService.error(`[remote-connection][attempt ${Q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(N),ge.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(N)),N}}async function O(W,_,$){const Q=await s(W,(0,w.generateUuid)(),null);return await u(Q,{host:_,port:$},r.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function F(W){return(0,I.createCancelablePromise)(_=>new Promise(($,Q)=>{const N=setTimeout($,W*1e3);_.onCancellationRequested(()=>{clearTimeout(N),$()})}))}var z;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class q{constructor(_,$){this.reconnectionToken=_,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=q;class ie{constructor(_,$,Q,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=$,this.durationSeconds=Q,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ie;class se{constructor(_,$,Q){this.reconnectionToken=_,this.millisSinceLastIncomingData=$,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=se;class oe{constructor(_,$,Q){this.reconnectionToken=_,this.millisSinceLastIncomingData=$,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=oe;class he{constructor(_,$){this.reconnectionToken=_,this.connectionHealth=$,this.type=5}}e.ConnectionHealthChangedEvent=he;class le{constructor(_,$,Q,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=$,this.attempt=Q,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=le;class ge extends P.Disposable{static triggerPermanentFailure(_,$,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=_,this._permanentFailureAttempt=$,this._permanentFailureHandled=Q,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(_=>_._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(_=>_._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ge._permanentFailure}constructor(_,$,Q,N,j){super(),this._connectionType=_,this._options=$,this.reconnectionToken=Q,this.protocol=N,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register(N.onSocketClose(G=>{const re=ne(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(G=>{const re=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(N.onHighRoundTripTime(G=>{const re=te(this._connectionType,this.reconnectionToken);this._options.logService.info(`${re} high roundtrip time: ${G.roundTripTime}ms (${G.recentHighRoundTripCount} of ${5} recent samples)`)})),this._register(N.onDidChangeConnectionHealth(G=>{this._onDidStateChange.fire(new he(this.reconnectionToken,G))})),ge._instances.push(this),this._register((0,P.toDisposable)(()=>{const G=ge._instances.indexOf(this);G>=0&&ge._instances.splice(G,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ge._permanentFailureMillisSinceLastIncomingData,ge._permanentFailureAttempt,ge._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const _=ne(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const N=Q<$.length?$[Q]:$[$.length-1];try{if(N>0){const G=F(N);this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,G)),this._options.logService.info(`${_} waiting for ${N} seconds before reconnecting...`);try{await G}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${_} resolving connection...`);const j=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${_} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,f(y)),this._options.logService.info(`${_} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,R.isCancellationError)(j)){this._options.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,S.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(_,$,Q){this._reconnectionFailureIsFatal?ge.triggerPermanentFailure(_,$,Q):this._gotoPermanentFailure(_,$,Q)}_gotoPermanentFailure(_,$,Q){this._onDidStateChange.fire(new le(this.reconnectionToken,_,$,Q)),T(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}ge._permanentFailure=!1,ge._permanentFailureMillisSinceLastIncomingData=0,ge._permanentFailureAttempt=0,ge._permanentFailureHandled=!1,ge._instances=[],e.PersistentConnection=ge;class V extends ge{constructor(_,$,Q,N,j){super(1,_,N,j,!0),this.client=this._register(new v.Client(j,{remoteAuthority:$,clientId:Q},_.ipcLogger))}async _reconnect(_,$){await n(_,$)}}e.ManagementPersistentConnection=V;class B extends ge{constructor(_,$,Q,N,j){super(2,_,Q,N,!1),this._startArguments=$,this.debugPort=j}async _reconnect(_,$){await o(_,this._startArguments,$)}}e.ExtensionHostPersistentConnection=B;function T(W){try{W.acceptDisconnect();const _=W.getSocket();W.dispose(),_.dispose()}catch(_){(0,R.onUnexpectedError)(_)}}function H(W){if(W&&W.type==="error"){const _=new Error(`Connection error: ${W.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function Y(W,_){for(;W.length<_;)W+=" ";return W}function te(W,_){return`[remote-connection][${Y(a(W),13)}][${_.substr(0,5)}\u2026]`}function ne(W,_,$){return`${te(W,_)}[${$?"reconnect":"initial"}]`}function U(W,_){return`${ne(_,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function A(W){return`${Date.now()-W} ms`}}),define(Z[233],ee([0,1,83,87]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(r,R,D,P,g,h){const w=S=>h(S,void 0),v=I.createConnection({host:r,port:R},()=>{v.removeListener("error",w);const S=Buffer.alloc(16);for(let a=0;a<16;a++)S[a]=Math.round(Math.random()*256);const l=S.toString("base64"),y=[`GET ws://${/:/.test(r)?`[${r}]`:r}:${R}${D}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`];v.write(y.join(`\r
`)+`\r
\r
`);const m=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",m),h(void 0,new M.NodeSocket(v,g)))};v.on("data",m)});v.setNoDelay(!0),v.once("error",w)}}}),define(Z[234],ee([0,1,26,46,41,193]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(l=!1){return(D===void 0||l)&&(D=g()),D}e.hasWSLFeatureInstalled=P;async function g(){const l=h();if(l===void 0)return!1;if(l>=22e3){const y=v();if(y)return new Promise(m=>{M.execFile(y,["--status"],a=>m(!a))})}else{const y=S();if(y)try{if((await r.promises.stat(y)).isFile())return!0}catch{}}return!1}function h(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(l)return parseInt(l[3])}function w(l){const y=process.env.SystemRoot;if(y){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(y,m?"Sysnative":"System32",l)}}function v(){return w("wsl.exe")}function S(){return w("lxss\\LxssManager.dll")}}),define(Z[56],ee([0,1,17,178,68,6,51]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=P;function g(m){return m.res.statusCode===204}async function h(m){return g(m)?null:(await(0,I.streamToBuffer)(m.stream)).toString()}e.asText=h;async function w(m){if(!P(m))throw new Error("Server returned "+m.res.statusCode);return h(m)}e.asTextOrError=w;async function v(m){if(!P(m))throw new Error("Server returned "+m.res.statusCode);if(g(m))return null;const f=(await(0,I.streamToBuffer)(m.stream)).toString();try{return JSON.parse(f)}catch(p){throw p.message+=`:
`+f,p}}e.asJson=v;function S(m){y(m)}e.updateProxyConfigurationsScope=S;let l;function y(m){const a=D.Registry.as(r.Extensions.Configuration),f=l;l={id:"http",order:15,title:(0,M.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(4,null),(0,M.localize)(5,null),(0,M.localize)(6,null),(0,M.localize)(7,null)],default:"override",description:(0,M.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(9,null),restricted:!0}}},a.updateConfigurations({add:[l],remove:f?[f]:[]})}y(2)}),define(Z[235],ee([0,1,17,22]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(P){this.service=P}listen(P,g){throw new Error("Invalid listen")}call(P,g,h,w=M.CancellationToken.None){switch(g){case"request":return this.service.request(h[0],w).then(async({res:v,stream:S})=>{const l=await(0,I.streamToBuffer)(S);return[{statusCode:v.statusCode,headers:v.headers},l]});case"resolveProxy":return this.service.resolveProxy(h[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class R{constructor(P){this.channel=P}async request(P,g){const[h,w]=await this.channel.call("request",[P],g);return{res:h,stream:(0,I.bufferToStream)(w)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=R}),define(Z[236],ee([0,1,237,10]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(D,P,g={}){const h=(0,I.parse)(D),w=g.proxyUrl||r(h,P);if(!w)return null;const v=(0,I.parse)(w);if(!/^https?:$/.test(v.protocol||""))return null;const S={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,M.isBoolean)(g.strictSSL)?g.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((l,y)=>{x(["http-proxy-agent"],l,y)}))(S):new(await new Promise((l,y)=>{x(["https-proxy-agent"],l,y)}))(S)}e.getProxyAgent=R}),define(Z[117],ee([0,1,46,9,179,22,44,13,4,31,154,62,7,133]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function m(f,p,b,E){return b["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(E)&&!b["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(E)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=S.Promises.withAsyncBody(async(k,t)=>{const c=new R.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,l.clamp)(n,1,120)*1e3);const o=setTimeout(()=>{c.dispose(!0),t(new Error((0,r.localize)(0,null)))},i);try{k(await a(p,c.token))}catch(u){!(0,P.isCancellationError)(u)&&!c.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,D.toErrorMessage)(u)))):k({})}finally{clearTimeout(o),c.dispose()}})),y)}e.getResolvedShellEnv=m;async function a(f,p){const b=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",b);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",E);const k=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(k+"({.*})"+k),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",c);const i=await(0,w.getSystemShell)(g.OS,c);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(p.isCancellationRequested)return o(new P.CancellationError);const u=(0,M.basename)(i);let s,d;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(s=`& '${process.execPath}' ${C} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,d=["-Login","-Command"]):(s=`'${process.execPath}' ${C} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,u==="tcsh"||u==="csh"?d=["-ic"]:d=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),s);const L=(0,I.spawn)(i,[...d,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});p.onCancellationRequested(()=>(L.kill(),o(new P.CancellationError))),L.on("error",z=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(z)),o(z)});const O=[];L.stdout.on("data",z=>O.push(z));const F=[];L.stderr.on("data",z=>F.push(z)),L.on("close",(z,q)=>{const ie=Buffer.concat(O).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const se=Buffer.concat(F).toString("utf8");if(se.trim()&&f.trace("getUnixShellEnvironment#stderr",se),z||q)return o(new Error((0,r.localize)(2,null,z,q)));const oe=t.exec(ie),he=oe?oe[1]:"{}";try{const le=JSON.parse(he);b?le.ELECTRON_RUN_AS_NODE=b:delete le.ELECTRON_RUN_AS_NODE,E?le.ELECTRON_NO_ATTACH_CONSOLE=E:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",le),n(le)}catch(le){f.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(le)),o(le)}})})}}),define(Z[92],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[238],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.validators=new Map}vsda(){return new Promise((r,R)=>x(["vsda"],r,R))}async createNewMessage(r){try{const R=await this.vsda(),D=new R.validator;if(D){const P=String(I._nextId++);return this.validators.set(P,D),{id:P,data:D.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,R){if(!r.id)return!0;const D=this.validators.get(r.id);if(!D)return!1;this.validators.delete(r.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(r){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(r)}catch{}return r}}I._nextId=1,e.SignService=I}),define(Z[33],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(Z[20],ee([0,1,15,42,7,3,2,4,36,10,6,5,33,28]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var y;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(y=e.ShutdownReason||(e.ShutdownReason={}));var m;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(m=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let a=class dt extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(p,b,E){super(),this.logService=p,this.stateService=b,this.environmentMainService=E,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const p=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};I.app.addListener("before-quit",p);const b=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",b),I.app.once("will-quit",E=>{this.trace("Lifecycle#app.on(will-quit) - begin"),E.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),I.app.removeListener("before-quit",p),I.app.removeListener("window-all-closed",b),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),I.app.quit()})})}fireOnWillShutdown(p){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const b=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({reason:p,join(k,t){b.trace(`Lifecycle#onWillShutdown - begin '${k}'`),E.push(t.finally(()=>{b.trace(`Lifecycle#onWillShutdown - end '${k}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(E)}catch(k){this.logService.error(k)}try{await this.stateService.close()}catch(k){this.logService.error(k)}})(),this.pendingWillShutdownPromise}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===p)return;this.trace(`lifecycle (main): phase changed (value: ${p})`),this._phase=p;const b=this.phaseWhen.get(this._phase);b&&(b.open(),this.phaseWhen.delete(this._phase))}async when(p){if(p<=this._phase)return;let b=this.phaseWhen.get(p);b||(b=new r.Barrier,this.phaseWhen.set(p,b)),await b.wait()}registerWindow(p){const b=new D.DisposableStore;this.windowCounter++,b.add(p.onWillLoad(k=>this._onWillLoadWindow.fire({window:p,workspace:k.workspace,reason:k.reason})));const E=(0,h.assertIsDefined)(p.win);E.on("close",k=>{const t=p.id;if(this.windowToCloseRequest.has(t)){this.windowToCloseRequest.delete(t);return}this.trace(`Lifecycle#window.on('close') - window ID ${p.id}`),k.preventDefault(),this.unload(p,1).then(c=>{if(c){this.windowToCloseRequest.delete(t);return}this.windowToCloseRequest.add(t),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this._onBeforeCloseWindow.fire(p),p.close()})}),E.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.windowCounter--,b.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(p,b){await this.unload(p,3)||p.reload(b)}unload(p,b){const E=this.mapWindowIdToPendingUnload.get(p.id);if(E)return E;const k=this.doUnload(p,b).finally(()=>{this.mapWindowIdToPendingUnload.delete(p.id)});return this.mapWindowIdToPendingUnload.set(p.id,k),k}async doUnload(p,b){if(!p.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${p.id}`);const E=this._quitRequested?2:b,k=await this.onBeforeUnloadWindowInRenderer(p,E);return k?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.handleWindowUnloadVeto(k)):(await this.onWillUnloadWindowInRenderer(p,E),!1)}handleWindowUnloadVeto(p){return p?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(p){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(p),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(p,b){return new Promise(E=>{const k=this.oneTimeListenerTokenGenerator++,t=`vscode:ok${k}`,c=`vscode:cancel${k}`;M.validatedIpcMain.once(t,()=>{E(!1)}),M.validatedIpcMain.once(c,()=>{E(!0)}),p.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:b})})}onWillUnloadWindowInRenderer(p,b){return new Promise(E=>{const t=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;M.validatedIpcMain.once(t,()=>E()),p.send("vscode:onWillUnload",{replyChannel:t,reason:b})})}quit(p){return this.trace(`Lifecycle#quit() - begin (willRestart: ${p})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(p&&this.stateService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(b=>{this.pendingQuitPromiseResolve=b,this.trace("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.pendingQuitPromise)}trace(p){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(p):this.logService.trace(p)}async relaunch(p){this.trace("Lifecycle#relaunch()");const b=process.argv.slice(1);if(p?.addArgs&&b.push(...p.addArgs),p?.removeArgs)for(const t of p.removeArgs){const c=b.indexOf(t);c>=0&&b.splice(c,1)}const E=()=>{try{if(P.isWindows){const t=(0,g.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:b})};I.app.once("quit",E),await this.quit(!0)&&I.app.removeListener("quit",E)}async kill(p){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const b of I.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let E;b.webContents&&!b.webContents.isDestroyed()?E=new Promise(k=>b.once("closed",k)):E=Promise.resolve(),b.destroy(),await E}})()]),I.app.exit(p)}};a.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",a=we([X(0,v.ILogService),X(1,S.IStateService),X(2,l.IEnvironmentMainService)],a),e.LifecycleMainService=a}),define(Z[239],ee([0,1,4,3,2,6,20]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let P=class extends r.Disposable{constructor(w){super(),this._onDidChangeKeyboardLayout=this._register(new M.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((v,S)=>{x(["native-keymap"],v,S)});this._keyboardLayoutData=g(w),I.isCI||w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=g(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=we([X(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function g(h){const w=h.getKeyMap(),v=h.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:v}}}),define(Z[118],ee([0,1,7,17,10,34,16,5]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var g;(function(S){S[S.IMMEDIATE=0]="IMMEDIATE",S[S.DELAYED=1]="DELAYED"})(g=e.SaveStrategy||(e.SaveStrategy={}));class h{constructor(l,y,m,a){this.storagePath=l,this.logService=m,this.fileService=a,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=y===0?void 0:new I.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(l){l.fileOperationResult!==1&&this.logService.error(l)}}getItem(l,y){const m=this.storage[l];return(0,r.isUndefinedOrNull)(m)?y:m}setItem(l,y){this.setItems([{key:l,data:y}])}setItems(l){let y=!1;for(const{key:m,data:a}of l)this.storage[m]!==a&&((0,r.isUndefinedOrNull)(a)?(0,r.isUndefined)(this.storage[m])||(this.storage[m]=void 0,y=!0):(this.storage[m]=a,y=!0));y&&this.save()}removeItem(l){(0,r.isUndefined)(this.storage[l])||(this.storage[l]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const l=JSON.stringify(this.storage,null,4);if(l!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,M.VSBuffer.fromString(l)),this.lastSavedStorageContents=l}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=h;let w=class{constructor(l,y,m,a){this.fileStorage=new h(y.stateResource,l,m,a)}async init(){await this.fileStorage.init()}getItem(l,y){return this.fileStorage.getItem(l,y)}};w=we([X(1,R.IEnvironmentService),X(2,P.ILogService),X(3,D.IFileService)],w),e.StateReadonlyService=w;class v extends w{setItem(l,y){this.fileStorage.setItem(l,y)}setItems(l){this.fileStorage.setItems(l)}removeItem(l){this.fileStorage.removeItem(l)}close(){return this.fileStorage.close()}}e.StateService=v}),define(Z[93],ee([0,1,4,36,8,31]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(h){if(I.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function P(h,w,v,S,l,y,m,a,f,p){const b=Object.create(null);b["common.machineId"]=m,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=l,b.version=y,b["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,I.PlatformToString)(I.platform),b["common.nodePlatform"]=M.platform,b["common.nodeArch"]=S,b["common.product"]=p||"desktop",a&&(b["common.msftInternal"]=a);let E=0;const k=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),I.isLinuxSnap&&(b["common.snap"]="true");const t=D(v);t&&(b["common.platformDetail"]=t);try{const c=await h.readFile(r.URI.file(f));b["common.source"]=c.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=P;function g(h){const w=M.env.USERDNSDOMAIN;if(!w)return!1;const v=w.toLowerCase();return h.some(S=>v===S)}e.verifyMicrosoftInternalDomain=g}),define(Z[24],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M=e.TelemetryLevel||(e.TelemetryLevel={}));var r;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(r=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[240],ee([0,1,26,7,43,14,9,4,8,85,23,104,88,16,21,24]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function f(t,c){const i=`${t}::${c.join(":")}`,n=a.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,s=new Map,d=2e4;function C(O,F,z,q){const ie=F.substring(O.length+1);return M.Promises.withAsyncBody(async se=>{let oe;try{oe=await w.Promises.readdir(F,{withFileTypes:!0})}catch{se();return}if(q.count>=d){q.count+=oe.length,q.maxReached=!0,se();return}let he=oe.length;if(he===0){se();return}let le=oe;q.count+oe.length>d&&(q.maxReached=!0,he=d-q.count,le=oe.slice(0,he)),q.count+=oe.length;for(const ge of le)if(ge.isDirectory()){if(z.includes(ge.name)||await C(O,(0,D.join)(F,ge.name),z,q),--he===0){se();return}}else{const V=ge.name.lastIndexOf(".");if(V>=0){const B=ge.name.substring(V+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(ie)!==!1&&B.filePattern.test(ge.name)&&s.set(B.tag,(s.get(B.tag)??0)+1);if(--he===0){se();return}}})}const L=M.Promises.withAsyncBody(async O=>{const F={count:0,maxReached:!1};await C(t,t,c,F);const z=await E(t);O({configFiles:p(s),fileTypes:p(u),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:z})});return a.set(i,L),L}e.collectWorkspaceStats=f;function p(t){return Array.from(t.entries(),([c,i])=>({name:c,count:i})).sort((c,i)=>i.count-c.count)}function b(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.virtualMachineHint.value()*100)}%`},c=I.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=b;async function E(t){try{const c=new Map,i=(0,D.join)(t,".vscode","launch.json"),n=await w.Promises.readFile(i),o=[],u=(0,r.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,r.getNodeType)(u)==="object"&&u.configurations)for(const s of u.configurations){const d=s.type;d&&(c.has(d)?c.set(d,c.get(d)+1):c.set(d,1))}return p(c)}catch{return[]}}e.collectLaunchConfigs=E;let k=class{constructor(c,i){this.telemetryService=c,this.productService=i}formatMachineInfo(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}formatEnvironment(c){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const n=I.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${I.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(h.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,v.listProcesses)(c.mainPID),this.formatWorkspaceMetadata(c)]).then(async n=>{let[o,u]=n,s=this.formatProcessList(c,o);return i.forEach(d=>{if((0,S.isRemoteDiagnosticError)(d))s+=`
${d.errorMessage}`,u+=`
${d.errorMessage}`;else if(s+=`

Remote: ${d.hostName}`,d.processes&&(s+=`
${this.formatProcessList(c,d.processes)}`),d.workspaceMetadata){u+=`
|  Remote: ${d.hostName}`;for(const C of Object.keys(d.workspaceMetadata)){const L=d.workspaceMetadata[C];let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${C}): ${O}`,u+=this.formatWorkspaceStats(L)}}}),{processInfo:s,workspaceInfo:u}})}async getSystemInfo(c,i){const{memory:n,vmHint:o,os:u,cpus:s}=b(),d={os:u,memory:n,cpus:s,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(d.load=`${I.loadavg().map(C=>Math.round(C)).join(", ")}`),P.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(c,i){const n=[];return(0,v.listProcesses)(c.mainPID).then(async o=>(n.push(""),n.push(this.formatEnvironment(c)),n.push(""),n.push(this.formatProcessList(c,o)),c.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(c))),i.forEach(u=>{if((0,S.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.formatMachineInfo(u.machineInfo)),u.processes&&n.push(this.formatProcessList(c,u.processes)),u.workspaceMetadata)for(const s of Object.keys(u.workspaceMetadata)){const d=u.workspaceMetadata[s];let C=`${d.fileCount} files`;d.maxFilesReached&&(C=`more than ${C}`),n.push(`Folder (${s}): ${C}`),n.push(this.formatWorkspaceStats(d))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(c){const i=[];let o=0;const u=(L,O)=>{const F=` ${L}(${O})`;o+F.length>60?(i.push(s),s="|                 ",o=s.length):o+=F.length,s+=F};let s="|      File types:";const d=10,C=c.fileTypes.length>d?d:c.fileTypes.length;for(let L=0;L<C;L++){const O=c.fileTypes[L];u(O.name,O.count)}if(i.push(s),c.configFiles.length>=0&&(s="|      Conf files:",o=0,c.configFiles.forEach(L=>{u(L.name,L.count)}),i.push(s)),c.launchConfigFiles.length>0){let L="|      Launch Configs:";c.launchConfigFiles.forEach(O=>{L+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(L)}return i.join(`
`)}expandGPUFeatures(c){const i=Math.max(...Object.keys(c).map(n=>n.length));return Object.keys(c).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${c[n]}`).join(`
                  `)}formatWorkspaceMetadata(c){const i=[],n=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const s=g.URI.revive(u);if(s.scheme===R.Schemas.file){const d=s.fsPath;n.push(f(d,["node_modules",".git"]).then(C=>{let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),i.push(`|    Folder (${(0,D.basename)(d)}): ${L}`),i.push(this.formatWorkspaceStats(C))}).catch(C=>{i.push(`|      Error: Unable to collect workspace stats for folder ${d} (${C.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(c,i){const n=new Map;c.windows.forEach(u=>n.set(u.pid,u.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(c.mainPID,n,o,i,0),o.join(`
`)}formatProcessItem(c,i,n,o,u){const s=u===0;let d;s?d=o.pid===c?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(u)} ${o.name}`,o.name==="window"&&(d=`${d} (${i.get(o.pid)})`));const C=process.platform==="win32"?o.mem:I.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(C/l.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(o.children)&&o.children.forEach(L=>this.formatProcessItem(c,i,n,L,u+1))}async getWorkspaceFileExtensions(c){const i=new Set;for(const{uri:n}of c.folders){const o=g.URI.revive(n);if(o.scheme!==R.Schemas.file)continue;const u=o.fsPath;try{(await f(u,["node_modules",".git"])).fileTypes.forEach(d=>i.add(d.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const n=g.URI.revive(i);if(n.scheme!==R.Schemas.file)continue;const o=n.fsPath;try{const u=await f(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),u.fileTypes.forEach(s=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})}),u.launchConfigFiles.forEach(s=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})}),u.configFiles.forEach(s=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};k=we([X(0,m.ITelemetryService),X(1,y.IProductService)],k),e.DiagnosticsService=k}),define(Z[241],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:P,data:g}){return this.appenders.forEach(h=>h.log(P,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class M{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(Z[48],ee([0,1,37,10,3,18,55,93,24]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(o){this.value=o}}e.TelemetryTrustedValue=h;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class v{async publicLog(o,u,s){}async publicLogError(o,u,s){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(n,o){return r.Event.debounce(o.onDidChangeConfiguration,(s,d)=>{const C=s?new Set([...s.affectedKeys,...d.affectedKeys]):d.affectedKeys;return{...d,affectedKeys:C}},1e3,!0)(s=>{s.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:Array.from(s.affectedKeys)})})}e.configurationTelemetry=S;function l(n,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!n.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=l;function y(n,o){return!(o.isBuilt||o.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=y;function m(n){const o=n.getValue(g.TELEMETRY_SETTING_ID),u=n.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function a(n){const o={},u={},s={};b(n,s);for(let d in s){d=d.length>150?d.substr(d.length-149):d;const C=s[d];typeof C=="number"?u[d]=C:typeof C=="boolean"?u[d]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${C.length}`),o[d]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(o[d]=C)}return{properties:o,measurements:u}}e.validateTelemetryData=a;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(n){if(!n)return"none";const o=(0,D.getRemoteName)(n);return f.has(o)?o:"other"}e.cleanRemoteAuthority=p;function b(n,o,u=0,s){if(!!n)for(const d of Object.getOwnPropertyNames(n)){const C=n[d],L=s?s+d:d;Array.isArray(C)?o[L]=(0,I.safeStringify)(C):C instanceof Date?o[L]=C.toISOString():(0,M.isObject)(C)?u<2?b(C,o,u+1,L+"."):o[L]=(0,I.safeStringify)(C):o[L]=C}}function E(n,o){const u=n.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(u)||s}e.isInternalTelemetry=E;function k(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=k;function t(n,o){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let u=n;const s=[];for(const O of o)for(;;){const F=O.exec(n);if(!F)break;s.push([F.index,O.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(u="";;){const O=C.exec(n);if(!O)break;const F=s.some(([z,q])=>O.index<q&&z<C.lastIndex);!d.test(O[0])&&!F&&(u+=n.substring(L,O.index)+"<REDACTED: user-file-path>",L=C.lastIndex)}return L<n.length&&(u+=n.substr(L)),u}function c(n){if(!n)return n;const o=n.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of u)if(s.regex.test(o))return`<REDACTED: ${s.label}>`;return n}function i(n,o){return(0,I.cloneAndChange)(n,u=>{if(u instanceof h)return u.value;if(typeof u=="string"){let s=u.replaceAll("%20"," ");s=t(s,o);for(const d of o)s=s.replace(d,"");return s=c(s),s}})}e.cleanData=i}),define(Z[119],ee([0,1,27,112,116,4,8,13,36,48]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,I.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=w;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(n){const o=n.manifest?n.manifest.version:n.version,u=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new S(n.identifier,o,u)}static parse(n){const o=v.exec(n);return o&&o[1]&&o[2]?new S({id:o[1]},o[2],o[4]||void 0):null}constructor(n,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof S?w(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=S;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const n=l.exec(i);return n&&n[1]?[a(n[1]),n[2]]:[a(i),void 0]}e.getIdAndVersion=y;function m(i,n){return`${i}.${n}`}e.getExtensionId=m;function a(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function f(i,n){return a(m(i,n))}e.getGalleryExtensionId=f;function p(i,n){const o=[],u=s=>{for(const d of o)if(d.some(C=>w(n(C),n(s))))return d;return null};for(const s of i){const d=u(s);d?d.push(s):o.push([s])}return o}e.groupByExtension=p;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function E(i){return{id:new h.TelemetryTrustedValue(i.identifier.id),name:new h.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function k(i,n){const o=[],u=n.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const s=u.shift();if(s&&o.every(d=>!w(d.identifier,{id:s}))){const d=i.filter(C=>w(C.identifier,{id:s}));d.length===1&&(o.push(d[0]),u.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=k;async function t(i,n){if(!R.isLinux)return!1;let o;try{o=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(s))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(i,n){const o=await t(i,n),u=(0,M.getTargetPlatform)(o?"alpine":R.platform,g.arch);return n.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=c}),define(Z[242],ee([0,1,199,48]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(R,D,P,g,h,w,v){const S={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,M.supportsTelemetry)(D,P)&&(0,M.getTelemetryLevel)(g)===3){const l=await(0,I.getServiceMachineId)(P,h,w),{machineId:y}=await v.getTelemetryInfo();S["X-Market-User-Id"]=l,S["VSCode-SessionId"]=y||l}return S}e.resolveMarketplaceHeaders=r}),define(Z[243],ee([0,1,13,37,48]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function P(h,w,v){const S=await new Promise((f,p)=>{x(["@microsoft/1ds-core-js"],f,p)}),l=await new Promise((f,p)=>{x(["@microsoft/1ds-post-js"],f,p)}),y=new S.AppInsightsCore,m=new l.PostChannel,a={instrumentationKey:h,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(v){a.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:v};a.extensionConfig[m.identifier]=f}return y.initialize(a,[]),y.addTelemetryInitializer(f=>{w&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),y}class g{constructor(w,v,S,l,y){this._isInternalTelemetry=w,this._eventPrefix=v,this._defaultData=S,this._xhrOverride=y,this.endPointUrl=R,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof l=="function"?this._aiCoreOrKey=l():this._aiCoreOrKey=l,this._asyncAiCore=null}_withAIClient(w){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){w(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=P(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(v=>{w(v)},v=>{(0,I.onUnexpectedError)(v),console.error(v)})}}log(w,v){if(!this._aiCoreOrKey)return;v=(0,M.mixin)(v,this._defaultData),v=(0,r.validateTelemetryData)(v);const S=this._eventPrefix+"/"+w;try{this._withAIClient(l=>{l.pluginVersionString=v?.properties.version??"Unknown",l.track({name:S,baseData:{name:S,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(w=>{this._withAIClient(v=>{v.unload(!0,()=>{this._aiCoreOrKey=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Z[120],ee([0,1,2,37,4,27,180,18,68,66,21,51,24,48]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(f,p,b){this._configurationService=p,this._productService=b,this._experimentProperties={},this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(S.TELEMETRY_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,p){this._experimentProperties[f]=p}_updateTelemetryLevel(){let f=(0,l.getTelemetryLevel)(this._configurationService);const p=this._productService.enabledTelemetryLevels;if(p){this._sendErrorTelemetry=this.sendErrorTelemetry?p.error:!1;const b=p.usage?3:p.error?2:0;f=Math.min(f,b)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties,p=f.sessionID,b=f["common.machineId"],E=f["common.firstSessionDate"],k=f["common.msftInternal"];return{sessionId:p,machineId:b,firstSessionDate:E,msftInternal:k}}dispose(){this._disposables.dispose()}_log(f,p,b){return this._telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(E=>{b=(0,M.mixin)(b,this._experimentProperties),b=(0,l.cleanData)(b,this._cleanupPatterns),b=(0,M.mixin)(b,E),this._appenders.forEach(k=>k.log(f,b))},E=>{console.error(E)})}publicLog(f,p){return this._log(f,3,p)}publicLog2(f,p){return this.publicLog(f,p)}publicLogError(f,p){return this._sendErrorTelemetry?this._log(f,2,p):Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=we([X(1,P.IConfigurationService),X(2,w.IProductService)],y),e.TelemetryService=y;function m(){const a=(0,D.localize)(0,null,h.default.nameLong),f=h.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",h.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=r.isWeb?"":(0,D.localize)(3,null),b=(0,D.localize)(4,null),E=(0,D.localize)(5,null),k=(0,D.localize)(6,null),t=(0,D.localize)(7,null),c=`
|       | ${b} | ${E} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${a} ${f} ${p}

&nbsp;

${t}
${c}

&nbsp;

${i}
`}v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:m(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,D.localize)(16,null,h.default.nameLong,h.default.privacyStatementUrl):(0,D.localize)(15,null,h.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[244],ee([0,1,292,243]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class r extends M.AbstractOneDataSystemAppender{constructor(D,P,g,h){const w={sendPOST:(v,S)=>{const l={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const y=I.request(v.urlString,l,m=>{m.on("data",function(a){S(m.statusCode??200,m.headers,a.toString())}),m.on("error",function(a){S(0,{})})});y.write(v.data),y.end()}catch{S(0,{})}}};super(D,P,g,h,w)}}e.OneDataSystemAppender=r}),define(Z[245],ee([0,1,4,85,24]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(D){let P=D.getItem(r.machineIdKey);return(typeof P!="string"||I.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,M.getMachineId)()),P}e.resolveMachineId=R}),define(Z[121],ee([0,1,24,245]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function r(R){const D=await(0,M.resolveMachineId)(R);return R.setItem(I.machineIdKey,D),D}e.resolveMachineId=r}),define(Z[69],ee([0,1,15,3,2,4,18,6,33]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const h="#FFFFFF",w="#1E1E1E",v="#000000",S="#FFFFFF",l="theme",y="themeBackground",m="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let a=class extends r.Disposable{constructor(p,b){super(),this.stateService=p,this.configurationService=b,this._onDidChangeColorScheme=this._register(new M.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,I.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const p=this.getColorScheme();if(p.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return p.dark?v:S;let b=this.stateService.getItem(y,null);if(!b)switch(this.stateService.getItem(l,"vs-dark").split(" ")[0]){case"vs":b=h;break;case"hc-black":b=v;break;case"hc-light":b=S;break;default:b=w}return R.isMacintosh&&b.toUpperCase()===w&&(b="#171717"),b}saveWindowSplash(p,b){this.stateService.setItems([{key:l,data:b.baseTheme},{key:y,data:b.colorInfo.background},{key:m,data:b}]),typeof p=="number"&&this.updateBackgroundColor(p,b)}updateBackgroundColor(p,b){for(const E of I.BrowserWindow.getAllWindows())if(E.id===p){E.setBackgroundColor(b.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(m)}};a=we([X(0,g.IStateService),X(1,D.IConfigurationService)],a),e.ThemeMainService=a}),define(Z[122],ee([0,1,3,18,6,5]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var D;(function(m){m.Http="http",m.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=v;function S(m,a,f,p){if(f===1)return!1;if(f===2&&v(a)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return m<1024}e.isPortPrivileged=S;class l{constructor(a,f,p){this.remoteAddress=a,this.localAddress=f,this._dispose=p,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=l;let y=class{constructor(a,f){this.logService=a,this.configurationService=f,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this._tunnelProvider=a,a?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this._canElevate=a.elevation,this._privacyOptions=a.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const a=[],f=Array.from(this._tunnels.values());for(const p of f){const b=Array.from(p.values());for(const E of b){const k=await E.value;k&&a.push(k)}}return a}async dispose(){for(const a of this._tunnels.values()){for(const{value:f}of a.values())await f.then(p=>p?.dispose());a.clear()}this._tunnels.clear()}setEnvironmentTunnel(a,f,p,b,E){this.addTunnelToMap(a,f,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:f,localAddress:p,privacy:b,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,f){(v(a)||w(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const p=this.getTunnelFromMap(a,f);if(p)return++p.refcount,p.value}openTunnel(a,f,p,b,E,k=!1,t,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${E}.`),!a)return;if(f||(f="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(a,f,p,b,E,k,t,c);return i?i.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(n);return(n.tunnelRemoteHost!==f||n.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const f=this._tunnels.get(a.tunnelRemoteHost);if(f){const p=f.get(a.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,p))}}}}async tryDisposeTunnel(a,f,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${f}.`);const b=p.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(f),b}}async closeTunnel(a,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${f} `);const p=this._tunnels.get(a);if(p&&p.has(f)){const b=p.get(f);b.refcount=0,await this.tryDisposeTunnel(a,f,b)}}addTunnelToMap(a,f,p){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(f,{refcount:1,value:p})}async removeEmptyTunnelFromMap(a,f){const p=this._tunnels.get(a);p&&(await p.get(f)||p.delete(f),p.size===0&&this._tunnels.delete(a))}getTunnelFromMap(a,f){const p=[a];w(a)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):v(a)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(E=>this._tunnels.get(E));for(const E of b){const k=E?.get(f);if(k)return k}}canTunnel(a){return!!h(a)}createWithProvider(a,f,p,b,E,k,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${b}.`);const c=p;this._factoryInProgress.add(c);const i=b===void 0?p:b,n={elevationRequired:E?this.isPortPrivileged(i):!1},o={remoteAddress:{host:f,port:p},localAddressPort:b,privacy:k,public:k?k!==P.Private:void 0,protocol:t},u=a.forwardPort(o,n);return u?(this.addTunnelToMap(f,p,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(c)})):this._factoryInProgress.delete(c),u}};y=we([X(0,R.ILogService),X(1,M.IConfigurationService)],y),e.AbstractTunnelService=y}),define(Z[246],ee([0,1,83,26,101,233,7,2,18,5,21,232,122,92,4]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function m(E,k,t,c,i){let n;for(let o=3;o&&(n?.dispose(),n=await new a(E,k,t,c,i).waitForReady(),!(i&&r.BROWSER_RESTRICTED_PORTS[i]||!r.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));o--);return n}class a extends P.Disposable{constructor(k,t,c,i,n){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=n,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=k,this._server=I.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=o=>this._onConnection(o),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const k=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,S.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let c=await(0,r.findFreePortFaster)(k,2,1e3,t),i=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(k){k.pause();const t=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,v.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),i=c.getSocket().socket,n=c.readEntireBuffer();c.dispose(),n.byteLength>0&&k.write(n.buffer),k.on("end",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),i.end()}),k.on("close",()=>i.end()),k.on("error",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),i.destroy()}),i.on("end",()=>k.end()),i.on("close",()=>k.end()),i.on("error",()=>{k.destroy()}),k.pipe(i),i.pipe(k),k.localAddress&&this._socketsDispose.set(k.localAddress,()=>{k.end(),i.end()})}}let f=class extends S.AbstractTunnelService{constructor(k,t,c,i,n){super(t,n),this.socketFactory=k,this.signService=c,this.productService=i}isPortPrivileged(k){return(0,S.isPortPrivileged)(k,this.defaultTunnelHost,y.OS,M.release())}retainOrCreateTunnel(k,t,c,i,n,o,u,s){const d=this.getTunnelFromMap(t,c);if(d)return++d.refcount,d.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,t,c,n,o,u,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${n}.`);const C={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:k,signService:this.signService,logService:this.logService,ipcLogger:null},L=m(C,i,t,c,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,c,L),L}}};f=we([X(1,h.ILogService),X(2,l.ISignService),X(3,w.IProductService),X(4,g.IConfigurationService)],f),e.BaseTunnelService=f;let p=class extends f{constructor(k,t,c,i){super(R.nodeSocketFactory,k,t,c,i)}};p=we([X(0,h.ILogService),X(1,l.ISignService),X(2,w.IProductService),X(3,g.IConfigurationService)],p),e.TunnelService=p;let b=class extends P.Disposable{constructor(k,t,c,i){super(),this.logService=k,this.productService=t,this.signService=c,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(k,t,c,i,n,o,u,s,d){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${o}.`),!this._tunnelServices.has(k)){const C=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(C),this._tunnelServices.set(k,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this._tunnelServices.delete(k))})}return this._tunnelServices.get(k).openTunnel(t,c,i,n,o,u,s,d)}};b=we([X(0,h.ILogService),X(1,w.IProductService),X(2,l.ISignService),X(3,g.IConfigurationService)],b),e.SharedTunnelsService=b}),define(Z[49],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(M=e.StateType||(e.StateType={}));var r;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap",R[R.WindowsInstaller=3]="WindowsInstaller"})(r=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(Z[247],ee([0,1,4,181,68,51]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,M.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,M.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,M.localize)(2,null),(0,M.localize)(3,null),(0,M.localize)(4,null),(0,M.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,M.localize)(6,null),deprecationMessage:(0,M.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,M.localize)(8,null),description:(0,M.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,M.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[248],ee([0,1,3,49]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(P){this.service=P}listen(P,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(P,g,h){switch(g){case"checkForUpdates":return this.service.checkForUpdates(h);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(h)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=r;class R{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,this._state=M.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=R}),define(Z[94],ee([0,1,7,22,3,18,28,20,5,21,56,49]),function(x,e,I,M,r,R,D,P,g,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(y,m,a){return`${a.updateUrl}/api/update/${y}/${m}/${a.commit}`}e.createUpdateURL=S;let l=class{get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}constructor(m,a,f,p,b,E){this.lifecycleMainService=m,this.configurationService=a,this.environmentMainService=f,this.requestService=p,this.logService=b,this.productService=E,this._state=v.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.configurationService.getValue("update.mode"),a=this.getProductQuality(m);if(!a){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(a),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(v.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,f=>this.logService.error(f))}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,I.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},M.CancellationToken.None)).res.statusCode===204}catch(a){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(a);return}}async _applySpecificUpdate(m){}getUpdateType(){return 1}doQuitAndInstall(){}};l=we([X(0,P.ILifecycleMainService),X(1,R.IConfigurationService),X(2,D.IEnvironmentMainService),X(3,w.IRequestService),X(4,g.ILogService),X(5,h.IProductService)],l),e.AbstractUpdateService=l}),define(Z[249],ee([0,1,15,54,3,2,18,28,20,5,21,56,24,49,94]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends y.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"error",(f,p)=>p)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(f,p,b)=>({url:p,version:b,productVersion:b}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(f,p,b,E)=>({releaseNotes:p,version:b,productVersion:b,date:E}))}constructor(f,p,b,E,k,t,c){super(f,p,E,k,t,c),this.telemetryService=b,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(f){this.logService.error("UpdateService error:",f);const b=(this.state.type==="checking for updates"?this.state.explicit:!0)?f:void 0;this.setState(l.State.Idle(1,b))}buildUpdateFeedUrl(f){let p;this.productService.darwinUniversalAssetId?p=this.productService.darwinUniversalAssetId:p=process.arch==="x64"?"darwin":"darwin-arm64";const b=(0,y.createUpdateURL)(p,f,this.productService);try{I.autoUpdater.setFeedURL({url:b})}catch(E){this.logService.error("Failed to set update feed URL",E);return}return b}doCheckForUpdates(f){this.setState(l.State.CheckingForUpdates(f)),I.autoUpdater.checkForUpdates()}onUpdateAvailable(f){this.state.type==="checking for updates"&&this.setState(l.State.Downloading(f))}onUpdateDownloaded(f){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:f.version}),this.setState(l.State.Ready(f)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(l.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};we([M.memoize],m.prototype,"onRawError",null),we([M.memoize],m.prototype,"onRawUpdateNotAvailable",null),we([M.memoize],m.prototype,"onRawUpdateAvailable",null),we([M.memoize],m.prototype,"onRawUpdateDownloaded",null),m=we([X(0,g.ILifecycleMainService),X(1,D.IConfigurationService),X(2,S.ITelemetryService),X(3,P.IEnvironmentMainService),X(4,v.IRequestService),X(5,h.ILogService),X(6,w.IProductService)],m),e.DarwinUpdateService=m}),define(Z[250],ee([0,1,46,41,7,3,9,28,20,5,24,49]),function(x,e,I,M,r,R,D,P,g,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}constructor(m,a,f){if(this.lifecycleMainService=m,this.logService=f,this._state=v.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,a.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(v.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}scheduleCheckForUpdates(m=60*60*1e3){return(0,r.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(m){}};S=we([X(0,g.ILifecycleMainService),X(1,P.IEnvironmentMainService),X(2,h.ILogService)],S);let l=class extends S{constructor(m,a,f,p,b,E){super(f,p,b),this.snap=m,this.snapRevision=a,this.telemetryService=E;const k=(0,M.watch)(D.dirname(this.snap)),t=R.Event.fromNodeEventEmitter(k,"change",(o,u)=>u),c=R.Event.filter(t,o=>o==="current"),n=R.Event.debounce(c,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));f.onWillShutdown(()=>{n.dispose(),k.close()})}doCheckForUpdates(){this.setState(v.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(v.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(v.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(v.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((f,p)=>(0,M.realpath)(`${D.dirname(this.snap)}/current`,(b,E)=>b?p(b):f(E))),a=D.basename(m);return this.snapRevision!==a}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};l=we([X(2,g.ILifecycleMainService),X(3,P.IEnvironmentMainService),X(4,h.ILogService),X(5,w.ITelemetryService)],l),e.SnapUpdateService=l}),define(Z[39],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(Z[251],ee([0,1,39,200,16,19,134,3,2]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class h{constructor(S){this.uri=S,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let w=class{constructor(S){this._fileService=S,this._dispooables=new g.DisposableStore,this._limit=2**16;const l=new Map,y=m=>{let a=l.get(m.scheme);return a===void 0&&(a=S.hasProvider(m)&&!this._fileService.hasCapability(m,1024),l.set(m.scheme,a)),a};this._dispooables.add(P.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(m=>{l.delete(m.scheme)})),this.extUri=new R.ExtUri(y),this._canonicalUris=new D.SkipList((m,a)=>this.extUri.compare(m,a,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,R.normalizePath)(S));const l=this._canonicalUris.get(S);return l?l.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new h(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((y,m)=>y[1].time<m[1].time?1:y[1].time>m[1].time?-1:0);h._clock=0,this._canonicalUris.clear();const l=this._limit*.5;for(let y=0;y<l;y++)this._canonicalUris.set(S[y][0],S[y][1].touch())}};w=we([X(0,r.IFileService)],w),e.UriIdentityService=w,(0,M.registerSingleton)(I.IUriIdentityService,w,1)}),define(Z[123],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(Z[252],ee([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(P){this.handler=P}listen(P,g){throw new Error(`Event not found: ${g}`)}call(P,g,h){switch(g){case"handleURL":return this.handler.handleURL(I.URI.revive(h[0]),h[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=M;class r{constructor(P){this.channel=P}handleURL(P,g){return this.channel.call("handleURL",[P.toJSON(),g])}}e.URLHandlerChannelClient=r;class R{constructor(P,g){this.next=P,this.logService=g}async routeCall(P,g,h,w){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(h)&&h.length>0){const v=I.URI.revive(h[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const S=/\bwindowId=(\d+)/.exec(v.query);if(S){const l=S[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${l}"`,v.toString(!0));const y=new RegExp(`window:${l}`),m=P.connections.find(a=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",a.ctx),y.test(a.ctx)));if(m)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),m;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(P,g,h,w)}routeEvent(P,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=R}),define(Z[253],ee([0,1,7,2,8,21]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends M.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(h,w){const v=[...this.handlers.values()];return(0,I.first)(v.map(S=>()=>S.handleURL(h,w)),void 0,!1).then(S=>S||!1)}registerHandler(h){return this.handlers.add(h),(0,M.toDisposable)(()=>this.handlers.delete(h))}}e.AbstractURLService=D;let P=class extends D{constructor(h){super(),this.productService=h}create(h){let{authority:w,path:v,query:S,fragment:l}=h||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return w&&v&&v.indexOf("/")!==0&&(v=`/${v}`),r.URI.from({scheme:this.productService.urlProtocol,authority:w,path:v,query:S,fragment:l})}};P=we([X(0,R.IProductService)],P),e.NativeURLService=P}),define(Z[254],ee([0,1,15,7,3,2,4,8]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class g{constructor(w,v,S,l,y,m){if(this.urlService=v,this.logService=m,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,w&&(m.trace("ElectronURLListener initialUrisToHandle:",w.map(p=>p.originalUrl)),this.uris=w),D.isWindows){const p=l.isBuilt?[]:[`"${l.appRoot}"`];p.push("--open-url","--"),I.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,p)}const a=r.Event.map(r.Event.fromNodeEventEmitter(I.app,"open-url",(p,b)=>({event:p,url:b})),({event:p,url:b})=>(p.preventDefault(),b));this.disposables.add(a(p=>{const b=this.uriFromRawUrl(p);!b||this.urlService.open(b,{originalUrl:p})})),S.getWindows().filter(p=>p.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(w){try{return P.URI.parse(w)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const w=[];for(const v of this.uris)await this.urlService.open(v.uri,{originalUrl:v.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),w.push(v));w.length!==0&&(this.uris=w,this.flushDisposable=(0,M.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(Z[255],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(Z[256],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(Z[257],ee([0,1,15,2,14,8]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends M.Disposable{constructor(){super();const g=this.handleWebviewRequest.bind(this);I.protocol.registerFileProtocol(r.Schemas.vscodeWebview,g)}handleWebviewRequest(g,h){try{const w=R.URI.parse(g.url),v=D.validWebviewFilePaths.get(w.path);if(typeof v=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${v}`,l=r.FileAccess.asFileUri(S);return h({path:decodeURIComponent(l.fsPath),headers:{...r.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return h({error:-10})}catch{}return h({error:-2})}}D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=D}),define(Z[78],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(w){return!!w.workspaceUri}e.isWorkspaceToOpen=M;function r(w){return!!w.folderUri}e.isFolderToOpen=r;function R(w){return!!w.fileUri}e.isFileToOpen=R;function D(w){const v=P(w),S=w.getValue("window.menuBarVisibility");return S==="default"||v==="native"&&S==="compact"||I.isMacintosh&&I.isNative?"classic":S}e.getMenuBarVisibility=D;function P(w){if(I.isWeb)return"custom";const v=w.getValue("window");if(v){if(I.isMacintosh&&v.nativeTabs===!0||I.isMacintosh&&v.nativeFullScreen===!1)return"native";const y=v.titleBarStyle;if(y==="native"||y==="custom")return y}return I.isLinux?"native":"custom"}e.getTitleBarStyle=P;function g(w){if(!I.isWindows||I.isWeb||P(w)==="native")return!1;const v=w.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=g;function h(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=h}),define(Z[124],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var M;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));const r=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=r;var R;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(Z[30],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var M;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}))}),define(Z[258],ee([0,1,15,22,3,60,2,31,76,111,5,21,30]),function(x,e,I,M,r,R,D,P,g,h,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var l;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(l||(l={}));let y=class extends D.Disposable{constructor(a,f,p,b,E){super(),this.logService=a,this.windowsMainService=f,this.credentialsService=p,this.encryptionMainService=b,this.productService=E,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=l.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const a=r.Event.fromNodeEventEmitter(I.app,"login",(f,p,b,E,k)=>({event:f,webContents:p,req:b,authInfo:E,callback:k}));this._register(a(this.onLogin,this))}async onLogin({event:a,authInfo:f,req:p,callback:b}){if(!f.isProxy)return;if(!this.pendingProxyResolve&&this.state===l.LoginDialogShown&&p.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}a.preventDefault();let E;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(f);try{E=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}b(E?.username,E?.password)}async resolveProxyCredentials(a){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const f=await this.doResolveProxyCredentials(a);if(f)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),f;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(a){this.logService.trace("auth#doResolveProxyCredentials - enter",a);const f=String((0,R.hash)({scheme:a.scheme,host:a.host,port:a.port}));let p,b;try{const c=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,f);if(c){const i=JSON.parse(await this.encryptionMainService.decrypt(c));p=i.username,b=i.password}}catch(c){this.logService.error(c)}if(this.state!==l.StoredCredentialsUsed&&typeof p=="string"&&typeof b=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=l.StoredCredentialsUsed,{username:p,password:b};const E=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!E){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const k={authInfo:a,username:this.sessionCredentials?.username??p,password:this.sessionCredentials?.password??b,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,k),this.state=l.LoginDialogShown;const t=await new Promise(c=>{const i=async(n,o,u)=>{if(o===k.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",i),u){const s={username:u.username,password:u.password};try{if(u.remember){const d=await this.encryptionMainService.encrypt(JSON.stringify(s));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,f,d)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,f)}catch(d){this.logService.error(d)}c({username:s.username,password:s.password})}else c(void 0)};E.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=t,t}};y=we([X(0,w.ILogService),X(1,S.IWindowsMainService),X(2,g.ICredentialsMainService),X(3,h.IEncryptionMainService),X(4,v.IProductService)],y),e.ProxyAuthHandler=y}),define(Z[259],ee([0,1,76,5,34,21,30,211]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends P.BaseCredentialsMainService{constructor(w,v,S,l){super(w),this.environmentMainService=v,this.productService=S,this.windowsMainService=l,this.surfaceKeytarLoadError=y=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new I.InMemoryCredentialsProvider,this._keytarCache;const w=await new Promise((v,S)=>{x(["keytar"],v,S)});return await w.findCredentials("test-keytar-loads"),this._keytarCache=w,this._keytarCache}};g=we([X(0,M.ILogService),X(1,r.INativeEnvironmentService),X(2,R.IProductService),X(3,D.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(Z[260],ee([0,1,15,25,4,8,23,18,62,6,5,123,30]),function(x,e,I,M,r,R,D,P,g,h,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,h.createDecorator)(e.ID);let l=class{constructor(m,a,f,p){this.logService=m,this.windowsMainService=a,this.urlService=f,this.configurationService=p}async start(m,a){this.logService.trace("Received data from other instance: ",m,a),r.isMacintosh&&I.app.focus({steal:!0});const f=this.parseOpenUrl(m);if(f.length){let p=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const b=(0,M.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));b&&(p=b.ready())}p.then(()=>{for(const{uri:b,originalUrl:E}of f)this.urlService.open(b,{originalUrl:E})})}else return this.startOpenWindow(m,a)}parseOpenUrl(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,M.coalesce)(m._urls.map(a=>{try{return{uri:R.URI.parse(a),originalUrl:a}}catch{return null}})):[]}async startOpenWindow(m,a){const f=(0,g.isLaunchedFromCli)(a)?0:4;let p=[];const b=m.wait&&m.waitMarkerFilePath?R.URI.file(m.waitMarkerFilePath):void 0,E=m.remote||void 0,k={context:f,cli:m,userEnv:a,waitMarkerFileURI:b,remoteAuthority:E,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,k);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let t=!1;if(m["new-window"]||m["unity-launch"]||k.forceProfile||k.forceTempProfile)t=!0;else if(m["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)p=await this.windowsMainService.open({...k,forceNewWindow:!0,forceEmpty:!0});else{const c=this.windowsMainService.getLastActiveWindow();c?(this.windowsMainService.openExistingWindow(c,k),p=[c]):p=await this.windowsMainService.open({...k,forceEmpty:!0})}}else p=await this.windowsMainService.open({...k,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(b&&p.length===1&&p[0])return Promise.race([p[0].whenClosedOrLoaded,(0,D.whenDeleted)(b.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};l=we([X(0,w.ILogService),X(1,S.IWindowsMainService),X(2,v.IURLService),X(3,P.IConfigurationService)],l),e.LaunchMainService=l}),define(Z[95],ee([0,1,15,2,3,5,261,7,14,71,30,74,24,20,72,37]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;let a=class It extends M.Disposable{constructor(b,E,k){super(),this.logService=b,this.telemetryService=E,this.lifecycleMainService=k,this.id=String(++It.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(b,E){let k;switch(this.configuration?.correlationId?k=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${b}`:k=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${b}`,E){case v.default.Error:this.logService.error(k);break;case v.default.Warning:this.logService.warn(k);break;case v.default.Info:this.logService.info(k);break}}validateCanStart(){if(!h.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");return this.process?(this.log("Cannot start utility process because it is already running...",v.default.Error),!1):!0}start(b){const E=this.doStart(b,!1);return E&&b.payload&&this.postMessage(b.payload),E}doStart(b,E){if(!this.validateCanStart())return!1;this.configuration=b;const k=`${this.configuration.type}-${this.id}`,t=g.FileAccess.asFileUri("bootstrap-fork.js").fsPath,c=this.configuration.args??[],i=this.configuration.execArgv??[],n=this.configuration.allowLoadingUnsignedLibraries,o="pipe",u=this.createEnv(b,E);return this.log("creating new...",v.default.Info),this.process=h.UtilityProcess.fork(t,c,{serviceName:k,env:u,execArgv:i,allowLoadingUnsignedLibraries:n,stdio:o}),this.registerListeners(this.process,this.configuration,k,E),!0}createEnv(b,E){const k=b.env?{...b.env}:{...(0,m.deepClone)(process.env)};k.VSCODE_AMD_ENTRYPOINT=b.entryPoint,typeof b.parentLifecycleBound=="number"&&(k.VSCODE_PARENT_PID=String(b.parentLifecycleBound)),E&&(k.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),k.VSCODE_CRASH_REPORTER_PROCESS_TYPE=b.type,(0,y.removeDangerousEnvVariables)(k);for(const t of Object.keys(k))k[t]=String(k[t]);return k}registerListeners(b,E,k,t){if(b.stdout){const c=new D.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(b.stdout,"data")(i=>this._onStdout.fire(typeof i=="string"?i:c.write(i))))}if(b.stderr){const c=new D.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(b.stderr,"data")(i=>this._onStderr.fire(typeof i=="string"?i:c.write(i))))}this._register(r.Event.fromNodeEventEmitter(b,"message")(c=>this._onMessage.fire(c))),this._register(r.Event.fromNodeEventEmitter(b,"spawn")(()=>{this.processPid=b.pid,this.log("successfully created",v.default.Info)})),this._register(r.Event.fromNodeEventEmitter(b,"exit")(c=>{this.log(`received exit event with code ${c}`,v.default.Info),this._onExit.fire({pid:this.processPid,code:c,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(I.app,"child-process-gone",(c,i)=>({event:c,details:i}))(({details:c})=>{c.type==="Utility"&&c.name===k&&(this.log(`crashed with code ${c.exitCode} and reason '${c.reason}'`,v.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:E.type,reason:c.reason,code:c.exitCode,sandboxed:t?"1":"0"}),this._onCrash.fire({pid:this.processPid,code:c.exitCode,reason:c.reason}),this.onDidExitOrCrashOrKill())}))}once(b,E){const k=this._register(this._onMessage.event(t=>{t===b&&(k.dispose(),E())}))}postMessage(b,E){!this.process||this.process.postMessage(b,E)}connect(b){const{port1:E,port2:k}=new I.MessageChannelMain;return this.postMessage(b,[k]),E}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",v.default.Info);const b=process;return typeof b._debugProcess=="function"?(b._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",v.default.Info),this.process.kill()?(this.log("successfully killed the process",v.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",v.default.Warning)}onDidExitOrCrashOrKill(){this.process=void 0}async waitForExit(b){!this.process||(this.log("waiting to exit...",v.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,P.timeout)(b)]),this.process&&(this.log(`did not exit within ${b}ms, will kill it now...`,v.default.Info),this.kill()))}};a.ID_COUNTER=0,a=we([X(0,R.ILogService),X(1,S.ITelemetryService),X(2,l.ILifecycleMainService)],a),e.UtilityProcess=a;let f=class extends a{constructor(b,E,k,t){super(b,k,t),this.windowsMainService=E}start(b){const E=this.windowsMainService.getWindowById(b.responseWindowId);if(!E?.win||E.win.isDestroyed()||E.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",v.default.Error),!0;if(!super.doStart(b,E.isSandboxed))return!1;this.registerWindowListeners(E.win,b);const t=this.connect(b.payload);return E.win.webContents.postMessage(b.responseChannel,b.responseNonce,[t]),!0}registerWindowListeners(b,E){E.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,k=>k.window.win===b)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(b,"closed")(()=>this.kill())))}};f=we([X(0,R.ILogService),X(1,w.IWindowsMainService),X(2,S.ITelemetryService),X(3,l.ILifecycleMainService)],f),e.WindowUtilityProcess=f}),define(Z[262],ee([0,1,13,2,3,5,20,73,46,261,7,14,37,4,36,71,95,30,24]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let b=class Pt{constructor(t,c,i,n){this._logService=t,this._lifecycleMainService=c,this._windowsMainService=i,this._telemetryService=n,this._shutdown=!1,this._extHosts=new Map,this._lifecycleMainService.onWillShutdown(o=>{this._shutdown=!0,o.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(t){const c=this._extHosts.get(t);if(!c)throw new Error("Unknown extension host!");return c}onDynamicStdout(t){return this._getExtHost(t).onStdout}onDynamicStderr(t){return this._getExtHost(t).onStderr}onDynamicMessage(t){return this._getExtHost(t).onMessage}onDynamicError(t){const c=this._getExtHost(t);return c instanceof a.WindowUtilityProcess?r.Event.None:c.onError}onDynamicExit(t){return this._getExtHost(t).onExit}async canUseUtilityProcess(){return m.canUseUtilityProcess}async createExtensionHost(t){if(this._shutdown)throw(0,I.canceled)();const c=String(++Pt._lastId);let i;if(t){if(!m.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new a.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService)}else i=new E(c,this._logService);return this._extHosts.set(c,i),i.onExit(({pid:n,code:o,signal:u})=>{this._logService.info(`Extension host with pid ${n} exited with code: ${o}, signal: ${u}.`),setTimeout(()=>{i.dispose(),this._extHosts.delete(c)})}),{id:c}}async start(t,c){if(this._shutdown)throw(0,I.canceled)();this._getExtHost(t).start({...c,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:c.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this._shutdown)throw(0,I.canceled)();const c=this._extHosts.get(t);return c?c.enableInspectPort():!1}async kill(t){if(this._shutdown)throw(0,I.canceled)();const c=this._extHosts.get(t);!c||c.kill()}async _killAllNow(){for(const[,t]of this._extHosts)t.kill()}async _waitForAllExit(t){const c=[];for(const[,i]of this._extHosts)c.push(i.waitForExit(t));return w.Promises.settled(c).then(()=>{})}};b._lastId=0,b=we([X(0,R.ILogService),X(1,D.ILifecycleMainService),X(2,f.IWindowsMainService),X(3,p.ITelemetryService)],b),e.ExtensionHostStarter=b;let E=class extends M.Disposable{constructor(t,c){super(),this.id=t,this._logService=c,this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(t){l.isCI&&this._logService.info("Calling fork to start extension host...");const c=P.StopWatch.create(!1);this._process=(0,g.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,y.cwd)()},t));const i=c.elapsed(),n=this._process.pid;this._logService.info(`Starting extension host with pid ${n} (fork() took ${i} ms).`);const o=new h.StringDecoder("utf-8");this._process.stdout?.on("data",s=>{const d=typeof s=="string"?s:o.write(s);this._onStdout.fire(d)});const u=new h.StringDecoder("utf-8");this._process.stderr?.on("data",s=>{const d=typeof s=="string"?s:u.write(s);this._onStderr.fire(d)}),this._process.on("message",s=>{this._onMessage.fire(s)}),this._process.on("error",s=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(s)})}),this._process.on("exit",(s,d)=>{this._hasExited=!0,this._onExit.fire({pid:n,code:s,signal:d})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):l.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(t){if(!this._process)return;const c=this._process.pid;this._logService.info(`Waiting for extension host with pid ${c} to exit.`),await Promise.race([r.Event.toPromise(this.onExit),(0,w.timeout)(t)]),this._hasExited||(this._logService.info(`Extension host with pid ${c} did not exit within ${t}ms.`),this._process.kill())}};E=we([X(1,R.ILogService)],E)}),define(Z[263],ee([0,1,2,6,5,30,95,24,60,3,7,20]),function(x,e,I,M,r,R,D,P,g,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,M.createDecorator)("utilityProcessWorker");let S=class extends I.Disposable{constructor(m,a,f,p){super(),this.logService=m,this.windowsMainService=a,this.telemetryService=f,this.lifecycleMainService=p,this.workers=new Map}async createWorker(m){const a=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${a})`);const f=this.hash(m);this.workers.has(f)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${a})`),this.disposeWorker(m));const p=new l(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,m);if(!p.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(f,p);const b=new w.DeferredPromise;return h.Event.once(p.onDidTerminate)(E=>{this.workers.delete(f),b.complete({reason:E})}),b.p}hash(m){return(0,g.hash)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const a=this.hash(m),f=this.workers.get(a);!f||(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),f.kill(),this.workers.delete(a))}};S=we([X(0,r.ILogService),X(1,R.IWindowsMainService),X(2,P.ITelemetryService),X(3,v.ILifecycleMainService)],S),e.UtilityProcessWorkerMainService=S;let l=class extends I.Disposable{constructor(m,a,f,p,b){super(),this.logService=m,this.windowsMainService=a,this.telemetryService=f,this.lifecycleMainService=p,this.configuration=b,this._onDidTerminate=this._register(new h.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new D.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(m=>this._onDidTerminate.fire({code:m.code,signal:m.signal}))),this._register(this.utilityProcess.onCrash(m=>this._onDidTerminate.fire({code:m.code,signal:"ECRASH"})))}spawn(){const a=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:a,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};l=we([X(0,r.ILogService),X(1,R.IWindowsMainService),X(2,P.ITelemetryService),X(3,v.ILifecycleMainService)],l)}),define(Z[264],ee([0,1,15,3,2,257,30]),function(x,e,I,M,r,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends r.Disposable{constructor(h){super(),this.windowsMainService=h,this._onFoundInFrame=this._register(new M.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(h,w){let v;if(typeof h.windowId=="number"){const{windowId:S}=h,l=this.windowsMainService.getWindowById(S);if(!l?.win)throw new Error(`Invalid windowId: ${S}`);v=l.win.webContents}else{const{webContentsId:S}=h;if(v=I.webContents.fromId(S),!v)throw new Error(`Invalid webContentsId: ${S}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(w)}async findInFrame(h,w,v,S){const y=this.getFrameByName(h,w);if(typeof y.findInFrame=="function"){y.findInFrame(v,{findNext:S.findNext,forward:S.forward});const m=(a,f)=>{f.finalUpdate&&(this._onFoundInFrame.fire(f),y.removeListener("found-in-frame",m))};y.on("found-in-frame",m)}}async stopFindInFrame(h,w,v){const l=this.getFrameByName(h,w);typeof l.stopFindInFrame=="function"&&l.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}getFrameByName(h,w){const v=this.windowsMainService.getWindowById(h.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${h}`);const S=v.win.webContents.mainFrame.framesInSubtree.find(l=>l.name===w);if(!S)throw new Error(`Unknown frame: ${w}`);return S}};P=we([X(0,D.IWindowsMainService)],P),e.WebviewMainService=P}),define(Z[265],ee([0,1,7,3,2]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends r.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:g,getActiveWindowId:h}){super(),this.disposables=this._register(new r.DisposableStore),M.Event.latch(M.Event.any(P,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,I.createCancelablePromise)(()=>h()),(async()=>{try{const v=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:v}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[29],ee([0,1,185,9,61,19,8,6,14]),function(x,e,I,M,r,R,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function h(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=h;function w(i){return typeof i?.id=="string"&&!h(i)&&!S(i)}e.isEmptyWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,M.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=v;function S(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=S;function l(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=l;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=m;function a(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=a;class f{constructor(n,o,u,s,d){this._id=n,this._transient=u,this._configuration=s,this._ignorePathCasing=d,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(i){return new p({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function k(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=k;function t(i,n){return!E(i,n)&&!k(i)}e.isSavedWorkspace=t;function c(i){return(typeof i=="string"?(0,M.extname)(i):(0,R.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=c}),define(Z[57],ee([0,1,15,7,60,45,2,81,4,10,23,162,89,6,5,21,29]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,l.createDecorator)("dialogMainService");let f=class{constructor(b,E){this.logService=b,this.productService=E,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new M.Queue}pickFileFolder(b,E){return this.doPick({...b,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},E)}pickFolder(b,E){return this.doPick({...b,pickFolders:!0,title:(0,v.localize)(1,null)},E)}pickFile(b,E){return this.doPick({...b,pickFiles:!0,title:(0,v.localize)(2,null)},E)}pickWorkspace(b,E){const k=(0,v.localize)(3,null),t=(0,R.mnemonicButtonLabel)((0,v.localize)(4,null)),c=a.WORKSPACE_FILTER;return this.doPick({...b,pickFiles:!0,title:k,filters:c,buttonLabel:t},E)}async doPick(b,E){const k={title:b.title,buttonLabel:b.buttonLabel,filters:b.filters,defaultPath:b.defaultPath};(typeof b.pickFiles=="boolean"||typeof b.pickFolders=="boolean")&&(k.properties=void 0,b.pickFiles&&b.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",b.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&k.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(k,(0,h.withNullAsUndefined)(E||I.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}getWindowDialogQueue(b){if(b){let E=this.windowDialogQueues.get(b.id);return E||(E=new M.Queue,this.windowDialogQueues.set(b.id,E)),E}else return this.noWindowDialogueQueue}showMessageBox(b,E){return this.getWindowDialogQueue(E).queue(async()=>{const{options:k,buttonIndeces:t}=(0,S.massageMessageBoxOptions)(b,this.productService);let c;return E?c=await I.dialog.showMessageBox(E,k):c=await I.dialog.showMessageBox(k),{response:t[c.response],checkboxChecked:c.checkboxChecked}})}async showSaveDialog(b,E){const k=this.acquireFileDialogLock(b,E);if(!k)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(E).queue(async()=>{let t;return E?t=await I.dialog.showSaveDialog(E,b):t=await I.dialog.showSaveDialog(b),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,D.dispose)(k)}}normalizePath(b){return b&&g.isMacintosh&&(b=(0,P.normalizeNFC)(b)),b}normalizePaths(b){return b.map(E=>this.normalizePath(E))}async showOpenDialog(b,E){b.defaultPath&&(await w.Promises.exists(b.defaultPath)||(b.defaultPath=void 0));const k=this.acquireFileDialogLock(b,E);if(!k)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(E).queue(async()=>{let t;return E?t=await I.dialog.showOpenDialog(E,b):t=await I.dialog.showOpenDialog(b),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,D.dispose)(k)}}acquireFileDialogLock(b,E){if(!E)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",b);let k=this.windowFileDialogLocks.get(E.id);k||(k=new Set,this.windowFileDialogLocks.set(E.id,k));const t=(0,r.hash)(b);if(!k.has(t))return this.logService.trace("[DialogMainService]: new file dialog lock created",b),k.add(t),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",b),k?.delete(t),k?.size===0&&this.windowFileDialogLocks.delete(E.id)})}};f=we([X(0,y.ILogService),X(1,m.IProductService)],f),e.DialogMainService=f}),define(Z[266],ee([0,1,3,2,84,29]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends M.Disposable{constructor(g,h){super(),this.logService=g,this.storageMainService=h,this.onDidChangeApplicationStorageEmitter=this._register(new I.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(h.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(g,h){this._register(I.Event.debounce(g.onDidChangeStorage,(w,v)=>(w?w.push(v):w=[v],w),D.STORAGE_CHANGE_DEBOUNCE_TIME)(w=>{w.length&&h.fire(this.serializeStorageChangeEvents(w,g))}))}serializeStorageChangeEvents(g,h){const w=new Map,v=new Set;return g.forEach(S=>{const l=h.get(S.key);typeof l=="string"?w.set(S.key,l):v.add(S.key)}),{changed:Array.from(w.entries()),deleted:Array.from(v.values())}}listen(g,h,w){switch(h){case"onDidChangeStorage":{const v=w.profile?(0,r.revive)(w.profile):void 0;if(!v)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(v.id);return S||(S=this._register(new I.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(v),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(v.id,S)),S.event}}throw new Error(`Event not found: ${h}`)}async call(g,h,w){const v=w.profile?(0,r.revive)(w.profile):void 0,S=(0,R.reviveIdentifier)(w.workspace),l=await this.withStorageInitialized(v,S);switch(h){case"getItems":return Array.from(l.items.entries());case"updateItems":{const y=w;if(y.insert)for(const[m,a]of y.insert)l.set(m,a);y.delete?.forEach(m=>l.delete(m));break}case"isUsed":{const y=w.payload;if(typeof y=="string")return this.storageMainService.isUsed(y)}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(g,h){let w;h?w=this.storageMainService.workspaceStorage(h):g?w=this.storageMainService.profileStorage(g):w=this.storageMainService.applicationStorage;try{await w.init()}catch(v){this.logService.error(`StorageIPC#init: Unable to init ${h?"workspace":g?"profile":"application"} storage due to ${v}`)}return w}}D.STORAGE_CHANGE_DEBOUNCE_TIME=100,e.StorageDatabaseChannel=D}),define(Z[40],ee([0,1,60,3,2,19,8,182,34,16,6,5,29,35,39,7,31,27,10]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.isUserDataProfile=b,e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function E(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=E;function k(i,n,o,u){return{id:i,name:n,location:o,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}e.toUserDataProfile=k;let t=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,u,s){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=u,this.logService=s,this.enabled=!0,this._onDidChangeProfiles=this._register(new M.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new M.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new M.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new M.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new l.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=[];if(this.enabled)try{for(const d of this.getStoredProfiles()){if(!d.name||!(0,p.isString)(d.name)||!d.location){this.logService.warn("Skipping the invalid stored profile",d.location||d.name);continue}n.push(k((0,R.basename)(d.location),d.name,d.location,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}))}}catch(d){this.logService.error(d)}const o=new l.ResourceMap,u=new Map,s=this.createDefaultProfile();if(n.unshift({...s,extensionsResource:this.getDefaultProfileExtensionsLocation()??s.extensionsResource,isDefault:!0}),n.length)try{const d=this.getStoredProfileAssociations();if(d.workspaces)for(const[C,L]of Object.entries(d.workspaces)){const O=D.URI.parse(C),F=n.find(z=>z.id===L);F&&o.set(O,F)}if(d.emptyWindows)for(const[C,L]of Object.entries(d.emptyWindows)){const O=n.find(F=>F.id===L);O&&u.set(C,O)}}catch(d){this.logService.error(d)}this._profilesObject={profiles:n,workspaces:o,emptyWindows:u}}return this._profilesObject}createDefaultProfile(){return k("__default__profile__",(0,P.localize)(0,null),this.environmentService.userRoamingDataHome)}async createTransientProfile(n){const o="Temp",u=new RegExp(`${(0,f.escapeRegExpCharacters)(o)}\\s(\\d+)`);let s=0;for(const C of this.profiles){const L=u.exec(C.name),O=L?parseInt(L[1]):0;s=O>s?O:s}const d=`${o} ${s+1}`;return this.createProfile((0,I.hash)((0,a.generateUuid)()).toString(16),d,{transient:!0},n)}async createNamedProfile(n,o,u){return this.createProfile((0,I.hash)((0,a.generateUuid)()).toString(16),n,o,u)}async createProfile(n,o,u,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const d=await this.doCreateProfile(n,o,u);return s&&await this.setProfileForWorkspace(s,d),d}async doCreateProfile(n,o,u){if(!(0,p.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.profileCreationPromises.get(o);return s||(s=(async()=>{try{const d=this.profiles.find(O=>O.name===o||O.id===n);if(d)return d;const C=k(n,o,(0,R.joinPath)(this.profilesHome,n),u);await this.fileService.createFolder(C.location);const L=[];return this._onWillCreateProfile.fire({profile:C,join(O){L.push(O)}}),await m.Promises.settled(L),this.updateProfiles([C],[],[]),C}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,s)),s}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(s=>s.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=k(u.id,o.name??u.name,u.location,{shortName:o.shortName??u.shortName,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags}),this.updateProfiles([],[],[u]),u}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(s=>s.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:o,join(s){u.push(s)}});try{await Promise.allSettled(u)}catch(s){this.logService.error(s)}for(const s of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(s)?.id&&this.profilesObject.emptyWindows.delete(s);for(const s of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(s)?.id&&this.profilesObject.workspaces.delete(s);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(s){this.logService.error(s)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(s=>s.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,u)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return D.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(n){return(0,S.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,S.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,u){const s=[...this.profiles,...n],d=[];this.transientProfilesObject.profiles=[];for(let C of s)C.isDefault||o.some(L=>C.id===L.id)||(C=u.find(L=>C.id===L.id)??C,C.isTransient?this.transientProfilesObject.profiles.push(C):d.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.saveStoredProfiles(d),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,u)}triggerProfilesChanges(n,o,u){this._onDidChangeProfiles.fire({added:n,removed:o,updated:u,all:this.profiles})}updateWorkspaceAssociation(n,o,u){u=o?.isTransient?!0:u,u||this.updateWorkspaceAssociation(n,void 0,!0);const s=this.getWorkspace(n),d=u?this.transientProfilesObject:this.profilesObject;D.URI.isUri(s)?(d.workspaces.delete(s),o&&d.workspaces.set(s,o)):(d.emptyWindows.delete(s),o&&d.emptyWindows.set(s,o)),u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[u,s]of this.profilesObject.workspaces.entries())n[u.toString()]=s.id;const o={};for(const[u,s]of this.profilesObject.emptyWindows.entries())o[u.toString()]=s.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},u=this.createDefaultProfile();if(n.workspaces)for(const[d,C]of Object.entries(n.workspaces)){const L=D.URI.parse(C);o[d]=this.uriIdentityService.extUri.isEqual(L,u.location)?u.id:this.uriIdentityService.extUri.basename(L)}const s={};if(n.emptyWindows)for(const[d,C]of Object.entries(n.emptyWindows)){const L=D.URI.parse(C);s[d]=this.uriIdentityService.extUri.isEqual(L,u.location)?u.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:o,emptyWindows:s}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",t=we([X(0,g.IEnvironmentService),X(1,h.IFileService),X(2,y.IUriIdentityService),X(3,v.ILogService)],t),e.UserDataProfilesService=t;class c extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=c}),define(Z[79],ee([0,1,7,17,2,3,35,8,112,119,16,6,5,40,39,10,13,24]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class b extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let E=class extends r.Disposable{constructor(i,n,o,u,s,d){super(),this.extensionsLocation=i,this.fileService=n,this.userDataProfilesService=o,this.uriIdentityService=u,this.telemetryService=s,this.logService=d,this._onAddExtensions=this._register(new R.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new R.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new R.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new R.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new D.ResourceMap}scanProfileExtensions(i,n){return this.withProfileExtensions(i,void 0,n)}async addExtensionsToProfile(i,n){const o=[],u=[];try{return await this.withProfileExtensions(n,s=>{const d=[];for(const C of s)i.some(([L])=>(0,h.areSameExtensions)(L.identifier,C.identifier)&&L.manifest.version!==C.version)?o.push(C):d.push(C);for(const[C,L]of i)if(!d.some(O=>(0,h.areSameExtensions)(O.identifier,C.identifier)&&O.version===C.manifest.version)){const O={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:L};u.push(O),d.push(O)}return u.length&&this._onAddExtensions.fire({extensions:u,profileLocation:n}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:n}),d}),u.length&&this._onDidAddExtensions.fire({extensions:u,profileLocation:n}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:n}),u}catch(s){throw u.length&&this._onDidAddExtensions.fire({extensions:u,error:s,profileLocation:n}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:s,profileLocation:n}),s}}async updateMetadata(i,n){const o=[];return await this.withProfileExtensions(n,u=>{const s=[];for(const d of u){const C=i.find(([L])=>(0,h.areSameExtensions)(L.identifier,d.identifier)&&L.manifest.version===d.version);C&&(d.metadata={...d.metadata,...C[1]},o.push(d)),s.push(d)}return s}),o}async removeExtensionFromProfile(i,n){const o=[];this._onRemoveExtensions.fire({extensions:o,profileLocation:n});try{await this.withProfileExtensions(n,u=>{const s=[];for(const d of u)(0,h.areSameExtensions)(d.identifier,i.identifier)?o.push(d):s.push(d);return o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:n}),s}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:n})}catch(u){throw o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:u,profileLocation:n}),u}}async withProfileExtensions(i,n,o){return this.getResourceAccessQueue(i).queue(async()=>{let u=[],s;try{const d=await this.fileService.readFile(i);s=JSON.parse(d.value.toString().trim()||"[]")}catch(d){if((0,w.toFileOperationResult)(d)!==1)throw d;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(s=await this.migrateFromOldDefaultProfileExtensionsLocation()),!s&&o?.bailOutWhenFileNotFound)throw new b((0,a.getErrorMessage)(d),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.reportAndThrowInvalidConentError(i);let d=!1;for(const C of s){k(C)||this.reportAndThrowInvalidConentError(i);let L;if((0,m.isString)(C.relativeLocation)&&C.relativeLocation)L=this.resolveExtensionLocation(C.relativeLocation);else if((0,m.isString)(C.location))L=this.resolveExtensionLocation(C.location),d=!0,C.relativeLocation=C.location,C.location=L.toJSON();else{L=P.URI.revive(C.location);const O=this.toRelativePath(L);O&&(d=!0,C.relativeLocation=O)}u.push({identifier:C.identifier,location:L,version:C.version,metadata:C.metadata})}d&&await this.fileService.writeFile(i,M.VSBuffer.fromString(JSON.stringify(s)))}if(n){u=n(u);const d=u.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.toRelativePath(C.location),metadata:C.metadata}));await this.fileService.writeFile(i,M.VSBuffer.fromString(JSON.stringify(d)))}return u})}reportAndThrowInvalidConentError(i){const n=new b(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let o;try{o=(await this.fileService.readFile(i)).value.toString()}catch(s){if((0,w.toFileOperationResult)(s)===1)return;throw s}this.logService.info("Migrating extensions from old default profile location",i.toString());let u;try{const s=JSON.parse(o);Array.isArray(s)&&s.every(d=>k(d))?u=s:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.logService.error(s)}if(u)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(s){if((0,w.toFileOperationResult)(s)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw s}try{await this.fileService.del(i)}catch(s){(0,w.toFileOperationResult)(s)!==1&&this.logService.error(s)}try{await this.fileService.del(n)}catch(s){(0,w.toFileOperationResult)(s)!==1&&this.logService.error(s)}return u})()),this._migrationPromise}getResourceAccessQueue(i){let n=this.resourcesAccessQueueMap.get(i);return n||(n=new I.Queue,this.resourcesAccessQueueMap.set(i,n)),n}};E=we([X(1,w.IFileService),X(2,l.IUserDataProfilesService),X(3,y.IUriIdentityService),X(4,f.ITelemetryService),X(5,S.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function k(c){return(0,m.isObject)(c)&&(0,g.isIExtensionIdentifier)(c.identifier)&&(t(c.location)||(0,m.isString)(c.location)&&c.location)&&((0,m.isUndefined)(c.relativeLocation)||(0,m.isString)(c.relativeLocation))&&c.version&&(0,m.isString)(c.version)}function t(c){return c?(0,m.isString)(c.path)&&(0,m.isString)(c.scheme):!1}}),define(Z[125],ee([0,1,25,7,37,17,13,43,147,2,14,9,4,19,198,74,10,8,167,34,119,116,197,16,6,5,21,3,84,79,40,39,195,196]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c,i,n,o,u,s,d,C,L,O,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var z;(function(ge){function V(B,T){if(B===T)return!0;const H=Object.keys(B),Y=new Set;for(const te of Object.keys(T))Y.add(te);if(H.length!==Y.size)return!1;for(const te of H){if(B[te]!==T[te])return!1;Y.delete(te)}return Y.size===0}ge.equals=V})(z=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let q=class extends h.Disposable{constructor(V,B,T,H,Y,te,ne,U,A,W,_,$){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=B,this.extensionsControlLocation=T,this.cacheLocation=H,this.userDataProfilesService=Y,this.extensionsProfileScannerService=te,this.fileService=ne,this.logService=U,this.environmentService=A,this.productService=W,this.uriIdentityService=_,this.instantiationService=$,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,l.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(oe,(0,l.joinPath)(this.cacheLocation,k.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(oe,(0,l.joinPath)(this.cacheLocation,k.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(se,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,B,T){const[H,Y]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(B)]),te=T?await this.scanExtensionsUnderDevelopment(V,[...H,...Y]):[];return this.dedupExtensions(H,Y,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const B=[];B.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),B.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[T,H]=await Promise.all(B);return this.applyScanOptions([...T,...H],0,V,!1)}async scanUserExtensions(V){const B=V.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",B);const T=this.uriIdentityService.extUri.isEqual(V.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,H=await this.createExtensionScannerInput(B,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,T),Y=V.useCache&&!H.devMode&&H.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let te;try{te=await Y.scanExtensions(H)}catch(ne){if(ne instanceof d.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),te=await Y.scanExtensions(H);else throw ne}return te=await this.applyScanOptions(te,1,V,!0),this.logService.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(V,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const T=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(H=>H.scheme===w.Schemas.file).map(async H=>{const Y=await this.createExtensionScannerInput(H,!1,1,!0,V.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(Y)).map(ne=>(ne.type=B.find(U=>(0,E.areSameExtensions)(U.identifier,ne.identifier))?.type??ne.type,this.extensionsScanner.validate(ne,Y)))}))).flat();return this.applyScanOptions(T,"development",V,!0)}return[]}async scanExistingExtension(V,B,T){const H=await this.createExtensionScannerInput(V,!1,B,!0,T.language,!0,void 0),Y=await this.extensionsScanner.scanExtension(H);return!Y||!T.includeInvalid&&!Y.isValid?null:Y}async scanOneOrMultipleExtensions(V,B,T){const H=await this.createExtensionScannerInput(V,!1,B,!0,T.language,!0,void 0),Y=await this.extensionsScanner.scanOneOrMultipleExtensions(H);return this.applyScanOptions(Y,B,T,!0)}async scanMetadata(V){const B=(0,l.joinPath)(V,"package.json"),T=(await this.fileService.readFile(B)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(V,B){const T=(0,l.joinPath)(V,"package.json"),H=(await this.fileService.readFile(T)).value.toString(),Y=JSON.parse(H);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,Y.__metadata={...Y.__metadata,...B},await this.fileService.writeFile((0,l.joinPath)(V,"package.json"),R.VSBuffer.fromString(JSON.stringify(Y,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof d.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw V}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.extensionsProfileScannerService.addExtensionsToProfile(V.map(B=>[B,B.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,c.toFileOperationResult)(B)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(B))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.logService.error(V)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(V,B,T,H){return T.includeAllVersions||(V=this.dedupExtensions(B===0?V:void 0,B===1?V:void 0,B==="development"?V:void 0,await this.getTargetPlatform(),H)),T.includeInvalid||(V=V.filter(Y=>Y.isValid)),V.sort((Y,te)=>{const ne=v.basename(Y.location.fsPath),U=v.basename(te.location.fsPath);return ne<U?-1:ne>U?1:0})}dedupExtensions(V,B,T,H,Y){const te=(U,A,W)=>{if(U.isValid&&!A.isValid)return!1;if(U.isValid===A.isValid){if(Y&&y.gt(U.manifest.version,A.manifest.version))return this.logService.debug(`Skipping extension ${A.location.path} with lower version ${A.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(y.eq(U.manifest.version,A.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${A.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===H)return this.logService.debug(`Skipping extension ${A.location.path} from different target platform ${A.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${U.location.path} with ${A.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${A.location.path}.`),!0},ne=new Map;return V?.forEach(U=>{const A=k.ExtensionIdentifier.toKey(U.identifier.id),W=ne.get(A);(!W||te(W,U,!1))&&ne.set(A,U)}),B?.forEach(U=>{const A=k.ExtensionIdentifier.toKey(U.identifier.id),W=ne.get(A);if(!W&&V&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!W||te(W,U,!1))&&ne.set(A,U)}),T?.forEach(U=>{const A=k.ExtensionIdentifier.toKey(U.identifier.id),W=ne.get(A);(!W||te(W,U,!0))&&ne.set(A,U),ne.set(A,U)}),[...ne.values()]}async scanDefaultSystemExtensions(V,B){this.logService.trace("Started scanning system extensions");const T=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),Y=await(V&&!T.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(T);return this.logService.trace("Scanned system extensions:",Y.length),Y}async scanDevSystemExtensions(V,B){const T=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!T?.length)return[];this.logService.trace("Started scanning dev system extensions");const H=B?await this.getBuiltInExtensionControl():{},Y=[],te=f.URI.file(v.normalize(v.join(w.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of T){const A=H[U.name]||"marketplace";switch(A){case"disabled":break;case"marketplace":Y.push((0,l.joinPath)(te,U.name));break;default:Y.push(f.URI.file(A));break}}const ne=await Promise.all(Y.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,V,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ne.length),(0,I.coalesce)(ne)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,B,T,H,Y,te,ne){const U=await this.getTranslations(Y??S.language),A=await this.getMtime(V),W=B&&!this.uriIdentityService.extUri.isEqual(V,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,_=W?await this.getMtime(W):void 0;return new ie(V,A,W,_,B,ne,T,H,te,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,Y,U)}async getMtime(V){try{const B=await this.fileService.stat(V);if(typeof B.mtime=="number")return B.mtime}catch{}}};q=we([X(4,C.IUserDataProfilesService),X(5,d.IExtensionsProfileScannerService),X(6,c.IFileService),X(7,n.ILogService),X(8,b.IEnvironmentService),X(9,o.IProductService),X(10,L.IUriIdentityService),X(11,i.IInstantiationService)],q),e.AbstractExtensionsScannerService=q;class ie{constructor(V,B,T,H,Y,te,ne,U,A,W,_,$,Q,N,j){this.location=V,this.mtime=B,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=H,this.profile=Y,this.profileScanOptions=te,this.type=ne,this.excludeObsolete=U,this.validate=A,this.productVersion=W,this.productDate=_,this.productCommit=$,this.devMode=Q,this.language=N,this.translations=j}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,B){return(0,l.isEqual)(V.location,B.location)&&V.mtime===B.mtime&&(0,l.isEqual)(V.applicationExtensionslocation,B.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&V.profile===B.profile&&r.equals(V.profileScanOptions,B.profileScanOptions)&&V.type===B.type&&V.excludeObsolete===B.excludeObsolete&&V.validate===B.validate&&V.productVersion===B.productVersion&&V.productDate===B.productDate&&V.productCommit===B.productCommit&&V.devMode===B.devMode&&V.language===B.language&&z.equals(V.translations,B.translations)}}e.ExtensionScannerInput=ie;let se=class extends h.Disposable{constructor(V,B,T,H,Y){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=B,this.uriIdentityService=T,this.fileService=H,this.logService=Y}async scanExtensions(V){const B=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let T={};if(V.excludeObsolete&&V.type===1)try{const H=(await this.fileService.readFile(this.obsoleteFile)).value.toString();T=JSON.parse(H)}catch{}return(0,a.isEmptyObject)(T)?B:B.filter(H=>!T[E.ExtensionKey.create(H).toString()])}async scanExtensionsFromLocation(V){const B=await this.fileService.resolve(V.location);if(!B.children?.length)return[];const T=await Promise.all(B.children.map(async H=>{if(!H.isDirectory||V.type===1&&(0,l.basename)(H.resource).indexOf(".")===0)return null;const Y=new ie(H.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(Y)}));return(0,I.coalesce)(T).sort((H,Y)=>H.location.path<Y.location.path?-1:1)}async scanExtensionsFromProfile(V){let B=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){B=B.filter(H=>!H.metadata?.isApplicationScoped);const T=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,H=>!!H.metadata?.isApplicationScoped,V);B.push(...T)}return B}async scanExtensionsFromProfileResource(V,B,T){const H=await this.extensionsProfileScannerService.scanProfileExtensions(V,T.profileScanOptions);if(!H.length)return[];const Y=await Promise.all(H.map(async te=>{if(B(te)){const ne=new ie(te.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(ne,te.metadata)}return null}));return(0,I.coalesce)(Y)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,l.joinPath)(V.location,"package.json"))){const B=await this.scanExtension(V);return B?[B]:[]}else return await this.scanExtensions(V)}catch(B){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,D.getErrorMessage)(B)),[]}}async scanExtension(V,B){try{let T=await this.scanExtensionManifest(V.location);if(T){T.publisher||(T.publisher=k.UNDEFINED_PUBLISHER),B=B??T.__metadata,delete T.__metadata;const H=(0,E.getGalleryExtensionId)(T.publisher,T.name),Y=B?.id?{id:H,uuid:B.id}:{id:H},te=B?.isSystem?0:V.type,ne=te===0||!!B?.isBuiltin;F.ImplicitActivationEvents.updateManifest(T),T=await this.translateManifest(V.location,T,ie.createNlsConfiguration(V));const U={type:te,identifier:Y,manifest:T,location:V.location,isBuiltin:ne,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return V.validate?this.validate(U,V):U}}catch(T){V.type!==0&&this.logService.error(T)}return null}validate(V,B){let T=!0;const H=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,V.manifest,V.isBuiltin);for(const[Y,te]of H)Y===m.default.Error&&(T=!1,this.logService.error(this.formatMessage(B.location,te)));return V.isValid=T,V.validations=H,V}async scanExtensionManifest(V){const B=(0,l.joinPath)(V,"package.json");let T;try{T=(await this.fileService.readFile(B)).value.toString()}catch(Y){return(0,c.toFileOperationResult)(Y)!==1&&this.logService.error(this.formatMessage(V,(0,p.localize)(0,null,B.path,Y.message))),null}let H;try{H=JSON.parse(T)}catch{const te=[];(0,P.parse)(T,te);for(const ne of te)this.logService.error(this.formatMessage(V,(0,p.localize)(1,null,B.path,ne.offset,ne.length,(0,g.getParseErrorMessage)(ne.error))));return null}return(0,P.getNodeType)(H)!=="object"?(this.logService.error(this.formatMessage(V,(0,p.localize)(2,null,B.path))),null):H}async translateManifest(V,B,T){const H=await this.getLocalizedMessages(V,B,T);if(H)try{const Y=[],te=await this.resolveOriginalMessageBundle(H.default,Y);if(Y.length>0)return Y.forEach(U=>{this.logService.error(this.formatMessage(V,(0,p.localize)(3,null,H.default?.path,(0,g.getParseErrorMessage)(U.error))))}),B;if((0,P.getNodeType)(H)!=="object")return this.logService.error(this.formatMessage(V,(0,p.localize)(4,null,H.default?.path))),B;const ne=H.values||Object.create(null);return(0,O.localizeManifest)(B,ne,te)}catch{}return B}async getLocalizedMessages(V,B,T){const H=(0,l.joinPath)(V,"package.nls.json"),Y=(A,W)=>{W.forEach(_=>{this.logService.error(this.formatMessage(V,(0,p.localize)(5,null,A?.path,(0,g.getParseErrorMessage)(_.error))))})},te=A=>{this.logService.error(this.formatMessage(V,(0,p.localize)(6,null,A?.path)))},ne=`${B.publisher}.${B.name}`,U=T.translations[ne];if(U)try{const A=f.URI.file(U),W=(await this.fileService.readFile(A)).value.toString(),_=[],$=(0,P.parse)(W,_);return _.length>0?(Y(A,_),{values:void 0,default:H}):(0,P.getNodeType)($)!=="object"?(te(A),{values:void 0,default:H}):{values:$.contents?$.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.fileService.exists(H))return;let W;try{W=await this.findMessageBundles(V,T)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const _=(await this.fileService.readFile(W.localized)).value.toString(),$=[],Q=(0,P.parse)(_,$);return $.length>0?(Y(W.localized,$),{values:void 0,default:W.original}):(0,P.getNodeType)(Q)!=="object"?(te(W.localized),{values:void 0,default:W.original}):{values:Q,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(V,B){if(V)try{const T=(await this.fileService.readFile(V)).value.toString();return(0,P.parse)(T,B)}catch{}}findMessageBundles(V,B){return new Promise((T,H)=>{const Y=te=>{const ne=(0,l.joinPath)(V,`package.nls.${te}.json`);this.fileService.exists(ne).then(U=>{U&&T({localized:ne,original:(0,l.joinPath)(V,"package.nls.json")});const A=te.lastIndexOf("-");A===-1?T({localized:(0,l.joinPath)(V,"package.nls.json"),original:null}):(te=te.substring(0,A),Y(te))})};if(B.devMode||B.pseudo||!B.language)return T({localized:(0,l.joinPath)(V,"package.nls.json"),original:null});Y(B.language)})}formatMessage(V,B){return`[${V.path}]: ${B}`}};se=we([X(1,d.IExtensionsProfileScannerService),X(2,L.IUriIdentityService),X(3,c.IFileService),X(4,n.ILogService)],se);let oe=class extends se{constructor(V,B,T,H,Y,te){super(B,T,H,Y,te),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new M.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const B=await this.readExtensionCache();if(this.input=V,B&&B.input&&ie.equals(B.input,this.input))return this.logService.debug("Using cached extensions scan result",V.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(H=>(H.location=f.URI.revive(H.location),H));const T=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:T}),T}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),B=JSON.parse(V.value.toString());return{result:B.result,input:(0,s.revive)(B.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(V)))}catch(B){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const B=V.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(T,B))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(H){this.logService.error(H)}}};oe=we([X(2,d.IExtensionsProfileScannerService),X(3,L.IUriIdentityService),X(4,c.IFileService),X(5,n.ILogService)],oe);function he(ge,V){const B=(0,E.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:B,identifier:new k.ExtensionIdentifier(B),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:V,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=he;class le extends q{constructor(V,B,T,H,Y,te,ne,U,A,W,_,$){super(V,B,(0,l.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,l.joinPath)(H,k.MANIFEST_CACHE_FOLDER),Y,te,ne,U,A,W,_,$),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const Q=await this.fileService.readFile(f.URI.file(S.translationsConfigFile));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=le}),define(Z[267],ee([0,1,5,40,39,24,79,16,34,8]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let w=class extends D.AbstractExtensionsProfileScannerService{constructor(S,l,y,m,a,f){super(h.URI.file(S.extensionsPath),l,y,m,a,f)}};w=we([X(0,g.INativeEnvironmentService),X(1,P.IFileService),X(2,M.IUserDataProfilesService),X(3,r.IUriIdentityService),X(4,R.ITelemetryService),X(5,I.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(Z[268],ee([0,1,8,34,79,125,16,6,5,21,39,40]),function(x,e,I,M,r,R,D,P,g,h,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends R.NativeExtensionsScannerService{constructor(y,m,a,f,p,b,E,k){super(I.URI.file(p.builtinExtensionsPath),I.URI.file(p.extensionsPath),p.userHome,I.URI.file(p.userDataPath),y,m,a,f,p,b,E,k)}};S=we([X(0,v.IUserDataProfilesService),X(1,r.IExtensionsProfileScannerService),X(2,D.IFileService),X(3,g.ILogService),X(4,M.INativeEnvironmentService),X(5,h.IProductService),X(6,w.IUriIdentityService),X(7,P.IInstantiationService)],S),e.ExtensionsScannerService=S}),define(Z[269],ee([0,1,15,2,14,9,4,61,8,31,42,34,5,40]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends M.Disposable{constructor(a,f,p){super(),this.environmentService=a,this.logService=p,this.validRoots=P.TernarySearchTree.forPaths(!D.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(a.appRoot),this.addValidFileRoot(a.extensionsPath),this.addValidFileRoot(f.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(a.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:a}=I.session;a.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(f,p)=>this.handleResourceRequest(f,p)),a.protocol.interceptFileProtocol(r.Schemas.file,(f,p)=>this.handleFileRequest(f,p)),this._register((0,M.toDisposable)(()=>{a.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),a.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(a){const f=(0,R.normalize)(a);return this.validRoots.get(f)?M.Disposable.None:(this.validRoots.set(f,!0),(0,M.toDisposable)(()=>this.validRoots.delete(f)))}handleFileRequest(a,f){const p=g.URI.parse(a.url);return this.logService.error(`Refused to load resource ${p.fsPath} from ${r.Schemas.file}: protocol (original URL: ${a.url})`),f({error:-3})}handleResourceRequest(a,f){const p=this.requestToNormalizedFilePath(a);let b;return this.environmentService.crossOriginIsolated&&((0,R.basename)(p)==="workbench.html"||(0,R.basename)(p)==="workbench-dev.html"?b=r.COI.CoopAndCoep:b=r.COI.getHeadersFromQuery(a.url)),this.validRoots.findSubstr(p)?f({path:p,headers:b}):this.validExtensions.has((0,R.extname)(p).toLowerCase())?f({path:p}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${a.url})`),f({error:-3}))}requestToNormalizedFilePath(a){const f=g.URI.parse(a.url),p=r.FileAccess.uriToFileUri(f);return(0,R.normalize)(p.fsPath)}createIPCObjectUrl(){let a;const f=g.URI.from({scheme:"vscode",path:(0,h.generateUuid)()}),p=f.toString(),b=async()=>a;return w.validatedIpcMain.handle(p,b),this.logService.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:f,update:E=>a=E,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${p}.`),w.validatedIpcMain.removeHandler(p)}}}};y=we([X(0,v.INativeEnvironmentService),X(1,l.IUserDataProfilesService),X(2,S.ILogService)],y),e.ProtocolMainService=y}),define(Z[270],ee([0,1,15,42,7,3,2,14,10,106,28,20,5,66,67,69,44,40,38,65,95,18,48,71,110]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let n=class extends D.Disposable{constructor(u,s,d,C,L,O,F,z,q,ie,se){super(),this.machineId=u,this.userEnv=s,this.environmentMainService=d,this.userDataProfilesService=C,this.lifecycleMainService=L,this.logService=O,this.loggerMainService=F,this.policyService=z,this.themeMainService=q,this.protocolMainService=ie,this.configurationService=se,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this.firstWindowConnectionBarrier=new r.Barrier,this.window=void 0,this.windowCloseListener=void 0,this.utilityProcess=void 0,this.useUtilityProcess=c.canUseUtilityProcess&&this.configurationService.getValue("window.experimental.sharedProcessUseUtilityProcess"),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners(),this.useUtilityProcess&&this.logService.info("[SharedProcess] using utility process")}registerListeners(){M.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(u,s)=>this.onWindowConnection(u,s)),M.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(u,s)=>this.onWorkerConnection(u,s)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(u,s){this.logService.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const d=await this.connect();if(u.sender.isDestroyed())return d.close();u.sender.postMessage("vscode:createSharedProcessMessageChannelResult",s,[d])}onWorkerConnection(u,s){this.logService.trace("[SharedProcess] onWorkerConnection",s);const d=new D.DisposableStore,C=O=>{!this.isWindowAlive()||(this.logService.trace(`[SharedProcess] disposing worker (reason: '${O}')`,s),d.dispose(),this.sendToWindow("vscode:electron-main->shared-process=disposeWorker",s))},L=I.BrowserWindow.fromId(s.reply.windowId);if(!L||L.isDestroyed()||L.webContents.isDestroyed()||!s.reply.channel){C("unavailable");return}d.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,O=>O.window.win===L)(()=>C("load"))),d.add(R.Event.fromNodeEventEmitter(L,"closed")(()=>C("closed"))),L.webContents.postMessage(s.reply.channel,s.reply.nonce,u.ports)}onWillShutdown(){if(this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess)this.utilityProcess.postMessage("vscode:electron-main->shared-process=exit"),this.utilityProcess=void 0;else{const u=this.window;if(!u)return;this.sendToWindow("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(u.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{this.logService.trace("[SharedProcess] onWillShutdown window.close()"),u.close()}catch(s){this.logService.trace(`[SharedProcess] onWillShutdown window.close() error: ${s}`)}this.window=void 0},0)}}sendToWindow(u,...s){if(!this.isWindowAlive()){this.logService.warn(`Sending IPC message to channel '${u}' for shared process that is destroyed`);return}try{this.window?.webContents.send(u,...s)}catch(d){this.logService.warn(`Error sending IPC message to channel '${u}' of shared process: ${(0,a.toErrorMessage)(d)}`)}}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const u=new r.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=init-done",()=>u.complete()):M.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>u.complete()),await u.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.spawn();const u=new r.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=ipc-ready",()=>u.complete()):M.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>u.complete()),await u.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}spawn(){this.useUtilityProcess?this.createUtilityProcess():this.createWindow(),this.registerSharedProcessListeners()}createUtilityProcess(){this.utilityProcess=this._register(new E.UtilityProcess(this.logService,t.NullTelemetryService,this.lifecycleMainService));const u=(0,i.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let s;u.port&&(s=["--nolazy"],u.break?s.push(`--inspect-brk=${u.port}`):s.push(`--inspect=${u.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:s})}createWindow(){const u=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new I.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${u.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),u.update(this.createSharedProcessConfiguration()),this.window.loadURL(P.FileAccess.asBrowserUri(`vs/code/node/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0))}createSharedProcessConfiguration(){return{machineId:this.machineId,windowId:this.window?.id??-1,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),product:l.default,policiesData:this.policyService.serialize()}}registerSharedProcessListeners(){this.window?(this.windowCloseListener=u=>{this.logService.trace("SharedProcess#close prevented"),u.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(u,s)=>this._onDidError.fire({type:2,details:s})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(u,s,d)=>this._onDidError.fire({type:3,details:{reason:d,exitCode:s}}))):this.utilityProcess&&this._register(this.utilityProcess.onCrash(u=>this._onDidError.fire({type:2,details:{reason:u.reason,exitCode:u.code}})))}async connect(){return await this.whenIpcReady,this.utilityProcess?this.utilityProcess.connect():(0,h.connect)((0,g.assertIsDefined)(this.window))}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}usingUtilityProcess(){return!!this.utilityProcess}isWindowAlive(){const u=this.window;return u?!u.isDestroyed()&&!u.webContents.isDestroyed():!1}};n=we([X(2,w.IEnvironmentMainService),X(3,f.IUserDataProfilesService),X(4,v.ILifecycleMainService),X(5,S.ILogService),X(6,b.ILoggerMainService),X(7,p.IPolicyService),X(8,m.IThemeMainService),X(9,y.IProtocolMainService),X(10,k.IConfigurationService)],n),e.SharedProcess=n}),define(Z[96],ee([0,1,7,3,2,64,10,107,6,40]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var w;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var S;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function l(p){const b=p.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=l;class y extends r.Disposable{constructor(b={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super(),this.options=b,this._onDidChangeValue=this._register(new M.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new M.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new M.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,E){if(E===e.TARGET_KEY){switch(b){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:b})}else this._onDidChangeValue.fire({scope:b,key:E,target:this.getKeyTargets(b)[E]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,E,k){return this.getStorage(E)?.get(b,k)}getBoolean(b,E,k){return this.getStorage(E)?.getBoolean(b,k)}getNumber(b,E,k){return this.getStorage(E)?.getNumber(b,k)}store(b,E,k,t){if((0,D.isUndefinedOrNull)(E)){this.remove(b,k);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,k,t),this.getStorage(k)?.set(b,E)})}remove(b,E){this.withPausedEmitters(()=>{this.updateKeyTarget(b,E,void 0),this.getStorage(E)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,E){const k=[],t=this.getKeyTargets(b);for(const c of Object.keys(t))t[c]===E&&k.push(c);return k}updateKeyTarget(b,E,k){const t=this.getKeyTargets(E);typeof k=="number"?t[b]!==k&&(t[b]=k,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[b]=="number"&&(delete t[b],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(b){switch(b){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(b){const E=this.getStorage(b);return E?l(E):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=w.NONE){this._onWillSaveState.fire({reason:b});const E=this.getStorage(-1),k=this.getStorage(0),t=this.getStorage(1);switch(b){case w.NONE:await I.Promises.settled([E?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await I.Promises.settled([E?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.getStorage(-1)?.items??new Map,E=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return f(b,E,k,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(b,E){return this.emitWillSaveState(w.NONE),(0,h.isUserDataProfile)(b)?this.switchToProfile(b,E):this.switchToWorkspace(b,E)}canSwitchProfile(b,E){return!(b.id===E.id||m(E)&&m(b))}switchData(b,E,k,t){this.withPausedEmitters(()=>{if(t)for(const[c,i]of b)E.set(c,i);else{const c=new Set;for(const[i,n]of b)c.add(i),E.get(i)!==n&&this.emitDidChangeValue(k,i);for(const[i]of E.items)c.has(i)||this.emitDidChangeValue(k,i)}})}}y.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=y;function m(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=m;class a extends y{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.profileStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),this._register(this.applicationStorage.onDidChangeStorage(b=>this.emitDidChangeValue(-1,b)))}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(b){return!1}}e.InMemoryStorageService=a;async function f(p,b,E,k,t,c){const i=F=>{try{return JSON.parse(F)}catch{return F}},n=new Map,o=new Map;p.forEach((F,z)=>{n.set(z,F),o.set(z,i(F))});const u=new Map,s=new Map;b.forEach((F,z)=>{u.set(z,F),s.set(z,i(F))});const d=new Map,C=new Map;E.forEach((F,z)=>{d.set(z,F),C.set(z,i(F))}),console.group(k!==t?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const L=[];if(n.forEach((F,z)=>{L.push({key:z,value:F})}),console.table(L),console.groupEnd(),console.log(o),k!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const F=[];u.forEach((z,q)=>{F.push({key:q,value:z})}),console.table(F),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${c})`);const O=[];d.forEach((F,z)=>{O.push({key:z,value:F})}),console.table(O),console.groupEnd(),console.log(C)}e.logStorage=f}),define(Z[271],ee([0,1,25,7,3,2,9,73,8,23,107,158,5,96,24,29]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class a extends R.Disposable{get storage(){return this._storage}constructor(c,i){super(),this.logService=c,this.fileService=i,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new M.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=w.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===w.StorageState.None)try{const c=await this.doCreate();this._storage.dispose(),this._storage=c,this._register(c.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(c);const i=c.getBoolean(l.IS_NEW_KEY);i===void 0?c.set(l.IS_NEW_KEY,!0):i&&c.set(l.IS_NEW_KEY,!1)}catch(c){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.state=w.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?c=>this.logService.trace(c):void 0,logError:c=>this.logService.error(c)}}doInit(c){return c.init()}get items(){return this._storage.items}get(c,i){return this._storage.get(c,i)}set(c,i){return this._storage.set(c,i)}delete(c){return this._storage.delete(c)}async close(){const c=new P.StopWatch(!1);await this.doClose(),c.stop(),c.elapsed()>a.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(c),this._onDidCloseStorage.fire()}async logSlowClose(c){if(!!this.path)try{const i=(0,I.top)(Array.from(this._storage.items.entries()).map(([o,u])=>({key:o,length:u.length})),(o,u)=>u.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(g.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=w.StorageState.Closed,await this._storage.close()}}a.LOG_SLOW_CLOSE_THRESHOLD=2e3;class f extends a{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,f.STORAGE_NAME)}constructor(c,i,n,o){super(n,o),this.profile=c,this.options=i}async doCreate(){return new w.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:w.StorageHint.STORAGE_IN_MEMORY})}}f.STORAGE_NAME="state.vscdb";class p extends f{constructor(c,i,n,o){super(c,i,n,o)}}e.ProfileStorageMain=p;class b extends f{constructor(c,i,n,o){super(i.defaultProfile,c,n,o)}async doInit(c){await super.doInit(c),this.updateTelemetryState(c)}updateTelemetryState(c){c.get(y.firstSessionDateStorageKey,void 0)===void 0&&c.set(y.firstSessionDateStorageKey,new Date().toUTCString());const n=c.get(y.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();c.set(y.lastSessionDateStorageKey,typeof n>"u"?null:n),c.set(y.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=b;class E extends a{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,E.WORKSPACE_STORAGE_NAME)}constructor(c,i,n,o,u){super(n,u),this.workspace=c,this.options=i,this.environmentService=o}async doCreate(){const{storageFilePath:c,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new w.Storage(new v.SQLiteStorageDatabase(c,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?w.StorageHint.STORAGE_IN_MEMORY:i?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(c,E.WORKSPACE_STORAGE_NAME);return await h.Promises.exists(c)?{storageFilePath:i,wasCreated:!1}:(await h.Promises.mkdir(c,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(c),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(c){let i;if((0,m.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,m.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(c,E.WORKSPACE_META_NAME);await h.Promises.exists(n)||await h.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}E.WORKSPACE_STORAGE_NAME="state.vscdb",E.WORKSPACE_META_NAME="workspace.json",e.WorkspaceStorageMain=E;class k extends a{get path(){}async doCreate(){return new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=k}),define(Z[272],ee([0,1,3,2,96]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends M.Disposable{constructor(P,g,h){super(),this.storageMainService=P,this.userDataProfilesService=g,this.logService=h;const w=this._register(new M.MutableDisposable);this._onDidChange=this._register(new I.Emitter({onWillAddFirstListener:()=>w.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>w.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new M.DisposableStore;return P.add(I.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(g,h)=>(g?g.push(h.key):g=[h.key],g),100)(g=>this.onDidChangeApplicationStorage(g))),P.add(I.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(g,h)=>{g||(g=new Map);let w=g.get(h.profile.id);return w||g.set(h.profile.id,w={profile:h.profile,keys:[],storage:h.storage}),w.keys.push(h.key),g},100)(g=>this.onDidChangeProfileStorage(g))),P}onDidChangeApplicationStorage(P){const g=P.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],h=[];if(P=P.filter(w=>w!==r.TARGET_KEY),P.length){const w=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);h.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:w[v]}))})}this.triggerEvents(g,h)}onDidChangeProfileStorage(P){const g=[],h=new Map;for(const[w,v]of P.entries()){v.keys.includes(r.TARGET_KEY)&&g.push(v.profile);const S=v.keys.filter(l=>l!==r.TARGET_KEY);if(S.length){const l=(0,r.loadKeyTargets)(v.storage.storage);h.set(w,{profile:v.profile,changes:S.map(y=>({key:y,scope:0,target:l[y]}))})}}this.triggerEvents(g,[...h.values()])}triggerEvents(P,g){(P.length||g.length)&&this._onDidChange.fire({valueChanges:g,targetChanges:P})}listen(P,g,h){switch(g){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${g}`)}async call(P,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=R}),define(Z[273],ee([0,1,8,34,16,5,33,39,40,10,118]),function(x,e,I,M,r,R,D,P,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let v=class ht extends g.UserDataProfilesService{constructor(m,a,f,p,b){super(f,p,a,b),this.stateReadonlyService=m,this.nativeEnvironmentService=f}getStoredProfiles(){return this.stateReadonlyService.getItem(ht.PROFILES_KEY,[]).map(a=>({...a,location:(0,h.isString)(a.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,a.location):I.URI.revive(a.location)}))}getStoredProfileAssociations(){const m=this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ht.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?m:this.migrateStoredProfileAssociations(m)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(I.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",v=we([X(0,D.IStateReadService),X(1,P.IUriIdentityService),X(2,M.INativeEnvironmentService),X(3,r.IFileService),X(4,R.ILogService)],v),e.UserDataProfilesReadonlyService=v;let S=class rt extends v{constructor(m,a,f,p,b){super(m,a,f,p,b),this.stateService=m}saveStoredProfiles(m){m.length?this.stateService.setItem(rt.PROFILES_KEY,m.map(a=>({...a,location:this.uriIdentityService.extUri.basename(a.location)}))):this.stateService.removeItem(rt.PROFILES_KEY)}getStoredProfiles(){const m=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(m),this.stateService.setItem("userDataProfilesMigration",!0)),m}saveStoredProfileAssociations(m){m.emptyWindows||m.workspaces?this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_KEY,m):this.stateService.removeItem(rt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const m="workspaceAndProfileInfo",a=this.stateService.getItem(m,void 0);if(a){this.stateService.removeItem(m);const p=a.reduce((b,{workspace:E,profile:k})=>(b[I.URI.revive(E).toString()]=I.URI.revive(k).toString(),b),{});this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_KEY,{workspaces:p})}const f=super.getStoredProfileAssociations();return this.stateService.getItem(rt.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(f),this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),f}};S=we([X(0,D.IStateService),X(1,P.IUriIdentityService),X(2,M.INativeEnvironmentService),X(3,r.IFileService),X(4,R.ILogService)],S),e.UserDataProfilesService=S;let l=class extends S{constructor(m,a,f,p){super(new w.StateService(0,a,p,f),m,a,f,p)}async init(){return await this.stateService.init(),super.init()}};l=we([X(0,P.IUriIdentityService),X(1,M.INativeEnvironmentService),X(2,r.IFileService),X(3,R.ILogService)],l),e.ServerUserDataProfilesService=l}),define(Z[52],ee([0,1,34,16,6,5,39,40,273,33]),function(x,e,I,M,r,R,D,P,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(P.IUserDataProfilesService);let w=class extends g.UserDataProfilesService{constructor(S,l,y,m,a){super(S,l,y,m,a)}getAssociatedEmptyWindows(){const S=[];for(const l of this.profilesObject.emptyWindows.keys())S.push({id:l});return S}};w=we([X(0,h.IStateService),X(1,D.IUriIdentityService),X(2,I.INativeEnvironmentService),X(3,M.IFileService),X(4,R.ILogService)],w),e.UserDataProfilesMainService=w}),define(Z[97],ee([0,1,8,50,3,2,34,16,6,20,5,96,271,40,52,39]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,g.createDecorator)("storageMainService");let a=class extends R.Disposable{constructor(b,E,k,t,c,i){super(),this.logService=b,this.environmentService=E,this.userDataProfilesService=k,this.lifecycleMainService=t,this.fileService=c,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new r.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)b.join("profileStorage",E.close());for(const[,E]of this.mapWorkspaceToStorage)b.join("workspaceStorage",E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const E=this.mapProfileToStorage.get(b.profile.id);E&&b.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new S.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,M.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,v.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let E=this.mapProfileToStorage.get(b.id);if(!E){this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),E=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,E);const k=this._register(E.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:E,profile:b})));(0,M.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id),k.dispose()})}return E}createProfileStorage(b){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let E=this.mapWorkspaceToStorage.get(b.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),E=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,E),(0,M.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),E}createWorkspaceStorage(b){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(b){const E=I.URI.file(b);for(const k of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!k.path&&this.uriIdentityService.extUri.isEqualOrParent(I.URI.file(k.path),E))return!0;return!1}};a=we([X(0,w.ILogService),X(1,D.IEnvironmentService),X(2,y.IUserDataProfilesMainService),X(3,h.ILifecycleMainService),X(4,P.IFileService),X(5,m.IUriIdentityService)],a),e.StorageMainService=a,e.IApplicationStorageMainService=(0,g.createDecorator)("applicationStorageMainService");let f=class extends v.AbstractStorageService{constructor(b,E){super(),this.userDataProfilesService=b,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};f=we([X(0,l.IUserDataProfilesService),X(1,e.IStorageMainService)],f),e.ApplicationStorageMainService=f}),define(Z[274],ee([0,1,2,20,52,29,7,30]),function(x,e,I,M,r,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends I.Disposable{constructor(w,v,S){super(),this.userDataProfilesService=v,this.windowsMainService=S,this._register(w.onWillLoadWindow(l=>{l.reason===2&&this.unsetProfileForWorkspace(l.window)})),this._register(w.onBeforeCloseWindow(l=>this.unsetProfileForWorkspace(l))),this._register(new D.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(w){const v=this.getWorkspace(w),S=this.userDataProfilesService.getProfileForWorkspace(v);S?.isTransient&&(this.userDataProfilesService.unsetWorkspace(v,S.isTransient),S.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(w){return w.openedWorkspace??(0,R.toWorkspaceIdentifier)(w.backupPath,w.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const w=this.userDataProfilesService.getAssociatedEmptyWindows();if(w.length===0)return;const v=this.windowsMainService.getWindows().map(S=>this.getWorkspace(S));for(const S of w)v.some(l=>l.id===S.id)||this.userDataProfilesService.unsetWorkspace(S,!1)}};g=we([X(0,M.ILifecycleMainService),X(1,r.IUserDataProfilesMainService),X(2,P.IWindowsMainService)],g),e.UserDataProfilesHandler=g}),define(Z[126],ee([0,1,19,8,29]),function(x,e,I,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(g,h,w){for(const S of g){const l=S.openedWorkspace;if((0,r.isWorkspaceIdentifier)(l)){const y=await w(l);if(y){if(y.folders.some(m=>I.extUriBiasedIgnorePathCase.isEqualOrParent(h,m.uri)))return S}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(h,l.configPath))return S}}const v=g.filter(S=>(0,r.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(h,S.openedWorkspace.uri));if(v.length)return v.sort((S,l)=>-(S.openedWorkspace.uri.path.length-l.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(g,h){for(const w of g)if((0,r.isWorkspaceIdentifier)(w.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.configPath,h)||(0,r.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.uri,h))return w}e.findWindowOnWorkspaceOrFolder=D;function P(g,h){const w=v=>h.some(S=>I.extUriBiasedIgnorePathCase.isEqual(M.URI.file(S),M.URI.file(v)));for(const v of g)if(v.config?.extensionDevelopmentPath?.some(S=>w(S)))return v}e.findWindowOnExtensionDevelopmentPath=P}),define(Z[275],ee([0,1,15,2,4,19,8,18,20,5,33,30,124,29]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class vt extends M.Disposable{get state(){return this._state}constructor(E,k,t,c,i){super(),this.windowsMainService=E,this.stateService=k,this.lifecycleMainService=t,this.logService=c,this.configurationService=i,this._state=m(this.stateService.getItem(vt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){I.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(E=>this.onBeforeCloseWindow(E)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(E=>this.onBeforeCloseWindow(E))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const E=new Set,k={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!k.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(k.lastActiveWindow=this.toWindowState(i),k.lastActiveWindow.uiState.mode===3&&E.add(k.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(k.lastPluginDevelopmentHostWindow=this.toWindowState(t),k.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(k.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!t.win?.isSimpleFullScreen()&&(k.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(k.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(k.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(E.has(n.uiState.display)?r.isMacintosh&&n.windowId!==k.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):E.add(n.uiState.display)),n}));const c=f(k);this.stateService.setItem(vt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(E){if(this.lifecycleMainService.quitRequested)return;const k=this.toWindowState(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=k:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this._state.openedWindows.forEach(t=>{const c=(0,l.isWorkspaceIdentifier)(E.openedWorkspace)&&t.workspace?.id===E.openedWorkspace.id,i=(0,l.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&t.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(t.folderUri,E.openedWorkspace.uri);(c||i)&&(t.uiState=k.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=k)}toWindowState(E){return{windowId:E.id,workspace:(0,l.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,l.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const k=this.doGetNewWindowState(E),t=this.configurationService.getValue("window");if(k.mode===3){let c;k.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),c||(k.mode=1)}return k}doGetNewWindowState(E){const k=this.windowsMainService.getLastActiveWindow();if(!E.extensionTestsPath){if(!!E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=E.workspace;if((0,l.isWorkspaceIdentifier)(u)){const d=this.state.openedWindows.filter(C=>C.workspace&&C.workspace.id===u.id).map(C=>C.uiState);if(d.length)return d[0]}if((0,l.isSingleFolderWorkspaceIdentifier)(u)){const d=this.state.openedWindows.filter(C=>C.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(C.folderUri,u.uri)).map(C=>C.uiState);if(d.length)return d[0]}else if(E.backupPath){const d=this.state.openedWindows.filter(C=>C.backupPath===E.backupPath).map(C=>C.uiState);if(d.length)return d[0]}const s=this.lastClosedState||this.state.lastActiveWindow;if(!k&&s)return s.uiState}let t;const c=I.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(r.isMacintosh){const u=I.screen.getCursorScreenPoint();t=I.screen.getDisplayNearestPoint(u)}!t&&k&&(t=I.screen.getDisplayMatching(k.getBounds())),t||(t=I.screen.getPrimaryDisplay()||c[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&k){const u=k.serializeWindowState();u.mode===3?i.mode=3:i=u,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(E){if(this.windowsMainService.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const k=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;k.some(t=>t.x===E.x||t.y===E.y);)E.x+=30,E.y+=30;return E}};y.windowsStateStorageKey="windowsState",y=we([X(0,v.IWindowsMainService),X(1,w.IStateService),X(2,g.ILifecycleMainService),X(3,h.ILogService),X(4,P.IConfigurationService)],y),e.WindowsStateHandler=y;function m(b){const E={openedWindows:[]},k=b||{openedWindows:[]};return k.lastActiveWindow&&(E.lastActiveWindow=a(k.lastActiveWindow)),k.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=a(k.lastPluginDevelopmentHostWindow)),Array.isArray(k.openedWindows)&&(E.openedWindows=k.openedWindows.map(t=>a(t))),E}e.restoreWindowsState=m;function a(b){const E={uiState:b.uiState};return b.backupPath&&(E.backupPath=b.backupPath),b.remoteAuthority&&(E.remoteAuthority=b.remoteAuthority),b.folder&&(E.folderUri=D.URI.parse(b.folder)),b.workspaceIdentifier&&(E.workspace={id:b.workspaceIdentifier.id,configPath:D.URI.parse(b.workspaceIdentifier.configURIPath)}),E}function f(b){return{lastActiveWindow:b.lastActiveWindow&&p(b.lastActiveWindow),lastPluginDevelopmentHostWindow:b.lastPluginDevelopmentHostWindow&&p(b.lastPluginDevelopmentHostWindow),openedWindows:b.openedWindows.map(E=>p(E))}}e.getWindowsStateStoreData=f;function p(b){return{workspaceIdentifier:b.workspace&&{id:b.workspace.id,configURIPath:b.workspace.configPath.toString()},folder:b.folderUri&&b.folderUri.toString(),backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.uiState}}}),define(Z[98],ee([0,1,32,43,131,45,14,9,4,19,8,6,55,29]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function y(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function m(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=m;function a(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=a;function f(C){return p(C)||b(C)}e.isStoredWorkspaceFolder=f;function p(C){const L=C;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function b(C){const L=C;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function E(C,L,O,F,z){if(C.scheme!==F.scheme)return{name:O,uri:C.toString(!0)};let q=L?void 0:z.relativePath(F,C);if(q!==void 0)q.length===0?q=".":g.isWindows&&(q=k(q));else if(C.scheme===D.Schemas.file)q=C.fsPath,g.isWindows&&(q=k(q));else if(z.isEqualAuthority(C.authority,F.authority))q=C.path;else return{name:O,uri:C.toString(!0)};return{name:O,path:q}}e.getStoredWorkspaceFolder=E;function k(C){return C=(0,R.normalizeDriveLetter)(C),(0,I.isUNC)(C)||(C=(0,I.toSlashes)(C)),C}function t(C,L,O){const F=[],z=new Set,q=O.dirname(L);for(const ie of C){let se;if(p(ie))ie.path&&(se=O.resolvePath(q,ie.path));else if(b(ie))try{se=w.URI.parse(ie.uri),se.path[0]!==P.posix.sep&&(se=se.with({path:P.posix.sep+se.path}))}catch(oe){console.warn(oe)}if(se){const oe=O.getComparisonKey(se);if(!z.has(oe)){z.add(oe);const he=ie.name||O.basenameOrAuthority(se);F.push(new l.WorkspaceFolder({uri:se,name:he,index:F.length},ie))}}}return F}e.toWorkspaceFolders=t;function c(C,L,O,F,z){const q=i(L,C),ie=z.dirname(L),se=z.dirname(F),oe=[];for(const V of q.folders){const B=p(V)?z.resolvePath(ie,V.path):w.URI.parse(V.uri);let T;O?T=!1:T=!p(V)||(0,P.isAbsolute)(V.path),oe.push(E(B,T,V.name,se,z))}const he={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},le=r.setProperty(C,["folders"],oe,he);let ge=r.applyEdits(C,le);return(0,h.isEqualAuthority)(q.remoteAuthority,(0,S.getRemoteAuthority)(F))&&(ge=r.applyEdits(ge,r.removeProperty(ge,["remoteAuthority"],he))),ge}e.rewriteWorkspaceFileForNewLocation=c;function i(C,L){const O=M.parse(L);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(F=>f(F));else throw new Error(`${C} looks like an invalid workspace file.`);return O}function n(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function o(C){return typeof C.folderUri=="string"}function u(C){return typeof C.fileUri=="string"}function s(C,L){const O={workspaces:[],files:[]};if(C){const F=function(q,ie){for(let se=0;se<q.length;se++)try{ie(q[se],se)}catch(oe){L.warn(`Error restoring recent entry ${JSON.stringify(q[se])}: ${oe.toString()}. Skip entry.`)}},z=C;Array.isArray(z.entries)&&F(z.entries,q=>{const ie=q.label,se=q.remoteAuthority;n(q)?O.workspaces.push({label:ie,remoteAuthority:se,workspace:{id:q.workspace.id,configPath:w.URI.parse(q.workspace.configPath)}}):o(q)?O.workspaces.push({label:ie,remoteAuthority:se,folderUri:w.URI.parse(q.folderUri)}):u(q)&&O.files.push({label:ie,remoteAuthority:se,fileUri:w.URI.parse(q.fileUri)})})}return O}e.restoreRecentlyOpened=s;function d(C){const L={entries:[]};for(const O of C.workspaces)m(O)?L.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):L.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of C.files)L.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return L}e.toStoreData=d}),define(Z[99],ee([0,1,82,14,4,19]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(h){function w(){let v=h.scheme===M.Schemas.file?(0,R.originalFSPath)(h):h.toString();return r.isLinux||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:w(),configPath:h}}e.getWorkspaceIdentifier=D;function P(h,w){function v(){if(h.scheme!==M.Schemas.file)return(0,I.createHash)("md5").update(h.toString()).digest("hex");if(!w)return;let l;return r.isLinux?l=w.ino:r.isMacintosh?l=w.birthtime.getTime():r.isWindows&&(typeof w.birthtimeMs=="number"?l=Math.floor(w.birthtimeMs):l=w.birthtime.getTime()),(0,I.createHash)("md5").update(h.fsPath).update(l?String(l):"").digest("hex")}const S=v();if(typeof S=="string")return{id:S,uri:h}}e.getSingleFolderWorkspaceIdentifier=P;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(Z[276],ee([0,1,82,32,14,9,4,19,23,189,18,28,33,16,5,188,29,99]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class wt{constructor(E,k,t,c){this.environmentMainService=E,this.configurationService=k,this.logService=t,this.stateService=c,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,M.isEqual)(i,n,!D.isLinux)}}async initialize(){const E=this.stateService.getItem(wt.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(E.emptyWindows),this.workspaces=await this.validateWorkspaces((0,h.deserializeWorkspaceInfos)(E)),this.folders=await this.validateFolders((0,h.deserializeFolderInfos)(E)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==l.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===l.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||l.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(E,k){this.workspaces.some(c=>E.workspace.id===c.workspace.id)||(this.workspaces.push(E),this.storeWorkspacesMetadata());const t=(0,R.join)(this.backupHome,E.workspace.id);return k?this.moveBackupFolder(t,k).then(()=>t):t}async moveBackupFolder(E,k){if(await g.Promises.exists(E)&&await this.convertToEmptyWindowBackup(E),await g.Promises.exists(k))try{await g.Promises.rename(k,E)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(E){return this.folders.some(k=>this.backupUriComparer.isEqual(E.folderUri,k.folderUri))||(this.folders.push(E),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(E))}registerEmptyWindowBackup(E){return this.emptyWindows.some(k=>!!k.backupFolder&&this.backupPathComparer.isEqual(k.backupFolder,E.backupFolder))||(this.emptyWindows.push(E),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,E.backupFolder)}async validateWorkspaces(E){if(!Array.isArray(E))return[];const k=new Set,t=[];for(const c of E){const i=c.workspace;if(!(0,a.isWorkspaceIdentifier)(i))return[];if(!k.has(i.id)){k.add(i.id);const n=(0,R.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==r.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?t.push(c):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return t}async validateFolders(E){if(!Array.isArray(E))return[];const k=[],t=new Set;for(const c of E){const i=c.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!t.has(n)){t.add(n);const o=(0,R.join)(this.backupHome,this.getFolderHash(c));await this.doHasBackups(o)?i.scheme!==r.Schemas.file||await g.Promises.exists(i.fsPath)?k.push(c):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return k}async validateEmptyWorkspaces(E){if(!Array.isArray(E))return[];const k=[],t=new Set;for(const c of E){const i=c.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const n=(0,R.join)(this.backupHome,i);await this.doHasBackups(n)?k.push(c):await this.deleteStaleBackup(n)}}return k}async deleteStaleBackup(E){try{await g.Promises.rm(E,g.RimRafMode.MOVE)}catch(k){this.logService.error(`Backup: Could not delete stale backup: ${k.toString()}`)}}prepareNewEmptyWindowBackup(){let E=(0,f.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(k=>!!k.backupFolder&&this.backupPathComparer.isEqual(k.backupFolder,E.id));)E=(0,f.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async convertToEmptyWindowBackup(E){const k=this.prepareNewEmptyWindowBackup(),t=(0,R.join)(this.backupHome,k.backupFolder);try{await g.Promises.rename(E,t)}catch(c){return this.logService.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.emptyWindows.push(k),!0}async getDirtyWorkspaces(){const E=[];for(const k of this.workspaces)await this.hasBackups(k)&&E.push(k);for(const k of this.folders)await this.hasBackups(k)&&E.push(k);return E}hasBackups(E){let k;return(0,h.isEmptyWindowBackupInfo)(E)?k=(0,R.join)(this.backupHome,E.backupFolder):(0,m.isFolderBackupInfo)(E)?k=(0,R.join)(this.backupHome,this.getFolderHash(E)):k=(0,R.join)(this.backupHome,E.workspace.id),this.doHasBackups(k)}async doHasBackups(E){try{const k=await g.Promises.readdir(E);for(const t of k)try{if((await g.Promises.readdir((0,R.join)(E,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const E={workspaces:this.workspaces.map(({workspace:k,remoteAuthority:t})=>{const c={id:k.id,configURIPath:k.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.folders.map(({folderUri:k,remoteAuthority:t})=>{const c={folderUri:k.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.emptyWindows.map(({backupFolder:k,remoteAuthority:t})=>{const c={backupFolder:k};return t&&(c.remoteAuthority=t),c})};this.stateService.setItem(wt.backupWorkspacesMetadataStorageKey,E)}getFolderHash(E){const k=E.folderUri;let t;return k.scheme===r.Schemas.file?t=D.isLinux?k.fsPath:k.fsPath.toLowerCase():t=k.toString().toLowerCase(),(0,I.createHash)("md5").update(t).digest("hex")}};p.backupWorkspacesMetadataStorageKey="backupWorkspaces",p=we([X(0,v.IEnvironmentMainService),X(1,w.IConfigurationService),X(2,y.ILogService),X(3,S.IStateService)],p),e.BackupMainService=p}),define(Z[53],ee([0,1,15,3,43,2,14,9,19,10,23,187,63,57,28,6,5,52,126,29,98,99]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let t=class extends R.Disposable{constructor(i,n,o,u,s){super(),this.environmentMainService=i,this.logService=n,this.userDataProfilesMainService=o,this.backupMainService=u,this.dialogMainService=s,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const i=(await w.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(n=>(0,g.joinPath)(this.untitledWorkspacesHome,n,b.UNTITLED_WORKSPACE_NAME));for(const n of i){const o=(0,k.getWorkspaceIdentifier)(n),u=await this.resolveLocalWorkspace(n);u?this.untitledWorkspaces.push({workspace:o,remoteAuthority:u.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${i}).`)}}resolveLocalWorkspace(i){return this.doResolveLocalWorkspace(i,n=>w.Promises.readFile(n,"utf8"))}doResolveLocalWorkspace(i,n){if(!!this.isWorkspacePath(i)&&i.scheme===D.Schemas.file)try{const o=n(i.fsPath);return o instanceof Promise?o.then(u=>this.doResolveWorkspace(i,u),u=>{}):this.doResolveWorkspace(i,o)}catch{return}}isWorkspacePath(i){return(0,b.isUntitledWorkspace)(i,this.environmentMainService)||(0,b.hasWorkspaceFileExtension)(i)}doResolveWorkspace(i,n){try{const o=this.doParseStoredWorkspace(i,n),u=(0,k.getWorkspaceIdentifier)(i);return{id:u.id,configPath:u.configPath,folders:(0,E.toWorkspaceFolders)(o.folders,u.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.logService.warn(o.toString())}}doParseStoredWorkspace(i,n){const o=(0,r.parse)(n);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(u=>(0,E.isStoredWorkspaceFolder)(u));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,n){const{workspace:o,storedWorkspace:u}=this.newUntitledWorkspace(i,n),s=o.configPath.fsPath;return await w.Promises.mkdir((0,P.dirname)(s),{recursive:!0}),await w.Promises.writeFile(s,JSON.stringify(u,null,"	")),this.untitledWorkspaces.push({workspace:o,remoteAuthority:n}),o}newUntitledWorkspace(i=[],n){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),u=(0,g.joinPath)(this.untitledWorkspacesHome,o),s=(0,g.joinPath)(u,b.UNTITLED_WORKSPACE_NAME),d=[];for(const C of i)d.push((0,E.getStoredWorkspaceFolder)(C.uri,!0,C.name,u,g.extUriBiasedIgnorePathCase));return{workspace:(0,k.getWorkspaceIdentifier)(s),storedWorkspace:{folders:d,remoteAuthority:n}}}async getWorkspaceIdentifier(i){return(0,k.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,b.isUntitledWorkspace)(i.configPath,this.environmentMainService)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.doDeleteUntitledWorkspace(i),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(i),this._onDidDeleteUntitledWorkspace.fire(i))}async doDeleteUntitledWorkspace(i){const n=(0,g.originalFSPath)(i.configPath);try{await w.Promises.rm((0,P.dirname)(n));const o=(0,P.join)(this.environmentMainService.workspaceStorageHome.fsPath,i.id);await w.Promises.exists(o)&&await w.Promises.writeFile((0,P.join)(o,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(u=>u.workspace.id!==i.id)}catch(o){this.logService.warn(`Unable to delete untitled workspace ${n} (${o}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(i,n,o){if(!i||!i.win||!i.isReady||!await this.isValidTargetWorkspacePath(i,n,o))return;const s=await this.doEnterWorkspace(i,(0,k.getWorkspaceIdentifier)(o));if(!!s)return this._onDidEnterWorkspace.fire({window:i,workspace:s.workspace}),s}async isValidTargetWorkspacePath(i,n,o){return o?(0,b.isWorkspaceIdentifier)(i.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,p.findWindowOnWorkspaceOrFolder)(n,o)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,g.basename)(o)),detail:(0,v.localize)(2,null)},(0,h.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1):!0:!0}async doEnterWorkspace(i,n){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority})),(0,b.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=n,i.config.backupPath=o,{workspace:n,backupPath:o}}};t=we([X(0,y.IEnvironmentMainService),X(1,a.ILogService),X(2,f.IUserDataProfilesMainService),X(3,S.IBackupMainService),X(4,l.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(Z[127],ee([0,1,15,42,22,6,30,29,53,10,5]),function(x,e,I,M,r,R,D,P,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let v=class{constructor(l,y,m){this.windowsMainService=l,this.workspacesManagementMainService=y,this.logService=m}async getRemoteDiagnostics(l){const y=this.windowsMainService.getWindows();return(await Promise.all(y.map(async a=>{const f=a.remoteAuthority;if(!f)return;const p=`vscode:getDiagnosticInfoResponse${a.id}`,b={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?await this.getFolderURIs(a):void 0};return new Promise(E=>{a.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:p,args:b}),M.validatedIpcMain.once(p,(k,t)=>{t||E({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),E(t)}),setTimeout(()=>{E({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(a=>!!a)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const l=[];for(const y of I.BrowserWindow.getAllWindows()){const m=this.windowsMainService.getWindowById(y.id);m?l.push(await this.codeWindowToInfo(m)):l.push(this.browserWindowToInfo(y))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async codeWindowToInfo(l){const y=await this.getFolderURIs(l),m=(0,h.assertIsDefined)(l.win);return this.browserWindowToInfo(m,y,l.remoteAuthority)}browserWindowToInfo(l,y=[],m){return{pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:y,remoteAuthority:m}}async getFolderURIs(l){const y=[],m=l.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(m))y.push(m.uri);else if((0,P.isWorkspaceIdentifier)(m)){const a=await this.workspacesManagementMainService.resolveLocalWorkspace(m.configPath);a&&a.folders.forEach(p=>{y.push(p.uri)})}return y}};v=we([X(0,D.IWindowsMainService),X(1,g.IWorkspacesManagementMainService),X(2,w.ILogService)],v),e.DiagnosticsMainService=v}),define(Z[58],ee([0,1,46,15,26,152,54,3,2,14,9,4,8,103,85,23,101,177,57,28,6,20,5,21,69,30,29,53,17,234,227,33]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c,i,n,o,u,s,d,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let O=class extends g.Disposable{constructor(z,q,ie,se,oe,he,le,ge,V,B){super(),this.sharedProcess=z,this.windowsMainService=q,this.dialogMainService=ie,this.lifecycleMainService=se,this.environmentMainService=oe,this.logService=he,this.productService=le,this.themeMainService=ge,this.stateService=V,this.workspacesManagementMainService=B,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,T=>T.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:T,x:H,y:Y})=>({windowId:T.id,x:H,y:Y})),({windowId:T})=>!!this.windowsMainService.getWindowById(T)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-maximize",(T,H)=>H.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-unmaximize",(T,H)=>H.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-blur",(T,H)=>H.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),T=>!!T),T=>T.id),P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-focus",(T,H)=>H.id),T=>!!this.windowsMainService.getWindowById(T))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(M.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(M.screen,"display-metrics-changed",(T,H,Y)=>Y),T=>!(Array.isArray(T)&&T.length===1&&T[0]==="workArea")),P.Event.fromNodeEventEmitter(M.screen,"display-added"),P.Event.fromNodeEventEmitter(M.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(q=>({id:q.id,workspace:q.openedWorkspace??(0,o.toWorkspaceIdentifier)(q.backupPath,q.isExtensionDevelopmentHost),title:q.win?.getTitle()??"",filename:q.getRepresentedFilename(),dirty:q.isDocumentEdited()}))}async getWindowCount(z){return this.windowsMainService.getWindowCount()}async getActiveWindowId(z){const q=M.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(q)return q.id}openWindow(z,q,ie){return Array.isArray(q)?this.doOpenWindow(z,q,ie):this.doOpenEmptyWindow(z,q)}async doOpenWindow(z,q,ie=Object.create(null)){q.length>0&&await this.windowsMainService.open({context:5,contextWindowId:z,urisToOpen:q,cli:this.environmentMainService.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async doOpenEmptyWindow(z,q){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:z},q)}async toggleFullScreen(z){this.windowById(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.windowById(z)?.handleTitleDoubleClick()}async isMaximized(z){const q=this.windowById(z);return q?.win?q.win.isMaximized():!1}async maximizeWindow(z){const q=this.windowById(z);q?.win&&q.win.maximize()}async unmaximizeWindow(z){const q=this.windowById(z);q?.win&&q.win.unmaximize()}async minimizeWindow(z){const q=this.windowById(z);q?.win&&q.win.minimize()}async updateWindowControls(z,q){const ie=this.windowById(z);ie&&ie.updateWindowControls(q)}async focusWindow(z,q){q&&typeof q.windowId=="number"&&(z=q.windowId),this.windowById(z)?.focus({force:q?.force??!1})}async setMinimumSize(z,q,ie){const se=this.windowById(z);if(se?.win){const[oe,he]=se.win.getSize(),[le,ge]=se.win.getMinimumSize(),[V,B]=[q??le,ie??ge],[T,H]=[Math.max(oe,V),Math.max(he,B)];(le!==V||ge!==B)&&se.win.setMinimumSize(V,B),(oe!==T||he!==H)&&se.win.setSize(T,H)}}async saveWindowSplash(z,q){this.themeMainService.saveWindowSplash(z,q)}async installShellCommand(z){const{source:q,target:ie}=await this.getShellCommandLink();try{const{symbolicLink:se}=await m.SymlinkSupport.stat(q);if(se&&!se.dangling){const oe=await(0,l.realpath)(q);if(ie===oe)return}await m.Promises.unlink(q)}catch(se){if(se.code!=="ENOENT")throw se}try{await m.Promises.symlink(ie,q)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:oe}=await this.showMessageBox(z,{type:"info",message:(0,f.localize)(0,null,this.productService.nameShort),buttons:[(0,f.localize)(1,null),(0,f.localize)(2,null)]});if(oe===0)try{const he=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${q}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(he)}catch{throw new Error((0,f.localize)(3,null,q))}}}async uninstallShellCommand(z){const{source:q}=await this.getShellCommandLink();try{await m.Promises.unlink(q)}catch(ie){switch(ie.code){case"EACCES":{const{response:se}=await this.showMessageBox(z,{type:"info",message:(0,f.localize)(4,null,this.productService.nameShort),buttons:[(0,f.localize)(5,null),(0,f.localize)(6,null)]});if(se===0)try{const oe=`osascript -e "do shell script \\"rm '${q}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(oe)}catch{throw new Error((0,f.localize)(7,null,q))}break}case"ENOENT":break;default:throw ie}}}async getShellCommandLink(){const z=(0,w.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),q=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(z))throw new Error((0,f.localize)(8,null,z));return{source:q,target:z}}async showMessageBox(z,q){return this.dialogMainService.showMessageBox(q,this.toBrowserWindow(z))}async showSaveDialog(z,q){return this.dialogMainService.showSaveDialog(q,this.toBrowserWindow(z))}async showOpenDialog(z,q){return this.dialogMainService.showOpenDialog(q,this.toBrowserWindow(z))}toBrowserWindow(z){const q=this.windowById(z);if(q?.win)return q.win}async pickFileFolderAndOpen(z,q){const ie=await this.dialogMainService.pickFileFolder(q);ie&&await this.doOpenPicked(await Promise.all(ie.map(async se=>await m.SymlinkSupport.existsDirectory(se)?{folderUri:S.URI.file(se)}:{fileUri:S.URI.file(se)})),q,z)}async pickFolderAndOpen(z,q){const ie=await this.dialogMainService.pickFolder(q);ie&&await this.doOpenPicked(ie.map(se=>({folderUri:S.URI.file(se)})),q,z)}async pickFileAndOpen(z,q){const ie=await this.dialogMainService.pickFile(q);ie&&await this.doOpenPicked(ie.map(se=>({fileUri:S.URI.file(se)})),q,z)}async pickWorkspaceAndOpen(z,q){const ie=await this.dialogMainService.pickWorkspace(q);ie&&await this.doOpenPicked(ie.map(se=>({workspaceUri:S.URI.file(se)})),q,z)}async doOpenPicked(z,q,ie){await this.windowsMainService.open({context:3,contextWindowId:ie,cli:this.environmentMainService.args,urisToOpen:z,forceNewWindow:q.forceNewWindow})}async showItemInFolder(z,q){M.shell.showItemInFolder(q)}async setRepresentedFilename(z,q){this.windowById(z)?.setRepresentedFilename(q)}async setDocumentEdited(z,q){this.windowById(z)?.setDocumentEdited(q)}async openExternal(z,q){return v.isLinuxSnap?this.safeSnapOpenExternal(q):M.shell.openExternal(q),!0}safeSnapOpenExternal(z){const q=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,M.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=q,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(z,q){return M.shell.trashItem(q)}async isAdmin(){let z;return v.isWindows?z=(await new Promise((q,ie)=>{x(["native-is-elevated"],q,ie)}))():z=process.getuid()===0,z}async writeElevated(z,q,ie,se){const oe=await new Promise((he,le)=>{x(["@vscode/sudo-prompt"],he,le)});return new Promise((he,le)=>{const ge=[`"${this.cliPath}"`];se?.unlock&&ge.push("--file-chmod"),ge.push("--file-write",`"${q.fsPath}"`,`"${ie.fsPath}"`);const V={name:this.productService.nameLong.replace("-",""),icns:v.isMacintosh&&this.environmentMainService.isBuilt?(0,w.join)((0,w.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(ge.join(" "),V,(B,T,H)=>{T&&this.logService.trace(`[sudo-prompt] received stdout: ${T}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),B?le(B):he(void 0)})})}get cliPath(){return v.isWindows?this.environmentMainService.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,w.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):v.isLinux?this.environmentMainService.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,w.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,w.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,w.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,d.hasWSLFeatureInstalled)()}async killProcess(z,q,ie){process.kill(q,ie)}async readClipboardText(z,q){return M.clipboard.readText(q)}async writeClipboardText(z,q,ie){return M.clipboard.writeText(q,ie)}async readClipboardFindText(z){return M.clipboard.readFindText()}async writeClipboardFindText(z,q){return M.clipboard.writeFindText(q)}async writeClipboardBuffer(z,q,ie,se){return M.clipboard.writeBuffer(q,Buffer.from(ie.buffer),se)}async readClipboardBuffer(z,q){return s.VSBuffer.wrap(M.clipboard.readBuffer(q))}async hasClipboard(z,q,ie){return M.clipboard.has(q,ie)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){M.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){M.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){M.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){M.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){M.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,q){this.windowById(z)?.updateTouchBar(q)}async notifyReady(z){this.windowById(z)?.setReady()}async relaunch(z,q){return this.lifecycleMainService.relaunch(q)}async reload(z,q){const ie=this.windowById(z);if(ie){if((0,o.isWorkspaceIdentifier)(ie.openedWorkspace)){const se=ie.openedWorkspace.configPath;if(se.scheme===h.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(ie,q?.disableExtensions!==void 0?{_:[],"disable-extensions":q.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,q){const ie=this.windowById(q);if(ie?.win)return ie.win.close()}async quit(z){const q=this.windowsMainService.getLastActiveWindow();q?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&q.win?q.win.close():this.lifecycleMainService.quit()}async exit(z,q){await this.lifecycleMainService.kill(q)}async resolveProxy(z,q){const se=this.windowById(z)?.win?.webContents?.session;if(se)return se.resolveProxy(q)}findFreePort(z,q,ie,se,oe=1){return(0,a.findFreePort)(q,ie,se,oe)}async openDevTools(z,q){const ie=this.windowById(z);ie?.win&&ie.win.webContents.openDevTools(q)}async toggleDevTools(z){const q=this.windowById(z);q?.win&&q.win.webContents.toggleDevTools()}async sendInputEvent(z,q){const ie=this.windowById(z);ie?.win&&(q.type==="mouseDown"||q.type==="mouseUp")&&ie.win.webContents.sendInputEvent(q)}async enableSandbox(z,q){q?this.stateService.setItem("window.experimental.useSandbox",!0):this.stateService.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async profileRenderer(z,q,ie){const se=this.windowById(z);if(!se||!se.win)throw new Error;return await new C.WindowProfiler(se.win,q,this.logService).inspect(ie)}async windowsGetStringRegKey(z,q,ie,se){if(!v.isWindows)return;const oe=await new Promise((he,le)=>{x(["@vscode/windows-registry"],he,le)});try{return oe.GetStringRegKey(q,ie,se)}catch{return}}windowById(z){if(typeof z=="number")return this.windowsMainService.getWindowById(z)}};we([D.memoize],O.prototype,"cliPath",null),O=we([X(1,n.IWindowsMainService),X(2,p.IDialogMainService),X(3,k.ILifecycleMainService),X(4,b.IEnvironmentMainService),X(5,t.ILogService),X(6,c.IProductService),X(7,i.IThemeMainService),X(8,L.IStateService),X(9,u.IWorkspacesManagementMainService)],O),e.NativeHostMainService=O}),define(Z[277],ee([0,1,15,42,26,2,14,4,104,175,88,127,57,28,6,5,58,66,21,67,78,32,10,33]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");const i="issue.processExplorerWindowState";let n=class Ct{constructor(s,d,C,L,O,F,z,q,ie,se){this.userEnv=s,this.environmentMainService=d,this.logService=C,this.diagnosticsService=L,this.diagnosticsMainService=O,this.dialogMainService=F,this.nativeHostMainService=z,this.protocolMainService=q,this.productService=ie,this.stateService=se,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){M.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[d,C]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),L=await this.diagnosticsService.getSystemInfo(d,C);this.safeSend(s,"vscode:issueSystemInfoResponse",L)}),M.validatedIpcMain.on("vscode:listProcesses",async s=>{const d=[];try{d.push({name:(0,h.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(L=>{(0,w.isRemoteDiagnosticError)(L)?d.push({name:L.hostName,rootProcess:L}):L.processes&&d.push({name:L.hostName,rootProcess:L.processes})})}catch(C){this.logService.error(`Listing processes failed: ${C}`)}this.safeSend(s,"vscode:listProcessesResponse",d)}),M.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{if(this.issueReporterWindow){const{response:d}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(1,null),buttons:[(0,h.localize)(2,null),(0,h.localize)(3,null)]},this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",d===0)}}),M.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const d=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",d)}),M.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.issueReporterWindow){const{response:s}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(4,null),buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]},this.issueReporterWindow);s===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}),M.validatedIpcMain.on("vscode:workbenchCommand",(s,d)=>{const{id:C,from:L,args:O}=d;let F;switch(L){case"issueReporter":F=this.issueReporterParentWindow;break;case"processExplorer":F=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${L}`)}F?.webContents.send("vscode:runAction",{id:C,from:L,args:O})}),M.validatedIpcMain.on("vscode:openExternal",(s,d)=>{this.nativeHostMainService.openExternal(void 0,d)}),M.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),M.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),M.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const d=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",d.windows)})}safeSend(s,d,...C){s.sender.isDestroyed()||s.sender.send(d,...C)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=I.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const d=new R.DisposableStore,C=d.add(this.protocolMainService.createIPCObjectUrl()),L=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(L,C,{backgroundColor:s.styles.backgroundColor,title:(0,h.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),C.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:f.default}),this.issueReporterWindow.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,d.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,d.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=I.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const d=new R.DisposableStore,C=d.add(this.protocolMainService.createIPCObjectUrl()),L=this.stateService.getItem(i,void 0),O=o(L)?L:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(O,C,{backgroundColor:s.styles.backgroundColor,title:(0,h.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),C.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:f.default}),this.processExplorerWindow.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,d.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,d.dispose())});const F=()=>{if(!this.processExplorerWindow)return;const z=this.processExplorerWindow.getSize(),q=this.processExplorerWindow.getPosition();if(!z||!q)return;const ie={width:z[0],height:z[1],x:q[0],y:q[1]};this.stateService.setItem(i,ie)};this.processExplorerWindow.on("moved",F),this.processExplorerWindow.on("resized",F)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,d,C,L){const O=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:C.title,backgroundColor:C.backgroundColor||Ct.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:D.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${d.resource.toString()}`,`--vscode-window-kind=${L}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,E.zoomLevelToZoomFactor)(C.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:C.alwaysOnTop,experimentalDarkMode:!0});return O.setMenuBarVisibility(!1),O}async getSystemStatus(){const[s,d]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,d)}getWindowPosition(s,d,C){let L;const O=I.screen.getAllDisplays();if(O.length===1)L=O[0];else{if(P.isMacintosh){const q=I.screen.getCursorScreenPoint();L=I.screen.getDisplayNearestPoint(q)}!L&&s&&(L=I.screen.getDisplayMatching(s.getBounds())),L||(L=I.screen.getPrimaryDisplay()||O[0])}const F=L.bounds,z={width:d,height:C,x:F.x+F.width/2-d/2,y:F.y+F.height/2-C/2};return F.width>0&&F.height>0&&(z.x<F.x&&(z.x=F.x),z.y<F.y&&(z.y=F.y),z.x>F.x+F.width&&(z.x=F.x),z.y>F.y+F.height&&(z.y=F.y),z.width>F.width&&(z.width=F.width),z.height>F.height&&(z.height=F.height)),z}async getPerformanceInfo(){try{const[s,d]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,d)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await I.contentTracing.stopRecording(`${(0,k.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,h.localize)(9,null),detail:(0,h.localize)(10,null,s),buttons:[(0,h.localize)(11,null)]},(0,t.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};n.DEFAULT_BACKGROUND_COLOR="#1E1E1E",n=we([X(1,l.IEnvironmentMainService),X(2,m.ILogService),X(3,w.IDiagnosticsService),X(4,v.IDiagnosticsMainService),X(5,S.IDialogMainService),X(6,a.INativeHostMainService),X(7,b.IProtocolMainService),X(8,p.IProductService),X(9,c.IStateService)],n),e.IssueMainService=n;function o(u){return typeof u!="object"||u===null?!1:"x"in u&&"y"in u&&"width"in u&&"height"in u}}),define(Z[278],ee([0,1,22,18,28,20,5,58,21,56,24,49,94]),function(x,e,I,M,r,R,D,P,g,h,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let l=class extends S.AbstractUpdateService{constructor(m,a,f,p,b,E,k,t){super(m,a,p,b,E,t),this.telemetryService=f,this.nativeHostMainService=k}buildUpdateFeedUrl(m){return(0,S.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(v.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},I.CancellationToken.None).then(h.asJson).then(a=>{!a||!a.url||!a.version||!a.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(v.State.Idle(1))):this.setState(v.State.AvailableForDownload(a))}).then(void 0,a=>{this.logService.error(a),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const f=m?a.message||a:void 0;this.setState(v.State.Idle(1,f))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(v.State.Idle(1))}};l=we([X(0,R.ILifecycleMainService),X(1,M.IConfigurationService),X(2,w.ITelemetryService),X(3,r.IEnvironmentMainService),X(4,h.IRequestService),X(5,D.ILogService),X(6,P.INativeHostMainService),X(7,g.IProductService)],l),e.LinuxUpdateService=l}),define(Z[279],ee([0,1,46,41,26,7,22,54,9,8,138,23,18,28,16,20,5,58,21,56,24,49,94]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(u,s=1e3){for(;!u();)await(0,R.timeout)(s)}let i;function n(){return typeof i>"u"&&(M.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?i=0:g.basename(g.normalize(g.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let o=class extends t.AbstractUpdateService{get cachePath(){const s=g.join((0,r.tmpdir)(),`${this.productService.applicationName}-update-${this.productService.target}-${process.arch}`);return v.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,d,C,L,O,F,z,q,ie){super(s,d,L,O,F,ie),this.telemetryService=C,this.fileService=z,this.nativeHostMainService=q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(s){let d="win32";switch(process.arch!=="ia32"&&(d+=`-${process.arch}`),n()){case 1:d+="-archive";break;case 3:d+="-msi";break;default:this.productService.target==="user"&&(d+="-user")}return(0,t.createUpdateURL)(d,s,this.productService)}doCheckForUpdates(s){!this.url||(this.setState(k.State.CheckingForUpdates(s)),this.requestService.request({url:this.url},D.CancellationToken.None).then(b.asJson).then(d=>{const C=n();return!d||!d.url||!d.version||!d.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!s}),this.setState(k.State.Idle(C)),Promise.resolve(null)):C===1?(this.setState(k.State.AvailableForDownload(d)),Promise.resolve(null)):(this.setState(k.State.Downloading(d)),this.cleanup(d.version).then(()=>this.getUpdatePackagePath(d.version).then(L=>v.Promises.exists(L).then(O=>{if(O)return Promise.resolve(L);const F=d.url,z=d.hash,q=`${L}.tmp`;return this.requestService.request({url:F},D.CancellationToken.None).then(ie=>this.fileService.writeFile(h.URI.file(q),ie.stream)).then(z?()=>(0,w.checksum)(q,d.hash):()=>{}).then(()=>v.Promises.rename(q,L)).then(()=>L)})).then(L=>{const O=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},O&&d.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(k.State.Downloaded(d)):this.setState(k.State.Ready(d))})))}).then(void 0,d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!s});const C=s?d.message||d:void 0;this.setState(k.State.Idle(n(),C))}))}async doDownloadUpdate(s){s.update.url&&this.nativeHostMainService.openExternal(void 0,s.update.url),this.setState(k.State.Idle(n()))}async getUpdatePackagePath(s){const d=await this.cachePath;return g.join(d,`CodeSetup-${this.productService.quality}-${s}.exe`)}async cleanup(s=null){const d=s?F=>!new RegExp(`${this.productService.quality}-${s}\\.exe$`).test(F):()=>!0,C=await this.cachePath,O=(await v.Promises.readdir(C)).filter(d).map(async F=>{try{await v.Promises.unlink(g.join(C,F))}catch{}});await Promise.all(O)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const s=this.state.update;this.setState(k.State.Updating(s));const d=await this.cachePath;this.availableUpdate.updateFilePath=g.join(d,`CodeSetup-${this.productService.quality}-${s.version}.flag`),await v.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(k.State.Idle(n()))});const L=`${this.productService.win32MutexName}-ready`,O=await new Promise((F,z)=>{x(["windows-mutex"],F,z)});c(()=>O.isActive(L)).then(()=>this.setState(k.State.Ready(s)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?M.unlinkSync(this.availableUpdate.updateFilePath):n()==3?(0,I.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const d=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!d};this.setState(k.State.Downloading(C)),this.availableUpdate={packagePath:s},d?this.productService.target==="user"?this.doApplyUpdate():this.setState(k.State.Downloaded(C)):this.setState(k.State.Ready(C))}};we([P.memoize],o.prototype,"cachePath",null),o=we([X(0,m.ILifecycleMainService),X(1,S.IConfigurationService),X(2,E.ITelemetryService),X(3,l.IEnvironmentMainService),X(4,b.IRequestService),X(5,a.ILogService),X(6,y.IFileService),X(7,f.INativeHostMainService),X(8,p.IProductService)],o),e.Win32UpdateService=o}),define(Z[280],ee([0,1,15,7,22,44,3,2,14,9,64,4,8,183,63,18,57,28,62,16,20,5,21,67,242,97,24,137,69,78,30,29,53,124,128,38,33,52,58,244,120,48,93,26,121,65]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c,i,n,o,u,s,d,C,L,O,F,z,q,ie,se,oe,he,le,ge,V,B,T,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Y;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.NAVIGATING=1]="NAVIGATING",ne[ne.READY=2]="READY"})(Y||(Y={}));let te=class ot extends P.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get isSandboxed(){return this._isSandboxed}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const U=this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,L.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(U,A,W,_,$,Q,N,j,G,re,ue,ye,Me,Te,Ae,We,me,pe,ke,J,ae){super(),this.logService=A,this.loggerMainService=W,this.environmentMainService=_,this.policyService=$,this.userDataProfilesService=Q,this.fileService=N,this.applicationStorageMainService=j,this.storageMainService=G,this.configurationService=re,this.themeMainService=ue,this.workspacesManagementMainService=ye,this.backupMainService=Me,this.telemetryService=Te,this.dialogMainService=Ae,this.lifecycleMainService=We,this.productService=me,this.protocolMainService=pe,this.windowsMainService=ke,this.stateService=J,this.nativeHostMainService=ae,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this._isSandboxed=!1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;let de=!1;{const[Pe,Re]=this.restoreWindowState(U.state);this.windowState=Pe,this.logService.trace("window#ctor: using window state",Pe);const Oe=this.windowState.mode===0||this.windowState.mode===3;typeof ot.sandboxState>"u"&&(ot.sandboxState=this.stateService.getItem("window.experimental.useSandbox",!1));const _e=this.configurationService.getValue("window");typeof _e?.experimental?.useSandbox=="boolean"?de=_e.experimental.useSandbox:this.productService.quality==="stable"&&ot.sandboxState?de=!0:de=typeof this.productService.quality=="string"&&this.productService.quality!=="stable",this._isSandboxed=de;const Be={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:d.WindowMinimumSize.WIDTH,minHeight:d.WindowMinimumSize.HEIGHT,show:!Oe,title:this.productService.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,d.zoomLevelToZoomFactor)(_e?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...de?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?Be.icon=(0,h.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):v.isWindows&&!this.environmentMainService.isBuilt&&(Be.icon=(0,h.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.useNativeFullScreen()&&(Be.fullscreenable=!1),v.isMacintosh&&(Be.acceptFirstMouse=!0,_e?.clickThroughInactive===!1&&(Be.acceptFirstMouse=!1));const ze=v.isMacintosh&&_e?.nativeTabs===!0;ze&&(Be.tabbingIdentifier=this.productService.nameShort);const Fe=(0,d.getTitleBarStyle)(this.configurationService)==="custom";if(Fe&&(Be.titleBarStyle="hidden",v.isMacintosh||(Be.frame=!1),(0,d.useWindowControlsOverlay)(this.configurationService))){const qe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),K=z.Color.fromHex(qe).isDarker()?"#FFFFFF":"#000000";Be.titleBarOverlay={height:29,color:qe,symbolColor:K},this.hasWindowControlOverlay=!0}if((0,w.mark)("code/willCreateCodeBrowserWindow"),this._win=new I.BrowserWindow(Be),(0,w.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,v.isMacintosh&&Fe&&this._win.setSheetOffset(22),Fe&&(v.isWindows&&(0,d.useWindowControlsOverlay)(this.configurationService)||v.isMacintosh)){const qe=this.stateService.getItem(ot.windowControlHeightStateStorageKey);qe&&this.updateWindowControls({height:qe})}v.isWindows&&Fe&&this._win.hookWindowMessage(278,()=>{const[K,ce]=this._win.getPosition(),fe=I.screen.getCursorScreenPoint(),Se=fe.x-K,ve=fe.y-ce;return(()=>!(Se>30&&ve>=0&&ve<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Se,y:ve})),0}),(v.isMacintosh||v.isWindows)&&Re&&(!ze||I.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(qe=>typeof qe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Oe&&((0,w.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,w.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners(de)}setRepresentedFilename(U){v.isMacintosh?this._win.setRepresentedFilename(U):this.representedFilename=U}getRepresentedFilename(){return v.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(U){v.isMacintosh&&this._win.setDocumentEdited(U),this.documentEdited=U}isDocumentEdited(){return v.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(U){v.isMacintosh&&U?.force&&I.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.whenReadyCallbacks.push(U)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(U=>{function A(){W.dispose(),_.dispose(),U()}const W=this.onDidClose(()=>A()),_=this.onWillLoad(()=>A())})}registerListeners(U){this._win.on("unresponsive",()=>this.onWindowError(1,{sandboxed:U})),this._win.webContents.on("render-process-gone",(W,_)=>this.onWindowError(2,{..._,sandboxed:U})),this._win.webContents.on("did-fail-load",(W,_,$)=>this.onWindowError(3,{reason:$,exitCode:_,sandboxed:U})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),I.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),I.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,_)=>{const $=await this.getMarketplaceHeaders();_({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,$)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(U,A){switch(U){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${A?.reason||"<unknown>"}, code: ${A?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${A?.reason||"<unknown>"}, code: ${A?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:U,reason:A?.reason,code:A?.exitCode,sandboxed:A?.sandboxed?"1":"0"}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:W,checkboxChecked:_}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,l.localize)(0,null),(0,l.localize)(1,null),(0,l.localize)(2,null)],message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null),checkboxLabel:this._config?.workspace?(0,l.localize)(5,null):void 0},this._win);if(W!==2){const $=W===0;await this.destroyWindow($,_)}}else if(U===2)if(v.isWindows&&A?.reason==="launch-failed"&&A.exitCode===18&&await this.nativeHostMainService.isAdmin(void 0))await this.handleWindowsAdminCrash(A);else{let W;A?W=(0,l.localize)(7,null,A.reason,A.exitCode??"<unknown>"):W=(0,l.localize)(6,null);const{response:_,checkboxChecked:$}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,l.localize)(8,null):(0,l.localize)(9,null),(0,l.localize)(10,null)],message:W,detail:this._config?.workspace?(0,l.localize)(11,null):(0,l.localize)(12,null),checkboxLabel:this._config?.workspace?(0,l.localize)(13,null):void 0},this._win),Q=_===0;await this.destroyWindow(Q,$)}break}}async handleWindowsAdminCrash(U){const A=[],W=(0,ge.isInternalTelemetry)(this.productService,this.configurationService);if((0,ge.supportsTelemetry)(this.productService,this.environmentMainService)){this.productService.aiConfig&&this.productService.aiConfig.ariaKey&&A.push(new he.OneDataSystemAppender(W,"monacoworkbench",null,this.productService.aiConfig.ariaKey));const{installSourcePath:$}=this.environmentMainService,Q=await(0,T.resolveMachineId)(this.stateService),N={appenders:A,sendErrorTelemetry:!1,commonProperties:(0,V.resolveCommonProperties)(this.fileService,(0,B.release)(),(0,B.hostname)(),process.arch,this.productService.commit,this.productService.version,Q,W,$),piiPaths:(0,ge.getPiiPathsFromEnvironment)(this.environmentMainService)};await new le.TelemetryService(N,this.configurationService,this.productService).publicLog2("windowadminerror",{reason:U.reason,code:U.exitCode})}const{response:_}=await this.dialogMainService.showMessageBox({type:"error",buttons:[(0,l.localize)(14,null),(0,l.localize)(15,null)],message:(0,l.localize)(16,null),detail:(0,l.localize)(17,null,this.productService.nameLong)},this._win);_===0&&await this.nativeHostMainService.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(A.map($=>$.flush())),await this.destroyWindow(!1,!1)}async destroyWindow(U,A){const W=this._config?.workspace;if(A&&W)try{const _=this.storageMainService.workspaceStorage(W);await _.init(),_.delete("memento/workbench.parts.editor"),await _.close()}catch(_){this.logService.error(_)}if(this._onDidDestroy.fire(),this._win?.destroy(),U&&this._config){let _,$;(0,L.isSingleFolderWorkspaceIdentifier)(W)?_={folderUri:W.uri}:(0,L.isWorkspaceIdentifier)(W)?_={workspaceUri:W.configPath}:$=!0;const[Q]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:_?[_]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});Q.focus()}}onDidDeleteUntitledWorkspace(U){this._config?.workspace?.id===U.id&&(this._config.workspace=void 0)}onConfigurationUpdated(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const A=this.getMenuBarVisibility();A!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=A,this.setMenuBarVisibility(A))}if(!U||U.affectsConfiguration("http.proxy")){let A=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;A?.endsWith("/")&&(A=A.substr(0,A.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((A||"").indexOf("@")===-1&&(A!==this.currentHttpProxy||W!==this.currentNoProxy)){this.currentHttpProxy=A,this.currentNoProxy=W;const _=A||"",$=W?`${W},<local>`:"<local>";this.logService.trace(`Setting proxy to '${_}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:_,proxyBypassRules:$,pacScript:""})}}}addTabbedWindow(U){v.isMacintosh&&U.win&&this._win.addTabbedWindow(U.win)}load(U,A=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!A.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),A.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(U,A),this.readyState===0?this._config=U:this.pendingLoadConfig=U,this.readyState=1,this._win.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new M.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:U.workspace,reason:A.isReload?3:W?2:1})}updateConfiguration(U,A){const W=(this._config??this.pendingLoadConfig)?.userEnv;if(W){const _=(0,p.isLaunchedFromCli)(W)&&!(0,p.isLaunchedFromCli)(U.userEnv),$=this.isExtensionDevelopmentHost;(_||$)&&(U.userEnv={...W,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),A.disableExtensions!==void 0&&(U["disable-extensions"]=A.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this._win.isMaximized(),U.partsSplash=this.themeMainService.getWindowSplash(),(0,w.mark)("code/willOpenNewWindow"),U.perfMarks=(0,w.getMarks)(),this.configObjectUrl.update(U)}async reload(U){const A=Object.assign({},this._config);A.workspace=await this.validateWorkspaceBeforeReload(A),delete A.filesToOpenOrCreate,delete A.filesToDiff,delete A.filesToMerge,delete A.filesToWait,this.isExtensionDevelopmentHost&&U&&(A.verbose=U.verbose,A.debugId=U.debugId,A.extensionEnvironment=U.extensionEnvironment,A["inspect-extensions"]=U["inspect-extensions"],A["inspect-brk-extensions"]=U["inspect-brk-extensions"],A["extensions-dir"]=U["extensions-dir"]),A.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),A.isInitialStartup=!1,A.policiesData=this.policyService.serialize(),A.continueOn=this.environmentMainService.continueOn,A.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},A.logLevel=this.loggerMainService.getLogLevel(),A.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(A,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async validateWorkspaceBeforeReload(U){if((0,L.isWorkspaceIdentifier)(U.workspace)){const A=U.workspace.configPath;if(A.scheme===g.Schemas.file&&!await this.fileService.exists(A))return}else if((0,L.isSingleFolderWorkspaceIdentifier)(U.workspace)){const A=U.workspace.uri;if(A.scheme===g.Schemas.file&&!await this.fileService.exists(A))return}return U.workspace}serializeWindowState(){if(!this._win)return(0,F.defaultWindowState)();if(this.isFullScreen){let W;try{W=I.screen.getDisplayMatching(this.getBounds())}catch{}const _=(0,F.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.windowState.width||_.width,height:this.windowState.height||_.height,x:this.windowState.x||0,y:this.windowState.y||0}}const U=Object.create(null);let A;if(!v.isMacintosh&&this._win.isMaximized()?A=0:A=1,A===0?U.mode=0:U.mode=1,A===1||A===0){let W;A===1?W=this.getBounds():W=this._win.getNormalBounds(),U.x=W.x,U.y=W.y,U.width=W.width,U.height=W.height}return U}updateWindowControls(U){if(U.height&&this.stateService.setItem(ot.windowControlHeightStateStorageKey,U.height),v.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(v.isMacintosh&&U.height!==void 0){const A=(U.height-15)/2;this._win.setTrafficLightPosition({x:A,y:A})}}restoreWindowState(U){(0,w.mark)("code/willRestoreCodeWindowState");let A=!1;if(U)try{const W=I.screen.getAllDisplays();A=W.length>1,U=this.validateWindowState(U,W)}catch(W){this.logService.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,w.mark)("code/didRestoreCodeWindowState"),[U||(0,F.defaultWindowState)(),A]}validateWindowState(U,A){if(this.logService.trace(`window#validateWindowState: validating window state on ${A.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(A.length===1){const $=this.getWorkingArea(A[0]);if($){let Q=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!$||(U.x<$.x&&(U.x=$.x),U.y<$.y&&(U.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),Q(),U.width>$.width&&(U.width=$.width),U.height>$.height&&(U.height=$.height),U.x>$.x+$.width-128&&(U.x=$.x+$.width-U.width),U.y>$.y+$.height-128&&(U.y=$.y+$.height-U.height),Q()}return U}if(U.display&&U.mode===3){const $=A.find(Q=>Q.id===U.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const Q=(0,F.defaultWindowState)(3);return Q.x=$.bounds.x,Q.y=$.bounds.y,Q}}let W,_;try{W=I.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),_=this.getWorkingArea(W)}catch{}if(W&&_&&U.x+U.width>_.x&&U.y+U.height>_.y&&U.x<_.x+_.width&&U.y<_.y+_.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",_),U}getWorkingArea(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,A]=this._win.getPosition(),[W,_]=this._win.getSize();return{x:U,y:A,width:W,height:_}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(U){this.useNativeFullScreen()?this.setNativeFullScreen(U):this.setSimpleFullScreen(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(U){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(U)}doSetNativeFullScreen(U){v.isMacintosh&&(this.transientIsNativeFullScreen=U,this.joinNativeFullScreenTransition=new M.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,M.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(U)}setSimpleFullScreen(U){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(U),this._win.webContents.focus()}useNativeFullScreen(){const U=this.configurationService.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let U=(0,d.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}setMenuBarVisibility(U,A=!0){v.isMacintosh||(U==="toggle"&&A&&this.send("vscode:showInfoMessage",(0,l.localize)(18,null)),U==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(U)}):this.doSetMenuBarVisibility(U))}doSetMenuBarVisibility(U){const A=this.isFullScreen;switch(U){case"classic":this._win.setMenuBarVisibility(!A),this._win.autoHideMenuBar=A;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(U,A,...W){this.isReady?this.send(U,...W):this.ready().then(()=>{A.isCancellationRequested||this.send(U,...W)})}send(U,...A){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this._win.webContents.send(U,...A)}catch(W){this.logService.warn(`Error sending IPC message to channel '${U}' of window ${this._id}: ${(0,R.toErrorMessage)(W)}`)}}}updateTouchBar(U){!v.isMacintosh||this.touchBarGroups.forEach((A,W)=>{const _=U[W];A.segments=this.createTouchBarGroupSegments(_)})}createTouchBar(){if(!!v.isMacintosh){for(let U=0;U<10;U++){const A=this.createTouchBarGroup();this.touchBarGroups.push(A)}this._win.setTouchBar(new I.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(U=[]){const A=this.createTouchBarGroupSegments(U),W=new I.TouchBar.TouchBarSegmentedControl({segments:A,mode:"buttons",segmentStyle:"automatic",change:_=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:W.segments[_].id,from:"touchbar"})}});return W}createTouchBarGroupSegments(U=[]){return U.map(W=>{let _;W.icon&&!u.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===g.Schemas.file&&(_=I.nativeImage.createFromPath(S.URI.revive(W.icon.dark).fsPath),_.isEmpty()&&(_=void 0));let $;return typeof W.title=="string"?$=W.title:$=W.title.value,{id:W.id,label:_?void 0:$,icon:_}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};te.windowControlHeightStateStorageKey="windowControlHeight",te.sandboxState=void 0,te=we([X(1,k.ILogService),X(2,H.ILoggerMainService),X(3,f.IEnvironmentMainService),X(4,q.IPolicyService),X(5,se.IUserDataProfilesMainService),X(6,b.IFileService),X(7,n.IApplicationStorageMainService),X(8,n.IStorageMainService),X(9,m.IConfigurationService),X(10,s.IThemeMainService),X(11,O.IWorkspacesManagementMainService),X(12,y.IBackupMainService),X(13,o.ITelemetryService),X(14,a.IDialogMainService),X(15,E.ILifecycleMainService),X(16,t.IProductService),X(17,c.IProtocolMainService),X(18,C.IWindowsMainService),X(19,ie.IStateService),X(20,oe.INativeHostMainService)],te),e.CodeWindow=te}),define(Z[80],ee([0,1,15,25,7,3,45,2,14,4,19,8,23,186,6,20,5,97,98,29,53,35]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let t=class tt extends P.Disposable{constructor(i,n,o,u){super(),this.logService=i,this.workspacesManagementMainService=n,this.lifecycleMainService=o,this.applicationStorageMainService=u,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const s of i)if((0,p.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&!this.containsWorkspace(n,s.workspace)&&n.push(s);else if((0,p.isRecentFolder)(s))this.containsFolder(n,s.folderUri)||n.push(s);else{const d=this.containsFile(o,s.fileUri),C=s.fileUri.scheme===g.Schemas.file&&tt.COMMON_FILES_FILTER.indexOf((0,w.basename)(s.fileUri))>=0;!d&&!C&&(o.push(s),h.isWindows&&s.fileUri.scheme===g.Schemas.file&&I.app.addRecentDocument(s.fileUri.fsPath))}const u=await this.mergeEntriesFromStorage({workspaces:n,files:o});n=u.workspaces,o=u.files,n.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=tt.MAX_TOTAL_RECENT_ENTRIES),o.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(o.length=tt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:o}),this._onDidChangeRecentlyOpened.fire(),h.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const n=d=>{const C=this.location(d);for(const L of i)if(w.extUriBiasedIgnorePathCase.isEqual(L,C))return!1;return!0},o=await this.getRecentlyOpened(),u=o.workspaces.filter(n),s=o.files.filter(n);(u.length!==o.workspaces.length||s.length!==o.files.length)&&(await this.saveRecentlyOpened({files:s,workspaces:u}),this._onDidChangeRecentlyOpened.fire(),h.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const n=new k.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.workspaces)for(const s of i.workspaces)n.set(this.location(s),s);const o=new k.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.files)for(const s of i.files)o.set(this.location(s),s);const u=await this.getRecentlyOpenedFromStorage();for(const s of u.workspaces){const d=n.get(this.location(s));d?d.label=d.label??s.label:n.set(this.location(s),s)}for(const s of u.files){const d=o.get(this.location(s));d?d.label=d.label??s.label:o.set(this.location(s),s)}return{workspaces:[...n.values()],files:[...o.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const n=this.applicationStorageMainService.get(tt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.logService.error("Unexpected error parsing opened paths list",o)}return(0,p.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(tt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,p.toStoreData)(i)),-1,1)}location(i){return(0,p.isRecentFolder)(i)?i.folderUri:(0,p.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,n){return!!i.find(o=>(0,p.isRecentWorkspace)(o)&&o.workspace.id===n.id)}containsFolder(i,n){return!!i.find(o=>(0,p.isRecentFolder)(o)&&w.extUriBiasedIgnorePathCase.isEqual(o.folderUri,n))}containsFile(i,n){return!!i.find(o=>w.extUriBiasedIgnorePathCase.isEqual(o.fileUri,n))}async handleWindowsJumpList(){!h.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!h.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,l.localize)(0,null),description:(0,l.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const s of I.app.getJumpListSettings().removedItems){const d=s.args;if(d){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);C&&n.push(v.URI.parse(C[2]))}}await this.removeRecentlyOpened(n);let o=!1;const u=(0,M.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(s=>{const d=(0,p.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:C,description:L}=this.getWindowsJumpListLabel(d,s.label);let O;return v.URI.isUri(d)?O=`--folder-uri "${d.toString()}"`:(o=!0,O=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:L.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));u.length>0&&i.push({type:"custom",name:o?(0,l.localize)(2,null):(0,l.localize)(3,null),items:u})}i.push({type:"recent"});try{const n=I.app.setJumpList(i);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(i,n){if(n)return{title:(0,D.splitName)(n).name,description:n};if(v.URI.isUri(i))return{title:(0,w.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,l.localize)(4,null),description:""};let o=(0,w.basename)(i.configPath);return o.endsWith(b.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-b.WORKSPACE_EXTENSION.length-1)),{title:(0,l.localize)(5,null,o),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!h.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let s=0;s<i.workspaces.length&&o<tt.MAX_MACOS_DOCK_RECENT_WORKSPACES;s++){const d=this.location(i.workspaces[s]);if(d.scheme===g.Schemas.file){const C=(0,w.originalFSPath)(d);await S.Promises.exists(C)&&(n.push(C),o++)}}const u=[];for(let s=0;s<i.files.length&&o<tt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;s++){const d=this.location(i.files[s]);if(d.scheme===g.Schemas.file){const C=(0,w.originalFSPath)(d);if(tt.COMMON_FILES_FILTER.includes((0,w.basename)(d))||n.includes(C))continue;await S.Promises.exists(C)&&(u.push(C),o++)}}u.reverse().forEach(s=>I.app.addRecentDocument(s)),n.reverse().forEach(s=>I.app.addRecentDocument(s))}};t.MAX_TOTAL_RECENT_ENTRIES=500,t.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",t.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,t.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,t.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],t=we([X(0,a.ILogService),X(1,E.IWorkspacesManagementMainService),X(2,m.ILifecycleMainService),X(3,f.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(Z[281],ee([0,1,15,7,22,45,4,8,176,18,28,20,5,222,58,21,33,24,49,78,30,80]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=class St{constructor(o,u,s,d,C,L,O,F,z,q,ie){this.updateService=o,this.configurationService=u,this.windowsMainService=s,this.environmentMainService=d,this.telemetryService=C,this.workspacesHistoryMainService=L,this.stateService=O,this.lifecycleMainService=F,this.logService=z,this.nativeHostMainService=q,this.productService=ie,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new M.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new M.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,b.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateService.getItem(St.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,O,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(L,O,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,O,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const u=this.productService.requestFeatureUrl;u&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(u,"openUserVoiceUrl"));const s=this.productService.reportIssueUrl;s&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(s,"openReportIssues"));const d=this.productService.licenseUrl;d&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const L=d.indexOf("?")>0?"&":"?";this.openUrl(`${d}${L}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(d,"openLicenseUrl")});const C=this.productService.privacyStatementUrl;C&&d&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(C,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,u){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateService.setItem(St.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!D.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!I.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=I.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){I.Menu.setApplicationMenu(D.isMacintosh?new I.Menu:null);return}const u=new I.Menu;let s;if(D.isMacintosh){const C=new I.Menu;s=new I.MenuItem({label:this.productService.nameShort,submenu:C}),this.setMacApplicationMenu(C),u.append(s)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const C=new I.Menu;C.append(new I.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),I.app.dock.setMenu(C)}if(this.shouldDrawMenu("File")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:C});this.setMenuById(C,"File"),u.append(L)}if(this.shouldDrawMenu("Edit")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:C});this.setMenuById(C,"Edit"),u.append(L)}if(this.shouldDrawMenu("Selection")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:C});this.setMenuById(C,"Selection"),u.append(L)}if(this.shouldDrawMenu("View")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:C});this.setMenuById(C,"View"),u.append(L)}if(this.shouldDrawMenu("Go")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:C});this.setMenuById(C,"Go"),u.append(L)}if(this.shouldDrawMenu("Run")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),u.append(L)}if(this.shouldDrawMenu("Terminal")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:C});this.setMenuById(C,"Terminal"),u.append(L)}let d;if(this.shouldDrawMenu("Window")){const C=new I.Menu;d=new I.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:C,role:"window"}),this.setMacWindowMenu(C)}if(d&&u.append(d),this.shouldDrawMenu("Help")){const C=new I.Menu,L=new I.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:C,role:"help"});this.setMenuById(C,"Help"),u.append(L)}u.items&&u.items.length>0?I.Menu.setApplicationMenu(u):I.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const u=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),s=this.getUpdateMenuItems();let d;if(this.shouldDrawMenu("Preferences")){const se=new I.Menu;this.setMenuById(se,"Preferences"),d=new I.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:se})}const C=new I.Menu,L=new I.MenuItem({label:g.localize(12,null),role:"services",submenu:C}),O=new I.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new I.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new I.MenuItem({label:g.localize(15,null),role:"unhide"}),q=new I.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:async(se,oe,he)=>{const le=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),ie=[u];ie.push(...s),d&&ie.push(i(),d),ie.push(i(),L,i(),O,F,z,i(),q),ie.forEach(se=>o.append(se))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const u=this.configurationService.getValue("window.confirmBeforeClose");if(u==="always"||u==="keyboardOnly"&&this.isKeyboardEvent(o)){const{response:s}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)});return s===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,b.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,u){u.forEach(s=>{if((0,l.isMenubarMenuItemSeparator)(s))o.append(i());else if((0,l.isMenubarMenuItemSubmenu)(s)){const d=new I.Menu,C=new I.MenuItem({label:this.mnemonicLabel(s.label),submenu:d});this.setMenu(d,s.submenu.items),o.append(C)}else(0,l.isMenubarMenuItemRecentAction)(s)?o.append(this.createOpenRecentMenuItem(s)):(0,l.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[s.id]?o.append(new I.MenuItem(this.likeAction(s.id,{label:this.mnemonicLabel(s.label),click:this.fallbackMenuHandlers[s.id]}))):o.append(this.createMenuItem(s.label,s.id,!1,s.checked)):o.append(this.createMenuItem(s.label,s.id,s.enabled!==!1,!!s.checked)):o.append(this.createMenuItem(s.label,s.id,s.enabled!==!1,!!s.checked)))})}setMenuById(o,u){this.menubarMenus&&this.menubarMenus[u]&&this.setMenu(o,this.menubarMenus[u].items)}insertCheckForUpdatesItems(o){const u=this.getUpdateMenuItems();u.length&&(u.forEach(s=>o.append(s)),o.append(i()))}createOpenRecentMenuItem(o){const u=P.URI.revive(o.uri),s=o.id,d=s==="openRecentFile"?{fileUri:u}:s==="openRecentWorkspace"?{workspaceUri:u}:{folderUri:u};return new I.MenuItem(this.likeAction(s,{label:o.label,click:async(C,L,O)=>{const F=this.isOptionClick(O);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[d],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([u])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,u,s){const d={label:this.mnemonicLabel(o),role:s,enabled:!0};return new I.MenuItem(this.withKeybinding(u,d))}setMacWindowMenu(o){const u=new I.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),s=new I.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),d=new I.MenuItem({label:g.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),C=this.createMenuItem(g.localize(23,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(i()),L.push(this.createMenuItem(g.localize(24,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[u,s,i(),C,...L,i(),d].forEach(O=>o.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new I.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,u,s,d){const C=this.mnemonicLabel(o),L=typeof u=="function"?u:(ie,se,oe)=>{const he=ie?ie.userSettingsLabel:null;let le=u;Array.isArray(u)&&(le=this.isOptionClick(oe)?u[1]:u[0]),he&&oe.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:le})},O=typeof s=="boolean"?s:this.windowsMainService.getWindowCount()>0,F=typeof d=="boolean"?d:!1,z={label:C,click:L,enabled:O};F&&(z.type="checkbox",z.checked=F);let q;return typeof u=="string"?q=u:Array.isArray(u)&&(q=u[0]),D.isMacintosh&&(q==="editor.action.clipboardCutAction"?z.role="cut":q==="editor.action.clipboardCopyAction"?z.role="copy":q==="editor.action.clipboardPasteAction"&&(z.role="paste"),q==="undo"?z.click=this.makeContextAwareClickHandler(L,{inDevTools:ie=>ie.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?z.click=this.makeContextAwareClickHandler(L,{inDevTools:ie=>ie.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(z.click=this.makeContextAwareClickHandler(L,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.withKeybinding(q,z))}makeContextAwareClickHandler(o,u){return(s,d,C)=>{const L=I.BrowserWindow.getFocusedWindow();if(!L)return u.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return u.inDevTools(L.webContents.devToolsWebContents);o(s,d||L,C)}}runActionInRenderer(o){let u=I.BrowserWindow.getFocusedWindow();if(!u){const d=this.windowsMainService.getLastActiveWindow();d?.isMinimized()&&(u=d.win)}const s=u?this.windowsMainService.getWindowById(u.id):void 0;if(s){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!s.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const d={id:o.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",r.CancellationToken.None,d)}else{const d={userSettingsLabel:o.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,d)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,u){const s=typeof o=="string"?this.keybindings[o]:void 0;if(s?.label){if(s.isNative!==!1)u.accelerator=s.label,u.userSettingsLabel=s.userSettingsLabel;else if(typeof u.label=="string"){const d=u.label.indexOf("[");d>=0?u.label=`${u.label.substr(0,d)} [${s.label}]`:u.label=`${u.label} [${s.label}]`}}else u.accelerator=void 0;return u}likeAction(o,u,s=!u.accelerator){s&&(u=this.withKeybinding(o,u));const d=u.click;return u.click=(C,L,O)=>{this.reportMenuActionTelemetry(o),d?.(C,L,O)},u}openUrl(o,u){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(u)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:t})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};c.lastKnownMenubarStorageKey="lastKnownMenubarData",c=we([X(0,p.IUpdateService),X(1,h.IConfigurationService),X(2,E.IWindowsMainService),X(3,w.IEnvironmentMainService),X(4,f.ITelemetryService),X(5,k.IWorkspacesHistoryMainService),X(6,a.IStateService),X(7,v.ILifecycleMainService),X(8,S.ILogService),X(9,y.INativeHostMainService),X(10,m.IProductService)],c),e.Menubar=c;function i(){return new I.MenuItem({type:"separator"})}}),define(Z[282],ee([0,1,6,20,5,281]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let D=class{constructor(g,h,w){this.instantiationService=g,this.lifecycleMainService=h,this.logService=w,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(g,h){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(h,g)}};D=we([X(0,I.IInstantiationService),X(1,M.ILifecycleMainService),X(2,r.ILogService)],D),e.MenubarMainService=D}),define(Z[283],ee([0,1,15,23,26,25,22,3,32,50,45,2,14,9,64,4,36,19,10,8,184,63,18,57,28,16,6,20,5,66,67,55,33,78,280,126,275,29,99,80,53,69,38,52,65,71]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c,i,n,o,u,s,d,C,L,O,F,z,q,ie,se,oe,he,le,ge,V,B,T,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Y(U){return(0,se.isWorkspaceIdentifier)(U?.workspace)}function te(U){return(0,se.isSingleFolderWorkspaceIdentifier)(U?.workspace)}let ne=class at extends v.Disposable{constructor(A,W,_,$,Q,N,j,G,re,ue,ye,Me,Te,Ae,We,me,pe,ke){super(),this.machineId=A,this.initialUserEnv=W,this.logService=_,this.loggerService=$,this.stateService=Q,this.policyService=N,this.environmentMainService=j,this.userDataProfilesMainService=G,this.lifecycleMainService=re,this.backupMainService=ue,this.configurationService=ye,this.workspacesHistoryMainService=Me,this.workspacesManagementMainService=Te,this.instantiationService=Ae,this.dialogMainService=We,this.fileService=me,this.protocolMainService=pe,this.themeMainService=ke,this._onDidOpenWindow=this._register(new P.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new P.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new P.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new P.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new P.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ie.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const W=new v.DisposableStore;if(W.add(P.Event.any(A.onDidClose,A.onDidDestroy)(()=>W.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(_));A.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,W){const _=this.environmentMainService.args,$=W?.remoteAuthority||void 0,Q=!0,N=W?.forceReuseWindow,j=!N;return this.open({...A,cli:_,forceEmpty:Q,forceNewWindow:j,forceReuseWindow:N,remoteAuthority:$})}openExistingWindow(A,W){A.focus(),this.handleWaitMarkerFile(W,[A])}async open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const W=[],_=[],$=[],Q=[],N=[];let j,G=0;const re=await this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const Ae of re)te(Ae)?A.addMode?W.push(Ae):_.push(Ae):Y(Ae)?$.push(Ae):Ae.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),j.filesToOpenOrCreate.push(Ae)):Ae.backupPath?N.push({backupFolder:(0,l.basename)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):G++;A.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),A.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&A.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(Q.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),$.push(...Q),N.push(...this.backupMainService.getEmptyWindowBackups())):N.length=0;const{windows:ue,filesOpenedInWindow:ye}=await this.doOpen(A,$,_,N,G,j,W);if(this.logService.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${$.length}, foldersToOpen: ${_.length}, emptyToRestore: ${N.length}, emptyToOpen: ${G})`),ue.length>1)if(ye)ye.focus();else{const Ae=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let We=!0,me=!0;if(Ae){const pe=ue.filter(ke=>this.windowsStateHandler.state.lastActiveWindow&&ke.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),We=!1,me=!1)}if(We)for(let pe=ue.length-1;pe>=0;pe--){const ke=ue[pe];if(!(ke.openedWorkspace&&Q.some(J=>ke.openedWorkspace&&J.workspace.id===ke.openedWorkspace.id)||ke.backupPath&&N.some(J=>ke.backupPath&&J.backupFolder===(0,l.basename)(ke.backupPath)))){ke.focus(),me=!1;break}}me&&ue[ue.length-1].focus()}const Me=j&&j.filesToDiff.length>0,Te=j&&j.filesToMerge.length>0;if(!ue.some(Ae=>Ae.isExtensionDevelopmentHost)&&!Me&&!Te&&!A.noRecentEntry){const Ae=[];for(const We of re)Y(We)&&!We.transient?Ae.push({label:We.label,workspace:We.workspace,remoteAuthority:We.remoteAuthority}):te(We)?Ae.push({label:We.label,folderUri:We.workspace.uri,remoteAuthority:We.remoteAuthority}):We.fileUri&&Ae.push({label:We.label,fileUri:We.fileUri,remoteAuthority:We.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ae)}return this.handleWaitMarkerFile(A,ue),ue}handleWaitMarkerFile(A,W){const _=A.waitMarkerFileURI;A.context===0&&_&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}async doOpen(A,W,_,$,Q,N,j){const G=[];let re;function ue(pe,ke){G.push(pe),ke&&(re=pe,N=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:Me}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&j.length>0){const pe=j[0].remoteAuthority,ke=this.getLastActiveWindowForAuthority(pe);ke&&ue(this.doAddFoldersToExistingWindow(ke,j.map(J=>J.workspace.uri)))}const Te=_.length+W.length+$.length;if(N&&Te===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],ke=this.getWindows().filter(ae=>N&&(0,f.isEqualAuthority)(ae.remoteAuthority,N.remoteAuthority));let J;pe?.fileUri&&!Me&&((A.context===4||A.context===0||A.context===1)&&(J=await(0,q.findWindowOnFile)(ke,pe.fileUri,async ae=>ae.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(ae.configPath):void 0)),J||(J=this.doGetLastActiveWindow(ke))),J?(0,se.isWorkspaceIdentifier)(J.openedWorkspace)?W.push({workspace:J.openedWorkspace,remoteAuthority:J.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(J.openedWorkspace)?_.push({workspace:J.openedWorkspace,remoteAuthority:J.remoteAuthority}):ue(this.doOpenFilesInExistingWindow(A,J,N),!0):ue(await this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Ae=(0,R.distinct)(W,pe=>pe.workspace.id);if(Ae.length>0){const pe=(0,R.coalesce)(Ae.map(ke=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ke.workspace.configPath)));if(pe.length>0){const ke=pe[0],J=(0,f.isEqualAuthority)(N?.remoteAuthority,ke.remoteAuthority)?N:void 0;ue(this.doOpenFilesInExistingWindow(A,ke,J),!!J),ye=!0}for(const ke of Ae){if(pe.some(de=>de.openedWorkspace&&de.openedWorkspace.id===ke.workspace.id))continue;const J=ke.remoteAuthority,ae=(0,f.isEqualAuthority)(N?.remoteAuthority,J)?N:void 0;ue(await this.doOpenFolderOrWorkspace(A,ke,ye,ae),!!ae),ye=!0}}const We=(0,R.distinct)(_,pe=>f.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(We.length>0){const pe=(0,R.coalesce)(We.map(ke=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ke.workspace.uri)));if(pe.length>0){const ke=pe[0],J=(0,f.isEqualAuthority)(N?.remoteAuthority,ke.remoteAuthority)?N:void 0;ue(this.doOpenFilesInExistingWindow(A,ke,J),!!J),ye=!0}for(const ke of We){if(pe.some(de=>(0,se.isSingleFolderWorkspaceIdentifier)(de.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(de.openedWorkspace.uri,ke.workspace.uri)))continue;const J=ke.remoteAuthority,ae=(0,f.isEqualAuthority)(N?.remoteAuthority,J)?N:void 0;ue(await this.doOpenFolderOrWorkspace(A,ke,ye,ae),!!ae),ye=!0}}const me=(0,R.distinct)($,pe=>pe.backupFolder);if(me.length>0)for(const pe of me){const ke=pe.remoteAuthority,J=(0,f.isEqualAuthority)(N?.remoteAuthority,ke)?N:void 0;ue(await this.doOpenEmpty(A,!0,ke,J,pe),!!J),ye=!0}if(G.length===0||N){N&&!Q&&Q++;const pe=N?N.remoteAuthority:A.remoteAuthority;for(let ke=0;ke<Q;ke++)ue(await this.doOpenEmpty(A,ye,pe,N),!!N),ye=!0}return{windows:(0,R.distinct)(G),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,W,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),W.focus();const $={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",D.CancellationToken.None,$),W}doAddFoldersToExistingWindow(A,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),A.focus();const _={foldersToAdd:W};return A.sendWhenReady("vscode:addFolders",D.CancellationToken.None,_),A}doOpenEmpty(A,W,_,$,Q){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:_,filesToOpen:$,forceNewWindow:W});let N;return!W&&typeof A.contextWindowId=="number"&&(N=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:$,windowToUse:N,emptyWindowBackupInfo:Q,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}doOpenFolderOrWorkspace(A,W,_,$,Q){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:$}),!_&&!Q&&typeof A.contextWindowId=="number"&&(Q=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:$,windowToUse:Q,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async getPathsToOpen(A){let W,_=!1,$=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(W=await this.doExtractPathsFromAPI(A),_=!0):A.forceEmpty?W=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(W=await this.doExtractPathsFromCLI(A.cli),W.length===0&&W.push(Object.create(null)),_=!0):(W=await this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),$=!0),!A.addMode&&_){const Q=W.filter(N=>te(N));if(Q.length>1){const N=Q[0].remoteAuthority;if(Q.every(j=>(0,f.isEqualAuthority)(j.remoteAuthority,N))){const j=await this.workspacesManagementMainService.createUntitledWorkspace(Q.map(G=>({uri:G.workspace.uri})));W.push({workspace:j,remoteAuthority:N}),W=W.filter(G=>!te(G))}}}if(A.initialStartup&&!$&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Q=await this.doGetPathsFromLastSession();W.unshift(...Q.filter(N=>Y(N)||te(N)||N.backupPath))}return W}async doExtractPathsFromAPI(A){const W={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,R.coalesce)(A.urisToOpen||[]).map(async $=>{const Q=await this.resolveOpenable($,W);if(Q)return Q.label=$.label,Q;const N=this.resourceFromOpenable($);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:N.scheme===S.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:N.scheme===S.Schemas.file?(0,E.localize)(3,null,(0,w.getPathLabel)(N,{os:m.OS,tildify:this.environmentMainService})):(0,E.localize)(4,null,N.toString(!0))},(0,p.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(_)}async doExtractPathsFromCLI(A){const W=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},$=A["folder-uri"];if($){const j=await Promise.all($.map(G=>{const re=this.cliArgToUri(G);if(!!re)return this.resolveOpenable({folderUri:re},_)}));W.push(...(0,R.coalesce)(j))}const Q=A["file-uri"];if(Q){const j=await Promise.all(Q.map(G=>{const re=this.cliArgToUri(G);if(!!re)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(G)?{workspaceUri:re}:{fileUri:re},_)}));W.push(...(0,R.coalesce)(j))}const N=await Promise.all(A._.map(j=>_.remoteAuthority?this.doResolveRemotePath(j,_):this.doResolveFilePath(j,_)));return W.push(...(0,R.coalesce)(N)),W}cliArgToUri(A){try{const W=b.URI.parse(A);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${A}, ${W.message}`)}}async doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];A!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const _=await Promise.all(W.map(async $=>{if($.workspace){const Q=await this.resolveOpenable({workspaceUri:$.workspace.configPath},{remoteAuthority:$.remoteAuthority,rejectTransientWorkspaces:!0});if(Y(Q))return Q}else if($.folderUri){const Q=await this.resolveOpenable({folderUri:$.folderUri},{remoteAuthority:$.remoteAuthority});if(te(Q))return Q}else if(A!=="folders"&&$.backupPath)return{backupPath:$.backupPath,remoteAuthority:$.remoteAuthority}}));return(0,R.coalesce)(_)}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async resolveOpenable(A,W=Object.create(null)){const _=this.resourceFromOpenable(A);return _.scheme===S.Schemas.file?((0,F.isFileToOpen)(A)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,W)):this.doResolveRemoteOpenable(A,W)}doResolveRemoteOpenable(A,W){let _=this.resourceFromOpenable(A);const $=(0,L.getRemoteAuthority)(_)||W.remoteAuthority;if(_=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(_)),(0,F.isFileToOpen)(A)){if(W.gotoLineMode){const{path:Q,line:N,column:j}=(0,g.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:Q}),options:{selection:N?{startLineNumber:N,startColumn:j||1}:void 0},remoteAuthority:$}}return{fileUri:_,remoteAuthority:$}}else if((0,F.isWorkspaceToOpen)(A))return{workspace:(0,oe.getWorkspaceIdentifier)(_),remoteAuthority:$};return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:$}}resourceFromOpenable(A){return(0,F.isWorkspaceToOpen)(A)?A.workspaceUri:(0,F.isFolderToOpen)(A)?A.folderUri:A.fileUri}async doResolveFilePath(A,W){let _,$;W.gotoLineMode&&({path:A,line:_,column:$}=(0,g.parseLineAndColumnAware)(A)),A=(0,g.sanitizeFilePath)((0,l.normalize)(A),(0,a.cwd)());try{const Q=await M.Promises.stat(A);if(Q.isFile()){if(!W.forceOpenWorkspaceAsFile){const N=await this.workspacesManagementMainService.resolveLocalWorkspace(b.URI.file(A));if(N)return N.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:n.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:b.URI.file(A),type:n.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:$||1}:void 0}}}else{if(Q.isDirectory())return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(b.URI.file(A),Q),type:n.FileType.Directory,exists:!0};if(!m.isWindows&&A==="/dev/null")return{fileUri:b.URI.file(A),type:n.FileType.File,exists:!0}}}catch{const N=b.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),W.ignoreFileNotFound)return{fileUri:N,type:n.FileType.File,exists:!1}}}doResolveRemotePath(A,W){const _=A.charCodeAt(0),$=W.remoteAuthority;let Q,N;W.gotoLineMode&&({path:A,line:Q,column:N}=(0,g.parseLineAndColumnAware)(A)),_!==47&&((0,g.isWindowsDriveLetter)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,g.toSlashes)(A)),A=`/${A}`);const j=b.URI.from({scheme:S.Schemas.vscodeRemote,authority:$,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(A))return W.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:Q?{startLineNumber:Q,startColumn:N||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,oe.getWorkspaceIdentifier)(j),remoteAuthority:$};if(W.gotoLineMode||l.posix.basename(A).indexOf(".")!==-1)return{fileUri:j,options:{selection:Q?{startLineNumber:Q,startColumn:N||1}:void 0},remoteAuthority:$}}return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:$}}shouldOpenNewWindow(A){const W=this.configurationService.getValue("window"),_=W?.openFoldersInNewWindow||"default",$=W?.openFilesInNewWindow||"off";let Q=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(Q=_==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(m.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&($==="on"||$==="off")&&(N=$==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(A,W){const _=(0,q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(_)return this.lifecycleMainService.reload(_,W.cli),_.focus(),[_];let $=W.cli["folder-uri"]||[],Q=W.cli["file-uri"]||[],N=W.cli._;if(!N.length&&!$.length&&!Q.length&&!W.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ue=re?.workspace??re?.folderUri;ue&&(b.URI.isUri(ue)?ue.scheme===S.Schemas.file?N=[ue.fsPath]:$=[ue.toString()]:ue.configPath.scheme===S.Schemas.file?N=[(0,f.originalFSPath)(ue.configPath)]:Q=[ue.configPath.toString()])}let j=W.remoteAuthority;for(const re of A)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=b.URI.parse(re),ye=(0,L.getRemoteAuthority)(ue);ye&&(j?(0,f.isEqualAuthority)(ye,j)||this.logService.error("more than one extension development path authority"):j=ye)}N=N.filter(re=>{const ue=b.URI.file(re);return(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:(0,f.isEqualAuthority)((0,L.getRemoteAuthority)(ue),j)}),$=$.filter(re=>{const ue=this.cliArgToUri(re);return ue&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,f.isEqualAuthority)((0,L.getRemoteAuthority)(ue),j):!1}),Q=Q.filter(re=>{const ue=this.cliArgToUri(re);return ue&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,f.isEqualAuthority)((0,L.getRemoteAuthority)(ue),j):!1}),W.cli._=N,W.cli["folder-uri"]=$,W.cli["file-uri"]=Q;const G={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!N.length&&!$.length&&!Q.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:j,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(G)}async openInBrowserWindow(A){const W=this.configurationService.getValue("window"),_=this.configurationService.getValue("files"),$=this.getLastActiveWindow(),Q=$?.profile??this.userDataProfilesMainService.defaultProfile;let N;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(N=A.windowToUse||$,N&&N.focus());const j={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,l.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:Q},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsPath,product:d.default,isInitialStartup:A.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,r.release)(),hostname:(0,r.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn,preferUtilityProcess:H.canUseUtilityProcess?_?.experimental?.watcherUseUtilityProcess??W?.experimental?.sharedProcessUseUtilityProcess??!1:!1};if(N){const G=N.config;!j.extensionDevelopmentPath&&G?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=G.extensionDevelopmentPath,j.extensionDevelopmentKind=G.extensionDevelopmentKind,j["enable-proposed-api"]=G["enable-proposed-api"],j.verbose=G.verbose,j["inspect-extensions"]=G["inspect-extensions"],j["inspect-brk-extensions"]=G["inspect-brk-extensions"],j.debugId=G.debugId,j.extensionEnvironment=G.extensionEnvironment,j["extensions-dir"]=G["extensions-dir"],j["disable-extensions"]=G["disable-extensions"]),j.loggers=G?.loggers??j.loggers}else{const G=this.windowsStateHandler.getNewWindowState(j);(0,y.mark)("code/willCreateCodeWindow");const re=N=this.instantiationService.createInstance(z.CodeWindow,{state:G,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),at.WINDOWS.push(re),this._onDidOpenWindow.fire(re),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,h.once)(re.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(re)),(0,h.once)(re.onDidClose)(()=>this.onWindowClosed(re)),(0,h.once)(re.onDidDestroy)(()=>this._onDidDestroyWindow.fire(re)),re.onDidTriggerSystemContextMenu(({x:ye,y:Me})=>this._onDidTriggerSystemContextMenu.fire({window:re,x:ye,y:Me}));const ue=(0,p.assertIsDefined)(re.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(re)),this.lifecycleMainService.registerWindow(re)}return j.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(async G=>{G||await this.doOpenInBrowserWindow(N,j,A,Q)}):await this.doOpenInBrowserWindow(N,j,A,Q),N}async doOpenInBrowserWindow(A,W,_,$){if(W.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(W.workspace)?W.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(W.workspace)?W.backupPath=this.backupMainService.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,oe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:W.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const Q=W.workspace??(0,se.toWorkspaceIdentifier)(W.backupPath,!1),N=this.resolveProfileForBrowserWindow(_,Q,$),j=N instanceof Promise?await N:N;W.profiles.profile=j,W.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(Q,j)}A.load(W)}resolveProfileForBrowserWindow(A,W,_){return A.forceProfile?this.userDataProfilesMainService.profiles.find($=>$.name===A.forceProfile)??this.userDataProfilesMainService.createNamedProfile(A.forceProfile):A.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(W)??_}onWindowClosed(A){const W=at.WINDOWS.indexOf(A);at.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=I.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,f.isEqualAuthority)(W.remoteAuthority,A)))}doGetLastActiveWindow(A){const W=Math.max.apply(Math,A.map(_=>_.lastFocusTime));return A.find(_=>_.lastFocusTime===W)}sendToFocused(A,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,D.CancellationToken.None,...W)}sendToAll(A,W,_){for(const $ of this.getWindows())_&&_.indexOf($.id)>=0||$.sendWhenReady(A,D.CancellationToken.None,W)}getWindows(){return at.WINDOWS}getWindowCount(){return at.WINDOWS.length}getWindowById(A){const W=this.getWindows().filter(_=>_.id===A);return(0,R.firstOrDefault)(W)}getWindowByWebContents(A){const W=I.BrowserWindow.fromWebContents(A);if(!!W)return this.getWindowById(W.id)}};ne.WINDOWS=[],ne=we([X(2,s.ILogService),X(3,T.ILoggerMainService),X(4,O.IStateService),X(5,V.IPolicyService),X(6,i.IEnvironmentMainService),X(7,B.IUserDataProfilesMainService),X(8,u.ILifecycleMainService),X(9,k.IBackupMainService),X(10,t.IConfigurationService),X(11,he.IWorkspacesHistoryMainService),X(12,le.IWorkspacesManagementMainService),X(13,o.IInstantiationService),X(14,c.IDialogMainService),X(15,n.IFileService),X(16,C.IProtocolMainService),X(17,ge.IThemeMainService)],ne),e.WindowsMainService=ne}),define(Z[284],ee([0,1,63,30,80,53]),function(x,e,I,M,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(g,h,w,v){this.workspacesManagementMainService=g,this.windowsMainService=h,this.workspacesHistoryMainService=w,this.backupMainService=v,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,h){const w=this.windowsMainService.getWindowById(g);if(w)return this.workspacesManagementMainService.enterWorkspace(w,this.windowsMainService.getWindows(),h)}createUntitledWorkspace(g,h,w){return this.workspacesManagementMainService.createUntitledWorkspace(h,w)}deleteUntitledWorkspace(g,h){return this.workspacesManagementMainService.deleteUntitledWorkspace(h)}getWorkspaceIdentifier(g,h){return this.workspacesManagementMainService.getWorkspaceIdentifier(h)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(g,h){return this.workspacesHistoryMainService.addRecentlyOpened(h)}removeRecentlyOpened(g,h){return this.workspacesHistoryMainService.removeRecentlyOpened(h)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=we([X(0,R.IWorkspacesManagementMainService),X(1,M.IWindowsMainService),X(2,r.IWorkspacesHistoryMainService),X(3,I.IBackupMainService)],D),e.WorkspacesMainService=D}),define(Z[285],ee([0,1,15,42,26,17,44,13,32,50,43,45,2,14,9,4,10,8,31,142,47,156,106,258,159,63,276,18,76,192,88,127,57,111,212,28,62,117,202,226,203,262,113,204,205,16,216,91,75,6,90,277,239,260,20,5,282,58,21,55,270,92,33,266,97,93,24,241,120,48,49,248,249,278,250,279,123,252,253,254,256,264,30,283,265,29,98,80,284,53,259,38,224,52,235,56,79,125,268,274,272,7,121,267,219,65,89,263,255]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c,i,n,o,u,s,d,C,L,O,F,z,q,ie,se,oe,he,le,ge,V,B,T,H,Y,te,ne,U,A,W,_,$,Q,N,j,G,re,ue,ye,Me,Te,Ae,We,me,pe,ke,J,ae,de,Pe,Re,Oe,_e,Be,ze,Fe,qe,K,ce,fe,Se,ve,Le,Ue,je,Ve,Ke,Ye,Je,st,ct,ft,kt,Dt,Mt,Rt,Lt,At,Tt,gt,Ot,Wt,_t,Ft,Ut,mt,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends S.Disposable{constructor(Ce,Ie,be,Ee,De,$e,Ge,Xe,He,Ne,xe){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=Ie,this.mainInstantiationService=be,this.logService=Ee,this.environmentMainService=De,this.lifecycleMainService=$e,this.configurationService=Ge,this.stateService=Xe,this.fileService=He,this.productService=Ne,this.userDataProfilesMainService=xe,this.configureSession(),this.registerListeners()}configureSession(){const Ce=He=>He?.startsWith(`${l.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((He,Ne,xe,Qe)=>Ce(Qe.requestingUrl)?xe(Ie.has(Ne)):xe(!1)),I.session.defaultSession.setPermissionCheckHandler((He,Ne,xe,Qe)=>Ce(Qe.requestingUrl)?Ie.has(Ne):!1);const be=new Set([l.Schemas.file,l.Schemas.vscodeFileResource,l.Schemas.vscodeRemoteResource,"devtools"]),Ee=He=>{for(let Ne=He;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${l.Schemas.vscodeWebview}://`))return!0;return!1},De=He=>He.resourceType==="xhr"||Ee(He.frame),$e=He=>{const Ne=He.frame;if(!Ne||!this.windowsMainService)return!1;const xe=I.BrowserWindow.getAllWindows();for(const Qe of xe)if(Ne.processId===Qe.webContents.mainFrame.processId)return!0;return!1},Ge=(He,Ne)=>{if(He.path!=="/index.html")return!0;const xe=Ne.frame;if(!xe||!this.windowsMainService)return!1;for(const Qe of this.windowsMainService.getWindows())if(Qe.win&&xe.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((He,Ne)=>{const xe=f.URI.parse(He.url);return xe.scheme===l.Schemas.vscodeWebview&&!Ge(xe,He)?(this.logService.error("Blocked vscode-webview request",He.url),Ne({cancel:!0})):xe.scheme===l.Schemas.vscodeFileResource&&!$e(He)?(this.logService.error("Blocked vscode-file request",He.url),Ne({cancel:!0})):xe.path.endsWith(".svg")&&!be.has(xe.scheme)?Ne({cancel:!De(He)}):Ne({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((He,Ne)=>{const xe=He.responseHeaders,Qe=xe["content-type"]||xe["Content-Type"];if(Qe&&Array.isArray(Qe)){const Ze=f.URI.parse(He.url);if(Ze.path.endsWith(".svg")&&be.has(Ze.scheme))return xe["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:xe});if(!Ze.path.endsWith(l.Schemas.vscodeRemoteResource)&&Qe.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!De(He)})}return Ne({cancel:!1})});const Xe=I.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Xe.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,P.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,P.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,P.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,b.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(be,Ee)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),I.app.on("activate",async(be,Ee)=>{this.logService.trace("app#activate"),Ee||await this.windowsMainService?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(be,Ee)=>{Ee.on("will-navigate",De=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Ee.setWindowOpenHandler(({url:De})=>(this.nativeHostMainService?.openExternal(void 0,De),{action:"deny"}))});let Ce=[],Ie;I.app.on("open-file",(be,Ee)=>{this.logService.trace("app#open-file: ",Ee),be.preventDefault(),Ce.push((0,Ue.hasWorkspaceFileExtension)(Ee)?{workspaceUri:f.URI.file(Ee)}:{fileUri:f.URI.file(Ee)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Ie=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),M.validatedIpcMain.handle("vscode:fetchShellEnv",be=>{const Ee=this.windowsMainService?.getWindowByWebContents(be.sender);let De,$e;return Ee?.config?(De=Ee.config,$e={...process.env,...Ee.config.userEnv}):(De=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(De,$e,!1)}),M.validatedIpcMain.handle("vscode:writeNlsFile",(be,Ee,De)=>{const $e=this.validateNlsPath([Ee]);if(!$e||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,R.VSBuffer.fromString(De))}),M.validatedIpcMain.handle("vscode:readNlsFile",async(be,...Ee)=>{const De=this.validateNlsPath(Ee);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(De)).value.toString()}),M.validatedIpcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),M.validatedIpcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),M.validatedIpcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(Ce){let Ie;for(const be of Ce)typeof be=="string"&&(typeof Ie!="string"?Ie=be:Ie=(0,y.join)(Ie,be));if(!(typeof Ie!="string"||!(0,y.isAbsolute)(Ie)||!(0,g.isEqualOrParent)(Ie,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return f.URI.file(Ie)}onUnexpectedError(Ce){if(Ce){const Ie={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;m.isWindows&&Ce&&I.app.setAppUserModelId(Ce);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.logService.error(Ne)}const Ie=new k.Server;this.lifecycleMainService.onWillShutdown(Ne=>{Ne.reason===2&&Ie.dispose()}),this.logService.trace("Resolving machine identifier...");const be=await(0,Ot.resolveMachineId)(this.stateService);this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Ee,sharedProcessReady:De,sharedProcessClient:$e}=this.setupSharedProcess(be),Ge=await this.initServices(be,Ee,De);this._register(Ge.createInstance(c.ProxyAuthHandler)),this._register(Ge.createInstance(At.UserDataProfilesHandler)),Ge.invokeFunction(Ne=>this.initChannels(Ne,Ie,$e));const Xe=Ge.invokeFunction(Ne=>this.setupProtocolUrlHandlers(Ne,Ie));this.lifecycleMainService.phase=2,await Ge.invokeFunction(Ne=>this.openFirstWindow(Ne,Xe)),this.lifecycleMainService.phase=3,Ge.invokeFunction(Ne=>this.afterWindowOpen(Ne,Ee)),this._register(new gt.RunOnceScheduler(()=>{this._register((0,gt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Ce,Ie){const be=this.windowsMainService=Ce.get(Se.IWindowsMainService),Ee=Ce.get(ze.IURLService),De=this.nativeHostMainService=Ce.get(G.INativeHostMainService),$e=this;Ee.registerHandler({async handleURL(Qe,Ze){return $e.handleProtocolUrl(be,Ee,Qe,Ze)}});const Ge=this._register(new Le.ActiveWindowManager({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Xe=new E.StaticRouter(Qe=>Ge.getActiveClientId().then(Ze=>Qe===Ze)),He=new Fe.URLHandlerRouter(Xe,this.logService),Ne=Ie.getChannel("urlHandler",He);Ee.registerHandler(new Fe.URLHandlerChannelClient(Ne));const xe=this.resolveInitialProtocolUrls();return this._register(new K.ElectronURLListener(xe?.urls,Ee,be,this.environmentMainService,this.productService,this.logService)),xe}resolveInitialProtocolUrls(){const Ce=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ce.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),Ce.length+Ie.length===0)return;const be=[];return{urls:[...Ce,...Ie].map(De=>{try{return{uri:f.URI.parse(De),originalUrl:De}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.shouldBlockURI(De.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const $e=this.getWindowOpenableFromProtocolUrl(De.uri);return $e?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),$e),be.push($e),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:be}}shouldBlockURI(Ce){if(Ce.authority===l.Schemas.file&&m.isWindows){const{options:Ie,buttonIndeces:be}=(0,Ut.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(Ce,{os:m.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null)},this.productService);if(be[I.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Ce){if(!!Ce.path){if(Ce.authority===l.Schemas.file){const Ie=f.URI.file(Ce.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Ce.authority===l.Schemas.vscodeRemote){const Ie=Ce.path.indexOf(y.posix.sep,1);if(Ie!==-1){const be=Ce.path.substring(1,Ie),Ee=Ce.path.substring(Ie),De=f.URI.from({scheme:l.Schemas.vscodeRemote,authority:be,path:Ee,query:Ce.query,fragment:Ce.fragment});return(0,Ue.hasWorkspaceFileExtension)(Ee)?{workspaceUri:De}:/:[\d]+$/.test(Ee)?{fileUri:De}:{folderUri:De}}}}}async handleProtocolUrl(Ce,Ie,be,Ee){if(this.logService.trace("app#handleProtocolUrl():",be.toString(!0),Ee),be.scheme===this.productService.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:f.URI.parse(be.query).path,query:""})),this.shouldBlockURI(be))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let De=!1;const $e=new URLSearchParams(be.query);$e.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),$e.delete("windowId"),be=be.with({query:$e.toString()}),De=!0):m.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),De=!0);const Ge=$e.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),$e.delete("continueOn"),be=be.with({query:$e.toString()}),this.environmentMainService.continueOn=Ge??void 0);const Xe=this.getWindowOpenableFromProtocolUrl(be);if(Xe){this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,be.toString(!0));const[He]=await Ce.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Xe],forceNewWindow:De,gotoLineMode:!0});return He.focus(),!0}if(De){this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0));const[He]=await Ce.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.getRemoteAuthority)(be)});return await He.ready(),Ie.open(be,Ee)}return this.logService.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ee),!1}setupSharedProcess(Ce){const Ie=this._register(this.mainInstantiationService.createInstance(ye.SharedProcess,Ce,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const De=await Ie.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new t.Client(De,"main")})(),Ee=(async()=>(await Ie.whenReady(),be))();return{sharedProcess:Ie,sharedProcessReady:Ee,sharedProcessClient:be}}async initServices(Ce,Ie,be){const Ee=new A.ServiceCollection;switch(process.platform){case"win32":Ee.set(de.IUpdateService,new ne.SyncDescriptor(Be.Win32UpdateService));break;case"linux":m.isLinuxSnap?Ee.set(de.IUpdateService,new ne.SyncDescriptor(_e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(de.IUpdateService,new ne.SyncDescriptor(Oe.LinuxUpdateService));break;case"darwin":Ee.set(de.IUpdateService,new ne.SyncDescriptor(Re.DarwinUpdateService));break}Ee.set(Se.IWindowsMainService,new ne.SyncDescriptor(ve.WindowsMainService,[Ce,this.userEnv],!1));const De=new O.DialogMainService(this.logService,this.productService);Ee.set(O.IDialogMainService,De),Ee.set($.ILaunchMainService,new ne.SyncDescriptor($.LaunchMainService,void 0,!1)),Ee.set(L.IDiagnosticsMainService,new ne.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ee.set(C.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(be.then(Xe=>Xe.getChannel("diagnostics"))))),Ee.set(W.IIssueMainService,new ne.SyncDescriptor(W.IssueMainService,[this.userEnv])),Ee.set(F.IEncryptionMainService,new ne.SyncDescriptor(z.EncryptionMainService,[Ce])),Ee.set(_.IKeyboardLayoutMainService,new ne.SyncDescriptor(_.KeyboardLayoutMainService)),Ee.set(G.INativeHostMainService,new ne.SyncDescriptor(G.NativeHostMainService,[Ie],!1)),Ee.set(s.ICredentialsMainService,new ne.SyncDescriptor(Je.CredentialsNativeMainService)),Ee.set(ce.IWebviewManagerService,new ne.SyncDescriptor(fe.WebviewMainService)),Ee.set(j.IMenubarMainService,new ne.SyncDescriptor(j.MenubarMainService)),Ee.set(oe.IExtensionUrlTrustService,new ne.SyncDescriptor(he.ExtensionUrlTrustService)),Ee.set(le.IExtensionHostStarter,new ne.SyncDescriptor(ge.ExtensionHostStarter)),Ee.set(We.IStorageMainService,new ne.SyncDescriptor(We.StorageMainService)),Ee.set(We.IApplicationStorageMainService,new ne.SyncDescriptor(We.ApplicationStorageMainService)),m.isWindows?Ee.set(V.IExternalTerminalMainService,new ne.SyncDescriptor(B.WindowsExternalTerminalService)):m.isMacintosh?Ee.set(V.IExternalTerminalMainService,new ne.SyncDescriptor(B.MacExternalTerminalService)):m.isLinux&&Ee.set(V.IExternalTerminalMainService,new ne.SyncDescriptor(B.LinuxExternalTerminalService));const $e=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Ee.set(n.IBackupMainService,$e);const Ge=new Ye.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,$e,De);if(Ee.set(Ye.IWorkspacesManagementMainService,Ge),Ee.set(je.IWorkspacesService,new ne.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Ee.set(Ve.IWorkspacesHistoryMainService,new ne.SyncDescriptor(Ve.WorkspacesHistoryMainService,void 0,!1)),Ee.set(ze.IURLService,new ne.SyncDescriptor(qe.NativeURLService,void 0,!1)),(0,ae.supportsTelemetry)(this.productService,this.environmentMainService)){const Xe=(0,ae.isInternalTelemetry)(this.productService,this.configurationService),He=(0,E.getDelayedChannel)(be.then(nt=>nt.getChannel("telemetryAppender"))),Ne=new ke.TelemetryAppenderClient(He),xe=(0,me.resolveCommonProperties)(this.fileService,(0,r.release)(),(0,r.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,Xe,this.environmentMainService.installSourcePath),Qe=(0,ae.getPiiPathsFromEnvironment)(this.environmentMainService),Ze={appenders:[Ne],commonProperties:xe,piiPaths:Qe,sendErrorTelemetry:!0};Ee.set(pe.ITelemetryService,new ne.SyncDescriptor(J.TelemetryService,[Ze],!1))}else Ee.set(pe.ITelemetryService,ae.NullTelemetryService);return Ee.set(Mt.IExtensionsProfileScannerService,new ne.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(Rt.IExtensionsScannerService,new ne.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),Ee.set(mt.IUtilityProcessWorkerMainService,new ne.SyncDescriptor(mt.UtilityProcessWorkerMainService,void 0,!0)),await gt.Promises.settled([$e.initialize(),Ge.initialize()]),this.mainInstantiationService.createChild(Ee)}initChannels(Ce,Ie,be){const Ee=E.ProxyChannel.fromService(Ce.get($.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ee);const De=E.ProxyChannel.fromService(Ce.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",De);const $e=new ct.PolicyChannel(Ce.get(st.IPolicyService));Ie.registerChannel("policy",$e),be.then(et=>et.registerChannel("policy",$e));const Ge=this.fileService.getProvider(l.Schemas.file);(0,a.assertType)(Ge instanceof te.DiskFileSystemProvider);const Xe=new Y.DiskFileSystemProviderChannel(Ge,this.logService,this.environmentMainService);Ie.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe),be.then(et=>et.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe));const He=E.ProxyChannel.fromService(Ce.get(ft.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",He),be.then(et=>et.registerChannel("userDataProfiles",He));const Ne=new kt.RequestChannel(Ce.get(Dt.IRequestService));be.then(et=>et.registerChannel("request",Ne));const xe=new Pe.UpdateChannel(Ce.get(de.IUpdateService));Ie.registerChannel("update",xe);const Qe=E.ProxyChannel.fromService(Ce.get(W.IIssueMainService));Ie.registerChannel("issue",Qe);const Ze=E.ProxyChannel.fromService(Ce.get(F.IEncryptionMainService));Ie.registerChannel("encryption",Ze);const nt=E.ProxyChannel.fromService(Ce.get(s.ICredentialsMainService));Ie.registerChannel("credentials",nt);const it=E.ProxyChannel.fromService(Ce.get(Me.ISignService));Ie.registerChannel("sign",it);const lt=E.ProxyChannel.fromService(Ce.get(_.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",lt),this.nativeHostMainService=Ce.get(G.INativeHostMainService);const yt=E.ProxyChannel.fromService(this.nativeHostMainService);Ie.registerChannel("nativeHost",yt),be.then(et=>et.registerChannel("nativeHost",yt));const Bt=E.ProxyChannel.fromService(Ce.get(je.IWorkspacesService));Ie.registerChannel("workspaces",Bt);const $t=E.ProxyChannel.fromService(Ce.get(j.IMenubarMainService));Ie.registerChannel("menubar",$t);const zt=E.ProxyChannel.fromService(Ce.get(ze.IURLService));Ie.registerChannel("url",zt);const Ht=E.ProxyChannel.fromService(Ce.get(oe.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",Ht);const qt=E.ProxyChannel.fromService(Ce.get(ce.IWebviewManagerService));Ie.registerChannel("webview",qt);const bt=this._register(new Ae.StorageDatabaseChannel(this.logService,Ce.get(We.IStorageMainService)));Ie.registerChannel("storage",bt),be.then(et=>et.registerChannel("storage",bt));const jt=this._register(new Tt.ProfileStorageChangesListenerChannel(Ce.get(We.IStorageMainService),Ce.get(ft.IUserDataProfilesMainService),this.logService));be.then(et=>et.registerChannel("profileStorageListener",jt));const xt=E.ProxyChannel.fromService(Ce.get(V.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",xt);const Et=new _t.LoggerChannel(Ce.get(Ft.ILoggerMainService));Ie.registerChannel("logger",Et),be.then(et=>et.registerChannel("logger",Et));const Vt=new d.ElectronExtensionHostDebugBroadcastChannel(Ce.get(Se.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Vt);const Kt=E.ProxyChannel.fromService(Ce.get(le.IExtensionHostStarter));Ie.registerChannel(le.ipcExtensionHostStarterChannelName,Kt);const Gt=E.ProxyChannel.fromService(Ce.get(mt.IUtilityProcessWorkerMainService));Ie.registerChannel(Nt.ipcUtilityProcessWorkerChannelName,Gt)}async openFirstWindow(Ce,Ie){const be=this.windowsMainService=Ce.get(Se.IWindowsMainService),Ee=(0,ie.isLaunchedFromCli)(process.env)?0:4,De=this.environmentMainService.args;if(Ie){if(Ie.openables.length>0)return be.open({context:Ee,cli:De,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const it of Ie.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),be.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const $e=global.macOpenFiles,Ge=De._.length,Xe=!!De["folder-uri"],He=!!De["file-uri"],Ne=De["skip-add-to-recently-opened"]===!0,xe=De.wait&&De.waitMarkerFilePath?f.URI.file(De.waitMarkerFilePath):void 0,Qe=De.remote||void 0,Ze=De.profile,nt=De["profile-temp"];if(!Ge&&!Xe&&!He){if(De["new-window"]||Ze||nt)return be.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:nt});if($e.length)return be.open({context:1,cli:De,urisToOpen:$e.map(it=>(0,Ue.hasWorkspaceFileExtension)(it)?{workspaceUri:f.URI.file(it)}:{fileUri:f.URI.file(it)}),noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0})}return be.open({context:Ee,cli:De,forceNewWindow:De["new-window"]||!Ge&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ne,waitMarkerFileURI:xe,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:nt})}afterWindowOpen(Ce,Ie){const be=Ce.get(pe.ITelemetryService),Ee=Ce.get(de.IUpdateService);this.handleSharedProcessErrors(be,Ie),this.installMutex(),I.protocol.registerHttpProtocol(l.Schemas.vscodeRemoteResource,(De,$e)=>{$e({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),(Ee instanceof Be.Win32UpdateService||Ee instanceof Oe.LinuxUpdateService||Ee instanceof Re.DarwinUpdateService)&&Ee.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const Ce=this.productService.win32MutexName;if(m.isWindows&&Ce)try{const Ie=await new Promise((Ee,De)=>{x(["windows-mutex"],Ee,De)}),be=new Ie.Mutex(Ce);(0,h.once)(this.lifecycleMainService.onWillShutdown)(()=>be.release())}catch(Ie){this.logService.error(Ie)}}handleSharedProcessErrors(Ce,Ie){let be=!1;(0,h.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0),this._register(Ie.onDidError(({type:Ee,details:De})=>{switch(Ee){case 2:this.logService.error(`SharedProcess: renderer process gone (reason: ${De?.reason||"<unknown>"}, code: ${De?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("SharedProcess: detected unresponsive");break;case 3:this.logService.error(`SharedProcess: failed to load (reason: ${De?.reason||"<unknown>"}, code: ${De?.exitCode||"<unknown>"})`);break}Ce.publicLog2("sharedprocesserror",{type:Ee,reason:De?.reason,code:De?.exitCode,visible:Ie.isVisible(),utilityprocess:Ie.usingUtilityProcess()?"1":"0",shuttingdown:be})}))}async resolveShellEnvironment(Ce,Ie,be){try{return await(0,se.getResolvedShellEnv)(this.configurationService,this.logService,Ce,Ie)}catch(Ee){const De=(0,D.toErrorMessage)(Ee);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",De):this.logService.error(De)}return{}}async updateCrashReporterEnablement(){try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),be=JSON.parse((0,w.stripComments)(Ie)),De=(0,ae.getTelemetryLevel)(this.configurationService)>=1;if(be["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,p.generateUuid)()}"`,"}"],Ge=Ie.substring(0,Ie.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ge))}else{const $e=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);$e!==Ie&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString($e))}}catch(Ce){this.logService.error(Ce)}}};pt=we([X(2,U.IInstantiationService),X(3,N.ILogService),X(4,q.IEnvironmentMainService),X(5,Q.ILifecycleMainService),X(6,u.IConfigurationService),X(7,Te.IStateService),X(8,H.IFileService),X(9,re.IProductService),X(10,ft.IUserDataProfilesMainService)],pt),e.CodeApplication=pt}),define(Z[286],ee([0,1,237,7,17,13,2,10,18,34,117,5,236,293]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends D.Disposable{constructor(a,f,p){super(),this.configurationService=a,this.environmentService=f,this.logService=p,this.configure(),this._register(a.onDidChangeConfiguration(b=>{b.affectsConfiguration("http")&&this.configure()}))}configure(){const a=this.configurationService.getValue("http");this.proxyUrl=a?.proxy,this.strictSSL=!!a?.proxyStrictSSL,this.authorization=a?.proxyAuthorization}async request(a,f){this.logService.trace("RequestService#request (node) - begin",a.url);const{proxyUrl:p,strictSSL:b}=this;let E;try{E=await(0,w.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(c){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",c))}const k={...process.env,...E},t=a.agent?a.agent:await(0,S.getProxyAgent)(a.url||"",k,{proxyUrl:p,strictSSL:b});a.agent=t,a.strictSSL=b,this.authorization&&(a.headers={...a.headers||{},"Proxy-Authorization":this.authorization});try{const c=await this._request(a,f);return this.logService.trace("RequestService#request (node) - success",a.url),c}catch(c){throw this.logService.trace("RequestService#request (node) - error",a.url,c),c}}async getNodeRequest(a){return((0,I.parse)(a.url).protocol==="https:"?await new Promise((b,E)=>{x(["https"],b,E)}):await new Promise((b,E)=>{x(["http"],b,E)})).request}_request(a,f){return M.Promises.withAsyncBody(async(p,b)=>{const E=(0,I.parse)(a.url),k=a.getRawRequest?a.getRawRequest(a):await this.getNodeRequest(a),t={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,P.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(t.auth=a.user+":"+a.password);const c=k(t,i=>{const n=(0,P.isNumber)(a.followRedirects)?a.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...a,url:i.headers.location,followRedirects:n-1},f).then(p,b);else{let o=i;!a.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,l.createGunzip)())),p({res:i,stream:(0,r.streamToBufferReadableStream)(o)})}});c.on("error",b),a.timeout&&c.setTimeout(a.timeout),a.isChromiumNetwork&&c.removeHeader("Content-Length"),a.data&&typeof a.data=="string"&&c.write(a.data),c.end(),f.onCancellationRequested(()=>{c.abort(),b(new R.CancellationError)})})}async resolveProxy(a){}};y=we([X(0,g.IConfigurationService),X(1,h.INativeEnvironmentService),X(2,v.ILogService)],y),e.RequestService=y}),define(Z[287],ee([0,1,15,286]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(D){return I.net.request}class R extends M.RequestService{request(P,g){return super.request({...P||{},getRawRequest:r,isChromiumNetwork:!0},g)}}e.RequestMainService=R}),define(Z[294],ee([0,1,15,41,8,25,7,44,13,32,50,45,14,9,64,4,36,27,23,47,87,285,11,18,230,240,28,62,194,16,214,91,75,210,90,20,217,5,66,21,67,269,122,246,56,287,92,238,33,48,69,52,38,225,223,2,39,251,65,218,89,118,247]),function(x,e,I,M,r,R,D,P,g,h,w,v,S,l,y,m,a,f,p,b,E,k,t,c,i,n,o,u,s,d,C,L,O,F,z,q,ie,se,oe,he,le,ge,V,B,T,H,Y,te,ne,U,A,W,_,$,Q,N,j,G,re,ue,ye,Me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Te{main(){try{this.startup()}catch(me){console.error(me.message),I.app.exit(1)}}async startup(){(0,g.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[me,pe,ke,J,ae,de,Pe,Re]=this.createServices();try{try{await this.initServices(ke,Re,J,ae,Pe)}catch(Oe){throw this.handleStartupDataDirError(ke,Pe,Oe),Oe}await me.invokeFunction(async Oe=>{const _e=Oe.get(se.ILogService),Be=Oe.get(q.ILifecycleMainService),ze=Oe.get(d.IFileService),Fe=Oe.get(se.ILoggerService),qe=await this.claimInstance(_e,ke,Be,me,Pe,!0);return p.Promises.writeFile(ke.mainLockfile,String(process.pid)).catch(K=>{_e.warn(`app#startup(): Error writing main lockfile: ${K.stack}`)}),de.logger=Fe.createLogger(r.URI.file((0,l.join)(ke.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,w.once)(Be.onWillShutdown)(K=>{ze.dispose(),J.dispose(),K.join("instanceLockfile",p.Promises.unlink(ke.mainLockfile).catch(()=>{}))}),me.createInstance(k.CodeApplication,qe,pe).startup()})}catch(Oe){me.invokeFunction(this.quit,Oe)}}createServices(){const me=new z.ServiceCollection,pe=new N.DisposableStore;process.once("exit",()=>pe.dispose());const ke={_serviceBrand:void 0,...oe.default};me.set(he.IProductService,ke);const J=new o.EnvironmentMainService(this.resolveArgs(),ke),ae=this.patchEnvironment(J);me.set(o.IEnvironmentMainService,J);const de=new re.LoggerMainService((0,se.getLogLevel)(J));me.set(re.ILoggerMainService,de);const Pe=new ie.BufferLogger(de.getLogLevel()),Re=pe.add(new ue.LogService(Pe,[new se.ConsoleMainLogger(de.getLogLevel())]));me.set(se.ILogService,Re);const Oe=new C.FileService(Re);me.set(d.IFileService,Oe);const _e=new L.DiskFileSystemProvider(Re);Oe.registerProvider(S.Schemas.file,_e);const Be=new G.UriIdentityService(Oe);me.set(j.IUriIdentityService,Be);const ze=new Me.StateService(1,J,Re,Oe);me.set(ne.IStateReadService,ze),me.set(ne.IStateService,ze);const Fe=new W.UserDataProfilesMainService(ze,Be,J,Oe,Re);me.set(W.IUserDataProfilesMainService,Fe);const qe=m.isWindows&&ke.win32RegValueName?pe.add(new $.NativePolicyService(Re,ke.win32RegValueName)):J.policyFile?pe.add(new Q.FilePolicyService(J.policyFile,Oe,Re)):new _.NullPolicyService;me.set(_.IPolicyService,qe);const K=new i.ConfigurationService(Fe.defaultProfile.settingsResource,Oe,qe,Re);return me.set(c.IConfigurationService,K),me.set(q.ILifecycleMainService,new O.SyncDescriptor(q.LifecycleMainService,void 0,!1)),me.set(T.IRequestService,new O.SyncDescriptor(H.RequestMainService,void 0,!0)),me.set(A.IThemeMainService,new O.SyncDescriptor(A.ThemeMainService)),me.set(Y.ISignService,new O.SyncDescriptor(te.SignService,void 0,!1)),me.set(V.ITunnelService,new O.SyncDescriptor(B.TunnelService)),me.set(le.IProtocolMainService,new ge.ProtocolMainService(J,Fe,Re)),[new F.InstantiationService(me,!0),ae,J,K,ze,Pe,ke,Fe]}patchEnvironment(me){const pe={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ke=>{const J=process.env[ke];typeof J=="string"&&(pe[ke]=J)}),Object.assign(process.env,pe),pe}async initServices(me,pe,ke,J,ae){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,pe.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(de=>de?p.Promises.mkdir(de,{recursive:!0}):void 0)),J.init(),ke.initialize()]),pe.init()}async claimInstance(me,pe,ke,J,ae,de){let Pe;try{(0,y.mark)("code/willStartMainServer"),Pe=await(0,E.serve)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,w.once)(ke.onWillShutdown)(()=>Pe.dispose())}catch(Re){if(Re.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,ae,Re),Re;let Oe;try{Oe=await(0,E.connect)(pe.mainIPCHandle,"main")}catch(Fe){if(!de||m.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,ae.nameShort),(0,t.localize)(2,null),ae),Fe;try{(0,M.unlinkSync)(pe.mainIPCHandle)}catch(qe){throw me.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(me,pe,ke,J,ae,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Fe=`Running extension tests from the command line is currently only supported if no other instance of ${ae.nameShort} is running.`;throw me.error(Fe),Oe.dispose(),new Error(Fe)}let _e;!pe.args.wait&&!pe.args.status&&(_e=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,ae.nameShort),(0,t.localize)(4,null),ae)},1e4));const Be=b.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),ze=b.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return J.invokeFunction(async()=>{const Fe=new n.DiagnosticsService(U.NullTelemetryService,ae),qe=await ze.getMainDiagnostics(),K=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ce=await Fe.getDiagnostics(qe,K);throw console.log(ce),new g.ExpectedError});throw m.isWindows&&await this.windowsAllowSetForegroundWindow(Be,me),me.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Oe.dispose(),_e&&clearTimeout(_e),new g.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw me.warn(`Warning: The --status argument can only be used if ${ae.nameShort} is already running. Please run it again after {0} has started.`),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Pe}handleStartupDataDirError(me,pe,ke){if(ke.code==="EACCES"||ke.code==="EPERM"){const J=(0,R.coalesce)([me.userDataPath,me.extensionsPath,E.XDG_RUNTIME_DIR]).map(ae=>(0,v.getPathLabel)(r.URI.file(ae),{os:m.OS,tildify:me}));this.showStartupWarningDialog((0,t.localize)(5,null),(0,t.localize)(6,null,(0,P.toErrorMessage)(ke),J.join(`
`)),pe)}}showStartupWarningDialog(me,pe,ke){I.dialog.showMessageBoxSync((0,ye.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:me,detail:pe},ke).options)}async windowsAllowSetForegroundWindow(me,pe){if(m.isWindows){const ke=await me.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ke);try{(await new Promise((J,ae)=>{x(["windows-foreground-love"],J,ae)})).allowSetForegroundWindow(ke)}catch(J){pe.error(J)}}}quit(me,pe){const ke=me.get(se.ILogService),J=me.get(q.ILifecycleMainService);let ae=0;pe&&(pe.isExpected?pe.message&&ke.trace(pe.message):(ae=1,pe.stack?ke.error(pe.stack):ke.error(`Startup error: ${pe.toString()}`))),J.kill(ae)}resolveArgs(){const me=this.validatePaths((0,u.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const pe=(0,s.createWaitMarkerFileSync)(me.verbose);pe&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",pe),me.waitMarkerFilePath=pe)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const pe=this.doValidatePaths(me._,me.goto);me._=pe}return me}doValidatePaths(me,pe){const ke=(0,a.cwd)(),J=me.map(Pe=>{let Re=String(Pe),Oe;pe&&(Oe=(0,h.parseLineAndColumnAware)(Re),Re=Oe.path),Re&&(Re=this.preparePath(ke,Re));const _e=(0,h.sanitizeFilePath)(Re,ke),Be=(0,l.basename)(_e);return Be&&!(0,h.isValidBasename)(Be)?null:pe&&Oe?(Oe.path=_e,this.toPath(Oe)):_e}),ae=m.isWindows||m.isMacintosh,de=(0,R.distinct)(J,Pe=>Pe&&ae?Pe.toLowerCase():Pe||"");return(0,R.coalesce)(de)}preparePath(me,pe){return m.isWindows&&(pe=(0,f.rtrim)(pe,'"')),pe=(0,f.trim)((0,f.trim)(pe," "),"	"),m.isWindows&&(pe=(0,l.resolve)(me,pe),pe=(0,f.rtrim)(pe,".")),pe}toPath(me){const pe=[me.path];return typeof me.line=="number"&&pe.push(String(me.line)),typeof me.column=="number"&&pe.push(String(me.column)),pe.join(":")}}new Te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/22a808587994126e19125c6a1a03c00b990223f4/core/vs/code/electron-main/main.js.map
