/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/errorMessage","vs/base/common/map","vs/platform/registry/common/platform","os","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/platform/environment/node/userDataPath","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function($){for(var e=[],O=0,D=$.length;O<D;O++)e[O]=Q[$[O]];return e};define(Q[49],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function O(R){return(E,g,c)=>{let I=null,S=null;if(typeof c.value=="function"?(I="value",S=c.value):typeof c.get=="function"&&(I="get",S=c.get),!S)throw new Error("not supported");c[I]=R(S,g)}}function D(R,E,g){let c=null,I=null;if(typeof g.value=="function"?(c="value",I=g.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",I=g.get),!I)throw new Error("not supported");const S=`$memoize$${E}`;g[c]=function(...h){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,h)}),this[S]}}e.memoize=D;function b(R,E,g){return O((c,I)=>{const S=`$debounce$${I}`,h=`$debounce$result$${I}`;return function(...m){this[h]||(this[h]=g?g():void 0),clearTimeout(this[S]),E&&(this[h]=E(this[h],...m),m=[this[h]]),this[S]=setTimeout(()=>{c.apply(this,m),this[h]=g?g():void 0},R)}})}e.debounce=b;function C(R,E,g){return O((c,I)=>{const S=`$throttle$timer$${I}`,h=`$throttle$result$${I}`,m=`$throttle$lastRun$${I}`,P=`$throttle$pending$${I}`;return function(...T){if(this[h]||(this[h]=g?g():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),E&&(this[h]=E(this[h],...T)),this[P])return;const u=this[m]+R;u<=Date.now()?(this[m]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0):(this[P]=!0,this[S]=setTimeout(()=>{this[P]=!1,this[m]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0},u-Date.now()))}})}e.throttle=C}),define(Q[70],Z([0,1,7]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(g,c){if(!g)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function b(g,c="Unreachable"){throw new Error(c)}e.assertNever=b;function C(g){if(!g)throw new O.BugIndicatingError("Assertion Failed")}e.assert=C;function R(g){if(!g()){debugger;g(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function E(g,c){let I=0;for(;I<g.length-1;){const S=g[I],h=g[I+1];if(!c(S,h))return!1;I++}return!0}e.checkAdjacentItems=E}),define(Q[50],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(O=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function R(t,s=!1){let i=0;const n=t.length;let r="",l=0,o=16,a=0;function d(ie){let ae=0,fe=0;for(;ae<ie;){const oe=t.charCodeAt(i);if(oe>=48&&oe<=57)fe=fe*16+oe-48;else if(oe>=65&&oe<=70)fe=fe*16+oe-65+10;else if(oe>=97&&oe<=102)fe=fe*16+oe-97+10;else break;i++,ae++}return ae<ie&&(fe=-1),fe}function A(ie){i=ie,r="",l=0,o=16,a=0}function V(){const ie=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return a=3,t.substring(ie,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else a=3;return t.substring(ie,ae)}function Y(){let ie="",ae=i;for(;;){if(i>=n){ie+=t.substring(ae,i),a=2;break}const fe=t.charCodeAt(i);if(fe===34){ie+=t.substring(ae,i),i++;break}if(fe===92){if(ie+=t.substring(ae,i),i++,i>=n){a=2;break}switch(t.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const pe=d(4);pe>=0?ie+=String.fromCharCode(pe):a=4;break}default:a=5}ae=i;continue}if(fe>=0&&fe<=31)if(g(fe)){ie+=t.substring(ae,i),a=2;break}else a=6;i++}return ie}function ee(){if(r="",a=0,l=i,i>=n)return l=n,o=17;let ie=t.charCodeAt(i);if(E(ie)){do i++,r+=String.fromCharCode(ie),ie=t.charCodeAt(i);while(E(ie));return o=15}if(g(ie))return i++,r+=String.fromCharCode(ie),ie===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),o=14;switch(ie){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,r=Y(),o=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const fe=n-1;let oe=!1;for(;i<fe;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,oe=!0;break}i++}return oe||(i++,a=1),r=t.substring(ae,i),o=13}return r+=String.fromCharCode(ie),i++,o=16}case 45:if(r+=String.fromCharCode(ie),i++,i===n||!c(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=V(),o=11;default:for(;i<n&&te(ie);)i++,ie=t.charCodeAt(i);if(l!==i){switch(r=t.substring(l,i),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(ie),i++,o=16}}function te(ie){if(E(ie)||g(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let ie;do ie=ee();while(ie>=12&&ie<=15);return ie}return{setPosition:A,getPosition:()=>i,scan:s?ne:ee,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>a}}e.createScanner=R;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function S(t,s){const i=[],n=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function a(d,A,V,Y){l.value=d,l.offset=A,l.length=V,l.type=Y,l.colonOffset=void 0,r=l}try{y(t,{onObjectBegin:(d,A)=>{if(s<=d)throw n;r=void 0,o=s>d,i.push("")},onObjectProperty:(d,A,V)=>{if(s<A||(a(d,A,V,"property"),i[i.length-1]=d,s<=A+V))throw n},onObjectEnd:(d,A)=>{if(s<=d)throw n;r=void 0,i.pop()},onArrayBegin:(d,A)=>{if(s<=d)throw n;r=void 0,i.push(0)},onArrayEnd:(d,A)=>{if(s<=d)throw n;r=void 0,i.pop()},onLiteralValue:(d,A,V)=>{if(s<A||(a(d,A,V,w(d)),s<=A+V))throw n},onSeparator:(d,A,V)=>{if(s<=A)throw n;if(d===":"&&r&&r.type==="property")r.colonOffset=A,o=!1,r=void 0;else if(d===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(d){if(d!==n)throw d}return{path:i,previousNode:r,isAtPropertyKey:o,matches:d=>{let A=0;for(let V=0;A<d.length&&V<i.length;V++)if(d[A]===i[V]||d[A]==="*")A++;else if(d[A]!=="**")return!1;return A===d.length}}}e.getLocation=S;function h(t,s=[],i=C.DEFAULT){let n=null,r=[];const l=[];function o(d){Array.isArray(r)?r.push(d):n!==null&&(r[n]=d)}return y(t,{onObjectBegin:()=>{const d={};o(d),l.push(r),r=d,n=null},onObjectProperty:d=>{n=d},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const d=[];o(d),l.push(r),r=d,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:o,onError:(d,A,V)=>{s.push({error:d,offset:A,length:V})}},i),r[0]}e.parse=h;function m(t,s=[],i=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(d){n.type==="property"&&(n.length=d-n.offset,n=n.parent)}function l(d){return n.children.push(d),d}y(t,{onObjectBegin:d=>{n=l({type:"object",offset:d,length:-1,parent:n,children:[]})},onObjectProperty:(d,A,V)=>{n=l({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:d,offset:A,length:V,parent:n})},onObjectEnd:(d,A)=>{n.length=d+A-n.offset,n=n.parent,r(d+A)},onArrayBegin:(d,A)=>{n=l({type:"array",offset:d,length:-1,parent:n,children:[]})},onArrayEnd:(d,A)=>{n.length=d+A-n.offset,n=n.parent,r(d+A)},onLiteralValue:(d,A,V)=>{l({type:w(d),offset:A,length:V,parent:n,value:d}),r(A+V)},onSeparator:(d,A,V)=>{n.type==="property"&&(d===":"?n.colonOffset=A:d===","&&r(A))},onError:(d,A,V)=>{s.push({error:d,offset:A,length:V})}},i);const a=n.children[0];return a&&delete a.parent,a}e.parseTree=m;function P(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===n){i=l.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=P;function T(t){if(!t.parent||!t.parent.children)return[];const s=T(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=T;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=u(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function f(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=f;function v(t,s,i=!1){if(f(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const l=v(n[r],s,i);if(l)return l}return t}}e.findNodeAtOffset=v;function y(t,s,i=C.DEFAULT){const n=R(t,!1);function r(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(B){return B?K=>B(K,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),a=l(s.onObjectProperty),d=r(s.onObjectEnd),A=r(s.onArrayBegin),V=r(s.onArrayEnd),Y=l(s.onLiteralValue),ee=l(s.onSeparator),te=r(s.onComment),ne=l(s.onError),ie=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function fe(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ie||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(B){case 12:case 13:ie?oe(10):te();break;case 16:oe(1);break;case 15:case 14:break;default:return B}}}function oe(B,K=[],N=[]){if(ne(B),K.length+N.length>0){let k=n.getToken();for(;k!==17;){if(K.indexOf(k)!==-1){fe();break}else if(N.indexOf(k)!==-1)break;k=fe()}}}function pe(B){const K=n.getTokenValue();return B?Y(K):a(K),fe(),!0}function W(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(oe(2),B=0)}catch{oe(2)}Y(B);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return fe(),!0}function M(){return n.getToken()!==10?(oe(3,[],[2,5]),!1):(pe(!1),n.getToken()===6?(ee(":"),fe(),z()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function F(){o(),fe();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||oe(4,[],[]),ee(","),fe(),n.getToken()===2&&ae)break}else B&&oe(6,[],[]);M()||oe(4,[],[2,5]),B=!0}return d(),n.getToken()!==2?oe(7,[2],[]):fe(),!0}function j(){A(),fe();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||oe(4,[],[]),ee(","),fe(),n.getToken()===4&&ae)break}else B&&oe(6,[],[]);z()||oe(4,[],[4,5]),B=!0}return V(),n.getToken()!==4?oe(8,[4],[]):fe(),!0}function z(){switch(n.getToken()){case 3:return j();case 1:return F();case 10:return pe(!0);default:return W()}}return fe(),n.getToken()===17?i.allowEmptyContent?!0:(oe(4,[],[]),!1):z()?(n.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.visit=y;function p(t,s){const i=R(t),n=[];let r,l=0,o;do switch(o=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:l!==o&&n.push(t.substring(l,o)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),l=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=p;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Q[71],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function O(E,g,c){return Math.min(Math.max(E,g),c)}e.clamp=O;function D(E,g){return(g+E%g)%g}e.rot=D;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class C{constructor(){this._n=1,this._val=0}update(g){return this._val=this._val+(g-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=C;class R{constructor(g){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(g),this._values.fill(0,0,g)}update(g){const c=this._values[this._index];return this._values[this._index]=g,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=g,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function $(b){const C=[];typeof b=="number"&&C.push("code/timeOrigin",b);function R(g){C.push(g,Date.now())}function E(){const g=[];for(let c=0;c<C.length;c+=2)g.push({name:C[c],startTime:C[c+1]});return g}return{mark:R,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(b+R.startTime)});return C}};if(typeof process=="object"){const b=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function O(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=O(D))}(),function($,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var D in O)(typeof exports=="object"?exports:$)[D]=O[D]}}(typeof self<"u"?self:this,function(){return function($){var e={};function O(D){if(e[D])return e[D].exports;var b=e[D]={i:D,l:!1,exports:{}};return $[D].call(b.exports,b,b.exports,O),b.l=!0,b.exports}return O.m=$,O.c=e,O.d=function(D,b,C){O.o(D,b)||Object.defineProperty(D,b,{enumerable:!0,get:C})},O.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},O.t=function(D,b){if(1&b&&(D=O(D)),8&b||4&b&&typeof D=="object"&&D&&D.__esModule)return D;var C=Object.create(null);if(O.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:D}),2&b&&typeof D!="string")for(var R in D)O.d(C,R,function(E){return D[E]}.bind(null,R));return C},O.n=function(D){var b=D&&D.__esModule?function(){return D.default}:function(){return D};return O.d(b,"a",b),b},O.o=function(D,b){return Object.prototype.hasOwnProperty.call(D,b)},O.p="",O(O.s=0)}([function($,e,O){(function(D){var b;e=$.exports=N,b=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],g=e.src=[],c=0,I=c++;g[I]="0|[1-9]\\d*";var S=c++;g[S]="[0-9]+";var h=c++;g[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=c++;g[m]="("+g[I]+")\\.("+g[I]+")\\.("+g[I]+")";var P=c++;g[P]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var T=c++;g[T]="(?:"+g[I]+"|"+g[h]+")";var u=c++;g[u]="(?:"+g[S]+"|"+g[h]+")";var f=c++;g[f]="(?:-("+g[T]+"(?:\\."+g[T]+")*))";var v=c++;g[v]="(?:-?("+g[u]+"(?:\\."+g[u]+")*))";var y=c++;g[y]="[0-9A-Za-z-]+";var p=c++;g[p]="(?:\\+("+g[y]+"(?:\\."+g[y]+")*))";var w=c++,t="v?"+g[m]+g[f]+"?"+g[p]+"?";g[w]="^"+t+"$";var s="[v=\\s]*"+g[P]+g[v]+"?"+g[p]+"?",i=c++;g[i]="^"+s+"$";var n=c++;g[n]="((?:<|>)?=?)";var r=c++;g[r]=g[S]+"|x|X|\\*";var l=c++;g[l]=g[I]+"|x|X|\\*";var o=c++;g[o]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[f]+")?"+g[p]+"?)?)?";var a=c++;g[a]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[v]+")?"+g[p]+"?)?)?";var d=c++;g[d]="^"+g[n]+"\\s*"+g[o]+"$";var A=c++;g[A]="^"+g[n]+"\\s*"+g[a]+"$";var V=c++;g[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=c++;g[Y]="(?:~>?)";var ee=c++;g[ee]="(\\s*)"+g[Y]+"\\s+",E[ee]=new RegExp(g[ee],"g");var te=c++;g[te]="^"+g[Y]+g[o]+"$";var ne=c++;g[ne]="^"+g[Y]+g[a]+"$";var ie=c++;g[ie]="(?:\\^)";var ae=c++;g[ae]="(\\s*)"+g[ie]+"\\s+",E[ae]=new RegExp(g[ae],"g");var fe=c++;g[fe]="^"+g[ie]+g[o]+"$";var oe=c++;g[oe]="^"+g[ie]+g[a]+"$";var pe=c++;g[pe]="^"+g[n]+"\\s*("+s+")$|^$";var W=c++;g[W]="^"+g[n]+"\\s*("+t+")$|^$";var M=c++;g[M]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[o]+")",E[M]=new RegExp(g[M],"g");var F=c++;g[F]="^\\s*("+g[o]+")\\s+-\\s+("+g[o]+")\\s*$";var j=c++;g[j]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var z=c++;g[z]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)b(B,g[B]),E[B]||(E[B]=new RegExp(g[B]));function K(_,H){if(_ instanceof N)return _;if(typeof _!="string"||_.length>C||!(H?E[i]:E[w]).test(_))return null;try{return new N(_,H)}catch{return null}}function N(_,H){if(_ instanceof N){if(_.loose===H)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof N))return new N(_,H);b("SemVer",_,H),this.loose=H;var X=_.trim().match(H?E[i]:E[w]);if(!X)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var ve=+de;if(ve>=0&&ve<R)return ve}return de}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=K,e.valid=function(_,H){var X=K(_,H);return X?X.version:null},e.clean=function(_,H){var X=K(_.trim().replace(/^[=v]+/,""),H);return X?X.version:null},e.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(_){return b("SemVer.compare",this.version,this.loose,_),_ instanceof N||(_=new N(_,this.loose)),this.compareMain(_)||this.comparePre(_)},N.prototype.compareMain=function(_){return _ instanceof N||(_=new N(_,this.loose)),L(this.major,_.major)||L(this.minor,_.minor)||L(this.patch,_.patch)},N.prototype.comparePre=function(_){if(_ instanceof N||(_=new N(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],de=_.prerelease[H];if(b("prerelease compare",H,X,de),X===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(X===void 0)return-1;if(X!==de)return L(X,de)}while(++H)},N.prototype.inc=function(_,H){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,H,X,de){typeof X=="string"&&(de=X,X=void 0);try{return new N(_,X).inc(H,de).version}catch{return null}},e.diff=function(_,H){if(G(_,H))return null;var X=K(_),de=K(H);if(X.prerelease.length||de.prerelease.length){for(var ve in X)if((ve==="major"||ve==="minor"||ve==="patch")&&X[ve]!==de[ve])return"pre"+ve;return"prerelease"}for(var ve in X)if((ve==="major"||ve==="minor"||ve==="patch")&&X[ve]!==de[ve])return ve},e.compareIdentifiers=L;var k=/^[0-9]+$/;function L(_,H){var X=k.test(_),de=k.test(H);return X&&de&&(_=+_,H=+H),X&&!de?-1:de&&!X?1:_<H?-1:_>H?1:0}function x(_,H,X){return new N(_,X).compare(new N(H,X))}function U(_,H,X){return x(_,H,X)>0}function q(_,H,X){return x(_,H,X)<0}function G(_,H,X){return x(_,H,X)===0}function re(_,H,X){return x(_,H,X)!==0}function le(_,H,X){return x(_,H,X)>=0}function Se(_,H,X){return x(_,H,X)<=0}function me(_,H,X,de){var ve;switch(H){case"===":typeof _=="object"&&(_=_.version),typeof X=="object"&&(X=X.version),ve=_===X;break;case"!==":typeof _=="object"&&(_=_.version),typeof X=="object"&&(X=X.version),ve=_!==X;break;case"":case"=":case"==":ve=G(_,X,de);break;case"!=":ve=re(_,X,de);break;case">":ve=U(_,X,de);break;case">=":ve=le(_,X,de);break;case"<":ve=q(_,X,de);break;case"<=":ve=Se(_,X,de);break;default:throw new TypeError("Invalid operator: "+H)}return ve}function ce(_,H){if(_ instanceof ce){if(_.loose===H)return _;_=_.value}if(!(this instanceof ce))return new ce(_,H);b("comparator",_,H),this.loose=H,this.parse(_),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(_,H){return L(H,_)},e.major=function(_,H){return new N(_,H).major},e.minor=function(_,H){return new N(_,H).minor},e.patch=function(_,H){return new N(_,H).patch},e.compare=x,e.compareLoose=function(_,H){return x(_,H,!0)},e.rcompare=function(_,H,X){return x(H,_,X)},e.sort=function(_,H){return _.sort(function(X,de){return e.compare(X,de,H)})},e.rsort=function(_,H){return _.sort(function(X,de){return e.rcompare(X,de,H)})},e.gt=U,e.lt=q,e.eq=G,e.neq=re,e.gte=le,e.lte=Se,e.cmp=me,e.Comparator=ce;var ge={};function se(_,H){if(_ instanceof se)return _.loose===H?_:new se(_.raw,H);if(_ instanceof ce)return new se(_.value,H);if(!(this instanceof se))return new se(_,H);if(this.loose=H,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function ue(_){return!_||_.toLowerCase()==="x"||_==="*"}function Ee(_,H,X,de,ve,Le,Pe,ke,De,Te,Fe,Ce,Oe){return((H=ue(X)?"":ue(de)?">="+X+".0.0":ue(ve)?">="+X+"."+de+".0":">="+H)+" "+(ke=ue(De)?"":ue(Te)?"<"+(+De+1)+".0.0":ue(Fe)?"<"+De+"."+(+Te+1)+".0":Ce?"<="+De+"."+Te+"."+Fe+"-"+Ce:"<="+ke)).trim()}function be(_,H){for(var X=0;X<_.length;X++)if(!_[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<_.length;X++)if(b(_[X].semver),_[X].semver!==ge&&_[X].semver.prerelease.length>0){var de=_[X].semver;if(de.major===H.major&&de.minor===H.minor&&de.patch===H.patch)return!0}return!1}return!0}function Me(_,H,X){try{H=new se(H,X)}catch{return!1}return H.test(_)}function xe(_,H,X,de){var ve,Le,Pe,ke,De;switch(_=new N(_,de),H=new se(H,de),X){case">":ve=U,Le=Se,Pe=q,ke=">",De=">=";break;case"<":ve=q,Le=le,Pe=U,ke="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(_,H,de))return!1;for(var Te=0;Te<H.set.length;++Te){var Fe=H.set[Te],Ce=null,Oe=null;if(Fe.forEach(function(Ae){Ae.semver===ge&&(Ae=new ce(">=0.0.0")),Ce=Ce||Ae,Oe=Oe||Ae,ve(Ae.semver,Ce.semver,de)?Ce=Ae:Pe(Ae.semver,Oe.semver,de)&&(Oe=Ae)}),Ce.operator===ke||Ce.operator===De||(!Oe.operator||Oe.operator===ke)&&Le(_,Oe.semver)||Oe.operator===De&&Pe(_,Oe.semver))return!1}return!0}ce.prototype.parse=function(_){var H=this.loose?E[pe]:E[W],X=_.match(H);if(!X)throw new TypeError("Invalid comparator: "+_);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new N(X[2],this.loose):this.semver=ge},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(_){return b("Comparator.test",_,this.loose),this.semver===ge||(typeof _=="string"&&(_=new N(_,this.loose)),me(_,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(_,H){if(!(_ instanceof ce))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new se(_.value,H),Me(this.value,X,H);if(_.operator==="")return X=new se(this.value,H),Me(_.semver,X,H);var de=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Le=this.semver.version===_.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),ke=me(this.semver,"<",_.semver,H)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),De=me(this.semver,">",_.semver,H)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return de||ve||Le&&Pe||ke||De},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(_){var H=this.loose;_=_.trim(),b("range",_,H);var X=H?E[j]:E[F];_=_.replace(X,Ee),b("hyphen replace",_),_=_.replace(E[M],"$1$2$3"),b("comparator trim",_,E[M]),_=(_=(_=_.replace(E[ee],"$1~")).replace(E[ae],"$1^")).split(/\s+/).join(" ");var de=H?E[pe]:E[W],ve=_.split(" ").map(function(Le){return function(Pe,ke){return b("comp",Pe),Pe=function(De,Te){return De.trim().split(/\s+/).map(function(Fe){return function(Ce,Oe){b("caret",Ce,Oe);var Ae=Oe?E[oe]:E[fe];return Ce.replace(Ae,function(Ue,ye,we,Ie,Re){var Ne;return b("caret",Ce,Ue,ye,we,Ie,Re),ue(ye)?Ne="":ue(we)?Ne=">="+ye+".0.0 <"+(+ye+1)+".0.0":ue(Ie)?Ne=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Re?(b("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ne=ye==="0"?we==="0"?">="+ye+"."+we+"."+Ie+Re+" <"+ye+"."+we+"."+(+Ie+1):">="+ye+"."+we+"."+Ie+Re+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+Ie+Re+" <"+(+ye+1)+".0.0"):(b("no pr"),Ne=ye==="0"?we==="0"?">="+ye+"."+we+"."+Ie+" <"+ye+"."+we+"."+(+Ie+1):">="+ye+"."+we+"."+Ie+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+Ie+" <"+(+ye+1)+".0.0"),b("caret return",Ne),Ne})}(Fe,Te)}).join(" ")}(Pe,ke),b("caret",Pe),Pe=function(De,Te){return De.trim().split(/\s+/).map(function(Fe){return function(Ce,Oe){var Ae=Oe?E[ne]:E[te];return Ce.replace(Ae,function(Ue,ye,we,Ie,Re){var Ne;return b("tilde",Ce,Ue,ye,we,Ie,Re),ue(ye)?Ne="":ue(we)?Ne=">="+ye+".0.0 <"+(+ye+1)+".0.0":ue(Ie)?Ne=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Re?(b("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ne=">="+ye+"."+we+"."+Ie+Re+" <"+ye+"."+(+we+1)+".0"):Ne=">="+ye+"."+we+"."+Ie+" <"+ye+"."+(+we+1)+".0",b("tilde return",Ne),Ne})}(Fe,Te)}).join(" ")}(Pe,ke),b("tildes",Pe),Pe=function(De,Te){return b("replaceXRanges",De,Te),De.split(/\s+/).map(function(Fe){return function(Ce,Oe){Ce=Ce.trim();var Ae=Oe?E[A]:E[d];return Ce.replace(Ae,function(Ue,ye,we,Ie,Re,Ne){b("xRange",Ce,Ue,ye,we,Ie,Re,Ne);var $e=ue(we),Ve=$e||ue(Ie),We=Ve||ue(Re);return ye==="="&&We&&(ye=""),$e?Ue=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(Ve&&(Ie=0),We&&(Re=0),ye===">"?(ye=">=",Ve?(we=+we+1,Ie=0,Re=0):We&&(Ie=+Ie+1,Re=0)):ye==="<="&&(ye="<",Ve?we=+we+1:Ie=+Ie+1),Ue=ye+we+"."+Ie+"."+Re):Ve?Ue=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(Ue=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0"),b("xRange return",Ue),Ue})}(Fe,Te)}).join(" ")}(Pe,ke),b("xrange",Pe),Pe=function(De,Te){return b("replaceStars",De,Te),De.trim().replace(E[z],"")}(Pe,ke),b("stars",Pe),Pe}(Le,H)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Le){return!!Le.match(de)})),ve=ve.map(function(Le){return new ce(Le,H)})},se.prototype.intersects=function(_,H){if(!(_ instanceof se))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(de){return _.set.some(function(ve){return ve.every(function(Le){return de.intersects(Le,H)})})})})},e.toComparators=function(_,H){return new se(_,H).set.map(function(X){return X.map(function(de){return de.value}).join(" ").trim().split(" ")})},se.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new N(_,this.loose));for(var H=0;H<this.set.length;H++)if(be(this.set[H],_))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(_,H,X){var de=null,ve=null;try{var Le=new se(H,X)}catch{return null}return _.forEach(function(Pe){Le.test(Pe)&&(de&&ve.compare(Pe)!==-1||(ve=new N(de=Pe,X)))}),de},e.minSatisfying=function(_,H,X){var de=null,ve=null;try{var Le=new se(H,X)}catch{return null}return _.forEach(function(Pe){Le.test(Pe)&&(de&&ve.compare(Pe)!==1||(ve=new N(de=Pe,X)))}),de},e.validRange=function(_,H){try{return new se(_,H).range||"*"}catch{return null}},e.ltr=function(_,H,X){return xe(_,H,"<",X)},e.gtr=function(_,H,X){return xe(_,H,">",X)},e.outside=xe,e.prerelease=function(_,H){var X=K(_,H);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(_,H,X){return _=new se(_,X),H=new se(H,X),_.intersects(H)},e.coerce=function(_){if(_ instanceof N)return _;if(typeof _!="string")return null;var H=_.match(E[V]);return H==null?null:K((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,O(1))},function($,e){var O,D,b=$.exports={};function C(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function E(u){if(O===setTimeout)return setTimeout(u,0);if((O===C||!O)&&setTimeout)return O=setTimeout,setTimeout(u,0);try{return O(u,0)}catch{try{return O.call(null,u,0)}catch{return O.call(this,u,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:C}catch{O=C}try{D=typeof clearTimeout=="function"?clearTimeout:R}catch{D=R}})();var g,c=[],I=!1,S=-1;function h(){I&&g&&(I=!1,g.length?c=g.concat(c):S=-1,c.length&&m())}function m(){if(!I){var u=E(h);I=!0;for(var f=c.length;f;){for(g=c,c=[];++S<f;)g&&g[S].run();S=-1,f=c.length}g=null,I=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===R||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch{try{return D.call(null,v)}catch{return D.call(this,v)}}}(u)}}function P(u,f){this.fun=u,this.array=f}function T(){}b.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];c.push(new P(u,f)),c.length!==1||I||E(m)},P.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=T,b.addListener=T,b.once=T,b.off=T,b.removeListener=T,b.removeAllListeners=T,b.emit=T,b.prependListener=T,b.prependOnceListener=T,b.listeners=function(u){return[]},b.binding=function(u){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(u){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Q[72],Z([0,1]),function($,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(E,g,c){this.level=E,this.key=g,this.value=c,this.forward=[]}}const b=void 0;class C{constructor(E,g=2**16){this.comparator=E,this[O]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(g)|0),this._header=new D(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,b,b)}has(E){return Boolean(C._search(this,E,this.comparator))}get(E){return C._search(this,E,this.comparator)?.value}set(E,g){return C._insert(this,E,g,this.comparator)&&(this._size+=1),this}delete(E){const g=C._delete(this,E,this.comparator);return g&&(this._size-=1),g}forEach(E,g){let c=this._header.forward[0];for(;c;)E.call(g,c.value,c.key,this),c=c.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",g=this._header.forward[0];for(;g;)E+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return E}static _search(E,g,c){let I=E._header;for(let S=E._level-1;S>=0;S--)for(;I.forward[S]&&c(I.forward[S].key,g)<0;)I=I.forward[S];if(I=I.forward[0],I&&c(I.key,g)===0)return I}static _insert(E,g,c,I){const S=[];let h=E._header;for(let m=E._level-1;m>=0;m--){for(;h.forward[m]&&I(h.forward[m].key,g)<0;)h=h.forward[m];S[m]=h}if(h=h.forward[0],h&&I(h.key,g)===0)return h.value=c,!1;{const m=C._randomLevel(E);if(m>E._level){for(let P=E._level;P<m;P++)S[P]=E._header;E._level=m}h=new D(m,g,c);for(let P=0;P<m;P++)h.forward[P]=S[P].forward[P],S[P].forward[P]=h;return!0}}static _randomLevel(E,g=.5){let c=1;for(;Math.random()<g&&c<E._maxLevel;)c+=1;return c}static _delete(E,g,c){const I=[];let S=E._header;for(let h=E._level-1;h>=0;h--){for(;S.forward[h]&&c(S.forward[h].key,g)<0;)S=S.forward[h];I[h]=S}if(S=S.forward[0],!S||c(S.key,g)!==0)return!1;for(let h=0;h<E._level&&I[h].forward[h]===S;h++)I[h].forward[h]=S.forward[h];for(;E._level>0&&E._header.forward[E._level-1]===b;)E._level-=1;return!0}}e.SkipList=C}),define(Q[43],Z([0,1,7,2]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=b;function C(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function R(p){const w=p;return w?C(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=R;function E(p,w){return new g(p,w)}e.newWriteableStream=E;class g{constructor(w,t){this.reducer=w,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(t=>t(w))}emitError(w){this.listeners.error.length===0?(0,O.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(t=>t(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,t){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(w,t){if(this.state.destroyed)return;let s;switch(w){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(p,w){const t=[];let s;for(;(s=p.read())!==null;)t.push(s);return w(t)}e.consumeReadable=c;function I(p,w,t){const s=[];let i;for(;(i=p.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?w(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return p.read()}}}e.peekReadable=I;function S(p,w){return new Promise((t,s)=>{const i=[];h(p,{onData:n=>{w&&i.push(n)},onError:n=>{w?s(n):t(void 0)},onEnd:()=>{t(w?w(i):void 0)}})})}e.consumeStream=S;function h(p,w){let t=!1;return p.on("error",s=>{t||w.onError(s)}),p.on("end",()=>{t||w.onEnd()}),p.on("data",s=>{t||w.onData(s)}),(0,D.toDisposable)(()=>t=!0)}e.listenStream=h;function m(p,w){return new Promise((t,s)=>{const i=new D.DisposableStore,n=[],r=a=>{if(n.push(a),n.length>w)return i.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},l=a=>s(a),o=()=>t({stream:p,buffer:n,ended:!0});i.add((0,D.toDisposable)(()=>p.removeListener("error",l))),p.on("error",l),i.add((0,D.toDisposable)(()=>p.removeListener("end",o))),p.on("end",o),i.add((0,D.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}e.peekStream=m;function P(p,w){const t=E(w);return t.end(p),t}e.toStream=P;function T(){const p=E(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=T;function u(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=u;function f(p,w,t){const s=E(t);return h(p,{onData:i=>s.write(w.data(i)),onError:i=>s.error(w.error?w.error(i):i),onEnd:()=>s.end()}),s}e.transform=f;function v(p,w,t){let s=!1;return{read:()=>{const i=w.read();return s?i:(s=!0,i!==null?t([p,i]):p)}}}e.prefixedReadable=v;function y(p,w,t){let s=!1;const i=E(t);return h(w,{onData:n=>s?i.write(n):(s=!0,i.write(t([p,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(p)),i.end()}}),i}e.prefixedStream=y}),define(Q[14],Z([0,1,43]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let b,C;class R{static alloc(a){return D?new R(Buffer.allocUnsafe(a)):new R(new Uint8Array(a))}static wrap(a){return D&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new R(a)}static fromString(a,d){return!(d?.dontUseNodeBuffer||!1)&&D?new R(Buffer.from(a)):(b||(b=new TextEncoder),new R(b.encode(a)))}static fromByteArray(a){const d=R.alloc(a.length);for(let A=0,V=a.length;A<V;A++)d.buffer[A]=a[A];return d}static concat(a,d){if(typeof d>"u"){d=0;for(let Y=0,ee=a.length;Y<ee;Y++)d+=a[Y].byteLength}const A=R.alloc(d);let V=0;for(let Y=0,ee=a.length;Y<ee;Y++){const te=a[Y];A.set(te,V),V+=te.byteLength}return A}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=R.alloc(this.byteLength);return a.set(this),a}toString(){return D?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(a,d){return new R(this.buffer.subarray(a,d))}set(a,d){if(a instanceof R)this.buffer.set(a.buffer,d);else if(a instanceof Uint8Array)this.buffer.set(a,d);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),d);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return c(this.buffer,a)}writeUInt32BE(a,d){I(this.buffer,a,d)}readUInt32LE(a){return S(this.buffer,a)}writeUInt32LE(a,d){h(this.buffer,a,d)}readUInt8(a){return m(this.buffer,a)}writeUInt8(a,d){P(this.buffer,a,d)}}e.VSBuffer=R;function E(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0}e.readUInt16LE=E;function g(o,a,d){o[d+0]=a&255,a=a>>>8,o[d+1]=a&255}e.writeUInt16LE=g;function c(o,a){return o[a]*2**24+o[a+1]*2**16+o[a+2]*2**8+o[a+3]}e.readUInt32BE=c;function I(o,a,d){o[d+3]=a,a=a>>>8,o[d+2]=a,a=a>>>8,o[d+1]=a,a=a>>>8,o[d]=a}e.writeUInt32BE=I;function S(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0|o[a+2]<<16>>>0|o[a+3]<<24>>>0}e.readUInt32LE=S;function h(o,a,d){o[d+0]=a&255,a=a>>>8,o[d+1]=a&255,a=a>>>8,o[d+2]=a&255,a=a>>>8,o[d+3]=a&255}e.writeUInt32LE=h;function m(o,a){return o[a]}e.readUInt8=m;function P(o,a,d){o[d]=a}e.writeUInt8=P;function T(o){return O.consumeReadable(o,a=>R.concat(a))}e.readableToBuffer=T;function u(o){return O.toReadable(o)}e.bufferToReadable=u;function f(o){return O.consumeStream(o,a=>R.concat(a))}e.streamToBuffer=f;async function v(o){return o.ended?R.concat(o.buffer):R.concat([...o.buffer,await f(o.stream)])}e.bufferedStreamToBuffer=v;function y(o){return O.toStream(o,a=>R.concat(a))}e.bufferToStream=y;function p(o){return O.transform(o,{data:a=>typeof a=="string"?R.fromString(a):R.wrap(a)},a=>R.concat(a))}e.streamToBufferReadableStream=p;function w(o){return O.newWriteableStream(a=>R.concat(a),o)}e.newWriteableBufferStream=w;function t(o,a){return O.prefixedReadable(o,a,d=>R.concat(d))}e.prefixedBufferReadable=t;function s(o,a){return O.prefixedStream(o,a,d=>R.concat(d))}e.prefixedBufferStream=s;function i(o){let a=0,d=0,A=0;const V=new Uint8Array(Math.floor(o.length/4*3)),Y=te=>{switch(d){case 3:V[A++]=a|te,d=0;break;case 2:V[A++]=a|te>>>2,a=te<<6,d=3;break;case 1:V[A++]=a|te>>>4,a=te<<4,d=2;break;default:a=te<<2,d=1}};for(let te=0;te<o.length;te++){const ne=o.charCodeAt(te);if(ne>=65&&ne<=90)Y(ne-65);else if(ne>=97&&ne<=122)Y(ne-97+26);else if(ne>=48&&ne<=57)Y(ne-48+52);else if(ne===43||ne===45)Y(62);else if(ne===47||ne===95)Y(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${o[te]}`)}}const ee=A;for(;d>0;)Y(0);return R.wrap(V).slice(0,ee)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:o},a=!0,d=!1){const A=d?r:n;let V="";const Y=o.byteLength%3;let ee=0;for(;ee<o.byteLength-Y;ee+=3){const te=o[ee+0],ne=o[ee+1],ie=o[ee+2];V+=A[te>>>2],V+=A[(te<<4|ne>>>4)&63],V+=A[(ne<<2|ie>>>6)&63],V+=A[ie&63]}if(Y===1){const te=o[ee+0];V+=A[te>>>2],V+=A[te<<4&63],a&&(V+="==")}else if(Y===2){const te=o[ee+0],ne=o[ee+1];V+=A[te>>>2],V+=A[(te<<4|ne>>>4)&63],V+=A[ne<<2&63],a&&(V+="=")}return V}e.encodeBase64=l}),define(Q[28],Z([0,1,3]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const v=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([y,p])=>{v[y]=p&&typeof p=="object"?D(p):p}),v}e.deepClone=D;function b(f){if(!f||typeof f!="object")return f;const v=[f];for(;v.length>0;){const y=v.shift();Object.freeze(y);for(const p in y)if(C.call(y,p)){const w=y[p];typeof w=="object"&&!Object.isFrozen(w)&&!(0,O.isTypedArray)(w)&&v.push(w)}}return f}e.deepFreeze=b;const C=Object.prototype.hasOwnProperty;function R(f,v){return E(f,v,new Set)}e.cloneAndChange=R;function E(f,v,y){if((0,O.isUndefinedOrNull)(f))return f;const p=v(f);if(typeof p<"u")return p;if(Array.isArray(f)){const w=[];for(const t of f)w.push(E(t,v,y));return w}if((0,O.isObject)(f)){if(y.has(f))throw new Error("Cannot clone recursive data-structure");y.add(f);const w={};for(const t in f)C.call(f,t)&&(w[t]=E(f[t],v,y));return y.delete(f),w}return f}function g(f,v,y=!0){return(0,O.isObject)(f)?((0,O.isObject)(v)&&Object.keys(v).forEach(p=>{p in f?y&&((0,O.isObject)(f[p])&&(0,O.isObject)(v[p])?g(f[p],v[p],y):f[p]=v[p]):f[p]=v[p]}),f):v}e.mixin=g;function c(f,v){if(f===v)return!0;if(f==null||v===null||v===void 0||typeof f!=typeof v||typeof f!="object"||Array.isArray(f)!==Array.isArray(v))return!1;let y,p;if(Array.isArray(f)){if(f.length!==v.length)return!1;for(y=0;y<f.length;y++)if(!c(f[y],v[y]))return!1}else{const w=[];for(p in f)w.push(p);w.sort();const t=[];for(p in v)t.push(p);if(t.sort(),!c(w,t))return!1;for(y=0;y<w.length;y++)if(!c(f[w[y]],v[w[y]]))return!1}return!0}e.equals=c;function I(f){const v=new Set;return JSON.stringify(f,(y,p)=>{if((0,O.isObject)(p)||Array.isArray(p)){if(v.has(p))return"[Circular]";v.add(p)}return p})}e.safeStringify=I;function S(f,v){const y=Object.create(null);return!f||!v||Object.keys(v).forEach(w=>{const t=f[w],s=v[w];c(t,s)||(y[w]=s)}),y}e.distinct=S;function h(f,v){const y=v.toLowerCase(),p=Object.keys(f).find(w=>w.toLowerCase()===y);return p?f[p]:f[v]}e.getCaseInsensitive=h;function m(f,v){const y=Object.create(null);for(const[p,w]of Object.entries(f))v(p,w)&&(y[p]=w);return y}e.filter=m;function P(f){let v=[],y=Object.getPrototypeOf(f);for(;Object.prototype!==y;)v=v.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return v}e.getAllPropertyNames=P;function T(f){const v=[];for(const y of P(f))typeof f[y]=="function"&&v.push(y);return v}e.getAllMethodNames=T;function u(f,v){const y=w=>function(){const t=Array.prototype.slice.call(arguments,0);return v(w,t)},p={};for(const w of f)p[w]=y(w);return p}e.createProxyObject=u}),define(Q[29],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(b){return O.test(b)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(E){for(let g=0;g<E.length;g++)E[g]=Math.floor(Math.random()*256);return E};const C=new Uint8Array(16),R=[];for(let E=0;E<256;E++)R.push(E.toString(16).padStart(2,"0"));return function(){b(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let g=0,c="";return c+=R[C[g++]],c+=R[C[g++]],c+=R[C[g++]],c+=R[C[g++]],c+="-",c+=R[C[g++]],c+=R[C[g++]],c+="-",c+=R[C[g++]],c+=R[C[g++]],c+="-",c+=R[C[g++]],c+=R[C[g++]],c+="-",c+=R[C[g++]],c+=R[C[g++]],c+=R[C[g++]],c+=R[C[g++]],c+=R[C[g++]],c+=R[C[g++]],c}}()}),define(Q[73],Z([0,1,36]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function b(R){const E=R.replace(/\-/g,":").toLowerCase();return!D.has(E)}function C(){const R=(0,O.networkInterfaces)();for(const E in R){const g=R[E];if(g){for(const{mac:c}of g)if(b(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(Q[74],Z([8,9]),function($,e){return $.create("vs/base/common/date",e)}),define(Q[75],Z([0,1,74]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,b=D*60,C=b*24,R=C*7,E=C*30,g=C*365;function c(S,h,m,P){typeof S!="number"&&(S=S.getTime());const T=Math.round((new Date().getTime()-S)/1e3);if(T<-30)return(0,O.localize)(0,null,c(new Date().getTime()+T*1e3,!1));if(!P&&T<30)return(0,O.localize)(1,null);let u;return T<D?(u=T,h?u===1?m?(0,O.localize)(2,null,u):(0,O.localize)(3,null,u):m?(0,O.localize)(4,null,u):(0,O.localize)(5,null,u):u===1?m?(0,O.localize)(6,null,u):(0,O.localize)(7,null,u):m?(0,O.localize)(8,null,u):(0,O.localize)(9,null,u)):T<b?(u=Math.floor(T/D),h?u===1?m?(0,O.localize)(10,null,u):(0,O.localize)(11,null,u):m?(0,O.localize)(12,null,u):(0,O.localize)(13,null,u):u===1?m?(0,O.localize)(14,null,u):(0,O.localize)(15,null,u):m?(0,O.localize)(16,null,u):(0,O.localize)(17,null,u)):T<C?(u=Math.floor(T/b),h?u===1?m?(0,O.localize)(18,null,u):(0,O.localize)(19,null,u):m?(0,O.localize)(20,null,u):(0,O.localize)(21,null,u):u===1?m?(0,O.localize)(22,null,u):(0,O.localize)(23,null,u):m?(0,O.localize)(24,null,u):(0,O.localize)(25,null,u)):T<R?(u=Math.floor(T/C),h?u===1?(0,O.localize)(26,null,u):(0,O.localize)(27,null,u):u===1?(0,O.localize)(28,null,u):(0,O.localize)(29,null,u)):T<E?(u=Math.floor(T/R),h?u===1?m?(0,O.localize)(30,null,u):(0,O.localize)(31,null,u):m?(0,O.localize)(32,null,u):(0,O.localize)(33,null,u):u===1?m?(0,O.localize)(34,null,u):(0,O.localize)(35,null,u):m?(0,O.localize)(36,null,u):(0,O.localize)(37,null,u)):T<g?(u=Math.floor(T/E),h?u===1?m?(0,O.localize)(38,null,u):(0,O.localize)(39,null,u):m?(0,O.localize)(40,null,u):(0,O.localize)(41,null,u):u===1?m?(0,O.localize)(42,null,u):(0,O.localize)(43,null,u):m?(0,O.localize)(44,null,u):(0,O.localize)(45,null,u)):(u=Math.floor(T/g),h?u===1?m?(0,O.localize)(46,null,u):(0,O.localize)(47,null,u):m?(0,O.localize)(48,null,u):(0,O.localize)(49,null,u):u===1?m?(0,O.localize)(50,null,u):(0,O.localize)(51,null,u):m?(0,O.localize)(52,null,u):(0,O.localize)(53,null,u))}e.fromNow=c;function I(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Q[76],Z([8,9]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Q[33],Z([0,1,19,3,76]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(S,h){return h&&(S.stack||S.stacktrace)?b.localize(0,null,E(S),R(S.stack)||R(S.stacktrace)):E(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function E(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?b.localize(1,null,S.message):S.message||b.localize(2,null)}function g(S=null,h=!1){if(!S)return b.localize(3,null);if(Array.isArray(S)){const m=O.coalesce(S),P=g(m[0],h);return m.length>1?b.localize(4,null,P,m.length):P}if(D.isString(S))return S;if(S.detail){const m=S.detail;if(m.error)return C(m.error,h);if(m.exception)return C(m.exception,h)}return S.stack?C(S,h):S.message?S.message:b.localize(5,null)}e.toErrorMessage=g;function c(S){const h=S;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=c;function I(S,h){let m;return typeof S=="string"?m=new Error(S):m=S,m.actions=h,m}e.createErrorWithActions=I}),define(Q[77],Z([8,9]),function($,e){return $.create("vs/base/common/jsonErrorMessages",e)}),define(Q[78],Z([0,1,77]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(b){switch(b){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(Q[51],Z([0,1,12]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var b;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(b=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(E,...g){const c=g.reduce((h,m)=>(h[m]=!0,h),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(h=>!c[h]).forEach(h=>{for(let m=0;m<I.length;m++)if(h.search(I[m])!==-1){delete E[h];break}})}e.sanitizeProcessEnvironment=C;function R(E){!E||(delete E.DEBUG,O.isMacintosh&&delete E.DYLD_LIBRARY_PATH,O.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(Q[52],Z([0,1,30]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(f){return b(f,0)}e.hash=D;function b(f,v){switch(typeof f){case"object":return f===null?C(349,v):Array.isArray(f)?g(f,v):c(f,v);case"string":return E(f,v);case"boolean":return R(f,v);case"number":return C(f,v);case"undefined":return C(937,v);default:return C(617,v)}}e.doHash=b;function C(f,v){return(v<<5)-v+f|0}e.numberHash=C;function R(f,v){return C(f?433:863,v)}function E(f,v){v=C(149417,v);for(let y=0,p=f.length;y<p;y++)v=C(f.charCodeAt(y),v);return v}e.stringHash=E;function g(f,v){return v=C(104579,v),f.reduce((y,p)=>b(p,y),v)}function c(f,v){return v=C(181387,v),Object.keys(f).sort().reduce((y,p)=>(y=E(p,y),b(f[p],y)),v)}class I{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=b(v,this._value),this._value}}e.Hasher=I;var S;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function h(f,v,y=32){const p=y-v,w=~((1<<p)-1);return(f<<v|(w&f)>>>p)>>>0}function m(f,v=0,y=f.byteLength,p=0){for(let w=0;w<y;w++)f[v+w]=p}function P(f,v,y="0"){for(;f.length<v;)f=y+f;return f}function T(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(y=>y.toString(16).padStart(2,"0")).join(""):P((f>>>0).toString(16),v/4)}e.toHexString=T;class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const y=v.length;if(y===0)return;const p=this._buff;let w=this._buffLen,t=this._leftoverHighSurrogate,s,i;for(t!==0?(s=t,i=-1,t=0):(s=v.charCodeAt(0),i=0);;){let n=s;if(O.isHighSurrogate(s))if(i+1<y){const r=v.charCodeAt(i+1);O.isLowSurrogate(r)?(i++,n=O.computeCodePoint(s,r)):n=65533}else{t=s;break}else O.isLowSurrogate(s)&&(n=65533);if(w=this._push(p,w,n),i++,i<y)s=v.charCodeAt(i);else break}this._buffLen=w,this._leftoverHighSurrogate=t}_push(v,y,p){return p<128?v[y++]=p:p<2048?(v[y++]=192|(p&1984)>>>6,v[y++]=128|(p&63)>>>0):p<65536?(v[y++]=224|(p&61440)>>>12,v[y++]=128|(p&4032)>>>6,v[y++]=128|(p&63)>>>0):(v[y++]=240|(p&1835008)>>>18,v[y++]=128|(p&258048)>>>12,v[y++]=128|(p&4032)>>>6,v[y++]=128|(p&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),T(this._h0)+T(this._h1)+T(this._h2)+T(this._h3)+T(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=u._bigBlock32,y=this._buffDV;for(let o=0;o<64;o+=4)v.setUint32(o,y.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,h(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let p=this._h0,w=this._h1,t=this._h2,s=this._h3,i=this._h4,n,r,l;for(let o=0;o<80;o++)o<20?(n=w&t|~w&s,r=1518500249):o<40?(n=w^t^s,r=1859775393):o<60?(n=w&t|w&s|t&s,r=2400959708):(n=w^t^s,r=3395469782),l=h(p,5)+n+i+r+v.getUint32(o*4,!1)&4294967295,i=s,s=t,t=h(w,30),w=p,p=l;this._h0=this._h0+p&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}u._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(Q[53],Z([0,1,30]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(D||(D={})),function(b){const C="error",R="warning",E="warn",g="info",c="ignore";function I(h){return h?O.equalsIgnoreCase(C,h)?b.Error:O.equalsIgnoreCase(R,h)||O.equalsIgnoreCase(E,h)?b.Warning:O.equalsIgnoreCase(g,h)?b.Info:b.Ignore:b.Ignore}b.fromValue=I;function S(h){switch(h){case b.Error:return C;case b.Warning:return R;case b.Info:return g;default:return c}}b.toString=S}(D||(D={})),e.default=D}),define(Q[79],Z([0,1,11]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=D;function b(c){const I=[];let S;try{const h=JSON.parse(c.arguments),m=h[h.length-1];m&&m.__$stack&&(h.pop(),S=m.__$stack),I.push(...h)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:S}}e.parse=b;function C(c){if(typeof c!="string")return C(b(c).stack);const I=c;if(I){const S=R(I),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(h&&h.length===4)return{uri:O.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=C;function R(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function E(c,I){const{args:S,stack:h}=b(c),m=typeof S[0]=="string"&&S.length===1;let P=R(h);P&&(P=`(${P.trim()})`);let T=[];if(typeof S[0]=="string"?P&&m?T=[`%c[${I}] %c${S[0]} %c${P}`,g("blue"),g(""),g("grey")]:T=[`%c[${I}] %c${S[0]}`,g("blue"),g(""),...S.slice(1)]:T=[`%c[${I}]%`,g("blue"),...S],P&&!m&&T.push(P),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,T)}e.log=E;function g(c){return`color: ${c}`}}),define(Q[54],Z([0,1,14,30,11]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(c){return JSON.stringify(c,E)}e.stringify=C;function R(c){let I=JSON.parse(c);return I=g(I),I}e.parse=R;function E(c,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,D.regExpFlags)(I)}:I}function g(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return b.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof O.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let S=0;S<c.length;++S)c[S]=g(c[S],I+1);else for(const S in c)Object.hasOwnProperty.call(c,S)&&(c[S]=g(c[S],I+1))}return c}e.revive=g}),define(Q[80],Z([0,1,36,7,55,29,73]),function($,e,O,D,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,S=0;const h=(0,O.networkInterfaces)();for(const m in h){const P=h[m];if(P)for(const{mac:T,internal:u}of P)u||(S+=1,this._isVirtualMachineMacAddress(T.toUpperCase())&&(I+=1))}this._value=S>0?I/S:0}return this._value}};let E;async function g(){return E||(E=(async()=>await c()||C.generateUuid())()),E}e.getMachineId=g;async function c(){try{const I=await new Promise((h,m)=>{$(["crypto"],h,m)}),S=(0,R.getMac)();return I.createHash("sha256").update(S,"utf8").digest("hex")}catch(I){D.onUnexpectedError(I);return}}}),define(Q[81],Z([0,1,36,15,20]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,R=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var g;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class S{constructor(w,t,s){this.exePath=w,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:p=!1,findPreview:w=!1}={}){const t=h({useAlternateBitness:p});if(!t)return null;const s=D.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const o of await b.Promises.readdir(s)){let a=-1;if(w){const A=o.indexOf("-");if(A<0)continue;const V=o.substring(0,A);if(!C.test(V)||o.substring(A+1)!=="preview")continue;a=parseInt(V,10)}else{if(!C.test(o))continue;a=parseInt(o,10)}if(a<=i)continue;const d=D.join(s,o,"pwsh.exe");!await b.SymlinkSupport.existsFile(d)||(n=d,i=a)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",l=w?" Preview":"";return new S(n,`PowerShell${l}${r}`,!0)}async function P({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const w=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=p?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const i of await b.Promises.readdir(w))if(t.test(i)){const n=D.join(w,i,"pwsh.exe");return new S(n,s)}return null}function T(){const p=D.join(O.homedir(),".dotnet","tools","pwsh.exe");return new S(p,".NET Core PowerShell Global Tool")}function u(){const p=D.join(process.env.windir,c===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(p,"Windows PowerShell",!0)}async function*f(){let p=await m();p&&(yield p),p=await m({useAlternateBitness:!0}),p&&(yield p),p=await P(),p&&(yield p),p=T(),p&&(yield p),p=await m({findPreview:!0}),p&&(yield p),p=await P({findPreview:!0}),p&&(yield p),p=await m({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=u(),p&&(yield p)}async function*v(){for await(const p of f())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=v;async function y(){for await(const p of v())return p;return null}e.getFirstAvailablePowerShellInstallation=y}),define(Q[56],Z([0,1,15,12,37,51,3,20]),function($,e,O,D,b,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function g(S=b.env){return S.comspec||"cmd.exe"}e.getWindowsShell=g;function c(S){let h=[],m=!1;const P=function(T){if(m){h.push(T);return}(!S.send(T,f=>{if(f&&console.error(f),m=!1,h.length>0){const v=h.slice(0);h=[],v.forEach(y=>P(y))}})||D.isWindows)&&(m=!0)};return{send:P}}e.createQueuedSender=c;var I;(function(S){async function h(m,P,T){if(O.isAbsolute(m))return m;if(P===void 0&&(P=b.cwd()),O.dirname(m)!=="."||(T===void 0&&R.isString(b.env.PATH)&&(T=b.env.PATH.split(O.delimiter)),T===void 0||T.length===0))return O.join(P,m);async function f(v){if(await E.Promises.exists(v)){let y;try{y=await E.Promises.stat(v)}catch(p){p.message.startsWith("EACCES")&&(y=await E.Promises.lstat(v))}return y?!y.isDirectory():!1}return!1}for(const v of T){let y;if(O.isAbsolute(v)?y=O.join(v,m):y=O.join(P,v,m),await f(y))return y;let p=y+".com";if(await f(p)||(p=y+".exe",await f(p)))return p}return O.join(P,m)}S.findExecutable=h})(I=e.win32||(e.win32={}))}),define(Q[82],Z([0,1,36,12,81,56]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(S,h){return S===1?D.isWindows?I():C.getWindowsShell(h):g(S,h)}e.getSystemShell=R;let E=null;function g(S,h){if(D.isLinux&&S===2||D.isMacintosh&&S===3)return"/bin/bash";if(!E){let m;if(D.isWindows)m="/bin/bash";else{if(m=h.SHELL,!m)try{m=(0,O.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}E=m}return E}let c=null;async function I(){return c||(c=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),c}});var he=this&&this.__decorate||function($,e,O,D){var b=arguments.length,C=b<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,O):D,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate($,e,O,D);else for(var E=$.length-1;E>=0;E--)(R=$[E])&&(C=(b<3?R(C):b>3?R(e,O,C):R(e,O))||C);return b>3&&C&&Object.defineProperty(e,O,C),C};define(Q[57],Z([0,1,19,5,14,23,49,7,4,2,54,30,3]),function($,e,O,D,b,C,R,E,g,c,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m||(m={}));function P(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var T;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(T||(T={}));function u(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(f||(f={}));function v(M){let F=0;for(let j=0;;j+=7){const z=M.read(1);if(F|=(z.buffer[0]&127)<<j,!(z.buffer[0]&128))return F}}const y=i(0);function p(M,F){if(F===0){M.write(y);return}let j=0;for(let B=F;B!==0;B=B>>>7)j++;const z=b.VSBuffer.alloc(j);for(let B=0;F!==0;B++)z.buffer[B]=F&127,F=F>>>7,F>0&&(z.buffer[B]|=128);M.write(z)}class w{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}e.BufferReader=w;class t{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}e.BufferWriter=t;var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(s||(s={}));function i(M){const F=b.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function l(M,F){if(typeof F>"u")M.write(n.Undefined);else if(typeof F=="string"){const j=b.VSBuffer.fromString(F);M.write(n.String),p(M,j.byteLength),M.write(j)}else if(r&&Buffer.isBuffer(F)){const j=b.VSBuffer.wrap(F);M.write(n.Buffer),p(M,j.byteLength),M.write(j)}else if(F instanceof b.VSBuffer)M.write(n.VSBuffer),p(M,F.byteLength),M.write(F);else if(Array.isArray(F)){M.write(n.Array),p(M,F.length);for(const j of F)l(M,j)}else if(typeof F=="number"&&(F|0)===F)M.write(n.Uint),p(M,F);else{const j=b.VSBuffer.fromString(JSON.stringify(F));M.write(n.Object),p(M,j.byteLength),M.write(j)}}e.serialize=l;function o(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(v(M)).toString();case s.Buffer:return M.read(v(M)).buffer;case s.VSBuffer:return M.read(v(M));case s.Array:{const j=v(M),z=[];for(let B=0;B<j;B++)z.push(o(M));return z}case s.Object:return JSON.parse(M.read(v(M)).toString());case s.Int:return v(M)}}e.deserialize=o;class a{constructor(F,j,z=null,B=1e3){this.protocol=F,this.ctx=j,this.logger=z,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger?.logOutgoing(j,0,1,u(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(j,F.id,1,u(F.type),F.data);return}}}send(F,j=void 0){const z=new t;return l(z,F),l(z,j),this.sendBuffer(z.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const j=new w(F),z=o(j),B=o(j),K=z[0];switch(K){case 100:return this.logger?.logIncoming(F.byteLength,z[1],1,`${P(K)}: ${z[2]}.${z[3]}`,B),this.onPromise({type:K,id:z[1],channelName:z[2],name:z[3],arg:B});case 102:return this.logger?.logIncoming(F.byteLength,z[1],1,`${P(K)}: ${z[2]}.${z[3]}`,B),this.onEventListen({type:K,id:z[1],channelName:z[2],name:z[3],arg:B});case 101:return this.logger?.logIncoming(F.byteLength,z[1],1,`${P(K)}`),this.disposeActiveRequest({type:K,id:z[1]});case 103:return this.logger?.logIncoming(F.byteLength,z[1],1,`${P(K)}`),this.disposeActiveRequest({type:K,id:z[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const z=new C.CancellationTokenSource;let B;try{B=j.call(this.ctx,F.name,F.arg,z.token)}catch(k){B=Promise.reject(k)}const K=F.id;B.then(k=>{this.sendResponse({id:K,data:k,type:201}),this.activeRequests.delete(F.id)},k=>{k instanceof Error?this.sendResponse({id:K,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:K,data:k,type:203}),this.activeRequests.delete(F.id)});const N=(0,c.toDisposable)(()=>z.cancel());this.activeRequests.set(F.id,N)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const z=F.id,K=j.listen(this.ctx,F.name,F.arg)(N=>this.sendResponse({id:z,data:N,type:204}));this.activeRequests.set(F.id,K)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const z=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:z})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const z of j)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var d;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=j}getChannel(F){const j=this;return{call(z,B,K){return j.isDisposed?Promise.reject(new E.CancellationError):j.requestPromise(F,z,B,K)},listen(z,B){return j.isDisposed?g.Event.None:j.requestEvent(F,z,B)}}}requestPromise(F,j,z,B=C.CancellationToken.None){const K=this.lastRequestId++,k={id:K,type:100,channelName:F,name:j,arg:z};if(B.isCancellationRequested)return Promise.reject(new E.CancellationError);let L;return new Promise((U,q)=>{if(B.isCancellationRequested)return q(new E.CancellationError);const G=()=>{const me=ce=>{switch(ce.type){case 201:this.handlers.delete(K),U(ce.data);break;case 202:{this.handlers.delete(K);const ge=new Error(ce.data.message);ge.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,ge.name=ce.data.name,q(ge);break}case 203:this.handlers.delete(K),q(ce.data);break}};this.handlers.set(K,me),this.sendRequest(k)};let re=null;this.state===f.Idle?G():(re=(0,D.createCancelablePromise)(me=>this.whenInitialized()),re.then(()=>{re=null,G()}));const le=()=>{re?(re.cancel(),re=null):this.sendRequest({id:K,type:101}),q(new E.CancellationError)},Se=B.onCancellationRequested(le);L=(0,c.combinedDisposable)((0,c.toDisposable)(le),Se),this.activeRequests.add(L)}).finally(()=>{this.activeRequests.delete(L)})}requestEvent(F,j,z){const B=this.lastRequestId++,N={id:B,type:102,channelName:F,name:j,arg:z};let k=null;const L=new g.Emitter({onWillAddFirstListener:()=>{k=(0,D.createCancelablePromise)(U=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(L),this.sendRequest(N)})},onDidRemoveLastListener:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(L),this.sendRequest({id:B,type:103}))}}),x=U=>L.fire(U.data);return this.handlers.set(B,x),L.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(j,F.id,0,`${P(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger?.logOutgoing(j,F.id,0,P(F.type));return}}}send(F,j=void 0){const z=new t;return l(z,F),l(z,j),this.sendBuffer(z.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const j=new w(F),z=o(j),B=o(j),K=z[0];switch(K){case 200:return this.logger?.logIncoming(F.byteLength,0,0,u(K)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,z[1],0,u(K),B),this.onResponse({type:z[0],id:z[1],data:B})}}onResponse(F){if(F.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([R.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class V{get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:z})=>{g.Event.once(j.onMessage)(K=>{const N=new w(K),k=o(N),L=new a(j,k),x=new A(j);this.channels.forEach((q,G)=>L.registerChannel(G,q));const U={channelServer:L,channelClient:x,ctx:k};this._connections.add(U),this._onDidAddConnection.fire(U),z(()=>{L.dispose(),x.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}getChannel(F,j){const z=this;return{call(B,K,N){let k;if((0,h.isFunction)(j)){const x=(0,O.getRandomElement)(z.connections.filter(j));k=x?Promise.resolve(x):g.Event.toPromise(g.Event.filter(z.onDidAddConnection,j))}else k=j.routeCall(z,B,K);const L=k.then(x=>x.channelClient.getChannel(F));return ee(L).call(B,K,N)},listen(B,K){if((0,h.isFunction)(j))return z.getMulticastEvent(F,j,B,K);const N=j.routeEvent(z,B,K).then(k=>k.channelClient.getChannel(F));return ee(N).listen(B,K)}}}getMulticastEvent(F,j,z,B){const K=this;let N=new c.DisposableStore;const k=new g.Emitter({onWillAddFirstListener:()=>{N=new c.DisposableStore;const L=new g.EventMultiplexer,x=new Map,U=G=>{const le=G.channelClient.getChannel(F).listen(z,B),Se=L.add(le);x.set(G,Se)},q=G=>{const re=x.get(G);!re||(re.dispose(),x.delete(G))};K.connections.filter(j).forEach(U),g.Event.filter(K.onDidAddConnection,j)(U,void 0,N),K.onDidRemoveConnection(q,void 0,N),L.event(k.fire,k,N),N.add(L)},onDidRemoveLastListener:()=>{N.dispose()}});return k.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach(z=>{z.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=V;class Y{constructor(F,j,z=null){const B=new t;l(B,j),F.send(B.buffer),this.channelClient=new A(F,z),this.channelServer=new a(F,j,z)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=Y;function ee(M){return{call(F,j,z){return M.then(B=>B.call(F,j,z))},listen(F,j){const z=new g.Relay;return M.then(B=>z.input=B.listen(F,j)),z.event}}}e.getDelayedChannel=ee;function te(M){let F=!1;return{call(j,z,B){return F?M.call(j,z,B):(0,D.timeout)(0).then(()=>F=!0).then(()=>M.call(j,z,B))},listen(j,z){if(F)return M.listen(j,z);const B=new g.Relay;return(0,D.timeout)(0).then(()=>F=!0).then(()=>B.input=M.listen(j,z)),B.event}}}e.getNextTickChannel=te;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await g.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=ne;var ie;(function(M){function F(K,N){const k=K,L=N&&N.disableMarshalling,x=new Map;for(const U in k)z(U)&&x.set(U,g.Event.buffer(k[U],!0));return new class{listen(U,q,G){const re=x.get(q);if(re)return re;if(B(q)){const le=k[q];if(typeof le=="function")return le.call(k,G)}throw new Error(`Event not found: ${q}`)}call(U,q,G){const re=k[q];if(typeof re=="function"){if(!L&&Array.isArray(G))for(let le=0;le<G.length;le++)G[le]=(0,I.revive)(G[le]);return re.apply(k,G)}throw new Error(`Method not found: ${q}`)}}}M.fromService=F;function j(K,N){const k=N&&N.disableMarshalling;return new Proxy({},{get(L,x){if(typeof x=="string")return N?.properties?.has(x)?N.properties.get(x):B(x)?function(U){return K.listen(x,U)}:z(x)?K.listen(x):async function(...U){let q;N&&!(0,h.isUndefinedOrNull)(N.context)?q=[N.context,...U]:q=U;const G=await K.call(x,q);return k?G:(0,I.revive)(G)};throw new Error(`Property not found: ${String(x)}`)}})}M.toService=j;function z(K){return K[0]==="o"&&K[1]==="n"&&S.isUpperAsciiLetter(K.charCodeAt(2))}function B(K){return/^onDynamic/.test(K)&&S.isUpperAsciiLetter(K.charCodeAt(9))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const F=M.toString();if(F!=="[object Object]")return F}return M}function oe(M){return Array.isArray(M)?M.map(fe):fe(M)}function pe(M,F,j,z,B,K,N){N=oe(N);const k=ae[B],L=k[z%k.length];let x=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(K)?(x=x.concat(N),x.push(")")):x.push(N),console.log.apply(console,x)}class W{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,z,B,K){this._totalOutgoing+=F,pe(this._outgoingPrefix,this._totalOutgoing,F,j,z,B,K)}logIncoming(F,j,z,B,K){this._totalIncoming+=F,pe(this._incomingPrefix,this._totalIncoming,F,j,z,B,K)}}e.IPCLogger=W}),define(Q[83],Z([0,1,58,5,14,23,79,7,4,2,28,56,51,57]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class P extends m.ChannelServer{constructor(f){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",v=>b.VSBuffer.wrap(Buffer.from(v,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=P;class T{constructor(f,v){this.modulePath=f,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new D.Delayer(y),this.child=null,this._client=null}getChannel(f){const v=this;return{call(y,p,w){return v.requestPromise(f,y,p,w)},listen(y,p){return v.requestEvent(f,y,p)}}}requestPromise(f,v,y,p=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(f),t=(0,D.createCancelablePromise)(n=>w.call(v,y,n)),s=p.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(f,v,y){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let p;const w=new g.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(f).listen(v,y)(w.fire,w),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,h.removeDangerousEnvVariables)(v.env),this.child=(0,O.fork)(this.modulePath,f,v);const y=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,R.isRemoteConsoleLog)(r)){(0,R.log)(r,`IPC Library: ${this.options.serverName}`);return}y.fire(b.VSBuffer.wrap(Buffer.from(r,"base64")))});const w=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&w.send(r.buffer.toString("base64")),s=y.event,i={send:t,onMessage:s};this._client=new m.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,c.dispose)(o)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(f){let v=this.channels.get(f);return v||(v=this.client.getChannel(f),this.channels.set(f,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=T}),define(Q[84],Z([0,1,5,4,2,3]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R=e.StorageHint||(e.StorageHint={}));function E(S){const h=S;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var g;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class c extends b.Disposable{constructor(h,m=Object.create(null)){super(),this.database=h,this.options=m,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((m,P)=>this.accept(P,m)),h.deleted?.forEach(m=>this.accept(m,void 0))}accept(h,m){if(this.state===g.Closed)return;let P=!1;(0,C.isUndefinedOrNull)(m)?P=this.cache.delete(h):this.cache.get(h)!==m&&(this.cache.set(h,m),P=!0),P&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,m){const P=this.cache.get(h);return(0,C.isUndefinedOrNull)(P)?m:P}getBoolean(h,m){const P=this.get(h);return(0,C.isUndefinedOrNull)(P)?m:P==="true"}getNumber(h,m){const P=this.get(h);return(0,C.isUndefinedOrNull)(P)?m:parseInt(P,10)}async set(h,m){if(this.state===g.Closed)return;if((0,C.isUndefinedOrNull)(m))return this.delete(h);const P=String(m);if(this.cache.get(h)!==P)return this.cache.set(h,P),this.pendingInserts.set(h,P),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===g.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}c.DEFAULT_FLUSH_DELAY=100,e.Storage=c;class I{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((m,P)=>this.items.set(P,m)),h.delete?.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=I}),define(Q[85],Z([8,9]),function($,e){return $.create("vs/base/node/zip",e)}),define(Q[86],Z([8,9]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[87],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[88],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[89],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[90],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[91],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[92],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[93],Z([8,9]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[94],Z([8,9]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[95],Z([8,9]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Q[96],Z([8,9]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Q[97],Z([8,9]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[98],Z([8,9]),function($,e){return $.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[99],Z([8,9]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Q[100],Z([8,9]),function($,e){return $.create("vs/platform/shell/node/shellEnv",e)}),define(Q[101],Z([8,9]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[102],Z([8,9]),function($,e){return $.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[103],Z([8,9]),function($,e){return $.create("vs/platform/workspace/common/workspace",e)}),define(Q[104],Z([0,1,75,49,16,15,37,18,11]),function($,e,O,D,b,C,R,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,C.dirname)(b.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(g.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=R.env.VSCODE_PORTABLE;return m?g.URI.file((0,C.join)(m,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,C.resolve)(m):(0,C.normalize)((0,C.join)(b.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?g.URI.file((0,C.resolve)(m)):g.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,C.resolve)(m);const P=R.env.VSCODE_EXTENSIONS;if(P)return P;const T=R.env.VSCODE_PORTABLE;return T?(0,C.join)(T,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(P=>/^[^:/?#]+?:\/\//.test(P)?g.URI.parse(P):g.URI.file((0,C.normalize)(P)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,C.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const P of this.args.log||[]){const T=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(P);T&&T[1]&&T[2]&&m.push([T[1],T[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=R.env.VSCODE_PORTABLE;return m?g.URI.file((0,C.join)(m,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this._args}constructor(m,P,T){this._args=m,this.paths=P,this.productService=T,this.editSessionId=this.args.editSessionId}}he([D.memoize],c.prototype,"appRoot",null),he([D.memoize],c.prototype,"userHome",null),he([D.memoize],c.prototype,"userDataPath",null),he([D.memoize],c.prototype,"appSettingsHome",null),he([D.memoize],c.prototype,"tmpDir",null),he([D.memoize],c.prototype,"cacheHome",null),he([D.memoize],c.prototype,"stateResource",null),he([D.memoize],c.prototype,"userRoamingDataHome",null),he([D.memoize],c.prototype,"userDataSyncHome",null),he([D.memoize],c.prototype,"userDataSyncLogResource",null),he([D.memoize],c.prototype,"editSessionsLogResource",null),he([D.memoize],c.prototype,"sync",null),he([D.memoize],c.prototype,"machineSettingsResource",null),he([D.memoize],c.prototype,"workspaceStorageHome",null),he([D.memoize],c.prototype,"localHistoryHome",null),he([D.memoize],c.prototype,"keyboardLayoutResource",null),he([D.memoize],c.prototype,"argvResource",null),he([D.memoize],c.prototype,"isExtensionDevelopment",null),he([D.memoize],c.prototype,"untitledWorkspacesHome",null),he([D.memoize],c.prototype,"installSourcePath",null),he([D.memoize],c.prototype,"builtinExtensionsPath",null),he([D.memoize],c.prototype,"extensionsPath",null),he([D.memoize],c.prototype,"extensionDevelopmentLocationURI",null),he([D.memoize],c.prototype,"extensionDevelopmentKind",null),he([D.memoize],c.prototype,"extensionTestsLocationURI",null),he([D.memoize],c.prototype,"debugExtensionHost",null),he([D.memoize],c.prototype,"logLevel",null),he([D.memoize],c.prototype,"extensionLogLevel",null),he([D.memoize],c.prototype,"serviceMachineIdResource",null),he([D.memoize],c.prototype,"telemetryLogResource",null),he([D.memoize],c.prototype,"disableWorkspaceTrust",null),he([D.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function I(h,m){return S(h["inspect-extensions"],h["inspect-brk-extensions"],5870,m,h.debugId,h.extensionEnvironment)}e.parseExtensionHostDebugPort=I;function S(h,m,P,T,u,f){const y=Number(m||h)||(T?null:P),p=y?Boolean(!!m):!1;let w;if(f)try{w=JSON.parse(f)}catch{}return{port:y,break:p,debugId:u,env:w}}e.parseDebugParams=S}),define(Q[105],Z([0,1,36,104,156]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class C extends D.AbstractNativeEnvironmentService{constructor(c,I){super(c,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,b.getUserDataPath)(c,I.nameShort)},I)}}e.NativeEnvironmentService=C;function R(g,c){return(0,D.parseDebugParams)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,c,g.extensionEnvironment)}e.parsePtyHostDebugPort=R;function E(g,c){return(0,D.parseDebugParams)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,c,g.extensionEnvironment)}e.parseSharedProcessDebugPort=E}),define(Q[106],Z([0,1,3,90]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function b(R,E,g){try{C(R,E,g)}catch(c){console.error(c?.message??c)}return R}e.localizeManifest=b;function C(R,E,g){const c=(I,S,h)=>{const m=I[S];if((0,O.isString)(m)){const P=m,T=P.length;if(T>1&&P[0]==="%"&&P[T-1]==="%"){const u=P.substr(1,T-2);let f=E[u];f===void 0&&g&&(f=g[u]);const v=typeof f=="string"?f:f?.message,y=g?.[u],p=typeof y=="string"?y:y?.message;if(!v){p||console.warn(`[${R.name}]: ${(0,D.localize)(0,null,u)}`);return}if(h&&(S==="title"||S==="category")&&p&&p!==v){const w={value:v,original:p};I[S]=w}else I[S]=v}}else if((0,O.isObject)(m))for(const P in m)m.hasOwnProperty(P)&&(P==="commands"?c(m,P,!0):c(m,P,h));else if(Array.isArray(m))for(let P=0;P<m.length;P++)c(m,P,h)};for(const I in R)R.hasOwnProperty(I)&&c(R,I)}}),define(Q[107],Z([0,1,7]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this._generators=new Map}register(C,R){this._generators.set(C,R)}updateManifest(C){if(!(typeof C.main>"u"&&typeof C.browser>"u")&&(C.activationEvents===void 0&&Object.assign(C,{activationEvents:[]}),!(!Array.isArray(C.activationEvents)||!C.contributes)))for(const R in C.contributes){const E=this._generators.get(R);if(!E)continue;const g=C.contributes[R],c=Array.isArray(g)?g:[g];try{E(c,C.activationEvents)}catch(I){(0,O.onUnexpectedError)(I)}}}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Q[44],Z([0,1,18,53,94,41]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||R.test(f)}e.isValidVersionStr=g;function c(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(R);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=c;function I(f){if(!f)return null;const v=f.majorBase,y=f.majorMustEqual,p=f.minorBase;let w=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(v===0||(w=!1),s=!1);let i=0;if(f.preRelease){const n=E.exec(f.preRelease);if(n){const[,r,l,o]=n;i=Date.UTC(Number(r),Number(l)-1,Number(o))}}return{majorBase:v,majorMustEqual:y,minorBase:p,minorMustEqual:w,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function S(f,v,y){let p;typeof f=="string"?p=I(c(f)):p=f;let w;v instanceof Date?w=v.getTime():typeof v=="string"&&(w=new Date(v).getTime());let t;if(typeof y=="string"?t=I(c(y)):t=y,!p||!t)return!1;const s=p.majorBase,i=p.minorBase,n=p.patchBase;let r=t.majorBase,l=t.minorBase,o=t.patchBase;const a=t.notBefore;let d=t.majorMustEqual,A=t.minorMustEqual,V=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>l?!0:i<l||w&&w<a?!1:n>=o:(s===1&&r===0&&(!d||!A||!V)&&(r=1,l=0,o=0,d=!0,A=!1,V=!1),s<r?!1:s>r?!d:i<l?!1:i>l?!A:n<o?!1:n>o?!V:!(w&&w<a))}e.isValidVersion=S;function h(f,v,y,p,w){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([D.default.Error,b.localize(0,null)]),t;if(typeof p.name!="string")return t.push([D.default.Error,b.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([D.default.Error,b.localize(2,null,"version")]),t;if(!p.engines)return t.push([D.default.Error,b.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([D.default.Error,b.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!u(p.extensionDependencies))return t.push([D.default.Error,b.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!u(p.activationEvents))return t.push([D.default.Error,b.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([D.default.Error,b.localize(7,null,"activationEvents","main")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([D.default.Warning,b.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([D.default.Error,b.localize(9,null,"main")]),t;{const n=(0,O.joinPath)(y,p.main);(0,O.isEqualOrParent)(n,y)||t.push([D.default.Warning,b.localize(10,null,n.path,y.path)])}if(typeof p.activationEvents>"u")return t.push([D.default.Error,b.localize(11,null,"activationEvents","main")]),t}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([D.default.Error,b.localize(12,null,"browser")]),t;{const n=(0,O.joinPath)(y,p.browser);(0,O.isEqualOrParent)(n,y)||t.push([D.default.Warning,b.localize(13,null,n.path,y.path)])}if(typeof p.activationEvents>"u")return t.push([D.default.Error,b.localize(14,null,"activationEvents","browser")]),t}if(!C.valid(p.version))return t.push([D.default.Error,b.localize(15,null)]),t;const s=[];if(!m(f,v,p,w,s))for(const n of s)t.push([D.default.Error,n]);return t}e.validateExtensionManifest=h;function m(f,v,y,p,w){return p||typeof y.main>"u"&&typeof y.browser>"u"?!0:T(f,v,y.engines.vscode,w)}e.isValidExtensionVersion=m;function P(f,v,y){return f==="*"||T(v,y,f)}e.isEngineValid=P;function T(f,v,y,p=[]){const w=I(c(y));if(!w)return p.push(b.localize(16,null,y)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(b.localize(17,null,y)),!1}else if(!w.majorMustEqual)return p.push(b.localize(18,null,y)),!1;return S(f,v,w)?!0:(p.push(b.localize(19,null,f,y)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let v=0,y=f.length;v<y;v++)if(typeof f[v]!="string")return!1;return!0}}),define(Q[108],Z([0,1,14,29]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function b(C,R,E){let g=E&&E.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const I=(await R.readFile(C.serviceMachineIdResource)).value.toString();g=(0,D.isUUID)(I)?I:null}catch{g=null}if(!g){g=(0,D.generateUuid)();try{await R.writeFile(C.serviceMachineIdResource,O.VSBuffer.fromString(g))}catch{}}return E?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=b}),define(Q[45],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(b,C=[],R=!1){this.ctor=b,this.staticArguments=C,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=O}),define(Q[109],Z([0,1,45]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var b;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(b=e.InstantiationType||(e.InstantiationType={}));function C(E,g,c){g instanceof O.SyncDescriptor||(g=new O.SyncDescriptor(g,[],Boolean(c))),D.push([E,g])}e.registerSingleton=C;function R(){return D}e.getSingletonServiceDescriptors=R}),define(Q[110],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(C,R){this.key=C,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class D{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(const R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const E=this.lookupOrInsertNode(C),g=this.lookupOrInsertNode(R);E.outgoing.set(g.key,g),g.incoming.set(E.key,E)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(const E of this._nodes.values())E.outgoing.delete(R),E.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let E=this._nodes.get(R);return E||(E=new O(R,C),this._nodes.set(R,E)),E}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){const C=[];for(const[R,E]of this._nodes)C.push(`${R}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,R]of this._nodes){const E=new Set([C]),g=this._findCycle(R,E);if(g)return g}}_findCycle(C,R){for(const[E,g]of C.outgoing){if(R.has(E))return[...R,E].join(" -> ");R.add(E);const c=this._findCycle(g,R);if(c)return c;R.delete(E)}}}e.Graph=D}),define(Q[24],Z([0,1,3,11,10]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.isConfigurationOverrides=C;function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=R;var E;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function c(u,f){const v=Object.create(null);for(const y in u)I(v,y,u[y],f);return v}e.toValuesTree=c;function I(u,f,v,y){const p=f.split("."),w=p.pop();let t=u;for(let s=0;s<p.length;s++){const i=p[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${f} as ${p.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[w]=v}catch{y(`Ignoring ${f} as ${p.join(".")} is ${JSON.stringify(t)}`)}else y(`Ignoring ${f} as ${p.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=I;function S(u,f){const v=f.split(".");h(u,v)}e.removeFromValueTree=S;function h(u,f){const v=f.shift();if(f.length===0){delete u[v];return}if(Object.keys(u).indexOf(v)!==-1){const y=u[v];typeof y=="object"&&!Array.isArray(y)&&(h(y,f),Object.keys(y).length===0&&delete u[v])}}function m(u,f,v){function y(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const p=f.split("."),w=y(u,p);return typeof w>"u"?v:w}e.getConfigurationValue=m;function P(u,f,v){Object.keys(f).forEach(y=>{y!=="__proto__"&&(y in u?O.isObject(u[y])&&O.isObject(f[y])?P(u[y],f[y],v):v&&(u[y]=f[y]):u[y]=f[y])})}e.merge=P;function T(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=T}),define(Q[59],Z([0,1,10]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Q[17],Z([0,1,10]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[21],Z([0,1,88,10]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function b(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function C(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function R(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function E(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function g(f,v,y){return E(v,y)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===y?!0:c(y).includes(f)}e.isTargetPlatformCompatible=g;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I;var S;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var h;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var m;(function(f){f.Install="install",f.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var P;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var T;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(T=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(v,y){super(v),this.code=y,this.name=y}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,O.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,O.localize)(1,null),original:"Preferences"}}),define(Q[60],Z([0,1,10]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");class D{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((C,R)=>$(["node-vsce-sign"],async E=>C(E),R))),this.moduleLoadingPromise}async verify(C,R,E){let g;try{g=await this.vsceSign()}catch{return!1}return g.verify(C,R,E)}}e.ExtensionSignatureVerificationService=D}),define(Q[61],Z([0,1,14,7,96,13]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(I,S,h,m,P,T){let u;try{await E(I,S,h,m,P,T)}catch(f){u=f}finally{u&&P.errorTransformer&&(u=P.errorTransformer(u)),typeof u<"u"&&h.error(u),h.end()}}e.readFileIntoStream=R;async function E(I,S,h,m,P,T){g(T);const u=await I.open(S,{create:!1});try{g(T);let f=0,v=0,y=P&&typeof P.length=="number"?P.length:void 0,p=O.VSBuffer.alloc(Math.min(P.bufferSize,typeof y=="number"?y:P.bufferSize)),w=P&&typeof P.position=="number"?P.position:0,t=0;do v=await I.read(u,w,p.buffer,t,p.byteLength-t),w+=v,t+=v,f+=v,typeof y=="number"&&(y-=v),t===p.byteLength&&(await h.write(m(p)),p=O.VSBuffer.alloc(Math.min(P.bufferSize,typeof y=="number"?y:P.bufferSize)),t=0);while(v>0&&(typeof y!="number"||y>0)&&g(T)&&c(f,P));if(t>0){let s=t;typeof y=="number"&&(s=Math.min(t,y)),h.write(m(p.slice(0,s)))}}catch(f){throw(0,C.ensureFileSystemProviderError)(f)}finally{await I.close(u)}}function g(I){if(I.isCancellationRequested)throw(0,D.canceled)();return!0}function c(I,S){if(S?.limits){if(typeof S.limits.memory=="number"&&I>S.limits.memory)throw(0,C.createFileSystemProviderError)((0,b.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&I>S.limits.size)throw(0,C.createFileSystemProviderError)((0,b.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[111],Z([0,1,4,157,2,12,158]),function($,e,O,D,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends b.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new O.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=O.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(c){const I=this.normalizeRequests(c),S=I.filter(m=>{const P=this.watchers.get(m.path);return P?!(0,D.patternsEquals)(P.request.excludes,m.excludes)||!(0,D.patternsEquals)(P.request.includes,m.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:m})=>!I.find(P=>P.path===m.path&&(0,D.patternsEquals)(P.excludes,m.excludes)&&(0,D.patternsEquals)(P.includes,m.includes))).map(({request:m})=>m.path);S.length&&this.trace(`Request to start watching: ${S.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const m of h)this.stopWatching(m);for(const m of S)this.startWatching(m)}startWatching(c){const I=new R.NodeJSFileWatcherLibrary(c,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),S={request:c,instance:I};this.watchers.set(c.path,S)}async stop(){for(const[c]of this.watchers)this.stopWatching(c);this.watchers.clear()}stopWatching(c){const I=this.watchers.get(c);I&&(this.watchers.delete(c),I.instance.dispose())}normalizeRequests(c){const I=new Map;for(const S of c){const h=C.isLinux?S.path:S.path.toLowerCase();I.set(h,S)}return Array.from(I.values())}async setVerboseLogging(c){this.verboseLogging=c;for(const[,I]of this.watchers)I.instance.setVerboseLogging(c)}trace(c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(c)})}toMessage(c,I){return I?`[File Watcher (node.js)] ${c} (path: ${I.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=E}),define(Q[112],Z([0,1,62,111]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class b extends O.AbstractNonRecursiveWatcherClient{constructor(R,E,g){super(R,E,g),this.init()}createWatcher(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=b}),define(Q[113],Z([0,1,16,57,83,62]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends C.AbstractUniversalWatcherClient{constructor(g,c,I){super(g,c,I),this.init()}createWatcher(g){const c=g.add(new b.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:I,signal:S})=>this.onError(`terminated by itself with code ${I}, signal: ${S}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(Q[63],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...b){this._entries=new Map;for(const[C,R]of b)this.set(C,R)}set(b,C){const R=this._entries.get(b);return this._entries.set(b,C),R}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=O}),define(Q[114],Z([0,1,5,7,2,45,110,10,63,159]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class S extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class h{constructor(u=new g.ServiceCollection,f=!1,v,y=I){this._services=u,this._strict=f,this._parent=v,this._enableTracing=y,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=y?v?._globalGraph??new R.Graph(p=>p):void 0}createChild(u){return new h(u,this._strict,this,this._enableTracing)}invokeFunction(u,...f){const v=P.traceInvocation(this._enableTracing,u);let y=!1;try{return u({get:w=>{if(y)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(w,v);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...f)}finally{y=!0,v.stop()}}createInstance(u,...f){let v,y;return u instanceof C.SyncDescriptor?(v=P.traceCreation(this._enableTracing,u.ctor),y=this._createInstance(u.ctor,u.staticArguments.concat(f),v)):(v=P.traceCreation(this._enableTracing,u),y=this._createInstance(u,f,v)),v.stop(),y}_createInstance(u,f=[],v){const y=E._util.getServiceDependencies(u).sort((t,s)=>t.index-s.index),p=[];for(const t of y){const s=this._getOrCreateServiceInstance(t.id,v);s||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(s)}const w=y.length>0?y[0].index:f.length;if(f.length!==w){console.trace(`[createInstance] First service dependency of ${u.name} at position ${w+1} conflicts with ${f.length} static arguments`);const t=w-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,w)}return Reflect.construct(u,f.concat(p))}_setServiceInstance(u,f){if(this._services.get(u)instanceof C.SyncDescriptor)this._services.set(u,f);else if(this._parent)this._parent._setServiceInstance(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const f=this._services.get(u);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):f}_getOrCreateServiceInstance(u,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(u));const v=this._getServiceInstanceOrDescriptor(u);return v instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,f.branch(u,!0)):(f.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,f,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,f,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,f,v){const y=new R.Graph(t=>t.id.toString());let p=0;const w=[{id:u,desc:f,_trace:v}];for(;w.length;){const t=w.pop();if(y.lookupOrInsertNode(t),p++>1e3)throw new S(y);for(const s of E._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof C.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};y.insertEdge(t,n),w.push(n)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new S(y);break}for(const{data:s}of t){if(this._getServiceInstanceOrDescriptor(s.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}y.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,f,v=[],y,p){if(this._services.get(u)instanceof C.SyncDescriptor)return this._createServiceInstance(u,f,v,y,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,f,v,y,p);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(u,f,v=[],y,p){if(y){const w=new h(void 0,this._strict,this,this._enableTracing);w._globalGraphImplicitDependency=String(u);const t=new Map,s=new O.IdleValue(()=>{const i=w._createInstance(f,v,p);for(const[n,r]of t){const l=i[n];if(typeof l=="function")for(const o of r)l.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new c.LinkedList,t.set(n,o)),(d,A,V)=>{const Y=o.push([d,A,V]);return(0,b.toDisposable)(Y)}}if(n in i)return i[n];const r=s.value;let l=r[n];return typeof l!="function"||(l=l.bind(r),i[n]=l),l},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this._createInstance(f,v,p)}_throwIfStrict(u,f){if(f&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=h;var m;(function(T){T[T.None=0]="None",T[T.Creation=1]="Creation",T[T.Invocation=2]="Invocation",T[T.Branch=3]="Branch"})(m||(m={}));class P{static traceInvocation(u,f){return u?new P(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):P._None}static traceCreation(u,f){return u?new P(1,f.name):P._None}constructor(u,f){this.type=u,this.name=f,this._start=Date.now(),this._dep=[]}branch(u,f){const v=new P(3,u.toString());return this._dep.push([u,f,v]),v}stop(){const u=Date.now()-this._start;P._totals+=u;let f=!1;function v(p,w){const t=[],s=new Array(p+1).join("	");for(const[i,n,r]of w._dep)if(n&&r){f=!0,t.push(`${s}CREATES -> ${i}`);const l=v(p+1,r);l&&t.push(l)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(u>2||f)&&P.all.add(y.join(`
`))}}P.all=new Set,P._None=new class extends P{constructor(){super(0,null)}stop(){}branch(){return this}},P._totals=0,e.Trace=P});var J=this&&this.__param||function($,e){return function(O,D){e(O,D,$)}};define(Q[64],Z([0,1,23,2,12,98,21,10]),function($,e,O,D,b,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(I){return I.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,E.createDecorator)("languagePackService");let c=class extends D.Disposable{constructor(S){super(),this.extensionGalleryService=S}async getAvailableLanguages(){const S=new O.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let h;try{h=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const P=h.firstPage.filter(T=>T.properties.localizedLanguages?.length&&T.tags.some(u=>u.startsWith("lp-"))).map(T=>{const u=T.properties.localizedLanguages?.[0],f=g(T);return{...this.createQuickPickItem(f,u,T),extensionId:T.identifier.id,galleryExtension:T}});return P.push(this.createQuickPickItem("en","English")),P}createQuickPickItem(S,h,m){const P=h??S;let T;if(P!==S&&(T=`(${S})`),S.toLowerCase()===b.language.toLowerCase()&&(T??="",T+=(0,C.localize)(0,null)),m?.installCount){T??="";const u=m.installCount;let f;u>1e6?f=`${Math.floor(u/1e5)/10}M`:u>1e3?f=`${Math.floor(u/1e3)}K`:f=String(u),T+=` $(cloud-download) ${f}`}return{id:S,label:P,description:T}}};c=he([J(0,R.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(Q[6],Z([0,1,33,4,2,34,12,3,11,10]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function I(){return new Date().toISOString()}function S(o){return(0,E.isNumber)(o)}e.isLogLevel=S;var h;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function m(o,a,d){switch(a){case h.Trace:o.trace(d);break;case h.Debug:o.debug(d);break;case h.Info:o.info(d);break;case h.Warning:o.warn(d);break;case h.Error:o.error(d);break;case h.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=m;function P(o){let a="";for(let d=0;d<o.length;d++){let A=o[d];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}a+=(d>0?" ":"")+A}return a}e.format=P;class T extends b.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(a){return this.level!==h.Off&&this.level<=a}}e.AbstractLogger=T;class u extends T{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||super.checkLogLevel(a)}trace(a,...d){this.checkLogLevel(h.Trace)&&this.log(h.Trace,P([a,...d]))}debug(a,...d){this.checkLogLevel(h.Debug)&&this.log(h.Debug,P([a,...d]))}info(a,...d){this.checkLogLevel(h.Info)&&this.log(h.Info,P([a,...d]))}warn(a,...d){this.checkLogLevel(h.Warning)&&this.log(h.Warning,P([a,...d]))}error(a,...d){if(this.checkLogLevel(h.Error))if(a instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=a.stack,this.log(h.Error,P(A))}else this.log(h.Error,P([a,...d]))}flush(){}}e.AbstractMessageLogger=u;class f extends T{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!R.isWindows}trace(a,...d){this.checkLogLevel(h.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,a,...d):console.log(`[main ${I()}]`,a,...d))}debug(a,...d){this.checkLogLevel(h.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,a,...d):console.log(`[main ${I()}]`,a,...d))}info(a,...d){this.checkLogLevel(h.Info)&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,a,...d):console.log(`[main ${I()}]`,a,...d))}warn(a,...d){this.checkLogLevel(h.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,a,...d):console.warn(`[main ${I()}]`,a,...d))}error(a,...d){this.checkLogLevel(h.Error)&&(this.useColors?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,a,...d):console.error(`[main ${I()}]`,a,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class v extends T{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...d){this.checkLogLevel(h.Trace)&&console.log("%cTRACE","color: #888",a,...d)}debug(a,...d){this.checkLogLevel(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...d)}info(a,...d){this.checkLogLevel(h.Info)&&console.log("%c INFO","color: #33f",a,...d)}warn(a,...d){this.checkLogLevel(h.Warning)&&console.log("%c WARN","color: #993",a,...d)}error(a,...d){this.checkLogLevel(h.Error)&&console.log("%c  ERR","color: #f33",a,...d)}dispose(){}flush(){}}e.ConsoleLogger=v;class y extends T{constructor(a,d=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(d)}trace(a,...d){this.checkLogLevel(h.Trace)&&this.adapter.log(h.Trace,[this.extractMessage(a),...d])}debug(a,...d){this.checkLogLevel(h.Debug)&&this.adapter.log(h.Debug,[this.extractMessage(a),...d])}info(a,...d){this.checkLogLevel(h.Info)&&this.adapter.log(h.Info,[this.extractMessage(a),...d])}warn(a,...d){this.checkLogLevel(h.Warning)&&this.adapter.log(h.Warning,[this.extractMessage(a),...d])}error(a,...d){this.checkLogLevel(h.Error)&&this.adapter.log(h.Error,[this.extractMessage(a),...d])}extractMessage(a){return typeof a=="string"?a:(0,O.toErrorMessage)(a,this.checkLogLevel(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=y;class p extends T{constructor(a){super(),this.loggers=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const d of this.loggers)d.setLevel(a);super.setLevel(a)}trace(a,...d){for(const A of this.loggers)A.trace(a,...d)}debug(a,...d){for(const A of this.loggers)A.debug(a,...d)}info(a,...d){for(const A of this.loggers)A.info(a,...d)}warn(a,...d){for(const A of this.loggers)A.warn(a,...d)}error(a,...d){for(const A of this.loggers)A.error(a,...d)}flush(){for(const a of this.loggers)a.flush()}dispose(){for(const a of this.loggers)a.dispose()}}e.MultiplexLogger=p;class w extends b.Disposable{constructor(a,d){if(super(),this.logLevel=a,this._loggers=new C.ResourceMap,this._loggerResources=new C.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,d)for(const A of d)this._loggerResources.set(A.resource,A)}getLogger(a){return this._loggers.get(a)}createLogger(a,d){let A=this._loggers.get(a);const V=d?.logLevel==="always"?h.Trace:d?.logLevel;return A||(A=this.doCreateLogger(a,V??this.getLogLevel(a)??this.logLevel,d),this._loggers.set(a,A)),this.registerLogger({resource:a,id:d?.id??a.toString(),logLevel:V,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId}),A}setLogLevel(a,d){if(g.URI.isUri(a)){const A=a,V=d,Y=this._loggerResources.get(A);Y&&V!==Y.logLevel&&(Y.logLevel=V===this.logLevel?void 0:V,this._loggers.get(A)?.setLevel(V),this._loggerResources.set(Y.resource,Y),this._onDidChangeLogLevel.fire([A,V]))}else{this.logLevel=a;for(const[A,V]of this._loggers.entries())this._loggerResources.get(A)?.logLevel===void 0&&V.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(a,d){const A=this._loggerResources.get(a);A&&d!==!A.hidden&&(A.hidden=!d,this._loggerResources.set(A.resource,A),this._onDidChangeVisibility.fire([a,d]))}getLogLevel(a){let d;return a&&(d=this._loggerResources.get(a)?.logLevel),d??this.logLevel}registerLogger(a){const d=this._loggerResources.get(a.resource);d?d.hidden!==a.hidden&&this.setVisibility(a.resource,!a.hidden):(this._loggerResources.set(a.resource,a),this._onDidChangeLoggers.fire({added:[a],removed:[]}))}deregisterLogger(a){const d=this._loggerResources.get(a);if(d){this._loggerResources.delete(a);const A=this._loggers.get(a);A&&(this._loggers.delete(a),A.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[d]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(a){return this._loggerResources.get(a)}dispose(){this._loggers.forEach(a=>a.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=w;class t{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(a){}getLevel(){return h.Info}trace(a,...d){}debug(a,...d){}info(a,...d){}warn(a,...d){}error(a,...d){}critical(a,...d){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends w{constructor(){super(h.Info)}doCreateLogger(a,d,A){return new t}}e.NullLoggerService=i;function n(o){if(o.verbose)return h.Trace;if(typeof o.logLevel=="string"){const a=l(o.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(o){switch(o){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=r;function l(o){switch(o){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=l}),define(Q[115],Z([0,1,19,5,7,4,2,15,62,6]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends R.Disposable{constructor(h,m){super(),this.logService=h,this.options=m,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(h,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,m):this.watchNonRecursive(h,m)}watchUniversal(h,m){const P={path:this.toFilePath(h),excludes:m.excludes,includes:m.includes,recursive:m.recursive},T=(0,O.insert)(this.universalPathsToWatch,P);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{T(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,b.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,g.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const m of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const m of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(m)&&h.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,m){const P={path:this.toFilePath(h),excludes:m.excludes,includes:m.includes,recursive:!1},T=(0,O.insert)(this.nonRecursivePathsToWatch,P);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{T(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,b.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,g.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,E.normalize)(h.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Q[116],Z([0,1,19,5,14,23,4,52,65,2,55,16,117,18,43,95,13,61,6,7]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends c.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(t,s){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.provider.set(t,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this._onDidFilesChange.fire(new u.FileChangesEvent(n,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:t}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:s}),this.provider.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){s.push(i)}}),!this.provider.has(t)&&await D.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,s){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.provider,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async withProvider(t){if(!(0,m.isAbsolutePath)(t))throw new u.FileOperationError((0,T.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const s=this.provider.get(t.scheme);if(!s){const i=new y.ErrorNoTelemetry;throw i.message=(0,T.localize)(1,null,t.toString()),i}return s}async withReadProvider(t){const s=await this.withProvider(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const s=await this.withProvider(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.doResolveFile(t,s)}catch(i){throw(0,u.toFileSystemProviderErrorCode)(i)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,T.localize)(2,null,this.resourceForError(t)),1):(0,u.ensureFileSystemProviderError)(i)}}async doResolveFile(t,s){const i=await this.withProvider(t),n=this.isPathCaseSensitive(i),r=s?.resolveTo,l=s?.resolveSingleChildDescendants,o=s?.resolveMetadata,a=await i.stat(t);let d;return this.toFileStat(i,t,a,void 0,!!o,(A,V)=>(d||(d=I.TernarySearchTree.forUris(()=>!n),d.set(t,!0),r&&d.fill(!0,r)),d.get(A.resource)||d.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&l?V===1:!1))}async toFileStat(t,s,i,n,r,l){const{providerExtUri:o}=this.getExtUri(t),a={resource:s,name:o.basename(s),isFile:(i.type&u.FileType.File)!==0,isDirectory:(i.type&u.FileType.Directory)!==0,isSymbolicLink:(i.type&u.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(a.isDirectory&&l(a,n)){try{const d=await t.readdir(s),A=await D.Promises.settled(d.map(async([V,Y])=>{try{const ee=o.joinPath(s,V),te=r?await t.stat(ee):{type:Y};return await this.toFileStat(t,ee,te,d.length,r,l)}catch(ee){return this.logService.trace(ee),null}}));a.children=(0,O.coalesce)(A)}catch(d){this.logService.trace(d),a.children=[]}return a}return a}async resolveAll(t){return D.Promises.settled(t.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.withProvider(t),i=await s.stat(t);return this.toFileStat(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.withProvider(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.doValidateCreateFile(t,s)}catch(i){return i}return!0}async doValidateCreateFile(t,s){if(!s?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,T.localize)(3,null,this.resourceForError(t)),3,s)}async createFile(t,s=b.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const n=await this.writeFile(t,s);return this._onDidRunOperation.fire(new u.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,t,i)||await this.mkdirp(n,r.dirname(t));let o;if((0,u.hasReadWriteCapability)(n)&&!(s instanceof b.VSBuffer))if((0,P.isReadableStream)(s)){const a=await(0,P.peekStream)(s,3);a.ended?o=b.VSBuffer.concat(a.buffer):o=a}else o=(0,P.peekReadable)(s,a=>b.VSBuffer.concat(a),3);else o=s;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&o instanceof b.VSBuffer?await this.doWriteUnbuffered(n,t,i,o):await this.doWriteBuffered(n,t,i,o instanceof b.VSBuffer?(0,b.bufferToReadable)(o):o),this._onDidRunOperation.fire(new u.FileOperationEvent(t,4))}catch(l){throw new u.FileOperationError((0,T.localize)(4,null,this.resourceForError(t),(0,u.ensureFileSystemProviderError)(l).toString()),(0,u.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,T.localize)(5,null,this.resourceForError(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,T.localize)(6,null,this.resourceForError(s)),0,i);if(this.throwIfFileIsReadonly(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,u.etag)({mtime:i.mtime,size:r.size}))throw new u.FileOperationError((0,T.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.withReadProvider(t);return s?.atomic?this.doReadFileAtomic(n,t,s,i):this.doReadFile(n,t,s,i)}async doReadFileAtomic(t,s,i,n){return new Promise((r,l)=>{this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(t,s,i,n);r(o)}catch(o){l(o)}})})}async doReadFile(t,s,i,n){const r=await this.doReadFileStream(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,s,i)}async doReadFileStream(t,s,i,n){const r=new C.CancellationTokenSource(n),l=this.validateReadFile(s,i).then(a=>a,a=>{throw r.cancel(),a});let o;try{return typeof i?.etag=="string"&&i.etag!==u.ETAG_DISABLED&&await l,i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.readFileUnbuffered(t,s,i):(0,u.hasFileReadStreamCapability)(t)?o=this.readFileStreamed(t,s,r.token,i):o=this.readFileBuffered(t,s,r.token,i),{...await l,value:o}}catch(a){throw o&&await(0,P.consumeStream)(o),this.restoreReadError(a,s,i)}}restoreReadError(t,s,i){const n=(0,T.localize)(8,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new u.FileOperationError(n,(0,u.toFileOperationResult)(t),i)}readFileStreamed(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,P.transform)(r,{data:l=>l instanceof b.VSBuffer?l:b.VSBuffer.wrap(l),error:l=>this.restoreReadError(l,s,n)},l=>b.VSBuffer.concat(l))}readFileBuffered(t,s,i,n=Object.create(null)){const r=(0,b.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,s,r,l=>l,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:l=>this.restoreReadError(l,s,n)},i),r}readFileUnbuffered(t,s,i){const n=(0,P.newWriteableStream)(r=>b.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(s,r.byteLength,i),n.end(b.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new u.FileOperationError((0,T.localize)(9,null,this.resourceForError(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===i.etag)throw new u.NotModifiedSinceFileOperationError((0,T.localize)(10,null),i,s);return this.validateReadFileLimits(t,i.size,s),i}validateReadFileLimits(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new u.TooLargeFileOperationError((0,T.localize)(11,null,this.resourceForError(t)),n,s,i)}}async canMove(t,s,i){return this.doCanMoveCopy(t,s,"move",i)}async canCopy(t,s,i){return this.doCanMoveCopy(t,s,"copy",i)}async doCanMoveCopy(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,t,l,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),l=await this.doMoveCopy(n,t,r,s,"move",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,l==="move"?2:3,o)),o}async copy(t,s,i){const n=await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),l=await this.doMoveCopy(n,t,r,s,"copy",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,l==="copy"?3:2,o)),o}async doMoveCopy(t,s,i,n,r,l){if(s.toString()===n.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(t,s,i,n,r,l);if(o&&!a&&l&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:l});else{const d=await this.resolve(s);d.isDirectory?await this.doCopyFolder(t,d,i,n):await this.doCopyFile(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:l}),r):(await this.doMoveCopy(t,s,i,n,"copy",l),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(t,s,i,n){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,s,i,n);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,s,i,n)}async doCopyFolder(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await D.Promises.settled(s.children.map(async r=>{const l=this.getExtUri(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(t,await this.resolve(r.resource),i,l):this.doCopyFile(t,r.resource,i,l)}))}async doValidateMoveCopy(t,s,i,n,r,l){let o=!1;if(t===i){const{providerExtUri:d,isPathCaseSensitive:A}=this.getExtUri(t);if(A||(o=d.isEqual(s,n)),o&&r==="copy")throw new Error((0,T.localize)(12,null,this.resourceForError(s),this.resourceForError(n)));if(!o&&d.isEqualOrParent(n,s))throw new Error((0,T.localize)(13,null,this.resourceForError(s),this.resourceForError(n)))}const a=await this.exists(n);if(a&&!o){if(!l)throw new u.FileOperationError((0,T.localize)(14,null,this.resourceForError(s),this.resourceForError(n)),4);if(t===i){const{providerExtUri:d}=this.getExtUri(t);if(d.isEqualOrParent(s,n))throw new Error((0,T.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:a,isSameResourceWithDifferentPathCase:o}}getExtUri(t){const s=this.isPathCaseSensitive(t);return{providerExtUri:s?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,0,i)),i}async mkdirp(t,s){const i=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&u.FileType.Directory)===0)throw new Error((0,T.localize)(16,null,this.resourceForError(s)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(l){if((0,u.toFileSystemProviderErrorCode)(l)!==u.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,s){try{await this.doValidateDelete(t,s)}catch(i){return i}return!0}async doValidateDelete(t,s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,T.localize)(17,null,this.resourceForError(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.throwIfFileIsReadonly(t,r);else throw new u.FileOperationError((0,T.localize)(18,null,this.resourceForError(t)),1);if(!!!s?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,T.localize)(19,null,this.resourceForError(t)))}return i}async del(t,s){const i=await this.doValidateDelete(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,u.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s));const r=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===n&&(0,u.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.doCopyFile(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,c.toDisposable)(()=>r())),(async()=>{try{const l=await this.doWatch(t,s);n?(0,c.dispose)(l):r=()=>(0,c.dispose)(l)}catch(l){this.logService.error(l)}})(),i}async doWatch(t,s){const i=await this.withProvider(t),n=(0,E.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),s]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.activeWatchers.set(n,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,c.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,s,i,n){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,P.isReadableStream)(n)||(0,P.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,r,n):await this.doWriteReadableBufferedQueued(t,r,n)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await t.close(r)}})}async doWriteStreamBufferedQueued(t,s,i){let n=0,r;if((0,P.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=b.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,s,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,o)=>{(0,P.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(t,s,a,a.byteLength,n,0)}catch(d){return o(d)}n+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>o(a),onEnd:()=>l()})})}async doWriteReadableBufferedQueued(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(t,s,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(t,s,i,n,r,l){let o=0;for(;o<n;)o+=await t.write(s,r+o,i.buffer,l+o,n-o)}async doWriteUnbuffered(t,s,i,n){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,s,i,n))}async doWriteUnbufferedQueued(t,s,i,n){let r;n instanceof b.VSBuffer?r=n:(0,P.isReadableStream)(n)?r=await(0,b.streamToBuffer)(n):(0,P.isReadableBufferedStream)(n)?r=await(0,b.bufferedStreamToBuffer)(n):r=(0,b.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(t,s,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,s,i,n))}async doPipeBufferedQueued(t,s,i,n){let r,l;try{r=await t.open(s,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const o=b.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,d=0,A=0;do A=await t.read(r,a,o.buffer,d,o.byteLength-d),await this.doWriteBuffer(i,l,o,A,a,d),a+=A,d+=A,d===o.byteLength&&(d=0);while(A>0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await D.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async doPipeUnbuffered(t,s,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,s,i,n))}async doPipeUnbufferedQueued(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(t,s,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,s,i,n))}async doPipeUnbufferedToBufferedQueued(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await t.readFile(s);await this.doWriteBuffer(i,r,b.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(t,s,i,n){const r=await(0,b.streamToBuffer)(this.readFileBuffered(t,s,C.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,r)}throwIfFileSystemIsReadonly(t,s){if(t.capabilities&2048)throw new u.FileOperationError((0,T.localize)(20,null,this.resourceForError(s)),6);return t}throwIfFileIsReadonly(t,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,T.localize)(21,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===S.Schemas.file?t.fsPath:t.toString(!0)}};p=he([J(0,v.ILogService)],p),e.FileService=p}),define(Q[118],Z([0,1,119,160,5,34,14,4,161,2,15,12,18,43,20,97,13,61,115,33,113,112]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v,y,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(O)}catch(s){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(s)}`)}})();class t extends v.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new C.ResourceMap(r=>h.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await P.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await P.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async l=>{try{let o;l.isSymbolicLink()?o=(await this.stat((0,h.joinPath)(i,l.name))).type:o=this.toType(l),r.push([l.name,o])}catch(o){this.logService.trace(o)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=u.FileType.Unknown:i.isFile()?r=u.FileType.File:i.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,n&&(r|=u.FileType.SymbolicLink),r}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const l=new b.Barrier;return this.resourceLocks.set(i,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const l=this.toFilePath(i);return await P.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{r?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,r){const l=(0,m.newWriteableStream)(o=>R.VSBuffer.concat(o.map(a=>R.VSBuffer.wrap(a))).buffer);return(0,f.readFileIntoStream)(this,i,l,o=>o.buffer,{...n,bufferSize:256*1024},r),l}async writeFile(i,n,r){let l;try{const o=this.toFilePath(i);if(!r.create||!r.overwrite){if(await P.Promises.exists(o)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,T.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,T.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(i,o)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,n){const r=this.toFilePath(i);let l;(0,u.isFileOpenForWriteOptions)(n)&&(l=await this.createResourceLock(i));let o;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:d}=await P.SymlinkSupport.stat(r);d.mode&128||await P.Promises.chmod(r,d.mode|128)}catch(d){this.logService.trace(d)}let a;if((0,u.isFileOpenForWriteOptions)(n)){if(S.isWindows)try{await P.Promises.truncate(r,0),a="r+"}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}a||(a="w")}else a="r";o=await P.Promises.open(r,a)}catch(a){throw l?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,a):this.toFileSystemProviderError(a)}if(this.mapHandleToPos.set(o,0),(0,u.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,i),l){const a=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.mapHandleToLock.set(o,l),a&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),a.dispose())}return o}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await P.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await P.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,l,o){const a=this.normalizePos(i,n);let d=null;try{d=(await P.Promises.read(i,r,l,o,a)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(i,a,d)}return d}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const l=this.mapHandleToPos.get(i);typeof l=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,l+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,l,o){return(0,b.retry)(()=>this.doWrite(i,n,r,l,o),100,3)}async doWrite(i,n,r,l,o){const a=this.normalizePos(i,n);let d=null;try{d=(await P.Promises.write(i,r,l,o,a)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),A)}finally{this.updatePos(i,a,d)}return d}async mkdir(i){try{await P.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);n.recursive?await P.Promises.rm(r,P.RimRafMode.MOVE):await P.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,n,r){const l=this.toFilePath(i),o=this.toFilePath(n);if(l!==o)try{await this.validateTargetDeleted(i,n,"move",r.overwrite),await P.Promises.move(l,o)}catch(a){throw(a.code==="EINVAL"||a.code==="EBUSY"||a.code==="ENAMETOOLONG")&&(a=new Error((0,T.localize)(2,null,(0,I.basename)(l),(0,I.basename)((0,I.dirname)(o)),a.toString()))),this.toFileSystemProviderError(a)}}async copy(i,n,r){const l=this.toFilePath(i),o=this.toFilePath(n);if(l!==o)try{await this.validateTargetDeleted(i,n,"copy",r.overwrite),await P.Promises.copy(l,o,{preserveSymlinks:!0})}catch(a){throw(a.code==="EINVAL"||a.code==="EBUSY"||a.code==="ENAMETOOLONG")&&(a=new Error((0,T.localize)(3,null,(0,I.basename)(l),(0,I.basename)((0,I.dirname)(o)),a.toString()))),this.toFileSystemProviderError(a)}}async validateTargetDeleted(i,n,r,l){const o=this.toFilePath(i),a=this.toFilePath(n);let d=!1;if(!!(this.capabilities&1024)||(d=(0,g.isEqual)(o,a,!0)),d&&r==="copy")throw(0,u.createFileSystemProviderError)((0,T.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!d&&await P.Promises.exists(a)){if(!l)throw(0,u.createFileSystemProviderError)((0,T.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,r){const l=this.toFilePath(i),o=this.toFilePath(n),a=!!(this.capabilities&1024);if((0,g.isEqual)(l,o,!a))return;const d=new c.DisposableStore;try{const[A,V]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);d.add(A),d.add(V),r&&await P.Promises.mkdir((0,I.dirname)(o),{recursive:!0}),await P.Promises.copyFile(l,o)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(A)}finally{d.dispose()}}createUniversalWatcher(i,n,r){return new p.UniversalWatcherClient(l=>i(l),l=>n(l),r)}createNonRecursiveWatcher(i,n,r){return new w.NodeJSWatcherClient(l=>i(l),l=>n(l),r)}toFileSystemProviderError(i){if(i instanceof u.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.toFilePath(i));l.mode&128||(r=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return r}}t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0,e.DiskFileSystemProvider=t}),define(Q[120],Z([0,1,2,6]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class b extends O.Disposable{constructor(R,E=[]){super(),this.logger=new D.MultiplexLogger([R,...E]),this._register(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...E){this.logger.trace(R,...E)}debug(R,...E){this.logger.debug(R,...E)}info(R,...E){this.logger.info(R,...E)}warn(R,...E){this.logger.warn(R,...E)}error(R,...E){this.logger.error(R,...E)}flush(){this.logger.flush()}}e.LogService=b}),define(Q[121],Z([0,1,13,6]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var b;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(b||(b={}));async function C(c,I,S,h,m){try{const P=await new Promise((u,f)=>{$(["spdlog"],u,f)});P.setFlushOn(b.Trace);const T=await P.createAsyncRotatingLogger(c,I,S,h);return m?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(P){console.error(P)}return null}function R(c,I,S){switch(I){case D.LogLevel.Trace:c.trace(S);break;case D.LogLevel.Debug:c.debug(S);break;case D.LogLevel.Info:c.info(S);break;case D.LogLevel.Warning:c.warn(S);break;case D.LogLevel.Error:c.error(S);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function E(c,I){switch(I){case D.LogLevel.Trace:c.setLevel(b.Trace);break;case D.LogLevel.Debug:c.setLevel(b.Debug);break;case D.LogLevel.Info:c.setLevel(b.Info);break;case D.LogLevel.Warning:c.setLevel(b.Warning);break;case D.LogLevel.Error:c.setLevel(b.Error);break;case D.LogLevel.Off:c.setLevel(b.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class g extends D.AbstractMessageLogger{constructor(I,S,h,m,P){super(),this.buffer=[],this.setLevel(P),this._loggerCreationPromise=this._createSpdLogLogger(I,S,h,m),this._register(this.onDidChangeLogLevel(T=>{this._logger&&E(this._logger,T)}))}async _createSpdLogLogger(I,S,h,m){const P=h?6:1,T=30/P*O.ByteSize.MB,u=await C(I,S,T,P,m);if(u){this._logger=u,E(this._logger,this.getLevel());for(const{level:f,message:v}of this.buffer)R(this._logger,f,v);this.buffer=[]}}log(I,S){this._logger?R(this._logger,I,S):this.getLevel()<=I&&this.buffer.push({level:I,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=g}),define(Q[38],Z([0,1,4,65,2,10]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class R extends b.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),D.Iterable.reduce(this.policies.entries(),(S,[h,m])=>({...S,[h]:m}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[I,S])=>({...c,[I]:{definition:S,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=R;class E{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(Q[122],Z([0,1,5,4,65,3,13,6,38]),function($,e,O,D,b,C,R,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(S,h){const m=[];for(const P of new Set(b.Iterable.concat(S.keys(),h.keys())))S.get(P)!==h.get(P)&&m.push(P);return m}let I=class extends g.AbstractPolicyService{constructor(h,m,P){super(),this.file=h,this.fileService=m,this.logService=P,this.throttledDelayer=this._register(new O.ThrottledDelayer(500));const T=D.Event.filter(m.onDidFilesChange,u=>u.affects(h));this._register(m.watch(h)),this._register(T(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const h=new Map;try{const m=await this.fileService.readFile(this.file),P=JSON.parse(m.value.toString());if(!(0,C.isObject)(P))throw new Error("Policy file isn't a JSON object");for(const T of Object.keys(P))this.policyDefinitions[T]&&h.set(T,P[T])}catch(m){m.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",m)}return h}async refresh(){const h=await this.read(),m=c(this.policies,h);this.policies=h,m.length>0&&this._onDidChange.fire(m)}};I=he([J(1,R.IFileService),J(2,E.ILogService)],I),e.FilePolicyService=I}),define(Q[123],Z([0,1,38,5,162,2,6]),function($,e,O,D,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let E=class extends O.AbstractPolicyService{constructor(c,I){super(),this.logService=c,this.productName=I,this.throttler=new D.Throttler,this.watcher=this._register(new C.MutableDisposable)}async _updatePolicyDefinitions(c){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.throttler.queue(()=>new Promise((I,S)=>{try{this.watcher.value=(0,b.createWatcher)(this.productName,c,h=>{this._onDidPolicyChange(h),I()})}catch(h){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),S(h)}}))}_onDidPolicyChange(c){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const I in c){const S=c[I];S===void 0?this.policies.delete(I):this.policies.set(I,S)}this._onDidChange.fire(Object.keys(c))}};E=he([J(0,R.ILogService)],E),e.NativePolicyService=E}),define(Q[31],Z([0,1,10]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[35],Z([0,1,70,3]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(R,E){O.ok(D.isString(R)),O.ok(D.isObject(E)),O.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,E)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new b}),define(Q[124],Z([0,1,4,35]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class C{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,c){this.schemasById[b(g)]=c,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;D.Registry.add(e.Extensions.JSONContribution,R)}),define(Q[42],Z([0,1,19,4,3,86,24,124,35]),function($,e,O,D,b,C,R,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=g.Registry.as(E.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.doRegisterConfigurations(t,s,i),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.doDeregisterConfigurations(t,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.doDeregisterConfigurations(s,i),this.doRegisterConfigurations(t,!1,i),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.doRegisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const l in n)if(s.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const o=this.configurationDefaultsOverrides.get(l),a=o?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[l]))a.set(Y,r);const d={...o?.value||{},...n[l]};this.configurationDefaultsOverrides.set(l,{source:r,value:d,valuesSources:a});const A=(0,R.getLanguageTagSettingPlainKey)(l),V={type:"object",default:d,description:C.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:b.isString(r)?void 0:r,defaultValueSource:r};i.push(...T(l)),this.configurationProperties[l]=V,this.defaultLanguageConfigurationOverridesNode.properties[l]=V}else{this.configurationDefaultsOverrides.set(l,{value:n[l],source:r});const o=this.configurationProperties[l];o&&(this.updatePropertyDefaultValue(l,o),this.updateSchema(l,o))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const s=new Set;this.doDeregisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const l=this.configurationDefaultsOverrides.get(r),o=b.isString(n)?n:n?.id,a=b.isString(l?.source)?l?.source:l?.source?.id;if(o===a)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const d=this.configurationProperties[r];d&&(this.updatePropertyDefaultValue(r,d),this.updateSchema(r,d))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const s of t)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,s,i){t.forEach(n=>{this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const l=this.configurationProperties[r];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,s=!0,i,n,r=3,l){r=b.isUndefinedOrNull(t.scope)?r:t.scope;const o=t.properties;if(o)for(const d in o){const A=o[d];if(s&&y(d,A)){delete o[d];continue}if(A.source=i,A.defaultDefaultValue=o[d].default,this.updatePropertyDefaultValue(d,A),e.OVERRIDE_PROPERTY_REGEX.test(d)?A.scope=void 0:(A.scope=b.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=b.isUndefinedOrNull(A.restricted)?!!n?.includes(d):A.restricted),o[d].hasOwnProperty("included")&&!o[d].included){this.excludedConfigurationProperties[d]=o[d],delete o[d];continue}else this.configurationProperties[d]=o[d],o[d].policy?.name&&this.policyConfigurations.set(o[d].policy.name,d);!o[d].deprecationMessage&&o[d].markdownDeprecationMessage&&(o[d].deprecationMessage=o[d].markdownDeprecationMessage),l.add(d)}const a=t.allOf;if(a)for(const d of a)this.validateAndRegisterProperties(d,s,i,n,r,l)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const s=i=>{const n=i.properties;if(n)for(const l in n)this.updateSchema(l,n[l]);i.allOf?.forEach(s)};s(t)}updateSchema(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.resourceLanguageSettingsSchema.properties[t]=s;break}}removeFromSchema(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const s=`[${t}]`,i={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,s){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,r=i?.source;b.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),b.isUndefined(n)&&(n=f(s.type)),s.default=n,s.defaultValueSource=r}}const m="\\[([^\\]]+)\\]",P=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function T(w){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let s=P.exec(w);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=P.exec(w)}}return(0,O.distinct)(t)}e.overrideIdentifiersFromKey=T;function u(w){return w.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=u;function f(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new h;g.Registry.add(e.Extensions.Configuration,v);function y(w,t){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?C.localize(7,null,w):v.getConfigurationProperties()[w]!==void 0?C.localize(8,null,w):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,w,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=y;function p(){const w=[],t=v.getConfigurationProperties();for(const s of Object.keys(t))w.push([s,t[s].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(Q[66],Z([0,1,19,4,50,2,34,28,3,11,24,42,35]),function($,e,O,D,b,C,R,E,g,c,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(s){return Object.isFrozen(s)?s:E.deepFreeze(s)}class P{constructor(i={},n=[],r=[],l){this._contents=i,this._keys=n,this._overrides=r,this.raw=l,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof P)return n;const r=new T("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),l=n?this.rawConfiguration.getOverrideValue(i,n):void 0,o=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:l,merged:o}}getOverrideValue(i,n){const r=this.getContentsForOverrideIdentifer(n);return r?i?(0,I.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return O.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return O.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=E.deepClone(this.contents),r=E.deepClone(this.overrides),l=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const a of i)if(o.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(n,a.contents);for(const d of a.overrides){const[A]=r.filter(V=>O.equals(V.identifiers,d.identifiers));A?(this.mergeContents(A.contents,d.contents),A.keys.push(...d.keys),A.keys=O.distinct(A.keys)):r.push(E.deepClone(d))}for(const d of a.keys)l.indexOf(d)===-1&&l.push(d)}return new P(n,l,r,o.every(a=>a instanceof P)?void 0:o)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const l of O.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[l];const a=n[l];a&&(typeof o=="object"&&typeof a=="object"?(o=E.deepClone(o),this.mergeContents(o,a)):o=a),r[l]=o}return new P(r,this.keys,this.overrides)}mergeContents(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.mergeContents(i[r],n[r]);continue}i[r]=E.deepClone(n[r])}}getContentsForOverrideIdentifer(i){let n=null,r=null;const l=o=>{o&&(r?this.mergeContents(r,o):r=E.deepClone(o))};for(const o of this.overrides)O.equals(o.identifiers,[i])?n=o.contents:o.identifiers.includes(i)&&l(o.contents);return l(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,I.removeFromValueTree)(this.contents,i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>O.equals(r.identifiers,(0,S.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,r){(0,I.addToValueTree)(this.contents,i,n,l=>console.error(l)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,I.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=P;class T{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:r,keys:l,overrides:o,restricted:a,hasExcludedProperties:d}=this.doParseRaw(i,n);this._configurationModel=new P(r,l,o,d?[i]:void 0),this._restrictedConfigurations=a||[]}doParseContent(i){let n={},r=null,l=[];const o=[],a=[];function d(V){Array.isArray(l)?l.push(V):r!==null&&(l[r]=V)}const A={onObjectBegin:()=>{const V={};d(V),o.push(l),l=V,r=null},onObjectProperty:V=>{r=V},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const V=[];d(V),o.push(l),l=V,r=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:d,onError:(V,Y,ee)=>{a.push({error:V,offset:Y,length:ee})}};if(i)try{b.visit(i,A),n=l[0]||{}}catch(V){console.error(`Error while parsing settings file ${this._name}: ${V}`),this._parseErrors=[V]}return n}doParseRaw(i,n){const r=h.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),l=this.filter(i,r,!0,n);i=l.raw;const o=(0,I.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),a=Object.keys(i),d=this.toOverrides(i,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:o,keys:a,overrides:d,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(i,n,r,l){let o=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const a={},d=[];for(const A in i)if(S.OVERRIDE_PROPERTY_REGEX.test(A)&&r){const V=this.filter(i[A],n,!1,l);a[A]=V.raw,o=o||V.hasExcludedProperties,d.push(...V.restricted)}else{const V=n[A],Y=V?typeof V.scope<"u"?V.scope:3:void 0;V?.restricted&&d.push(A),(Y===void 0||l.scopes===void 0||l.scopes.includes(Y))&&!(l.skipRestricted&&V?.restricted)?a[A]=i[A]:o=!0}return{raw:a,restricted:d,hasExcludedProperties:o}}toOverrides(i,n){const r=[];for(const l of Object.keys(i))if(S.OVERRIDE_PROPERTY_REGEX.test(l)){const o={};for(const a in i[l])o[a]=i[l][a];r.push({identifiers:(0,S.overrideIdentifiersFromKey)(l),keys:Object.keys(o),contents:(0,I.toValuesTree)(o,n)})}return r}}e.ConfigurationModelParser=T;class u extends C.Disposable{constructor(i,n,r,l){super(),this.userSettingsResource=i,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new T(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class f{constructor(i,n,r,l,o,a,d,A,V,Y,ee,te,ne){this.key=i,this.overrides=n,this._value=r,this.overrideIdentifiers=l,this.defaultConfiguration=o,this.policyConfiguration=a,this.applicationConfiguration=d,this.userConfiguration=A,this.localUserConfiguration=V,this.remoteUserConfiguration=Y,this.workspaceConfiguration=ee,this.folderConfigurationModel=te,this.memoryConfigurationModel=ne}get value(){return m(this._value)}inspect(i,n,r){const l=i.inspect(n,r);return{get value(){return m(l.value)},get override(){return m(l.override)},get merged(){return m(l.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class v{constructor(i,n,r,l,o=new P,a=new P,d=new R.ResourceMap,A=new P,V=new R.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=l,this._remoteUserConfiguration=o,this._workspaceConfiguration=a,this._folderConfigurations=d,this._memoryConfiguration=A,this._memoryConfigurationByResource=V,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,n,r){return this.getConsolidatedConfigurationModel(i,n,r).getValue(i)}updateValue(i,n,r={}){let l;r.resource?(l=this._memoryConfigurationByResource.get(r.resource),l||(l=new P,this._memoryConfigurationByResource.set(r.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(i):l.setValue(i,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,r){const l=this.getConsolidatedConfigurationModel(i,n,r),o=this.getFolderConfigurationModelForResource(n.resource,r),a=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,d=new Set;for(const A of l.overrides)for(const V of A.identifiers)l.getOverrideValue(i,V)!==void 0&&d.add(V);return new f(i,n,l.getValue(i),d.size?[...d]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,o||void 0,a)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:l,updated:o,removed:a}=w(this._defaultConfiguration,i);n=[...l,...o,...a]}for(const l of n)for(const o of(0,S.overrideIdentifiersFromKey)(l)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(o),d=i.getKeysForOverrideIdentifier(o),A=[...d.filter(V=>a.indexOf(V)===-1),...a.filter(V=>d.indexOf(V)===-1),...a.filter(V=>!E.equals(this._defaultConfiguration.override(o).getValue(V),i.override(o).getValue(V)))];r.push([o,A])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:l}=w(this._policyConfiguration,i),o=[...n,...r,...l];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:l,overrides:o}=w(this.applicationConfiguration,i),a=[...n,...r,...l];return a.length&&this.updateApplicationConfiguration(i),{keys:a,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:l,overrides:o}=w(this.localUserConfiguration,i),a=[...n,...r,...l];return a.length&&this.updateLocalUserConfiguration(i),{keys:a,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:l,overrides:o}=w(this.remoteUserConfiguration,i),a=[...n,...r,...l];return a.length&&this.updateRemoteUserConfiguration(i),{keys:a,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:l,overrides:o}=w(this.workspaceConfiguration,i),a=[...n,...r,...l];return a.length&&this.updateWorkspaceConfiguration(i),{keys:a,overrides:o}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:l,updated:o,removed:a,overrides:d}=w(r,n),A=[...l,...o,...a];return(A.length||!r)&&this.updateFolderConfiguration(i,n),{keys:A,overrides:d}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:l,removed:o,overrides:a}=w(n,void 0);return{keys:[...r,...l,...o],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,r){let l=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:i},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const l=n.getFolder(i);l&&(r=this.getFolderConsolidatedConfiguration(l.uri)||r);const o=this._memoryConfigurationByResource.get(i);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(i);l?(n=r.merge(l),this._foldersConsolidatedConfigurations.set(i,n)):n=r}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:r,overrides:l,keys:o}=this._folderConfigurations.get(n);return i.push([n,{contents:r,overrides:l,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.policy),l=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),a=this.parseConfigurationModel(i.workspace),d=i.folders.reduce((A,V)=>(A.set(c.URI.revive(V[0]),this.parseConfigurationModel(V[1])),A),new R.ResourceMap);return new v(n,r,l,o,new P,a,d,new P,new R.ResourceMap)}static parseConfigurationModel(i){return new P(i.contents,i.keys,i.overrides)}}e.Configuration=v;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const l of s)l.keys.forEach(o=>i.add(o)),l.overrides.forEach(([o,a])=>{const d=(0,R.getOrSet)(n,o,new Set);a.forEach(A=>d.add(A))});const r=[];return n.forEach((l,o)=>r.push([o,[...l.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=y;class p{constructor(i,n,r,l){this.change=i,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=l,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const a of o)this.affectedKeys.add(a);this._affectsConfigStr=this._marker;for(const o of this.affectedKeys)this._affectsConfigStr+=o+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){const r=this._marker+i,l=this._affectsConfigStr.indexOf(r);if(l<0)return!1;const o=l+r.length;if(o>=this._affectsConfigStr.length)return!1;const a=this._affectsConfigStr.charCodeAt(o);if(a!==this._markerCode1&&a!==this._markerCode2)return!1;if(n){const d=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,A=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!E.equals(d,A)}return!0}}e.ConfigurationChangeEvent=p;function w(s,i){const{added:n,removed:r,updated:l}=t(i?.rawConfiguration,s?.rawConfiguration),o=[],a=s?.getAllOverrideIdentifiers()||[],d=i?.getAllOverrideIdentifiers()||[];if(i){const A=d.filter(V=>!a.includes(V));for(const V of A)o.push([V,i.getKeysForOverrideIdentifier(V)])}if(s){const A=a.filter(V=>!d.includes(V));for(const V of A)o.push([V,s.getKeysForOverrideIdentifier(V)])}if(i&&s){for(const A of a)if(d.includes(A)){const V=t({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});o.push([A,[...V.added,...V.removed,...V.updated]])}}return{added:n,removed:r,updated:l,overrides:o}}function t(s,i){const n=s?i?s.keys.filter(o=>i.keys.indexOf(o)===-1):[...s.keys]:[],r=i?s?i.keys.filter(o=>s.keys.indexOf(o)===-1):[...i.keys]:[],l=[];if(s&&i){for(const o of i.keys)if(s.keys.indexOf(o)!==-1){const a=(0,I.getConfigurationValue)(i.contents,o),d=(0,I.getConfigurationValue)(s.contents,o);E.equals(a,d)||l.push(o)}}return{added:n,removed:r,updated:l}}}),define(Q[125],Z([0,1,19,4,2,28,3,66,42,6,38,35]),function($,e,O,D,b,C,R,E,g,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class h extends b.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(S.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(u),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(u,f){this.updateConfigurationModel(u,S.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new E.ConfigurationModel;const u=S.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(u),u)}updateConfigurationModel(u,f){const v=this.getConfigurationDefaultOverrides();for(const y of u){const p=v[y],w=f[y];p!==void 0?this._configurationModel.addValue(y,p):w?this._configurationModel.addValue(y,w.default):this._configurationModel.removeValue(y)}}}e.DefaultConfiguration=h;class m{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let P=class extends b.Disposable{get configurationModel(){return this._configurationModel}constructor(u,f,v){super(),this.defaultConfiguration=u,this.policyService=f,this.logService=v,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.updatePolicyDefinitions(u),!0))),this._configurationModel}async updatePolicyDefinitions(u){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",u);const f={},v=[],y=S.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const p of u){const w=y[p];if(!w){v.push(p);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.logService.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}v.push(p),f[w.policy.name]={type:w.type}}}return(0,R.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),v}onDidChangePolicies(u){this.logService.trace("PolicyConfiguration#onDidChangePolicies",u);const f=S.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),v=(0,O.coalesce)(u.map(y=>f.get(y)));this.update(v,!0)}update(u,f){this.logService.trace("PolicyConfiguration#update",u);const v=S.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),y=[],p=this._configurationModel.isEmpty();for(const w of u){const t=v[w]?.policy?.name;if(t){const s=this.policyService.getPolicyValue(t);(p?s!==void 0:!(0,C.equals)(this._configurationModel.getValue(w),s))&&y.push([w,s])}else this._configurationModel.getValue(w)!==void 0&&y.push([w,void 0])}if(y.length){this.logService.trace("PolicyConfiguration#changed",y);const w=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of w.keys)this._configurationModel.setValue(t,w.getValue(t));for(const[t,s]of y)s===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,s);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};P=he([J(1,I.IPolicyService),J(2,c.ILogService)],P),e.PolicyConfiguration=P}),define(Q[126],Z([0,1,5,4,2,18,24,66,125,38]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends b.Disposable{constructor(h,m,P,T){super(),this.settingsResource=h,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration),this.policyConfiguration=P instanceof c.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,P,T)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,m)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:u,properties:f})=>this.onDidDefaultConfigurationChange(u,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(u=>this.onDidPolicyConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,m,P]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(h,m,new E.ConfigurationModel,P)}getConfigurationData(){return this.configuration.toData()}getValue(h,m){const P=typeof h=="string"?h:void 0,T=(0,R.isConfigurationOverrides)(h)?h:(0,R.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(P,T,void 0)}updateValue(h,m,P,T){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const m=this.configuration.toData(),P=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(P,m,2)}onDidDefaultConfigurationChange(h,m){const P=this.configuration.toData(),T=this.configuration.compareAndUpdateDefaultConfiguration(h,m);this.trigger(T,P,7)}onDidPolicyConfigurationChange(h){const m=this.configuration.toData(),P=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(P,m,7)}trigger(h,m,P){const T=new E.ConfigurationChangeEvent(h,{data:m},this.configuration);T.source=P,T.sourceConfig=this.getTargetConfiguration(P),this._onDidChangeConfiguration.fire(T)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Q[67],Z([0,1,16]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(c){return c.scheme===O.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=D;function b(c){if(!c)return;const I=c.indexOf("+");return I<0?c:c.substr(0,I)}e.getRemoteName=b;function C(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=C;function R(c){const{host:I,port:S}=g(c);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:S}}e.parseAuthorityWithPort=R;function E(c,I){let{host:S,port:h}=g(c);return typeof h>"u"&&(h=I),{host:S,port:h}}e.parseAuthorityWithOptionalPort=E;function g(c){const I=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const S=c.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const h=c.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:c,port:void 0}}}),define(Q[32],Z([0,1,30,10,67]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var E;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,T){if(typeof P>"u"||P===null)return typeof T>"u"||T===null;if(typeof T>"u"||T===null)return!1;if(typeof P=="string"||typeof T=="string"){const u=typeof P=="string"?P:P.value,f=typeof T=="string"?T:T.value;return O.equalsIgnoreCase(u,f)}return P._lower===T._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=g;function c(m){return I(m)}e.isApplicationScopedExtension=c;function I(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function S(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function h(m,P){if(P){const T=`onResolveRemoteAuthority:${(0,b.getRemoteName)(P)}`;return!!m.activationEvents?.includes(T)}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[127],Z([0,1,2,15,20,32]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class R extends O.Disposable{constructor(g,c){super(),this.environmentService=g,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(c.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(c.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(g){g.some(c=>!!c.local)&&this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=R}),define(Q[46],Z([0,1,14,99,42,10,35]),function($,e,O,D,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function E(T){return T.res.statusCode&&T.res.statusCode>=200&&T.res.statusCode<300||T.res.statusCode===1223}e.isSuccess=E;function g(T){return T.res.statusCode===204}async function c(T){return g(T)?null:(await(0,O.streamToBuffer)(T.stream)).toString()}e.asText=c;async function I(T){if(!E(T))throw new Error("Server returned "+T.res.statusCode);return c(T)}e.asTextOrError=I;async function S(T){if(!E(T))throw new Error("Server returned "+T.res.statusCode);if(g(T))return null;const f=(await(0,O.streamToBuffer)(T.stream)).toString();try{return JSON.parse(f)}catch(v){throw v.message+=`:
`+f,v}}e.asJson=S;function h(T){P(T)}e.updateProxyConfigurationsScope=h;let m;function P(T){const u=R.Registry.as(b.Extensions.Configuration),f=m;m={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:T,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[m],remove:f?[f]:[]})}P(2)}),define(Q[128],Z([0,1,23,16,13,46]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let R=class{constructor(g,c){this.requestService=g,this.fileService=c}async download(g,c,I=O.CancellationToken.None){if(g.scheme===D.Schemas.file||g.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(g,c);return}const S={type:"GET",url:g.toString(!0)},h=await this.requestService.request(S,I);if(h.res.statusCode===200)await this.fileService.writeFile(c,h.stream);else{const m=await(0,C.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${m}`)}}};R=he([J(0,C.IRequestService),J(1,b.IFileService)],R),e.DownloadService=R}),define(Q[129],Z([0,1,130,3]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function b(R,E){return R.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:R.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function C(R,E,g={}){const c=(0,O.parse)(R),I=g.proxyUrl||b(c,E);if(!I)return null;const S=(0,O.parse)(I);if(!/^https?:$/.test(S.protocol||""))return null;const h={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((m,P)=>{$(["http-proxy-agent"],m,P)}))(h):new(await new Promise((m,P)=>{$(["https-proxy-agent"],m,P)}))(h)}e.getProxyAgent=C}),define(Q[131],Z([0,1,58,15,100,23,33,7,12,29,82,163,5,71]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let P;async function T(f,v,y,p){return y["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(p)&&!y["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(p)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),P||(P=h.Promises.withAsyncBody(async(w,t)=>{const s=new C.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,m.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,b.localize)(0,null)))},i);try{w(await u(v,s.token))}catch(l){!(0,E.isCancellationError)(l)&&!s.token.isCancellationRequested?t(new Error((0,b.localize)(1,null,(0,R.toErrorMessage)(l)))):w({})}finally{clearTimeout(r),s.dispose()}})),P)}e.getResolvedShellEnv=T;async function u(f,v){const y=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",y);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",p);const w=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(w+"({.*})"+w),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,I.getSystemShell)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(v.isCancellationRequested)return r(new E.CancellationError);const l=(0,D.basename)(i);let o,a;const d=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(o=`& '${process.execPath}' ${d} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,a=["-Login","-Command"]):(o=`'${process.execPath}' ${d} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,l==="tcsh"||l==="csh"?a=["-ic"]:a=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(a),o);const A=(0,O.spawn)(i,[...a,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(A.kill(),r(new E.CancellationError))),A.on("error",ee=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(ee)),r(ee)});const V=[];A.stdout.on("data",ee=>V.push(ee));const Y=[];A.stderr.on("data",ee=>Y.push(ee)),A.on("close",(ee,te)=>{const ne=Buffer.concat(V).toString("utf8");f.trace("getUnixShellEnvironment#raw",ne);const ie=Buffer.concat(Y).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),ee||te)return r(new Error((0,b.localize)(2,null,ee,te)));const ae=t.exec(ne),fe=ae?ae[1]:"{}";try{const oe=JSON.parse(fe);y?oe.ELECTRON_RUN_AS_NODE=y:delete oe.ELECTRON_RUN_AS_NODE,p?oe.ELECTRON_NO_ATTACH_CONSOLE=p:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",oe),n(oe)}catch(oe){f.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(oe)),r(oe)}})})}}),define(Q[132],Z([0,1,10]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,O.createDecorator)("stateReadService"),e.IStateService=(0,O.createDecorator)("stateService")}),define(Q[68],Z([0,1,5,14,3,17,13,6]),function($,e,O,D,b,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var g;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(g=e.SaveStrategy||(e.SaveStrategy={}));class c{constructor(m,P,T,u){this.storagePath=m,this.logService=T,this.fileService=u,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=P===0?void 0:new O.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}}getItem(m,P){const T=this.storage[m];return(0,b.isUndefinedOrNull)(T)?P:T}setItem(m,P){this.setItems([{key:m,data:P}])}setItems(m){let P=!1;for(const{key:T,data:u}of m)this.storage[T]!==u&&((0,b.isUndefinedOrNull)(u)?(0,b.isUndefined)(this.storage[T])||(this.storage[T]=void 0,P=!0):(this.storage[T]=u,P=!0));P&&this.save()}removeItem(m){(0,b.isUndefined)(this.storage[m])||(this.storage[m]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const m=JSON.stringify(this.storage,null,4);if(m!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(m)),this.lastSavedStorageContents=m}catch(P){this.logService.error(P)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=c;let I=class{constructor(m,P,T,u){this.fileStorage=new c(P.stateResource,m,T,u)}async init(){await this.fileStorage.init()}getItem(m,P){return this.fileStorage.getItem(m,P)}};I=he([J(1,C.IEnvironmentService),J(2,E.ILogService),J(3,R.IFileService)],I),e.StateReadonlyService=I;class S extends I{setItem(m,P){this.fileStorage.setItem(m,P)}setItems(m){this.fileStorage.setItems(m)}removeItem(m){this.fileStorage.removeItem(m)}close(){return this.fileStorage.close()}}e.StateService=S}),define(Q[69],Z([0,1,12,37,11,29]),function($,e,O,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(c){if(O.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function E(c,I,S,h,m,P,T,u,f,v){const y=Object.create(null);y["common.machineId"]=T,y.sessionID=(0,C.generateUuid)()+Date.now(),y.commitHash=m,y.version=P,y["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,O.PlatformToString)(O.platform),y["common.nodePlatform"]=D.platform,y["common.nodeArch"]=h,y["common.product"]=v||"desktop",u&&(y["common.msftInternal"]=u);let p=0;const w=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),O.isLinuxSnap&&(y["common.snap"]="true");const t=R(S);t&&(y["common.platformDetail"]=t);try{const s=await c.readFile(b.URI.file(f));y["common.source"]=s.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=E;function g(c){const I=D.env.USERDNSDOMAIN;if(!I)return!1;const S=I.toLowerCase();return c.some(h=>S===h)}e.verifyMicrosoftInternalDomain=g}),define(Q[25],Z([0,1,10]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var b;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(b=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[39],Z([0,1,28,3,4,24,67,69,25]),function($,e,O,D,b,C,R,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(r){this.value=r}}e.TelemetryTrustedValue=c;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,l){return Promise.resolve(void 0)}publicLog2(r,l){return this.publicLog(r,l)}publicLogError(r,l){return Promise.resolve(void 0)}publicLogError2(r,l){return this.publicLogError(r,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class S{async publicLog(r,l,o){}async publicLogError(r,l,o){}}e.NullEndpointTelemetryService=S,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(n,r){return b.Event.debounce(r.onDidChangeConfiguration,(o,a)=>{const d=o?new Set([...o.affectedKeys,...a.affectedKeys]):a.affectedKeys;return{...a,affectedKeys:d}},1e3,!0)(o=>{o.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.configurationTelemetry=h;function m(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=m;function P(n,r){return!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=P;function T(n){const r=n.getValue(g.TELEMETRY_SETTING_ID),l=n.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=T;function u(n){const r={},l={},o={};y(n,o);for(let a in o){a=a.length>150?a.substr(a.length-149):a;const d=o[a];typeof d=="number"?l[a]=d:typeof d=="boolean"?l[a]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${d.length}`),r[a]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(r[a]=d)}return{properties:r,measurements:l}}e.validateTelemetryData=u;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(n){if(!n)return"none";const r=(0,R.getRemoteName)(n);return f.has(r)?r:"other"}e.cleanRemoteAuthority=v;function y(n,r,l=0,o){if(!!n)for(const a of Object.getOwnPropertyNames(n)){const d=n[a],A=o?o+a:a;Array.isArray(d)?r[A]=(0,O.safeStringify)(d):d instanceof Date?r[A]=d.toISOString():(0,D.isObject)(d)?l<2?y(d,r,l+1,A+"."):r[A]=(0,O.safeStringify)(d):r[A]=d}}function p(n,r){const l=n.msftInternalDomains||[],o=r.getValue("telemetry.internalTesting");return(0,E.verifyMicrosoftInternalDomain)(l)||o}e.isInternalTelemetry=p;function w(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=w;function t(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let l=n;const o=[];for(const V of r)for(;;){const Y=V.exec(n);if(!Y)break;o.push([Y.index,V.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let A=0;for(l="";;){const V=d.exec(n);if(!V)break;const Y=o.some(([ee,te])=>V.index<te&&ee<d.lastIndex);!a.test(V[0])&&!Y&&(l+=n.substring(A,V.index)+"<REDACTED: user-file-path>",A=d.lastIndex)}return A<n.length&&(l+=n.substr(A)),l}function s(n){if(!n)return n;const r=n.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of l)if(o.regex.test(r))return`<REDACTED: ${o.label}>`;return n}function i(n,r){return(0,O.cloneAndChange)(n,l=>{if(l instanceof c)return l.value;if(typeof l=="string"){let o=l.replaceAll("%20"," ");o=t(o,r);for(const a of r)o=o.replace(a,"");return o=s(o),o}})}e.cleanData=i}),define(Q[26],Z([0,1,30,21,32,12,11,7,37,39]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,O.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=I;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(n){const r=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new h(n.identifier,r,l)}static parse(n){const r=S.exec(n);return r&&r[1]&&r[2]?new h({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,l="undefined"){this.version=r,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof h?I(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=h;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(i){const n=m.exec(i);return n&&n[1]?[u(n[1]),n[2]]:[u(i),void 0]}e.getIdAndVersion=P;function T(i,n){return`${i}.${n}`}e.getExtensionId=T;function u(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function f(i,n){return u(T(i,n))}e.getGalleryExtensionId=f;function v(i,n){const r=[],l=o=>{for(const a of r)if(a.some(d=>I(n(d),n(o))))return a;return null};for(const o of i){const a=l(o);a?a.push(o):r.push([o])}return r}e.groupByExtension=v;function y(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function p(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function w(i,n){const r=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const o=l.shift();if(o&&r.every(a=>!I(a.identifier,{id:o}))){const a=i.filter(d=>I(d.identifier,{id:o}));a.length===1&&(r.push(a[0]),l.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=w;async function t(i,n){if(!C.isLinux)return!1;let r;try{r=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(o))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,n){const r=await t(i,n),l=(0,D.getTargetPlatform)(r?"alpine":C.platform,g.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=s}),define(Q[133],Z([0,1,23,7,16,18,41,11,89,21,26,32]),function($,e,O,D,b,C,R,E,g,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const h=u=>(0,g.localize)(0,null,u),m=(0,g.localize)(1,null,"ms-dotnettools.csharp");function P(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let T=class{constructor(f,v){this.extensionManagementService=f,this.extensionGalleryService=v}get location(){}async listExtensions(f,v,y,p=console){let w=await this.extensionManagementService.getInstalled(1,y);const t=S.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(v&&v!==""){if(t.indexOf(v.toLowerCase())<0){p.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}w=w.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){p.log("Possible Categories: "),t.forEach(i=>{p.log(i)});return}this.location&&p.log((0,g.localize)(2,null,this.location)),w=w.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of w)s!==i.identifier.id&&(s=i.identifier.id,p.log(P(i.manifest,f)))}async installExtensions(f,v,y,p,w=console){const t=[],s=[];f.length&&w.log(this.location?(0,g.localize)(3,null,this.location):(0,g.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1,y.profileLocation),n=(a,d)=>{const A=i.find(V=>(0,I.areSameExtensions)(V.identifier,{id:a}));if(A){if(!p&&(!d||d==="prerelease"&&A.preRelease))return w.log((0,g.localize)(5,null,a,A.manifest.version,a)),!1;if(d&&A.manifest.version===d)return w.log((0,g.localize)(6,null,`${a}@${d}`)),!1}return!0},r=(a,d,A)=>{o.push({id:a,version:d!=="prerelease"?d:void 0,installOptions:{...y,isBuiltin:A,installPreReleaseVersion:d==="prerelease"||y.installPreReleaseVersion}})},l=[],o=[];for(const a of f)if(a instanceof E.URI)l.push(a);else{const[d,A]=(0,I.getIdAndVersion)(a);n(d,A)&&r(d,A,!1)}for(const a of v){const[d,A]=(0,I.getIdAndVersion)(a);n(d,A)&&r(d,A,!0)}if(l.length&&await Promise.all(l.map(async a=>{try{const d=await this.installVSIX(a,{...y,isBuiltin:!1},p,w);d&&s.push(d)}catch(d){w.error(d.message||d.stack||d),t.push(a.toString())}})),o.length){const a=await this.getGalleryExtensions(o);await Promise.all(o.map(async d=>{const A=a.get(d.id.toLowerCase());if(A)try{const V=await this.installFromGallery(d,A,i,p,w);V&&s.push(V)}catch(V){w.error(V.message||V.stack||V),t.push(d.id)}else w.error(`${h(d.version?`${d.id}@${d.version}`:d.id)}
${m}`),t.push(d.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async installVSIX(f,v,y,p){const w=await this.extensionManagementService.getManifest(f);if(!w)throw new Error("Invalid vsix");if(await this.validateVSIX(w,y,v.profileLocation,p))try{return await this.extensionManagementService.install(f,v),p.log((0,g.localize)(8,null,(0,C.basename)(f))),w}catch(s){if((0,D.isCancellationError)(s))return p.log((0,g.localize)(9,null,(0,C.basename)(f))),null;throw s}return null}async getGalleryExtensions(f){const v=new Map,y=f.some(w=>w.installOptions.installPreReleaseVersion),p=await this.extensionGalleryService.getExtensions(f.map(w=>({...w,preRelease:y})),O.CancellationToken.None);for(const w of p)v.set(w.identifier.id.toLowerCase(),w);return v}async installFromGallery({id:f,version:v,installOptions:y},p,w,t,s){const i=await this.extensionGalleryService.getManifest(p,O.CancellationToken.None);if(i&&!this.validateExtensionKind(i,s))return null;const n=w.find(r=>(0,I.areSameExtensions)(r.identifier,p.identifier));if(n){if(p.version===n.manifest.version)return s.log((0,g.localize)(10,null,v?`${f}@${v}`:f)),null;s.log((0,g.localize)(11,null,f,p.version))}try{y.isBuiltin?s.log(v?(0,g.localize)(12,null,f,v):(0,g.localize)(13,null,f)):s.log(v?(0,g.localize)(14,null,f,v):(0,g.localize)(15,null,f));const r=await this.extensionManagementService.installFromGallery(p,{...y,installGivenVersion:!!v});return s.log((0,g.localize)(16,null,f,r.manifest.version)),i}catch(r){if((0,D.isCancellationError)(r))return s.log((0,g.localize)(17,null,f)),null;throw r}}validateExtensionKind(f,v){return!0}async validateVSIX(f,v,y,p){const w={id:(0,I.getGalleryExtensionId)(f.publisher,f.name)},s=(await this.extensionManagementService.getInstalled(1,y)).find(i=>(0,I.areSameExtensions)(w,i.identifier)&&(0,R.gt)(i.manifest.version,f.version));return s&&!v?(p.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,f.version)),!1):this.validateExtensionKind(f,p)}async uninstallExtensions(f,v,y,p=console){const w=async s=>{if(s instanceof E.URI){const i=await this.extensionManagementService.getManifest(s);return P(i)}return s},t=[];for(const s of f){const i=await w(s),r=(await this.extensionManagementService.getInstalled(void 0,y)).filter(l=>(0,I.areSameExtensions)(l.identifier,{id:i}));if(!r.length)throw new Error(`${this.notInstalled(i)}
${m}`);if(r.some(l=>l.type===0)){p.log((0,g.localize)(19,null,i));return}if(!v&&r.some(l=>l.isBuiltin)){p.log((0,g.localize)(20,null,i));return}p.log((0,g.localize)(21,null,i));for(const l of r)await this.extensionManagementService.uninstall(l,{profileLocation:y}),t.push(l);this.location?p.log((0,g.localize)(22,null,i,this.location)):p.log((0,g.localize)(23,null,i))}}async locateExtension(f,v=console){const y=await this.extensionManagementService.getInstalled();f.forEach(p=>{y.forEach(w=>{if(w.identifier.id===p&&w.location.scheme===b.Schemas.file){v.log(w.location.fsPath);return}})})}notInstalled(f){return this.location?(0,g.localize)(24,null,f,this.location):(0,g.localize)(25,null,f)}};T=he([J(0,c.IExtensionManagementService),J(1,c.IExtensionGalleryService)],T),e.ExtensionManagementCLI=T}),define(Q[134],Z([0,1,4,2,34,26,32]),function($,e,O,D,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class E extends D.Disposable{constructor(c,I,S,h,m,P,T){super(),this.extensionManagementService=c,this.extensionsScannerService=I,this.userDataProfilesService=S,this.extensionsProfileScannerService=h,this.uriIdentityService=m,this.fileService=P,this.logService=T,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new D.DisposableMap),this.initialize().then(null,u=>T.error(u))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(c=>this.onDidChangeProfiles(c.added,c.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(c=>this.onAddExtensions(c))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(c=>this.onDidAddExtensions(c))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(c=>this.onRemoveExtensions(c))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(c=>this.onDidRemoveExtensions(c))),this._register(this.fileService.onDidFilesChange(c=>this.onDidFilesChange(c)))}async onDidChangeProfiles(c,I){try{await Promise.all(I.map(S=>(this.extensionsProfileWatchDisposables.deleteAndDispose(S.id),this.removeExtensionsFromProfile(S.extensionsResource)))),c.length&&await Promise.all(c.map(S=>(this.extensionsProfileWatchDisposables.set(S.id,(0,D.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(S.extensionsResource)),this.fileService.watch(S.extensionsResource))),this.populateExtensionsFromProfile(S.extensionsResource))))}catch(S){throw this.logService.error(S),S}}async onAddExtensions(c){for(const I of c.extensions)this.addExtensionWithKey(this.getKey(I.identifier,I.version),c.profileLocation)}async onDidAddExtensions(c){for(const I of c.extensions){const S=this.getKey(I.identifier,I.version);c.error?this.removeExtensionWithKey(S,c.profileLocation):this.addExtensionWithKey(S,c.profileLocation)}}async onRemoveExtensions(c){for(const I of c.extensions)this.removeExtensionWithKey(this.getKey(I.identifier,I.version),c.profileLocation)}async onDidRemoveExtensions(c){const I=[],S=[];for(const h of c.extensions){const m=this.getKey(h.identifier,h.version);c.error?this.addExtensionWithKey(m,c.profileLocation):(this.removeExtensionWithKey(m,c.profileLocation),this.allExtensions.has(m)||(this.logService.debug("Extension is removed from all profiles",h.identifier.id,h.version),S.push(this.extensionManagementService.scanInstalledExtensionAtLocation(h.location).then(P=>{P?I.push(P):this.logService.info("Extension not found at the location",h.location.toString())},P=>this.logService.error(P)))))}try{await Promise.all(S),I.length&&await this.uninstallExtensionsNotInProfiles(I)}catch(h){this.logService.error(h)}}onDidFilesChange(c){for(const I of this.userDataProfilesService.profiles)c.contains(I.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(I.extensionsResource)}async onDidExtensionsProfileChange(c){const I=[],S=[],h=await this.extensionsProfileScannerService.scanProfileExtensions(c),m=new Set,P=new Set;for(const[T,u]of this.allExtensions)u.has(c)&&P.add(T);for(const T of h){const u=this.getKey(T.identifier,T.version);m.add(u),P.has(u)||(I.push(T.identifier),this.addExtensionWithKey(u,c))}for(const T of P)if(!m.has(T)){const u=this.fromKey(T);u&&(S.push(u.identifier),this.removeExtensionWithKey(T,c))}(I.length||S.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I.length?{extensions:I,profileLocation:c}:void 0,removed:S.length?{extensions:S,profileLocation:c}:void 0})}async populateExtensionsFromProfile(c){const I=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const S of I)this.addExtensionWithKey(this.getKey(S.identifier,S.version),c)}async removeExtensionsFromProfile(c){for(const I of[...this.allExtensions.keys()])this.removeExtensionWithKey(I,c);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(c){c||(c=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(S=>!this.allExtensions.has(this.getKey(S.identifier,S.manifest.version)))),c.length&&await this.extensionManagementService.markAsUninstalled(...c)}addExtensionWithKey(c,I){let S=this.allExtensions.get(c);S||this.allExtensions.set(c,S=new b.ResourceSet(h=>this.uriIdentityService.extUri.getComparisonKey(h))),S.add(I)}removeExtensionWithKey(c,I){const S=this.allExtensions.get(c);S&&S.delete(I),S?.size||this.allExtensions.delete(c)}getKey(c,I){return`${R.ExtensionIdentifier.toKey(c.id)}@${I}`}fromKey(c){const[I,S]=(0,C.getIdAndVersion)(c);return S?{identifier:{id:I},version:S}:void 0}}e.ExtensionsWatcher=E}),define(Q[135],Z([0,1,108,39]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function b(C,R,E,g,c,I,S){const h={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${R.nameShort})`};if((0,D.supportsTelemetry)(R,E)&&(0,D.getTelemetryLevel)(g)===3){const m=await(0,O.getServiceMachineId)(E,c,I),{machineId:P}=await S.getTelemetryInfo();h["X-Market-User-Id"]=m,h["VSCode-SessionId"]=P||m}return h}e.resolveMarketplaceHeaders=b}),define(Q[136],Z([0,1,164,19,5,2,16,15,20,17,21,26,6,64,11]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let T=class extends m.LanguagePackBaseService{constructor(y,p,w,t){super(w),this.extensionManagementService=y,this.logService=t,this.cache=this._register(new u(p,t)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getBuiltInExtensionTranslationsUri(y,p){const t=(await this.cache.getLanguagePacks())[p];if(!t){this.logService.warn(`No language pack found for ${p}`);return}const s=t.translations[y];return s?P.URI.file(s):void 0}async getInstalledLanguages(){const y=await this.cache.getLanguagePacks(),p=Object.keys(y).map(w=>{const t=y[w];return{...this.createQuickPickItem(w,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((w,t)=>w.label.localeCompare(t.label)),p}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const p=await this.cache.getLanguagePacks();Object.keys(p).some(w=>p[w]&&p[w].extensions.some(t=>(0,S.areSameExtensions)(t.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(p);return!(0,D.equals)(Object.keys(y),Object.keys(w))}};T=he([J(0,I.IExtensionManagementService),J(1,c.INativeEnvironmentService),J(2,I.IExtensionGalleryService),J(3,h.ILogService)],T),e.NativeLanguagePackService=T;let u=class extends C.Disposable{constructor(y,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(p=>{Object.keys(p).forEach(w=>delete p[w]),this.createLanguagePacksFromExtensions(p,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...p){for(const w of p)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,w);Object.keys(y).forEach(w=>this.updateHash(y[w]))}createLanguagePacksFromExtension(y,p){const w=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const s of t)if(p.location.scheme===R.Schemas.file&&f(s)){let i=y[s.languageId];i||(i={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},y[s.languageId]=i);const n=i.extensions.filter(r=>(0,S.areSameExtensions)(r.extensionIdentifier,w))[0];n?n.version=p.manifest.version:i.extensions.push({extensionIdentifier:w,version:p.manifest.version});for(const r of s.translations)i.translations[r.id]=(0,E.join)(p.location.fsPath,r.path)}}updateHash(y){if(y){const p=(0,O.createHash)("md5");for(const w of y.extensions)p.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);y.hash=p.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return g.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(p=y(w),w)).then(w=>{for(const s of Object.keys(w))w[s]||delete w[s];this.languagePacks=w,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),g.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>p,w=>this.logService.error(w))})}};u=he([J(0,c.INativeEnvironmentService),J(1,h.ILogService)],u);function f(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const y of v.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(Q[137],Z([0,1,7,28,39]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function E(c,I,S){const h=await new Promise((f,v)=>{$(["@microsoft/1ds-core-js"],f,v)}),m=await new Promise((f,v)=>{$(["@microsoft/1ds-post-js"],f,v)}),P=new h.AppInsightsCore,T=new m.PostChannel,u={instrumentationKey:c,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[T]]};if(S){u.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:S};u.extensionConfig[T.identifier]=f}return P.initialize(u,[]),P.addTelemetryInitializer(f=>{I&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),P}class g{constructor(I,S,h,m,P){this._isInternalTelemetry=I,this._eventPrefix=S,this._defaultData=h,this._xhrOverride=P,this.endPointUrl=C,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(I){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){I(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=E(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(S=>{I(S)},S=>{(0,O.onUnexpectedError)(S),console.error(S)})}}log(I,S){if(!this._aiCoreOrKey)return;S=(0,D.mixin)(S,this._defaultData),S=(0,b.validateTelemetryData)(S);const h=this._eventPrefix+"/"+I;try{this._withAIClient(m=>{m.pluginVersionString=S?.properties.version??"Unknown",m.track({name:h,baseData:{name:h,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(I=>{this._withAIClient(S=>{S.unload(!0,()=>{this._aiCoreOrKey=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Q[138],Z([0,1,2,28,12,30,101,24,42,139,31,35,25,39]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{constructor(f,v,y){this._configurationService=v,this._productService=y,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(h.TELEMETRY_SETTING_ID)||p.affectsConfiguration(h.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(h.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,v){this._experimentProperties[f]=v}_updateTelemetryLevel(){let f=(0,m.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const y=v.usage?3:v.error?2:0;f=Math.min(f,y)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties,v=f.sessionID,y=f["common.machineId"],p=f["common.firstSessionDate"],w=f["common.msftInternal"];return{sessionId:v,machineId:y,firstSessionDate:p,msftInternal:w}}dispose(){this._disposables.dispose()}_log(f,v,y){return this._telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(p=>{y=(0,D.mixin)(y,this._experimentProperties),y=(0,m.cleanData)(y,this._cleanupPatterns),y=(0,D.mixin)(y,p),this._appenders.forEach(w=>w.log(f,y))},p=>{console.error(p)})}publicLog(f,v){return this._log(f,3,v)}publicLog2(f,v){return this.publicLog(f,v)}publicLogError(f,v){return this._sendErrorTelemetry?this._log(f,2,v):Promise.resolve(void 0)}publicLogError2(f,v){return this.publicLogError(f,v)}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=he([J(1,E.IConfigurationService),J(2,I.IProductService)],P),e.TelemetryService=P;function T(){const u=(0,R.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=b.isWeb?"":(0,R.localize)(3,null),y=(0,R.localize)(4,null),p=(0,R.localize)(5,null),w=(0,R.localize)(6,null),t=(0,R.localize)(7,null),s=`
|       | ${y} | ${p} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${u} ${f} ${v}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}S.Registry.as(g.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:T(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(g.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,R.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,R.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[140],Z([0,1,165,137]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class b extends D.AbstractOneDataSystemAppender{constructor(R,E,g,c){const I={sendPOST:(S,h)=>{const m={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const P=O.request(S.urlString,m,T=>{T.on("data",function(u){h(T.statusCode??200,T.headers,u.toString())}),T.on("error",function(u){h(0,{})})});P.write(S.data),P.end()}catch{h(0,{})}}};super(R,E,g,c,I)}}e.OneDataSystemAppender=b}),define(Q[141],Z([0,1,15,20]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function b(C,R){const E=Object.create(null),g=(I,S)=>{const h=JSON.parse(I);E[S]=h};if(R){const I=[],S=await D.Promises.readdir(R);for(const m of S)try{(await D.Promises.stat((0,O.join)(R,m))).isDirectory()&&I.push(m)}catch{}const h=[];for(const m of I)(await D.Promises.readdir((0,O.join)(R,m))).filter(T=>T==="telemetry.json").length===1&&h.push(m);for(const m of h){const P=(await D.Promises.readFile((0,O.join)(R,m,"telemetry.json"))).toString();g(P,m)}}let c=(await D.Promises.readFile((0,O.join)(C,"telemetry-core.json"))).toString();return g(c,"vscode-core"),c=(await D.Promises.readFile((0,O.join)(C,"telemetry-extensions.json"))).toString(),g(c,"vscode-extensions"),JSON.stringify(E,null,4)}e.buildTelemetryMessage=b}),define(Q[142],Z([0,1,12,80,25]),function($,e,O,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(R){let E=R.getItem(b.machineIdKey);return(typeof E!="string"||O.isMacintosh&&E==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(E=await(0,D.getMachineId)()),E}e.resolveMachineId=C}),define(Q[27],Z([0,1,10]),function($,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(Q[143],Z([0,1,27,109,13,18,72,4,2]),function($,e,O,D,b,C,R,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(h){this.uri=h,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let I=class{constructor(h){this._fileService=h,this._dispooables=new g.DisposableStore,this._limit=2**16;const m=new Map,P=T=>{let u=m.get(T.scheme);return u===void 0&&(u=h.hasProvider(T)&&!this._fileService.hasCapability(T,1024),m.set(T.scheme,u)),u};this._dispooables.add(E.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(T=>{m.delete(T.scheme)})),this.extUri=new C.ExtUri(P),this._canonicalUris=new R.SkipList((T,u)=>this.extUri.compare(T,u,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,C.normalizePath)(h));const m=this._canonicalUris.get(h);return m?m.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new c(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((P,T)=>P[1].time<T[1].time?1:P[1].time>T[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let P=0;P<m;P++)this._canonicalUris.set(h[P][0],h[P][1].touch())}};I=he([J(0,b.IFileService)],I),e.UriIdentityService=I,(0,D.registerSingleton)(O.IUriIdentityService,I,1)}),define(Q[144],Z([0,1,103,15,55,18,11,10,16]),function($,e,O,D,b,C,R,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function I(i){return typeof i?.id=="string"&&!c(i)&&!h(i)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=S;function h(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=h;function m(i){const n=i;if(n?.uri)return{id:n.id,uri:R.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:R.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var P;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function T(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=T;function u(i){const n=i;return!!(n&&typeof n=="object"&&R.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=u;class f{constructor(n,r,l,o,a){this._id=n,this._transient=l,this._configuration=o,this._ignorePathCasing=a,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class v{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,C.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function y(i){return new v({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,n){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function w(i){let n;return R.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=w;function t(i,n){return!p(i,n)&&!w(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,D.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Q[22],Z([0,1,52,4,2,18,11,102,17,13,10,6,144,34,27,5,29,30,3]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&R.URI.isUri(n.location)&&R.URI.isUri(n.globalStorageHome)&&R.URI.isUri(n.settingsResource)&&R.URI.isUri(n.keybindingsResource)&&R.URI.isUri(n.tasksResource)&&R.URI.isUri(n.snippetsHome)&&R.URI.isUri(n.extensionsResource))}e.isUserDataProfile=y,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function p(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:n}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:R.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=p;function w(i,n,r,l){return{id:i,name:n,location:r,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,C.joinPath)(r,"globalStorage"),settingsResource:(0,C.joinPath)(r,"settings.json"),keybindingsResource:(0,C.joinPath)(r,"keybindings.json"),tasksResource:(0,C.joinPath)(r,"tasks.json"),snippetsHome:(0,C.joinPath)(r,"snippets"),extensionsResource:(0,C.joinPath)(r,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=w;let t=class extends b.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,r,l,o){super(),this.environmentService=n,this.fileService=r,this.uriIdentityService=l,this.logService=o,this.enabled=!0,this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new D.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new D.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new D.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=[];if(this.enabled)try{for(const a of this.getStoredProfiles()){if(!a.name||!(0,v.isString)(a.name)||!a.location){this.logService.warn("Skipping the invalid stored profile",a.location||a.name);continue}n.push(w((0,C.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags}))}}catch(a){this.logService.error(a)}const r=new m.ResourceMap,l=new Map,o=this.createDefaultProfile();if(n.unshift({...o,extensionsResource:this.getDefaultProfileExtensionsLocation()??o.extensionsResource,isDefault:!0}),n.length)try{const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[d,A]of Object.entries(a.workspaces)){const V=R.URI.parse(d),Y=n.find(ee=>ee.id===A);Y&&r.set(V,Y)}if(a.emptyWindows)for(const[d,A]of Object.entries(a.emptyWindows)){const V=n.find(Y=>Y.id===A);V&&l.set(d,V)}}catch(a){this.logService.error(a)}this._profilesObject={profiles:n,workspaces:r,emptyWindows:l}}return this._profilesObject}createDefaultProfile(){return w("__default__profile__",(0,E.localize)(0,null),this.environmentService.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const d of this.profiles){const A=l.exec(d.name),V=A?parseInt(A[1]):0;o=V>o?V:o}const a=`${r} ${o+1}`;return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),a,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),n,r,l)}async createProfile(n,r,l,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=await this.doCreateProfile(n,r,l);return o&&await this.setProfileForWorkspace(o,a),a}async doCreateProfile(n,r,l){if(!(0,v.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.profileCreationPromises.get(r);return o||(o=(async()=>{try{const a=this.profiles.find(V=>V.name===r||V.id===n);if(a)return a;const d=w(n,r,(0,C.joinPath)(this.profilesHome,n),l);await this.fileService.createFolder(d.location);const A=[];return this._onWillCreateProfile.fire({profile:d,join(V){A.push(V)}}),await T.Promises.settled(A),this.updateProfiles([d],[],[]),d}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,o)),o}async updateProfile(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(o=>o.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=w(l.id,r.name??l.name,l.location,{shortName:r.shortName??l.shortName,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags}),this.updateProfiles([],[],[l]),l}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this._onWillRemoveProfile.fire({profile:r,join(o){l.push(o)}});try{await Promise.allSettled(l)}catch(o){this.logService.error(o)}for(const o of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(o)?.id&&this.profilesObject.emptyWindows.delete(o);for(const o of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(o){this.logService.error(o)}}async setProfileForWorkspace(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(o=>o.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(n,l)}unsetWorkspace(n,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.uriIdentityService.extUri.isEqual(l.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.getWorkspace(n);return R.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(n){return(0,h.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,h.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,n.location)))}updateProfiles(n,r,l){const o=[...this.profiles,...n],a=[];this.transientProfilesObject.profiles=[];for(let d of o)d.isDefault||r.some(A=>d.id===A.id)||(d=l.find(A=>d.id===A.id)??d,d.isTransient?this.transientProfilesObject.profiles.push(d):a.push({location:d.location,name:d.name,shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(n,r,l)}triggerProfilesChanges(n,r,l){this._onDidChangeProfiles.fire({added:n,removed:r,updated:l,all:this.profiles})}updateWorkspaceAssociation(n,r,l){l=r?.isTransient?!0:l,l||this.updateWorkspaceAssociation(n,void 0,!0);const o=this.getWorkspace(n),a=l?this.transientProfilesObject:this.profilesObject;R.URI.isUri(o)?(a.workspaces.delete(o),r&&a.workspaces.set(o,r)):(a.emptyWindows.delete(o),r&&a.emptyWindows.set(o,r)),l||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[l,o]of this.profilesObject.workspaces.entries())n[l.toString()]=o.id;const r={};for(const[l,o]of this.profilesObject.emptyWindows.entries())r[l.toString()]=o.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const r={},l=this.createDefaultProfile();if(n.workspaces)for(const[a,d]of Object.entries(n.workspaces)){const A=R.URI.parse(d);r[a]=this.uriIdentityService.extUri.isEqual(A,l.location)?l.id:this.uriIdentityService.extUri.basename(A)}const o={};if(n.emptyWindows)for(const[a,d]of Object.entries(n.emptyWindows)){const A=R.URI.parse(d);o[a]=this.uriIdentityService.extUri.isEqual(A,l.location)?l.id:this.uriIdentityService.extUri.basename(A)}return{workspaces:r,emptyWindows:o}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",t=he([J(0,g.IEnvironmentService),J(1,c.IFileService),J(2,P.IUriIdentityService),J(3,S.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(Q[145],Z([0,1,19,5,23,7,4,2,12,11,87,21,26,32,6,31,25,22]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var v;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(v=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let y=class extends E.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,r,l,o,a){super(),this.galleryService=n,this.telemetryService=r,this.logService=l,this.productService=o,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(({task:d})=>d.cancel()),this.uninstallingExtensions.forEach(d=>d.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,S.isTargetPlatformCompatible)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.galleryService.isEnabled())throw new S.ExtensionManagementError(I.localize(0,null),S.ExtensionManagementErrorCode.Internal);const l=await this.checkAndGetCompatibleVersion(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(l.manifest,l.extension,r)}catch(l){throw t(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(n),error:l}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(l),w(l)}}async uninstall(n,r={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,r,l){const o={...l,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,m.isApplicationScopedExtension)(n)?this.userDataProfilesService.defaultProfile.extensionsResource:l.profileLocation??this.getCurrentExtensionsManifestLocation()},a=te=>`${h.ExtensionKey.create(te).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const te=this.installingExtensions.get(a(r));if(te)return this.logService.info("Extensions is already requested to install",r.identifier.id),te.task.waitUntilTaskIsFinished()}const d=[],A=[],V=[],Y=this.createInstallExtensionTask(n,r,o);c.URI.isUri(r)||this.installingExtensions.set(a(r),{task:Y,waitingTasks:[]}),this._onInstallExtension.fire({identifier:Y.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",Y.identifier.id),d.push({task:Y,manifest:n});let ee=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ne=await this.getAllDepsAndPackExtensions(Y.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ie=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:ae,manifest:fe}of(0,O.distinct)(ne,({gallery:oe})=>oe.identifier.id)){ee=ee||!!fe.extensionDependencies?.some(W=>(0,h.areSameExtensions)({id:W},Y.identifier));const oe=a(ae),pe=this.installingExtensions.get(oe);if(pe){if(this.canWaitForTask(Y,pe.task)){const W=pe.task.identifier;this.logService.info("Waiting for already requested installing extension",W.id,Y.identifier.id),pe.waitingTasks.push(Y),A.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,M=>M.some(F=>(0,h.areSameExtensions)(F.identifier,W)))).then(M=>{if(this.logService.info("Finished waiting for already requested installing extension",W.id,Y.identifier.id),!M.find(j=>(0,h.areSameExtensions)(j.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!ie.some(({identifier:W})=>(0,h.areSameExtensions)(W,ae.identifier))){const W=this.createInstallExtensionTask(fe,ae,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(oe,{task:W,waitingTasks:[Y]}),this._onInstallExtension.fire({identifier:W.identifier,source:ae,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",W.identifier.id,Y.identifier.id),d.push({task:W,manifest:fe})}}}catch(ne){if(c.URI.isUri(Y.source))(0,O.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Y.identifier.id,ne.message),(0,O.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Y.identifier.id,ne.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ne}const te=d.reduce((ne,{task:ie,manifest:ae})=>(ne.set(ie.identifier.id.toLowerCase(),{task:ie,manifest:ae}),ne),new Map);for(;te.size;){let ne;const ie=[...te.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(fe=>te.has(fe.toLowerCase())));ie.length?ne=te.size===1?ie:ie.filter(({task:ae})=>!(ae===Y&&!ee)):(this.logService.info("Found extensions with circular dependencies",ie.map(({task:ae})=>ae.identifier.id)),ne=[...te.values()]),await this.joinAllSettled(ne.map(async({task:ae})=>{const fe=new Date().getTime();try{const oe=await ae.run();if(await this.joinAllSettled(this.participants.map(pe=>pe.postInstall(oe,ae.source,o,b.CancellationToken.None))),!c.URI.isUri(ae.source)){const pe=ae.operation===3,W=pe?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.telemetryService,pe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:W}),g.isWeb&&ae.operation!==3)try{await this.galleryService.reportStatistic(oe.manifest.publisher,oe.manifest.name,oe.manifest.version,"install")}catch{}}V.push({local:oe,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:oe.isApplicationScoped})}catch(oe){throw c.URI.isUri(ae.source)||t(this.telemetryService,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,error:oe}),this.logService.error("Error while installing the extension:",ae.identifier.id),oe}finally{te.delete(ae.identifier.id.toLowerCase())}}))}return A.length&&await this.joinAllSettled(A),V.forEach(({identifier:ne})=>this.logService.info("Extension installed successfully:",ne.id)),this._onDidInstallExtensions.fire(V),V.filter(({identifier:ne})=>(0,h.areSameExtensions)(ne,Y.identifier))[0].local}catch(te){if(d.forEach(({task:ne})=>ne.cancel()),V.length)try{const ne=await Promise.allSettled(V.map(({local:ie})=>this.createUninstallExtensionTask(ie,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ie=0;ie<ne.length;ie++){const ae=ne[ie],{identifier:fe}=V[ie];ae.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",fe.id):this.logService.warn("Rollback: Error while uninstalling extension",fe.id,(0,C.getErrorMessage)(ae.reason))}}catch(ne){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(ne),V.map(({identifier:ie})=>ie.id))}throw this._onDidInstallExtensions.fire(d.map(({task:ne})=>({identifier:ne.identifier,operation:2,source:ne.source,context:o.context,profileLocation:o.profileLocation}))),te}finally{for(const{task:te}of d)te.source&&!c.URI.isUri(te.source)&&this.installingExtensions.delete(a(te.source))}}canWaitForTask(n,r){for(const[,{task:l,waitingTasks:o}]of this.installingExtensions.entries())if(l===n&&(o.includes(r)||o.some(a=>this.canWaitForTask(a,r)))||l===r&&o[0]&&!this.canWaitForTask(n,o[0]))return!1;return!0}async joinAllSettled(n){const r=[],l=[],o=await Promise.allSettled(n);for(const a of o)a.status==="fulfilled"?r.push(a.value):l.push(a.reason);if(l.length)throw p(l);return r}async getAllDepsAndPackExtensions(n,r,l,o,a){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,a),A=[],V=[],Y=async(ee,te)=>{A.push(ee);const ne=te.extensionDependencies||[],ie=[...ne];if(te.extensionPack){const ae=l?d.find(fe=>(0,h.areSameExtensions)(fe.identifier,ee)):void 0;for(const fe of te.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(oe=>(0,h.areSameExtensions)({id:oe},{id:fe}))||ie.every(oe=>!(0,h.areSameExtensions)({id:oe},{id:fe}))&&ie.push(fe)}if(ie.length){const ae=ie.filter(fe=>A.every(oe=>!(0,h.areSameExtensions)(oe,{id:fe})));if(ae.length){const fe=await this.galleryService.getExtensions(ae.map(oe=>({id:oe,preRelease:o})),b.CancellationToken.None);for(const oe of fe){if(A.find(M=>(0,h.areSameExtensions)(M,oe.identifier)))continue;const pe=ne.some(M=>(0,h.areSameExtensions)({id:M},oe.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(oe,!1,o)}catch(M){if(M instanceof S.ExtensionManagementError&&M.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!pe){this.logService.info("Skipping the packed extension as it cannot be installed",oe.identifier.id);continue}else throw M}V.push({gallery:W.extension,manifest:W.manifest}),await Y(W.extension.identifier,W.manifest)}}}};return await Y(n,r),V}async checkAndGetCompatibleVersion(n,r,l){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,h.areSameExtensions)(n.identifier,A)))throw new S.ExtensionManagementError(I.localize(1,null,n.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const A=await this.getTargetPlatform();throw new S.ExtensionManagementError(I.localize(2,null,n.identifier.id,this.productService.nameLong,(0,S.TargetPlatformToString)(A)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(n,r,l);if(a){if(l&&!r&&n.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(I.localize(3,null,n.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!l&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],b.CancellationToken.None))[0]?new S.ExtensionManagementError(I.localize(4,null,n.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(I.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const d=await this.galleryService.getManifest(a,b.CancellationToken.None);if(d===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(d.version!==a.version)throw new S.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:d}}async getCompatibleVersion(n,r,l){const o=await this.getTargetPlatform();let a=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(a=(await this.galleryService.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:o,compatible:!0},b.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(n,l,o)&&(a=n),a||(r?a=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},b.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(n,l,o)),a}async uninstallExtension(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},o=ee=>`${ee.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(o(n.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),a.waitUntilTaskIsFinished();const d=ee=>{const te=this.createUninstallExtensionTask(ee,l);return this.uninstallingExtensions.set(o(te.extension.identifier),te),l.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this._onUninstallExtension.fire({identifier:ee.identifier,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped}),te},A=(ee,te)=>{te?l.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString(),te.message):this.logService.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,te.message):l.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(ee),error:te}),this._onDidUninstallExtension.fire({identifier:ee.identifier,error:te?.code,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped})},V=[],Y=[];try{V.push(d(n));const ee=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.getAllPackExtensionsToUninstall(n,ee);for(const ne of te)this.uninstallingExtensions.has(o(ne.identifier))?this.logService.info("Extensions is already requested to uninstall",ne.identifier.id):V.push(d(ne))}l.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(V.map(te=>te.extension),ee,n),await this.joinAllSettled(V.map(async te=>{try{if(await te.run(),await this.joinAllSettled(this.participants.map(ne=>ne.postUninstall(te.extension,l,b.CancellationToken.None))),te.extension.identifier.uuid)try{await this.galleryService.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}A(te.extension)}catch(ne){const ie=ne instanceof S.ExtensionManagementError?ne:new S.ExtensionManagementError((0,C.getErrorMessage)(ne),S.ExtensionManagementErrorCode.Internal);throw A(te.extension,ie),ie}finally{Y.push(te)}}))}catch(ee){const te=ee instanceof S.ExtensionManagementError?ee:new S.ExtensionManagementError((0,C.getErrorMessage)(ee),S.ExtensionManagementErrorCode.Internal);for(const ne of V){try{ne.cancel()}catch{}Y.includes(ne)||A(ne.extension,te)}throw te}finally{for(const ee of V)this.uninstallingExtensions.delete(o(ee.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}checkForDependents(n,r,l){for(const o of n){const a=this.getDependents(o,r);if(a.length){const d=a.filter(A=>!n.some(V=>(0,h.areSameExtensions)(V.identifier,A.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(o,d,l))}}}getDependentsErrorMessage(n,r,l){return l===n?r.length===1?I.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const a=r.filter(A=>!A.isBuiltin&&o.some(V=>(0,h.areSameExtensions)({id:V},A.identifier))),d=[];for(const A of a)d.push(...this.getAllPackExtensionsToUninstall(A,r,l));return[...a,...d]}return[]}getDependents(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(o=>(0,h.areSameExtensions)({id:o},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};y=he([J(0,S.IExtensionGalleryService),J(1,u.ITelemetryService),J(2,P.ILogService),J(3,T.IProductService),J(4,f.IUserDataProfilesService)],y),e.AbstractExtensionManagementService=y;function p(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=p;function w(i){if(i instanceof S.ExtensionManagementError)return i;const n=new S.ExtensionManagementError(i.message,S.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:l,duration:o,error:a,durationSinceUpdate:d}){let A,V;a&&(a instanceof S.ExtensionManagementError?(A=a.code,a.code===S.ExtensionManagementErrorCode.Signature&&(V=a.message)):A=S.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!a,duration:o,errorcode:A,errorcodeDetail:V,durationSinceUpdate:d})}class s{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(n=>new Promise((r,l)=>{const o=n.onCancellationRequested(()=>{o.dispose(),l(new C.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(Q[40],Z([0,1,5,14,2,4,34,11,21,26,13,10,6,22,27,3,7,25]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class y extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=y,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let p=class extends b.Disposable{constructor(i,n,r,l,o,a){super(),this.extensionsLocation=i,this.fileService=n,this.userDataProfilesService=r,this.uriIdentityService=l,this.telemetryService=o,this.logService=a,this._onAddExtensions=this._register(new C.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new C.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new C.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new C.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(i,n){return this.withProfileExtensions(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],l=[];try{return await this.withProfileExtensions(n,o=>{const a=[];for(const d of o)i.some(([A])=>(0,c.areSameExtensions)(A.identifier,d.identifier)&&A.manifest.version!==d.version)?r.push(d):a.push(d);for(const[d,A]of i)if(!a.some(V=>(0,c.areSameExtensions)(V.identifier,d.identifier)&&V.version===d.manifest.version)){const V={identifier:d.identifier,version:d.manifest.version,location:d.location,metadata:A};l.push(V),a.push(V)}return l.length&&this._onAddExtensions.fire({extensions:l,profileLocation:n}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),a}),l.length&&this._onDidAddExtensions.fire({extensions:l,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n}),l}catch(o){throw l.length&&this._onDidAddExtensions.fire({extensions:l,error:o,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:n}),o}}async updateMetadata(i,n){const r=[];return await this.withProfileExtensions(n,l=>{const o=[];for(const a of l){const d=i.find(([A])=>(0,c.areSameExtensions)(A.identifier,a.identifier)&&A.manifest.version===a.version);d&&(a.metadata={...a.metadata,...d[1]},r.push(a)),o.push(a)}return o}),r}async removeExtensionFromProfile(i,n){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:n});try{await this.withProfileExtensions(n,l=>{const o=[];for(const a of l)(0,c.areSameExtensions)(a.identifier,i.identifier)?r.push(a):o.push(a);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),o}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n})}catch(l){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:l,profileLocation:n}),l}}async withProfileExtensions(i,n,r){return this.getResourceAccessQueue(i).queue(async()=>{let l=[],o;try{const a=await this.fileService.readFile(i);o=JSON.parse(a.value.toString().trim()||"[]")}catch(a){if((0,I.toFileOperationResult)(a)!==1)throw a;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(o=await this.migrateFromOldDefaultProfileExtensionsLocation()),!o&&r?.bailOutWhenFileNotFound)throw new y((0,u.getErrorMessage)(a),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.reportAndThrowInvalidConentError(i);let a=!1;for(const d of o){w(d)||this.reportAndThrowInvalidConentError(i);let A;if((0,T.isString)(d.relativeLocation)&&d.relativeLocation)A=this.resolveExtensionLocation(d.relativeLocation);else if((0,T.isString)(d.location))A=this.resolveExtensionLocation(d.location),a=!0,d.relativeLocation=d.location,d.location=A.toJSON();else{A=E.URI.revive(d.location);const V=this.toRelativePath(A);V&&(a=!0,d.relativeLocation=V)}l.push({identifier:d.identifier,location:A,version:d.version,metadata:d.metadata})}a&&await this.fileService.writeFile(i,D.VSBuffer.fromString(JSON.stringify(o)))}if(n){l=n(l);const a=l.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),relativeLocation:this.toRelativePath(d.location),metadata:d.metadata}));await this.fileService.writeFile(i,D.VSBuffer.fromString(JSON.stringify(a)))}return l})}reportAndThrowInvalidConentError(i){const n=new y(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(i)).value.toString()}catch(o){if((0,I.toFileOperationResult)(o)===1)return;throw o}this.logService.info("Migrating extensions from old default profile location",i.toString());let l;try{const o=JSON.parse(r);Array.isArray(o)&&o.every(a=>w(a))?l=o:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.logService.error(o)}if(l)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(o){if((0,I.toFileOperationResult)(o)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw o}try{await this.fileService.del(i)}catch(o){(0,I.toFileOperationResult)(o)!==1&&this.logService.error(o)}try{await this.fileService.del(n)}catch(o){(0,I.toFileOperationResult)(o)!==1&&this.logService.error(o)}return l})()),this._migrationPromise}getResourceAccessQueue(i){let n=this.resourcesAccessQueueMap.get(i);return n||(n=new O.Queue,this.resourcesAccessQueueMap.set(i,n)),n}};p=he([J(1,I.IFileService),J(2,m.IUserDataProfilesService),J(3,P.IUriIdentityService),J(4,f.ITelemetryService),J(5,h.ILogService)],p),e.AbstractExtensionsProfileScannerService=p;function w(s){return(0,T.isObject)(s)&&(0,g.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,T.isString)(s.location)&&s.location)&&((0,T.isUndefined)(s.relativeLocation)||(0,T.isString)(s.relativeLocation))&&s.version&&(0,T.isString)(s.version)}function t(s){return s?(0,T.isString)(s.path)&&(0,T.isString)(s.scheme):!1}}),define(Q[47],Z([0,1,19,5,28,14,7,50,78,2,16,15,12,18,41,53,3,11,91,17,26,32,44,13,10,6,31,4,54,40,22,27,106,107]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v,y,p,w,t,s,i,n,r,l,o,a,d,A,V,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ee;(function(pe){function W(M,F){if(M===F)return!0;const j=Object.keys(M),z=new Set;for(const B of Object.keys(F))z.add(B);if(j.length!==z.size)return!1;for(const B of j){if(M[B]!==F[B])return!1;z.delete(B)}return z.size===0}pe.equals=W})(ee=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let te=class extends c.Disposable{constructor(W,M,F,j,z,B,K,N,k,L,x,U){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=M,this.extensionsControlLocation=F,this.cacheLocation=j,this.userDataProfilesService=z,this.extensionsProfileScannerService=B,this.fileService=K,this.logService=N,this.environmentService=k,this.productService=L,this.uriIdentityService=x,this.instantiationService=U,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,m.joinPath)(this.cacheLocation,w.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,m.joinPath)(this.cacheLocation,w.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ie,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,M,F){const[j,z]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(M)]),B=F?await this.scanExtensionsUnderDevelopment(W,[...j,...z]):[];return this.dedupExtensions(j,z,B,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const M=[];M.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),M.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[F,j]=await Promise.all(M);return this.applyScanOptions([...F,...j],0,W,!1)}async scanUserExtensions(W){const M=W.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",M);const F=this.uriIdentityService.extUri.isEqual(W.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.createExtensionScannerInput(M,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,F),z=W.useCache&&!j.devMode&&j.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let B;try{B=await z.scanExtensions(j)}catch(K){if(K instanceof a.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),B=await z.scanExtensions(j);else throw K}return B=await this.applyScanOptions(B,1,W,!0),this.logService.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment(W,M){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(j=>j.scheme===I.Schemas.file).map(async j=>{const z=await this.createExtensionScannerInput(j,!1,1,!0,W.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(K=>(K.type=M.find(N=>(0,p.areSameExtensions)(N.identifier,K.identifier))?.type??K.type,this.extensionsScanner.validate(K,z)))}))).flat();return this.applyScanOptions(F,"development",W,!0)}return[]}async scanExistingExtension(W,M,F){const j=await this.createExtensionScannerInput(W,!1,M,!0,F.language,!0,void 0),z=await this.extensionsScanner.scanExtension(j);return!z||!F.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(W,M,F){const j=await this.createExtensionScannerInput(W,!1,M,!0,F.language,!0,void 0),z=await this.extensionsScanner.scanOneOrMultipleExtensions(j);return this.applyScanOptions(z,M,F,!0)}async scanMetadata(W){const M=(0,m.joinPath)(W,"package.json"),F=(await this.fileService.readFile(M)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(W,M){const F=(0,m.joinPath)(W,"package.json"),j=(await this.fileService.readFile(F)).value.toString(),z=JSON.parse(j);M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,z.__metadata={...z.__metadata,...M},await this.fileService.writeFile((0,m.joinPath)(W,"package.json"),C.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof a.ExtensionsProfileScanningError&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw W}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.extensionsProfileScannerService.addExtensionsToProfile(W.map(M=>[M,M.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(M){(0,s.toFileOperationResult)(M)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(M))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.logService.error(W)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(W,M,F,j){return F.includeAllVersions||(W=this.dedupExtensions(M===0?W:void 0,M===1?W:void 0,M==="development"?W:void 0,await this.getTargetPlatform(),j)),F.includeInvalid||(W=W.filter(z=>z.isValid)),W.sort((z,B)=>{const K=S.basename(z.location.fsPath),N=S.basename(B.location.fsPath);return K<N?-1:K>N?1:0})}dedupExtensions(W,M,F,j,z){const B=(N,k,L)=>{if(N.isValid&&!k.isValid)return!1;if(N.isValid===k.isValid){if(z&&P.gt(N.manifest.version,k.manifest.version))return this.logService.debug(`Skipping extension ${k.location.path} with lower version ${k.manifest.version} in favour of ${N.location.path} with version ${N.manifest.version}`),!1;if(P.eq(N.manifest.version,k.manifest.version)){if(N.type===0)return this.logService.debug(`Skipping extension ${k.location.path} in favour of system extension ${N.location.path} with same version`),!1;if(N.targetPlatform===j)return this.logService.debug(`Skipping extension ${k.location.path} from different target platform ${k.targetPlatform}`),!1}}return L?this.logService.warn(`Overwriting user extension ${N.location.path} with ${k.location.path}.`):this.logService.debug(`Overwriting user extension ${N.location.path} with ${k.location.path}.`),!0},K=new Map;return W?.forEach(N=>{const k=w.ExtensionIdentifier.toKey(N.identifier.id),L=K.get(k);(!L||B(L,N,!1))&&K.set(k,N)}),M?.forEach(N=>{const k=w.ExtensionIdentifier.toKey(N.identifier.id),L=K.get(k);if(!L&&W&&N.type===0){this.logService.debug(`Skipping obsolete system extension ${N.location.path}.`);return}(!L||B(L,N,!1))&&K.set(k,N)}),F?.forEach(N=>{const k=w.ExtensionIdentifier.toKey(N.identifier.id),L=K.get(k);(!L||B(L,N,!0))&&K.set(k,N),K.set(k,N)}),[...K.values()]}async scanDefaultSystemExtensions(W,M){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,M,!0,void 0),z=await(W&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(W,M){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const j=M?await this.getBuiltInExtensionControl():{},z=[],B=f.URI.file(S.normalize(S.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const N of F){const k=j[N.name]||"marketplace";switch(k){case"disabled":break;case"marketplace":z.push((0,m.joinPath)(B,N.name));break;default:z.push(f.URI.file(k));break}}const K=await Promise.all(z.map(async N=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(N,!1,0,!0,W,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",K.length),(0,O.coalesce)(K)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,M,F,j,z,B,K){const N=await this.getTranslations(z??h.language),k=await this.getMtime(W),L=M&&!this.uriIdentityService.extUri.isEqual(W,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,x=L?await this.getMtime(L):void 0;return new ne(W,k,L,x,M,K,F,j,B,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,N)}async getMtime(W){try{const M=await this.fileService.stat(W);if(typeof M.mtime=="number")return M.mtime}catch{}}};te=he([J(4,d.IUserDataProfilesService),J(5,a.IExtensionsProfileScannerService),J(6,s.IFileService),J(7,n.ILogService),J(8,y.IEnvironmentService),J(9,r.IProductService),J(10,A.IUriIdentityService),J(11,i.IInstantiationService)],te),e.AbstractExtensionsScannerService=te;class ne{constructor(W,M,F,j,z,B,K,N,k,L,x,U,q,G,re){this.location=W,this.mtime=M,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=j,this.profile=z,this.profileScanOptions=B,this.type=K,this.excludeObsolete=N,this.validate=k,this.productVersion=L,this.productDate=x,this.productCommit=U,this.devMode=q,this.language=G,this.translations=re}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,M){return(0,m.isEqual)(W.location,M.location)&&W.mtime===M.mtime&&(0,m.isEqual)(W.applicationExtensionslocation,M.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===M.applicationExtensionslocationMtime&&W.profile===M.profile&&b.equals(W.profileScanOptions,M.profileScanOptions)&&W.type===M.type&&W.excludeObsolete===M.excludeObsolete&&W.validate===M.validate&&W.productVersion===M.productVersion&&W.productDate===M.productDate&&W.productCommit===M.productCommit&&W.devMode===M.devMode&&W.language===M.language&&ee.equals(W.translations,M.translations)}}e.ExtensionScannerInput=ne;let ie=class extends c.Disposable{constructor(W,M,F,j,z){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=M,this.uriIdentityService=F,this.fileService=j,this.logService=z}async scanExtensions(W){const M=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let F={};if(W.excludeObsolete&&W.type===1)try{const j=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(j)}catch{}return(0,u.isEmptyObject)(F)?M:M.filter(j=>!F[p.ExtensionKey.create(j).toString()])}async scanExtensionsFromLocation(W){const M=await this.fileService.resolve(W.location);if(!M.children?.length)return[];const F=await Promise.all(M.children.map(async j=>{if(!j.isDirectory||W.type===1&&(0,m.basename)(j.resource).indexOf(".")===0)return null;const z=new ne(j.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(z)}));return(0,O.coalesce)(F).sort((j,z)=>j.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(W){let M=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){M=M.filter(j=>!j.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,j=>!!j.metadata?.isApplicationScoped,W);M.push(...F)}return M}async scanExtensionsFromProfileResource(W,M,F){const j=await this.extensionsProfileScannerService.scanProfileExtensions(W,F.profileScanOptions);if(!j.length)return[];const z=await Promise.all(j.map(async B=>{if(M(B)){const K=new ne(B.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(K,B.metadata)}return null}));return(0,O.coalesce)(z)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,m.joinPath)(W.location,"package.json"))){const M=await this.scanExtension(W);return M?[M]:[]}else return await this.scanExtensions(W)}catch(M){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,R.getErrorMessage)(M)),[]}}async scanExtension(W,M){try{let F=await this.scanExtensionManifest(W.location);if(F){F.publisher||(F.publisher=w.UNDEFINED_PUBLISHER),M=M??F.__metadata,delete F.__metadata;const j=(0,p.getGalleryExtensionId)(F.publisher,F.name),z=M?.id?{id:j,uuid:M.id}:{id:j},B=M?.isSystem?0:W.type,K=B===0||!!M?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(F),F=await this.translateManifest(W.location,F,ne.createNlsConfiguration(W));const N={type:B,identifier:z,manifest:F,location:W.location,isBuiltin:K,targetPlatform:M?.targetPlatform??"undefined",metadata:M,isValid:!0,validations:[]};return W.validate?this.validate(N,W):N}}catch(F){W.type!==0&&this.logService.error(F)}return null}validate(W,M){let F=!0;const j=(0,t.validateExtensionManifest)(M.productVersion,M.productDate,M.location,W.manifest,W.isBuiltin);for(const[z,B]of j)z===T.default.Error&&(F=!1,this.logService.error(this.formatMessage(M.location,B)));return W.isValid=F,W.validations=j,W}async scanExtensionManifest(W){const M=(0,m.joinPath)(W,"package.json");let F;try{F=(await this.fileService.readFile(M)).value.toString()}catch(z){return(0,s.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(W,(0,v.localize)(0,null,M.path,z.message))),null}let j;try{j=JSON.parse(F)}catch{const B=[];(0,E.parse)(F,B);for(const K of B)this.logService.error(this.formatMessage(W,(0,v.localize)(1,null,M.path,K.offset,K.length,(0,g.getParseErrorMessage)(K.error))));return null}return(0,E.getNodeType)(j)!=="object"?(this.logService.error(this.formatMessage(W,(0,v.localize)(2,null,M.path))),null):j}async translateManifest(W,M,F){const j=await this.getLocalizedMessages(W,M,F);if(j)try{const z=[],B=await this.resolveOriginalMessageBundle(j.default,z);if(z.length>0)return z.forEach(N=>{this.logService.error(this.formatMessage(W,(0,v.localize)(3,null,j.default?.path,(0,g.getParseErrorMessage)(N.error))))}),M;if((0,E.getNodeType)(j)!=="object")return this.logService.error(this.formatMessage(W,(0,v.localize)(4,null,j.default?.path))),M;const K=j.values||Object.create(null);return(0,V.localizeManifest)(M,K,B)}catch{}return M}async getLocalizedMessages(W,M,F){const j=(0,m.joinPath)(W,"package.nls.json"),z=(k,L)=>{L.forEach(x=>{this.logService.error(this.formatMessage(W,(0,v.localize)(5,null,k?.path,(0,g.getParseErrorMessage)(x.error))))})},B=k=>{this.logService.error(this.formatMessage(W,(0,v.localize)(6,null,k?.path)))},K=`${M.publisher}.${M.name}`,N=F.translations[K];if(N)try{const k=f.URI.file(N),L=(await this.fileService.readFile(k)).value.toString(),x=[],U=(0,E.parse)(L,x);return x.length>0?(z(k,x),{values:void 0,default:j}):(0,E.getNodeType)(U)!=="object"?(B(k),{values:void 0,default:j}):{values:U.contents?U.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.fileService.exists(j))return;let L;try{L=await this.findMessageBundles(W,F)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const x=(await this.fileService.readFile(L.localized)).value.toString(),U=[],q=(0,E.parse)(x,U);return U.length>0?(z(L.localized,U),{values:void 0,default:L.original}):(0,E.getNodeType)(q)!=="object"?(B(L.localized),{values:void 0,default:L.original}):{values:q,default:L.original}}catch{return{values:void 0,default:L.original}}}}async resolveOriginalMessageBundle(W,M){if(W)try{const F=(await this.fileService.readFile(W)).value.toString();return(0,E.parse)(F,M)}catch{}}findMessageBundles(W,M){return new Promise((F,j)=>{const z=B=>{const K=(0,m.joinPath)(W,`package.nls.${B}.json`);this.fileService.exists(K).then(N=>{N&&F({localized:K,original:(0,m.joinPath)(W,"package.nls.json")});const k=B.lastIndexOf("-");k===-1?F({localized:(0,m.joinPath)(W,"package.nls.json"),original:null}):(B=B.substring(0,k),z(B))})};if(M.devMode||M.pseudo||!M.language)return F({localized:(0,m.joinPath)(W,"package.nls.json"),original:null});z(M.language)})}formatMessage(W,M){return`[${W.path}]: ${M}`}};ie=he([J(1,a.IExtensionsProfileScannerService),J(2,A.IUriIdentityService),J(3,s.IFileService),J(4,n.ILogService)],ie);let ae=class extends ie{constructor(W,M,F,j,z,B){super(M,F,j,z,B),this.cacheFile=W,this.cacheValidatorThrottler=this._register(new D.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const M=await this.readExtensionCache();if(this.input=W,M&&M.input&&ne.equals(M.input,this.input))return this.logService.debug("Using cached extensions scan result",W.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),M.result.map(j=>(j.location=f.URI.revive(j.location),j));const F=await super.scanExtensions(W);return await this.writeExtensionCache({input:W,result:F}),F}async readExtensionCache(){try{const W=await this.fileService.readFile(this.cacheFile),M=JSON.parse(W.value.toString());return{result:M.result,input:(0,o.revive)(M.input)}}catch(W){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,R.getErrorMessage)(W))}return null}async writeExtensionCache(W){try{await this.fileService.writeFile(this.cacheFile,C.VSBuffer.fromString(JSON.stringify(W)))}catch(M){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,R.getErrorMessage)(M))}}async validateCache(){if(!this.input)return;const W=await this.readExtensionCache();if(!W)return;const M=W.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!b.equals(F,M))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(j){this.logService.error(j)}}};ae=he([J(2,a.IExtensionsProfileScannerService),J(3,A.IUriIdentityService),J(4,s.IFileService),J(5,n.ILogService)],ae);function fe(pe,W){const M=(0,p.getExtensionId)(pe.manifest.publisher,pe.manifest.name);return{id:M,identifier:new w.ExtensionIdentifier(M),isBuiltin:pe.type===0,isUserBuiltin:pe.type===1&&pe.isBuiltin,isUnderDevelopment:W,extensionLocation:pe.location,uuid:pe.identifier.uuid,targetPlatform:pe.targetPlatform,...pe.manifest}}e.toExtensionDescription=fe;class oe extends te{constructor(W,M,F,j,z,B,K,N,k,L,x,U){super(W,M,(0,m.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,m.joinPath)(j,w.MANIFEST_CACHE_FOLDER),z,B,K,N,k,L,x,U),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const q=await this.fileService.readFile(f.URI.file(h.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=oe}),define(Q[146],Z([0,1,58,5,33,4,2,16,15,20,6,22]),function($,e,O,D,b,C,R,E,g,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends R.Disposable{constructor(P,T){super(),this.userDataProfilesService=P,this.logService=T,this.processesLimiter=new D.Limiter(5)}async postUninstall(P){const T=this.parseScript(P,"uninstall");T&&(this.logService.info(P.identifier.id,P.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(T.script,"uninstall",T.args,!0,P),this.logService.info("Finished running post uninstall script",P.identifier.id,P.manifest.version)}catch(u){this.logService.error("Failed to run post uninstall script",P.identifier.id,P.manifest.version),this.logService.error(u)}}));try{await c.Promises.rm(this.getExtensionStoragePath(P))}catch(u){this.logService.error("Error while removing extension storage path",P.identifier.id),this.logService.error(u)}}parseScript(P,T){const u=`vscode:${T}`;if(P.location.scheme===E.Schemas.file&&P.manifest&&P.manifest.scripts&&typeof P.manifest.scripts[u]=="string"){const f=P.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(P.identifier.id,P.manifest.version,`${u} should be a node script`),null):{script:(0,g.join)(P.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(P,T,u,f,v){return new Promise((y,p)=>{const w=this.start(P,T,u,v);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?p(i):y(void 0)};w.on("error",i=>{s((0,b.toErrorMessage)(i)||"Unknown")}),w.on("exit",(i,n)=>{s(i?`post-${T} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,w.kill(),p("timed out")},5e3))})}start(P,T,u,f){const v={silent:!0,execArgv:void 0},y=(0,O.fork)(P,[`--type=extension-post-${T}`,...u],v);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=C.Event.fromNodeEventEmitter(y.stdout,"data"),w=C.Event.fromNodeEventEmitter(y.stderr,"data");p(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${T}`,i)),w(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${T}`,i));const t=C.Event.any(C.Event.map(p,i=>({data:`%c${i}`,format:[""]})),C.Event.map(w,i=>({data:`%c${i}`,format:["color: red"]})));return C.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(P){return(0,g.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,P.identifier.id.toLowerCase())}};h=he([J(0,S.IUserDataProfilesService),J(1,I.ILogService)],h),e.ExtensionsLifecycle=h}),define(Q[147],Z([0,1,6,22,27,25,40,13,17,11]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends R.AbstractExtensionsProfileScannerService{constructor(h,m,P,T,u,f){super(c.URI.file(h.extensionsPath),m,P,T,u,f)}};I=he([J(0,g.INativeEnvironmentService),J(1,E.IFileService),J(2,D.IUserDataProfilesService),J(3,b.IUriIdentityService),J(4,C.ITelemetryService),J(5,O.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(Q[148],Z([0,1,11,17,40,47,13,10,6,31,27,22]),function($,e,O,D,b,C,R,E,g,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let h=class extends C.NativeExtensionsScannerService{constructor(P,T,u,f,v,y,p,w){super(O.URI.file(v.builtinExtensionsPath),O.URI.file(v.extensionsPath),v.userHome,O.URI.file(v.userDataPath),P,T,u,f,v,y,p,w)}};h=he([J(0,S.IUserDataProfilesService),J(1,b.IExtensionsProfileScannerService),J(2,R.IFileService),J(3,g.ILogService),J(4,D.INativeEnvironmentService),J(5,c.IProductService),J(6,I.IUriIdentityService),J(7,E.IInstantiationService)],h),e.ExtensionsScannerService=h}),define(Q[149],Z([0,1,5,4,2,117,3,84,10,22]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var I;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var h;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(h=e.StorageTarget||(e.StorageTarget={}));function m(v){const y=v.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=m;class P extends b.Disposable{constructor(y={flushInterval:P.DEFAULT_FLUSH_INTERVAL}){super(),this.options=y,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,p){if(p===e.TARGET_KEY){switch(y){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:y})}else this._onDidChangeValue.fire({scope:y,key:p,target:this.getKeyTargets(y)[p]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,p,w){return this.getStorage(p)?.get(y,w)}getBoolean(y,p,w){return this.getStorage(p)?.getBoolean(y,w)}getNumber(y,p,w){return this.getStorage(p)?.getNumber(y,w)}store(y,p,w,t){if((0,R.isUndefinedOrNull)(p)){this.remove(y,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,w,t),this.getStorage(w)?.set(y,p)})}remove(y,p){this.withPausedEmitters(()=>{this.updateKeyTarget(y,p,void 0),this.getStorage(p)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,p){const w=[],t=this.getKeyTargets(y);for(const s of Object.keys(t))t[s]===p&&w.push(s);return w}updateKeyTarget(y,p,w){const t=this.getKeyTargets(p);typeof w=="number"?t[y]!==w&&(t[y]=w,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[y]=="number"&&(delete t[y],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(y){switch(y){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(y){const p=this.getStorage(y);return p?m(p):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=I.NONE){this._onWillSaveState.fire({reason:y});const p=this.getStorage(-1),w=this.getStorage(0),t=this.getStorage(1);switch(y){case I.NONE:await O.Promises.settled([p?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await O.Promises.settled([p?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return f(y,p,w,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(y,p){return this.emitWillSaveState(I.NONE),(0,c.isUserDataProfile)(y)?this.switchToProfile(y,p):this.switchToWorkspace(y,p)}canSwitchProfile(y,p){return!(y.id===p.id||T(p)&&T(y))}switchData(y,p,w,t){this.withPausedEmitters(()=>{if(t)for(const[s,i]of y)p.set(s,i);else{const s=new Set;for(const[i,n]of y)s.add(i),p.get(i)!==n&&this.emitDidChangeValue(w,i);for(const[i]of p.items)s.has(i)||this.emitDidChangeValue(w,i)}})}}P.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=P;function T(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=T;class u extends P{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.profileStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y))),this._register(this.applicationStorage.onDidChangeStorage(y=>this.emitDidChangeValue(-1,y)))}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(y){return!1}}e.InMemoryStorageService=u;async function f(v,y,p,w,t,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;v.forEach((Y,ee)=>{n.set(ee,Y),r.set(ee,i(Y))});const l=new Map,o=new Map;y.forEach((Y,ee)=>{l.set(ee,Y),o.set(ee,i(Y))});const a=new Map,d=new Map;p.forEach((Y,ee)=>{a.set(ee,Y),d.set(ee,i(Y))}),console.group(w!==t?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const A=[];if(n.forEach((Y,ee)=>{A.push({key:ee,value:Y})}),console.table(A),console.groupEnd(),console.log(r),w!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];l.forEach((ee,te)=>{Y.push({key:te,value:ee})}),console.table(Y),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const V=[];a.forEach((Y,ee)=>{V.push({key:ee,value:Y})}),console.table(V),console.groupEnd(),console.log(d)}e.logStorage=f}),define(Q[150],Z([0,1,19,23,7,12,37,3,11,24,17,21,26,44,13,6,31,46,135,149,25]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const w=C.isWeb?"web":(0,S.getTargetPlatform)(C.platform,R.arch),t="X-Market-Search-Activity-Id";var s;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...k){return String(k.reduce((L,x)=>L|x,0))}var n;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class d{constructor(L=a){this.state=L}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(L,x=this.state.pageSize){return new d({...this.state,pageNumber:L,pageSize:x})}withFilter(L,...x){const U=[...this.state.criteria,...x.length?x.map(q=>({filterType:L,value:q})):[{filterType:L}]];return new d({...this.state,criteria:U})}withSortBy(L){return new d({...this.state,sortBy:L})}withSortOrder(L){return new d({...this.state,sortOrder:L})}withFlags(...L){return new d({...this.state,flags:L.reduce((x,U)=>x|U,0)})}withAssetTypes(...L){return new d({...this.state,assetTypes:L})}withSource(L){return new d({...this.state,source:L})}get raw(){const{criteria:L,pageNumber:x,pageSize:U,sortBy:q,sortOrder:G,flags:re,assetTypes:le}=this.state;return{filters:[{criteria:L,pageNumber:x,pageSize:U,sortBy:q,sortOrder:G}],assetTypes:le,flags:re}}get searchText(){const L=this.state.criteria.filter(x=>x.filterType===n.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(L=>String(L.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function A(k,L){const x=(k||[]).filter(U=>U.statisticName===L)[0];return x?x.value:0}function V(k){const L="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(U=>U.assetType.indexOf(L)===0).reduce((U,q)=>{const G=te(k,q.assetType);return G&&U.push([q.assetType.substring(L.length),G]),U},[])}function Y(k){if(k.properties){const L=k.properties.filter(q=>q.key===r.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=L.filter(q=>x.test(q.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return te(k,r.Repository)}function ee(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function te(k,L){return k.files.filter(U=>U.assetType===L)[0]?{uri:`${k.assetUri}/${L}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${L}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function ne(k,L){const x=k.properties?k.properties.filter(q=>q.key===L):[],U=x.length>0&&x[0].value;return U?U.split(",").map(q=>(0,h.adoptToGalleryExtensionId)(q)):[]}function ie(k){const L=k.properties?k.properties.filter(x=>x.key===l.Engine):[];return L.length>0&&L[0].value||""}function ae(k){const L=k.properties?k.properties.filter(x=>x.key===l.PreRelease):[];return L.length>0&&L[0].value==="true"}function fe(k){const L=k.properties?k.properties.filter(U=>U.key===l.LocalizedLanguages):[],x=L.length>0&&L[0].value||"";return x?x.split(","):[]}function oe(k){return k.properties?.find(L=>L.key===l.SponsorLink)?.value}function pe(k){return k.indexOf("preview")!==-1}function W(k){return k.targetPlatform?(0,S.toTargetPlatform)(k.targetPlatform):"undefined"}function M(k){const L=(0,O.distinct)(k.versions.map(W)),x=!!k.tags?.includes(S.WEB_EXTENSION_TAG),U=L.indexOf("web");return x?U===-1&&L.push("web"):U!==-1&&L.splice(U,1),L}function F(k,L){const x=(0,S.getFallbackTargetPlarforms)(L);for(let U=0;U<k.length;U++){const q=k[U];if(q.version===k[U-1]?.version){let G=U;const re=W(q);if(re===L)for(;G>0&&k[G-1].version===q.version;)G--;else if(x.includes(re))for(;G>0&&k[G-1].version===q.version&&W(k[G-1])!==L;)G--;G!==U&&(k.splice(U,1),k.splice(G,0,q))}}return k}e.sortExtensionVersions=F;function j(k,L,x){k.telemetryData={index:L,querySource:x,queryActivityId:k.queryContext?.[t]}}function z(k,L,x,U){const q=k.versions[0],G={manifest:te(L,r.Manifest),readme:te(L,r.Details),changelog:te(L,r.Changelog),license:te(L,r.License),repository:Y(L),download:ee(L),icon:te(L,r.Icon),signature:te(L,r.Signature),coreTranslations:V(L)};return{identifier:{id:(0,h.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:L.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:oe(q),description:k.shortDescription||"",installCount:A(k.statistics,"install"),rating:A(k.statistics,"averagerating"),ratingCount:A(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:x,assets:G,properties:{dependencies:ne(L,l.Dependency),extensionPack:ne(L,l.ExtensionPack),engine:ie(L),localizedLanguages:fe(L),targetPlatform:W(L),isPreReleaseVersion:ae(L)},hasPreReleaseVersion:ae(q),hasReleaseVersion:!0,preview:pe(k.flags),isSigned:!!G.signature,queryContext:U}}let B=class{constructor(L,x,U,q,G,re,le,Se){this.requestService=x,this.logService=U,this.environmentService=q,this.telemetryService=G,this.fileService=re,this.productService=le,this.configurationService=Se;const me=le.extensionsGallery,ce=me?.servicePPEUrl&&Se.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ce?me.servicePPEUrl:me?.serviceUrl,this.extensionsGallerySearchUrl=ce?void 0:me?.searchUrl,this.extensionsControlUrl=me?.controlUrl,this.commonHeadersPromise=(0,v.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,L,this.telemetryService)}api(L=""){return`${this.extensionsGalleryUrl}${L}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(L,x,U){const q=D.CancellationToken.isCancellationToken(x)?{}:x,G=D.CancellationToken.isCancellationToken(x)?x:U,re=[],le=[],Se=[],me=[];let ce=!0;for(const ue of L){ue.uuid?le.push(ue.uuid):re.push(ue.id);const Ee=!!(ue.version||ue.preRelease);Se.push({id:ue.id,uuid:ue.uuid,includePreRelease:Ee}),ue.version&&me.push({id:ue.id,uuid:ue.uuid,version:ue.version}),ce=ce&&!!ue.hasPreRelease&&!Ee}if(!le.length&&!re.length)return[];let ge=new d().withPage(1,L.length);le.length&&(ge=ge.withFilter(n.ExtensionId,...le)),re.length&&(ge=ge.withFilter(n.ExtensionName,...re)),(q.queryAllVersions||ce)&&(ge=ge.withFlags(ge.flags,s.IncludeVersions)),q.source&&(ge=ge.withSource(q.source));const{extensions:se}=await this.queryGalleryExtensions(ge,{targetPlatform:q.targetPlatform??w,includePreRelease:Se,versions:me,compatible:!!q.compatible},G);return q.source&&se.forEach((ue,Ee)=>j(ue,Ee,q.source)),se}async getCompatibleExtension(L,x,U){if((0,S.isNotWebExtensionInWebTargetPlatform)(L.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(L,x,U))return L;const q=new d().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,L.identifier.uuid),{extensions:G}=await this.queryGalleryExtensions(q,{targetPlatform:U,compatible:!0,includePreRelease:x},D.CancellationToken.None);return G[0]||null}async isExtensionCompatible(L,x,U){if(!(0,S.isTargetPlatformCompatible)(L.properties.targetPlatform,L.allTargetPlatforms,U)||!x&&L.properties.isPreReleaseVersion)return!1;let q=L.properties.engine;if(!q){const G=await this.getManifest(L,D.CancellationToken.None);if(!G)throw new Error("Manifest was not found");q=G.engines.vscode}return(0,m.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(L,x,U,q,G){if(!(0,S.isTargetPlatformCompatible)(W(L),q,G)||x!=="any"&&ae(L)!==(x==="prerelease"))return!1;if(U)try{const re=await this.getEngine(L);if(!(0,m.isEngineValid)(re,this.productService.version,this.productService.date))return!1}catch(re){return this.logService.error(`Error while getting the engine for the version ${L.version}.`,(0,b.getErrorMessage)(re)),!1}return!0}async query(L,x){let U=L.text||"";const q=L.pageSize??50;let G=new d().withPage(1,q);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,ge,se)=>(G=G.withFilter(n.Category,se||ge),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,ge,se)=>(G=G.withFilter(n.Tag,se||ge),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),G=G.withFilter(n.SearchText,U)),G=G.withSortBy(0)):L.ids?G=G.withFilter(n.ExtensionId,...L.ids):L.names?G=G.withFilter(n.ExtensionName,...L.names):G=G.withSortBy(4),typeof L.sortBy=="number"&&(G=G.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(G=G.withSortOrder(L.sortOrder)),L.source&&(G=G.withSource(L.source));const re=async(ce,ge)=>{const{extensions:se,total:ue}=await this.queryGalleryExtensions(ce,{targetPlatform:w,compatible:!1,includePreRelease:!!L.includePreRelease},ge);return se.forEach((Ee,be)=>j(Ee,(ce.pageNumber-1)*ce.pageSize+be,L.source)),{extensions:se,total:ue}},{extensions:le,total:Se}=await re(G,x),me=async(ce,ge)=>{if(ge.isCancellationRequested)throw new b.CancellationError;const{extensions:se}=await re(G.withPage(ce+1),ge);return se};return{firstPage:le,total:Se,pageSize:G.pageSize,getPage:me}}async queryGalleryExtensions(L,x,U){const q=L.flags;!!(L.flags&s.IncludeLatestVersionOnly)&&!!(L.flags&s.IncludeVersions)&&(L=L.withFlags(L.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(L.flags&s.IncludeLatestVersionOnly)&&!(L.flags&s.IncludeVersions)&&(L=L.withFlags(L.flags,s.IncludeLatestVersionOnly)),x.versions?.length&&(L=L.withFlags(L.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),L=L.withFlags(L.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:G,total:re,context:le}=await this.queryRawGalleryExtensions(L,U);if(!(L.flags&s.IncludeLatestVersionOnly)){const ge=[];for(const se of G){const ue=await this.toGalleryExtensionWithCriteria(se,x,le);ue&&ge.push(ue)}return{extensions:ge,total:re}}const me=[],ce=new Map;for(let ge=0;ge<G.length;ge++){const se=G[ge],ue={id:(0,h.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},Ee=(0,E.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Me=>(0,h.areSameExtensions)(Me,ue))?.includePreRelease;if(x.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(M(se),x.targetPlatform))continue;const be=await this.toGalleryExtensionWithCriteria(se,x,le);!be||be.properties.isPreReleaseVersion&&(!Ee||!be.hasReleaseVersion)||!be.properties.isPreReleaseVersion&&be.properties.targetPlatform!==x.targetPlatform&&be.hasPreReleaseVersion?ce.set(se.extensionId,ge):me.push([ge,be])}if(ce.size){const ge=new Date().getTime(),se=new d().withFlags(q&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ce.size).withFilter(n.ExtensionId,...ce.keys()),{extensions:ue}=await this.queryGalleryExtensions(se,x,U);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ce.size});for(const Ee of ue){const be=ce.get(Ee.identifier.uuid);me.push([be,Ee])}}return{extensions:me.sort((ge,se)=>ge[0]-se[0]).map(([,ge])=>ge),total:re}}async toGalleryExtensionWithCriteria(L,x,U){const q={id:(0,h.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},G=x.versions?.find(me=>(0,h.areSameExtensions)(me,q))?.version,re=(0,E.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(me=>(0,h.areSameExtensions)(me,q))?.includePreRelease,le=M(L),Se=F(L.versions,x.targetPlatform);if(x.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(le,x.targetPlatform))return null;for(let me=0;me<Se.length;me++){const ce=Se[me];if(!(G&&ce.version!==G)){if(await this.isValidVersion(ce,re?"any":"release",x.compatible,le,x.targetPlatform))return z(L,ce,le,U);if(G&&ce.version===G)return null}}return G||x.compatible?null:z(L,L.versions[0],le)}async queryRawGalleryExtensions(L,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const U=await this.commonHeadersPromise,q=JSON.stringify(L.raw),G={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},re=new Date().getTime();let le,Se,me=0;try{if(le=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&L.criteria.some(ge=>ge.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:G},x),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:me};const ce=await(0,f.asJson)(le);if(ce){const ge=ce.results[0],se=ge.extensions,ue=ge.resultMetadata&&ge.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return me=ue&&ue.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:me,context:{[t]:le.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ce){throw Se=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-re,success:!!le&&(0,f.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:Se?(0,b.isCancellationError)(Se)?"canceled":(0,b.getErrorMessage)(Se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(L,x,U,q){if(!this.isEnabled())return;const G=C.isWeb?this.api(`/itemName/${L}.${x}/version/${U}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${L}/extensions/${x}/${U}/stats?statType=${q}`),re=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Se={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:G,headers:Se},D.CancellationToken.None)}catch{}}async download(L,x,U){this.logService.trace("ExtensionGalleryService#download",L.identifier.id);const q=(0,h.getGalleryExtensionTelemetryData)(L),G=new Date().getTime(),re=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:ge}),le=U===2?"install":U===3?"update":"",Se=le?{uri:`${L.assets.download.uri}${g.URI.parse(L.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${L.assets.download.fallbackUri}${g.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:L.assets.download,me=L.queryContext?.[t]?{[t]:L.queryContext[t]}:void 0,ce=await this.getAsset(Se,me?{headers:me}:void 0);await this.fileService.writeFile(x,ce.stream),re(new Date().getTime()-G)}async downloadSignatureArchive(L,x){if(!L.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const U=await this.getAsset(L.assets.signature);await this.fileService.writeFile(x,U.stream)}async getReadme(L,x){if(L.assets.readme){const U=await this.getAsset(L.assets.readme,{},x);return await(0,f.asTextOrError)(U)||""}return""}async getManifest(L,x){if(L.assets.manifest){const U=await this.getAsset(L.assets.manifest,{},x),q=await(0,f.asTextOrError)(U);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(L,x){const U=te(L,r.Manifest);if(!U)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},G=await this.getAsset(U,{headers:q});return await(0,f.asJson)(G)}async getCoreTranslation(L,x){const U=L.assets.coreTranslations.filter(q=>q[0]===x.toUpperCase())[0];if(U){const q=await this.getAsset(U[1]),G=await(0,f.asTextOrError)(q);return G?JSON.parse(G):null}return null}async getChangelog(L,x){if(L.assets.changelog){const U=await this.getAsset(L.assets.changelog,{},x);return await(0,f.asTextOrError)(U)||""}return""}async getAllCompatibleVersions(L,x,U){let q=new d().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?q=q.withFilter(n.ExtensionId,L.identifier.uuid):q=q.withFilter(n.ExtensionName,L.identifier.id);const{galleryExtensions:G}=await this.queryRawGalleryExtensions(q,D.CancellationToken.None);if(!G.length)return[];const re=M(G[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(re,U))return[];const le=[];await Promise.all(G[0].versions.map(async ce=>{try{await this.isValidVersion(ce,x?"any":"release",!0,re,U)&&le.push(ce)}catch{}}));const Se=[],me=new Set;for(const ce of F(le,U))me.has(ce.version)||(me.add(ce.version),Se.push({version:ce.version,date:ce.lastUpdated,isPreReleaseVersion:ae(ce)}));return Se}async getAsset(L,x={},U=D.CancellationToken.None){const q=await this.commonHeadersPromise,G={type:"GET"},re={...q,...x.headers||{}};x={...x,...G,headers:re};const le=L.uri,Se=L.fallbackUri,me={...x,url:le};try{const ce=await this.requestService.request(me,U);if(ce.res.statusCode===200)return ce;const ge=await(0,f.asTextOrError)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ge}`)}catch(ce){if((0,b.isCancellationError)(ce))throw ce;const ge=(0,b.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:ge});const se={...x,url:Se};return this.requestService.request(se,U)}}async getEngine(L){let x=ie(L);if(!x){const U=await this.getManifestFromRawExtensionVersion(L,D.CancellationToken.None);if(!U)throw new Error("Manifest was not found");x=U.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const L=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,f.asJson)(L),U=[],q={};if(x){for(const G of x.malicious)U.push({id:G});if(x.migrateToPreRelease)for(const[G,re]of Object.entries(x.migrateToPreRelease))(!re.engine||(0,m.isEngineValid)(re.engine,this.productService.version,this.productService.date))&&(q[G.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[G,re]of Object.entries(x.deprecated))re&&(q[G.toLowerCase()]=(0,E.isBoolean)(re)?{}:re)}return{malicious:U,deprecated:q}}};B=he([J(1,f.IRequestService),J(2,T.ILogService),J(3,I.IEnvironmentService),J(4,p.ITelemetryService),J(5,P.IFileService),J(6,u.IProductService),J(7,c.IConfigurationService)],B);let K=class extends B{constructor(L,x,U,q,G,re,le,Se){super(L,x,U,q,G,re,le,Se)}};K=he([J(0,y.IStorageService),J(1,f.IRequestService),J(2,T.ILogService),J(3,I.IEnvironmentService),J(4,p.ITelemetryService),J(5,P.IFileService),J(6,u.IProductService),J(7,c.IConfigurationService)],K),e.ExtensionGalleryService=K;let N=class extends B{constructor(L,x,U,q,G,re,le){super(void 0,L,x,U,q,G,re,le)}};N=he([J(0,f.IRequestService),J(1,T.ILogService),J(2,I.IEnvironmentService),J(3,p.ITelemetryService),J(4,P.IFileService),J(5,u.IProductService),J(6,c.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N}),define(Q[151],Z([0,1,11,17,13,6,132,27,22,3,68]),function($,e,O,D,b,C,R,E,g,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let S=class je extends g.UserDataProfilesService{constructor(T,u,f,v,y){super(f,v,u,y),this.stateReadonlyService=T,this.nativeEnvironmentService=f}getStoredProfiles(){return this.stateReadonlyService.getItem(je.PROFILES_KEY,[]).map(u=>({...u,location:(0,c.isString)(u.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,u.location):O.URI.revive(u.location)}))}getStoredProfileAssociations(){const T=this.stateReadonlyService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(je.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?T:this.migrateStoredProfileAssociations(T)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(O.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",S=he([J(0,R.IStateReadService),J(1,E.IUriIdentityService),J(2,D.INativeEnvironmentService),J(3,b.IFileService),J(4,C.ILogService)],S),e.UserDataProfilesReadonlyService=S;let h=class _e extends S{constructor(T,u,f,v,y){super(T,u,f,v,y),this.stateService=T}saveStoredProfiles(T){T.length?this.stateService.setItem(_e.PROFILES_KEY,T.map(u=>({...u,location:this.uriIdentityService.extUri.basename(u.location)}))):this.stateService.removeItem(_e.PROFILES_KEY)}getStoredProfiles(){const T=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(T),this.stateService.setItem("userDataProfilesMigration",!0)),T}saveStoredProfileAssociations(T){T.emptyWindows||T.workspaces?this.stateService.setItem(_e.PROFILE_ASSOCIATIONS_KEY,T):this.stateService.removeItem(_e.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const T="workspaceAndProfileInfo",u=this.stateService.getItem(T,void 0);if(u){this.stateService.removeItem(T);const v=u.reduce((y,{workspace:p,profile:w})=>(y[O.URI.revive(p).toString()]=O.URI.revive(w).toString(),y),{});this.stateService.setItem(_e.PROFILE_ASSOCIATIONS_KEY,{workspaces:v})}const f=super.getStoredProfileAssociations();return this.stateService.getItem(_e.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(f),this.stateService.setItem(_e.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),f}};h=he([J(0,R.IStateService),J(1,E.IUriIdentityService),J(2,D.INativeEnvironmentService),J(3,b.IFileService),J(4,C.ILogService)],h),e.UserDataProfilesService=h;let m=class extends h{constructor(T,u,f,v){super(new I.StateService(0,u,v,f),T,u,f,v)}async init(){return await this.stateService.init(),super.init()}};m=he([J(0,E.IUriIdentityService),J(1,D.INativeEnvironmentService),J(2,b.IFileService),J(3,C.ILogService)],m),e.ServerUserDataProfilesService=m}),define(Q[48],Z([0,1,119,5,15,3,20,85,166,167]),function($,e,O,D,b,C,R,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class S extends Error{constructor(s,i){let n=i.message;switch(s){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=s,this.cause=i}}e.ExtractError=S;function h(t){const s=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>s&i).reduce((i,n)=>i+n,s&61440)}function m(t){if(t instanceof S)return t;let s;return I.test(t.message)&&(s="CorruptZip"),new S(s,t)}function P(t,s,i,n,r,l){const o=b.dirname(s),a=b.join(n,o);if(!a.startsWith(n))return Promise.reject(new Error(E.localize(0,null,s)));const d=b.join(n,s);let A;return l.onCancellationRequested(()=>{A?.destroy()}),Promise.resolve(R.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((V,Y)=>{if(!l.isCancellationRequested)try{A=(0,O.createWriteStream)(d,{mode:i}),A.once("close",()=>V()),A.once("error",Y),t.once("error",Y),t.pipe(A)}catch(ee){Y(ee)}}))}function T(t,s,i,n){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((o,a)=>{const d=new D.Sequencer,A=V=>{V.isCancellationRequested||(l++,t.readEntry())};t.once("error",a),t.once("close",()=>r.then(()=>{n.isCancellationRequested||t.entryCount===l?o():a(new S("Incomplete",new Error(E.localize(1,null,l,t.entryCount))))},a)),t.readEntry(),t.on("entry",V=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(V.fileName)){A(n);return}const Y=V.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(Y)){const ne=b.join(s,Y);r=(0,D.createCancelablePromise)(ie=>R.Promises.mkdir(ne,{recursive:!0}).then(()=>A(ie)).then(void 0,a));return}const ee=f(t,V),te=h(V);r=(0,D.createCancelablePromise)(ne=>d.queue(()=>ee.then(ie=>P(ie,Y,te,s,i,ne).then(()=>A(ne)))).then(null,a))})})}function u(t,s=!1){return new Promise((i,n)=>{(0,g.open)(t,s?{lazyEntries:!0}:void 0,(r,l)=>{r?n(m(r)):i((0,C.assertIsDefined)(l))})})}function f(t,s){return new Promise((i,n)=>{t.openReadStream(s,(r,l)=>{r?n(m(r)):i((0,C.assertIsDefined)(l))})})}function v(t,s){return new Promise((i,n)=>{const r=new c.ZipFile;s.forEach(o=>{o.contents?r.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&r.addFile(o.localPath,o.path)}),r.end();const l=(0,O.createWriteStream)(t);r.outputStream.pipe(l),r.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(t))})}e.zip=v;function y(t,s,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=u(t,!0);return i.overwrite&&(l=l.then(o=>R.Promises.rm(s).then(()=>o))),l.then(o=>T(o,s,{sourcePathRegex:r},n))}e.extract=y;function p(t,s){return u(t).then(i=>new Promise((n,r)=>{i.on("entry",l=>{l.fileName===s&&f(i,l).then(o=>n(o),o=>r(o))}),i.once("close",()=>r(new Error(E.localize(2,null,s))))}))}function w(t,s){return p(t,s).then(i=>new Promise((n,r)=>{const l=[];i.once("error",r),i.on("data",o=>l.push(o)),i.on("end",()=>n(Buffer.concat(l)))}))}e.buffer=w}),define(Q[152],Z([0,1,5,7,2,16,12,18,41,3,29,20,48,24,17,21,26,60,13,6]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class ze extends b.Disposable{constructor(t,s,i,n,r,l){super(),this.fileService=s,this.extensionGalleryService=i,this.configurationService=n,this.extensionSignatureVerificationService=r,this.logService=l,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,s){await this.cleanUpPromise;const i=(0,E.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,i,r=>this.extensionGalleryService.download(t,r,s))}catch(r){throw new T.ExtensionManagementError(r.message,T.ExtensionManagementErrorCode.Download)}let n="Unverified";if(this.shouldVerifySignature(t)){const r=await this.downloadSignatureArchive(t);try{await this.extensionSignatureVerificationService.verify(i.fsPath,r.fsPath,this.logService.getLevel()===y.LogLevel.Trace)&&(n="Verified"),this.logService.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(l){const o=l,a=o.code;if(o.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${o.output}`),a==="UnknownError")n="UnknownError",this.logService.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else{if(a==="PackageIsInvalidZip"||a==="SignatureArchiveIsInvalidZip")throw new T.ExtensionManagementError(h.CorruptZipMessage,T.ExtensionManagementErrorCode.CorruptZip);if(!o.didExecute)this.logService.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n} (${a})`);else throw await this.delete(i),new T.ExtensionManagementError(a,T.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(r)}catch(l){this.logService.error(l)}}}return{location:i,verificationStatus:n}}shouldVerifySignature(t){if(!t.isSigned)return!1;const s=this.configurationService.getValue("extensions.verifySignature");return(0,c.isBoolean)(s)?s:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const s=(0,E.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${ze.SignatureArchiveExtension}`);return await this.downloadFile(t,s,i=>this.extensionGalleryService.downloadSignatureArchive(t,i)),s}async downloadFile(t,s,i){if(await this.fileService.exists(s))return;if(s.scheme!==C.Schemas.file){await i(s);return}const n=(0,E.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(n)||await i(n);try{await this.rename(n,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async rename(t,s,i){try{await S.Promises.rename(t.fsPath,s.fsPath)}catch(n){if(R.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${t} to ${s} with 'EPERM' error. Trying again...`),this.rename(t,s,i);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],i=[],n=[];for(const o of t.children)if(o.name.endsWith(ze.SignatureArchiveExtension))n.push(o.resource);else{const a=u.ExtensionKey.parse(o.name);a&&i.push([a,o])}const r=(0,u.groupByExtension)(i,([o])=>o),l=[];for(const o of r)o.sort((a,d)=>g.rcompare(a[0].version,d[0].version)),s.push(...o.slice(1).map(a=>a[1].resource)),l.push(o[0][1]);l.sort((o,a)=>o.mtime-a.mtime),s.push(...l.slice(0,Math.max(0,l.length-this.cache)).map(o=>o.resource)),s.push(...n),await O.Promises.settled(s.map(o=>(this.logService.trace("Deleting from cache",o.path),this.fileService.del(o))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?u.ExtensionKey.create(t).toString().toLowerCase():(0,I.generateUuid)()}};p.SignatureArchiveExtension=".sigzip",p=he([J(0,P.INativeEnvironmentService),J(1,v.IFileService),J(2,T.IExtensionGalleryService),J(3,m.IConfigurationService),J(4,f.IExtensionSignatureVerificationService),J(5,y.ILogService)],p),e.ExtensionsDownloader=p}),define(Q[153],Z([0,1,48,93]),function($,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function b(C){return(0,O.buffer)(C,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.getManifest=b}),define(Q[154],Z([0,1,5,14,23,33,7,4,2,34,16,15,12,18,41,3,11,29,20,48,92,59,17,145,21,26,40,47,152,146,153,127,134,32,44,13,10,6,31,25,27,22]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v,y,p,w,t,s,i,n,r,l,o,a,d,A,V,Y,ee,te,ne,ie,ae,fe,oe,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ne.refineServiceDecorator)(i.IExtensionManagementService);let W=class extends s.AbstractExtensionManagementService{constructor(N,k,L,x,U,q,G,re,le,Se,me,ce){super(N,k,L,Se,ce),this.extensionsScannerService=U,this.extensionsProfileScannerService=q,this.downloadService=G,this.fileService=le,this.uriIdentityService=me,this._onDidUpdateExtensionMetadata=this._register(new E.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new c.ResourceSet;const ge=this._register(re.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(re.createInstance(M,ue=>ge.postUninstall(ue))),this.manifestCache=this._register(new A.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(re.createInstance(o.ExtensionsDownloader));const se=this._register(new V.ExtensionsWatcher(this,this.extensionsScannerService,ce,q,me,le,L));this._register(se.onDidChangeExtensionsByAnotherSource(ue=>this.onDidChangeExtensionsFromAnotherSource(ue))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(N){this.logService.trace("ExtensionManagementService#zip",N.identifier.id);const k=await this.collectFiles(N),L=await(0,y.zip)((0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,k);return u.URI.file(L)}async unzip(N){return this.logService.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const{location:k,cleanup:L}=await this.downloadVsix(N),x=S.resolve(k.fsPath);try{return await(0,d.getManifest)(x)}finally{await L()}}getInstalled(N,k=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(N??null,k)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(N){return this.extensionsScanner.scanUserExtensionAtLocation(N)}async install(N,k={}){this.logService.trace("ExtensionManagementService#install",N.toString());const{location:L,cleanup:x}=await this.downloadVsix(N);try{const U=await(0,d.getManifest)(S.resolve(L.fsPath));if(U.engines&&U.engines.vscode&&!(0,ee.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,(0,n.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return await this.installExtension(U,L,k)}finally{await x()}}async installFromLocation(N,k){this.logService.trace("ExtensionManagementService#installFromLocation",N.toString());const L=await this.extensionsScanner.scanUserExtensionAtLocation(N);if(!L)throw new Error(`Cannot find a valid extension from the location ${N.toString()}`);return await this.addExtensionsToProfile([[L,void 0]],k),this.logService.info("Successfully installed extension",L.identifier.id,k.toString()),L}async installExtensionsFromProfile(N,k,L){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",N,k.toString(),L.toString());const x=(await this.extensionsScanner.scanExtensions(1,k)).filter(U=>N.some(q=>(0,n.areSameExtensions)(q,U.identifier)));if(x.length){const U=await Promise.all(x.map(q=>this.extensionsScanner.scanMetadata(q,k)));await this.addExtensionsToProfile(x.map((q,G)=>[q,U[G]]),L),this.logService.info("Successfully installed extensions",x.map(q=>q.identifier.id),L.toString())}return x}async updateMetadata(N,k,L=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",N.identifier.id),k.isPreReleaseVersion&&(k.preRelease=!0),k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.pinned=k.pinned||void 0,N=await this.extensionsScanner.updateMetadata(N,k,L),this.manifestCache.invalidate(),this._onDidUpdateExtensionMetadata.fire(N),N}async reinstallFromGallery(N){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",N.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const k=await this.getTargetPlatform(),[L]=await this.galleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],{targetPlatform:k,compatible:!0},b.CancellationToken.None);if(!L)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(N);try{await this.extensionsScanner.removeUninstalledExtension(N)}catch(x){throw new Error(p.localize(3,null,(0,C.toErrorMessage)(x)))}return this.installFromGallery(L)}copyExtensions(N,k){return this.extensionsScanner.copyExtensions(N,k)}markAsUninstalled(...N){return this.extensionsScanner.setUninstalled(...N)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(N){this.logService.error(N)}}async download(N,k){const{location:L}=await this.extensionsDownloader.download(N,k);return L}async downloadVsix(N){if(N.scheme===I.Schemas.file)return{location:N,async cleanup(){}};this.logService.trace("Downloading extension from",N.toString());const k=(0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)());return await this.downloadService.download(N,k),this.logService.info("Downloaded extension to",k.toString()),{location:k,cleanup:async()=>{try{await this.fileService.del(k)}catch(x){this.logService.error(x)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(N,k,L){if(u.URI.isUri(k))return new z(N,k,L,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const x=n.ExtensionKey.create(k).toString();let U=this.installGalleryExtensionsTasks.get(x);return U||(this.installGalleryExtensionsTasks.set(x,U=new j(N,k,L,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x))),U}createUninstallExtensionTask(N,k){return new B(N,k.profileLocation,this.extensionsProfileScannerService)}async collectFiles(N){const k=async x=>{let U=await v.Promises.readdir(x);U=U.map(re=>S.join(x,re));const q=await Promise.all(U.map(re=>v.Promises.stat(re)));let G=Promise.resolve([]);return q.forEach((re,le)=>{const Se=U[le];re.isFile()&&(G=G.then(me=>[...me,Se])),re.isDirectory()&&(G=G.then(me=>k(Se).then(ce=>[...me,...ce])))}),G};return(await k(N.location.fsPath)).map(x=>({path:`extension/${S.relative(N.location.fsPath,x)}`,localPath:x}))}async onDidChangeExtensionsFromAnotherSource({added:N,removed:k}){if(k)for(const L of k.extensions)this.logService.info("Extensions removed from another source",L.id,k.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:L,profileLocation:k.profileLocation});if(N){const x=(await this.extensionsScanner.scanExtensions(1,N.profileLocation)).filter(U=>N.extensions.some(q=>(0,n.areSameExtensions)(q,U.identifier)));this._onDidInstallExtensions.fire(x.map(U=>(this.logService.info("Extensions added from another source",U.identifier.id,N.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:N.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(k=>this.knownDirectories.add(k)));const N=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const k of N.children??[])k.isDirectory&&this.knownDirectories.add(k.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(k=>this.onDidFilesChange(k)))}async onDidFilesChange(N){if(!N.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const k=[];for(const L of N.rawAdded){if(this.knownDirectories.has(L)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(L),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(L,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(L).startsWith(".")||!(await this.fileService.stat(L)).isDirectory)continue;const x=await this.extensionsScanner.scanUserExtensionAtLocation(L);x&&x.installedTimestamp===void 0&&(this.knownDirectories.add(L),k.push(x))}k.length&&(await this.addExtensionsToProfile(k.map(L=>[L,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",k.map(L=>L.identifier.id)))}async addExtensionsToProfile(N,k){const L=N.map(x=>x[0]);await this.setInstalled(L),await this.extensionsProfileScannerService.addExtensionsToProfile(N,k),this._onDidInstallExtensions.fire(L.map(x=>({local:x,identifier:x.identifier,operation:1,profileLocation:k})))}async setInstalled(N){const k=await this.extensionsScanner.getUninstalledExtensions();for(const L of N){const x=n.ExtensionKey.create(L);!k[x.toString()]||(this.logService.trace("Removing the extension from uninstalled list:",x.id),await this.extensionsScanner.setInstalled(x),this.logService.info("Removed the extension from uninstalled list:",x.id))}}};W=he([J(0,i.IExtensionGalleryService),J(1,fe.ITelemetryService),J(2,ie.ILogService),J(3,t.INativeEnvironmentService),J(4,l.IExtensionsScannerService),J(5,r.IExtensionsProfileScannerService),J(6,w.IDownloadService),J(7,ne.IInstantiationService),J(8,te.IFileService),J(9,ae.IProductService),J(10,oe.IUriIdentityService),J(11,pe.IUserDataProfilesService)],W),e.ExtensionManagementService=W;let M=class extends g.Disposable{constructor(N,k,L,x,U,q){super(),this.beforeRemovingExtension=N,this.fileService=k,this.extensionsScannerService=L,this.extensionsProfileScannerService=x,this.uriIdentityService=U,this.logService=q,this._onExtract=this._register(new E.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,m.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(N,k){const L={includeInvalid:!0,profileLocation:k};let x=[];return N===null||N===0?x.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},L,!1)):N===1&&x.push(...await this.extensionsScannerService.scanUserExtensions(L)),x=N!==null?x.filter(U=>U.type===N):x,Promise.all(x.map(U=>this.toLocalExtension(U)))}async scanAllUserExtensions(N){const k=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!N,includeInvalid:!0});return Promise.all(k.map(L=>this.toLocalExtension(L)))}async scanUserExtensionAtLocation(N){try{const k=await this.extensionsScannerService.scanExistingExtension(N,1,{includeInvalid:!0});if(k)return await this.toLocalExtension(k)}catch(k){this.logService.error(k)}return null}async extractUserExtension(N,k,L,x){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const U=N.toString(),q=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),G=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await v.Promises.rm(G)}catch{throw new i.ExtensionManagementError(p.localize(4,null,G,N.id),i.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(N,k,q,x),await this.extensionsScannerService.updateMetadata(u.URI.file(q),L);try{this._onExtract.fire(u.URI.file(G)),await this.rename(N,q,G,Date.now()+2*60*1e3),this.logService.info("Renamed to",G)}catch(re){try{await v.Promises.rm(q)}catch{}if(re.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",N.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(re)}. Deleted from extracted location`,q),re}return this.scanLocalExtension(u.URI.file(G),1)}async scanMetadata(N,k){return k?(await this.extensionsProfileScannerService.scanProfileExtensions(k)).find(x=>(0,n.areSameExtensions)(x.identifier,N.identifier))?.metadata:this.extensionsScannerService.scanMetadata(N.location)}async updateMetadata(N,k,L){return L?await this.extensionsProfileScannerService.updateMetadata([[N,k]],L):await this.extensionsScannerService.updateMetadata(N.location,k),this.scanLocalExtension(N.location,N.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...N){const k=N.map(L=>n.ExtensionKey.create(L));await this.withUninstalledExtensions(L=>k.forEach(x=>{L[x.toString()]=!0,this.logService.info("Marked extension as uninstalled",x.toString())}))}async setInstalled(N){await this.withUninstalledExtensions(k=>delete k[N.toString()])}async removeExtension(N,k){this.logService.trace(`Deleting ${k} extension from disk`,N.identifier.id,N.location.fsPath);const L=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(N.location),`.${(0,f.generateUuid)()}`);await this.rename(N.identifier,N.location.fsPath,L.fsPath,Date.now()+2*60*1e3),await this.fileService.del(L,{recursive:!0}),this.logService.info("Deleted from disk",N.identifier.id,N.location.fsPath)}async removeUninstalledExtension(N){await this.removeExtension(N,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[n.ExtensionKey.create(N).toString()])}async copyExtensions(N,k){const L=await this.scanExtensions(1,N),x=await Promise.all(L.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,N)]));await this.extensionsProfileScannerService.addExtensionsToProfile(x,k)}async withUninstalledExtensions(N){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(x){if((0,te.toFileOperationResult)(x)!==1)throw x}let L={};if(k)try{L=JSON.parse(k)}catch{}return N&&(N(L),Object.keys(L).length?await this.fileService.writeFile(this.uninstalledResource,D.VSBuffer.fromString(JSON.stringify(L))):await this.fileService.del(this.uninstalledResource)),L})}async extractAtLocation(N,k,L,x){this.logService.trace(`Started extracting the extension from ${k} to ${L}`);try{await v.Promises.rm(L)}catch(U){throw new i.ExtensionManagementError(this.joinErrors(U).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(k,L,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${L}:`,N.id)}catch(U){try{await v.Promises.rm(L)}catch{}let q=i.ExtensionManagementErrorCode.Extract;throw U instanceof y.ExtractError&&(U.type==="CorruptZip"?q=i.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(q=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(U.message,q)}}async rename(N,k,L,x){try{await v.Promises.rename(k,L)}catch(U){if(h.isWindows&&U&&U.code==="EPERM"&&Date.now()<x)return this.logService.info(`Failed renaming ${k} to ${L} with 'EPERM' error. Trying again...`,N.id),this.rename(N,k,L,x);throw new i.ExtensionManagementError(U.message||p.localize(5,null,k,L),U.code||i.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(N,k){const L=await this.extensionsScannerService.scanExistingExtension(N,k,{includeInvalid:!0});if(L)return this.toLocalExtension(L);throw new Error(p.localize(6,null,N.path))}async toLocalExtension(N){const k=await this.fileService.resolve(N.location);let L,x;return k.children&&(L=k.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,x=k.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:N.identifier,type:N.type,isBuiltin:N.isBuiltin||!!N.metadata?.isBuiltin,location:N.location,manifest:N.manifest,targetPlatform:N.targetPlatform,validations:N.validations,isValid:N.isValid,readmeUrl:L,changelogUrl:x,publisherDisplayName:N.metadata?.publisherDisplayName||null,publisherId:N.metadata?.publisherId||null,isApplicationScoped:!!N.metadata?.isApplicationScoped,isMachineScoped:!!N.metadata?.isMachineScoped,isPreReleaseVersion:!!N.metadata?.isPreReleaseVersion,preRelease:!!N.metadata?.preRelease,installedTimestamp:N.metadata?.installedTimestamp,updated:!!N.metadata?.updated,pinned:!!N.metadata?.pinned}}async removeUninstalledExtensions(){const N=await this.getUninstalledExtensions();this.logService.debug("Removing uninstalled extensions:",Object.keys(N));const k=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const U of k)N[n.ExtensionKey.create(U).toString()]||L.add(U.identifier.id.toLowerCase());try{const U=(0,n.groupByExtension)(k,q=>q.identifier);await O.Promises.settled(U.map(async q=>{const G=q.sort((re,le)=>P.rcompare(re.manifest.version,le.manifest.version))[0];L.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}))}catch(U){this.logService.error(U)}const x=k.filter(U=>U.metadata&&N[n.ExtensionKey.create(U).toString()]);await Promise.allSettled(x.map(U=>this.removeUninstalledExtension(U)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const N=[];let k;try{k=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(L){(0,te.toFileOperationResult)(L)!==1&&this.logService.error(L)}for(const L of k?.children??[])L.isDirectory&&L.name.startsWith(".")&&(0,f.isUUID)(L.name.substring(1))&&N.push((async()=>{this.logService.trace("Deleting the generated extension folder",L.resource.toString());try{await this.fileService.del(L.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",L.resource.toString())}catch(x){this.logService.error(x)}})());await Promise.allSettled(N)}joinErrors(N){const k=Array.isArray(N)?N:[N];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((L,x)=>new Error(`${L.message}${L.message?",":""}${x instanceof Error?x.message:x}`),new Error(""))}};M=he([J(1,te.IFileService),J(2,l.IExtensionsScannerService),J(3,r.IExtensionsProfileScannerService),J(4,oe.IUriIdentityService),J(5,ie.ILogService)],M),e.ExtensionsScanner=M;class F extends s.AbstractExtensionTask{get verificationStatus(){return this._verificationStatus}get operation(){return(0,T.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(N,k,L,x,U,q,G,re,le){super(),this.identifier=N,this.source=k,this.options=L,this.extensionsScanner=x,this.uriIdentityService=U,this.userDataProfilesService=q,this.extensionsScannerService=G,this.extensionsProfileScannerService=re,this.logService=le,this._verificationStatus="Unverified",this._operation=2}async doRun(N){const[k,L]=await this.install(N);return this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[k,L]],this.options.profileLocation),k}async extractExtension({zipPath:N,key:k,metadata:L},x){let U=await this.unsetIfUninstalled(k);return U||(this.logService.trace("Extracting extension...",k.id),U=await this.extensionsScanner.extractUserExtension(k,N,L,x),this.logService.info("Extracting extension completed.",k.id)),U}async unsetIfUninstalled(N){return await this.isUninstalled(N)?(this.logService.trace("Removing the extension from uninstalled list:",N.id),await this.extensionsScanner.setInstalled(N),this.logService.info("Removed the extension from uninstalled list:",N.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(x=>n.ExtensionKey.create(x).equals(N))):void 0}async isUninstalled(N){return!!(await this.extensionsScanner.getUninstalledExtensions())[N.toString()]}}class j extends F{constructor(N,k,L,x,U,q,G,re,le,Se){super(k.identifier,k,L,U,q,G,re,le,Se),this.manifest=N,this.gallery=k,this.extensionsDownloader=x}async install(N){const L=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(G=>(0,n.areSameExtensions)(G.identifier,this.gallery.identifier));L&&(this._operation=3);const x={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,Y.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,T.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(L,x),x];const{location:U,verificationStatus:q}=await this.extensionsDownloader.download(this.gallery,this._operation);try{return this._verificationStatus=q,this.validateManifest(U.fsPath),[await this.extractExtension({zipPath:U.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:x},N),x]}catch(G){try{await this.extensionsDownloader.delete(U)}catch(re){this.logService.warn("Error while deleting the downloaded file",U.toString(),(0,R.getErrorMessage)(re))}throw G}}async validateManifest(N){try{await(0,d.getManifest)(N)}catch(k){throw new i.ExtensionManagementError((0,s.joinErrors)(k).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class z extends F{constructor(N,k,L,x,U,q,G,re,le,Se){super({id:(0,n.getGalleryExtensionId)(N.publisher,N.name)},k,L,U,q,G,re,le,Se),this.manifest=N,this.location=k,this.galleryService=x}async install(N){const k=new n.ExtensionKey(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(G=>(0,n.areSameExtensions)(this.identifier,G.identifier)),U=await this.getMetadata(this.identifier.id,this.manifest.version,N);if(U.isApplicationScoped=(0,Y.isApplicationScopedExtension)(this.manifest),U.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,U.isBuiltin=this.options.isBuiltin||x?.isBuiltin,U.installedTimestamp=Date.now(),U.pinned=this.options.installGivenVersion?!0:void 0,x)if(this._operation=3,k.equals(new n.ExtensionKey(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&P.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const G=await this.unsetIfUninstalled(k);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:S.resolve(this.location.fsPath),key:k,metadata:U},N),U]}async getMetadata(N,k,L){try{let[x]=await this.galleryService.getExtensions([{id:N,version:k}],L);if(x||([x]=await this.galleryService.getExtensions([{id:N}],L)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B extends s.AbstractExtensionTask{constructor(N,k,L){super(),this.extension=N,this.profileLocation=k,this.extensionsProfileScannerService=L}async doRun(N){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(Q[155],Z([0,1,130,5,14,7,2,3,24,17,131,6,129,168]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let P=class extends R.Disposable{constructor(u,f,v){super(),this.configurationService=u,this.environmentService=f,this.logService=v,this.configure(),this._register(u.onDidChangeConfiguration(y=>{y.affectsConfiguration("http")&&this.configure()}))}configure(){const u=this.configurationService.getValue("http");this.proxyUrl=u?.proxy,this.strictSSL=!!u?.proxyStrictSSL,this.authorization=u?.proxyAuthorization}async request(u,f){this.logService.trace("RequestService#request (node) - begin",u.url);const{proxyUrl:v,strictSSL:y}=this;let p;try{p=await(0,I.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",s))}const w={...process.env,...p},t=u.agent?u.agent:await(0,h.getProxyAgent)(u.url||"",w,{proxyUrl:v,strictSSL:y});u.agent=t,u.strictSSL=y,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization});try{const s=await this._request(u,f);return this.logService.trace("RequestService#request (node) - success",u.url),s}catch(s){throw this.logService.trace("RequestService#request (node) - error",u.url,s),s}}async getNodeRequest(u){return((0,O.parse)(u.url).protocol==="https:"?await new Promise((y,p)=>{$(["https"],y,p)}):await new Promise((y,p)=>{$(["http"],y,p)})).request}_request(u,f){return D.Promises.withAsyncBody(async(v,y)=>{const p=(0,O.parse)(u.url),w=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),t={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,E.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const s=w(t,i=>{const n=(0,E.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...u,url:i.headers.location,followRedirects:n-1},f).then(v,y);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,m.createGunzip)())),v({res:i,stream:(0,b.streamToBufferReadableStream)(r)})}});s.on("error",y),u.timeout&&s.setTimeout(u.timeout),u.isChromiumNetwork&&s.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&s.write(u.data),s.end(),f.onCancellationRequested(()=>{s.abort(),y(new C.CancellationError)})})}async resolveProxy(u){}};P=he([J(0,g.IConfigurationService),J(1,c.INativeEnvironmentService),J(2,S.ILogService)],P),e.RequestService=P}),define(Q[169],Z([0,1,36,5,14,33,7,2,16,15,12,37,11,20,24,126,59,128,17,105,150,21,60,133,40,47,154,148,13,116,118,45,114,63,64,136,6,121,122,38,123,139,31,46,155,68,69,25,138,39,140,141,27,143,22,151,142,147,120]),function($,e,O,D,b,C,R,E,g,c,I,S,h,m,P,T,u,f,v,y,p,w,t,s,i,n,r,l,o,a,d,A,V,Y,ee,te,ne,ie,ae,fe,oe,pe,W,M,F,j,z,B,K,N,k,L,x,U,q,G,re,le,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class me extends E.Disposable{constructor(se){super(),this.argv=se,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[se,ue]=await this.initServices();return se.invokeFunction(async Ee=>{const be=Ee.get(ne.ILogService),Me=Ee.get(o.IFileService),xe=Ee.get(v.INativeEnvironmentService),_=Ee.get(q.IUserDataProfilesService);be.info("CLI main",this.argv),this.registerErrorHandler(be),await this.doRun(xe,Me,_,se),await Promise.all(ue.map(H=>{(0,D.raceTimeout)(H.flush(),1e3)}))})}async initServices(){const se=new Y.ServiceCollection,ue={_serviceBrand:void 0,...pe.default};se.set(W.IProductService,ue);const Ee=new y.NativeEnvironmentService(this.argv,ue);se.set(v.INativeEnvironmentService,Ee),await Promise.all([Ee.appSettingsHome.fsPath,Ee.extensionsPath].map(Fe=>Fe?m.Promises.mkdir(Fe,{recursive:!0}):void 0));const be=(0,ne.getLogLevel)(Ee),Me=new ie.SpdLogLogger("cli",(0,c.join)(Ee.logsPath,"cli.log"),!0,!1,be),xe=[];be===ne.LogLevel.Trace&&xe.push(new ne.ConsoleLogger(be));const _=this._register(new Se.LogService(Me,xe));se.set(ne.ILogService,_);const H=this._register(new a.FileService(_));se.set(o.IFileService,H);const X=this._register(new d.DiskFileSystemProvider(_));H.registerProvider(g.Schemas.file,X);const de=new U.UriIdentityService(H);se.set(x.IUriIdentityService,de);const ve=new j.StateReadonlyService(1,Ee,_,H),Le=new G.UserDataProfilesReadonlyService(ve,de,Ee,H,_);se.set(q.IUserDataProfilesService,Le);const Pe=I.isWindows&&ue.win32RegValueName?this._register(new oe.NativePolicyService(_,ue.win32RegValueName)):Ee.policyFile?this._register(new ae.FilePolicyService(Ee.policyFile,H,_)):new fe.NullPolicyService;se.set(fe.IPolicyService,Pe);const ke=this._register(new T.ConfigurationService(Le.defaultProfile.settingsResource,H,Pe,_));se.set(P.IConfigurationService,ke),await Promise.all([ve.init(),ke.initialize()]),Le.init(),se.set(x.IUriIdentityService,new U.UriIdentityService(H)),se.set(M.IRequestService,new A.SyncDescriptor(F.RequestService,void 0,!0)),se.set(u.IDownloadService,new A.SyncDescriptor(f.DownloadService,void 0,!0)),se.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(le.ExtensionsProfileScannerService,void 0,!0)),se.set(n.IExtensionsScannerService,new A.SyncDescriptor(l.ExtensionsScannerService,void 0,!0)),se.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),se.set(r.INativeServerExtensionManagementService,new A.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),se.set(w.IExtensionGalleryService,new A.SyncDescriptor(p.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),se.set(ee.ILanguagePackService,new A.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const De=[],Te=(0,N.isInternalTelemetry)(ue,ke);if((0,N.supportsTelemetry)(ue,Ee)){ue.aiConfig&&ue.aiConfig.ariaKey&&De.push(new k.OneDataSystemAppender(Te,"monacoworkbench",null,ue.aiConfig.ariaKey));const{installSourcePath:Fe}=Ee,Ce={appenders:De,sendErrorTelemetry:!1,commonProperties:(async()=>{let Oe;try{Oe=await(0,re.resolveMachineId)(ve)}catch(Ae){Ae.code!=="ENOENT"&&_.error(Ae)}return(0,z.resolveCommonProperties)(H,(0,O.release)(),(0,O.hostname)(),process.arch,ue.commit,ue.version,Oe,Te,Fe)})(),piiPaths:(0,N.getPiiPathsFromEnvironment)(Ee)};se.set(B.ITelemetryService,new A.SyncDescriptor(K.TelemetryService,[Ce],!1))}else se.set(B.ITelemetryService,N.NullTelemetryService);return[new V.InstantiationService(se),De]}registerErrorHandler(se){(0,R.setUnexpectedErrorHandler)(ue=>{const Ee=(0,C.toErrorMessage)(ue,!0);!Ee||se.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",ue=>{(0,R.isSigPipeError)(ue)||(0,R.onUnexpectedError)(ue)}),process.on("unhandledRejection",ue=>(0,R.onUnexpectedError)(ue))}async doRun(se,ue,Ee,be){let Me;if(se.args.profile&&(Me=Ee.profiles.find(_=>_.name===se.args.profile),!Me))throw new Error(`Profile '${se.args.profile}' not found.`);const xe=(Me??Ee.defaultProfile).extensionsResource;if(this.argv["install-source"])return this.setInstallSource(se,ue,this.argv["install-source"]);if(this.argv["list-extensions"])return be.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,xe);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const _={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:xe};return be.createInstance(s.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],_,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return be.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,xe);if(this.argv["locate-extension"])return be.createInstance(s.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,L.buildTelemetryMessage)(se.appRoot,se.extensionsPath))}}asExtensionIdOrVSIX(se){return se.map(ue=>/\.vsix$/i.test(ue)?h.URI.file((0,c.isAbsolute)(ue)?ue:(0,c.join)((0,S.cwd)(),ue)):ue)}async setInstallSource(se,ue,Ee){await ue.writeFile(h.URI.file(se.installSourcePath),b.VSBuffer.fromString(Ee.slice(0,30)))}}async function ce(ge){const se=new me(ge);try{await se.run()}finally{se.dispose()}}e.main=ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/22a808587994126e19125c6a1a03c00b990223f4/core/vs/code/node/cliProcessMain.js.map
