/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/resources","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/map","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(ee){for(var e=[],L=0,_=ee.length;L<_;L++)e[L]=se[ee[L]];return e};define(se[62],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(D){return(I,C,S)=>{let P=null,w=null;if(typeof S.value=="function"?(P="value",w=S.value):typeof S.get=="function"&&(P="get",w=S.get),!w)throw new Error("not supported");S[P]=D(w,C)}}function _(D,I,C){let S=null,P=null;if(typeof C.value=="function"?(S="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(S="get",P=C.get),!P)throw new Error("not supported");const w=`$memoize$${I}`;C[S]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[w]}}e.memoize=_;function c(D,I,C){return L((S,P)=>{const w=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...d){this[m]||(this[m]=C?C():void 0),clearTimeout(this[w]),I&&(this[m]=I(this[m],...d),d=[this[m]]),this[w]=setTimeout(()=>{S.apply(this,d),this[m]=C?C():void 0},D)}})}e.debounce=c;function R(D,I,C){return L((S,P)=>{const w=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,f=`$throttle$pending$${P}`;return function(...y){if(this[m]||(this[m]=C?C():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...y)),this[f])return;const h=this[d]+D;h<=Date.now()?(this[d]=Date.now(),S.apply(this,[this[m]]),this[m]=C?C():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[d]=Date.now(),S.apply(this,[this[m]]),this[m]=C?C():void 0},h-Date.now()))}})}e.throttle=R}),define(se[7],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?b.isErrorNoTelemetry(o)?new b(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(t=>{t(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=L,e.errorHandler=new L;function _(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=_;function c(n){if(!n||typeof n!="object")return!1;const o=n;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=c;function R(n){S(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=R;function D(n){S(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=D;function I(n){if(n instanceof Error){const{name:o,message:t}=n,i=n.stacktrace||n.stack;return{$isError:!0,name:o,message:t,stack:i,noTelemetry:b.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=I;const C="Canceled";function S(n){return n instanceof P?!0:n instanceof Error&&n.name===C&&n.message===C}e.isCancellationError=S;class P extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=P;function w(){const n=new Error(C);return n.name=n.message,n}e.canceled=w;function m(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=m;function d(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=d;function f(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function y(n){const o=new Error(`${n} has been disposed`);return o.name="DISPOSED",o}e.disposed=y;function h(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=h;class u extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=u;class g extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=g;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class b extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof b)return o;const t=new b;return t.message=o.message,t.stack=o.stack,t}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class k extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype);debugger}}e.BugIndicatingError=k}),define(se[19],oe([0,1,7]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function _(G,X=0){return G[G.length-(1+X)]}e.tail=_;function c(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.tail2=c;function R(G,X,ie=(le,he)=>le===he){if(G===X)return!0;if(!G||!X||G.length!==X.length)return!1;for(let le=0,he=G.length;le<he;le++)if(!ie(G[le],X[le]))return!1;return!0}e.equals=R;function D(G,X){const ie=G.length-1;X<ie&&(G[X]=G[ie]),G.pop()}e.removeFastWithoutKeepingOrder=D;function I(G,X,ie){return C(G.length,le=>ie(G[le],X))}e.binarySearch=I;function C(G,X){let ie=0,le=G-1;for(;ie<=le;){const he=(ie+le)/2|0,me=X(he);if(me<0)ie=he+1;else if(me>0)le=he-1;else return he}return-(ie+1)}e.binarySearch2=C;function S(G,X){let ie=0,le=G.length;if(le===0)return 0;for(;ie<le;){const he=Math.floor((ie+le)/2);X(G[he])?le=he:ie=he+1}return ie}e.findFirstInSorted=S;function P(G,X,ie){if(G=G|0,G>=X.length)throw new TypeError("invalid index");const le=X[Math.floor(X.length*Math.random())],he=[],me=[],ve=[];for(const we of X){const Ce=ie(we,le);Ce<0?he.push(we):Ce>0?me.push(we):ve.push(we)}return G<he.length?P(G,he,ie):G<he.length+ve.length?ve[0]:P(G-(he.length+ve.length),me,ie)}e.quickSelect=P;function w(G,X){const ie=[];let le;for(const he of G.slice(0).sort(X))!le||X(le[0],he)!==0?(le=[he],ie.push(le)):le.push(he);return ie}e.groupBy=w;function m(G,X,ie){const le=[];function he(we,Ce,Re){if(Ce===0&&Re.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=Ce,ke.toInsert.push(...Re)):le.push({start:we,deleteCount:Ce,toInsert:Re})}let me=0,ve=0;for(;;){if(me===G.length){he(me,0,X.slice(ve));break}if(ve===X.length){he(me,G.length-me,[]);break}const we=G[me],Ce=X[ve],Re=ie(we,Ce);Re===0?(me+=1,ve+=1):Re<0?(he(me,1,[]),me+=1):Re>0&&(he(me,0,[Ce]),ve+=1)}return le}e.sortedDiff=m;function d(G,X,ie){const le=m(G,X,ie),he=[],me=[];for(const ve of le)he.push(...G.slice(ve.start,ve.start+ve.deleteCount)),me.push(...ve.toInsert);return{removed:he,added:me}}e.delta=d;function f(G,X,ie){if(ie===0)return[];const le=G.slice(0,ie).sort(X);return h(G,X,le,ie,G.length),le}e.top=f;function y(G,X,ie,le,he){return ie===0?Promise.resolve([]):new Promise((me,ve)=>{(async()=>{const we=G.length,Ce=G.slice(0,ie).sort(X);for(let Re=ie,ke=Math.min(ie+le,we);Re<we;Re=ke,ke=Math.min(ke+le,we)){if(Re>ie&&await new Promise(ze=>setTimeout(ze)),he&&he.isCancellationRequested)throw new L.CancellationError;h(G,X,Ce,Re,ke)}return Ce})().then(me,ve)})}e.topAsync=y;function h(G,X,ie,le,he){for(const me=ie.length;le<he;le++){const ve=G[le];if(X(ve,ie[me-1])<0){ie.pop();const we=S(ie,Ce=>X(ve,Ce)<0);ie.splice(we,0,ve)}}}function u(G){return G.filter(X=>!!X)}e.coalesce=u;function g(G){let X=0;for(let ie=0;ie<G.length;ie++)G[ie]&&(G[X]=G[ie],X+=1);G.length=X}e.coalesceInPlace=g;function v(G,X,ie){G.splice(ie,0,G.splice(X,1)[0])}e.move=v;function b(G){return!Array.isArray(G)||G.length===0}e.isFalsyOrEmpty=b;function k(G){return Array.isArray(G)&&G.length>0}e.isNonEmptyArray=k;function n(G,X=ie=>ie){const ie=new Set;return G.filter(le=>{const he=X(le);return ie.has(he)?!1:(ie.add(he),!0)})}e.distinct=n;function o(G){const X=new Set;return ie=>{const le=G(ie);return X.has(le)?!1:(X.add(le),!0)}}e.uniqueFilter=o;function t(G,X){const ie=i(G,X);if(ie!==-1)return G[ie]}e.findLast=t;function i(G,X){for(let ie=G.length-1;ie>=0;ie--){const le=G[ie];if(X(le))return ie}return-1}e.lastIndex=i;function r(G,X){return G.length>0?G[0]:X}e.firstOrDefault=r;function a(G,X){return G.length>0?G[G.length-1]:X}e.lastOrDefault=a;function s(G,X,ie=(le,he)=>le===he){let le=0;for(let he=0,me=Math.min(G.length,X.length);he<me&&ie(G[he],X[he]);he++)le++;return le}e.commonPrefixLength=s;function l(G){return[].concat(...G)}e.flatten=l;function p(G,X){let ie=typeof X=="number"?G:0;typeof X=="number"?ie=G:(ie=0,X=G);const le=[];if(ie<=X)for(let he=ie;he<X;he++)le.push(he);else for(let he=ie;he>X;he--)le.push(he);return le}e.range=p;function E(G,X,ie){return G.reduce((le,he)=>(le[X(he)]=ie?ie(he):he,le),Object.create(null))}e.index=E;function T(G,X){return G.push(X),()=>A(G,X)}e.insert=T;function A(G,X){const ie=G.indexOf(X);if(ie>-1)return G.splice(ie,1),X}e.remove=A;function N(G,X,ie){const le=G.slice(0,X),he=G.slice(X);return le.concat(ie,he)}e.arrayInsert=N;function W(G,X){let ie;if(typeof X=="number"){let le=X;ie=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else ie=Math.random;for(let le=G.length-1;le>0;le-=1){const he=Math.floor(ie()*(le+1)),me=G[le];G[le]=G[he],G[he]=me}}e.shuffle=W;function V(G,X){const ie=G.indexOf(X);ie>-1&&(G.splice(ie,1),G.unshift(X))}e.pushToStart=V;function K(G,X){const ie=G.indexOf(X);ie>-1&&(G.splice(ie,1),G.push(X))}e.pushToEnd=K;function z(G,X){for(const ie of X)G.push(ie)}e.pushMany=z;function O(G,X){return Array.isArray(G)?G.map(X):X(G)}e.mapArrayOrNot=O;function $(G){return Array.isArray(G)?G:[G]}e.asArray=$;function Z(G){return G[Math.floor(Math.random()*G.length)]}e.getRandomElement=Z;function q(G,X){for(const ie of G){const le=X(ie);if(le!==void 0)return le}}e.mapFind=q;function j(G,X,ie){const le=J(G,X),he=G.length,me=ie.length;G.length=he+me;for(let ve=he-1;ve>=le;ve--)G[ve+me]=G[ve];for(let ve=0;ve<me;ve++)G[ve+le]=ie[ve]}e.insertInto=j;function M(G,X,ie,le){const he=J(G,X),me=G.splice(he,ie);return j(G,he,le),me}e.splice=M;function J(G,X){return X<0?Math.max(X+G.length,0):Math.min(X,G.length)}var Q;(function(G){function X(he){return he<0}G.isLessThan=X;function ie(he){return he>0}G.isGreaterThan=ie;function le(he){return he===0}G.isNeitherLessOrGreaterThan=le,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function re(G,X){return(ie,le)=>X(G(ie),G(le))}e.compareBy=re;function ae(...G){return(X,ie)=>{for(const le of G){const he=le(X,ie);if(!Q.isNeitherLessOrGreaterThan(he))return he}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const B=(G,X)=>G-X;e.numberComparator=B;function F(G,X){if(G.length===0)return;let ie=G[0];for(let le=1;le<G.length;le++){const he=G[le];X(he,ie)>0&&(ie=he)}return ie}e.findMaxBy=F;function U(G,X){if(G.length===0)return;let ie=G[0];for(let le=1;le<G.length;le++){const he=G[le];X(he,ie)>=0&&(ie=he)}return ie}e.findLastMaxBy=U;function x(G,X){return F(G,(ie,le)=>-X(ie,le))}e.findMinBy=x;class H{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let ie=this.firstIdx;for(;ie<this.items.length&&X(this.items[ie]);)ie++;const le=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,le}takeFromEndWhile(X){let ie=this.lastIdx;for(;ie>=0&&X(this.items[ie]);)ie--;const le=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,le}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}removeLast(){const X=this.items[this.lastIdx];return this.lastIdx--,X}takeCount(X){const ie=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,ie}}e.ArrayQueue=H;class te{constructor(X){this.iterate=X}forEach(X){this.iterate(ie=>(X(ie),!0))}toArray(){const X=[];return this.iterate(ie=>(X.push(ie),!0)),X}filter(X){return new te(ie=>this.iterate(le=>X(le)?ie(le):!0))}map(X){return new te(ie=>this.iterate(le=>ie(X(le))))}some(X){let ie=!1;return this.iterate(le=>(ie=X(le),!ie)),ie}findFirst(X){let ie;return this.iterate(le=>X(le)?(ie=le,!1):!0),ie}findLast(X){let ie;return this.iterate(le=>(X(le)&&(ie=le),!0)),ie}findLastMaxBy(X){let ie,le=!0;return this.iterate(he=>((le||Q.isGreaterThan(X(he,ie)))&&(le=!1,ie=he),!0)),ie}}te.empty=new te(G=>{}),e.CallbackIterable=te}),define(se[130],oe([0,1,7]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function _(C,S){if(!C)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=_;function c(C,S="Unreachable"){throw new Error(S)}e.assertNever=c;function R(C){if(!C)throw new L.BugIndicatingError("Assertion Failed")}e.assert=R;function D(C){if(!C()){debugger;C(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function I(C,S){let P=0;for(;P<C.length-1;){const w=C[P],m=C[P+1];if(!S(w,m))return!1;P++}return!0}e.checkAdjacentItems=I}),define(se[82],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(_){const c=this;let R=!1,D;return function(){return R||(R=!0,D=_.apply(c,arguments)),D}}e.once=L}),define(se[63],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(_){function c(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}_.is=c;const R=Object.freeze([]);function D(){return R}_.empty=D;function*I(b){yield b}_.single=I;function C(b){return c(b)?b:I(b)}_.wrap=C;function S(b){return b||R}_.from=S;function P(b){return!b||b[Symbol.iterator]().next().done===!0}_.isEmpty=P;function w(b){return b[Symbol.iterator]().next().value}_.first=w;function m(b,k){for(const n of b)if(k(n))return!0;return!1}_.some=m;function d(b,k){for(const n of b)if(k(n))return n}_.find=d;function*f(b,k){for(const n of b)k(n)&&(yield n)}_.filter=f;function*y(b,k){let n=0;for(const o of b)yield k(o,n++)}_.map=y;function*h(...b){for(const k of b)for(const n of k)yield n}_.concat=h;function u(b,k,n){let o=n;for(const t of b)o=k(o,t);return o}_.reduce=u;function*g(b,k,n=b.length){for(k<0&&(k+=b.length),n<0?n+=b.length:n>b.length&&(n=b.length);k<n;k++)yield b[k]}_.slice=g;function v(b,k=Number.POSITIVE_INFINITY){const n=[];if(k===0)return[n,b];const o=b[Symbol.iterator]();for(let t=0;t<k;t++){const i=o.next();if(i.done)return[n,_.empty()];n.push(i.value)}return[n,{[Symbol.iterator](){return o}}]}_.consume=v})(L=e.Iterable||(e.Iterable={}))}),define(se[35],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var _;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(_=e.SyntaxKind||(e.SyntaxKind={}));var c;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(c=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(n,o=!1){let t=0;const i=n.length;let r="",a=0,s=16,l=0;function p(K){let z=0,O=0;for(;z<K;){const $=n.charCodeAt(t);if($>=48&&$<=57)O=O*16+$-48;else if($>=65&&$<=70)O=O*16+$-65+10;else if($>=97&&$<=102)O=O*16+$-97+10;else break;t++,z++}return z<K&&(O=-1),O}function E(K){t=K,r="",a=0,s=16,l=0}function T(){const K=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return l=3,n.substring(K,t);let z=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;z=t}else l=3;return n.substring(K,z)}function A(){let K="",z=t;for(;;){if(t>=i){K+=n.substring(z,t),l=2;break}const O=n.charCodeAt(t);if(O===34){K+=n.substring(z,t),t++;break}if(O===92){if(K+=n.substring(z,t),t++,t>=i){l=2;break}switch(n.charCodeAt(t++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:{const Z=p(4);Z>=0?K+=String.fromCharCode(Z):l=4;break}default:l=5}z=t;continue}if(O>=0&&O<=31)if(C(O)){K+=n.substring(z,t),l=2;break}else l=6;t++}return K}function N(){if(r="",l=0,a=t,t>=i)return a=i,s=17;let K=n.charCodeAt(t);if(I(K)){do t++,r+=String.fromCharCode(K),K=n.charCodeAt(t);while(I(K));return s=15}if(C(K))return t++,r+=String.fromCharCode(K),K===13&&n.charCodeAt(t)===10&&(t++,r+=`
`),s=14;switch(K){case 123:return t++,s=1;case 125:return t++,s=2;case 91:return t++,s=3;case 93:return t++,s=4;case 58:return t++,s=6;case 44:return t++,s=5;case 34:return t++,r=A(),s=10;case 47:{const z=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!C(n.charCodeAt(t));)t++;return r=n.substring(z,t),s=12}if(n.charCodeAt(t+1)===42){t+=2;const O=i-1;let $=!1;for(;t<O;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,$=!0;break}t++}return $||(t++,l=1),r=n.substring(z,t),s=13}return r+=String.fromCharCode(K),t++,s=16}case 45:if(r+=String.fromCharCode(K),t++,t===i||!S(n.charCodeAt(t)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),s=11;default:for(;t<i&&W(K);)t++,K=n.charCodeAt(t);if(a!==t){switch(r=n.substring(a,t),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode(K),t++,s=16}}function W(K){if(I(K)||C(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let K;do K=N();while(K>=12&&K<=15);return K}return{setPosition:E,getPosition:()=>t,scan:o?V:N,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>l}}e.createScanner=D;function I(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function C(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function w(n,o){const t=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function l(p,E,T,A){a.value=p,a.offset=E,a.length=T,a.type=A,a.colonOffset=void 0,r=a}try{v(n,{onObjectBegin:(p,E)=>{if(o<=p)throw i;r=void 0,s=o>p,t.push("")},onObjectProperty:(p,E,T)=>{if(o<E||(l(p,E,T,"property"),t[t.length-1]=p,o<=E+T))throw i},onObjectEnd:(p,E)=>{if(o<=p)throw i;r=void 0,t.pop()},onArrayBegin:(p,E)=>{if(o<=p)throw i;r=void 0,t.push(0)},onArrayEnd:(p,E)=>{if(o<=p)throw i;r=void 0,t.pop()},onLiteralValue:(p,E,T)=>{if(o<E||(l(p,E,T,k(p)),o<=E+T))throw i},onSeparator:(p,E,T)=>{if(o<=E)throw i;if(p===":"&&r&&r.type==="property")r.colonOffset=E,s=!1,r=void 0;else if(p===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(s=!0,t[t.length-1]=""),r=void 0}}})}catch(p){if(p!==i)throw p}return{path:t,previousNode:r,isAtPropertyKey:s,matches:p=>{let E=0;for(let T=0;E<p.length&&T<t.length;T++)if(p[E]===t[T]||p[E]==="*")E++;else if(p[E]!=="**")return!1;return E===p.length}}}e.getLocation=w;function m(n,o=[],t=R.DEFAULT){let i=null,r=[];const a=[];function s(p){Array.isArray(r)?r.push(p):i!==null&&(r[i]=p)}return v(n,{onObjectBegin:()=>{const p={};s(p),a.push(r),r=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];s(p),a.push(r),r=p,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:s,onError:(p,E,T)=>{o.push({error:p,offset:E,length:T})}},t),r[0]}e.parse=m;function d(n,o=[],t=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function a(p){return i.children.push(p),p}v(n,{onObjectBegin:p=>{i=a({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,E,T)=>{i=a({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:E,length:T,parent:i})},onObjectEnd:(p,E)=>{i.length=p+E-i.offset,i=i.parent,r(p+E)},onArrayBegin:(p,E)=>{i=a({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,E)=>{i.length=p+E-i.offset,i=i.parent,r(p+E)},onLiteralValue:(p,E,T)=>{a({type:k(p),offset:E,length:T,parent:i,value:p}),r(E+T)},onSeparator:(p,E,T)=>{i.type==="property"&&(p===":"?i.colonOffset=E:p===","&&r(E))},onError:(p,E,T)=>{o.push({error:p,offset:E,length:T})}},t);const l=i.children[0];return l&&delete l.parent,l}e.parseTree=d;function f(n,o){if(!n)return;let t=n;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===i){t=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=f;function y(n){if(!n.parent||!n.parent.children)return[];const o=y(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;o.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&o.push(t)}return o}e.getNodePath=y;function h(n){switch(n.type){case"array":return n.children.map(h);case"object":{const o=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(o[t.children[0].value]=h(i))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=h;function u(n,o,t=!1){return o>=n.offset&&o<n.offset+n.length||t&&o===n.offset+n.length}e.contains=u;function g(n,o,t=!1){if(u(n,o,t)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=o;r++){const a=g(i[r],o,t);if(a)return a}return n}}e.findNodeAtOffset=g;function v(n,o,t=R.DEFAULT){const i=D(n,!1);function r(re){return re?()=>re(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(re){return re?ae=>re(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=r(o.onObjectBegin),l=a(o.onObjectProperty),p=r(o.onObjectEnd),E=r(o.onArrayBegin),T=r(o.onArrayEnd),A=a(o.onLiteralValue),N=a(o.onSeparator),W=r(o.onComment),V=a(o.onError),K=t&&t.disallowComments,z=t&&t.allowTrailingComma;function O(){for(;;){const re=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:K||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(re){case 12:case 13:K?$(10):W();break;case 16:$(1);break;case 15:case 14:break;default:return re}}}function $(re,ae=[],B=[]){if(V(re),ae.length+B.length>0){let F=i.getToken();for(;F!==17;){if(ae.indexOf(F)!==-1){O();break}else if(B.indexOf(F)!==-1)break;F=O()}}}function Z(re){const ae=i.getTokenValue();return re?A(ae):l(ae),O(),!0}function q(){switch(i.getToken()){case 11:{let re=0;try{re=JSON.parse(i.getTokenValue()),typeof re!="number"&&($(2),re=0)}catch{$(2)}A(re);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return O(),!0}function j(){return i.getToken()!==10?($(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(N(":"),O(),Q()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function M(){s(),O();let re=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(re||$(4,[],[]),N(","),O(),i.getToken()===2&&z)break}else re&&$(6,[],[]);j()||$(4,[],[2,5]),re=!0}return p(),i.getToken()!==2?$(7,[2],[]):O(),!0}function J(){E(),O();let re=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(re||$(4,[],[]),N(","),O(),i.getToken()===4&&z)break}else re&&$(6,[],[]);Q()||$(4,[],[4,5]),re=!0}return T(),i.getToken()!==4?$(8,[4],[]):O(),!0}function Q(){switch(i.getToken()){case 3:return J();case 1:return M();case 10:return Z(!0);default:return q()}}return O(),i.getToken()===17?t.allowEmptyContent?!0:($(4,[],[]),!1):Q()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=v;function b(n,o){const t=D(n),i=[];let r,a=0,s;do switch(s=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:a!==s&&i.push(n.substring(a,s)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),a=t.getPosition();break}while(r!==17);return i.join("")}e.stripComments=b;function k(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(se[42],oe([0,1,35]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function _(S,P,w){let m,d,f,y,h;if(P){for(y=P.offset,h=y+P.length,f=y;f>0&&!C(S,f-1);)f--;let s=h;for(;s<S.length&&!C(S,s);)s++;d=S.substring(f,s),m=D(d,w)}else d=S,m=0,f=0,y=0,h=S.length;const u=I(w,S);let g=!1,v=0,b;w.insertSpaces?b=R(" ",w.tabSize||4):b="	";const k=(0,L.createScanner)(d,!1);let n=!1;function o(){return u+R(b,m+v)}function t(){let s=k.scan();for(g=!1;s===15||s===14;)g=g||s===14,s=k.scan();return n=s===16||k.getTokenError()!==0,s}const i=[];function r(s,l,p){!n&&l<h&&p>y&&S.substring(l,p)!==s&&i.push({offset:l,length:p-l,content:s})}let a=t();if(a!==17){const s=k.getTokenOffset()+f,l=R(b,m);r(l,f,s)}for(;a!==17;){let s=k.getTokenOffset()+k.getTokenLength()+f,l=t(),p="";for(;!g&&(l===12||l===13);){const T=k.getTokenOffset()+f;r(" ",s,T),s=k.getTokenOffset()+k.getTokenLength()+f,p=l===12?o():"",l=t()}if(l===2)a!==1&&(v--,p=o());else if(l===4)a!==3&&(v--,p=o());else{switch(a){case 3:case 1:v++,p=o();break;case 5:case 12:p=o();break;case 13:g?p=o():p=" ";break;case 6:p=" ";break;case 10:if(l===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?p=" ":l!==5&&l!==17&&(n=!0);break;case 16:n=!0;break}g&&(l===12||l===13)&&(p=o())}const E=k.getTokenOffset()+f;r(p,s,E),a=l}return i}e.format=_;function c(S,P){const w=JSON.stringify(S,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?w.replace(/\r\n|\r|\n/g,P.eol):w}e.toFormattedString=c;function R(S,P){let w="";for(let m=0;m<P;m++)w+=S;return w}function D(S,P){let w=0,m=0;const d=P.tabSize||4;for(;w<S.length;){const f=S.charAt(w);if(f===" ")m++;else if(f==="	")m+=d;else break;w++}return Math.floor(m/d)}function I(S,P){for(let w=0;w<P.length;w++){const m=P.charAt(w);if(m==="\r")return w+1<P.length&&P.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=I;function C(S,P){return`\r
`.indexOf(S.charAt(P))!==-1}e.isEOL=C}),define(se[83],oe([0,1,35,42]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function c(S,P,w){return R(S,P,void 0,w)}e.removeProperty=c;function R(S,P,w,m,d){const f=P.slice(),y=[],h=(0,L.parseTree)(S,y);let u,g;for(;f.length>0&&(g=f.pop(),u=(0,L.findNodeAtLocation)(h,f),u===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const v=(0,L.findNodeAtLocation)(u,[g]);if(v!==void 0)if(w===void 0){if(!v.parent)throw new Error("Malformed AST");const b=u.children.indexOf(v.parent);let k,n=v.parent.offset+v.parent.length;if(b>0){const o=u.children[b-1];k=o.offset+o.length}else k=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return D(S,{offset:k,length:n-k,content:""},m)}else return D(S,{offset:v.offset,length:v.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const b=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,k=d?d(u.children.map(o=>o.children[0].value)):u.children.length;let n;if(k>0){const o=u.children[k-1];n={offset:o.offset+o.length,length:0,content:","+b}}else u.children.length===0?n={offset:u.offset+1,length:0,content:b}:n={offset:u.offset+1,length:0,content:b+","};return D(S,n,m)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(w!==void 0){const v=`${JSON.stringify(w)}`;let b;if(u.children.length===0||g===0)b={offset:u.offset+1,length:0,content:u.children.length===0?v:v+","};else{const k=g===-1||g>u.children.length?u.children.length:g,n=u.children[k-1];b={offset:n.offset+n.length,length:0,content:","+v}}return D(S,b,m)}else{const v=g,b=u.children[v];let k;if(u.children.length===1)k={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===v){const n=u.children[v-1],o=n.offset+n.length,t=u.offset+u.length;k={offset:o,length:t-2-o,content:""}}else k={offset:b.offset,length:u.children[v+1].offset-b.offset,content:""};return D(S,k,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return D(S,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(w)},m)}}e.setProperty=R;function D(S,P,w){let m=I(S,P),d=P.offset,f=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;d>0&&!(0,_.isEOL)(m,d-1);)d--;for(;f<m.length&&!(0,_.isEOL)(m,f);)f++}const y=(0,_.format)(m,{offset:d,length:f-d},w);for(let u=y.length-1;u>=0;u--){const g=y[u];m=I(m,g),d=Math.min(d,g.offset),f=Math.max(f,g.offset+g.length),f+=g.content.length-g.length}const h=S.length-(m.length-f)-d;return[{offset:d,length:h,content:m.substring(d,f)}]}e.withFormatting=D;function I(S,P){return S.substring(0,P.offset)+P.content+S.substring(P.offset+P.length)}e.applyEdit=I;function C(S,P){const w=P.slice(0).sort((d,f)=>{const y=d.offset-f.offset;return y===0?d.length-f.length:y});let m=S.length;for(let d=w.length-1;d>=0;d--){const f=w[d];if(f.offset+f.length<=m)S=I(S,f);else throw new Error("Overlapping edit");m=f.offset}return S}e.applyEdits=C}),define(se[131],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(c){this.executor=c,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(c){this._error=c}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=L}),define(se[2],oe([0,1,82,63]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const c=!1;let R=null;function D(a){R=a}if(e.setDisposableTracker=D,c){const a="__is_disposable_tracked__";D(new class{trackDisposable(s){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[a]||console.log(l)},3e3)}setParent(s,l){if(s&&s!==g.None)try{s[a]=!0}catch{}}markAsDisposed(s){if(s&&s!==g.None)try{s[a]=!0}catch{}}markAsSingleton(s){}})}function I(a){return R?.trackDisposable(a),a}function C(a){R?.markAsDisposed(a)}function S(a,s){R?.setParent(a,s)}function P(a,s){if(!!R)for(const l of a)R.setParent(l,s)}function w(a){return R?.markAsSingleton(a),a}e.markAsSingleton=w;function m(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=m;function d(a){if(_.Iterable.is(a)){const s=[];for(const l of a)if(l)try{l.dispose()}catch(p){s.push(p)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function f(a){for(const s of a)m(s)&&s.dispose();return[]}e.disposeIfDisposable=f;function y(...a){const s=h(()=>d(a));return P(a,s),s}e.combinedDisposable=y;function h(a){const s=I({dispose:(0,L.once)(()=>{C(s),a()})});return s}e.toDisposable=h;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return S(s,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class g{constructor(){this._store=new u,I(this),S(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class v{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&S(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&S(s,null),s}}e.MutableDisposable=v;class b{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=b;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(s){let l=s;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,C(this))},this}}e.SafeDisposable=k;class n{constructor(){this.references=new Map}acquire(s,...l){let p=this.references.get(s);p||(p={counter:0,object:this.createReferencedObject(s,...l)},this.references.set(s,p));const{object:E}=p,T=(0,L.once)(()=>{--p.counter===0&&(this.destroyReferencedObject(s,p.object),this.references.delete(s))});return p.counter++,{object:E,dispose:T}}}e.ReferenceCollection=n;class o{constructor(s){this.referenceCollection=s}async acquire(s,...l){const p=this.referenceCollection.acquire(s,...l);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(E){throw p.dispose(),E}}}e.AsyncReferenceCollection=o;class t{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=t;function i(a){const s=new u;try{a(s)}finally{s.dispose()}}e.disposeOnReturn=i;class r{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){C(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(s){return this._store.has(s)}get(s){return this._store.get(s)}set(s,l,p=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this._store.get(s)?.dispose(),this._store.set(s,l)}deleteAndDispose(s){this._store.get(s)?.dispose(),this._store.delete(s)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(se[84],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(R){this.element=R,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class _{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let R=this._first;for(;R!==L.Undefined;){const D=R.next;R.prev=L.Undefined,R.next=L.Undefined,R=D}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const I=new L(R);if(this._first===L.Undefined)this._first=I,this._last=I;else if(D){const S=this._last;this._last=I,I.prev=S,S.next=I}else{const S=this._first;this._first=I,I.next=S,S.prev=I}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(I))}}shift(){if(this._first!==L.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==L.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==L.Undefined&&R.next!==L.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===L.Undefined&&R.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):R.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):R.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==L.Undefined;)yield R.element,R=R.next}}e.LinkedList=_}),define(se[38],oe([0,1]),function(ee,e){"use strict";var L,_,c;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(f,y,h){let u=f.get(y);return u===void 0&&(u=h,f.set(y,u)),u}e.getOrSet=R;function D(f){const y=[];return f.forEach((h,u)=>{y.push(`${u} => ${h}`)}),`Map(${f.size}) {${y.join(", ")}}`}e.mapToString=D;function I(f){const y=[];return f.forEach(h=>{y.push(h)}),`Set(${f.size}) {${y.join(", ")}}`}e.setToString=I;class C{constructor(y,h){this.uri=y,this.value=h}}class S{constructor(y,h){this[L]="ResourceMap",y instanceof S?(this.map=new Map(y.map),this.toKey=h??S.defaultToKey):(this.map=new Map,this.toKey=y??S.defaultToKey)}set(y,h){return this.map.set(this.toKey(y),new C(y,h)),this}get(y){return this.map.get(this.toKey(y))?.value}has(y){return this.map.has(this.toKey(y))}get size(){return this.map.size}clear(){this.map.clear()}delete(y){return this.map.delete(this.toKey(y))}forEach(y,h){typeof h<"u"&&(y=y.bind(h));for(const[u,g]of this.map)y(g.value,g.uri,this)}*values(){for(const y of this.map.values())yield y.value}*keys(){for(const y of this.map.values())yield y.uri}*entries(){for(const y of this.map.values())yield[y.uri,y.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,y]of this.map)yield[y.uri,y.value]}}S.defaultToKey=f=>f.toString(),e.ResourceMap=S;class P{constructor(y,h){this[_]="ResourceSet",!y||typeof y=="function"?this._map=new S(y):(this._map=new S(h),y.forEach(this.add,this))}get size(){return this._map.size}add(y){return this._map.set(y,y),this}clear(){this._map.clear()}delete(y){return this._map.delete(y)}forEach(y,h){this._map.forEach((u,g)=>y.call(h,g,g,this))}has(y){return this._map.has(y)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class m{constructor(){this[c]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(y){return this._map.has(y)}get(y,h=0){const u=this._map.get(y);if(!!u)return h!==0&&this.touch(u,h),u.value}set(y,h,u=0){let g=this._map.get(y);if(g)g.value=h,u!==0&&this.touch(g,u);else{switch(g={key:y,value:h,next:void 0,previous:void 0},u){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(y,g),this._size++}return this}delete(y){return!!this.remove(y)}remove(y){const h=this._map.get(y);if(!!h)return this._map.delete(y),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const y=this._head;return this._map.delete(y.key),this.removeItem(y),this._size--,y.value}forEach(y,h){const u=this._state;let g=this._head;for(;g;){if(h?y.bind(h)(g.value,g.key,this):y(g.value,g.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const y=this,h=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(y._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.key,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return g}values(){const y=this,h=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(y._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.value,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return g}entries(){const y=this,h=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(y._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:[u.key,u.value],done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return g}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(y){if(y>=this.size)return;if(y===0){this.clear();return}let h=this._head,u=this.size;for(;h&&u>y;)this._map.delete(h.key),h=h.next,u--;this._head=h,this._size=u,h&&(h.previous=void 0),this._state++}addItemFirst(y){if(!this._head&&!this._tail)this._tail=y;else if(this._head)y.next=this._head,this._head.previous=y;else throw new Error("Invalid list");this._head=y,this._state++}addItemLast(y){if(!this._head&&!this._tail)this._head=y;else if(this._tail)y.previous=this._tail,this._tail.next=y;else throw new Error("Invalid list");this._tail=y,this._state++}removeItem(y){if(y===this._head&&y===this._tail)this._head=void 0,this._tail=void 0;else if(y===this._head){if(!y.next)throw new Error("Invalid list");y.next.previous=void 0,this._head=y.next}else if(y===this._tail){if(!y.previous)throw new Error("Invalid list");y.previous.next=void 0,this._tail=y.previous}else{const h=y.next,u=y.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}y.next=void 0,y.previous=void 0,this._state++}touch(y,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(y===this._head)return;const u=y.next,g=y.previous;y===this._tail?(g.next=void 0,this._tail=g):(u.previous=g,g.next=u),y.previous=void 0,y.next=this._head,this._head.previous=y,this._head=y,this._state++}else if(h===2){if(y===this._tail)return;const u=y.next,g=y.previous;y===this._head?(u.previous=void 0,this._head=u):(u.previous=g,g.next=u),y.next=void 0,y.previous=this._tail,this._tail.next=y,this._tail=y,this._state++}}}toJSON(){const y=[];return this.forEach((h,u)=>{y.push([u,h])}),y}fromJSON(y){this.clear();for(const[h,u]of y)this.set(h,u)}}e.LinkedMap=m;class d extends m{constructor(y,h=1){super(),this._limit=y,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(y){this._limit=y,this.checkTrim()}get ratio(){return this._ratio}set ratio(y){this._ratio=Math.min(Math.max(0,y),1),this.checkTrim()}get(y,h=2){return super.get(y,h)}peek(y){return super.get(y,0)}set(y,h){return super.set(y,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(se[85],oe([0,1,38]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const _=new L.LRUCache(1e4);function c(S){return C(S,"NFC",_)}e.normalizeNFC=c;const R=new L.LRUCache(1e4);function D(S){return C(S,"NFD",R)}e.normalizeNFD=D;const I=/[^\u0000-\u0080]/;function C(S,P,w){if(!S)return S;const m=w.get(S);if(m)return m;let d;return I.test(S)?d=S.normalize(P):d=S,w.set(S,d),d}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(P){return D(P).replace(S,"")}}()}),define(se[132],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(I,C,S){return Math.min(Math.max(I,C),S)}e.clamp=L;function _(I,C){return(C+I%C)%C}e.rot=_;class c{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=c;class R{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class D{constructor(C){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(C),this._values.fill(0,0,C)}update(C){const S=this._values[this._index];return this._values[this._index]=C,this._index=(this._index+1)%this._values.length,this._sum-=S,this._sum+=C,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function ee(c){const R=[];typeof c=="number"&&R.push("code/timeOrigin",c);function D(C){R.push(C,Date.now())}function I(){const C=[];for(let S=0;S<R.length;S+=2)C.push({name:R[S],startTime:R[S+1]});return C}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(c){performance.mark(c)},getMarks(){let c=performance.timeOrigin;typeof c!="number"&&(c=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(c)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(c+D.startTime)});return R}};if(typeof process=="object"){const c=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(c)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function L(c){return c.MonacoPerformanceMarks||(c.MonacoPerformanceMarks=e()),c.MonacoPerformanceMarks}var _;typeof global=="object"?_=global:typeof self=="object"?_=self:_={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(_)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(_):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),_.perf=L(_))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var _ in L)(typeof exports=="object"?exports:ee)[_]=L[_]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function L(_){if(e[_])return e[_].exports;var c=e[_]={i:_,l:!1,exports:{}};return ee[_].call(c.exports,c,c.exports,L),c.l=!0,c.exports}return L.m=ee,L.c=e,L.d=function(_,c,R){L.o(_,c)||Object.defineProperty(_,c,{enumerable:!0,get:R})},L.r=function(_){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(_,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(_,"__esModule",{value:!0})},L.t=function(_,c){if(1&c&&(_=L(_)),8&c||4&c&&typeof _=="object"&&_&&_.__esModule)return _;var R=Object.create(null);if(L.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:_}),2&c&&typeof _!="string")for(var D in _)L.d(R,D,function(I){return _[I]}.bind(null,D));return R},L.n=function(_){var c=_&&_.__esModule?function(){return _.default}:function(){return _};return L.d(c,"a",c),c},L.o=function(_,c){return Object.prototype.hasOwnProperty.call(_,c)},L.p="",L(L.s=0)}([function(ee,e,L){(function(_){var c;e=ee.exports=B,c=typeof _=="object"&&_.env&&_.env.NODE_DEBUG&&/\bsemver\b/i.test(_.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],C=e.src=[],S=0,P=S++;C[P]="0|[1-9]\\d*";var w=S++;C[w]="[0-9]+";var m=S++;C[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=S++;C[d]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var f=S++;C[f]="("+C[w]+")\\.("+C[w]+")\\.("+C[w]+")";var y=S++;C[y]="(?:"+C[P]+"|"+C[m]+")";var h=S++;C[h]="(?:"+C[w]+"|"+C[m]+")";var u=S++;C[u]="(?:-("+C[y]+"(?:\\."+C[y]+")*))";var g=S++;C[g]="(?:-?("+C[h]+"(?:\\."+C[h]+")*))";var v=S++;C[v]="[0-9A-Za-z-]+";var b=S++;C[b]="(?:\\+("+C[v]+"(?:\\."+C[v]+")*))";var k=S++,n="v?"+C[d]+C[u]+"?"+C[b]+"?";C[k]="^"+n+"$";var o="[v=\\s]*"+C[f]+C[g]+"?"+C[b]+"?",t=S++;C[t]="^"+o+"$";var i=S++;C[i]="((?:<|>)?=?)";var r=S++;C[r]=C[w]+"|x|X|\\*";var a=S++;C[a]=C[P]+"|x|X|\\*";var s=S++;C[s]="[v=\\s]*("+C[a]+")(?:\\.("+C[a]+")(?:\\.("+C[a]+")(?:"+C[u]+")?"+C[b]+"?)?)?";var l=S++;C[l]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[g]+")?"+C[b]+"?)?)?";var p=S++;C[p]="^"+C[i]+"\\s*"+C[s]+"$";var E=S++;C[E]="^"+C[i]+"\\s*"+C[l]+"$";var T=S++;C[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=S++;C[A]="(?:~>?)";var N=S++;C[N]="(\\s*)"+C[A]+"\\s+",I[N]=new RegExp(C[N],"g");var W=S++;C[W]="^"+C[A]+C[s]+"$";var V=S++;C[V]="^"+C[A]+C[l]+"$";var K=S++;C[K]="(?:\\^)";var z=S++;C[z]="(\\s*)"+C[K]+"\\s+",I[z]=new RegExp(C[z],"g");var O=S++;C[O]="^"+C[K]+C[s]+"$";var $=S++;C[$]="^"+C[K]+C[l]+"$";var Z=S++;C[Z]="^"+C[i]+"\\s*("+o+")$|^$";var q=S++;C[q]="^"+C[i]+"\\s*("+n+")$|^$";var j=S++;C[j]="(\\s*)"+C[i]+"\\s*("+o+"|"+C[s]+")",I[j]=new RegExp(C[j],"g");var M=S++;C[M]="^\\s*("+C[s]+")\\s+-\\s+("+C[s]+")\\s*$";var J=S++;C[J]="^\\s*("+C[l]+")\\s+-\\s+("+C[l]+")\\s*$";var Q=S++;C[Q]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)c(re,C[re]),I[re]||(I[re]=new RegExp(C[re]));function ae(ce,de){if(ce instanceof B)return ce;if(typeof ce!="string"||ce.length>R||!(de?I[t]:I[k]).test(ce))return null;try{return new B(ce,de)}catch{return null}}function B(ce,de){if(ce instanceof B){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof B))return new B(ce,de);c("SemVer",ce,de),this.loose=de;var fe=ce.trim().match(de?I[t]:I[k]);if(!fe)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ie=+Pe;if(Ie>=0&&Ie<D)return Ie}return Pe}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,de){var fe=ae(ce,de);return fe?fe.version:null},e.clean=function(ce,de){var fe=ae(ce.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(ce){return c("SemVer.compare",this.version,this.loose,ce),ce instanceof B||(ce=new B(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},B.prototype.compareMain=function(ce){return ce instanceof B||(ce=new B(ce,this.loose)),U(this.major,ce.major)||U(this.minor,ce.minor)||U(this.patch,ce.patch)},B.prototype.comparePre=function(ce){if(ce instanceof B||(ce=new B(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Pe=ce.prerelease[de];if(c("prerelease compare",de,fe,Pe),fe===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(fe===void 0)return-1;if(fe!==Pe)return U(fe,Pe)}while(++de)},B.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,fe,Pe){typeof fe=="string"&&(Pe=fe,fe=void 0);try{return new B(ce,fe).inc(de,Pe).version}catch{return null}},e.diff=function(ce,de){if(G(ce,de))return null;var fe=ae(ce),Pe=ae(de);if(fe.prerelease.length||Pe.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Pe[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Pe[Ie])return Ie},e.compareIdentifiers=U;var F=/^[0-9]+$/;function U(ce,de){var fe=F.test(ce),Pe=F.test(de);return fe&&Pe&&(ce=+ce,de=+de),fe&&!Pe?-1:Pe&&!fe?1:ce<de?-1:ce>de?1:0}function x(ce,de,fe){return new B(ce,fe).compare(new B(de,fe))}function H(ce,de,fe){return x(ce,de,fe)>0}function te(ce,de,fe){return x(ce,de,fe)<0}function G(ce,de,fe){return x(ce,de,fe)===0}function X(ce,de,fe){return x(ce,de,fe)!==0}function ie(ce,de,fe){return x(ce,de,fe)>=0}function le(ce,de,fe){return x(ce,de,fe)<=0}function he(ce,de,fe,Pe){var Ie;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof fe=="object"&&(fe=fe.version),Ie=ce===fe;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof fe=="object"&&(fe=fe.version),Ie=ce!==fe;break;case"":case"=":case"==":Ie=G(ce,fe,Pe);break;case"!=":Ie=X(ce,fe,Pe);break;case">":Ie=H(ce,fe,Pe);break;case">=":Ie=ie(ce,fe,Pe);break;case"<":Ie=te(ce,fe,Pe);break;case"<=":Ie=le(ce,fe,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function me(ce,de){if(ce instanceof me){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof me))return new me(ce,de);c("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,c("comp",this)}e.rcompareIdentifiers=function(ce,de){return U(de,ce)},e.major=function(ce,de){return new B(ce,de).major},e.minor=function(ce,de){return new B(ce,de).minor},e.patch=function(ce,de){return new B(ce,de).patch},e.compare=x,e.compareLoose=function(ce,de){return x(ce,de,!0)},e.rcompare=function(ce,de,fe){return x(de,ce,fe)},e.sort=function(ce,de){return ce.sort(function(fe,Pe){return e.compare(fe,Pe,de)})},e.rsort=function(ce,de){return ce.sort(function(fe,Pe){return e.rcompare(fe,Pe,de)})},e.gt=H,e.lt=te,e.eq=G,e.neq=X,e.gte=ie,e.lte=le,e.cmp=he,e.Comparator=me;var ve={};function we(ce,de){if(ce instanceof we)return ce.loose===de?ce:new we(ce.raw,de);if(ce instanceof me)return new we(ce.value,de);if(!(this instanceof we))return new we(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ce(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Re(ce,de,fe,Pe,Ie,Ne,Le,Fe,Me,Oe,$e,ne,ue){return((de=Ce(fe)?"":Ce(Pe)?">="+fe+".0.0":Ce(Ie)?">="+fe+"."+Pe+".0":">="+de)+" "+(Fe=Ce(Me)?"":Ce(Oe)?"<"+(+Me+1)+".0.0":Ce($e)?"<"+Me+"."+(+Oe+1)+".0":ne?"<="+Me+"."+Oe+"."+$e+"-"+ne:"<="+Fe)).trim()}function ke(ce,de){for(var fe=0;fe<ce.length;fe++)if(!ce[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ce.length;fe++)if(c(ce[fe].semver),ce[fe].semver!==ve&&ce[fe].semver.prerelease.length>0){var Pe=ce[fe].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function ze(ce,de,fe){try{de=new we(de,fe)}catch{return!1}return de.test(ce)}function Ye(ce,de,fe,Pe){var Ie,Ne,Le,Fe,Me;switch(ce=new B(ce,Pe),de=new we(de,Pe),fe){case">":Ie=H,Ne=le,Le=te,Fe=">",Me=">=";break;case"<":Ie=te,Ne=ie,Le=H,Fe="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(ce,de,Pe))return!1;for(var Oe=0;Oe<de.set.length;++Oe){var $e=de.set[Oe],ne=null,ue=null;if($e.forEach(function(ge){ge.semver===ve&&(ge=new me(">=0.0.0")),ne=ne||ge,ue=ue||ge,Ie(ge.semver,ne.semver,Pe)?ne=ge:Le(ge.semver,ue.semver,Pe)&&(ue=ge)}),ne.operator===Fe||ne.operator===Me||(!ue.operator||ue.operator===Fe)&&Ne(ce,ue.semver)||ue.operator===Me&&Le(ce,ue.semver))return!1}return!0}me.prototype.parse=function(ce){var de=this.loose?I[Z]:I[q],fe=ce.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ce);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new B(fe[2],this.loose):this.semver=ve},me.prototype.toString=function(){return this.value},me.prototype.test=function(ce){return c("Comparator.test",ce,this.loose),this.semver===ve||(typeof ce=="string"&&(ce=new B(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},me.prototype.intersects=function(ce,de){if(!(ce instanceof me))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(ce.value,de),ze(this.value,fe,de);if(ce.operator==="")return fe=new we(this.value,de),ze(ce.semver,fe,de);var Pe=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ne=this.semver.version===ce.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Fe=he(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=he(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Pe||Ie||Ne&&Le||Fe||Me},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),c("range",ce,de);var fe=de?I[J]:I[M];ce=ce.replace(fe,Re),c("hyphen replace",ce),ce=ce.replace(I[j],"$1$2$3"),c("comparator trim",ce,I[j]),ce=(ce=(ce=ce.replace(I[N],"$1~")).replace(I[z],"$1^")).split(/\s+/).join(" ");var Pe=de?I[Z]:I[q],Ie=ce.split(" ").map(function(Ne){return function(Le,Fe){return c("comp",Le),Le=function(Me,Oe){return Me.trim().split(/\s+/).map(function($e){return function(ne,ue){c("caret",ne,ue);var ge=ue?I[$]:I[O];return ne.replace(ge,function(ye,Se,be,De,_e){var Ae;return c("caret",ne,ye,Se,be,De,_e),Ce(Se)?Ae="":Ce(be)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(De)?Ae=Se==="0"?">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0":">="+Se+"."+be+".0 <"+(+Se+1)+".0.0":_e?(c("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Ae=Se==="0"?be==="0"?">="+Se+"."+be+"."+De+_e+" <"+Se+"."+be+"."+(+De+1):">="+Se+"."+be+"."+De+_e+" <"+Se+"."+(+be+1)+".0":">="+Se+"."+be+"."+De+_e+" <"+(+Se+1)+".0.0"):(c("no pr"),Ae=Se==="0"?be==="0"?">="+Se+"."+be+"."+De+" <"+Se+"."+be+"."+(+De+1):">="+Se+"."+be+"."+De+" <"+Se+"."+(+be+1)+".0":">="+Se+"."+be+"."+De+" <"+(+Se+1)+".0.0"),c("caret return",Ae),Ae})}($e,Oe)}).join(" ")}(Le,Fe),c("caret",Le),Le=function(Me,Oe){return Me.trim().split(/\s+/).map(function($e){return function(ne,ue){var ge=ue?I[V]:I[W];return ne.replace(ge,function(ye,Se,be,De,_e){var Ae;return c("tilde",ne,ye,Se,be,De,_e),Ce(Se)?Ae="":Ce(be)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(De)?Ae=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0":_e?(c("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Ae=">="+Se+"."+be+"."+De+_e+" <"+Se+"."+(+be+1)+".0"):Ae=">="+Se+"."+be+"."+De+" <"+Se+"."+(+be+1)+".0",c("tilde return",Ae),Ae})}($e,Oe)}).join(" ")}(Le,Fe),c("tildes",Le),Le=function(Me,Oe){return c("replaceXRanges",Me,Oe),Me.split(/\s+/).map(function($e){return function(ne,ue){ne=ne.trim();var ge=ue?I[E]:I[p];return ne.replace(ge,function(ye,Se,be,De,_e,Ae){c("xRange",ne,ye,Se,be,De,_e,Ae);var Ue=Ce(be),xe=Ue||Ce(De),We=xe||Ce(_e);return Se==="="&&We&&(Se=""),Ue?ye=Se===">"||Se==="<"?"<0.0.0":"*":Se&&We?(xe&&(De=0),We&&(_e=0),Se===">"?(Se=">=",xe?(be=+be+1,De=0,_e=0):We&&(De=+De+1,_e=0)):Se==="<="&&(Se="<",xe?be=+be+1:De=+De+1),ye=Se+be+"."+De+"."+_e):xe?ye=">="+be+".0.0 <"+(+be+1)+".0.0":We&&(ye=">="+be+"."+De+".0 <"+be+"."+(+De+1)+".0"),c("xRange return",ye),ye})}($e,Oe)}).join(" ")}(Le,Fe),c("xrange",Le),Le=function(Me,Oe){return c("replaceStars",Me,Oe),Me.trim().replace(I[Q],"")}(Le,Fe),c("stars",Le),Le}(Ne,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Ne){return!!Ne.match(Pe)})),Ie=Ie.map(function(Ne){return new me(Ne,de)})},we.prototype.intersects=function(ce,de){if(!(ce instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Pe){return ce.set.some(function(Ie){return Ie.every(function(Ne){return Pe.intersects(Ne,de)})})})})},e.toComparators=function(ce,de){return new we(ce,de).set.map(function(fe){return fe.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new B(ce,this.loose));for(var de=0;de<this.set.length;de++)if(ke(this.set[de],ce))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(ce,de,fe){var Pe=null,Ie=null;try{var Ne=new we(de,fe)}catch{return null}return ce.forEach(function(Le){Ne.test(Le)&&(Pe&&Ie.compare(Le)!==-1||(Ie=new B(Pe=Le,fe)))}),Pe},e.minSatisfying=function(ce,de,fe){var Pe=null,Ie=null;try{var Ne=new we(de,fe)}catch{return null}return ce.forEach(function(Le){Ne.test(Le)&&(Pe&&Ie.compare(Le)!==1||(Ie=new B(Pe=Le,fe)))}),Pe},e.validRange=function(ce,de){try{return new we(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,fe){return Ye(ce,de,"<",fe)},e.gtr=function(ce,de,fe){return Ye(ce,de,">",fe)},e.outside=Ye,e.prerelease=function(ce,de){var fe=ae(ce,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ce,de,fe){return ce=new we(ce,fe),de=new we(de,fe),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof B)return ce;if(typeof ce!="string")return null;var de=ce.match(I[T]);return de==null?null:ae((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,L(1))},function(ee,e){var L,_,c=ee.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I(h){if(L===setTimeout)return setTimeout(h,0);if((L===R||!L)&&setTimeout)return L=setTimeout,setTimeout(h,0);try{return L(h,0)}catch{try{return L.call(null,h,0)}catch{return L.call(this,h,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:R}catch{L=R}try{_=typeof clearTimeout=="function"?clearTimeout:D}catch{_=D}})();var C,S=[],P=!1,w=-1;function m(){P&&C&&(P=!1,C.length?S=C.concat(S):w=-1,S.length&&d())}function d(){if(!P){var h=I(m);P=!0;for(var u=S.length;u;){for(C=S,S=[];++w<u;)C&&C[w].run();w=-1,u=S.length}C=null,P=!1,function(g){if(_===clearTimeout)return clearTimeout(g);if((_===D||!_)&&clearTimeout)return _=clearTimeout,clearTimeout(g);try{_(g)}catch{try{return _.call(null,g)}catch{return _.call(this,g)}}}(h)}}function f(h,u){this.fun=h,this.array=u}function y(){}c.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];S.push(new f(h,u)),S.length!==1||P||I(d)},f.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=y,c.addListener=y,c.once=y,c.off=y,c.removeListener=y,c.removeAllListeners=y,c.emit=y,c.prependListener=y,c.prependOnceListener=y,c.listeners=function(h){return[]},c.binding=function(h){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(h){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}}])}),define(se[133],oe([0,1]),function(ee,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class _{constructor(I,C,S){this.level=I,this.key=C,this.value=S,this.forward=[]}}const c=void 0;class R{constructor(I,C=2**16){this.comparator=I,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new _(this._maxLevel,c,c)}get size(){return this._size}clear(){this._header=new _(this._maxLevel,c,c)}has(I){return Boolean(R._search(this,I,this.comparator))}get(I){return R._search(this,I,this.comparator)?.value}set(I,C){return R._insert(this,I,C,this.comparator)&&(this._size+=1),this}delete(I){const C=R._delete(this,I,this.comparator);return C&&(this._size-=1),C}forEach(I,C){let S=this._header.forward[0];for(;S;)I.call(C,S.value,S.key,this),S=S.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",C=this._header.forward[0];for(;C;)I+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return I}static _search(I,C,S){let P=I._header;for(let w=I._level-1;w>=0;w--)for(;P.forward[w]&&S(P.forward[w].key,C)<0;)P=P.forward[w];if(P=P.forward[0],P&&S(P.key,C)===0)return P}static _insert(I,C,S,P){const w=[];let m=I._header;for(let d=I._level-1;d>=0;d--){for(;m.forward[d]&&P(m.forward[d].key,C)<0;)m=m.forward[d];w[d]=m}if(m=m.forward[0],m&&P(m.key,C)===0)return m.value=S,!1;{const d=R._randomLevel(I);if(d>I._level){for(let f=I._level;f<d;f++)w[f]=I._header;I._level=d}m=new _(d,C,S);for(let f=0;f<d;f++)m.forward[f]=w[f].forward[f],w[f].forward[f]=m;return!0}}static _randomLevel(I,C=.5){let S=1;for(;Math.random()<C&&S<I._maxLevel;)S+=1;return S}static _delete(I,C,S){const P=[];let w=I._header;for(let m=I._level-1;m>=0;m--){for(;w.forward[m]&&S(w.forward[m].key,C)<0;)w=w.forward[m];P[m]=w}if(w=w.forward[0],!w||S(w.key,C)!==0)return!1;for(let m=0;m<I._level&&P[m].forward[m]===w;m++)P[m].forward[m]=w.forward[m];for(;I._level>0&&I._header.forward[I._level-1]===c;)I._level-=1;return!0}}e.SkipList=R}),define(se[43],oe([0,1,7,2]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function c(b){const k=b;return k?typeof k.read=="function":!1}e.isReadable=c;function R(b){const k=b;return k?[k.on,k.pause,k.resume,k.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function D(b){const k=b;return k?R(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=D;function I(b,k){return new C(b,k)}e.newWriteableStream=I;class C{constructor(k,n){this.reducer=k,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(k){if(!this.state.destroyed){if(this.state.flowing)this.emitData(k);else if(this.buffer.data.push(k),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(k){this.state.destroyed||(this.state.flowing?this.emitError(k):this.buffer.error.push(k))}end(k){this.state.destroyed||(typeof k<"u"&&this.write(k),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(k){this.listeners.data.slice(0).forEach(n=>n(k))}emitError(k){this.listeners.error.length===0?(0,L.onUnexpectedError)(k):this.listeners.error.slice(0).forEach(n=>n(k))}emitEnd(){this.listeners.end.slice(0).forEach(k=>k())}on(k,n){if(!this.state.destroyed)switch(k){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(k,n){if(this.state.destroyed)return;let o;switch(k){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(n);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const k=this.reducer(this.buffer.data);this.emitData(k),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const k of this.buffer.error)this.emitError(k);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(b,k){const n=[];let o;for(;(o=b.read())!==null;)n.push(o);return k(n)}e.consumeReadable=S;function P(b,k,n){const o=[];let t;for(;(t=b.read())!==null&&o.length<n;)o.push(t);return t===null&&o.length>0?k(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return b.read()}}}e.peekReadable=P;function w(b,k){return new Promise((n,o)=>{const t=[];m(b,{onData:i=>{k&&t.push(i)},onError:i=>{k?o(i):n(void 0)},onEnd:()=>{n(k?k(t):void 0)}})})}e.consumeStream=w;function m(b,k){let n=!1;return b.on("error",o=>{n||k.onError(o)}),b.on("end",()=>{n||k.onEnd()}),b.on("data",o=>{n||k.onData(o)}),(0,_.toDisposable)(()=>n=!0)}e.listenStream=m;function d(b,k){return new Promise((n,o)=>{const t=new _.DisposableStore,i=[],r=l=>{if(i.push(l),i.length>k)return t.dispose(),b.pause(),n({stream:b,buffer:i,ended:!1})},a=l=>o(l),s=()=>n({stream:b,buffer:i,ended:!0});t.add((0,_.toDisposable)(()=>b.removeListener("error",a))),b.on("error",a),t.add((0,_.toDisposable)(()=>b.removeListener("end",s))),b.on("end",s),t.add((0,_.toDisposable)(()=>b.removeListener("data",r))),b.on("data",r)})}e.peekStream=d;function f(b,k){const n=I(k);return n.end(b),n}e.toStream=f;function y(){const b=I(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=y;function h(b){let k=!1;return{read:()=>k?null:(k=!0,b)}}e.toReadable=h;function u(b,k,n){const o=I(n);return m(b,{onData:t=>o.write(k.data(t)),onError:t=>o.error(k.error?k.error(t):t),onEnd:()=>o.end()}),o}e.transform=u;function g(b,k,n){let o=!1;return{read:()=>{const t=k.read();return o?t:(o=!0,t!==null?n([b,t]):b)}}}e.prefixedReadable=g;function v(b,k,n){let o=!1;const t=I(n);return m(k,{onData:i=>o?t.write(i):(o=!0,t.write(n([b,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(b)),t.end()}}),t}e.prefixedStream=v}),define(se[16],oe([0,1,43]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer<"u";let c,R;class D{static alloc(l){return _?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return _&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,p){return!(p?.dontUseNodeBuffer||!1)&&_?new D(Buffer.from(l)):(c||(c=new TextEncoder),new D(c.encode(l)))}static fromByteArray(l){const p=D.alloc(l.length);for(let E=0,T=l.length;E<T;E++)p.buffer[E]=l[E];return p}static concat(l,p){if(typeof p>"u"){p=0;for(let A=0,N=l.length;A<N;A++)p+=l[A].byteLength}const E=D.alloc(p);let T=0;for(let A=0,N=l.length;A<N;A++){const W=l[A];E.set(W,T),T+=W.byteLength}return E}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return _?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(l,p){return new D(this.buffer.subarray(l,p))}set(l,p){if(l instanceof D)this.buffer.set(l.buffer,p);else if(l instanceof Uint8Array)this.buffer.set(l,p);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),p);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return S(this.buffer,l)}writeUInt32BE(l,p){P(this.buffer,l,p)}readUInt32LE(l){return w(this.buffer,l)}writeUInt32LE(l,p){m(this.buffer,l,p)}readUInt8(l){return d(this.buffer,l)}writeUInt8(l,p){f(this.buffer,l,p)}}e.VSBuffer=D;function I(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0}e.readUInt16LE=I;function C(s,l,p){s[p+0]=l&255,l=l>>>8,s[p+1]=l&255}e.writeUInt16LE=C;function S(s,l){return s[l]*2**24+s[l+1]*2**16+s[l+2]*2**8+s[l+3]}e.readUInt32BE=S;function P(s,l,p){s[p+3]=l,l=l>>>8,s[p+2]=l,l=l>>>8,s[p+1]=l,l=l>>>8,s[p]=l}e.writeUInt32BE=P;function w(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0|s[l+2]<<16>>>0|s[l+3]<<24>>>0}e.readUInt32LE=w;function m(s,l,p){s[p+0]=l&255,l=l>>>8,s[p+1]=l&255,l=l>>>8,s[p+2]=l&255,l=l>>>8,s[p+3]=l&255}e.writeUInt32LE=m;function d(s,l){return s[l]}e.readUInt8=d;function f(s,l,p){s[p]=l}e.writeUInt8=f;function y(s){return L.consumeReadable(s,l=>D.concat(l))}e.readableToBuffer=y;function h(s){return L.toReadable(s)}e.bufferToReadable=h;function u(s){return L.consumeStream(s,l=>D.concat(l))}e.streamToBuffer=u;async function g(s){return s.ended?D.concat(s.buffer):D.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=g;function v(s){return L.toStream(s,l=>D.concat(l))}e.bufferToStream=v;function b(s){return L.transform(s,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=b;function k(s){return L.newWriteableStream(l=>D.concat(l),s)}e.newWriteableBufferStream=k;function n(s,l){return L.prefixedReadable(s,l,p=>D.concat(p))}e.prefixedBufferReadable=n;function o(s,l){return L.prefixedStream(s,l,p=>D.concat(p))}e.prefixedBufferStream=o;function t(s){let l=0,p=0,E=0;const T=new Uint8Array(Math.floor(s.length/4*3)),A=W=>{switch(p){case 3:T[E++]=l|W,p=0;break;case 2:T[E++]=l|W>>>2,l=W<<6,p=3;break;case 1:T[E++]=l|W>>>4,l=W<<4,p=2;break;default:l=W<<2,p=1}};for(let W=0;W<s.length;W++){const V=s.charCodeAt(W);if(V>=65&&V<=90)A(V-65);else if(V>=97&&V<=122)A(V-97+26);else if(V>=48&&V<=57)A(V-48+52);else if(V===43||V===45)A(62);else if(V===47||V===95)A(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${s[W]}`)}}const N=E;for(;p>0;)A(0);return D.wrap(T).slice(0,N)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:s},l=!0,p=!1){const E=p?r:i;let T="";const A=s.byteLength%3;let N=0;for(;N<s.byteLength-A;N+=3){const W=s[N+0],V=s[N+1],K=s[N+2];T+=E[W>>>2],T+=E[(W<<4|V>>>4)&63],T+=E[(V<<2|K>>>6)&63],T+=E[K&63]}if(A===1){const W=s[N+0];T+=E[W>>>2],T+=E[W<<4&63],l&&(T+="==")}else if(A===2){const W=s[N+0],V=s[N+1];T+=E[W>>>2],T+=E[(W<<4|V>>>4)&63],T+=E[V<<2&63],l&&(T+="=")}return T}e.encodeBase64=a}),define(se[134],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(se[12],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(o){return typeof o=="string"}e.isString=L;function _(o){return Array.isArray(o)&&o.every(t=>L(t))}e.isStringArray=_;function c(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=c;function R(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=R;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function I(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=I;function C(o){return o===!0||o===!1}e.isBoolean=C;function S(o){return typeof o>"u"}e.isUndefined=S;function P(o){return!w(o)}e.isDefined=P;function w(o){return S(o)||o===null}e.isUndefinedOrNull=w;function m(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function d(o){if(w(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=d;function f(...o){const t=[];for(let i=0;i<o.length;i++){const r=o[i];if(w(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(r)}return t}e.assertAllDefined=f;const y=Object.prototype.hasOwnProperty;function h(o){if(!c(o))return!1;for(const t in o)if(y.call(o,t))return!1;return!0}e.isEmptyObject=h;function u(o){return typeof o=="function"}e.isFunction=u;function g(...o){return o.length>0&&o.every(u)}e.areFunctions=g;function v(o,t){const i=Math.min(o.length,t.length);for(let r=0;r<i;r++)b(o[r],t[r])}e.validateConstraints=v;function b(o,t){if(L(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(o instanceof t)return}catch{}if(!w(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b;function k(o){return o===null?void 0:o}e.withNullAsUndefined=k;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(se[52],oe([0,1,12]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const _=Object.create(null);function c(I,C){if((0,L.isString)(C)){const S=_[C];if(S===void 0)throw new Error(`${I} references an unknown codicon: ${C}`);C=S}return _[I]=C,{id:I}}function R(){return _}e.getCodiconFontCharacters=R;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:c("add",6e4),plus:c("plus",6e4),gistNew:c("gist-new",6e4),repoCreate:c("repo-create",6e4),lightbulb:c("lightbulb",60001),lightBulb:c("light-bulb",60001),repo:c("repo",60002),repoDelete:c("repo-delete",60002),gistFork:c("gist-fork",60003),repoForked:c("repo-forked",60003),gitPullRequest:c("git-pull-request",60004),gitPullRequestAbandoned:c("git-pull-request-abandoned",60004),recordKeys:c("record-keys",60005),keyboard:c("keyboard",60005),tag:c("tag",60006),tagAdd:c("tag-add",60006),tagRemove:c("tag-remove",60006),person:c("person",60007),personFollow:c("person-follow",60007),personOutline:c("person-outline",60007),personFilled:c("person-filled",60007),gitBranch:c("git-branch",60008),gitBranchCreate:c("git-branch-create",60008),gitBranchDelete:c("git-branch-delete",60008),sourceControl:c("source-control",60008),mirror:c("mirror",60009),mirrorPublic:c("mirror-public",60009),star:c("star",60010),starAdd:c("star-add",60010),starDelete:c("star-delete",60010),starEmpty:c("star-empty",60010),comment:c("comment",60011),commentAdd:c("comment-add",60011),alert:c("alert",60012),warning:c("warning",60012),search:c("search",60013),searchSave:c("search-save",60013),logOut:c("log-out",60014),signOut:c("sign-out",60014),logIn:c("log-in",60015),signIn:c("sign-in",60015),eye:c("eye",60016),eyeUnwatch:c("eye-unwatch",60016),eyeWatch:c("eye-watch",60016),circleFilled:c("circle-filled",60017),primitiveDot:c("primitive-dot",60017),closeDirty:c("close-dirty",60017),debugBreakpoint:c("debug-breakpoint",60017),debugBreakpointDisabled:c("debug-breakpoint-disabled",60017),debugHint:c("debug-hint",60017),primitiveSquare:c("primitive-square",60018),edit:c("edit",60019),pencil:c("pencil",60019),info:c("info",60020),issueOpened:c("issue-opened",60020),gistPrivate:c("gist-private",60021),gitForkPrivate:c("git-fork-private",60021),lock:c("lock",60021),mirrorPrivate:c("mirror-private",60021),close:c("close",60022),removeClose:c("remove-close",60022),x:c("x",60022),repoSync:c("repo-sync",60023),sync:c("sync",60023),clone:c("clone",60024),desktopDownload:c("desktop-download",60024),beaker:c("beaker",60025),microscope:c("microscope",60025),vm:c("vm",60026),deviceDesktop:c("device-desktop",60026),file:c("file",60027),fileText:c("file-text",60027),more:c("more",60028),ellipsis:c("ellipsis",60028),kebabHorizontal:c("kebab-horizontal",60028),mailReply:c("mail-reply",60029),reply:c("reply",60029),organization:c("organization",60030),organizationFilled:c("organization-filled",60030),organizationOutline:c("organization-outline",60030),newFile:c("new-file",60031),fileAdd:c("file-add",60031),newFolder:c("new-folder",60032),fileDirectoryCreate:c("file-directory-create",60032),trash:c("trash",60033),trashcan:c("trashcan",60033),history:c("history",60034),clock:c("clock",60034),folder:c("folder",60035),fileDirectory:c("file-directory",60035),symbolFolder:c("symbol-folder",60035),logoGithub:c("logo-github",60036),markGithub:c("mark-github",60036),github:c("github",60036),terminal:c("terminal",60037),console:c("console",60037),repl:c("repl",60037),zap:c("zap",60038),symbolEvent:c("symbol-event",60038),error:c("error",60039),stop:c("stop",60039),variable:c("variable",60040),symbolVariable:c("symbol-variable",60040),array:c("array",60042),symbolArray:c("symbol-array",60042),symbolModule:c("symbol-module",60043),symbolPackage:c("symbol-package",60043),symbolNamespace:c("symbol-namespace",60043),symbolObject:c("symbol-object",60043),symbolMethod:c("symbol-method",60044),symbolFunction:c("symbol-function",60044),symbolConstructor:c("symbol-constructor",60044),symbolBoolean:c("symbol-boolean",60047),symbolNull:c("symbol-null",60047),symbolNumeric:c("symbol-numeric",60048),symbolNumber:c("symbol-number",60048),symbolStructure:c("symbol-structure",60049),symbolStruct:c("symbol-struct",60049),symbolParameter:c("symbol-parameter",60050),symbolTypeParameter:c("symbol-type-parameter",60050),symbolKey:c("symbol-key",60051),symbolText:c("symbol-text",60051),symbolReference:c("symbol-reference",60052),goToFile:c("go-to-file",60052),symbolEnum:c("symbol-enum",60053),symbolValue:c("symbol-value",60053),symbolRuler:c("symbol-ruler",60054),symbolUnit:c("symbol-unit",60054),activateBreakpoints:c("activate-breakpoints",60055),archive:c("archive",60056),arrowBoth:c("arrow-both",60057),arrowDown:c("arrow-down",60058),arrowLeft:c("arrow-left",60059),arrowRight:c("arrow-right",60060),arrowSmallDown:c("arrow-small-down",60061),arrowSmallLeft:c("arrow-small-left",60062),arrowSmallRight:c("arrow-small-right",60063),arrowSmallUp:c("arrow-small-up",60064),arrowUp:c("arrow-up",60065),bell:c("bell",60066),bold:c("bold",60067),book:c("book",60068),bookmark:c("bookmark",60069),debugBreakpointConditionalUnverified:c("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:c("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:c("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:c("debug-breakpoint-data-unverified",60072),debugBreakpointData:c("debug-breakpoint-data",60073),debugBreakpointDataDisabled:c("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:c("debug-breakpoint-log-unverified",60074),debugBreakpointLog:c("debug-breakpoint-log",60075),debugBreakpointLogDisabled:c("debug-breakpoint-log-disabled",60075),briefcase:c("briefcase",60076),broadcast:c("broadcast",60077),browser:c("browser",60078),bug:c("bug",60079),calendar:c("calendar",60080),caseSensitive:c("case-sensitive",60081),check:c("check",60082),checklist:c("checklist",60083),chevronDown:c("chevron-down",60084),dropDownButton:c("drop-down-button",60084),chevronLeft:c("chevron-left",60085),chevronRight:c("chevron-right",60086),chevronUp:c("chevron-up",60087),chromeClose:c("chrome-close",60088),chromeMaximize:c("chrome-maximize",60089),chromeMinimize:c("chrome-minimize",60090),chromeRestore:c("chrome-restore",60091),circle:c("circle",60092),circleOutline:c("circle-outline",60092),debugBreakpointUnverified:c("debug-breakpoint-unverified",60092),circleSlash:c("circle-slash",60093),circuitBoard:c("circuit-board",60094),clearAll:c("clear-all",60095),clippy:c("clippy",60096),closeAll:c("close-all",60097),cloudDownload:c("cloud-download",60098),cloudUpload:c("cloud-upload",60099),code:c("code",60100),collapseAll:c("collapse-all",60101),colorMode:c("color-mode",60102),commentDiscussion:c("comment-discussion",60103),compareChanges:c("compare-changes",60157),creditCard:c("credit-card",60105),dash:c("dash",60108),dashboard:c("dashboard",60109),database:c("database",60110),debugContinue:c("debug-continue",60111),debugDisconnect:c("debug-disconnect",60112),debugPause:c("debug-pause",60113),debugRestart:c("debug-restart",60114),debugStart:c("debug-start",60115),debugStepInto:c("debug-step-into",60116),debugStepOut:c("debug-step-out",60117),debugStepOver:c("debug-step-over",60118),debugStop:c("debug-stop",60119),debug:c("debug",60120),deviceCameraVideo:c("device-camera-video",60121),deviceCamera:c("device-camera",60122),deviceMobile:c("device-mobile",60123),diffAdded:c("diff-added",60124),diffIgnored:c("diff-ignored",60125),diffModified:c("diff-modified",60126),diffRemoved:c("diff-removed",60127),diffRenamed:c("diff-renamed",60128),diff:c("diff",60129),discard:c("discard",60130),editorLayout:c("editor-layout",60131),emptyWindow:c("empty-window",60132),exclude:c("exclude",60133),extensions:c("extensions",60134),eyeClosed:c("eye-closed",60135),fileBinary:c("file-binary",60136),fileCode:c("file-code",60137),fileMedia:c("file-media",60138),filePdf:c("file-pdf",60139),fileSubmodule:c("file-submodule",60140),fileSymlinkDirectory:c("file-symlink-directory",60141),fileSymlinkFile:c("file-symlink-file",60142),fileZip:c("file-zip",60143),files:c("files",60144),filter:c("filter",60145),flame:c("flame",60146),foldDown:c("fold-down",60147),foldUp:c("fold-up",60148),fold:c("fold",60149),folderActive:c("folder-active",60150),folderOpened:c("folder-opened",60151),gear:c("gear",60152),gift:c("gift",60153),gistSecret:c("gist-secret",60154),gist:c("gist",60155),gitCommit:c("git-commit",60156),gitCompare:c("git-compare",60157),gitMerge:c("git-merge",60158),githubAction:c("github-action",60159),githubAlt:c("github-alt",60160),globe:c("globe",60161),grabber:c("grabber",60162),graph:c("graph",60163),gripper:c("gripper",60164),heart:c("heart",60165),home:c("home",60166),horizontalRule:c("horizontal-rule",60167),hubot:c("hubot",60168),inbox:c("inbox",60169),issueClosed:c("issue-closed",60324),issueReopened:c("issue-reopened",60171),issues:c("issues",60172),italic:c("italic",60173),jersey:c("jersey",60174),json:c("json",60175),bracket:c("bracket",60175),kebabVertical:c("kebab-vertical",60176),key:c("key",60177),law:c("law",60178),lightbulbAutofix:c("lightbulb-autofix",60179),linkExternal:c("link-external",60180),link:c("link",60181),listOrdered:c("list-ordered",60182),listUnordered:c("list-unordered",60183),liveShare:c("live-share",60184),loading:c("loading",60185),location:c("location",60186),mailRead:c("mail-read",60187),mail:c("mail",60188),markdown:c("markdown",60189),megaphone:c("megaphone",60190),mention:c("mention",60191),milestone:c("milestone",60192),mortarBoard:c("mortar-board",60193),move:c("move",60194),multipleWindows:c("multiple-windows",60195),mute:c("mute",60196),noNewline:c("no-newline",60197),note:c("note",60198),octoface:c("octoface",60199),openPreview:c("open-preview",60200),package_:c("package",60201),paintcan:c("paintcan",60202),pin:c("pin",60203),play:c("play",60204),run:c("run",60204),plug:c("plug",60205),preserveCase:c("preserve-case",60206),preview:c("preview",60207),project:c("project",60208),pulse:c("pulse",60209),question:c("question",60210),quote:c("quote",60211),radioTower:c("radio-tower",60212),reactions:c("reactions",60213),references:c("references",60214),refresh:c("refresh",60215),regex:c("regex",60216),remoteExplorer:c("remote-explorer",60217),remote:c("remote",60218),remove:c("remove",60219),replaceAll:c("replace-all",60220),replace:c("replace",60221),repoClone:c("repo-clone",60222),repoForcePush:c("repo-force-push",60223),repoPull:c("repo-pull",60224),repoPush:c("repo-push",60225),report:c("report",60226),requestChanges:c("request-changes",60227),rocket:c("rocket",60228),rootFolderOpened:c("root-folder-opened",60229),rootFolder:c("root-folder",60230),rss:c("rss",60231),ruby:c("ruby",60232),saveAll:c("save-all",60233),saveAs:c("save-as",60234),save:c("save",60235),screenFull:c("screen-full",60236),screenNormal:c("screen-normal",60237),searchStop:c("search-stop",60238),server:c("server",60240),settingsGear:c("settings-gear",60241),settings:c("settings",60242),shield:c("shield",60243),smiley:c("smiley",60244),sortPrecedence:c("sort-precedence",60245),splitHorizontal:c("split-horizontal",60246),splitVertical:c("split-vertical",60247),squirrel:c("squirrel",60248),starFull:c("star-full",60249),starHalf:c("star-half",60250),symbolClass:c("symbol-class",60251),symbolColor:c("symbol-color",60252),symbolCustomColor:c("symbol-customcolor",60252),symbolConstant:c("symbol-constant",60253),symbolEnumMember:c("symbol-enum-member",60254),symbolField:c("symbol-field",60255),symbolFile:c("symbol-file",60256),symbolInterface:c("symbol-interface",60257),symbolKeyword:c("symbol-keyword",60258),symbolMisc:c("symbol-misc",60259),symbolOperator:c("symbol-operator",60260),symbolProperty:c("symbol-property",60261),wrench:c("wrench",60261),wrenchSubaction:c("wrench-subaction",60261),symbolSnippet:c("symbol-snippet",60262),tasklist:c("tasklist",60263),telescope:c("telescope",60264),textSize:c("text-size",60265),threeBars:c("three-bars",60266),thumbsdown:c("thumbsdown",60267),thumbsup:c("thumbsup",60268),tools:c("tools",60269),triangleDown:c("triangle-down",60270),triangleLeft:c("triangle-left",60271),triangleRight:c("triangle-right",60272),triangleUp:c("triangle-up",60273),twitter:c("twitter",60274),unfold:c("unfold",60275),unlock:c("unlock",60276),unmute:c("unmute",60277),unverified:c("unverified",60278),verified:c("verified",60279),versions:c("versions",60280),vmActive:c("vm-active",60281),vmOutline:c("vm-outline",60282),vmRunning:c("vm-running",60283),watch:c("watch",60284),whitespace:c("whitespace",60285),wholeWord:c("whole-word",60286),window:c("window",60287),wordWrap:c("word-wrap",60288),zoomIn:c("zoom-in",60289),zoomOut:c("zoom-out",60290),listFilter:c("list-filter",60291),listFlat:c("list-flat",60292),listSelection:c("list-selection",60293),selection:c("selection",60293),listTree:c("list-tree",60294),debugBreakpointFunctionUnverified:c("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:c("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:c("debug-breakpoint-function-disabled",60296),debugStackframeActive:c("debug-stackframe-active",60297),circleSmallFilled:c("circle-small-filled",60298),debugStackframeDot:c("debug-stackframe-dot",60298),debugStackframe:c("debug-stackframe",60299),debugStackframeFocused:c("debug-stackframe-focused",60299),debugBreakpointUnsupported:c("debug-breakpoint-unsupported",60300),symbolString:c("symbol-string",60301),debugReverseContinue:c("debug-reverse-continue",60302),debugStepBack:c("debug-step-back",60303),debugRestartFrame:c("debug-restart-frame",60304),callIncoming:c("call-incoming",60306),callOutgoing:c("call-outgoing",60307),menu:c("menu",60308),expandAll:c("expand-all",60309),feedback:c("feedback",60310),groupByRefType:c("group-by-ref-type",60311),ungroupByRefType:c("ungroup-by-ref-type",60312),account:c("account",60313),bellDot:c("bell-dot",60314),debugConsole:c("debug-console",60315),library:c("library",60316),output:c("output",60317),runAll:c("run-all",60318),syncIgnored:c("sync-ignored",60319),pinned:c("pinned",60320),githubInverted:c("github-inverted",60321),debugAlt:c("debug-alt",60305),serverProcess:c("server-process",60322),serverEnvironment:c("server-environment",60323),pass:c("pass",60324),stopCircle:c("stop-circle",60325),playCircle:c("play-circle",60326),record:c("record",60327),debugAltSmall:c("debug-alt-small",60328),vmConnect:c("vm-connect",60329),cloud:c("cloud",60330),merge:c("merge",60331),exportIcon:c("export",60332),graphLeft:c("graph-left",60333),magnet:c("magnet",60334),notebook:c("notebook",60335),redo:c("redo",60336),checkAll:c("check-all",60337),pinnedDirty:c("pinned-dirty",60338),passFilled:c("pass-filled",60339),circleLargeFilled:c("circle-large-filled",60340),circleLarge:c("circle-large",60341),circleLargeOutline:c("circle-large-outline",60341),combine:c("combine",60342),gather:c("gather",60342),table:c("table",60343),variableGroup:c("variable-group",60344),typeHierarchy:c("type-hierarchy",60345),typeHierarchySub:c("type-hierarchy-sub",60346),typeHierarchySuper:c("type-hierarchy-super",60347),gitPullRequestCreate:c("git-pull-request-create",60348),runAbove:c("run-above",60349),runBelow:c("run-below",60350),notebookTemplate:c("notebook-template",60351),debugRerun:c("debug-rerun",60352),workspaceTrusted:c("workspace-trusted",60353),workspaceUntrusted:c("workspace-untrusted",60354),workspaceUnspecified:c("workspace-unspecified",60355),terminalCmd:c("terminal-cmd",60356),terminalDebian:c("terminal-debian",60357),terminalLinux:c("terminal-linux",60358),terminalPowershell:c("terminal-powershell",60359),terminalTmux:c("terminal-tmux",60360),terminalUbuntu:c("terminal-ubuntu",60361),terminalBash:c("terminal-bash",60362),arrowSwap:c("arrow-swap",60363),copy:c("copy",60364),personAdd:c("person-add",60365),filterFilled:c("filter-filled",60366),wand:c("wand",60367),debugLineByLine:c("debug-line-by-line",60368),inspect:c("inspect",60369),layers:c("layers",60370),layersDot:c("layers-dot",60371),layersActive:c("layers-active",60372),compass:c("compass",60373),compassDot:c("compass-dot",60374),compassActive:c("compass-active",60375),azure:c("azure",60376),issueDraft:c("issue-draft",60377),gitPullRequestClosed:c("git-pull-request-closed",60378),gitPullRequestDraft:c("git-pull-request-draft",60379),debugAll:c("debug-all",60380),debugCoverage:c("debug-coverage",60381),runErrors:c("run-errors",60382),folderLibrary:c("folder-library",60383),debugContinueSmall:c("debug-continue-small",60384),beakerStop:c("beaker-stop",60385),graphLine:c("graph-line",60386),graphScatter:c("graph-scatter",60387),pieChart:c("pie-chart",60388),bracketDot:c("bracket-dot",60389),bracketError:c("bracket-error",60390),lockSmall:c("lock-small",60391),azureDevops:c("azure-devops",60392),verifiedFilled:c("verified-filled",60393),newLine:c("newline",60394),layout:c("layout",60395),layoutActivitybarLeft:c("layout-activitybar-left",60396),layoutActivitybarRight:c("layout-activitybar-right",60397),layoutPanelLeft:c("layout-panel-left",60398),layoutPanelCenter:c("layout-panel-center",60399),layoutPanelJustify:c("layout-panel-justify",60400),layoutPanelRight:c("layout-panel-right",60401),layoutPanel:c("layout-panel",60402),layoutSidebarLeft:c("layout-sidebar-left",60403),layoutSidebarRight:c("layout-sidebar-right",60404),layoutStatusbar:c("layout-statusbar",60405),layoutMenubar:c("layout-menubar",60406),layoutCentered:c("layout-centered",60407),layoutSidebarRightOff:c("layout-sidebar-right-off",60416),layoutPanelOff:c("layout-panel-off",60417),layoutSidebarLeftOff:c("layout-sidebar-left-off",60418),target:c("target",60408),indent:c("indent",60409),recordSmall:c("record-small",60410),errorSmall:c("error-small",60411),arrowCircleDown:c("arrow-circle-down",60412),arrowCircleLeft:c("arrow-circle-left",60413),arrowCircleRight:c("arrow-circle-right",60414),arrowCircleUp:c("arrow-circle-up",60415),heartFilled:c("heart-filled",60420),map:c("map",60421),mapFilled:c("map-filled",60422),circleSmall:c("circle-small",60423),bellSlash:c("bell-slash",60424),bellSlashDot:c("bell-slash-dot",60425),commentUnresolved:c("comment-unresolved",60426),gitPullRequestGoToChanges:c("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:c("git-pull-request-new-changes",60428),searchFuzzy:c("search-fuzzy",60429),commentDraft:c("comment-draft",60430),dialogError:c("dialog-error","error"),dialogWarning:c("dialog-warning","warning"),dialogInfo:c("dialog-info","info"),dialogClose:c("dialog-close","close"),treeItemExpanded:c("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:c("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:c("tree-filter-on-type-off","list-selection"),treeFilterClear:c("tree-filter-clear","close"),treeItemLoading:c("tree-item-loading","loading"),menuSelection:c("menu-selection","check"),menuSubmenu:c("menu-submenu","chevron-right"),menuBarMore:c("menubar-more","more"),scrollbarButtonLeft:c("scrollbar-button-left","triangle-left"),scrollbarButtonRight:c("scrollbar-button-right","triangle-right"),scrollbarButtonUp:c("scrollbar-button-up","triangle-up"),scrollbarButtonDown:c("scrollbar-button-down","triangle-down"),toolBarMore:c("toolbar-more","more"),quickInputBack:c("quick-input-back","arrow-left")}}),define(se[32],oe([0,1,12]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function _(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([v,b])=>{g[v]=b&&typeof b=="object"?_(b):b}),g}e.deepClone=_;function c(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const b in v)if(R.call(v,b)){const k=v[b];typeof k=="object"&&!Object.isFrozen(k)&&!(0,L.isTypedArray)(k)&&g.push(k)}}return u}e.deepFreeze=c;const R=Object.prototype.hasOwnProperty;function D(u,g){return I(u,g,new Set)}e.cloneAndChange=D;function I(u,g,v){if((0,L.isUndefinedOrNull)(u))return u;const b=g(u);if(typeof b<"u")return b;if(Array.isArray(u)){const k=[];for(const n of u)k.push(I(n,g,v));return k}if((0,L.isObject)(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const k={};for(const n in u)R.call(u,n)&&(k[n]=I(u[n],g,v));return v.delete(u),k}return u}function C(u,g,v=!0){return(0,L.isObject)(u)?((0,L.isObject)(g)&&Object.keys(g).forEach(b=>{b in u?v&&((0,L.isObject)(u[b])&&(0,L.isObject)(g[b])?C(u[b],g[b],v):u[b]=g[b]):u[b]=g[b]}),u):g}e.mixin=C;function S(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let v,b;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(v=0;v<u.length;v++)if(!S(u[v],g[v]))return!1}else{const k=[];for(b in u)k.push(b);k.sort();const n=[];for(b in g)n.push(b);if(n.sort(),!S(k,n))return!1;for(v=0;v<k.length;v++)if(!S(u[k[v]],g[k[v]]))return!1}return!0}e.equals=S;function P(u){const g=new Set;return JSON.stringify(u,(v,b)=>{if((0,L.isObject)(b)||Array.isArray(b)){if(g.has(b))return"[Circular]";g.add(b)}return b})}e.safeStringify=P;function w(u,g){const v=Object.create(null);return!u||!g||Object.keys(g).forEach(k=>{const n=u[k],o=g[k];S(n,o)||(v[k]=o)}),v}e.distinct=w;function m(u,g){const v=g.toLowerCase(),b=Object.keys(u).find(k=>k.toLowerCase()===v);return b?u[b]:u[g]}e.getCaseInsensitive=m;function d(u,g){const v=Object.create(null);for(const[b,k]of Object.entries(u))g(b,k)&&(v[b]=k);return v}e.filter=d;function f(u){let g=[],v=Object.getPrototypeOf(u);for(;Object.prototype!==v;)g=g.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return g}e.getAllPropertyNames=f;function y(u){const g=[];for(const v of f(u))typeof u[v]=="function"&&g.push(v);return g}e.getAllMethodNames=y;function h(u,g){const v=k=>function(){const n=Array.prototype.slice.call(arguments,0);return g(k,n)},b={};for(const k of u)b[k]=v(k);return b}e.createProxyObject=h}),define(se[135],oe([0,1,52]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var _;(function(D){function I(C){return C&&typeof C=="object"&&typeof C.id=="string"}D.isThemeColor=I})(_=e.ThemeColor||(e.ThemeColor={}));function c(D){return{id:D}}e.themeColorFromId=c;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function C(g){const v=I.exec(g.id);if(!v)return C(L.Codicon.error);const[,b,k]=v,n=["codicon","codicon-"+b];return k&&n.push("codicon-modifier-"+k.substring(1)),n}D.asClassNameArray=C;function S(g){return C(g).join(" ")}D.asClassName=S;function P(g){return"."+C(g).join(".")}D.asCSSSelector=P;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||_.isThemeColor(g.color))}D.isThemeIcon=w;const m=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function d(g){const v=m.exec(g);if(!v)return;const[,b]=v;return{id:b}}D.fromString=d;function f(g){return{id:g}}D.fromId=f;function y(g,v){let b=g.id;const k=b.lastIndexOf("~");return k!==-1&&(b=b.substring(0,k)),v&&(b=`${b}~${v}`),{id:b}}D.modify=y;function h(g){const v=g.id.lastIndexOf("~");if(v!==-1)return g.id.substring(v+1)}D.getModifier=h;function u(g,v){return g.id===v.id&&g.color?.id===v.color?.id}D.isEqual=u})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(se[31],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function _(c){return L.test(c)}e.isUUID=_,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let c;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?c=crypto.getRandomValues.bind(crypto):c=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};const R=new Uint8Array(16),D=[];for(let I=0;I<256;I++)D.push(I.toString(16).padStart(2,"0"));return function(){c(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let C=0,S="";return S+=D[R[C++]],S+=D[R[C++]],S+=D[R[C++]],S+=D[R[C++]],S+="-",S+=D[R[C++]],S+=D[R[C++]],S+="-",S+=D[R[C++]],S+=D[R[C++]],S+="-",S+=D[R[C++]],S+=D[R[C++]],S+="-",S+=D[R[C++]],S+=D[R[C++]],S+=D[R[C++]],S+=D[R[C++]],S+=D[R[C++]],S+=D[R[C++]],S}}()}),define(se[136],oe([0,1,34]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const _=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function c(D){const I=D.replace(/\-/g,":").toLowerCase();return!_.has(I)}function R(){const D=(0,L.networkInterfaces)();for(const I in D){const C=D[I];if(C){for(const{mac:S}of C)if(c(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(se[137],oe([0,1,86]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function _(I,C,S,P=1){let w=!1;return new Promise(m=>{const d=setTimeout(()=>{if(!w)return w=!0,m(0)},S);c(I,C,P,f=>{if(!w)return w=!0,clearTimeout(d),m(f)})})}e.findFreePort=_;function c(I,C,S,P){if(C===0)return P(0);const w=new L.Socket;w.once("connect",()=>(D(w),c(I+S,C-1,S,P))),w.once("data",()=>{}),w.once("error",m=>(D(w),m.code!=="ECONNREFUSED"?c(I+S,C-1,S,P):P(I))),w.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(I,C,S,P="127.0.0.1"){let w=!1,m,d=1;const f=L.createServer({pauseOnConnect:!0});function y(h,u){w||(w=!0,f.removeAllListeners(),f.close(),m&&clearTimeout(m),u(h))}return new Promise(h=>{m=setTimeout(()=>{y(0,h)},S),f.on("listening",()=>{y(I,h)}),f.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&d<C?(I++,d++,f.listen(I,P)):y(0,h)}),f.on("close",()=>{y(0,h)}),f.listen(I,P)})}e.findFreePortFaster=R;function D(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(C){console.error(C)}}}),define(se[138],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const L="Offline";function _(R){return R instanceof c?!0:R instanceof Error&&R.name===L&&R.message===L}e.isOfflineError=_;class c extends Error{constructor(){super(L),this.name=this.message}}e.OfflineError=c}),define(se[139],oe([0,1,16,7,138]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(C,S){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const P=new XMLHttpRequest;return new Promise((w,m)=>{P.open(C.type||"GET",C.url||"",!0,C.user,C.password),D(P,C),P.responseType="arraybuffer",P.onerror=d=>m(navigator.onLine?new Error(P.statusText&&"XHR failed: "+P.statusText||"XHR failed"):new c.OfflineError),P.onload=d=>{w({res:{statusCode:P.status,headers:I(P)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(P.response)))})},P.ontimeout=d=>m(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(P.timeout=C.timeout),P.send(C.data),S.onCancellationRequested(()=>{P.abort(),m((0,_.canceled)())})})}e.request=R;function D(C,S){if(S.headers){e:for(const P in S.headers){switch(P){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(P,S.headers[P])}}}function I(C){const S=Object.create(null);for(const P of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(P){const w=P.indexOf(":");S[P.substr(0,w).trim().toLowerCase()]=P.substr(w+1).trim()}return S}}),define(se[87],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(_){return!!_.parentPort}e.isUtilityProcess=L}),define(se[140],oe([10,8]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(se[64],oe([0,1,140]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const _=60,c=_*60,R=c*24,D=R*7,I=R*30,C=R*365;function S(w,m,d,f){typeof w!="number"&&(w=w.getTime());const y=Math.round((new Date().getTime()-w)/1e3);if(y<-30)return(0,L.localize)(0,null,S(new Date().getTime()+y*1e3,!1));if(!f&&y<30)return(0,L.localize)(1,null);let h;return y<_?(h=y,m?h===1?d?(0,L.localize)(2,null,h):(0,L.localize)(3,null,h):d?(0,L.localize)(4,null,h):(0,L.localize)(5,null,h):h===1?d?(0,L.localize)(6,null,h):(0,L.localize)(7,null,h):d?(0,L.localize)(8,null,h):(0,L.localize)(9,null,h)):y<c?(h=Math.floor(y/_),m?h===1?d?(0,L.localize)(10,null,h):(0,L.localize)(11,null,h):d?(0,L.localize)(12,null,h):(0,L.localize)(13,null,h):h===1?d?(0,L.localize)(14,null,h):(0,L.localize)(15,null,h):d?(0,L.localize)(16,null,h):(0,L.localize)(17,null,h)):y<R?(h=Math.floor(y/c),m?h===1?d?(0,L.localize)(18,null,h):(0,L.localize)(19,null,h):d?(0,L.localize)(20,null,h):(0,L.localize)(21,null,h):h===1?d?(0,L.localize)(22,null,h):(0,L.localize)(23,null,h):d?(0,L.localize)(24,null,h):(0,L.localize)(25,null,h)):y<D?(h=Math.floor(y/R),m?h===1?(0,L.localize)(26,null,h):(0,L.localize)(27,null,h):h===1?(0,L.localize)(28,null,h):(0,L.localize)(29,null,h)):y<I?(h=Math.floor(y/D),m?h===1?d?(0,L.localize)(30,null,h):(0,L.localize)(31,null,h):d?(0,L.localize)(32,null,h):(0,L.localize)(33,null,h):h===1?d?(0,L.localize)(34,null,h):(0,L.localize)(35,null,h):d?(0,L.localize)(36,null,h):(0,L.localize)(37,null,h)):y<C?(h=Math.floor(y/I),m?h===1?d?(0,L.localize)(38,null,h):(0,L.localize)(39,null,h):d?(0,L.localize)(40,null,h):(0,L.localize)(41,null,h):h===1?d?(0,L.localize)(42,null,h):(0,L.localize)(43,null,h):d?(0,L.localize)(44,null,h):(0,L.localize)(45,null,h)):(h=Math.floor(y/C),m?h===1?d?(0,L.localize)(46,null,h):(0,L.localize)(47,null,h):d?(0,L.localize)(48,null,h):(0,L.localize)(49,null,h):h===1?d?(0,L.localize)(50,null,h):(0,L.localize)(51,null,h):d?(0,L.localize)(52,null,h):(0,L.localize)(53,null,h))}e.fromNow=S;function P(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(se[141],oe([10,8]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(se[39],oe([0,1,19,12,141]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(w,m){return m&&(w.stack||w.stacktrace)?c.localize(0,null,I(w),D(w.stack)||D(w.stacktrace)):I(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function I(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?c.localize(1,null,w.message):w.message||c.localize(2,null)}function C(w=null,m=!1){if(!w)return c.localize(3,null);if(Array.isArray(w)){const d=L.coalesce(w),f=C(d[0],m);return d.length>1?c.localize(4,null,f,d.length):f}if(_.isString(w))return w;if(w.detail){const d=w.detail;if(d.error)return R(d.error,m);if(d.exception)return R(d.exception,m)}return w.stack?R(w,m):w.message?w.message:c.localize(5,null)}e.toErrorMessage=C;function S(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=S;function P(w,m){let d;return typeof w=="string"?d=new Error(w):d=w,d.actions=m,d}e.createErrorWithActions=P}),define(se[142],oe([10,8]),function(ee,e){return ee.create("vs/base/common/jsonErrorMessages",e)}),define(se[143],oe([0,1,142]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function _(c){switch(c){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=_}),define(se[144],oe([10,8]),function(ee,e){return ee.create("vs/base/common/platform",e)}),define(se[4],oe([0,1,144]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let _=!1,c=!1,R=!1,D=!1,I=!1,C=!1,S=!1,P=!1,w=!1,m=!1,d,f=e.LANGUAGE_DEFAULT,y,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",v=g&&u?.type==="renderer";if(typeof navigator=="object"&&!v)h=navigator.userAgent,_=h.indexOf("Windows")>=0,c=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,C=!0,d=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,f=d;else if(typeof u=="object"){_=u.platform==="win32",c=u.platform==="darwin",R=u.platform==="linux",D=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=g,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),p=l.availableLanguages["*"];d=l.locale,f=p||e.LANGUAGE_DEFAULT,y=l._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function k(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=k;let n=0;c?n=1:_?n=3:R&&(n=2),e.isWindows=_,e.isMacintosh=c,e.isLinux=R,e.isLinuxSnap=D,e.isNative=I,e.isElectron=S,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=m,e.isCI=w,e.platform=n,e.userAgent=h,e.language=f;var o;(function(s){function l(){return e.language}s.value=l;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=p;function E(){return e.language==="en"}s.isDefault=E})(o=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let E=0,T=s.length;E<T;E++){const A=s[E];if(A.id===p.data.vscodeScheduleAsyncWork){s.splice(E,1),A.callback();return}}});let l=0;return p=>{const E=++l;s.push({id:E,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return s=>setTimeout(s)})();var t;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=c||P?2:_?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(se[36],oe([0,1,4]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let _;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const c=L.globals.vscode.process;_={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=_.cwd,e.env=_.env,e.platform=_.platform,e.arch=_.arch}),define(se[13],oe([0,1,36]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const _=65,c=97,R=90,D=122,I=46,C=47,S=92,P=58,w=63;class m extends Error{constructor(o,t,i){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const a=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${a} ${r} of type ${t}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function d(n,o){if(n===null||typeof n!="object")throw new m(o,"Object",n)}function f(n,o){if(typeof n!="string")throw new m(o,"string",n)}const y=L.platform==="win32";function h(n){return n===C||n===S}function u(n){return n===C}function g(n){return n>=_&&n<=R||n>=c&&n<=D}function v(n,o,t,i){let r="",a=0,s=-1,l=0,p=0;for(let E=0;E<=n.length;++E){if(E<n.length)p=n.charCodeAt(E);else{if(i(p))break;p=C}if(i(p)){if(!(s===E-1||l===1))if(l===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==I||r.charCodeAt(r.length-2)!==I){if(r.length>2){const T=r.lastIndexOf(t);T===-1?(r="",a=0):(r=r.slice(0,T),a=r.length-1-r.lastIndexOf(t)),s=E,l=0;continue}else if(r.length!==0){r="",a=0,s=E,l=0;continue}}o&&(r+=r.length>0?`${t}..`:"..",a=2)}else r.length>0?r+=`${t}${n.slice(s+1,E)}`:r=n.slice(s+1,E),a=E-s-1;s=E,l=0}else p===I&&l!==-1?++l:l=-1}return r}function b(n,o){d(o,"pathObject");const t=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return t?t===o.root?`${t}${i}`:`${t}${n}${i}`:i}e.win32={resolve(...n){let o="",t="",i=!1;for(let r=n.length-1;r>=-1;r--){let a;if(r>=0){if(a=n[r],f(a,"path"),a.length===0)continue}else o.length===0?a=L.cwd():(a=L.env[`=${o}`]||L.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===S)&&(a=`${o}\\`));const s=a.length;let l=0,p="",E=!1;const T=a.charCodeAt(0);if(s===1)h(T)&&(l=1,E=!0);else if(h(T))if(E=!0,h(a.charCodeAt(1))){let A=2,N=A;for(;A<s&&!h(a.charCodeAt(A));)A++;if(A<s&&A!==N){const W=a.slice(N,A);for(N=A;A<s&&h(a.charCodeAt(A));)A++;if(A<s&&A!==N){for(N=A;A<s&&!h(a.charCodeAt(A));)A++;(A===s||A!==N)&&(p=`\\\\${W}\\${a.slice(N,A)}`,l=A)}}}else l=1;else g(T)&&a.charCodeAt(1)===P&&(p=a.slice(0,2),l=2,s>2&&h(a.charCodeAt(2))&&(E=!0,l=3));if(p.length>0)if(o.length>0){if(p.toLowerCase()!==o.toLowerCase())continue}else o=p;if(i){if(o.length>0)break}else if(t=`${a.slice(l)}\\${t}`,i=E,E&&o.length>0)break}return t=v(t,!i,"\\",h),i?`${o}\\${t}`:`${o}${t}`||"."},normalize(n){f(n,"path");const o=n.length;if(o===0)return".";let t=0,i,r=!1;const a=n.charCodeAt(0);if(o===1)return u(a)?"\\":n;if(h(a))if(r=!0,h(n.charCodeAt(1))){let l=2,p=l;for(;l<o&&!h(n.charCodeAt(l));)l++;if(l<o&&l!==p){const E=n.slice(p,l);for(p=l;l<o&&h(n.charCodeAt(l));)l++;if(l<o&&l!==p){for(p=l;l<o&&!h(n.charCodeAt(l));)l++;if(l===o)return`\\\\${E}\\${n.slice(p)}\\`;l!==p&&(i=`\\\\${E}\\${n.slice(p,l)}`,t=l)}}}else t=1;else g(a)&&n.charCodeAt(1)===P&&(i=n.slice(0,2),t=2,o>2&&h(n.charCodeAt(2))&&(r=!0,t=3));let s=t<o?v(n.slice(t),!r,"\\",h):"";return s.length===0&&!r&&(s="."),s.length>0&&h(n.charCodeAt(o-1))&&(s+="\\"),i===void 0?r?`\\${s}`:s:r?`${i}\\${s}`:`${i}${s}`},isAbsolute(n){f(n,"path");const o=n.length;if(o===0)return!1;const t=n.charCodeAt(0);return h(t)||o>2&&g(t)&&n.charCodeAt(1)===P&&h(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let o,t;for(let a=0;a<n.length;++a){const s=n[a];f(s,"path"),s.length>0&&(o===void 0?o=t=s:o+=`\\${s}`)}if(o===void 0)return".";let i=!0,r=0;if(typeof t=="string"&&h(t.charCodeAt(0))){++r;const a=t.length;a>1&&h(t.charCodeAt(1))&&(++r,a>2&&(h(t.charCodeAt(2))?++r:i=!1))}if(i){for(;r<o.length&&h(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(n,o){if(f(n,"from"),f(o,"to"),n===o)return"";const t=e.win32.resolve(n),i=e.win32.resolve(o);if(t===i||(n=t.toLowerCase(),o=i.toLowerCase(),n===o))return"";let r=0;for(;r<n.length&&n.charCodeAt(r)===S;)r++;let a=n.length;for(;a-1>r&&n.charCodeAt(a-1)===S;)a--;const s=a-r;let l=0;for(;l<o.length&&o.charCodeAt(l)===S;)l++;let p=o.length;for(;p-1>l&&o.charCodeAt(p-1)===S;)p--;const E=p-l,T=s<E?s:E;let A=-1,N=0;for(;N<T;N++){const V=n.charCodeAt(r+N);if(V!==o.charCodeAt(l+N))break;V===S&&(A=N)}if(N!==T){if(A===-1)return i}else{if(E>T){if(o.charCodeAt(l+N)===S)return i.slice(l+N+1);if(N===2)return i.slice(l+N)}s>T&&(n.charCodeAt(r+N)===S?A=N:N===2&&(A=3)),A===-1&&(A=0)}let W="";for(N=r+A+1;N<=a;++N)(N===a||n.charCodeAt(N)===S)&&(W+=W.length===0?"..":"\\..");return l+=A,W.length>0?`${W}${i.slice(l,p)}`:(i.charCodeAt(l)===S&&++l,i.slice(l,p))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const o=e.win32.resolve(n);if(o.length<=2)return n;if(o.charCodeAt(0)===S){if(o.charCodeAt(1)===S){const t=o.charCodeAt(2);if(t!==w&&t!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===S)return`\\\\?\\${o}`;return n},dirname(n){f(n,"path");const o=n.length;if(o===0)return".";let t=-1,i=0;const r=n.charCodeAt(0);if(o===1)return h(r)?n:".";if(h(r)){if(t=i=1,h(n.charCodeAt(1))){let l=2,p=l;for(;l<o&&!h(n.charCodeAt(l));)l++;if(l<o&&l!==p){for(p=l;l<o&&h(n.charCodeAt(l));)l++;if(l<o&&l!==p){for(p=l;l<o&&!h(n.charCodeAt(l));)l++;if(l===o)return n;l!==p&&(t=i=l+1)}}}}else g(r)&&n.charCodeAt(1)===P&&(t=o>2&&h(n.charCodeAt(2))?3:2,i=t);let a=-1,s=!0;for(let l=o-1;l>=i;--l)if(h(n.charCodeAt(l))){if(!s){a=l;break}}else s=!1;if(a===-1){if(t===-1)return".";a=t}return n.slice(0,a)},basename(n,o){o!==void 0&&f(o,"ext"),f(n,"path");let t=0,i=-1,r=!0,a;if(n.length>=2&&g(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(t=2),o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let s=o.length-1,l=-1;for(a=n.length-1;a>=t;--a){const p=n.charCodeAt(a);if(h(p)){if(!r){t=a+1;break}}else l===-1&&(r=!1,l=a+1),s>=0&&(p===o.charCodeAt(s)?--s===-1&&(i=a):(s=-1,i=l))}return t===i?i=l:i===-1&&(i=n.length),n.slice(t,i)}for(a=n.length-1;a>=t;--a)if(h(n.charCodeAt(a))){if(!r){t=a+1;break}}else i===-1&&(r=!1,i=a+1);return i===-1?"":n.slice(t,i)},extname(n){f(n,"path");let o=0,t=-1,i=0,r=-1,a=!0,s=0;n.length>=2&&n.charCodeAt(1)===P&&g(n.charCodeAt(0))&&(o=i=2);for(let l=n.length-1;l>=o;--l){const p=n.charCodeAt(l);if(h(p)){if(!a){i=l+1;break}continue}r===-1&&(a=!1,r=l+1),p===I?t===-1?t=l:s!==1&&(s=1):t!==-1&&(s=-1)}return t===-1||r===-1||s===0||s===1&&t===r-1&&t===i+1?"":n.slice(t,r)},format:b.bind(null,"\\"),parse(n){f(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const t=n.length;let i=0,r=n.charCodeAt(0);if(t===1)return h(r)?(o.root=o.dir=n,o):(o.base=o.name=n,o);if(h(r)){if(i=1,h(n.charCodeAt(1))){let A=2,N=A;for(;A<t&&!h(n.charCodeAt(A));)A++;if(A<t&&A!==N){for(N=A;A<t&&h(n.charCodeAt(A));)A++;if(A<t&&A!==N){for(N=A;A<t&&!h(n.charCodeAt(A));)A++;A===t?i=A:A!==N&&(i=A+1)}}}}else if(g(r)&&n.charCodeAt(1)===P){if(t<=2)return o.root=o.dir=n,o;if(i=2,h(n.charCodeAt(2))){if(t===3)return o.root=o.dir=n,o;i=3}}i>0&&(o.root=n.slice(0,i));let a=-1,s=i,l=-1,p=!0,E=n.length-1,T=0;for(;E>=i;--E){if(r=n.charCodeAt(E),h(r)){if(!p){s=E+1;break}continue}l===-1&&(p=!1,l=E+1),r===I?a===-1?a=E:T!==1&&(T=1):a!==-1&&(T=-1)}return l!==-1&&(a===-1||T===0||T===1&&a===l-1&&a===s+1?o.base=o.name=n.slice(s,l):(o.name=n.slice(s,a),o.base=n.slice(s,l),o.ext=n.slice(a,l))),s>0&&s!==i?o.dir=n.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(y){const n=/\\/g;return()=>{const o=L.cwd().replace(n,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...n){let o="",t=!1;for(let i=n.length-1;i>=-1&&!t;i--){const r=i>=0?n[i]:k();f(r,"path"),r.length!==0&&(o=`${r}/${o}`,t=r.charCodeAt(0)===C)}return o=v(o,!t,"/",u),t?`/${o}`:o.length>0?o:"."},normalize(n){if(f(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===C,t=n.charCodeAt(n.length-1)===C;return n=v(n,!o,"/",u),n.length===0?o?"/":t?"./":".":(t&&(n+="/"),o?`/${n}`:n)},isAbsolute(n){return f(n,"path"),n.length>0&&n.charCodeAt(0)===C},join(...n){if(n.length===0)return".";let o;for(let t=0;t<n.length;++t){const i=n[t];f(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(n,o){if(f(n,"from"),f(o,"to"),n===o||(n=e.posix.resolve(n),o=e.posix.resolve(o),n===o))return"";const t=1,i=n.length,r=i-t,a=1,s=o.length-a,l=r<s?r:s;let p=-1,E=0;for(;E<l;E++){const A=n.charCodeAt(t+E);if(A!==o.charCodeAt(a+E))break;A===C&&(p=E)}if(E===l)if(s>l){if(o.charCodeAt(a+E)===C)return o.slice(a+E+1);if(E===0)return o.slice(a+E)}else r>l&&(n.charCodeAt(t+E)===C?p=E:E===0&&(p=0));let T="";for(E=t+p+1;E<=i;++E)(E===i||n.charCodeAt(E)===C)&&(T+=T.length===0?"..":"/..");return`${T}${o.slice(a+p)}`},toNamespacedPath(n){return n},dirname(n){if(f(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===C;let t=-1,i=!0;for(let r=n.length-1;r>=1;--r)if(n.charCodeAt(r)===C){if(!i){t=r;break}}else i=!1;return t===-1?o?"/":".":o&&t===1?"//":n.slice(0,t)},basename(n,o){o!==void 0&&f(o,"ext"),f(n,"path");let t=0,i=-1,r=!0,a;if(o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let s=o.length-1,l=-1;for(a=n.length-1;a>=0;--a){const p=n.charCodeAt(a);if(p===C){if(!r){t=a+1;break}}else l===-1&&(r=!1,l=a+1),s>=0&&(p===o.charCodeAt(s)?--s===-1&&(i=a):(s=-1,i=l))}return t===i?i=l:i===-1&&(i=n.length),n.slice(t,i)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===C){if(!r){t=a+1;break}}else i===-1&&(r=!1,i=a+1);return i===-1?"":n.slice(t,i)},extname(n){f(n,"path");let o=-1,t=0,i=-1,r=!0,a=0;for(let s=n.length-1;s>=0;--s){const l=n.charCodeAt(s);if(l===C){if(!r){t=s+1;break}continue}i===-1&&(r=!1,i=s+1),l===I?o===-1?o=s:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||i===-1||a===0||a===1&&o===i-1&&o===t+1?"":n.slice(o,i)},format:b.bind(null,"/"),parse(n){f(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const t=n.charCodeAt(0)===C;let i;t?(o.root="/",i=1):i=0;let r=-1,a=0,s=-1,l=!0,p=n.length-1,E=0;for(;p>=i;--p){const T=n.charCodeAt(p);if(T===C){if(!l){a=p+1;break}continue}s===-1&&(l=!1,s=p+1),T===I?r===-1?r=p:E!==1&&(E=1):r!==-1&&(E=-1)}if(s!==-1){const T=a===0&&t?1:a;r===-1||E===0||E===1&&r===s-1&&r===a+1?o.base=o.name=n.slice(T,s):(o.name=n.slice(T,r),o.base=n.slice(T,s),o.ext=n.slice(r,s))}return a>0?o.dir=n.slice(0,a-1):t&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(se[145],oe([0,1,13]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(P){const w=(0,L.extname)(P),m=_[w.toLowerCase()];return m!==void 0?m:D(P)}e.getMediaOrTextMime=R;function D(P){const w=(0,L.extname)(P);return c[w.toLowerCase()]}e.getMediaMime=D;function I(P){for(const w in c)if(c[w]===P)return w}e.getExtensionForMimeType=I;const C=/^(.+)\/(.+?)(;.+)?$/;function S(P,w){const m=C.exec(P);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:P}e.normalizeMimeType=S}),define(se[88],oe([0,1,4]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var c;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(c=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(I,...C){const S=C.reduce((m,d)=>(m[d]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!S[m]).forEach(m=>{for(let d=0;d<P.length;d++)if(m.search(P[d])!==-1){delete I[m];break}})}e.sanitizeProcessEnvironment=R;function D(I){!I||(delete I.DEBUG,L.isMacintosh&&delete I.DYLD_LIBRARY_PATH,L.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(se[89],oe([0,1,4]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=L.globals.performance&&typeof L.globals.performance.now=="function";class c{static create(D=!0){return new c(D)}constructor(D){this._highResolution=_&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=c}),define(se[3],oe([0,1,7,82,2,84,89]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,C=!1;var S;(function(a){a.None=()=>c.Disposable.None;function s(x){if(C){const{onDidAddListener:H}=x,te=f.create();let G=0;x.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),te.print()),H?.()}}}function l(x,H){return z(x,()=>{},0,void 0,!0,void 0,H)}a.defer=l;function p(x){return(H,te=null,G)=>{let X=!1,ie;return ie=x(le=>{if(!X)return ie?ie.dispose():X=!0,H.call(te,le)},null,G),X&&ie.dispose(),ie}}a.once=p;function E(x,H,te){return K((G,X=null,ie)=>x(le=>G.call(X,H(le)),null,ie),te)}a.map=E;function T(x,H,te){return K((G,X=null,ie)=>x(le=>{H(le),G.call(X,le)},null,ie),te)}a.forEach=T;function A(x,H,te){return K((G,X=null,ie)=>x(le=>H(le)&&G.call(X,le),null,ie),te)}a.filter=A;function N(x){return x}a.signal=N;function W(...x){return(H,te=null,G)=>(0,c.combinedDisposable)(...x.map(X=>X(ie=>H.call(te,ie),null,G)))}a.any=W;function V(x,H,te,G){let X=te;return E(x,ie=>(X=H(X,ie),X),G)}a.reduce=V;function K(x,H){let te;const G={onWillAddFirstListener(){te=x(X.fire,X)},onDidRemoveLastListener(){te?.dispose()}};H||s(G);const X=new h(G);return H?.add(X),X.event}function z(x,H,te=100,G=!1,X=!1,ie,le){let he,me,ve,we=0,Ce;const Re={leakWarningThreshold:ie,onWillAddFirstListener(){he=x(ze=>{we++,me=H(me,ze),G&&!ve&&(ke.fire(me),me=void 0),Ce=()=>{const Ye=me;me=void 0,ve=void 0,(!G||we>1)&&ke.fire(Ye),we=0},typeof te=="number"?(clearTimeout(ve),ve=setTimeout(Ce,te)):ve===void 0&&(ve=0,queueMicrotask(Ce))})},onWillRemoveListener(){X&&we>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};le||s(Re);const ke=new h(Re);return le?.add(ke),ke.event}a.debounce=z;function O(x,H=0,te){return a.debounce(x,(G,X)=>G?(G.push(X),G):[X],H,void 0,!0,void 0,te)}a.accumulate=O;function $(x,H=(G,X)=>G===X,te){let G=!0,X;return A(x,ie=>{const le=G||!H(ie,X);return G=!1,X=ie,le},te)}a.latch=$;function Z(x,H,te){return[a.filter(x,H,te),a.filter(x,G=>!H(G),te)]}a.split=Z;function q(x,H=!1,te=[]){let G=te.slice(),X=x(he=>{G?G.push(he):le.fire(he)});const ie=()=>{G?.forEach(he=>le.fire(he)),G=null},le=new h({onWillAddFirstListener(){X||(X=x(he=>le.fire(he)))},onDidAddFirstListener(){G&&(H?setTimeout(ie):ie())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return le.event}a.buffer=q;class j{constructor(H){this.event=H,this.disposables=new c.DisposableStore}map(H){return new j(E(this.event,H,this.disposables))}forEach(H){return new j(T(this.event,H,this.disposables))}filter(H){return new j(A(this.event,H,this.disposables))}reduce(H,te){return new j(V(this.event,H,te,this.disposables))}latch(){return new j($(this.event,void 0,this.disposables))}debounce(H,te=100,G=!1,X=!1,ie){return new j(z(this.event,H,te,G,X,ie,this.disposables))}on(H,te,G){return this.event(H,te,G)}once(H,te,G){return p(this.event)(H,te,G)}dispose(){this.disposables.dispose()}}function M(x){return new j(x)}a.chain=M;function J(x,H,te=G=>G){const G=(...he)=>le.fire(te(...he)),X=()=>x.on(H,G),ie=()=>x.removeListener(H,G),le=new h({onWillAddFirstListener:X,onDidRemoveLastListener:ie});return le.event}a.fromNodeEventEmitter=J;function Q(x,H,te=G=>G){const G=(...he)=>le.fire(te(...he)),X=()=>x.addEventListener(H,G),ie=()=>x.removeEventListener(H,G),le=new h({onWillAddFirstListener:X,onDidRemoveLastListener:ie});return le.event}a.fromDOMEventEmitter=Q;function re(x){return new Promise(H=>p(x)(H))}a.toPromise=re;function ae(x,H){return H(void 0),x(te=>H(te))}a.runAndSubscribe=ae;function B(x,H){let te=null;function G(ie){te?.dispose(),te=new c.DisposableStore,H(ie,te)}G(void 0);const X=x(ie=>G(ie));return(0,c.toDisposable)(()=>{X.dispose(),te?.dispose()})}a.runAndSubscribeWithStore=B;class F{constructor(H,te){this.obs=H,this._counter=0,this._hasChanged=!1;const G={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};te||s(G),this.emitter=new h(G),te&&te.add(this.emitter)}beginUpdate(H){this._counter++}handleChange(H,te){this._hasChanged=!0}endUpdate(H){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function U(x,H){return new F(x,H).emitter.event}a.fromObservable=U})(S=e.Event||(e.Event={}));class P{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${P._idPool++}`,P.all.add(this)}start(s){this._stopWatch=new D.StopWatch(!0),this.listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this._stopWatch=void 0}}}P.all=new Set,P._idPool=0,e.EventProfiling=P;let w=-1;function m(a){const s=w;return w=a,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=m;class d{constructor(s,l=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=l,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(s,l){const p=this.threshold;if(p<=0||l<p)return;this._stacks||(this._stacks=new Map);const E=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,E+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let T,A=0;for(const[N,W]of this._stacks)(!T||A<W)&&(T=N,A=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${A}):`),console.warn(T)}return()=>{const T=this._stacks.get(s.value)||0;this._stacks.set(s.value,T-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(s,l,p){this.callback=s,this.callbackThis=l,this.stack=p,this.subscription=new c.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class h{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=w>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??w):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const l of s)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,l,p)=>{if(this._listeners||(this._listeners=new R.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),c.Disposable.None;const E=this._listeners.isEmpty();E&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let T,A;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(A=f.create(),T=this._leakageMon.check(A,this._listeners.size+1)),I&&(A=A??f.create());const N=new y(s,l,A),W=this._listeners.push(N);E&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,s,l);const V=N.subscription.set(()=>{T?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),W(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return p instanceof c.DisposableStore?p.add(V):Array.isArray(p)&&p.push(V),V}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const l of this._listeners)this._deliveryQueue.push(this,l,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=h;class u{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(s,l,p){this._queue.push(new v(s,l,p))}clear(s){const l=new R.LinkedList;for(const p of this._queue)p.emitter!==s&&l.push(p);this._queue=l}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(l){(0,L.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=u;class g extends u{clear(s){this._queue.clear()}}class v{constructor(s,l,p){this.emitter=s,this.listener=l,this.event=p}}class b extends h{async fireAsync(s,l,p){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const E of this._listeners)this._asyncDeliveryQueue.push([E,s]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[E,T]=this._asyncDeliveryQueue.shift(),A=[],N={...T,token:l,waitUntil:W=>{if(Object.isFrozen(A))throw new Error("waitUntil can NOT be called asynchronous");p&&(W=p(W,E.callback)),A.push(W)}};try{E.invoke(N)}catch(W){(0,L.onUnexpectedError)(W);continue}Object.freeze(A),await Promise.allSettled(A).then(W=>{for(const V of W)V.status==="rejected"&&(0,L.onUnexpectedError)(V.reason)})}}}}e.AsyncEmitter=b;class k extends h{constructor(s){super(s),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=k;class n extends k{constructor(s){super(s),this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=n;class o extends h{constructor(s){super(s),this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){!this.hasListeners()||(this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const l={event:s,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const p=()=>{this.hasListeners&&this.unhook(l);const E=this.events.indexOf(l);this.events.splice(E,1)};return(0,c.toDisposable)((0,_.once)(p))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(l=>this.emitter.fire(l))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(s){return(l,p,E)=>s(T=>{const A=this.buffers[this.buffers.length-1];A?A.push(()=>l.call(p,T)):l.call(p,T)},void 0,E)}bufferEvents(s){const l=[];this.buffers.push(l);const p=s();return this.buffers.pop(),l.forEach(E=>E()),p}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=c.Disposable.None,this.emitter=new h({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(se[24],oe([0,1,3]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const _=Object.freeze(function(I,C){const S=setTimeout(I.bind(C),0);return{dispose(){clearTimeout(S)}}});var c;(function(I){function C(S){return S===I.None||S===I.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}I.isCancellationToken=C,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(c=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?_:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=c.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=c.None}}e.CancellationTokenSource=D}),define(se[146],oe([0,1,24]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class _{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new L.CancellationTokenSource,C=this.task(I.token);return this.result={promise:C,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=_;class c{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const C=JSON.stringify(I);return this.lastArgKey!==C&&(this.lastArgKey=C,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=c;class R{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const C=this.fn(I);return this._map.set(I,C),C}}e.CachedFunction=R}),define(se[27],oe([0,1,146,131]),function(ee,e,L,_){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function I(ne,...ue){return ue.length===0?ne:ne.replace(D,function(ge,ye){const Se=parseInt(ye,10);return isNaN(Se)||Se<0||Se>=ue.length?ge:ue[Se]})}e.format=I;const C=/{([^}]+)}/g;function S(ne,ue){return ne.replace(C,(ge,ye)=>ue[ye]??ge)}e.format2=S;function P(ne){return ne.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function m(ne,ue){let ge=0;const ye=ue.charCodeAt(0);for(let Se=ne.length-1;Se>=0;Se--)ne.charCodeAt(Se)===ye&&ge++;return ge}e.count=m;function d(ne,ue,ge="\u2026"){return ne.length<=ue?ne:`${ne.substr(0,ue)}${ge}`}e.truncate=d;function f(ne,ue=" "){const ge=y(ne,ue);return h(ge,ue)}e.trim=f;function y(ne,ue){if(!ne||!ue)return ne;const ge=ue.length;if(ge===0||ne.length===0)return ne;let ye=0;for(;ne.indexOf(ue,ye)===ye;)ye=ye+ge;return ne.substring(ye)}e.ltrim=y;function h(ne,ue){if(!ne||!ue)return ne;const ge=ue.length,ye=ne.length;if(ge===0||ye===0)return ne;let Se=ye,be=-1;for(;be=ne.lastIndexOf(ue,Se-1),!(be===-1||be+ge!==Se);){if(be===0)return"";Se=be}return ne.substring(0,Se)}e.rtrim=h;function u(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(ne){return ne.replace(/\*/g,"")}e.stripWildcards=g;function v(ne,ue,ge={}){if(!ne)throw new Error("Cannot create regex from empty string");ue||(ne=w(ne)),ge.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ye="";return ge.global&&(ye+="g"),ge.matchCase||(ye+="i"),ge.multiline&&(ye+="m"),ge.unicode&&(ye+="u"),new RegExp(ne,ye)}e.createRegExp=v;function b(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function k(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function n(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=n;function o(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=o;function t(ne){for(let ue=0,ge=ne.length;ue<ge;ue++){const ye=ne.charCodeAt(ue);if(ye!==32&&ye!==9)return ue}return-1}e.firstNonWhitespaceIndex=t;function i(ne,ue=0,ge=ne.length){for(let ye=ue;ye<ge;ye++){const Se=ne.charCodeAt(ye);if(Se!==32&&Se!==9)return ne.substring(ue,ye)}return ne.substring(ue,ge)}e.getLeadingWhitespace=i;function r(ne,ue=ne.length-1){for(let ge=ue;ge>=0;ge--){const ye=ne.charCodeAt(ge);if(ye!==32&&ye!==9)return ge}return-1}e.lastNonWhitespaceIndex=r;function a(ne,ue,ge){const ye=[];let Se=0;for(const be of ne.matchAll(ue)){if(ye.push(ne.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,ye.push(ge(be[0],...be.slice(1),be.index,ne,be.groups))}return ye.push(ne.slice(Se)),Promise.all(ye).then(be=>be.join(""))}e.replaceAsync=a;function s(ne,ue){return ne<ue?-1:ne>ue?1:0}e.compare=s;function l(ne,ue,ge=0,ye=ne.length,Se=0,be=ue.length){for(;ge<ye&&Se<be;ge++,Se++){const Ae=ne.charCodeAt(ge),Ue=ue.charCodeAt(Se);if(Ae<Ue)return-1;if(Ae>Ue)return 1}const De=ye-ge,_e=be-Se;return De<_e?-1:De>_e?1:0}e.compareSubstring=l;function p(ne,ue){return E(ne,ue,0,ne.length,0,ue.length)}e.compareIgnoreCase=p;function E(ne,ue,ge=0,ye=ne.length,Se=0,be=ue.length){for(;ge<ye&&Se<be;ge++,Se++){let Ae=ne.charCodeAt(ge),Ue=ue.charCodeAt(Se);if(Ae===Ue)continue;if(Ae>=128||Ue>=128)return l(ne.toLowerCase(),ue.toLowerCase(),ge,ye,Se,be);A(Ae)&&(Ae-=32),A(Ue)&&(Ue-=32);const xe=Ae-Ue;if(xe!==0)return xe}const De=ye-ge,_e=be-Se;return De<_e?-1:De>_e?1:0}e.compareSubstringIgnoreCase=E;function T(ne){return ne>=48&&ne<=57}e.isAsciiDigit=T;function A(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=A;function N(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=N;function W(ne,ue){return ne.length===ue.length&&E(ne,ue)===0}e.equalsIgnoreCase=W;function V(ne,ue){const ge=ue.length;return ue.length>ne.length?!1:E(ne,ue,0,ge)===0}e.startsWithIgnoreCase=V;function K(ne,ue){const ge=Math.min(ne.length,ue.length);let ye;for(ye=0;ye<ge;ye++)if(ne.charCodeAt(ye)!==ue.charCodeAt(ye))return ye;return ge}e.commonPrefixLength=K;function z(ne,ue){const ge=Math.min(ne.length,ue.length);let ye;const Se=ne.length-1,be=ue.length-1;for(ye=0;ye<ge;ye++)if(ne.charCodeAt(Se-ye)!==ue.charCodeAt(be-ye))return ye;return ge}e.commonSuffixLength=z;function O(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=O;function $(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=$;function Z(ne,ue){return(ne-55296<<10)+(ue-56320)+65536}e.computeCodePoint=Z;function q(ne,ue,ge){const ye=ne.charCodeAt(ge);if(O(ye)&&ge+1<ue){const Se=ne.charCodeAt(ge+1);if($(Se))return Z(ye,Se)}return ye}e.getNextCodePoint=q;function j(ne,ue){const ge=ne.charCodeAt(ue-1);if($(ge)&&ue>1){const ye=ne.charCodeAt(ue-2);if(O(ye))return Z(ye,ge)}return ge}class M{get offset(){return this._offset}constructor(ue,ge=0){this._str=ue,this._len=ue.length,this._offset=ge}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=j(this._str,this._offset);return this._offset-=ue>=65536?2:1,ue}nextCodePoint(){const ue=q(this._str,this._len,this._offset);return this._offset+=ue>=65536?2:1,ue}eol(){return this._offset>=this._len}}e.CodePointIterator=M;class J{get offset(){return this._iterator.offset}constructor(ue,ge=0){this._iterator=new M(ue,ge)}nextGraphemeLength(){const ue=Pe.getInstance(),ge=this._iterator,ye=ge.offset;let Se=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const be=ge.offset,De=ue.getGraphemeBreakType(ge.nextCodePoint());if(de(Se,De)){ge.setOffset(be);break}Se=De}return ge.offset-ye}prevGraphemeLength(){const ue=Pe.getInstance(),ge=this._iterator,ye=ge.offset;let Se=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const be=ge.offset,De=ue.getGraphemeBreakType(ge.prevCodePoint());if(de(De,Se)){ge.setOffset(be);break}Se=De}return ye-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=J;function Q(ne,ue){return new J(ne,ue).nextGraphemeLength()}e.nextCharLength=Q;function re(ne,ue){return new J(ne,ue).prevGraphemeLength()}e.prevCharLength=re;function ae(ne,ue){ue>0&&$(ne.charCodeAt(ue))&&ue--;const ge=ue+Q(ne,ue);return[ge-re(ne,ge),ge]}e.getCharContainingOffset=ae;function B(ne){const ue=new J(ne);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}e.charCount=B;let F;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function x(ne){return F||(F=U()),F.test(ne)}e.containsRTL=x;const H=/^[\t\n\r\x20-\x7E]*$/;function te(ne){return H.test(ne)}e.isBasicASCII=te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=G;function X(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=X;function ie(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ie;function le(ne,ue){if(ne.length<ue)return ne;const ge=/\b/g;let ye=0;for(;ge.test(ne)&&!(ne.length-ge.lastIndex<ue);)ye=ge.lastIndex,ge.lastIndex+=1;return ne.substring(ye).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function me(ne){return ne&&(ne=ne.replace(he,"")),ne}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ve;function we(ne){return ve(ne)?ne.substr(1):ne}e.stripUTF8BOM=we;function Ce(ne,ue){if(!ne||!ue||ne.length<ue.length)return!1;const ge=ue.length,ye=ne.toLowerCase();let Se=0,be=-1;for(;Se<ge;){const De=ye.indexOf(ue[Se],be+1);if(De<0)return!1;be=De,Se++}return!0}e.fuzzyContains=Ce;function Re(ne,ue=!1){return ne?(ue&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Re;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ke;function ze(ne,ue=1){if(ue===0)return"";let ge=-1;do ge=ne.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?ne:(ne[ge-1]==="\r"&&ge--,ne.substr(0,ge))}e.getNLines=ze;function Ye(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=Ye;function ce(ne){return Pe.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ce;function de(ne,ue){return ne===0?ue!==5&&ue!==7:ne===2&&ue===3?!1:ne===4||ne===2||ne===3||ue===4||ue===2||ue===3?!0:!(ne===8&&(ue===8||ue===9||ue===11||ue===12)||(ne===11||ne===9)&&(ue===9||ue===10)||(ne===12||ne===10)&&ue===10||ue===5||ue===13||ue===7||ne===1||ne===13&&ue===14||ne===6&&ue===6)}var fe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Pe{static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Ie()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this._data,ye=ge.length/3;let Se=1;for(;Se<=ye;)if(ue<ge[3*Se])Se=2*Se;else if(ue>ge[3*Se+1])Se=2*Se+1;else return ge[3*Se+2];return 0}}Pe._INSTANCE=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(ne,ue){if(ne===0)return 0;const ge=Le(ne,ue);if(ge!==void 0)return ge;const ye=new M(ue,ne);return ye.prevCodePoint(),ye.offset}e.getLeftDeleteOffset=Ne;function Le(ne,ue){const ge=new M(ue,ne);let ye=ge.prevCodePoint();for(;Fe(ye)||ye===65039||ye===8419;){if(ge.offset===0)return;ye=ge.prevCodePoint()}if(!ie(ye))return;let Se=ge.offset;return Se>0&&ge.prevCodePoint()===8205&&(Se=ge.offset),Se}function Fe(ne){return 127995<=ne&&ne<=127999}var Me;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Oe{static getInstance(ue){return Oe.cache.get(Array.from(ue))}static getLocales(){return Oe._locales.value}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}c=Oe,Oe.ambiguousCharacterData=new _.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new L.LRUCachedFunction(ne=>{function ue(Ue){const xe=new Map;for(let We=0;We<Ue.length;We+=2)xe.set(Ue[We],Ue[We+1]);return xe}function ge(Ue,xe){const We=new Map(Ue);for(const[et,rt]of xe)We.set(et,rt);return We}function ye(Ue,xe){if(!Ue)return xe;const We=new Map;for(const[et,rt]of Ue)xe.has(et)&&We.set(et,rt);return We}const Se=c.ambiguousCharacterData.value;let be=ne.filter(Ue=>!Ue.startsWith("_")&&Ue in Se);be.length===0&&(be=["_default"]);let De;for(const Ue of be){const xe=ue(Se[Ue]);De=ye(De,xe)}const _e=ue(Se._common),Ae=ge(_e,De);return new Oe(Ae)}),Oe._locales=new _.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.value).filter(ne=>!ne.startsWith("_"))),e.AmbiguousCharacters=Oe;class $e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set($e.getRawData())),this._data}static isInvisibleCharacter(ue){return $e.getData().has(ue)}static get codePoints(){return $e.getData()}}$e._data=void 0,e.InvisibleCharacters=$e}),define(se[48],oe([0,1,13,4,27,12]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function I(r){return r.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=I;function C(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function S(r,a=L.posix.sep){if(!r)return"";const s=r.length,l=r.charCodeAt(0);if(D(l)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let E=3;const T=E;for(;E<s&&!D(r.charCodeAt(E));E++);if(T!==E&&!D(r.charCodeAt(E+1))){for(E+=1;E<s;E++)if(D(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,a)}}return a}else if(u(l)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<s;p++)if(D(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=S;function P(r){if(!_.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let s=2;const l=s;for(;s<r.length&&(a=r.charCodeAt(s),a!==92);s++);return!(l===s||(a=r.charCodeAt(s+1),isNaN(a)||a===92))}e.isUNC=P;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,a=_.isWindows){const s=a?w:m;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||a&&d.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function y(r,a,s){const l=r===a;return!s||l?l:!r||!a?!1:(0,c.equalsIgnoreCase)(r,a)}e.isEqual=y;function h(r,a,s,l=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(s){if(!(0,c.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let E=a.length;return a.charAt(a.length-1)===l&&E--,r.charAt(E)===l}return a.charAt(a.length-1)!==l&&(a+=l),r.indexOf(a)===0}e.isEqualOrParent=h;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function g(r,a){return _.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(a,r)),r=(0,L.normalize)(r),_.isWindows?(r=(0,c.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,c.rtrim)(r,L.sep),r||(r=L.sep)),r}e.sanitizeFilePath=g;function v(r){const a=(0,L.normalize)(r);return _.isWindows?r.length>3?!1:b(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=v;function b(r,a=_.isWindows){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function k(r){return b(r)?r[0]:void 0}e.getDriveLetter=k;function n(r,a,s){return a.length>r.length?-1:r===a?0:(s&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=n;function o(r){const a=r.split(":");let s,l,p;for(const E of a){const T=Number(E);(0,R.isNumber)(T)?l===void 0?l=T:p===void 0&&(p=T):s=s?[s,E].join(":"):E}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:l!==void 0?l:void 0,column:p!==void 0?p:l!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,a,s=8){let l="";for(let E=0;E<s;E++)l+=t.charAt(Math.floor(Math.random()*t.length));let p;return a?p=`${a}-${l}`:p=l,r?(0,L.join)(r,p):p}e.randomPath=i}),define(se[65],oe([0,1,27]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function _(u){return c(u,0)}e.hash=_;function c(u,g){switch(typeof u){case"object":return u===null?R(349,g):Array.isArray(u)?C(u,g):S(u,g);case"string":return I(u,g);case"boolean":return D(u,g);case"number":return R(u,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=c;function R(u,g){return(g<<5)-g+u|0}e.numberHash=R;function D(u,g){return R(u?433:863,g)}function I(u,g){g=R(149417,g);for(let v=0,b=u.length;v<b;v++)g=R(u.charCodeAt(v),g);return g}e.stringHash=I;function C(u,g){return g=R(104579,g),u.reduce((v,b)=>c(b,v),g)}function S(u,g){return g=R(181387,g),Object.keys(u).sort().reduce((v,b)=>(v=I(b,v),c(u[b],v)),g)}class P{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=c(g,this._value),this._value}}e.Hasher=P;var w;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(u,g,v=32){const b=v-g,k=~((1<<b)-1);return(u<<g|(k&u)>>>b)>>>0}function d(u,g=0,v=u.byteLength,b=0){for(let k=0;k<v;k++)u[g+k]=b}function f(u,g,v="0"){for(;u.length<g;)u=v+u;return u}function y(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(v=>v.toString(16).padStart(2,"0")).join(""):f((u>>>0).toString(16),g/4)}e.toHexString=y;class h{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const v=g.length;if(v===0)return;const b=this._buff;let k=this._buffLen,n=this._leftoverHighSurrogate,o,t;for(n!==0?(o=n,t=-1,n=0):(o=g.charCodeAt(0),t=0);;){let i=o;if(L.isHighSurrogate(o))if(t+1<v){const r=g.charCodeAt(t+1);L.isLowSurrogate(r)?(t++,i=L.computeCodePoint(o,r)):i=65533}else{n=o;break}else L.isLowSurrogate(o)&&(i=65533);if(k=this._push(b,k,i),t++,t<v)o=g.charCodeAt(t);else break}this._buffLen=k,this._leftoverHighSurrogate=n}_push(g,v,b){return b<128?g[v++]=b:b<2048?(g[v++]=192|(b&1984)>>>6,g[v++]=128|(b&63)>>>0):b<65536?(g[v++]=224|(b&61440)>>>12,g[v++]=128|(b&4032)>>>6,g[v++]=128|(b&63)>>>0):(g[v++]=240|(b&1835008)>>>18,g[v++]=128|(b&258048)>>>12,g[v++]=128|(b&4032)>>>6,g[v++]=128|(b&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=h._bigBlock32,v=this._buffDV;for(let s=0;s<64;s+=4)g.setUint32(s,v.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)g.setUint32(s,m(g.getUint32(s-12,!1)^g.getUint32(s-32,!1)^g.getUint32(s-56,!1)^g.getUint32(s-64,!1),1),!1);let b=this._h0,k=this._h1,n=this._h2,o=this._h3,t=this._h4,i,r,a;for(let s=0;s<80;s++)s<20?(i=k&n|~k&o,r=1518500249):s<40?(i=k^n^o,r=1859775393):s<60?(i=k&n|k&o|n&o,r=2400959708):(i=k^n^o,r=3395469782),a=m(b,5)+i+t+r+g.getUint32(s*4,!1)&4294967295,t=o,o=n,n=m(k,30),k=b,b=a;this._h0=this._h0+b&4294967295,this._h1=this._h1+k&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}h._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=h}),define(se[90],oe([0,1,27]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var _;(function(c){c[c.Ignore=0]="Ignore",c[c.Info=1]="Info",c[c.Warning=2]="Warning",c[c.Error=3]="Error"})(_||(_={})),function(c){const R="error",D="warning",I="warn",C="info",S="ignore";function P(m){return m?L.equalsIgnoreCase(R,m)?c.Error:L.equalsIgnoreCase(D,m)||L.equalsIgnoreCase(I,m)?c.Warning:L.equalsIgnoreCase(C,m)?c.Info:c.Ignore:c.Ignore}c.fromValue=P;function w(m){switch(m){case c.Error:return R;case c.Warning:return D;case c.Info:return C;default:return S}}c.toString=w}(_||(_={})),e.default=_}),define(se[49],oe([0,1,19,27]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class c{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const f=d.charCodeAt(0),y=this._value.charCodeAt(this._pos);return f-y}value(){return this._value[this._pos]}}e.StringIterator=c;class R{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,_.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class D{constructor(d=!0,f=!0){this._splitOnBackslash=d,this._caseSensitive=f}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let f=d.length-1;f>=0;f--,this._valueLen--){const y=this._value.charCodeAt(f);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,_.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var I;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(I||(I={}));class C{constructor(d,f){this._ignorePathCasing=d,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,_.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,_.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,_.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,_.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=C;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(P||(P={}));class w{static forUris(d=()=>!1,f=()=>!1){return new w(new C(d,f))}static forPaths(d=!1){return new w(new D(void 0,!d))}static forStrings(){return new w(new c)}static forConfigKeys(){return new w(new R)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,f){if(f){const y=f.slice(0);(0,L.shuffle)(y);for(const h of y)this.set(h,d)}else{const y=d.slice(0);(0,L.shuffle)(y);for(const h of y)this.set(h[0],h[1])}}set(d,f){const y=this._iter.reset(d);let h;this._root||(this._root=new S,this._root.segment=y.value());const u=[];for(h=this._root;;){const v=y.cmp(h.segment);if(v>0)h.left||(h.left=new S,h.left.segment=y.value()),u.push([-1,h]),h=h.left;else if(v<0)h.right||(h.right=new S,h.right.segment=y.value()),u.push([1,h]),h=h.right;else if(y.hasNext())y.next(),h.mid||(h.mid=new S,h.mid.segment=y.value()),u.push([0,h]),h=h.mid;else break}const g=h.value;h.value=f,h.key=d;for(let v=u.length-1;v>=0;v--){const b=u[v][1];b.updateHeight();const k=b.balanceFactor();if(k<-1||k>1){const n=u[v][0],o=u[v+1][0];if(n===1&&o===1)u[v][1]=b.rotateLeft();else if(n===-1&&o===-1)u[v][1]=b.rotateRight();else if(n===1&&o===-1)b.right=u[v+1][1]=u[v+1][1].rotateRight(),u[v][1]=b.rotateLeft();else if(n===-1&&o===1)b.left=u[v+1][1]=u[v+1][1].rotateLeft(),u[v][1]=b.rotateRight();else throw new Error;if(v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}return g}get(d){return this._getNode(d)?.value}_getNode(d){const f=this._iter.reset(d);let y=this._root;for(;y;){const h=f.cmp(y.segment);if(h>0)y=y.left;else if(h<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has(d){const f=this._getNode(d);return!(f?.value===void 0&&f?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,f){const y=this._iter.reset(d),h=[];let u=this._root;for(;u;){const g=y.cmp(u.segment);if(g>0)h.push([-1,u]),u=u.left;else if(g<0)h.push([1,u]),u=u.right;else if(y.hasNext())y.next(),h.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this._min(u.right);if(g.key){const{key:v,value:b,segment:k}=g;this._delete(g.key,!1),u.key=v,u.value=b,u.segment=k}}else{const g=u.left??u.right;if(h.length>0){const[v,b]=h[h.length-1];switch(v){case-1:b.left=g;break;case 0:b.mid=g;break;case 1:b.right=g;break}}else this._root=g}for(let g=h.length-1;g>=0;g--){const v=h[g][1];v.updateHeight();const b=v.balanceFactor();if(b>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),h[g][1]=v.rotateLeft()):b<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),h[g][1]=v.rotateRight()),g>0)switch(h[g-1][0]){case-1:h[g-1][1].left=h[g][1];break;case 1:h[g-1][1].right=h[g][1];break;case 0:h[g-1][1].mid=h[g][1];break}else this._root=h[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const f=this._iter.reset(d);let y=this._root,h;for(;y;){const u=f.cmp(y.segment);if(u>0)y=y.left;else if(u<0)y=y.right;else if(f.hasNext())f.next(),h=y.value||h,y=y.mid;else break}return y&&y.value||h}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,f){const y=this._iter.reset(d);let h=this._root;for(;h;){const u=y.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(y.hasNext())y.next(),h=h.mid;else return h.mid?this._entries(h.mid):f?h.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[f,y]of this)d(y,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const f=[];return this._dfsEntries(d,f),f[Symbol.iterator]()}_dfsEntries(d,f){!d||(d.left&&this._dfsEntries(d.left,f),d.value&&f.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,f),d.right&&this._dfsEntries(d.right,f))}_isBalanced(){const d=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:d(f.left)&&d(f.right)};return d(this._root)}}e.TernarySearchTree=w}),define(se[11],oe([0,1,13,4]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const c=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function I(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!R.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(t,i){return!t&&!i?"file":t}function S(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==w&&(i=w+i):i=w;break}return i}const P="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,s,l,p=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=C(i,p),this.authority=r||P,this.path=S(this.scheme,a||P),this.query=s||P,this.fragment=l||P,I(this,p))}get fsPath(){return v(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:s,query:l,fragment:p}=i;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),s===void 0?s=this.path:s===null&&(s=P),l===void 0?l=this.query:l===null&&(l=P),p===void 0?p=this.fragment:p===null&&(p=P),r===this.scheme&&a===this.authority&&s===this.path&&l===this.query&&p===this.fragment?this:new y(r,a,s,l,p)}static parse(i,r=!1){const a=m.exec(i);return a?new y(a[2]||P,o(a[4]||P),o(a[5]||P),o(a[7]||P),o(a[9]||P),r):new y(P,P,P,P,P)}static file(i){let r=P;if(_.isWindows&&(i=i.replace(/\\/g,w)),i[0]===w&&i[1]===w){const a=i.indexOf(w,2);a===-1?(r=i.substring(2),i=w):(r=i.substring(2,a),i=i.substring(a)||w)}return new y("file",r,i,P,P)}static from(i){const r=new y(i.scheme,i.authority,i.path,i.query,i.fragment);return I(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return _.isWindows&&i.scheme==="file"?a=d.file(L.win32.join(v(i,!0),...r)).path:a=L.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return b(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const r=new y(i);return r._formatted=i.external,r._fsPath=i._sep===f?i.fsPath:null,r}}else return i}}e.URI=d;const f=_.isWindows?1:void 0;class y extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(i=!1){return i?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=f),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,i,r){let a,s=-1;for(let l=0;l<t.length;l++){const p=t.charCodeAt(l);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||i&&p===47||r&&p===91||r&&p===93||r&&p===58)s!==-1&&(a+=encodeURIComponent(t.substring(s,l)),s=-1),a!==void 0&&(a+=t.charAt(l));else{a===void 0&&(a=t.substr(0,l));const E=h[p];E!==void 0?(s!==-1&&(a+=encodeURIComponent(t.substring(s,l)),s=-1),a+=E):s===-1&&(s=l)}}return s!==-1&&(a+=encodeURIComponent(t.substring(s))),a!==void 0?a:t}function g(t){let i;for(let r=0;r<t.length;r++){const a=t.charCodeAt(r);a===35||a===63?(i===void 0&&(i=t.substr(0,r)),i+=h[a]):i!==void 0&&(i+=t[r])}return i!==void 0?i:t}function v(t,i){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,_.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=v;function b(t,i){const r=i?g:u;let a="",{scheme:s,authority:l,path:p,query:E,fragment:T}=t;if(s&&(a+=s,a+=":"),(l||s==="file")&&(a+=w,a+=w),l){let A=l.indexOf("@");if(A!==-1){const N=l.substr(0,A);l=l.substr(A+1),A=N.lastIndexOf(":"),A===-1?a+=r(N,!1,!1):(a+=r(N.substr(0,A),!1,!1),a+=":",a+=r(N.substr(A+1),!1,!0)),a+="@"}l=l.toLowerCase(),A=l.lastIndexOf(":"),A===-1?a+=r(l,!1,!0):(a+=r(l.substr(0,A),!1,!0),a+=l.substr(A))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const A=p.charCodeAt(1);A>=65&&A<=90&&(p=`/${String.fromCharCode(A+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const A=p.charCodeAt(0);A>=65&&A<=90&&(p=`${String.fromCharCode(A+32)}:${p.substr(2)}`)}a+=r(p,!0,!1)}return E&&(a+="?",a+=r(E,!1,!1)),T&&(a+="#",a+=i?T:u(T,!1,!1)),a}function k(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+k(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(n)?t.replace(n,i=>k(i)):t}}),define(se[147],oe([0,1,11]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function _(S){const P=S;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=_;function c(S){const P=[];let w;try{const m=JSON.parse(S.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),w=d.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",S.arguments)}return{args:P,stack:w}}e.parse=c;function R(S){if(typeof S!="string")return R(c(S).stack);const P=S;if(P){const w=D(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=R;function D(S){if(!S)return S;const P=S.indexOf(`
`);return P===-1?S:S.substring(0,P)}function I(S,P){const{args:w,stack:m}=c(S),d=typeof w[0]=="string"&&w.length===1;let f=D(m);f&&(f=`(${f.trim()})`);let y=[];if(typeof w[0]=="string"?f&&d?y=[`%c[${P}] %c${w[0]} %c${f}`,C("blue"),C(""),C("grey")]:y=[`%c[${P}] %c${w[0]}`,C("blue"),C(""),...w.slice(1)]:y=[`%c[${P}]%`,C("blue"),...w],f&&!d&&y.push(f),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,y)}e.log=I;function C(S){return`color: ${S}`}}),define(se[91],oe([0,1,16,27,11]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(S){return JSON.stringify(S,I)}e.stringify=R;function D(S){let P=JSON.parse(S);return P=C(P),P}e.parse=D;function I(S,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,_.regExpFlags)(P)}:P}function C(S,P=0){if(!S||P>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return c.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof L.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let w=0;w<S.length;++w)S[w]=C(S[w],P+1);else for(const w in S)Object.hasOwnProperty.call(S,w)&&(S[w]=C(S[w],P+1))}return S}e.revive=C}),define(se[22],oe([0,1,7,4,11]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${R.vscodeRemoteResource}`}set(P,w,m){this._hosts[P]=w,this._ports[P]=m}setConnectionToken(P,w){this._connectionTokens[P]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(h){return L.onUnexpectedError(h),P}const w=P.authority;let m=this._hosts[w];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const d=this._ports[w],f=this._connectionTokens[w];let y=`path=${encodeURIComponent(P.path)}`;return typeof f=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),c.URI.from({scheme:_.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${m}:${d}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(P){const w=this.toUri(P,ee);return this.uriToBrowserUri(w)}uriToBrowserUri(P){return P.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===R.file&&(_.isNative||_.isWebWorker&&_.globals.origin===`${R.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?P.with({scheme:R.vscodeFileResource,authority:P.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const w=this.toUri(P,ee);return this.uriToFileUri(w)}uriToFileUri(P){return P.scheme===R.vscodeFileResource?P.with({scheme:R.file,authority:P.authority!==I.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,w){return c.URI.isUri(P)?P:c.URI.parse(w.toUrl(P))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I;var C;(function(S){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(P.get("3"));const w="vscode-coi";function m(f){let y;typeof f=="string"?y=new URL(f).searchParams:f instanceof URL?y=f.searchParams:c.URI.isUri(f)&&(y=new URL(f.toString(!0)).searchParams);const h=y?.get(w);if(!!h)return P.get(h)}S.getHeadersFromQuery=m;function d(f,y,h){if(!globalThis.crossOriginIsolated)return;const u=y&&h?"3":h?"2":"1";f instanceof URLSearchParams?f.set(w,u):f[w]=u}S.addSearchParam=d})(C=e.COI||(e.COI={}))}),define(se[25],oe([0,1,48,22,13,4,27,11]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(d){return(0,I.uriToFsPath)(d,!0)}e.originalFSPath=C;class S{constructor(f){this._ignorePathCasing=f}compare(f,y,h=!1){return f===y?0:(0,D.compare)(this.getComparisonKey(f,h),this.getComparisonKey(y,h))}isEqual(f,y,h=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,h)===this.getComparisonKey(y,h)}getComparisonKey(f,y=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,y,h=!1){if(f.scheme===y.scheme){if(f.scheme===_.Schemas.file)return L.isEqualOrParent(C(f),C(y),this._ignorePathCasing(f))&&f.query===y.query&&(h||f.fragment===y.fragment);if((0,e.isEqualAuthority)(f.authority,y.authority))return L.isEqualOrParent(f.path,y.path,this._ignorePathCasing(f),"/")&&f.query===y.query&&(h||f.fragment===y.fragment)}return!1}joinPath(f,...y){return I.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return c.posix.basename(f.path)}extname(f){return c.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===_.Schemas.file?y=I.URI.file(c.dirname(C(f))).path:(y=c.posix.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===_.Schemas.file?y=I.URI.file(c.normalize(C(f))).path:y=c.posix.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.isEqualAuthority)(f.authority,y.authority))return;if(f.scheme===_.Schemas.file){const g=c.relative(C(f),C(y));return R.isWindows?L.toSlashes(g):g}let h=f.path||"/";const u=y.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const v=Math.min(h.length,u.length);g<v&&!(h.charCodeAt(g)!==u.charCodeAt(g)&&h.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);h=u.substr(0,g)+h.substr(g)}return c.posix.relative(h,u)}resolvePath(f,y){if(f.scheme===_.Schemas.file){const h=I.URI.file(c.resolve(C(f),y));return f.with({authority:h.authority,path:h.path})}return y=L.toPosixPath(y),f.with({path:c.posix.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,D.equalsIgnoreCase)(f,y)}hasTrailingPathSeparator(f,y=c.sep){if(f.scheme===_.Schemas.file){const h=C(f);return h.length>L.getRoot(h).length&&h[h.length-1]===y}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=c.sep){return(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=c.sep){let h=!1;if(f.scheme===_.Schemas.file){const u=C(f);h=u!==void 0&&u.length===L.getRoot(u).length&&u[u.length-1]===y}else{y="/";const u=f.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path+"/"}):f}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(d=>d.scheme===_.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new S(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(d,f){const y=[];for(let h=0;h<d.length;h++){const u=f(d[h]);d.some((g,v)=>v===h?!1:(0,e.isEqualOrParent)(u,f(g)))||y.push(d[h])}return y}e.distinctParents=P;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function f(y){const h=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(v=>{const[b,k]=v.split(":");b&&k&&h.set(b,k)});const g=y.path.substring(0,y.path.indexOf(";"));return g&&h.set(d.META_DATA_MIME,g),h}d.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function m(d,f,y){if(f){let h=d.path;return h&&h[0]!==c.posix.sep&&(h=c.posix.sep+h),d.with({scheme:y,authority:f,path:h})}return d.with({scheme:y})}e.toLocalResource=m}),define(se[6],oe([0,1,24,7,3,2,25,4,134]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(B){return!!B&&typeof B.then=="function"}e.isThenable=S;function P(B){const F=new L.CancellationTokenSource,U=B(F.token),x=new Promise((H,te)=>{const G=F.token.onCancellationRequested(()=>{G.dispose(),F.dispose(),te(new _.CancellationError)});Promise.resolve(U).then(X=>{G.dispose(),F.dispose(),H(X)},X=>{G.dispose(),F.dispose(),te(X)})});return new class{cancel(){F.cancel()}then(H,te){return x.then(H,te)}catch(H){return this.then(void 0,H)}finally(H){return x.finally(H)}}}e.createCancelablePromise=P;function w(B,F,U){return new Promise((x,H)=>{const te=F.onCancellationRequested(()=>{te.dispose(),x(U)});B.then(x,H).finally(()=>te.dispose())})}e.raceCancellation=w;function m(B,F){return new Promise((U,x)=>{const H=F.onCancellationRequested(()=>{H.dispose(),x(new _.CancellationError)});B.then(U,x).finally(()=>H.dispose())})}e.raceCancellationError=m;async function d(B){let F=-1;const U=B.map((H,te)=>H.then(G=>(F=te,G))),x=await Promise.race(U);return B.forEach((H,te)=>{te!==F&&H.cancel()}),x}e.raceCancellablePromises=d;function f(B,F,U){let x;const H=setTimeout(()=>{x?.(void 0),U?.()},F);return Promise.race([B.finally(()=>clearTimeout(H)),new Promise(te=>x=te)])}e.raceTimeout=f;function y(B){return new Promise((F,U)=>{const x=B();S(x)?x.then(F,U):F(x)})}e.asPromise=y;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(U,U).then(x)})}return new Promise((U,x)=>{this.queuedPromise.then(U,x)})}return this.activePromise=F(),new Promise((U,x)=>{this.activePromise.then(H=>{this.activePromise=null,U(H)},H=>{this.activePromise=null,x(H)})})}}e.Throttler=h;class u{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=u;class g{constructor(){this.promiseMap=new Map}queue(F,U){const H=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(F)===H&&this.promiseMap.delete(F)});return this.promiseMap.set(F,H),H}}e.SequencerByKey=g;const v=(B,F)=>{let U=!0;const x=setTimeout(()=>{U=!1,F()},B);return{isTriggered:()=>U,dispose:()=>{clearTimeout(x),U=!1}}},b=B=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,B())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class k{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,U=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,te)=>{this.doResolve=H,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const x=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===C.MicrotaskDelay?b(x):v(U,x),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new _.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=k;class n{constructor(F){this.delayer=new k(F),this.throttler=new h}trigger(F,U){return this.delayer.trigger(()=>this.throttler.queue(F),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class o{constructor(){this._isOpen=!1,this._promise=new Promise((F,U)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class t extends o{constructor(F){super(),this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=t;function i(B,F){return F?new Promise((U,x)=>{const H=setTimeout(()=>{te.dispose(),U()},B),te=F.onCancellationRequested(()=>{clearTimeout(H),te.dispose(),x(new _.CancellationError)})}):P(U=>i(B,U))}e.timeout=i;function r(B,F=0){const U=setTimeout(B,F);return(0,R.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=r;function a(B){const F=[];let U=0;const x=B.length;function H(){return U<x?B[U++]():null}function te(G){G!=null&&F.push(G);const X=H();return X?X.then(te):Promise.resolve(F)}return Promise.resolve(null).then(te)}e.sequence=a;function s(B,F=x=>!!x,U=null){let x=0;const H=B.length,te=()=>{if(x>=H)return Promise.resolve(U);const G=B[x++];return Promise.resolve(G()).then(ie=>F(ie)?Promise.resolve(ie):te())};return te()}e.first=s;function l(B,F=x=>!!x,U=null){if(B.length===0)return Promise.resolve(U);let x=B.length;const H=()=>{x=-1;for(const te of B)te.cancel?.()};return new Promise((te,G)=>{for(const X of B)X.then(ie=>{--x>=0&&F(ie)?(H(),te(ie)):x===0&&te(U)}).catch(ie=>{--x>=0&&(H(),G(ie))})})}e.firstParallel=l;class p{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new c.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(F){return this._size++,new Promise((U,x)=>{this.outstandingPromises.push({factory:F,c:U,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const U=F.factory();U.then(F.c,F.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=p;class E extends p{constructor(){super(1)}}e.Queue=E;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new j;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,U=D.extUri){const x=U.getComparisonKey(F);let H=this.queues.get(x);return H||(H=new E,c.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete(x),this.onDidQueueDrain()}),this.queues.set(x,H)),H}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class A{constructor(F,U){this._token=-1,typeof F=="function"&&typeof U=="number"&&this.setIfNotSet(F,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},U)}setIfNotSet(F,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},U))}}e.TimeoutTimer=A;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,U){this.cancel(),this._token=setInterval(()=>{F()},U)}}e.IntervalTimer=N;class W{constructor(F,U){this.timeoutToken=-1,this.runner=F,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class V{constructor(F,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class K extends W{constructor(F,U){super(F,U),this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner?.(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=K;class z extends R.Disposable{constructor(F,U){super(),this.options=F,this.handler=U,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const U of F)this.pendingWork.push(U);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,I.setTimeout0)(()=>{if(F)return;const U=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(B,F)=>{const U=requestIdleCallback(B,typeof F=="number"?{timeout:F}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(U))}}}}();class O{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function $(B,F,U){let x;for(let H=0;H<U;H++)try{return await B()}catch(te){x=te,await i(F)}throw x}e.retry=$;class Z{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(F,U,x){return this._pending={taskId:F,cancel:()=>x?.(),promise:U},U.then(()=>this.donePending(F),()=>this.donePending(F)),U}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let U,x;const H=new Promise((te,G)=>{U=te,x=G});this._next={run:F,promise:H,promiseResolve:U,promiseReject:x}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=Z;class q{constructor(F,U=()=>Date.now()){this.interval=F,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class j{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,U)=>{this.completeCallback=F,this.errorCallback=U})}complete(F){return new Promise(U=>{this.completeCallback(F),this.resolved=!0,U()})}error(F){return new Promise(U=>{this.errorCallback(F),this.rejected=!0,U()})}cancel(){new Promise(F=>{this.errorCallback(new _.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=j;var M;(function(B){async function F(x){let H;const te=await Promise.all(x.map(G=>G.then(X=>X,X=>{H||(H=X)})));if(typeof H<"u")throw H;return te}B.settled=F;function U(x){return new Promise(async(H,te)=>{try{await x(H,te)}catch(G){te(G)}})}B.withAsyncBody=U})(M=e.Promises||(e.Promises={}));var J;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(J||(J={}));class Q{static fromArray(F){return new Q(U=>{U.emitMany(F)})}static fromPromise(F){return new Q(async U=>{U.emitMany(await F)})}static fromPromises(F){return new Q(async U=>{await Promise.all(F.map(async x=>U.emitOne(await x)))})}static merge(F){return new Q(async U=>{await Promise.all(F.map(async x=>{for await(const H of x)U.emitOne(H)}))})}constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new c.Emitter,queueMicrotask(async()=>{const U={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(F(U)),this.resolve()}catch(x){this.reject(x)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await c.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,U){return new Q(async x=>{for await(const H of F)x.emitOne(U(H))})}map(F){return Q.map(this,F)}static filter(F,U){return new Q(async x=>{for await(const H of F)U(H)&&x.emitOne(H)})}filter(F){return Q.filter(this,F)}static coalesce(F){return Q.filter(F,U=>!!U)}coalesce(){return Q.coalesce(this)}static async toPromise(F){const U=[];for await(const x of F)U.push(x);return U}toPromise(){return Q.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}Q.EMPTY=Q.fromArray([]),e.AsyncIterableObject=Q;class re extends Q{constructor(F,U){super(U),this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function ae(B){const F=new L.CancellationTokenSource,U=B(F.token);return new re(F,async x=>{const H=F.token.onCancellationRequested(()=>{H.dispose(),F.dispose(),x.reject(new _.CancellationError)});try{for await(const te of U){if(F.token.isCancellationRequested)return;x.emitOne(te)}H.dispose(),F.dispose()}catch(te){H.dispose(),F.dispose(),x.reject(te)}})}e.createCancelableAsyncIterable=ae}),define(se[92],oe([0,1,19,6,48,38,13,4,27]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",w="[^/\\\\]",m=/\//g;function d(q,j){switch(q){case 0:return"";case 1:return`${w}*?`;default:return`(?:${P}|${w}+${P}${j?`|${P}${w}+`:""})*?`}}function f(q,j){if(!q)return[];const M=[];let J=!1,Q=!1,re="";for(const ae of q){switch(ae){case j:if(!J&&!Q){M.push(re),re="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}re+=ae}return re&&M.push(re),M}e.splitGlobAware=f;function y(q){if(!q)return"";let j="";const M=f(q,e.GLOB_SPLIT);if(M.every(J=>J===e.GLOBSTAR))j=".*";else{let J=!1;M.forEach((Q,re)=>{if(Q===e.GLOBSTAR){if(J)return;j+=d(2,re===M.length-1)}else{let ae=!1,B="",F=!1,U="";for(const x of Q){if(x!=="}"&&ae){B+=x;continue}if(F&&(x!=="]"||!U)){let H;x==="-"?H=x:(x==="^"||x==="!")&&!U?H="^":x===e.GLOB_SPLIT?H="":H=(0,C.escapeRegExpCharacters)(x),U+=H;continue}switch(x){case"{":ae=!0;continue;case"[":F=!0;continue;case"}":{j+=`(?:${f(B,",").map(G=>y(G)).join("|")})`,ae=!1,B="";break}case"]":{j+="["+U+"]",F=!1,U="";break}case"?":j+=w;continue;case"*":j+=d(1);continue;default:j+=(0,C.escapeRegExpCharacters)(x)}}re<M.length-1&&(M[re+1]!==e.GLOBSTAR||re+2<M.length)&&(j+=P)}J=Q===e.GLOBSTAR})}return j}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),o=function(){return!1},t=function(){return null};function i(q,j){if(!q)return t;let M;typeof q!="string"?M=q.pattern:M=q,M=M.trim();const J=`${M}_${!!j.trimForExclusions}`;let Q=n.get(J);if(Q)return r(Q,q);let re;return h.test(M)?Q=s(M.substr(4),M):(re=u.exec(a(M,j)))?Q=l(re[1],M):(j.trimForExclusions?v:g).test(M)?Q=p(M,j):(re=b.exec(a(M,j)))?Q=E(re[1].substr(1),M,!0):(re=k.exec(a(M,j)))?Q=E(re[1],M,!1):Q=T(M),n.set(J,Q),r(Q,q)}function r(q,j){if(typeof j=="string")return q;const M=function(J,Q){return(0,c.isEqualOrParent)(J,j.base,!I.isLinux)?q((0,C.ltrim)(J.substr(j.base.length),D.sep),Q):null};return M.allBasenames=q.allBasenames,M.allPaths=q.allPaths,M.basenames=q.basenames,M.patterns=q.patterns,M}function a(q,j){return j.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function s(q,j){return function(M,J){return typeof M=="string"&&M.endsWith(q)?j:null}}function l(q,j){const M=`/${q}`,J=`\\${q}`,Q=function(ae,B){return typeof ae!="string"?null:B?B===q?j:null:ae===q||ae.endsWith(M)||ae.endsWith(J)?j:null},re=[q];return Q.basenames=re,Q.patterns=[j],Q.allBasenames=re,Q}function p(q,j){const M=$(q.slice(1,-1).split(",").map(B=>i(B,j)).filter(B=>B!==t),q),J=M.length;if(!J)return t;if(J===1)return M[0];const Q=function(B,F){for(let U=0,x=M.length;U<x;U++)if(M[U](B,F))return q;return null},re=M.find(B=>!!B.allBasenames);re&&(Q.allBasenames=re.allBasenames);const ae=M.reduce((B,F)=>F.allPaths?B.concat(F.allPaths):B,[]);return ae.length&&(Q.allPaths=ae),Q}function E(q,j,M){const J=D.sep===D.posix.sep,Q=J?q:q.replace(m,D.sep),re=D.sep+Q,ae=D.posix.sep+q;let B;return M?B=function(F,U){return typeof F=="string"&&(F===Q||F.endsWith(re)||!J&&(F===q||F.endsWith(ae)))?j:null}:B=function(F,U){return typeof F=="string"&&(F===Q||!J&&F===q)?j:null},B.allPaths=[(M?"*/":"./")+q],B}function T(q){try{const j=new RegExp(`^${y(q)}$`);return function(M){return j.lastIndex=0,typeof M=="string"&&j.test(M)?q:null}}catch{return t}}function A(q,j,M){return!q||typeof j!="string"?!1:N(q)(j,void 0,M)}e.match=A;function N(q,j={}){if(!q)return o;if(typeof q=="string"||W(q)){const M=i(q,j);if(M===t)return o;const J=function(Q,re){return!!M(Q,re)};return M.allBasenames&&(J.allBasenames=M.allBasenames),M.allPaths&&(J.allPaths=M.allPaths),J}return z(q,j)}e.parse=N;function W(q){const j=q;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=W;function V(q){return q.allBasenames||[]}e.getBasenameTerms=V;function K(q){return q.allPaths||[]}e.getPathTerms=K;function z(q,j){const M=$(Object.getOwnPropertyNames(q).map(B=>O(B,q[B],j)).filter(B=>B!==t)),J=M.length;if(!J)return t;if(!M.some(B=>!!B.requiresSiblings)){if(J===1)return M[0];const B=function(x,H){let te;for(let G=0,X=M.length;G<X;G++){const ie=M[G](x,H);if(typeof ie=="string")return ie;(0,_.isThenable)(ie)&&(te||(te=[]),te.push(ie))}return te?(async()=>{for(const G of te){const X=await G;if(typeof X=="string")return X}return null})():null},F=M.find(x=>!!x.allBasenames);F&&(B.allBasenames=F.allBasenames);const U=M.reduce((x,H)=>H.allPaths?x.concat(H.allPaths):x,[]);return U.length&&(B.allPaths=U),B}const Q=function(B,F,U){let x,H;for(let te=0,G=M.length;te<G;te++){const X=M[te];X.requiresSiblings&&U&&(F||(F=(0,D.basename)(B)),x||(x=F.substr(0,F.length-(0,D.extname)(B).length)));const ie=X(B,F,x,U);if(typeof ie=="string")return ie;(0,_.isThenable)(ie)&&(H||(H=[]),H.push(ie))}return H?(async()=>{for(const te of H){const G=await te;if(typeof G=="string")return G}return null})():null},re=M.find(B=>!!B.allBasenames);re&&(Q.allBasenames=re.allBasenames);const ae=M.reduce((B,F)=>F.allPaths?B.concat(F.allPaths):B,[]);return ae.length&&(Q.allPaths=ae),Q}function O(q,j,M){if(j===!1)return t;const J=i(q,M);if(J===t)return t;if(typeof j=="boolean")return J;if(j){const Q=j.when;if(typeof Q=="string"){const re=(ae,B,F,U)=>{if(!U||!J(ae,B))return null;const x=Q.replace("$(basename)",()=>F),H=U(x);return(0,_.isThenable)(H)?H.then(te=>te?q:null):H?q:null};return re.requiresSiblings=!0,re}}return J}function $(q,j){const M=q.filter(B=>!!B.basenames);if(M.length<2)return q;const J=M.reduce((B,F)=>{const U=F.basenames;return U?B.concat(U):B},[]);let Q;if(j){Q=[];for(let B=0,F=J.length;B<F;B++)Q.push(j)}else Q=M.reduce((B,F)=>{const U=F.patterns;return U?B.concat(U):B},[]);const re=function(B,F){if(typeof B!="string")return null;if(!F){let x;for(x=B.length;x>0;x--){const H=B.charCodeAt(x-1);if(H===47||H===92)break}F=B.substr(x)}const U=J.indexOf(F);return U!==-1?Q[U]:null};re.basenames=J,re.patterns=Q,re.allBasenames=J;const ae=q.filter(B=>!B.basenames);return ae.push(re),ae}function Z(q,j){return(0,L.equals)(q,j,(M,J)=>typeof M=="string"&&typeof J=="string"?M===J:typeof M!="string"&&typeof J!="string"?M.base===J.base&&M.pattern===J.pattern:!1)}e.patternsEquals=Z}),define(se[93],oe([0,1,16,11]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function c(w){return w.toJSON()}class R{constructor(m){this._uriTransformer=m}transformIncoming(m){const d=this._uriTransformer.transformIncoming(m);return d===m?m:c(_.URI.from(d))}transformOutgoing(m){const d=this._uriTransformer.transformOutgoing(m);return d===m?m:c(_.URI.from(d))}transformOutgoingURI(m){const d=this._uriTransformer.transformOutgoing(m);return d===m?m:_.URI.from(d)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function D(w,m,d){if(!w||d>200)return null;if(typeof w=="object"){if(w instanceof _.URI)return m.transformOutgoing(w);for(const f in w)if(Object.hasOwnProperty.call(w,f)){const y=D(w[f],m,d+1);y!==null&&(w[f]=y)}}return null}function I(w,m){const d=D(w,m,0);return d===null?w:d}e.transformOutgoingURIs=I;function C(w,m,d,f){if(!w||f>200)return null;if(typeof w=="object"){if(w.$mid===1)return d?_.URI.revive(m.transformIncoming(w)):m.transformIncoming(w);if(w instanceof L.VSBuffer)return null;for(const y in w)if(Object.hasOwnProperty.call(w,y)){const h=C(w[y],m,d,f+1);h!==null&&(w[y]=h)}}return null}function S(w,m){const d=C(w,m,!1,0);return d===null?w:d}e.transformIncomingURIs=S;function P(w,m){const d=C(w,m,!0,0);return d===null?w:d}e.transformAndReviveIncomingURIs=P}),define(se[148],oe([0,1,34,7,49,31,136]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=c.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,w=0;const m=(0,L.networkInterfaces)();for(const d in m){const f=m[d];if(f)for(const{mac:y,internal:h}of f)h||(w+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(P+=1))}this._value=w>0?P/w:0}return this._value}};let I;async function C(){return I||(I=(async()=>await S()||R.generateUuid())()),I}e.getMachineId=C;async function S(){try{const P=await new Promise((m,d)=>{ee(["crypto"],m,d)}),w=(0,D.getMac)();return P.createHash("sha256").update(w,"utf8").digest("hex")}catch(P){_.onUnexpectedError(P);return}}}),define(se[28],oe([0,1,53,34,295,6,48,85,13,4,25,11]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function d(z,O=m.UNLINK){if((0,D.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return O===m.UNLINK?y(z):f(z)}async function f(z){try{const O=(0,D.randomPath)((0,_.tmpdir)());try{await L.promises.rename(z,O)}catch($){return $.code==="ENOENT"?void 0:y(z)}y(O).catch($=>{})}catch(O){if(O.code!=="ENOENT")throw O}}async function y(z){return(0,c.promisify)(L.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function h(z){if((0,D.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function u(z,O){return b(await(O?g(z):(0,c.promisify)(L.readdir)(z)))}async function g(z){try{return await(0,c.promisify)(L.readdir)(z,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const O=[],$=await u(z);for(const Z of $){let q=!1,j=!1,M=!1;try{const J=await e.Promises.lstat((0,C.join)(z,Z));q=J.isFile(),j=J.isDirectory(),M=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}O.push({name:Z,isFile:()=>q,isDirectory:()=>j,isSymbolicLink:()=>M})}return O}function v(z){return b(L.readdirSync(z))}e.readdirSync=v;function b(z){return z.map(O=>typeof O=="string"?S.isMacintosh?(0,I.normalizeNFC)(O):O:(O.name=S.isMacintosh?(0,I.normalizeNFC)(O.name):O.name,O))}async function k(z){const O=await u(z),$=[];for(const Z of O)await o.existsDirectory((0,C.join)(z,Z))&&$.push(Z);return $}function n(z,O=1e3){return new Promise($=>{let Z=!1;const q=setInterval(()=>{Z||(Z=!0,L.access(z,j=>{Z=!1,j&&(clearInterval(q),$(void 0))}))},O)})}e.whenDeleted=n;var o;(function(z){async function O(q){let j;try{if(j=await e.Promises.lstat(q),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(S.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw J}throw M}}z.stat=O;async function $(q){try{const{stat:j,symbolicLink:M}=await z.stat(q);return j.isFile()&&M?.dangling!==!0}catch{}return!1}z.existsFile=$;async function Z(q){try{const{stat:j,symbolicLink:M}=await z.stat(q);return j.isDirectory()&&M?.dangling!==!0}catch{}return!1}z.existsDirectory=Z})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new R.ResourceQueue;function i(z,O,$){return t.queueFor(w.URI.file(z),P.extUriBiasedIgnorePathCase).queue(()=>{const Z=p($);return new Promise((q,j)=>s(z,O,Z,M=>M?j(M):q()))})}let r=!0;function a(z){r=z}e.configureFlushOnWrite=a;function s(z,O,$,Z){if(!r)return L.writeFile(z,O,{mode:$.mode,flag:$.flag},Z);L.open(z,$.flag,$.mode,(q,j)=>{if(q)return Z(q);L.writeFile(j,O,M=>{if(M)return L.close(j,()=>Z(M));L.fdatasync(j,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),a(!1)),L.close(j,Q=>Z(Q))))})})}function l(z,O,$){const Z=p($);if(!r)return L.writeFileSync(z,O,{mode:Z.mode,flag:Z.flag});const q=L.openSync(z,Z.flag,Z.mode);try{L.writeFileSync(q,O);try{L.fdatasyncSync(q)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),a(!1)}}finally{L.closeSync(q)}}e.writeFileSync=l;function p(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function E(z,O){if(z!==O)try{await e.Promises.rename(z,O)}catch($){if(z.toLowerCase()!==O.toLowerCase()&&$.code==="EXDEV"||z.endsWith("."))await T(z,O,{preserveSymlinks:!1}),await d(z,m.MOVE);else throw $}}async function T(z,O,$){return N(z,O,{root:{source:z,target:O},options:$,handledSourcePaths:new Set})}const A=511;async function N(z,O,$){if($.handledSourcePaths.has(z))return;$.handledSourcePaths.add(z);const{stat:Z,symbolicLink:q}=await o.stat(z);if(q){if($.options.preserveSymlinks)try{return await K(z,O,$)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(q.dangling)return}return Z.isDirectory()?W(z,O,Z.mode&A,$):V(z,O,Z.mode&A)}async function W(z,O,$,Z){await e.Promises.mkdir(O,{recursive:!0,mode:$});const q=await u(z);for(const j of q)await N((0,C.join)(z,j),(0,C.join)(O,j),Z)}async function V(z,O,$){await e.Promises.copyFile(z,O),await e.Promises.chmod(O,$)}async function K(z,O,$){let Z=await e.Promises.readlink(z);(0,D.isEqualOrParent)(Z,$.root.source,!S.isLinux)&&(Z=(0,C.join)($.root.target,Z.substr($.root.source.length+1))),await e.Promises.symlink(Z,O)}e.Promises=new class{get access(){return(0,c.promisify)(L.access)}get stat(){return(0,c.promisify)(L.stat)}get lstat(){return(0,c.promisify)(L.lstat)}get utimes(){return(0,c.promisify)(L.utimes)}get read(){return(z,O,$,Z,q)=>new Promise((j,M)=>{L.read(z,O,$,Z,q,(J,Q,re)=>J?M(J):j({bytesRead:Q,buffer:re}))})}get readFile(){return(0,c.promisify)(L.readFile)}get write(){return(z,O,$,Z,q)=>new Promise((j,M)=>{L.write(z,O,$,Z,q,(J,Q,re)=>J?M(J):j({bytesWritten:Q,buffer:re}))})}get appendFile(){return(0,c.promisify)(L.appendFile)}get fdatasync(){return(0,c.promisify)(L.fdatasync)}get truncate(){return(0,c.promisify)(L.truncate)}get rename(){return(0,c.promisify)(L.rename)}get copyFile(){return(0,c.promisify)(L.copyFile)}get open(){return(0,c.promisify)(L.open)}get close(){return(0,c.promisify)(L.close)}get symlink(){return(0,c.promisify)(L.symlink)}get readlink(){return(0,c.promisify)(L.readlink)}get chmod(){return(0,c.promisify)(L.chmod)}get mkdir(){return(0,c.promisify)(L.mkdir)}get unlink(){return(0,c.promisify)(L.unlink)}get rmdir(){return(0,c.promisify)(L.rmdir)}get realpath(){return(0,c.promisify)(L.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return d}get move(){return E}get copy(){return T}}}),define(se[149],oe([0,1,53,13,4,27,28]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(m){if(c.isLinux)return m;const d=(0,_.dirname)(m);if(m===d)return m;const f=((0,_.basename)(m)||m).toLowerCase();try{const h=(0,D.readdirSync)(d).filter(u=>u.toLowerCase()===f);if(h.length===1){const u=I(d);if(u)return(0,_.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(f);if(u>=0){const g=I(d);if(g)return(0,_.join)(g,h[u])}}}catch{}return null}e.realcaseSync=I;async function C(m){if(c.isLinux)return m;const d=(0,_.dirname)(m);if(m===d)return m;const f=((0,_.basename)(m)||m).toLowerCase();try{const h=(await D.Promises.readdir(d)).filter(u=>u.toLowerCase()===f);if(h.length===1){const u=await C(d);if(u)return(0,_.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(f);if(u>=0){const g=await C(d);if(g)return(0,_.join)(g,h[u])}}}catch{}return null}e.realcase=C;async function S(m){try{return await D.Promises.realpath(m)}catch{const f=w(m);return await D.Promises.access(f,L.constants.R_OK),f}}e.realpath=S;function P(m){try{return L.realpathSync(m)}catch{const f=w(m);return L.accessSync(f,L.constants.R_OK),f}}e.realpathSync=P;function w(m){return(0,R.rtrim)((0,_.normalize)(m),_.sep)}}),define(se[94],oe([0,1,34,13,28]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var C;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(C||(C={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class w{constructor(k,n,o){this.exePath=k,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await c.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:b=!1}={}){return b?S===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:b=!1,findPreview:k=!1}={}){const n=m({useAlternateBitness:b});if(!n)return null;const o=_.join(n,"PowerShell");if(!await c.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const s of await c.Promises.readdir(o)){let l=-1;if(k){const E=s.indexOf("-");if(E<0)continue;const T=s.substring(0,E);if(!R.test(T)||s.substring(E+1)!=="preview")continue;l=parseInt(T,10)}else{if(!R.test(s))continue;l=parseInt(s,10)}if(l<=t)continue;const p=_.join(o,s,"pwsh.exe");!await c.SymlinkSupport.existsFile(p)||(i=p,t=l)}if(!i)return null;const r=n.includes("x86")?" (x86)":"",a=k?" Preview":"";return new w(i,`PowerShell${a}${r}`,!0)}async function f({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const k=_.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await c.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=b?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const t of await c.Promises.readdir(k))if(n.test(t)){const i=_.join(k,t,"pwsh.exe");return new w(i,o)}return null}function y(){const b=_.join(L.homedir(),".dotnet","tools","pwsh.exe");return new w(b,".NET Core PowerShell Global Tool")}function h(){const b=_.join(process.env.windir,S===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(b,"Windows PowerShell",!0)}async function*u(){let b=await d();b&&(yield b),b=await d({useAlternateBitness:!0}),b&&(yield b),b=await f(),b&&(yield b),b=y(),b&&(yield b),b=await d({findPreview:!0}),b&&(yield b),b=await f({findPreview:!0}),b&&(yield b),b=await d({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=h(),b&&(yield b)}async function*g(){for await(const b of u())await b.exists()&&(yield b)}e.enumeratePowerShellInstallations=g;async function v(){for await(const b of g())return b;return null}e.getFirstAvailablePowerShellInstallation=v}),define(se[95],oe([0,1,13,4,36,88,12,28]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function C(w=c.env){return w.comspec||"cmd.exe"}e.getWindowsShell=C;function S(w){let m=[],d=!1;const f=function(y){if(d){m.push(y);return}(!w.send(y,u=>{if(u&&console.error(u),d=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(v=>f(v))}})||_.isWindows)&&(d=!0)};return{send:f}}e.createQueuedSender=S;var P;(function(w){async function m(d,f,y){if(L.isAbsolute(d))return d;if(f===void 0&&(f=c.cwd()),L.dirname(d)!=="."||(y===void 0&&D.isString(c.env.PATH)&&(y=c.env.PATH.split(L.delimiter)),y===void 0||y.length===0))return L.join(f,d);async function u(g){if(await I.Promises.exists(g)){let v;try{v=await I.Promises.stat(g)}catch(b){b.message.startsWith("EACCES")&&(v=await I.Promises.lstat(g))}return v?!v.isDirectory():!1}return!1}for(const g of y){let v;if(L.isAbsolute(g)?v=L.join(g,d):v=L.join(f,g,d),await u(v))return v;let b=v+".com";if(await u(b)||(b=v+".exe",await u(b)))return b}return L.join(f,d)}w.findExecutable=m})(P=e.win32||(e.win32={}))}),define(se[150],oe([0,1,50,22]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function c(D){return new Promise((I,C)=>{let S;const P=new Map;function w(d,f,y,h,u){const g=P.get(f);if(d===D||g){const v={name:m(y),cmd:y,pid:d,ppid:f,load:h,mem:u};P.set(d,v),d===D&&(S=v),g&&(g.children||(g.children=[]),g.children.push(v),g.children.length>1&&(g.children=g.children.sort((b,k)=>b.pid-k.pid)))}}function m(d){const f=/--vscode-window-kind=shared-process/i,y=/--vscode-window-kind=issue-reporter/i,h=/--vscode-window-kind=process-explorer/i,u=/--utility-sub-type=network/i,g=/--vscode-utility-kind=extensionHost/i,v=/--vscode-utility-kind=fileWatcher/i,b=/--vscode-utility-kind=shared-process/i,k=/--ms-enable-electron-run-as-node/i,n=/--crashes-directory/i,o=/\\pipe\\winpty-control/i,t=/conhost\.exe/i,i=/--type=([a-zA-Z-]+)/;if(n.exec(d))return"electron-crash-reporter";if(o.exec(d))return"winpty-process";if(t.exec(d))return"console-window-host (Windows internal process)";let r=i.exec(d);if(r&&r.length===2)return r[1]==="renderer"?f.exec(d)?"shared-process":y.exec(d)?"issue-reporter":h.exec(d)?"process-explorer":"window":r[1]==="utility"?u.exec(d)?"utility-network-service":g.exec(d)?"extension-host":v.exec(d)?"file-watcher":b.exec(d)?"shared-process":"utility-process":r[1]==="extensionHost"?"extension-host":r[1];const a=/[a-zA-Z-]+\.js/g;let s="";do r=a.exec(d),r&&(s+=r+" ");while(r);return s&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${s})`:k.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,y)=>{ee(["windows-process-tree"],f,y)}).then(f=>{f.getProcessList(D,y=>{if(!y){C(new Error(`Root process ${D} not found`));return}f.getProcessCpuUsage(y,h=>{const u=new Map;h.forEach(g=>{const v=d(g.commandLine||"");u.set(g.pid,{name:m(v),cmd:v,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),S=u.get(D),S?(u.forEach(g=>{const v=u.get(g.ppid);v&&(v.children||(v.children=[]),v.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((v,b)=>v.pid-b.pid))}),I(S)):C(new Error(`Root process ${D} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let d=function(){let f=[S];const y=[];for(;f.length;){const u=f.shift();u&&(y.push(u.pid),u.children&&(f=f.concat(u.children)))}let h=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+y.join(" "),(0,L.exec)(h,{},(u,g,v)=>{if(u||v)C(u||new Error(v.toString()));else{const b=g.toString().split(`
`);for(let k=0;k<y.length;k++){const n=P.get(y[k]);n.load=parseFloat(b[k])}if(!S){C(new Error(`Root process ${D} not found`));return}I(S)}})};(0,L.exec)("which ps",{},(f,y,h)=>{if(f||h)if(process.platform!=="linux")C(f||new Error(h.toString()));else{const u=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(u,{},(g,v,b)=>{g||b?C(g||new Error(b.toString())):(R(v,w),d())})}else{const u=y.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,b,k)=>{v||k&&!k.includes("screen size is bogus")?C(v||new Error(k.toString())):(R(b,w),process.platform==="linux"?d():S?I(S):C(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=c;function R(D,I){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=D.toString().split(`
`);for(const P of S){const w=C.exec(P.trim());w&&w.length===6&&I(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(se[151],oe([0,1,34,4,94,95]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(w,m){return w===1?_.isWindows?P():R.getWindowsShell(m):C(w,m)}e.getSystemShell=D;let I=null;function C(w,m){if(_.isLinux&&w===2||_.isMacintosh&&w===3)return"/bin/bash";if(!I){let d;if(_.isWindows)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}I=d}return I}let S=null;async function P(){return S||(S=(await(0,c.getFirstAvailablePowerShellInstallation)()).exePath),S}});var pe=this&&this.__decorate||function(ee,e,L,_){var c=arguments.length,R=c<3?e:_===null?_=Object.getOwnPropertyDescriptor(e,L):_,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ee,e,L,_);else for(var I=ee.length-1;I>=0;I--)(D=ee[I])&&(R=(c<3?D(R):c>3?D(e,L,R):D(e,L))||R);return c>3&&R&&Object.defineProperty(e,L,R),R};define(se[37],oe([0,1,19,6,16,24,62,7,3,2,91,27,12]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(d||(d={}));function f(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(y||(y={}));function h(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(u||(u={}));function g(j){let M=0;for(let J=0;;J+=7){const Q=j.read(1);if(M|=(Q.buffer[0]&127)<<J,!(Q.buffer[0]&128))return M}}const v=t(0);function b(j,M){if(M===0){j.write(v);return}let J=0;for(let re=M;re!==0;re=re>>>7)J++;const Q=c.VSBuffer.alloc(J);for(let re=0;M!==0;re++)Q.buffer[re]=M&127,M=M>>>7,M>0&&(Q.buffer[re]|=128);j.write(Q)}class k{constructor(M){this.buffer=M,this.pos=0}read(M){const J=this.buffer.slice(this.pos,this.pos+M);return this.pos+=J.byteLength,J}}e.BufferReader=k;class n{constructor(){this.buffers=[]}get buffer(){return c.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}e.BufferWriter=n;var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(o||(o={}));function t(j){const M=c.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},r=typeof Buffer<"u";function a(j,M){if(typeof M>"u")j.write(i.Undefined);else if(typeof M=="string"){const J=c.VSBuffer.fromString(M);j.write(i.String),b(j,J.byteLength),j.write(J)}else if(r&&Buffer.isBuffer(M)){const J=c.VSBuffer.wrap(M);j.write(i.Buffer),b(j,J.byteLength),j.write(J)}else if(M instanceof c.VSBuffer)j.write(i.VSBuffer),b(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(i.Array),b(j,M.length);for(const J of M)a(j,J)}else if(typeof M=="number"&&(M|0)===M)j.write(i.Uint),b(j,M);else{const J=c.VSBuffer.fromString(JSON.stringify(M));j.write(i.Object),b(j,J.byteLength),j.write(J)}}e.serialize=a;function s(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(g(j)).toString();case o.Buffer:return j.read(g(j)).buffer;case o.VSBuffer:return j.read(g(j));case o.Array:{const J=g(j),Q=[];for(let re=0;re<J;re++)Q.push(s(j));return Q}case o.Object:return JSON.parse(j.read(g(j)).toString());case o.Int:return g(j)}}e.deserialize=s;class l{constructor(M,J,Q=null,re=1e3){this.protocol=M,this.ctx=J,this.logger=Q,this.timeoutDelay=re,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(M,J){this.channels.set(M,J),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const J=this.send([M.type]);this.logger?.logOutgoing(J,0,1,h(M.type));return}case 201:case 202:case 204:case 203:{const J=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(J,M.id,1,h(M.type),M.data);return}}}send(M,J=void 0){const Q=new n;return a(Q,M),a(Q,J),this.sendBuffer(Q.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const J=new k(M),Q=s(J),re=s(J),ae=Q[0];switch(ae){case 100:return this.logger?.logIncoming(M.byteLength,Q[1],1,`${f(ae)}: ${Q[2]}.${Q[3]}`,re),this.onPromise({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:re});case 102:return this.logger?.logIncoming(M.byteLength,Q[1],1,`${f(ae)}: ${Q[2]}.${Q[3]}`,re),this.onEventListen({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:re});case 101:return this.logger?.logIncoming(M.byteLength,Q[1],1,`${f(ae)}`),this.disposeActiveRequest({type:ae,id:Q[1]});case 103:return this.logger?.logIncoming(M.byteLength,Q[1],1,`${f(ae)}`),this.disposeActiveRequest({type:ae,id:Q[1]})}}onPromise(M){const J=this.channels.get(M.channelName);if(!J){this.collectPendingRequest(M);return}const Q=new R.CancellationTokenSource;let re;try{re=J.call(this.ctx,M.name,M.arg,Q.token)}catch(F){re=Promise.reject(F)}const ae=M.id;re.then(F=>{this.sendResponse({id:ae,data:F,type:201}),this.activeRequests.delete(M.id)},F=>{F instanceof Error?this.sendResponse({id:ae,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:ae,data:F,type:203}),this.activeRequests.delete(M.id)});const B=(0,S.toDisposable)(()=>Q.cancel());this.activeRequests.set(M.id,B)}onEventListen(M){const J=this.channels.get(M.channelName);if(!J){this.collectPendingRequest(M);return}const Q=M.id,ae=J.listen(this.ctx,M.name,M.arg)(B=>this.sendResponse({id:Q,data:B,type:204}));this.activeRequests.set(M.id,ae)}disposeActiveRequest(M){const J=this.activeRequests.get(M.id);J&&(J.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let J=this.pendingRequests.get(M.channelName);J||(J=[],this.pendingRequests.set(M.channelName,J));const Q=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:M,timeoutTimer:Q})}flushPendingRequests(M){const J=this.pendingRequests.get(M);if(J){for(const Q of J)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var p;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(M,J=null){this.protocol=M,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=J}getChannel(M){const J=this;return{call(Q,re,ae){return J.isDisposed?Promise.reject(new I.CancellationError):J.requestPromise(M,Q,re,ae)},listen(Q,re){return J.isDisposed?C.Event.None:J.requestEvent(M,Q,re)}}}requestPromise(M,J,Q,re=R.CancellationToken.None){const ae=this.lastRequestId++,F={id:ae,type:100,channelName:M,name:J,arg:Q};if(re.isCancellationRequested)return Promise.reject(new I.CancellationError);let U;return new Promise((H,te)=>{if(re.isCancellationRequested)return te(new I.CancellationError);const G=()=>{const he=me=>{switch(me.type){case 201:this.handlers.delete(ae),H(me.data);break;case 202:{this.handlers.delete(ae);const ve=new Error(me.data.message);ve.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,ve.name=me.data.name,te(ve);break}case 203:this.handlers.delete(ae),te(me.data);break}};this.handlers.set(ae,he),this.sendRequest(F)};let X=null;this.state===u.Idle?G():(X=(0,_.createCancelablePromise)(he=>this.whenInitialized()),X.then(()=>{X=null,G()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:ae,type:101}),te(new I.CancellationError)},le=re.onCancellationRequested(ie);U=(0,S.combinedDisposable)((0,S.toDisposable)(ie),le),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(M,J,Q){const re=this.lastRequestId++,B={id:re,type:102,channelName:M,name:J,arg:Q};let F=null;const U=new C.Emitter({onWillAddFirstListener:()=>{F=(0,_.createCancelablePromise)(H=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(U),this.sendRequest(B)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(U),this.sendRequest({id:re,type:103}))}}),x=H=>U.fire(H.data);return this.handlers.set(re,x),U.event}sendRequest(M){switch(M.type){case 100:case 102:{const J=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing(J,M.id,0,`${f(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const J=this.send([M.type,M.id]);this.logger?.logOutgoing(J,M.id,0,f(M.type));return}}}send(M,J=void 0){const Q=new n;return a(Q,M),a(Q,J),this.sendBuffer(Q.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const J=new k(M),Q=s(J),re=s(J),ae=Q[0];switch(ae){case 200:return this.logger?.logIncoming(M.byteLength,0,0,h(ae)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(M.byteLength,Q[1],0,h(ae),re),this.onResponse({type:Q[0],id:Q[1],data:re})}}onResponse(M){if(M.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([D.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class T{get connections(){const M=[];return this._connections.forEach(J=>M.push(J)),M}constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:J,onDidClientDisconnect:Q})=>{C.Event.once(J.onMessage)(ae=>{const B=new k(ae),F=s(B),U=new l(J,F),x=new E(J);this.channels.forEach((te,G)=>U.registerChannel(G,te));const H={channelServer:U,channelClient:x,ctx:F};this._connections.add(H),this._onDidAddConnection.fire(H),Q(()=>{U.dispose(),x.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}getChannel(M,J){const Q=this;return{call(re,ae,B){let F;if((0,m.isFunction)(J)){const x=(0,L.getRandomElement)(Q.connections.filter(J));F=x?Promise.resolve(x):C.Event.toPromise(C.Event.filter(Q.onDidAddConnection,J))}else F=J.routeCall(Q,re,ae);const U=F.then(x=>x.channelClient.getChannel(M));return N(U).call(re,ae,B)},listen(re,ae){if((0,m.isFunction)(J))return Q.getMulticastEvent(M,J,re,ae);const B=J.routeEvent(Q,re,ae).then(F=>F.channelClient.getChannel(M));return N(B).listen(re,ae)}}}getMulticastEvent(M,J,Q,re){const ae=this;let B=new S.DisposableStore;const F=new C.Emitter({onWillAddFirstListener:()=>{B=new S.DisposableStore;const U=new C.EventMultiplexer,x=new Map,H=G=>{const ie=G.channelClient.getChannel(M).listen(Q,re),le=U.add(ie);x.set(G,le)},te=G=>{const X=x.get(G);!X||(X.dispose(),x.delete(G))};ae.connections.filter(J).forEach(H),C.Event.filter(ae.onDidAddConnection,J)(H,void 0,B),ae.onDidRemoveConnection(te,void 0,B),U.event(F.fire,F,B),B.add(U)},onDidRemoveLastListener:()=>{B.dispose()}});return F.event}registerChannel(M,J){this.channels.set(M,J),this._connections.forEach(Q=>{Q.channelServer.registerChannel(M,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class A{constructor(M,J,Q=null){const re=new n;a(re,J),M.send(re.buffer),this.channelClient=new E(M,Q),this.channelServer=new l(M,J,Q)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,J){this.channelServer.registerChannel(M,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function N(j){return{call(M,J,Q){return j.then(re=>re.call(M,J,Q))},listen(M,J){const Q=new C.Relay;return j.then(re=>Q.input=re.listen(M,J)),Q.event}}}e.getDelayedChannel=N;function W(j){let M=!1;return{call(J,Q,re){return M?j.call(J,Q,re):(0,_.timeout)(0).then(()=>M=!0).then(()=>j.call(J,Q,re))},listen(J,Q){if(M)return j.listen(J,Q);const re=new C.Relay;return(0,_.timeout)(0).then(()=>M=!0).then(()=>re.input=j.listen(J,Q)),re.event}}}e.getNextTickChannel=W;class V{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const J of M.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await C.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=V;var K;(function(j){function M(ae,B){const F=ae,U=B&&B.disableMarshalling,x=new Map;for(const H in F)Q(H)&&x.set(H,C.Event.buffer(F[H],!0));return new class{listen(H,te,G){const X=x.get(te);if(X)return X;if(re(te)){const ie=F[te];if(typeof ie=="function")return ie.call(F,G)}throw new Error(`Event not found: ${te}`)}call(H,te,G){const X=F[te];if(typeof X=="function"){if(!U&&Array.isArray(G))for(let ie=0;ie<G.length;ie++)G[ie]=(0,P.revive)(G[ie]);return X.apply(F,G)}throw new Error(`Method not found: ${te}`)}}}j.fromService=M;function J(ae,B){const F=B&&B.disableMarshalling;return new Proxy({},{get(U,x){if(typeof x=="string")return B?.properties?.has(x)?B.properties.get(x):re(x)?function(H){return ae.listen(x,H)}:Q(x)?ae.listen(x):async function(...H){let te;B&&!(0,m.isUndefinedOrNull)(B.context)?te=[B.context,...H]:te=H;const G=await ae.call(x,te);return F?G:(0,P.revive)(G)};throw new Error(`Property not found: ${String(x)}`)}})}j.toService=J;function Q(ae){return ae[0]==="o"&&ae[1]==="n"&&w.isUpperAsciiLetter(ae.charCodeAt(2))}function re(ae){return/^onDynamic/.test(ae)&&w.isUpperAsciiLetter(ae.charCodeAt(9))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function $(j){return Array.isArray(j)?j.map(O):O(j)}function Z(j,M,J,Q,re,ae,B){B=$(B);const F=z[re],U=F[Q%F.length];let x=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?(x=x.concat(B),x.push(")")):x.push(B),console.log.apply(console,x)}class q{constructor(M,J){this._outgoingPrefix=M,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,J,Q,re,ae){this._totalOutgoing+=M,Z(this._outgoingPrefix,this._totalOutgoing,M,J,Q,re,ae)}logIncoming(M,J,Q,re,ae){this._totalIncoming+=M,Z(this._incomingPrefix,this._totalIncoming,M,J,Q,re,ae)}}e.IPCLogger=q}),define(se[152],oe([0,1,16,3,37]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(C){this.port=C,this.onMessage=_.Event.fromDOMEventEmitter(this.port,"message",S=>L.VSBuffer.wrap(S.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends c.IPCClient{constructor(C,S){const P=new R(C);super(P,S),this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=D}),define(se[96],oe([0,1,6,16,3,2,37]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(I=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(E){E.enableDiagnostics=!1,E.records=[];const T=new WeakMap;let A=0;function N(V,K){if(!T.has(V)){const z=String(++A);T.set(V,z)}return T.get(V)}function W(V,K,z,O){if(!E.enableDiagnostics)return;const $=N(V,K);if(O instanceof _.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const Z=_.VSBuffer.alloc(O.byteLength);Z.set(O),E.records.push({timestamp:Date.now(),id:$,label:K,type:z,buff:Z})}else E.records.push({timestamp:Date.now(),id:$,label:K,type:z,data:O})}E.traceSocketEvent=W})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function w(){return P||(P=_.VSBuffer.alloc(0)),P}class m{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(T){this._chunks.push(T),this._totalLength+=T.byteLength}read(T){return this._read(T,!0)}peek(T){return this._read(T,!1)}_read(T,A){if(T===0)return w();if(T>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===T){const K=this._chunks[0];return A&&(this._chunks.shift(),this._totalLength-=T),K}if(this._chunks[0].byteLength>T){const K=this._chunks[0].slice(0,T);return A&&(this._chunks[0]=this._chunks[0].slice(T),this._totalLength-=T),K}const N=_.VSBuffer.alloc(T);let W=0,V=0;for(;T>0;){const K=this._chunks[V];if(K.byteLength>T){const z=K.slice(0,T);N.set(z,W),W+=T,A&&(this._chunks[V]=K.slice(T),this._totalLength-=T),T-=T}else N.set(K,W),W+=K.byteLength,A?(this._chunks.shift(),this._totalLength-=K.byteLength):V++,T-=K.byteLength}return N}}e.ChunkStream=m;var d;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function f(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var y;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(T,A,N,W){this.type=T,this.id=A,this.ack=N,this.data=W,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends R.Disposable{constructor(T){super(),this._onMessage=this._register(new c.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=T,this._isDisposed=!1,this._incomingData=new m,this._register(this._socket.onData(A=>this.acceptChunk(A))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(T);this._incomingData.byteLength>=this._state.readLen;){const A=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=A.readUInt32BE(9),this._state.messageType=A.readUInt8(0),this._state.id=A.readUInt32BE(1),this._state.ack=A.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const N=this._state.messageType,W=this._state.id,V=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",A),this._onMessage.fire(new h(N,W,V,A)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(T){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=T,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(T){if(this._isDisposed)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const A=_.VSBuffer.alloc(13);A.writeUInt8(T.type,0),A.writeUInt32BE(T.id,1),A.writeUInt32BE(T.ack,5),A.writeUInt32BE(T.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",T.data),this._writeSoon(A,T.data)}_bufferAdd(T,A){const N=this._totalLength===0;return this._data.push(T,A),this._totalLength+=T.byteLength+A.byteLength,N}_bufferTake(){const T=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,T}_writeSoon(T,A){this._bufferAdd(T,A)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const T=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this._socket.write(T)}}class v extends R.Disposable{constructor(T){super(),this._onMessage=new c.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new c.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=T,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(A=>{A.type===1&&this._onMessage.fire(A.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(T){this._socketWriter.write(new h(1,0,0,T))}}e.Protocol=v;class b extends D.IPCClient{static fromSocket(T,A){return new b(new v(T),A)}get onDidDispose(){return this.protocol.onDidDispose}constructor(T,A,N=null){super(T,A,N),this.protocol=T}dispose(){super.dispose();const T=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),T.end()}}e.Client=b;class k{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new c.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(T){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(T):this._emitter.fire(T):this._bufferedMessages.push(T)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=k;class n{constructor(T){this.data=T,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let T=0,A=this._first;for(;A;)A=A.next,T++;return T}peek(){return this._first?this._first.data:null}toArray(){const T=[];let A=0,N=this._first;for(;N;)T[A++]=N.data,N=N.next;return T}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(T){const A=new n(T);if(!this._first){this._first=A,this._last=A;return}this._last.next=A,this._last=A}}class t{static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}constructor(){this.lastRuns=[];const T=Date.now();for(let A=0;A<t._HISTORY_LENGTH;A++)this.lastRuns[A]=T-1e3*A;setInterval(()=>{for(let A=t._HISTORY_LENGTH;A>=1;A--)this.lastRuns[A]=this.lastRuns[A-1];this.lastRuns[0]=Date.now()},1e3)}load(){const T=Date.now(),A=(1+t._HISTORY_LENGTH)*1e3;let N=0;for(let W=0;W<t._HISTORY_LENGTH;W++)T-this.lastRuns[W]<=A&&N++;return 1-N/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;var i;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(i=e.ConnectionHealth||(e.ConnectionHealth={}));function r(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class a{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=a;class s{constructor(T,A){this.roundTripTime=T,this.recentHighRoundTripCount=A}}e.HighRoundTripTimeEvent=s;class l{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(T){this._onControlMessage=new k,this.onControlMessage=this._onControlMessage.event,this._onMessage=new k,this.onMessage=this._onMessage.event,this._onDidDispose=new k,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new k,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new k,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new k,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new k,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=T.loadEstimator??t.getInstance(),this._measureRoundTripTime=T.measureRoundTripTime??!1,this._shouldSendKeepAlive=T.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new R.DisposableStore,this._socket=T.socket,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(A=>this._receiveMessage(A))),this._socketDisposables.add(this._socket.onClose(A=>this._onSocketClose.fire(A))),this._socketLatencyMonitor=this._socketDisposables.add(new p),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(A=>this._sendLatencyMeasurementRequest(A))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(A=>this._onHighRoundTripTime.fire(A))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(A=>this._onDidChangeConnectionHealth.fire(A))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),T.initialChunk&&this._socketReader.acceptChunk(T.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const T=new h(5,0,0,w());this._socketWriter.write(T),this._socketWriter.flush()}sendPause(){const T=new h(7,0,0,w());this._socketWriter.write(T)}sendResume(){const T=new h(8,0,0,w());this._socketWriter.write(T)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(T,A){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new R.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=T,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(N=>this._receiveMessage(N))),this._socketDisposables.add(this._socket.onClose(N=>this._onSocketClose.fire(N))),this._socketLatencyMonitor=this._socketDisposables.add(new p),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(N=>this._sendLatencyMeasurementRequest(N))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(N=>this._onHighRoundTripTime.fire(N))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(N=>this._onDidChangeConnectionHealth.fire(N))),this._socketReader.acceptChunk(A)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const T=new h(3,0,this._incomingAckId,w());this._socketWriter.write(T);const A=this._outgoingUnackMsg.toArray();for(let N=0,W=A.length;N<W;N++)this._socketWriter.write(A[N]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(T){if(T.ack>this._outgoingAckId){this._outgoingAckId=T.ack;do{const A=this._outgoingUnackMsg.peek();if(A&&A.id<=T.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this._incomingMsgId)if(T.id!==this._incomingMsgId+1){const A=Date.now();A-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=A,this._socketWriter.write(new h(6,0,0,w())))}else this._incomingMsgId=T.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(T.data);break}case 2:{this._onControlMessage.fire(T.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const A=this._outgoingUnackMsg.toArray();for(let N=0,W=A.length;N<W;N++)this._socketWriter.write(A[N]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(T.data);break}case 11:{this._socketLatencyMonitor.handleResponse(T.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(T){const A=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const N=new h(1,A,this._incomingAckId,T);this._outgoingUnackMsg.push(N),this._isReconnecting||(this._socketWriter.write(N),this._recvAckCheck())}sendControl(T){const A=new h(2,0,0,T);this._socketWriter.write(A)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const T=Date.now()-this._incomingMsgLastTime;if(T>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-T+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const T=this._outgoingUnackMsg.peek(),A=Date.now()-T.writtenTime,N=Date.now()-this._socketReader.lastReadTime,W=Date.now()-this._lastSocketTimeoutTime;if(A>=2e4&&N>=2e4&&W>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:A,timeSinceLastReceivedSomeData:N});return}const V=Math.max(2e4-A,2e4-N,2e4-W,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},V)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const T=new h(3,0,this._incomingAckId,w());this._socketWriter.write(T)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const T=new h(9,0,this._incomingAckId,w());this._socketWriter.write(T)}_sendLatencyMeasurementRequest(T){this._incomingAckId=this._incomingMsgId;const A=new h(10,0,this._incomingAckId,T);this._socketWriter.write(A)}_sendLatencyMeasurementResponse(T){this._incomingAckId=this._incomingMsgId;const A=new h(11,0,this._incomingAckId,T);this._socketWriter.write(A)}}e.PersistentProtocol=l;class p extends R.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new c.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new c.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new c.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new L.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},T=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const T=++this._lastLatencyMeasurementId,A=_.VSBuffer.alloc(4);A.writeUInt32BE(T,0),this._onSendLatencyRequest.fire(A)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const A=T.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||A!==this._lastLatencyMeasurementId)return;const N=Date.now()-this._lastLatencyMeasurementSent,W=this._latencySampleIndex++;this._latencySamples[W%this._latencySamples.length]=N;const V=this._connectionHealth,K=this._latencySamples.filter(z=>z>=1e3).length;this._connectionHealth=K>=3?1:0,N>1e3&&this._onHighRoundTripTime.fire(new s(N,K)),V!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(se[153],oe([0,1,154,3,37,152]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class D extends c.IPCServer{static getOnDidClientConnect(){const C=_.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(S,P)=>P);return _.Event.map(C,S=>{const{port1:P,port2:w}=new MessageChannel,d={protocol:new R.Protocol(P),onDidClientDisconnect:_.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[w]),d})}constructor(){super(D.getOnDidClientConnect())}}e.Server=D}),define(se[66],oe([0,1,50,6,16,24,147,7,3,2,32,95,88,37]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends d.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",g=>c.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=f;class y{constructor(u,g){this.modulePath=u,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new _.Delayer(v),this.child=null,this._client=null}getChannel(u){const g=this;return{call(v,b,k){return g.requestPromise(u,v,b,k)},listen(v,b){return g.requestEvent(u,v,b)}}}requestPromise(u,g,v,b=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const k=this.getCachedChannel(u),n=(0,_.createCancelablePromise)(i=>k.call(g,v,i)),o=b.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(u,g,v){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let b;const k=new C.Emitter({onWillAddFirstListener:()=>{b=this.getCachedChannel(u).listen(g,v)(k.fire,k),this.activeRequests.add(b)},onDidRemoveLastListener:()=>{this.activeRequests.delete(b),b.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return k.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(g.env),this.child=(0,L.fork)(this.modulePath,u,g);const v=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,D.isRemoteConsoleLog)(r)){(0,D.log)(r,`IPC Library: ${this.options.serverName}`);return}v.fire(c.VSBuffer.wrap(Buffer.from(r,"base64")))});const k=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,n=r=>this.child&&this.child.connected&&k.send(r.buffer.toString("base64")),o=v.event,t={send:n,onMessage:o};this._client=new d.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,S.dispose)(s)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(u){let g=this.channels.get(u);return g||(g=this.client.getChannel(u),this.channels.set(u,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(se[155],oe([0,1,87,16,37,3,12,19]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class C{constructor(m){this.port=m,this.onMessage=R.Event.fromNodeEventEmitter(this.port,"message",d=>_.VSBuffer.wrap(d.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}class S extends c.IPCServer{static getOnDidClientConnect(){(0,D.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const m=new R.Emitter;return process.parentPort.on("message",d=>{const f=(0,I.firstOrDefault)(d.ports);f&&m.fire(f)}),R.Event.map(m.event,d=>({protocol:new C(d),onDidClientDisconnect:R.Event.fromNodeEventEmitter(d,"close")}))}constructor(){super(S.getOnDidClientConnect())}}e.Server=S;function P(w,m,d){const f=y=>{y.data===m&&(w.removeListener("message",f),d())};w.on("message",f)}e.once=P}),define(se[156],oe([0,1,16,7,3,2,13,4,31,37,96]),function(ee,e,L,_,c,R,D,I,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(s,l){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,l)}constructor(s,l=""){this._canWrite=!0,this.debugLabel=l,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,_.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener),this._closeListener=p=>{this.traceSocketEvent("close",{hadError:p}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(s){const l=p=>{this.traceSocketEvent("read",p),s(L.VSBuffer.wrap(p))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(s){const l=p=>{s({type:0,hadError:p,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(s){const l=()=>{s()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(s){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,_.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,_.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=m;var d;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize",a[a.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var f;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(f||(f={}));class y extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(s,l){this.socket.traceSocketEvent(s,l)}constructor(s,l,p,E){super(),this._onData=this._register(new c.Emitter),this._onClose=this._register(new c.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:p?.byteLength||0,recordInflateBytes:E}),this._flowManager=this._register(new h(this,l,p,E,this._onData,(T,A)=>this._write(T,A))),this._register(this._flowManager.onError(T=>{console.error(T),(0,_.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new P.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(async T=>{this._flowManager.isProcessingReadQueue()&&await c.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(T)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this._onData.event(s)}onClose(s){return this._onClose.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){let l=0;for(;l<s.byteLength;)this._flowManager.writeMessage(s.slice(l,Math.min(l+262144,s.byteLength))),l+=262144}_write(s,l){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let p=2;s.byteLength<126?p+=0:s.byteLength<2**16?p+=2:p+=8;const E=L.VSBuffer.alloc(p);if(l?E.writeUInt8(194,0):E.writeUInt8(130,0),s.byteLength<126)E.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){E.writeUInt8(126,1);let T=1;E.writeUInt8(s.byteLength>>>8&255,++T),E.writeUInt8(s.byteLength>>>0&255,++T)}else{E.writeUInt8(127,1);let T=1;E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(s.byteLength>>>24&255,++T),E.writeUInt8(s.byteLength>>>16&255,++T),E.writeUInt8(s.byteLength>>>8&255,++T),E.writeUInt8(s.byteLength>>>0&255,++T)}this.socket.write(L.VSBuffer.concat([E,s]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(s){if(s.byteLength!==0){for(this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const l=this._incomingData.peek(this._state.readLen),p=l.readUInt8(0),E=(p&128)>>>7,T=(p&64)>>>6,A=l.readUInt8(1),N=(A&128)>>>7,W=A&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const l=this._incomingData.read(this._state.readLen),p=l.readUInt8(1),E=(p&128)>>>7;let T=p&127,A=1;T===126?T=l.readUInt8(++A)*2**8+l.readUInt8(++A):T===127&&(T=l.readUInt8(++A)*0+l.readUInt8(++A)*0+l.readUInt8(++A)*0+l.readUInt8(++A)*0+l.readUInt8(++A)*2**24+l.readUInt8(++A)*2**16+l.readUInt8(++A)*2**8+l.readUInt8(++A));let N=0;E&&(N=l.readUInt8(++A)*2**24+l.readUInt8(++A)*2**16+l.readUInt8(++A)*2**8+l.readUInt8(++A)),this._state.state=3,this._state.readLen=T,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const l=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),v(l,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(l,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await c.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class h extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(s,l,p,E,T,A){super(),this._tracer=s,this._onData=T,this._writeFn=A,this._onError=this._register(new c.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new c.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new c.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,l?(this._zlibInflateStream=this._register(new u(this._tracer,E,p,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(s){this._writeQueue.push(s),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const s=this._writeQueue.shift();if(this._zlibDeflateStream){const l=await this._deflateMessage(this._zlibDeflateStream,s);this._writeFn(l,!0)}else this._writeFn(s,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(s,l){return new Promise((p,E)=>{s.write(l),s.flush(T=>p(T))})}acceptFrame(s,l,p){this._readQueue.push({data:s,isCompressed:l,isLastFrameOfMessage:p}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const s=this._readQueue.shift();if(this._zlibInflateStream&&s.isCompressed){const l=await this._inflateFrame(this._zlibInflateStream,s.data,s.isLastFrameOfMessage);this._onData.fire(l)}else this._onData.fire(s.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(s,l,p){return new Promise((E,T)=>{s.write(l),p&&s.write(L.VSBuffer.fromByteArray([0,0,255,255])),s.flush(A=>E(A))})}}class u extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(s,l,p,E){super(),this._tracer=s,this._recordInflateBytes=l,this._onError=this._register(new c.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(E),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(L.VSBuffer.wrap(T))}),p&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(s){this._recordInflateBytes&&this._recordedInflateBytes.push(s.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",s),this._zlibInflate.write(s.buffer)}flush(s){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const l=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,s(l)})}}class g extends R.Disposable{constructor(s,l){super(),this._tracer=s,this._onError=this._register(new c.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",p=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibDeflate.on("data",p=>{this._tracer.traceSocketEvent("zlibDeflateData",p),this._pendingDeflateData.push(L.VSBuffer.wrap(p))})}write(s){this._tracer.traceSocketEvent("zlibDeflateWrite",s.buffer),this._zlibDeflate.write(s.buffer)}flush(s){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let l=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,l=l.slice(0,l.byteLength-4),s(l)})}}function v(a,s){if(s===0)return;const l=a.byteLength>>>2;for(let W=0;W<l;W++){const V=a.readUInt32BE(W*4);a.writeUInt32BE(V^s,W*4)}const p=l*4,E=a.byteLength-p,T=s>>>24&255,A=s>>>16&255,N=s>>>8&255;E>=1&&a.writeUInt8(a.readUInt8(p)^T,p),E>=2&&a.writeUInt8(a.readUInt8(p+1)^A,p+1),E>=3&&a.writeUInt8(a.readUInt8(p+2)^N,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const b={[2]:107,[1]:103};function k(){const a=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):s=(0,D.join)(w().os.tmpdir(),`vscode-ipc-${a}.sock`),o(s),s}e.createRandomIPCHandle=k;function n(a,s,l){const p=w().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${l}-${s}-sock`;const E=l.substr(0,4),T=s.substr(0,6),A=p.substr(0,8);let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${A}-${E}-${T}.sock`):N=(0,D.join)(a,`${E}-${T}.sock`),o(N),N}e.createStaticIPCHandle=n;function o(a){const s=b[I.platform];typeof s=="number"&&a.length>=s&&console.warn(`WARNING: IPC handle "${a}" is longer than ${s} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static toClientConnectionEvent(s){const l=c.Event.fromNodeEventEmitter(s,"connection");return c.Event.map(l,p=>({protocol:new P.Protocol(new m(p,"ipc-server-connection")),onDidClientDisconnect:c.Event.once(c.Event.fromNodeEventEmitter(p,"close"))}))}constructor(s){super(t.toClientConnectionEvent(s)),this.server=s}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function i(a){return new Promise((s,l)=>{const p=w().net.createServer();p.on("error",l),p.listen(a,()=>{p.removeListener("error",l),s(new t(p))})})}e.serve=i;function r(a,s){return new Promise((l,p)=>{const E=w().net.createConnection(a,()=>{E.removeListener("error",p),l(P.Client.fromSocket(new m(E,`ipc-client${s}`),s))});E.once("error",p)})}e.connect=r}),define(se[67],oe([0,1,6,3,2,12]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function I(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var C;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(C=e.StorageState||(e.StorageState={}));class S extends c.Disposable{constructor(m,d=Object.create(null)){super(),this.database=m,this.options=d,this._onDidChangeStorage=this._register(new _.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((d,f)=>this.accept(f,d)),m.deleted?.forEach(d=>this.accept(d,void 0))}accept(m,d){if(this.state===C.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(d)?f=this.cache.delete(m):this.cache.get(m)!==d&&(this.cache.set(m,d),f=!0),f&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,d){const f=this.cache.get(m);return(0,R.isUndefinedOrNull)(f)?d:f}getBoolean(m,d){const f=this.get(m);return(0,R.isUndefinedOrNull)(f)?d:f==="true"}getNumber(m,d){const f=this.get(m);return(0,R.isUndefinedOrNull)(f)?d:parseInt(f,10)}async set(m,d){if(this.state===C.Closed)return;if((0,R.isUndefinedOrNull)(d))return this.delete(m);const f=String(d);if(this.cache.get(m)!==f)return this.cache.set(m,f),this.pendingInserts.set(m,f),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===C.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}S.DEFAULT_FLUSH_DELAY=100,e.Storage=S;class P{constructor(){this.onDidChangeItemsExternal=_.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((d,f)=>this.items.set(f,d)),m.delete?.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=P}),define(se[157],oe([10,8]),function(ee,e){return ee.create("vs/base/node/zip",e)}),define(se[158],oe([10,8]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[159],oe([10,8]),function(ee,e){return ee.create("vs/platform/environment/node/argv",e)}),define(se[160],oe([10,8]),function(ee,e){return ee.create("vs/platform/environment/node/argvHelper",e)}),define(se[161],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[162],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[163],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[164],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[165],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(se[166],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[167],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[168],oe([10,8]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[169],oe([10,8]),function(ee,e){return ee.create("vs/platform/files/common/fileService",e)}),define(se[170],oe([10,8]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(se[171],oe([10,8]),function(ee,e){return ee.create("vs/platform/files/common/io",e)}),define(se[172],oe([10,8]),function(ee,e){return ee.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[173],oe([10,8]),function(ee,e){return ee.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[174],oe([10,8]),function(ee,e){return ee.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(se[175],oe([10,8]),function(ee,e){return ee.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(se[176],oe([10,8]),function(ee,e){return ee.create("vs/platform/request/common/request",e)}),define(se[177],oe([10,8]),function(ee,e){return ee.create("vs/platform/shell/node/shellEnv",e)}),define(se[178],oe([10,8]),function(ee,e){return ee.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(se[179],oe([10,8]),function(ee,e){return ee.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[180],oe([10,8]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[181],oe([10,8]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[182],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[183],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(se[184],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(se[185],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/settingsSync",e)}),define(se[186],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(se[187],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSync",e)}),define(se[188],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(se[189],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(se[190],oe([10,8]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(se[191],oe([10,8]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(se[192],oe([0,1,7]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var _;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(_=e.TokenType||(e.TokenType={}));class c{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errorTokens=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(D){if(D.type!==19)throw(0,L.illegalArgument)(`expected an error token but got ${JSON.stringify(D)}`);switch(D.lexeme){case"=":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '||'?`;default:{const I=D.lexeme;return I&&I.length>1&&I.startsWith("'")?`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you forget to close the string?`:I&&I.length>1&&I.endsWith("'")?`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you forget to open the string?`:`Unexpected token '${D.lexeme}' at offset ${D.offset}`}}}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errorTokens(){return this._errorTokens}reset(D){return this._input=D,this._start=0,this._current=0,this._tokens=[],this._errorTokens=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:this._addToken(this._match(61)?4:2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:this._match(61)?this._addToken(3):this._match(126)?this._addToken(9):this._error();break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error();break;case 124:this._match(124)?this._addToken(16):this._error();break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(D){return this._isAtEnd()||this._input.charCodeAt(this._current)!==D?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(D){this._tokens.push({type:D,offset:this._start})}_error(){const D={type:19,offset:this._start,lexeme:this._input.substring(this._start,this._current)};this._errorTokens.push(D),this._tokens.push(D)}_string(){this.stringRe.lastIndex=this._start;const D=this.stringRe.exec(this._input);if(D){this._current=this._start+D[0].length;const I=this._input.substring(this._start,this._current),C=c._keywords.get(I);C?this._addToken(C):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error();return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let D=this._current,I=!1,C=!1;for(;;){if(D>=this._input.length){this._current=D,this._error();return}const P=this._input.charCodeAt(D);if(I)I=!1;else if(P===47&&!C){D++;break}else P===91?C=!0:P===92?I=!0:P===93&&(C=!1);D++}for(;D<this._input.length&&c._regexFlags.has(this._input.charCodeAt(D));)D++;this._current=D;const S=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}c._regexFlags=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0))),c._keywords=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=c}),define(se[193],oe([0,1,64,62,22,13,36,25,11]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,R.dirname)(c.FileAccess.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return C.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(C.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?C.URI.file((0,R.join)(d,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,R.resolve)(d):(0,R.normalize)((0,R.join)(c.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?C.URI.file((0,R.resolve)(d)):C.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,R.resolve)(d);const f=D.env.VSCODE_EXTENSIONS;if(f)return f;const y=D.env.VSCODE_PORTABLE;return y?(0,R.join)(y,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(f=>/^[^:/?#]+?:\/\//.test(f)?C.URI.parse(f):C.URI.file((0,R.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?C.URI.parse(d):C.URI.file((0,R.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const f of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(f);y&&y[1]&&y[2]&&d.push([y[1],y[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return C.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=D.env.VSCODE_PORTABLE;return d?C.URI.file((0,R.join)(d,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this._args}constructor(d,f,y){this._args=d,this.paths=f,this.productService=y,this.editSessionId=this.args.editSessionId}}pe([_.memoize],S.prototype,"appRoot",null),pe([_.memoize],S.prototype,"userHome",null),pe([_.memoize],S.prototype,"userDataPath",null),pe([_.memoize],S.prototype,"appSettingsHome",null),pe([_.memoize],S.prototype,"tmpDir",null),pe([_.memoize],S.prototype,"cacheHome",null),pe([_.memoize],S.prototype,"stateResource",null),pe([_.memoize],S.prototype,"userRoamingDataHome",null),pe([_.memoize],S.prototype,"userDataSyncHome",null),pe([_.memoize],S.prototype,"userDataSyncLogResource",null),pe([_.memoize],S.prototype,"editSessionsLogResource",null),pe([_.memoize],S.prototype,"sync",null),pe([_.memoize],S.prototype,"machineSettingsResource",null),pe([_.memoize],S.prototype,"workspaceStorageHome",null),pe([_.memoize],S.prototype,"localHistoryHome",null),pe([_.memoize],S.prototype,"keyboardLayoutResource",null),pe([_.memoize],S.prototype,"argvResource",null),pe([_.memoize],S.prototype,"isExtensionDevelopment",null),pe([_.memoize],S.prototype,"untitledWorkspacesHome",null),pe([_.memoize],S.prototype,"installSourcePath",null),pe([_.memoize],S.prototype,"builtinExtensionsPath",null),pe([_.memoize],S.prototype,"extensionsPath",null),pe([_.memoize],S.prototype,"extensionDevelopmentLocationURI",null),pe([_.memoize],S.prototype,"extensionDevelopmentKind",null),pe([_.memoize],S.prototype,"extensionTestsLocationURI",null),pe([_.memoize],S.prototype,"debugExtensionHost",null),pe([_.memoize],S.prototype,"logLevel",null),pe([_.memoize],S.prototype,"extensionLogLevel",null),pe([_.memoize],S.prototype,"serviceMachineIdResource",null),pe([_.memoize],S.prototype,"telemetryLogResource",null),pe([_.memoize],S.prototype,"disableWorkspaceTrust",null),pe([_.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function P(m,d){return w(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function w(m,d,f,y,h,u){const v=Number(d||m)||(y?null:f),b=v?Boolean(!!d):!1;let k;if(u)try{k=JSON.parse(u)}catch{}return{port:v,break:b,debugId:h,env:k}}e.parseDebugParams=w}),define(se[194],oe([0,1,296,4,159]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,c.localize)(0,null),e:(0,c.localize)(1,null),t:(0,c.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,c.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,c.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,c.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,c.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,c.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,c.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,c.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,c.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,c.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,c.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,c.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,c.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,c.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,c.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,c.localize)(17,null)},category:{type:"string",cat:"e",description:(0,c.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,c.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,c.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,c.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,c.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,c.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,c.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,c.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,c.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,c.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,c.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,c.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,c.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,c.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,c.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,c.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,c.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,c.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(y,h,u=D){const g=y.find(a=>a.length>0&&a[0]!=="-"),v={},b=["_"],k=[],n={};let o;for(const a in h){const s=h[a];s.type==="subcommand"?a===g&&(o=s):(s.alias&&(v[a]=s.alias),s.type==="string"||s.type==="string[]"?(b.push(a),s.deprecates&&b.push(...s.deprecates)):s.type==="boolean"&&(k.push(a),s.deprecates&&k.push(...s.deprecates)),s.global&&(n[a]=s))}if(o&&g){const a=n;for(const E in o.options)a[E]=o.options[E];const s=y.filter(E=>E!==g),l=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,p=I(s,a,l);return{[g]:p,_:[]}}const t=L(y,{string:b,boolean:k,alias:v}),i={},r=t;i._=t._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(const a in h){const s=h[a];if(s.type==="subcommand")continue;s.alias&&delete r[s.alias];let l=r[a];if(s.deprecates)for(const p of s.deprecates)r.hasOwnProperty(p)&&(l||(l=r[p],l&&u.onDeprecatedOption(p,s.deprecationMessage||(0,c.localize)(36,null,a))),delete r[p]);if(typeof l<"u"){if(s.type==="string[]"){if(Array.isArray(l)||(l=[l]),!s.allowEmptyValue){const p=l.filter(E=>E.length>0);p.length!==l.length&&(u.onEmptyValue(a),l=p.length>0?p:void 0)}}else s.type==="string"&&(Array.isArray(l)?(l=l.pop(),u.onMultipleValues(a,l)):!l&&!s.allowEmptyValue&&(u.onEmptyValue(a),l=void 0));i[a]=l,s.deprecationMessage&&u.onDeprecatedOption(a,s.deprecationMessage)}delete r[a]}for(const a in r)u.onUnknownOption(a);return i}e.parseArgs=I;function C(y,h){let u="";return h.args&&(Array.isArray(h.args)?u=` <${h.args.join("> <")}>`:u=` <${h.args}>`),h.alias?`-${h.alias} --${y}${u}`:`--${y}${u}`}function S(y,h){const u=[];for(const g in y){const v=y[g],b=C(g,v);u.push([b,v.description])}return P(u,h)}e.formatOptions=S;function P(y,h){const g=y.reduce((k,n)=>Math.max(k,n[0].length),12)+2+1;if(h-g<25)return y.reduce((k,n)=>k.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const v=h-g-1,b=[];for(const k of y){const n=k[0],o=m(k[1],v),t=w(g-n.length-2);b.push("  "+n+t+o[0]);for(let i=1;i<o.length;i++)b.push(w(g)+o[i])}return b}function w(y){return" ".repeat(y)}function m(y,h){const u=[];for(;y.length;){const g=y.length<h?y.length:y.lastIndexOf(" ",h),v=y.slice(0,g).trim();y=y.slice(g),u.push(v)}return u}function d(y,h,u,g,v){const b=process.stdout.isTTY&&process.stdout.columns||80,k=v?.noInputFiles!==!0?`[${(0,c.localize)(37,null)}...]`:"",n=[`${y} ${u}`];n.push(""),n.push(`${(0,c.localize)(38,null)}: ${h} [${(0,c.localize)(39,null)}]${k}`),n.push(""),v?.noPipe!==!0&&(_.isWindows?n.push((0,c.localize)(40,null,h)):n.push((0,c.localize)(41,null,h)),n.push(""));const o={},t=[];for(const i in g){const r=g[i];if(r.type==="subcommand")r.description&&t.push({command:i,description:r.description});else if(r.description&&r.cat){let a=o[r.cat];a||(o[r.cat]=a={}),a[i]=r}}for(const i in o){const r=i,a=o[r];a&&(n.push(R[r]),n.push(...S(a,b)),n.push(""))}return t.length&&(n.push((0,c.localize)(42,null)),n.push(...P(t.map(i=>[i.command,i.description]),b)),n.push("")),n.join(`
`)}e.buildHelpMessage=d;function f(y,h){return`${y||(0,c.localize)(43,null)}
${h||(0,c.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(se[195],oe([0,1,297,160,194]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(m,d){const f=(b,k)=>{console.warn((0,_.localize)(0,null,b,k))},y=b=>{console.warn((0,_.localize)(1,null,b))},h=(b,k)=>{console.warn((0,_.localize)(2,null,b,k))},u=b=>({onUnknownOption:k=>{b!=="tunnel"&&console.warn((0,_.localize)(3,null,k,b))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:h,getSubcommandReporter:b!=="tunnel"?u:void 0}),g={onUnknownOption:b=>{console.warn((0,_.localize)(4,null,b))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:h,getSubcommandReporter:u},v=(0,c.parseArgs)(m,c.OPTIONS,d?g:void 0);return v.goto&&v._.forEach(b=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,_.localize)(5,null))),v["max-memory"]&&L(parseInt(v["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),v}function I(m){const d=m.findIndex(f=>!/^-/.test(f));if(d>-1)return[...m.slice(0,d),...m.slice(d+1)]}function C(m){let[,...d]=m;process.env.VSCODE_DEV&&(d=I(d)||[]);const f=!w(process.env);return D(d,f)}e.parseMainProcessArgv=C;function S(m){let[,,...d]=m;return process.env.VSCODE_DEV&&(d=I(d)||[]),D(d,!0)}e.parseCLIProcessArgv=S;function P(m,...d){const f=m.indexOf("--");return f===-1?m.push(...d):m.splice(f,0,...d),m}e.addArg=P;function w(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function ee(e,L,_){function c(D,I){const C=R(D,I),S=[C];return e.isAbsolute(C)||S.unshift(_),e.resolve(...S)}function R(D,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,I);const P=D["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(w,"AppData","Roaming")}break;case"darwin":S=e.join(L.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,I)}return{getUserDataPath:c}}if(typeof define=="function")define(se[97],oe([298,34,36]),function(e,L,_){return ee(e,L,_.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=ee(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[98],oe([0,1,34,193,97]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class R extends _.AbstractNativeEnvironmentService{constructor(S,P){super(S,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,c.getUserDataPath)(S,P.nameShort)},P)}}e.NativeEnvironmentService=R;function D(C,S){return(0,_.parseDebugParams)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,S,C.extensionEnvironment)}e.parsePtyHostDebugPort=D;function I(C,S){return(0,_.parseDebugParams)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,S,C.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(se[196],oe([0,1,11]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const _=/^([^@:]+@)?([^:]+):/,c=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,D=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(h){const u=h.match(D);return u?u[1]:null}function P(h){if(h.indexOf("://")===-1){const u=h.match(_);return u?S(u[2]):null}try{const u=L.URI.parse(h);if(u.authority)return S(u.authority)}catch{}return null}function w(h,u){const g=new Set;let v;for(;v=I.exec(h);){const k=P(v[1]);k&&g.add(k)}const b=new Set(u);return Array.from(g).map(k=>b.has(k)?k:k.replace(C,"a"))}e.getDomainsOfRemotes=w;function m(h){const u=h.match(R);return u?u[2]:null}function d(h,u,g){return h&&u?(g&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${h}${u}`:`${h}/${u}`):null}function f(h,u){if(h.indexOf("://")===-1){const g=h.match(c);if(g)return d(g[2],g[3],u)}try{const g=L.URI.parse(h);if(g.authority)return d(m(g.authority),g.path,u)}catch{}return null}function y(h,u=!1){const g=[];let v;for(;v=I.exec(h);){const b=f(v[1],u);b&&g.push(b)}return g}e.getRemotes=y}),define(se[197],oe([0,1,12,163]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function c(D,I,C){try{R(D,I,C)}catch(S){console.error(S?.message??S)}return D}e.localizeManifest=c;function R(D,I,C){const S=(P,w,m)=>{const d=P[w];if((0,L.isString)(d)){const f=d,y=f.length;if(y>1&&f[0]==="%"&&f[y-1]==="%"){const h=f.substr(1,y-2);let u=I[h];u===void 0&&C&&(u=C[h]);const g=typeof u=="string"?u:u?.message,v=C?.[h],b=typeof v=="string"?v:v?.message;if(!g){b||console.warn(`[${D.name}]: ${(0,_.localize)(0,null,h)}`);return}if(m&&(w==="title"||w==="category")&&b&&b!==g){const k={value:g,original:b};P[w]=k}else P[w]=g}}else if((0,L.isObject)(d))for(const f in d)d.hasOwnProperty(f)&&(f==="commands"?S(d,f,!0):S(d,f,m));else if(Array.isArray(d))for(let f=0;f<d.length;f++)S(d,f,m)};for(const P in D)D.hasOwnProperty(P)&&S(D,P)}}),define(se[198],oe([0,1,7]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class _{constructor(){this._generators=new Map}register(R,D){this._generators.set(R,D)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const D in R.contributes){const I=this._generators.get(D);if(!I)continue;const C=R.contributes[D],S=Array.isArray(C)?C:[C];try{I(S,R.activationEvents)}catch(P){(0,L.onUnexpectedError)(P)}}}}e.ImplicitActivationEventsImpl=_,e.ImplicitActivationEvents=new _}),define(se[199],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,D,I,C){return this.channel.call("promptImportantExtensionsInstallNotification",[R,D,I,C])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class _{constructor(R){this.service=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,I){switch(D){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${D}`)}}e.ExtensionRecommendationNotificationServiceChannel=_}),define(se[68],oe([0,1,25,90,168,54]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||D.test(u)}e.isValidVersionStr=C;function S(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(D);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=S;function P(u){if(!u)return null;const g=u.majorBase,v=u.majorMustEqual,b=u.minorBase;let k=u.minorMustEqual;const n=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(g===0||(k=!1),o=!1);let t=0;if(u.preRelease){const i=I.exec(u.preRelease);if(i){const[,r,a,s]=i;t=Date.UTC(Number(r),Number(a)-1,Number(s))}}return{majorBase:g,majorMustEqual:v,minorBase:b,minorMustEqual:k,patchBase:n,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=P;function w(u,g,v){let b;typeof u=="string"?b=P(S(u)):b=u;let k;g instanceof Date?k=g.getTime():typeof g=="string"&&(k=new Date(g).getTime());let n;if(typeof v=="string"?n=P(S(v)):n=v,!b||!n)return!1;const o=b.majorBase,t=b.minorBase,i=b.patchBase;let r=n.majorBase,a=n.minorBase,s=n.patchBase;const l=n.notBefore;let p=n.majorMustEqual,E=n.minorMustEqual,T=n.patchMustEqual;return n.isMinimum?o>r?!0:o<r?!1:t>a?!0:t<a||k&&k<l?!1:i>=s:(o===1&&r===0&&(!p||!E||!T)&&(r=1,a=0,s=0,p=!0,E=!1,T=!1),o<r?!1:o>r?!p:t<a?!1:t>a?!E:i<s?!1:i>s?!T:!(k&&k<l))}e.isValidVersion=w;function m(u,g,v,b,k){const n=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return n.push([_.default.Error,c.localize(0,null)]),n;if(typeof b.name!="string")return n.push([_.default.Error,c.localize(1,null,"name")]),n;if(typeof b.version!="string")return n.push([_.default.Error,c.localize(2,null,"version")]),n;if(!b.engines)return n.push([_.default.Error,c.localize(3,null,"engines")]),n;if(typeof b.engines.vscode!="string")return n.push([_.default.Error,c.localize(4,null,"engines.vscode")]),n;if(typeof b.extensionDependencies<"u"&&!h(b.extensionDependencies))return n.push([_.default.Error,c.localize(5,null,"extensionDependencies")]),n;if(typeof b.activationEvents<"u"){if(!h(b.activationEvents))return n.push([_.default.Error,c.localize(6,null,"activationEvents")]),n;if(typeof b.main>"u"&&typeof b.browser>"u")return n.push([_.default.Error,c.localize(7,null,"activationEvents","main")]),n}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&n.push([_.default.Warning,c.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return n.push([_.default.Error,c.localize(9,null,"main")]),n;{const i=(0,L.joinPath)(v,b.main);(0,L.isEqualOrParent)(i,v)||n.push([_.default.Warning,c.localize(10,null,i.path,v.path)])}if(typeof b.activationEvents>"u")return n.push([_.default.Error,c.localize(11,null,"activationEvents","main")]),n}if(typeof b.browser<"u"){if(typeof b.browser!="string")return n.push([_.default.Error,c.localize(12,null,"browser")]),n;{const i=(0,L.joinPath)(v,b.browser);(0,L.isEqualOrParent)(i,v)||n.push([_.default.Warning,c.localize(13,null,i.path,v.path)])}if(typeof b.activationEvents>"u")return n.push([_.default.Error,c.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(b.version))return n.push([_.default.Error,c.localize(15,null)]),n;const o=[];if(!d(u,g,b,k,o))for(const i of o)n.push([_.default.Error,i]);return n}e.validateExtensionManifest=m;function d(u,g,v,b,k){return b||typeof v.main>"u"&&typeof v.browser>"u"?!0:y(u,g,v.engines.vscode,k)}e.isValidExtensionVersion=d;function f(u,g,v){return u==="*"||y(g,v,u)}e.isEngineValid=f;function y(u,g,v,b=[]){const k=P(S(v));if(!k)return b.push(c.localize(16,null,v)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return b.push(c.localize(17,null,v)),!1}else if(!k.majorMustEqual)return b.push(c.localize(18,null,v)),!1;return w(u,g,k)?!0:(b.push(c.localize(19,null,u,v)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let g=0,v=u.length;g<v;g++)if(typeof u[g]!="string")return!1;return!0}}),define(se[44],oe([0,1,16,31]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function c(R,D,I){let C=I&&I.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const P=(await D.readFile(R.serviceMachineIdResource)).value.toString();C=(0,_.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,_.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,L.VSBuffer.fromString(C))}catch{}}return I?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=c}),define(se[55],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(c,R=[],D=!1){this.ctor=c,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=L}),define(se[69],oe([0,1,55]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const _=[];var c;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(c=e.InstantiationType||(e.InstantiationType={}));function R(I,C,S){C instanceof L.SyncDescriptor||(C=new L.SyncDescriptor(C,[],Boolean(S))),_.push([I,C])}e.registerSingleton=R;function D(){return _}e.getSingletonServiceDescriptors=D}),define(se[200],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class _{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const I=this.lookupOrInsertNode(R),C=this.lookupOrInsertNode(D);I.outgoing.set(C.key,C),C.incoming.set(I.key,I)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const I of this._nodes.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let I=this._nodes.get(D);return I||(I=new L(D,R),this._nodes.set(D,I)),I}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,I]of this._nodes)R.push(`${D}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const I=new Set([R]),C=this._findCycle(D,I);if(C)return C}}_findCycle(R,D){for(const[I,C]of R.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const S=this._findCycle(C,D);if(S)return S;D.delete(I)}}}e.Graph=_}),define(se[5],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=I})(L=e._util||(e._util={})),e.IInstantiationService=c("instantiationService");function _(D,I,C){I[L.DI_TARGET]===I?I[L.DI_DEPENDENCIES].push({id:D,index:C}):(I[L.DI_DEPENDENCIES]=[{id:D,index:C}],I[L.DI_TARGET]=I)}function c(D){if(L.serviceIds.has(D))return L.serviceIds.get(D);const I=function(C,S,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");_(I,C,P)};return I.toString=()=>D,L.serviceIds.set(D,I),I}e.createDecorator=c;function R(D){return D}e.refineServiceDecorator=R}),define(se[201],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(se[17],oe([0,1,12,11,5]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,c.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof _.URI)}e.isConfigurationOverrides=R;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof _.URI)}e.isConfigurationUpdateOverrides=D;var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function S(h,u){const g=Object.create(null);for(const v in h)P(g,v,h[v],u);return g}e.toValuesTree=S;function P(h,u,g,v){const b=u.split("."),k=b.pop();let n=h;for(let o=0;o<b.length;o++){const t=b[o];let i=n[t];switch(typeof i){case"undefined":i=n[t]=Object.create(null);break;case"object":break;default:v(`Ignoring ${u} as ${b.slice(0,o+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[k]=g}catch{v(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(n)}`)}else v(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=P;function w(h,u){const g=u.split(".");m(h,g)}e.removeFromValueTree=w;function m(h,u){const g=u.shift();if(u.length===0){delete h[g];return}if(Object.keys(h).indexOf(g)!==-1){const v=h[g];typeof v=="object"&&!Array.isArray(v)&&(m(v,u),Object.keys(v).length===0&&delete h[g])}}function d(h,u,g){function v(n,o){let t=n;for(const i of o){if(typeof t!="object"||t===null)return;t=t[i]}return t}const b=u.split("."),k=v(h,b);return typeof k>"u"?g:k}e.getConfigurationValue=d;function f(h,u,g){Object.keys(u).forEach(v=>{v!=="__proto__"&&(v in h?L.isObject(h[v])&&L.isObject(u[v])?f(h[v],u[v],g):g&&(h[v]=u[v]):h[v]=u[v])})}e.merge=f;function y(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(se[202],oe([0,1,4,27,192,5]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",L.isMacintosh),D.set("isLinux",L.isLinux),D.set("isWindows",L.isWindows),D.set("isWeb",L.isWeb),D.set("isMacNative",L.isMacintosh&&!L.isWeb),D.set("isEdge",L.isEdge),D.set("isFirefox",L.isFirefox),D.set("isChrome",L.isChrome),D.set("isSafari",L.isSafari);const I=Object.prototype.hasOwnProperty;var C;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return f.INSTANCE}static true(){return y.INSTANCE}static has(O){return h.create(O)}static equals(O,$){return u.create(O,$)}static notEquals(O,$){return b.create(O,$)}static regex(O,$){return a.create(O,$)}static in(O,$){return g.create(O,$)}static notIn(O,$){return v.create(O,$)}static not(O){return k.create(O)}static and(...O){return p.create(O,null,!0)}static or(...O){return E.create(O,null,!0)}static greater(O,$){return o.create(O,$)}static greaterEquals(O,$){return t.create(O,$)}static smaller(O,$){return i.create(O,$)}static smallerEquals(O,$){return r.create(O,$)}static deserializeOrErrorNew(O){if(!O)return{type:"error",lexingErrors:[],parsingErrors:[]};const $=new w,Z=$.parse(O);return Z===void 0?{type:"error",lexingErrors:$.lexingErrors.map(q=>c.Scanner.reportError(q)),parsingErrors:$.parsingErrors}:{type:"ok",expr:Z}}static deserialize(O){if(!!O)return this._deserializeOrExpression(O)}static _deserializeOrExpression(O){const $=O.split("||");return E.create($.map(Z=>this._deserializeAndExpression(Z)),null,!0)}static _deserializeAndExpression(O){const $=O.split("&&");return p.create($.map(Z=>this._deserializeOne(Z)),null,!0)}static _deserializeOne(O){if(O=O.trim(),O.indexOf("!=")>=0){const $=O.split("!=");return b.create($[0].trim(),this._deserializeValue($[1]))}if(O.indexOf("==")>=0){const $=O.split("==");return u.create($[0].trim(),this._deserializeValue($[1]))}if(O.indexOf("=~")>=0){const $=O.split("=~");return a.create($[0].trim(),this._deserializeRegexValue($[1]))}if(O.indexOf(" not in ")>=0){const $=O.split(" not in ");return v.create($[0].trim(),this._deserializeValue($[1]))}if(O.indexOf(" in ")>=0){const $=O.split(" in ");return g.create($[0].trim(),this._deserializeValue($[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const $=O.split(">=");return t.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const $=O.split(">");return o.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const $=O.split("<=");return r.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const $=O.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(O)?k.create(O.substr(1).trim()):h.create(O)}static _deserializeValue(O){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const $=/^'([^']*)'$/.exec(O);return $?$[1].trim():O}static _deserializeRegexValue(O){if((0,_.isFalsyOrWhitespace)(O))return null;const $=O.indexOf("/"),Z=O.lastIndexOf("/");if($===Z||$<0)return null;const q=O.slice($+1,Z),j=O[Z+1]==="i"?"i":"";try{return new RegExp(q,j)}catch{return null}}}e.ContextKeyExpr=S;class P extends Error{}class w{constructor(){this._scanner=new c.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[]}get lexingErrors(){return this._scanner.errorTokens}get parsingErrors(){return this._parsingErrors}parse(O){if(O===""){this._parsingErrors.push("Expected an expression but got an empty string");return}this._tokens=this._scanner.reset(O).scan(),this._current=0,this._parsingErrors=[];try{const $=this._expr();if(!this._isAtEnd())throw this._errUnexpected(this._peek());return $}catch($){if(!($ instanceof P)){const Z=this._peek();this._parsingErrors.push(`Unexpected error: ${$} for token ${c.Scanner.getLexeme(Z)} at offset ${Z.offset}.`)}return}}_expr(){return this._or()}_or(){const O=[this._and()];for(;this._matchOne(16);){const $=this._and();O.push($)}return O.length===1?O[0]:S.or(...O)}_and(){const O=[this._term()];for(;this._matchOne(15);){const $=this._term();O.push($)}return O.length===1?O[0]:S.and(...O)}_term(){if(this._matchOne(2)){const O=this._peek();switch(O.type){case 17:return this._advance(),S.not(O.lexeme);case 11:return this._advance(),S.false();case 12:return this._advance(),S.true();default:throw this._errExpectedButGot("KEY, 'true', or 'false'",O)}}return this._primary()}_primary(){const O=this._peek();switch(O.type){case 11:return this._advance(),S.true();case 12:return this._advance(),S.false();case 0:{this._advance();const $=this._expr();return this._consume(1,"')'"),$}case 17:{const $=O.lexeme;if(this._advance(),this._matchOne(9)){const q=this._peek();switch(q.type){case 10:case 19:{const j=[q.lexeme];this._advance();let M=this._peek(),J=0;for(let F=0;F<q.lexeme.length;F++)q.lexeme.charCodeAt(F)===40?J++:q.lexeme.charCodeAt(F)===41&&J--;for(;!this._isAtEnd()&&M.type!==15&&M.type!==16;){switch(M.type){case 0:J++;break;case 1:J--;break;case 10:case 18:for(let F=0;F<M.lexeme.length;F++)M.lexeme.charCodeAt(F)===40?J++:q.lexeme.charCodeAt(F)===41&&J--}if(J<0)break;j.push(c.Scanner.getLexeme(M)),this._advance(),M=this._peek()}const Q=j.join(""),re=Q.lastIndexOf("/"),ae=re===Q.length-1?void 0:Q.substring(re+1),B=new RegExp(Q.substring(1,re),ae);return S.regex($,B)}case 18:{const j=q.lexeme;this._advance();let M=null;if(!(0,_.isFalsyOrWhitespace)(j)){const J=j.indexOf("/"),Q=j.lastIndexOf("/");if(J!==Q&&J>=0){const re=j.slice(J+1,Q),ae=j[Q+1]==="i"?"i":"";try{M=new RegExp(re,ae)}catch{}}}if(M===null)throw this._errExpectedButGot("REGEX",q);return a.create($,M)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,"'in' after 'not'");const q=this._value();return S.notIn($,q)}switch(this._peek().type){case 3:{this._advance();const q=this._value();switch(q){case"true":return S.has($);case"false":return S.not($);default:return S.equals($,q)}}case 4:{this._advance();const q=this._value();switch(q){case"true":return S.not($);case"false":return S.has($);default:return S.notEquals($,q)}}case 5:return this._advance(),i.create($,this._value());case 6:return this._advance(),r.create($,this._value());case 7:return this._advance(),o.create($,this._value());case 8:return this._advance(),t.create($,this._value());case 13:return this._advance(),S.in($,this._value());default:return S.has($)}}default:throw this._errExpectedButGot("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this._peek())}}_value(){const O=this._peek();switch(O.type){case 17:case 18:return this._advance(),O.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_previous(){return this._tokens[this._current-1]}_matchOne(O){return this._check(O)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(O,$){if(this._check(O))return this._advance();throw this._errExpectedButGot($,this._peek())}_errExpectedButGot(O,$){return this._error(`Expected ${O} but got '${c.Scanner.getLexeme($)}' at offset ${$.offset}.`)}_errUnexpected(O){return this._error(`Unexpected '${c.Scanner.getLexeme(O)}' at offset ${O.offset}.`)}_error(O){return this._parsingErrors.push(O),new P}_check(O){return this._peek().type===O}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=w;function m(z,O){const $=z?z.substituteConstants():void 0,Z=O?O.substituteConstants():void 0;return!$&&!Z?!0:!$||!Z?!1:$.equals(Z)}e.expressionsAreEqualWithConstantSubstitution=m;function d(z,O){return z.cmp(O)}class f{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return y.INSTANCE}}f.INSTANCE=new f,e.ContextKeyFalseExpr=f;class y{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return f.INSTANCE}}y.INSTANCE=new y,e.ContextKeyTrueExpr=y;class h{static create(O,$=null){const Z=D.get(O);return typeof Z=="boolean"?Z?y.INSTANCE:f.INSTANCE:new h(O,$)}constructor(O,$){this.key=O,this.negated=$,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:A(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=D.get(this.key);return typeof O=="boolean"?O?y.INSTANCE:f.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class u{static create(O,$,Z=null){if(typeof $=="boolean")return $?h.create(O,Z):k.create(O,Z);const q=D.get(O);return typeof q=="boolean"?$===(q?"true":"false")?y.INSTANCE:f.INSTANCE:new u(O,$,Z)}constructor(O,$,Z){this.key=O,this.value=$,this.negated=Z,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=D.get(this.key);if(typeof O=="boolean"){const $=O?"true":"false";return this.value===$?y.INSTANCE:f.INSTANCE}return this}evaluate(O){return O.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(O){return O.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class g{static create(O,$){return new g(O,$)}constructor(O,$){this.key=O,this.valueKey=$,this.type=10,this.negated=null}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,this.valueKey,O.key,O.valueKey)}equals(O){return O.type===this.type?this.key===O.key&&this.valueKey===O.valueKey:!1}substituteConstants(){return this}evaluate(O){const $=O.getValue(this.valueKey),Z=O.getValue(this.key);return Array.isArray($)?$.includes(Z):typeof Z=="string"&&typeof $=="object"&&$!==null?I.call($,Z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(O){return O.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class v{static create(O,$){return new v(O,$)}constructor(O,$){this.key=O,this.valueKey=$,this.type=11,this._negated=g.create(O,$)}cmp(O){return O.type!==this.type?this.type-O.type:this._negated.cmp(O._negated)}equals(O){return O.type===this.type?this._negated.equals(O._negated):!1}substituteConstants(){return this}evaluate(O){return!this._negated.evaluate(O)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(O){return O.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class b{static create(O,$,Z=null){if(typeof $=="boolean")return $?k.create(O,Z):h.create(O,Z);const q=D.get(O);return typeof q=="boolean"?$===(q?"true":"false")?f.INSTANCE:y.INSTANCE:new b(O,$,Z)}constructor(O,$,Z){this.key=O,this.value=$,this.negated=Z,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=D.get(this.key);if(typeof O=="boolean"){const $=O?"true":"false";return this.value===$?f.INSTANCE:y.INSTANCE}return this}evaluate(O){return O.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(O){return O.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class k{static create(O,$=null){const Z=D.get(O);return typeof Z=="boolean"?Z?f.INSTANCE:y.INSTANCE:new k(O,$)}constructor(O,$){this.key=O,this.negated=$,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:A(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=D.get(this.key);return typeof O=="boolean"?O?f.INSTANCE:y.INSTANCE:this}evaluate(O){return!O.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(O){return O.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function n(z,O){if(typeof z=="string"){const $=parseFloat(z);isNaN($)||(z=$)}return typeof z=="string"||typeof z=="number"?O(z):f.INSTANCE}class o{static create(O,$,Z=null){return n($,q=>new o(O,q,Z))}constructor(O,$,Z){this.key=O,this.value=$,this.negated=Z,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class t{static create(O,$,Z=null){return n($,q=>new t(O,q,Z))}constructor(O,$,Z){this.key=O,this.value=$,this.negated=Z,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=t;class i{static create(O,$,Z=null){return n($,q=>new i(O,q,Z))}constructor(O,$,Z){this.key=O,this.value=$,this.negated=Z,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class r{static create(O,$,Z=null){return n($,q=>new r(O,q,Z))}constructor(O,$,Z){this.key=O,this.value=$,this.negated=Z,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class a{static create(O,$){return new a(O,$)}constructor(O,$){this.key=O,this.regexp=$,this.type=7,this.negated=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.key<O.key)return-1;if(this.key>O.key)return 1;const $=this.regexp?this.regexp.source:"",Z=O.regexp?O.regexp.source:"";return $<Z?-1:$>Z?1:0}equals(O){if(O.type===this.type){const $=this.regexp?this.regexp.source:"",Z=O.regexp?O.regexp.source:"";return this.key===O.key&&$===Z}return!1}substituteConstants(){return this}evaluate(O){const $=O.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const O=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${O}`}keys(){return[this.key]}map(O){return O.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class s{static create(O){return new s(O)}constructor(O){this._actual=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this._actual.cmp(O._actual)}equals(O){return O.type===this.type?this._actual.equals(O._actual):!1}substituteConstants(){return this}evaluate(O){return!this._actual.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(O){return new s(this._actual.map(O))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function l(z){let O=null;for(let $=0,Z=z.length;$<Z;$++){const q=z[$].substituteConstants();if(z[$]!==q&&O===null){O=[];for(let j=0;j<$;j++)O[j]=z[j]}O!==null&&(O[$]=q)}return O===null?z:O}class p{static create(O,$,Z){return p._normalizeArr(O,$,Z)}constructor(O,$){this.expr=O,this.negated=$,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let $=0,Z=this.expr.length;$<Z;$++){const q=d(this.expr[$],O.expr[$]);if(q!==0)return q}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let $=0,Z=this.expr.length;$<Z;$++)if(!this.expr[$].equals(O.expr[$]))return!1;return!0}return!1}substituteConstants(){const O=l(this.expr);return O===this.expr?this:p.create(O,this.negated,!1)}evaluate(O){for(let $=0,Z=this.expr.length;$<Z;$++)if(!this.expr[$].evaluate(O))return!1;return!0}static _normalizeArr(O,$,Z){const q=[];let j=!1;for(const M of O)if(!!M){if(M.type===1){j=!0;continue}if(M.type===0)return f.INSTANCE;if(M.type===6){q.push(...M.expr);continue}q.push(M)}if(q.length===0&&j)return y.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(d);for(let M=1;M<q.length;M++)q[M-1].equals(q[M])&&(q.splice(M,1),M--);if(q.length===1)return q[0];for(;q.length>1;){const M=q[q.length-1];if(M.type!==9)break;q.pop();const J=q.pop(),Q=q.length===0,re=E.create(M.expr.map(ae=>p.create([ae,J],null,Z)),null,Q);re&&(q.push(re),q.sort(d))}if(q.length===1)return q[0];if(Z){for(let M=0;M<q.length;M++)for(let J=M+1;J<q.length;J++)if(q[M].negate().equals(q[J]))return f.INSTANCE;if(q.length===1)return q[0]}return new p(q,$)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const $ of this.expr)O.push(...$.keys());return O}map(O){return new p(this.expr.map($=>$.map(O)),null)}negate(){if(!this.negated){const O=[];for(const $ of this.expr)O.push($.negate());this.negated=E.create(O,this,!0)}return this.negated}}class E{static create(O,$,Z){return E._normalizeArr(O,$,Z)}constructor(O,$){this.expr=O,this.negated=$,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let $=0,Z=this.expr.length;$<Z;$++){const q=d(this.expr[$],O.expr[$]);if(q!==0)return q}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let $=0,Z=this.expr.length;$<Z;$++)if(!this.expr[$].equals(O.expr[$]))return!1;return!0}return!1}substituteConstants(){const O=l(this.expr);return O===this.expr?this:E.create(O,this.negated,!1)}evaluate(O){for(let $=0,Z=this.expr.length;$<Z;$++)if(this.expr[$].evaluate(O))return!0;return!1}static _normalizeArr(O,$,Z){let q=[],j=!1;if(O){for(let M=0,J=O.length;M<J;M++){const Q=O[M];if(!!Q){if(Q.type===0){j=!0;continue}if(Q.type===1)return y.INSTANCE;if(Q.type===9){q=q.concat(Q.expr);continue}q.push(Q)}}if(q.length===0&&j)return f.INSTANCE;q.sort(d)}if(q.length!==0){if(q.length===1)return q[0];for(let M=1;M<q.length;M++)q[M-1].equals(q[M])&&(q.splice(M,1),M--);if(q.length===1)return q[0];if(Z){for(let M=0;M<q.length;M++)for(let J=M+1;J<q.length;J++)if(q[M].negate().equals(q[J]))return y.INSTANCE;if(q.length===1)return q[0]}return new E(q,$)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const $ of this.expr)O.push(...$.keys());return O}map(O){return new E(this.expr.map($=>$.map(O)),null)}negate(){if(!this.negated){const O=[];for(const $ of this.expr)O.push($.negate());for(;O.length>1;){const $=O.shift(),Z=O.shift(),q=[];for(const j of K($))for(const M of K(Z))q.push(p.create([j,M],null,!1));O.unshift(E.create(q,null,!1))}this.negated=E.create(O,this,!0)}return this.negated}}class T extends h{static all(){return T._info.values()}constructor(O,$,Z){super(O,null),this._defaultValue=$,typeof Z=="object"?T._info.push({...Z,key:O}):Z!==!0&&T._info.push({key:O,description:Z,type:$!=null?typeof $:void 0})}bindTo(O){return O.createKey(this.key,this._defaultValue)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return u.create(this.key,O)}notEqualsTo(O){return b.create(this.key,O)}}T._info=[],e.RawContextKey=T,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function A(z,O){return z<O?-1:z>O?1:0}function N(z,O,$,Z){return z<$?-1:z>$?1:O<Z?-1:O>Z?1:0}function W(z,O){if(z.type===0||O.type===1)return!0;if(z.type===9)return O.type===9?V(z.expr,O.expr):!1;if(O.type===9){for(const $ of O.expr)if(W(z,$))return!0;return!1}if(z.type===6){if(O.type===6)return V(O.expr,z.expr);for(const $ of z.expr)if(W($,O))return!0;return!1}return z.equals(O)}e.implies=W;function V(z,O){let $=0,Z=0;for(;$<z.length&&Z<O.length;){const q=z[$].cmp(O[Z]);if(q<0)return!1;q===0&&$++,Z++}return $===z.length}function K(z){return z.type===9?z.expr:[z]}}),define(se[99],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function _(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=_;class c{async getPerformanceInfo(D,I){return{}}async getSystemInfo(D,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,I){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=c}),define(se[100],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(se[15],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(se[29],oe([0,1,162,5]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function c(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=c;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function I(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function C(u,g,v){return I(g,v)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===v?!0:S(v).includes(u)}e.isTargetPlatformCompatible=C;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,_.createDecorator)("extensionGalleryService");var y;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(g,v){super(g),this.code=v,this.name=v}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,_.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,_.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,_.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(se[203],oe([0,1,3,2,32,11,93,29]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(h,u){return h?R.URI.revive(u?u.transformIncoming(h):h):void 0}function S(h,u){return u?u.transformOutgoingURI(h):h}function P(h,u){u=u||D.DefaultURITransformer;const g=h.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...h,manifest:void 0},u),manifest:g}}function w(h,u){return h?.profileLocation?(0,D.transformAndReviveIncomingURIs)(h,u??D.DefaultURITransformer):h}function m(h,u){return u?(0,c.cloneAndChange)(h,g=>g instanceof R.URI?u.transformOutgoingURI(g):void 0):h}class d{constructor(u,g){this.service=u,this.getUriTransformer=g,this.onInstallExtension=L.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,g){const v=this.getUriTransformer(u);switch(g){case"onInstallExtension":return L.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?S(b.profileLocation,v):b.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,b=>b.map(k=>({...k,local:k.local?m(k.local,v):k.local,profileLocation:k.profileLocation?S(k.profileLocation,v):k.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?S(b.profileLocation,v):b.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?S(b.profileLocation,v):b.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,b=>m(b,v))}throw new Error("Invalid listen")}async call(u,g,v){const b=this.getUriTransformer(u);switch(g){case"zip":{const k=P(v[0],b),n=await this.service.zip(k);return S(n,b)}case"unzip":return this.service.unzip(C(v[0],b));case"install":return this.service.install(C(v[0],b),w(v[1],b));case"installFromLocation":return this.service.installFromLocation(C(v[0],b),C(v[1],b));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(v[0],C(v[1],b),C(v[2],b));case"getManifest":return this.service.getManifest(C(v[0],b));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],w(v[1],b));case"uninstall":return this.service.uninstall(P(v[0],b),w(v[1],b));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(v[0],b));case"getInstalled":return(await this.service.getInstalled(v[0],C(v[1],b))).map(n=>m(n,b));case"copyExtensions":return this.service.copyExtensions(C(v[0],b),C(v[1],b));case"updateMetadata":{const k=await this.service.updateMetadata(P(v[0],b),v[1],C(v[2],b));return m(k,b)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(v[0],v[1]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class f extends _.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this.fireEvent(this._onInstallExtension,{...g,source:this.isUriComponents(g.source)?R.URI.revive(g.source):g.source,profileLocation:R.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this.fireEvent(this._onDidInstallExtensions,g.map(v=>({...v,local:v.local?P(v.local,null):v.local,source:this.isUriComponents(v.source)?R.URI.revive(v.source):v.source,profileLocation:R.URI.revive(v.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this.fireEvent(this._onUninstallExtension,{...g,profileLocation:R.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this.fireEvent(this._onDidUninstallExtension,{...g,profileLocation:R.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(g=>this._onDidUpdateExtensionMetadata.fire(P(g,null))))}fireEvent(u,g){u.fire(g)}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const g=await this.getTargetPlatform();return u.allTargetPlatforms.some(v=>(0,I.isTargetPlatformCompatible)(v,u.allTargetPlatforms,g))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(g=>R.URI.revive(g)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,g){return Promise.resolve(this.channel.call("install",[u,g])).then(v=>P(v,null))}installFromLocation(u,g){return Promise.resolve(this.channel.call("installFromLocation",[u,g])).then(v=>P(v,null))}async installExtensionsFromProfile(u,g,v){return(await this.channel.call("installExtensionsFromProfile",[u,g,v])).map(k=>P(k,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,g){return Promise.resolve(this.channel.call("installFromGallery",[u,g])).then(v=>P(v,null))}uninstall(u,g){return Promise.resolve(this.channel.call("uninstall",[u,g]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u])).then(g=>P(g,null))}getInstalled(u=null,g){return Promise.resolve(this.channel.call("getInstalled",[u,g])).then(v=>v.map(b=>P(b,null)))}updateMetadata(u,g,v){return Promise.resolve(this.channel.call("updateMetadata",[u,g,v])).then(b=>P(b,null))}copyExtensions(u,g){return this.channel.call("copyExtensions",[u,g])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,g){const v=await this.channel.call("download",[u,g]);return R.URI.revive(v)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class y{constructor(u){this.service=u}listen(u,g){throw new Error("Invalid listen")}call(u,g,v){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(se[101],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class _{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((R,D)=>ee(["node-vsce-sign"],async I=>R(I),D))),this.moduleLoadingPromise}async verify(R,D,I){let C;try{C=await this.vsceSign()}catch{return!1}return C.verify(R,D,I)}}e.ExtensionSignatureVerificationService=_}),define(se[102],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var _;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(_=e.RecommendationSource||(e.RecommendationSource={}));function c(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=c;var R;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(se[14],oe([0,1,49,13,27,12,11,170,5,4,22]),function(ee,e,L,_,c,R,D,I,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function w(M){return M.create===!0}e.isFileOpenForWriteOptions=w;var m;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(m=e.FileType||(e.FileType={}));var d;(function(M){M[M.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var f;(function(M){M[M.None=0]="None",M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function u(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=u;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function v(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=v;function b(M){return y(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var k;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class n extends Error{static create(J,Q){const re=new n(J.toString(),Q);return i(re,Q),re}constructor(J,Q){super(J),this.code=Q}}e.FileSystemProviderError=n;function o(M,J){return n.create(M,J)}e.createFileSystemProviderError=o;function t(M){return M||o((0,I.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=t;function i(M,J){return M.name=J?`${J} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=i;function r(M){if(!M)return k.Unknown;if(M instanceof n)return M.code;const J=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!J)return k.Unknown;switch(J[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=r;function a(M){if(M instanceof A)return M.fileOperationResult;switch(r(M)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(J,Q,re){this.resource=J,this.operation=Q,this.target=re}isOperation(J){return this.operation===J}}e.FileOperationEvent=l;var p;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(p=e.FileChangeType||(e.FileChangeType={}));class E{constructor(J,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const ae of J){const B=re.get(ae.type);switch(B?B.push([ae.resource,ae]):re.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,B]of re)switch(ae){case 1:this.added=L.TernarySearchTree.forUris(()=>Q),this.added.fill(B);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>Q),this.updated.fill(B);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>Q),this.deleted.fill(B);break}}contains(J,...Q){return this.doContains(J,{includeChildren:!1},...Q)}affects(J,...Q){return this.doContains(J,{includeChildren:!0},...Q)}doContains(J,Q,...re){if(!J)return!1;const ae=re.length>0;return!!((!ae||re.includes(1))&&(this.added?.get(J)||Q.includeChildren&&this.added?.findSuperstr(J))||(!ae||re.includes(0))&&(this.updated?.get(J)||Q.includeChildren&&this.updated?.findSuperstr(J))||(!ae||re.includes(2))&&(this.deleted?.findSubstr(J)||Q.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=E;function T(M,J,Q){return!M||!J||M===J||J.length>M.length?!1:(J.charAt(J.length-1)!==_.sep&&(J+=_.sep),Q?(0,c.startsWithIgnoreCase)(M,J):M.indexOf(J)===0)}e.isParent=T;class A extends Error{constructor(J,Q,re){super(J),this.fileOperationResult=Q,this.options=re}}e.FileOperationError=A;class N extends A{constructor(J,Q,re,ae){super(J,Q,ae),this.fileOperationResult=Q,this.size=re}}e.TooLargeFileOperationError=N;class W extends A{constructor(J,Q,re){super(J,2,re),this.stat=Q}}e.NotModifiedSinceFileOperationError=W;var V;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=z;async function O(M,J){if(!J.hasProvider(D.URI.from({scheme:M.scheme})))return new Promise(Q=>{const re=J.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===M.scheme&&ae.added&&(re.dispose(),Q())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<$.KB?(0,I.localize)(1,null,J.toFixed(0)):J<$.MB?(0,I.localize)(2,null,(J/$.KB).toFixed(2)):J<$.GB?(0,I.localize)(3,null,(J/$.MB).toFixed(2)):J<$.TB?(0,I.localize)(4,null,(J/$.GB).toFixed(2)):(0,I.localize)(5,null,(J/$.TB).toFixed(2))}}$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB,e.ByteSize=$;var Z;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(Z=e.Arch||(e.Arch={}));function q(M){return{maxFileSize:M===0?300*$.MB:16*$.GB,maxHeapSize:M===0?700*$.MB:2*700*$.MB}}e.getPlatformFileLimits=q;function j(M){const J=typeof M=="string"||M?.scheme===P.Schemas.vscodeRemote;return typeof M!="string"&&M?.scheme===P.Schemas.file?1024*$.MB:J?10*$.MB:S.isWeb?50*$.MB:1024*$.MB}e.getLargeFileConfirmationLimit=j});var Y=this&&this.__param||function(ee,e){return function(L,_){e(L,_,ee)}};define(se[204],oe([0,1,103,43,14]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(I){this.fileService=I}async checksum(I){const C=(await this.fileService.readFileStream(I)).value;return new Promise((S,P)=>{const w=(0,L.createHash)("md5");(0,_.listenStream)(C,{onData:m=>w.update(m.buffer),onError:m=>P(m),onEnd:()=>S(w.digest("base64").replace(/=+$/,""))})})}};R=pe([Y(0,c.IFileService)],R),e.ChecksumService=R}),define(se[205],oe([0,1,16,39,7,3,2,43,11,31,14]),function(ee,e,L,_,c,R,D,I,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends D.Disposable{constructor(d,f){super(),this.channel=d,this.extraCapabilities=f,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,f){const{buffer:y}=await this.channel.call("readFile",[d,f]);return y}readFileStream(d,f,y){const h=(0,I.newWriteableStream)(g=>L.VSBuffer.concat(g.map(v=>L.VSBuffer.wrap(v))).buffer),u=this.channel.listen("readFileStream",[d,f])(g=>{if(g instanceof L.VSBuffer)h.write(g.buffer);else{if(g==="end")h.end();else{let v;if(g instanceof Error)v=g;else{const b=g;v=(0,P.createFileSystemProviderError)(b.message??(0,_.toErrorMessage)(b),b.code??P.FileSystemProviderErrorCode.Unknown)}h.error(v),h.end()}u.dispose()}});return y.onCancellationRequested(()=>{h.error((0,c.canceled)()),h.end(),u.dispose()}),h}writeFile(d,f,y){return this.channel.call("writeFile",[d,L.VSBuffer.wrap(f),y])}open(d,f){return this.channel.call("open",[d,f])}close(d){return this.channel.call("close",[d])}async read(d,f,y,h,u){const[g,v]=await this.channel.call("read",[d,f,u]);return y.set(g.buffer.slice(0,v),h),v}write(d,f,y,h,u){return this.channel.call("write",[d,f,L.VSBuffer.wrap(y),h,u])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,f){return this.channel.call("delete",[d,f])}rename(d,f,y){return this.channel.call("rename",[d,f,y])}copy(d,f,y){return this.channel.call("copy",[d,f,y])}cloneFile(d,f){return this.channel.call("cloneFile",[d,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const f=d;this._onDidChange.fire(f.map(y=>({resource:C.URI.revive(y.resource),type:y.type})))}else{const f=d;this._onDidWatchError.fire(f)}}))}watch(d,f){const y=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,y,d,f]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=w}),define(se[104],oe([0,1,16,7,171,14]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(P,w,m,d,f,y){let h;try{await I(P,w,m,d,f,y)}catch(u){h=u}finally{h&&f.errorTransformer&&(h=f.errorTransformer(h)),typeof h<"u"&&m.error(h),m.end()}}e.readFileIntoStream=D;async function I(P,w,m,d,f,y){C(y);const h=await P.open(w,{create:!1});try{C(y);let u=0,g=0,v=f&&typeof f.length=="number"?f.length:void 0,b=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof v=="number"?v:f.bufferSize)),k=f&&typeof f.position=="number"?f.position:0,n=0;do g=await P.read(h,k,b.buffer,n,b.byteLength-n),k+=g,n+=g,u+=g,typeof v=="number"&&(v-=g),n===b.byteLength&&(await m.write(d(b)),b=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof v=="number"?v:f.bufferSize)),n=0);while(g>0&&(typeof v!="number"||v>0)&&C(y)&&S(u,f));if(n>0){let o=n;typeof v=="number"&&(o=Math.min(n,v)),m.write(d(b.slice(0,o)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await P.close(h)}}function C(P){if(P.isCancellationRequested)throw(0,_.canceled)();return!0}function S(P,w){if(w?.limits){if(typeof w.limits.memory=="number"&&P>w.limits.memory)throw(0,R.createFileSystemProviderError)((0,c.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&P>w.limits.size)throw(0,R.createFileSystemProviderError)((0,c.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(se[56],oe([0,1,92,2,13,4,11,14]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(u){return u.recursive===!0}e.isRecursiveWatchRequest=C;class S extends _.Disposable{constructor(g,v,b,k){super(),this.onFileChanges=g,this.onLogMessage=v,this.verboseLogging=b,this.options=k,this.watcherDisposables=this._register(new _.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new _.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),g.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),g.add(this.watcher.onDidError(v=>this.onError(v)))}onError(g){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}trace(g){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}S.MAX_RESTARTS=5,e.AbstractWatcherClient=S;class P extends S{constructor(g,v,b){super(g,v,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class w extends S{constructor(g,v,b){super(g,v,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function m(u){return u.map(g=>({type:g.type,resource:D.URI.file(g.path)}))}e.toFileChanges=m;function d(u){const g=new h;for(const v of u)g.processEvent(v);return g.coalesce()}e.coalesceEvents=d;function f(u,g){return typeof g=="string"&&!g.startsWith(L.GLOBSTAR)&&!(0,c.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=f;function y(u,g){const v=[];for(const b of g)v.push((0,L.parse)(f(u,b)));return v}e.parseWatcherPatterns=y;class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return R.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const v=this.mapPathToChange.get(this.toKey(g));let b=!1;if(v){const k=v.type,n=g.type;v.path!==g.path&&(g.type===2||g.type===1)?b=!0:k===1&&n===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(v)):k===2&&n===1?v.type=0:k===1&&n===0||(v.type=n)}else b=!0;b&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],v=[];return Array.from(this.coalesced).filter(b=>b.type!==2?(g.push(b),!1):!0).sort((b,k)=>b.path.length-k.path.length).filter(b=>v.some(k=>(0,I.isParent)(b.path,k,!R.isLinux))?!1:(v.push(b.path),!0)).concat(g)}}}),define(se[206],oe([0,1,53,6,24,48,2,85,13,4,149,28,56]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends D.Disposable{constructor(h,u,g,v){super(),this.request=h,this.onDidFilesChange=u,this.onLogMessage=g,this.verboseLogging=v,this.throttledFileChangesEmitter=this._register(new _.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.onDidFilesChange(b))),this.fileChangesAggregator=this._register(new _.RunOnceWorker(b=>this.handleFileChanges(b),d.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new c.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await w.Promises.stat(h);this._register(await this.doWatch(h,u.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(h)}}async normalizePath(h){let u=h.path;try{u=await w.Promises.realpath(h.path),h.path===u&&(u=await(0,P.realcase)(h.path)??h.path),h.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${u})`)}catch{}return u}async doWatch(h,u){if(S.isMacintosh&&(0,R.isEqualOrParent)(h,"/Volumes/",!0))return this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const g=new c.CancellationTokenSource(this.cts.token),v=new D.DisposableStore;try{const b=(0,C.basename)(h),k=(0,L.watch)(h);v.add((0,D.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.trace(`Started watching: '${h}'`);const n=new Set;if(u)try{for(const t of await w.Promises.readdir(h))n.add(t)}catch(t){this.error(t)}const o=new Map;v.add((0,D.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),k.on("error",(t,i)=>{this.error(`Failed to watch ${h} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),k.on("change",(t,i)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let r="";if(i&&(r=i.toString(),S.isMacintosh&&(r=(0,I.normalizeNFC)(r))),!(!r||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){o.get(r)?.dispose();const a=setTimeout(async()=>{if(o.delete(r),r===b&&!await w.Promises.exists(h)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.existsChildStrictCase((0,C.join)(h,r));if(g.token.isCancellationRequested)return;let l;s?n.has(r)?l=0:(l=1,n.add(r)):(n.delete(r),l=2),this.onFileChange({path:(0,C.join)(this.request.path,r),type:l})},d.FILE_DELETE_HANDLER_DELAY);o.set(r,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(r)?a=0:(a=1,n.add(r)),this.onFileChange({path:(0,C.join)(this.request.path,r),type:a})}else if(t==="rename"||r!==b){const a=setTimeout(async()=>{const s=await w.Promises.exists(h);g.token.isCancellationRequested||(s?(this.onFileChange({path:this.request.path,type:0},!0),v.add(await this.doWatch(h,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);v.clear(),v.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(b){await w.Promises.exists(h)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${h} for changes using fs.watch() (${b.toString()})`)}return(0,D.toDisposable)(()=>{g.dispose(!0),v.dispose()})}onFileChange(h,u=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!u&&this.excludes.some(g=>g(h.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${h.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(h.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${h.path}`):this.fileChangesAggregator.work(h))}handleFileChanges(h){const u=(0,m.coalesceEvents)(h);if(u.length>0){if(this.verboseLogging)for(const v of u)this.trace(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.throttledFileChangesEmitter.work(u)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(h){if(S.isLinux)return w.Promises.exists(h);try{const u=(0,C.basename)(h);return(await w.Promises.readdir((0,C.dirname)(h))).some(v=>v===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=75,e.NodeJSFileWatcherLibrary=d;async function f(y,h,u,g,v=512){const b=await w.Promises.open(y,"r"),k=Buffer.allocUnsafe(v),n=new c.CancellationTokenSource(g);let o,t=!1;const i={path:y,excludes:[],recursive:!1},r=new d(i,a=>{(async()=>{for(const{type:s}of a)if(s===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:l}=await w.Promises.read(b,k,0,v,null);if(!l||n.token.isCancellationRequested)break;h(k.slice(0,l))}}catch(l){o=new Error(l),n.dispose(!0)}finally{t=!1}}})()});return await r.ready,u(),new Promise((a,s)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await w.Promises.close(b)}catch(l){o=new Error(l)}o?s(o):a()})})}e.watchFileContents=f}),define(se[207],oe([0,1,3,92,2,4,206]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends c.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=L.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const P=this.normalizeRequests(S),w=P.filter(d=>{const f=this.watchers.get(d.path);return f?!(0,_.patternsEquals)(f.request.excludes,d.excludes)||!(0,_.patternsEquals)(f.request.includes,d.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:d})=>!P.find(f=>f.path===d.path&&(0,_.patternsEquals)(f.excludes,d.excludes)&&(0,_.patternsEquals)(f.includes,d.includes))).map(({request:d})=>d.path);w.length&&this.trace(`Request to start watching: ${w.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const d of m)this.stopWatching(d);for(const d of w)this.startWatching(d)}startWatching(S){const P=new D.NodeJSFileWatcherLibrary(S,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),w={request:S,instance:P};this.watchers.set(S.path,w)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const P=this.watchers.get(S);P&&(this.watchers.delete(S),P.instance.dispose())}normalizeRequests(S){const P=new Map;for(const w of S){const m=R.isLinux?w.path:w.path.toLowerCase();P.set(m,w)}return Array.from(P.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,P]of this.watchers)P.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,P){return P?`[File Watcher (node.js)] ${S} (path: ${P.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=I}),define(se[208],oe([0,1,56,207]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class c extends L.AbstractNonRecursiveWatcherClient{constructor(D,I,C){super(D,I,C),this.init()}createWatcher(){return new _.NodeJSWatcher}}e.NodeJSWatcherClient=c}),define(se[209],oe([0,1,22,37,66,56]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(C,S,P){super(C,S,P),this.init()}createWatcher(C){const S=C.add(new c.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(S.onDidProcessExit(({code:P,signal:w})=>this.onError(`terminated by itself with code ${P}, signal: ${w}`))),_.ProxyChannel.toService((0,_.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(se[70],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...c){this._entries=new Map;for(const[R,D]of c)this.set(R,D)}set(c,R){const D=this._entries.get(c);return this._entries.set(c,R),D}has(c){return this._entries.has(c)}get(c){return this._entries.get(c)}}e.ServiceCollection=L}),define(se[210],oe([0,1,6,7,2,55,200,5,70,84]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class w extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class m{constructor(h=new C.ServiceCollection,u=!1,g,v=P){this._services=h,this._strict=u,this._parent=g,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=v?g?._globalGraph??new D.Graph(b=>b):void 0}createChild(h){return new m(h,this._strict,this,this._enableTracing)}invokeFunction(h,...u){const g=f.traceInvocation(this._enableTracing,h);let v=!1;try{return h({get:k=>{if(v)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(k,g);if(!n)throw new Error(`[invokeFunction] unknown service '${k}'`);return n}},...u)}finally{v=!0,g.stop()}}createInstance(h,...u){let g,v;return h instanceof R.SyncDescriptor?(g=f.traceCreation(this._enableTracing,h.ctor),v=this._createInstance(h.ctor,h.staticArguments.concat(u),g)):(g=f.traceCreation(this._enableTracing,h),v=this._createInstance(h,u,g)),g.stop(),v}_createInstance(h,u=[],g){const v=I._util.getServiceDependencies(h).sort((n,o)=>n.index-o.index),b=[];for(const n of v){const o=this._getOrCreateServiceInstance(n.id,g);o||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${n.id}.`,!1),b.push(o)}const k=v.length>0?v[0].index:u.length;if(u.length!==k){console.trace(`[createInstance] First service dependency of ${h.name} at position ${k+1} conflicts with ${u.length} static arguments`);const n=k-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,k)}return Reflect.construct(h,u.concat(b))}_setServiceInstance(h,u){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,u);else if(this._parent)this._parent._setServiceInstance(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const u=this._services.get(h);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):u}_getOrCreateServiceInstance(h,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const g=this._getServiceInstanceOrDescriptor(h);return g instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,g,u.branch(h,!0)):(u.branch(h,!1),g)}_safeCreateAndCacheServiceInstance(h,u,g){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,u,g)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,u,g){const v=new D.Graph(n=>n.id.toString());let b=0;const k=[{id:h,desc:u,_trace:g}];for(;k.length;){const n=k.pop();if(v.lookupOrInsertNode(n),b++>1e3)throw new w(v);for(const o of I._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${h} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),t instanceof R.SyncDescriptor){const i={id:o.id,desc:t,_trace:n._trace.branch(o.id,!0)};v.insertEdge(n,i),k.push(i)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:o}of n){if(this._getServiceInstanceOrDescriptor(o.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}v.removeNode(o)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,u,g=[],v,b){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(h,u,g,v,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,u,g,v,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(h,u,g=[],v,b){if(v){const k=new m(void 0,this._strict,this,this._enableTracing);k._globalGraphImplicitDependency=String(h);const n=new Map,o=new L.IdleValue(()=>{const t=k._createInstance(u,g,b);for(const[i,r]of n){const a=t[i];if(typeof a=="function")for(const s of r)a.apply(t,s)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let s=n.get(i);return s||(s=new S.LinkedList,n.set(i,s)),(p,E,T)=>{const A=s.push([p,E,T]);return(0,c.toDisposable)(A)}}if(i in t)return t[i];const r=o.value;let a=r[i];return typeof a!="function"||(a=a.bind(r),t[i]=a),a},set(t,i,r){return o.value[i]=r,!0},getPrototypeOf(t){return u.prototype}})}else return this._createInstance(u,g,b)}_throwIfStrict(h,u){if(u&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=m;var d;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(d||(d={}));class f{static traceInvocation(h,u){return h?new f(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(h,u){return h?new f(1,u.name):f._None}constructor(h,u){this.type=h,this.name=u,this._start=Date.now(),this._dep=[]}branch(h,u){const g=new f(3,h.toString());return this._dep.push([h,u,g]),g}stop(){const h=Date.now()-this._start;f._totals+=h;let u=!1;function g(b,k){const n=[],o=new Array(b+1).join("	");for(const[t,i,r]of k._dep)if(i&&r){u=!0,n.push(`${o}CREATES -> ${t}`);const a=g(b+1,r);a&&n.push(a)}else n.push(`${o}uses -> ${t}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||u)&&f.all.add(v.join(`
`))}}f.all=new Set,f._None=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f._totals=0,e.Trace=f}),define(se[211],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class L{constructor(c,R){this.server=c,this.router=R}getChannel(c){return this.server.getChannel(c,this.router)}registerChannel(c,R){this.server.registerChannel(c,R)}}e.MessagePortMainProcessService=L}),define(se[71],oe([0,1,37,55,69,5]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class D{constructor(d,f,y,h){const u=y.getChannel(d);return I(f)?h.createInstance(new _.SyncDescriptor(f.channelClientCtor,[u])):L.ProxyChannel.toService(u,f?.proxyOptions)}}function I(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let C=class extends D{constructor(d,f,y,h){super(d,f,y,h)}};C=pe([Y(2,e.IMainProcessService),Y(3,R.IInstantiationService)],C);function S(m,d,f){(0,c.registerSingleton)(m,new _.SyncDescriptor(C,[d,f],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let P=class extends D{constructor(d,f,y,h){super(d,f,y,h)}};P=pe([Y(2,e.ISharedProcessService),Y(3,R.IInstantiationService)],P);function w(m,d,f){(0,c.registerSingleton)(m,new _.SyncDescriptor(P,[d,f],!0))}e.registerSharedProcessRemoteService=w}),define(se[72],oe([0,1,24,2,4,173,29,5]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function C(P){return P.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=C,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let S=class extends _.Disposable{constructor(w){super(),this.extensionGalleryService=w}async getAvailableLanguages(){const w=new L.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const f=m.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(h=>h.startsWith("lp-"))).map(y=>{const h=y.properties.localizedLanguages?.[0],u=C(y);return{...this.createQuickPickItem(u,h,y),extensionId:y.identifier.id,galleryExtension:y}});return f.push(this.createQuickPickItem("en","English")),f}createQuickPickItem(w,m,d){const f=m??w;let y;if(f!==w&&(y=`(${w})`),w.toLowerCase()===c.language.toLowerCase()&&(y??="",y+=(0,R.localize)(0,null)),d?.installCount){y??="";const h=d.installCount;let u;h>1e6?u=`${Math.floor(h/1e5)/10}M`:h>1e3?u=`${Math.floor(h/1e3)}K`:u=String(h),y+=` $(cloud-download) ${u}`}return{id:w,label:f,description:y}}};S=pe([Y(0,D.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(se[212],oe([0,1,2,72]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let c=class extends L.Disposable{constructor(D){super(),this.localizationsService=D,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};c=pe([Y(0,_.ILanguagePackService)],c),e.LocalizationsUpdater=c}),define(se[9],oe([0,1,39,3,2,38,4,12,11,5]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function P(){return new Date().toISOString()}function w(s){return(0,I.isNumber)(s)}e.isLogLevel=w;var m;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function d(s,l,p){switch(l){case m.Trace:s.trace(p);break;case m.Debug:s.debug(p);break;case m.Info:s.info(p);break;case m.Warning:s.warn(p);break;case m.Error:s.error(p);break;case m.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=d;function f(s){let l="";for(let p=0;p<s.length;p++){let E=s[p];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}l+=(p>0?" ":"")+E}return l}e.format=f;class y extends c.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(l){this.level!==l&&(this.level=l,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(l){return this.level!==m.Off&&this.level<=l}}e.AbstractLogger=y;class h extends y{constructor(l){super(),this.logAlways=l}checkLogLevel(l){return this.logAlways||super.checkLogLevel(l)}trace(l,...p){this.checkLogLevel(m.Trace)&&this.log(m.Trace,f([l,...p]))}debug(l,...p){this.checkLogLevel(m.Debug)&&this.log(m.Debug,f([l,...p]))}info(l,...p){this.checkLogLevel(m.Info)&&this.log(m.Info,f([l,...p]))}warn(l,...p){this.checkLogLevel(m.Warning)&&this.log(m.Warning,f([l,...p]))}error(l,...p){if(this.checkLogLevel(m.Error))if(l instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=l.stack,this.log(m.Error,f(E))}else this.log(m.Error,f([l,...p]))}flush(){}}e.AbstractMessageLogger=h;class u extends y{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.useColors=!D.isWindows}trace(l,...p){this.checkLogLevel(m.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...p):console.log(`[main ${P()}]`,l,...p))}debug(l,...p){this.checkLogLevel(m.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...p):console.log(`[main ${P()}]`,l,...p))}info(l,...p){this.checkLogLevel(m.Info)&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,l,...p):console.log(`[main ${P()}]`,l,...p))}warn(l,...p){this.checkLogLevel(m.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,l,...p):console.warn(`[main ${P()}]`,l,...p))}error(l,...p){this.checkLogLevel(m.Error)&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,l,...p):console.error(`[main ${P()}]`,l,...p))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class g extends y{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...p){this.checkLogLevel(m.Trace)&&console.log("%cTRACE","color: #888",l,...p)}debug(l,...p){this.checkLogLevel(m.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...p)}info(l,...p){this.checkLogLevel(m.Info)&&console.log("%c INFO","color: #33f",l,...p)}warn(l,...p){this.checkLogLevel(m.Warning)&&console.log("%c WARN","color: #993",l,...p)}error(l,...p){this.checkLogLevel(m.Error)&&console.log("%c  ERR","color: #f33",l,...p)}dispose(){}flush(){}}e.ConsoleLogger=g;class v extends y{constructor(l,p=e.DEFAULT_LOG_LEVEL){super(),this.adapter=l,this.setLevel(p)}trace(l,...p){this.checkLogLevel(m.Trace)&&this.adapter.log(m.Trace,[this.extractMessage(l),...p])}debug(l,...p){this.checkLogLevel(m.Debug)&&this.adapter.log(m.Debug,[this.extractMessage(l),...p])}info(l,...p){this.checkLogLevel(m.Info)&&this.adapter.log(m.Info,[this.extractMessage(l),...p])}warn(l,...p){this.checkLogLevel(m.Warning)&&this.adapter.log(m.Warning,[this.extractMessage(l),...p])}error(l,...p){this.checkLogLevel(m.Error)&&this.adapter.log(m.Error,[this.extractMessage(l),...p])}extractMessage(l){return typeof l=="string"?l:(0,L.toErrorMessage)(l,this.checkLogLevel(m.Trace))}dispose(){}flush(){}}e.AdapterLogger=v;class b extends y{constructor(l){super(),this.loggers=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const p of this.loggers)p.setLevel(l);super.setLevel(l)}trace(l,...p){for(const E of this.loggers)E.trace(l,...p)}debug(l,...p){for(const E of this.loggers)E.debug(l,...p)}info(l,...p){for(const E of this.loggers)E.info(l,...p)}warn(l,...p){for(const E of this.loggers)E.warn(l,...p)}error(l,...p){for(const E of this.loggers)E.error(l,...p)}flush(){for(const l of this.loggers)l.flush()}dispose(){for(const l of this.loggers)l.dispose()}}e.MultiplexLogger=b;class k extends c.Disposable{constructor(l,p){if(super(),this.logLevel=l,this._loggers=new R.ResourceMap,this._loggerResources=new R.ResourceMap,this._onDidChangeLoggers=this._register(new _.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,p)for(const E of p)this._loggerResources.set(E.resource,E)}getLogger(l){return this._loggers.get(l)}createLogger(l,p){let E=this._loggers.get(l);const T=p?.logLevel==="always"?m.Trace:p?.logLevel;return E||(E=this.doCreateLogger(l,T??this.getLogLevel(l)??this.logLevel,p),this._loggers.set(l,E)),this.registerLogger({resource:l,id:p?.id??l.toString(),logLevel:T,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId}),E}setLogLevel(l,p){if(C.URI.isUri(l)){const E=l,T=p,A=this._loggerResources.get(E);A&&T!==A.logLevel&&(A.logLevel=T===this.logLevel?void 0:T,this._loggers.get(E)?.setLevel(T),this._loggerResources.set(A.resource,A),this._onDidChangeLogLevel.fire([E,T]))}else{this.logLevel=l;for(const[E,T]of this._loggers.entries())this._loggerResources.get(E)?.logLevel===void 0&&T.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(l,p){const E=this._loggerResources.get(l);E&&p!==!E.hidden&&(E.hidden=!p,this._loggerResources.set(E.resource,E),this._onDidChangeVisibility.fire([l,p]))}getLogLevel(l){let p;return l&&(p=this._loggerResources.get(l)?.logLevel),p??this.logLevel}registerLogger(l){const p=this._loggerResources.get(l.resource);p?p.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this._loggerResources.set(l.resource,l),this._onDidChangeLoggers.fire({added:[l],removed:[]}))}deregisterLogger(l){const p=this._loggerResources.get(l);if(p){this._loggerResources.delete(l);const E=this._loggers.get(l);E&&(this._loggers.delete(l),E.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[p]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(l){return this._loggerResources.get(l)}dispose(){this._loggers.forEach(l=>l.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=k;class n{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(l){}getLevel(){return m.Info}trace(l,...p){}debug(l,...p){}info(l,...p){}warn(l,...p){}error(l,...p){}critical(l,...p){}dispose(){}flush(){}}e.NullLogger=n;class o extends n{}e.NullLogService=o;class t extends k{constructor(){super(m.Info)}doCreateLogger(l,p,E){return new n}}e.NullLoggerService=t;function i(s){if(s.verbose)return m.Trace;if(typeof s.logLevel=="string"){const l=a(s.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function r(s){switch(s){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function a(s){switch(s){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=a}),define(se[213],oe([0,1,6,7,2,13,28,15,9]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends c.Disposable{constructor(w,m){super(),this.environmentService=w,this.logService=m,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,R.basename)(this.environmentService.logsPath),m=(0,R.dirname)(this.environmentService.logsPath),y=(await D.Promises.readdir(m)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==w),h=y.slice(0,Math.max(0,y.length-9));h.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(u=>D.Promises.rm((0,R.join)(m,u)))))}catch(w){(0,_.onUnexpectedError)(w)}}};S=pe([Y(0,I.IEnvironmentService),Y(1,C.ILogService)],S),e.LogsDataCleaner=S}),define(se[214],oe([0,1,19,6,7,3,2,13,56,9]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends D.Disposable{constructor(m,d){super(),this.logService=m,this.options=d,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new _.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new _.ThrottledDelayer(0))}watch(m,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,d):this.watchNonRecursive(m,d)}watchUniversal(m,d){const f={path:this.toFilePath(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive},y=(0,L.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,c.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,C.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(d)&&m.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,d){const f={path:this.toFilePath(m),excludes:d.excludes,includes:d.includes,recursive:!1},y=(0,L.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,c.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,C.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(se[215],oe([0,1,19,6,16,24,3,65,63,2,49,22,105,25,43,169,14,104,9,7]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class extends S.Disposable{constructor(n){super(),this.logService=n,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new _.ResourceQueue)}registerProvider(n,o){if(this.provider.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${n}`);const t=new S.DisposableStore;return this.provider.set(n,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:n,provider:o}),t.add(o.onDidChangeFile(i=>this._onDidFilesChange.fire(new h.FileChangesEvent(i,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&t.add(o.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),t.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:n}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:n,provider:o}),this.provider.delete(n),(0,S.dispose)(t)})}getProvider(n){return this.provider.get(n)}async activateProvider(n){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:n,join(t){o.push(t)}}),!this.provider.has(n)&&await _.Promises.settled(o)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.provider.has(n.scheme)}hasCapability(n,o){const t=this.provider.get(n.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return C.Iterable.map(this.provider,([n,o])=>({scheme:n,capabilities:o.capabilities}))}async withProvider(n){if(!(0,d.isAbsolutePath)(n))throw new h.FileOperationError((0,y.localize)(0,null,this.resourceForError(n)),8);await this.activateProvider(n.scheme);const o=this.provider.get(n.scheme);if(!o){const t=new v.ErrorNoTelemetry;throw t.message=(0,y.localize)(1,null,n.toString()),t}return o}async withReadProvider(n){const o=await this.withProvider(n);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o)||(0,h.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(n){const o=await this.withProvider(n);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,o){try{return await this.doResolveFile(n,o)}catch(t){throw(0,h.toFileSystemProviderErrorCode)(t)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,y.localize)(2,null,this.resourceForError(n)),1):(0,h.ensureFileSystemProviderError)(t)}}async doResolveFile(n,o){const t=await this.withProvider(n),i=this.isPathCaseSensitive(t),r=o?.resolveTo,a=o?.resolveSingleChildDescendants,s=o?.resolveMetadata,l=await t.stat(n);let p;return this.toFileStat(t,n,l,void 0,!!s,(E,T)=>(p||(p=P.TernarySearchTree.forUris(()=>!i),p.set(n,!0),r&&p.fill(!0,r)),p.get(E.resource)||p.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&a?T===1:!1))}async toFileStat(n,o,t,i,r,a){const{providerExtUri:s}=this.getExtUri(n),l={resource:o,name:s.basename(o),isFile:(t.type&h.FileType.File)!==0,isDirectory:(t.type&h.FileType.Directory)!==0,isSymbolicLink:(t.type&h.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&h.FilePermission.Readonly)||Boolean(n.capabilities&2048),etag:(0,h.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(l.isDirectory&&a(l,i)){try{const p=await n.readdir(o),E=await _.Promises.settled(p.map(async([T,A])=>{try{const N=s.joinPath(o,T),W=r?await n.stat(N):{type:A};return await this.toFileStat(n,N,W,p.length,r,a)}catch(N){return this.logService.trace(N),null}}));l.children=(0,L.coalesce)(E)}catch(p){this.logService.trace(p),l.children=[]}return l}return l}async resolveAll(n){return _.Promises.settled(n.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const o=await this.withProvider(n),t=await o.stat(n);return this.toFileStat(o,n,t,void 0,!0,()=>!1)}async exists(n){const o=await this.withProvider(n);try{return!!await o.stat(n)}catch{return!1}}async canCreateFile(n,o){try{await this.doValidateCreateFile(n,o)}catch(t){return t}return!0}async doValidateCreateFile(n,o){if(!o?.overwrite&&await this.exists(n))throw new h.FileOperationError((0,y.localize)(3,null,this.resourceForError(n)),3,o)}async createFile(n,o=c.VSBuffer.fromString(""),t){await this.doValidateCreateFile(n,t);const i=await this.writeFile(n,o);return this._onDidRunOperation.fire(new h.FileOperationEvent(n,0,i)),i}async writeFile(n,o,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,n,t)||await this.mkdirp(i,r.dirname(n));let s;if((0,h.hasReadWriteCapability)(i)&&!(o instanceof c.VSBuffer))if((0,f.isReadableStream)(o)){const l=await(0,f.peekStream)(o,3);l.ended?s=c.VSBuffer.concat(l.buffer):s=l}else s=(0,f.peekReadable)(o,l=>c.VSBuffer.concat(l),3);else s=o;!(0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasReadWriteCapability)(i)&&s instanceof c.VSBuffer?await this.doWriteUnbuffered(i,n,t,s):await this.doWriteBuffered(i,n,t,s instanceof c.VSBuffer?(0,c.bufferToReadable)(s):s),this._onDidRunOperation.fire(new h.FileOperationEvent(n,4))}catch(a){throw new h.FileOperationError((0,y.localize)(4,null,this.resourceForError(n),(0,h.ensureFileSystemProviderError)(a).toString()),(0,h.toFileOperationResult)(a),t)}return this.resolve(n,{resolveMetadata:!0})}async validateWriteFile(n,o,t){if(!!t?.unlock&&!(n.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(o)));let r;try{r=await n.stat(o)}catch{return}if((r.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,y.localize)(6,null,this.resourceForError(o)),0,t);if(this.throwIfFileIsReadonly(o,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==h.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,h.etag)({mtime:t.mtime,size:r.size}))throw new h.FileOperationError((0,y.localize)(7,null),3,t);return r}async readFile(n,o,t){const i=await this.withReadProvider(n);return o?.atomic?this.doReadFileAtomic(i,n,o,t):this.doReadFile(i,n,o,t)}async doReadFileAtomic(n,o,t,i){return new Promise((r,a)=>{this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(n,o,t,i);r(s)}catch(s){a(s)}})})}async doReadFile(n,o,t,i){const r=await this.doReadFileStream(n,o,{...t,preferUnbuffered:!0},i);return{...r,value:await(0,c.streamToBuffer)(r.value)}}async readFileStream(n,o,t){const i=await this.withReadProvider(n);return this.doReadFileStream(i,n,o,t)}async doReadFileStream(n,o,t,i){const r=new R.CancellationTokenSource(i),a=this.validateReadFile(o,t).then(l=>l,l=>{throw r.cancel(),l});let s;try{return typeof t?.etag=="string"&&t.etag!==h.ETAG_DISABLED&&await a,t?.atomic&&(0,h.hasFileAtomicReadCapability)(n)||!((0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasFileReadStreamCapability)(n))||(0,h.hasReadWriteCapability)(n)&&t?.preferUnbuffered?s=this.readFileUnbuffered(n,o,t):(0,h.hasFileReadStreamCapability)(n)?s=this.readFileStreamed(n,o,r.token,t):s=this.readFileBuffered(n,o,r.token,t),{...await a,value:s}}catch(l){throw s&&await(0,f.consumeStream)(s),this.restoreReadError(l,o,t)}}restoreReadError(n,o,t){const i=(0,y.localize)(8,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(n).toString());return n instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(i,n.stat,t):n instanceof h.TooLargeFileOperationError?new h.TooLargeFileOperationError(i,n.fileOperationResult,n.size,n.options):new h.FileOperationError(i,(0,h.toFileOperationResult)(n),t)}readFileStreamed(n,o,t,i=Object.create(null)){const r=n.readFileStream(o,i,t);return(0,f.transform)(r,{data:a=>a instanceof c.VSBuffer?a:c.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,o,i)},a=>c.VSBuffer.concat(a))}readFileBuffered(n,o,t,i=Object.create(null)){const r=(0,c.newWriteableBufferStream)();return(0,u.readFileIntoStream)(n,o,r,a=>a,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,o,i)},t),r}readFileUnbuffered(n,o,t){const i=(0,f.newWriteableStream)(r=>c.VSBuffer.concat(r));return(async()=>{try{let r;t?.atomic&&(0,h.hasFileAtomicReadCapability)(n)?r=await n.readFile(o,{atomic:!0}):r=await n.readFile(o),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(o,r.byteLength,t),i.end(c.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(n,o){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new h.FileOperationError((0,y.localize)(9,null,this.resourceForError(n)),0,o);if(typeof o?.etag=="string"&&o.etag!==h.ETAG_DISABLED&&o.etag===t.etag)throw new h.NotModifiedSinceFileOperationError((0,y.localize)(10,null),t,o);return this.validateReadFileLimits(n,t.size,o),t}validateReadFileLimits(n,o,t){if(t?.limits){let i;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&o>t.limits.size&&(i=7),typeof i=="number")throw new h.TooLargeFileOperationError((0,y.localize)(11,null,this.resourceForError(n)),i,o,t)}}async canMove(n,o,t){return this.doCanMoveCopy(n,o,"move",t)}async canCopy(n,o,t){return this.doCanMoveCopy(n,o,"copy",t)}async doCanMoveCopy(n,o,t,i){if(n.toString()!==o.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n):await this.withReadProvider(n),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(r,n,a,o,t,i)}catch(r){return r}return!0}async move(n,o,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(i,n,r,o,"move",!!t),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(n,a==="move"?2:3,s)),s}async copy(n,o,t){const i=await this.withReadProvider(n),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(i,n,r,o,"copy",!!t),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(n,a==="copy"?3:2,s)),s}async doMoveCopy(n,o,t,i,r,a){if(o.toString()===i.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(n,o,t,i,r,a);if(s&&!l&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),r==="copy"){if(n===t&&(0,h.hasFileFolderCopyCapability)(n))await n.copy(o,i,{overwrite:a});else{const p=await this.resolve(o);p.isDirectory?await this.doCopyFolder(n,p,t,i):await this.doCopyFile(n,o,t,i)}return r}else return n===t?(await n.rename(o,i,{overwrite:a}),r):(await this.doMoveCopy(n,o,t,i,"copy",a),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(n,o,t,i){if((0,h.hasOpenReadWriteCloseCapability)(n)&&(0,h.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(n,o,t,i);if((0,h.hasOpenReadWriteCloseCapability)(n)&&(0,h.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(n,o,t,i);if((0,h.hasReadWriteCapability)(n)&&(0,h.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(n,o,t,i);if((0,h.hasReadWriteCapability)(n)&&(0,h.hasReadWriteCapability)(t))return this.doPipeUnbuffered(n,o,t,i)}async doCopyFolder(n,o,t,i){await t.mkdir(i),Array.isArray(o.children)&&await _.Promises.settled(o.children.map(async r=>{const a=this.getExtUri(t).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(n,await this.resolve(r.resource),t,a):this.doCopyFile(n,r.resource,t,a)}))}async doValidateMoveCopy(n,o,t,i,r,a){let s=!1;if(n===t){const{providerExtUri:p,isPathCaseSensitive:E}=this.getExtUri(n);if(E||(s=p.isEqual(o,i)),s&&r==="copy")throw new Error((0,y.localize)(12,null,this.resourceForError(o),this.resourceForError(i)));if(!s&&p.isEqualOrParent(i,o))throw new Error((0,y.localize)(13,null,this.resourceForError(o),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!s){if(!a)throw new h.FileOperationError((0,y.localize)(14,null,this.resourceForError(o),this.resourceForError(i)),4);if(n===t){const{providerExtUri:p}=this.getExtUri(n);if(p.isEqualOrParent(o,i))throw new Error((0,y.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:s}}getExtUri(n){const o=this.isPathCaseSensitive(n);return{providerExtUri:o?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(n){return!!(n.capabilities&1024)}async createFolder(n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n);await this.mkdirp(o,n);const t=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(n,0,t)),t}async mkdirp(n,o){const t=[],{providerExtUri:i}=this.getExtUri(n);for(;!i.isEqual(o,i.dirname(o));)try{if(((await n.stat(o)).type&h.FileType.Directory)===0)throw new Error((0,y.localize)(16,null,this.resourceForError(o)));break}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(i.basename(o)),o=i.dirname(o)}for(let r=t.length-1;r>=0;r--){o=i.joinPath(o,t[r]);try{await n.mkdir(o)}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(n,o){try{await this.doValidateDelete(n,o)}catch(t){return t}return!0}async doValidateDelete(n,o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,y.localize)(17,null,this.resourceForError(n)));let r;try{r=await t.stat(n)}catch{}if(r)this.throwIfFileIsReadonly(n,r);else throw new h.FileOperationError((0,y.localize)(18,null,this.resourceForError(n)),1);if(!!!o?.recursive){const s=await this.resolve(n);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,y.localize)(19,null,this.resourceForError(n)))}return t}async del(n,o){const t=await this.doValidateDelete(n,o),i=!!o?.useTrash,r=!!o?.recursive;await t.delete(n,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new h.FileOperationEvent(n,1))}async cloneFile(n,o){const t=await this.withProvider(n),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(t===i&&this.getExtUri(t).providerExtUri.isEqual(n,o))return;if(t===i&&(0,h.hasFileCloneCapability)(t))return t.cloneFile(n,o);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(o));const r=this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri);return t===i&&(0,h.hasFileFolderCopyCapability)(t)?r.queue(()=>t.copy(n,o,{overwrite:!0})):r.queue(()=>this.doCopyFile(t,n,i,o))}watch(n,o={recursive:!1,excludes:[]}){const t=new S.DisposableStore;let i=!1,r=()=>{i=!0};return t.add((0,S.toDisposable)(()=>r())),(async()=>{try{const a=await this.doWatch(n,o);i?(0,S.dispose)(a):r=()=>(0,S.dispose)(a)}catch(a){this.logService.error(a)}})(),t}async doWatch(n,o){const t=await this.withProvider(n),i=(0,I.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(n),o]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:t.watch(n,o)},this.activeWatchers.set(i,r)),r.count+=1,(0,S.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,n]of this.activeWatchers)(0,S.dispose)(n.disposable);this.activeWatchers.clear()}async doWriteBuffered(n,o,t,i){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(async()=>{const r=await n.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,f.isReadableStream)(i)||(0,f.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(n,r,i):await this.doWriteReadableBufferedQueued(n,r,i)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await n.close(r)}})}async doWriteStreamBufferedQueued(n,o,t){let i=0,r;if((0,f.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=c.VSBuffer.concat(t.buffer);await this.doWriteBuffer(n,o,a,a.byteLength,i,0),i+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((a,s)=>{(0,f.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(n,o,l,l.byteLength,i,0)}catch(p){return s(p)}i+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>s(l),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(n,o,t){let i=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(n,o,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(n,o,t,i,r,a){let s=0;for(;s<i;)s+=await n.write(o,r+s,t.buffer,a+s,i-s)}async doWriteUnbuffered(n,o,t,i){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(n,o,t,i))}async doWriteUnbufferedQueued(n,o,t,i){let r;i instanceof c.VSBuffer?r=i:(0,f.isReadableStream)(i)?r=await(0,c.streamToBuffer)(i):(0,f.isReadableBufferedStream)(i)?r=await(0,c.bufferedStreamToBuffer)(i):r=(0,c.readableToBuffer)(i),await n.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(n,o,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(n,o,t,i))}async doPipeBufferedQueued(n,o,t,i){let r,a;try{r=await n.open(o,{create:!1}),a=await t.open(i,{create:!0,unlock:!1});const s=c.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,p=0,E=0;do E=await n.read(r,l,s.buffer,p,s.byteLength-p),await this.doWriteBuffer(t,a,s,E,l,p),l+=E,p+=E,p===s.byteLength&&(p=0);while(E>0)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await _.Promises.settled([typeof r=="number"?n.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(n,o,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(n,o,t,i))}async doPipeUnbufferedQueued(n,o,t,i){return t.writeFile(i,await n.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(n,o,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(n,o,t,i))}async doPipeUnbufferedToBufferedQueued(n,o,t,i){const r=await t.open(i,{create:!0,unlock:!1});try{const a=await n.readFile(o);await this.doWriteBuffer(t,r,c.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(n,o,t,i){const r=await(0,c.streamToBuffer)(this.readFileBuffered(n,o,R.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,r)}throwIfFileSystemIsReadonly(n,o){if(n.capabilities&2048)throw new h.FileOperationError((0,y.localize)(20,null,this.resourceForError(o)),6);return n}throwIfFileIsReadonly(n,o){if((o.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,y.localize)(21,null,this.resourceForError(n)),6)}resourceForError(n){return n.scheme===w.Schemas.file?n.fsPath:n.toString(!0)}};b=pe([Y(0,g.ILogService)],b),e.FileService=b}),define(se[216],oe([0,1,53,299,6,38,16,3,48,2,13,4,25,43,28,172,14,104,214,39,209,208]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,_.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(o)}`)}})();class n extends g.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new R.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:r}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(t){try{const i=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async a=>{try{let s;a.isSymbolicLink()?s=(await this.stat((0,m.joinPath)(t,a.name))).type:s=this.toType(a),r.push([a.name,s])}catch(s){this.logService.trace(s)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let r;return i?.dangling?r=h.FileType.Unknown:t.isFile()?r=h.FileType.File:t.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,i&&(r|=h.FileType.SymbolicLink),r}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const a=new c.Barrier;return this.resourceLocks.set(t,a),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===a&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(t,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const a=this.toFilePath(t);return await f.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,r){const a=(0,d.newWriteableStream)(s=>D.VSBuffer.concat(s.map(l=>D.VSBuffer.wrap(l))).buffer);return(0,u.readFileIntoStream)(this,t,a,s=>s.buffer,{...i,bufferSize:256*1024},r),a}async writeFile(t,i,r){let a;try{const s=this.toFilePath(t);if(!r.create||!r.overwrite){if(await f.Promises.exists(s)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,y.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,y.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:r.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(t,s)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,i){const r=this.toFilePath(t);let a;(0,h.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(t));let s;try{if((0,h.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:p}=await f.SymlinkSupport.stat(r);p.mode&128||await f.Promises.chmod(r,p.mode|128)}catch(p){this.logService.trace(p)}let l;if((0,h.isFileOpenForWriteOptions)(i)){if(w.isWindows)try{await f.Promises.truncate(r,0),l="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}l||(l="w")}else l="r";s=await f.Promises.open(r,l)}catch(l){throw a?.dispose(),(0,h.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(s,0),(0,h.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(s,t),a){const l=this.mapHandleToLock.get(s);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.mapHandleToLock.set(s,a),l&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),l.dispose())}return s}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await f.Promises.fdatasync(t)}catch(r){n.configureFlushOnWrite(!1),this.logService.error(r)}return await f.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,r,a,s){const l=this.normalizePos(t,i);let p=null;try{p=(await f.Promises.read(t,r,a,s,l)).bytesRead}catch(E){throw this.toFileSystemProviderError(E)}finally{this.updatePos(t,l,p)}return p}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,r){const a=this.mapHandleToPos.get(t);typeof a=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,a+r):this.mapHandleToPos.delete(t)))}async write(t,i,r,a,s){return(0,c.retry)(()=>this.doWrite(t,i,r,a,s),100,3)}async doWrite(t,i,r,a,s){const l=this.normalizePos(t,i);let p=null;try{p=(await f.Promises.write(t,r,a,s,l)).bytesWritten}catch(E){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),E)}finally{this.updatePos(t,l,p)}return p}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const r=this.toFilePath(t);i.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,i,r){const a=this.toFilePath(t),s=this.toFilePath(i);if(a!==s)try{await this.validateTargetDeleted(t,i,"move",r.overwrite),await f.Promises.move(a,s)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,y.localize)(2,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(s)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(t,i,r){const a=this.toFilePath(t),s=this.toFilePath(i);if(a!==s)try{await this.validateTargetDeleted(t,i,"copy",r.overwrite),await f.Promises.copy(a,s,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,y.localize)(3,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(s)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(t,i,r,a){const s=this.toFilePath(t),l=this.toFilePath(i);let p=!1;if(!!(this.capabilities&1024)||(p=(0,C.isEqual)(s,l,!0)),p&&r==="copy")throw(0,h.createFileSystemProviderError)((0,y.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!p&&await f.Promises.exists(l)){if(!a)throw(0,h.createFileSystemProviderError)((0,y.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,r){const a=this.toFilePath(t),s=this.toFilePath(i),l=!!(this.capabilities&1024);if((0,C.isEqual)(a,s,!l))return;const p=new S.DisposableStore;try{const[E,T]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);p.add(E),p.add(T),r&&await f.Promises.mkdir((0,P.dirname)(s),{recursive:!0}),await f.Promises.copyFile(a,s)}catch(E){if(E.code==="ENOENT"&&!r)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(E)}finally{p.dispose()}}createUniversalWatcher(t,i,r){return new b.UniversalWatcherClient(a=>t(a),a=>i(a),r)}createNonRecursiveWatcher(t,i,r){return new k.NodeJSWatcherClient(a=>t(a),a=>i(a),r)}toFileSystemProviderError(t){if(t instanceof h.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=h.FileSystemProviderErrorCode.NoPermissions;break;default:i=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(t,i)}async toFileSystemProviderWriteError(t,i){let r=this.toFileSystemProviderError(i);if(t&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await f.SymlinkSupport.stat(this.toFilePath(t));a.mode&128||(r=(0,h.createFileSystemProviderError)(i,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0,e.DiskFileSystemProvider=n}),define(se[106],oe([0,1,3,2,5,9]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,c.createDecorator)("sharedProcessLifecycleService");let D=class extends _.Disposable{constructor(C){super(),this.logService=C,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};D=pe([Y(0,R.ILogService)],D),e.SharedProcessLifecycleService=D}),define(se[107],oe([0,1,11,3,9,2]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class D extends c.AbstractLoggerService{constructor(w,m,d,f){super(m,d),this.windowId=w,this.channel=f,this._register(f.listen("onDidChangeLogLevel",w)(y=>{(0,c.isLogLevel)(y)?super.setLogLevel(y):super.setLogLevel(L.URI.revive(y[0]),y[1])})),this._register(f.listen("onDidChangeVisibility",w)(([y,h])=>super.setVisibility(L.URI.revive(y),h))),this._register(f.listen("onDidChangeLoggers",w)(({added:y,removed:h})=>{for(const u of y)super.registerLogger({...u,resource:L.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new c.AdapterLogger({log:(w,m)=>{this.channel.call("consoleLog",[w,m])}})}registerLogger(w){super.registerLogger(w),this.channel.call("registerLogger",[w,this.windowId])}deregisterLogger(w){super.deregisterLogger(w),this.channel.call("deregisterLogger",[w,this.windowId])}setLogLevel(w,m){super.setLogLevel(w,m),this.channel.call("setLogLevel",[w,m])}setVisibility(w,m){super.setVisibility(w,m),this.channel.call("setVisibility",[w,m])}doCreateLogger(w,m,d){return new I(this.channel,w,m,d,this.windowId)}static setLogLevel(w,m,d){return w.call("setLogLevel",[m,d])}}e.LoggerChannelClient=D;class I extends c.AbstractMessageLogger{constructor(w,m,d,f,y){super(f?.logLevel==="always"),this.channel=w,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[m,f,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,m){const d=[[w,m]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(w){this.channel.call("log",[this.file,w])}}class C{constructor(w,m){this.loggerService=w,this.getUriTransformer=m}listen(w,m){const d=this.getUriTransformer(w);switch(m){case"onDidChangeLoggers":return _.Event.map(this.loggerService.onDidChangeLoggers,f=>({added:[...f.added].map(y=>this.transformLogger(y,d)),removed:[...f.removed].map(y=>this.transformLogger(y,d))}));case"onDidChangeVisibility":return _.Event.map(this.loggerService.onDidChangeVisibility,f=>[d.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return _.Event.map(this.loggerService.onDidChangeLogLevel,f=>(0,c.isLogLevel)(f)?f:[d.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${m}`)}async call(w,m,d){const f=this.getUriTransformer(w);switch(m){case"setLogLevel":return(0,c.isLogLevel)(d[0])?this.loggerService.setLogLevel(d[0]):this.loggerService.setLogLevel(L.URI.revive(f.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,f)))}throw new Error(`Call not found: ${m}`)}transformLogger(w,m){return{...w,resource:m.transformOutgoingURI(w.resource)}}}e.LoggerChannel=C;class S extends R.Disposable{constructor(w,m){super(),m.call("setLogLevel",[w.getLogLevel()]),this._register(w.onDidChangeLogLevel(d=>m.call("setLogLevel",[d]))),m.call("getRegisteredLoggers").then(d=>{for(const f of d)w.registerLogger({...f,resource:L.URI.revive(f.resource)})}),this._register(m.listen("onDidChangeVisibility")(([d,f])=>w.setVisibility(L.URI.revive(d),f))),this._register(m.listen("onDidChangeLoggers")(({added:d,removed:f})=>{for(const y of d)w.registerLogger({...y,resource:L.URI.revive(y.resource)});for(const y of f)w.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=S}),define(se[217],oe([0,1,2,9]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class c extends L.Disposable{constructor(D,I=[]){super(),this.logger=new _.MultiplexLogger([D,...I]),this._register(D.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(D){this.logger.setLevel(D)}getLevel(){return this.logger.getLevel()}trace(D,...I){this.logger.trace(D,...I)}debug(D,...I){this.logger.debug(D,...I)}info(D,...I){this.logger.info(D,...I)}warn(D,...I){this.logger.warn(D,...I)}error(D,...I){this.logger.error(D,...I)}flush(){this.logger.flush()}}e.LogService=c}),define(se[57],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(se[58],oe([0,1,3,63,2,5]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends c.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(S){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...S,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(S),_.Iterable.reduce(this.policies.entries(),(w,[m,d])=>({...w,[m]:d}),{})}getPolicyValue(S){return this.policies.get(S)}serialize(){return _.Iterable.reduce(Object.entries(this.policyDefinitions),(S,[P,w])=>({...S,[P]:{definition:w,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=D;class I{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(se[218],oe([0,1,3,2,58]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(C){this.service=C,this.disposables=new _.DisposableStore}listen(C,S){switch(S){case"onDidChange":return L.Event.map(this.service.onDidChange,P=>P.reduce((w,m)=>({...w,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${S}`)}call(C,S,P){switch(S){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${S}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends c.AbstractPolicyService{constructor(C,S){super(),this.channel=S;for(const P in C){const{definition:w,value:m}=C[P];this.policyDefinitions[P]=w,m!==void 0&&this.policies.set(P,m)}this.channel.listen("onDidChange")(P=>{for(const w in P){const m=P[w];m===null?this.policies.delete(w):this.policies.set(w,m)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(C){const S=await this.channel.call("updatePolicyDefinitions",C);for(const P in S)this.policies.set(P,S[P])}}e.PolicyChannelClient=D}),define(se[108],oe([0,1,22,4,36,97]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof _.globals.vscode<"u"&&typeof _.globals.vscode.context<"u"){const I=_.globals.vscode.context.configuration();if(I)D=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){D=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:I,searchUrl:C,itemUrl:S,controlUrl:P}=D.extensionsGallery||{};Object.assign(D,{extensionsGallery:{serviceUrl:c.env.VSCODE_GALLERY_SERVICE_URL||I,searchUrl:c.env.VSCODE_GALLERY_SEARCH_URL||C,itemUrl:c.env.VSCODE_GALLERY_ITEM_URL||S,controlUrl:c.env.VSCODE_GALLERY_CONTROL_URL||P}});try{const w=(...y)=>y.reduce((h,u)=>(Object.keys(u).forEach(g=>{Array.isArray(h[g])&&Array.isArray(u[g])?h[g]=u[g]:typeof h[g]=="object"&&typeof u[g]=="object"?h[g]=w(h[g],u[g]):h[g]=u[g]}),h),{}),m=(0,R.getUserDataPath)({},D.nameShort),d=_.isWindows?`file:///${m}/product.json`:`file://${m}/product.json`,f=ee.__$__nodeRequire(L.FileAccess.asFileUri(d).fsPath);D=w(D,f)}catch{}if(c.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const w=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:w.version,release:w.release})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(se[26],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(se[219],oe([0,1,6,7,2,13,28,9,26]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends c.Disposable{constructor(w,m,d){super(),this.productService=m,this.logService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},3e4)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),d=(0,R.dirname)(w),f=(0,R.basename)(w),y=await D.Promises.readdir(d);await Promise.all(y.map(async h=>{if(h===f)return;const u=(0,R.join)(d,h),g=await D.Promises.stat(u);if(g.isDirectory()&&m-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${h}.`),D.Promises.rm(u)}))}catch(m){(0,_.onUnexpectedError)(m)}}};S=pe([Y(1,C.IProductService),Y(2,I.ILogService)],S),e.CodeCacheCleaner=S}),define(se[220],oe([0,1,6,7,2,13,28,15,9,26]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends c.Disposable{constructor(m,d,f){super(),this.environmentService=m,this.logService=d,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),d=JSON.parse(await D.Promises.readFile((0,R.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(d)){const v=d[g];m[`${v.hash}.${g}`]=!0}const f=(0,R.join)(this.environmentService.userDataPath,"clp");if(!await D.Promises.exists(f))return;const h=await D.Promises.readdir(f);for(const g of h){if(m[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await D.Promises.rm((0,R.join)(f,g))}const u=Date.now();for(const g of Object.keys(m)){const v=(0,R.join)(f,g),b=await D.Promises.readdir(v);for(const k of b){if(k==="tcf.json")continue;const n=(0,R.join)(v,k),o=await D.Promises.stat(n);o.isDirectory()&&u-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,R.join)(g,k)}`),await D.Promises.rm(n))}}}catch(m){(0,_.onUnexpectedError)(m)}}};P=pe([Y(0,I.INativeEnvironmentService),Y(1,C.ILogService),Y(2,S.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(se[221],oe([0,1,19,2,25,196,14,26]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends _.Disposable{constructor(P,w){super(),this.fileService=P,this.productService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,m])=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(P){return this.getValidConfigBasedTips(P)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(P){const w=[];for(const[m,d]of this.allConfigBasedTips)if(!(d.configScheme&&d.configScheme!==P.scheme))try{const f=await this.fileService.readFile((0,c.joinPath)(P,m)),y=new Map;Object.entries(d.recommendations).forEach(([u,g])=>{if((0,L.isNonEmptyArray)(g.remotes))for(const v of g.remotes)y.set(v,{extensionId:u,extensionName:g.name,configName:d.configName,important:!!g.important,isExtensionPack:!!g.isExtensionPack,whenNotInstalled:g.whenNotInstalled});else w.push({extensionId:u,extensionName:g.name,configName:d.configName,important:!!g.important,isExtensionPack:!!g.isExtensionPack,whenNotInstalled:g.whenNotInstalled})});const h=(0,R.getDomainsOfRemotes)(f.value.toString(),[...y.keys()]);for(const u of h){const g=y.get(u);g&&w.push(g)}}catch{}return w}};C=pe([Y(0,D.IFileService),Y(1,I.IProductService)],C),e.ExtensionTipsService=C}),define(se[222],oe([0,1,13,5]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,_.createDecorator)("IV8InspectProfilingService");var c;(function(R){function D(C){return Boolean(C.samples&&C.timeDeltas)}R.isValidProfile=D;function I(C,S="noAbsolutePaths"){for(const P of C.nodes)P.callFrame&&P.callFrame.url&&((0,L.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,L.join)(S,(0,L.basename)(P.callFrame.url)));return C}R.rewriteAbsolutePaths=I})(c=e.Utils||(e.Utils={}))}),define(se[223],oe([0,1,31]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class _{constructor(){this._sessions=new Map}async startProfiling(R){const I=await(await new Promise((S,P)=>{ee(["v8-inspect-profiler"],S,P)})).startProfiling({port:R.port,checkForPaused:!0}),C=(0,L.generateUuid)();return this._sessions.set(C,I),C}async stopProfiling(R){const D=this._sessions.get(R);if(!D)throw new Error(`UNKNOWN session '${R}'`);const I=await D.stop();return this._sessions.delete(R),I.profile}}e.InspectProfilingService=_}),define(se[40],oe([0,1,130,12]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class c{constructor(){this.data=new Map}add(D,I){L.ok(_.isString(D)),L.ok(_.isObject(I)),L.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,I)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new c}),define(se[109],oe([0,1,3,40]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function c(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,S){this.schemasById[c(C)]=S,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;_.Registry.add(e.Extensions.JSONContribution,D)}),define(se[45],oe([0,1,19,3,12,158,17,109,40]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=C.Registry.as(I.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new _.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new _.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const t=new Set;this.doRegisterConfigurations(n,o,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const o=new Set;this.doDeregisterConfigurations(n,o),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const t=new Set;this.doDeregisterConfigurations(o,t),this.doRegisterConfigurations(n,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(n){const o=new Set;this.doRegisterDefaultConfigurations(n,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,o){const t=[];for(const{overrides:i,source:r}of n)for(const a in i)if(o.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const s=this.configurationDefaultsOverrides.get(a),l=s?.valuesSources??new Map;if(r)for(const A of Object.keys(i[a]))l.set(A,r);const p={...s?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:r,value:p,valuesSources:l});const E=(0,D.getLanguageTagSettingPlainKey)(a),T={type:"object",default:p,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:c.isString(r)?void 0:r,defaultValueSource:r};t.push(...y(a)),this.configurationProperties[a]=T,this.defaultLanguageConfigurationOverridesNode.properties[a]=T}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:r});const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(n){const o=new Set;this.doDeregisterDefaultConfigurations(n,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,o){for(const{overrides:t,source:i}of n)for(const r in t){const a=this.configurationDefaultsOverrides.get(r),s=c.isString(i)?i:i?.id,l=c.isString(a?.source)?a?.source:a?.source?.id;if(s===l)if(o.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const p=this.configurationProperties[r];p&&(this.updatePropertyDefaultValue(r,p),this.updateSchema(r,p))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let o=!1;const t=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,t),o=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,t),o=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,t),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o,t){n.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(n,o){const t=i=>{if(i.properties)for(const r in i.properties){o.add(r);const a=this.configurationProperties[r];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>t(r))};for(const i of n){t(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(n,o=!0,t,i,r=3,a){r=c.isUndefinedOrNull(n.scope)?r:n.scope;const s=n.properties;if(s)for(const p in s){const E=s[p];if(o&&v(p,E)){delete s[p];continue}if(E.source=t,E.defaultDefaultValue=s[p].default,this.updatePropertyDefaultValue(p,E),e.OVERRIDE_PROPERTY_REGEX.test(p)?E.scope=void 0:(E.scope=c.isUndefinedOrNull(E.scope)?r:E.scope,E.restricted=c.isUndefinedOrNull(E.restricted)?!!i?.includes(p):E.restricted),s[p].hasOwnProperty("included")&&!s[p].included){this.excludedConfigurationProperties[p]=s[p],delete s[p];continue}else this.configurationProperties[p]=s[p],s[p].policy?.name&&this.policyConfigurations.set(s[p].policy.name,p);!s[p].deprecationMessage&&s[p].markdownDeprecationMessage&&(s[p].deprecationMessage=s[p].markdownDeprecationMessage),a.add(p)}const l=n.allOf;if(l)for(const p of l)this.validateAndRegisterProperties(p,o,t,i,r,a)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=t=>{const i=t.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);t.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,t={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const t=this.configurationDefaultsOverrides.get(n);let i=t?.value,r=t?.source;c.isUndefined(i)&&(i=o.defaultDefaultValue,r=void 0),c.isUndefined(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=r}}const d="\\[([^\\]]+)\\]",f=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(k){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let o=f.exec(k);for(;o?.length;){const t=o[1].trim();t&&n.push(t),o=f.exec(k)}}return(0,L.distinct)(n)}e.overrideIdentifiersFromKey=y;function h(k){return k.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=h;function u(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new m;C.Registry.add(e.Extensions.Configuration,g);function v(k,n){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?R.localize(7,null,k):g.getConfigurationProperties()[k]!==void 0?R.localize(8,null,k):n.policy?.name&&g.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,k,n.policy?.name,g.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=v;function b(){const k=[],n=g.getConfigurationProperties();for(const o of Object.keys(n))k.push([o,n[o].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=b}),define(se[73],oe([0,1,19,3,35,2,38,32,12,11,17,45,40]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(o){return Object.isFrozen(o)?o:I.deepFreeze(o)}class f{constructor(t={},i=[],r=[],a){this._contents=t,this._keys=i,this._overrides=r,this.raw=a,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof f)return i;const r=new y("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=t.reduce((i,r)=>r===i?r:i.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const r=this.rawConfiguration.getValue(t),a=i?this.rawConfiguration.getOverrideValue(t,i):void 0,s=i?this.rawConfiguration.override(i).getValue(t):r;return{value:r,override:a,merged:s}}getOverrideValue(t,i){const r=this.getContentsForOverrideIdentifer(i);return r?t?(0,P.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const r of this.overrides)r.identifiers.includes(t)&&i.push(...r.keys);return L.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.distinct(t)}override(t){let i=this.overrideConfigurations.get(t);return i||(i=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,i)),i}merge(...t){const i=I.deepClone(this.contents),r=I.deepClone(this.overrides),a=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const l of t)if(s.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.mergeContents(i,l.contents);for(const p of l.overrides){const[E]=r.filter(T=>L.equals(T.identifiers,p.identifiers));E?(this.mergeContents(E.contents,p.contents),E.keys.push(...p.keys),E.keys=L.distinct(E.keys)):r.push(I.deepClone(p))}for(const p of l.keys)a.indexOf(p)===-1&&a.push(p)}return new f(i,a,r,s.every(l=>l instanceof f)?void 0:s)}createOverrideConfigurationModel(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[a];const l=i[a];l&&(typeof s=="object"&&typeof l=="object"?(s=I.deepClone(s),this.mergeContents(s,l)):s=l),r[a]=s}return new f(r,this.keys,this.overrides)}mergeContents(t,i){for(const r of Object.keys(i)){if(r in t&&C.isObject(t[r])&&C.isObject(i[r])){this.mergeContents(t[r],i[r]);continue}t[r]=I.deepClone(i[r])}}getContentsForOverrideIdentifer(t){let i=null,r=null;const a=s=>{s&&(r?this.mergeContents(r,s):r=I.deepClone(s))};for(const s of this.overrides)L.equals(s.identifiers,[t])?i=s.contents:s.identifiers.includes(t)&&a(s.contents);return a(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.updateValue(t,i,!0)}setValue(t,i){this.updateValue(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>L.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}updateValue(t,i,r){(0,P.addToValueTree)(this.contents,t,i,a=>console.error(a)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,P.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=f;class y{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!C.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:r,keys:a,overrides:s,restricted:l,hasExcludedProperties:p}=this.doParseRaw(t,i);this._configurationModel=new f(r,a,s,p?[t]:void 0),this._restrictedConfigurations=l||[]}doParseContent(t){let i={},r=null,a=[];const s=[],l=[];function p(T){Array.isArray(a)?a.push(T):r!==null&&(a[r]=T)}const E={onObjectBegin:()=>{const T={};p(T),s.push(a),a=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{a=s.pop()},onArrayBegin:()=>{const T=[];p(T),s.push(a),a=T,r=null},onArrayEnd:()=>{a=s.pop()},onLiteralValue:p,onError:(T,A,N)=>{l.push({error:T,offset:A,length:N})}};if(t)try{c.visit(t,E),i=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(t,i){const r=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,r,!0,i);t=a.raw;const s=(0,P.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),l=Object.keys(t),p=this.toOverrides(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:s,keys:l,overrides:p,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(t,i,r,a){let s=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:s};const l={},p=[];for(const E in t)if(w.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const T=this.filter(t[E],i,!1,a);l[E]=T.raw,s=s||T.hasExcludedProperties,p.push(...T.restricted)}else{const T=i[E],A=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&p.push(E),(A===void 0||a.scopes===void 0||a.scopes.includes(A))&&!(a.skipRestricted&&T?.restricted)?l[E]=t[E]:s=!0}return{raw:l,restricted:p,hasExcludedProperties:s}}toOverrides(t,i){const r=[];for(const a of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(a)){const s={};for(const l in t[a])s[l]=t[a][l];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(s),contents:(0,P.toValuesTree)(s,i)})}return r}}e.ConfigurationModelParser=y;class h extends R.Disposable{constructor(t,i,r,a){super(),this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(_.Event.any(_.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),_.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class u{constructor(t,i,r,a,s,l,p,E,T,A,N,W,V){this.key=t,this.overrides=i,this._value=r,this.overrideIdentifiers=a,this.defaultConfiguration=s,this.policyConfiguration=l,this.applicationConfiguration=p,this.userConfiguration=E,this.localUserConfiguration=T,this.remoteUserConfiguration=A,this.workspaceConfiguration=N,this.folderConfigurationModel=W,this.memoryConfigurationModel=V}get value(){return d(this._value)}inspect(t,i,r){const a=t.inspect(i,r);return{get value(){return d(a.value)},get override(){return d(a.override)},get merged(){return d(a.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class g{constructor(t,i,r,a,s=new f,l=new f,p=new D.ResourceMap,E=new f,T=new D.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=a,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=p,this._memoryConfiguration=E,this._memoryConfigurationByResource=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,i,r){return this.getConsolidatedConfigurationModel(t,i,r).getValue(t)}updateValue(t,i,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new f,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,r){const a=this.getConsolidatedConfigurationModel(t,i,r),s=this.getFolderConfigurationModelForResource(i.resource,r),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=new Set;for(const E of a.overrides)for(const T of E.identifiers)a.getOverrideValue(t,T)!==void 0&&p.add(T);return new u(t,i,a.getValue(t),p.size?[...p]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,s||void 0,l)}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const r=[];if(!i){const{added:a,updated:s,removed:l}=k(this._defaultConfiguration,t);i=[...a,...s,...l]}for(const a of i)for(const s of(0,w.overrideIdentifiersFromKey)(a)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),p=t.getKeysForOverrideIdentifier(s),E=[...p.filter(T=>l.indexOf(T)===-1),...l.filter(T=>p.indexOf(T)===-1),...l.filter(T=>!I.equals(this._defaultConfiguration.override(s).getValue(T),t.override(s).getValue(T)))];r.push([s,E])}return this.updateDefaultConfiguration(t),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:r,removed:a}=k(this._policyConfiguration,t),s=[...i,...r,...a];return s.length&&this.updatePolicyConfiguration(t),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:r,removed:a,overrides:s}=k(this.applicationConfiguration,t),l=[...i,...r,...a];return l.length&&this.updateApplicationConfiguration(t),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:r,removed:a,overrides:s}=k(this.localUserConfiguration,t),l=[...i,...r,...a];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:r,removed:a,overrides:s}=k(this.remoteUserConfiguration,t),l=[...i,...r,...a];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:r,removed:a,overrides:s}=k(this.workspaceConfiguration,t),l=[...i,...r,...a];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(t,i){const r=this.folderConfigurations.get(t),{added:a,updated:s,removed:l,overrides:p}=k(r,i),E=[...a,...s,...l];return(E.length||!r)&&this.updateFolderConfiguration(t,i),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:s,overrides:l}=k(i,void 0);return{keys:[...r,...a,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,i,r){let a=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:t},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const s=this._memoryConfigurationByResource.get(t);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=r.merge(a),this._foldersConsolidatedConfigurations.set(t,i)):i=r}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const r=i.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:r,overrides:a,keys:s}=this._folderConfigurations.get(i);return t.push([i,{contents:r,overrides:a,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this._workspaceConfiguration.keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.policy),a=this.parseConfigurationModel(t.application),s=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),p=t.folders.reduce((E,T)=>(E.set(S.URI.revive(T[0]),this.parseConfigurationModel(T[1])),E),new D.ResourceMap);return new g(i,r,a,s,new f,l,p,new f,new D.ResourceMap)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides)}}e.Configuration=g;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const a of o)a.keys.forEach(s=>t.add(s)),a.overrides.forEach(([s,l])=>{const p=(0,D.getOrSet)(i,s,new Set);l.forEach(E=>p.add(E))});const r=[];return i.forEach((a,s)=>r.push([s,[...a.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=v;class b{constructor(t,i,r,a){this.change=t,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=a,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const s of t.keys)this.affectedKeys.add(s);for(const[,s]of t.overrides)for(const l of s)this.affectedKeys.add(l);this._affectsConfigStr=this._marker;for(const s of this.affectedKeys)this._affectsConfigStr+=s+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){const r=this._marker+t,a=this._affectsConfigStr.indexOf(r);if(a<0)return!1;const s=a+r.length;if(s>=this._affectsConfigStr.length)return!1;const l=this._affectsConfigStr.charCodeAt(s);if(l!==this._markerCode1&&l!==this._markerCode2)return!1;if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!I.equals(p,E)}return!0}}e.ConfigurationChangeEvent=b;function k(o,t){const{added:i,removed:r,updated:a}=n(t?.rawConfiguration,o?.rawConfiguration),s=[],l=o?.getAllOverrideIdentifiers()||[],p=t?.getAllOverrideIdentifiers()||[];if(t){const E=p.filter(T=>!l.includes(T));for(const T of E)s.push([T,t.getKeysForOverrideIdentifier(T)])}if(o){const E=l.filter(T=>!p.includes(T));for(const T of E)s.push([T,o.getKeysForOverrideIdentifier(T)])}if(t&&o){for(const E of l)if(p.includes(E)){const T=n({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:t.getOverrideValue(void 0,E)||{},keys:t.getKeysForOverrideIdentifier(E)});s.push([E,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:r,updated:a,overrides:s}}function n(o,t){const i=o?t?o.keys.filter(s=>t.keys.indexOf(s)===-1):[...o.keys]:[],r=t?o?t.keys.filter(s=>o.keys.indexOf(s)===-1):[...t.keys]:[],a=[];if(o&&t){for(const s of t.keys)if(o.keys.indexOf(s)!==-1){const l=(0,P.getConfigurationValue)(t.contents,s),p=(0,P.getConfigurationValue)(o.contents,s);I.equals(l,p)||a.push(s)}}return{added:i,removed:r,updated:a}}}),define(se[224],oe([0,1,19,3,2,32,12,73,45,9,58,40]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends c.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(h),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(h,u){this.updateConfigurationModel(h,w.Registry.as(C.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:h})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const h=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(h),h)}updateConfigurationModel(h,u){const g=this.getConfigurationDefaultOverrides();for(const v of h){const b=g[v],k=u[v];b!==void 0?this._configurationModel.addValue(v,b):k?this._configurationModel.addValue(v,k.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=m;class d{constructor(){this.onDidChangeConfiguration=_.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let f=class extends c.Disposable{get configurationModel(){return this._configurationModel}constructor(h,u,g){super(),this.defaultConfiguration=h,this.policyService=u,this.logService=g,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(h=>this.onDidChangePolicies(h))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:h})=>this.update(await this.updatePolicyDefinitions(h),!0))),this._configurationModel}async updatePolicyDefinitions(h){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",h);const u={},g=[],v=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const b of h){const k=v[b];if(!k){g.push(b);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.logService.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}g.push(b),u[k.policy.name]={type:k.type}}}return(0,D.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),g}onDidChangePolicies(h){this.logService.trace("PolicyConfiguration#onDidChangePolicies",h);const u=w.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),g=(0,L.coalesce)(h.map(v=>u.get(v)));this.update(g,!0)}update(h,u){this.logService.trace("PolicyConfiguration#update",h);const g=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),v=[],b=this._configurationModel.isEmpty();for(const k of h){const n=g[k]?.policy?.name;if(n){const o=this.policyService.getPolicyValue(n);(b?o!==void 0:!(0,R.equals)(this._configurationModel.getValue(k),o))&&v.push([k,o])}else this._configurationModel.getValue(k)!==void 0&&v.push([k,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const k=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const n of k.keys)this._configurationModel.setValue(n,k.getValue(n));for(const[n,o]of v)o===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,o);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};f=pe([Y(1,P.IPolicyService),Y(2,S.ILogService)],f),e.PolicyConfiguration=f}),define(se[225],oe([0,1,6,3,2,25,17,73,224,58]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends c.Disposable{constructor(m,d,f,y){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new C.DefaultConfiguration),this.policyConfiguration=f instanceof S.NullPolicyService?new C.NullPolicyConfiguration:this._register(new C.PolicyConfiguration(this.defaultConfiguration,f,y)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,d)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:h,properties:u})=>this.onDidDefaultConfigurationChange(h,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(h=>this.onDidPolicyConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,d,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(m,d,new I.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(m,d){const f=typeof m=="string"?m:void 0,y=(0,D.isConfigurationOverrides)(m)?m:(0,D.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(f,y,void 0)}updateValue(m,d,f,y){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const d=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(f,d,2)}onDidDefaultConfigurationChange(m,d){const f=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(m,d);this.trigger(y,f,7)}onDidPolicyConfigurationChange(m){const d=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(f,d,7)}trigger(m,d,f){const y=new I.ConfigurationChangeEvent(m,{data:d},this.configuration);y.source=f,y.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(se[226],oe([0,1,7,5]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var c;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(c=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends L.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof R&&C._code===c.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof R&&C._code===c.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof R&&C._code===c.NoResolverFound}static isHandled(C){return C instanceof R&&C.isHandled}constructor(C,S=c.Unknown,P){super(C),this._message=C,this._code=S,this._detail=P,this.isHandled=S===c.NotAvailable&&P===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function D(I){const C=I.indexOf("+");return C===-1?I:I.substring(0,C)}e.getRemoteAuthorityPrefix=D}),define(se[74],oe([0,1,22]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function _(S){return S.scheme===L.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=_;function c(S){if(!S)return;const P=S.indexOf("+");return P<0?S:S.substr(0,P)}e.getRemoteName=c;function R(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(S){const{host:P,port:w}=C(S);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:w}}e.parseAuthorityWithPort=D;function I(S,P){let{host:w,port:m}=C(S);return typeof m>"u"&&(m=P),{host:w,port:m}}e.parseAuthorityWithOptionalPort=I;function C(S){const P=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const w=S.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=S.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:S,port:void 0}}}),define(se[46],oe([0,1,27,5,74]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var I;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,y){if(typeof f>"u"||f===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof f=="string"||typeof y=="string"){const h=typeof f=="string"?f:f.value,u=typeof y=="string"?y:y.value;return L.equalsIgnoreCase(h,u)}return f._lower===y._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=C;function S(d){return P(d)}e.isApplicationScopedExtension=S;function P(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function w(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function m(d,f){if(f){const y=`onResolveRemoteAuthority:${(0,c.getRemoteName)(f)}`;return!!d.activationEvents?.includes(y)}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,_.createDecorator)("IBuiltinExtensionsScannerService")}),define(se[227],oe([0,1,2,13,28,46]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends L.Disposable{constructor(C,S){super(),this.environmentService=C,this.extensionsManifestCache=(0,_.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(S.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(S.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(S=>!!S.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){c.Promises.rm(this.extensionsManifestCache,c.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(se[228],oe([0,1,6,16,24,7,3,2,105,89,31,96,226,74]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var y;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function h(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const x=new c.CancellationTokenSource;return setTimeout(()=>x.cancel(),U),x.token}function g(U,x){if(U.isCancellationRequested||x.isCancellationRequested)return c.CancellationToken.Cancelled;const H=new c.CancellationTokenSource;return U.onCancellationRequested(()=>H.cancel()),x.onCancellationRequested(()=>H.cancel()),H.token}class v{get didTimeout(){return this._state==="timedout"}constructor(x){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((H,te)=>{this._resolvePromise=H,this._rejectPromise=te}),x.isCancellationRequested?this._timeout():this._disposables.add(x.onCancellationRequested(()=>this._timeout()))}registerDisposable(x){this._state==="pending"?this._disposables.add(x):x.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(x))}reject(x){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(x))}}function b(U,x){const H=new v(x);return H.registerDisposable(U.onControlMessage(te=>{const G=JSON.parse(te.toString()),X=J(G);X?H.reject(X):H.resolve(G)})),H.promise}function k(U,x,H,te,G,X,ie,le,he){const me=new v(he),ve=S.StopWatch.create(!1);return U.info(`Creating a socket (${le})...`),C.mark(`code/willCreateSocket/${ie}`),x.connect(H,te,G,X,le,(we,Ce)=>{me.didTimeout?(C.mark(`code/didCreateSocketError/${ie}`),U.info(`Creating a socket (${le}) finished after ${ve.elapsed()} ms, but this is too late and has timed out already.`),we&&U.error(we),Ce?.dispose()):we||!Ce?(C.mark(`code/didCreateSocketError/${ie}`),U.info(`Creating a socket (${le}) returned an error after ${ve.elapsed()} ms.`),me.reject(we)):(C.mark(`code/didCreateSocketOK/${ie}`),U.info(`Creating a socket (${le}) was successful after ${ve.elapsed()} ms.`),me.resolve(Ce))}),me.promise}function n(U,x){const H=new v(x);return U.then(te=>{H.didTimeout||H.resolve(te)},te=>{H.didTimeout||H.reject(te)}),H.promise}async function o(U,x,H,te){const G=B(U,x);U.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let X;try{X=await k(U.logService,U.socketFactory,U.host,U.port,(0,d.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,h(x),`renderer-${h(x)}-${U.reconnectionToken}`,te)}catch(ve){throw U.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),U.logService.error(ve),ve}U.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let ie,le;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(X,null),ie=U.reconnectionProtocol,le=!1):(ie=new w.PersistentProtocol({socket:X,measureRoundTripTime:!0}),le=!0),U.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const he=await n(U.signService.createNewMessage((0,P.generateUuid)()),te),me={type:"auth",auth:U.connectionToken||"00000000000000000000",data:he.data};ie.sendControl(_.VSBuffer.fromString(JSON.stringify(me)));try{const ve=await b(ie,g(te,u(1e4)));if(ve.type!=="sign"||typeof ve.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(U.logService.trace(`${G} 4/6. received SignRequest control message.`),!await n(U.signService.validate(he,ve.signedData),te)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await n(U.signService.sign(ve.data),te),Re={type:"connectionType",commit:U.commit,signedData:Ce,desiredConnectionType:x};return H&&(Re.args=H),U.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(_.VSBuffer.fromString(JSON.stringify(Re))),{protocol:ie,ownsProtocol:le}}catch(ve){throw ve&&ve.code==="ETIMEDOUT"&&(U.logService.error(`${G} the handshake timed out. Error:`),U.logService.error(ve)),ve&&ve.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${G} received error control message when negotiating connection. Error:`),U.logService.error(ve)),le&&M(ie),ve}}async function t(U,x,H,te){const G=Date.now(),X=B(U,x),{protocol:ie,ownsProtocol:le}=await o(U,x,H,te),he=new v(te);return he.registerDisposable(ie.onControlMessage(me=>{const ve=JSON.parse(me.toString()),we=J(ve);we?(U.logService.error(`${X} received error control message when negotiating connection. Error:`),U.logService.error(we),le&&M(ie),he.reject(we)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${F(G)}!`),he.resolve({protocol:ie,firstMessage:ve}))})),he.promise}async function i(U,x){const{protocol:H}=await t(U,1,void 0,x);return{protocol:H}}async function r(U,x,H){const{protocol:te,firstMessage:G}=await t(U,2,x,H),X=G&&G.debugPort;return{protocol:te,debugPort:X}}async function a(U,x,H){const te=Date.now(),G=B(U,3),{protocol:X}=await o(U,3,x,H);return U.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${F(te)}!`),X}async function s(U,x,H){const{host:te,port:G,connectionToken:X}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:te,port:G,connectionToken:X,reconnectionToken:x,reconnectionProtocol:H,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function l(U,x,H){return E(U,async te=>{const{protocol:G}=await i(te,c.CancellationToken.None);return new q(U,x,H,te.reconnectionToken,G)})}e.connectRemoteAgentManagement=l;async function p(U,x){return E(U,async H=>{const{protocol:te,debugPort:G}=await r(H,x,c.CancellationToken.None);return new j(U,x,H.reconnectionToken,te,G)})}e.connectRemoteAgentExtensionHost=p;async function E(U,x){for(let te=1;;te++)try{const G=(0,P.generateUuid)(),X=await s(U,G,null);return await x(X)}catch(G){if(te<5)U.logService.error(`[remote-connection][attempt ${te}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(G);else throw U.logService.error(`[remote-connection][attempt ${te}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(G),Z.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(G)),G}}async function T(U,x,H){const te=await s(U,(0,P.generateUuid)(),null);return await a(te,{host:x,port:H},c.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function A(U){return(0,L.createCancelablePromise)(x=>new Promise((H,te)=>{const G=setTimeout(H,U*1e3);x.onCancellationRequested(()=>{clearTimeout(G),H()})}))}var N;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class W{constructor(x,H){this.reconnectionToken=x,this.millisSinceLastIncomingData=H,this.type=0}}e.ConnectionLostEvent=W;class V{constructor(x,H,te,G){this.reconnectionToken=x,this.millisSinceLastIncomingData=H,this.durationSeconds=te,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=V;class K{constructor(x,H,te){this.reconnectionToken=x,this.millisSinceLastIncomingData=H,this.attempt=te,this.type=2}}e.ReconnectionRunningEvent=K;class z{constructor(x,H,te){this.reconnectionToken=x,this.millisSinceLastIncomingData=H,this.attempt=te,this.type=4}}e.ConnectionGainEvent=z;class O{constructor(x,H){this.reconnectionToken=x,this.connectionHealth=H,this.type=5}}e.ConnectionHealthChangedEvent=O;class ${constructor(x,H,te,G){this.reconnectionToken=x,this.millisSinceLastIncomingData=H,this.attempt=te,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class Z extends I.Disposable{static triggerPermanentFailure(x,H,te){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=x,this._permanentFailureAttempt=H,this._permanentFailureHandled=te,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(x=>x._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(x=>x._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||Z._permanentFailure}constructor(x,H,te,G,X){super(),this._connectionType=x,this._options=H,this.reconnectionToken=te,this.protocol=G,this._reconnectionFailureIsFatal=X,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new z(this.reconnectionToken,0,0)),this._register(G.onSocketClose(ie=>{const le=ae(this._connectionType,this.reconnectionToken,!0);ie?ie.type===0?(this._options.logService.info(`${le} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this._options.logService.error(ie.error)):(this._options.logService.info(`${le} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this._options.logService.error(ie.event)):this._options.logService.info(`${le} received socket close event.`),this._beginReconnecting()})),this._register(G.onSocketTimeout(ie=>{const le=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(G.onHighRoundTripTime(ie=>{const le=re(this._connectionType,this.reconnectionToken);this._options.logService.info(`${le} high roundtrip time: ${ie.roundTripTime}ms (${ie.recentHighRoundTripCount} of ${5} recent samples)`)})),this._register(G.onDidChangeConnectionHealth(ie=>{this._onDidStateChange.fire(new O(this.reconnectionToken,ie))})),Z._instances.push(this),this._register((0,I.toDisposable)(()=>{const ie=Z._instances.indexOf(this);ie>=0&&Z._instances.splice(ie,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Z._permanentFailureMillisSinceLastIncomingData,Z._permanentFailureAttempt,Z._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const x=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const H=[0,5,5,10,10,10,10,10,30];let te=-1;do{te++;const G=te<H.length?H[te]:H[H.length-1];try{if(G>0){const ie=A(G);this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,ie)),this._options.logService.info(`${x} waiting for ${G} seconds before reconnecting...`);try{await ie}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te+1)),this._options.logService.info(`${x} resolving connection...`);const X=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${x} connecting to ${X.host}:${X.port}...`),await this._reconnect(X,u(f)),this._options.logService.info(`${x} reconnected!`),this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),te+1,!1);break}if(te>360){this._options.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),te+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this._options.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this._options.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((0,R.isCancellationError)(X)){this._options.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(X instanceof m.RemoteAuthorityResolverError){this._options.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),te+1,m.RemoteAuthorityResolverError.isHandled(X));break}this._options.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),te+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(x,H,te){this._reconnectionFailureIsFatal?Z.triggerPermanentFailure(x,H,te):this._gotoPermanentFailure(x,H,te)}_gotoPermanentFailure(x,H,te){this._onDidStateChange.fire(new $(this.reconnectionToken,x,H,te)),M(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}Z._permanentFailure=!1,Z._permanentFailureMillisSinceLastIncomingData=0,Z._permanentFailureAttempt=0,Z._permanentFailureHandled=!1,Z._instances=[],e.PersistentConnection=Z;class q extends Z{constructor(x,H,te,G,X){super(1,x,G,X,!0),this.client=this._register(new w.Client(X,{remoteAuthority:H,clientId:te},x.ipcLogger))}async _reconnect(x,H){await i(x,H)}}e.ManagementPersistentConnection=q;class j extends Z{constructor(x,H,te,G,X){super(2,x,te,G,!1),this._startArguments=H,this.debugPort=X}async _reconnect(x,H){await r(x,this._startArguments,H)}}e.ExtensionHostPersistentConnection=j;function M(U){try{U.acceptDisconnect();const x=U.getSocket();U.dispose(),x.dispose()}catch(x){(0,R.onUnexpectedError)(x)}}function J(U){if(U&&U.type==="error"){const x=new Error(`Connection error: ${U.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function Q(U,x){for(;U.length<x;)U+=" ";return U}function re(U,x){return`[remote-connection][${Q(h(U),13)}][${x.substr(0,5)}\u2026]`}function ae(U,x,H){return`${re(U,x)}[${H?"reconnect":"initial"}]`}function B(U,x){return`${ae(x,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function F(U){return`${Date.now()-U} ms`}}),define(se[229],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(se[230],oe([0,1,86,156]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(c,R,D,I,C,S){const P=m=>S(m,void 0),w=L.createConnection({host:c,port:R},()=>{w.removeListener("error",P);const m=Buffer.alloc(16);for(let h=0;h<16;h++)m[h]=Math.round(Math.random()*256);const d=m.toString("base64"),f=[`GET ws://${/:/.test(c)?`[${c}]`:c}:${R}${D}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];w.write(f.join(`\r
`)+`\r
\r
`);const y=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",y),S(void 0,new _.NodeSocket(w,C)))};w.on("data",y)});w.setNoDelay(!0),w.once("error",P)}}}),define(se[110],oe([0,1,5,174]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var c;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=D=>({type:"connected",info:D}),R.connecting=D=>({type:"connecting",progress:D})})(c=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,_.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(se[231],oe([0,1,139,17,9]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(I,C){this.configurationService=I,this.logService=C}async request(I,C){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const S=await(0,L.request)(I,C);return this.logService.trace("RequestService#request (browser) - success",I.url),S}catch(S){throw this.logService.error("RequestService#request (browser) - error",I.url,S),S}}async resolveProxy(I){}};R=pe([Y(0,_.IConfigurationService),Y(1,c.ILogService)],R),e.RequestService=R}),define(se[59],oe([0,1,16,176,45,5,40]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function I(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=I;function C(y){return y.res.statusCode===204}async function S(y){return C(y)?null:(await(0,L.streamToBuffer)(y.stream)).toString()}e.asText=S;async function P(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);return S(y)}e.asTextOrError=P;async function w(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);if(C(y))return null;const u=(await(0,L.streamToBuffer)(y.stream)).toString();try{return JSON.parse(u)}catch(g){throw g.message+=`:
`+u,g}}e.asJson=w;function m(y){f(y)}e.updateProxyConfigurationsScope=m;let d;function f(y){const h=D.Registry.as(c.Extensions.Configuration),u=d;d={id:"http",order:15,title:(0,_.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(4,null),(0,_.localize)(5,null),(0,_.localize)(6,null),(0,_.localize)(7,null)],default:"override",description:(0,_.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[d],remove:u?[u]:[]})}f(2)}),define(se[232],oe([0,1,24,22,14,59]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(C,S){this.requestService=C,this.fileService=S}async download(C,S,P=L.CancellationToken.None){if(C.scheme===_.Schemas.file||C.scheme===_.Schemas.vscodeRemote){await this.fileService.copy(C,S);return}const w={type:"GET",url:C.toString(!0)},m=await this.requestService.request(w,P);if(m.res.statusCode===200)await this.fileService.writeFile(S,m.stream);else{const d=await(0,R.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};D=pe([Y(0,R.IRequestService),Y(1,c.IFileService)],D),e.DownloadService=D}),define(se[233],oe([0,1,16,24]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class c{constructor(I){this.service=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,S,P=_.CancellationToken.None){switch(C){case"request":return this.service.request(S[0],P).then(async({res:w,stream:m})=>{const d=await(0,L.streamToBuffer)(m);return[{statusCode:w.statusCode,headers:w.headers},d]});case"resolveProxy":return this.service.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=c;class R{constructor(I){this.channel=I}async request(I,C){const[S,P]=await this.channel.call("request",[I],C);return{res:S,stream:(0,L.bufferToStream)(P)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=R}),define(se[234],oe([0,1,12,231,233]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(I,C,S){this.configurationService=C,this.logService=S,this.browserRequestService=new _.RequestService(C,S),this.mainRequestService=new c.RequestChannelClient(I.getChannel("request"))}request(I,C){return this.getRequestService().request(I,C)}async resolveProxy(I){return this.getRequestService().resolveProxy(I)}getRequestService(){return this.isMainRequestServiceEnabled()?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}isMainRequestServiceEnabled(){const I=this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,L.isBoolean)(I)?I:!0}}e.SharedProcessRequestService=R}),define(se[111],oe([0,1,65,5]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function c(R){return(0,L.hash)({moduleId:R.process.moduleId,windowId:R.reply.windowId})}e.hash=c,e.ISharedProcessWorkerService=(0,_.createDecorator)("sharedProcessWorkerService")}),define(se[235],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(_){_.Spawn="vscode:shared-process->shared-process-worker=spawn",_.Terminate="vscode:shared-process->shared-process-worker=terminate",_.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",_.Ready="vscode:shared-process-worker->shared-process=ready",_.Ack="vscode:shared-process-worker->shared-process=ack",_.Trace="vscode:shared-process-worker->shared-process=trace",_.Info="vscode:shared-process-worker->shared-process=info",_.Warn="vscode:shared-process-worker->shared-process=warn",_.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(se[236],oe([0,1,154,6,24,3,2,22,31,9,111,235]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(y){this.logService=y,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const h=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${h})`);const u=(0,P.hash)(y);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${h})`),this.doDisposeWorker(y));const g=new c.CancellationTokenSource;let v,b,k;this.processeDisposables.set(u,i=>{g.dispose(!0),v?.terminate(y,c.CancellationToken.None),b?.close(),k?.close(),this.processeDisposables.delete(u);const r=this.processResolvers.get(u);r&&(this.processResolvers.delete(u),r({reason:i}))}),v=await this.getOrCreateWebWorker(y);const n=new Promise(i=>{this.processResolvers.set(u,i)});if(g.token.isCancellationRequested)return n;const{port1:o,port2:t}=new MessageChannel;return b=o,k=t,await v.spawn(y,k,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${h})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[b])),n}getOrCreateWebWorker(y){let h=this.workers.get(y.process.moduleId);if(!h){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const u=new d(y.process.type,this.logService);h=u.init(),u.onDidProcessSelfTerminate(({configuration:g,reason:v})=>{this.doDisposeWorker(g,v)}),this.workers.set(y.process.moduleId,h)}return h}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,h){const u=this.processeDisposables.get((0,P.hash)(y));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),u(h))}};m=pe([Y(0,S.ILogService)],m),e.SharedProcessWorkerService=m;class d extends D.Disposable{constructor(y,h){super(),this.type=y,this.logService=h,this._onDidProcessSelfTerminate=this._register(new R.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new _.DeferredPromise,h=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return h.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},h.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},h.onmessage=u=>{const{id:g,message:v,configuration:b,nonce:k}=u.data;switch(g){case w.SharedProcessWorkerMessages.Ready:y.complete(h);break;case w.SharedProcessWorkerMessages.Ack:if(k){const n=this.mapMessageNonceToPendingMessageResolve.get(k);n&&(this.mapMessageNonceToPendingMessageResolve.delete(k),n())}break;case w.SharedProcessWorkerMessages.SelfTerminated:b&&v&&this._onDidProcessSelfTerminate.fire({configuration:b,reason:JSON.parse(v)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,v);break;case w.SharedProcessWorkerMessages.Info:v&&this.logService.info(v);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,v);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,v);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},h.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,h,u){const g=await this.workerReady;if(!h.isCancellationRequested)return new Promise(v=>{const b=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(b,v);const k={...y,nonce:b};u?g.postMessage(k,[u]):g.postMessage(k),h.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(b)&&v()})})}spawn(y,h,u){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.send(g,u,h)}terminate(y,h){const u={id:w.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(u,h)}}}),define(se[237],oe([0,1,62,22,98]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class R extends c.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:_.Schemas.vscodeUserData})}}pe([L.memoize],R.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=R}),define(se[238],oe([0,1,50,13,177,24,39,7,4,31,151,195,6,132]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let f;async function y(u,g,v,b){return v["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(b)&&!v["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(b)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=m.Promises.withAsyncBody(async(k,n)=>{const o=new R.CancellationTokenSource;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,d.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),n(new Error((0,c.localize)(0,null)))},t);try{k(await h(g,o.token))}catch(a){!(0,I.isCancellationError)(a)&&!o.token.isCancellationRequested?n(new Error((0,c.localize)(1,null,(0,D.toErrorMessage)(a)))):k({})}finally{clearTimeout(r),o.dispose()}})),f)}e.getResolvedShellEnv=y;async function h(u,g){const v=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",v);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",b);const k=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(k+"({.*})"+k),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,P.getSystemShell)(C.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,r)=>{if(g.isCancellationRequested)return r(new I.CancellationError);const a=(0,_.basename)(t);let s,l;const p=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(s=`& '${process.execPath}' ${p} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,l=["-Login","-Command"]):(s=`'${process.execPath}' ${p} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,a==="tcsh"||a==="csh"?l=["-ic"]:l=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),s);const E=(0,L.spawn)(t,[...l,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});g.onCancellationRequested(()=>(E.kill(),r(new I.CancellationError))),E.on("error",N=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(N)),r(N)});const T=[];E.stdout.on("data",N=>T.push(N));const A=[];E.stderr.on("data",N=>A.push(N)),E.on("close",(N,W)=>{const V=Buffer.concat(T).toString("utf8");u.trace("getUnixShellEnvironment#raw",V);const K=Buffer.concat(A).toString("utf8");if(K.trim()&&u.trace("getUnixShellEnvironment#stderr",K),N||W)return r(new Error((0,c.localize)(2,null,N,W)));const z=n.exec(V),O=z?z[1]:"{}";try{const $=JSON.parse(O);v?$.ELECTRON_RUN_AS_NODE=v:delete $.ELECTRON_RUN_AS_NODE,b?$.ELECTRON_NO_ATTACH_CONSOLE=b:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.VSCODE_RESOLVING_ENVIRONMENT,delete $.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",$),i($)}catch($){u.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)($)),r($)}})})}}),define(se[112],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(se[239],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.validators=new Map}vsda(){return new Promise((c,R)=>ee(["vsda"],c,R))}async createNewMessage(c){try{const R=await this.vsda(),D=new R.validator;if(D){const I=String(L._nextId++);return this.validators.set(I,D),{id:I,data:D.createNewMessage(c)}}}catch{}return{id:"",data:c}}async validate(c,R){if(!c.id)return!0;const D=this.validators.get(c.id);if(!D)return!1;this.validators.delete(c.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(c){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(c)}catch{}return c}}L._nextId=1,e.SignService=L}),define(se[75],oe([0,1,3,2]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class c extends _.Disposable{constructor(w,m,d){super(),this.channel=w,this.profile=m,this.workspace=d}async getItems(){const w={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",w);return new Map(m)}updateItems(w){const m={profile:this.profile,workspace:this.workspace};return w.insert&&(m.insert=Array.from(w.insert.entries())),w.delete&&(m.delete=Array.from(w.delete.values())),this.channel.call("updateItems",m)}}class R extends c{constructor(w,m){super(w,m,void 0),this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(w=>this.onDidChangeStorage(w)))}onDidChangeStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class D extends R{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=D;class I extends R{constructor(w,m){super(w,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class C extends c{constructor(w,m){super(w,void 0,m),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C;class S{constructor(w){this.channel=w}isUsed(w){const m={payload:w,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=S}),define(se[113],oe([0,1,4,36,11,31]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(S){if(L.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function I(S,P,w,m,d,f,y,h,u,g){const v=Object.create(null);v["common.machineId"]=y,v.sessionID=(0,R.generateUuid)()+Date.now(),v.commitHash=d,v.version=f,v["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,L.PlatformToString)(L.platform),v["common.nodePlatform"]=_.platform,v["common.nodeArch"]=m,v["common.product"]=g||"desktop",h&&(v["common.msftInternal"]=h);let b=0;const k=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),L.isLinuxSnap&&(v["common.snap"]="true");const n=D(w);n&&(v["common.platformDetail"]=n);try{const o=await S.readFile(c.URI.file(u));v["common.source"]=o.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=I;function C(S){const P=_.env.USERDNSDOMAIN;if(!P)return!1;const w=P.toLowerCase();return S.some(m=>w===m)}e.verifyMicrosoftInternalDomain=C}),define(se[20],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var _;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(_=e.TelemetryLevel||(e.TelemetryLevel={}));var c;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(c=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(se[240],oe([0,1,34,6,35,22,13,4,11,148,28,150,99,14,26,20]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function u(n,o){const t=`${n}::${o.join(":")}`,i=h.get(t);if(i)return i;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,s=new Map,l=2e4;function p(T,A,N,W){const V=A.substring(T.length+1);return _.Promises.withAsyncBody(async K=>{let z;try{z=await P.Promises.readdir(A,{withFileTypes:!0})}catch{K();return}if(W.count>=l){W.count+=z.length,W.maxReached=!0,K();return}let O=z.length;if(O===0){K();return}let $=z;W.count+z.length>l&&(W.maxReached=!0,O=l-W.count,$=z.slice(0,O)),W.count+=z.length;for(const Z of $)if(Z.isDirectory()){if(N.includes(Z.name)||await p(T,(0,D.join)(A,Z.name),N,W),--O===0){K();return}}else{const q=Z.name.lastIndexOf(".");if(q>=0){const j=Z.name.substring(q+1);j&&a.set(j,(a.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test(V)!==!1&&j.filePattern.test(Z.name)&&s.set(j.tag,(s.get(j.tag)??0)+1);if(--O===0){K();return}}})}const E=_.Promises.withAsyncBody(async T=>{const A={count:0,maxReached:!1};await p(n,n,o,A);const N=await b(n);T({configFiles:g(s),fileTypes:g(a),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:N})});return h.set(t,E),E}e.collectWorkspaceStats=u;function g(n){return Array.from(n.entries(),([o,t])=>({name:o,count:t})).sort((o,t)=>t.count-o.count)}function v(){const n={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.getMachineInfo=v;async function b(n){try{const o=new Map,t=(0,D.join)(n,".vscode","launch.json"),i=await P.Promises.readFile(t),r=[],a=(0,c.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${t}`),[];if((0,c.getNodeType)(a)==="object"&&a.configurations)for(const s of a.configurations){const l=s.type;l&&(o.has(l)?o.set(l,o.get(l)+1):o.set(l,1))}return g(o)}catch{return[]}}e.collectLaunchConfigs=b;let k=class{constructor(o,t){this.telemetryService=o,this.productService=t}formatMachineInfo(o){const t=[];return t.push(`OS Version:       ${o.os}`),t.push(`CPUs:             ${o.cpus}`),t.push(`Memory (System):  ${o.memory}`),t.push(`VM:               ${o.vmHint}`),t.join(`
`)}formatEnvironment(o){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const i=L.cpus();return i&&i.length>0&&t.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),t.push(`Memory (System):  ${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||t.push(`Load (avg):       ${L.loadavg().map(r=>Math.round(r)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${o.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(o,t){return Promise.all([(0,w.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async i=>{let[r,a]=i,s=this.formatProcessList(o,r);return t.forEach(l=>{if((0,m.isRemoteDiagnosticError)(l))s+=`
${l.errorMessage}`,a+=`
${l.errorMessage}`;else if(s+=`

Remote: ${l.hostName}`,l.processes&&(s+=`
${this.formatProcessList(o,l.processes)}`),l.workspaceMetadata){a+=`
|  Remote: ${l.hostName}`;for(const p of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[p];let T=`${E.fileCount} files`;E.maxFilesReached&&(T=`more than ${T}`),a+=`|    Folder (${p}): ${T}`,a+=this.formatWorkspaceStats(E)}}}),{processInfo:s,workspaceInfo:a}})}async getSystemInfo(o,t){const{memory:i,vmHint:r,os:a,cpus:s}=v(),l={os:a,memory:i,cpus:s,vmHint:r,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:t};return I.isWindows||(l.load=`${L.loadavg().map(p=>Math.round(p)).join(", ")}`),I.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(o,t){const i=[];return(0,w.listProcesses)(o.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(o)),i.push(""),i.push(this.formatProcessList(o,r)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(o))),t.forEach(a=>{if((0,m.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(o,a.processes)),a.workspaceMetadata)for(const s of Object.keys(a.workspaceMetadata)){const l=a.workspaceMetadata[s];let p=`${l.fileCount} files`;l.maxFilesReached&&(p=`more than ${p}`),i.push(`Folder (${s}): ${p}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(o){const t=[];let r=0;const a=(E,T)=>{const A=` ${E}(${T})`;r+A.length>60?(t.push(s),s="|                 ",r=s.length):r+=A.length,s+=A};let s="|      File types:";const l=10,p=o.fileTypes.length>l?l:o.fileTypes.length;for(let E=0;E<p;E++){const T=o.fileTypes[E];a(T.name,T.count)}if(t.push(s),o.configFiles.length>=0&&(s="|      Conf files:",r=0,o.configFiles.forEach(E=>{a(E.name,E.count)}),t.push(s)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(T=>{E+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),t.push(E)}return t.join(`
`)}expandGPUFeatures(o){const t=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${o[i]}`).join(`
                  `)}formatWorkspaceMetadata(o){const t=[],i=[];return o.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(t.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const s=C.URI.revive(a);if(s.scheme===R.Schemas.file){const l=s.fsPath;i.push(u(l,["node_modules",".git"]).then(p=>{let E=`${p.fileCount} files`;p.maxFilesReached&&(E=`more than ${E}`),t.push(`|    Folder (${(0,D.basename)(l)}): ${E}`),t.push(this.formatWorkspaceStats(p))}).catch(p=>{t.push(`|      Error: Unable to collect workspace stats for folder ${l} (${p.toString()})`)}))}else t.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>t.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(o,t){const i=new Map;o.windows.forEach(a=>i.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(o.mainPID,i,r,t,0),r.join(`
`)}formatProcessItem(o,t,i,r,a){const s=a===0;let l;s?l=r.pid===o?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(l=`${l} (${t.get(r.pid)})`));const p=process.platform==="win32"?r.mem:L.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(p/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(r.children)&&r.children.forEach(E=>this.formatProcessItem(o,t,i,E,a+1))}async getWorkspaceFileExtensions(o){const t=new Set;for(const{uri:i}of o.folders){const r=C.URI.revive(i);if(r.scheme!==R.Schemas.file)continue;const a=r.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(l=>t.add(l.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(o){for(const{uri:t}of o.folders){const i=C.URI.revive(t);if(i.scheme!==R.Schemas.file)continue;const r=i.fsPath;try{const a=await u(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(s=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:s.name,count:s.count})}),a.launchConfigFiles.forEach(s=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:s.name,count:s.count})}),a.configFiles.forEach(s=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};k=pe([Y(0,y.ITelemetryService),Y(1,f.IProductService)],k),e.DiagnosticsService=k}),define(se[241],oe([0,1,110,3,20,15,2,9,13,50,26,4,6,106,17,175,34,11]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const g=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP];let v=class extends D.Disposable{constructor(k,n,o,t,i,r){super(),this.telemetryService=k,this.productService=n,this.environmentService=o,this.configurationService=r,this._onDidTokenFailedEmitter=new _.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new _.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new _.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=L.TunnelStates.disconnected;const a=u.URI.file((0,C.join)(o.logsPath,L.LOG_FILE_NAME));this._logger=this._register(t.createLogger(a,{name:L.LOGGER_NAME,id:L.LOG_CHANNEL_ID})),this._startTunnelProcessDelayer=new m.Delayer(100),this._register(this._logger.onDidChangeLogLevel(s=>this._logger.info("Log level changed to "+(0,I.LogLevelToString)(s)))),this._register(i.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(r.onDidChangeConfiguration(s=>{g.some(l=>s.affectsConfiguration(l))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(k){if(k&&this._account?k.token!==this._account.token||k.providerId!==this._account.providerId:k!==this._account){this._account=k,this._onDidChangeAccountEmitter.fire(k),k?this._logger.info(`Account updated: ${k.accountLabel} (${k.providerId})`):this._logger.info("Account reset"),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!k});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(n){this._logger.error(n)}}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let k;w.isMacintosh?k=this.environmentService.appRoot:k=(0,C.dirname)((0,C.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,C.join)(k,"bin",`${this.productService.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this._tunnelCommand}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(L.TunnelStates.disconnected);return}const{token:k,providerId:n,accountLabel:o}=this._account;this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(0,null,o,n)));const t=(l,p)=>{l=l.replaceAll(k,"*".repeat(4)),p?this._logger.error(l):this._logger.info(l),!this.environmentService.isBuilt&&l.startsWith("   Compiling")&&this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(1,null)))},i=this.runCodeTunneCommand("login",["user","login","--provider",n,"--access-token",k,"--log",(0,I.LogLevelToString)(this._logger.getLevel())],t);this._tunnelProcess=i;try{if(await i,this._tunnelProcess!==i)return}catch(l){this._logger.error(l),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(L.TunnelStates.disconnected);return}const r=this._getHostName();r?this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(2,null,r))):this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(3,null)));const a=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,I.LogLevelToString)(this._logger.getLevel())];r?a.push("--name",r):a.push("--random-name"),this._preventSleep()&&a.push("--no-sleep");const s=this.runCodeTunneCommand("tunnel",a,(l,p)=>{p?this._logger.error(l):this._logger.info(l);const E=l.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(E){const T={link:E[1],domain:E[2],hostName:E[4]};this.setTunnelStatus(L.TunnelStates.connected(T))}else l.match(/error refreshing token/)&&(s.cancel(),this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(L.TunnelStates.disconnected))});this._tunnelProcess=s,s.finally(()=>{s===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(k){this._tunnelStatus=k,this._onDidChangeTunnelStatusEmitter.fire(k)}runCodeTunneCommand(k,n,o=()=>{}){return(0,m.createCancelablePromise)(t=>new Promise((i,r)=>{t.isCancellationRequested&&i();let a;if(t.onCancellationRequested(()=>{a&&(this._logger.info(`${k} terminating(${a.pid})`),a.kill())}),!this.environmentService.isBuilt)o("Building tunnel CLI from sources and run",!1),o(`${k} Spawning: cargo run -- tunnel ${n.join(" ")}`,!1),a=(0,S.spawn)("cargo",["run","--","tunnel",...n],{cwd:(0,C.join)(this.environmentService.appRoot,"cli")});else{o("Running tunnel CLI",!1);const s=this.getTunnelCommandLocation();o(`${k} Spawning: ${s} tunnel ${n.join(" ")}`,!1),a=(0,S.spawn)(s,["tunnel",...n],{cwd:(0,h.homedir)()})}a.stdout.on("data",s=>{if(a){const l=s.toString();o(l,!1)}}),a.stderr.on("data",s=>{if(a){const l=s.toString();o(l,!0)}}),a.on("exit",s=>{a&&(o(`${k} exit(${a.pid}): + ${s} `,!1),a=void 0,s===0?i():r())}),a.on("error",s=>{a&&(o(`${k} error(${a.pid}): + ${s} `,!0),a=void 0,r())})}))}async getHostName(){return this._getHostName()}_preventSleep(){return!!this.configurationService.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}_getHostName(){let k=this.configurationService.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,h.hostname)();return k=k.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),k||void 0}};v=pe([Y(0,c.ITelemetryService),Y(1,P.IProductService),Y(2,R.INativeEnvironmentService),Y(3,I.ILoggerService),Y(4,d.ISharedProcessLifecycleService),Y(5,f.IConfigurationService)],v),e.RemoteTunnelService=v}),define(se[114],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:I,data:C}){return this.appenders.forEach(S=>S.log(I,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class _{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=_}),define(se[47],oe([0,1,32,12,3,17,74,113,20]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(r){this.value=r}}e.TelemetryTrustedValue=S;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,a){return Promise.resolve(void 0)}publicLog2(r,a){return this.publicLog(r,a)}publicLogError(r,a){return Promise.resolve(void 0)}publicLogError2(r,a){return this.publicLogError(r,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class w{async publicLog(r,a,s){}async publicLogError(r,a,s){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,r){return c.Event.debounce(r.onDidChangeConfiguration,(s,l)=>{const p=s?new Set([...s.affectedKeys,...l.affectedKeys]):l.affectedKeys;return{...l,affectedKeys:p}},1e3,!0)(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:Array.from(s.affectedKeys)})})}e.configurationTelemetry=m;function d(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=d;function f(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=f;function y(i){const r=i.getValue(C.TELEMETRY_SETTING_ID),a=i.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function h(i){const r={},a={},s={};v(i,s);for(let l in s){l=l.length>150?l.substr(l.length-149):l;const p=s[l];typeof p=="number"?a[l]=p:typeof p=="boolean"?a[l]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${p.length}`),r[l]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(r[l]=p)}return{properties:r,measurements:a}}e.validateTelemetryData=h;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(i){if(!i)return"none";const r=(0,D.getRemoteName)(i);return u.has(r)?r:"other"}e.cleanRemoteAuthority=g;function v(i,r,a=0,s){if(!!i)for(const l of Object.getOwnPropertyNames(i)){const p=i[l],E=s?s+l:l;Array.isArray(p)?r[E]=(0,L.safeStringify)(p):p instanceof Date?r[E]=p.toISOString():(0,_.isObject)(p)?a<2?v(p,r,a+1,E+"."):r[E]=(0,L.safeStringify)(p):r[E]=p}}function b(i,r){const a=i.msftInternalDomains||[],s=r.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(a)||s}e.isInternalTelemetry=b;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=k;function n(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const s=[];for(const T of r)for(;;){const A=T.exec(i);if(!A)break;s.push([A.index,T.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(a="";;){const T=p.exec(i);if(!T)break;const A=s.some(([N,W])=>T.index<W&&N<p.lastIndex);!l.test(T[0])&&!A&&(a+=i.substring(E,T.index)+"<REDACTED: user-file-path>",E=p.lastIndex)}return E<i.length&&(a+=i.substr(E)),a}function o(i){if(!i)return i;const r=i.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of a)if(s.regex.test(r))return`<REDACTED: ${s.label}>`;return i}function t(i,r){return(0,L.cloneAndChange)(i,a=>{if(a instanceof S)return a.value;if(typeof a=="string"){let s=a.replaceAll("%20"," ");s=n(s,r);for(const l of r)s=s.replace(l,"");return s=o(s),s}})}e.cleanData=t}),define(se[33],oe([0,1,27,29,46,4,11,7,36,47]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=P;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const r=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,r,a)}static parse(i){const r=w.exec(i);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(t){const i=d.exec(t);return i&&i[1]?[h(i[1]),i[2]]:[h(t),void 0]}e.getIdAndVersion=f;function y(t,i){return`${t}.${i}`}e.getExtensionId=y;function h(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function u(t,i){return h(y(t,i))}e.getGalleryExtensionId=u;function g(t,i){const r=[],a=s=>{for(const l of r)if(l.some(p=>P(i(p),i(s))))return l;return null};for(const s of t){const l=a(s);l?l.push(s):r.push([s])}return r}e.groupByExtension=g;function v(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function b(t){return{id:new S.TelemetryTrustedValue(t.identifier.id),name:new S.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new c.ExtensionIdentifier("pprice.better-merge");function k(t,i){const r=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const s=a.shift();if(s&&r.every(l=>!P(l.identifier,{id:s}))){const l=t.filter(p=>P(p.identifier,{id:s}));l.length===1&&(r.push(l[0]),a.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=k;async function n(t,i){if(!R.isLinux)return!1;let r;try{r=(await t.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){i.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(s))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const r=await n(t,i),a=(0,_.getTargetPlatform)(r?"alpine":R.platform,C.arch);return i.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(se[242],oe([0,1,24,33]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function c(R,D,I,C,S){try{const P=await R.getExtensionsControlManifest();if(!P.deprecated)return;const w=await R.getInstalled(1);for(const[m,d]of Object.entries(P.deprecated)){if(!d?.extension)continue;const{id:f,autoMigrate:y,preRelease:h}=d.extension;if(!y)continue;const u=w.find(v=>(0,_.areSameExtensions)(v.identifier,{id:m}));if(!u)continue;const g=(await D.getExtensions([{id:f,preRelease:h}],{targetPlatform:await R.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!g){S.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{S.info(`Migrating '${u.identifier.id}' extension to '${f}' extension...`);const v=!C.getDisabledExtensions().some(k=>(0,_.areSameExtensions)(k,u.identifier));await R.uninstall(u),S.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let b=w.find(k=>(0,_.areSameExtensions)(k.identifier,{id:f}));(!b||!b.isPreReleaseVersion&&v)&&(b=await R.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${b.identifier.id}'`),v||(await C.disableExtension(b.identifier),S.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),y.storage&&(I.addToMigrationList((0,_.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,_.getExtensionId)(b.manifest.publisher,b.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${u.identifier.id}' extension to '${f}' extension.`)}catch(v){S.error(v)}}}catch(P){S.error(P)}}e.migrateUnsupportedExtensions=c}),define(se[243],oe([0,1,3,2,38,33,46]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends _.Disposable{constructor(S,P,w,m,d,f,y){super(),this.extensionManagementService=S,this.extensionsScannerService=P,this.userDataProfilesService=w,this.extensionsProfileScannerService=m,this.uriIdentityService=d,this.fileService=f,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new _.DisposableMap),this.initialize().then(null,h=>y.error(h))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(S=>this.onDidChangeProfiles(S.added,S.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(S=>this.onAddExtensions(S))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(S=>this.onDidAddExtensions(S))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(S=>this.onRemoveExtensions(S))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(S=>this.onDidRemoveExtensions(S))),this._register(this.fileService.onDidFilesChange(S=>this.onDidFilesChange(S)))}async onDidChangeProfiles(S,P){try{await Promise.all(P.map(w=>(this.extensionsProfileWatchDisposables.deleteAndDispose(w.id),this.removeExtensionsFromProfile(w.extensionsResource)))),S.length&&await Promise.all(S.map(w=>(this.extensionsProfileWatchDisposables.set(w.id,(0,_.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(w.extensionsResource)),this.fileService.watch(w.extensionsResource))),this.populateExtensionsFromProfile(w.extensionsResource))))}catch(w){throw this.logService.error(w),w}}async onAddExtensions(S){for(const P of S.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),S.profileLocation)}async onDidAddExtensions(S){for(const P of S.extensions){const w=this.getKey(P.identifier,P.version);S.error?this.removeExtensionWithKey(w,S.profileLocation):this.addExtensionWithKey(w,S.profileLocation)}}async onRemoveExtensions(S){for(const P of S.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),S.profileLocation)}async onDidRemoveExtensions(S){const P=[],w=[];for(const m of S.extensions){const d=this.getKey(m.identifier,m.version);S.error?this.addExtensionWithKey(d,S.profileLocation):(this.removeExtensionWithKey(d,S.profileLocation),this.allExtensions.has(d)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),w.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(f=>{f?P.push(f):this.logService.info("Extension not found at the location",m.location.toString())},f=>this.logService.error(f)))))}try{await Promise.all(w),P.length&&await this.uninstallExtensionsNotInProfiles(P)}catch(m){this.logService.error(m)}}onDidFilesChange(S){for(const P of this.userDataProfilesService.profiles)S.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(S){const P=[],w=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(S),d=new Set,f=new Set;for(const[y,h]of this.allExtensions)h.has(S)&&f.add(y);for(const y of m){const h=this.getKey(y.identifier,y.version);d.add(h),f.has(h)||(P.push(y.identifier),this.addExtensionWithKey(h,S))}for(const y of f)if(!d.has(y)){const h=this.fromKey(y);h&&(w.push(h.identifier),this.removeExtensionWithKey(y,S))}(P.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:S}:void 0,removed:w.length?{extensions:w,profileLocation:S}:void 0})}async populateExtensionsFromProfile(S){const P=await this.extensionsProfileScannerService.scanProfileExtensions(S);for(const w of P)this.addExtensionWithKey(this.getKey(w.identifier,w.version),S)}async removeExtensionsFromProfile(S){for(const P of[...this.allExtensions.keys()])this.removeExtensionWithKey(P,S);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(S){S||(S=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(w=>!this.allExtensions.has(this.getKey(w.identifier,w.manifest.version)))),S.length&&await this.extensionManagementService.markAsUninstalled(...S)}addExtensionWithKey(S,P){let w=this.allExtensions.get(S);w||this.allExtensions.set(S,w=new c.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),w.add(P)}removeExtensionWithKey(S,P){const w=this.allExtensions.get(S);w&&w.delete(P),w?.size||this.allExtensions.delete(S)}getKey(S,P){return`${D.ExtensionIdentifier.toKey(S.id)}@${P}`}fromKey(S){const[P,w]=(0,R.getIdAndVersion)(S);return w?{identifier:{id:P},version:w}:void 0}}e.ExtensionsWatcher=I}),define(se[244],oe([0,1,44,47]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function c(R,D,I,C,S,P,w){const m={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,_.supportsTelemetry)(D,I)&&(0,_.getTelemetryLevel)(C)===3){const d=await(0,L.getServiceMachineId)(I,S,P),{machineId:f}=await w.getTelemetryInfo();m["X-Market-User-Id"]=d,m["VSCode-SessionId"]=f||d}return m}e.resolveMarketplaceHeaders=c}),define(se[245],oe([0,1,103,19,6,2,22,13,28,15,29,33,9,72,11]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends d.LanguagePackBaseService{constructor(v,b,k,n){super(k),this.extensionManagementService=v,this.logService=n,this.cache=this._register(new h(b,n)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(v,b){const n=(await this.cache.getLanguagePacks())[b];if(!n){this.logService.warn(`No language pack found for ${b}`);return}const o=n.translations[v];return o?f.URI.file(o):void 0}async getInstalledLanguages(){const v=await this.cache.getLanguagePacks(),b=Object.keys(v).map(k=>{const n=v[k];return{...this.createQuickPickItem(k,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return b.push(this.createQuickPickItem("en","English")),b.sort((k,n)=>k.label.localeCompare(n.label)),b}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const b=await this.cache.getLanguagePacks();Object.keys(b).some(k=>b[k]&&b[k].extensions.some(n=>(0,w.areSameExtensions)(n.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,b]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),k=await this.cache.update(b);return!(0,_.equals)(Object.keys(v),Object.keys(k))}};y=pe([Y(0,P.IExtensionManagementService),Y(1,S.INativeEnvironmentService),Y(2,P.IExtensionGalleryService),Y(3,m.ILogService)],y),e.NativeLanguagePackService=y;let h=class extends R.Disposable{constructor(v,b){super(),this.logService=b,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new c.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(b=>{Object.keys(b).forEach(k=>delete b[k]),this.createLanguagePacksFromExtensions(b,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...b){for(const k of b)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,k);Object.keys(v).forEach(k=>this.updateHash(v[k]))}createLanguagePacksFromExtension(v,b){const k=b.identifier,n=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const o of n)if(b.location.scheme===D.Schemas.file&&u(o)){let t=v[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},v[o.languageId]=t);const i=t.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,k))[0];i?i.version=b.manifest.version:t.extensions.push({extensionIdentifier:k,version:b.manifest.version});for(const r of o.translations)t.translations[r.id]=(0,I.join)(b.location.fsPath,r.path)}}updateHash(v){if(v){const b=(0,L.createHash)("md5");for(const k of v.extensions)b.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);v.hash=b.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let b=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(b=v(k),k)).then(k=>{for(const o of Object.keys(k))k[o]||delete k[o];this.languagePacks=k,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),C.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>b,k=>this.logService.error(k))})}};h=pe([Y(0,S.INativeEnvironmentService),Y(1,m.ILogService)],h);function u(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const v of g.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(se[246],oe([0,1,7,32,47]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function I(S,P,w){const m=await new Promise((u,g)=>{ee(["@microsoft/1ds-core-js"],u,g)}),d=await new Promise((u,g)=>{ee(["@microsoft/1ds-post-js"],u,g)}),f=new m.AppInsightsCore,y=new d.PostChannel,h={instrumentationKey:S,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(w){h.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:w};h.extensionConfig[y.identifier]=u}return f.initialize(h,[]),f.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),f}class C{constructor(P,w,m,d,f){this._isInternalTelemetry=P,this._eventPrefix=w,this._defaultData=m,this._xhrOverride=f,this.endPointUrl=R,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof d=="function"?this._aiCoreOrKey=d():this._aiCoreOrKey=d,this._asyncAiCore=null}_withAIClient(P){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=I(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(w=>{P(w)},w=>{(0,L.onUnexpectedError)(w),console.error(w)})}}log(P,w){if(!this._aiCoreOrKey)return;w=(0,_.mixin)(w,this._defaultData),w=(0,c.validateTelemetryData)(w);const m=this._eventPrefix+"/"+P;try{this._withAIClient(d=>{d.pluginVersionString=w?.properties.version??"Unknown",d.track({name:m,baseData:{name:m,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(w=>{w.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(se[115],oe([0,1,2,178,15,9,26,47]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let C=class extends L.Disposable{constructor(P,w,m,d,f=""){super(),this.prefix=f;const y=w.getLogger(m.telemetryLogResource);if(y)this.logger=this._register(y);else{const u=(0,I.isLoggingOnly)(d,m)?" (Not Sent)":"",g=m.telemetryLogResource,v=()=>(0,I.supportsTelemetry)(d,m)&&P.getLevel()===R.LogLevel.Trace;this.logger=this._register(w.createLogger(g,{id:I.telemetryLogChannelId,name:(0,_.localize)(0,null,u),hidden:!v()})),this._register(P.onDidChangeLogLevel(()=>w.setVisibility(g,v()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,w){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,I.validateTelemetryData)(w))}};C=pe([Y(0,R.ILogService),Y(1,R.ILoggerService),Y(2,c.IEnvironmentService),Y(3,D.IProductService)],C),e.TelemetryLogAppender=C}),define(se[116],oe([0,1,2,32,4,27,179,17,45,108,26,40,20,47]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(u,g,v){this._configurationService=g,this._productService=v,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(b),"gi")),b.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(b.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(b=>{(b.affectsConfiguration(m.TELEMETRY_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,g){this._experimentProperties[u]=g}_updateTelemetryLevel(){let u=(0,d.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const v=g.usage?3:g.error?2:0;u=Math.min(u,v)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const u=await this._commonProperties,g=u.sessionID,v=u["common.machineId"],b=u["common.firstSessionDate"],k=u["common.msftInternal"];return{sessionId:g,machineId:v,firstSessionDate:b,msftInternal:k}}dispose(){this._disposables.dispose()}_log(u,g,v){return this._telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(b=>{v=(0,_.mixin)(v,this._experimentProperties),v=(0,d.cleanData)(v,this._cleanupPatterns),v=(0,_.mixin)(v,b),this._appenders.forEach(k=>k.log(u,v))},b=>{console.error(b)})}publicLog(u,g){return this._log(u,3,g)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return this._sendErrorTelemetry?this._log(u,2,g):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=pe([Y(1,I.IConfigurationService),Y(2,P.IProductService)],f),e.TelemetryService=f;function y(){const h=(0,D.localize)(0,null,S.default.nameLong),u=S.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=c.isWeb?"":(0,D.localize)(3,null),v=(0,D.localize)(4,null),b=(0,D.localize)(5,null),k=(0,D.localize)(6,null),n=(0,D.localize)(7,null),o=`
|       | ${v} | ${b} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,D.localize)(8,null);return`
${h} ${u} ${g}

&nbsp;

${n}
${o}

&nbsp;

${t}
`}w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,D.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,D.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[247],oe([0,1,300,246]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class c extends _.AbstractOneDataSystemAppender{constructor(D,I,C,S){const P={sendPOST:(w,m)=>{const d={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const f=L.request(w.urlString,d,y=>{y.on("data",function(h){m(y.statusCode??200,y.headers,h.toString())}),y.on("error",function(h){m(0,{})})});f.write(w.data),f.end()}catch{m(0,{})}}};super(D,I,C,S,P)}}e.OneDataSystemAppender=c}),define(se[248],oe([0,1,22,66,17,15,9,26,20,114,115,116]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(f,y,h,u,g,v){this.configurationService=f,this.telemetryService=y,this.logService=h,this.loggerService=u,this.environmentService=g,this.productService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const{machineId:y,sessionId:h}=await this.telemetryService.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=y,u["common.vscodesessionid"]=h;const g=[f.id,JSON.stringify(u),f.aiKey],b=new _.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),k=[new S.TelemetryAppenderClient(b),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new w.TelemetryService({appenders:k,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}async publicLog(f,y,h){await(await this.getCustomTelemetryService(f)).publicLog(y,h)}async publicLogError(f,y,h){await(await this.getCustomTelemetryService(f)).publicLogError(y,h)}};m=pe([Y(0,c.IConfigurationService),Y(1,C.ITelemetryService),Y(2,D.ILogService),Y(3,D.ILoggerService),Y(4,R.IEnvironmentService),Y(5,I.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(se[117],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(_){_[_.Replace=1]="Replace",_[_.Append=2]="Append",_[_.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(se[249],oe([0,1,4,117]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class c{constructor(C){this.collections=C,this.map=new Map,C.forEach((S,P)=>{const w=S.map.entries();let m=w.next();for(;!m.done;){const d=m.value[0];let f=this.map.get(d);if(f||(f=[],this.map.set(d,f)),f.length>0&&f[0].type===_.EnvironmentVariableMutatorType.Replace){m=w.next();continue}const y=m.value[1];f.unshift({extensionIdentifier:P,value:y.value,type:y.type}),m=w.next()}})}async applyToProcessEnvironment(C,S){let P;L.isWindows&&(P={},Object.keys(C).forEach(w=>P[w.toLowerCase()]=w));for(const[w,m]of this.map){const d=L.isWindows&&P[w.toLowerCase()]||w;for(const f of m){const y=S?await S(f.value):f.value;switch(f.type){case _.EnvironmentVariableMutatorType.Append:C[d]=(C[d]||"")+y;break;case _.EnvironmentVariableMutatorType.Prepend:C[d]=y+(C[d]||"");break;case _.EnvironmentVariableMutatorType.Replace:C[d]=y;break}}}}diff(C){const S=new Map,P=new Map,w=new Map;if(C.map.forEach((m,d)=>{const f=this.map.get(d),y=R(m,f);y&&S.set(d,y)}),this.map.forEach((m,d)=>{const f=C.map.get(d),y=R(m,f);y&&w.set(d,y)}),this.map.forEach((m,d)=>{const f=C.map.get(d),y=D(m,f);y&&P.set(d,y)}),!(S.size===0&&P.size===0&&w.size===0))return{added:S,changed:P,removed:w}}}e.MergedEnvironmentVariableCollection=c;function R(I,C){if(!C)return I;const S=new Set;C.forEach(w=>S.add(w.extensionIdentifier));const P=[];return I.forEach(w=>{S.has(w.extensionIdentifier)||P.push(w)}),P.length===0?void 0:P}function D(I,C){if(!C)return;const S=new Map;C.forEach(w=>S.set(w.extensionIdentifier,w));const P=[];return I.forEach(w=>{const m=S.get(w.extensionIdentifier);m&&(w.type!==m.type||w.value!==m.value)&&P.push(m)}),P.length===0?void 0:P}}),define(se[250],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=L;function _(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=_;function c(D){return Array.from(D.entries()).map(I=>[I[0],L(I[1].map)])}e.serializeEnvironmentVariableCollections=c;function R(D){return new Map(D.map(I=>[I[0],{map:_(I[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(se[251],oe([0,1,6,24,3,2,9]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends R.Disposable{constructor(S,P){super(),this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new c.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=S===void 0?15e3:S}createRequest(S){return new Promise((P,w)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,P),this._onCreateRequest.fire({requestId:m,...S});const d=new _.CancellationTokenSource;(0,L.timeout)(this._timeout,d.token).then(()=>w(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,R.toDisposable)(()=>d.cancel())])})}acceptReply(S,P){const w=this._pendingRequests.get(S);w?(this._pendingRequests.delete(S),(0,R.dispose)(this._pendingRequestDisposables.get(S)||[]),this._pendingRequestDisposables.delete(S),w(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};I=pe([Y(1,D.ILogService)],I),e.RequestStore=I}),define(se[118],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var _;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(_=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var c;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsDefaultColor="terminal.integrated.tabs.defaultColor",v.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.TabStopWidth="terminal.integrated.tabStopWidth",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.TabFocusMode="terminal.integrated.tabFocusMode",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",v.AutoReplies="terminal.integrated.autoReplies",v.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",v.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",v.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",v.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",v.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",v.SmoothScrolling="terminal.integrated.smoothScrolling"})(c=e.TerminalSettingId||(e.TerminalSettingId={}));var R;(function(v){v.FileName="ptyhost"})(R=e.TerminalLogConstants||(e.TerminalLogConstants={}));var D;(function(v){v.PowerShell="pwsh",v.Bash="bash",v.Fish="fish",v.Sh="sh",v.Csh="csh",v.Ksh="ksh",v.Zsh="zsh"})(D=e.PosixShellType||(e.PosixShellType={}));var I;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})(C=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Logger="logger",v.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var P;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions",v.FailedShellIntegrationActivation="failedShellIntegrationActivation",v.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var d;(function(v){v.TerminalView="view",v.Editor="editor"})(d=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}));var u;(function(v){v[v.Off=0]="Off",v[v.FinalTerm=1]="FinalTerm",v[v.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(v){v[v.Unknown=0]="Unknown",v[v.Shutdown=1]="Shutdown",v[v.Process=2]="Process",v[v.User=3]="User",v[v.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(se[252],oe([0,1,52,11,181,135]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function D(m,d){const f=[{name:null,description:(0,c.localize)(0,null)}];return f.push(...m.map(y=>({name:y.profileName,description:I(y)}))),d&&f.push(...d.map(y=>({name:y.title,description:C(y)}))),{values:f.map(y=>y.name),markdownDescriptions:f.map(y=>y.description)}}e.createProfileSchemaEnums=D;function I(m){let d=`$(${R.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:L.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?d+=`
- args: "${m.args}"`:d+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(d+=`
- overrideName: ${m.overrideName}`),m.color&&(d+=`
- color: ${m.color}`),m.env&&(d+=`
- env: ${JSON.stringify(m.env)}`),d}function C(m){return`$(${R.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:L.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function S(m,d){if(!m&&!d)return!0;if(typeof m=="string"&&typeof d=="string")return m===d;if(Array.isArray(m)&&Array.isArray(d)){if(m.length!==d.length)return!1;for(let f=0;f<m.length;f++)if(m[f]!==d[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function P(m,d){if(!m&&!d)return!0;if(!m||!d)return!1;if(R.ThemeIcon.isThemeIcon(m)&&R.ThemeIcon.isThemeIcon(d))return m.id===d.id&&m.color===d.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof d=="object"&&"light"in d&&"dark"in d){const f=m,y=d;if((_.URI.isUri(f.light)||w(f.light))&&(_.URI.isUri(f.dark)||w(f.dark))&&(_.URI.isUri(y.light)||w(y.light))&&(_.URI.isUri(y.dark)||w(y.dark)))return f.light.path===y.light.path&&f.dark.path===y.dark.path}if(_.URI.isUri(m)&&_.URI.isUri(d)||w(m)||w(d)){const f=m,y=d;return f.path===y.path&&f.scheme===y.scheme}return!1}e.terminalIconsEqual=P;function w(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=w}),define(se[253],oe([0,1,52,180,45,40,252]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,L.getAllCodicons)(),b=>b.id),markdownEnumDescriptions:Array.from((0,L.getAllCodicons)(),b=>`$(${b.id})`)};const I={args:{description:(0,_.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,_.localize)(1,null),type:"boolean"},icon:{description:(0,_.localize)(2,null),...e.terminalIconSchema},color:{description:(0,_.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,_.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},S={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(6,null),type:["string"],items:{type:"string"}},...I}},P=(0,_.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,_.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,_.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,_.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,_.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,_.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),h={id:"terminal",order:100,title:(0,_.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,_.localize)(26,null)}},{type:"string",markdownDescription:(0,_.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,_.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(30,null),type:"string"},id:{description:(0,_.localize)(31,null),type:"string"},title:{description:(0,_.localize)(32,null),type:"string"},...I}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(34,null),type:"string"},id:{description:(0,_.localize)(35,null),type:"string"},title:{description:(0,_.localize)(36,null),type:"string"},...I}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(38,null),type:"string"},id:{description:(0,_.localize)(39,null),type:"string"},title:{description:(0,_.localize)(40,null),type:"string"},...I}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,_.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,_.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,_.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,_.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,_.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){R.Registry.as(c.Extensions.Configuration).registerConfiguration(h),v()}e.registerTerminalPlatformConfiguration=u;let g;function v(b,k){const n=R.Registry.as(c.Extensions.Configuration);let o;b&&(o=(0,D.createProfileSchemaEnums)(b?.profiles,k));const t=g;g={id:"terminal",order:100,title:(0,_.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?o?.values:void 0,markdownEnumDescriptions:b?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?o?.values:void 0,markdownEnumDescriptions:b?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?o?.values:void 0,markdownEnumDescriptions:b?.os===1?o?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(se[254],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(se[255],oe([0,1,34,22,32,13,4,36,27,12,28,117,250,249]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function f(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let r=0;return i&&i.length===4&&(r=parseInt(i[3])),r}e.getWindowsBuildNumber=f;async function y(i,r,a,s=I.env,l=P.Promises.exists){if(R.isAbsolute(i))return await l(i)?i:void 0;if(r===void 0&&(r=I.cwd()),R.dirname(i)!=="."){const A=R.join(r,i);return await l(A)?A:void 0}const E=(0,c.getCaseInsensitive)(s,"PATH");if(a===void 0&&(0,S.isString)(E)&&(a=E.split(R.delimiter)),a===void 0||a.length===0){const A=R.join(r,i);return await l(A)?A:void 0}for(const A of a){let N;if(R.isAbsolute(A)?N=R.join(A,i):N=R.join(r,A,i),await l(N))return N;if(D.isWindows){let W=N+".com";if(await l(W)||(W=N+".exe",await l(W)))return W}}const T=R.join(r,i);return await l(T)?T:void 0}e.findExecutable=y;function h(i,r,a,s,l){const p=D.isWindows&&(!r.windowsEnableConpty||f()<18309);if(!r.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||p)return;const E=i.args,T=I.platform==="win32"?R.basename(i.executable).toLowerCase():R.basename(i.executable),A=R.dirname(_.FileAccess.asFileUri("").fsPath);let N;const W={VSCODE_INJECTION:"1"};if(D.isWindows){if(T==="pwsh.exe"||T==="powershell.exe")return!E||o(E)?N=v.get(g.WindowsPwsh):n(E)&&(N=v.get(g.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,C.format)(N[N.length-1],A,""),r.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),{newArgs:N,envMixin:W}):void 0;s.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(T){case"bash":return!E||E.length===0?N=v.get(g.Bash):t(E)&&(W.VSCODE_SHELL_LOGIN="1",u(r,W),N=v.get(g.Bash)),N?(N=[...N],N[N.length-1]=(0,C.format)(N[N.length-1],A),{newArgs:N,envMixin:W}):void 0;case"fish":{const V=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",K=R.join(A,"out/vs/workbench/contrib/xdg_data");return W.XDG_DATA_DIRS=`${V}:${K}`,u(r,W),{newArgs:void 0,envMixin:W}}case"pwsh":return!E||o(E)?N=v.get(g.Pwsh):n(E)&&(N=v.get(g.PwshLogin)),N?(r.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),N=[...N],N[N.length-1]=(0,C.format)(N[N.length-1],A,""),{newArgs:N,envMixin:W}):void 0;case"zsh":{if(!E||E.length===0?N=v.get(g.Zsh):t(E)?(N=v.get(g.ZshLogin),u(r,W)):(E===v.get(g.Zsh)||E===v.get(g.ZshLogin))&&(N=E),!N)return;N=[...N],N[N.length-1]=(0,C.format)(N[N.length-1],A);let V;try{V=L.userInfo().username}catch{V="unknown"}const K=R.join(L.tmpdir(),`${V}-${l.applicationName}-zsh`);W.ZDOTDIR=K;const z=a?.ZDOTDIR??L.homedir()??"~";W.USER_ZDOTDIR=z;const O=[];return O.push({source:R.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.join(K,".zshrc")}),O.push({source:R.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.join(K,".zprofile")}),O.push({source:R.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.join(K,".zshenv")}),O.push({source:R.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.join(K,".zlogin")}),{newArgs:N,envMixin:W,filesToCopy:O}}}s.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=h;function u(i,r){if(D.isMacintosh&&i.environmentVariableCollections){const a=(0,m.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),l=new d.MergedEnvironmentVariableCollection(a).map.get("PATH"),p=[];if(l)for(const E of l)E.type===w.EnvironmentVariableMutatorType.Prepend&&p.push(E.value);p.length>0&&(r.VSCODE_PATH_PREFIX=p.join(""))}}var g;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(g||(g={}));const v=new Map;v.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(g.Zsh,["-i"]),v.set(g.ZshLogin,["-il"]),v.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],k=["-nol","-nologo"];function n(i){return typeof i=="string"?b.includes(i.toLowerCase()):i.length===1&&b.includes(i[0].toLowerCase())||i.length===2&&(b.includes(i[0].toLowerCase())||b.includes(i[1].toLowerCase()))&&(k.includes(i[0].toLowerCase())||k.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?k.includes(i.toLowerCase()):i.length===0||i?.length===1&&k.includes(i[0].toLowerCase())}function t(i){return i==="string"&&b.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&b.includes(i[0].toLowerCase())}}),define(se[256],oe([0,1,50,52,13,4,12,28,94,255]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,w=!0;function m(o,t,i,r,a=process.env,s,l,p,E){return s=s||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},R.isWindows?d(i,s,a,l,r.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:r.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:r.getValue("terminal.integrated.defaultProfile.windows"),E,p):b(s,l,i,o&&typeof o=="object"?{...o}:r.getValue(R.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:r.getValue(R.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),E,p,a)}e.detectAvailableProfiles=m;async function d(o,t,i,r,a,s,l,p,E){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let N=!1;(0,S.getWindowsBuildNumber)()>=16299&&(N=!0),await h(p);const W=new Map;if(o){W.set("PowerShell",{source:"PowerShell",icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),W.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),W.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),W.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:_.Codicon.terminalCmd,isAutoDetected:!0}),W.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),W.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:_.Codicon.terminalBash,isAutoDetected:!0});const K=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;W.set("Cmder",{path:`${A}\\cmd.exe`,args:["/K",K],requiresPath:process.env.CMDER_ROOT?K:{path:K,isUnsafe:!0},isAutoDetected:!0})}k(s,W);const V=await f(W.entries(),l,t,i,r,E);if(o||a)try{const K=await g(`${A}\\${N?"wsl":"bash"}.exe`,l);for(const z of K)(!s||!(z.profileName in s))&&V.push(z)}catch{w&&(r?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return V}async function f(o,t,i,r=process.env,a,s){const l=[];for(const[p,E]of o){if(E===null)continue;let T,A,N;if("source"in E){const z=P?.get(E.source);if(!z)continue;T=z.paths,A=E.args||z.args,E.icon?N=y(E.icon):z.icon&&(N=z.icon)}else T=Array.isArray(E.path)?E.path:[E.path],A=R.isWindows||Array.isArray(E.args)?E.args:void 0,N=y(E.icon);let W;if(s){const z=T.map($=>typeof $=="string"?$:$.path),O=await s(z);W=new Array(T.length);for(let $=0;$<T.length;$++)typeof T[$]=="string"?W[$]=O[$]:W[$]={path:O[$],isUnsafe:!0}}else W=T.slice();let V;if(E.requiresPath){let z;if((0,D.isString)(E.requiresPath)?z=E.requiresPath:(z=E.requiresPath.path,E.requiresPath.isUnsafe&&(V=z)),!await i.existsFile(z))continue}const K=await n(p,t,W,i,r,A,E.env,E.overrideName,E.isAutoDetected,V);K?(K.isAutoDetected=E.isAutoDetected,K.icon=N,K.color=E.color,l.push(K)):a?.debug("Terminal profile not validated",p,T)}return a?.debug("Validated terminal profiles",l),l}function y(o){return typeof o=="string"?{id:o}:o}async function h(o){P&&!o||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),P.set("PowerShell",{profileName:"PowerShell",paths:o||await u(),icon:_.Codicon.terminalPowershell}))}async function u(){const o=[];for await(const t of(0,C.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function g(o,t){const i=[],r=await new Promise((l,p)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(E,T)=>{if(E)return p("Problem occurred when getting wsl distros");l(T)})});if(!r)return[];const a=new RegExp(/[\r?\n]/),s=r.split(a).filter(l=>l.trim().length>0&&l!=="");for(const l of s){if(l===""||l.startsWith("docker-desktop"))continue;const p=`${l} (WSL)`,E={profileName:p,path:o,args:["-d",`${l}`],isDefault:p===t,icon:v(l),isAutoDetected:!1};i.push(E)}return i}function v(o){return o.includes("Ubuntu")?_.Codicon.terminalUbuntu:o.includes("Debian")?_.Codicon.terminalDebian:_.Codicon.terminalLinux}async function b(o,t,i,r,a,s,l,p){const E=new Map;if(i){const T=(await o.readFile("/etc/shells")).toString(),A=s||T.split(`
`).filter(W=>W.trim().includes("#")&&W.trim().length>0),N=new Map;for(const W of A){let V=(0,c.basename)(W),K=N.get(V)||0;K++,K>1&&(V=`${V} (${K})`),N.set(V,K),E.set(V,{path:W,isAutoDetected:!0})}}return k(r,E),await f(E.entries(),a,o,p,t,l)}function k(o,t){if(!!o)for(const[i,r]of Object.entries(o))r===null||typeof r!="object"||!("path"in r)&&!("source"in r)?t.delete(i):(r.icon=r.icon||t.get(i)?.icon,t.set(i,r))}async function n(o,t,i,r,a,s,l,p,E,T){if(i.length===0)return Promise.resolve(void 0);const A=i.shift();if(A==="")return n(o,t,i,r,a,s,l,p,E);const N=typeof A!="string"&&A.isUnsafe,W=typeof A=="string"?A:A.path,V={profileName:o,path:W,args:s,env:l,overrideName:p,isAutoDetected:E,isDefault:o===t,isUnsafePath:N,requiresUnsafePath:T};if((0,c.basename)(W)===W){const z=a.PATH?a.PATH.split(c.delimiter):void 0,O=await(0,S.findExecutable)(W,void 0,z,void 0,r.existsFile);return O?(V.path=O,V.isFromPath=!0,V):n(o,t,i,r,a,s)}return await r.existsFile((0,c.normalize)(W))?V:n(o,t,i,r,a,s,l,p,E)}}),define(se[257],oe([0,1,3,2,22,4,37,66,17,15,98,238,9,251,118,253,256,107]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(k){k[k.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let v=0,b=class extends _.Disposable{constructor(n,o,t,i,r,a){super(),this._reconnectConstants=n,this.loggerName=o,this._configurationService=t,this._environmentService=i,this._logService=r,this._loggerService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new L.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new L.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new L.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new L.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new L.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,_.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(R.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:v,VSCODE_PTY_LOG_NAME:this.loggerName,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,P.parsePtyHostDebugPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?n.debugBrk=o.port:!o.break&&o.port&&(n.debug=o.port));const t=new I.Client(c.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this._onPtyHostStart.fire(),D.ProxyChannel.toService(t.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this._register(new u.RemoteLoggerChannelClient(this._loggerService,t.getChannel(f.TerminalIpcChannels.Logger)));const r=D.ProxyChannel.toService(t.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(r.onProcessData(a=>this._onProcessData.fire(a))),this._register(r.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(r.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(r.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(r.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(r.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(r.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,r]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,o,t,i,r,a,s,l,p,E,T){const A=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(n,o,t,i,r,a,s,l,p,E,T);return clearTimeout(A),v=Math.max(v,N),N}updateTitle(n,o,t){return this._proxy.updateTitle(n,o,t)}updateIcon(n,o,t,i){return this._proxy.updateIcon(n,o,t,i)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,o){return this._proxy.detachFromProcess(n,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,o){return this._proxy.shutdown(n,o)}input(n,o){return this._proxy.input(n,o)}processBinary(n,o){return this._proxy.processBinary(n,o)}resize(n,o,t){return this._proxy.resize(n,o,t)}acknowledgeDataEvent(n,o){return this._proxy.acknowledgeDataEvent(n,o)}setUnicodeVersion(n,o){return this._proxy.setUnicodeVersion(n,o)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,o){return this._proxy.installAutoReply(n,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,o,t,i=!1){const r=await this._shellEnv;return(0,h.detectAvailableProfiles)(o,t,i,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n,o){return this._proxy.getWslPath(n,o)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,o){return this._proxy.requestDetachInstance(n,o)}async acceptDetachInstanceReply(n,o){return this._proxy.acceptDetachInstanceReply(n,o)}async freePortKillProcess(n){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(n)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,o){return this._proxy.reviveTerminalProcesses(n,o)}async refreshProperty(n,o){return this._proxy.refreshProperty(n,o)}async updateProperty(n,o,t){return this._proxy.updateProperty(n,o,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:o})}async acceptPtyHostResolvedVariables(n,o){this._resolveVariablesRequestStore.acceptReply(n,o)}};b=pe([Y(2,C.IConfigurationService),Y(3,S.IEnvironmentService),Y(4,m.ILogService),Y(5,m.ILoggerService)],b),e.PtyHostService=b}),define(se[76],oe([0,1,3,17,5,9]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,c.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,c.createDecorator)("sharedTunnelsService");var D;(function(y){y.Http="http",y.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=w;function m(y,h,u,g){if(u===1)return!1;if(u===2&&w(h)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(v?.length===4&&parseInt(v[1])>=18)return!1}return y<1024}e.isPortPrivileged=m;class d{constructor(h,u,g){this.remoteAddress=h,this.localAddress=u,this._dispose=g,this._onDispose=new L.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let f=class{constructor(h,u){this.logService=h,this.configurationService=u,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const h=this.configurationService.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],u=Array.from(this._tunnels.values());for(const g of u){const v=Array.from(g.values());for(const b of v){const k=await b.value;k&&h.push(k)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:u}of h.values())await u.then(g=>g?.dispose());h.clear()}this._tunnels.clear()}setEnvironmentTunnel(h,u,g,v,b){this.addTunnelToMap(h,u,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:u,localAddress:g,privacy:v,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,u){(w(h)||P(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(h,u);if(g)return++g.refcount,g.value}openTunnel(h,u,g,v,b,k=!1,n,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${b}.`),!h)return;if(u||(u="localhost"),v||(v=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(h,u,g,v,b,k,n,o);return t?t.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this._tunnels.get(h.tunnelRemoteHost);if(u){const g=u.get(h.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,g))}}}}async tryDisposeTunnel(h,u,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const v=g.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(u),v}}async closeTunnel(h,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const g=this._tunnels.get(h);if(g&&g.has(u)){const v=g.get(u);v.refcount=0,await this.tryDisposeTunnel(h,u,v)}}addTunnelToMap(h,u,g){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(u,{refcount:1,value:g})}async removeEmptyTunnelFromMap(h,u){const g=this._tunnels.get(h);g&&(await g.get(u)||g.delete(u),g.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,u){const g=[h];P(h)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(h)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const v=g.map(b=>this._tunnels.get(b));for(const b of v){const k=b?.get(u);if(k)return k}}canTunnel(h){return!!S(h)}createWithProvider(h,u,g,v,b,k,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${v}.`);const o=g;this._factoryInProgress.add(o);const t=v===void 0?g:v,i={elevationRequired:b?this.isPortPrivileged(t):!1},r={remoteAddress:{host:u,port:g},localAddressPort:v,privacy:k,public:k?k!==I.Private:void 0,protocol:n},a=h.forwardPort(r,i);return a?(this.addTunnelToMap(u,g,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),a}};f=pe([Y(0,R.ILogService),Y(1,_.IConfigurationService)],f),e.AbstractTunnelService=f}),define(se[258],oe([0,1,9,76,2,7,6]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends c.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new D.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class Dt extends c.Disposable{constructor(P,w){super(),this._tunnelService=P,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Dt._lastId)}}async startTunnel(P,w,m,d,f,y,h){const u=new I,g=await Promise.resolve(this._tunnelService.openTunnel(P,u,m,d,f,y,h));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${d} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),u.dispose(),await g.dispose(),(0,R.canceled)();return u.setTunnel(g),this._tunnels.set(w,u),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${g.localAddress} (local) to ${m}:${d} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(P,w){const m=this._tunnels.get(P);!m||m.setAddress(w)}async destroyTunnel(P){const w=this._tunnels.get(P);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await w.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=pe([Y(0,_.ISharedTunnelsService),Y(1,L.ILogService)],C),e.SharedProcessTunnelService=C}),define(se[259],oe([0,1,86,34,137,230,6,2,17,9,26,228,76,112,4]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(b,k,n,o,t){let i;for(let r=3;r&&(i?.dispose(),i=await new h(b,k,n,o,t).waitForReady(),!(t&&c.BROWSER_RESTRICTED_PORTS[t]||!c.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));r--);return i}class h extends I.Disposable{constructor(k,n,o,t,i){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=i,this.privacy=m.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=k,this._server=L.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const k=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,m.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let o=await(0,c.findFreePortFaster)(k,2,1e3,n),t=null;return this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(o=0,this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(k){k.pause();const n=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,w.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=o.getSocket().socket,i=o.readEntireBuffer();o.dispose(),i.byteLength>0&&k.write(i.buffer),k.on("end",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),t.end()}),k.on("close",()=>t.end()),k.on("error",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),t.destroy()}),t.on("end",()=>k.end()),t.on("close",()=>k.end()),t.on("error",()=>{k.destroy()}),k.pipe(t),t.pipe(k),k.localAddress&&this._socketsDispose.set(k.localAddress,()=>{k.end(),t.end()})}}let u=class extends m.AbstractTunnelService{constructor(k,n,o,t,i){super(n,i),this.socketFactory=k,this.signService=o,this.productService=t}isPortPrivileged(k){return(0,m.isPortPrivileged)(k,this.defaultTunnelHost,f.OS,_.release())}retainOrCreateTunnel(k,n,o,t,i,r,a,s){const l=this.getTunnelFromMap(n,o);if(l)return++l.refcount,l.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,o,i,r,a,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${o} on local port ${i}.`);const p={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:k,signService:this.signService,logService:this.logService,ipcLogger:null},E=y(p,t,n,o,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,o,E),E}}};u=pe([Y(1,S.ILogService),Y(2,d.ISignService),Y(3,P.IProductService),Y(4,C.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(k,n,o,t){super(R.nodeSocketFactory,k,n,o,t)}};g=pe([Y(0,S.ILogService),Y(1,d.ISignService),Y(2,P.IProductService),Y(3,C.IConfigurationService)],g),e.TunnelService=g;let v=class extends I.Disposable{constructor(k,n,o,t){super(),this.logService=k,this.productService=n,this.signService=o,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(k,n,o,t,i,r,a,s,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${r}.`),!this._tunnelServices.has(k)){const p=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(p),this._tunnelServices.set(k,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this._tunnelServices.delete(k))})}return this._tunnelServices.get(k).openTunnel(n,o,t,i,r,a,s,l)}};v=pe([Y(0,S.ILogService),Y(1,P.IProductService),Y(2,d.ISignService),Y(3,C.IConfigurationService)],v),e.SharedTunnelsService=v}),define(se[30],oe([0,1,5]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(se[260],oe([0,1,30,69,14,25,133,3,2]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(m){this.uri=m,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let P=class{constructor(m){this._fileService=m,this._dispooables=new C.DisposableStore,this._limit=2**16;const d=new Map,f=y=>{let h=d.get(y.scheme);return h===void 0&&(h=m.hasProvider(y)&&!this._fileService.hasCapability(y,1024),d.set(y.scheme,h)),h};this._dispooables.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{d.delete(y.scheme)})),this.extUri=new R.ExtUri(f),this._canonicalUris=new D.SkipList((y,h)=>this.extUri.compare(y,h,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,R.normalizePath)(m));const d=this._canonicalUris.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new S(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((f,y)=>f[1].time<y[1].time?1:f[1].time>y[1].time?-1:0);S._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let f=0;f<d;f++)this._canonicalUris.set(m[f][0],m[f][1].touch())}};P=pe([Y(0,c.IFileService)],P),e.UriIdentityService=P,(0,_.registerSingleton)(L.IUriIdentityService,P,1)}),define(se[261],oe([0,1,3,2,14,43,49,16]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends _.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(P,w,m,d){super(),this.fileSystemScheme=P,this.fileSystemProvider=w,this.userDataScheme=m,this.logService=d,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=D.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(P,w){this.watchResources.set(P,P);const m=this.fileSystemProvider.watch(this.toFileSystemResource(P),w);return(0,_.toDisposable)(()=>{this.watchResources.delete(P),m.dispose()})}stat(P){return this.fileSystemProvider.stat(this.toFileSystemResource(P))}mkdir(P){return this.fileSystemProvider.mkdir(this.toFileSystemResource(P))}rename(P,w,m){return this.fileSystemProvider.rename(this.toFileSystemResource(P),this.toFileSystemResource(w),m)}readFile(P){return this.fileSystemProvider.readFile(this.toFileSystemResource(P),{atomic:!0})}readFileStream(P,w,m){const d=(0,R.newWriteableStream)(f=>I.VSBuffer.concat(f.map(y=>I.VSBuffer.wrap(y))).buffer);return(async()=>{try{const f=await this.readFile(P);d.end(f)}catch(f){d.error(f),d.end()}})(),d}readdir(P){return this.fileSystemProvider.readdir(this.toFileSystemResource(P))}writeFile(P,w,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(P),w,m)}delete(P,w){return this.fileSystemProvider.delete(this.toFileSystemResource(P),w)}copy(P,w,m){if((0,c.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(P),this.toFileSystemResource(w),m);throw new Error("copy not supported")}handleFileChanges(P){const w=[];for(const m of P){if(m.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(m.resource);this.watchResources.findSubstr(d)&&w.push({resource:d,type:m.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(P){return P.with({scheme:this.fileSystemScheme})}toUserDataResource(P){return P.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=C}),define(se[60],oe([0,1,83]),function(ee,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function _(D,I,C,S){const P=(0,L.setProperty)(D,I,C,S)[0];return P&&(D=D.substring(0,P.offset)+P.content+D.substring(P.offset+P.length)),D}e.edit=_;function c(D,I,C){let S=C;for(;S>=0;){if(D.charAt(S)===I.charAt(I.length-1)&&I.length===1)return S+1;if(S--,I.length===2&&S>=0&&D.charAt(S)===I.charAt(0))return S+2}return 0}e.getLineStartOffset=c;function R(D,I,C){let S=C;for(;S>=0;)if(D.charAt(S)===I.charAt(I.length-1)&&I.length===1||(S++,I.length===2&&S>=0&&D.charAt(S)===I.charAt(1)))return S;return D.length-1}e.getLineEndOffset=R}),define(se[262],oe([0,1,32,54,12]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(d,f,y,h,u,g){const v=[],b=[],k=[];if(!f){const K=d.filter(({identifier:z})=>u.every(O=>O.toLowerCase()!==z.id.toLowerCase()));return{local:{added:v,removed:b,updated:k},remote:K.length>0?{added:K,updated:[],removed:[],all:K}:null}}d=d.map(w),f=f.map(w),y=y?y.map(w):null;const n=new Map,o=K=>{K.uuid&&n.set(K.id.toLowerCase(),K.uuid)};d.forEach(({identifier:K})=>o(K)),f.forEach(({identifier:K})=>o(K)),y?.forEach(({identifier:K})=>o(K));const t=K=>{const z=K.identifier.uuid||n.get(K.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${K.identifier.id.toLowerCase()}`},i=(K,z)=>(K.set(t(z),z),K),r=d.reduce(i,new Map),a=f.reduce(i,new Map),s=f.reduce((K,z)=>i(K,(0,L.deepClone)(z)),new Map),l=y?y.reduce(i,new Map):null,p=h.reduce(i,new Map),E=u.reduce((K,z)=>{const O=n.get(z.toLowerCase());return K.add(O?`uuid:${O}`:`id:${z.toLowerCase()}`)},new Set),T=g?g.reduce((K,{id:z,uuid:O})=>(O=O??n.get(z.toLowerCase()),K.add(O?`uuid:${O}`:`id:${z.toLowerCase()}`)),new Set):null,A=D(r,a,E,!1);if(A.added.size>0||A.removed.size>0||A.updated.size>0){const K=D(l,r,E,!1),z=D(l,a,E,!0),O=($,Z,q,j)=>{let M,J,Q;return Z.installed?(M=j.pinned,Q=j.preRelease,M&&(J=j.version)):(M=q.pinned,Q=q.preRelease,M&&(J=q.version)),M===void 0&&(M=Z.pinned,M&&(J=Z.version)),Q===void 0&&(Q=Z.preRelease),{...j,installed:Z.installed||q.installed,pinned:M,preRelease:Q,version:J??(q.version&&(!Z.installed||_.gt(q.version,Z.version))?q.version:Z.version),state:C(Z,q,l?.get($))}};for(const $ of z.removed.values()){const Z=r.get($);if(!Z)continue;const q=(0,c.assertIsDefined)(l?.get($)),j=T&&!T.has($)&&q.installed;Z.installed&&j?b.push(Z.identifier):s.set($,Z)}for(const $ of z.added.values()){const Z=(0,c.assertIsDefined)(a.get($)),q=r.get($);if(q){if(A.updated.has($)){const j=O($,q,Z,Z);I(q,Z,!1,!1)||k.push(m(j,$)),s.set($,j)}}else Z.installed&&v.push(m(Z,$))}for(const $ of z.updated.values()){const Z=(0,c.assertIsDefined)(a.get($)),q=(0,c.assertIsDefined)(l?.get($)),j=r.get($);if(j)if(T&&!T.has($)&&q.installed&&j.installed&&!Z.installed)b.push(j.identifier);else{const J=O($,j,Z,Z);k.push(m(J,$)),s.set($,J)}else Z.installed&&v.push(m(Z,$))}for(const $ of K.added.values())z.added.has($)||s.set($,(0,c.assertIsDefined)(r.get($)));for(const $ of K.updated.values()){if(z.removed.has($)||z.updated.has($))continue;const Z=(0,c.assertIsDefined)(r.get($)),q=(0,c.assertIsDefined)(a.get($));s.set($,O($,Z,q,Z))}for(const $ of K.removed.values())z.updated.has($)||z.removed.has($)||p.has($)||!(0,c.assertIsDefined)(a.get($)).installed||!T||T.has($)||!(0,c.assertIsDefined)(l?.get($)).installed||s.delete($)}const N=[],W=D(a,s,new Set,!0),V=W.added.size>0||W.updated.size>0||W.removed.size>0;return V&&s.forEach((K,z)=>N.push(m(K,z))),{local:{added:v,removed:b,updated:k},remote:V?{added:[...W.added].map(K=>s.get(K)),updated:[...W.updated].map(K=>s.get(K)),removed:[...W.removed].map(K=>a.get(K)),all:N}:null}}e.merge=R;function D(d,f,y,h){const u=d?[...d.keys()].filter(n=>!y.has(n)):[],g=[...f.keys()].filter(n=>!y.has(n)),v=g.filter(n=>u.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),b=u.filter(n=>g.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),k=new Set;for(const n of u){if(b.has(n))continue;const o=d.get(n),t=f.get(n);(!t||!I(o,t,h,!0))&&k.add(n)}return{added:v,removed:b,updated:k}}function I(d,f,y,h){return!(d.disabled!==f.disabled||h&&d.installed!==f.installed||d.installed&&f.installed&&(d.preRelease!==f.preRelease||d.pinned!==f.pinned||f.pinned&&d.version!==f.version)||!P(d.state,f.state)||y&&d.version!==f.version)}function C(d,f,y){const h=d.state,u=f.state,g=y?.state;if(!f.version||h&&_.gt(d.version,f.version))return h;if(u&&_.gt(f.version,d.version)||!h)return u;if(!u)return h;const v=(0,L.deepClone)(h),b=g?S(g,u):{added:Object.keys(u).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set},k=g?S(g,h):{added:Object.keys(h).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set};for(const n of[...b.added.values(),...b.updated.values()])v[n]=u[n];for(const n of b.removed.values())k.updated.has(n)||delete v[n];return v}function S(d,f){const y=Object.keys(d),h=Object.keys(f),u=h.filter(b=>y.indexOf(b)===-1).reduce((b,k)=>(b.add(k),b),new Set),g=y.filter(b=>h.indexOf(b)===-1).reduce((b,k)=>(b.add(k),b),new Set),v=new Set;for(const b of y){if(g.has(b))continue;const k=d[b],n=f[b];(0,L.equals)(k,n)||v.add(b)}return{added:u,removed:g,updated:v}}function P(d={},f={}){const{added:y,removed:h,updated:u}=S(d,f);return y.size===0&&h.size===0&&u.size===0}function w(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function m(d,f){const y={identifier:{id:d.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},version:d.version,preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled&&(y.disabled=!0),d.installed&&(y.installed=!0),d.state&&(y.state=d.state),y}}),define(se[119],oe([0,1,19,17,5]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,c.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,C){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==I&&P!==`-${I}`),C&&S.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(I,C){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==I&&P!==`-${I}`),C&&S.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(I){const C=I.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),P=[],w=[];if(Array.isArray(S))for(const m of S)m.startsWith("-")?w.push(m.substring(1)):P.push(m);return(0,L.distinct)([...C,...P].filter(m=>w.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};R=pe([Y(0,_.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(se[263],oe([0,1,19,35,32,202,60]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function I(b){return(0,_.parse)(b)||[]}async function C(b,k,n,o,t){const i=I(b),r=I(k),a=n?I(n):null,s=[...i,...r,...a||[]].map(O=>O.key),l=await t.resolveUserBindings(s),p=P(i,r,a,l);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const E=m(i),T=m(r),A=a?m(a):null,N=f(E,T,l),W=A?f(A,E,l):{added:[...E.keys()].reduce((O,$)=>(O.add($),O),new Set),removed:new Set,updated:new Set},V=A?f(A,T,l):{added:[...T.keys()].reduce((O,$)=>(O.add($),O),new Set),removed:new Set,updated:new Set},K=S(N,W,V);let z=b;for(const O of K.removed.values())K.conflicts.has(O)||(z=g(z,O,o));for(const O of K.added.values()){if(K.conflicts.has(O))continue;const $=T.get(O);if($.some(Z=>Z.command!==`-${O}`&&p.conflicts.has(l[Z.key]))){K.conflicts.add(O);continue}z=u(z,$,o)}for(const O of K.updated.values()){if(K.conflicts.has(O))continue;const $=T.get(O);if($.some(Z=>Z.command!==`-${O}`&&p.conflicts.has(l[Z.key]))){K.conflicts.add(O);continue}z=v(z,O,$,o)}return{mergeContent:z,hasChanges:!0,hasConflicts:K.conflicts.size>0}}e.merge=C;function S(b,k,n){const o=new Set,t=new Set,i=new Set,r=new Set;for(const a of k.removed.values())n.updated.has(a)&&r.add(a);for(const a of n.removed.values())r.has(a)||(k.updated.has(a)?r.add(a):t.add(a));for(const a of k.added.values())r.has(a)||n.added.has(a)&&b.updated.has(a)&&r.add(a);for(const a of n.added.values())r.has(a)||(k.added.has(a)?b.updated.has(a)&&r.add(a):o.add(a));for(const a of k.updated.values())r.has(a)||n.updated.has(a)&&b.updated.has(a)&&r.add(a);for(const a of n.updated.values())r.has(a)||(k.updated.has(a)?b.updated.has(a)&&r.add(a):i.add(a));return{added:o,removed:t,updated:i,conflicts:r}}function P(b,k,n,o){const t=new Set,i=w(b,o),r=w(k,o),a=n?w(n,o):null,s=d(i,r);if(s.added.size===0&&s.removed.size===0&&s.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const l=a?d(a,i):{added:[...i.keys()].reduce((W,V)=>(W.add(V),W),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const p=a?d(a,r):{added:[...r.keys()].reduce((W,V)=>(W.add(V),W),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:E,removed:T,updated:A,conflicts:N}=S(s,l,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:T,updated:A,conflicts:N}}function w(b,k){const n=new Map;for(const o of b){const t=k[o.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(o)}return n}function m(b){const k=new Map;for(const n of b){const o=n.command[0]==="-"?n.command.substring(1):n.command;let t=k.get(o);t||(t=[],k.set(o,t)),t.push(n)}return k}function d(b,k){const n=[...b.keys()],o=[...k.keys()],t=o.filter(a=>n.indexOf(a)===-1).reduce((a,s)=>(a.add(s),a),new Set),i=n.filter(a=>o.indexOf(a)===-1).reduce((a,s)=>(a.add(s),a),new Set),r=new Set;for(const a of n){if(i.has(a))continue;const s=b.get(a).map(p=>({...p,key:a})),l=k.get(a).map(p=>({...p,key:a}));(0,L.equals)(s,l,(p,E)=>h(p,E))||r.add(a)}return{added:t,removed:i,updated:r}}function f(b,k,n){const o=[...b.keys()],t=[...k.keys()],i=t.filter(s=>o.indexOf(s)===-1).reduce((s,l)=>(s.add(l),s),new Set),r=o.filter(s=>t.indexOf(s)===-1).reduce((s,l)=>(s.add(l),s),new Set),a=new Set;for(const s of o){if(r.has(s))continue;const l=b.get(s).map(E=>({...E,key:n[E.key]})),p=k.get(s).map(E=>({...E,key:n[E.key]}));y(l,p)||a.add(s)}return{added:i,removed:r,updated:a}}function y(b,k){return!(!(0,L.equals)(b.filter(({command:n})=>n[0]!=="-"),k.filter(({command:n})=>n[0]!=="-"),(n,o)=>h(n,o))||!(0,L.equals)(b.filter(({command:n})=>n[0]==="-"),k.filter(({command:n})=>n[0]==="-"),(n,o)=>h(n,o)))}function h(b,k){if(b.command!==k.command||b.key!==k.key)return!1;const n=R.ContextKeyExpr.deserialize(b.when),o=R.ContextKeyExpr.deserialize(k.when);return!(n&&!o||!n&&o||n&&o&&!n.equals(o)||!c.equals(b.args,k.args))}function u(b,k,n){for(const o of k)b=D.edit(b,[-1],o,n);return b}function g(b,k,n){const o=I(b);for(let t=o.length-1;t>=0;t--)(o[t].command===k||o[t].command===`-${k}`)&&(b=D.edit(b,[t],void 0,n));return b}function v(b,k,n,o){const t=I(b),i=t.findIndex(r=>r.command===k||r.command===`-${k}`);for(let r=t.length-1;r>=0;r--)(t[r].command===k||t[r].command===`-${k}`)&&(b=D.edit(b,[r],void 0,o));for(let r=n.length-1;r>=0;r--)b=D.edit(b,[i],n[r],o);return b}}),define(se[264],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(R,D,I){const C={},S={},P=new Set;if(!D)return{local:{added:C,updated:S,removed:[...P.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const w=_(R,D);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:C,updated:S,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=_(I,R),d=_(I,D),f={},y={},h=new Set,u=new Set;for(const g of m.removed.values())d.updated.has(g)?C[g]=D[g]:h.add(g);for(const g of d.removed.values())u.has(g)||(m.updated.has(g)?u.add(g):P.add(g));for(const g of m.updated.values())u.has(g)||(d.updated.has(g)?w.updated.has(g)&&u.add(g):y[g]=R[g]);for(const g of d.updated.values())u.has(g)||(m.updated.has(g)?w.updated.has(g)&&u.add(g):R[g]!==void 0&&(S[g]=D[g]));for(const g of m.added.values())u.has(g)||(d.added.has(g)?w.updated.has(g)&&u.add(g):f[g]=R[g]);for(const g of d.added.values())u.has(g)||(m.added.has(g)?w.updated.has(g)&&u.add(g):C[g]=D[g]);return{local:{added:C,removed:[...P.values()],updated:S},remote:{added:f,removed:[...h.values()],updated:y},conflicts:[...u.values()]}}e.merge=L;function _(R,D){const I=R?Object.keys(R):[],C=D?Object.keys(D):[],S=C.filter(m=>I.indexOf(m)===-1).reduce((m,d)=>(m.add(d),m),new Set),P=I.filter(m=>C.indexOf(m)===-1).reduce((m,d)=>(m.add(d),m),new Set),w=new Set;for(const m of I){if(P.has(m))continue;const d=R[m],f=D[m];d!==f&&w.add(m)}return{added:S,removed:P,updated:w}}function c(R,D){const{added:I,removed:C,updated:S}=_(R,D);return I.size===0&&C.size===0&&S.size===0}e.areSame=c}),define(se[265],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(c,R,D,I){const C={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!R){const w=c.filter(({id:m})=>!I.includes(m));return w.length?S.added=w:S=null,{local:C,remote:S}}const P=_(c,R,I);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const w=_(D,c,I),m=_(D,R,I);for(const d of m.removed){const f=c.find(y=>y.id===d);f&&C.removed.push(f)}for(const d of m.added){const f=R.find(y=>y.id===d);w.added.includes(d)?P.updated.includes(d)&&C.updated.push(f):C.added.push(f)}for(const d of m.updated)C.updated.push(R.find(f=>f.id===d));for(const d of w.added)m.added.includes(d)||S.added.push(c.find(f=>f.id===d));for(const d of w.updated)m.removed.includes(d)||m.updated.includes(d)||S.updated.push(c.find(f=>f.id===d));for(const d of w.removed){const f=R.find(y=>y.id===d);f&&S.removed.push(f)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:C,remote:S}}e.merge=L;function _(c,R,D){c=c?c.filter(({id:m})=>!D.includes(m)):[],R=R.filter(({id:m})=>!D.includes(m));const I=c.map(({id:m})=>m),C=R.map(({id:m})=>m),S=C.filter(m=>I.indexOf(m)===-1),P=I.filter(m=>C.indexOf(m)===-1),w=[];for(const{id:m,name:d,shortName:f}of c){if(P.includes(m))continue;const y=R.find(h=>h.id===m);(!y||y.name!==d||y.shortName!==f)&&w.push(m)}return{added:S,removed:P,updated:w}}}),define(se[23],oe([0,1,19,12,187,45,29,5,109,40]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const r=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(a=>!!r[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function w(){const r=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(r).filter(p=>!!r[p].ignoreSync),s=Object.keys(r).filter(p=>r[p].scope===2||r[p].scope===6),l=P();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...s,...l])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const r="vscode://schemas/ignoredSettings",a=S.Registry.as(R.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,c.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,c.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,c.localize)(2,null),items:[{type:"string",pattern:D.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,c.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,c.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const s=S.Registry.as(C.Extensions.JSONContribution),l=()=>{const p=P(),E=w().filter(W=>W!==e.CONFIGURATION_SYNC_STORE_KEY),T=Object.keys(R.allSettings.properties).filter(W=>E.indexOf(W)===-1),A=E.filter(W=>p.indexOf(W)===-1),N={items:{type:"string",enum:[...T,...A.map(W=>`-${W}`)]}};s.registerSchema(r,N)};return a.onDidUpdateConfiguration(()=>l())}e.registerConfiguration=m;function d(r){return r&&(0,_.isObject)(r)&&(0,_.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=d;var f;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(r,...a){return r?[r,...a]:a}e.getPathSegments=y;function h(r,a,s,l){return l.joinPath(s.userDataSyncHome,...y(r,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=h,e.IUserDataSyncStoreManagementService=(0,I.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,I.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,I.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(r){const a={};return a[e.HEADER_EXECUTION_ID]=r,a}e.createSyncHeaders=u;var g;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(a,s,l,p){super(a),this.code=s,this.resource=l,this.operationId=p,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class b extends v{constructor(a,s,l,p,E){super(a,l,void 0,E),this.url=s,this.serverCode=p}}e.UserDataSyncStoreError=b;class k extends v{constructor(a,s){super(a,s)}}e.UserDataAutoSyncError=k,function(r){function a(s){if(s instanceof r)return s;const l=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(s.name);if(l&&l[1]){const p=l[2]==="unknown"?void 0:l[2],E=l[3]==="unknown"?void 0:l[3];return new r(s.message,l[1],p,E)}return new r(s.message,"Unknown")}r.toUserDataSyncError=a}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var o;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(r){return`sync.enable.${r}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,I.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,I.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,I.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,I.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,I.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,I.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(se[266],oe([0,1,32,23]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function c(D,I,C,S,P){if(!I)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const w=R(D,I);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=C?R(C,I):{added:Object.keys(I).reduce((g,v)=>(g.add(v),g),new Set),removed:new Set,updated:new Set},d=C?R(C,D):{added:Object.keys(D).reduce((g,v)=>(g.add(v),g),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},y=L.deepClone(I),h=!C;for(const g of d.added.values())g!==_.SYNC_SERVICE_URL_TYPE&&h&&m.added.has(g)||(y[g]=D[g]);for(const g of d.updated.values())y[g]=D[g];for(const g of d.removed.values())S.unregistered.includes(g)||delete y[g];for(const g of m.added.values()){const v=I[g];if(S.machine.includes(g)){P.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(C&&d.added.has(g))continue;const b=D[g];b&&b.value===v.value||g===_.SYNC_SERVICE_URL_TYPE&&h&&d.added.has(g)||(b?f.updated[g]=v:f.added[g]=v)}for(const g of m.updated.values()){const v=I[g];if(S.machine.includes(g)){P.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(g)||d.removed.has(g))continue;const b=D[g];b&&b.value===v.value||(f.updated[g]=v)}for(const g of m.removed.values()){if(S.machine.includes(g)){P.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}d.updated.has(g)||d.removed.has(g)||f.removed.push(g)}const u=R(I,y);return{local:f,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:y}}}e.merge=c;function R(D,I){const C=Object.keys(D),S=Object.keys(I),P=S.filter(d=>C.indexOf(d)===-1).reduce((d,f)=>(d.add(f),d),new Set),w=C.filter(d=>S.indexOf(d)===-1).reduce((d,f)=>(d.add(f),d),new Set),m=new Set;for(const d of C){if(w.has(d))continue;const f=D[d],y=I[d];L.equals(f,y)||m.add(d)}return{added:P,removed:w,updated:m}}}),define(se[267],oe([0,1,19,35,83,42,32,60,23]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(s,l,p){let E=[];p?E=w(p):E=P(l);const T=[],A=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const N of E)N.startsWith("-")?A.push(N.substring(1)):T.push(N);return(0,L.distinct)([...s,...T].filter(N=>A.indexOf(N)===-1))}e.getIgnoredSettings=S;function P(s){let l=s.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=s.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:s.getValue("settingsSync.ignoredSettings")||[]}function w(s){const l=(0,_.parse)(s);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function m(s,l){const p=(0,_.parse)(s)||{};let E="{}";for(const T of Object.keys(p)){const A=(0,c.setProperty)(E,[T],p[T],l);E=(0,c.applyEdits)(E,A)}return E}e.removeComments=m;function d(s,l,p,E){if(p.length){const T=a(l),A=(0,_.parse)(l)||{},N=(0,_.parse)(s);if(!N)return s;const W=[];for(const V of p){const K=A[V],z=N[V];K===void 0?s=I.edit(s,[V],void 0,E):z!==void 0?s=I.edit(s,[V],K,E):W.push(n(V,T))}W.sort((V,K)=>V.startOffset-K.startOffset),W.forEach(V=>s=g(V.setting.key,l,s,E))}return s}e.updateIgnoredSettings=d;function f(s,l,p,E,T,A){const N=d(s,l,E,A),W=p!==N,V=p!==l;if(!W&&!V)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(W&&!V)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(V&&!W)return{conflictsSettings:[],localContent:d(l,s,E,A),remoteContent:null,hasConflicts:!1};if(p===null&&h(s)){const x=y(s,l,E)?null:d(l,s,E,A);return{conflictsSettings:[],localContent:x,remoteContent:null,hasConflicts:!1}}let K=s,z=l;const O=(0,_.parse)(s),$=(0,_.parse)(l),Z=p?(0,_.parse)(p):null,q=E.reduce((x,H)=>(x.add(H),x),new Set),j=u(O,$,q),M=u(Z,O,q),J=u(Z,$,q),Q=new Map,re=new Set,ae=x=>{re.add(x);const H=T.filter(({key:te})=>te===x)[0];H?(K=I.edit(K,[x],H.value,A),z=I.edit(z,[x],H.value,A)):Q.set(x,{key:x,localValue:O[x],remoteValue:$[x]})};for(const x of M.removed.values())J.updated.has(x)?ae(x):z=I.edit(z,[x],void 0,A);for(const x of J.removed.values())re.has(x)||(M.updated.has(x)?ae(x):K=I.edit(K,[x],void 0,A));for(const x of M.updated.values())re.has(x)||(J.updated.has(x)?j.updated.has(x)&&ae(x):z=I.edit(z,[x],O[x],A));for(const x of J.updated.values())re.has(x)||(M.updated.has(x)?j.updated.has(x)&&ae(x):K=I.edit(K,[x],$[x],A));for(const x of M.added.values())re.has(x)||(J.added.has(x)?j.updated.has(x)&&ae(x):z=g(x,K,z,A));for(const x of J.added.values())re.has(x)||(M.added.has(x)?j.updated.has(x)&&ae(x):K=g(x,z,K,A));const B=Q.size>0||!y(K,z,E),F=B||!y(K,s,[]),U=B||!y(z,l,[]);return{localContent:F?K:null,remoteContent:U?z:null,conflictsSettings:[...Q.values()],hasConflicts:B}}e.merge=f;function y(s,l,p){if(s===l)return!0;const E=(0,_.parse)(s),T=(0,_.parse)(l),A=p.reduce((V,K)=>(V.add(K),V),new Set),N=a(s).filter(V=>!(V.setting&&A.has(V.setting.key))),W=a(l).filter(V=>!(V.setting&&A.has(V.setting.key)));if(N.length!==W.length)return!1;for(let V=0;V<N.length;V++){const K=N[V],z=W[V];if(K.setting&&z.setting){if(K.setting.key!==z.setting.key||!D.equals(E[K.setting.key],T[K.setting.key]))return!1}else if(!K.setting&&!z.setting){if(K.value!==z.value)return!1}else return!1}return!0}function h(s){return s?a(s).length===0:!0}e.isEmpty=h;function u(s,l,p){const E=s?Object.keys(s).filter(V=>!p.has(V)):[],T=Object.keys(l).filter(V=>!p.has(V)),A=T.filter(V=>E.indexOf(V)===-1).reduce((V,K)=>(V.add(K),V),new Set),N=E.filter(V=>T.indexOf(V)===-1).reduce((V,K)=>(V.add(K),V),new Set),W=new Set;if(s)for(const V of E){if(N.has(V))continue;const K=s[V],z=l[V];D.equals(K,z)||W.add(V)}return{added:A,removed:N,updated:W}}function g(s,l,p,E){const T=(0,_.parse)(l),A=a(l),N=a(p),W=v(s,A,N);return b(p,s,T[s],W,N,E)}e.addSetting=g;function v(s,l,p){const E=l.findIndex(A=>A.setting?.key===s),T=l[E-1];if(T){if(T.setting){const N=n(T.setting.key,p);if(N)return{index:p.indexOf(N),insertAfter:!0}}else{const N=o(E,l);if(N){const W=n(N.setting.key,p);if(W){const V=t(p.indexOf(W),p),K=i(l,N,l[E]);if(V){const z=i(p,W,V),O=r(K,z);return O?{index:p.indexOf(O),insertAfter:!0}:{index:p.indexOf(V),insertAfter:!1}}else{const z=i(p,W,p[p.length-1]),O=r(K,z);return O?{index:p.indexOf(O),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const A=l[E+1];if(A)if(A.setting){const N=n(A.setting.key,p);if(N)return{index:p.indexOf(N),insertAfter:!1}}else{const N=t(E,l);if(N){const W=n(N.setting.key,p);if(W){const V=o(p.indexOf(W),p),K=i(l,l[E],N);if(V){const z=i(p,V,W),O=r(K.reverse(),z.reverse());return O?{index:p.indexOf(O),insertAfter:!1}:{index:p.indexOf(V),insertAfter:!0}}else{const z=i(p,p[0],W),O=r(K.reverse(),z.reverse());return O?{index:p.indexOf(O),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function b(s,l,p,E,T,A){let N;return E.index===-1?N=(0,c.setProperty)(s,[l],p,A):N=k(s,l,p,E,T,A).map(W=>(0,c.withFormatting)(s,W,A)[0]),(0,c.applyEdits)(s,N)}function k(s,l,p,E,T,A){const N=`${JSON.stringify(l)}: ${JSON.stringify(p)}`,W=(0,R.getEOL)(A,s),V=T[E.index];if(E.insertAfter){const K=[];if(V.setting)K.push({offset:V.endOffset,length:0,content:","+N});else{const z=t(E.index,T),O=o(E.index,T),$=O?.setting?.commaOffset;O&&$===void 0&&K.push({offset:O.endOffset,length:0,content:","});const Z=$!==void 0&&$>V.endOffset;K.push({offset:Z?$+1:V.endOffset,length:0,content:z?W+N+",":W+N})}return K}else{if(V.setting)return[{offset:V.startOffset,length:0,content:N+","}];const K=(T[E.index-1]&&!T[E.index-1].setting?W:"")+N+(t(E.index,T)?",":"")+W;return[{offset:V.startOffset,length:0,content:K}]}}function n(s,l){return l.filter(p=>p.setting?.key===s)[0]}function o(s,l){for(let p=s-1;p>=0;p--)if(l[p].setting)return l[p]}function t(s,l){for(let p=s+1;p<l.length;p++)if(l[p].setting)return l[p]}function i(s,l,p){const E=s.indexOf(l),T=s.indexOf(p);return s.filter((A,N)=>E<N&&N<T)}function r(s,l){if(s.length&&l.length){let p=0;for(;p<l.length&&p<s.length;p++)if(s[p].value!==l[p].value)return l[p-1];return l[p-1]}}function a(s){const l=[];let p=-1,E,T;const A={onObjectBegin:N=>{p++},onObjectProperty:(N,W,V)=>{p===0&&(E=W,T=N)},onObjectEnd:(N,W)=>{p--,p===0&&l.push({startOffset:E,endOffset:N+W,value:s.substring(E,N+W),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(N,W)=>{p++},onArrayEnd:(N,W)=>{p--,p===0&&l.push({startOffset:E,endOffset:N+W,value:s.substring(E,N+W),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(N,W,V)=>{p===0&&l.push({startOffset:E,endOffset:W+V,value:s.substring(E,W+V),setting:{key:T,commaOffset:void 0}})},onSeparator:(N,W,V)=>{if(p===0&&N===","){let K=l.length-1;for(;K>=0&&!l[K].setting;K--);const z=l[K];z&&l.splice(K,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:W}})}},onComment:(N,W)=>{p===0&&l.push({startOffset:N,endOffset:N+W,value:s.substring(N,N+W)})}};return(0,_.visit)(s,A),l}}),define(se[77],oe([0,1,3,2,5,23]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,c.createDecorator)("IUserDataSyncAccountService");let D=class extends _.Disposable{get account(){return this._account}constructor(C,S){super(),this.userDataSyncStoreService=C,this.logService=S,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};D=pe([Y(0,R.IUserDataSyncStoreService),Y(1,R.IUserDataSyncLogService)],D),e.UserDataSyncAccountService=D}),define(se[268],oe([0,1,2,11]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class c{constructor(m){this.service=m}listen(m,d){switch(d){case"onError":return this.service.onError}throw new Error(`Event not found: ${d}`)}call(m,d,f){switch(d){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=c;class R{constructor(m){this.service=m}listen(m,d){throw new Error(`Event not found: ${d}`)}call(m,d,f){switch(d){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(_.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class D{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=D;class I{constructor(m){this.service=m}listen(m,d){switch(d){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${d}`)}async call(m,d,f){switch(d){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class C{constructor(m){this.service=m}listen(m,d){switch(d){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(m,d,f){switch(d){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class S{constructor(m){this.service=m}listen(m,d){switch(d){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(m,d,f){switch(d){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class P extends L.Disposable{constructor(m){super(),this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:_.URI.revive(m.url),type:m.type,defaultUrl:_.URI.revive(m.defaultUrl),insidersUrl:_.URI.revive(m.insidersUrl),stableUrl:_.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(se[269],oe([0,1,188,15,9,23]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends c.AbstractLogger{constructor(C,S){super(),this.logger=this._register(C.createLogger(S.userDataSyncLogResource,{id:R.USER_DATA_SYNC_LOG_ID,name:(0,L.localize)(0,null)}))}trace(C,...S){this.logger.trace(C,...S)}debug(C,...S){this.logger.debug(C,...S)}info(C,...S){this.logger.info(C,...S)}warn(C,...S){this.logger.warn(C,...S)}error(C,...S){this.logger.error(C,...S)}flush(){this.logger.flush()}};D=pe([Y(0,c.ILoggerService),Y(1,_.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(se[270],oe([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(se[271],oe([0,1,6,3,2]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends c.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:C,getActiveWindowId:S}){super(),this.disposables=this._register(new c.DisposableStore),_.Event.latch(_.Event.any(I,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>S()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(se[120],oe([0,1,191,13,49,25,11,5,22]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function S(t){const i=t;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=S;function P(t){return typeof t?.id=="string"&&!S(t)&&!m(t)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(t,i){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,_.basename)(t)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=w;function m(t){const i=t;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=m;function d(t){const i=t;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=d;var f;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function y(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=y;function h(t){const i=t;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class u{constructor(i,r,a,s,l){this._id=i,this._transient=a,this._configuration=s,this._ignorePathCasing=l,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function v(t){return new g({uri:t,index:0,name:(0,R.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(t,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(t,i.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function k(t){let i;return D.URI.isUri(t)?i=t:i=t.configuration,i?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=k;function n(t,i){return!b(t,i)&&!k(t)}e.isSavedWorkspace=n;function o(t){return(typeof t=="string"?(0,_.extname)(t):(0,R.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(se[18],oe([0,1,65,3,2,25,11,182,15,14,5,9,120,38,30,6,31,27,12]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function v(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.isUserDataProfile=v,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function b(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:D.URI.revive(t.location).with({scheme:i}),globalStorageHome:D.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(t.extensionsResource)?.with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=b;function k(t,i,r,a){return{id:t,name:i,location:r,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=k;let n=class extends c.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,a,s){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=a,this.logService=s,this.enabled=!0,this._onDidChangeProfiles=this._register(new _.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new _.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new _.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new _.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=[];if(this.enabled)try{for(const l of this.getStoredProfiles()){if(!l.name||!(0,g.isString)(l.name)||!l.location){this.logService.warn("Skipping the invalid stored profile",l.location||l.name);continue}i.push(k((0,R.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}}catch(l){this.logService.error(l)}const r=new d.ResourceMap,a=new Map,s=this.createDefaultProfile();if(i.unshift({...s,extensionsResource:this.getDefaultProfileExtensionsLocation()??s.extensionsResource,isDefault:!0}),i.length)try{const l=this.getStoredProfileAssociations();if(l.workspaces)for(const[p,E]of Object.entries(l.workspaces)){const T=D.URI.parse(p),A=i.find(N=>N.id===E);A&&r.set(T,A)}if(l.emptyWindows)for(const[p,E]of Object.entries(l.emptyWindows)){const T=i.find(A=>A.id===E);T&&a.set(p,T)}}catch(l){this.logService.error(l)}this._profilesObject={profiles:i,workspaces:r,emptyWindows:a}}return this._profilesObject}createDefaultProfile(){return k("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome)}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let s=0;for(const p of this.profiles){const E=a.exec(p.name),T=E?parseInt(E[1]):0;s=T>s?T:s}const l=`${r} ${s+1}`;return this.createProfile((0,L.hash)((0,h.generateUuid)()).toString(16),l,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,L.hash)((0,h.generateUuid)()).toString(16),i,r,a)}async createProfile(i,r,a,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const l=await this.doCreateProfile(i,r,a);return s&&await this.setProfileForWorkspace(s,l),l}async doCreateProfile(i,r,a){if(!(0,g.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.profileCreationPromises.get(r);return s||(s=(async()=>{try{const l=this.profiles.find(T=>T.name===r||T.id===i);if(l)return l;const p=k(i,r,(0,R.joinPath)(this.profilesHome,i),a);await this.fileService.createFolder(p.location);const E=[];return this._onWillCreateProfile.fire({profile:p,join(T){E.push(T)}}),await y.Promises.settled(E),this.updateProfiles([p],[],[]),p}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,s)),s}async updateProfile(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(s=>s.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=k(a.id,r.name??a.name,a.location,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(s=>s.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(s){a.push(s)}});try{await Promise.allSettled(a)}catch(s){this.logService.error(s)}for(const s of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(s)?.id&&this.profilesObject.emptyWindows.delete(s);for(const s of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(s)?.id&&this.profilesObject.workspaces.delete(s);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(s){this.logService.error(s)}}async setProfileForWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(s=>s.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return D.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(i){return(0,m.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,m.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,a){const s=[...this.profiles,...i],l=[];this.transientProfilesObject.profiles=[];for(let p of s)p.isDefault||r.some(E=>p.id===E.id)||(p=a.find(E=>p.id===E.id)??p,p.isTransient?this.transientProfilesObject.profiles.push(p):l.push({location:p.location,name:p.name,shortName:p.shortName,useDefaultFlags:p.useDefaultFlags}));this.saveStoredProfiles(l),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,a)}triggerProfilesChanges(i,r,a){this._onDidChangeProfiles.fire({added:i,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const s=this.getWorkspace(i),l=a?this.transientProfilesObject:this.profilesObject;D.URI.isUri(s)?(l.workspaces.delete(s),r&&l.workspaces.set(s,r)):(l.emptyWindows.delete(s),r&&l.emptyWindows.set(s,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,s]of this.profilesObject.workspaces.entries())i[a.toString()]=s.id;const r={};for(const[a,s]of this.profilesObject.emptyWindows.entries())r[a.toString()]=s.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const r={},a=this.createDefaultProfile();if(i.workspaces)for(const[l,p]of Object.entries(i.workspaces)){const E=D.URI.parse(p);r[l]=this.uriIdentityService.extUri.isEqual(E,a.location)?a.id:this.uriIdentityService.extUri.basename(E)}const s={};if(i.emptyWindows)for(const[l,p]of Object.entries(i.emptyWindows)){const E=D.URI.parse(p);s[l]=this.uriIdentityService.extUri.isEqual(E,a.location)?a.id:this.uriIdentityService.extUri.basename(E)}return{workspaces:r,emptyWindows:s}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=pe([Y(0,C.IEnvironmentService),Y(1,S.IFileService),Y(2,f.IUriIdentityService),Y(3,w.ILogService)],n),e.UserDataProfilesService=n;class o extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=o}),define(se[272],oe([0,1,6,2,18]),function(ee,e,L,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let R=class extends _.Disposable{constructor(I){super(),this._register(new L.RunOnceScheduler(()=>{I.cleanUp()},10*1e3)).schedule()}};R=pe([Y(0,c.IUserDataProfilesService)],R),e.UserDataProfilesCleaner=R}),define(se[273],oe([0,1,19,6,24,7,3,2,4,11,161,29,33,46,9,26,20,18]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var g;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(g=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let v=class extends I.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,r,a,s,l){super(),this.galleryService=i,this.telemetryService=r,this.logService=a,this.productService=s,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:p})=>p.cancel()),this.uninstallingExtensions.forEach(p=>p.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,w.isTargetPlatformCompatible)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(P.localize(0,null),w.ExtensionManagementErrorCode.Internal);const a=await this.checkAndGetCompatibleVersion(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(a.manifest,a.extension,r)}catch(a){throw n(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:a}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(a),k(a)}}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,r,a){const s={...a,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,d.isApplicationScopedExtension)(i)?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},l=W=>`${m.ExtensionKey.create(W).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!S.URI.isUri(r)){const W=this.installingExtensions.get(l(r));if(W)return this.logService.info("Extensions is already requested to install",r.identifier.id),W.task.waitUntilTaskIsFinished()}const p=[],E=[],T=[],A=this.createInstallExtensionTask(i,r,s);S.URI.isUri(r)||this.installingExtensions.set(l(r),{task:A,waitingTasks:[]}),this._onInstallExtension.fire({identifier:A.identifier,source:r,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",A.identifier.id),p.push({task:A,manifest:i});let N=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const V=await this.getAllDepsAndPackExtensions(A.identifier,i,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),K=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:z,manifest:O}of(0,L.distinct)(V,({gallery:$})=>$.identifier.id)){N=N||!!O.extensionDependencies?.some(q=>(0,m.areSameExtensions)({id:q},A.identifier));const $=l(z),Z=this.installingExtensions.get($);if(Z){if(this.canWaitForTask(A,Z.task)){const q=Z.task.identifier;this.logService.info("Waiting for already requested installing extension",q.id,A.identifier.id),Z.waitingTasks.push(A),E.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,m.areSameExtensions)(M.identifier,q)))).then(j=>{if(this.logService.info("Finished waiting for already requested installing extension",q.id,A.identifier.id),!j.find(J=>(0,m.areSameExtensions)(J.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!K.some(({identifier:q})=>(0,m.areSameExtensions)(q,z.identifier))){const q=this.createInstallExtensionTask(O,z,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set($,{task:q,waitingTasks:[A]}),this._onInstallExtension.fire({identifier:q.identifier,source:z,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",q.identifier.id,A.identifier.id),p.push({task:q,manifest:O})}}}catch(V){if(S.URI.isUri(A.source))(0,L.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",A.identifier.id,V.message),(0,L.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",A.identifier.id,V.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),V}const W=p.reduce((V,{task:K,manifest:z})=>(V.set(K.identifier.id.toLowerCase(),{task:K,manifest:z}),V),new Map);for(;W.size;){let V;const K=[...W.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(O=>W.has(O.toLowerCase())));K.length?V=W.size===1?K:K.filter(({task:z})=>!(z===A&&!N)):(this.logService.info("Found extensions with circular dependencies",K.map(({task:z})=>z.identifier.id)),V=[...W.values()]),await this.joinAllSettled(V.map(async({task:z})=>{const O=new Date().getTime();try{const $=await z.run();if(await this.joinAllSettled(this.participants.map(Z=>Z.postInstall($,z.source,s,c.CancellationToken.None))),!S.URI.isUri(z.source)){const Z=z.operation===3,q=Z?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(n(this.telemetryService,Z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-O,durationSinceUpdate:q}),C.isWeb&&z.operation!==3)try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}T.push({local:$,identifier:z.identifier,operation:z.operation,source:z.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw S.URI.isUri(z.source)||n(this.telemetryService,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-O,error:$}),this.logService.error("Error while installing the extension:",z.identifier.id),$}finally{W.delete(z.identifier.id.toLowerCase())}}))}return E.length&&await this.joinAllSettled(E),T.forEach(({identifier:V})=>this.logService.info("Extension installed successfully:",V.id)),this._onDidInstallExtensions.fire(T),T.filter(({identifier:V})=>(0,m.areSameExtensions)(V,A.identifier))[0].local}catch(W){if(p.forEach(({task:V})=>V.cancel()),T.length)try{const V=await Promise.allSettled(T.map(({local:K})=>this.createUninstallExtensionTask(K,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let K=0;K<V.length;K++){const z=V[K],{identifier:O}=T[K];z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,R.getErrorMessage)(z.reason))}}catch(V){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(V),T.map(({identifier:K})=>K.id))}throw this._onDidInstallExtensions.fire(p.map(({task:V})=>({identifier:V.identifier,operation:2,source:V.source,context:s.context,profileLocation:s.profileLocation}))),W}finally{for(const{task:W}of p)W.source&&!S.URI.isUri(W.source)&&this.installingExtensions.delete(l(W.source))}}canWaitForTask(i,r){for(const[,{task:a,waitingTasks:s}]of this.installingExtensions.entries())if(a===i&&(s.includes(r)||s.some(l=>this.canWaitForTask(l,r)))||a===r&&s[0]&&!this.canWaitForTask(i,s[0]))return!1;return!0}async joinAllSettled(i){const r=[],a=[],s=await Promise.allSettled(i);for(const l of s)l.status==="fulfilled"?r.push(l.value):a.push(l.reason);if(a.length)throw b(a);return r}async getAllDepsAndPackExtensions(i,r,a,s,l){if(!this.galleryService.isEnabled())return[];const p=await this.getInstalled(void 0,l),E=[],T=[],A=async(N,W)=>{E.push(N);const V=W.extensionDependencies||[],K=[...V];if(W.extensionPack){const z=a?p.find(O=>(0,m.areSameExtensions)(O.identifier,N)):void 0;for(const O of W.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some($=>(0,m.areSameExtensions)({id:$},{id:O}))||K.every($=>!(0,m.areSameExtensions)({id:$},{id:O}))&&K.push(O)}if(K.length){const z=K.filter(O=>E.every($=>!(0,m.areSameExtensions)($,{id:O})));if(z.length){const O=await this.galleryService.getExtensions(z.map($=>({id:$,preRelease:s})),c.CancellationToken.None);for(const $ of O){if(E.find(j=>(0,m.areSameExtensions)(j,$.identifier)))continue;const Z=V.some(j=>(0,m.areSameExtensions)({id:j},$.identifier));let q;try{q=await this.checkAndGetCompatibleVersion($,!1,s)}catch(j){if(j instanceof w.ExtensionManagementError&&j.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Z){this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id);continue}else throw j}T.push({gallery:q.extension,manifest:q.manifest}),await A(q.extension.identifier,q.manifest)}}}};return await A(i,r),T}async checkAndGetCompatibleVersion(i,r,a){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,m.areSameExtensions)(i.identifier,E)))throw new w.ExtensionManagementError(P.localize(1,null,i.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const E=await this.getTargetPlatform();throw new w.ExtensionManagementError(P.localize(2,null,i.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(E)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(i,r,a);if(l){if(a&&!r&&i.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(P.localize(3,null,i.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],c.CancellationToken.None))[0]?new w.ExtensionManagementError(P.localize(4,null,i.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(P.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const p=await this.galleryService.getManifest(l,c.CancellationToken.None);if(p===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(p.version!==l.version)throw new w.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:p}}async getCompatibleVersion(i,r,a){const s=await this.getTargetPlatform();let l=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(l=(await this.galleryService.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:s,compatible:!0},c.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(i,a,s)&&(l=i),l||(r?l=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:s,compatible:!0},c.CancellationToken.None))[0]||null:l=await this.galleryService.getCompatibleExtension(i,a,s)),l}async uninstallExtension(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},s=N=>`${N.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,l=this.uninstallingExtensions.get(s(i.identifier));if(l)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),l.waitUntilTaskIsFinished();const p=N=>{const W=this.createUninstallExtensionTask(N,a);return this.uninstallingExtensions.set(s(W.extension.identifier),W),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this._onUninstallExtension.fire({identifier:N.identifier,profileLocation:a.profileLocation,applicationScoped:N.isApplicationScoped}),W},E=(N,W)=>{W?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString(),W.message):this.logService.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,W.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(N),error:W}),this._onDidUninstallExtension.fire({identifier:N.identifier,error:W?.code,profileLocation:a.profileLocation,applicationScoped:N.isApplicationScoped})},T=[],A=[];try{T.push(p(i));const N=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const W=this.getAllPackExtensionsToUninstall(i,N);for(const V of W)this.uninstallingExtensions.has(s(V.identifier))?this.logService.info("Extensions is already requested to uninstall",V.identifier.id):T.push(p(V))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(T.map(W=>W.extension),N,i),await this.joinAllSettled(T.map(async W=>{try{if(await W.run(),await this.joinAllSettled(this.participants.map(V=>V.postUninstall(W.extension,a,c.CancellationToken.None))),W.extension.identifier.uuid)try{await this.galleryService.reportStatistic(W.extension.manifest.publisher,W.extension.manifest.name,W.extension.manifest.version,"uninstall")}catch{}E(W.extension)}catch(V){const K=V instanceof w.ExtensionManagementError?V:new w.ExtensionManagementError((0,R.getErrorMessage)(V),w.ExtensionManagementErrorCode.Internal);throw E(W.extension,K),K}finally{A.push(W)}}))}catch(N){const W=N instanceof w.ExtensionManagementError?N:new w.ExtensionManagementError((0,R.getErrorMessage)(N),w.ExtensionManagementErrorCode.Internal);for(const V of T){try{V.cancel()}catch{}A.includes(V)||E(V.extension,W)}throw W}finally{for(const N of T)this.uninstallingExtensions.delete(s(N.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}checkForDependents(i,r,a){for(const s of i){const l=this.getDependents(s,r);if(l.length){const p=l.filter(E=>!i.some(T=>(0,m.areSameExtensions)(T.identifier,E.identifier)));if(p.length)throw new Error(this.getDependentsErrorMessage(s,p,a))}}}getDependentsErrorMessage(i,r,a){return a===i?r.length===1?P.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const s=i.manifest.extensionPack?i.manifest.extensionPack:[];if(s.length){const l=r.filter(E=>!E.isBuiltin&&s.some(T=>(0,m.areSameExtensions)({id:T},E.identifier))),p=[];for(const E of l)p.push(...this.getAllPackExtensionsToUninstall(E,r,a));return[...l,...p]}return[]}getDependents(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(s=>(0,m.areSameExtensions)({id:s},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};v=pe([Y(0,w.IExtensionGalleryService),Y(1,h.ITelemetryService),Y(2,f.ILogService),Y(3,y.IProductService),Y(4,u.IUserDataProfilesService)],v),e.AbstractExtensionManagementService=v;function b(t){const i=Array.isArray(t)?t:[t];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=b;function k(t){if(t instanceof w.ExtensionManagementError)return t;const i=new w.ExtensionManagementError(t.message,w.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:r,verificationStatus:a,duration:s,error:l,durationSinceUpdate:p}){let E,T;l&&(l instanceof w.ExtensionManagementError?(E=l.code,l.code===w.ExtensionManagementErrorCode.Signature&&(T=l.message)):E=w.ExtensionManagementErrorCode.Internal),t.publicLog(i,{...r,verificationStatus:a,success:!l,duration:s,errorcode:E,errorcodeDetail:T,durationSinceUpdate:p})}class o{constructor(){this.barrier=new _.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(i=>new Promise((r,a)=>{const s=i.onCancellationRequested(()=>{s.dispose(),a(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=o}),define(se[51],oe([0,1,6,16,2,3,38,11,29,33,14,5,9,18,30,12,7,20]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class v extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let b=class extends c.Disposable{constructor(t,i,r,a,s,l){super(),this.extensionsLocation=t,this.fileService=i,this.userDataProfilesService=r,this.uriIdentityService=a,this.telemetryService=s,this.logService=l,this._onAddExtensions=this._register(new R.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new R.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new R.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new R.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new D.ResourceMap}scanProfileExtensions(t,i){return this.withProfileExtensions(t,void 0,i)}async addExtensionsToProfile(t,i){const r=[],a=[];try{return await this.withProfileExtensions(i,s=>{const l=[];for(const p of s)t.some(([E])=>(0,S.areSameExtensions)(E.identifier,p.identifier)&&E.manifest.version!==p.version)?r.push(p):l.push(p);for(const[p,E]of t)if(!l.some(T=>(0,S.areSameExtensions)(T.identifier,p.identifier)&&T.version===p.manifest.version)){const T={identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:E};a.push(T),l.push(T)}return a.length&&this._onAddExtensions.fire({extensions:a,profileLocation:i}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),l}),a.length&&this._onDidAddExtensions.fire({extensions:a,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i}),a}catch(s){throw a.length&&this._onDidAddExtensions.fire({extensions:a,error:s,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:s,profileLocation:i}),s}}async updateMetadata(t,i){const r=[];return await this.withProfileExtensions(i,a=>{const s=[];for(const l of a){const p=t.find(([E])=>(0,S.areSameExtensions)(E.identifier,l.identifier)&&E.manifest.version===l.version);p&&(l.metadata={...l.metadata,...p[1]},r.push(l)),s.push(l)}return s}),r}async removeExtensionFromProfile(t,i){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:i});try{await this.withProfileExtensions(i,a=>{const s=[];for(const l of a)(0,S.areSameExtensions)(l.identifier,t.identifier)?r.push(l):s.push(l);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),s}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i})}catch(a){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:a,profileLocation:i}),a}}async withProfileExtensions(t,i,r){return this.getResourceAccessQueue(t).queue(async()=>{let a=[],s;try{const l=await this.fileService.readFile(t);s=JSON.parse(l.value.toString().trim()||"[]")}catch(l){if((0,P.toFileOperationResult)(l)!==1)throw l;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(s=await this.migrateFromOldDefaultProfileExtensionsLocation()),!s&&r?.bailOutWhenFileNotFound)throw new v((0,h.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.reportAndThrowInvalidConentError(t);let l=!1;for(const p of s){k(p)||this.reportAndThrowInvalidConentError(t);let E;if((0,y.isString)(p.relativeLocation)&&p.relativeLocation)E=this.resolveExtensionLocation(p.relativeLocation);else if((0,y.isString)(p.location))E=this.resolveExtensionLocation(p.location),l=!0,p.relativeLocation=p.location,p.location=E.toJSON();else{E=I.URI.revive(p.location);const T=this.toRelativePath(E);T&&(l=!0,p.relativeLocation=T)}a.push({identifier:p.identifier,location:E,version:p.version,metadata:p.metadata})}l&&await this.fileService.writeFile(t,_.VSBuffer.fromString(JSON.stringify(s)))}if(i){a=i(a);const l=a.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),relativeLocation:this.toRelativePath(p.location),metadata:p.metadata}));await this.fileService.writeFile(t,_.VSBuffer.fromString(JSON.stringify(l)))}return a})}reportAndThrowInvalidConentError(t){const i=new v(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(t)).value.toString()}catch(s){if((0,P.toFileOperationResult)(s)===1)return;throw s}this.logService.info("Migrating extensions from old default profile location",t.toString());let a;try{const s=JSON.parse(r);Array.isArray(s)&&s.every(l=>k(l))?a=s:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.logService.error(s)}if(a)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,_.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(s){if((0,P.toFileOperationResult)(s)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw s}try{await this.fileService.del(t)}catch(s){(0,P.toFileOperationResult)(s)!==1&&this.logService.error(s)}try{await this.fileService.del(i)}catch(s){(0,P.toFileOperationResult)(s)!==1&&this.logService.error(s)}return a})()),this._migrationPromise}getResourceAccessQueue(t){let i=this.resourcesAccessQueueMap.get(t);return i||(i=new L.Queue,this.resourcesAccessQueueMap.set(t,i)),i}};b=pe([Y(1,P.IFileService),Y(2,d.IUserDataProfilesService),Y(3,f.IUriIdentityService),Y(4,u.ITelemetryService),Y(5,m.ILogService)],b),e.AbstractExtensionsProfileScannerService=b;function k(o){return(0,y.isObject)(o)&&(0,C.isIExtensionIdentifier)(o.identifier)&&(n(o.location)||(0,y.isString)(o.location)&&o.location)&&((0,y.isUndefined)(o.relativeLocation)||(0,y.isString)(o.relativeLocation))&&o.version&&(0,y.isString)(o.version)}function n(o){return o?(0,y.isString)(o.path)&&(0,y.isString)(o.scheme):!1}}),define(se[78],oe([0,1,19,6,32,16,7,35,143,2,22,13,4,25,54,90,12,11,164,15,33,46,68,14,5,9,26,3,91,51,18,30,197,198]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k,n,o,t,i,r,a,s,l,p,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var N;(function(Z){function q(j,M){if(j===M)return!0;const J=Object.keys(j),Q=new Set;for(const re of Object.keys(M))Q.add(re);if(J.length!==Q.size)return!1;for(const re of J){if(j[re]!==M[re])return!1;Q.delete(re)}return Q.size===0}Z.equals=q})(N=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let W=class extends S.Disposable{constructor(q,j,M,J,Q,re,ae,B,F,U,x,H){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=j,this.extensionsControlLocation=M,this.cacheLocation=J,this.userDataProfilesService=Q,this.extensionsProfileScannerService=re,this.fileService=ae,this.logService=B,this.environmentService=F,this.productService=U,this.uriIdentityService=x,this.instantiationService=H,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,(0,d.joinPath)(this.cacheLocation,k.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,(0,d.joinPath)(this.cacheLocation,k.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(K,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,b.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(q,j,M){const[J,Q]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(j)]),re=M?await this.scanExtensionsUnderDevelopment(q,[...J,...Q]):[];return this.dedupExtensions(J,Q,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const j=[];j.push(this.scanDefaultSystemExtensions(!!q.useCache,q.language)),j.push(this.scanDevSystemExtensions(q.language,!!q.checkControlFile));const[M,J]=await Promise.all(j);return this.applyScanOptions([...M,...J],0,q,!1)}async scanUserExtensions(q){const j=q.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",j);const M=this.uriIdentityService.extUri.isEqual(q.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,J=await this.createExtensionScannerInput(j,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,M),Q=q.useCache&&!J.devMode&&J.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let re;try{re=await Q.scanExtensions(J)}catch(ae){if(ae instanceof l.ExtensionsProfileScanningError&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),re=await Q.scanExtensions(J);else throw ae}return re=await this.applyScanOptions(re,1,q,!0),this.logService.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(q,j){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const M=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(J=>J.scheme===P.Schemas.file).map(async J=>{const Q=await this.createExtensionScannerInput(J,!1,1,!0,q.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(Q)).map(ae=>(ae.type=j.find(B=>(0,b.areSameExtensions)(B.identifier,ae.identifier))?.type??ae.type,this.extensionsScanner.validate(ae,Q)))}))).flat();return this.applyScanOptions(M,"development",q,!0)}return[]}async scanExistingExtension(q,j,M){const J=await this.createExtensionScannerInput(q,!1,j,!0,M.language,!0,void 0),Q=await this.extensionsScanner.scanExtension(J);return!Q||!M.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(q,j,M){const J=await this.createExtensionScannerInput(q,!1,j,!0,M.language,!0,void 0),Q=await this.extensionsScanner.scanOneOrMultipleExtensions(J);return this.applyScanOptions(Q,j,M,!0)}async scanMetadata(q){const j=(0,d.joinPath)(q,"package.json"),M=(await this.fileService.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(q,j){const M=(0,d.joinPath)(q,"package.json"),J=(await this.fileService.readFile(M)).value.toString(),Q=JSON.parse(J);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,Q.__metadata={...Q.__metadata,...j},await this.fileService.writeFile((0,d.joinPath)(q,"package.json"),R.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof l.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw q}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.extensionsProfileScannerService.addExtensionsToProfile(q.map(j=>[j,j.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,o.toFileOperationResult)(j)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(j))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.logService.error(q)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(q,j,M,J){return M.includeAllVersions||(q=this.dedupExtensions(j===0?q:void 0,j===1?q:void 0,j==="development"?q:void 0,await this.getTargetPlatform(),J)),M.includeInvalid||(q=q.filter(Q=>Q.isValid)),q.sort((Q,re)=>{const ae=w.basename(Q.location.fsPath),B=w.basename(re.location.fsPath);return ae<B?-1:ae>B?1:0})}dedupExtensions(q,j,M,J,Q){const re=(B,F,U)=>{if(B.isValid&&!F.isValid)return!1;if(B.isValid===F.isValid){if(Q&&f.gt(B.manifest.version,F.manifest.version))return this.logService.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${B.location.path} with version ${B.manifest.version}`),!1;if(f.eq(B.manifest.version,F.manifest.version)){if(B.type===0)return this.logService.debug(`Skipping extension ${F.location.path} in favour of system extension ${B.location.path} with same version`),!1;if(B.targetPlatform===J)return this.logService.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return U?this.logService.warn(`Overwriting user extension ${B.location.path} with ${F.location.path}.`):this.logService.debug(`Overwriting user extension ${B.location.path} with ${F.location.path}.`),!0},ae=new Map;return q?.forEach(B=>{const F=k.ExtensionIdentifier.toKey(B.identifier.id),U=ae.get(F);(!U||re(U,B,!1))&&ae.set(F,B)}),j?.forEach(B=>{const F=k.ExtensionIdentifier.toKey(B.identifier.id),U=ae.get(F);if(!U&&q&&B.type===0){this.logService.debug(`Skipping obsolete system extension ${B.location.path}.`);return}(!U||re(U,B,!1))&&ae.set(F,B)}),M?.forEach(B=>{const F=k.ExtensionIdentifier.toKey(B.identifier.id),U=ae.get(F);(!U||re(U,B,!0))&&ae.set(F,B),ae.set(F,B)}),[...ae.values()]}async scanDefaultSystemExtensions(q,j){this.logService.trace("Started scanning system extensions");const M=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),Q=await(q&&!M.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return this.logService.trace("Scanned system extensions:",Q.length),Q}async scanDevSystemExtensions(q,j){const M=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!M?.length)return[];this.logService.trace("Started scanning dev system extensions");const J=j?await this.getBuiltInExtensionControl():{},Q=[],re=u.URI.file(w.normalize(w.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const B of M){const F=J[B.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":Q.push((0,d.joinPath)(re,B.name));break;default:Q.push(u.URI.file(F));break}}const ae=await Promise.all(Q.map(async B=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(B,!1,0,!0,q,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ae.length),(0,L.coalesce)(ae)}async getBuiltInExtensionControl(){try{const q=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(q.value.toString())}catch{return{}}}async createExtensionScannerInput(q,j,M,J,Q,re,ae){const B=await this.getTranslations(Q??m.language),F=await this.getMtime(q),U=j&&!this.uriIdentityService.extUri.isEqual(q,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,x=U?await this.getMtime(U):void 0;return new V(q,F,U,x,j,ae,M,J,re,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,Q,B)}async getMtime(q){try{const j=await this.fileService.stat(q);if(typeof j.mtime=="number")return j.mtime}catch{}}};W=pe([Y(4,p.IUserDataProfilesService),Y(5,l.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,i.ILogService),Y(8,v.IEnvironmentService),Y(9,r.IProductService),Y(10,E.IUriIdentityService),Y(11,t.IInstantiationService)],W),e.AbstractExtensionsScannerService=W;class V{constructor(q,j,M,J,Q,re,ae,B,F,U,x,H,te,G,X){this.location=q,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=J,this.profile=Q,this.profileScanOptions=re,this.type=ae,this.excludeObsolete=B,this.validate=F,this.productVersion=U,this.productDate=x,this.productCommit=H,this.devMode=te,this.language=G,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,j){return(0,d.isEqual)(q.location,j.location)&&q.mtime===j.mtime&&(0,d.isEqual)(q.applicationExtensionslocation,j.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&q.profile===j.profile&&c.equals(q.profileScanOptions,j.profileScanOptions)&&q.type===j.type&&q.excludeObsolete===j.excludeObsolete&&q.validate===j.validate&&q.productVersion===j.productVersion&&q.productDate===j.productDate&&q.productCommit===j.productCommit&&q.devMode===j.devMode&&q.language===j.language&&N.equals(q.translations,j.translations)}}e.ExtensionScannerInput=V;let K=class extends S.Disposable{constructor(q,j,M,J,Q){super(),this.obsoleteFile=q,this.extensionsProfileScannerService=j,this.uriIdentityService=M,this.fileService=J,this.logService=Q}async scanExtensions(q){const j=q.profile?await this.scanExtensionsFromProfile(q):await this.scanExtensionsFromLocation(q);let M={};if(q.excludeObsolete&&q.type===1)try{const J=(await this.fileService.readFile(this.obsoleteFile)).value.toString();M=JSON.parse(J)}catch{}return(0,h.isEmptyObject)(M)?j:j.filter(J=>!M[b.ExtensionKey.create(J).toString()])}async scanExtensionsFromLocation(q){const j=await this.fileService.resolve(q.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async J=>{if(!J.isDirectory||q.type===1&&(0,d.basename)(J.resource).indexOf(".")===0)return null;const Q=new V(J.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Q)}));return(0,L.coalesce)(M).sort((J,Q)=>J.location.path<Q.location.path?-1:1)}async scanExtensionsFromProfile(q){let j=await this.scanExtensionsFromProfileResource(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(q.location,q.applicationExtensionslocation)){j=j.filter(J=>!J.metadata?.isApplicationScoped);const M=await this.scanExtensionsFromProfileResource(q.applicationExtensionslocation,J=>!!J.metadata?.isApplicationScoped,q);j.push(...M)}return j}async scanExtensionsFromProfileResource(q,j,M){const J=await this.extensionsProfileScannerService.scanProfileExtensions(q,M.profileScanOptions);if(!J.length)return[];const Q=await Promise.all(J.map(async re=>{if(j(re)){const ae=new V(re.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(ae,re.metadata)}return null}));return(0,L.coalesce)(Q)}async scanOneOrMultipleExtensions(q){try{if(await this.fileService.exists((0,d.joinPath)(q.location,"package.json"))){const j=await this.scanExtension(q);return j?[j]:[]}else return await this.scanExtensions(q)}catch(j){return this.logService.error(`Error scanning extensions at ${q.location.path}:`,(0,D.getErrorMessage)(j)),[]}}async scanExtension(q,j){try{let M=await this.scanExtensionManifest(q.location);if(M){M.publisher||(M.publisher=k.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const J=(0,b.getGalleryExtensionId)(M.publisher,M.name),Q=j?.id?{id:J,uuid:j.id}:{id:J},re=j?.isSystem?0:q.type,ae=re===0||!!j?.isBuiltin;A.ImplicitActivationEvents.updateManifest(M),M=await this.translateManifest(q.location,M,V.createNlsConfiguration(q));const B={type:re,identifier:Q,manifest:M,location:q.location,isBuiltin:ae,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return q.validate?this.validate(B,q):B}}catch(M){q.type!==0&&this.logService.error(M)}return null}validate(q,j){let M=!0;const J=(0,n.validateExtensionManifest)(j.productVersion,j.productDate,j.location,q.manifest,q.isBuiltin);for(const[Q,re]of J)Q===y.default.Error&&(M=!1,this.logService.error(this.formatMessage(j.location,re)));return q.isValid=M,q.validations=J,q}async scanExtensionManifest(q){const j=(0,d.joinPath)(q,"package.json");let M;try{M=(await this.fileService.readFile(j)).value.toString()}catch(Q){return(0,o.toFileOperationResult)(Q)!==1&&this.logService.error(this.formatMessage(q,(0,g.localize)(0,null,j.path,Q.message))),null}let J;try{J=JSON.parse(M)}catch{const re=[];(0,I.parse)(M,re);for(const ae of re)this.logService.error(this.formatMessage(q,(0,g.localize)(1,null,j.path,ae.offset,ae.length,(0,C.getParseErrorMessage)(ae.error))));return null}return(0,I.getNodeType)(J)!=="object"?(this.logService.error(this.formatMessage(q,(0,g.localize)(2,null,j.path))),null):J}async translateManifest(q,j,M){const J=await this.getLocalizedMessages(q,j,M);if(J)try{const Q=[],re=await this.resolveOriginalMessageBundle(J.default,Q);if(Q.length>0)return Q.forEach(B=>{this.logService.error(this.formatMessage(q,(0,g.localize)(3,null,J.default?.path,(0,C.getParseErrorMessage)(B.error))))}),j;if((0,I.getNodeType)(J)!=="object")return this.logService.error(this.formatMessage(q,(0,g.localize)(4,null,J.default?.path))),j;const ae=J.values||Object.create(null);return(0,T.localizeManifest)(j,ae,re)}catch{}return j}async getLocalizedMessages(q,j,M){const J=(0,d.joinPath)(q,"package.nls.json"),Q=(F,U)=>{U.forEach(x=>{this.logService.error(this.formatMessage(q,(0,g.localize)(5,null,F?.path,(0,C.getParseErrorMessage)(x.error))))})},re=F=>{this.logService.error(this.formatMessage(q,(0,g.localize)(6,null,F?.path)))},ae=`${j.publisher}.${j.name}`,B=M.translations[ae];if(B)try{const F=u.URI.file(B),U=(await this.fileService.readFile(F)).value.toString(),x=[],H=(0,I.parse)(U,x);return x.length>0?(Q(F,x),{values:void 0,default:J}):(0,I.getNodeType)(H)!=="object"?(re(F),{values:void 0,default:J}):{values:H.contents?H.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.fileService.exists(J))return;let U;try{U=await this.findMessageBundles(q,M)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const x=(await this.fileService.readFile(U.localized)).value.toString(),H=[],te=(0,I.parse)(x,H);return H.length>0?(Q(U.localized,H),{values:void 0,default:U.original}):(0,I.getNodeType)(te)!=="object"?(re(U.localized),{values:void 0,default:U.original}):{values:te,default:U.original}}catch{return{values:void 0,default:U.original}}}}async resolveOriginalMessageBundle(q,j){if(q)try{const M=(await this.fileService.readFile(q)).value.toString();return(0,I.parse)(M,j)}catch{}}findMessageBundles(q,j){return new Promise((M,J)=>{const Q=re=>{const ae=(0,d.joinPath)(q,`package.nls.${re}.json`);this.fileService.exists(ae).then(B=>{B&&M({localized:ae,original:(0,d.joinPath)(q,"package.nls.json")});const F=re.lastIndexOf("-");F===-1?M({localized:(0,d.joinPath)(q,"package.nls.json"),original:null}):(re=re.substring(0,F),Q(re))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,d.joinPath)(q,"package.nls.json"),original:null});Q(j.language)})}formatMessage(q,j){return`[${q.path}]: ${j}`}};K=pe([Y(1,l.IExtensionsProfileScannerService),Y(2,E.IUriIdentityService),Y(3,o.IFileService),Y(4,i.ILogService)],K);let z=class extends K{constructor(q,j,M,J,Q,re){super(j,M,J,Q,re),this.cacheFile=q,this.cacheValidatorThrottler=this._register(new _.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(q){const j=await this.readExtensionCache();if(this.input=q,j&&j.input&&V.equals(j.input,this.input))return this.logService.debug("Using cached extensions scan result",q.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),j.result.map(J=>(J.location=u.URI.revive(J.location),J));const M=await super.scanExtensions(q);return await this.writeExtensionCache({input:q,result:M}),M}async readExtensionCache(){try{const q=await this.fileService.readFile(this.cacheFile),j=JSON.parse(q.value.toString());return{result:j.result,input:(0,s.revive)(j.input)}}catch(q){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(q))}return null}async writeExtensionCache(q){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(q)))}catch(j){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(j))}}async validateCache(){if(!this.input)return;const q=await this.readExtensionCache();if(!q)return;const j=q.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!c.equals(M,j))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(J){this.logService.error(J)}}};z=pe([Y(2,l.IExtensionsProfileScannerService),Y(3,E.IUriIdentityService),Y(4,o.IFileService),Y(5,i.ILogService)],z);function O(Z,q){const j=(0,b.getExtensionId)(Z.manifest.publisher,Z.manifest.name);return{id:j,identifier:new k.ExtensionIdentifier(j),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:q,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}e.toExtensionDescription=O;class $ extends W{constructor(q,j,M,J,Q,re,ae,B,F,U,x,H){super(q,j,(0,d.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(J,k.MANIFEST_CACHE_FOLDER),Q,re,ae,B,F,U,x,H),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const te=await this.fileService.readFile(u.URI.file(m.translationsConfigFile));return JSON.parse(te.value.toString())}catch{}return Object.create(null)})()}getTranslations(q){return this.translationsPromise}}e.NativeExtensionsScannerService=$}),define(se[274],oe([0,1,9,18,30,20,51,14,15,11]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends D.AbstractExtensionsProfileScannerService{constructor(m,d,f,y,h,u){super(S.URI.file(m.extensionsPath),d,f,y,h,u)}};P=pe([Y(0,C.INativeEnvironmentService),Y(1,I.IFileService),Y(2,_.IUserDataProfilesService),Y(3,c.IUriIdentityService),Y(4,R.ITelemetryService),Y(5,L.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(se[275],oe([0,1,50,6,39,3,2,22,13,28,9,18]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends D.Disposable{constructor(f,y){super(),this.userDataProfilesService=f,this.logService=y,this.processesLimiter=new _.Limiter(5)}async postUninstall(f){const y=this.parseScript(f,"uninstall");y&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(y.script,"uninstall",y.args,!0,f),this.logService.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(h){this.logService.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.logService.error(h)}}));try{await S.Promises.rm(this.getExtensionStoragePath(f))}catch(h){this.logService.error("Error while removing extension storage path",f.identifier.id),this.logService.error(h)}}parseScript(f,y){const h=`vscode:${y}`;if(f.location.scheme===I.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[h]=="string"){const u=f.manifest.scripts[h].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${h} should be a node script`),null):{script:(0,C.join)(f.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(f,y,h,u,g){return new Promise((v,b)=>{const k=this.start(f,y,h,g);let n;const o=t=>{n&&(clearTimeout(n),n=null),t?b(t):v(void 0)};k.on("error",t=>{o((0,c.toErrorMessage)(t)||"Unknown")}),k.on("exit",(t,i)=>{o(t?`post-${y} process exited with code ${t}`:void 0)}),u&&(n=setTimeout(()=>{n=null,k.kill(),b("timed out")},5e3))})}start(f,y,h,u){const g={silent:!0,execArgv:void 0},v=(0,L.fork)(f,[`--type=extension-post-${y}`,...h],g);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const b=R.Event.fromNodeEventEmitter(v.stdout,"data"),k=R.Event.fromNodeEventEmitter(v.stderr,"data");b(t=>this.logService.info(u.identifier.id,u.manifest.version,`post-${y}`,t)),k(t=>this.logService.error(u.identifier.id,u.manifest.version,`post-${y}`,t));const n=R.Event.any(R.Event.map(b,t=>({data:`%c${t}`,format:[""]})),R.Event.map(k,t=>({data:`%c${t}`,format:["color: red"]})));return R.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}getExtensionStoragePath(f){return(0,C.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};m=pe([Y(0,w.IUserDataProfilesService),Y(1,P.ILogService)],m),e.ExtensionsLifecycle=m}),define(se[276],oe([0,1,11,15,51,78,14,5,9,26,30,18]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends R.NativeExtensionsScannerService{constructor(f,y,h,u,g,v,b,k){super(L.URI.file(g.builtinExtensionsPath),L.URI.file(g.extensionsPath),g.userHome,L.URI.file(g.userDataPath),f,y,h,u,g,v,b,k)}};m=pe([Y(0,w.IUserDataProfilesService),Y(1,c.IExtensionsProfileScannerService),Y(2,D.IFileService),Y(3,C.ILogService),Y(4,_.INativeEnvironmentService),Y(5,S.IProductService),Y(6,P.IUriIdentityService),Y(7,I.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(se[21],oe([0,1,6,3,2,105,12,67,5,18]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function d(g){const v=g.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=d;class f extends c.Disposable{constructor(v={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new _.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new _.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new _.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new c.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,c.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,b){if(b===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:b,target:this.getKeyTargets(v)[b]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,b,k){return this.getStorage(b)?.get(v,k)}getBoolean(v,b,k){return this.getStorage(b)?.getBoolean(v,k)}getNumber(v,b,k){return this.getStorage(b)?.getNumber(v,k)}store(v,b,k,n){if((0,D.isUndefinedOrNull)(b)){this.remove(v,k);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,k,n),this.getStorage(k)?.set(v,b)})}remove(v,b){this.withPausedEmitters(()=>{this.updateKeyTarget(v,b,void 0),this.getStorage(b)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,b){const k=[],n=this.getKeyTargets(v);for(const o of Object.keys(n))n[o]===b&&k.push(o);return k}updateKeyTarget(v,b,k){const n=this.getKeyTargets(b);typeof k=="number"?n[v]!==k&&(n[v]=k,this.getStorage(b)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[v]=="number"&&(delete n[v],this.getStorage(b)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const b=this.getStorage(v);return b?d(b):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=P.NONE){this._onWillSaveState.fire({reason:v});const b=this.getStorage(-1),k=this.getStorage(0),n=this.getStorage(1);switch(v){case P.NONE:await L.Promises.settled([b?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([b?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,b=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return u(v,b,k,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(v,b){return this.emitWillSaveState(P.NONE),(0,S.isUserDataProfile)(v)?this.switchToProfile(v,b):this.switchToWorkspace(v,b)}canSwitchProfile(v,b){return!(v.id===b.id||y(b)&&y(v))}switchData(v,b,k,n){this.withPausedEmitters(()=>{if(n)for(const[o,t]of v)b.set(o,t);else{const o=new Set;for(const[t,i]of v)o.add(t),b.get(t)!==i&&this.emitDidChangeValue(k,t);for(const[t]of b.items)o.has(t)||this.emitDidChangeValue(k,t)}})}}f.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=f;function y(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class h extends f{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(v){return!1}}e.InMemoryStorageService=h;async function u(g,v,b,k,n,o){const t=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,r=new Map;g.forEach((A,N)=>{i.set(N,A),r.set(N,t(A))});const a=new Map,s=new Map;v.forEach((A,N)=>{a.set(N,A),s.set(N,t(A))});const l=new Map,p=new Map;b.forEach((A,N)=>{l.set(N,A),p.set(N,t(A))}),console.group(k!==n?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const E=[];if(i.forEach((A,N)=>{E.push({key:N,value:A})}),console.table(E),console.groupEnd(),console.log(r),k!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const A=[];a.forEach((N,W)=>{A.push({key:W,value:N})}),console.table(A),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${o})`);const T=[];l.forEach((A,N)=>{T.push({key:N,value:A})}),console.table(T),console.groupEnd(),console.log(p)}e.logStorage=u}),define(se[121],oe([0,1,3,2,12,29,33,21]),function(ee,e,L,_,c,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends _.Disposable{constructor(w,m){super(),this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(w)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"}))),this._register(m.onDidInstallExtensions(d=>d.forEach(({local:f,operation:y})=>{f&&y===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(w,m){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}async disableExtension(w,m){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const m=this.getDisabledExtensions();return m.every(d=>!(0,D.areSameExtensions)(d,w))?(m.push(w),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(w){const m=this.getDisabledExtensions();for(let d=0;d<m.length;d++){const f=m[d];if((0,D.areSameExtensions)(f,w))return m.splice(d,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(w){this._setExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,m){this.storageManger.set(w,m,0)}};C=pe([Y(0,I.IStorageService),Y(1,R.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class S extends _.Disposable{constructor(w){super(),this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(w,m){let d;return m===0?((0,c.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,m)),d=this.storage[w]):d=this._get(w,m),JSON.parse(d)}set(w,m,d){const f=JSON.stringify(m.map(({id:h,uuid:u})=>({id:h,uuid:u})));this._get(w,d)!==f&&(d===0&&(m.length?this.storage[w]=f:delete this.storage[w]),this._set(w,m.length?f:void 0,d))}onDidStorageChange(w){if(w.scope===0&&!(0,c.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const d=this.get(w.key,w.scope);delete this.storage[w.key];const f=this.get(w.key,w.scope),y=d.filter(u=>!f.some(g=>(0,D.areSameExtensions)(u,g))),h=f.filter(u=>!d.some(g=>(0,D.areSameExtensions)(g,u)));(y.length||h.length)&&this._onDidChange.fire([...y,...h])}}_get(w,m){return this.storageService.get(w,m,"[]")}_set(w,m,d){m?this.storageService.store(w,m,d,1):this.storageService.remove(w,d)}}e.StorageManager=S}),define(se[277],oe([0,1,19,24,7,4,36,12,11,17,15,29,33,68,14,9,26,59,244,21,20]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const k=R.isWeb?"web":(0,w.getTargetPlatform)(R.platform,D.arch),n="X-Market-Search-Activity-Id";var o;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function t(...F){return String(F.reduce((U,x)=>U|x,0))}var i;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class p{constructor(U=l){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(U,x=this.state.pageSize){return new p({...this.state,pageNumber:U,pageSize:x})}withFilter(U,...x){const H=[...this.state.criteria,...x.length?x.map(te=>({filterType:U,value:te})):[{filterType:U}]];return new p({...this.state,criteria:H})}withSortBy(U){return new p({...this.state,sortBy:U})}withSortOrder(U){return new p({...this.state,sortOrder:U})}withFlags(...U){return new p({...this.state,flags:U.reduce((x,H)=>x|H,0)})}withAssetTypes(...U){return new p({...this.state,assetTypes:U})}withSource(U){return new p({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:x,pageSize:H,sortBy:te,sortOrder:G,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:U,pageNumber:x,pageSize:H,sortBy:te,sortOrder:G}],assetTypes:ie,flags:X}}get searchText(){const U=this.state.criteria.filter(x=>x.filterType===i.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function E(F,U){const x=(F||[]).filter(H=>H.statisticName===U)[0];return x?x.value:0}function T(F){const U="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(H=>H.assetType.indexOf(U)===0).reduce((H,te)=>{const G=W(F,te.assetType);return G&&H.push([te.assetType.substring(U.length),G]),H},[])}function A(F){if(F.properties){const U=F.properties.filter(te=>te.key===r.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=U.filter(te=>x.test(te.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return W(F,r.Repository)}function N(F){return{uri:`${F.fallbackAssetUri}/${r.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${r.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function W(F,U){return F.files.filter(H=>H.assetType===U)[0]?{uri:`${F.assetUri}/${U}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${U}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function V(F,U){const x=F.properties?F.properties.filter(te=>te.key===U):[],H=x.length>0&&x[0].value;return H?H.split(",").map(te=>(0,m.adoptToGalleryExtensionId)(te)):[]}function K(F){const U=F.properties?F.properties.filter(x=>x.key===a.Engine):[];return U.length>0&&U[0].value||""}function z(F){const U=F.properties?F.properties.filter(x=>x.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function O(F){const U=F.properties?F.properties.filter(H=>H.key===a.LocalizedLanguages):[],x=U.length>0&&U[0].value||"";return x?x.split(","):[]}function $(F){return F.properties?.find(U=>U.key===a.SponsorLink)?.value}function Z(F){return F.indexOf("preview")!==-1}function q(F){return F.targetPlatform?(0,w.toTargetPlatform)(F.targetPlatform):"undefined"}function j(F){const U=(0,L.distinct)(F.versions.map(q)),x=!!F.tags?.includes(w.WEB_EXTENSION_TAG),H=U.indexOf("web");return x?H===-1&&U.push("web"):H!==-1&&U.splice(H,1),U}function M(F,U){const x=(0,w.getFallbackTargetPlarforms)(U);for(let H=0;H<F.length;H++){const te=F[H];if(te.version===F[H-1]?.version){let G=H;const X=q(te);if(X===U)for(;G>0&&F[G-1].version===te.version;)G--;else if(x.includes(X))for(;G>0&&F[G-1].version===te.version&&q(F[G-1])!==U;)G--;G!==H&&(F.splice(H,1),F.splice(G,0,te))}}return F}e.sortExtensionVersions=M;function J(F,U,x){F.telemetryData={index:U,querySource:x,queryActivityId:F.queryContext?.[n]}}function Q(F,U,x,H){const te=F.versions[0],G={manifest:W(U,r.Manifest),readme:W(U,r.Details),changelog:W(U,r.Changelog),license:W(U,r.License),repository:A(U),download:N(U),icon:W(U,r.Icon),signature:W(U,r.Signature),coreTranslations:T(U)};return{identifier:{id:(0,m.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:U.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:$(te),description:F.shortDescription||"",installCount:E(F.statistics,"install"),rating:E(F.statistics,"averagerating"),ratingCount:E(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:x,assets:G,properties:{dependencies:V(U,a.Dependency),extensionPack:V(U,a.ExtensionPack),engine:K(U),localizedLanguages:O(U),targetPlatform:q(U),isPreReleaseVersion:z(U)},hasPreReleaseVersion:z(te),hasReleaseVersion:!0,preview:Z(F.flags),isSigned:!!G.signature,queryContext:H}}let re=class{constructor(U,x,H,te,G,X,ie,le){this.requestService=x,this.logService=H,this.environmentService=te,this.telemetryService=G,this.fileService=X,this.productService=ie,this.configurationService=le;const he=ie.extensionsGallery,me=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=me?he.servicePPEUrl:he?.serviceUrl,this.extensionsGallerySearchUrl=me?void 0:he?.searchUrl,this.extensionsControlUrl=he?.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,x,H){const te=_.CancellationToken.isCancellationToken(x)?{}:x,G=_.CancellationToken.isCancellationToken(x)?x:H,X=[],ie=[],le=[],he=[];let me=!0;for(const Ce of U){Ce.uuid?ie.push(Ce.uuid):X.push(Ce.id);const Re=!!(Ce.version||Ce.preRelease);le.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Re}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),me=me&&!!Ce.hasPreRelease&&!Re}if(!ie.length&&!X.length)return[];let ve=new p().withPage(1,U.length);ie.length&&(ve=ve.withFilter(i.ExtensionId,...ie)),X.length&&(ve=ve.withFilter(i.ExtensionName,...X)),(te.queryAllVersions||me)&&(ve=ve.withFlags(ve.flags,o.IncludeVersions)),te.source&&(ve=ve.withSource(te.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:te.targetPlatform??k,includePreRelease:le,versions:he,compatible:!!te.compatible},G);return te.source&&we.forEach((Ce,Re)=>J(Ce,Re,te.source)),we}async getCompatibleExtension(U,x,H){if((0,w.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(U,x,H))return U;const te=new p().withFlags(o.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,U.identifier.uuid),{extensions:G}=await this.queryGalleryExtensions(te,{targetPlatform:H,compatible:!0,includePreRelease:x},_.CancellationToken.None);return G[0]||null}async isExtensionCompatible(U,x,H){if(!(0,w.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,H)||!x&&U.properties.isPreReleaseVersion)return!1;let te=U.properties.engine;if(!te){const G=await this.getManifest(U,_.CancellationToken.None);if(!G)throw new Error("Manifest was not found");te=G.engines.vscode}return(0,d.isEngineValid)(te,this.productService.version,this.productService.date)}async isValidVersion(U,x,H,te,G){if(!(0,w.isTargetPlatformCompatible)(q(U),te,G)||x!=="any"&&z(U)!==(x==="prerelease"))return!1;if(H)try{const X=await this.getEngine(U);if(!(0,d.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,c.getErrorMessage)(X)),!1}return!0}async query(U,x){let H=U.text||"";const te=U.pageSize??50;let G=new p().withPage(1,te);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ve,we)=>(G=G.withFilter(i.Category,we||ve),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ve,we)=>(G=G.withFilter(i.Tag,we||ve),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),G=G.withFilter(i.SearchText,H)),G=G.withSortBy(0)):U.ids?G=G.withFilter(i.ExtensionId,...U.ids):U.names?G=G.withFilter(i.ExtensionName,...U.names):G=G.withSortBy(4),typeof U.sortBy=="number"&&(G=G.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(G=G.withSortOrder(U.sortOrder)),U.source&&(G=G.withSource(U.source));const X=async(me,ve)=>{const{extensions:we,total:Ce}=await this.queryGalleryExtensions(me,{targetPlatform:k,compatible:!1,includePreRelease:!!U.includePreRelease},ve);return we.forEach((Re,ke)=>J(Re,(me.pageNumber-1)*me.pageSize+ke,U.source)),{extensions:we,total:Ce}},{extensions:ie,total:le}=await X(G,x),he=async(me,ve)=>{if(ve.isCancellationRequested)throw new c.CancellationError;const{extensions:we}=await X(G.withPage(me+1),ve);return we};return{firstPage:ie,total:le,pageSize:G.pageSize,getPage:he}}async queryGalleryExtensions(U,x,H){const te=U.flags;!!(U.flags&o.IncludeLatestVersionOnly)&&!!(U.flags&o.IncludeVersions)&&(U=U.withFlags(U.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(U.flags&o.IncludeLatestVersionOnly)&&!(U.flags&o.IncludeVersions)&&(U=U.withFlags(U.flags,o.IncludeLatestVersionOnly)),x.versions?.length&&(U=U.withFlags(U.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),U=U.withFlags(U.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:G,total:X,context:ie}=await this.queryRawGalleryExtensions(U,H);if(!(U.flags&o.IncludeLatestVersionOnly)){const ve=[];for(const we of G){const Ce=await this.toGalleryExtensionWithCriteria(we,x,ie);Ce&&ve.push(Ce)}return{extensions:ve,total:X}}const he=[],me=new Map;for(let ve=0;ve<G.length;ve++){const we=G[ve],Ce={id:(0,m.getGalleryExtensionId)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Re=(0,I.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ze=>(0,m.areSameExtensions)(ze,Ce))?.includePreRelease;if(x.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(j(we),x.targetPlatform))continue;const ke=await this.toGalleryExtensionWithCriteria(we,x,ie);!ke||ke.properties.isPreReleaseVersion&&(!Re||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==x.targetPlatform&&ke.hasPreReleaseVersion?me.set(we.extensionId,ve):he.push([ve,ke])}if(me.size){const ve=new Date().getTime(),we=new p().withFlags(te&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,me.size).withFilter(i.ExtensionId,...me.keys()),{extensions:Ce}=await this.queryGalleryExtensions(we,x,H);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ve,count:me.size});for(const Re of Ce){const ke=me.get(Re.identifier.uuid);he.push([ke,Re])}}return{extensions:he.sort((ve,we)=>ve[0]-we[0]).map(([,ve])=>ve),total:X}}async toGalleryExtensionWithCriteria(U,x,H){const te={id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},G=x.versions?.find(he=>(0,m.areSameExtensions)(he,te))?.version,X=(0,I.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(he=>(0,m.areSameExtensions)(he,te))?.includePreRelease,ie=j(U),le=M(U.versions,x.targetPlatform);if(x.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ie,x.targetPlatform))return null;for(let he=0;he<le.length;he++){const me=le[he];if(!(G&&me.version!==G)){if(await this.isValidVersion(me,X?"any":"release",x.compatible,ie,x.targetPlatform))return Q(U,me,ie,H);if(G&&me.version===G)return null}}return G||x.compatible?null:Q(U,U.versions[0],ie)}async queryRawGalleryExtensions(U,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,o.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,t(o.Unpublished));const H=await this.commonHeadersPromise,te=JSON.stringify(U.raw),G={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(te.length)},X=new Date().getTime();let ie,le,he=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&U.criteria.some(ve=>ve.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:te,headers:G},x),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:he};const me=await(0,u.asJson)(ie);if(me){const ve=me.results[0],we=ve.extensions,Ce=ve.resultMetadata&&ve.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[n]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(me){throw le=me,me}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(te.length),duration:new Date().getTime()-X,success:!!ie&&(0,u.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:le?(0,c.isCancellationError)(le)?"canceled":(0,c.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(U,x,H,te){if(!this.isEnabled())return;const G=R.isWeb?this.api(`/itemName/${U}.${x}/version/${H}/statType/${te==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${x}/${H}/stats?statType=${te}`),X=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:G,headers:le},_.CancellationToken.None)}catch{}}async download(U,x,H){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const te=(0,m.getGalleryExtensionTelemetryData)(U),G=new Date().getTime(),X=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...te,duration:ve}),ie=H===2?"install":H===3?"update":"",le=ie?{uri:`${U.assets.download.uri}${C.URI.parse(U.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${U.assets.download.fallbackUri}${C.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:U.assets.download,he=U.queryContext?.[n]?{[n]:U.queryContext[n]}:void 0,me=await this.getAsset(le,he?{headers:he}:void 0);await this.fileService.writeFile(x,me.stream),X(new Date().getTime()-G)}async downloadSignatureArchive(U,x){if(!U.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const H=await this.getAsset(U.assets.signature);await this.fileService.writeFile(x,H.stream)}async getReadme(U,x){if(U.assets.readme){const H=await this.getAsset(U.assets.readme,{},x);return await(0,u.asTextOrError)(H)||""}return""}async getManifest(U,x){if(U.assets.manifest){const H=await this.getAsset(U.assets.manifest,{},x),te=await(0,u.asTextOrError)(H);return te?JSON.parse(te):null}return null}async getManifestFromRawExtensionVersion(U,x){const H=W(U,r.Manifest);if(!H)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},G=await this.getAsset(H,{headers:te});return await(0,u.asJson)(G)}async getCoreTranslation(U,x){const H=U.assets.coreTranslations.filter(te=>te[0]===x.toUpperCase())[0];if(H){const te=await this.getAsset(H[1]),G=await(0,u.asTextOrError)(te);return G?JSON.parse(G):null}return null}async getChangelog(U,x){if(U.assets.changelog){const H=await this.getAsset(U.assets.changelog,{},x);return await(0,u.asTextOrError)(H)||""}return""}async getAllCompatibleVersions(U,x,H){let te=new p().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?te=te.withFilter(i.ExtensionId,U.identifier.uuid):te=te.withFilter(i.ExtensionName,U.identifier.id);const{galleryExtensions:G}=await this.queryRawGalleryExtensions(te,_.CancellationToken.None);if(!G.length)return[];const X=j(G[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(X,H))return[];const ie=[];await Promise.all(G[0].versions.map(async me=>{try{await this.isValidVersion(me,x?"any":"release",!0,X,H)&&ie.push(me)}catch{}}));const le=[],he=new Set;for(const me of M(ie,H))he.has(me.version)||(he.add(me.version),le.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:z(me)}));return le}async getAsset(U,x={},H=_.CancellationToken.None){const te=await this.commonHeadersPromise,G={type:"GET"},X={...te,...x.headers||{}};x={...x,...G,headers:X};const ie=U.uri,le=U.fallbackUri,he={...x,url:ie};try{const me=await this.requestService.request(he,H);if(me.res.statusCode===200)return me;const ve=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${ve}`)}catch(me){if((0,c.isCancellationError)(me))throw me;const ve=(0,c.getErrorMessage)(me);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...x,url:le};return this.requestService.request(we,H)}}async getEngine(U){let x=K(U);if(!x){const H=await this.getManifestFromRawExtensionVersion(U,_.CancellationToken.None);if(!H)throw new Error("Manifest was not found");x=H.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},_.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,u.asJson)(U),H=[],te={};if(x){for(const G of x.malicious)H.push({id:G});if(x.migrateToPreRelease)for(const[G,X]of Object.entries(x.migrateToPreRelease))(!X.engine||(0,d.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(te[G.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[G,X]of Object.entries(x.deprecated))X&&(te[G.toLowerCase()]=(0,I.isBoolean)(X)?{}:X)}return{malicious:H,deprecated:te}}};re=pe([Y(1,u.IRequestService),Y(2,y.ILogService),Y(3,P.IEnvironmentService),Y(4,b.ITelemetryService),Y(5,f.IFileService),Y(6,h.IProductService),Y(7,S.IConfigurationService)],re);let ae=class extends re{constructor(U,x,H,te,G,X,ie,le){super(U,x,H,te,G,X,ie,le)}};ae=pe([Y(0,v.IStorageService),Y(1,u.IRequestService),Y(2,y.ILogService),Y(3,P.IEnvironmentService),Y(4,b.ITelemetryService),Y(5,f.IFileService),Y(6,h.IProductService),Y(7,S.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let B=class extends re{constructor(U,x,H,te,G,X,ie){super(void 0,U,x,H,te,G,X,ie)}};B=pe([Y(0,u.IRequestService),Y(1,y.ILogService),Y(2,P.IEnvironmentService),Y(3,b.ITelemetryService),Y(4,f.IFileService),Y(5,h.IProductService),Y(6,S.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B}),define(se[79],oe([0,1,5,3,2,21,33,26,19,9,12]),function(ee,e,L,_,c,R,D,I,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Je extends c.Disposable{static toKey(f){return`extensionKeys/${(0,D.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const y=w.exec(f);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(f,y){const h=await f.getInstalled(),u=[];for(const[g,v]of Je.readAllExtensionsWithKeysForSync(y)){const b=h.find(k=>(0,D.areSameExtensions)(k.identifier,{id:g}))?.manifest.version;for(const k of v)b!==k&&u.push(Je.toKey({id:g,version:k}))}for(const g of u)y.remove(g,0)}static readAllExtensionsWithKeysForSync(f){const y=new Map,h=f.keys(0,1);for(const u of h){const g=Je.fromKey(u);if(g){let v=y.get(g.id.toLowerCase());v||y.set(g.id.toLowerCase(),v=[]),v.push(g.version)}}return y}constructor(f,y,h){super(),this.storageService=f,this.productService=y,this.logService=h,this._onDidChangeExtensionStorageToSync=this._register(new _.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const y=Je.fromKey(f.key);if(y){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(y.id.toLowerCase());else{let h=this.extensionsWithKeysForSync.get(y.id.toLowerCase());h||this.extensionsWithKeysForSync.set(y.id.toLowerCase(),h=[]),h.push(y.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,P.isString)(f))return f;const y=f.manifest?f.manifest.publisher:f.publisher,h=f.manifest?f.manifest.name:f.name;return(0,D.getExtensionId)(y,h)}getExtensionState(f,y){const h=this.getExtensionId(f),u=this.getExtensionStateRaw(f,y);if(u)try{return JSON.parse(u)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${y}): ${g}`)}}getExtensionStateRaw(f,y){const h=this.getExtensionId(f),u=this.storageService.get(h,y?0:1);return u&&u?.length>Je.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${y}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(f,y,h){const u=this.getExtensionId(f);y===void 0?this.storageService.remove(u,h?0:1):this.storageService.store(u,JSON.stringify(y),h?0:1,1)}setKeysForSync(f,y){this.storageService.store(Je.toKey(f),JSON.stringify(y),0,1)}getKeysForSync(f){const y=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],h=this.storageService.get(Je.toKey(f),0),u=h?JSON.parse(h):void 0;return u&&y?(0,C.distinct)([...u,...y]):u||y}addToMigrationList(f,y){if(f!==y){const h=this.migrationList.filter(u=>!u.includes(f)&&!u.includes(y));h.push([f,y]),this.migrationList=h}}getSourceExtensionToMigrate(f){const y=this.migrationList.find(([,h])=>f===h);return y?y[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(f);if(Array.isArray(y))return y}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};m.LARGE_STATE_WARNING_THRESHOLD=512*1024,m=pe([Y(0,R.IStorageService),Y(1,I.IProductService),Y(2,S.ILogService)],m),e.ExtensionStorageService=m}),define(se[278],oe([0,1,19,6,3,13,4,36,11,165,15,29,33,221,102,14,57,26,21,20]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const b="extensionTips/promptedExecutableTips",k="extensionTips/lastPromptedMediumImpExeTime";let n=class extends d.ExtensionTipsService{constructor(t,i,r,a,s,l,p,E){super(p,E),this.environmentService=t,this.telemetryService=i,this.extensionManagementService=r,this.storageService=a,this.nativeHostService=s,this.extensionRecommendationNotificationService=l,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([T,A])=>{const N=[],W=[],V=[];Object.entries(A.recommendations).forEach(([K,z])=>{z.important?A.important?N.push({extensionId:K,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):W.push({extensionId:K,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):V.push({extensionId:K,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),N.length&&this.highImportanceExecutableTips.set(T,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:N}),W.length&&this.mediumImportanceExecutableTips.set(T,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:W}),V.length&&this.allOtherExecutableTips.set(T,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:V})}),(0,_.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const t=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),i=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...t,...i]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const t=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),i=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),r=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(t,r),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(i,r)}groupImportantTipsByExe(t,i){const r=new Map;t.forEach(E=>r.set(E.extensionId.toLowerCase(),E));const{installed:a,uninstalled:s}=this.groupByInstalled([...r.keys()],i);for(const E of a){const T=r.get(E);T&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:T.exeName})}for(const E of s){const T=r.get(E);T&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:T.exeName})}const l=this.getPromptedExecutableTips(),p=new Map;for(const E of s){const T=r.get(E);if(T&&(!l[T.exeName]||!l[T.exeName].includes(T.extensionId))){let A=p.get(T.exeName);A||(A=[],p.set(T.exeName,A)),A.push(T)}}return p}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[t,i]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(i).then(r=>{switch(r){case"reacted":this.addToRecommendedExecutables(i[0].exeName,i);break;case"ignored":this.highImportanceTipsByExe.delete(t);break;case"incompatibleWindow":{const a=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(a(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const a=this._register((0,_.disposableTimeout)(()=>{a.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const t=this.getLastPromptedMediumExeTime(),i=Date.now()-t,r=7*24*60*60*1e3;if(i<r){const l=this._register((0,_.disposableTimeout)(()=>{l.dispose(),this.promptMediumImportanceExeBasedTip()},r-i));return}const[a,s]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(l=>{switch(l){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(a),this.addToRecommendedExecutables(s[0].exeName,s);const p=this._register((0,_.disposableTimeout)(()=>{p.dispose(),this.promptMediumImportanceExeBasedTip()},r));break}case"ignored":this.mediumImportanceTipsByExe.delete(a),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const p=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(p(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const p=this._register((0,_.disposableTimeout)(()=>{p.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(t){const i=await this.extensionManagementService.getInstalled(1),r=t.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(l=>i.every(p=>!(0,m.areSameExtensions)(p.identifier,{id:l})))).map(({extensionId:s})=>s.toLowerCase()),a=(0,S.localize)(0,null,t[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(r,a,`@exe:"${t[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let t=this.storageService.getNumber(k,-1);return t||(t=Date.now(),this.updateLastPromptedMediumExeTime(t)),t}updateLastPromptedMediumExeTime(t){this.storageService.store(k,t,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(b,-1,"{}"))}addToRecommendedExecutables(t,i){const r=this.getPromptedExecutableTips();r[t]=i.map(({extensionId:a})=>a.toLowerCase()),this.storageService.store(b,JSON.stringify(r),-1,0)}groupByInstalled(t,i){const r=[],a=[],s=i.reduce((l,p)=>(l.add(p.identifier.id.toLowerCase()),l),new Set);return t.forEach(l=>{s.has(l.toLowerCase())?r.push(l):a.push(l)}),{installed:r,uninstalled:a}}async getValidExecutableBasedExtensionTips(t){const i=[],r=new Map;for(const a of t.keys()){const s=t.get(a);if(!s||!(0,L.isNonEmptyArray)(s.recommendations))continue;const l=[];D.isWindows?s.windowsPath&&l.push(s.windowsPath.replace("%USERPROFILE%",()=>I.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>I.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>I.env.ProgramFiles).replace("%APPDATA%",()=>I.env.APPDATA).replace("%WINDIR%",()=>I.env.WINDIR)):(l.push((0,R.join)("/usr/local/bin",a)),l.push((0,R.join)("/usr/bin",a)),l.push((0,R.join)(this.environmentService.userHome.fsPath,a)));for(const p of l){let E=r.get(p);if(E===void 0&&(E=await this.fileService.exists(C.URI.file(p)),r.set(p,E)),E)for(const{extensionId:T,extensionName:A,isExtensionPack:N,whenNotInstalled:W}of s.recommendations)i.push({extensionId:T,extensionName:A,isExtensionPack:N,exeName:a,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:W})}}return i}};n=pe([Y(0,P.INativeEnvironmentService),Y(1,v.ITelemetryService),Y(2,w.IExtensionManagementService),Y(3,g.IStorageService),Y(4,h.INativeHostService),Y(5,f.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,u.IProductService)],n),e.ExtensionTipsService=n}),define(se[279],oe([0,1,6,2,25,67,21,75,18]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends D.AbstractStorageService{constructor(w,m,d,f){super(),this.initialWorkspace=w,this.initialProfiles=m,this.mainProcessService=d,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new _.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new _.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const w=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),m=this._register(new R.Storage(w));return this._register(m.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d))),m}createProfileStorage(w){this.profileStorageDisposables.clear(),this.profileStorageProfile=w;let m;if((0,D.isProfileUsingDefaultStorage)(w))m=this.applicationStorage;else{const d=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),w));m=this.profileStorageDisposables.add(new R.Storage(d))}return this.profileStorageDisposables.add(m.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),m}createWorkspaceStorage(w){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=w?.id;let m;if(w){const d=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),w));m=this.workspaceStorageDisposables.add(new R.Storage(d)),this.workspaceStorageDisposables.add(m.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return m}async doInitialize(){await L.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,c.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(D.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(w,m){if(!this.canSwitchProfile(this.profileStorageProfile,w))return;const d=this.profileStorage,f=d.items;d!==this.applicationStorage&&await d.close(),this.profileStorage=this.createProfileStorage(w),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0,m)}async switchToWorkspace(w,m){const d=this.workspaceStorage,f=d?.items??new Map;await d?.close(),this.workspaceStorage=this.createWorkspaceStorage(w),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1,m)}hasScope(w){return(0,C.isUserDataProfile)(w)?this.profileStorageProfile.id===w.id:this.workspaceStorageId===w.id}}e.NativeStorageService=S}),define(se[280],oe([0,1,3,2,18,93]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class D{constructor(S,P){this.service=S,this.getUriTransformer=P}listen(S,P){const w=this.getUriTransformer(S);switch(P){case"onDidChangeProfiles":return L.Event.map(this.service.onDidChangeProfiles,m=>({all:m.all.map(d=>(0,R.transformOutgoingURIs)({...d},w)),added:m.added.map(d=>(0,R.transformOutgoingURIs)({...d},w)),removed:m.removed.map(d=>(0,R.transformOutgoingURIs)({...d},w)),updated:m.updated.map(d=>(0,R.transformOutgoingURIs)({...d},w))}))}throw new Error(`Invalid listen ${P}`)}async call(S,P,w){const m=this.getUriTransformer(S);switch(P){case"createProfile":{const d=await this.service.createProfile(w[0],w[1],w[2]);return(0,R.transformOutgoingURIs)({...d},m)}case"updateProfile":{let d=(0,c.reviveProfile)((0,R.transformIncomingURIs)(w[0],m),this.service.profilesHome.scheme);return d=await this.service.updateProfile(d,w[1]),(0,R.transformOutgoingURIs)({...d},m)}case"removeProfile":{const d=(0,c.reviveProfile)((0,R.transformIncomingURIs)(w[0],m),this.service.profilesHome.scheme);return this.service.removeProfile(d)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=D;class I extends _.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(S,P,w){super(),this.profilesHome=P,this.channel=w,this._profiles=[],this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=S.map(m=>(0,c.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const d=m.added.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme)),f=m.removed.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme)),y=m.updated.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme));this._profiles=m.all.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:f,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(S){this.enabled=S}isEnabled(){return this.enabled}async createNamedProfile(S,P,w){const m=await this.channel.call("createNamedProfile",[S,P,w]);return(0,c.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(S,P,w,m){const d=await this.channel.call("createProfile",[S,P,w,m]);return(0,c.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(S){const P=await this.channel.call("createTransientProfile",[S]);return(0,c.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(S,P){await this.channel.call("setProfileForWorkspace",[S,P])}removeProfile(S){return this.channel.call("removeProfile",[S])}async updateProfile(S,P){const w=await this.channel.call("updateProfile",[S,P]);return(0,c.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=I}),define(se[61],oe([0,1,2,67,5,21]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,c.createDecorator)("IUserDataProfileStorageService");let D=class extends L.Disposable{constructor(S){super(),this.storageService=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async P=>this.getItems(P))}async updateStorageData(S,P,w){return this.withProfileScopedStorageService(S,async m=>this.writeItems(m,P,w))}async withProfileScopedStorageService(S,P){if(this.storageService.hasScope(S))return P(this.storageService);const w=await this.createStorageDatabase(S),m=new I(w);try{await m.initialize();const d=await P(m);return await m.flush(),d}finally{m.dispose(),await this.closeAndDispose(w)}}getItems(S){const P=new Map,w=m=>{for(const d of S.keys(0,m))P.set(d,{value:S.get(d,0),target:m})};return w(0),w(1),P}writeItems(S,P,w){for(const[m,d]of P)S.store(m,d,0,w)}async closeAndDispose(S){try{await S.close()}finally{(0,L.isDisposable)(S)&&S.dispose()}}};D=pe([Y(0,R.IStorageService)],D),e.AbstractUserDataProfileStorageService=D;class I extends R.AbstractStorageService{constructor(S){super({flushInterval:100}),this.profileStorage=this._register(new _.Storage(S))}doInitialize(){return this.profileStorage.init()}getStorage(S){return S===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(se[281],oe([0,1,3,2,71,9,61,21,75,18,69]),function(ee,e,L,_,c,R,D,I,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let w=class extends D.AbstractUserDataProfileStorageService{constructor(d,f,y,h){super(y),this.mainProcessService=d;const u=d.getChannel("profileStorageListener"),g=this._register(new _.MutableDisposable);this._onDidChange=this._register(new L.Emitter({onWillAddFirstListener:()=>{g.value=u.listen("onDidChange")(v=>{h.trace("profile storage changes",v),this._onDidChange.fire({targetChanges:v.targetChanges.map(b=>(0,S.reviveProfile)(b,f.profilesHome.scheme)),valueChanges:v.valueChanges.map(b=>({...b,profile:(0,S.reviveProfile)(b.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>g.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(d){const f=this.mainProcessService.getChannel("storage");return(0,I.isProfileUsingDefaultStorage)(d)?new C.ApplicationStorageDatabaseClient(f):new C.ProfileStorageDatabaseClient(f,d)}};w=pe([Y(0,c.IMainProcessService),Y(1,S.IUserDataProfilesService),Y(2,I.IStorageService),Y(3,R.ILogService)],w),e.UserDataProfileStorageService=w,(0,P.registerSingleton)(D.IUserDataProfileStorageService,w,1)}),define(se[41],oe([0,1,19,6,16,24,3,35,2,27,12,183,17,15,14,9,44,21,20,30,23,18]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(l){return!!(l&&l.ref!==void 0&&typeof l.ref=="string"&&l.ref!==""&&l.syncData!==void 0&&(l.syncData===null||o(l.syncData)))}e.isRemoteUserData=n;function o(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=o;function t(l,p){return`${(0,S.uppercaseFirstLetter)(l)}${p.isDefault?"":` (${p.name})`}`}e.getSyncResourceLogLabel=t;let i=class extends C.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(p,E,T,A,N,W,V,K,z,O,$,Z){super(),this.syncResource=p,this.collection=E,this.fileService=T,this.environmentService=A,this.storageService=N,this.userDataSyncStoreService=W,this.userDataSyncBackupStoreService=V,this.userDataSyncEnablementService=K,this.telemetryService=z,this.logService=O,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new _.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new D.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=t(p.syncResource,p.profile),this.extUri=Z.extUri,this.syncFolder=this.extUri.joinPath(A.userDataSyncHome,...(0,b.getPathSegments)(p.profile.isDefault?void 0:p.profile.id,p.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,b.PREVIEW_DIR_NAME),this.lastSyncResource=(0,b.getLastSyncResourceUri)(p.profile.isDefault?void 0:p.profile.id,p.syncResource,A,this.extUri),this.currentMachineIdPromise=(0,h.getServiceMachineId)(A,T,N)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const p=await this.syncPreviewPromise;this.syncPreviewPromise=null;const E=await this.performSync(p.remoteUserData,p.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(E)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const p=await this.getLastSyncUserData();(p?await this.hasRemoteChanged(p):!0)&&this._onDidChangeLocal.fire()}}setStatus(p){this._status!==p&&(this._status=p,this._onDidChangStatus.fire(p))}async sync(p,E={}){await this._sync(p,!0,this.getUserDataSyncConfiguration(),E)}async preview(p,E,T={}){return this._sync(p,!1,E,T)}async apply(p,E={}){try{this.syncHeaders={...E};const T=await this.doApply(p);return this.setStatus(T),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(p,E,T,A){try{if(this.syncHeaders={...A},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let N="idle";try{const W=await this.getLastSyncUserData(),V=await this.getLatestRemoteUserData(p,W);return N=await this.performSync(V,W,E,T),N==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(N)}}finally{this.syncHeaders={}}}async replace(p){const E=this.parseSyncData(p);if(!E)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const T=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,T),N=await this.isRemoteDataFromCurrentMachine(A),W=await this.generateSyncPreview({ref:A.ref,syncData:E},T,N,this.getUserDataSyncConfiguration(),R.CancellationToken.None),V=[];for(const K of W){const z=await this.getAcceptResult(K,K.remoteResource,void 0,R.CancellationToken.None),{remoteChange:O}=await this.getAcceptResult(K,K.previewResource,K.remoteContent,R.CancellationToken.None);V.push([K,{...z,remoteChange:O!==0?O:2}])}await this.applyResult(A,T,V,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(p){const E=await this.currentMachineIdPromise;return!!p.syncData?.machineId&&p.syncData.machineId===E}async getLatestRemoteUserData(p,E){if(E){const T=p?p[this.resource]:void 0;if(E.ref===T||T===void 0&&E.syncData===null)return E}return this.getRemoteUserData(E)}async performSync(p,E,T,A){if(p.syncData&&p.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new b.UserDataSyncError((0,w.localize)(0,null,this.resource,this.version,p.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(p,E,T,A)}catch(N){if(N instanceof b.UserDataSyncError)switch(N.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(p,E,T,A);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),p=await this.getRemoteUserData(null),E=await this.getLastSyncUserData(),this.performSync(p,E,T,A)}throw N}}async doSync(p,E,T,A){try{const N=await this.isRemoteDataFromCurrentMachine(p),W=!N&&E===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,V=T&&!W;this.syncPreviewPromise||(this.syncPreviewPromise=(0,_.createCancelablePromise)(z=>this.doGenerateSyncResourcePreview(p,E,N,V,A,z)));let K=await this.syncPreviewPromise;if(T&&W){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of K.resourcePreviews)K=await this.accept(z.remoteResource)||K}return this.updateConflicts(K.resourcePreviews),K.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":T?await this.doApply(!1):"syncing"}catch(N){throw this.syncPreviewPromise=null,N}}async merge(p){return await this.updateSyncResourcePreview(p,async E=>{const T=await this.getMergeResult(E,R.CancellationToken.None);await this.fileService.writeFile(E.previewResource,c.VSBuffer.fromString(T?.content||""));const A=T&&!T.hasConflicts?await this.getAcceptResult(E,E.previewResource,void 0,R.CancellationToken.None):void 0;return E.acceptResult=A,E.mergeState=T.hasConflicts?"conflict":A?"accepted":"preview",E.localChange=A?A.localChange:T.localChange,E.remoteChange=A?A.remoteChange:T.remoteChange,E}),this.syncPreviewPromise}async accept(p,E){return await this.updateSyncResourcePreview(p,async T=>{const A=await this.getAcceptResult(T,p,E,R.CancellationToken.None);return T.acceptResult=A,T.mergeState="accepted",T.localChange=A.localChange,T.remoteChange=A.remoteChange,T}),this.syncPreviewPromise}async discard(p){return await this.updateSyncResourcePreview(p,async E=>{const T=await this.getMergeResult(E,R.CancellationToken.None);return await this.fileService.writeFile(E.previewResource,c.VSBuffer.fromString(T.content||"")),E.acceptResult=void 0,E.mergeState="preview",E.localChange=T.localChange,E.remoteChange=T.remoteChange,E}),this.syncPreviewPromise}async updateSyncResourcePreview(p,E){if(!this.syncPreviewPromise)return;let T=await this.syncPreviewPromise;const A=T.resourcePreviews.findIndex(({localResource:N,remoteResource:W,previewResource:V})=>this.extUri.isEqual(N,p)||this.extUri.isEqual(W,p)||this.extUri.isEqual(V,p));A!==-1&&(this.syncPreviewPromise=(0,_.createCancelablePromise)(async N=>{const W=[...T.resourcePreviews];return W[A]=await E(W[A]),{...T,resourcePreviews:W}}),T=await this.syncPreviewPromise,this.updateConflicts(T.resourcePreviews),T.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(p){if(!this.syncPreviewPromise)return"idle";const E=await this.syncPreviewPromise;return E.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":E.resourcePreviews.some(({mergeState:T})=>T!=="accepted")?"syncing":(await this.applyResult(E.remoteUserData,E.lastSyncUserData,E.resourcePreviews.map(T=>[T,T.acceptResult]),p),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(p){const E=p.filter(({mergeState:T})=>T==="conflict");(0,L.equals)(this._conflicts,E,(T,A)=>this.extUri.isEqual(T.previewResource,A.previewResource))||(this._conflicts=E,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const p=await this.getLastSyncUserData();return!!p&&p.syncData!==null}async resolvePreviewContent(p){const E=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(E)for(const T of E.resourcePreviews){if(this.extUri.isEqual(T.acceptedResource,p))return T.acceptResult?T.acceptResult.content:null;if(this.extUri.isEqual(T.remoteResource,p))return T.remoteContent;if(this.extUri.isEqual(T.localResource,p))return T.localContent;if(this.extUri.isEqual(T.baseResource,p))return T.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(p){(0,f.toFileOperationResult)(p)!==1&&this.logService.error(p)}}async doGenerateSyncResourcePreview(p,E,T,A,N,W){const V=await this.generateSyncPreview(p,E,T,N,W),K=[];for(const z of V){const O=z.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)K.push({...z,acceptedResource:O,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=A?await this.getMergeResult(z,W):void 0;if(W.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,c.VSBuffer.fromString($?.content||""));const Z=$&&!$.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,W):void 0;K.push({...z,acceptResult:Z,mergeState:$?.hasConflicts?"conflict":Z?"accepted":"preview",localChange:Z?Z.localChange:$?$.localChange:z.localChange,remoteChange:Z?Z.remoteChange:$?$.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:p,lastSyncUserData:E,resourcePreviews:K,isLastSyncFromCurrentMachine:T}}async getLastSyncUserData(){let p=this.getStoredLastSyncUserDataStateContent();if(p||(p=await this.migrateLastSyncUserData()),!p)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const E=JSON.parse(p),T=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!E.version&&!!T&&E.version!==T,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${E.version} is not compatible with current sync state version ${T}.`),await this.resetLocal(),null;let A,N=1;for(;A===void 0&&N++<6;)try{const W=await this.readLastSyncStoredRemoteUserData();W&&(W.ref===E.ref?A=W.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(W){if(W instanceof f.FileOperationError&&W.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(W instanceof b.UserDataSyncError)throw W;this.logService.error(W,N)}}if(A===void 0)try{const W=await this.userDataSyncStoreService.resolveResourceContent(this.resource,E.ref,this.collection,this.syncHeaders);A=W===null?null:this.parseSyncData(W),await this.writeLastSyncStoredRemoteUserData({ref:E.ref,syncData:A})}catch(W){if(W instanceof b.UserDataSyncError&&W.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw W}return A===void 0?null:{...E,syncData:A}}async updateLastSyncUserData(p,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const T=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),A={ref:p.ref,version:T,...E};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(A),-1,1),await this.writeLastSyncStoredRemoteUserData(p)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const p=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const E=p?JSON.parse(p):void 0;if(n(E))return E}catch(E){this.logService.error(E)}}async writeLastSyncStoredRemoteUserData(p){await this.fileService.writeFile(this.lastSyncResource,c.VSBuffer.fromString(JSON.stringify(p)))}async migrateLastSyncUserData(){try{const p=await this.fileService.readFile(this.lastSyncResource),E=JSON.parse(p.value.toString());await this.fileService.del(this.lastSyncResource),E.ref&&E.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...E,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:E.ref,syncData:E.content===null?null:JSON.parse(E.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,E)}catch(p){p instanceof f.FileOperationError&&p.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(p)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(p){const{ref:E,content:T}=await this.getUserData(p);let A=null;return T!==null&&(A=this.parseSyncData(T)),{ref:E,syncData:A}}parseSyncData(p){try{const E=JSON.parse(p);if(o(E))return E}catch(E){this.logService.error(E)}throw new b.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(p){const E=p?{ref:p.ref,content:p.syncData?JSON.stringify(p.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,E,this.collection,this.syncHeaders)}async updateRemoteUserData(p,E){const T=await this.currentMachineIdPromise,A={version:this.version,machineId:T,content:p};try{return E=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(A),E,this.collection,this.syncHeaders),{ref:E,syncData:A}}catch(N){throw N instanceof b.UserDataSyncError&&N.code==="TooLarge"&&(N=new b.UserDataSyncError(N.message,N.code,this.resource)),N}}async backupLocal(p){const E={version:this.version,content:p};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(E))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(b.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=pe([Y(2,f.IFileService),Y(3,d.IEnvironmentService),Y(4,u.IStorageService),Y(5,b.IUserDataSyncStoreService),Y(6,b.IUserDataSyncBackupStoreService),Y(7,b.IUserDataSyncEnablementService),Y(8,g.ITelemetryService),Y(9,b.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,v.IUriIdentityService)],i),e.AbstractSynchroniser=i;let r=class extends i{constructor(p,E,T,A,N,W,V,K,z,O,$,Z,q){super(E,T,A,N,W,V,K,z,O,$,Z,q),this.file=p,this._register(this.fileService.watch(this.extUri.dirname(p))),this._register(this.fileService.onDidFilesChange(j=>this.onFileChanges(j)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(p,E,T){try{E?await this.fileService.writeFile(this.file,c.VSBuffer.fromString(p),T?void 0:E):await this.fileService.createFile(this.file,c.VSBuffer.fromString(p),{overwrite:T})}catch(A){throw A instanceof f.FileOperationError&&A.fileOperationResult===1||A instanceof f.FileOperationError&&A.fileOperationResult===3?new b.UserDataSyncError(A.message,"LocalPreconditionFailed"):A}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(p){if(!(p instanceof f.FileOperationError&&p.fileOperationResult===1))throw p}}onFileChanges(p){!p.contains(this.file)||this.triggerLocalChange()}};r=pe([Y(3,f.IFileService),Y(4,d.IEnvironmentService),Y(5,u.IStorageService),Y(6,b.IUserDataSyncStoreService),Y(7,b.IUserDataSyncBackupStoreService),Y(8,b.IUserDataSyncEnablementService),Y(9,g.ITelemetryService),Y(10,b.IUserDataSyncLogService),Y(11,m.IConfigurationService),Y(12,v.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let a=class extends r{constructor(p,E,T,A,N,W,V,K,z,O,$,Z,q,j){super(p,E,T,A,N,W,V,K,z,O,$,q,j),this.userDataSyncUtilService=Z,this._formattingOptions=void 0}hasErrors(p,E){const T=[],A=(0,I.parse)(p,T,{allowEmptyContent:!0,allowTrailingComma:!0});return T.length>0||!(0,P.isUndefined)(A)&&E!==Array.isArray(A)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};a=pe([Y(3,f.IFileService),Y(4,d.IEnvironmentService),Y(5,u.IStorageService),Y(6,b.IUserDataSyncStoreService),Y(7,b.IUserDataSyncBackupStoreService),Y(8,b.IUserDataSyncEnablementService),Y(9,g.ITelemetryService),Y(10,b.IUserDataSyncLogService),Y(11,b.IUserDataSyncUtilService),Y(12,m.IConfigurationService),Y(13,v.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let s=class{constructor(p,E,T,A,N,W,V){this.resource=p,this.userDataProfilesService=E,this.environmentService=T,this.logService=A,this.fileService=N,this.storageService=W,this.extUri=V.extUri,this.lastSyncResource=(0,b.getLastSyncResourceUri)(void 0,this.resource,T,this.extUri)}async initialize({ref:p,content:E}){if(!E){this.logService.info("Remote content does not exist.",this.resource);return}const T=this.parseSyncData(E);if(!!T)try{await this.doInitialize({ref:p,syncData:T})}catch(A){this.logService.error(A)}}parseSyncData(p){try{const E=JSON.parse(p);if(o(E))return E}catch(E){this.logService.error(E)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(p,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const T={ref:p.ref,version:void 0,...E};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(T),-1,1),await this.fileService.writeFile(this.lastSyncResource,c.VSBuffer.fromString(JSON.stringify(p)))}};s=pe([Y(1,k.IUserDataProfilesService),Y(2,d.IEnvironmentService),Y(3,y.ILogService),Y(4,f.IFileService),Y(5,u.IStorageService),Y(6,v.IUriIdentityService)],s),e.AbstractInitializer=s}),define(se[122],oe([0,1,6,24,7,3,42,2,27,17,15,121,29,33,79,14,5,70,9,21,20,30,18,41,262,119,23,61]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k,n,o,t,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function s(N,W){const V=JSON.parse(N.content);if(N.version===1||N.version===2){const K=(await W.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of V)N.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),N.version===2&&K.every(O=>!(0,d.areSameExtensions)(O.identifier,z.identifier))&&(z.installed=!0)}return V}function l(N){return JSON.parse(N.content)}e.parseExtensions=l;function p(N,W){return N.sort((V,K)=>!V.identifier.uuid&&K.identifier.uuid?-1:V.identifier.uuid&&!K.identifier.uuid?1:(0,C.compare)(V.identifier.id,K.identifier.id)),W?(0,D.toFormattedString)(N,{}):JSON.stringify(N)}e.stringify=p;let E=class extends o.AbstractSynchroniser{constructor(W,V,K,z,O,$,Z,q,j,M,J,Q,re,ae,B,F,U){super({syncResource:"extensions",profile:W},V,z,K,O,$,Z,Q,re,M,J,B),this.extensionManagementService=q,this.ignoredExtensionsManagementService=j,this.instantiationService=U,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(T),this._register(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:H})=>!!H)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),R.Event.filter(F.onDidChange,x=>x.valueChanges.some(({profile:H,changes:te})=>this.syncResource.profile.id===H.id&&te.some(G=>G.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),ae.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(W,V){const K=W.syncData?await s(W.syncData,this.extensionManagementService):null,z=V?.skippedExtensions??[],O=V?.builtinExtensions??null,$=V?.syncData?await s(V.syncData,this.extensionManagementService):null,{localExtensions:Z,ignoredExtensions:q}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);K?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:M}=(0,t.merge)(Z,K,$,z,q,O),J={local:j,remote:M,content:this.getPreviewContent(Z,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:M!==null?2:0},Q=this.stringify(Z,!1);return[{skippedExtensions:z,builtinExtensions:O,baseResource:this.baseResource,baseContent:$?this.stringify($,!1):Q,localResource:this.localResource,localContent:Q,localExtensions:Z,remoteResource:this.remoteResource,remoteExtensions:K,remoteContent:K?this.stringify(K,!1):null,previewResource:this.previewResource,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(W){const V=W.syncData?await s(W.syncData,this.extensionManagementService):null,{localExtensions:K,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:O}=(0,t.merge)(K,V,V,W.skippedExtensions||[],z,W.builtinExtensions||[]);return O!==null}getPreviewContent(W,V,K,z){const O=[...V,...K],$=new Set,Z=q=>{$.add(q.id.toLowerCase()),q.uuid&&$.add(q.uuid)};O.forEach(({identifier:q})=>Z(q)),z.forEach(Z);for(const q of W)$.has(q.identifier.id.toLowerCase())||q.identifier.uuid&&$.has(q.identifier.uuid)||O.push(q);return this.stringify(O,!1)}async getMergeResult(W,V){return{...W.previewResult,hasConflicts:!1}}async getAcceptResult(W,V,K,z){if(this.extUri.isEqual(V,this.localResource))return this.acceptLocal(W);if(this.extUri.isEqual(V,this.remoteResource))return this.acceptRemote(W);if(this.extUri.isEqual(V,this.previewResource))return W.previewResult;throw new Error(`Invalid Resource: ${V.toString()}`)}async acceptLocal(W){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),z=(0,t.merge)(W.localExtensions,null,null,W.skippedExtensions,K,W.builtinExtensions),{local:O,remote:$}=z;return{content:W.localContent,local:O,remote:$,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:$!==null?2:0}}async acceptRemote(W){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),z=W.remoteContent?JSON.parse(W.remoteContent):null;if(z!==null){const O=(0,t.merge)(W.localExtensions,z,W.localExtensions,[],K,W.builtinExtensions),{local:$,remote:Z}=O;return{content:W.remoteContent,local:$,remote:Z,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:Z!==null?2:0}}else return{content:W.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(W,V,K,z){let{skippedExtensions:O,builtinExtensions:$,localExtensions:Z}=K[0][0];const{local:q,remote:j,localChange:M,remoteChange:J}=K[0][1];if(M===0&&J===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(Z)),O=await this.localExtensionsProvider.updateLocalExtensions(q.added,q.removed,q.updated,O,this.syncResource.profile)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const Q=JSON.stringify(j.all);W=await this.updateRemoteUserData(Q,z?null:W.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(re=>re.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(re=>re.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(re=>re.identifier.id))}.`:""}`)}V?.ref!==W.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),$=this.computeBuiltinExtensions(Z,$),await this.updateLastSyncUserData(W,{skippedExtensions:O,builtinExtensions:$}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(Q=>Q.identifier.id))}.`:""}`))}computeBuiltinExtensions(W,V){const K=new Set,z=[];for(const O of W)K.add(O.identifier.id.toLowerCase()),O.installed||z.push(O.identifier);if(V)for(const O of V)K.has(O.id.toLowerCase())||z.push(O);return z}async resolveContent(W){if(this.extUri.isEqual(this.remoteResource,W)||this.extUri.isEqual(this.baseResource,W)||this.extUri.isEqual(this.localResource,W)||this.extUri.isEqual(this.acceptedResource,W)){const V=await this.resolvePreviewContent(W);return V&&this.stringify(JSON.parse(V),!0)}return null}stringify(W,V){return p(W,V)}async hasLocalData(){try{const{localExtensions:W}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(W.some(V=>V.installed||V.disabled))return!0}catch{}return!1}};E=pe([Y(2,P.IEnvironmentService),Y(3,y.IFileService),Y(4,v.IStorageService),Y(5,r.IUserDataSyncStoreService),Y(6,r.IUserDataSyncBackupStoreService),Y(7,m.IExtensionManagementService),Y(8,i.IIgnoredExtensionsManagementService),Y(9,r.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,b.ITelemetryService),Y(13,f.IExtensionStorageService),Y(14,k.IUriIdentityService),Y(15,a.IUserDataProfileStorageService),Y(16,h.IInstantiationService)],E),e.ExtensionsSynchroniser=E;let T=class{constructor(W,V,K,z,O,$){this.extensionManagementService=W,this.userDataProfileStorageService=V,this.extensionGalleryService=K,this.ignoredExtensionsManagementService=z,this.instantiationService=O,this.logService=$}async getLocalExtensions(W){const V=await this.extensionManagementService.getInstalled(void 0,W.extensionsResource),K=this.ignoredExtensionsManagementService.getIgnoredExtensions(V);return{localExtensions:await this.withProfileScopedServices(W,async(O,$)=>{const Z=O.getDisabledExtensions();return V.map(q=>{const{identifier:j,isBuiltin:M,manifest:J,preRelease:Q,pinned:re}=q,ae={identifier:j,preRelease:Q,version:J.version,pinned:!!re};Z.some(B=>(0,d.areSameExtensions)(B,j))&&(ae.disabled=!0),M||(ae.installed=!0);try{const B=$.getKeysForSync({id:j.id,version:J.version});if(B){const F=$.getExtensionState(q,!0)||{};ae.state=Object.keys(F).reduce((U,x)=>(B.includes(x)&&(U[x]=F[x]),U),{})}}catch(B){this.logService.info(`${(0,o.getSyncResourceLogLabel)("extensions",W)}: Error while parsing extension state`,(0,c.getErrorMessage)(B))}return ae})}),ignoredExtensions:K}}async updateLocalExtensions(W,V,K,z,O){const $=(0,o.getSyncResourceLogLabel)("extensions",O),Z=[],q=[],j=[],M=await this.extensionManagementService.getInstalled(void 0,O.extensionsResource);if((W.length||K.length)&&await this.withProfileScopedServices(O,async(Q,re)=>{await L.Promises.settled([...W,...K].map(async ae=>{const B=M.find(x=>(0,d.areSameExtensions)(x.identifier,ae.identifier));if(B&&B.isBuiltin){ae.state&&B.manifest.version===ae.version&&this.updateExtensionState(ae.state,B,B.manifest.version,re),Q.getDisabledExtensions().some(H=>(0,d.areSameExtensions)(H,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.logService.trace(`${$}: Disabling extension...`,ae.identifier.id),await Q.disableExtension(ae.identifier),this.logService.info(`${$}: Disabled extension`,ae.identifier.id)):(this.logService.trace(`${$}: Enabling extension...`,ae.identifier.id),await Q.enableExtension(ae.identifier),this.logService.info(`${$}: Enabled extension`,ae.identifier.id))),q.push(ae.identifier);return}const F=ae.pinned?ae.version:void 0,U=(await this.extensionGalleryService.getExtensions([{...ae.identifier,version:F,preRelease:F?void 0:ae.preRelease}],_.CancellationToken.None))[0];if(ae.state&&(B?B.manifest.version===ae.version:!!U)&&this.updateExtensionState(ae.state,B||U,B?.manifest.version,re),U)try{Q.getDisabledExtensions().some(H=>(0,d.areSameExtensions)(H,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.logService.trace(`${$}: Disabling extension...`,ae.identifier.id,U.version),await Q.disableExtension(U.identifier),this.logService.info(`${$}: Disabled extension`,ae.identifier.id,U.version)):(this.logService.trace(`${$}: Enabling extension...`,ae.identifier.id,U.version),await Q.enableExtension(U.identifier),this.logService.info(`${$}: Enabled extension`,ae.identifier.id,U.version))),(!B||B.preRelease!==ae.preRelease||B.pinned!==ae.pinned||F&&B.manifest.version!==F)&&(await this.extensionManagementService.canInstall(U)?Z.push([ae,U]):(this.logService.info(`${$}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),j.push(ae)))}catch(x){j.push(ae),this.logService.error(x),this.logService.info(`${$}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else j.push(ae),this.logService.info(`${$}: Skipped synchronizing extension because the extension is not found.`,ae.identifier.id)}))}),V.length){const Q=M.filter(({identifier:re,isBuiltin:ae})=>!ae&&V.some(B=>(0,d.areSameExtensions)(re,B)));await L.Promises.settled(Q.map(async re=>{this.logService.trace(`${$}: Uninstalling local extension...`,re.identifier.id),await this.extensionManagementService.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:O.extensionsResource}),this.logService.info(`${$}: Uninstalled local extension.`,re.identifier.id),q.push(re.identifier)}))}for(const[Q,re]of Z)try{this.logService.trace(`${$}: Installing extension...`,re.identifier.id,re.version),await this.extensionManagementService.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:Q.pinned&&!!Q.version,installPreReleaseVersion:Q.preRelease,profileLocation:O.extensionsResource,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.logService.info(`${$}: Installed extension.`,re.identifier.id,re.version),q.push(re.identifier)}catch(ae){j.push(Q),ae instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ae.code)?this.logService.info(`${$}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.logService.error(ae),this.logService.info(`${$}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const J=[];for(const Q of z)q.some(re=>(0,d.areSameExtensions)(re,Q.identifier))||J.push(Q);for(const Q of j)J.some(re=>(0,d.areSameExtensions)(re.identifier,Q.identifier))||J.push(Q);return J}updateExtensionState(W,V,K,z){const O=z.getExtensionState(V,!0)||{},$=K?z.getKeysForSync({id:V.identifier.id,version:K}):void 0;$?$.forEach(Z=>{O[Z]=W[Z]}):Object.keys(W).forEach(Z=>O[Z]=W[Z]),z.setExtensionState(V,O,!0)}async withProfileScopedServices(W,V){return this.userDataProfileStorageService.withProfileScopedStorageService(W,async K=>{const z=new I.DisposableStore,O=this.instantiationService.createChild(new u.ServiceCollection([v.IStorageService,K])),$=z.add(O.createInstance(w.GlobalExtensionEnablementService)),Z=z.add(O.createInstance(f.ExtensionStorageService));try{return await V($,Z)}finally{z.dispose()}})}};T=pe([Y(0,m.IExtensionManagementService),Y(1,a.IUserDataProfileStorageService),Y(2,m.IExtensionGalleryService),Y(3,i.IIgnoredExtensionsManagementService),Y(4,h.IInstantiationService),Y(5,r.IUserDataSyncLogService)],T),e.LocalExtensionsProvider=T;let A=class extends o.AbstractInitializer{constructor(W,V,K,z,O,$,Z,q){super("extensions",z,O,$,K,Z,q),this.extensionManagementService=W,this.ignoredExtensionsManagementService=V}async parseExtensions(W){return W.syncData?await s(W.syncData,this.extensionManagementService):null}generatePreview(W,V){const K=[],z=[],O=[];for(const $ of W){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension($.identifier.id))continue;const Z=V.find(q=>(0,d.areSameExtensions)(q.identifier,$.identifier));Z?(K.push(Z),$.disabled&&O.push($.identifier)):$.installed&&(z.push({...$.identifier,preRelease:!!$.preRelease}),$.disabled&&O.push($.identifier))}return{installedExtensions:K,newExtensions:z,disabledExtensions:O,remoteExtensions:W}}};A=pe([Y(0,m.IExtensionManagementService),Y(1,i.IIgnoredExtensionsManagementService),Y(2,y.IFileService),Y(3,n.IUserDataProfilesService),Y(4,P.IEnvironmentService),Y(5,g.ILogService),Y(6,v.IStorageService),Y(7,k.IUriIdentityService)],A),e.AbstractExtensionsInitializer=A}),define(se[123],oe([0,1,16,7,3,35,42,4,31,17,15,14,9,44,21,20,30,41,60,266,23,18,61,5]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",i=["locale"];function r(T,A){const N=T.storage?Object.keys(T.storage).sort():[],W={};return N.forEach(V=>W[V]=T.storage[V]),T.storage=W,A?(0,D.toFormattedString)(T,{}):JSON.stringify(T)}e.stringify=r;const a=1;let s=class extends u.AbstractSynchroniser{constructor(A,N,W,V,K,z,O,$,Z,q,j,M,J,Q){super({syncResource:"globalState",profile:A},N,V,$,M,K,z,Z,q,O,j,J),this.userDataProfileStorageService=W,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=Q.createInstance(l),this._register(V.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(c.Event.any(c.Event.filter(V.onDidFilesChange,re=>re.contains(this.environmentService.argvResource)),c.Event.filter(W.onDidChange,re=>!!(re.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||re.valueChanges.some(({profile:ae,changes:B})=>this.syncResource.profile.id===ae.id&&B.some(F=>F.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(A,N,W){const V=A.syncData?JSON.parse(A.syncData.content):null;N=N===null&&W?A:N;const K=N&&N.syncData?JSON.parse(N.syncData.content):null,z=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);V?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const O=await this.getStorageKeys(K),{local:$,remote:Z}=(0,v.merge)(z.storage,V?V.storage:null,K?K.storage:null,O,this.logService),q={content:null,local:$,remote:Z,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:Z.all!==null?2:0},j=r(z,!1);return[{baseResource:this.baseResource,baseContent:K?r(K,!1):j,localResource:this.localResource,localContent:j,localUserData:z,remoteResource:this.remoteResource,remoteContent:V?r(V,!1):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource,storageKeys:O}]}async hasRemoteChanged(A){const N=A.syncData?JSON.parse(A.syncData.content):null;if(N===null)return!0;const W=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),V=await this.getStorageKeys(N),{remote:K}=(0,v.merge)(W.storage,N.storage,N.storage,V,this.logService);return K.all!==null}async getMergeResult(A,N){return{...A.previewResult,hasConflicts:!1}}async getAcceptResult(A,N,W,V){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(A);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(A);if(this.extUri.isEqual(N,this.previewResource))return A.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(A.localUserData.storage),removed:[],updated:[],all:A.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(A){if(A.remoteContent!==null){const N=JSON.parse(A.remoteContent),{local:W,remote:V}=(0,v.merge)(A.localUserData.storage,N.storage,null,A.storageKeys,this.logService);return{content:A.remoteContent,local:W,remote:V,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:V!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(A,N,W,V){const{localUserData:K}=W[0][0],{local:z,remote:O,localChange:$,remoteChange:Z}=W[0][1];if($===0&&Z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(K)),await this.localGlobalStateProvider.writeLocalGlobalState(z,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),Z!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const q=JSON.stringify({storage:O.all});A=await this.updateRemoteUserData(q,V?null:A.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${O.added.length?` Added: ${O.added}.`:""}${O.updated.length?` Updated: ${O.updated}.`:""}${O.removed.length?` Removed: ${O.removed}.`:""}`)}N?.ref!==A.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(A),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(A){if(this.extUri.isEqual(this.remoteResource,A)||this.extUri.isEqual(this.baseResource,A)||this.extUri.isEqual(this.localResource,A)||this.extUri.isEqual(this.acceptedResource,A)){const N=await this.resolvePreviewContent(A);return N&&r(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:A}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(A).length>1||A[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(A){const N=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),W=[],V=[];for(const[O,$]of N)$.target===0?W.push(O):$.target===1&&V.push(O);const K=[...W,...V],z=A?.storage?Object.keys(A.storage).filter(O=>!O.startsWith(t)&&!K.includes(O)&&N.get(O)!==void 0):[];if(!I.isWeb){const O=[...b.ALL_SYNC_RESOURCES.map($=>(0,b.getEnablementKey)($)),b.SYNC_SERVICE_URL_TYPE];z.push(...O),V.push(...O)}return{user:W,machine:V,unregistered:z}}};s=pe([Y(2,n.IUserDataProfileStorageService),Y(3,w.IFileService),Y(4,b.IUserDataSyncStoreService),Y(5,b.IUserDataSyncBackupStoreService),Y(6,b.IUserDataSyncLogService),Y(7,P.IEnvironmentService),Y(8,b.IUserDataSyncEnablementService),Y(9,y.ITelemetryService),Y(10,S.IConfigurationService),Y(11,f.IStorageService),Y(12,h.IUriIdentityService),Y(13,o.IInstantiationService)],s),e.GlobalStateSynchroniser=s;let l=class{constructor(A,N,W,V){this.fileService=A,this.environmentService=N,this.userDataProfileStorageService=W,this.logService=V}async getLocalGlobalState(A){const N={};if(A.isDefault){const V=await this.getLocalArgvContent(),K=(0,R.parse)(V);for(const z of i)K[z]!==void 0&&(N[`${t}${z}`]={version:1,value:K[z]})}const W=await this.userDataProfileStorageService.readStorageData(A);for(const[V,K]of W)K.value&&K.target===0&&(N[V]={version:1,value:K.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const A=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),A.value.toString()}catch(A){this.logService.debug((0,_.getErrorMessage)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:N,updated:W},V){const K=(0,u.getSyncResourceLogLabel)("globalState",V),z={},O=new Map,$=await this.userDataProfileStorageService.readStorageData(V),Z=(q,j)=>{for(const M of q){if(M.startsWith(t)){z[M.substring(t.length)]=j?j[M].value:void 0;continue}if(j){const J=j[M];J.value!==$.get(M)?.value&&O.set(M,J.value)}else $.get(M)!==void 0&&O.set(M,void 0)}};if(Z(Object.keys(A),A),Z(Object.keys(W),W),Z(N),Object.keys(z).length){this.logService.trace(`${K}: Updating locale...`);const q=await this.getLocalArgvContent();let j=q;for(const M of Object.keys(z))j=(0,g.edit)(j,[M],z[M],{});q!==j&&(this.logService.trace(`${K}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(j)),this.logService.info(`${K}: Updated locale.`)),this.logService.info(`${K}: Updated locale`)}O.size&&(this.logService.trace(`${K}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(V,O,0),this.logService.info(`${K}: Updated global state`,[...O.keys()]))}};l=pe([Y(0,w.IFileService),Y(1,P.IEnvironmentService),Y(2,n.IUserDataProfileStorageService),Y(3,b.IUserDataSyncLogService)],l),e.LocalGlobalStateProvider=l;let p=class extends u.AbstractInitializer{constructor(A,N,W,V,K,z){super("globalState",W,V,K,N,A,z)}async doInitialize(A){const N=A.syncData?JSON.parse(A.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const W={},V={};for(const K of Object.keys(N.storage))K.startsWith(t)?W[K.substring(t.length)]=N.storage[K].value:this.storageService.get(K,0)===void 0&&(V[K]=N.storage[K].value);if(Object.keys(W).length){let K="{}";try{K=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const z of Object.keys(W))K=(0,g.edit)(K,[z],W[z],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(K))}if(Object.keys(V).length)for(const K of Object.keys(V))this.storageService.store(K,V[K],0,0)}};p=pe([Y(0,f.IStorageService),Y(1,w.IFileService),Y(2,k.IUserDataProfilesService),Y(3,P.IEnvironmentService),Y(4,b.IUserDataSyncLogService),Y(5,h.IUriIdentityService)],p),e.GlobalStateInitializer=p;let E=class{constructor(A,N,W,V,K){this.userDataSyncStoreClient=A,this.storageService=N,this.environmentService=W,this.fileService=V,this.logService=K}getSyncStoreType(A){return this.parseGlobalState(A)?.storage[b.SYNC_SERVICE_URL_TYPE]?.value}async sync(A){const N=(0,b.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(A,N)}catch(W){if(W instanceof b.UserDataSyncError)switch(W.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(A,N)}throw W}}async doSync(A,N){const W=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),V=this.parseGlobalState(W)||{storage:{}};V.storage[b.SYNC_SERVICE_URL_TYPE]={value:A,version:a};const K=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:a,machineId:K,content:r(V,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(z),W.ref,void 0,N)}parseGlobalState({content:A}){if(!A)return null;const N=JSON.parse(A);if((0,u.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};E=pe([Y(1,f.IStorageService),Y(2,P.IEnvironmentService),Y(3,w.IFileService),Y(4,m.ILogService)],E),e.UserDataSyncStoreTypeSynchronizer=E}),define(se[124],oe([0,1,19,16,3,35,4,12,184,17,15,14,21,20,30,18,41,263,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(n,o,t){try{const i=JSON.parse(n);if(!o)return(0,I.isUndefined)(i.all)?null:i.all;switch(D.OS){case 2:return(0,I.isUndefined)(i.mac)?null:i.mac;case 3:return(0,I.isUndefined)(i.linux)?null:i.linux;case 1:return(0,I.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=v;let b=class extends h.AbstractJsonFileSynchroniser{constructor(o,t,i,r,a,s,l,p,E,T,A,N,W){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,p,E,T,i,r,l,N,a,A,s,W),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(c.Event.filter(s.onDidChangeConfiguration,V=>V.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,i,r){const a=o.syncData?v(o.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?o:t;const s=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),p=await this.getFormattingOptions();let E=null,T=!1,A=!1,N=!1;if(a){let K=l?l.value.toString():"[]";if(K=K||"[]",this.hasErrors(K,!0))throw new g.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==K||s!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,u.merge)(K,a,s,p,this.userDataSyncUtilService);z.hasChanges&&(E=z.mergeContent,N=z.hasConflicts,T=N||z.mergeContent!==K,A=N||z.mergeContent!==a)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),E=l.value.toString(),A=!0);const W={content:N?s:E,localChange:T?l?2:1:0,remoteChange:A?2:0,hasConflicts:N},V=l?l.value.toString():null;return[{fileContent:l,baseResource:this.baseResource,baseContent:s,localResource:this.localResource,localContent:V,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getKeybindingsContentFromLastSyncUserData(o);if(t===null)return!0;const i=await this.getLocalFileContent(),r=i?i.value.toString():"",a=await this.getFormattingOptions(),s=await(0,u.merge)(r||"[]",t,t,a,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==t}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,i,r){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,i,r){const{fileContent:a}=i[0][0];let{content:s,localChange:l,remoteChange:p}=i[0][1];if(l===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s,!0)))throw new g.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(s||"[]",a,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),p!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const E=this.toSyncContent(s||"[]",o.syncData?.content);o=await this.updateRemoteUserData(E,r?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,R.parse)(o.value.toString());if((0,L.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let i={};try{i=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=o,D.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(g.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};b=pe([Y(2,g.IUserDataSyncStoreService),Y(3,g.IUserDataSyncBackupStoreService),Y(4,g.IUserDataSyncLogService),Y(5,S.IConfigurationService),Y(6,g.IUserDataSyncEnablementService),Y(7,w.IFileService),Y(8,P.IEnvironmentService),Y(9,m.IStorageService),Y(10,g.IUserDataSyncUtilService),Y(11,d.ITelemetryService),Y(12,f.IUriIdentityService)],b),e.KeybindingsSynchroniser=b;let k=class extends h.AbstractInitializer{constructor(o,t,i,r,a,s){super("keybindings",t,i,r,o,a,s)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,_.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,R.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return v(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};k=pe([Y(0,w.IFileService),Y(1,y.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,g.IUserDataSyncLogService),Y(4,m.IStorageService),Y(5,f.IUriIdentityService)],k),e.KeybindingsInitializer=k}),define(se[125],oe([0,1,16,3,185,17,73,15,29,14,21,20,30,18,41,60,267,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function v(n){const o=JSON.parse(n);return g(o)?o:{settings:n}}e.parseSettingsSyncContent=v;let b=class extends f.AbstractJsonFileSynchroniser{constructor(o,t,i,r,a,s,l,p,E,T,A,N,W,V){super(o.settingsResource,{syncResource:"settings",profile:o},t,i,r,a,s,l,A,N,p,E,T,V),this.extensionManagementService=W,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(o,t),r=this.getSettingsSyncContent(i),a=new D.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&a.parse(r.settings),a.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,t,i){const r=await this.getLocalFileContent(),a=await this.getFormattingOptions(),s=this.getSettingsSyncContent(o);t=t===null&&i?o:t;const l=t?this.getSettingsSyncContent(t):null,p=await this.getIgnoredSettings();let E=null,T=!1,A=!1,N=!1;if(s){let z=r?r.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const O=(0,h.merge)(z,s.settings,l?l.settings:null,p,[],a);E=O.localContent||O.remoteContent,T=O.localContent!==null,A=O.remoteContent!==null,N=O.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),E=r.value.toString().trim()||"{}",this.validateContent(E),A=!0);const W=r?r.value.toString():null,V=l?.settings??null,K={content:N?V:E,localChange:T?2:0,remoteChange:A?2:0,hasConflicts:N};return[{fileContent:r,baseResource:this.baseResource,baseContent:V,localResource:this.localResource,localContent:W,localChange:K.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:K.remoteChange,previewResource:this.previewResource,previewResult:K,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getSettingsSyncContent(o);if(t===null)return!0;const i=await this.getLocalFileContent(),r=i?i.value.toString().trim():"",a=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,h.merge)(r||"{}",t.settings,t.settings,a,[],s).remoteContent!==null}async getMergeResult(o,t){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,h.updateIgnoredSettings)(o.previewResult.content,"{}",r,i):null}}async getAcceptResult(o,t,i,r){const a=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?(0,h.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",s,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,h.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",s,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i!==null?(0,h.updateIgnoredSettings)(i,o.fileContent?o.fileContent.value.toString():"{}",s,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,i,r){const{fileContent:a}=i[0][0];let{content:s,localChange:l,remoteChange:p}=i[0][1];if(l===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(s,a,r),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),p!==0){const E=await this.getFormattingOptions(),T=this.getSettingsSyncContent(o),A=await this.getIgnoredSettings(s);s=(0,h.updateIgnoredSettings)(s,T?T.settings:"{}",A,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),r?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=await this.getFormattingOptions(),i=(0,y.edit)(o.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,h.isEmpty)(i)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o)?this.resolvePreviewContent(o):null}async resolvePreviewContent(o){let t=await super.resolvePreviewContent(o);if(t){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();t=(0,h.updateIgnoredSettings)(t,"{}",r,i)}return t}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return v(o)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:a})=>!!a)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,h.getIgnoredSettings)(t,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new u.UserDataSyncError((0,c.localize)(0,null),"LocalInvalidContent",this.resource)}};b=pe([Y(2,S.IFileService),Y(3,I.IEnvironmentService),Y(4,P.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,u.IUserDataSyncLogService),Y(8,u.IUserDataSyncUtilService),Y(9,R.IConfigurationService),Y(10,u.IUserDataSyncEnablementService),Y(11,w.ITelemetryService),Y(12,C.IExtensionManagementService),Y(13,m.IUriIdentityService)],b),e.SettingsSynchroniser=b;let k=class extends f.AbstractInitializer{constructor(o,t,i,r,a,s){super("settings",t,i,r,o,a,s)}async doInitialize(o){const t=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,L.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,h.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return v(o)}catch(t){this.logService.error(t)}return null}};k=pe([Y(0,S.IFileService),Y(1,d.IUserDataProfilesService),Y(2,I.IEnvironmentService),Y(3,u.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,m.IUriIdentityService)],k),e.SettingsInitializer=k}),define(se[126],oe([0,1,16,3,32,17,15,14,21,20,30,18,41,264,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function y(g){return JSON.parse(g.content)}e.parseSnippets=y;let h=class extends m.AbstractSynchroniser{constructor(v,b,k,n,o,t,i,r,a,s,l,p){super({syncResource:"snippets",profile:v},b,n,k,o,t,i,s,l,r,a,p),this.version=1,this.snippetsFolder=v.snippetsHome,this._register(this.fileService.watch(k.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(_.Event.filter(this.fileService.onDidFilesChange,E=>E.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(v,b,k){const n=await this.getSnippetsFileContents(),o=this.toSnippetsContents(n),t=v.syncData?this.parseSnippets(v.syncData):null;b=b===null&&k?v:b;const i=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,d.merge)(o,t,i);return this.getResourcePreviews(r,n,t||{},i||{})}async hasRemoteChanged(v){const b=v.syncData?this.parseSnippets(v.syncData):null;if(b===null)return!0;const k=await this.getSnippetsFileContents(),n=this.toSnippetsContents(k),o=(0,d.merge)(n,b,b);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(v,b){return v.previewResult}async getAcceptResult(v,b,k,n){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:v.fileContent?v.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:v.remoteContent,localChange:v.remoteContent!==null?v.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return k===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:k,localChange:k===null?v.fileContent!==null?3:0:2,remoteChange:k===null?v.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(v,b,k,n){const o=k.map(([t,i])=>({...t,acceptResult:i}));o.every(({localChange:t,remoteChange:i})=>t===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,n)),o.some(({remoteChange:t})=>t!==0)&&(v=await this.updateRemoteSnippets(o,v,n)),b?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of o)try{await this.fileService.del(t)}catch{}}getResourcePreviews(v,b,k,n){const o=new Map;for(const t of Object.keys(v.local.added)){const i={content:v.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v.local.updated)){const i={content:v.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},r=b[t]?b[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of v.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=b[t]?b[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v.remote.added)){const i={content:v.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},r=b[t]?b[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v.remote.updated)){const i={content:v.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},r=b[t]?b[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of v.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of v.conflicts){const i={content:n[t]??null,hasConflicts:!0,localChange:b[t]?2:1,remoteChange:k[t]?2:1},r=b[t]?b[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(b))if(!o.has(t)){const i={content:b[t]?b[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=b[t]?b[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(v){return this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(v):null}async hasLocalData(){try{const v=await this.getSnippetsFileContents();if(Object.keys(v).length)return!0}catch{}return!1}async updateLocalBackup(v){const b={};for(const k of v)k.fileContent&&(b[this.extUri.basename(k.localResource)]=k.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(v,b){for(const{fileContent:k,acceptResult:n,localResource:o,remoteResource:t,localChange:i}of v)if(i!==0){const r=t?this.extUri.basename(t):this.extUri.basename(o),a=this.extUri.joinPath(this.snippetsFolder,r);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(a)),await this.fileService.del(a),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(a))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(a)),await this.fileService.createFile(a,L.VSBuffer.fromString(n.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(a))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(a)),await this.fileService.writeFile(a,L.VSBuffer.fromString(n.content),b?void 0:k),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(a)))}}async updateRemoteSnippets(v,b,k){const n=b.syncData?this.parseSnippets(b.syncData):{},o=(0,c.deepClone)(n);for(const{acceptResult:t,localResource:i,remoteResource:r,remoteChange:a}of v)if(a!==0){const s=i?this.extUri.basename(i):this.extUri.basename(r);a===3?delete o[s]:o[s]=t.content}return(0,d.areSame)(n,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(o),k?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(v){return y(v)}toSnippetsContents(v){const b={};for(const k of Object.keys(v))b[k]=v[k].value.toString();return b}async getSnippetsFileContents(){const v={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(k){if(k instanceof I.FileOperationError&&k.fileOperationResult===1)return v;throw k}for(const k of b.children||[]){const n=k.resource,o=this.extUri.extname(n);if(o===".json"||o===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,n),i=await this.fileService.readFile(n);v[t]=i}}return v}};h=pe([Y(2,D.IEnvironmentService),Y(3,I.IFileService),Y(4,C.IStorageService),Y(5,f.IUserDataSyncStoreService),Y(6,f.IUserDataSyncBackupStoreService),Y(7,f.IUserDataSyncLogService),Y(8,R.IConfigurationService),Y(9,f.IUserDataSyncEnablementService),Y(10,S.ITelemetryService),Y(11,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let u=class extends m.AbstractInitializer{constructor(v,b,k,n,o,t){super("snippets",b,k,n,v,o,t)}async doInitialize(v){const b=v.syncData?JSON.parse(v.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(b)){const o=b[n];if(o){const t=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,n);await this.fileService.createFile(t,L.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(v)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(v){return v.fileOperationResult===1}}};u=pe([Y(0,I.IFileService),Y(1,w.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,C.IStorageService),Y(5,P.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(se[127],oe([0,1,16,17,15,14,21,20,30,18,41,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(h,u){try{return JSON.parse(h).tasks??null}catch(g){return u.error(g),null}}e.getTasksContentFromSyncContent=m;let d=class extends P.AbstractFileSynchroniser{constructor(u,g,v,b,k,n,o,t,i,r,a,s){super(u.tasksResource,{syncResource:"tasks",profile:u},g,t,i,r,v,b,o,a,k,n,s),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,g,v,b){const k=u.syncData?m(u.syncData.content,this.logService):null;g=g===null&&v?u:g;const n=g?.syncData?m(g.syncData.content,this.logService):null,o=await this.getLocalFileContent();let t=null,i=!1,r=!1,a=!1;if(u.syncData){const p=o?o.value.toString():null;if(!n||n!==p||n!==k){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const E=y(p,k,n);t=E.content,a=E.hasConflicts,i=E.hasLocalChanged,r=E.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),r=!0);const s={content:a?n:t,localChange:i?o?2:1:0,remoteChange:r?2:0,hasConflicts:a},l=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:l,localChange:s.localChange,remoteResource:this.remoteResource,remoteContent:k,remoteChange:s.remoteChange,previewResource:this.previewResource,previewResult:s,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const g=u?.syncData?m(u.syncData.content,this.logService):null;if(g===null)return!0;const v=await this.getLocalFileContent(),b=v?v.value.toString():null,k=y(b,g,g);return k.hasLocalChanged||k.hasRemoteChanged}async getMergeResult(u,g){return u.previewResult}async getAcceptResult(u,g,v,b){if(this.extUri.isEqual(g,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return v===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:v,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(u,g,v,b){const{fileContent:k}=v[0][0],{content:n,localChange:o,remoteChange:t}=v[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),k&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(k.value.toString()))),n?await this.updateLocalFileContent(n,k,b):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(n));u=await this.updateRemoteUserData(i,b?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};d=pe([Y(2,w.IUserDataSyncStoreService),Y(3,w.IUserDataSyncBackupStoreService),Y(4,w.IUserDataSyncLogService),Y(5,_.IConfigurationService),Y(6,w.IUserDataSyncEnablementService),Y(7,R.IFileService),Y(8,c.IEnvironmentService),Y(9,D.IStorageService),Y(10,I.ITelemetryService),Y(11,C.IUriIdentityService)],d),e.TasksSynchroniser=d;let f=class extends P.AbstractInitializer{constructor(u,g,v,b,k,n){super("tasks",g,v,b,u,k,n),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const g=u.syncData?m(u.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,L.VSBuffer.fromString(g)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};f=pe([Y(0,R.IFileService),Y(1,S.IUserDataProfilesService),Y(2,c.IEnvironmentService),Y(3,w.IUserDataSyncLogService),Y(4,D.IStorageService),Y(5,C.IUriIdentityService)],f),e.TasksInitializer=f;function y(h,u,g){if(h===null&&u===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(h===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const v=g!==h,b=g!==u;return!v&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:v&&!b?{content:h,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!v?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:h,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(se[128],oe([0,1,42,17,15,14,21,20,30,18,41,265,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let d=class extends P.AbstractSynchroniser{constructor(u,g,v,b,k,n,o,t,i,r,a,s,l){super({syncResource:"profiles",profile:u},g,b,k,n,o,t,a,s,i,r,l),this.userDataProfilesService=v,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?y(u.syncData):null}async getRemoteSyncedProfiles(u){const g=await this.getLastSyncUserData(),v=await this.getLatestRemoteUserData(u,g);return v?.syncData?y(v.syncData):null}async generateSyncPreview(u,g,v){if(!this.userDataProfilesService.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const b=u.syncData?y(u.syncData):null,k=g?.syncData?y(g.syncData):null,n=this.getLocalUserDataProfiles(),{local:o,remote:t}=(0,w.merge)(n,b,k,[]),i={local:o,remote:t,content:k?this.stringifyRemoteProfiles(k):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},r=f(n,!1);return[{baseResource:this.baseResource,baseContent:k?this.stringifyRemoteProfiles(k):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:b?this.stringifyRemoteProfiles(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const g=u?.syncData?y(u.syncData):null,v=this.getLocalUserDataProfiles(),{remote:b}=(0,w.merge)(v,g,g,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async getMergeResult(u,g){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,g,v,b){if(this.extUri.isEqual(g,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(g,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(g,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async acceptLocal(u){const g=this.getLocalUserDataProfiles(),v=(0,w.merge)(g,null,null,[]),{local:b,remote:k}=v;return{content:u.localContent,local:b,remote:k,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:k!==null?2:0}}async acceptRemote(u){const g=u.remoteContent?JSON.parse(u.remoteContent):null,v=[],b=[];for(const k of this.getLocalUserDataProfiles()){const n=g?.find(o=>o.id===k.id);n&&(v.push({id:k.id,name:k.name,collection:n.collection}),b.push(k))}if(g!==null){const k=(0,w.merge)(b,g,v,[]),{local:n,remote:o}=k;return{content:u.remoteContent,local:n,remote:o,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,g,v,b){const{local:k,remote:n,localChange:o,remoteChange:t}=v[0][1];o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const i=v[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const r=[];for(const a of k.added)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${a.name}' profile...`),await this.userDataProfilesService.createProfile(a.id,a.name,{shortName:a.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${a.name}'.`)})());for(const a of k.removed)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${a.name}' profile...`),await this.userDataProfilesService.removeProfile(a),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${a.name}'.`)})());for(const a of k.updated){const s=this.userDataProfilesService.profiles.find(l=>l.id===a.id);s?r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${a.name}' profile...`),await this.userDataProfilesService.updateProfile(s,{name:a.name,shortName:a.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${a.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(r)}if(t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const r=[],a=i.length+(n?.added.length??0)<=20;if(a)for(const s of n?.added||[]){const l=await this.userDataSyncStoreService.createCollection(this.syncHeaders);r.push(l),i.push({id:s.id,name:s.name,collection:l,shortName:s.shortName})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const s of n?.removed||[])i.splice(i.findIndex(({id:l})=>s.id===l),1);for(const s of n?.updated||[]){const l=i.find(({id:p})=>s.id===p);l&&i.splice(i.indexOf(l),1,{id:s.id,name:s.name,collection:l.collection,shortName:s.shortName})}try{u=await this.updateRemoteProfiles(i,b?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${a&&n?.added.length?` Added: ${JSON.stringify(n.added.map(s=>s.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(s=>s.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(s=>s.name))}.`:""}`)}catch(s){if(r.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const l of r)await this.userDataSyncStoreService.deleteCollection(l,this.syncHeaders)}throw s}for(const s of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}g?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,g){return this.updateRemoteUserData(this.stringifyRemoteProfiles(u),g)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const g=await this.resolvePreviewContent(u);return g&&(0,L.toFormattedString)(JSON.parse(g),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((g,v)=>g.name.localeCompare(v.name)))}};d=pe([Y(2,S.IUserDataProfilesService),Y(3,R.IFileService),Y(4,c.IEnvironmentService),Y(5,D.IStorageService),Y(6,m.IUserDataSyncStoreService),Y(7,m.IUserDataSyncBackupStoreService),Y(8,m.IUserDataSyncLogService),Y(9,_.IConfigurationService),Y(10,m.IUserDataSyncEnablementService),Y(11,I.ITelemetryService),Y(12,C.IUriIdentityService)],d),e.UserDataProfilesManifestSynchroniser=d;function f(h,u){const g=[...h].sort((v,b)=>v.name.localeCompare(b.name)).map(v=>({id:v.id,name:v.name}));return u?(0,L.toFormattedString)(g,{}):JSON.stringify(g)}e.stringifyLocalProfiles=f;function y(h){return JSON.parse(h.content)}e.parseUserDataProfilesManifest=y}),define(se[282],oe([0,1,6,16,64,2,25,17,15,14,18,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends R.Disposable{constructor(f,y,h,u,g){super(),this.environmentService=f,this.fileService=y,this.configurationService=h,this.logService=u,this.userDataProfilesService=g,this.cleanUp()}async cleanUp(){for(const y of this.userDataProfilesService.profiles)for(const h of w.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(y,h))}catch(u){this.logService.error(u)}let f;try{f=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(y){(0,S.toFileOperationResult)(y)!==1&&this.logService.error(y);return}if(f.children){for(const y of f.children)if(y.isDirectory&&!this.userDataProfilesService.profiles.some(h=>h.id===y.name))try{this.logService.info("Deleting non existing profile from backup",y.resource.path),await this.fileService.del(y.resource,{recursive:!0})}catch(h){this.logService.error(h)}}}async getAllRefs(f,y){const h=this.getResourceBackupHome(f,y);try{const u=await this.fileService.resolve(h);if(u.children)return u.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort().reverse().map(v=>({ref:v.name,created:this.getCreationTime(v)}))}catch(u){if((0,S.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(f,y,h){const u=this.getResourceBackupHome(f,y),g=(0,D.joinPath)(u,h);try{return(await this.fileService.readFile(g)).value.toString()}catch(v){return this.logService.error(v),null}}async backup(f,y,h){const u=this.getResourceBackupHome(f,y),g=(0,D.joinPath)(u,`${(0,c.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,_.VSBuffer.fromString(h))}catch(v){this.logService.error(v)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(f,y){return(0,D.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[y]:[f.id,y])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const y=await this.fileService.resolve(f);if(y.children){const h=y.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=h.filter(b=>Date.now()-this.getCreationTime(b)>u);const v=h.length-g.length;v<10&&(g=g.slice(10-v)),await L.Promises.settled(g.map(async b=>{this.logService.info("Deleting from backup",b.resource.path),await this.fileService.del(b.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};m=pe([Y(0,C.IEnvironmentService),Y(1,S.IFileService),Y(2,I.IConfigurationService),Y(3,w.IUserDataSyncLogService),Y(4,P.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(se[283],oe([0,1,3,2,4,15,21,20,23]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let P=class extends _.Disposable{constructor(m,d,f,y){super(),this.storageService=m,this.telemetryService=d,this.environmentService=f,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(h=>this.onDidStorageChange(h)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(S,{enabled:m}),this.storageService.store(S,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,C.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,d){if(this.isResourceEnabled(m)!==d){const f=(0,C.getEnablementKey)(m);this.storeResourceEnablement(f,d)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,d){this.storageService.store(m,d,-1,c.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==-1)return;if(S===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const d=C.ALL_SYNC_RESOURCES.filter(f=>(0,C.getEnablementKey)(f)===m.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}};P=pe([Y(0,D.IStorageService),Y(1,I.ITelemetryService),Y(2,R.IEnvironmentService),Y(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(se[80],oe([0,1,3,2,4,27,189,15,14,5,26,44,21,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",y="Safari",h="Chrome",u="Edge",g="Firefox",v="Android";function b(o){switch(o){case y:case h:case u:case g:case v:case(0,c.PlatformToString)(0):return!0}return!1}e.isWebPlatform=b;function k(){return c.isSafari?y:c.isChrome?h:c.isEdge?u:c.isFirefox?g:c.isAndroid?v:(0,c.PlatformToString)(c.isWeb?0:c.platform)}let n=class nt extends _.Disposable{constructor(t,i,r,a,s,l){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=s,this.productService=l,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,i,r)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(t);r.machines.some(({id:a})=>a===i)||(r.machines.push({id:i,name:this.computeCurrentMachineName(r.machines),platform:k()}),await this.writeMachinesData(r))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(t),a=r.machines.filter(({id:s})=>s!==i);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(t,i,r){const a=await this.readMachinesData(r),s=a.machines.find(({id:l})=>l===t);if(s){s.name=i,await this.writeMachinesData(a);const l=await this.currentMachineIdPromise;t===l&&this.storageService.store(f,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[r,a]of t){const s=i.machines.find(l=>l.id===r);s&&(s.disabled=a?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(f,-1);if(i)return i;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${k()} (${this.productService.nameShort})`,a=new RegExp(`${(0,R.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let s=0;for(const l of t){const p=a.exec(l.name),E=p?parseInt(p[1]):0;s=E>s?E:s}return`${r} #${s+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==nt.VERSION)throw new Error((0,D.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),r=await this.userDataSyncStoreService.writeResource(nt.RESOURCE,i,this.userData?.ref||null);this.userData={ref:r,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:nt.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=pe([Y(0,I.IEnvironmentService),Y(1,C.IFileService),Y(2,m.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncLogService),Y(5,P.IProductService)],n),e.UserDataSyncMachinesService=n}),define(se[284],oe([0,1,6,64,39,7,3,2,4,25,11,186,26,21,20,23,77,80]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",v="sync.sessionId",b="sync.storeUrl",k="sync.productQuality";let n=class extends I.Disposable{get syncUrl(){const i=this.storageService.get(b,-1);return i?P.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(b,i.toString(),-1,1):this.storageService.remove(b,-1)}get productQuality(){return this.storageService.get(k,-1)}set productQuality(i){i?this.storageService.store(k,i,-1,1):this.storageService.remove(k,-1)}constructor(i,r,a,s,l,p,E,T,A,N){super(),this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncEnablementService=s,this.userDataSyncService=l,this.logService=p,this.userDataSyncAccountService=E,this.telemetryService=T,this.userDataSyncMachinesService=A,this.storageService=N,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(r.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.syncUrl,r.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(E.onDidChangeAccount(()=>this.updateAutoSync())),this._register(a.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(W=>this.triggerSync([W],!1,!1))),this._register(D.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,W])=>W)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:r}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(a=>this.onDidFinishSync(a))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(r&&this.logService.info(r),this.autoSync.clear()):r&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(r))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,_.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,r,a){try{this.userDataSyncAccountService.account&&!a&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(v,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(s){if(this.logService.error(s),r)this.updateEnablement(!1);else throw s}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const r=y.UserDataSyncError.toUserDataSyncError(i);r instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:r.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?C.isWeb&&r.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(r),this.successiveFailures++),this._onError.fire(r)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(i,r,a){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(r&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const s=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:s}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",a)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=pe([Y(0,m.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncEnablementService),Y(4,y.IUserDataSyncService),Y(5,y.IUserDataSyncLogService),Y(6,h.IUserDataSyncAccountService),Y(7,f.ITelemetryService),Y(8,u.IUserDataSyncMachinesService),Y(9,d.IStorageService)],n),e.UserDataAutoSyncService=n;class o extends I.Disposable{constructor(i,r,a,s,l,p,E,T){super(),this.lastSyncUrl=i,this.interval=r,this.userDataSyncStoreManagementService=a,this.userDataSyncStoreService=s,this.userDataSyncService=l,this.userDataSyncMachinesService=p,this.logService=E,this.storageService=T,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new D.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new D.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(i,r){const a=(0,L.createCancelablePromise)(async s=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,R.isCancellationError)(l))return}return this.doSync(i,r,s)});return this.syncPromise=a,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,S.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),r=this.userDataSyncStoreManagementService.userDataSyncStore;return!!r&&!!i&&(!(0,S.isEqual)(r.defaultUrl,i.defaultUrl)||!(0,S.isEqual)(r.insidersUrl,i.insidersUrl)||!(0,S.isEqual)(r.stableUrl,i.stableUrl))}async doSync(i,r,a){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let s;try{await this.createAndRunSyncTask(r,a)}catch(l){if(this.logService.error(l),s=l,y.UserDataSyncError.toUserDataSyncError(l).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(r,a),s=void 0}catch(p){this.logService.error(p),s=p}}this._onDidFinishSync.fire(s)}async createAndRunSyncTask(i,r){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,i),r.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const a=this.storageService.get(v,-1);if(a&&this.manifest&&a!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const s=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(r.isCancellationRequested)return;const l=s.find(p=>p.isCurrent);if(l?.disabled)throw new y.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(p){throw new y.UserDataAutoSyncError((0,c.toErrorMessage)(p),p instanceof y.UserDataSyncError?p.code:"Unknown")}this.manifest&&this.manifest.session!==a&&this.storageService.store(v,this.manifest.session,-1,1),!r.isCancellationRequested&&(l||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(i){return super._register(i)}}o.INTERVAL_SYNCING="Interval"}),define(se[285],oe([0,1,11,190,15,14,44,21,30,23,18,41,126,125,124,17,127,122,123,5,128,42]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Be{constructor(t,i,r,a,s,l,p,E,T,A){this.userDataSyncStoreService=t,this.userDataSyncBackupStoreService=i,this.logService=r,this.environmentService=s,this.storageService=l,this.fileService=p,this.userDataProfilesService=E,this.configurationService=T,this.instantiationService=A,this.extUri=a.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const i=this.parseSyncData(t.content,"profiles");return(0,b.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(t,i){return(await this.userDataSyncStoreService.getAllResourceRefs(t,i?.collection)).map(({created:a,ref:s})=>({created:a,uri:this.toUri({remote:!0,syncResource:t,profile:i?.id??this.userDataProfilesService.defaultProfile.id,collection:i?.collection,ref:s,node:void 0})}))}async getLocalSyncResourceHandles(t,i){return(await this.userDataSyncBackupStoreService.getAllRefs(i,t)).map(({created:a,ref:s})=>({created:a,uri:this.toUri({remote:!1,syncResource:t,profile:i.id,collection:void 0,ref:s,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const i=this.resolveUri(t),r=i?this.userDataProfilesService.profiles.find(a=>a.id===i.profile):void 0;return i&&r?{profile:r,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:t}){const i=this.resolveUri(t);if(!i)return[];const r=this.userDataProfilesService.profiles.find(a=>a.id===i.profile);switch(i.syncResource){case"settings":return this.getSettingsAssociatedResources(t,r);case"keybindings":return this.getKeybindingsAssociatedResources(t,r);case"tasks":return this.getTasksAssociatedResources(t,r);case"snippets":return this.getSnippetsAssociatedResources(t,r);case"globalState":return this.getGlobalStateAssociatedResources(t,r);case"extensions":return this.getExtensionsAssociatedResources(t,r);case"profiles":return this.getProfilesAssociatedResources(t,r)}}async getMachineId({uri:t}){const i=this.resolveUri(t);if(!!i){if(i.remote){if(i.ref){const{content:r}=await this.getUserData(i.syncResource,i.ref,i.collection);if(r)return this.parseSyncData(r,i.syncResource)?.machineId}return}return(0,D.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const i=this.resolveUri(t);if(!i||i.node===Be.NOT_EXISTING_RESOURCE)return null;if(i.ref){const r=await this.getContentFromStore(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&r?this.resolveNodeContent(i.syncResource,r,i.node):r}return!i.remote&&!i.node?this.resolveLatestContent(i.syncResource,i.profile):null}async getContentFromStore(t,i,r,a,s){if(t){const{content:p}=await this.getUserData(i,s,a);return p}const l=this.userDataProfilesService.profiles.find(p=>p.id===r);return l?this.userDataSyncBackupStoreService.resolveContent(l,i,s):null}resolveNodeContent(t,i,r){const a=this.parseSyncData(i,t);switch(t){case"settings":return this.resolveSettingsNodeContent(a,r);case"keybindings":return this.resolveKeybindingsNodeContent(a,r);case"tasks":return this.resolveTasksNodeContent(a,r);case"snippets":return this.resolveSnippetsNodeContent(a,r);case"globalState":return this.resolveGlobalStateNodeContent(a,r);case"extensions":return this.resolveExtensionsNodeContent(a,r);case"profiles":return this.resolveProfileNodeContent(a,r)}}async resolveLatestContent(t,i){const r=this.userDataProfilesService.profiles.find(a=>a.id===i);if(!r)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(r);case"extensions":return this.resolveLatestExtensionsContent(r);case"profiles":return this.resolveLatestProfilesContent(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}getSettingsAssociatedResources(t,i){const r=this.extUri.joinPath(t,"settings.json"),a=i?i.settingsResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveSettingsNodeContent(t,i){switch(i){case"settings.json":return(0,d.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,i){const r=this.extUri.joinPath(t,"keybindings.json"),a=i?i.keybindingsResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveKeybindingsNodeContent(t,i){switch(i){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,i){const r=this.extUri.joinPath(t,"tasks.json"),a=i?i.tasksResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveTasksNodeContent(t,i){switch(i){case"tasks.json":return(0,h.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,i){const r=await this.resolveContent(t);if(r){const a=this.parseSyncData(r,"snippets");if(a){const s=(0,m.parseSnippets)(a),l=[];for(const p of Object.keys(s)){const E=this.extUri.joinPath(t,p),T=i?this.extUri.joinPath(i.snippetsHome,p):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);l.push({resource:E,comparableResource:T})}return l}}return[]}resolveSnippetsNodeContent(t,i){return(0,m.parseSnippets)(t)[i]||null}getExtensionsAssociatedResources(t,i){const r=this.extUri.joinPath(t,"extensions.json"),a=i?this.toUri({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveExtensionsNodeContent(t,i){switch(i){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:i}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(i,!0)}getGlobalStateAssociatedResources(t,i){const r=this.extUri.joinPath(t,"globalState.json"),a=i?this.toUri({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:a}]}resolveGlobalStateNodeContent(t,i){switch(i){case"globalState.json":return(0,g.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const i=await this.instantiationService.createInstance(g.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,g.stringify)(i,!0)}getProfilesAssociatedResources(t,i){const r=this.extUri.joinPath(t,"profiles.json"),a=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:a}]}resolveProfileNodeContent(t,i){switch(i){case"profiles.json":return(0,k.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,b.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}toUri(t){const i=t.remote?Be.REMOTE_BACKUP_AUTHORITY:Be.LOCAL_BACKUP_AUTHORITY,r=[t.syncResource,t.profile];return t.collection&&r.push(`collection:${t.collection}`),t.ref&&r.push(`ref:${t.ref}`),t.node&&r.push(t.node),this.extUri.joinPath(L.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...r)}resolveUri(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Be.LOCAL_BACKUP_AUTHORITY&&t.authority!==Be.REMOTE_BACKUP_AUTHORITY)return;const i=[];for(;t.path!=="/";)i.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(i.length<2)return;const r=t.authority===Be.REMOTE_BACKUP_AUTHORITY,a=i.shift(),s=i.shift();let l,p,E;for(;i.length;){const T=i.shift();T.startsWith("collection:")?l=T.substring(11):T.startsWith("ref:")?p=T.substring(4):E=T}return{remote:r,syncResource:a,profile:s,collection:l,ref:p,node:E}}parseSyncData(t,i){try{const r=JSON.parse(t);if((0,w.isSyncData)(r))return r}catch(r){this.logService.error(r)}throw new S.UserDataSyncError((0,_.localize)(0,null),"IncompatibleRemoteContent",i)}async getUserData(t,i,r){const a=await this.userDataSyncStoreService.resolveResourceContent(t,i,r);return{ref:i,content:a}}};n.NOT_EXISTING_RESOURCE="not-existing-resource",n.REMOTE_BACKUP_AUTHORITY="remote-backup",n.LOCAL_BACKUP_AUTHORITY="local-backup",n=pe([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncBackupStoreService),Y(2,S.IUserDataSyncLogService),Y(3,C.IUriIdentityService),Y(4,c.IEnvironmentService),Y(5,I.IStorageService),Y(6,R.IFileService),Y(7,P.IUserDataProfilesService),Y(8,y.IConfigurationService),Y(9,v.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(se[286],oe([0,1,19,6,24,39,3,2,25,12,31,17,29,5,21,20,18,122,123,124,125,126,127,128,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k,n,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let r=class extends I.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(E,T,A,N,W,V,K,z,O){super(),this.userDataSyncStoreService=E,this.userDataSyncStoreManagementService=T,this.instantiationService=A,this.logService=N,this.telemetryService=W,this.storageService=V,this.userDataSyncEnablementService=K,this.userDataProfilesService=z,this.userDataSyncResourceProviderService=O,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new D.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new D.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new D.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=T.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(i,-1,void 0),this._register((0,I.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(E,T){this.checkEnablement(),this.logService.info("Sync started.");const A=new Date().getTime(),N=(0,P.generateUuid)();try{const z=(0,t.createSyncHeaders)(N);T&&(z["Cache-Control"]="no-cache"),E=await this.userDataSyncStoreService.manifest(E,z)}catch(z){const O=t.UserDataSyncError.toUserDataSyncError(z);throw l(O,N,this.userDataSyncStoreManagementService,this.telemetryService),O}const W=!1,V=this;let K;return{manifest:E,async run(){if(W)throw new Error("Can run a task only once");K=(0,_.createCancelablePromise)(z=>V.sync(E,!1,N,z)),await K.finally(()=>K=void 0),V.logService.info(`Sync done. Took ${new Date().getTime()-A}ms`),V.updateLastSyncTime()},stop(){return K?.cancel(),V.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const E=new Date().getTime(),T=(0,P.generateUuid)(),A=(0,t.createSyncHeaders)(T);let N;try{N=await this.userDataSyncStoreService.manifest(null,A)}catch(K){const z=t.UserDataSyncError.toUserDataSyncError(K);throw l(z,T,this.userDataSyncStoreManagementService,this.telemetryService),z}await this.resetLocal();const W=this,V=new c.CancellationTokenSource;return{id:T,async merge(){return W.sync(N,!0,T,V.token)},async apply(){try{try{await W.applyManualSync(N,T,V.token)}catch(K){if(t.UserDataSyncError.toUserDataSyncError(K).code==="MethodNotFound")W.logService.info("Client is making invalid requests. Cleaning up data..."),await W.cleanUpRemoteData(),W.logService.info("Applying manual sync again..."),await W.applyManualSync(N,T,V.token);else throw K}}catch(K){throw W.logService.error(K),K}W.logService.info(`Sync done. Took ${new Date().getTime()-E}ms`),W.updateLastSyncTime()},async stop(){V.cancel(),await W.stop(),await W.resetLocal()}}}async sync(E,T,A,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const W=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(W,E,T,A,N));const V=W.enabled.find(K=>K.resource==="profiles");if(V){const K=await V.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(K,E,T,A,N)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(E,T,A,N,W){for(const V of E){if(W.isCancellationRequested)return;const K=this.userDataProfilesService.profiles.find(O=>O.id===V.id);if(!K){this.logService.error(`Profile with id:${V.id} and name: ${V.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",V.name);const z=this.getOrCreateActiveProfileSynchronizer(K,V);this._syncErrors.push(...await this.syncProfile(z,T,A,N,W))}for(const[V,K]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(z=>z.id===K[0].profile.id)||(K[1].dispose(),this.activeProfileSynchronizers.delete(V))}async applyManualSync(E,T,A){const N=this.getActiveProfileSynchronizers();for(const O of N){if(A.isCancellationRequested)return;await O.apply(T,A)}const W=N.find(O=>O.profile.isDefault);if(!W)return;const V=W.enabled.find(O=>O.resource==="profiles");if(!V)return;const z=(await V.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(O=>N.every($=>$.profile.id!==O.id));z.length&&await this.syncRemoteProfiles(z,E,!1,T,A)}async syncProfile(E,T,A,N,W){return(await E.sync(T,A,N,W)).map(([K,z])=>({profile:E.profile,syncResource:K,error:z}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(E=>E.stop()))}async resolveContent(E){const T=await this.userDataSyncResourceProviderService.resolveContent(E);if(T)return T;for(const A of this.getActiveProfileSynchronizers())for(const N of A.enabled){const W=await N.resolveContent(E);if(W)return W}return null}async replace(E){this.checkEnablement();const T=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(E);if(!T)return;const A=await this.resolveContent(E.uri);!A||await this.performAction(T.profile,async N=>{if(T.syncResource===N.resource)return await N.replace(A),!0})}async accept(E,T,A,N){this.checkEnablement(),await this.performAction(E.profile,async W=>{if(E.syncResource===W.resource)return await W.accept(T,A),N&&await W.apply((0,S.isBoolean)(N)?!1:N.force,(0,t.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,T){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(E,T)}async getLocalSyncResourceHandles(E,T){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(E,T??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(E){return this.userDataSyncResourceProviderService.getAssociatedResources(E)}async getMachineId(E){return this.userDataSyncResourceProviderService.getMachineId(E)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async T=>{if(T.resource!=="globalState"&&await T.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async T=>{if(await T.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(E){this.logService.error(E)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(i,-1);for(const[E]of this.activeProfileSynchronizers.values())try{await E.resetLocal()}catch(T){this.logService.error(T)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),T=E.map(V=>V.collection),A=await this.userDataSyncStoreService.getAllCollections(),N=A.filter(V=>!T.includes(V));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map(V=>this.userDataSyncStoreService.deleteCollection(V))),this.logService.info("Deleted redundant collections on server"));const W=E.filter(V=>A.includes(V.collection));if(W.length!==E.length){this.logService.info("Updating remote profiles with invalid collections on server");const V=this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{await V.updateRemoteProfiles(W,null),this.logService.info("Updated remote profiles on server")}finally{V.dispose()}}}async performAction(E,T){const A=new I.DisposableStore;try{const N=this.activeProfileSynchronizers.get(E.id);if(N){const O=await this.performActionWithProfileSynchronizer(N[0],T,A);return(0,S.isUndefined)(O)?null:O}if(E.isDefault){const O=A.add(this.instantiationService.createInstance(a,E,void 0)),$=await this.performActionWithProfileSynchronizer(O,T,A);return(0,S.isUndefined)($)?null:$}if(this.userDataProfilesService.isEnabled())return null;const W=A.add(this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,E,void 0)),V=await this.userDataSyncStoreService.manifest(null),z=(await W.getRemoteSyncedProfiles(V?.latest??null)||[]).find(O=>O.id===E.id);if(z){const O=A.add(this.instantiationService.createInstance(a,E,z.collection)),$=await this.performActionWithProfileSynchronizer(O,T,A);return(0,S.isUndefined)($)?null:$}return null}finally{A.dispose()}}async performActionWithProfileSynchronizer(E,T,A){const N=[...E.enabled,...E.disabled.map(W=>A.add(E.createSynchronizer(W)))];for(const W of N){const V=await T(W);if(!(0,S.isUndefined)(V))return V}}setStatus(E){const T=this._status;this._status!==E&&(this._status=E,this._onDidChangeStatus.fire(E),T==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const E=this.getActiveProfileSynchronizers().map(T=>T.conflicts).flat();(0,L.equals)(this._conflicts,E,(T,A)=>T.profile.id===A.profile.id&&T.syncResource===A.syncResource&&(0,L.equals)(T.conflicts,A.conflicts,(N,W)=>(0,C.isEqual)(N.previewResource,W.previewResource)))||(this._conflicts=E,this._onDidChangeConflicts.fire(E))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(E,T){let A=this.activeProfileSynchronizers.get(E.id);if(A&&A[0].collection!==T?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),A[1].dispose(),A=void 0,this.activeProfileSynchronizers.delete(E.id)),!A){const N=new I.DisposableStore,W=N.add(this.instantiationService.createInstance(a,E,T?.collection));N.add(W.onDidChangeStatus(V=>this.setStatus(V))),N.add(W.onDidChangeConflicts(V=>this.updateConflicts())),N.add(W.onDidChangeLocal(V=>this._onDidChangeLocal.fire(V))),this.activeProfileSynchronizers.set(E.id,A=[W,N])}return A[0]}getActiveProfileSynchronizers(){const E=[];for(const[T]of this.activeProfileSynchronizers.values())E.push(T);return E}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,E])=>E.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=pe([Y(0,t.IUserDataSyncStoreService),Y(1,t.IUserDataSyncStoreManagementService),Y(2,d.IInstantiationService),Y(3,t.IUserDataSyncLogService),Y(4,y.ITelemetryService),Y(5,f.IStorageService),Y(6,t.IUserDataSyncEnablementService),Y(7,h.IUserDataProfilesService),Y(8,t.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let a=class extends I.Disposable{get enabled(){return this._enabled.sort((E,T)=>E[1]-T[1]).map(([E])=>E)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(E=>!this.userDataSyncEnablementService.isResourceEnabled(E))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(E,T,A,N,W,V,K,z,O,$){super(),this.profile=E,this.collection=T,this.userDataSyncEnablementService=A,this.instantiationService=N,this.extensionGalleryService=W,this.userDataSyncStoreManagementService=V,this.telemetryService=K,this.logService=z,this.userDataProfilesService=O,this.configurationService=$,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new D.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(A.onDidChangeResourceEnablement(([Z,q])=>this.onDidChangeResourceEnablement(Z,q))),this._register((0,I.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,Z])=>Z.dispose())));for(const Z of t.ALL_SYNC_RESOURCES)A.isResourceEnabled(Z)&&this.registerSynchronizer(Z)}onDidChangeResourceEnablement(E,T){T?this.registerSynchronizer(E):this.deRegisterSynchronizer(E)}registerSynchronizer(E){if(this._enabled.some(([W])=>W.resource===E))return;if(E==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled()))return;const T=new I.DisposableStore,A=T.add(this.createSynchronizer(E));T.add(A.onDidChangeStatus(()=>this.updateStatus())),T.add(A.onDidChangeConflicts(()=>this.updateConflicts())),T.add(A.onDidChangeLocal(()=>this._onDidChangeLocal.fire(E)));const N=this.getOrder(E);this._enabled.push([A,N,T])}deRegisterSynchronizer(E){const T=this._enabled.findIndex(([A])=>A.resource===E);if(T!==-1){const[[A,,N]]=this._enabled.splice(T,1);N.dispose(),this.updateStatus(),Promise.allSettled([A.stop(),A.resetLocal()]).then(null,W=>this.logService.error(W))}}createSynchronizer(E){switch(E){case"settings":return this.instantiationService.createInstance(b.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(v.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(k.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(g.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,T,A,N){if(N.isCancellationRequested)return[];const W=this.enabled;if(!W.length)return[];try{const V=[],K=(0,t.createSyncHeaders)(A),z=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,O=T?await this.getUserDataSyncConfiguration(z):{};for(const $ of W){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled($.resource))return[];try{if(T){const Z=await $.preview(z,O,K);if(Z)for(const q of Z.resourcePreviews)(q.localChange!==0||q.remoteChange!==0)&&q.mergeState==="preview"&&await $.merge(q.previewResource)}else await $.sync(z,K)}catch(Z){const q=t.UserDataSyncError.toUserDataSyncError(Z);if(l(q,A,this.userDataSyncStoreManagementService,this.telemetryService),s(Z))throw q;this.logService.error(Z),this.logService.error(`${$.resource}: ${(0,R.toErrorMessage)(Z)}`),V.push([$.resource,q])}}return V}finally{this.updateStatus()}}async apply(E,T){const A=(0,t.createSyncHeaders)(E);for(const N of this.enabled){if(T.isCancellationRequested)return;try{await N.apply(!1,A)}catch(W){const V=t.UserDataSyncError.toUserDataSyncError(W);if(l(V,E,this.userDataSyncStoreManagementService,this.telemetryService),s(W))throw V;this.logService.error(W),this.logService.error(`${N.resource}: ${(0,R.toErrorMessage)(W)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(T){this.logService.error(T)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(T){this.logService.error(`${E.resource}: ${(0,R.toErrorMessage)(T)}`),this.logService.error(T)}}async getUserDataSyncConfiguration(E){if(!this.profile.isDefault)return{};const T=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),A=this.enabled.find(N=>N instanceof b.SettingsSynchroniser);if(A){const N=await A.getRemoteUserDataSyncConfiguration(E);return{...T,...N}}return T}setStatus(E){this._status!==E&&(this._status=E,this._onDidChangeStatus.fire(E))}updateStatus(){return this.updateConflicts(),this.enabled.some(E=>E.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const E=this.enabled.filter(T=>T.status==="hasConflicts").filter(T=>T.conflicts.conflicts.length>0).map(T=>T.conflicts);(0,L.equals)(this._conflicts,E,(T,A)=>T.syncResource===A.syncResource&&(0,L.equals)(T.conflicts,A.conflicts,(N,W)=>(0,C.isEqual)(N.previewResource,W.previewResource)))||(this._conflicts=E,this._onDidChangeConflicts.fire(E))}getOrder(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=pe([Y(2,t.IUserDataSyncEnablementService),Y(3,d.IInstantiationService),Y(4,m.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,y.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,h.IUserDataProfilesService),Y(9,w.IConfigurationService)],a);function s(p){if(p instanceof t.UserDataSyncError)switch(p.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function l(p,E,T,A){A.publicLog2("sync/error",{code:p.code,serverCode:p instanceof t.UserDataSyncStoreError?String(p.serverCode):void 0,url:p instanceof t.UserDataSyncStoreError?p.url:void 0,resource:p.resource,executionId:E,service:T.userDataSyncStore.url.toString()})}}),define(se[287],oe([0,1,3,2,11,18,23]),function(ee,e,L,_,c,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function I(m,d){return{...m,profile:(0,R.reviveProfile)(m.profile,d.profilesHome.scheme)}}function C(m){return{created:m.created,uri:c.URI.revive(m.uri)}}class S{constructor(d,f,y){this.service=d,this.userDataProfilesService=f,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(d,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(d,f,y){try{return await this._call(d,f,y)}catch(h){throw this.logService.error(h),h}}async _call(d,f,y){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(c.URI.revive(y[0]));case"accept":return this.service.accept(I(y[0],this.userDataProfilesService),c.URI.revive(y[1]),y[2],y[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0],y[1]?(0,R.reviveProfile)(y[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0],y[1]);case"replace":return this.service.replace(C(y[0]));case"getAssociatedResources":return this.service.getAssociatedResources(C(y[0]));case"getMachineId":return this.service.getMachineId(C(y[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring(11),u=y[0],g=this.getManualSyncTask(u);switch(y=y.slice(1),h){case"merge":return g.merge();case"apply":return g.apply().then(()=>this.manualSyncTasks.delete(this.createKey(g.id)));case"stop":return g.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(g.id)))}}throw new Error("Invalid call")}getManualSyncTask(d){const f=this.manualSyncTasks.get(this.createKey(d));if(!f)throw new Error(`Manual sync taks not found: ${d}`);return f}async createManualSyncTask(){const d=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(d.id),d),d.id}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=S;let P=class extends _.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(d,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,h,u){return d.call(y,h,u).then(null,g=>{throw D.UserDataSyncError.toUserDataSyncError(g)})},listen(y,h){return d.listen(y,h)}},this.channel.call("_getInitialData").then(([y,h,u])=>{this.updateStatus(y),this.updateConflicts(h),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(g=>this.updateStatus(g))),this._register(this.channel.listen("onDidChangeLastSyncTime")(g=>this.updateLastSyncTime(g)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(h=>({...h,error:D.UserDataSyncError.toUserDataSyncError(h.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.channel.call("createManualSyncTask"),f=this;return new w(d,{async call(h,u,g){return f.channel.call(`manualSync/${h}`,[d,...Array.isArray(u)?u:[u]],g)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,f,y,h){return this.channel.call("accept",[d,f,y,h])}resolveContent(d){return this.channel.call("resolveContent",[d])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(d,f){return(await this.channel.call("getLocalSyncResourceHandles",[d,f])).map(({created:h,uri:u})=>({created:h,uri:c.URI.revive(u)}))}async getRemoteSyncResourceHandles(d,f){return(await this.channel.call("getRemoteSyncResourceHandles",[d,f])).map(({created:h,uri:u})=>({created:h,uri:c.URI.revive(u)}))}async getAssociatedResources(d){return(await this.channel.call("getAssociatedResources",[d])).map(({resource:y,comparableResource:h})=>({resource:c.URI.revive(y),comparableResource:c.URI.revive(h)}))}getMachineId(d){return this.channel.call("getMachineId",[d])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(d){return this.channel.call("replace",[d])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(f=>({syncResource:f.syncResource,profile:(0,R.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(y=>({...y,baseResource:c.URI.revive(y.baseResource),localResource:c.URI.revive(y.localResource),remoteResource:c.URI.revive(y.remoteResource),previewResource:c.URI.revive(y.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}};P=pe([Y(1,R.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class w extends _.Disposable{constructor(d,f){super(),this.id=d,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(se[288],oe([0,1,6,24,7,3,2,145,4,25,12,11,31,17,15,14,26,59,44,21,23]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const k="sync.previous.store",n="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends D.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(b.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(A){this.storageService.store(b.SYNC_SERVICE_URL_TYPE,A,-1,C.isWeb?0:1)}constructor(A,N,W){super(),this.productService=A,this.configurationService=N,this.storageService=W,this._onDidChangeUserDataSyncStore=this._register(new R.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(R.Event.filter(W.onDidChangeValue,V=>V.key===b.SYNC_SERVICE_URL_TYPE&&V.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[b.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(b.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,N){A=C.isWeb&&A?.web?{...A,...A.web}:A;const W={...A||{},...N||{}};if(W&&(0,P.isString)(W.url)&&(0,P.isObject)(W.authenticationProviders)&&Object.keys(W.authenticationProviders).every(V=>Array.isArray(W.authenticationProviders[V].scopes))){const V=W,K=!!V.canSwitch&&!N?.url,z=V.url===V.insidersUrl?"insiders":"stable",O=(K?this.userDataSyncStoreType:void 0)||z,$=N?.url||(O==="insiders"?V.insidersUrl:O==="stable"?V.stableUrl:V.url);return{url:w.URI.parse($),type:O,defaultType:z,defaultUrl:w.URI.parse(V.url),stableUrl:w.URI.parse(V.stableUrl),insidersUrl:w.URI.parse(V.insidersUrl),canSwitch:K,authenticationProviders:Object.keys(V.authenticationProviders).reduce((Z,q)=>(Z.push({id:q,scopes:V.authenticationProviders[q].scopes}),Z),[])}}}};a=pe([Y(0,h.IProductService),Y(1,d.IConfigurationService),Y(2,v.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let s=class extends a{constructor(A,N,W){super(A,N,W);const V=this.storageService.get(k,-1);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const K=this.productService[b.CONFIGURATION_SYNC_STORE_KEY];K?this.storageService.store(k,JSON.stringify(K),-1,1):this.storageService.remove(k,-1)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};s=pe([Y(0,h.IProductService),Y(1,d.IConfigurationService),Y(2,v.IStorageService)],s),e.UserDataSyncStoreManagementService=s;let l=class extends D.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(A,N,W,V,K,z,O){super(),this.requestService=W,this.logService=V,this.storageService=O,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new R.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new R.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,g.getServiceMachineId)(K,z,O).then($=>{const Z={"X-Client-Name":`${N.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(Z["X-Client-Commit"]=N.commit),Z}),this.session=new E(i,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,D.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(A,N){this.authToken={token:A,type:N}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,S.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(n,-1);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]="application/json";const W=await this.request(N,{type:"GET",headers:A},[],_.CancellationToken.None);return(await(0,u.asJson)(W))?.map(({id:V})=>V)||[]}async createCollection(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]=I.Mimes.text;const W=await this.request(N,{type:"POST",headers:A},[],_.CancellationToken.None),V=await(0,u.asTextOrError)(W);if(!V)throw new b.UserDataSyncStoreError("Server did not return the collection id",N,"NoCollection",W.res.statusCode,W.res.headers[b.HEADER_OPERATION_ID]);return V}async deleteCollection(A,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=A?(0,S.joinPath)(this.userDataSyncStoreUrl,"collection",A).toString():(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(W,{type:"DELETE",headers:N},[],_.CancellationToken.None)}async getAllResourceRefs(A,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=this.getResourceUrl(this.userDataSyncStoreUrl,N,A),V={},K=await this.request(W.toString(),{type:"GET",headers:V},[],_.CancellationToken.None);return(await(0,u.asJson)(K)||[]).map(({url:O,created:$})=>({ref:(0,S.relativePath)(W,W.with({path:O})),created:$*1e3}))}async resolveResourceContent(A,N,W,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,A),N).toString();V={...V},V["Cache-Control"]="no-cache";const z=await this.request(K,{type:"GET",headers:V},[],_.CancellationToken.None);return await(0,u.asTextOrError)(z)}async deleteResource(A,N,W){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=N!==null?(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,A),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,W,A).toString(),K={};await this.request(V,{type:"DELETE",headers:K},[],_.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,S.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":I.Mimes.text};await this.request(A,{type:"DELETE",headers:N},[],_.CancellationToken.None)}async readResource(A,N,W,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,A),"latest").toString();V={...V},V["Cache-Control"]="no-cache",N&&(V["If-None-Match"]=N.ref);const z=await this.request(K,{type:"GET",headers:V},[304],_.CancellationToken.None);let O=null;if(z.res.statusCode===304&&(O=N),O===null){const $=z.res.headers.etag;if(!$)throw new b.UserDataSyncStoreError("Server did not return the ref",K,"NoRef",z.res.statusCode,z.res.headers[b.HEADER_OPERATION_ID]);const Z=await(0,u.asTextOrError)(z);if(!Z&&z.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",K,"EmptyResponse",z.res.statusCode,z.res.headers[b.HEADER_OPERATION_ID]);O={ref:$,content:Z}}return O}async writeResource(A,N,W,V,K={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=this.getResourceUrl(this.userDataSyncStoreUrl,V,A).toString();K={...K},K["Content-Type"]=I.Mimes.text,W&&(K["If-Match"]=W);const O=await this.request(z,{type:"POST",data:N,headers:K},[],_.CancellationToken.None),$=O.res.headers.etag;if(!$)throw new b.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",O.res.statusCode,O.res.headers[b.HEADER_OPERATION_ID]);return $}async manifest(A,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,S.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",A&&(N["If-None-Match"]=A.ref);const V=await this.request(W,{type:"GET",headers:N},[304],_.CancellationToken.None);let K=null;if(V.res.statusCode===304&&(K=A),!K){const O=V.res.headers.etag;if(!O)throw new b.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",V.res.statusCode,V.res.headers[b.HEADER_OPERATION_ID]);const $=await(0,u.asTextOrError)(V);if(!$&&V.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",W,"EmptyResponse",V.res.statusCode,V.res.headers[b.HEADER_OPERATION_ID]);$&&(K={...JSON.parse($),ref:O})}const z=this.storageService.get(o,-1);return z&&K&&z!==K.session&&this.clearSession(),K===null&&z&&this.clearSession(),K&&this.storageService.store(o,K.session,-1,1),K}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(A,N,W){return N?(0,S.joinPath)(A,"collection",N,"resource",W):(0,S.joinPath)(A,"resource",W)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(t,-1)}async request(A,N,W,V){if(!this.authToken)throw new b.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const K=await this.commonHeadersPromise;N.headers={...N.headers||{},...K,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:A,type:N.type,headers:{...N.headers,authorization:void 0}});let z;try{z=await this.session.request(A,N,V)}catch(j){if(!(j instanceof b.UserDataSyncStoreError)){let M="RequestFailed";const J=(0,c.getErrorMessage)(j).toLowerCase();J.includes("xhr timeout")?M="RequestTimeout":J.includes("protocol")&&J.includes("not supported")?M="RequestProtocolNotSupported":J.includes("request path contains unescaped characters")?M="RequestPathNotEscaped":J.includes("headers must be an object")?M="RequestHeadersNotObject":(0,c.isCancellationError)(j)&&(M="RequestCanceled"),j=new b.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,M,void 0,void 0)}throw this.logService.info("Request failed",A),j}const O=z.res.headers[b.HEADER_OPERATION_ID],$={url:A,status:z.res.statusCode,"execution-id":N.headers[b.HEADER_EXECUTION_ID],"operation-id":O},Z=(0,u.isSuccess)(z)||z.res.statusCode&&W.indexOf(z.res.statusCode)!==-1;let q="";if(Z?this.logService.trace("Request succeeded",$):(this.logService.info("Request failed",$),q=await(0,u.asText)(z)||""),z.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new b.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",z.res.statusCode,O);if(this._onTokenSucceed.fire(),z.res.statusCode===404)throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because the requested resource is not found (404).`,A,"NotFound",z.res.statusCode,O);if(z.res.statusCode===405)throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because the requested endpoint is not found (405). ${q}`,A,"MethodNotFound",z.res.statusCode,O);if(z.res.statusCode===409)throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",z.res.statusCode,O);if(z.res.statusCode===410)throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",z.res.statusCode,O);if(z.res.statusCode===412)throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",z.res.statusCode,O);if(z.res.statusCode===413)throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",z.res.statusCode,O);if(z.res.statusCode===426)throw new b.UserDataSyncStoreError(`${N.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",z.res.statusCode,O);if(z.res.statusCode===429){const j=z.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",z.res.statusCode,O)):new b.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",z.res.statusCode,O)}if(!Z)throw new b.UserDataSyncStoreError("Server returned "+z.res.statusCode,A,"Unknown",z.res.statusCode,O);return z}addSessionHeaders(A){let N=this.storageService.get(t,-1);N===void 0&&(N=(0,m.generateUuid)(),this.storageService.store(t,N,-1,1)),A["X-Machine-Session-Id"]=N;const W=this.storageService.get(o,-1);W!==void 0&&(A["X-User-Session-Id"]=W)}};l=pe([Y(1,h.IProductService),Y(2,u.IRequestService),Y(3,b.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,y.IFileService),Y(6,v.IStorageService)],l),e.UserDataSyncStoreClient=l;let p=class extends l{constructor(A,N,W,V,K,z,O){super(A.userDataSyncStore?.url,N,W,V,K,z,O),this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};p=pe([Y(0,b.IUserDataSyncStoreManagementService),Y(1,h.IProductService),Y(2,u.IRequestService),Y(3,b.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,y.IFileService),Y(6,v.IStorageService)],p),e.UserDataSyncStoreService=p;class E{constructor(A,N,W,V){this.limit=A,this.interval=N,this.requestService=W,this.logService=V,this.requests=[],this.startTime=void 0}request(A,N,W){if(this.isExpired()&&this.reset(),N.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new b.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(N,W)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=E}),define(se[289],oe([0,1,3,57,26,21,20,284,23,77,80]),function(ee,e,L,_,c,R,D,I,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends I.UserDataAutoSyncService{constructor(d,f,y,h,u,g,v,b,k,n,o){super(d,f,y,h,u,v,b,k,n,o),this._register(L.Event.debounce(L.Event.any(L.Event.map(g.onDidFocusWindow,()=>"windowFocus"),L.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=pe([Y(0,c.IProductService),Y(1,C.IUserDataSyncStoreManagementService),Y(2,C.IUserDataSyncStoreService),Y(3,C.IUserDataSyncEnablementService),Y(4,C.IUserDataSyncService),Y(5,_.INativeHostService),Y(6,C.IUserDataSyncLogService),Y(7,S.IUserDataSyncAccountService),Y(8,D.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,R.IStorageService)],w),e.UserDataAutoSyncService=w}),define(se[290],oe([0,1,103,22,4,25]),function(ee,e,L,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(S){function P(){let w=S.scheme===_.Schemas.file?(0,R.originalFSPath)(S):S.toString();return c.isLinux||(w=w.toLowerCase()),(0,L.createHash)("md5").update(w).digest("hex")}return{id:P(),configPath:S}}e.getWorkspaceIdentifier=D;function I(S,P){function w(){if(S.scheme!==_.Schemas.file)return(0,L.createHash)("md5").update(S.toString()).digest("hex");if(!P)return;let d;return c.isLinux?d=P.ino:c.isMacintosh?d=P.birthtime.getTime():c.isWindows&&(typeof P.birthtimeMs=="number"?d=Math.floor(P.birthtimeMs):d=P.birthtime.getTime()),(0,L.createHash)("md5").update(S.fsPath).update(d?String(d):"").digest("hex")}const m=w();if(typeof m=="string")return{id:m,uri:S}}e.getSingleFolderWorkspaceIdentifier=I;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=C}),define(se[291],oe([0,1,6,7,2,13,28,15,9,75,120,290,71,57]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends c.Disposable{constructor(h,u,g,v){super(),this.environmentService=h,this.logService=u,this.nativeHostService=g,this.mainProcessService=v,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=await D.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new S.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(h.map(async g=>{const v=(0,R.join)(this.environmentService.workspaceStorageHome.fsPath,g);g.length===w.NON_EMPTY_WORKSPACE_ID_LENGTH||g===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===g)||await u.isUsed(v)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await D.Promises.rm(v))}))}catch(h){(0,_.onUnexpectedError)(h)}}};f=pe([Y(0,I.INativeEnvironmentService),Y(1,C.ILogService),Y(2,d.INativeHostService),Y(3,m.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(se[81],oe([0,1,53,6,13,12,28,157,301,302]),function(ee,e,L,_,c,R,D,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class w extends Error{constructor(o,t){let i=t.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=t}}e.ExtractError=w;function m(n){const o=n.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,i)=>t+i,o&61440)}function d(n){if(n instanceof w)return n;let o;return P.test(n.message)&&(o="CorruptZip"),new w(o,n)}function f(n,o,t,i,r,a){const s=c.dirname(o),l=c.join(i,s);if(!l.startsWith(i))return Promise.reject(new Error(I.localize(0,null,o)));const p=c.join(i,o);let E;return a.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(D.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((T,A)=>{if(!a.isCancellationRequested)try{E=(0,L.createWriteStream)(p,{mode:t}),E.once("close",()=>T()),E.once("error",A),n.once("error",A),n.pipe(E)}catch(N){A(N)}}))}function y(n,o,t,i){let r=(0,_.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{r.cancel(),n.close()}),new Promise((s,l)=>{const p=new _.Sequencer,E=T=>{T.isCancellationRequested||(a++,n.readEntry())};n.once("error",l),n.once("close",()=>r.then(()=>{i.isCancellationRequested||n.entryCount===a?s():l(new w("Incomplete",new Error(I.localize(1,null,a,n.entryCount))))},l)),n.readEntry(),n.on("entry",T=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(T.fileName)){E(i);return}const A=T.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(A)){const V=c.join(o,A);r=(0,_.createCancelablePromise)(K=>D.Promises.mkdir(V,{recursive:!0}).then(()=>E(K)).then(void 0,l));return}const N=u(n,T),W=m(T);r=(0,_.createCancelablePromise)(V=>p.queue(()=>N.then(K=>f(K,A,W,o,t,V).then(()=>E(V)))).then(null,l))})})}function h(n,o=!1){return new Promise((t,i)=>{(0,C.open)(n,o?{lazyEntries:!0}:void 0,(r,a)=>{r?i(d(r)):t((0,R.assertIsDefined)(a))})})}function u(n,o){return new Promise((t,i)=>{n.openReadStream(o,(r,a)=>{r?i(d(r)):t((0,R.assertIsDefined)(a))})})}function g(n,o){return new Promise((t,i)=>{const r=new S.ZipFile;o.forEach(s=>{s.contents?r.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&r.addFile(s.localPath,s.path)}),r.end();const a=(0,L.createWriteStream)(n);r.outputStream.pipe(a),r.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>t(n))})}e.zip=g;function v(n,o,t={},i){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let a=h(n,!0);return t.overwrite&&(a=a.then(s=>D.Promises.rm(o).then(()=>s))),a.then(s=>y(s,o,{sourcePathRegex:r},i))}e.extract=v;function b(n,o){return h(n).then(t=>new Promise((i,r)=>{t.on("entry",a=>{a.fileName===o&&u(t,a).then(s=>i(s),s=>r(s))}),t.once("close",()=>r(new Error(I.localize(2,null,o))))}))}function k(n,o){return b(n,o).then(t=>new Promise((i,r)=>{const a=[];t.once("error",r),t.on("data",s=>a.push(s)),t.on("end",()=>i(Buffer.concat(a)))}))}e.buffer=k}),define(se[292],oe([0,1,6,7,2,22,4,25,54,12,31,28,81,17,15,29,33,101,14,9]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let b=class pt extends c.Disposable{constructor(n,o,t,i,r,a){super(),this.fileService=o,this.extensionGalleryService=t,this.configurationService=i,this.extensionSignatureVerificationService=r,this.logService=a,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,o){await this.cleanUpPromise;const t=(0,I.joinPath)(this.extensionsDownloadDir,this.getName(n));try{await this.downloadFile(n,t,r=>this.extensionGalleryService.download(n,r,o))}catch(r){throw new y.ExtensionManagementError(r.message,y.ExtensionManagementErrorCode.Download)}let i="Unverified";if(this.shouldVerifySignature(n)){const r=await this.downloadSignatureArchive(n);try{await this.extensionSignatureVerificationService.verify(t.fsPath,r.fsPath,this.logService.getLevel()===v.LogLevel.Trace)&&(i="Verified"),this.logService.info(`Extension signature verification: ${n.identifier.id}. Verification status: ${i}.`)}catch(a){const s=a,l=s.code;if(s.output&&this.logService.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${s.output}`),l==="UnknownError")i="UnknownError",this.logService.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${i}.`);else{if(l==="PackageIsInvalidZip"||l==="SignatureArchiveIsInvalidZip")throw new y.ExtensionManagementError(m.CorruptZipMessage,y.ExtensionManagementErrorCode.CorruptZip);if(!s.didExecute)this.logService.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${i} (${l})`);else throw await this.delete(t),new y.ExtensionManagementError(l,y.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return{location:t,verificationStatus:i}}shouldVerifySignature(n){if(!n.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,S.isBoolean)(o)?o:!0}async downloadSignatureArchive(n){await this.cleanUpPromise;const o=(0,I.joinPath)(this.extensionsDownloadDir,`${this.getName(n)}${pt.SignatureArchiveExtension}`);return await this.downloadFile(n,o,t=>this.extensionGalleryService.downloadSignatureArchive(n,t)),o}async downloadFile(n,o,t){if(await this.fileService.exists(o))return;if(o.scheme!==R.Schemas.file){await t(o);return}const i=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(i)||await t(i);try{await this.rename(i,o,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async rename(n,o,t){try{await w.Promises.rename(n.fsPath,o.fsPath)}catch(i){if(D.isWindows&&i&&i.code==="EPERM"&&Date.now()<t)return this.logService.info(`Failed renaming ${n} to ${o} with 'EPERM' error. Trying again...`),this.rename(n,o,t);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const o=[],t=[],i=[];for(const s of n.children)if(s.name.endsWith(pt.SignatureArchiveExtension))i.push(s.resource);else{const l=h.ExtensionKey.parse(s.name);l&&t.push([l,s])}const r=(0,h.groupByExtension)(t,([s])=>s),a=[];for(const s of r)s.sort((l,p)=>C.rcompare(l[0].version,p[0].version)),o.push(...s.slice(1).map(l=>l[1].resource)),a.push(s[0][1]);a.sort((s,l)=>s.mtime-l.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(s=>s.resource)),o.push(...i),await L.Promises.settled(o.map(s=>(this.logService.trace("Deleting from cache",s.path),this.fileService.del(s))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?h.ExtensionKey.create(n).toString().toLowerCase():(0,P.generateUuid)()}};b.SignatureArchiveExtension=".sigzip",b=pe([Y(0,f.INativeEnvironmentService),Y(1,g.IFileService),Y(2,y.IExtensionGalleryService),Y(3,d.IConfigurationService),Y(4,u.IExtensionSignatureVerificationService),Y(5,v.ILogService)],b),e.ExtensionsDownloader=b}),define(se[293],oe([0,1,81,167]),function(ee,e,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function c(R){return(0,L.buffer)(R,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,_.localize)(0,null))}})}e.getManifest=c}),define(se[129],oe([0,1,6,16,24,39,7,3,2,38,22,13,4,25,54,12,11,31,28,81,166,100,15,273,29,33,51,78,292,275,293,227,243,46,68,14,5,9,26,20,30,18]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k,n,o,t,i,r,a,s,l,p,E,T,A,N,W,V,K,z,O,$,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,V.refineServiceDecorator)(t.IExtensionManagementService);let q=class extends o.AbstractExtensionManagementService{constructor(B,F,U,x,H,te,G,X,ie,le,he,me){super(B,F,U,le,me),this.extensionsScannerService=H,this.extensionsProfileScannerService=te,this.downloadService=G,this.fileService=ie,this.uriIdentityService=he,this._onDidUpdateExtensionMetadata=this._register(new I.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new S.ResourceSet;const ve=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(j,Ce=>ve.postUninstall(Ce))),this.manifestCache=this._register(new E.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(X.createInstance(s.ExtensionsDownloader));const we=this._register(new T.ExtensionsWatcher(this,this.extensionsScannerService,me,te,he,ie,U));this._register(we.onDidChangeExtensionsByAnotherSource(Ce=>this.onDidChangeExtensionsFromAnotherSource(Ce))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const F=await this.collectFiles(B),U=await(0,v.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,F);return h.URI.file(U)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:F,cleanup:U}=await this.downloadVsix(B),x=w.resolve(F.fsPath);try{return await(0,p.getManifest)(x)}finally{await U()}}getInstalled(B,F=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(B??null,F)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(B){return this.extensionsScanner.scanUserExtensionAtLocation(B)}async install(B,F={}){this.logService.trace("ExtensionManagementService#install",B.toString());const{location:U,cleanup:x}=await this.downloadVsix(B);try{const H=await(0,p.getManifest)(w.resolve(U.fsPath));if(H.engines&&H.engines.vscode&&!(0,N.isEngineValid)(H.engines.vscode,this.productService.version,this.productService.date))throw new Error(b.localize(0,null,(0,i.getGalleryExtensionId)(H.publisher,H.name),this.productService.version));return await this.installExtension(H,U,F)}finally{await x()}}async installFromLocation(B,F){this.logService.trace("ExtensionManagementService#installFromLocation",B.toString());const U=await this.extensionsScanner.scanUserExtensionAtLocation(B);if(!U)throw new Error(`Cannot find a valid extension from the location ${B.toString()}`);return await this.addExtensionsToProfile([[U,void 0]],F),this.logService.info("Successfully installed extension",U.identifier.id,F.toString()),U}async installExtensionsFromProfile(B,F,U){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",B,F.toString(),U.toString());const x=(await this.extensionsScanner.scanExtensions(1,F)).filter(H=>B.some(te=>(0,i.areSameExtensions)(te,H.identifier)));if(x.length){const H=await Promise.all(x.map(te=>this.extensionsScanner.scanMetadata(te,F)));await this.addExtensionsToProfile(x.map((te,G)=>[te,H[G]]),U),this.logService.info("Successfully installed extensions",x.map(te=>te.identifier.id),U.toString())}return x}async updateMetadata(B,F,U=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.pinned=F.pinned||void 0,B=await this.extensionsScanner.updateMetadata(B,F,U),this.manifestCache.invalidate(),this._onDidUpdateExtensionMetadata.fire(B),B}async reinstallFromGallery(B){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const F=await this.getTargetPlatform(),[U]=await this.galleryService.getExtensions([{...B.identifier,preRelease:B.preRelease}],{targetPlatform:F,compatible:!0},c.CancellationToken.None);if(!U)throw new Error(b.localize(2,null));await this.extensionsScanner.setUninstalled(B);try{await this.extensionsScanner.removeUninstalledExtension(B)}catch(x){throw new Error(b.localize(3,null,(0,R.toErrorMessage)(x)))}return this.installFromGallery(U)}copyExtensions(B,F){return this.extensionsScanner.copyExtensions(B,F)}markAsUninstalled(...B){return this.extensionsScanner.setUninstalled(...B)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(B){this.logService.error(B)}}async download(B,F){const{location:U}=await this.extensionsDownloader.download(B,F);return U}async downloadVsix(B){if(B.scheme===P.Schemas.file)return{location:B,async cleanup(){}};this.logService.trace("Downloading extension from",B.toString());const F=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)());return await this.downloadService.download(B,F),this.logService.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.fileService.del(F)}catch(x){this.logService.error(x)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(B,F,U){if(h.URI.isUri(F))return new Q(B,F,U,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const x=i.ExtensionKey.create(F).toString();let H=this.installGalleryExtensionsTasks.get(x);return H||(this.installGalleryExtensionsTasks.set(x,H=new J(B,F,U,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),H.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x))),H}createUninstallExtensionTask(B,F){return new re(B,F.profileLocation,this.extensionsProfileScannerService)}async collectFiles(B){const F=async x=>{let H=await g.Promises.readdir(x);H=H.map(X=>w.join(x,X));const te=await Promise.all(H.map(X=>g.Promises.stat(X)));let G=Promise.resolve([]);return te.forEach((X,ie)=>{const le=H[ie];X.isFile()&&(G=G.then(he=>[...he,le])),X.isDirectory()&&(G=G.then(he=>F(le).then(me=>[...he,...me])))}),G};return(await F(B.location.fsPath)).map(x=>({path:`extension/${w.relative(B.location.fsPath,x)}`,localPath:x}))}async onDidChangeExtensionsFromAnotherSource({added:B,removed:F}){if(F)for(const U of F.extensions)this.logService.info("Extensions removed from another source",U.id,F.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:U,profileLocation:F.profileLocation});if(B){const x=(await this.extensionsScanner.scanExtensions(1,B.profileLocation)).filter(H=>B.extensions.some(te=>(0,i.areSameExtensions)(te,H.identifier)));this._onDidInstallExtensions.fire(x.map(H=>(this.logService.info("Extensions added from another source",H.identifier.id,B.profileLocation.toString()),{identifier:H.identifier,local:H,profileLocation:B.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(F=>this.knownDirectories.add(F)));const B=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const F of B.children??[])F.isDirectory&&this.knownDirectories.add(F.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(F=>this.onDidFilesChange(F)))}async onDidFilesChange(B){if(!B.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const F=[];for(const U of B.rawAdded){if(this.knownDirectories.has(U)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(U),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(U,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(U).startsWith(".")||!(await this.fileService.stat(U)).isDirectory)continue;const x=await this.extensionsScanner.scanUserExtensionAtLocation(U);x&&x.installedTimestamp===void 0&&(this.knownDirectories.add(U),F.push(x))}F.length&&(await this.addExtensionsToProfile(F.map(U=>[U,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",F.map(U=>U.identifier.id)))}async addExtensionsToProfile(B,F){const U=B.map(x=>x[0]);await this.setInstalled(U),await this.extensionsProfileScannerService.addExtensionsToProfile(B,F),this._onDidInstallExtensions.fire(U.map(x=>({local:x,identifier:x.identifier,operation:1,profileLocation:F})))}async setInstalled(B){const F=await this.extensionsScanner.getUninstalledExtensions();for(const U of B){const x=i.ExtensionKey.create(U);!F[x.toString()]||(this.logService.trace("Removing the extension from uninstalled list:",x.id),await this.extensionsScanner.setInstalled(x),this.logService.info("Removed the extension from uninstalled list:",x.id))}}};q=pe([Y(0,t.IExtensionGalleryService),Y(1,O.ITelemetryService),Y(2,K.ILogService),Y(3,n.INativeEnvironmentService),Y(4,a.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,k.IDownloadService),Y(7,V.IInstantiationService),Y(8,W.IFileService),Y(9,z.IProductService),Y(10,$.IUriIdentityService),Y(11,Z.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let j=class extends C.Disposable{constructor(B,F,U,x,H,te){super(),this.beforeRemovingExtension=B,this.fileService=F,this.extensionsScannerService=U,this.extensionsProfileScannerService=x,this.uriIdentityService=H,this.logService=te,this._onExtract=this._register(new I.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(B,F){const U={includeInvalid:!0,profileLocation:F};let x=[];return B===null||B===0?x.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},U,!1)):B===1&&x.push(...await this.extensionsScannerService.scanUserExtensions(U)),x=B!==null?x.filter(H=>H.type===B):x,Promise.all(x.map(H=>this.toLocalExtension(H)))}async scanAllUserExtensions(B){const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(F.map(U=>this.toLocalExtension(U)))}async scanUserExtensionAtLocation(B){try{const F=await this.extensionsScannerService.scanExistingExtension(B,1,{includeInvalid:!0});if(F)return await this.toLocalExtension(F)}catch(F){this.logService.error(F)}return null}async extractUserExtension(B,F,U,x){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const H=B.toString(),te=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),G=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,H);try{await g.Promises.rm(G)}catch{throw new t.ExtensionManagementError(b.localize(4,null,G,B.id),t.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(B,F,te,x),await this.extensionsScannerService.updateMetadata(h.URI.file(te),U);try{this._onExtract.fire(h.URI.file(G)),await this.rename(B,te,G,Date.now()+2*60*1e3),this.logService.info("Renamed to",G)}catch(X){try{await g.Promises.rm(te)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(X)}. Deleted from extracted location`,te),X}return this.scanLocalExtension(h.URI.file(G),1)}async scanMetadata(B,F){return F?(await this.extensionsProfileScannerService.scanProfileExtensions(F)).find(x=>(0,i.areSameExtensions)(x.identifier,B.identifier))?.metadata:this.extensionsScannerService.scanMetadata(B.location)}async updateMetadata(B,F,U){return U?await this.extensionsProfileScannerService.updateMetadata([[B,F]],U):await this.extensionsScannerService.updateMetadata(B.location,F),this.scanLocalExtension(B.location,B.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...B){const F=B.map(U=>i.ExtensionKey.create(U));await this.withUninstalledExtensions(U=>F.forEach(x=>{U[x.toString()]=!0,this.logService.info("Marked extension as uninstalled",x.toString())}))}async setInstalled(B){await this.withUninstalledExtensions(F=>delete F[B.toString()])}async removeExtension(B,F){this.logService.trace(`Deleting ${F} extension from disk`,B.identifier.id,B.location.fsPath);const U=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(B.location),`.${(0,u.generateUuid)()}`);await this.rename(B.identifier,B.location.fsPath,U.fsPath,Date.now()+2*60*1e3),await this.fileService.del(U,{recursive:!0}),this.logService.info("Deleted from disk",B.identifier.id,B.location.fsPath)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.withUninstalledExtensions(F=>delete F[i.ExtensionKey.create(B).toString()])}async copyExtensions(B,F){const U=await this.scanExtensions(1,B),x=await Promise.all(U.filter(H=>!H.isApplicationScoped).map(async H=>[H,await this.scanMetadata(H,B)]));await this.extensionsProfileScannerService.addExtensionsToProfile(x,F)}async withUninstalledExtensions(B){return this.uninstalledFileLimiter.queue(async()=>{let F;try{F=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(x){if((0,W.toFileOperationResult)(x)!==1)throw x}let U={};if(F)try{U=JSON.parse(F)}catch{}return B&&(B(U),Object.keys(U).length?await this.fileService.writeFile(this.uninstalledResource,_.VSBuffer.fromString(JSON.stringify(U))):await this.fileService.del(this.uninstalledResource)),U})}async extractAtLocation(B,F,U,x){this.logService.trace(`Started extracting the extension from ${F} to ${U}`);try{await g.Promises.rm(U)}catch(H){throw new t.ExtensionManagementError(this.joinErrors(H).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,v.extract)(F,U,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${U}:`,B.id)}catch(H){try{await g.Promises.rm(U)}catch{}let te=t.ExtensionManagementErrorCode.Extract;throw H instanceof v.ExtractError&&(H.type==="CorruptZip"?te=t.ExtensionManagementErrorCode.CorruptZip:H.type==="Incomplete"&&(te=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(H.message,te)}}async rename(B,F,U,x){try{await g.Promises.rename(F,U)}catch(H){if(m.isWindows&&H&&H.code==="EPERM"&&Date.now()<x)return this.logService.info(`Failed renaming ${F} to ${U} with 'EPERM' error. Trying again...`,B.id),this.rename(B,F,U,x);throw new t.ExtensionManagementError(H.message||b.localize(5,null,F,U),H.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(B,F){const U=await this.extensionsScannerService.scanExistingExtension(B,F,{includeInvalid:!0});if(U)return this.toLocalExtension(U);throw new Error(b.localize(6,null,B.path))}async toLocalExtension(B){const F=await this.fileService.resolve(B.location);let U,x;return F.children&&(U=F.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,x=F.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:U,changelogUrl:x,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated,pinned:!!B.metadata?.pinned}}async removeUninstalledExtensions(){const B=await this.getUninstalledExtensions();this.logService.debug("Removing uninstalled extensions:",Object.keys(B));const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const H of F)B[i.ExtensionKey.create(H).toString()]||U.add(H.identifier.id.toLowerCase());try{const H=(0,i.groupByExtension)(F,te=>te.identifier);await L.Promises.settled(H.map(async te=>{const G=te.sort((X,ie)=>f.rcompare(X.manifest.version,ie.manifest.version))[0];U.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}))}catch(H){this.logService.error(H)}const x=F.filter(H=>H.metadata&&B[i.ExtensionKey.create(H).toString()]);await Promise.allSettled(x.map(H=>this.removeUninstalledExtension(H)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const B=[];let F;try{F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(U){(0,W.toFileOperationResult)(U)!==1&&this.logService.error(U)}for(const U of F?.children??[])U.isDirectory&&U.name.startsWith(".")&&(0,u.isUUID)(U.name.substring(1))&&B.push((async()=>{this.logService.trace("Deleting the generated extension folder",U.resource.toString());try{await this.fileService.del(U.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",U.resource.toString())}catch(x){this.logService.error(x)}})());await Promise.allSettled(B)}joinErrors(B){const F=Array.isArray(B)?B:[B];return F.length===1?F[0]instanceof Error?F[0]:new Error(F[0]):F.reduce((U,x)=>new Error(`${U.message}${U.message?",":""}${x instanceof Error?x.message:x}`),new Error(""))}};j=pe([Y(1,W.IFileService),Y(2,a.IExtensionsScannerService),Y(3,r.IExtensionsProfileScannerService),Y(4,$.IUriIdentityService),Y(5,K.ILogService)],j),e.ExtensionsScanner=j;class M extends o.AbstractExtensionTask{get verificationStatus(){return this._verificationStatus}get operation(){return(0,y.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(B,F,U,x,H,te,G,X,ie){super(),this.identifier=B,this.source=F,this.options=U,this.extensionsScanner=x,this.uriIdentityService=H,this.userDataProfilesService=te,this.extensionsScannerService=G,this.extensionsProfileScannerService=X,this.logService=ie,this._verificationStatus="Unverified",this._operation=2}async doRun(B){const[F,U]=await this.install(B);return this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,U]],this.options.profileLocation),F}async extractExtension({zipPath:B,key:F,metadata:U},x){let H=await this.unsetIfUninstalled(F);return H||(this.logService.trace("Extracting extension...",F.id),H=await this.extensionsScanner.extractUserExtension(F,B,U,x),this.logService.info("Extracting extension completed.",F.id)),H}async unsetIfUninstalled(B){return await this.isUninstalled(B)?(this.logService.trace("Removing the extension from uninstalled list:",B.id),await this.extensionsScanner.setInstalled(B),this.logService.info("Removed the extension from uninstalled list:",B.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(x=>i.ExtensionKey.create(x).equals(B))):void 0}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.toString()]}}class J extends M{constructor(B,F,U,x,H,te,G,X,ie,le){super(F.identifier,F,U,H,te,G,X,ie,le),this.manifest=B,this.gallery=F,this.extensionsDownloader=x}async install(B){const U=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(G=>(0,i.areSameExtensions)(G.identifier,this.gallery.identifier));U&&(this._operation=3);const x={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,A.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||U?.isMachineScoped,isBuiltin:this.options.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,y.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(U,x),x];const{location:H,verificationStatus:te}=await this.extensionsDownloader.download(this.gallery,this._operation);try{return this._verificationStatus=te,this.validateManifest(H.fsPath),[await this.extractExtension({zipPath:H.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:x},B),x]}catch(G){try{await this.extensionsDownloader.delete(H)}catch(X){this.logService.warn("Error while deleting the downloaded file",H.toString(),(0,D.getErrorMessage)(X))}throw G}}async validateManifest(B){try{await(0,p.getManifest)(B)}catch(F){throw new t.ExtensionManagementError((0,o.joinErrors)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=J;class Q extends M{constructor(B,F,U,x,H,te,G,X,ie,le){super({id:(0,i.getGalleryExtensionId)(B.publisher,B.name)},F,U,H,te,G,X,ie,le),this.manifest=B,this.location=F,this.galleryService=x}async install(B){const F=new i.ExtensionKey(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(G=>(0,i.areSameExtensions)(this.identifier,G.identifier)),H=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(H.isApplicationScoped=(0,A.isApplicationScopedExtension)(this.manifest),H.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,H.isBuiltin=this.options.isBuiltin||x?.isBuiltin,H.installedTimestamp=Date.now(),H.pinned=this.options.installGivenVersion?!0:void 0,x)if(this._operation=3,F.equals(new i.ExtensionKey(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(b.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&f.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const G=await this.unsetIfUninstalled(F);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(b.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:w.resolve(this.location.fsPath),key:F,metadata:H},B),H]}async getMetadata(B,F,U){try{let[x]=await this.galleryService.getExtensions([{id:B,version:F}],U);if(x||([x]=await this.galleryService.getExtensions([{id:B}],U)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class re extends o.AbstractExtensionTask{constructor(B,F,U){super(),this.extension=B,this.profileLocation=F,this.extensionsProfileScannerService=U}async doRun(B){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(se[294],oe([0,1,2,29,79,242,129,9,21]),function(ee,e,L,_,c,R,D,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends L.Disposable{constructor(w,m,d,f,y,h){super(),w.cleanUp(),(0,R.migrateUnsupportedExtensions)(w,m,d,f,h),c.ExtensionStorageService.removeOutdatedExtensionVersions(w,y)}};S=pe([Y(0,D.INativeServerExtensionManagementService),Y(1,_.IExtensionGalleryService),Y(2,c.IExtensionStorageService),Y(3,_.IGlobalExtensionEnablementService),Y(4,C.IStorageService),Y(5,I.ILogService)],S),e.ExtensionsContributions=S}),define(se[303],oe([0,1,34,39,7,2,22,25,11,37,155,219,220,212,213,291,201,204,17,225,99,240,100,232,15,237,121,277,29,101,203,129,102,14,215,216,55,5,210,70,72,245,9,107,108,26,59,21,113,20,114,115,116,47,248,118,257,79,119,23,77,282,268,269,80,283,286,287,288,61,271,112,239,76,259,229,258,111,30,260,4,261,205,223,222,78,276,18,51,218,58,280,247,272,110,285,294,8,217,270,87,153,278,199,211,71,57,279,254,289,281,236,234,241,106,274]),function(ee,e,L,_,c,R,D,I,C,S,P,w,m,d,f,y,h,u,g,v,b,k,n,o,t,i,r,a,s,l,p,E,T,A,N,W,V,K,z,O,$,Z,q,j,M,J,Q,re,ae,B,F,U,x,H,te,G,X,ie,le,he,me,ve,we,Ce,Re,ke,ze,Ye,ce,de,fe,Pe,Ie,Ne,Le,Fe,Me,Oe,$e,ne,ue,ge,ye,Se,be,De,_e,Ae,Ue,xe,We,et,rt,Rt,St,kt,Lt,yt,_t,Tt,Xe,At,Ot,Ut,Mt,Nt,Ft,xt,wt,$t,Wt,zt,qt,jt,Et,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Bt extends R.Disposable{constructor(Ee,Te){super(),this.configuration=Ee,this.ipcRenderer=Te,this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,(0,Xe.isUtilityProcess)(process)?this.server=this._register(new P.Server):this.server=this._register(new At.Server),this.registerListeners()}registerListeners(){const Ee=async()=>{this.lifecycleService?.fireOnWillShutdown(),this.dispose()};if(process.once("exit",Ee),(0,Xe.isUtilityProcess)(process)?(0,P.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Ee):this.ipcRenderer.once("vscode:electron-main->shared-process=exit",Ee),!(0,Xe.isUtilityProcess)(process)){const Te="vscode:electron-main->shared-process=disposeWorker",qe=(je,tt)=>{this.onDisposeWorker(tt)};this.ipcRenderer.on(Te,qe),this._register((0,R.toDisposable)(()=>this.ipcRenderer.removeListener(Te,qe)))}}onDisposeWorker(Ee){this.sharedProcessWorkerService?.disposeWorker(Ee)}async init(){const Ee=await this.initServices();(0,he.registerConfiguration)(),Ee.invokeFunction(Te=>{const qe=Te.get(q.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Te),this.registerErrorHandler(qe)}),this._register((0,R.combinedDisposable)(Ee.createInstance(w.CodeCacheCleaner,this.configuration.codeCachePath),Ee.createInstance(m.LanguagePackCachedDataCleaner),Ee.createInstance(y.UnusedWorkspaceStorageDataCleaner),Ee.createInstance(f.LogsDataCleaner),Ee.createInstance(d.LocalizationsUpdater),Ee.createInstance(Lt.ExtensionsContributions),Ee.createInstance(Rt.UserDataProfilesCleaner)))}async initServices(){const Ee=new O.ServiceCollection,Te={_serviceBrand:void 0,...M.default};Ee.set(J.IProductService,Te);const qe=new S.StaticRouter(Ge=>Ge==="main"),je=new Mt.MessagePortMainProcessService(this.server,qe);Ee.set(Nt.IMainProcessService,je);const tt=this.configuration.policiesData?new xe.PolicyChannelClient(this.configuration.policiesData,je.getChannel("policy")):new We.NullPolicyService;Ee.set(We.IPolicyService,tt);const He=new i.SharedProcessEnvironmentService(this.configuration.args,Te);Ee.set(t.INativeEnvironmentService,He);const Ze=new j.LoggerChannelClient(void 0,this.configuration.logLevel,this.configuration.loggers.map(Ge=>({...Ge,resource:C.URI.revive(Ge.resource)})),je.getChannel("logger"));Ee.set(q.ILoggerService,Ze);const ct=this._register(Ze.createLogger((0,I.joinPath)(C.URI.file(He.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,yt.localize)(0,null)})),ht=this._register(new q.ConsoleLogger(ct.getLevel())),Ve=this._register(new _t.LogService(ct,[ht]));Ee.set(q.ILogService,Ve),this.lifecycleService=this._register(new Et.SharedProcessLifecycleService(Ve)),Ee.set(Et.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new zt.SharedProcessWorkerService(Ve),Ee.set(Oe.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new N.FileService(Ve));Ee.set(A.IFileService,Qe);const dt=this._register(new W.DiskFileSystemProvider(Ve));Qe.registerProvider(D.Schemas.file,dt);const ft=this._register(new ge.FileUserDataProvider(D.Schemas.file,this._register(new ye.DiskFileSystemProviderClient(je.getChannel(ye.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ue.isLinux})),D.Schemas.vscodeUserData,Ve));Qe.registerProvider(D.Schemas.vscodeUserData,ft);const it=this._register(new et.UserDataProfilesService(this.configuration.profiles.all,C.URI.revive(this.configuration.profiles.home).with({scheme:He.userRoamingDataHome.scheme}),je.getChannel("userDataProfiles")));Ee.set(Ae.IUserDataProfilesService,it);const Ke=this._register(new v.ConfigurationService(it.defaultProfile.settingsResource,Qe,tt,Ve));Ee.set(g.IConfigurationService,Ke);const st=new xt.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},je,He);Ee.set(re.IStorageService,st),this._register((0,R.toDisposable)(()=>st.flush())),await Promise.all([Ke.initialize(),st.initialize()]);const gt=new ne.UriIdentityService(Qe);Ee.set($e.IUriIdentityService,gt),Ee.set(Q.IRequestService,new qt.SharedProcessRequestService(je,Ke,Ve)),Ee.set(h.IChecksumService,new V.SyncDescriptor(u.ChecksumService,void 0,!1)),Ee.set(be.IV8InspectProfilingService,new V.SyncDescriptor(Se.InspectProfilingService,void 0,!1));const lt=S.ProxyChannel.toService(je.getChannel("nativeHost"),{context:this.configuration.windowId});Ee.set(Ft.INativeHostService,lt),Ee.set(n.IDownloadService,new V.SyncDescriptor(o.DownloadService,void 0,!0));const mt=this._register(new fe.ActiveWindowManager(lt)),Ht=new S.StaticRouter(Ge=>mt.getActiveClientId().then(vt=>Ge===vt));Ee.set(T.IExtensionRecommendationNotificationService,new Ut.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ht)));let ut;const ot=[],Ct=(0,H.isInternalTelemetry)(Te,Ke);if((0,H.supportsTelemetry)(Te,He)){const Ge=new U.TelemetryLogAppender(Ve,Ze,He,Te);ot.push(Ge);const{installSourcePath:vt}=He;if(Te.aiConfig?.ariaKey){const It=new rt.OneDataSystemAppender(Ct,"monacoworkbench",null,Te.aiConfig.ariaKey);this._register((0,R.toDisposable)(()=>It.flush())),ot.push(It)}ut=new x.TelemetryService({appenders:ot,commonProperties:(0,ae.resolveCommonProperties)(Qe,(0,L.release)(),(0,L.hostname)(),process.arch,Te.commit,Te.version,this.configuration.machineId,Ct,vt),sendErrorTelemetry:!0,piiPaths:(0,H.getPiiPathsFromEnvironment)(He)},Ke,Te)}else{ut=H.NullTelemetryService;const Ge=H.NullAppender;ot.push(Ge)}this.server.registerChannel("telemetryAppender",new F.TelemetryAppenderChannel(ot)),Ee.set(B.ITelemetryService,ut);const Gt=new te.CustomEndpointTelemetryService(Ke,ut,Ve,Ze,He,Te);Ee.set(B.ICustomEndpointTelemetryService,Gt),Ee.set(Ue.IExtensionsProfileScannerService,new V.SyncDescriptor(Vt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(De.IExtensionsScannerService,new V.SyncDescriptor(_e.ExtensionsScannerService,void 0,!0)),Ee.set(l.IExtensionSignatureVerificationService,new V.SyncDescriptor(l.ExtensionSignatureVerificationService,void 0,!0)),Ee.set(E.INativeServerExtensionManagementService,new V.SyncDescriptor(E.ExtensionManagementService,void 0,!0)),Ee.set(s.IExtensionGalleryService,new V.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),Ee.set(s.IExtensionTipsService,new V.SyncDescriptor(Ot.ExtensionTipsService,void 0,!1)),Ee.set($.ILanguagePackService,new V.SyncDescriptor(Z.NativeLanguagePackService,void 0,!1)),Ee.set(b.IDiagnosticsService,new V.SyncDescriptor(k.DiagnosticsService,void 0,!1)),Ee.set(me.IUserDataSyncAccountService,new V.SyncDescriptor(me.UserDataSyncAccountService,void 0,!0)),Ee.set(he.IUserDataSyncLogService,new V.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),Ee.set(he.IUserDataSyncUtilService,new we.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),Ee.set(s.IGlobalExtensionEnablementService,new V.SyncDescriptor(r.GlobalExtensionEnablementService,void 0,!1)),Ee.set(le.IIgnoredExtensionsManagementService,new V.SyncDescriptor(le.IgnoredExtensionsManagementService,void 0,!0)),Ee.set(ie.IExtensionStorageService,new V.SyncDescriptor(ie.ExtensionStorageService)),Ee.set(he.IUserDataSyncStoreManagementService,new V.SyncDescriptor(ce.UserDataSyncStoreManagementService,void 0,!0)),Ee.set(he.IUserDataSyncStoreService,new V.SyncDescriptor(ce.UserDataSyncStoreService,void 0,!0)),Ee.set(Re.IUserDataSyncMachinesService,new V.SyncDescriptor(Re.UserDataSyncMachinesService,void 0,!0)),Ee.set(he.IUserDataSyncBackupStoreService,new V.SyncDescriptor(ve.UserDataSyncBackupStoreService,void 0,!1)),Ee.set(he.IUserDataSyncEnablementService,new V.SyncDescriptor(ke.UserDataSyncEnablementService,void 0,!0)),Ee.set(he.IUserDataSyncService,new V.SyncDescriptor(ze.UserDataSyncService,void 0,!1)),Ee.set(de.IUserDataProfileStorageService,new V.SyncDescriptor(Wt.UserDataProfileStorageService,void 0,!0)),Ee.set(he.IUserDataSyncResourceProviderService,new V.SyncDescriptor(kt.UserDataSyncResourceProviderService,void 0,!0));const Pt=new X.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,yt.localize)(1,null),Ke,He,Ve,Ze);return Pt.initialize(),Ee.set(wt.ILocalPtyService,this._register(Pt)),Ee.set(Pe.ISignService,new V.SyncDescriptor(Ie.SignService,void 0,!1)),Ee.set(Ne.ISharedTunnelsService,new V.SyncDescriptor(Le.SharedTunnelsService)),Ee.set(Fe.ISharedProcessTunnelService,new V.SyncDescriptor(Me.SharedProcessTunnelService)),Ee.set(St.IRemoteTunnelService,new V.SyncDescriptor(jt.RemoteTunnelService)),new z.InstantiationService(Ee)}initChannels(Ee){const Te=new p.ExtensionManagementChannel(Ee.get(s.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Te);const qe=S.ProxyChannel.fromService(Ee.get($.ILanguagePackService));this.server.registerChannel("languagePacks",qe);const je=S.ProxyChannel.fromService(Ee.get(b.IDiagnosticsService));this.server.registerChannel("diagnostics",je);const tt=new p.ExtensionTipsChannel(Ee.get(s.IExtensionTipsService));this.server.registerChannel("extensionTipsService",tt);const He=S.ProxyChannel.fromService(Ee.get(h.IChecksumService));this.server.registerChannel("checksum",He);const Ze=S.ProxyChannel.fromService(Ee.get(be.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Ze);const ct=new we.UserDataSyncMachinesServiceChannel(Ee.get(Re.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const ht=S.ProxyChannel.fromService(Ee.get(B.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ht);const Ve=new we.UserDataSyncAccountServiceChannel(Ee.get(me.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const Qe=new we.UserDataSyncStoreManagementServiceChannel(Ee.get(he.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const dt=new Ye.UserDataSyncChannel(Ee.get(he.IUserDataSyncService),Ee.get(Ae.IUserDataProfilesService),Ee.get(q.ILogService));this.server.registerChannel("userDataSync",dt);const ft=this._register(Ee.get(K.IInstantiationService).createInstance($t.UserDataAutoSyncService)),it=new we.UserDataAutoSyncChannel(ft);this.server.registerChannel("userDataAutoSync",it);const Ke=Ee.get(wt.ILocalPtyService),st=S.ProxyChannel.fromService(Ke);this.server.registerChannel(G.TerminalIpcChannels.LocalPty,st);const gt=S.ProxyChannel.fromService(Ee.get(Fe.ISharedProcessTunnelService));this.server.registerChannel(Fe.ipcSharedProcessTunnelChannelName,gt);const lt=S.ProxyChannel.fromService(Ee.get(Oe.ISharedProcessWorkerService));this.server.registerChannel(Tt.ipcUtilityProcessWorkerChannelName,lt);const mt=S.ProxyChannel.fromService(Ee.get(St.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",mt)}registerErrorHandler(Ee){(0,Xe.isUtilityProcess)(process)?(process.on("uncaughtException",Te=>(0,c.onUnexpectedError)(Te)),process.on("unhandledRejection",Te=>(0,c.onUnexpectedError)(Te))):globalThis.addEventListener("unhandledrejection",Te=>{(0,c.onUnexpectedError)(Te.reason),Te.preventDefault()}),(0,c.setUnexpectedErrorHandler)(Te=>{const qe=(0,_.toErrorMessage)(Te,!0);!qe||Ee.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function bt(at){let Ee;(0,Xe.isUtilityProcess)(process)||(Ee=(await new Promise((qe,je)=>{ee(["electron"],qe,je)})).ipcRenderer);const Te=new Bt(at,Ee);(0,Xe.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):Ee.send("vscode:shared-process->electron-main=ipc-ready"),await Te.init(),(0,Xe.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):Ee.send("vscode:shared-process->electron-main=init-done")}e.main=bt,(0,Xe.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{bt(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/22a808587994126e19125c6a1a03c00b990223f4/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
