/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/process","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","path","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(re){for(var e=[],o=0,R=re.length;o<R;o++)e[o]=Se[re[o]];return e};define(Se[61],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(w,P){const S=Object.create(null);for(const C of w){const L=P(C);let k=S[L];k||(k=S[L]=[]),k.push(C)}return S}e.groupBy=o;function R(w,P){const S=[],C=[];for(const L of w)P.has(L)||S.push(L);for(const L of P)w.has(L)||C.push(L);return{removed:S,added:C}}e.diffSets=R;function l(w,P){const S=[],C=[];for(const[L,k]of w)P.has(L)||S.push(k);for(const[L,k]of P)w.has(L)||C.push(k);return{removed:S,added:C}}e.diffMaps=l;class A{constructor(){this.map=new Map}add(P,S){let C=this.map.get(P);C||(C=new Set,this.map.set(P,C)),C.add(S)}delete(P,S){const C=this.map.get(P);!C||(C.delete(S),C.size===0&&this.map.delete(P))}forEach(P,S){const C=this.map.get(P);!C||C.forEach(S)}}e.SetMap=A}),define(Se[62],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(w){return(P,S,C)=>{let L=null,k=null;if(typeof C.value=="function"?(L="value",k=C.value):typeof C.get=="function"&&(L="get",k=C.get),!k)throw new Error("not supported");C[L]=w(k,S)}}function R(w,P,S){let C=null,L=null;if(typeof S.value=="function"?(C="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",L=S.get),!L)throw new Error("not supported");const k=`$memoize$${P}`;S[C]=function(...b){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,b)}),this[k]}}e.memoize=R;function l(w,P,S){return o((C,L)=>{const k=`$debounce$${L}`,b=`$debounce$result$${L}`;return function(...I){this[b]||(this[b]=S?S():void 0),clearTimeout(this[k]),P&&(this[b]=P(this[b],...I),I=[this[b]]),this[k]=setTimeout(()=>{C.apply(this,I),this[b]=S?S():void 0},w)}})}e.debounce=l;function A(w,P,S){return o((C,L)=>{const k=`$throttle$timer$${L}`,b=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,y=`$throttle$pending$${L}`;return function(...f){if(this[b]||(this[b]=S?S():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...f)),this[y])return;const d=this[I]+w;d<=Date.now()?(this[I]=Date.now(),C.apply(this,[this[b]]),this[b]=S?S():void 0):(this[y]=!0,this[k]=setTimeout(()=>{this[y]=!1,this[I]=Date.now(),C.apply(this,[this[b]]),this[b]=S?S():void 0},d-Date.now()))}})}e.throttle=A}),define(Se[10],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?D.isErrorNoTelemetry(s)?new D(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=o,e.errorHandler=new o;function R(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=R;function l(n){if(!n||typeof n!="object")return!1;const s=n;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function A(n){C(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=A;function w(n){C(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=w;function P(n){if(n instanceof Error){const{name:s,message:r}=n,a=n.stacktrace||n.stack;return{$isError:!0,name:s,message:r,stack:a,noTelemetry:D.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=P;const S="Canceled";function C(n){return n instanceof L?!0:n instanceof Error&&n.name===S&&n.message===S}e.isCancellationError=C;class L extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=L;function k(){const n=new Error(S);return n.name=n.message,n}e.canceled=k;function b(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=b;function I(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=I;function y(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function f(n){const s=new Error(`${n} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function d(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=d;class u extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=u;class m extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class D extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof D)return s;const r=new D;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class p extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(Se[16],ye([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(ae,le=0){return ae[ae.length-(1+le)]}e.tail=R;function l(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}e.tail2=l;function A(ae,le,ue=(ne,ce)=>ne===ce){if(ae===le)return!0;if(!ae||!le||ae.length!==le.length)return!1;for(let ne=0,ce=ae.length;ne<ce;ne++)if(!ue(ae[ne],le[ne]))return!1;return!0}e.equals=A;function w(ae,le){const ue=ae.length-1;le<ue&&(ae[le]=ae[ue]),ae.pop()}e.removeFastWithoutKeepingOrder=w;function P(ae,le,ue){return S(ae.length,ne=>ue(ae[ne],le))}e.binarySearch=P;function S(ae,le){let ue=0,ne=ae-1;for(;ue<=ne;){const ce=(ue+ne)/2|0,oe=le(ce);if(oe<0)ue=ce+1;else if(oe>0)ne=ce-1;else return ce}return-(ue+1)}e.binarySearch2=S;function C(ae,le){let ue=0,ne=ae.length;if(ne===0)return 0;for(;ue<ne;){const ce=Math.floor((ue+ne)/2);le(ae[ce])?ne=ce:ue=ce+1}return ue}e.findFirstInSorted=C;function L(ae,le,ue){if(ae=ae|0,ae>=le.length)throw new TypeError("invalid index");const ne=le[Math.floor(le.length*Math.random())],ce=[],oe=[],M=[];for(const B of le){const q=ue(B,ne);q<0?ce.push(B):q>0?oe.push(B):M.push(B)}return ae<ce.length?L(ae,ce,ue):ae<ce.length+M.length?M[0]:L(ae-(ce.length+M.length),oe,ue)}e.quickSelect=L;function k(ae,le){const ue=[];let ne;for(const ce of ae.slice(0).sort(le))!ne||le(ne[0],ce)!==0?(ne=[ce],ue.push(ne)):ne.push(ce);return ue}e.groupBy=k;function b(ae,le,ue){const ne=[];function ce(B,q,te){if(q===0&&te.length===0)return;const de=ne[ne.length-1];de&&de.start+de.deleteCount===B?(de.deleteCount+=q,de.toInsert.push(...te)):ne.push({start:B,deleteCount:q,toInsert:te})}let oe=0,M=0;for(;;){if(oe===ae.length){ce(oe,0,le.slice(M));break}if(M===le.length){ce(oe,ae.length-oe,[]);break}const B=ae[oe],q=le[M],te=ue(B,q);te===0?(oe+=1,M+=1):te<0?(ce(oe,1,[]),oe+=1):te>0&&(ce(oe,0,[q]),M+=1)}return ne}e.sortedDiff=b;function I(ae,le,ue){const ne=b(ae,le,ue),ce=[],oe=[];for(const M of ne)ce.push(...ae.slice(M.start,M.start+M.deleteCount)),oe.push(...M.toInsert);return{removed:ce,added:oe}}e.delta=I;function y(ae,le,ue){if(ue===0)return[];const ne=ae.slice(0,ue).sort(le);return d(ae,le,ne,ue,ae.length),ne}e.top=y;function f(ae,le,ue,ne,ce){return ue===0?Promise.resolve([]):new Promise((oe,M)=>{(async()=>{const B=ae.length,q=ae.slice(0,ue).sort(le);for(let te=ue,de=Math.min(ue+ne,B);te<B;te=de,de=Math.min(de+ne,B)){if(te>ue&&await new Promise(Ee=>setTimeout(Ee)),ce&&ce.isCancellationRequested)throw new o.CancellationError;d(ae,le,q,te,de)}return q})().then(oe,M)})}e.topAsync=f;function d(ae,le,ue,ne,ce){for(const oe=ue.length;ne<ce;ne++){const M=ae[ne];if(le(M,ue[oe-1])<0){ue.pop();const B=C(ue,q=>le(M,q)<0);ue.splice(B,0,M)}}}function u(ae){return ae.filter(le=>!!le)}e.coalesce=u;function m(ae){let le=0;for(let ue=0;ue<ae.length;ue++)ae[ue]&&(ae[le]=ae[ue],le+=1);ae.length=le}e.coalesceInPlace=m;function v(ae,le,ue){ae.splice(ue,0,ae.splice(le,1)[0])}e.move=v;function D(ae){return!Array.isArray(ae)||ae.length===0}e.isFalsyOrEmpty=D;function p(ae){return Array.isArray(ae)&&ae.length>0}e.isNonEmptyArray=p;function n(ae,le=ue=>ue){const ue=new Set;return ae.filter(ne=>{const ce=le(ne);return ue.has(ce)?!1:(ue.add(ce),!0)})}e.distinct=n;function s(ae){const le=new Set;return ue=>{const ne=ae(ue);return le.has(ne)?!1:(le.add(ne),!0)}}e.uniqueFilter=s;function r(ae,le){const ue=a(ae,le);if(ue!==-1)return ae[ue]}e.findLast=r;function a(ae,le){for(let ue=ae.length-1;ue>=0;ue--){const ne=ae[ue];if(le(ne))return ue}return-1}e.lastIndex=a;function c(ae,le){return ae.length>0?ae[0]:le}e.firstOrDefault=c;function g(ae,le){return ae.length>0?ae[ae.length-1]:le}e.lastOrDefault=g;function i(ae,le,ue=(ne,ce)=>ne===ce){let ne=0;for(let ce=0,oe=Math.min(ae.length,le.length);ce<oe&&ue(ae[ce],le[ce]);ce++)ne++;return ne}e.commonPrefixLength=i;function t(ae){return[].concat(...ae)}e.flatten=t;function h(ae,le){let ue=typeof le=="number"?ae:0;typeof le=="number"?ue=ae:(ue=0,le=ae);const ne=[];if(ue<=le)for(let ce=ue;ce<le;ce++)ne.push(ce);else for(let ce=ue;ce>le;ce--)ne.push(ce);return ne}e.range=h;function _(ae,le,ue){return ae.reduce((ne,ce)=>(ne[le(ce)]=ue?ue(ce):ce,ne),Object.create(null))}e.index=_;function E(ae,le){return ae.push(le),()=>O(ae,le)}e.insert=E;function O(ae,le){const ue=ae.indexOf(le);if(ue>-1)return ae.splice(ue,1),le}e.remove=O;function $(ae,le,ue){const ne=ae.slice(0,le),ce=ae.slice(le);return ne.concat(ue,ce)}e.arrayInsert=$;function H(ae,le){let ue;if(typeof le=="number"){let ne=le;ue=()=>{const ce=Math.sin(ne++)*179426549;return ce-Math.floor(ce)}}else ue=Math.random;for(let ne=ae.length-1;ne>0;ne-=1){const ce=Math.floor(ue()*(ne+1)),oe=ae[ne];ae[ne]=ae[ce],ae[ce]=oe}}e.shuffle=H;function X(ae,le){const ue=ae.indexOf(le);ue>-1&&(ae.splice(ue,1),ae.unshift(le))}e.pushToStart=X;function V(ae,le){const ue=ae.indexOf(le);ue>-1&&(ae.splice(ue,1),ae.push(le))}e.pushToEnd=V;function N(ae,le){for(const ue of le)ae.push(ue)}e.pushMany=N;function T(ae,le){return Array.isArray(ae)?ae.map(le):le(ae)}e.mapArrayOrNot=T;function F(ae){return Array.isArray(ae)?ae:[ae]}e.asArray=F;function U(ae){return ae[Math.floor(Math.random()*ae.length)]}e.getRandomElement=U;function Z(ae,le){for(const ue of ae){const ne=le(ue);if(ne!==void 0)return ne}}e.mapFind=Z;function J(ae,le,ue){const ne=Q(ae,le),ce=ae.length,oe=ue.length;ae.length=ce+oe;for(let M=ce-1;M>=ne;M--)ae[M+oe]=ae[M];for(let M=0;M<oe;M++)ae[M+ne]=ue[M]}e.insertInto=J;function z(ae,le,ue,ne){const ce=Q(ae,le),oe=ae.splice(ce,ue);return J(ae,ce,ne),oe}e.splice=z;function Q(ae,le){return le<0?Math.max(le+ae.length,0):Math.min(le,ae.length)}var ie;(function(ae){function le(ce){return ce<0}ae.isLessThan=le;function ue(ce){return ce>0}ae.isGreaterThan=ue;function ne(ce){return ce===0}ae.isNeitherLessOrGreaterThan=ne,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function ge(ae,le){return(ue,ne)=>le(ae(ue),ae(ne))}e.compareBy=ge;function K(...ae){return(le,ue)=>{for(const ne of ae){const ce=ne(le,ue);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=K;const Y=(ae,le)=>ae-le;e.numberComparator=Y;function ee(ae,le){if(ae.length===0)return;let ue=ae[0];for(let ne=1;ne<ae.length;ne++){const ce=ae[ne];le(ce,ue)>0&&(ue=ce)}return ue}e.findMaxBy=ee;function me(ae,le){if(ae.length===0)return;let ue=ae[0];for(let ne=1;ne<ae.length;ne++){const ce=ae[ne];le(ce,ue)>=0&&(ue=ce)}return ue}e.findLastMaxBy=me;function be(ae,le){return ee(ae,(ue,ne)=>-le(ue,ne))}e.findMinBy=be;class De{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ue=this.firstIdx;for(;ue<this.items.length&&le(this.items[ue]);)ue++;const ne=ue===this.firstIdx?null:this.items.slice(this.firstIdx,ue);return this.firstIdx=ue,ne}takeFromEndWhile(le){let ue=this.lastIdx;for(;ue>=0&&le(this.items[ue]);)ue--;const ne=ue===this.lastIdx?null:this.items.slice(ue+1,this.lastIdx+1);return this.lastIdx=ue,ne}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const ue=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,ue}}e.ArrayQueue=De;class Ae{constructor(le){this.iterate=le}forEach(le){this.iterate(ue=>(le(ue),!0))}toArray(){const le=[];return this.iterate(ue=>(le.push(ue),!0)),le}filter(le){return new Ae(ue=>this.iterate(ne=>le(ne)?ue(ne):!0))}map(le){return new Ae(ue=>this.iterate(ne=>ue(le(ne))))}some(le){let ue=!1;return this.iterate(ne=>(ue=le(ne),!ue)),ue}findFirst(le){let ue;return this.iterate(ne=>le(ne)?(ue=ne,!1):!0),ue}findLast(le){let ue;return this.iterate(ne=>(le(ne)&&(ue=ne),!0)),ue}findLastMaxBy(le){let ue,ne=!0;return this.iterate(ce=>((ne||ie.isGreaterThan(le(ce,ue)))&&(ne=!1,ue=ce),!0)),ue}}Ae.empty=new Ae(ae=>{}),e.CallbackIterable=Ae}),define(Se[50],ye([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(S,C){if(!S)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=R;function l(S,C="Unreachable"){throw new Error(C)}e.assertNever=l;function A(S){if(!S)throw new o.BugIndicatingError("Assertion Failed")}e.assert=A;function w(S){if(!S()){debugger;S(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=w;function P(S,C){let L=0;for(;L<S.length-1;){const k=S[L],b=S[L+1];if(!C(k,b))return!1;L++}return!0}e.checkAdjacentItems=P}),define(Se[63],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(R){const l=this;let A=!1,w;return function(){return A||(A=!0,w=R.apply(l,arguments)),w}}e.once=o}),define(Se[101],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(l){this._prefix=l,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(Se[64],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(R){function l(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}R.is=l;const A=Object.freeze([]);function w(){return A}R.empty=w;function*P(D){yield D}R.single=P;function S(D){return l(D)?D:P(D)}R.wrap=S;function C(D){return D||A}R.from=C;function L(D){return!D||D[Symbol.iterator]().next().done===!0}R.isEmpty=L;function k(D){return D[Symbol.iterator]().next().value}R.first=k;function b(D,p){for(const n of D)if(p(n))return!0;return!1}R.some=b;function I(D,p){for(const n of D)if(p(n))return n}R.find=I;function*y(D,p){for(const n of D)p(n)&&(yield n)}R.filter=y;function*f(D,p){let n=0;for(const s of D)yield p(s,n++)}R.map=f;function*d(...D){for(const p of D)for(const n of p)yield n}R.concat=d;function u(D,p,n){let s=n;for(const r of D)s=p(s,r);return s}R.reduce=u;function*m(D,p,n=D.length){for(p<0&&(p+=D.length),n<0?n+=D.length:n>D.length&&(n=D.length);p<n;p++)yield D[p]}R.slice=m;function v(D,p=Number.POSITIVE_INFINITY){const n=[];if(p===0)return[n,D];const s=D[Symbol.iterator]();for(let r=0;r<p;r++){const a=s.next();if(a.done)return[n,R.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}R.consume=v})(o=e.Iterable||(e.Iterable={}))}),define(Se[146],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function w(n,s=!1){let r=0;const a=n.length;let c="",g=0,i=16,t=0;function h(V){let N=0,T=0;for(;N<V;){const F=n.charCodeAt(r);if(F>=48&&F<=57)T=T*16+F-48;else if(F>=65&&F<=70)T=T*16+F-65+10;else if(F>=97&&F<=102)T=T*16+F-97+10;else break;r++,N++}return N<V&&(T=-1),T}function _(V){r=V,c="",g=0,i=16,t=0}function E(){const V=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&C(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&C(n.charCodeAt(r)))for(r++;r<n.length&&C(n.charCodeAt(r));)r++;else return t=3,n.substring(V,r);let N=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&C(n.charCodeAt(r))){for(r++;r<n.length&&C(n.charCodeAt(r));)r++;N=r}else t=3;return n.substring(V,N)}function O(){let V="",N=r;for(;;){if(r>=a){V+=n.substring(N,r),t=2;break}const T=n.charCodeAt(r);if(T===34){V+=n.substring(N,r),r++;break}if(T===92){if(V+=n.substring(N,r),r++,r>=a){t=2;break}switch(n.charCodeAt(r++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const U=h(4);U>=0?V+=String.fromCharCode(U):t=4;break}default:t=5}N=r;continue}if(T>=0&&T<=31)if(S(T)){V+=n.substring(N,r),t=2;break}else t=6;r++}return V}function $(){if(c="",t=0,g=r,r>=a)return g=a,i=17;let V=n.charCodeAt(r);if(P(V)){do r++,c+=String.fromCharCode(V),V=n.charCodeAt(r);while(P(V));return i=15}if(S(V))return r++,c+=String.fromCharCode(V),V===13&&n.charCodeAt(r)===10&&(r++,c+=`
`),i=14;switch(V){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,c=O(),i=10;case 47:{const N=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<a&&!S(n.charCodeAt(r));)r++;return c=n.substring(N,r),i=12}if(n.charCodeAt(r+1)===42){r+=2;const T=a-1;let F=!1;for(;r<T;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,t=1),c=n.substring(N,r),i=13}return c+=String.fromCharCode(V),r++,i=16}case 45:if(c+=String.fromCharCode(V),r++,r===a||!C(n.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=E(),i=11;default:for(;r<a&&H(V);)r++,V=n.charCodeAt(r);if(g!==r){switch(c=n.substring(g,r),c){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return c+=String.fromCharCode(V),r++,i=16}}function H(V){if(P(V)||S(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let V;do V=$();while(V>=12&&V<=15);return V}return{setPosition:_,getPosition:()=>r,scan:s?X:$,getToken:()=>i,getTokenValue:()=>c,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>t}}e.createScanner=w;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function S(n){return n===10||n===13||n===8232||n===8233}function C(n){return n>=48&&n<=57}var L;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(L||(L={}));function k(n,s){const r=[],a=new Object;let c;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function t(h,_,E,O){g.value=h,g.offset=_,g.length=E,g.type=O,g.colonOffset=void 0,c=g}try{v(n,{onObjectBegin:(h,_)=>{if(s<=h)throw a;c=void 0,i=s>h,r.push("")},onObjectProperty:(h,_,E)=>{if(s<_||(t(h,_,E,"property"),r[r.length-1]=h,s<=_+E))throw a},onObjectEnd:(h,_)=>{if(s<=h)throw a;c=void 0,r.pop()},onArrayBegin:(h,_)=>{if(s<=h)throw a;c=void 0,r.push(0)},onArrayEnd:(h,_)=>{if(s<=h)throw a;c=void 0,r.pop()},onLiteralValue:(h,_,E)=>{if(s<_||(t(h,_,E,p(h)),s<=_+E))throw a},onSeparator:(h,_,E)=>{if(s<=_)throw a;if(h===":"&&c&&c.type==="property")c.colonOffset=_,i=!1,c=void 0;else if(h===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(i=!0,r[r.length-1]=""),c=void 0}}})}catch(h){if(h!==a)throw h}return{path:r,previousNode:c,isAtPropertyKey:i,matches:h=>{let _=0;for(let E=0;_<h.length&&E<r.length;E++)if(h[_]===r[E]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=k;function b(n,s=[],r=A.DEFAULT){let a=null,c=[];const g=[];function i(h){Array.isArray(c)?c.push(h):a!==null&&(c[a]=h)}return v(n,{onObjectBegin:()=>{const h={};i(h),g.push(c),c=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const h=[];i(h),g.push(c),c=h,a=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:i,onError:(h,_,E)=>{s.push({error:h,offset:_,length:E})}},r),c[0]}e.parse=b;function I(n,s=[],r=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function g(h){return a.children.push(h),h}v(n,{onObjectBegin:h=>{a=g({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,_,E)=>{a=g({type:"property",offset:_,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:_,length:E,parent:a})},onObjectEnd:(h,_)=>{a.length=h+_-a.offset,a=a.parent,c(h+_)},onArrayBegin:(h,_)=>{a=g({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,_)=>{a.length=h+_-a.offset,a=a.parent,c(h+_)},onLiteralValue:(h,_,E)=>{g({type:p(h),offset:_,length:E,parent:a,value:h}),c(_+E)},onSeparator:(h,_,E)=>{a.type==="property"&&(h===":"?a.colonOffset=_:h===","&&c(_))},onError:(h,_,E)=>{s.push({error:h,offset:_,length:E})}},r);const t=a.children[0];return t&&delete t.parent,t}e.parseTree=I;function y(n,s){if(!n)return;let r=n;for(const a of s)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===a){r=g.children[1],c=!0;break}if(!c)return}else{const c=a;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=y;function f(n){if(!n.parent||!n.parent.children)return[];const s=f(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;s.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&s.push(r)}return s}e.getNodePath=f;function d(n){switch(n.type){case"array":return n.children.map(d);case"object":{const s=Object.create(null);for(const r of n.children){const a=r.children[1];a&&(s[r.children[0].value]=d(a))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=d;function u(n,s,r=!1){return s>=n.offset&&s<n.offset+n.length||r&&s===n.offset+n.length}e.contains=u;function m(n,s,r=!1){if(u(n,s,r)){const a=n.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=s;c++){const g=m(a[c],s,r);if(g)return g}return n}}e.findNodeAtOffset=m;function v(n,s,r=A.DEFAULT){const a=w(n,!1);function c(ge){return ge?()=>ge(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(ge){return ge?K=>ge(K,a.getTokenOffset(),a.getTokenLength()):()=>!0}const i=c(s.onObjectBegin),t=g(s.onObjectProperty),h=c(s.onObjectEnd),_=c(s.onArrayBegin),E=c(s.onArrayEnd),O=g(s.onLiteralValue),$=g(s.onSeparator),H=c(s.onComment),X=g(s.onError),V=r&&r.disallowComments,N=r&&r.allowTrailingComma;function T(){for(;;){const ge=a.scan();switch(a.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:V||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(ge){case 12:case 13:V?F(10):H();break;case 16:F(1);break;case 15:case 14:break;default:return ge}}}function F(ge,K=[],Y=[]){if(X(ge),K.length+Y.length>0){let ee=a.getToken();for(;ee!==17;){if(K.indexOf(ee)!==-1){T();break}else if(Y.indexOf(ee)!==-1)break;ee=T()}}}function U(ge){const K=a.getTokenValue();return ge?O(K):t(K),T(),!0}function Z(){switch(a.getToken()){case 11:{let ge=0;try{ge=JSON.parse(a.getTokenValue()),typeof ge!="number"&&(F(2),ge=0)}catch{F(2)}O(ge);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return T(),!0}function J(){return a.getToken()!==10?(F(3,[],[2,5]),!1):(U(!1),a.getToken()===6?($(":"),T(),ie()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function z(){i(),T();let ge=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ge||F(4,[],[]),$(","),T(),a.getToken()===2&&N)break}else ge&&F(6,[],[]);J()||F(4,[],[2,5]),ge=!0}return h(),a.getToken()!==2?F(7,[2],[]):T(),!0}function Q(){_(),T();let ge=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ge||F(4,[],[]),$(","),T(),a.getToken()===4&&N)break}else ge&&F(6,[],[]);ie()||F(4,[],[4,5]),ge=!0}return E(),a.getToken()!==4?F(8,[4],[]):T(),!0}function ie(){switch(a.getToken()){case 3:return Q();case 1:return z();case 10:return U(!0);default:return Z()}}return T(),a.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):ie()?(a.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=v;function D(n,s){const r=w(n),a=[];let c,g=0,i;do switch(i=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:g!==i&&a.push(n.substring(g,i)),s!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,s)),g=r.getPosition();break}while(c!==17);return a.join("")}e.stripComments=D;function p(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Se[65],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(l){this.executor=l,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(l){this._error=l}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=o}),define(Se[6],ye([1,0,63,64]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let A=null;function w(g){A=g}if(e.setDisposableTracker=w,l){const g="__is_disposable_tracked__";w(new class{trackDisposable(i){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[g]||console.log(t)},3e3)}setParent(i,t){if(i&&i!==m.None)try{i[g]=!0}catch{}}markAsDisposed(i){if(i&&i!==m.None)try{i[g]=!0}catch{}}markAsSingleton(i){}})}function P(g){return A?.trackDisposable(g),g}function S(g){A?.markAsDisposed(g)}function C(g,i){A?.setParent(g,i)}function L(g,i){if(!!A)for(const t of g)A.setParent(t,i)}function k(g){return A?.markAsSingleton(g),g}e.markAsSingleton=k;function b(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=b;function I(g){if(R.Iterable.is(g)){const i=[];for(const t of g)if(t)try{t.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.dispose=I;function y(g){for(const i of g)b(i)&&i.dispose();return[]}e.disposeIfDisposable=y;function f(...g){const i=d(()=>I(g));return L(g,i),i}e.combinedDisposable=f;function d(g){const i=P({dispose:(0,o.once)(()=>{S(i),g()})});return i}e.toDisposable=d;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{I(this._toDispose)}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return C(i,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class m{constructor(){this._store=new u,P(this),C(this._store,this)}dispose(){S(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}m.None=Object.freeze({dispose(){}}),e.Disposable=m;class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&C(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&C(i,null),i}}e.MutableDisposable=v;class D{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=D;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(i){let t=i;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,S(this))},this}}e.SafeDisposable=p;class n{constructor(){this.references=new Map}acquire(i,...t){let h=this.references.get(i);h||(h={counter:0,object:this.createReferencedObject(i,...t)},this.references.set(i,h));const{object:_}=h,E=(0,o.once)(()=>{--h.counter===0&&(this.destroyReferencedObject(i,h.object),this.references.delete(i))});return h.counter++,{object:_,dispose:E}}}e.ReferenceCollection=n;class s{constructor(i){this.referenceCollection=i}async acquire(i,...t){const h=this.referenceCollection.acquire(i,...t);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(_){throw h.dispose(),_}}}e.AsyncReferenceCollection=s;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r;function a(g){const i=new u;try{g(i)}finally{i.dispose()}}e.disposeOnReturn=a;class c{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{I(this._store.values())}finally{this._store.clear()}}has(i){return this._store.has(i)}get(i){return this._store.get(i)}set(i,t,h=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this._store.get(i)?.dispose(),this._store.set(i,t)}deleteAndDispose(i){this._store.get(i)?.dispose(),this._store.delete(i)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=c}),define(Se[66],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(A){this.element=A,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class R{constructor(){this._first=o.Undefined,this._last=o.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===o.Undefined}clear(){let A=this._first;for(;A!==o.Undefined;){const w=A.next;A.prev=o.Undefined,A.next=o.Undefined,A=w}this._first=o.Undefined,this._last=o.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,w){const P=new o(A);if(this._first===o.Undefined)this._first=P,this._last=P;else if(w){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==o.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==o.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==o.Undefined&&A.next!==o.Undefined){const w=A.prev;w.next=A.next,A.next.prev=w}else A.prev===o.Undefined&&A.next===o.Undefined?(this._first=o.Undefined,this._last=o.Undefined):A.next===o.Undefined?(this._last=this._last.prev,this._last.next=o.Undefined):A.prev===o.Undefined&&(this._first=this._first.next,this._first.prev=o.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==o.Undefined;)yield A.element,A=A.next}}e.LinkedList=R}),define(Se[28],ye([1,0]),function(re,e){"use strict";var o,R,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(y,f,d){let u=y.get(f);return u===void 0&&(u=d,y.set(f,u)),u}e.getOrSet=A;function w(y){const f=[];return y.forEach((d,u)=>{f.push(`${u} => ${d}`)}),`Map(${y.size}) {${f.join(", ")}}`}e.mapToString=w;function P(y){const f=[];return y.forEach(d=>{f.push(d)}),`Set(${y.size}) {${f.join(", ")}}`}e.setToString=P;class S{constructor(f,d){this.uri=f,this.value=d}}class C{constructor(f,d){this[o]="ResourceMap",f instanceof C?(this.map=new Map(f.map),this.toKey=d??C.defaultToKey):(this.map=new Map,this.toKey=f??C.defaultToKey)}set(f,d){return this.map.set(this.toKey(f),new S(f,d)),this}get(f){return this.map.get(this.toKey(f))?.value}has(f){return this.map.has(this.toKey(f))}get size(){return this.map.size}clear(){this.map.clear()}delete(f){return this.map.delete(this.toKey(f))}forEach(f,d){typeof d<"u"&&(f=f.bind(d));for(const[u,m]of this.map)f(m.value,m.uri,this)}*values(){for(const f of this.map.values())yield f.value}*keys(){for(const f of this.map.values())yield f.uri}*entries(){for(const f of this.map.values())yield[f.uri,f.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.map)yield[f.uri,f.value]}}C.defaultToKey=y=>y.toString(),e.ResourceMap=C;class L{constructor(f,d){this[R]="ResourceSet",!f||typeof f=="function"?this._map=new C(f):(this._map=new C(d),f.forEach(this.add,this))}get size(){return this._map.size}add(f){return this._map.set(f,f),this}clear(){this._map.clear()}delete(f){return this._map.delete(f)}forEach(f,d){this._map.forEach((u,m)=>f.call(d,m,m,this))}has(f){return this._map.has(f)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var k;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class b{constructor(){this[l]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(f){return this._map.has(f)}get(f,d=0){const u=this._map.get(f);if(!!u)return d!==0&&this.touch(u,d),u.value}set(f,d,u=0){let m=this._map.get(f);if(m)m.value=d,u!==0&&this.touch(m,u);else{switch(m={key:f,value:d,next:void 0,previous:void 0},u){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(f,m),this._size++}return this}delete(f){return!!this.remove(f)}remove(f){const d=this._map.get(f);if(!!d)return this._map.delete(f),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const f=this._head;return this._map.delete(f.key),this.removeItem(f),this._size--,f.value}forEach(f,d){const u=this._state;let m=this._head;for(;m;){if(d?f.bind(d)(m.value,m.key,this):f(m.value,m.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const f=this,d=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(f._state!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.key,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return m}values(){const f=this,d=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(f._state!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.value,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return m}entries(){const f=this,d=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(f._state!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:[u.key,u.value],done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return m}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(f){if(f>=this.size)return;if(f===0){this.clear();return}let d=this._head,u=this.size;for(;d&&u>f;)this._map.delete(d.key),d=d.next,u--;this._head=d,this._size=u,d&&(d.previous=void 0),this._state++}addItemFirst(f){if(!this._head&&!this._tail)this._tail=f;else if(this._head)f.next=this._head,this._head.previous=f;else throw new Error("Invalid list");this._head=f,this._state++}addItemLast(f){if(!this._head&&!this._tail)this._head=f;else if(this._tail)f.previous=this._tail,this._tail.next=f;else throw new Error("Invalid list");this._tail=f,this._state++}removeItem(f){if(f===this._head&&f===this._tail)this._head=void 0,this._tail=void 0;else if(f===this._head){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this._head=f.next}else if(f===this._tail){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this._tail=f.previous}else{const d=f.next,u=f.previous;if(!d||!u)throw new Error("Invalid list");d.previous=u,u.next=d}f.next=void 0,f.previous=void 0,this._state++}touch(f,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(f===this._head)return;const u=f.next,m=f.previous;f===this._tail?(m.next=void 0,this._tail=m):(u.previous=m,m.next=u),f.previous=void 0,f.next=this._head,this._head.previous=f,this._head=f,this._state++}else if(d===2){if(f===this._tail)return;const u=f.next,m=f.previous;f===this._head?(u.previous=void 0,this._head=u):(u.previous=m,m.next=u),f.next=void 0,f.previous=this._tail,this._tail.next=f,this._tail=f,this._state++}}}toJSON(){const f=[];return this.forEach((d,u)=>{f.push([u,d])}),f}fromJSON(f){this.clear();for(const[d,u]of f)this.set(d,u)}}e.LinkedMap=b;class I extends b{constructor(f,d=1){super(),this._limit=f,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(f){this._limit=f,this.checkTrim()}get ratio(){return this._ratio}set ratio(f){this._ratio=Math.min(Math.max(0,f),1),this.checkTrim()}get(f,d=2){return super.get(f,d)}peek(f){return super.get(f,0)}set(f,d){return super.set(f,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=I}),function(re,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Se[147],ye([0]),e):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ae,le){for(var ue=0;ue<le.length;ue++){var ne=le[ue];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(ae,ne.key,ne)}}function o(ae,le,ue){return le&&e(ae.prototype,le),ue&&e(ae,ue),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function R(ae,le){if(!!ae){if(typeof ae=="string")return l(ae,le);var ue=Object.prototype.toString.call(ae).slice(8,-1);if(ue==="Object"&&ae.constructor&&(ue=ae.constructor.name),ue==="Map"||ue==="Set")return Array.from(ae);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return l(ae,le)}}function l(ae,le){(le==null||le>ae.length)&&(le=ae.length);for(var ue=0,ne=new Array(le);ue<le;ue++)ne[ue]=ae[ue];return ne}function A(ae,le){var ue=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(ue)return(ue=ue.call(ae)).next.bind(ue);if(Array.isArray(ae)||(ue=R(ae))||le&&ae&&typeof ae.length=="number"){ue&&(ae=ue);var ne=0;return function(){return ne>=ae.length?{done:!0}:{done:!1,value:ae[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=w();function P(ae){re.defaults=ae}var S=/[&<>"']/,C=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(le){return b[le]};function y(ae,le){if(le){if(S.test(ae))return ae.replace(C,I)}else if(L.test(ae))return ae.replace(k,I);return ae}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ae){return ae.replace(f,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var u=/(^|[^\[])\^/g;function m(ae,le){ae=typeof ae=="string"?ae:ae.source,le=le||"";var ue={replace:function(ce,oe){return oe=oe.source||oe,oe=oe.replace(u,"$1"),ae=ae.replace(ce,oe),ue},getRegex:function(){return new RegExp(ae,le)}};return ue}var v=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(ae,le,ue){if(ae){var ne;try{ne=decodeURIComponent(d(ue)).replace(v,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}le&&!D.test(ue)&&(ue=c(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var n={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ae,le){n[" "+ae]||(s.test(ae)?n[" "+ae]=ae+"/":n[" "+ae]=h(ae,"/",!0)),ae=n[" "+ae];var ue=ae.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:ae.replace(r,"$1")+le:le.charAt(0)==="/"?ue?le:ae.replace(a,"$1")+le:ae+le}var g={exec:function(){}};function i(ae){for(var le=1,ue,ne;le<arguments.length;le++){ue=arguments[le];for(ne in ue)Object.prototype.hasOwnProperty.call(ue,ne)&&(ae[ne]=ue[ne])}return ae}function t(ae,le){var ue=ae.replace(/\|/g,function(oe,M,B){for(var q=!1,te=M;--te>=0&&B[te]==="\\";)q=!q;return q?"|":" |"}),ne=ue.split(/ \|/),ce=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>le)ne.splice(le);else for(;ne.length<le;)ne.push("");for(;ce<ne.length;ce++)ne[ce]=ne[ce].trim().replace(/\\\|/g,"|");return ne}function h(ae,le,ue){var ne=ae.length;if(ne===0)return"";for(var ce=0;ce<ne;){var oe=ae.charAt(ne-ce-1);if(oe===le&&!ue)ce++;else if(oe!==le&&ue)ce++;else break}return ae.slice(0,ne-ce)}function _(ae,le){if(ae.indexOf(le[1])===-1)return-1;for(var ue=ae.length,ne=0,ce=0;ce<ue;ce++)if(ae[ce]==="\\")ce++;else if(ae[ce]===le[0])ne++;else if(ae[ce]===le[1]&&(ne--,ne<0))return ce;return-1}function E(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(ae,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=ae),le>>=1,ae+=ae;return ue+ae}function $(ae,le,ue,ne){var ce=le.href,oe=le.title?y(le.title):null,M=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){ne.state.inLink=!0;var B={type:"link",raw:ue,href:ce,title:oe,text:M,tokens:ne.inlineTokens(M)};return ne.state.inLink=!1,B}return{type:"image",raw:ue,href:ce,title:oe,text:y(M)}}function H(ae,le){var ue=ae.match(/^(\s+)(?:```)/);if(ue===null)return le;var ne=ue[1];return le.split(`
`).map(function(ce){var oe=ce.match(/^\s+/);if(oe===null)return ce;var M=oe[0];return M.length>=ne.length?ce.slice(ne.length):ce}).join(`
`)}var X=function(){function ae(ue){this.options=ue||re.defaults}var le=ae.prototype;return le.space=function(ne){var ce=this.rules.block.newline.exec(ne);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},le.code=function(ne){var ce=this.rules.block.code.exec(ne);if(ce){var oe=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:h(oe,`
`)}}},le.fences=function(ne){var ce=this.rules.block.fences.exec(ne);if(ce){var oe=ce[0],M=H(oe,ce[3]||"");return{type:"code",raw:oe,lang:ce[2]?ce[2].trim():ce[2],text:M}}},le.heading=function(ne){var ce=this.rules.block.heading.exec(ne);if(ce){var oe=ce[2].trim();if(/#$/.test(oe)){var M=h(oe,"#");(this.options.pedantic||!M||/ $/.test(M))&&(oe=M.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:oe,tokens:this.lexer.inline(oe)}}},le.hr=function(ne){var ce=this.rules.block.hr.exec(ne);if(ce)return{type:"hr",raw:ce[0]}},le.blockquote=function(ne){var ce=this.rules.block.blockquote.exec(ne);if(ce){var oe=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},le.list=function(ne){var ce=this.rules.block.list.exec(ne);if(ce){var oe,M,B,q,te,de,Ee,Te,ve,Ce,Ie,ze,qe=ce[1].trim(),nt=qe.length>1,Xe={type:"list",raw:"",ordered:nt,start:nt?+qe.slice(0,-1):"",loose:!1,items:[]};qe=nt?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=nt?qe:"[*+-]");for(var tt=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(ze=!1,!(!(ce=tt.exec(ne))||this.rules.block.hr.test(ne)));){if(oe=ce[0],ne=ne.substring(oe.length),Te=ce[2].split(`
`,1)[0],ve=ne.split(`
`,1)[0],this.options.pedantic?(q=2,Ie=Te.trimLeft()):(q=ce[2].search(/[^ ]/),q=q>4?1:q,Ie=Te.slice(q),q+=ce[1].length),de=!1,!Te&&/^ *$/.test(ve)&&(oe+=ve+`
`,ne=ne.substring(ve.length+1),ze=!0),!ze)for(var rt=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),x=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");ne&&(Ce=ne.split(`
`,1)[0],Te=Ce,this.options.pedantic&&(Te=Te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Te)||x.test(Te)||rt.test(Te)||Ue.test(ne)));){if(Te.search(/[^ ]/)>=q||!Te.trim())Ie+=`
`+Te.slice(q);else if(!de)Ie+=`
`+Te;else break;!de&&!Te.trim()&&(de=!0),oe+=Ce+`
`,ne=ne.substring(Ce.length+1)}Xe.loose||(Ee?Xe.loose=!0:/\n *\n *$/.test(oe)&&(Ee=!0)),this.options.gfm&&(M=/^\[[ xX]\] /.exec(Ie),M&&(B=M[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:oe,task:!!M,checked:B,loose:!1,text:Ie}),Xe.raw+=oe}Xe.items[Xe.items.length-1].raw=oe.trimRight(),Xe.items[Xe.items.length-1].text=Ie.trimRight(),Xe.raw=Xe.raw.trimRight();var G=Xe.items.length;for(te=0;te<G;te++){this.lexer.state.top=!1,Xe.items[te].tokens=this.lexer.blockTokens(Xe.items[te].text,[]);var he=Xe.items[te].tokens.filter(function(Oe){return Oe.type==="space"}),Re=he.every(function(Oe){for(var Ve=Oe.raw.split(""),$e=0,Ze=A(Ve),st;!(st=Ze()).done;){var at=st.value;if(at===`
`&&($e+=1),$e>1)return!0}return!1});!Xe.loose&&he.length&&Re&&(Xe.loose=!0,Xe.items[te].loose=!0)}return Xe}},le.html=function(ne){var ce=this.rules.block.html.exec(ne);if(ce){var oe={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var M=this.options.sanitizer?this.options.sanitizer(ce[0]):y(ce[0]);oe.type="paragraph",oe.text=M,oe.tokens=this.lexer.inline(M)}return oe}},le.def=function(ne){var ce=this.rules.block.def.exec(ne);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var oe=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:ce[0],href:ce[2],title:ce[3]}}},le.table=function(ne){var ce=this.rules.block.table.exec(ne);if(ce){var oe={type:"table",header:t(ce[1]).map(function(Ee){return{text:Ee}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=ce[0];var M=oe.align.length,B,q,te,de;for(B=0;B<M;B++)/^ *-+: *$/.test(oe.align[B])?oe.align[B]="right":/^ *:-+: *$/.test(oe.align[B])?oe.align[B]="center":/^ *:-+ *$/.test(oe.align[B])?oe.align[B]="left":oe.align[B]=null;for(M=oe.rows.length,B=0;B<M;B++)oe.rows[B]=t(oe.rows[B],oe.header.length).map(function(Ee){return{text:Ee}});for(M=oe.header.length,q=0;q<M;q++)oe.header[q].tokens=this.lexer.inline(oe.header[q].text);for(M=oe.rows.length,q=0;q<M;q++)for(de=oe.rows[q],te=0;te<de.length;te++)de[te].tokens=this.lexer.inline(de[te].text);return oe}}},le.lheading=function(ne){var ce=this.rules.block.lheading.exec(ne);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},le.paragraph=function(ne){var ce=this.rules.block.paragraph.exec(ne);if(ce){var oe=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:oe,tokens:this.lexer.inline(oe)}}},le.text=function(ne){var ce=this.rules.block.text.exec(ne);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},le.escape=function(ne){var ce=this.rules.inline.escape.exec(ne);if(ce)return{type:"escape",raw:ce[0],text:y(ce[1])}},le.tag=function(ne){var ce=this.rules.inline.tag.exec(ne);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):y(ce[0]):ce[0]}},le.link=function(ne){var ce=this.rules.inline.link.exec(ne);if(ce){var oe=ce[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var M=h(oe.slice(0,-1),"\\");if((oe.length-M.length)%2===0)return}else{var B=_(ce[2],"()");if(B>-1){var q=ce[0].indexOf("!")===0?5:4,te=q+ce[1].length+B;ce[2]=ce[2].substring(0,B),ce[0]=ce[0].substring(0,te).trim(),ce[3]=""}}var de=ce[2],Ee="";if(this.options.pedantic){var Te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Te&&(de=Te[1],Ee=Te[3])}else Ee=ce[3]?ce[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(oe)?de=de.slice(1):de=de.slice(1,-1)),$(ce,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},le.reflink=function(ne,ce){var oe;if((oe=this.rules.inline.reflink.exec(ne))||(oe=this.rules.inline.nolink.exec(ne))){var M=(oe[2]||oe[1]).replace(/\s+/g," ");if(M=ce[M.toLowerCase()],!M||!M.href){var B=oe[0].charAt(0);return{type:"text",raw:B,text:B}}return $(oe,M,oe[0],this.lexer)}},le.emStrong=function(ne,ce,oe){oe===void 0&&(oe="");var M=this.rules.inline.emStrong.lDelim.exec(ne);if(!!M&&!(M[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=M[1]||M[2]||"";if(!B||B&&(oe===""||this.rules.inline.punctuation.exec(oe))){var q=M[0].length-1,te,de,Ee=q,Te=0,ve=M[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ve.lastIndex=0,ce=ce.slice(-1*ne.length+q);(M=ve.exec(ce))!=null;)if(te=M[1]||M[2]||M[3]||M[4]||M[5]||M[6],!!te){if(de=te.length,M[3]||M[4]){Ee+=de;continue}else if((M[5]||M[6])&&q%3&&!((q+de)%3)){Te+=de;continue}if(Ee-=de,!(Ee>0)){if(de=Math.min(de,de+Ee+Te),Math.min(q,de)%2){var Ce=ne.slice(1,q+M.index+de);return{type:"em",raw:ne.slice(0,q+M.index+de+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var Ie=ne.slice(2,q+M.index+de-1);return{type:"strong",raw:ne.slice(0,q+M.index+de+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},le.codespan=function(ne){var ce=this.rules.inline.code.exec(ne);if(ce){var oe=ce[2].replace(/\n/g," "),M=/[^ ]/.test(oe),B=/^ /.test(oe)&&/ $/.test(oe);return M&&B&&(oe=oe.substring(1,oe.length-1)),oe=y(oe,!0),{type:"codespan",raw:ce[0],text:oe}}},le.br=function(ne){var ce=this.rules.inline.br.exec(ne);if(ce)return{type:"br",raw:ce[0]}},le.del=function(ne){var ce=this.rules.inline.del.exec(ne);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},le.autolink=function(ne,ce){var oe=this.rules.inline.autolink.exec(ne);if(oe){var M,B;return oe[2]==="@"?(M=y(this.options.mangle?ce(oe[1]):oe[1]),B="mailto:"+M):(M=y(oe[1]),B=M),{type:"link",raw:oe[0],text:M,href:B,tokens:[{type:"text",raw:M,text:M}]}}},le.url=function(ne,ce){var oe;if(oe=this.rules.inline.url.exec(ne)){var M,B;if(oe[2]==="@")M=y(this.options.mangle?ce(oe[0]):oe[0]),B="mailto:"+M;else{var q;do q=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(q!==oe[0]);M=y(oe[0]),oe[1]==="www."?B="http://"+M:B=M}return{type:"link",raw:oe[0],text:M,href:B,tokens:[{type:"text",raw:M,text:M}]}}},le.inlineText=function(ne,ce){var oe=this.rules.inline.text.exec(ne);if(oe){var M;return this.lexer.state.inRawBlock?M=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):y(oe[0]):oe[0]:M=y(this.options.smartypants?ce(oe[0]):oe[0]),{type:"text",raw:oe[0],text:M}}},ae}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=m(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=m(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=m(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=m(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=m(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=m(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=i({},V),V.gfm=i({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=m(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=m(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=i({},V.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:m(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=m(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=m(V._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=m(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=m(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=m(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=m(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=m(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=m(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=m(N.reflink).replace("label",N._label).replace("ref",V._label).getRegex(),N.nolink=m(N.nolink).replace("ref",V._label).getRegex(),N.reflinkSearch=m(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=i({},N),N.pedantic=i({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=i({},N.normal,{escape:m(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=m(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=i({},N.gfm,{br:m(N.br).replace("{2,}","*").getRegex(),text:m(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ae){var le="",ue,ne,ce=ae.length;for(ue=0;ue<ce;ue++)ne=ae.charCodeAt(ue),Math.random()>.5&&(ne="x"+ne.toString(16)),le+="&#"+ne+";";return le}var U=function(){function ae(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||re.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:V.normal,inline:N.normal};this.options.pedantic?(ne.block=V.pedantic,ne.inline=N.pedantic):this.options.gfm&&(ne.block=V.gfm,this.options.breaks?ne.inline=N.breaks:ne.inline=N.gfm),this.tokenizer.rules=ne}ae.lex=function(ne,ce){var oe=new ae(ce);return oe.lex(ne)},ae.lexInline=function(ne,ce){var oe=new ae(ce);return oe.inlineTokens(ne)};var le=ae.prototype;return le.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},le.blockTokens=function(ne,ce){var oe=this;ce===void 0&&(ce=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(Ee,Te,ve){return Te+"    ".repeat(ve.length)});for(var M,B,q,te;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(M=Ee.call({lexer:oe},ne,ce))?(ne=ne.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.space(ne)){ne=ne.substring(M.raw.length),M.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(M);continue}if(M=this.tokenizer.code(ne)){ne=ne.substring(M.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+M.raw,B.text+=`
`+M.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(M);continue}if(M=this.tokenizer.fences(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.heading(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.hr(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.blockquote(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.list(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.html(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.def(ne)){ne=ne.substring(M.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+M.raw,B.text+=`
`+M.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[M.tag]||(this.tokens.links[M.tag]={href:M.href,title:M.title});continue}if(M=this.tokenizer.table(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.lheading(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(q=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,Te=ne.slice(1),ve=void 0;oe.options.extensions.startBlock.forEach(function(Ce){ve=Ce.call({lexer:this},Te),typeof ve=="number"&&ve>=0&&(Ee=Math.min(Ee,ve))}),Ee<1/0&&Ee>=0&&(q=ne.substring(0,Ee+1))}(),this.state.top&&(M=this.tokenizer.paragraph(q))){B=ce[ce.length-1],te&&B.type==="paragraph"?(B.raw+=`
`+M.raw,B.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(M),te=q.length!==ne.length,ne=ne.substring(M.raw.length);continue}if(M=this.tokenizer.text(ne)){ne=ne.substring(M.raw.length),B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=`
`+M.raw,B.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(M);continue}if(ne){var de="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ce},le.inline=function(ne,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ne,tokens:ce}),ce},le.inlineTokens=function(ne,ce){var oe=this;ce===void 0&&(ce=[]);var M,B,q,te=ne,de,Ee,Te;if(this.tokens.links){var ve=Object.keys(this.tokens.links);if(ve.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)ve.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,de.index)+"["+O("a",de[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,de.index)+"["+O("a",de[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,de.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(Ee||(Te=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(M=Ie.call({lexer:oe},ne,ce))?(ne=ne.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.escape(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.tag(ne)){ne=ne.substring(M.raw.length),B=ce[ce.length-1],B&&M.type==="text"&&B.type==="text"?(B.raw+=M.raw,B.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.link(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(M.raw.length),B=ce[ce.length-1],B&&M.type==="text"&&B.type==="text"?(B.raw+=M.raw,B.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.emStrong(ne,te,Te)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.codespan(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.br(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.del(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.autolink(ne,F)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(!this.state.inLink&&(M=this.tokenizer.url(ne,F))){ne=ne.substring(M.raw.length),ce.push(M);continue}if(q=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,ze=ne.slice(1),qe=void 0;oe.options.extensions.startInline.forEach(function(nt){qe=nt.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(Ie=Math.min(Ie,qe))}),Ie<1/0&&Ie>=0&&(q=ne.substring(0,Ie+1))}(),M=this.tokenizer.inlineText(q,T)){ne=ne.substring(M.raw.length),M.raw.slice(-1)!=="_"&&(Te=M.raw.slice(-1)),Ee=!0,B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=M.raw,B.text+=M.text):ce.push(M);continue}if(ne){var Ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ce},o(ae,null,[{key:"rules",get:function(){return{block:V,inline:N}}}]),ae}(),Z=function(){function ae(ue){this.options=ue||re.defaults}var le=ae.prototype;return le.code=function(ne,ce,oe){var M=(ce||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(ne,M);B!=null&&B!==ne&&(oe=!0,ne=B)}return ne=ne.replace(/\n$/,"")+`
`,M?'<pre><code class="'+this.options.langPrefix+y(M,!0)+'">'+(oe?ne:y(ne,!0))+`</code></pre>
`:"<pre><code>"+(oe?ne:y(ne,!0))+`</code></pre>
`},le.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},le.html=function(ne){return ne},le.heading=function(ne,ce,oe,M){if(this.options.headerIds){var B=this.options.headerPrefix+M.slug(oe);return"<h"+ce+' id="'+B+'">'+ne+"</h"+ce+`>
`}return"<h"+ce+">"+ne+"</h"+ce+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(ne,ce,oe){var M=ce?"ol":"ul",B=ce&&oe!==1?' start="'+oe+'"':"";return"<"+M+B+`>
`+ne+"</"+M+`>
`},le.listitem=function(ne){return"<li>"+ne+`</li>
`},le.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(ne){return"<p>"+ne+`</p>
`},le.table=function(ne,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+ce+`</table>
`},le.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},le.tablecell=function(ne,ce){var oe=ce.header?"th":"td",M=ce.align?"<"+oe+' align="'+ce.align+'">':"<"+oe+">";return M+ne+("</"+oe+`>
`)},le.strong=function(ne){return"<strong>"+ne+"</strong>"},le.em=function(ne){return"<em>"+ne+"</em>"},le.codespan=function(ne){return"<code>"+ne+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(ne){return"<del>"+ne+"</del>"},le.link=function(ne,ce,oe){if(ne=p(this.options.sanitize,this.options.baseUrl,ne),ne===null)return oe;var M='<a href="'+y(ne)+'"';return ce&&(M+=' title="'+ce+'"'),M+=">"+oe+"</a>",M},le.image=function(ne,ce,oe){if(ne=p(this.options.sanitize,this.options.baseUrl,ne),ne===null)return oe;var M='<img src="'+ne+'" alt="'+oe+'"';return ce&&(M+=' title="'+ce+'"'),M+=this.options.xhtml?"/>":">",M},le.text=function(ne){return ne},ae}(),J=function(){function ae(){}var le=ae.prototype;return le.strong=function(ne){return ne},le.em=function(ne){return ne},le.codespan=function(ne){return ne},le.del=function(ne){return ne},le.html=function(ne){return ne},le.text=function(ne){return ne},le.link=function(ne,ce,oe){return""+oe},le.image=function(ne,ce,oe){return""+oe},le.br=function(){return""},ae}(),z=function(){function ae(){this.seen={}}var le=ae.prototype;return le.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(ne,ce){var oe=ne,M=0;if(this.seen.hasOwnProperty(oe)){M=this.seen[ne];do M++,oe=ne+"-"+M;while(this.seen.hasOwnProperty(oe))}return ce||(this.seen[ne]=M,this.seen[oe]=0),oe},le.slug=function(ne,ce){ce===void 0&&(ce={});var oe=this.serialize(ne);return this.getNextSafeSlug(oe,ce.dryrun)},ae}(),Q=function(){function ae(ue){this.options=ue||re.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new z}ae.parse=function(ne,ce){var oe=new ae(ce);return oe.parse(ne)},ae.parseInline=function(ne,ce){var oe=new ae(ce);return oe.parseInline(ne)};var le=ae.prototype;return le.parse=function(ne,ce){ce===void 0&&(ce=!0);var oe="",M,B,q,te,de,Ee,Te,ve,Ce,Ie,ze,qe,nt,Xe,tt,rt,Ue,it,x,G=ne.length;for(M=0;M<G;M++){if(Ie=ne[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(x=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){oe+=x||"";continue}switch(Ie.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,d(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(ve="",Te="",te=Ie.header.length,B=0;B<te;B++)Te+=this.renderer.tablecell(this.parseInline(Ie.header[B].tokens),{header:!0,align:Ie.align[B]});for(ve+=this.renderer.tablerow(Te),Ce="",te=Ie.rows.length,B=0;B<te;B++){for(Ee=Ie.rows[B],Te="",de=Ee.length,q=0;q<de;q++)Te+=this.renderer.tablecell(this.parseInline(Ee[q].tokens),{header:!1,align:Ie.align[q]});Ce+=this.renderer.tablerow(Te)}oe+=this.renderer.table(ve,Ce);continue}case"blockquote":{Ce=this.parse(Ie.tokens),oe+=this.renderer.blockquote(Ce);continue}case"list":{for(ze=Ie.ordered,qe=Ie.start,nt=Ie.loose,te=Ie.items.length,Ce="",B=0;B<te;B++)tt=Ie.items[B],rt=tt.checked,Ue=tt.task,Xe="",tt.task&&(it=this.renderer.checkbox(rt),nt?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Xe+=it),Xe+=this.parse(tt.tokens,nt),Ce+=this.renderer.listitem(Xe,Ue,rt);oe+=this.renderer.list(Ce,ze,qe);continue}case"html":{oe+=this.renderer.html(Ie.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(Ce=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;M+1<G&&ne[M+1].type==="text";)Ie=ne[++M],Ce+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);oe+=ce?this.renderer.paragraph(Ce):Ce;continue}default:{var he='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return oe},le.parseInline=function(ne,ce){ce=ce||this.renderer;var oe="",M,B,q,te=ne.length;for(M=0;M<te;M++){if(B=ne[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(q=this.options.extensions.renderers[B.type].call({parser:this},B),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){oe+=q||"";continue}switch(B.type){case"escape":{oe+=ce.text(B.text);break}case"html":{oe+=ce.html(B.text);break}case"link":{oe+=ce.link(B.href,B.title,this.parseInline(B.tokens,ce));break}case"image":{oe+=ce.image(B.href,B.title,B.text);break}case"strong":{oe+=ce.strong(this.parseInline(B.tokens,ce));break}case"em":{oe+=ce.em(this.parseInline(B.tokens,ce));break}case"codespan":{oe+=ce.codespan(B.text);break}case"br":{oe+=ce.br();break}case"del":{oe+=ce.del(this.parseInline(B.tokens,ce));break}case"text":{oe+=ce.text(B.text);break}default:{var de='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return oe},ae}();function ie(ae,le,ue){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=i({},ie.defaults,le||{}),E(le),ue){var ne=le.highlight,ce;try{ce=U.lex(ae,le)}catch(te){return ue(te)}var oe=function(de){var Ee;if(!de)try{le.walkTokens&&ie.walkTokens(ce,le.walkTokens),Ee=Q.parse(ce,le)}catch(Te){de=Te}return le.highlight=ne,de?ue(de):ue(null,Ee)};if(!ne||ne.length<3||(delete le.highlight,!ce.length))return oe();var M=0;ie.walkTokens(ce,function(te){te.type==="code"&&(M++,setTimeout(function(){ne(te.text,te.lang,function(de,Ee){if(de)return oe(de);Ee!=null&&Ee!==te.text&&(te.text=Ee,te.escaped=!0),M--,M===0&&oe()})},0))}),M===0&&oe();return}function B(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+y(te.message+"",!0)+"</pre>";throw te}try{var q=U.lex(ae,le);if(le.walkTokens){if(le.async)return Promise.all(ie.walkTokens(q,le.walkTokens)).then(function(){return Q.parse(q,le)}).catch(B);ie.walkTokens(q,le.walkTokens)}return Q.parse(q,le)}catch(te){B(te)}}ie.options=ie.setOptions=function(ae){return i(ie.defaults,ae),P(ie.defaults),ie},ie.getDefaults=w,ie.defaults=re.defaults,ie.use=function(){for(var ae=arguments.length,le=new Array(ae),ue=0;ue<ae;ue++)le[ue]=arguments[ue];var ne=i.apply(void 0,[{}].concat(le)),ce=ie.defaults.extensions||{renderers:{},childTokens:{}},oe;le.forEach(function(M){if(M.extensions&&(oe=!0,M.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var te=ce.renderers?ce.renderers[q.name]:null;te?ce.renderers[q.name]=function(){for(var de=arguments.length,Ee=new Array(de),Te=0;Te<de;Te++)Ee[Te]=arguments[Te];var ve=q.renderer.apply(this,Ee);return ve===!1&&(ve=te.apply(this,Ee)),ve}:ce.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[q.level]?ce[q.level].unshift(q.tokenizer):ce[q.level]=[q.tokenizer],q.start&&(q.level==="block"?ce.startBlock?ce.startBlock.push(q.start):ce.startBlock=[q.start]:q.level==="inline"&&(ce.startInline?ce.startInline.push(q.start):ce.startInline=[q.start]))}q.childTokens&&(ce.childTokens[q.name]=q.childTokens)})),M.renderer&&function(){var q=ie.defaults.renderer||new Z,te=function(Te){var ve=q[Te];q[Te]=function(){for(var Ce=arguments.length,Ie=new Array(Ce),ze=0;ze<Ce;ze++)Ie[ze]=arguments[ze];var qe=M.renderer[Te].apply(q,Ie);return qe===!1&&(qe=ve.apply(q,Ie)),qe}};for(var de in M.renderer)te(de);ne.renderer=q}(),M.tokenizer&&function(){var q=ie.defaults.tokenizer||new X,te=function(Te){var ve=q[Te];q[Te]=function(){for(var Ce=arguments.length,Ie=new Array(Ce),ze=0;ze<Ce;ze++)Ie[ze]=arguments[ze];var qe=M.tokenizer[Te].apply(q,Ie);return qe===!1&&(qe=ve.apply(q,Ie)),qe}};for(var de in M.tokenizer)te(de);ne.tokenizer=q}(),M.walkTokens){var B=ie.defaults.walkTokens;ne.walkTokens=function(q){var te=[];return te.push(M.walkTokens.call(this,q)),B&&(te=te.concat(B.call(this,q))),te}}oe&&(ne.extensions=ce),ie.setOptions(ne)})},ie.walkTokens=function(ae,le){for(var ue=[],ne=function(){var B=oe.value;switch(ue=ue.concat(le.call(ie,B)),B.type){case"table":{for(var q=A(B.header),te;!(te=q()).done;){var de=te.value;ue=ue.concat(ie.walkTokens(de.tokens,le))}for(var Ee=A(B.rows),Te;!(Te=Ee()).done;)for(var ve=Te.value,Ce=A(ve),Ie;!(Ie=Ce()).done;){var ze=Ie.value;ue=ue.concat(ie.walkTokens(ze.tokens,le))}break}case"list":{ue=ue.concat(ie.walkTokens(B.items,le));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[B.type]?ie.defaults.extensions.childTokens[B.type].forEach(function(qe){ue=ue.concat(ie.walkTokens(B[qe],le))}):B.tokens&&(ue=ue.concat(ie.walkTokens(B.tokens,le)))}},ce=A(ae),oe;!(oe=ce()).done;)ne();return ue},ie.parseInline=function(ae,le){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");le=i({},ie.defaults,le||{}),E(le);try{var ue=U.lexInline(ae,le);return le.walkTokens&&ie.walkTokens(ue,le.walkTokens),Q.parseInline(ue,le)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+y(ne.message+"",!0)+"</pre>";throw ne}},ie.Parser=Q,ie.parser=Q.parse,ie.Renderer=Z,ie.TextRenderer=J,ie.Lexer=U,ie.lexer=U.lex,ie.Tokenizer=X,ie.Slugger=z,ie.parse=ie;var ge=ie.options,K=ie.setOptions,Y=ie.use,ee=ie.walkTokens,me=ie.parseInline,be=ie,De=Q.parse,Ae=U.lex;re.Lexer=U,re.Parser=Q,re.Renderer=Z,re.Slugger=z,re.TextRenderer=J,re.Tokenizer=X,re.getDefaults=w,re.lexer=Ae,re.marked=ie,re.options=ge,re.parse=be,re.parseInline=me,re.parser=De,re.setOptions=K,re.use=Y,re.walkTokens=ee,Object.defineProperty(re,"__esModule",{value:!0})}),define(Se[87],ye([1,0,28]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new o.LRUCache(1e4);function l(C){return S(C,"NFC",R)}e.normalizeNFC=l;const A=new o.LRUCache(1e4);function w(C){return S(C,"NFD",A)}e.normalizeNFD=w;const P=/[^\u0000-\u0080]/;function S(C,L,k){if(!C)return C;const b=k.get(C);if(b)return b;let I;return P.test(C)?I=C.normalize(L):I=C,k.set(C,I),I}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(L){return w(L).replace(C,"")}}()}),define(Se[102],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(P,S,C){return Math.min(Math.max(P,S),C)}e.clamp=o;function R(P,S){return(S+P%S)%S}e.rot=R;class l{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=l;class A{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class w{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const C=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=C,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=w}),function(){function re(l){const A=[];typeof l=="number"&&A.push("code/timeOrigin",l);function w(S){A.push(S,Date.now())}function P(){const S=[];for(let C=0;C<A.length;C+=2)S.push({name:A[C],startTime:A[C+1]});return S}return{mark:w,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const w of performance.getEntriesByType("mark"))A.push({name:w.name,startTime:Math.round(l+w.startTime)});return A}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function o(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=o(R))}(),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var R in o)(typeof exports=="object"?exports:re)[R]=o[R]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function o(R){if(e[R])return e[R].exports;var l=e[R]={i:R,l:!1,exports:{}};return re[R].call(l.exports,l,l.exports,o),l.l=!0,l.exports}return o.m=re,o.c=e,o.d=function(R,l,A){o.o(R,l)||Object.defineProperty(R,l,{enumerable:!0,get:A})},o.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},o.t=function(R,l){if(1&l&&(R=o(R)),8&l||4&l&&typeof R=="object"&&R&&R.__esModule)return R;var A=Object.create(null);if(o.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:R}),2&l&&typeof R!="string")for(var w in R)o.d(A,w,function(P){return R[P]}.bind(null,w));return A},o.n=function(R){var l=R&&R.__esModule?function(){return R.default}:function(){return R};return o.d(l,"a",l),l},o.o=function(R,l){return Object.prototype.hasOwnProperty.call(R,l)},o.p="",o(o.s=0)}([function(re,e,o){(function(R){var l;e=re.exports=Y,l=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ve=Array.prototype.slice.call(arguments,0);ve.unshift("SEMVER"),console.log.apply(console,ve)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,w=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],C=0,L=C++;S[L]="0|[1-9]\\d*";var k=C++;S[k]="[0-9]+";var b=C++;S[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=C++;S[I]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var y=C++;S[y]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var f=C++;S[f]="(?:"+S[L]+"|"+S[b]+")";var d=C++;S[d]="(?:"+S[k]+"|"+S[b]+")";var u=C++;S[u]="(?:-("+S[f]+"(?:\\."+S[f]+")*))";var m=C++;S[m]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var v=C++;S[v]="[0-9A-Za-z-]+";var D=C++;S[D]="(?:\\+("+S[v]+"(?:\\."+S[v]+")*))";var p=C++,n="v?"+S[I]+S[u]+"?"+S[D]+"?";S[p]="^"+n+"$";var s="[v=\\s]*"+S[y]+S[m]+"?"+S[D]+"?",r=C++;S[r]="^"+s+"$";var a=C++;S[a]="((?:<|>)?=?)";var c=C++;S[c]=S[k]+"|x|X|\\*";var g=C++;S[g]=S[L]+"|x|X|\\*";var i=C++;S[i]="[v=\\s]*("+S[g]+")(?:\\.("+S[g]+")(?:\\.("+S[g]+")(?:"+S[u]+")?"+S[D]+"?)?)?";var t=C++;S[t]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[m]+")?"+S[D]+"?)?)?";var h=C++;S[h]="^"+S[a]+"\\s*"+S[i]+"$";var _=C++;S[_]="^"+S[a]+"\\s*"+S[t]+"$";var E=C++;S[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=C++;S[O]="(?:~>?)";var $=C++;S[$]="(\\s*)"+S[O]+"\\s+",P[$]=new RegExp(S[$],"g");var H=C++;S[H]="^"+S[O]+S[i]+"$";var X=C++;S[X]="^"+S[O]+S[t]+"$";var V=C++;S[V]="(?:\\^)";var N=C++;S[N]="(\\s*)"+S[V]+"\\s+",P[N]=new RegExp(S[N],"g");var T=C++;S[T]="^"+S[V]+S[i]+"$";var F=C++;S[F]="^"+S[V]+S[t]+"$";var U=C++;S[U]="^"+S[a]+"\\s*("+s+")$|^$";var Z=C++;S[Z]="^"+S[a]+"\\s*("+n+")$|^$";var J=C++;S[J]="(\\s*)"+S[a]+"\\s*("+s+"|"+S[i]+")",P[J]=new RegExp(S[J],"g");var z=C++;S[z]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var Q=C++;S[Q]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var ie=C++;S[ie]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)l(ge,S[ge]),P[ge]||(P[ge]=new RegExp(S[ge]));function K(ve,Ce){if(ve instanceof Y)return ve;if(typeof ve!="string"||ve.length>A||!(Ce?P[r]:P[p]).test(ve))return null;try{return new Y(ve,Ce)}catch{return null}}function Y(ve,Ce){if(ve instanceof Y){if(ve.loose===Ce)return ve;ve=ve.version}else if(typeof ve!="string")throw new TypeError("Invalid Version: "+ve);if(ve.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Y))return new Y(ve,Ce);l("SemVer",ve,Ce),this.loose=Ce;var Ie=ve.trim().match(Ce?P[r]:P[p]);if(!Ie)throw new TypeError("Invalid Version: "+ve);if(this.raw=ve,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>w||this.major<0)throw new TypeError("Invalid major version");if(this.minor>w||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>w||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var qe=+ze;if(qe>=0&&qe<w)return qe}return ze}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=K,e.valid=function(ve,Ce){var Ie=K(ve,Ce);return Ie?Ie.version:null},e.clean=function(ve,Ce){var Ie=K(ve.trim().replace(/^[=v]+/,""),Ce);return Ie?Ie.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ve){return l("SemVer.compare",this.version,this.loose,ve),ve instanceof Y||(ve=new Y(ve,this.loose)),this.compareMain(ve)||this.comparePre(ve)},Y.prototype.compareMain=function(ve){return ve instanceof Y||(ve=new Y(ve,this.loose)),me(this.major,ve.major)||me(this.minor,ve.minor)||me(this.patch,ve.patch)},Y.prototype.comparePre=function(ve){if(ve instanceof Y||(ve=new Y(ve,this.loose)),this.prerelease.length&&!ve.prerelease.length)return-1;if(!this.prerelease.length&&ve.prerelease.length)return 1;if(!this.prerelease.length&&!ve.prerelease.length)return 0;var Ce=0;do{var Ie=this.prerelease[Ce],ze=ve.prerelease[Ce];if(l("prerelease compare",Ce,Ie,ze),Ie===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==ze)return me(Ie,ze)}while(++Ce)},Y.prototype.inc=function(ve,Ce){switch(ve){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ve)}return this.format(),this.raw=this.version,this},e.inc=function(ve,Ce,Ie,ze){typeof Ie=="string"&&(ze=Ie,Ie=void 0);try{return new Y(ve,Ie).inc(Ce,ze).version}catch{return null}},e.diff=function(ve,Ce){if(ae(ve,Ce))return null;var Ie=K(ve),ze=K(Ce);if(Ie.prerelease.length||ze.prerelease.length){for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==ze[qe])return"pre"+qe;return"prerelease"}for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==ze[qe])return qe},e.compareIdentifiers=me;var ee=/^[0-9]+$/;function me(ve,Ce){var Ie=ee.test(ve),ze=ee.test(Ce);return Ie&&ze&&(ve=+ve,Ce=+Ce),Ie&&!ze?-1:ze&&!Ie?1:ve<Ce?-1:ve>Ce?1:0}function be(ve,Ce,Ie){return new Y(ve,Ie).compare(new Y(Ce,Ie))}function De(ve,Ce,Ie){return be(ve,Ce,Ie)>0}function Ae(ve,Ce,Ie){return be(ve,Ce,Ie)<0}function ae(ve,Ce,Ie){return be(ve,Ce,Ie)===0}function le(ve,Ce,Ie){return be(ve,Ce,Ie)!==0}function ue(ve,Ce,Ie){return be(ve,Ce,Ie)>=0}function ne(ve,Ce,Ie){return be(ve,Ce,Ie)<=0}function ce(ve,Ce,Ie,ze){var qe;switch(Ce){case"===":typeof ve=="object"&&(ve=ve.version),typeof Ie=="object"&&(Ie=Ie.version),qe=ve===Ie;break;case"!==":typeof ve=="object"&&(ve=ve.version),typeof Ie=="object"&&(Ie=Ie.version),qe=ve!==Ie;break;case"":case"=":case"==":qe=ae(ve,Ie,ze);break;case"!=":qe=le(ve,Ie,ze);break;case">":qe=De(ve,Ie,ze);break;case">=":qe=ue(ve,Ie,ze);break;case"<":qe=Ae(ve,Ie,ze);break;case"<=":qe=ne(ve,Ie,ze);break;default:throw new TypeError("Invalid operator: "+Ce)}return qe}function oe(ve,Ce){if(ve instanceof oe){if(ve.loose===Ce)return ve;ve=ve.value}if(!(this instanceof oe))return new oe(ve,Ce);l("comparator",ve,Ce),this.loose=Ce,this.parse(ve),this.semver===M?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ve,Ce){return me(Ce,ve)},e.major=function(ve,Ce){return new Y(ve,Ce).major},e.minor=function(ve,Ce){return new Y(ve,Ce).minor},e.patch=function(ve,Ce){return new Y(ve,Ce).patch},e.compare=be,e.compareLoose=function(ve,Ce){return be(ve,Ce,!0)},e.rcompare=function(ve,Ce,Ie){return be(Ce,ve,Ie)},e.sort=function(ve,Ce){return ve.sort(function(Ie,ze){return e.compare(Ie,ze,Ce)})},e.rsort=function(ve,Ce){return ve.sort(function(Ie,ze){return e.rcompare(Ie,ze,Ce)})},e.gt=De,e.lt=Ae,e.eq=ae,e.neq=le,e.gte=ue,e.lte=ne,e.cmp=ce,e.Comparator=oe;var M={};function B(ve,Ce){if(ve instanceof B)return ve.loose===Ce?ve:new B(ve.raw,Ce);if(ve instanceof oe)return new B(ve.value,Ce);if(!(this instanceof B))return new B(ve,Ce);if(this.loose=Ce,this.raw=ve,this.set=ve.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ve);this.format()}function q(ve){return!ve||ve.toLowerCase()==="x"||ve==="*"}function te(ve,Ce,Ie,ze,qe,nt,Xe,tt,rt,Ue,it,x,G){return((Ce=q(Ie)?"":q(ze)?">="+Ie+".0.0":q(qe)?">="+Ie+"."+ze+".0":">="+Ce)+" "+(tt=q(rt)?"":q(Ue)?"<"+(+rt+1)+".0.0":q(it)?"<"+rt+"."+(+Ue+1)+".0":x?"<="+rt+"."+Ue+"."+it+"-"+x:"<="+tt)).trim()}function de(ve,Ce){for(var Ie=0;Ie<ve.length;Ie++)if(!ve[Ie].test(Ce))return!1;if(Ce.prerelease.length){for(Ie=0;Ie<ve.length;Ie++)if(l(ve[Ie].semver),ve[Ie].semver!==M&&ve[Ie].semver.prerelease.length>0){var ze=ve[Ie].semver;if(ze.major===Ce.major&&ze.minor===Ce.minor&&ze.patch===Ce.patch)return!0}return!1}return!0}function Ee(ve,Ce,Ie){try{Ce=new B(Ce,Ie)}catch{return!1}return Ce.test(ve)}function Te(ve,Ce,Ie,ze){var qe,nt,Xe,tt,rt;switch(ve=new Y(ve,ze),Ce=new B(Ce,ze),Ie){case">":qe=De,nt=ne,Xe=Ae,tt=">",rt=">=";break;case"<":qe=Ae,nt=ue,Xe=De,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(ve,Ce,ze))return!1;for(var Ue=0;Ue<Ce.set.length;++Ue){var it=Ce.set[Ue],x=null,G=null;if(it.forEach(function(he){he.semver===M&&(he=new oe(">=0.0.0")),x=x||he,G=G||he,qe(he.semver,x.semver,ze)?x=he:Xe(he.semver,G.semver,ze)&&(G=he)}),x.operator===tt||x.operator===rt||(!G.operator||G.operator===tt)&&nt(ve,G.semver)||G.operator===rt&&Xe(ve,G.semver))return!1}return!0}oe.prototype.parse=function(ve){var Ce=this.loose?P[U]:P[Z],Ie=ve.match(Ce);if(!Ie)throw new TypeError("Invalid comparator: "+ve);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new Y(Ie[2],this.loose):this.semver=M},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(ve){return l("Comparator.test",ve,this.loose),this.semver===M||(typeof ve=="string"&&(ve=new Y(ve,this.loose)),ce(ve,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(ve,Ce){if(!(ve instanceof oe))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new B(ve.value,Ce),Ee(this.value,Ie,Ce);if(ve.operator==="")return Ie=new B(this.value,Ce),Ee(ve.semver,Ie,Ce);var ze=!(this.operator!==">="&&this.operator!==">"||ve.operator!==">="&&ve.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ve.operator!=="<="&&ve.operator!=="<"),nt=this.semver.version===ve.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ve.operator!==">="&&ve.operator!=="<="),tt=ce(this.semver,"<",ve.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ve.operator==="<="||ve.operator==="<"),rt=ce(this.semver,">",ve.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ve.operator===">="||ve.operator===">");return ze||qe||nt&&Xe||tt||rt},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(ve){return ve.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(ve){var Ce=this.loose;ve=ve.trim(),l("range",ve,Ce);var Ie=Ce?P[Q]:P[z];ve=ve.replace(Ie,te),l("hyphen replace",ve),ve=ve.replace(P[J],"$1$2$3"),l("comparator trim",ve,P[J]),ve=(ve=(ve=ve.replace(P[$],"$1~")).replace(P[N],"$1^")).split(/\s+/).join(" ");var ze=Ce?P[U]:P[Z],qe=ve.split(" ").map(function(nt){return function(Xe,tt){return l("comp",Xe),Xe=function(rt,Ue){return rt.trim().split(/\s+/).map(function(it){return function(x,G){l("caret",x,G);var he=G?P[F]:P[T];return x.replace(he,function(Re,Oe,Ve,$e,Ze){var st;return l("caret",x,Re,Oe,Ve,$e,Ze),q(Oe)?st="":q(Ve)?st=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":q($e)?st=Oe==="0"?">="+Oe+"."+Ve+".0 <"+Oe+"."+(+Ve+1)+".0":">="+Oe+"."+Ve+".0 <"+(+Oe+1)+".0.0":Ze?(l("replaceCaret pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=Oe==="0"?Ve==="0"?">="+Oe+"."+Ve+"."+$e+Ze+" <"+Oe+"."+Ve+"."+(+$e+1):">="+Oe+"."+Ve+"."+$e+Ze+" <"+Oe+"."+(+Ve+1)+".0":">="+Oe+"."+Ve+"."+$e+Ze+" <"+(+Oe+1)+".0.0"):(l("no pr"),st=Oe==="0"?Ve==="0"?">="+Oe+"."+Ve+"."+$e+" <"+Oe+"."+Ve+"."+(+$e+1):">="+Oe+"."+Ve+"."+$e+" <"+Oe+"."+(+Ve+1)+".0":">="+Oe+"."+Ve+"."+$e+" <"+(+Oe+1)+".0.0"),l("caret return",st),st})}(it,Ue)}).join(" ")}(Xe,tt),l("caret",Xe),Xe=function(rt,Ue){return rt.trim().split(/\s+/).map(function(it){return function(x,G){var he=G?P[X]:P[H];return x.replace(he,function(Re,Oe,Ve,$e,Ze){var st;return l("tilde",x,Re,Oe,Ve,$e,Ze),q(Oe)?st="":q(Ve)?st=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":q($e)?st=">="+Oe+"."+Ve+".0 <"+Oe+"."+(+Ve+1)+".0":Ze?(l("replaceTilde pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=">="+Oe+"."+Ve+"."+$e+Ze+" <"+Oe+"."+(+Ve+1)+".0"):st=">="+Oe+"."+Ve+"."+$e+" <"+Oe+"."+(+Ve+1)+".0",l("tilde return",st),st})}(it,Ue)}).join(" ")}(Xe,tt),l("tildes",Xe),Xe=function(rt,Ue){return l("replaceXRanges",rt,Ue),rt.split(/\s+/).map(function(it){return function(x,G){x=x.trim();var he=G?P[_]:P[h];return x.replace(he,function(Re,Oe,Ve,$e,Ze,st){l("xRange",x,Re,Oe,Ve,$e,Ze,st);var at=q(Ve),mt=at||q($e),gt=mt||q(Ze);return Oe==="="&&gt&&(Oe=""),at?Re=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&gt?(mt&&($e=0),gt&&(Ze=0),Oe===">"?(Oe=">=",mt?(Ve=+Ve+1,$e=0,Ze=0):gt&&($e=+$e+1,Ze=0)):Oe==="<="&&(Oe="<",mt?Ve=+Ve+1:$e=+$e+1),Re=Oe+Ve+"."+$e+"."+Ze):mt?Re=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":gt&&(Re=">="+Ve+"."+$e+".0 <"+Ve+"."+(+$e+1)+".0"),l("xRange return",Re),Re})}(it,Ue)}).join(" ")}(Xe,tt),l("xrange",Xe),Xe=function(rt,Ue){return l("replaceStars",rt,Ue),rt.trim().replace(P[ie],"")}(Xe,tt),l("stars",Xe),Xe}(nt,Ce)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(nt){return!!nt.match(ze)})),qe=qe.map(function(nt){return new oe(nt,Ce)})},B.prototype.intersects=function(ve,Ce){if(!(ve instanceof B))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function(ze){return ve.set.some(function(qe){return qe.every(function(nt){return ze.intersects(nt,Ce)})})})})},e.toComparators=function(ve,Ce){return new B(ve,Ce).set.map(function(Ie){return Ie.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},B.prototype.test=function(ve){if(!ve)return!1;typeof ve=="string"&&(ve=new Y(ve,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(de(this.set[Ce],ve))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(ve,Ce,Ie){var ze=null,qe=null;try{var nt=new B(Ce,Ie)}catch{return null}return ve.forEach(function(Xe){nt.test(Xe)&&(ze&&qe.compare(Xe)!==-1||(qe=new Y(ze=Xe,Ie)))}),ze},e.minSatisfying=function(ve,Ce,Ie){var ze=null,qe=null;try{var nt=new B(Ce,Ie)}catch{return null}return ve.forEach(function(Xe){nt.test(Xe)&&(ze&&qe.compare(Xe)!==1||(qe=new Y(ze=Xe,Ie)))}),ze},e.validRange=function(ve,Ce){try{return new B(ve,Ce).range||"*"}catch{return null}},e.ltr=function(ve,Ce,Ie){return Te(ve,Ce,"<",Ie)},e.gtr=function(ve,Ce,Ie){return Te(ve,Ce,">",Ie)},e.outside=Te,e.prerelease=function(ve,Ce){var Ie=K(ve,Ce);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(ve,Ce,Ie){return ve=new B(ve,Ie),Ce=new B(Ce,Ie),ve.intersects(Ce)},e.coerce=function(ve){if(ve instanceof Y)return ve;if(typeof ve!="string")return null;var Ce=ve.match(P[E]);return Ce==null?null:K((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,o(1))},function(re,e){var o,R,l=re.exports={};function A(){throw new Error("setTimeout has not been defined")}function w(){throw new Error("clearTimeout has not been defined")}function P(d){if(o===setTimeout)return setTimeout(d,0);if((o===A||!o)&&setTimeout)return o=setTimeout,setTimeout(d,0);try{return o(d,0)}catch{try{return o.call(null,d,0)}catch{return o.call(this,d,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:A}catch{o=A}try{R=typeof clearTimeout=="function"?clearTimeout:w}catch{R=w}})();var S,C=[],L=!1,k=-1;function b(){L&&S&&(L=!1,S.length?C=S.concat(C):k=-1,C.length&&I())}function I(){if(!L){var d=P(b);L=!0;for(var u=C.length;u;){for(S=C,C=[];++k<u;)S&&S[k].run();k=-1,u=C.length}S=null,L=!1,function(m){if(R===clearTimeout)return clearTimeout(m);if((R===w||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(m);try{R(m)}catch{try{return R.call(null,m)}catch{return R.call(this,m)}}}(d)}}function y(d,u){this.fun=d,this.array=u}function f(){}l.nextTick=function(d){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];C.push(new y(d,u)),C.length!==1||L||P(I)},y.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=f,l.addListener=f,l.once=f,l.off=f,l.removeListener=f,l.removeAllListeners=f,l.emit=f,l.prependListener=f,l.prependOnceListener=f,l.listeners=function(d){return[]},l.binding=function(d){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(d){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(Se[103],ye([1,0,10,6]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(D){const p=D;return p?typeof p.read=="function":!1}e.isReadable=l;function A(D){const p=D;return p?[p.on,p.pause,p.resume,p.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function w(D){const p=D;return p?A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=w;function P(D,p){return new S(D,p)}e.newWriteableStream=P;class S{constructor(p,n){this.reducer=p,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(n=>n(p))}emitError(p){this.listeners.error.length===0?(0,o.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(n=>n(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,n){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(p,n){if(this.state.destroyed)return;let s;switch(p){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const r=s.indexOf(n);r>=0&&s.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(D,p){const n=[];let s;for(;(s=D.read())!==null;)n.push(s);return p(n)}e.consumeReadable=C;function L(D,p,n){const s=[];let r;for(;(r=D.read())!==null&&s.length<n;)s.push(r);return r===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return D.read()}}}e.peekReadable=L;function k(D,p){return new Promise((n,s)=>{const r=[];b(D,{onData:a=>{p&&r.push(a)},onError:a=>{p?s(a):n(void 0)},onEnd:()=>{n(p?p(r):void 0)}})})}e.consumeStream=k;function b(D,p){let n=!1;return D.on("error",s=>{n||p.onError(s)}),D.on("end",()=>{n||p.onEnd()}),D.on("data",s=>{n||p.onData(s)}),(0,R.toDisposable)(()=>n=!0)}e.listenStream=b;function I(D,p){return new Promise((n,s)=>{const r=new R.DisposableStore,a=[],c=t=>{if(a.push(t),a.length>p)return r.dispose(),D.pause(),n({stream:D,buffer:a,ended:!1})},g=t=>s(t),i=()=>n({stream:D,buffer:a,ended:!0});r.add((0,R.toDisposable)(()=>D.removeListener("error",g))),D.on("error",g),r.add((0,R.toDisposable)(()=>D.removeListener("end",i))),D.on("end",i),r.add((0,R.toDisposable)(()=>D.removeListener("data",c))),D.on("data",c)})}e.peekStream=I;function y(D,p){const n=P(p);return n.end(D),n}e.toStream=y;function f(){const D=P(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=f;function d(D){let p=!1;return{read:()=>p?null:(p=!0,D)}}e.toReadable=d;function u(D,p,n){const s=P(n);return b(D,{onData:r=>s.write(p.data(r)),onError:r=>s.error(p.error?p.error(r):r),onEnd:()=>s.end()}),s}e.transform=u;function m(D,p,n){let s=!1;return{read:()=>{const r=p.read();return s?r:(s=!0,r!==null?n([D,r]):D)}}}e.prefixedReadable=m;function v(D,p,n){let s=!1;const r=P(n);return b(p,{onData:a=>s?r.write(a):(s=!0,r.write(n([D,a]))),onError:a=>r.error(a),onEnd:()=>{s||(s=!0,r.write(D)),r.end()}}),r}e.prefixedStream=v}),define(Se[22],ye([1,0,103]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let l,A;class w{static alloc(t){return R?new w(Buffer.allocUnsafe(t)):new w(new Uint8Array(t))}static wrap(t){return R&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new w(t)}static fromString(t,h){return!(h?.dontUseNodeBuffer||!1)&&R?new w(Buffer.from(t)):(l||(l=new TextEncoder),new w(l.encode(t)))}static fromByteArray(t){const h=w.alloc(t.length);for(let _=0,E=t.length;_<E;_++)h.buffer[_]=t[_];return h}static concat(t,h){if(typeof h>"u"){h=0;for(let O=0,$=t.length;O<$;O++)h+=t[O].byteLength}const _=w.alloc(h);let E=0;for(let O=0,$=t.length;O<$;O++){const H=t[O];_.set(H,E),E+=H.byteLength}return _}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=w.alloc(this.byteLength);return t.set(this),t}toString(){return R?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(t,h){return new w(this.buffer.subarray(t,h))}set(t,h){if(t instanceof w)this.buffer.set(t.buffer,h);else if(t instanceof Uint8Array)this.buffer.set(t,h);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),h);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,h){L(this.buffer,t,h)}readUInt32LE(t){return k(this.buffer,t)}writeUInt32LE(t,h){b(this.buffer,t,h)}readUInt8(t){return I(this.buffer,t)}writeUInt8(t,h){y(this.buffer,t,h)}}e.VSBuffer=w;function P(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0}e.readUInt16LE=P;function S(i,t,h){i[h+0]=t&255,t=t>>>8,i[h+1]=t&255}e.writeUInt16LE=S;function C(i,t){return i[t]*2**24+i[t+1]*2**16+i[t+2]*2**8+i[t+3]}e.readUInt32BE=C;function L(i,t,h){i[h+3]=t,t=t>>>8,i[h+2]=t,t=t>>>8,i[h+1]=t,t=t>>>8,i[h]=t}e.writeUInt32BE=L;function k(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0|i[t+2]<<16>>>0|i[t+3]<<24>>>0}e.readUInt32LE=k;function b(i,t,h){i[h+0]=t&255,t=t>>>8,i[h+1]=t&255,t=t>>>8,i[h+2]=t&255,t=t>>>8,i[h+3]=t&255}e.writeUInt32LE=b;function I(i,t){return i[t]}e.readUInt8=I;function y(i,t,h){i[h]=t}e.writeUInt8=y;function f(i){return o.consumeReadable(i,t=>w.concat(t))}e.readableToBuffer=f;function d(i){return o.toReadable(i)}e.bufferToReadable=d;function u(i){return o.consumeStream(i,t=>w.concat(t))}e.streamToBuffer=u;async function m(i){return i.ended?w.concat(i.buffer):w.concat([...i.buffer,await u(i.stream)])}e.bufferedStreamToBuffer=m;function v(i){return o.toStream(i,t=>w.concat(t))}e.bufferToStream=v;function D(i){return o.transform(i,{data:t=>typeof t=="string"?w.fromString(t):w.wrap(t)},t=>w.concat(t))}e.streamToBufferReadableStream=D;function p(i){return o.newWriteableStream(t=>w.concat(t),i)}e.newWriteableBufferStream=p;function n(i,t){return o.prefixedReadable(i,t,h=>w.concat(h))}e.prefixedBufferReadable=n;function s(i,t){return o.prefixedStream(i,t,h=>w.concat(h))}e.prefixedBufferStream=s;function r(i){let t=0,h=0,_=0;const E=new Uint8Array(Math.floor(i.length/4*3)),O=H=>{switch(h){case 3:E[_++]=t|H,h=0;break;case 2:E[_++]=t|H>>>2,t=H<<6,h=3;break;case 1:E[_++]=t|H>>>4,t=H<<4,h=2;break;default:t=H<<2,h=1}};for(let H=0;H<i.length;H++){const X=i.charCodeAt(H);if(X>=65&&X<=90)O(X-65);else if(X>=97&&X<=122)O(X-97+26);else if(X>=48&&X<=57)O(X-48+52);else if(X===43||X===45)O(62);else if(X===47||X===95)O(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${i[H]}`)}}const $=_;for(;h>0;)O(0);return w.wrap(E).slice(0,$)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:i},t=!0,h=!1){const _=h?c:a;let E="";const O=i.byteLength%3;let $=0;for(;$<i.byteLength-O;$+=3){const H=i[$+0],X=i[$+1],V=i[$+2];E+=_[H>>>2],E+=_[(H<<4|X>>>4)&63],E+=_[(X<<2|V>>>6)&63],E+=_[V&63]}if(O===1){const H=i[$+0];E+=_[H>>>2],E+=_[H<<4&63],t&&(E+="==")}else if(O===2){const H=i[$+0],X=i[$+1];E+=_[H>>>2],E+=_[(H<<4|X>>>4)&63],E+=_[X<<2&63],t&&(E+="=")}return E}e.encodeBase64=g}),define(Se[148],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Se[9],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function R(s){return Array.isArray(s)&&s.every(r=>o(r))}e.isStringArray=R;function l(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=l;function A(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}e.isTypedArray=A;function w(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=w;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function S(s){return s===!0||s===!1}e.isBoolean=S;function C(s){return typeof s>"u"}e.isUndefined=C;function L(s){return!k(s)}e.isDefined=L;function k(s){return C(s)||s===null}e.isUndefinedOrNull=k;function b(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=b;function I(s){if(k(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=I;function y(...s){const r=[];for(let a=0;a<s.length;a++){const c=s[a];if(k(c))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);r.push(c)}return r}e.assertAllDefined=y;const f=Object.prototype.hasOwnProperty;function d(s){if(!l(s))return!1;for(const r in s)if(f.call(s,r))return!1;return!0}e.isEmptyObject=d;function u(s){return typeof s=="function"}e.isFunction=u;function m(...s){return s.length>0&&s.every(u)}e.areFunctions=m;function v(s,r){const a=Math.min(s.length,r.length);for(let c=0;c<a;c++)D(s[c],r[c])}e.validateConstraints=v;function D(s,r){if(o(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(u(r)){try{if(s instanceof r)return}catch{}if(!k(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function p(s){return s===null?void 0:s}e.withNullAsUndefined=p;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(Se[67],ye([1,0,9]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const R=Object.create(null);function l(P,S){if((0,o.isString)(S)){const C=R[S];if(C===void 0)throw new Error(`${P} references an unknown codicon: ${S}`);S=C}return R[P]=S,{id:P}}function A(){return R}e.getCodiconFontCharacters=A;function w(){return Object.values(e.Codicon)}e.getAllCodicons=w,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(Se[23],ye([1,0,9]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([v,D])=>{m[v]=D&&typeof D=="object"?R(D):D}),m}e.deepClone=R;function l(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const v=m.shift();Object.freeze(v);for(const D in v)if(A.call(v,D)){const p=v[D];typeof p=="object"&&!Object.isFrozen(p)&&!(0,o.isTypedArray)(p)&&m.push(p)}}return u}e.deepFreeze=l;const A=Object.prototype.hasOwnProperty;function w(u,m){return P(u,m,new Set)}e.cloneAndChange=w;function P(u,m,v){if((0,o.isUndefinedOrNull)(u))return u;const D=m(u);if(typeof D<"u")return D;if(Array.isArray(u)){const p=[];for(const n of u)p.push(P(n,m,v));return p}if((0,o.isObject)(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const p={};for(const n in u)A.call(u,n)&&(p[n]=P(u[n],m,v));return v.delete(u),p}return u}function S(u,m,v=!0){return(0,o.isObject)(u)?((0,o.isObject)(m)&&Object.keys(m).forEach(D=>{D in u?v&&((0,o.isObject)(u[D])&&(0,o.isObject)(m[D])?S(u[D],m[D],v):u[D]=m[D]):u[D]=m[D]}),u):m}e.mixin=S;function C(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let v,D;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(v=0;v<u.length;v++)if(!C(u[v],m[v]))return!1}else{const p=[];for(D in u)p.push(D);p.sort();const n=[];for(D in m)n.push(D);if(n.sort(),!C(p,n))return!1;for(v=0;v<p.length;v++)if(!C(u[p[v]],m[p[v]]))return!1}return!0}e.equals=C;function L(u){const m=new Set;return JSON.stringify(u,(v,D)=>{if((0,o.isObject)(D)||Array.isArray(D)){if(m.has(D))return"[Circular]";m.add(D)}return D})}e.safeStringify=L;function k(u,m){const v=Object.create(null);return!u||!m||Object.keys(m).forEach(p=>{const n=u[p],s=m[p];C(n,s)||(v[p]=s)}),v}e.distinct=k;function b(u,m){const v=m.toLowerCase(),D=Object.keys(u).find(p=>p.toLowerCase()===v);return D?u[D]:u[m]}e.getCaseInsensitive=b;function I(u,m){const v=Object.create(null);for(const[D,p]of Object.entries(u))m(D,p)&&(v[D]=p);return v}e.filter=I;function y(u){let m=[],v=Object.getPrototypeOf(u);for(;Object.prototype!==v;)m=m.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return m}e.getAllPropertyNames=y;function f(u){const m=[];for(const v of y(u))typeof u[v]=="function"&&m.push(v);return m}e.getAllMethodNames=f;function d(u,m){const v=p=>function(){const n=Array.prototype.slice.call(arguments,0);return m(p,n)},D={};for(const p of u)D[p]=v(p);return D}e.createProxyObject=d}),define(Se[51],ye([1,0,67]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(w){function P(S){return S&&typeof S=="object"&&typeof S.id=="string"}w.isThemeColor=P})(R=e.ThemeColor||(e.ThemeColor={}));function l(w){return{id:w}}e.themeColorFromId=l;var A;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function S(m){const v=P.exec(m.id);if(!v)return S(o.Codicon.error);const[,D,p]=v,n=["codicon","codicon-"+D];return p&&n.push("codicon-modifier-"+p.substring(1)),n}w.asClassNameArray=S;function C(m){return S(m).join(" ")}w.asClassName=C;function L(m){return"."+S(m).join(".")}w.asCSSSelector=L;function k(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||R.isThemeColor(m.color))}w.isThemeIcon=k;const b=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function I(m){const v=b.exec(m);if(!v)return;const[,D]=v;return{id:D}}w.fromString=I;function y(m){return{id:m}}w.fromId=y;function f(m,v){let D=m.id;const p=D.lastIndexOf("~");return p!==-1&&(D=D.substring(0,p)),v&&(D=`${D}~${v}`),{id:D}}w.modify=f;function d(m){const v=m.id.lastIndexOf("~");if(v!==-1)return m.id.substring(v+1)}w.getModifier=d;function u(m,v){return m.id===v.id&&m.color?.id===v.color?.id}w.isEqual=u})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(Se[104],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o=e.Constants||(e.Constants={}));function R(A){return A<0?0:A>255?255:A|0}e.toUint8=R;function l(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=l}),define(Se[30],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(l){return o.test(l)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),w=[];for(let P=0;P<256;P++)w.push(P.toString(16).padStart(2,"0"));return function(){l(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,C="";return C+=w[A[S++]],C+=w[A[S++]],C+=w[A[S++]],C+=w[A[S++]],C+="-",C+=w[A[S++]],C+=w[A[S++]],C+="-",C+=w[A[S++]],C+=w[A[S++]],C+="-",C+=w[A[S++]],C+=w[A[S++]],C+="-",C+=w[A[S++]],C+=w[A[S++]],C+=w[A[S++]],C+=w[A[S++]],C+=w[A[S++]],C+=w[A[S++]],C}}()}),define(Se[149],ye([1,0,16,30]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(P){return{id:(0,R.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=l;function A(P,S,C){return{id:(0,R.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=A;class w{constructor(){this._entries=new Map}get size(){return this._entries.size}has(S){return this._entries.has(this.toKey(S))}get(S){return this._entries.get(this.toKey(S))?.[0]}append(S,C){const L=this._entries.get(S);L?L.push(C):this._entries.set(this.toKey(S),[C])}replace(S,C){this._entries.set(this.toKey(S),[C])}delete(S){this._entries.delete(this.toKey(S))}*entries(){for(const[S,C]of this._entries.entries())for(const L of C)yield[S,L]}values(){return Array.from(this._entries.values()).flat()}forEach(S){for(const[C,L]of this.entries())S(L,C)}toKey(S){return S.toLowerCase()}}e.VSDataTransfer=w,e.UriList=Object.freeze({create:P=>(0,o.distinct)(P.map(S=>S.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(S=>!S.startsWith("#"))})}),define(Se[105],ye([1,0,104]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(P){const S=(0,o.toUint8)(P);this._defaultValue=S,this._asciiMap=R._createAsciiMap(S),this._map=new Map}static _createAsciiMap(P){const S=new Uint8Array(256);return S.fill(P),S}set(P,S){const C=(0,o.toUint8)(S);P>=0&&P<256?this._asciiMap[P]=C:this._map.set(P,C)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=R;var l;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(l||(l={}));class A{constructor(){this._actual=new R(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(Se[52],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(l,A){this.lineNumber=l,this.column=A}with(l=this.lineNumber,A=this.column){return l===this.lineNumber&&A===this.column?this:new o(l,A)}delta(l=0,A=0){return this.with(this.lineNumber+l,this.column+A)}equals(l){return o.equals(this,l)}static equals(l,A){return!l&&!A?!0:!!l&&!!A&&l.lineNumber===A.lineNumber&&l.column===A.column}isBefore(l){return o.isBefore(this,l)}static isBefore(l,A){return l.lineNumber<A.lineNumber?!0:A.lineNumber<l.lineNumber?!1:l.column<A.column}isBeforeOrEqual(l){return o.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,A){return l.lineNumber<A.lineNumber?!0:A.lineNumber<l.lineNumber?!1:l.column<=A.column}static compare(l,A){const w=l.lineNumber|0,P=A.lineNumber|0;if(w===P){const S=l.column|0,C=A.column|0;return S-C}return w-P}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new o(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=o}),define(Se[32],ye([1,0,52]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(A,w,P,S){A>P||A===P&&w>S?(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=A,this.endColumn=w):(this.startLineNumber=A,this.startColumn=w,this.endLineNumber=P,this.endColumn=S)}isEmpty(){return R.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return R.containsPosition(this,A)}static containsPosition(A,w){return!(w.lineNumber<A.startLineNumber||w.lineNumber>A.endLineNumber||w.lineNumber===A.startLineNumber&&w.column<A.startColumn||w.lineNumber===A.endLineNumber&&w.column>A.endColumn)}static strictContainsPosition(A,w){return!(w.lineNumber<A.startLineNumber||w.lineNumber>A.endLineNumber||w.lineNumber===A.startLineNumber&&w.column<=A.startColumn||w.lineNumber===A.endLineNumber&&w.column>=A.endColumn)}containsRange(A){return R.containsRange(this,A)}static containsRange(A,w){return!(w.startLineNumber<A.startLineNumber||w.endLineNumber<A.startLineNumber||w.startLineNumber>A.endLineNumber||w.endLineNumber>A.endLineNumber||w.startLineNumber===A.startLineNumber&&w.startColumn<A.startColumn||w.endLineNumber===A.endLineNumber&&w.endColumn>A.endColumn)}strictContainsRange(A){return R.strictContainsRange(this,A)}static strictContainsRange(A,w){return!(w.startLineNumber<A.startLineNumber||w.endLineNumber<A.startLineNumber||w.startLineNumber>A.endLineNumber||w.endLineNumber>A.endLineNumber||w.startLineNumber===A.startLineNumber&&w.startColumn<=A.startColumn||w.endLineNumber===A.endLineNumber&&w.endColumn>=A.endColumn)}plusRange(A){return R.plusRange(this,A)}static plusRange(A,w){let P,S,C,L;return w.startLineNumber<A.startLineNumber?(P=w.startLineNumber,S=w.startColumn):w.startLineNumber===A.startLineNumber?(P=w.startLineNumber,S=Math.min(w.startColumn,A.startColumn)):(P=A.startLineNumber,S=A.startColumn),w.endLineNumber>A.endLineNumber?(C=w.endLineNumber,L=w.endColumn):w.endLineNumber===A.endLineNumber?(C=w.endLineNumber,L=Math.max(w.endColumn,A.endColumn)):(C=A.endLineNumber,L=A.endColumn),new R(P,S,C,L)}intersectRanges(A){return R.intersectRanges(this,A)}static intersectRanges(A,w){let P=A.startLineNumber,S=A.startColumn,C=A.endLineNumber,L=A.endColumn;const k=w.startLineNumber,b=w.startColumn,I=w.endLineNumber,y=w.endColumn;return P<k?(P=k,S=b):P===k&&(S=Math.max(S,b)),C>I?(C=I,L=y):C===I&&(L=Math.min(L,y)),P>C||P===C&&S>L?null:new R(P,S,C,L)}equalsRange(A){return R.equalsRange(this,A)}static equalsRange(A,w){return!A&&!w?!0:!!A&&!!w&&A.startLineNumber===w.startLineNumber&&A.startColumn===w.startColumn&&A.endLineNumber===w.endLineNumber&&A.endColumn===w.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(A){return new o.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(A){return new o.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,w){return new R(this.startLineNumber,this.startColumn,A,w)}setStartPosition(A,w){return new R(A,w,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(A){return new R(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(A){return new R(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new R(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,w=A){return new R(A.lineNumber,A.column,w.lineNumber,w.column)}static lift(A){return A?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,w){return!(A.endLineNumber<w.startLineNumber||A.endLineNumber===w.startLineNumber&&A.endColumn<w.startColumn||w.endLineNumber<A.startLineNumber||w.endLineNumber===A.startLineNumber&&w.endColumn<A.startColumn)}static areIntersecting(A,w){return!(A.endLineNumber<w.startLineNumber||A.endLineNumber===w.startLineNumber&&A.endColumn<=w.startColumn||w.endLineNumber<A.startLineNumber||w.endLineNumber===A.startLineNumber&&w.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,w){if(A&&w){const C=A.startLineNumber|0,L=w.startLineNumber|0;if(C===L){const k=A.startColumn|0,b=w.startColumn|0;if(k===b){const I=A.endLineNumber|0,y=w.endLineNumber|0;if(I===y){const f=A.endColumn|0,d=w.endColumn|0;return f-d}return I-y}return k-b}return C-L}return(A?1:0)-(w?1:0)}static compareRangesUsingEnds(A,w){return A.endLineNumber===w.endLineNumber?A.endColumn===w.endColumn?A.startLineNumber===w.startLineNumber?A.startColumn-w.startColumn:A.startLineNumber-w.startLineNumber:A.endColumn-w.endColumn:A.endLineNumber-w.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=R}),define(Se[150],ye([1,0,52,32]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(l=e.SelectionDirection||(e.SelectionDirection={}));class A extends R.Range{constructor(P,S,C,L){super(P,S,C,L),this.selectionStartLineNumber=P,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return A.selectionsEqual(this,P)}static selectionsEqual(P,S){return P.selectionStartLineNumber===S.selectionStartLineNumber&&P.selectionStartColumn===S.selectionStartColumn&&P.positionLineNumber===S.positionLineNumber&&P.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,P,S):new A(P,S,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,S){return this.getDirection()===0?new A(P,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,P,S)}static fromPositions(P,S=P){return new A(P.lineNumber,P.column,S.lineNumber,S.column)}static fromRange(P,S){return S===0?new A(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new A(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new A(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,S){if(P&&!S||!P&&S)return!1;if(!P&&!S)return!0;if(P.length!==S.length)return!1;for(let C=0,L=P.length;C<L;C++)if(!this.selectionsEqual(P[C],S[C]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,S,C,L,k){return k===0?new A(P,S,C,L):new A(C,L,P,S)}}e.Selection=A}),define(Se[151],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[152],ye([1,0,105]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(w){w[w.Regular=0]="Regular",w[w.Whitespace=1]="Whitespace",w[w.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class l extends o.CharacterClassifier{constructor(P){super(0);for(let S=0,C=P.length;S<C;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function A(w){const P={};return S=>(P.hasOwnProperty(S)||(P[S]=w(S)),P[S])}e.getMapForWordSeparators=A(w=>new l(w))}),define(Se[106],ye([1,0,64,6,66]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(k=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)k.indexOf(I)>=0||(b+="\\"+I);return b+="\\s]+)",new RegExp(b,"g")}e.DEFAULT_WORD_REGEXP=A();function w(k){let b=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)b=k;else{let I="g";k.ignoreCase&&(I+="i"),k.multiline&&(I+="m"),k.unicode&&(I+="u"),b=new RegExp(k.source,I)}return b.lastIndex=0,b}e.ensureValidWordDefinition=w;const P=new l.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(k){const b=P.unshift(k);return(0,R.toDisposable)(b)}e.setDefaultGetWordAtTextConfig=S;function C(k,b,I,y,f){if(f||(f=o.Iterable.first(P)),I.length>f.maxLen){let D=k-f.maxLen/2;return D<0?D=0:y+=D,I=I.substring(D,k+f.maxLen/2),C(k,b,I,y,f)}const d=Date.now(),u=k-1-y;let m=-1,v=null;for(let D=1;!(Date.now()-d>=f.timeBudget);D++){const p=u-f.windowSize*D;b.lastIndex=Math.max(0,p);const n=L(b,I,u,m);if(!n&&v||(v=n,p<=0))break;m=p}if(v){const D={word:v[0],startColumn:y+1+v.index,endColumn:y+1+v.index+v[0].length};return b.lastIndex=0,D}return null}e.getWordAtText=C;function L(k,b,I,y){let f;for(;f=k.exec(b);){const d=f.index||0;if(d<=I&&k.lastIndex>=I)return f;if(y>0&&d>y)return null}return null}}),define(Se[153],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(w){w[w.None=0]="None",w[w.Indent=1]="Indent",w[w.IndentOutdent=2]="IndentOutdent",w[w.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class R{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let S=0,C=P.notIn.length;S<C;S++)switch(P.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,S){if(P.getTokenCount()===0)return!0;const C=P.findTokenIndexAtOffset(S-2),L=P.getStandardTokenType(C);return this.isOK(L)}_findNeutralCharacterInRange(P,S){for(let C=P;C<=S;C++){const L=String.fromCharCode(C);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=R;class l{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=l;function A(w,P,S){w.has(P)?w.get(P).push(S):w.set(P,[S])}}),define(Se[154],ye([1,0,105]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var R;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class l{constructor(y,f,d){const u=new Uint8Array(y*f);for(let m=0,v=y*f;m<v;m++)u[m]=d;this._data=u,this.rows=y,this.cols=f}get(y,f){return this._data[y*this.cols+f]}set(y,f,d){this._data[y*this.cols+f]=d}}class A{constructor(y){let f=0,d=0;for(let m=0,v=y.length;m<v;m++){const[D,p,n]=y[m];p>f&&(f=p),D>d&&(d=D),n>d&&(d=n)}f++,d++;const u=new l(d,f,0);for(let m=0,v=y.length;m<v;m++){const[D,p,n]=y[m];u.set(D,p,n)}this._states=u,this._maxCharCode=f}nextState(y,f){return f<0||f>=this._maxCharCode?0:this._states.get(y,f)}}e.StateMachine=A;let w=null;function P(){return w===null&&(w=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),w}var S;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function L(){if(C===null){C=new o.CharacterClassifier(0);const I=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<I.length;f++)C.set(I.charCodeAt(f),1);const y=".,;:";for(let f=0;f<y.length;f++)C.set(y.charCodeAt(f),2)}return C}class k{static _createLink(y,f,d,u,m){let v=m-1;do{const D=f.charCodeAt(v);if(y.get(D)!==2)break;v--}while(v>u);if(u>0){const D=f.charCodeAt(u-1),p=f.charCodeAt(v);(D===40&&p===41||D===91&&p===93||D===123&&p===125)&&v--}return{range:{startLineNumber:d,startColumn:u+1,endLineNumber:d,endColumn:v+2},url:f.substring(u,v+1)}}static computeLinks(y,f=P()){const d=L(),u=[];for(let m=1,v=y.getLineCount();m<=v;m++){const D=y.getLineContent(m),p=D.length;let n=0,s=0,r=0,a=1,c=!1,g=!1,i=!1,t=!1;for(;n<p;){let h=!1;const _=D.charCodeAt(n);if(a===13){let E;switch(_){case 40:c=!0,E=0;break;case 41:E=c?0:1;break;case 91:i=!0,g=!0,E=0;break;case 93:i=!1,E=g?0:1;break;case 123:t=!0,E=0;break;case 125:E=t?0:1;break;case 39:case 34:case 96:r===_?E=1:r===39||r===34||r===96?E=0:E=1;break;case 42:E=r===42?1:0;break;case 124:E=r===124?1:0;break;case 32:E=i?0:1;break;default:E=d.get(_)}E===1&&(u.push(k._createLink(d,D,m,s,n)),h=!0)}else if(a===12){let E;_===91?(g=!0,E=0):E=d.get(_),E===1?h=!0:a=13}else a=f.nextState(a,_),a===0&&(h=!0);h&&(a=1,c=!1,g=!1,t=!1,s=n+1,r=_),n++}a===13&&u.push(k._createLink(d,D,m,s,p))}return u}}e.LinkComputer=k;function b(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:k.computeLinks(I)}e.computeLinks=b}),define(Se[107],ye([1,0,23]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var R;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(R=e.OverviewRulerLane||(e.OverviewRulerLane={}));var l;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(l=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var w;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(w=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),D.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,D.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this._indentSizeIsTabSize===D._indentSizeIsTabSize&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class L{constructor(D,p){this._findMatchBrand=void 0,this.range=D,this.matches=p}}e.FindMatch=L;var k;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function b(v){return v&&typeof v.read=="function"}e.isITextSnapshot=b;var I;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None",v[v.LeftOfInjectedText=3]="LeftOfInjectedText",v[v.RightOfInjectedText=4]="RightOfInjectedText"})(I=e.PositionAffinity||(e.PositionAffinity={}));var y;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(y=e.ModelConstants||(e.ModelConstants={}));class f{constructor(D,p,n,s,r,a){this.identifier=D,this.range=p,this.text=n,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=r,this._isTracked=a}}e.ValidAnnotatedEditOperation=f;class d{constructor(D,p,n){this.regex=D,this.wordSeparators=p,this.simpleSearch=n}}e.SearchData=d;class u{constructor(D,p,n){this.reverseEdits=D,this.changes=p,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=u;function m(v){return!v.isTooLargeForSyncing()&&!v.isForSimpleWidget}e.shouldSynchronizeModel=m}),define(Se[155],ye([1,0,16,104]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,C){S=(0,R.toUint32)(S);const L=this.values,k=this.prefixSum,b=C.length;return b===0?!1:(this.values=new Uint32Array(L.length+b),this.values.set(L.subarray(0,S),0),this.values.set(L.subarray(S),S+b),this.values.set(C,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,C){return S=(0,R.toUint32)(S),C=(0,R.toUint32)(C),this.values[S]===C?!1:(this.values[S]=C,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,C){S=(0,R.toUint32)(S),C=(0,R.toUint32)(C);const L=this.values,k=this.prefixSum;if(S>=L.length)return!1;const b=L.length-S;return C>=b&&(C=b),C===0?!1:(this.values=new Uint32Array(L.length-C),this.values.set(L.subarray(0,S),0),this.values.set(L.subarray(S+C),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,R.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),S>=this.values.length&&(S=this.values.length-1);for(let L=C;L<=S;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let C=0,L=this.values.length-1,k=0,b=0,I=0;for(;C<=L;)if(k=C+(L-C)/2|0,b=this.prefixSum[k],I=b-this.values[k],S<I)L=k-1;else if(S>=b)C=k+1;else break;return new w(k,S-I)}}e.PrefixSumComputer=l;class A{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const C=this._indexBySum[S],L=C>0?this._prefixSum[C-1]:0;return new w(C,S-L)}removeValues(S,C){this._values.splice(S,C),this._invalidate(S)}insertValues(S,C){this._values=(0,o.arrayInsert)(this._values,S,C),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,C=this._values.length;S<C;S++){const L=this._values[S],k=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=k+L;for(let b=0;b<L;b++)this._indexBySum[k+b]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,C){this._values[S]!==C&&(this._values[S]=C,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=A;class w{constructor(S,C){this.index=S,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=w}),define(Se[156],ye([17,18]),function(re,e){return re.create("vs/base/common/actions",e)}),define(Se[157],ye([17,18]),function(re,e){return re.create("vs/base/common/date",e)}),define(Se[158],ye([1,0,157]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,l=R*60,A=l*24,w=A*7,P=A*30,S=A*365;function C(k,b,I,y){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,o.localize)(0,null,C(new Date().getTime()+f*1e3,!1));if(!y&&f<30)return(0,o.localize)(1,null);let d;return f<R?(d=f,b?d===1?I?(0,o.localize)(2,null,d):(0,o.localize)(3,null,d):I?(0,o.localize)(4,null,d):(0,o.localize)(5,null,d):d===1?I?(0,o.localize)(6,null,d):(0,o.localize)(7,null,d):I?(0,o.localize)(8,null,d):(0,o.localize)(9,null,d)):f<l?(d=Math.floor(f/R),b?d===1?I?(0,o.localize)(10,null,d):(0,o.localize)(11,null,d):I?(0,o.localize)(12,null,d):(0,o.localize)(13,null,d):d===1?I?(0,o.localize)(14,null,d):(0,o.localize)(15,null,d):I?(0,o.localize)(16,null,d):(0,o.localize)(17,null,d)):f<A?(d=Math.floor(f/l),b?d===1?I?(0,o.localize)(18,null,d):(0,o.localize)(19,null,d):I?(0,o.localize)(20,null,d):(0,o.localize)(21,null,d):d===1?I?(0,o.localize)(22,null,d):(0,o.localize)(23,null,d):I?(0,o.localize)(24,null,d):(0,o.localize)(25,null,d)):f<w?(d=Math.floor(f/A),b?d===1?(0,o.localize)(26,null,d):(0,o.localize)(27,null,d):d===1?(0,o.localize)(28,null,d):(0,o.localize)(29,null,d)):f<P?(d=Math.floor(f/w),b?d===1?I?(0,o.localize)(30,null,d):(0,o.localize)(31,null,d):I?(0,o.localize)(32,null,d):(0,o.localize)(33,null,d):d===1?I?(0,o.localize)(34,null,d):(0,o.localize)(35,null,d):I?(0,o.localize)(36,null,d):(0,o.localize)(37,null,d)):f<S?(d=Math.floor(f/P),b?d===1?I?(0,o.localize)(38,null,d):(0,o.localize)(39,null,d):I?(0,o.localize)(40,null,d):(0,o.localize)(41,null,d):d===1?I?(0,o.localize)(42,null,d):(0,o.localize)(43,null,d):I?(0,o.localize)(44,null,d):(0,o.localize)(45,null,d)):(d=Math.floor(f/S),b?d===1?I?(0,o.localize)(46,null,d):(0,o.localize)(47,null,d):I?(0,o.localize)(48,null,d):(0,o.localize)(49,null,d):d===1?I?(0,o.localize)(50,null,d):(0,o.localize)(51,null,d):I?(0,o.localize)(52,null,d):(0,o.localize)(53,null,d))}e.fromNow=C;function L(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Se[159],ye([17,18]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Se[45],ye([1,0,16,9,159]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(k,b){return b&&(k.stack||k.stacktrace)?l.localize(0,null,P(k),w(k.stack)||w(k.stacktrace)):P(k)}function w(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?l.localize(1,null,k.message):k.message||l.localize(2,null)}function S(k=null,b=!1){if(!k)return l.localize(3,null);if(Array.isArray(k)){const I=o.coalesce(k),y=S(I[0],b);return I.length>1?l.localize(4,null,y,I.length):y}if(R.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return A(I.error,b);if(I.exception)return A(I.exception,b)}return k.stack?A(k,b):k.message?k.message:l.localize(5,null)}e.toErrorMessage=S;function C(k){const b=k;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=C;function L(k,b){let I;return typeof k=="string"?I=new Error(k):I=k,I.actions=b,I}e.createErrorWithActions=L}),define(Se[160],ye([17,18]),function(re,e){return re.create("vs/base/common/platform",e)}),define(Se[11],ye([1,0,160]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let R=!1,l=!1,A=!1,w=!1,P=!1,S=!1,C=!1,L=!1,k=!1,b=!1,I,y=e.LANGUAGE_DEFAULT,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",v=m&&u?.type==="renderer";if(typeof navigator=="object"&&!v)d=navigator.userAgent,R=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=d.indexOf("Linux")>=0,b=d?.indexOf("Mobi")>=0,S=!0,I=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,y=I;else if(typeof u=="object"){R=u.platform==="win32",l=u.platform==="darwin",A=u.platform==="linux",w=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,C=m,k=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const t=JSON.parse(i),h=t.availableLanguages["*"];I=t.locale,y=h||e.LANGUAGE_DEFAULT,f=t._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function p(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let n=0;l?n=1:R?n=3:A&&(n=2),e.isWindows=R,e.isMacintosh=l,e.isLinux=A,e.isLinuxSnap=w,e.isNative=P,e.isElectron=C,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=b,e.isCI=k,e.platform=n,e.userAgent=d,e.language=y;var s;(function(i){function t(){return e.language}i.value=t;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function _(){return e.language==="en"}i.isDefault=_})(s=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let _=0,E=i.length;_<E;_++){const O=i[_];if(O.id===h.data.vscodeScheduleAsyncWork){i.splice(_,1),O.callback();return}}});let t=0;return h=>{const _=++t;i.push({id:_,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return i=>setTimeout(i)})();var r;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||L?2:R?1:3;let a=!0,c=!1;function g(){if(!c){c=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=g,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Se[33],ye([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const l=o.globals.vscode.process;R={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(Se[12],ye([1,0,33]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,l=97,A=90,w=122,P=46,S=47,C=92,L=58,k=63;class b extends Error{constructor(s,r,a){let c;typeof r=="string"&&r.indexOf("not ")===0?(c="must not be",r=r.replace(/^not /,"")):c="must be";const g=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${g} ${c} of type ${r}`;i+=`. Received type ${typeof a}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function I(n,s){if(n===null||typeof n!="object")throw new b(s,"Object",n)}function y(n,s){if(typeof n!="string")throw new b(s,"string",n)}const f=o.platform==="win32";function d(n){return n===S||n===C}function u(n){return n===S}function m(n){return n>=R&&n<=A||n>=l&&n<=w}function v(n,s,r,a){let c="",g=0,i=-1,t=0,h=0;for(let _=0;_<=n.length;++_){if(_<n.length)h=n.charCodeAt(_);else{if(a(h))break;h=S}if(a(h)){if(!(i===_-1||t===1))if(t===2){if(c.length<2||g!==2||c.charCodeAt(c.length-1)!==P||c.charCodeAt(c.length-2)!==P){if(c.length>2){const E=c.lastIndexOf(r);E===-1?(c="",g=0):(c=c.slice(0,E),g=c.length-1-c.lastIndexOf(r)),i=_,t=0;continue}else if(c.length!==0){c="",g=0,i=_,t=0;continue}}s&&(c+=c.length>0?`${r}..`:"..",g=2)}else c.length>0?c+=`${r}${n.slice(i+1,_)}`:c=n.slice(i+1,_),g=_-i-1;i=_,t=0}else h===P&&t!==-1?++t:t=-1}return c}function D(n,s){I(s,"pathObject");const r=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${a}`:`${r}${n}${a}`:a}e.win32={resolve(...n){let s="",r="",a=!1;for(let c=n.length-1;c>=-1;c--){let g;if(c>=0){if(g=n[c],y(g,"path"),g.length===0)continue}else s.length===0?g=o.cwd():(g=o.env[`=${s}`]||o.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==s.toLowerCase()&&g.charCodeAt(2)===C)&&(g=`${s}\\`));const i=g.length;let t=0,h="",_=!1;const E=g.charCodeAt(0);if(i===1)d(E)&&(t=1,_=!0);else if(d(E))if(_=!0,d(g.charCodeAt(1))){let O=2,$=O;for(;O<i&&!d(g.charCodeAt(O));)O++;if(O<i&&O!==$){const H=g.slice($,O);for($=O;O<i&&d(g.charCodeAt(O));)O++;if(O<i&&O!==$){for($=O;O<i&&!d(g.charCodeAt(O));)O++;(O===i||O!==$)&&(h=`\\\\${H}\\${g.slice($,O)}`,t=O)}}}else t=1;else m(E)&&g.charCodeAt(1)===L&&(h=g.slice(0,2),t=2,i>2&&d(g.charCodeAt(2))&&(_=!0,t=3));if(h.length>0)if(s.length>0){if(h.toLowerCase()!==s.toLowerCase())continue}else s=h;if(a){if(s.length>0)break}else if(r=`${g.slice(t)}\\${r}`,a=_,_&&s.length>0)break}return r=v(r,!a,"\\",d),a?`${s}\\${r}`:`${s}${r}`||"."},normalize(n){y(n,"path");const s=n.length;if(s===0)return".";let r=0,a,c=!1;const g=n.charCodeAt(0);if(s===1)return u(g)?"\\":n;if(d(g))if(c=!0,d(n.charCodeAt(1))){let t=2,h=t;for(;t<s&&!d(n.charCodeAt(t));)t++;if(t<s&&t!==h){const _=n.slice(h,t);for(h=t;t<s&&d(n.charCodeAt(t));)t++;if(t<s&&t!==h){for(h=t;t<s&&!d(n.charCodeAt(t));)t++;if(t===s)return`\\\\${_}\\${n.slice(h)}\\`;t!==h&&(a=`\\\\${_}\\${n.slice(h,t)}`,r=t)}}}else r=1;else m(g)&&n.charCodeAt(1)===L&&(a=n.slice(0,2),r=2,s>2&&d(n.charCodeAt(2))&&(c=!0,r=3));let i=r<s?v(n.slice(r),!c,"\\",d):"";return i.length===0&&!c&&(i="."),i.length>0&&d(n.charCodeAt(s-1))&&(i+="\\"),a===void 0?c?`\\${i}`:i:c?`${a}\\${i}`:`${a}${i}`},isAbsolute(n){y(n,"path");const s=n.length;if(s===0)return!1;const r=n.charCodeAt(0);return d(r)||s>2&&m(r)&&n.charCodeAt(1)===L&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,r;for(let g=0;g<n.length;++g){const i=n[g];y(i,"path"),i.length>0&&(s===void 0?s=r=i:s+=`\\${i}`)}if(s===void 0)return".";let a=!0,c=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++c;const g=r.length;g>1&&d(r.charCodeAt(1))&&(++c,g>2&&(d(r.charCodeAt(2))?++c:a=!1))}if(a){for(;c<s.length&&d(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return e.win32.normalize(s)},relative(n,s){if(y(n,"from"),y(s,"to"),n===s)return"";const r=e.win32.resolve(n),a=e.win32.resolve(s);if(r===a||(n=r.toLowerCase(),s=a.toLowerCase(),n===s))return"";let c=0;for(;c<n.length&&n.charCodeAt(c)===C;)c++;let g=n.length;for(;g-1>c&&n.charCodeAt(g-1)===C;)g--;const i=g-c;let t=0;for(;t<s.length&&s.charCodeAt(t)===C;)t++;let h=s.length;for(;h-1>t&&s.charCodeAt(h-1)===C;)h--;const _=h-t,E=i<_?i:_;let O=-1,$=0;for(;$<E;$++){const X=n.charCodeAt(c+$);if(X!==s.charCodeAt(t+$))break;X===C&&(O=$)}if($!==E){if(O===-1)return a}else{if(_>E){if(s.charCodeAt(t+$)===C)return a.slice(t+$+1);if($===2)return a.slice(t+$)}i>E&&(n.charCodeAt(c+$)===C?O=$:$===2&&(O=3)),O===-1&&(O=0)}let H="";for($=c+O+1;$<=g;++$)($===g||n.charCodeAt($)===C)&&(H+=H.length===0?"..":"\\..");return t+=O,H.length>0?`${H}${a.slice(t,h)}`:(a.charCodeAt(t)===C&&++t,a.slice(t,h))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.win32.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===C){if(s.charCodeAt(1)===C){const r=s.charCodeAt(2);if(r!==k&&r!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(m(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===C)return`\\\\?\\${s}`;return n},dirname(n){y(n,"path");const s=n.length;if(s===0)return".";let r=-1,a=0;const c=n.charCodeAt(0);if(s===1)return d(c)?n:".";if(d(c)){if(r=a=1,d(n.charCodeAt(1))){let t=2,h=t;for(;t<s&&!d(n.charCodeAt(t));)t++;if(t<s&&t!==h){for(h=t;t<s&&d(n.charCodeAt(t));)t++;if(t<s&&t!==h){for(h=t;t<s&&!d(n.charCodeAt(t));)t++;if(t===s)return n;t!==h&&(r=a=t+1)}}}}else m(c)&&n.charCodeAt(1)===L&&(r=s>2&&d(n.charCodeAt(2))?3:2,a=r);let g=-1,i=!0;for(let t=s-1;t>=a;--t)if(d(n.charCodeAt(t))){if(!i){g=t;break}}else i=!1;if(g===-1){if(r===-1)return".";g=r}return n.slice(0,g)},basename(n,s){s!==void 0&&y(s,"ext"),y(n,"path");let r=0,a=-1,c=!0,g;if(n.length>=2&&m(n.charCodeAt(0))&&n.charCodeAt(1)===L&&(r=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let i=s.length-1,t=-1;for(g=n.length-1;g>=r;--g){const h=n.charCodeAt(g);if(d(h)){if(!c){r=g+1;break}}else t===-1&&(c=!1,t=g+1),i>=0&&(h===s.charCodeAt(i)?--i===-1&&(a=g):(i=-1,a=t))}return r===a?a=t:a===-1&&(a=n.length),n.slice(r,a)}for(g=n.length-1;g>=r;--g)if(d(n.charCodeAt(g))){if(!c){r=g+1;break}}else a===-1&&(c=!1,a=g+1);return a===-1?"":n.slice(r,a)},extname(n){y(n,"path");let s=0,r=-1,a=0,c=-1,g=!0,i=0;n.length>=2&&n.charCodeAt(1)===L&&m(n.charCodeAt(0))&&(s=a=2);for(let t=n.length-1;t>=s;--t){const h=n.charCodeAt(t);if(d(h)){if(!g){a=t+1;break}continue}c===-1&&(g=!1,c=t+1),h===P?r===-1?r=t:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||c===-1||i===0||i===1&&r===c-1&&r===a+1?"":n.slice(r,c)},format:D.bind(null,"\\"),parse(n){y(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const r=n.length;let a=0,c=n.charCodeAt(0);if(r===1)return d(c)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(d(c)){if(a=1,d(n.charCodeAt(1))){let O=2,$=O;for(;O<r&&!d(n.charCodeAt(O));)O++;if(O<r&&O!==$){for($=O;O<r&&d(n.charCodeAt(O));)O++;if(O<r&&O!==$){for($=O;O<r&&!d(n.charCodeAt(O));)O++;O===r?a=O:O!==$&&(a=O+1)}}}}else if(m(c)&&n.charCodeAt(1)===L){if(r<=2)return s.root=s.dir=n,s;if(a=2,d(n.charCodeAt(2))){if(r===3)return s.root=s.dir=n,s;a=3}}a>0&&(s.root=n.slice(0,a));let g=-1,i=a,t=-1,h=!0,_=n.length-1,E=0;for(;_>=a;--_){if(c=n.charCodeAt(_),d(c)){if(!h){i=_+1;break}continue}t===-1&&(h=!1,t=_+1),c===P?g===-1?g=_:E!==1&&(E=1):g!==-1&&(E=-1)}return t!==-1&&(g===-1||E===0||E===1&&g===t-1&&g===i+1?s.base=s.name=n.slice(i,t):(s.name=n.slice(i,g),s.base=n.slice(i,t),s.ext=n.slice(g,t))),i>0&&i!==a?s.dir=n.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(f){const n=/\\/g;return()=>{const s=o.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...n){let s="",r=!1;for(let a=n.length-1;a>=-1&&!r;a--){const c=a>=0?n[a]:p();y(c,"path"),c.length!==0&&(s=`${c}/${s}`,r=c.charCodeAt(0)===S)}return s=v(s,!r,"/",u),r?`/${s}`:s.length>0?s:"."},normalize(n){if(y(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===S,r=n.charCodeAt(n.length-1)===S;return n=v(n,!s,"/",u),n.length===0?s?"/":r?"./":".":(r&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return y(n,"path"),n.length>0&&n.charCodeAt(0)===S},join(...n){if(n.length===0)return".";let s;for(let r=0;r<n.length;++r){const a=n[r];y(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":e.posix.normalize(s)},relative(n,s){if(y(n,"from"),y(s,"to"),n===s||(n=e.posix.resolve(n),s=e.posix.resolve(s),n===s))return"";const r=1,a=n.length,c=a-r,g=1,i=s.length-g,t=c<i?c:i;let h=-1,_=0;for(;_<t;_++){const O=n.charCodeAt(r+_);if(O!==s.charCodeAt(g+_))break;O===S&&(h=_)}if(_===t)if(i>t){if(s.charCodeAt(g+_)===S)return s.slice(g+_+1);if(_===0)return s.slice(g+_)}else c>t&&(n.charCodeAt(r+_)===S?h=_:_===0&&(h=0));let E="";for(_=r+h+1;_<=a;++_)(_===a||n.charCodeAt(_)===S)&&(E+=E.length===0?"..":"/..");return`${E}${s.slice(g+h)}`},toNamespacedPath(n){return n},dirname(n){if(y(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===S;let r=-1,a=!0;for(let c=n.length-1;c>=1;--c)if(n.charCodeAt(c)===S){if(!a){r=c;break}}else a=!1;return r===-1?s?"/":".":s&&r===1?"//":n.slice(0,r)},basename(n,s){s!==void 0&&y(s,"ext"),y(n,"path");let r=0,a=-1,c=!0,g;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let i=s.length-1,t=-1;for(g=n.length-1;g>=0;--g){const h=n.charCodeAt(g);if(h===S){if(!c){r=g+1;break}}else t===-1&&(c=!1,t=g+1),i>=0&&(h===s.charCodeAt(i)?--i===-1&&(a=g):(i=-1,a=t))}return r===a?a=t:a===-1&&(a=n.length),n.slice(r,a)}for(g=n.length-1;g>=0;--g)if(n.charCodeAt(g)===S){if(!c){r=g+1;break}}else a===-1&&(c=!1,a=g+1);return a===-1?"":n.slice(r,a)},extname(n){y(n,"path");let s=-1,r=0,a=-1,c=!0,g=0;for(let i=n.length-1;i>=0;--i){const t=n.charCodeAt(i);if(t===S){if(!c){r=i+1;break}continue}a===-1&&(c=!1,a=i+1),t===P?s===-1?s=i:g!==1&&(g=1):s!==-1&&(g=-1)}return s===-1||a===-1||g===0||g===1&&s===a-1&&s===r+1?"":n.slice(s,a)},format:D.bind(null,"/"),parse(n){y(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const r=n.charCodeAt(0)===S;let a;r?(s.root="/",a=1):a=0;let c=-1,g=0,i=-1,t=!0,h=n.length-1,_=0;for(;h>=a;--h){const E=n.charCodeAt(h);if(E===S){if(!t){g=h+1;break}continue}i===-1&&(t=!1,i=h+1),E===P?c===-1?c=h:_!==1&&(_=1):c!==-1&&(_=-1)}if(i!==-1){const E=g===0&&r?1:g;c===-1||_===0||_===1&&c===i-1&&c===g+1?s.base=s.name=n.slice(E,i):(s.name=n.slice(E,c),s.base=n.slice(E,i),s.ext=n.slice(c,i))}return g>0?s.dir=n.slice(0,g-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(Se[108],ye([1,0,65,12]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new o.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),A=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),w=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(t,h,_=!1){const E=t||"",O=h||"",$=l.value.collator.compare(E,O);return l.value.collatorIsNumeric&&$===0&&E!==O?E<O?-1:1:$}e.compareFileNames=P;function S(t,h){const _=A.value.collator;return t=t||"",h=h||"",D(_,t,h)}e.compareFileNamesDefault=S;function C(t,h){const _=A.value.collator;return t=t||"",h=h||"",r(t,h)||D(_,t,h)}e.compareFileNamesUpper=C;function L(t,h){const _=A.value.collator;return t=t||"",h=h||"",s(t,h)||D(_,t,h)}e.compareFileNamesLower=L;function k(t,h){return t=t||"",h=h||"",t===h?0:t<h?-1:1}e.compareFileNamesUnicode=k;function b(t,h){const[_,E]=m(t),[O,$]=m(h);let H=l.value.collator.compare(E,$);if(H===0){if(l.value.collatorIsNumeric&&E!==$)return E<$?-1:1;if(H=l.value.collator.compare(_,O),l.value.collatorIsNumeric&&H===0&&_!==O)return _<O?-1:1}return H}e.compareFileExtensions=b;function I(t,h){t=t||"",h=h||"";const _=v(t),E=v(h),O=A.value.collator,$=w.value.collator;return D($,_,E)||D(O,t,h)}e.compareFileExtensionsDefault=I;function y(t,h){t=t||"",h=h||"";const _=v(t),E=v(h),O=A.value.collator,$=w.value.collator;return D($,_,E)||r(t,h)||D(O,t,h)}e.compareFileExtensionsUpper=y;function f(t,h){t=t||"",h=h||"";const _=v(t),E=v(h),O=A.value.collator,$=w.value.collator;return D($,_,E)||s(t,h)||D(O,t,h)}e.compareFileExtensionsLower=f;function d(t,h){t=t||"",h=h||"";const _=v(t).toLowerCase(),E=v(h).toLowerCase();return _!==E?_<E?-1:1:t!==h?t<h?-1:1:0}e.compareFileExtensionsUnicode=d;const u=/^(.*?)(\.([^.]*))?$/;function m(t,h=!1){const _=t?u.exec(t):[];let E=[_&&_[1]||"",_&&_[3]||""];return h&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function v(t){const h=t?u.exec(t):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function D(t,h,_){const E=t.compare(h,_);return E!==0?E:h.length!==_.length?h.length<_.length?-1:1:0}function p(t){const h=t.charAt(0);return h.toLocaleUpperCase()!==h}function n(t){const h=t.charAt(0);return h.toLocaleLowerCase()!==h}function s(t,h){return p(t)&&n(h)?-1:n(t)&&p(h)?1:0}function r(t,h){return n(t)&&p(h)?-1:p(t)&&n(h)?1:0}function a(t,h,_=!1){return _||(t=t&&t.toLowerCase(),h=h&&h.toLowerCase()),t===h?0:t<h?-1:1}function c(t,h,_=!1){const E=t.split(R.sep),O=h.split(R.sep),$=E.length-1,H=O.length-1;let X,V;for(let N=0;;N++){if(X=$===N,V=H===N,X&&V)return P(E[N],O[N],_);if(X)return-1;if(V)return 1;const T=a(E[N],O[N],_);if(T!==0)return T}}e.comparePaths=c;function g(t,h,_){const E=t.toLowerCase(),O=h.toLowerCase(),$=i(t,h,_);if($)return $;const H=E.endsWith(_),X=O.endsWith(_);if(H!==X)return H?-1:1;const V=P(E,O);return V!==0?V:E.localeCompare(O)}e.compareAnything=g;function i(t,h,_){const E=t.toLowerCase(),O=h.toLowerCase(),$=E.startsWith(_),H=O.startsWith(_);if($!==H)return $?-1:1;if($&&H){if(E.length<O.length)return-1;if(E.length>O.length)return 1}return 0}e.compareByPrefix=i}),define(Se[88],ye([1,0,12]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const k=(0,o.extname)(L),b=R[k.toLowerCase()];return b!==void 0?b:w(L)}e.getMediaOrTextMime=A;function w(L){const k=(0,o.extname)(L);return l[k.toLowerCase()]}e.getMediaMime=w;function P(L){for(const k in l)if(l[k]===L)return k}e.getExtensionForMimeType=P;const S=/^(.+)\/(.+?)(;.+)?$/;function C(L,k){const b=S.exec(L);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:k?void 0:L}e.normalizeMimeType=C}),define(Se[109],ye([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(P,...S){const C=S.reduce((b,I)=>(b[I]=!0,b),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!C[b]).forEach(b=>{for(let I=0;I<L.length;I++)if(b.search(L[I])!==-1){delete P[b];break}})}e.sanitizeProcessEnvironment=A;function w(P){!P||(delete P.DEBUG,o.isMacintosh&&delete P.DYLD_LIBRARY_PATH,o.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=w}),define(Se[43],ye([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=o.globals.performance&&typeof o.globals.performance.now=="function";class l{static create(w=!0){return new l(w)}constructor(w){this._highResolution=R&&w,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?o.globals.performance.now():Date.now()}}e.StopWatch=l}),define(Se[3],ye([1,0,10,63,6,66,43]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,S=!1;var C;(function(g){g.None=()=>l.Disposable.None;function i(be){if(S){const{onDidAddListener:De}=be,Ae=y.create();let ae=0;be.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),De?.()}}}function t(be,De){return N(be,()=>{},0,void 0,!0,void 0,De)}g.defer=t;function h(be){return(De,Ae=null,ae)=>{let le=!1,ue;return ue=be(ne=>{if(!le)return ue?ue.dispose():le=!0,De.call(Ae,ne)},null,ae),le&&ue.dispose(),ue}}g.once=h;function _(be,De,Ae){return V((ae,le=null,ue)=>be(ne=>ae.call(le,De(ne)),null,ue),Ae)}g.map=_;function E(be,De,Ae){return V((ae,le=null,ue)=>be(ne=>{De(ne),ae.call(le,ne)},null,ue),Ae)}g.forEach=E;function O(be,De,Ae){return V((ae,le=null,ue)=>be(ne=>De(ne)&&ae.call(le,ne),null,ue),Ae)}g.filter=O;function $(be){return be}g.signal=$;function H(...be){return(De,Ae=null,ae)=>(0,l.combinedDisposable)(...be.map(le=>le(ue=>De.call(Ae,ue),null,ae)))}g.any=H;function X(be,De,Ae,ae){let le=Ae;return _(be,ue=>(le=De(le,ue),le),ae)}g.reduce=X;function V(be,De){let Ae;const ae={onWillAddFirstListener(){Ae=be(le.fire,le)},onDidRemoveLastListener(){Ae?.dispose()}};De||i(ae);const le=new d(ae);return De?.add(le),le.event}function N(be,De,Ae=100,ae=!1,le=!1,ue,ne){let ce,oe,M,B=0,q;const te={leakWarningThreshold:ue,onWillAddFirstListener(){ce=be(Ee=>{B++,oe=De(oe,Ee),ae&&!M&&(de.fire(oe),oe=void 0),q=()=>{const Te=oe;oe=void 0,M=void 0,(!ae||B>1)&&de.fire(Te),B=0},typeof Ae=="number"?(clearTimeout(M),M=setTimeout(q,Ae)):M===void 0&&(M=0,queueMicrotask(q))})},onWillRemoveListener(){le&&B>0&&q?.()},onDidRemoveLastListener(){q=void 0,ce.dispose()}};ne||i(te);const de=new d(te);return ne?.add(de),de.event}g.debounce=N;function T(be,De=0,Ae){return g.debounce(be,(ae,le)=>ae?(ae.push(le),ae):[le],De,void 0,!0,void 0,Ae)}g.accumulate=T;function F(be,De=(ae,le)=>ae===le,Ae){let ae=!0,le;return O(be,ue=>{const ne=ae||!De(ue,le);return ae=!1,le=ue,ne},Ae)}g.latch=F;function U(be,De,Ae){return[g.filter(be,De,Ae),g.filter(be,ae=>!De(ae),Ae)]}g.split=U;function Z(be,De=!1,Ae=[]){let ae=Ae.slice(),le=be(ce=>{ae?ae.push(ce):ne.fire(ce)});const ue=()=>{ae?.forEach(ce=>ne.fire(ce)),ae=null},ne=new d({onWillAddFirstListener(){le||(le=be(ce=>ne.fire(ce)))},onDidAddFirstListener(){ae&&(De?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return ne.event}g.buffer=Z;class J{constructor(De){this.event=De,this.disposables=new l.DisposableStore}map(De){return new J(_(this.event,De,this.disposables))}forEach(De){return new J(E(this.event,De,this.disposables))}filter(De){return new J(O(this.event,De,this.disposables))}reduce(De,Ae){return new J(X(this.event,De,Ae,this.disposables))}latch(){return new J(F(this.event,void 0,this.disposables))}debounce(De,Ae=100,ae=!1,le=!1,ue){return new J(N(this.event,De,Ae,ae,le,ue,this.disposables))}on(De,Ae,ae){return this.event(De,Ae,ae)}once(De,Ae,ae){return h(this.event)(De,Ae,ae)}dispose(){this.disposables.dispose()}}function z(be){return new J(be)}g.chain=z;function Q(be,De,Ae=ae=>ae){const ae=(...ce)=>ne.fire(Ae(...ce)),le=()=>be.on(De,ae),ue=()=>be.removeListener(De,ae),ne=new d({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ne.event}g.fromNodeEventEmitter=Q;function ie(be,De,Ae=ae=>ae){const ae=(...ce)=>ne.fire(Ae(...ce)),le=()=>be.addEventListener(De,ae),ue=()=>be.removeEventListener(De,ae),ne=new d({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ne.event}g.fromDOMEventEmitter=ie;function ge(be){return new Promise(De=>h(be)(De))}g.toPromise=ge;function K(be,De){return De(void 0),be(Ae=>De(Ae))}g.runAndSubscribe=K;function Y(be,De){let Ae=null;function ae(ue){Ae?.dispose(),Ae=new l.DisposableStore,De(ue,Ae)}ae(void 0);const le=be(ue=>ae(ue));return(0,l.toDisposable)(()=>{le.dispose(),Ae?.dispose()})}g.runAndSubscribeWithStore=Y;class ee{constructor(De,Ae){this.obs=De,this._counter=0,this._hasChanged=!1;const ae={onWillAddFirstListener:()=>{De.addObserver(this)},onDidRemoveLastListener:()=>{De.removeObserver(this)}};Ae||i(ae),this.emitter=new d(ae),Ae&&Ae.add(this.emitter)}beginUpdate(De){this._counter++}handleChange(De,Ae){this._hasChanged=!0}endUpdate(De){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function me(be,De){return new ee(be,De).emitter.event}g.fromObservable=me})(C=e.Event||(e.Event={}));class L{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${L._idPool++}`,L.all.add(this)}start(i){this._stopWatch=new w.StopWatch(!0),this.listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this._stopWatch=void 0}}}L.all=new Set,L._idPool=0,e.EventProfiling=L;let k=-1;function b(g){const i=k;return k=g,{dispose(){k=i}}}e.setGlobalLeakWarningThreshold=b;class I{constructor(i,t=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=t,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(i,t){const h=this.threshold;if(h<=0||t<h)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let E,O=0;for(const[$,H]of this._stacks)(!E||O<H)&&(E=$,O=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${O}):`),console.warn(E)}return()=>{const E=this._stacks.get(i.value)||0;this._stacks.set(i.value,E-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(i,t,h){this.callback=i,this.callbackThis=t,this.stack=h,this.subscription=new l.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class d{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=k>0||this._options?.leakWarningThreshold?new I(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const t of i)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,t,h)=>{if(this._listeners||(this._listeners=new A.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const _=this._listeners.isEmpty();_&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let E,O;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(O=y.create(),E=this._leakageMon.check(O,this._listeners.size+1)),P&&(O=O??y.create());const $=new f(i,t,O),H=this._listeners.push($);_&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,i,t);const X=$.subscription.set(()=>{E?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),H(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return h instanceof l.DisposableStore?h.add(X):Array.isArray(h)&&h.push(X),X}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const t of this._listeners)this._deliveryQueue.push(this,t,i);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=d;class u{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(i,t,h){this._queue.push(new v(i,t,h))}clear(i){const t=new A.LinkedList;for(const h of this._queue)h.emitter!==i&&t.push(h);this._queue=t}deliver(){for(;this._queue.size>0;){const i=this._queue.shift();try{i.listener.invoke(i.event)}catch(t){(0,o.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=u;class m extends u{clear(i){this._queue.clear()}}class v{constructor(i,t,h){this.emitter=i,this.listener=t,this.event=h}}class D extends d{async fireAsync(i,t,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,i]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[_,E]=this._asyncDeliveryQueue.shift(),O=[],$={...E,token:t,waitUntil:H=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");h&&(H=h(H,_.callback)),O.push(H)}};try{_.invoke($)}catch(H){(0,o.onUnexpectedError)(H);continue}Object.freeze(O),await Promise.allSettled(O).then(H=>{for(const X of H)X.status==="rejected"&&(0,o.onUnexpectedError)(X.reason)})}}}}e.AsyncEmitter=D;class p extends d{constructor(i){super(i),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=p;class n extends p{constructor(i){super(i),this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=n;class s extends d{constructor(i){super(i),this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){!this.hasListeners()||(this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const t={event:i,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const h=()=>{this.hasListeners&&this.unhook(t);const _=this.events.indexOf(t);this.events.splice(_,1)};return(0,l.toDisposable)((0,R.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(t=>this.emitter.fire(t))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(i){return(t,h,_)=>i(E=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>t.call(h,E)):t.call(h,E)},void 0,_)}bufferEvents(i){const t=[];this.buffers.push(t);const h=i();return this.buffers.pop(),t.forEach(_=>_()),h}}e.EventBufferer=a;class c{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=l.Disposable.None,this.emitter=new d({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Se[161],ye([1,0,3,6,156]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends R.Disposable{constructor(b,I="",y="",f=!0,d){super(),this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=b,this._label=I,this._cssClass=y,this._enabled=f,this._actionCallback=d}get id(){return this._id}get label(){return this._label}set label(b){this._setLabel(b)}_setLabel(b){this._label!==b&&(this._label=b,this._onDidChange.fire({label:b}))}get tooltip(){return this._tooltip||""}set tooltip(b){this._setTooltip(b)}_setTooltip(b){this._tooltip!==b&&(this._tooltip=b,this._onDidChange.fire({tooltip:b}))}get class(){return this._cssClass}set class(b){this._setClass(b)}_setClass(b){this._cssClass!==b&&(this._cssClass=b,this._onDidChange.fire({class:b}))}get enabled(){return this._enabled}set enabled(b){this._setEnabled(b)}_setEnabled(b){this._enabled!==b&&(this._enabled=b,this._onDidChange.fire({enabled:b}))}get checked(){return this._checked}set checked(b){this._setChecked(b)}_setChecked(b){this._checked!==b&&(this._checked=b,this._onDidChange.fire({checked:b}))}async run(b,I){this._actionCallback&&await this._actionCallback(b)}}e.Action=A;class w extends R.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new o.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new o.Emitter),this.onDidRun=this._onDidRun.event}async run(b,I){if(!b.enabled)return;this._onWillRun.fire({action:b});let y;try{await this.runAction(b,I)}catch(f){y=f}this._onDidRun.fire({action:b,error:y})}async runAction(b,I){await b.run(I)}}e.ActionRunner=w;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let I=[];for(const y of b)y.length&&(I.length?I=[...I,new P,...y]:I=y);return I}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class S{get actions(){return this._actions}constructor(b,I,y,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=I,this.class=f,this._actions=y}async run(){}}e.SubmenuAction=S;class C extends A{constructor(){super(C.ID,l.localize(0,null),void 0,!1)}}C.ID="vs.actions.empty",e.EmptySubmenuAction=C;function L(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=L}),define(Se[21],ye([1,0,3]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,S){const C=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(C)}}});var l;(function(P){function S(C){return C===P.None||C===P.Cancelled||C instanceof A?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(l=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new o.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class w{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=l.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=l.None}}e.CancellationTokenSource=w}),define(Se[162],ye([1,0,21]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new o.CancellationTokenSource,S=this.task(P.token);return this.result={promise:S,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=R;class l{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const S=JSON.stringify(P);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=l;class A{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const S=this.fn(P);return this._map.set(P,S),S}}e.CachedFunction=A}),define(Se[8],ye([1,0,162,65]),function(re,e,o,R){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=A;const w=/{(\d+)}/g;function P(x,...G){return G.length===0?x:x.replace(w,function(he,Re){const Oe=parseInt(Re,10);return isNaN(Oe)||Oe<0||Oe>=G.length?he:G[Oe]})}e.format=P;const S=/{([^}]+)}/g;function C(x,G){return x.replace(S,(he,Re)=>G[Re]??he)}e.format2=C;function L(x){return x.replace(/[<>&]/g,function(G){switch(G){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return G}})}e.escape=L;function k(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function b(x,G){let he=0;const Re=G.charCodeAt(0);for(let Oe=x.length-1;Oe>=0;Oe--)x.charCodeAt(Oe)===Re&&he++;return he}e.count=b;function I(x,G,he="\u2026"){return x.length<=G?x:`${x.substr(0,G)}${he}`}e.truncate=I;function y(x,G=" "){const he=f(x,G);return d(he,G)}e.trim=y;function f(x,G){if(!x||!G)return x;const he=G.length;if(he===0||x.length===0)return x;let Re=0;for(;x.indexOf(G,Re)===Re;)Re=Re+he;return x.substring(Re)}e.ltrim=f;function d(x,G){if(!x||!G)return x;const he=G.length,Re=x.length;if(he===0||Re===0)return x;let Oe=Re,Ve=-1;for(;Ve=x.lastIndexOf(G,Oe-1),!(Ve===-1||Ve+he!==Oe);){if(Ve===0)return"";Oe=Ve}return x.substring(0,Oe)}e.rtrim=d;function u(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(x){return x.replace(/\*/g,"")}e.stripWildcards=m;function v(x,G,he={}){if(!x)throw new Error("Cannot create regex from empty string");G||(x=k(x)),he.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Re="";return he.global&&(Re+="g"),he.matchCase||(Re+="i"),he.multiline&&(Re+="m"),he.unicode&&(Re+="u"),new RegExp(x,Re)}e.createRegExp=v;function D(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function p(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function n(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=n;function s(x){return x.split(/\r\n|\r|\n/)}e.splitLines=s;function r(x){for(let G=0,he=x.length;G<he;G++){const Re=x.charCodeAt(G);if(Re!==32&&Re!==9)return G}return-1}e.firstNonWhitespaceIndex=r;function a(x,G=0,he=x.length){for(let Re=G;Re<he;Re++){const Oe=x.charCodeAt(Re);if(Oe!==32&&Oe!==9)return x.substring(G,Re)}return x.substring(G,he)}e.getLeadingWhitespace=a;function c(x,G=x.length-1){for(let he=G;he>=0;he--){const Re=x.charCodeAt(he);if(Re!==32&&Re!==9)return he}return-1}e.lastNonWhitespaceIndex=c;function g(x,G,he){const Re=[];let Oe=0;for(const Ve of x.matchAll(G)){if(Re.push(x.slice(Oe,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");Oe=Ve.index+Ve[0].length,Re.push(he(Ve[0],...Ve.slice(1),Ve.index,x,Ve.groups))}return Re.push(x.slice(Oe)),Promise.all(Re).then(Ve=>Ve.join(""))}e.replaceAsync=g;function i(x,G){return x<G?-1:x>G?1:0}e.compare=i;function t(x,G,he=0,Re=x.length,Oe=0,Ve=G.length){for(;he<Re&&Oe<Ve;he++,Oe++){const st=x.charCodeAt(he),at=G.charCodeAt(Oe);if(st<at)return-1;if(st>at)return 1}const $e=Re-he,Ze=Ve-Oe;return $e<Ze?-1:$e>Ze?1:0}e.compareSubstring=t;function h(x,G){return _(x,G,0,x.length,0,G.length)}e.compareIgnoreCase=h;function _(x,G,he=0,Re=x.length,Oe=0,Ve=G.length){for(;he<Re&&Oe<Ve;he++,Oe++){let st=x.charCodeAt(he),at=G.charCodeAt(Oe);if(st===at)continue;if(st>=128||at>=128)return t(x.toLowerCase(),G.toLowerCase(),he,Re,Oe,Ve);O(st)&&(st-=32),O(at)&&(at-=32);const mt=st-at;if(mt!==0)return mt}const $e=Re-he,Ze=Ve-Oe;return $e<Ze?-1:$e>Ze?1:0}e.compareSubstringIgnoreCase=_;function E(x){return x>=48&&x<=57}e.isAsciiDigit=E;function O(x){return x>=97&&x<=122}e.isLowerAsciiLetter=O;function $(x){return x>=65&&x<=90}e.isUpperAsciiLetter=$;function H(x,G){return x.length===G.length&&_(x,G)===0}e.equalsIgnoreCase=H;function X(x,G){const he=G.length;return G.length>x.length?!1:_(x,G,0,he)===0}e.startsWithIgnoreCase=X;function V(x,G){const he=Math.min(x.length,G.length);let Re;for(Re=0;Re<he;Re++)if(x.charCodeAt(Re)!==G.charCodeAt(Re))return Re;return he}e.commonPrefixLength=V;function N(x,G){const he=Math.min(x.length,G.length);let Re;const Oe=x.length-1,Ve=G.length-1;for(Re=0;Re<he;Re++)if(x.charCodeAt(Oe-Re)!==G.charCodeAt(Ve-Re))return Re;return he}e.commonSuffixLength=N;function T(x){return 55296<=x&&x<=56319}e.isHighSurrogate=T;function F(x){return 56320<=x&&x<=57343}e.isLowSurrogate=F;function U(x,G){return(x-55296<<10)+(G-56320)+65536}e.computeCodePoint=U;function Z(x,G,he){const Re=x.charCodeAt(he);if(T(Re)&&he+1<G){const Oe=x.charCodeAt(he+1);if(F(Oe))return U(Re,Oe)}return Re}e.getNextCodePoint=Z;function J(x,G){const he=x.charCodeAt(G-1);if(F(he)&&G>1){const Re=x.charCodeAt(G-2);if(T(Re))return U(Re,he)}return he}class z{get offset(){return this._offset}constructor(G,he=0){this._str=G,this._len=G.length,this._offset=he}setOffset(G){this._offset=G}prevCodePoint(){const G=J(this._str,this._offset);return this._offset-=G>=65536?2:1,G}nextCodePoint(){const G=Z(this._str,this._len,this._offset);return this._offset+=G>=65536?2:1,G}eol(){return this._offset>=this._len}}e.CodePointIterator=z;class Q{get offset(){return this._iterator.offset}constructor(G,he=0){this._iterator=new z(G,he)}nextGraphemeLength(){const G=ze.getInstance(),he=this._iterator,Re=he.offset;let Oe=G.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Ve=he.offset,$e=G.getGraphemeBreakType(he.nextCodePoint());if(Ce(Oe,$e)){he.setOffset(Ve);break}Oe=$e}return he.offset-Re}prevGraphemeLength(){const G=ze.getInstance(),he=this._iterator,Re=he.offset;let Oe=G.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Ve=he.offset,$e=G.getGraphemeBreakType(he.prevCodePoint());if(Ce($e,Oe)){he.setOffset(Ve);break}Oe=$e}return Re-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function ie(x,G){return new Q(x,G).nextGraphemeLength()}e.nextCharLength=ie;function ge(x,G){return new Q(x,G).prevGraphemeLength()}e.prevCharLength=ge;function K(x,G){G>0&&F(x.charCodeAt(G))&&G--;const he=G+ie(x,G);return[he-ge(x,he),he]}e.getCharContainingOffset=K;function Y(x){const G=new Q(x);let he=0;for(;!G.eol();)he++,G.nextGraphemeLength();return he}e.charCount=Y;let ee;function me(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(x){return ee||(ee=me()),ee.test(x)}e.containsRTL=be;const De=/^[\t\n\r\x20-\x7E]*$/;function Ae(x){return De.test(x)}e.isBasicASCII=Ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ae(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ae;function le(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=le;function ue(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}e.isEmojiImprecise=ue;function ne(x,G){if(x.length<G)return x;const he=/\b/g;let Re=0;for(;he.test(x)&&!(x.length-he.lastIndex<G);)Re=he.lastIndex,he.lastIndex+=1;return x.substring(Re).replace(/^\s/,"")}e.lcut=ne;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function oe(x){return x&&(x=x.replace(ce,"")),x}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function M(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=M;function B(x){return M(x)?x.substr(1):x}e.stripUTF8BOM=B;function q(x,G){if(!x||!G||x.length<G.length)return!1;const he=G.length,Re=x.toLowerCase();let Oe=0,Ve=-1;for(;Oe<he;){const $e=Re.indexOf(G[Oe],Ve+1);if($e<0)return!1;Ve=$e,Oe++}return!0}e.fuzzyContains=q;function te(x,G=!1){return x?(G&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=te;function de(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=de;function Ee(x,G=1){if(G===0)return"";let he=-1;do he=x.indexOf(`
`,he+1),G--;while(G>0&&he>=0);return he===-1?x:(x[he-1]==="\r"&&he--,x.substr(0,he))}e.getNLines=Ee;function Te(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}e.singleLetterHash=Te;function ve(x){return ze.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=ve;function Ce(x,G){return x===0?G!==5&&G!==7:x===2&&G===3?!1:x===4||x===2||x===3||G===4||G===2||G===3?!0:!(x===8&&(G===8||G===9||G===11||G===12)||(x===11||x===9)&&(G===9||G===10)||(x===12||x===10)&&G===10||G===5||G===13||G===7||x===1||x===13&&G===14||x===6&&G===6)}var Ie;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(G){if(G<32)return G===10?3:G===13?2:4;if(G<127)return 0;const he=this._data,Re=he.length/3;let Oe=1;for(;Oe<=Re;)if(G<he[3*Oe])Oe=2*Oe;else if(G>he[3*Oe+1])Oe=2*Oe+1;else return he[3*Oe+2];return 0}}ze._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(x,G){if(x===0)return 0;const he=Xe(x,G);if(he!==void 0)return he;const Re=new z(G,x);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=nt;function Xe(x,G){const he=new z(G,x);let Re=he.prevCodePoint();for(;tt(Re)||Re===65039||Re===8419;){if(he.offset===0)return;Re=he.prevCodePoint()}if(!ue(Re))return;let Oe=he.offset;return Oe>0&&he.prevCodePoint()===8205&&(Oe=he.offset),Oe}function tt(x){return 127995<=x&&x<=127999}var rt;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Ue{static getInstance(G){return Ue.cache.get(Array.from(G))}static getLocales(){return Ue._locales.value}constructor(G){this.confusableDictionary=G}isAmbiguous(G){return this.confusableDictionary.has(G)}getPrimaryConfusable(G){return this.confusableDictionary.get(G)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}l=Ue,Ue.ambiguousCharacterData=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new o.LRUCachedFunction(x=>{function G(at){const mt=new Map;for(let gt=0;gt<at.length;gt+=2)mt.set(at[gt],at[gt+1]);return mt}function he(at,mt){const gt=new Map(at);for(const[wt,lt]of mt)gt.set(wt,lt);return gt}function Re(at,mt){if(!at)return mt;const gt=new Map;for(const[wt,lt]of at)mt.has(wt)&&gt.set(wt,lt);return gt}const Oe=l.ambiguousCharacterData.value;let Ve=x.filter(at=>!at.startsWith("_")&&at in Oe);Ve.length===0&&(Ve=["_default"]);let $e;for(const at of Ve){const mt=G(Oe[at]);$e=Re($e,mt)}const Ze=G(Oe._common),st=he(Ze,$e);return new Ue(st)}),Ue._locales=new R.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.value).filter(x=>!x.startsWith("_"))),e.AmbiguousCharacters=Ue;class it{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(it.getRawData())),this._data}static isInvisibleCharacter(G){return it.getData().has(G)}static get codePoints(){return it.getData()}}it._data=void 0,e.InvisibleCharacters=it}),define(Se[34],ye([1,0,12,11,8,9]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function w(c){return c===47||c===92}e.isPathSeparator=w;function P(c){return c.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=P;function S(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=S;function C(c,g=o.posix.sep){if(!c)return"";const i=c.length,t=c.charCodeAt(0);if(w(t)){if(w(c.charCodeAt(1))&&!w(c.charCodeAt(2))){let _=3;const E=_;for(;_<i&&!w(c.charCodeAt(_));_++);if(E!==_&&!w(c.charCodeAt(_+1))){for(_+=1;_<i;_++)if(w(c.charCodeAt(_)))return c.slice(0,_+1).replace(/[\\/]/g,g)}}return g}else if(u(t)&&c.charCodeAt(1)===58)return w(c.charCodeAt(2))?c.slice(0,2)+g:c.slice(0,2);let h=c.indexOf("://");if(h!==-1){for(h+=3;h<i;h++)if(w(c.charCodeAt(h)))return c.slice(0,h+1)}return""}e.getRoot=C;function L(c){if(!R.isWindows||!c||c.length<5)return!1;let g=c.charCodeAt(0);if(g!==92||(g=c.charCodeAt(1),g!==92))return!1;let i=2;const t=i;for(;i<c.length&&(g=c.charCodeAt(i),g!==92);i++);return!(t===i||(g=c.charCodeAt(i+1),isNaN(g)||g===92))}e.isUNC=L;const k=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(c,g=R.isWindows){const i=g?k:b;return!(!c||c.length===0||/^\s+$/.test(c)||(i.lastIndex=0,i.test(c))||g&&I.test(c)||c==="."||c===".."||g&&c[c.length-1]==="."||g&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=y;function f(c,g,i){const t=c===g;return!i||t?t:!c||!g?!1:(0,l.equalsIgnoreCase)(c,g)}e.isEqual=f;function d(c,g,i,t=o.sep){if(c===g)return!0;if(!c||!g||g.length>c.length)return!1;if(i){if(!(0,l.startsWithIgnoreCase)(c,g))return!1;if(g.length===c.length)return!0;let _=g.length;return g.charAt(g.length-1)===t&&_--,c.charAt(_)===t}return g.charAt(g.length-1)!==t&&(g+=t),c.indexOf(g)===0}e.isEqualOrParent=d;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=u;function m(c,g){return R.isWindows&&c.endsWith(":")&&(c+=o.sep),(0,o.isAbsolute)(c)||(c=(0,o.join)(g,c)),c=(0,o.normalize)(c),R.isWindows?(c=(0,l.rtrim)(c,o.sep),c.endsWith(":")&&(c+=o.sep)):(c=(0,l.rtrim)(c,o.sep),c||(c=o.sep)),c}e.sanitizeFilePath=m;function v(c){const g=(0,o.normalize)(c);return R.isWindows?c.length>3?!1:D(g)&&(c.length===2||g.charCodeAt(2)===92):g===o.posix.sep}e.isRootOrDriveLetter=v;function D(c,g=R.isWindows){return g?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function p(c){return D(c)?c[0]:void 0}e.getDriveLetter=p;function n(c,g,i){return g.length>c.length?-1:c===g?0:(i&&(c=c.toLowerCase(),g=g.toLowerCase()),c.indexOf(g))}e.indexOfPath=n;function s(c){const g=c.split(":");let i,t,h;for(const _ of g){const E=Number(_);(0,A.isNumber)(E)?t===void 0?t=E:h===void 0&&(h=E):i=i?[i,_].join(":"):_}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:t!==void 0?t:void 0,column:h!==void 0?h:t!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(c,g,i=8){let t="";for(let _=0;_<i;_++)t+=r.charAt(Math.floor(Math.random()*r.length));let h;return g?h=`${g}-${t}`:h=t,c?(0,o.join)(c,h):h}e.randomPath=a}),define(Se[110],ye([1,0,28,8]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...oe){return function(M,B){for(let q=0,te=oe.length;q<te;q++){const de=oe[q](M,B);if(de)return de}return null}}e.or=l,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(oe,M,B){if(!B||B.length<M.length)return null;let q;return oe?q=R.startsWithIgnoreCase(B,M):q=B.indexOf(M)===0,q?M.length>0?[{start:0,end:M.length}]:[]:null}function w(oe,M){const B=M.toLowerCase().indexOf(oe.toLowerCase());return B===-1?null:[{start:B,end:B+oe.length}]}e.matchesContiguousSubString=w;function P(oe,M){return S(oe.toLowerCase(),M.toLowerCase(),0,0)}e.matchesSubString=P;function S(oe,M,B,q){if(B===oe.length)return[];if(q===M.length)return null;if(oe[B]===M[q]){let te=null;return(te=S(oe,M,B+1,q+1))?u({start:q,end:q+1},te):null}return S(oe,M,B,q+1)}function C(oe){return 97<=oe&&oe<=122}function L(oe){return 65<=oe&&oe<=90}e.isUpper=L;function k(oe){return 48<=oe&&oe<=57}function b(oe){return oe===32||oe===9||oe===10||oe===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>I.add(oe.charCodeAt(0)));function y(oe){return b(oe)||I.has(oe)}function f(oe,M){return oe===M||y(oe)&&y(M)}function d(oe){return C(oe)||L(oe)||k(oe)}function u(oe,M){return M.length===0?M=[oe]:oe.end===M[0].start?M[0].start=oe.start:M.unshift(oe),M}function m(oe,M){for(let B=M;B<oe.length;B++){const q=oe.charCodeAt(B);if(L(q)||k(q)||B>0&&!d(oe.charCodeAt(B-1)))return B}return oe.length}function v(oe,M,B,q){if(B===oe.length)return[];if(q===M.length)return null;if(oe[B]!==M[q].toLowerCase())return null;{let te=null,de=q+1;for(te=v(oe,M,B+1,q+1);!te&&(de=m(M,de))<M.length;)te=v(oe,M,B+1,de),de++;return te===null?null:u({start:q,end:q+1},te)}}function D(oe){let M=0,B=0,q=0,te=0,de=0;for(let Ie=0;Ie<oe.length;Ie++)de=oe.charCodeAt(Ie),L(de)&&M++,C(de)&&B++,d(de)&&q++,k(de)&&te++;const Ee=M/oe.length,Te=B/oe.length,ve=q/oe.length,Ce=te/oe.length;return{upperPercent:Ee,lowerPercent:Te,alphaPercent:ve,numericPercent:Ce}}function p(oe){const{upperPercent:M,lowerPercent:B}=oe;return B===0&&M>.6}function n(oe){const{upperPercent:M,lowerPercent:B,alphaPercent:q,numericPercent:te}=oe;return B>.2&&M<.8&&q>.6&&te<.2}function s(oe){let M=0,B=0,q=0,te=0;for(let de=0;de<oe.length;de++)q=oe.charCodeAt(de),L(q)&&M++,C(q)&&B++,b(q)&&te++;return(M===0||B===0)&&te===0?oe.length<=30:M<=5}function r(oe,M){if(!M||(M=M.trim(),M.length===0)||!s(oe)||M.length>60)return null;const B=D(M);if(!n(B)){if(!p(B))return null;M=M.toLowerCase()}let q=null,te=0;for(oe=oe.toLowerCase();te<M.length&&(q=v(oe,M,0,te))===null;)te=m(M,te+1);return q}e.matchesCamelCase=r;function a(oe,M,B=!1){if(!M||M.length===0)return null;let q=null,te=0;for(oe=oe.toLowerCase(),M=M.toLowerCase();te<M.length&&(q=c(oe,M,0,te,B))===null;)te=g(M,te+1);return q}e.matchesWords=a;function c(oe,M,B,q,te){if(B===oe.length)return[];if(q===M.length)return null;if(f(oe.charCodeAt(B),M.charCodeAt(q))){let de=null,Ee=q+1;if(de=c(oe,M,B+1,q+1,te),!te)for(;!de&&(Ee=g(M,Ee))<M.length;)de=c(oe,M,B+1,Ee,te),Ee++;return de?oe.charCodeAt(B)!==M.charCodeAt(q)?de:u({start:q,end:q+1},de):null}else return null}function g(oe,M){for(let B=M;B<oe.length;B++)if(y(oe.charCodeAt(B))||B>0&&y(oe.charCodeAt(B-1)))return B;return oe.length}const i=l(e.matchesPrefix,r,w),t=l(e.matchesPrefix,r,P),h=new o.LRUCache(1e4);function _(oe,M,B=!1){if(typeof oe!="string"||typeof M!="string")return null;let q=h.get(oe);q||(q=new RegExp(R.convertSimple2RegExpPattern(oe),"i"),h.set(oe,q));const te=q.exec(M);return te?[{start:te.index,end:te.index+te[0].length}]:B?t(oe,M):i(oe,M)}e.matchesFuzzy=_;function E(oe,M){const B=De(oe,oe.toLowerCase(),0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?$(B):null}e.matchesFuzzy2=E;function O(oe,M,B,q,te,de){const Ee=Math.min(13,oe.length);for(;B<Ee;B++){const Te=De(oe,M,B,q,te,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Te)return Te}return[0,de]}e.anyScore=O;function $(oe){if(typeof oe>"u")return[];const M=[],B=oe[1];for(let q=oe.length-1;q>1;q--){const te=oe[q]+B,de=M[M.length-1];de&&de.end===te?de.end=te+1:M.push({start:te,end:te+1})}return M}e.createMatches=$;const H=128;function X(){const oe=[],M=[];for(let B=0;B<=H;B++)M[B]=0;for(let B=0;B<=H;B++)oe.push(M.slice(0));return oe}function V(oe){const M=[];for(let B=0;B<=oe;B++)M[B]=0;return M}const N=V(2*H),T=V(2*H),F=X(),U=X(),Z=X(),J=!1;function z(oe,M,B,q,te){function de(Te,ve,Ce=" "){for(;Te.length<ve;)Te=Ce+Te;return Te}let Ee=` |   |${q.split("").map(Te=>de(Te,3)).join("|")}
`;for(let Te=0;Te<=B;Te++)Te===0?Ee+=" |":Ee+=`${M[Te-1]}|`,Ee+=oe[Te].slice(0,te+1).map(ve=>de(ve.toString(),3)).join("|")+`
`;return Ee}function Q(oe,M,B,q){oe=oe.substr(M),B=B.substr(q),console.log(z(U,oe,oe.length,B,B.length)),console.log(z(Z,oe,oe.length,B,B.length)),console.log(z(F,oe,oe.length,B,B.length))}function ie(oe,M){if(M<0||M>=oe.length)return!1;const B=oe.codePointAt(M);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(B)}}function ge(oe,M){if(M<0||M>=oe.length)return!1;switch(oe.charCodeAt(M)){case 32:case 9:return!0;default:return!1}}function K(oe,M,B){return M[oe]!==B[oe]}function Y(oe,M,B,q,te,de,Ee=!1){for(;M<B&&te<de;)oe[M]===q[te]&&(Ee&&(N[M]=te),M+=1),te+=1;return M===B}e.isPatternInWord=Y;var ee;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var me;(function(oe){oe.Default=[-100,0];function M(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}oe.isDefault=M})(me=e.FuzzyScore||(e.FuzzyScore={}));class be{constructor(M,B){this.firstMatchCanBeWeak=M,this.boostFullMatch=B}}be.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=be;function De(oe,M,B,q,te,de,Ee=be.default){const Te=oe.length>H?H:oe.length,ve=q.length>H?H:q.length;if(B>=Te||de>=ve||Te-B>ve-de||!Y(M,B,Te,te,de,ve,!0))return;Ae(Te,ve,B,de,M,te);let Ce=1,Ie=1,ze=B,qe=de;const nt=[!1];for(Ce=1,ze=B;ze<Te;Ce++,ze++){const it=N[ze],x=T[ze],G=ze+1<Te?T[ze+1]:ve;for(Ie=it-de+1,qe=it;qe<G;Ie++,qe++){let he=Number.MIN_SAFE_INTEGER,Re=!1;qe<=x&&(he=ae(oe,M,ze,B,q,te,qe,ve,de,F[Ce-1][Ie-1]===0,nt));let Oe=0;he!==Number.MAX_SAFE_INTEGER&&(Re=!0,Oe=he+U[Ce-1][Ie-1]);const Ve=qe>it,$e=Ve?U[Ce][Ie-1]+(F[Ce][Ie-1]>0?-5:0):0,Ze=qe>it+1&&F[Ce][Ie-1]>0,st=Ze?U[Ce][Ie-2]+(F[Ce][Ie-2]>0?-5:0):0;if(Ze&&(!Ve||st>=$e)&&(!Re||st>=Oe))U[Ce][Ie]=st,Z[Ce][Ie]=3,F[Ce][Ie]=0;else if(Ve&&(!Re||$e>=Oe))U[Ce][Ie]=$e,Z[Ce][Ie]=2,F[Ce][Ie]=0;else if(Re)U[Ce][Ie]=Oe,Z[Ce][Ie]=1,F[Ce][Ie]=F[Ce-1][Ie-1]+1;else throw new Error("not possible")}}if(J&&Q(oe,B,q,de),!nt[0]&&!Ee.firstMatchCanBeWeak)return;Ce--,Ie--;const Xe=[U[Ce][Ie],de];let tt=0,rt=0;for(;Ce>=1;){let it=Ie;do{const x=Z[Ce][it];if(x===3)it=it-2;else if(x===2)it=it-1;else break}while(it>=1);tt>1&&M[B+Ce-1]===te[de+Ie-1]&&!K(it+de-1,q,te)&&tt+1>F[Ce][it]&&(it=Ie),it===Ie?tt++:tt=1,rt||(rt=it),Ce--,Ie=it-1,Xe.push(Ie)}ve===Te&&Ee.boostFullMatch&&(Xe[0]+=2);const Ue=rt-Te;return Xe[0]-=Ue,Xe}e.fuzzyScore=De;function Ae(oe,M,B,q,te,de){let Ee=oe-1,Te=M-1;for(;Ee>=B&&Te>=q;)te[Ee]===de[Te]&&(T[Ee]=Te,Ee--),Te--}function ae(oe,M,B,q,te,de,Ee,Te,ve,Ce,Ie){if(M[B]!==de[Ee])return Number.MIN_SAFE_INTEGER;let ze=1,qe=!1;return Ee===B-q?ze=oe[B]===te[Ee]?7:5:K(Ee,te,de)&&(Ee===0||!K(Ee-1,te,de))?(ze=oe[B]===te[Ee]?7:5,qe=!0):ie(de,Ee)&&(Ee===0||!ie(de,Ee-1))?ze=5:(ie(de,Ee-1)||ge(de,Ee-1))&&(ze=5,qe=!0),ze>1&&B===q&&(Ie[0]=!0),qe||(qe=K(Ee,te,de)||ie(de,Ee-1)||ge(de,Ee-1)),B===q?Ee>ve&&(ze-=qe?3:5):Ce?ze+=qe?2:0:ze+=qe?0:1,Ee+1===Te&&(ze-=qe?3:5),ze}function le(oe,M,B,q,te,de,Ee){return ne(oe,M,B,q,te,de,!0,Ee)}e.fuzzyScoreGracefulAggressive=le;function ue(oe,M,B,q,te,de,Ee){return ne(oe,M,B,q,te,de,!1,Ee)}e.fuzzyScoreGraceful=ue;function ne(oe,M,B,q,te,de,Ee,Te){let ve=De(oe,M,B,q,te,de,Te);if(ve&&!Ee)return ve;if(oe.length>=3){const Ce=Math.min(7,oe.length-1);for(let Ie=B+1;Ie<Ce;Ie++){const ze=ce(oe,Ie);if(ze){const qe=De(ze,ze.toLowerCase(),B,q,te,de,Te);qe&&(qe[0]-=3,(!ve||qe[0]>ve[0])&&(ve=qe))}}}return ve}function ce(oe,M){if(M+1>=oe.length)return;const B=oe[M],q=oe[M+1];if(B!==q)return oe.slice(0,M)+q+B+oe.slice(M+2)}}),define(Se[89],ye([1,0,8]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(u){return l(u,0)}e.hash=R;function l(u,m){switch(typeof u){case"object":return u===null?A(349,m):Array.isArray(u)?S(u,m):C(u,m);case"string":return P(u,m);case"boolean":return w(u,m);case"number":return A(u,m);case"undefined":return A(937,m);default:return A(617,m)}}e.doHash=l;function A(u,m){return(m<<5)-m+u|0}e.numberHash=A;function w(u,m){return A(u?433:863,m)}function P(u,m){m=A(149417,m);for(let v=0,D=u.length;v<D;v++)m=A(u.charCodeAt(v),m);return m}e.stringHash=P;function S(u,m){return m=A(104579,m),u.reduce((v,D)=>l(D,v),m)}function C(u,m){return m=A(181387,m),Object.keys(u).sort().reduce((v,D)=>(v=P(D,v),l(u[D],v)),m)}class L{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=l(m,this._value),this._value}}e.Hasher=L;var k;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(u,m,v=32){const D=v-m,p=~((1<<D)-1);return(u<<m|(p&u)>>>D)>>>0}function I(u,m=0,v=u.byteLength,D=0){for(let p=0;p<v;p++)u[m+p]=D}function y(u,m,v="0"){for(;u.length<m;)u=v+u;return u}function f(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(v=>v.toString(16).padStart(2,"0")).join(""):y((u>>>0).toString(16),m/4)}e.toHexString=f;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const v=m.length;if(v===0)return;const D=this._buff;let p=this._buffLen,n=this._leftoverHighSurrogate,s,r;for(n!==0?(s=n,r=-1,n=0):(s=m.charCodeAt(0),r=0);;){let a=s;if(o.isHighSurrogate(s))if(r+1<v){const c=m.charCodeAt(r+1);o.isLowSurrogate(c)?(r++,a=o.computeCodePoint(s,c)):a=65533}else{n=s;break}else o.isLowSurrogate(s)&&(a=65533);if(p=this._push(D,p,a),r++,r<v)s=m.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=n}_push(m,v,D){return D<128?m[v++]=D:D<2048?(m[v++]=192|(D&1984)>>>6,m[v++]=128|(D&63)>>>0):D<65536?(m[v++]=224|(D&61440)>>>12,m[v++]=128|(D&4032)>>>6,m[v++]=128|(D&63)>>>0):(m[v++]=240|(D&1835008)>>>18,m[v++]=128|(D&258048)>>>12,m[v++]=128|(D&4032)>>>6,m[v++]=128|(D&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,I(this._buff,this._buffLen),this._buffLen>56&&(this._step(),I(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=d._bigBlock32,v=this._buffDV;for(let i=0;i<64;i+=4)m.setUint32(i,v.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)m.setUint32(i,b(m.getUint32(i-12,!1)^m.getUint32(i-32,!1)^m.getUint32(i-56,!1)^m.getUint32(i-64,!1),1),!1);let D=this._h0,p=this._h1,n=this._h2,s=this._h3,r=this._h4,a,c,g;for(let i=0;i<80;i++)i<20?(a=p&n|~p&s,c=1518500249):i<40?(a=p^n^s,c=1859775393):i<60?(a=p&n|p&s|n&s,c=2400959708):(a=p^n^s,c=3395469782),g=b(D,5)+a+r+c+m.getUint32(i*4,!1)&4294967295,r=s,s=n,n=b(p,30),p=D,D=g;this._h0=this._h0+D&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}d._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=d}),define(Se[111],ye([1,0,108,110,89,12,11,8]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,C=[S,[]];function L(F,U,Z,J){if(!F||!U)return C;const z=F.length,Q=U.length;if(z<Q)return C;const ie=F.toLowerCase();return k(U,Z,Q,F,ie,z,J)}e.scoreFuzzy=L;function k(F,U,Z,J,z,Q,ie){const ge=[],K=[];for(let be=0;be<Z;be++){const De=be*Q,Ae=De-Q,ae=be>0,le=F[be],ue=U[be];for(let ne=0;ne<Q;ne++){const ce=ne>0,oe=De+ne,M=oe-1,B=Ae+ne-1,q=ce?ge[M]:0,te=ae&&ce?ge[B]:0,de=ae&&ce?K[B]:0;let Ee;!te&&ae?Ee=0:Ee=b(le,ue,J,z,ne,de),Ee&&te+Ee>=q&&(ie||ae||z.startsWith(U,ne))?(K[oe]=de+1,ge[oe]=te+Ee):(K[oe]=S,ge[oe]=q)}}const Y=[];let ee=Z-1,me=Q-1;for(;ee>=0&&me>=0;){const be=ee*Q+me;K[be]===S||(Y.push(me),ee--),me--}return[ge[Z*Q-1],Y.reverse()]}function b(F,U,Z,J,z,Q){let ie=0;if(!I(U,J[z]))return ie;if(ie+=1,Q>0&&(ie+=Q*5),F===Z[z]&&(ie+=1),z===0)ie+=8;else{const ge=y(Z.charCodeAt(z-1));ge?ie+=ge:(0,R.isUpper)(Z.charCodeAt(z))&&Q===0&&(ie+=2)}return ie}function I(F,U){return F===U?!0:F==="/"||F==="\\"?U==="/"||U==="\\":!1}function y(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(F,U,Z=0,J=0){const z=U;return z.values&&z.values.length>1?u(F,z.values,Z,J):m(F,U,Z,J)}e.scoreFuzzy2=d;function u(F,U,Z,J){let z=0;const Q=[];for(const ie of U){const[ge,K]=m(F,ie,Z,J);if(typeof ge!="number")return f;z+=ge,Q.push(...K)}return[z,t(Q)]}function m(F,U,Z,J){const z=(0,R.fuzzyScore)(U.original,U.originalLowercase,Z,F,F.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?[z[0],(0,R.createMatches)(z)]:f}const v=Object.freeze({score:0}),D=1<<18,p=1<<17,n=1<<16;function s(F,U,Z,J){const z=J.values?J.values:[J];return(0,l.hash)({[J.normalized]:{values:z.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:F,description:U,allowNonContiguousMatches:Z}})}function r(F,U,Z,J,z){if(!F||!U.normalized)return v;const Q=J.getItemLabel(F);if(!Q)return v;const ie=J.getItemDescription(F),ge=s(Q,ie,Z,U),K=z[ge];if(K)return K;const Y=a(Q,ie,J.getItemPath(F),U,Z);return z[ge]=Y,Y}e.scoreItemFuzzy=r;function a(F,U,Z,J,z){const Q=!Z||!J.containsPathSeparator;return Z&&(w.isLinux?J.pathNormalized===Z:(0,P.equalsIgnoreCase)(J.pathNormalized,Z))?{score:D,labelMatch:[{start:0,end:F.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:J.values&&J.values.length>1?c(F,U,Z,J.values,Q,z):g(F,U,Z,J,Q,z)}function c(F,U,Z,J,z,Q){let ie=0;const ge=[],K=[];for(const Y of J){const{score:ee,labelMatch:me,descriptionMatch:be}=g(F,U,Z,Y,z,Q);if(ee===S)return v;ie+=ee,me&&ge.push(...me),be&&K.push(...be)}return{score:ie,labelMatch:t(ge),descriptionMatch:t(K)}}function g(F,U,Z,J,z,Q){if(z||!U){const[ie,ge]=L(F,J.normalized,J.normalizedLowercase,Q&&!J.expectContiguousMatch);if(ie){const K=(0,R.matchesPrefix)(J.normalized,F);let Y;return K?(Y=p,Y+=Math.round(J.normalized.length/F.length*100)):Y=n,{score:Y+ie,labelMatch:K||i(ge)}}}if(U){let ie=U;Z&&(ie=`${U}${A.sep}`);const ge=ie.length,K=`${ie}${F}`,[Y,ee]=L(K,J.normalized,J.normalizedLowercase,Q&&!J.expectContiguousMatch);if(Y){const me=i(ee),be=[],De=[];return me.forEach(Ae=>{Ae.start<ge&&Ae.end>ge?(be.push({start:0,end:Ae.end-ge}),De.push({start:Ae.start,end:ge})):Ae.start>=ge?be.push({start:Ae.start-ge,end:Ae.end-ge}):De.push(Ae)}),{score:Y,labelMatch:be,descriptionMatch:De}}}return v}function i(F){const U=[];if(!F)return U;let Z;for(const J of F)Z&&Z.end===J?Z.end+=1:(Z={start:J,end:J+1},U.push(Z));return U}function t(F){const U=F.sort((z,Q)=>z.start-Q.start),Z=[];let J;for(const z of U)!J||!h(J,z)?(J=z,Z.push(z)):(J.start=Math.min(J.start,z.start),J.end=Math.max(J.end,z.end));return Z}function h(F,U){return!(F.end<U.start||U.end<F.start)}function _(F,U,Z,J,z,Q){const ie=r(F,Z,J,z,Q),ge=r(U,Z,J,z,Q),K=ie.score,Y=ge.score;if((K===D||Y===D)&&K!==Y)return K===D?-1:1;if(K>n||Y>n){if(K!==Y)return K>Y?-1:1;if(K<p&&Y<p){const le=O(ie.labelMatch,ge.labelMatch);if(le!==0)return le}const Ae=z.getItemLabel(F)||"",ae=z.getItemLabel(U)||"";if(Ae.length!==ae.length)return Ae.length-ae.length}if(K!==Y)return K>Y?-1:1;const ee=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,me=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(ee&&!me)return-1;if(me&&!ee)return 1;const be=E(F,ie,z),De=E(U,ge,z);return be&&De&&be!==De?De>be?-1:1:$(F,U,Z,z)}e.compareItemsByFuzzyScore=_;function E(F,U,Z){let J=-1,z=-1;if(U.descriptionMatch&&U.descriptionMatch.length?J=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(J=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(z=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const Q=Z.getItemDescription(F);Q&&(z+=Q.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(z=U.descriptionMatch[U.descriptionMatch.length-1].end);return z-J}function O(F,U){if(!F&&!U||(!F||!F.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!F||!F.length)return 1;const Z=F[0].start,z=F[F.length-1].end-Z,Q=U[0].start,ge=U[U.length-1].end-Q;return z===ge?0:ge<z?1:-1}function $(F,U,Z,J){const z=J.getItemLabel(F)||"",Q=J.getItemLabel(U)||"",ie=J.getItemDescription(F),ge=J.getItemDescription(U),K=z.length+(ie?ie.length:0),Y=Q.length+(ge?ge.length:0);if(K!==Y)return K-Y;const ee=J.getItemPath(F),me=J.getItemPath(U);return ee&&me&&ee.length!==me.length?ee.length-me.length:z!==Q?(0,o.compareAnything)(z,Q,Z.normalized):ie&&ge&&ie!==ge?(0,o.compareAnything)(ie,ge,Z.normalized):ee&&me&&ee!==me?(0,o.compareAnything)(ee,me,Z.normalized):0}function H(F){return F.startsWith('"')&&F.endsWith('"')}const X=" ";function V(F){typeof F!="string"&&(F="");const U=F.toLowerCase(),{pathNormalized:Z,normalized:J,normalizedLowercase:z}=N(F),Q=Z.indexOf(A.sep)>=0,ie=H(F);let ge;const K=F.split(X);if(K.length>1)for(const Y of K){const ee=H(Y),{pathNormalized:me,normalized:be,normalizedLowercase:De}=N(Y);be&&(ge||(ge=[]),ge.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:me,normalized:be,normalizedLowercase:De,expectContiguousMatch:ee}))}return{original:F,originalLowercase:U,pathNormalized:Z,normalized:J,normalizedLowercase:z,values:ge,containsPathSeparator:Q,expectContiguousMatch:ie}}e.prepareQuery=V;function N(F){let U;w.isWindows?U=F.replace(/\//g,A.sep):U=F.replace(/\\/g,A.sep);const Z=(0,P.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function T(F){return Array.isArray(F)?V(F.map(U=>U.original).join(X)):V(F.original)}e.pieceToQuery=T}),define(Se[163],ye([1,0,110,8,51]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",w=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${w.source}`,"g");function S(u){return u.replace(P,(m,v)=>v?m:`\\${m}`)}e.escapeIcons=S;const C=new RegExp(`\\\\${w.source}`,"g");function L(u){return u.replace(C,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=L;const k=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function b(u){return u.indexOf(A)===-1?u:u.replace(k,(m,v,D,p)=>D?m:v||p||"")}e.stripIcons=b;function I(u){return u?u.replace(/\$\((.*?)\)/g,(m,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=I;const y=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(u){y.lastIndex=0;let m="";const v=[];let D=0;for(;;){const p=y.lastIndex,n=y.exec(u),s=u.substring(p,n?.index);if(s.length>0){m+=s;for(let r=0;r<s.length;r++)v.push(D)}if(!n)break;D+=n[0].length}return{text:m,iconOffsets:v}}e.parseLabelWithIcons=f;function d(u,m,v=!1){const{text:D,iconOffsets:p}=m;if(!p||p.length===0)return(0,o.matchesFuzzy)(u,D,v);const n=(0,R.ltrim)(D," "),s=D.length-n.length,r=(0,o.matchesFuzzy)(u,n,v);if(r)for(const a of r){const c=p[a.start+s]+s;a.start+=c,a.end+=c}return r}e.matchesFuzzyIconAware=d}),define(Se[37],ye([1,0,8]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(R||(R={})),function(l){const A="error",w="warning",P="warn",S="info",C="ignore";function L(b){return b?o.equalsIgnoreCase(A,b)?l.Error:o.equalsIgnoreCase(w,b)||o.equalsIgnoreCase(P,b)?l.Warning:o.equalsIgnoreCase(S,b)?l.Info:l.Ignore:l.Ignore}l.fromValue=L;function k(b){switch(b){case l.Error:return A;case l.Warning:return w;case l.Info:return S;default:return C}}l.toString=k}(R||(R={})),e.default=R}),define(Se[68],ye([1,0,16,8]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this._value="",this._pos=0}reset(I){return this._value=I,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(I){const y=I.charCodeAt(0),f=this._value.charCodeAt(this._pos);return y-f}value(){return this._value[this._pos]}}e.StringIterator=l;class A{constructor(I=!0){this._caseSensitive=I}reset(I){return this._value=I,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let I=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(I)this._from++;else break;else I=!1;return this}cmp(I){return this._caseSensitive?(0,R.compareSubstring)(I,this._value,0,I.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(I,this._value,0,I.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class w{constructor(I=!0,y=!0){this._splitOnBackslash=I,this._caseSensitive=y}reset(I){this._from=0,this._to=0,this._value=I,this._valueLen=I.length;for(let y=I.length-1;y>=0;y--,this._valueLen--){const f=this._value.charCodeAt(y);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let I=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===47||this._splitOnBackslash&&y===92)if(I)this._from++;else break;else I=!1}return this}cmp(I){return this._caseSensitive?(0,R.compareSubstring)(I,this._value,0,I.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(I,this._value,0,I.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(I,y){this._ignorePathCasing=I,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(I){return this._value=I,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(I)),this._pathIterator.reset(I.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(I)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(I){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(I,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(I,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(I);if(this._states[this._stateIdx]===4)return(0,R.compare)(I,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(I,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const I=this.right;return this.right=I.left,I.left=this,this.updateHeight(),I.updateHeight(),I}rotateRight(){const I=this.left;return this.left=I.right,I.right=this,this.updateHeight(),I.updateHeight(),I}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(L||(L={}));class k{static forUris(I=()=>!1,y=()=>!1){return new k(new S(I,y))}static forPaths(I=!1){return new k(new w(void 0,!I))}static forStrings(){return new k(new l)}static forConfigKeys(){return new k(new A)}constructor(I){this._iter=I}clear(){this._root=void 0}fill(I,y){if(y){const f=y.slice(0);(0,o.shuffle)(f);for(const d of f)this.set(d,I)}else{const f=I.slice(0);(0,o.shuffle)(f);for(const d of f)this.set(d[0],d[1])}}set(I,y){const f=this._iter.reset(I);let d;this._root||(this._root=new C,this._root.segment=f.value());const u=[];for(d=this._root;;){const v=f.cmp(d.segment);if(v>0)d.left||(d.left=new C,d.left.segment=f.value()),u.push([-1,d]),d=d.left;else if(v<0)d.right||(d.right=new C,d.right.segment=f.value()),u.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new C,d.mid.segment=f.value()),u.push([0,d]),d=d.mid;else break}const m=d.value;d.value=y,d.key=I;for(let v=u.length-1;v>=0;v--){const D=u[v][1];D.updateHeight();const p=D.balanceFactor();if(p<-1||p>1){const n=u[v][0],s=u[v+1][0];if(n===1&&s===1)u[v][1]=D.rotateLeft();else if(n===-1&&s===-1)u[v][1]=D.rotateRight();else if(n===1&&s===-1)D.right=u[v+1][1]=u[v+1][1].rotateRight(),u[v][1]=D.rotateLeft();else if(n===-1&&s===1)D.left=u[v+1][1]=u[v+1][1].rotateLeft(),u[v][1]=D.rotateRight();else throw new Error;if(v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}return m}get(I){return this._getNode(I)?.value}_getNode(I){const y=this._iter.reset(I);let f=this._root;for(;f;){const d=y.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else break}return f}has(I){const y=this._getNode(I);return!(y?.value===void 0&&y?.mid===void 0)}delete(I){return this._delete(I,!1)}deleteSuperstr(I){return this._delete(I,!0)}_delete(I,y){const f=this._iter.reset(I),d=[];let u=this._root;for(;u;){const m=f.cmp(u.segment);if(m>0)d.push([-1,u]),u=u.left;else if(m<0)d.push([1,u]),u=u.right;else if(f.hasNext())f.next(),d.push([0,u]),u=u.mid;else break}if(!!u){if(y?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this._min(u.right);if(m.key){const{key:v,value:D,segment:p}=m;this._delete(m.key,!1),u.key=v,u.value=D,u.segment=p}}else{const m=u.left??u.right;if(d.length>0){const[v,D]=d[d.length-1];switch(v){case-1:D.left=m;break;case 0:D.mid=m;break;case 1:D.right=m;break}}else this._root=m}for(let m=d.length-1;m>=0;m--){const v=d[m][1];v.updateHeight();const D=v.balanceFactor();if(D>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),d[m][1]=v.rotateLeft()):D<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),d[m][1]=v.rotateRight()),m>0)switch(d[m-1][0]){case-1:d[m-1][1].left=d[m][1];break;case 1:d[m-1][1].right=d[m][1];break;case 0:d[m-1][1].mid=d[m][1];break}else this._root=d[0][1]}}}_min(I){for(;I.left;)I=I.left;return I}findSubstr(I){const y=this._iter.reset(I);let f=this._root,d;for(;f;){const u=y.cmp(f.segment);if(u>0)f=f.left;else if(u<0)f=f.right;else if(y.hasNext())y.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(I){return this._findSuperstrOrElement(I,!1)}_findSuperstrOrElement(I,y){const f=this._iter.reset(I);let d=this._root;for(;d;){const u=f.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this._entries(d.mid):y?d.value:void 0}}hasElementOrSubtree(I){return this._findSuperstrOrElement(I,!0)!==void 0}forEach(I){for(const[y,f]of this)I(f,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(I){const y=[];return this._dfsEntries(I,y),y[Symbol.iterator]()}_dfsEntries(I,y){!I||(I.left&&this._dfsEntries(I.left,y),I.value&&y.push([I.key,I.value]),I.mid&&this._dfsEntries(I.mid,y),I.right&&this._dfsEntries(I.right,y))}_isBalanced(){const I=y=>{if(!y)return!0;const f=y.balanceFactor();return f<-1||f>1?!1:I(y.left)&&I(y.right)};return I(this._root)}}e.TernarySearchTree=k}),define(Se[2],ye([1,0,12,11]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,A=/^\//,w=/^\/\//;function P(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,a){return!r&&!a?"file":r}function C(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==k&&(a=k+a):a=k;break}return a}const L="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{static isUri(a){return a instanceof I?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,c,g,i,t,h=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=S(a,h),this.authority=c||L,this.path=C(this.scheme,g||L),this.query=i||L,this.fragment=t||L,P(this,h))}get fsPath(){return v(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:g,path:i,query:t,fragment:h}=a;return c===void 0?c=this.scheme:c===null&&(c=L),g===void 0?g=this.authority:g===null&&(g=L),i===void 0?i=this.path:i===null&&(i=L),t===void 0?t=this.query:t===null&&(t=L),h===void 0?h=this.fragment:h===null&&(h=L),c===this.scheme&&g===this.authority&&i===this.path&&t===this.query&&h===this.fragment?this:new f(c,g,i,t,h)}static parse(a,c=!1){const g=b.exec(a);return g?new f(g[2]||L,s(g[4]||L),s(g[5]||L),s(g[7]||L),s(g[9]||L),c):new f(L,L,L,L,L)}static file(a){let c=L;if(R.isWindows&&(a=a.replace(/\\/g,k)),a[0]===k&&a[1]===k){const g=a.indexOf(k,2);g===-1?(c=a.substring(2),a=k):(c=a.substring(2,g),a=a.substring(g)||k)}return new f("file",c,a,L,L)}static from(a){const c=new f(a.scheme,a.authority,a.path,a.query,a.fragment);return P(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return R.isWindows&&a.scheme==="file"?g=I.file(o.win32.join(v(a,!0),...c)).path:g=o.posix.join(a.path,...c),a.with({path:g})}toString(a=!1){return D(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof I)return a;{const c=new f(a);return c._formatted=a.external,c._fsPath=a._sep===y?a.fsPath:null,c}}else return a}}e.URI=I;const y=R.isWindows?1:void 0;class f extends I{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(a=!1){return a?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=y),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(r,a,c){let g,i=-1;for(let t=0;t<r.length;t++){const h=r.charCodeAt(t);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||a&&h===47||c&&h===91||c&&h===93||c&&h===58)i!==-1&&(g+=encodeURIComponent(r.substring(i,t)),i=-1),g!==void 0&&(g+=r.charAt(t));else{g===void 0&&(g=r.substr(0,t));const _=d[h];_!==void 0?(i!==-1&&(g+=encodeURIComponent(r.substring(i,t)),i=-1),g+=_):i===-1&&(i=t)}}return i!==-1&&(g+=encodeURIComponent(r.substring(i))),g!==void 0?g:r}function m(r){let a;for(let c=0;c<r.length;c++){const g=r.charCodeAt(c);g===35||g===63?(a===void 0&&(a=r.substr(0,c)),a+=d[g]):a!==void 0&&(a+=r[c])}return a!==void 0?a:r}function v(r,a){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,R.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=v;function D(r,a){const c=a?m:u;let g="",{scheme:i,authority:t,path:h,query:_,fragment:E}=r;if(i&&(g+=i,g+=":"),(t||i==="file")&&(g+=k,g+=k),t){let O=t.indexOf("@");if(O!==-1){const $=t.substr(0,O);t=t.substr(O+1),O=$.lastIndexOf(":"),O===-1?g+=c($,!1,!1):(g+=c($.substr(0,O),!1,!1),g+=":",g+=c($.substr(O+1),!1,!0)),g+="@"}t=t.toLowerCase(),O=t.lastIndexOf(":"),O===-1?g+=c(t,!1,!0):(g+=c(t.substr(0,O),!1,!0),g+=t.substr(O))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const O=h.charCodeAt(1);O>=65&&O<=90&&(h=`/${String.fromCharCode(O+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const O=h.charCodeAt(0);O>=65&&O<=90&&(h=`${String.fromCharCode(O+32)}:${h.substr(2)}`)}g+=c(h,!0,!1)}return _&&(g+="?",g+=c(_,!1,!1)),E&&(g+="#",g+=a?E:u(E,!1,!1)),g}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(n)?r.replace(n,a=>p(a)):r}}),define(Se[69],ye([1,0,22,8,2]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(C){return JSON.stringify(C,P)}e.stringify=A;function w(C){let L=JSON.parse(C);return L=S(L),L}e.parse=w;function P(C,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,R.regExpFlags)(L)}:L}function S(C,L=0){if(!C||L>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return l.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof o.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let k=0;k<C.length;++k)C[k]=S(C[k],L+1);else for(const k in C)Object.hasOwnProperty.call(C,k)&&(C[k]=S(C[k],L+1))}return C}e.revive=S}),define(Se[15],ye([1,0,10,11,2]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.vscodeUserData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls",C.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(L){this._preferredWebSchema=L}setDelegate(L){this._delegate=L}setServerRootPath(L){this._remoteResourcesPath=`${L}/${A.vscodeRemoteResource}`}set(L,k,b){this._hosts[L]=k,this._ports[L]=b}setConnectionToken(L,k){this._connectionTokens[L]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(L){if(this._delegate)try{return this._delegate(L)}catch(d){return o.onUnexpectedError(d),L}const k=L.authority;let b=this._hosts[k];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const I=this._ports[k],y=this._connectionTokens[k];let f=`path=${encodeURIComponent(L.path)}`;return typeof y=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),l.URI.from({scheme:R.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${b}:${I}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new w,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(L){const k=this.toUri(L,re);return this.uriToBrowserUri(k)}uriToBrowserUri(L){return L.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===A.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${A.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?L.with({scheme:A.vscodeFileResource,authority:L.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(L){const k=this.toUri(L,re);return this.uriToFileUri(k)}uriToFileUri(L){return L.scheme===A.vscodeFileResource?L.with({scheme:A.file,authority:L.authority!==P.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(L,k){return l.URI.isUri(L)?L:l.URI.parse(k.toUrl(L))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var S;(function(C){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);C.CoopAndCoep=Object.freeze(L.get("3"));const k="vscode-coi";function b(y){let f;typeof y=="string"?f=new URL(y).searchParams:y instanceof URL?f=y.searchParams:l.URI.isUri(y)&&(f=new URL(y.toString(!0)).searchParams);const d=f?.get(k);if(!!d)return L.get(d)}C.getHeadersFromQuery=b;function I(y,f,d){if(!globalThis.crossOriginIsolated)return;const u=f&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(k,u):y[k]=u}C.addSearchParam=I})(S=e.COI||(e.COI={}))}),define(Se[24],ye([1,0,34,15,12,11,8,2]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(I){return(0,P.uriToFsPath)(I,!0)}e.originalFSPath=S;class C{constructor(y){this._ignorePathCasing=y}compare(y,f,d=!1){return y===f?0:(0,w.compare)(this.getComparisonKey(y,d),this.getComparisonKey(f,d))}isEqual(y,f,d=!1){return y===f?!0:!y||!f?!1:this.getComparisonKey(y,d)===this.getComparisonKey(f,d)}getComparisonKey(y,f=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,f,d=!1){if(y.scheme===f.scheme){if(y.scheme===R.Schemas.file)return o.isEqualOrParent(S(y),S(f),this._ignorePathCasing(y))&&y.query===f.query&&(d||y.fragment===f.fragment);if((0,e.isEqualAuthority)(y.authority,f.authority))return o.isEqualOrParent(y.path,f.path,this._ignorePathCasing(y),"/")&&y.query===f.query&&(d||y.fragment===f.fragment)}return!1}joinPath(y,...f){return P.URI.joinPath(y,...f)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return l.posix.basename(y.path)}extname(y){return l.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let f;return y.scheme===R.Schemas.file?f=P.URI.file(l.dirname(S(y))).path:(f=l.posix.dirname(y.path),y.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),f="/")),y.with({path:f})}normalizePath(y){if(!y.path.length)return y;let f;return y.scheme===R.Schemas.file?f=P.URI.file(l.normalize(S(y))).path:f=l.posix.normalize(y.path),y.with({path:f})}relativePath(y,f){if(y.scheme!==f.scheme||!(0,e.isEqualAuthority)(y.authority,f.authority))return;if(y.scheme===R.Schemas.file){const m=l.relative(S(y),S(f));return A.isWindows?o.toSlashes(m):m}let d=y.path||"/";const u=f.path||"/";if(this._ignorePathCasing(y)){let m=0;for(const v=Math.min(d.length,u.length);m<v&&!(d.charCodeAt(m)!==u.charCodeAt(m)&&d.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);d=u.substr(0,m)+d.substr(m)}return l.posix.relative(d,u)}resolvePath(y,f){if(y.scheme===R.Schemas.file){const d=P.URI.file(l.resolve(S(y),f));return y.with({authority:d.authority,path:d.path})}return f=o.toPosixPath(f),y.with({path:l.posix.resolve(y.path,f)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,f){return y===f||y!==void 0&&f!==void 0&&(0,w.equalsIgnoreCase)(y,f)}hasTrailingPathSeparator(y,f=l.sep){if(y.scheme===R.Schemas.file){const d=S(y);return d.length>o.getRoot(d).length&&d[d.length-1]===f}else{const d=y.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,f=l.sep){return(0,e.hasTrailingPathSeparator)(y,f)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,f=l.sep){let d=!1;if(y.scheme===R.Schemas.file){const u=S(y);d=u!==void 0&&u.length===o.getRoot(u).length&&u[u.length-1]===f}else{f="/";const u=y.path;d=u.length===1&&u.charCodeAt(u.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(y,f)?y.with({path:y.path+"/"}):y}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(I=>I.scheme===R.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new C(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,y){const f=[];for(let d=0;d<I.length;d++){const u=y(I[d]);I.some((m,v)=>v===d?!1:(0,e.isEqualOrParent)(u,y(m)))||f.push(I[d])}return f}e.distinctParents=L;var k;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function y(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[D,p]=v.split(":");D&&p&&d.set(D,p)});const m=f.path.substring(0,f.path.indexOf(";"));return m&&d.set(I.META_DATA_MIME,m),d}I.parseMetaData=y})(k=e.DataUri||(e.DataUri={}));function b(I,y,f){if(y){let d=I.path;return d&&d[0]!==l.posix.sep&&(d=l.posix.sep+d),I.with({scheme:f,authority:y,path:d})}return I.with({scheme:f})}e.toLocalResource=b}),define(Se[19],ye([1,0,21,10,3,6,24,11,148]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=C;function L(Y){const ee=new o.CancellationTokenSource,me=Y(ee.token),be=new Promise((De,Ae)=>{const ae=ee.token.onCancellationRequested(()=>{ae.dispose(),ee.dispose(),Ae(new R.CancellationError)});Promise.resolve(me).then(le=>{ae.dispose(),ee.dispose(),De(le)},le=>{ae.dispose(),ee.dispose(),Ae(le)})});return new class{cancel(){ee.cancel()}then(De,Ae){return be.then(De,Ae)}catch(De){return this.then(void 0,De)}finally(De){return be.finally(De)}}}e.createCancelablePromise=L;function k(Y,ee,me){return new Promise((be,De)=>{const Ae=ee.onCancellationRequested(()=>{Ae.dispose(),be(me)});Y.then(be,De).finally(()=>Ae.dispose())})}e.raceCancellation=k;function b(Y,ee){return new Promise((me,be)=>{const De=ee.onCancellationRequested(()=>{De.dispose(),be(new R.CancellationError)});Y.then(me,be).finally(()=>De.dispose())})}e.raceCancellationError=b;async function I(Y){let ee=-1;const me=Y.map((De,Ae)=>De.then(ae=>(ee=Ae,ae))),be=await Promise.race(me);return Y.forEach((De,Ae)=>{Ae!==ee&&De.cancel()}),be}e.raceCancellablePromises=I;function y(Y,ee,me){let be;const De=setTimeout(()=>{be?.(void 0),me?.()},ee);return Promise.race([Y.finally(()=>clearTimeout(De)),new Promise(Ae=>be=Ae)])}e.raceTimeout=y;function f(Y){return new Promise((ee,me)=>{const be=Y();C(be)?be.then(ee,me):ee(be)})}e.asPromise=f;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(me,me).then(be)})}return new Promise((me,be)=>{this.queuedPromise.then(me,be)})}return this.activePromise=ee(),new Promise((me,be)=>{this.activePromise.then(De=>{this.activePromise=null,me(De)},De=>{this.activePromise=null,be(De)})})}}e.Throttler=d;class u{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=u;class m{constructor(){this.promiseMap=new Map}queue(ee,me){const De=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(ee)===De&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,De),De}}e.SequencerByKey=m;const v=(Y,ee)=>{let me=!0;const be=setTimeout(()=>{me=!1,ee()},Y);return{isTriggered:()=>me,dispose:()=>{clearTimeout(be),me=!1}}},D=Y=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,Y())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class p{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,me=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((De,Ae)=>{this.doResolve=De,this.doReject=Ae}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const De=this.task;return this.task=null,De()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===S.MicrotaskDelay?D(be):v(me,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new R.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class n{constructor(ee){this.delayer=new p(ee),this.throttler=new d}trigger(ee,me){return this.delayer.trigger(()=>this.throttler.queue(ee),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class s{constructor(){this._isOpen=!1,this._promise=new Promise((ee,me)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(ee){super(),this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function a(Y,ee){return ee?new Promise((me,be)=>{const De=setTimeout(()=>{Ae.dispose(),me()},Y),Ae=ee.onCancellationRequested(()=>{clearTimeout(De),Ae.dispose(),be(new R.CancellationError)})}):L(me=>a(Y,me))}e.timeout=a;function c(Y,ee=0){const me=setTimeout(Y,ee);return(0,A.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=c;function g(Y){const ee=[];let me=0;const be=Y.length;function De(){return me<be?Y[me++]():null}function Ae(ae){ae!=null&&ee.push(ae);const le=De();return le?le.then(Ae):Promise.resolve(ee)}return Promise.resolve(null).then(Ae)}e.sequence=g;function i(Y,ee=be=>!!be,me=null){let be=0;const De=Y.length,Ae=()=>{if(be>=De)return Promise.resolve(me);const ae=Y[be++];return Promise.resolve(ae()).then(ue=>ee(ue)?Promise.resolve(ue):Ae())};return Ae()}e.first=i;function t(Y,ee=be=>!!be,me=null){if(Y.length===0)return Promise.resolve(me);let be=Y.length;const De=()=>{be=-1;for(const Ae of Y)Ae.cancel?.()};return new Promise((Ae,ae)=>{for(const le of Y)le.then(ue=>{--be>=0&&ee(ue)?(De(),Ae(ue)):be===0&&Ae(me)}).catch(ue=>{--be>=0&&(De(),ae(ue))})})}e.firstParallel=t;class h{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new l.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((me,be)=>{this.outstandingPromises.push({factory:ee,c:me,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const me=ee.factory();me.then(ee.c,ee.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class _ extends h{constructor(){super(1)}}e.Queue=_;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new J;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,me=w.extUri){const be=me.getComparisonKey(ee);let De=this.queues.get(be);return De||(De=new _,l.Event.once(De.onDrained)(()=>{De?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,De)),De}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class O{constructor(ee,me){this._token=-1,typeof ee=="function"&&typeof me=="number"&&this.setIfNotSet(ee,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},me)}setIfNotSet(ee,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},me))}}e.TimeoutTimer=O;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,me){this.cancel(),this._token=setInterval(()=>{ee()},me)}}e.IntervalTimer=$;class H{constructor(ee,me){this.timeoutToken=-1,this.runner=ee,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class X{constructor(ee,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=X;class V extends H{constructor(ee,me){super(ee,me),this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=V;class N extends A.Disposable{constructor(ee,me){super(),this.options=ee,this.handler=me,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const me of ee)this.pendingWork.push(me);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,P.setTimeout0)(()=>{if(ee)return;const me=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(Y,ee)=>{const me=requestIdleCallback(Y,typeof ee=="number"?{timeout:ee}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(me))}}}}();class T{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=T;async function F(Y,ee,me){let be;for(let De=0;De<me;De++)try{return await Y()}catch(Ae){be=Ae,await a(ee)}throw be}e.retry=F;class U{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ee,me,be){return this._pending={taskId:ee,cancel:()=>be?.(),promise:me},me.then(()=>this.donePending(ee),()=>this.donePending(ee)),me}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let me,be;const De=new Promise((Ae,ae)=>{me=Ae,be=ae});this._next={run:ee,promise:De,promiseResolve:me,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=U;class Z{constructor(ee,me=()=>Date.now()){this.interval=ee,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=Z;class J{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,me)=>{this.completeCallback=ee,this.errorCallback=me})}complete(ee){return new Promise(me=>{this.completeCallback(ee),this.resolved=!0,me()})}error(ee){return new Promise(me=>{this.errorCallback(ee),this.rejected=!0,me()})}cancel(){new Promise(ee=>{this.errorCallback(new R.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=J;var z;(function(Y){async function ee(be){let De;const Ae=await Promise.all(be.map(ae=>ae.then(le=>le,le=>{De||(De=le)})));if(typeof De<"u")throw De;return Ae}Y.settled=ee;function me(be){return new Promise(async(De,Ae)=>{try{await be(De,Ae)}catch(ae){Ae(ae)}})}Y.withAsyncBody=me})(z=e.Promises||(e.Promises={}));var Q;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(Q||(Q={}));class ie{static fromArray(ee){return new ie(me=>{me.emitMany(ee)})}static fromPromise(ee){return new ie(async me=>{me.emitMany(await ee)})}static fromPromises(ee){return new ie(async me=>{await Promise.all(ee.map(async be=>me.emitOne(await be)))})}static merge(ee){return new ie(async me=>{await Promise.all(ee.map(async be=>{for await(const De of be)me.emitOne(De)}))})}constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new l.Emitter,queueMicrotask(async()=>{const me={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(ee(me)),this.resolve()}catch(be){this.reject(be)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await l.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,me){return new ie(async be=>{for await(const De of ee)be.emitOne(me(De))})}map(ee){return ie.map(this,ee)}static filter(ee,me){return new ie(async be=>{for await(const De of ee)me(De)&&be.emitOne(De)})}filter(ee){return ie.filter(this,ee)}static coalesce(ee){return ie.filter(ee,me=>!!me)}coalesce(){return ie.coalesce(this)}static async toPromise(ee){const me=[];for await(const be of ee)me.push(be);return me}toPromise(){return ie.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class ge extends ie{constructor(ee,me){super(me),this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ge;function K(Y){const ee=new o.CancellationTokenSource,me=Y(ee.token);return new ge(ee,async be=>{const De=ee.token.onCancellationRequested(()=>{De.dispose(),ee.dispose(),be.reject(new R.CancellationError)});try{for await(const Ae of me){if(ee.token.isCancellationRequested)return;be.emitOne(Ae)}De.dispose(),ee.dispose()}catch(Ae){De.dispose(),ee.dispose(),be.reject(Ae)}})}e.createCancelableAsyncIterable=K}),define(Se[38],ye([1,0,16,19,34,28,12,11,8]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",k="[^/\\\\]",b=/\//g;function I(Z,J){switch(Z){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${J?`|${L}${k}+`:""})*?`}}function y(Z,J){if(!Z)return[];const z=[];let Q=!1,ie=!1,ge="";for(const K of Z){switch(K){case J:if(!Q&&!ie){z.push(ge),ge="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ge+=K}return ge&&z.push(ge),z}e.splitGlobAware=y;function f(Z){if(!Z)return"";let J="";const z=y(Z,e.GLOB_SPLIT);if(z.every(Q=>Q===e.GLOBSTAR))J=".*";else{let Q=!1;z.forEach((ie,ge)=>{if(ie===e.GLOBSTAR){if(Q)return;J+=I(2,ge===z.length-1)}else{let K=!1,Y="",ee=!1,me="";for(const be of ie){if(be!=="}"&&K){Y+=be;continue}if(ee&&(be!=="]"||!me)){let De;be==="-"?De=be:(be==="^"||be==="!")&&!me?De="^":be===e.GLOB_SPLIT?De="":De=(0,S.escapeRegExpCharacters)(be),me+=De;continue}switch(be){case"{":K=!0;continue;case"[":ee=!0;continue;case"}":{J+=`(?:${y(Y,",").map(ae=>f(ae)).join("|")})`,K=!1,Y="";break}case"]":{J+="["+me+"]",ee=!1,me="";break}case"?":J+=k;continue;case"*":J+=I(1);continue;default:J+=(0,S.escapeRegExpCharacters)(be)}}ge<z.length-1&&(z[ge+1]!==e.GLOBSTAR||ge+2<z.length)&&(J+=L)}Q=ie===e.GLOBSTAR})}return J}const d=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),s=function(){return!1},r=function(){return null};function a(Z,J){if(!Z)return r;let z;typeof Z!="string"?z=Z.pattern:z=Z,z=z.trim();const Q=`${z}_${!!J.trimForExclusions}`;let ie=n.get(Q);if(ie)return c(ie,Z);let ge;return d.test(z)?ie=i(z.substr(4),z):(ge=u.exec(g(z,J)))?ie=t(ge[1],z):(J.trimForExclusions?v:m).test(z)?ie=h(z,J):(ge=D.exec(g(z,J)))?ie=_(ge[1].substr(1),z,!0):(ge=p.exec(g(z,J)))?ie=_(ge[1],z,!1):ie=E(z),n.set(Q,ie),c(ie,Z)}function c(Z,J){if(typeof J=="string")return Z;const z=function(Q,ie){return(0,l.isEqualOrParent)(Q,J.base,!P.isLinux)?Z((0,S.ltrim)(Q.substr(J.base.length),w.sep),ie):null};return z.allBasenames=Z.allBasenames,z.allPaths=Z.allPaths,z.basenames=Z.basenames,z.patterns=Z.patterns,z}function g(Z,J){return J.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function i(Z,J){return function(z,Q){return typeof z=="string"&&z.endsWith(Z)?J:null}}function t(Z,J){const z=`/${Z}`,Q=`\\${Z}`,ie=function(K,Y){return typeof K!="string"?null:Y?Y===Z?J:null:K===Z||K.endsWith(z)||K.endsWith(Q)?J:null},ge=[Z];return ie.basenames=ge,ie.patterns=[J],ie.allBasenames=ge,ie}function h(Z,J){const z=F(Z.slice(1,-1).split(",").map(Y=>a(Y,J)).filter(Y=>Y!==r),Z),Q=z.length;if(!Q)return r;if(Q===1)return z[0];const ie=function(Y,ee){for(let me=0,be=z.length;me<be;me++)if(z[me](Y,ee))return Z;return null},ge=z.find(Y=>!!Y.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const K=z.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return K.length&&(ie.allPaths=K),ie}function _(Z,J,z){const Q=w.sep===w.posix.sep,ie=Q?Z:Z.replace(b,w.sep),ge=w.sep+ie,K=w.posix.sep+Z;let Y;return z?Y=function(ee,me){return typeof ee=="string"&&(ee===ie||ee.endsWith(ge)||!Q&&(ee===Z||ee.endsWith(K)))?J:null}:Y=function(ee,me){return typeof ee=="string"&&(ee===ie||!Q&&ee===Z)?J:null},Y.allPaths=[(z?"*/":"./")+Z],Y}function E(Z){try{const J=new RegExp(`^${f(Z)}$`);return function(z){return J.lastIndex=0,typeof z=="string"&&J.test(z)?Z:null}}catch{return r}}function O(Z,J,z){return!Z||typeof J!="string"?!1:$(Z)(J,void 0,z)}e.match=O;function $(Z,J={}){if(!Z)return s;if(typeof Z=="string"||H(Z)){const z=a(Z,J);if(z===r)return s;const Q=function(ie,ge){return!!z(ie,ge)};return z.allBasenames&&(Q.allBasenames=z.allBasenames),z.allPaths&&(Q.allPaths=z.allPaths),Q}return N(Z,J)}e.parse=$;function H(Z){const J=Z;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=H;function X(Z){return Z.allBasenames||[]}e.getBasenameTerms=X;function V(Z){return Z.allPaths||[]}e.getPathTerms=V;function N(Z,J){const z=F(Object.getOwnPropertyNames(Z).map(Y=>T(Y,Z[Y],J)).filter(Y=>Y!==r)),Q=z.length;if(!Q)return r;if(!z.some(Y=>!!Y.requiresSiblings)){if(Q===1)return z[0];const Y=function(be,De){let Ae;for(let ae=0,le=z.length;ae<le;ae++){const ue=z[ae](be,De);if(typeof ue=="string")return ue;(0,R.isThenable)(ue)&&(Ae||(Ae=[]),Ae.push(ue))}return Ae?(async()=>{for(const ae of Ae){const le=await ae;if(typeof le=="string")return le}return null})():null},ee=z.find(be=>!!be.allBasenames);ee&&(Y.allBasenames=ee.allBasenames);const me=z.reduce((be,De)=>De.allPaths?be.concat(De.allPaths):be,[]);return me.length&&(Y.allPaths=me),Y}const ie=function(Y,ee,me){let be,De;for(let Ae=0,ae=z.length;Ae<ae;Ae++){const le=z[Ae];le.requiresSiblings&&me&&(ee||(ee=(0,w.basename)(Y)),be||(be=ee.substr(0,ee.length-(0,w.extname)(Y).length)));const ue=le(Y,ee,be,me);if(typeof ue=="string")return ue;(0,R.isThenable)(ue)&&(De||(De=[]),De.push(ue))}return De?(async()=>{for(const Ae of De){const ae=await Ae;if(typeof ae=="string")return ae}return null})():null},ge=z.find(Y=>!!Y.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const K=z.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return K.length&&(ie.allPaths=K),ie}function T(Z,J,z){if(J===!1)return r;const Q=a(Z,z);if(Q===r)return r;if(typeof J=="boolean")return Q;if(J){const ie=J.when;if(typeof ie=="string"){const ge=(K,Y,ee,me)=>{if(!me||!Q(K,Y))return null;const be=ie.replace("$(basename)",()=>ee),De=me(be);return(0,R.isThenable)(De)?De.then(Ae=>Ae?Z:null):De?Z:null};return ge.requiresSiblings=!0,ge}}return Q}function F(Z,J){const z=Z.filter(Y=>!!Y.basenames);if(z.length<2)return Z;const Q=z.reduce((Y,ee)=>{const me=ee.basenames;return me?Y.concat(me):Y},[]);let ie;if(J){ie=[];for(let Y=0,ee=Q.length;Y<ee;Y++)ie.push(J)}else ie=z.reduce((Y,ee)=>{const me=ee.patterns;return me?Y.concat(me):Y},[]);const ge=function(Y,ee){if(typeof Y!="string")return null;if(!ee){let be;for(be=Y.length;be>0;be--){const De=Y.charCodeAt(be-1);if(De===47||De===92)break}ee=Y.substr(be)}const me=Q.indexOf(ee);return me!==-1?ie[me]:null};ge.basenames=Q,ge.patterns=ie,ge.allBasenames=Q;const K=Z.filter(Y=>!Y.basenames);return K.push(ge),K}function U(Z,J){return(0,o.equals)(Z,J,(z,Q)=>typeof z=="string"&&typeof Q=="string"?z===Q:typeof z!="string"&&typeof Q!="string"?z.base===Q.base&&z.pattern===Q.pattern:!1)}e.patternsEquals=U}),define(Se[112],ye([1,0,10,163,24,8,2]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(u="",m=!1){if(this.value=u,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(u,m=0){return this.value+=b(this.supportThemeIcons?(0,R.escapeIcons)(u):u).replace(/([ \t]+)/g,(v,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,m){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(u,m,v){return this.value+="[",this.value+=this._escape(m,"]"),this.value+="](",this.value+=this._escape(String(u),")"),v&&(this.value+=` "${this._escape(this._escape(v,'"'),")")}"`),this.value+=")",this}_escape(u,m){const v=new RegExp((0,A.escapeRegExpCharacters)(m),"g");return u.replace(v,(D,p)=>u.charAt(p-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=S;function C(d){return L(d)?!d.value:Array.isArray(d)?d.every(C):!0}e.isEmptyMarkdownString=C;function L(d){return d instanceof S?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function k(d,u){return d===u?!0:!d||!u?!1:d.value===u.value&&d.isTrusted===u.isTrusted&&d.supportThemeIcons===u.supportThemeIcons&&d.supportHtml===u.supportHtml&&(d.baseUri===u.baseUri||!!d.baseUri&&!!u.baseUri&&(0,l.isEqual)(w.URI.from(d.baseUri),w.URI.from(u.baseUri)))}e.markdownStringEqual=k;function b(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function I(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function y(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=y;function f(d){const u=[],m=d.split("|").map(D=>D.trim());d=m[0];const v=m[1];if(v){const D=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),n=D?D[1]:"",s=p?p[1]:"",r=isFinite(parseInt(s)),a=isFinite(parseInt(n));r&&u.push(`width="${s}"`),a&&u.push(`height="${n}"`)}return{href:d,dimensions:u}}e.parseHrefAndDimensions=f}),define(Se[113],ye([1,0,16,34,12,11,24,8]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,a){const{os:c,tildify:g,relative:i}=a;if(i){const _=C(r,i,c);if(typeof _=="string")return _}let t=r.fsPath;if(c===1&&!A.isWindows?t=t.replace(/\//g,"\\"):c!==1&&A.isWindows&&(t=t.replace(/\\/g,"/")),c!==1&&g?.userHome){const _=g.userHome.fsPath;let E;r.scheme!==g.userHome.scheme&&r.path.startsWith(l.posix.sep)?E=g.userHome.with({path:r.path}).fsPath:E=r.fsPath,t=b(E,_,c)}return(c===1?l.win32:l.posix).normalize(L(t,c===1))}e.getPathLabel=S;function C(r,a,c){const g=c===1?l.win32:l.posix,i=c===3?w.extUri:w.extUriIgnorePathCase,t=a.getWorkspace(),h=(0,o.firstOrDefault)(t.folders);if(!h)return;r.scheme!==h.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=h.uri.with({path:r.path}));const _=a.getWorkspaceFolder(r);if(!_)return;let E;if(i.isEqual(_.uri,r)?E="":E=i.relativePath(_.uri,r)??"",E&&(E=g.normalize(E)),t.folders.length>1&&!a.noPrefix){const O=_.name?_.name:i.basenameOrAuthority(_.uri);E=E?`${O} \u2022 ${E}`:O}return E}function L(r,a=A.isWindows){return(0,R.hasDriveLetter)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let k=Object.create(null);function b(r,a,c=A.OS){if(c===1||!r||!a)return r;let g=k.original===a?k.normalized:void 0;g||(g=a,A.isWindows&&(g=(0,R.toSlashes)(g)),g=`${(0,P.rtrim)(g,l.posix.sep)}${l.posix.sep}`,k={original:a,normalized:g});let i=r;return A.isWindows&&(i=(0,R.toSlashes)(i)),(c===3?i.startsWith(g):(0,P.startsWithIgnoreCase)(i,g))?`~/${i.substr(g.length)}`:r}e.tildify=b;function I(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=I;const y="\u2026",f="\\\\",d="~";function u(r,a=l.sep){const c=new Array(r.length);let g=!1;for(let i=0;i<r.length;i++){const t=r[i];if(t===""){c[i]=`.${a}`;continue}if(!t){c[i]=t;continue}g=!0;let h="",_=t;_.indexOf(f)===0?(h=_.substr(0,_.indexOf(f)+f.length),_=_.substr(_.indexOf(f)+f.length)):_.indexOf(a)===0?(h=_.substr(0,_.indexOf(a)+a.length),_=_.substr(_.indexOf(a)+a.length)):_.indexOf(d)===0&&(h=_.substr(0,_.indexOf(d)+d.length),_=_.substr(_.indexOf(d)+d.length));const E=_.split(a);for(let O=1;g&&O<=E.length;O++)for(let $=E.length-O;g&&$>=0;$--){g=!1;let H=E.slice($,$+O).join(a);for(let X=0;!g&&X<r.length;X++)if(X!==i&&r[X]&&r[X].indexOf(H)>-1){const V=$+O===E.length,N=$>0&&r[X].indexOf(a)>-1?a+H:H,T=r[X].endsWith(N);g=!V||T}if(!g){let X="";(E[0].endsWith(":")||h!=="")&&($===1&&($=0,O++,H=E[0]+a+H),$>0&&(X=E[0]+a),X=h+X),$>0&&(X=X+y+a),X=X+H,$+O<E.length&&(X=X+a+y),c[i]=X}}g&&(c[i]=t)}return c}e.shorten=u;var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function v(r,a=Object.create(null)){const c=[];let g=!1,i="";for(const t of r)if(t==="$"||g&&t==="{")i&&c.push({value:i,type:m.TEXT}),i="",g=!0;else if(t==="}"&&g){const h=a[i];if(typeof h=="string")h.length&&c.push({value:h,type:m.VARIABLE});else if(h){const _=c[c.length-1];(!_||_.type!==m.SEPARATOR)&&c.push({value:h.label,type:m.SEPARATOR})}i="",g=!1}else i+=t;return i&&!g&&c.push({value:i,type:m.TEXT}),c.filter((t,h)=>{if(t.type===m.SEPARATOR){const _=c[h-1],E=c[h+1];return[_,E].every(O=>O&&(O.type===m.VARIABLE||O.type===m.TEXT)&&O.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=v;function D(r,a){return A.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function p(r,a){return A.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const a=r.indexOf("/")!==-1?l.posix:l.win32,c=a.basename(r),g=a.dirname(r);return c.length?{name:c,parentPath:g}:{name:g,parentPath:""}}e.splitName=s}),define(Se[114],ye([1,0,22,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(k){return k.toJSON()}class A{constructor(b){this._uriTransformer=b}transformIncoming(b){const I=this._uriTransformer.transformIncoming(b);return I===b?b:l(R.URI.from(I))}transformOutgoing(b){const I=this._uriTransformer.transformOutgoing(b);return I===b?b:l(R.URI.from(I))}transformOutgoingURI(b){const I=this._uriTransformer.transformOutgoing(b);return I===b?b:R.URI.from(I)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function w(k,b,I){if(!k||I>200)return null;if(typeof k=="object"){if(k instanceof R.URI)return b.transformOutgoing(k);for(const y in k)if(Object.hasOwnProperty.call(k,y)){const f=w(k[y],b,I+1);f!==null&&(k[y]=f)}}return null}function P(k,b){const I=w(k,b,0);return I===null?k:I}e.transformOutgoingURIs=P;function S(k,b,I,y){if(!k||y>200)return null;if(typeof k=="object"){if(k.$mid===1)return I?R.URI.revive(b.transformIncoming(k)):b.transformIncoming(k);if(k instanceof o.VSBuffer)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const d=S(k[f],b,I,y+1);d!==null&&(k[f]=d)}}return null}function C(k,b){const I=S(k,b,!1,0);return I===null?k:I}e.transformIncomingURIs=C;function L(k,b){const I=S(k,b,!0,0);return I===null?k:I}e.transformAndReviveIncomingURIs=L}),define(Se[29],ye([1,0,70,71,320,19,34,87,12,11,24,2]),function(re,e,o,R,l,A,w,P,S,C,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function I(N,T=b.UNLINK){if((0,w.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return T===b.UNLINK?f(N):y(N)}async function y(N){try{const T=(0,w.randomPath)((0,R.tmpdir)());try{await o.promises.rename(N,T)}catch(F){return F.code==="ENOENT"?void 0:f(N)}f(T).catch(F=>{})}catch(T){if(T.code!=="ENOENT")throw T}}async function f(N){return(0,l.promisify)(o.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function d(N){if((0,w.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function u(N,T){return D(await(T?m(N):(0,l.promisify)(o.readdir)(N)))}async function m(N){try{return await(0,l.promisify)(o.readdir)(N,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const T=[],F=await u(N);for(const U of F){let Z=!1,J=!1,z=!1;try{const Q=await e.Promises.lstat((0,S.join)(N,U));Z=Q.isFile(),J=Q.isDirectory(),z=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}T.push({name:U,isFile:()=>Z,isDirectory:()=>J,isSymbolicLink:()=>z})}return T}function v(N){return D(o.readdirSync(N))}e.readdirSync=v;function D(N){return N.map(T=>typeof T=="string"?C.isMacintosh?(0,P.normalizeNFC)(T):T:(T.name=C.isMacintosh?(0,P.normalizeNFC)(T.name):T.name,T))}async function p(N){const T=await u(N),F=[];for(const U of T)await s.existsDirectory((0,S.join)(N,U))&&F.push(U);return F}function n(N,T=1e3){return new Promise(F=>{let U=!1;const Z=setInterval(()=>{U||(U=!0,o.access(N,J=>{U=!1,J&&(clearInterval(Z),F(void 0))}))},T)})}e.whenDeleted=n;var s;(function(N){async function T(Z){let J;try{if(J=await e.Promises.lstat(Z),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(C.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw Q}throw z}}N.stat=T;async function F(Z){try{const{stat:J,symbolicLink:z}=await N.stat(Z);return J.isFile()&&z?.dangling!==!0}catch{}return!1}N.existsFile=F;async function U(Z){try{const{stat:J,symbolicLink:z}=await N.stat(Z);return J.isDirectory()&&z?.dangling!==!0}catch{}return!1}N.existsDirectory=U})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function a(N,T,F){return r.queueFor(k.URI.file(N),L.extUriBiasedIgnorePathCase).queue(()=>{const U=h(F);return new Promise((Z,J)=>i(N,T,U,z=>z?J(z):Z()))})}let c=!0;function g(N){c=N}e.configureFlushOnWrite=g;function i(N,T,F,U){if(!c)return o.writeFile(N,T,{mode:F.mode,flag:F.flag},U);o.open(N,F.flag,F.mode,(Z,J)=>{if(Z)return U(Z);o.writeFile(J,T,z=>{if(z)return o.close(J,()=>U(z));o.fdatasync(J,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),g(!1)),o.close(J,ie=>U(ie))))})})}function t(N,T,F){const U=h(F);if(!c)return o.writeFileSync(N,T,{mode:U.mode,flag:U.flag});const Z=o.openSync(N,U.flag,U.mode);try{o.writeFileSync(Z,T);try{o.fdatasyncSync(Z)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),g(!1)}}finally{o.closeSync(Z)}}e.writeFileSync=t;function h(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function _(N,T){if(N!==T)try{await e.Promises.rename(N,T)}catch(F){if(N.toLowerCase()!==T.toLowerCase()&&F.code==="EXDEV"||N.endsWith("."))await E(N,T,{preserveSymlinks:!1}),await I(N,b.MOVE);else throw F}}async function E(N,T,F){return $(N,T,{root:{source:N,target:T},options:F,handledSourcePaths:new Set})}const O=511;async function $(N,T,F){if(F.handledSourcePaths.has(N))return;F.handledSourcePaths.add(N);const{stat:U,symbolicLink:Z}=await s.stat(N);if(Z){if(F.options.preserveSymlinks)try{return await V(N,T,F)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(Z.dangling)return}return U.isDirectory()?H(N,T,U.mode&O,F):X(N,T,U.mode&O)}async function H(N,T,F,U){await e.Promises.mkdir(T,{recursive:!0,mode:F});const Z=await u(N);for(const J of Z)await $((0,S.join)(N,J),(0,S.join)(T,J),U)}async function X(N,T,F){await e.Promises.copyFile(N,T),await e.Promises.chmod(T,F)}async function V(N,T,F){let U=await e.Promises.readlink(N);(0,w.isEqualOrParent)(U,F.root.source,!C.isLinux)&&(U=(0,S.join)(F.root.target,U.substr(F.root.source.length+1))),await e.Promises.symlink(U,T)}e.Promises=new class{get access(){return(0,l.promisify)(o.access)}get stat(){return(0,l.promisify)(o.stat)}get lstat(){return(0,l.promisify)(o.lstat)}get utimes(){return(0,l.promisify)(o.utimes)}get read(){return(N,T,F,U,Z)=>new Promise((J,z)=>{o.read(N,T,F,U,Z,(Q,ie,ge)=>Q?z(Q):J({bytesRead:ie,buffer:ge}))})}get readFile(){return(0,l.promisify)(o.readFile)}get write(){return(N,T,F,U,Z)=>new Promise((J,z)=>{o.write(N,T,F,U,Z,(Q,ie,ge)=>Q?z(Q):J({bytesWritten:ie,buffer:ge}))})}get appendFile(){return(0,l.promisify)(o.appendFile)}get fdatasync(){return(0,l.promisify)(o.fdatasync)}get truncate(){return(0,l.promisify)(o.truncate)}get rename(){return(0,l.promisify)(o.rename)}get copyFile(){return(0,l.promisify)(o.copyFile)}get open(){return(0,l.promisify)(o.open)}get close(){return(0,l.promisify)(o.close)}get symlink(){return(0,l.promisify)(o.symlink)}get readlink(){return(0,l.promisify)(o.readlink)}get chmod(){return(0,l.promisify)(o.chmod)}get mkdir(){return(0,l.promisify)(o.mkdir)}get unlink(){return(0,l.promisify)(o.unlink)}get rmdir(){return(0,l.promisify)(o.rmdir)}get realpath(){return(0,l.promisify)(o.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return p}get writeFile(){return a}get rm(){return I}get move(){return _}get copy(){return E}}}),define(Se[115],ye([1,0,70,12,11,8,29]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(b){if(l.isLinux)return b;const I=(0,R.dirname)(b);if(b===I)return b;const y=((0,R.basename)(b)||b).toLowerCase();try{const d=(0,w.readdirSync)(I).filter(u=>u.toLowerCase()===y);if(d.length===1){const u=P(I);if(u)return(0,R.join)(u,d[0])}else if(d.length>1){const u=d.indexOf(y);if(u>=0){const m=P(I);if(m)return(0,R.join)(m,d[u])}}}catch{}return null}e.realcaseSync=P;async function S(b){if(l.isLinux)return b;const I=(0,R.dirname)(b);if(b===I)return b;const y=((0,R.basename)(b)||b).toLowerCase();try{const d=(await w.Promises.readdir(I)).filter(u=>u.toLowerCase()===y);if(d.length===1){const u=await S(I);if(u)return(0,R.join)(u,d[0])}else if(d.length>1){const u=d.indexOf(y);if(u>=0){const m=await S(I);if(m)return(0,R.join)(m,d[u])}}}catch{}return null}e.realcase=S;async function C(b){try{return await w.Promises.realpath(b)}catch{const y=k(b);return await w.Promises.access(y,o.constants.R_OK),y}}e.realpath=C;function L(b){try{return o.realpathSync(b)}catch{const y=k(b);return o.accessSync(y,o.constants.R_OK),y}}e.realpathSync=L;function k(b){return(0,A.rtrim)((0,R.normalize)(b),R.sep)}}),define(Se[116],ye([1,0,12,11,33,109,9,29]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(k=l.env){return k.comspec||"cmd.exe"}e.getWindowsShell=S;function C(k){let b=[],I=!1;const y=function(f){if(I){b.push(f);return}(!k.send(f,u=>{if(u&&console.error(u),I=!1,b.length>0){const m=b.slice(0);b=[],m.forEach(v=>y(v))}})||R.isWindows)&&(I=!0)};return{send:y}}e.createQueuedSender=C;var L;(function(k){async function b(I,y,f){if(o.isAbsolute(I))return I;if(y===void 0&&(y=l.cwd()),o.dirname(I)!=="."||(f===void 0&&w.isString(l.env.PATH)&&(f=l.env.PATH.split(o.delimiter)),f===void 0||f.length===0))return o.join(y,I);async function u(m){if(await P.Promises.exists(m)){let v;try{v=await P.Promises.stat(m)}catch(D){D.message.startsWith("EACCES")&&(v=await P.Promises.lstat(m))}return v?!v.isDirectory():!1}return!1}for(const m of f){let v;if(o.isAbsolute(m)?v=o.join(m,I):v=o.join(y,m,I),await u(v))return v;let D=v+".com";if(await u(D)||(D=v+".exe",await u(D)))return D}return o.join(y,I)}k.findExecutable=b})(L=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(re,e,o,R){var l=arguments.length,A=l<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,o):R,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(re,e,o,R);else for(var P=re.length-1;P>=0;P--)(w=re[P])&&(A=(l<3?w(A):l>3?w(e,o,A):w(e,o))||A);return l>3&&A&&Object.defineProperty(e,o,A),A};define(Se[117],ye([1,0,16,19,22,21,62,10,3,6,69,8,9]),function(re,e,o,R,l,A,w,P,S,C,L,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(I||(I={}));function y(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(f||(f={}));function d(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(u||(u={}));function m(J){let z=0;for(let Q=0;;Q+=7){const ie=J.read(1);if(z|=(ie.buffer[0]&127)<<Q,!(ie.buffer[0]&128))return z}}const v=r(0);function D(J,z){if(z===0){J.write(v);return}let Q=0;for(let ge=z;ge!==0;ge=ge>>>7)Q++;const ie=l.VSBuffer.alloc(Q);for(let ge=0;z!==0;ge++)ie.buffer[ge]=z&127,z=z>>>7,z>0&&(ie.buffer[ge]|=128);J.write(ie)}class p{constructor(z){this.buffer=z,this.pos=0}read(z){const Q=this.buffer.slice(this.pos,this.pos+z);return this.pos+=Q.byteLength,Q}}e.BufferReader=p;class n{constructor(){this.buffers=[]}get buffer(){return l.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}e.BufferWriter=n;var s;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(s||(s={}));function r(J){const z=l.VSBuffer.alloc(1);return z.writeUInt8(J,0),z}const a={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},c=typeof Buffer<"u";function g(J,z){if(typeof z>"u")J.write(a.Undefined);else if(typeof z=="string"){const Q=l.VSBuffer.fromString(z);J.write(a.String),D(J,Q.byteLength),J.write(Q)}else if(c&&Buffer.isBuffer(z)){const Q=l.VSBuffer.wrap(z);J.write(a.Buffer),D(J,Q.byteLength),J.write(Q)}else if(z instanceof l.VSBuffer)J.write(a.VSBuffer),D(J,z.byteLength),J.write(z);else if(Array.isArray(z)){J.write(a.Array),D(J,z.length);for(const Q of z)g(J,Q)}else if(typeof z=="number"&&(z|0)===z)J.write(a.Uint),D(J,z);else{const Q=l.VSBuffer.fromString(JSON.stringify(z));J.write(a.Object),D(J,Q.byteLength),J.write(Q)}}e.serialize=g;function i(J){switch(J.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return J.read(m(J)).toString();case s.Buffer:return J.read(m(J)).buffer;case s.VSBuffer:return J.read(m(J));case s.Array:{const Q=m(J),ie=[];for(let ge=0;ge<Q;ge++)ie.push(i(J));return ie}case s.Object:return JSON.parse(J.read(m(J)).toString());case s.Int:return m(J)}}e.deserialize=i;class t{constructor(z,Q,ie=null,ge=1e3){this.protocol=z,this.ctx=Q,this.logger=ie,this.timeoutDelay=ge,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(z,Q){this.channels.set(z,Q),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const Q=this.send([z.type]);this.logger?.logOutgoing(Q,0,1,d(z.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(Q,z.id,1,d(z.type),z.data);return}}}send(z,Q=void 0){const ie=new n;return g(ie,z),g(ie,Q),this.sendBuffer(ie.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const Q=new p(z),ie=i(Q),ge=i(Q),K=ie[0];switch(K){case 100:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${y(K)}: ${ie[2]}.${ie[3]}`,ge),this.onPromise({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 102:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${y(K)}: ${ie[2]}.${ie[3]}`,ge),this.onEventListen({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 101:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${y(K)}`),this.disposeActiveRequest({type:K,id:ie[1]});case 103:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${y(K)}`),this.disposeActiveRequest({type:K,id:ie[1]})}}onPromise(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ie=new A.CancellationTokenSource;let ge;try{ge=Q.call(this.ctx,z.name,z.arg,ie.token)}catch(ee){ge=Promise.reject(ee)}const K=z.id;ge.then(ee=>{this.sendResponse({id:K,data:ee,type:201}),this.activeRequests.delete(z.id)},ee=>{ee instanceof Error?this.sendResponse({id:K,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.sendResponse({id:K,data:ee,type:203}),this.activeRequests.delete(z.id)});const Y=(0,C.toDisposable)(()=>ie.cancel());this.activeRequests.set(z.id,Y)}onEventListen(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ie=z.id,K=Q.listen(this.ctx,z.name,z.arg)(Y=>this.sendResponse({id:ie,data:Y,type:204}));this.activeRequests.set(z.id,K)}disposeActiveRequest(z){const Q=this.activeRequests.get(z.id);Q&&(Q.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let Q=this.pendingRequests.get(z.channelName);Q||(Q=[],this.pendingRequests.set(z.channelName,Q));const ie=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:z,timeoutTimer:ie})}flushPendingRequests(z){const Q=this.pendingRequests.get(z);if(Q){for(const ie of Q)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=t;var h;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class _{constructor(z,Q=null){this.protocol=z,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=Q}getChannel(z){const Q=this;return{call(ie,ge,K){return Q.isDisposed?Promise.reject(new P.CancellationError):Q.requestPromise(z,ie,ge,K)},listen(ie,ge){return Q.isDisposed?S.Event.None:Q.requestEvent(z,ie,ge)}}}requestPromise(z,Q,ie,ge=A.CancellationToken.None){const K=this.lastRequestId++,ee={id:K,type:100,channelName:z,name:Q,arg:ie};if(ge.isCancellationRequested)return Promise.reject(new P.CancellationError);let me;return new Promise((De,Ae)=>{if(ge.isCancellationRequested)return Ae(new P.CancellationError);const ae=()=>{const ce=oe=>{switch(oe.type){case 201:this.handlers.delete(K),De(oe.data);break;case 202:{this.handlers.delete(K);const M=new Error(oe.data.message);M.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,M.name=oe.data.name,Ae(M);break}case 203:this.handlers.delete(K),Ae(oe.data);break}};this.handlers.set(K,ce),this.sendRequest(ee)};let le=null;this.state===u.Idle?ae():(le=(0,R.createCancelablePromise)(ce=>this.whenInitialized()),le.then(()=>{le=null,ae()}));const ue=()=>{le?(le.cancel(),le=null):this.sendRequest({id:K,type:101}),Ae(new P.CancellationError)},ne=ge.onCancellationRequested(ue);me=(0,C.combinedDisposable)((0,C.toDisposable)(ue),ne),this.activeRequests.add(me)}).finally(()=>{this.activeRequests.delete(me)})}requestEvent(z,Q,ie){const ge=this.lastRequestId++,Y={id:ge,type:102,channelName:z,name:Q,arg:ie};let ee=null;const me=new S.Emitter({onWillAddFirstListener:()=>{ee=(0,R.createCancelablePromise)(De=>this.whenInitialized()),ee.then(()=>{ee=null,this.activeRequests.add(me),this.sendRequest(Y)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.activeRequests.delete(me),this.sendRequest({id:ge,type:103}))}}),be=De=>me.fire(De.data);return this.handlers.set(ge,be),me.event}sendRequest(z){switch(z.type){case 100:case 102:{const Q=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(Q,z.id,0,`${y(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const Q=this.send([z.type,z.id]);this.logger?.logOutgoing(Q,z.id,0,y(z.type));return}}}send(z,Q=void 0){const ie=new n;return g(ie,z),g(ie,Q),this.sendBuffer(ie.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const Q=new p(z),ie=i(Q),ge=i(Q),K=ie[0];switch(K){case 200:return this.logger?.logIncoming(z.byteLength,0,0,d(K)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(z.byteLength,ie[1],0,d(K),ge),this.onResponse({type:ie[0],id:ie[1],data:ge})}}onResponse(z){if(z.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([w.memoize],_.prototype,"onDidInitializePromise",null),e.ChannelClient=_;class E{get connections(){const z=[];return this._connections.forEach(Q=>z.push(Q)),z}constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:Q,onDidClientDisconnect:ie})=>{S.Event.once(Q.onMessage)(K=>{const Y=new p(K),ee=i(Y),me=new t(Q,ee),be=new _(Q);this.channels.forEach((Ae,ae)=>me.registerChannel(ae,Ae));const De={channelServer:me,channelClient:be,ctx:ee};this._connections.add(De),this._onDidAddConnection.fire(De),ie(()=>{me.dispose(),be.dispose(),this._connections.delete(De),this._onDidRemoveConnection.fire(De)})})})}getChannel(z,Q){const ie=this;return{call(ge,K,Y){let ee;if((0,b.isFunction)(Q)){const be=(0,o.getRandomElement)(ie.connections.filter(Q));ee=be?Promise.resolve(be):S.Event.toPromise(S.Event.filter(ie.onDidAddConnection,Q))}else ee=Q.routeCall(ie,ge,K);const me=ee.then(be=>be.channelClient.getChannel(z));return $(me).call(ge,K,Y)},listen(ge,K){if((0,b.isFunction)(Q))return ie.getMulticastEvent(z,Q,ge,K);const Y=Q.routeEvent(ie,ge,K).then(ee=>ee.channelClient.getChannel(z));return $(Y).listen(ge,K)}}}getMulticastEvent(z,Q,ie,ge){const K=this;let Y=new C.DisposableStore;const ee=new S.Emitter({onWillAddFirstListener:()=>{Y=new C.DisposableStore;const me=new S.EventMultiplexer,be=new Map,De=ae=>{const ue=ae.channelClient.getChannel(z).listen(ie,ge),ne=me.add(ue);be.set(ae,ne)},Ae=ae=>{const le=be.get(ae);!le||(le.dispose(),be.delete(ae))};K.connections.filter(Q).forEach(De),S.Event.filter(K.onDidAddConnection,Q)(De,void 0,Y),K.onDidRemoveConnection(Ae,void 0,Y),me.event(ee.fire,ee,Y),Y.add(me)},onDidRemoveLastListener:()=>{Y.dispose()}});return ee.event}registerChannel(z,Q){this.channels.set(z,Q),this._connections.forEach(ie=>{ie.channelServer.registerChannel(z,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class O{constructor(z,Q,ie=null){const ge=new n;g(ge,Q),z.send(ge.buffer),this.channelClient=new _(z,ie),this.channelServer=new t(z,Q,ie)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,Q){this.channelServer.registerChannel(z,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function $(J){return{call(z,Q,ie){return J.then(ge=>ge.call(z,Q,ie))},listen(z,Q){const ie=new S.Relay;return J.then(ge=>ie.input=ge.listen(z,Q)),ie.event}}}e.getDelayedChannel=$;function H(J){let z=!1;return{call(Q,ie,ge){return z?J.call(Q,ie,ge):(0,R.timeout)(0).then(()=>z=!0).then(()=>J.call(Q,ie,ge))},listen(Q,ie){if(z)return J.listen(Q,ie);const ge=new S.Relay;return(0,R.timeout)(0).then(()=>z=!0).then(()=>ge.input=J.listen(Q,ie)),ge.event}}}e.getNextTickChannel=H;class X{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const Q of z.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=X;var V;(function(J){function z(K,Y){const ee=K,me=Y&&Y.disableMarshalling,be=new Map;for(const De in ee)ie(De)&&be.set(De,S.Event.buffer(ee[De],!0));return new class{listen(De,Ae,ae){const le=be.get(Ae);if(le)return le;if(ge(Ae)){const ue=ee[Ae];if(typeof ue=="function")return ue.call(ee,ae)}throw new Error(`Event not found: ${Ae}`)}call(De,Ae,ae){const le=ee[Ae];if(typeof le=="function"){if(!me&&Array.isArray(ae))for(let ue=0;ue<ae.length;ue++)ae[ue]=(0,L.revive)(ae[ue]);return le.apply(ee,ae)}throw new Error(`Method not found: ${Ae}`)}}}J.fromService=z;function Q(K,Y){const ee=Y&&Y.disableMarshalling;return new Proxy({},{get(me,be){if(typeof be=="string")return Y?.properties?.has(be)?Y.properties.get(be):ge(be)?function(De){return K.listen(be,De)}:ie(be)?K.listen(be):async function(...De){let Ae;Y&&!(0,b.isUndefinedOrNull)(Y.context)?Ae=[Y.context,...De]:Ae=De;const ae=await K.call(be,Ae);return ee?ae:(0,L.revive)(ae)};throw new Error(`Property not found: ${String(be)}`)}})}J.toService=Q;function ie(K){return K[0]==="o"&&K[1]==="n"&&k.isUpperAsciiLetter(K.charCodeAt(2))}function ge(K){return/^onDynamic/.test(K)&&k.isUpperAsciiLetter(K.charCodeAt(9))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const z=J.toString();if(z!=="[object Object]")return z}return J}function F(J){return Array.isArray(J)?J.map(T):T(J)}function U(J,z,Q,ie,ge,K,Y){Y=F(Y);const ee=N[ge],me=ee[ie%ee.length];let be=[`%c[${J}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(K)?(be=be.concat(Y),be.push(")")):be.push(Y),console.log.apply(console,be)}class Z{constructor(z,Q){this._outgoingPrefix=z,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,Q,ie,ge,K){this._totalOutgoing+=z,U(this._outgoingPrefix,this._totalOutgoing,z,Q,ie,ge,K)}logIncoming(z,Q,ie,ge,K){this._totalIncoming+=z,U(this._incomingPrefix,this._totalIncoming,z,Q,ie,ge,K)}}e.IPCLogger=Z}),define(Se[118],ye([1,0,19,22,3,6,117]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(_){_.Created="created",_.Read="read",_.Write="write",_.Open="open",_.Error="error",_.Close="close",_.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",_.NodeEndReceived="nodeEndReceived",_.NodeEndSent="nodeEndSent",_.NodeDrainBegin="nodeDrainBegin",_.NodeDrainEnd="nodeDrainEnd",_.zlibInflateError="zlibInflateError",_.zlibInflateData="zlibInflateData",_.zlibInflateInitialWrite="zlibInflateInitialWrite",_.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",_.zlibInflateWrite="zlibInflateWrite",_.zlibInflateFlushFired="zlibInflateFlushFired",_.zlibDeflateError="zlibDeflateError",_.zlibDeflateData="zlibDeflateData",_.zlibDeflateWrite="zlibDeflateWrite",_.zlibDeflateFlushFired="zlibDeflateFlushFired",_.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",_.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",_.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",_.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",_.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",_.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",_.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",_.ProtocolHeaderRead="protocolHeaderRead",_.ProtocolMessageRead="protocolMessageRead",_.ProtocolHeaderWrite="protocolHeaderWrite",_.ProtocolMessageWrite="protocolMessageWrite",_.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(_){_.enableDiagnostics=!1,_.records=[];const E=new WeakMap;let O=0;function $(X,V){if(!E.has(X)){const N=String(++O);E.set(X,N)}return E.get(X)}function H(X,V,N,T){if(!_.enableDiagnostics)return;const F=$(X,V);if(T instanceof R.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const U=R.VSBuffer.alloc(T.byteLength);U.set(T),_.records.push({timestamp:Date.now(),id:F,label:V,type:N,buff:U})}else _.records.push({timestamp:Date.now(),id:F,label:V,type:N,data:T})}_.traceSocketEvent=H})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(_){_[_.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",_[_.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function k(){return L||(L=R.VSBuffer.alloc(0)),L}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(E){this._chunks.push(E),this._totalLength+=E.byteLength}read(E){return this._read(E,!0)}peek(E){return this._read(E,!1)}_read(E,O){if(E===0)return k();if(E>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===E){const V=this._chunks[0];return O&&(this._chunks.shift(),this._totalLength-=E),V}if(this._chunks[0].byteLength>E){const V=this._chunks[0].slice(0,E);return O&&(this._chunks[0]=this._chunks[0].slice(E),this._totalLength-=E),V}const $=R.VSBuffer.alloc(E);let H=0,X=0;for(;E>0;){const V=this._chunks[X];if(V.byteLength>E){const N=V.slice(0,E);$.set(N,H),H+=E,O&&(this._chunks[X]=V.slice(E),this._totalLength-=E),E-=E}else $.set(V,H),H+=V.byteLength,O?(this._chunks.shift(),this._totalLength-=V.byteLength):X++,E-=V.byteLength}return $}}e.ChunkStream=b;var I;(function(_){_[_.None=0]="None",_[_.Regular=1]="Regular",_[_.Control=2]="Control",_[_.Ack=3]="Ack",_[_.Disconnect=5]="Disconnect",_[_.ReplayRequest=6]="ReplayRequest",_[_.Pause=7]="Pause",_[_.Resume=8]="Resume",_[_.KeepAlive=9]="KeepAlive",_[_.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",_[_.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(I||(I={}));function y(_){switch(_){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(_){_[_.HeaderLength=13]="HeaderLength",_[_.AcknowledgeTime=2e3]="AcknowledgeTime",_[_.TimeoutTime=2e4]="TimeoutTime",_[_.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",_[_.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",_[_.KeepAliveSendTime=5e3]="KeepAliveSendTime",_[_.LatencySampleTime=6e4]="LatencySampleTime",_[_.LatencySampleCount=5]="LatencySampleCount",_[_.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",_[_.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(E,O,$,H){this.type=E,this.id=O,this.ack=$,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends A.Disposable{constructor(E){super(),this._onMessage=this._register(new l.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=E,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(E){if(!(!E||E.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;){const O=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=O.readUInt32BE(9),this._state.messageType=O.readUInt8(0),this._state.id=O.readUInt32BE(1),this._state.ack=O.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const $=this._state.messageType,H=this._state.id,X=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",O),this._onMessage.fire(new d($,H,X,O)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(E){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=E,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(E){if(this._isDisposed)return;E.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=R.VSBuffer.alloc(13);O.writeUInt8(E.type,0),O.writeUInt32BE(E.id,1),O.writeUInt32BE(E.ack,5),O.writeUInt32BE(E.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(E.type),id:E.id,ack:E.ack,messageSize:E.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",E.data),this._writeSoon(O,E.data)}_bufferAdd(E,O){const $=this._totalLength===0;return this._data.push(E,O),this._totalLength+=E.byteLength+O.byteLength,$}_bufferTake(){const E=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,E}_writeSoon(E,O){this._bufferAdd(E,O)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const E=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:E.byteLength}),this._socket.write(E)}}class v extends A.Disposable{constructor(E){super(),this._onMessage=new l.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=E,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(O=>{O.type===1&&this._onMessage.fire(O.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(E){this._socketWriter.write(new d(1,0,0,E))}}e.Protocol=v;class D extends w.IPCClient{static fromSocket(E,O){return new D(new v(E),O)}get onDidDispose(){return this.protocol.onDidDispose}constructor(E,O,$=null){super(E,O,$),this.protocol=E}dispose(){super.dispose();const E=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),E.end()}}e.Client=D;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new l.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(E){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(E):this._emitter.fire(E):this._bufferedMessages.push(E)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class n{constructor(E){this.data=E,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let E=0,O=this._first;for(;O;)O=O.next,E++;return E}peek(){return this._first?this._first.data:null}toArray(){const E=[];let O=0,$=this._first;for(;$;)E[O++]=$.data,$=$.next;return E}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(E){const O=new n(E);if(!this._first){this._first=O,this._last=O;return}this._last.next=O,this._last=O}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const E=Date.now();for(let O=0;O<r._HISTORY_LENGTH;O++)this.lastRuns[O]=E-1e3*O;setInterval(()=>{for(let O=r._HISTORY_LENGTH;O>=1;O--)this.lastRuns[O]=this.lastRuns[O-1];this.lastRuns[0]=Date.now()},1e3)}load(){const E=Date.now(),O=(1+r._HISTORY_LENGTH)*1e3;let $=0;for(let H=0;H<r._HISTORY_LENGTH;H++)E-this.lastRuns[H]<=O&&$++;return 1-$/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;var a;(function(_){_[_.Good=0]="Good",_[_.Poor=1]="Poor"})(a=e.ConnectionHealth||(e.ConnectionHealth={}));function c(_){switch(_){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=c;class g{constructor(E){this.connectionHealth=E}}e.ConnectionHealthChangedEvent=g;class i{constructor(E,O){this.roundTripTime=E,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=i;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(E){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new p,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new p,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=E.loadEstimator??r.getInstance(),this._measureRoundTripTime=E.measureRoundTripTime??!1,this._shouldSendKeepAlive=E.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=E.socket,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(O=>this._receiveMessage(O))),this._socketDisposables.add(this._socket.onClose(O=>this._onSocketClose.fire(O))),this._socketLatencyMonitor=this._socketDisposables.add(new h),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(O=>this._sendLatencyMeasurementRequest(O))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(O=>this._onHighRoundTripTime.fire(O))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(O=>this._onDidChangeConnectionHealth.fire(O))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),E.initialChunk&&this._socketReader.acceptChunk(E.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const E=new d(5,0,0,k());this._socketWriter.write(E),this._socketWriter.flush()}sendPause(){const E=new d(7,0,0,k());this._socketWriter.write(E)}sendResume(){const E=new d(8,0,0,k());this._socketWriter.write(E)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(E,O){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=E,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new u(this._socket)),this._socketDisposables.add(this._socketReader.onMessage($=>this._receiveMessage($))),this._socketDisposables.add(this._socket.onClose($=>this._onSocketClose.fire($))),this._socketLatencyMonitor=this._socketDisposables.add(new h),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest($=>this._sendLatencyMeasurementRequest($))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime($=>this._onHighRoundTripTime.fire($))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth($=>this._onDidChangeConnectionHealth.fire($))),this._socketReader.acceptChunk(O)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const E=new d(3,0,this._incomingAckId,k());this._socketWriter.write(E);const O=this._outgoingUnackMsg.toArray();for(let $=0,H=O.length;$<H;$++)this._socketWriter.write(O[$]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(E){if(E.ack>this._outgoingAckId){this._outgoingAckId=E.ack;do{const O=this._outgoingUnackMsg.peek();if(O&&O.id<=E.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(E.type){case 0:break;case 1:{if(E.id>this._incomingMsgId)if(E.id!==this._incomingMsgId+1){const O=Date.now();O-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=O,this._socketWriter.write(new d(6,0,0,k())))}else this._incomingMsgId=E.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(E.data);break}case 2:{this._onControlMessage.fire(E.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const O=this._outgoingUnackMsg.toArray();for(let $=0,H=O.length;$<H;$++)this._socketWriter.write(O[$]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(E.data);break}case 11:{this._socketLatencyMonitor.handleResponse(E.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(E){const O=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const $=new d(1,O,this._incomingAckId,E);this._outgoingUnackMsg.push($),this._isReconnecting||(this._socketWriter.write($),this._recvAckCheck())}sendControl(E){const O=new d(2,0,0,E);this._socketWriter.write(O)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const E=Date.now()-this._incomingMsgLastTime;if(E>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-E+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const E=this._outgoingUnackMsg.peek(),O=Date.now()-E.writtenTime,$=Date.now()-this._socketReader.lastReadTime,H=Date.now()-this._lastSocketTimeoutTime;if(O>=2e4&&$>=2e4&&H>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:$});return}const X=Math.max(2e4-O,2e4-$,2e4-H,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},X)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const E=new d(3,0,this._incomingAckId,k());this._socketWriter.write(E)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const E=new d(9,0,this._incomingAckId,k());this._socketWriter.write(E)}_sendLatencyMeasurementRequest(E){this._incomingAckId=this._incomingMsgId;const O=new d(10,0,this._incomingAckId,E);this._socketWriter.write(O)}_sendLatencyMeasurementResponse(E){this._incomingAckId=this._incomingMsgId;const O=new d(11,0,this._incomingAckId,E);this._socketWriter.write(O)}}e.PersistentProtocol=t;class h extends A.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new l.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new l.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new l.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new o.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},E=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const E=++this._lastLatencyMeasurementId,O=R.VSBuffer.alloc(4);O.writeUInt32BE(E,0),this._onSendLatencyRequest.fire(O)},6e4)}handleResponse(E){if(E.byteLength!==4)return;const O=E.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||O!==this._lastLatencyMeasurementId)return;const $=Date.now()-this._lastLatencyMeasurementSent,H=this._latencySampleIndex++;this._latencySamples[H%this._latencySamples.length]=$;const X=this._connectionHealth,V=this._latencySamples.filter(N=>N>=1e3).length;this._connectionHealth=V>=3?1:0,$>1e3&&this._onHighRoundTripTime.fire(new i($,V)),X!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(Se[119],ye([1,0,22,10,3,6,12,11,30,117,118]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(i,t){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,t)}constructor(i,t=""){this._canWrite=!0,this.debugLabel=t,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,R.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener),this._closeListener=h=>{this.traceSocketEvent("close",{hadError:h}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(i){const t=h=>{this.traceSocketEvent("read",h),i(o.VSBuffer.wrap(h))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(i){const t=h=>{i({type:0,hadError:h,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(i){const t=()=>{i()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(i){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,R.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,R.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=b;var I;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(I||(I={}));var y;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(y||(y={}));class f extends A.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(i,t){this.socket.traceSocketEvent(i,t)}constructor(i,t,h,_){super(),this._onData=this._register(new l.Emitter),this._onClose=this._register(new l.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:h?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new d(this,t,h,_,this._onData,(E,O)=>this._write(E,O))),this._register(this._flowManager.onError(E=>{console.error(E),(0,R.onUnexpectedError)(E),this._onClose.fire({type:0,hadError:!0,error:E})})),this._incomingData=new L.ChunkStream,this._register(this.socket.onData(E=>this._acceptChunk(E))),this._register(this.socket.onClose(async E=>{this._flowManager.isProcessingReadQueue()&&await l.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(E)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this._onData.event(i)}onClose(i){return this._onClose.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){let t=0;for(;t<i.byteLength;)this._flowManager.writeMessage(i.slice(t,Math.min(t+262144,i.byteLength))),t+=262144}_write(i,t){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let h=2;i.byteLength<126?h+=0:i.byteLength<2**16?h+=2:h+=8;const _=o.VSBuffer.alloc(h);if(t?_.writeUInt8(194,0):_.writeUInt8(130,0),i.byteLength<126)_.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){_.writeUInt8(126,1);let E=1;_.writeUInt8(i.byteLength>>>8&255,++E),_.writeUInt8(i.byteLength>>>0&255,++E)}else{_.writeUInt8(127,1);let E=1;_.writeUInt8(0,++E),_.writeUInt8(0,++E),_.writeUInt8(0,++E),_.writeUInt8(0,++E),_.writeUInt8(i.byteLength>>>24&255,++E),_.writeUInt8(i.byteLength>>>16&255,++E),_.writeUInt8(i.byteLength>>>8&255,++E),_.writeUInt8(i.byteLength>>>0&255,++E)}this.socket.write(o.VSBuffer.concat([_,i]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(i){if(i.byteLength!==0){for(this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const t=this._incomingData.peek(this._state.readLen),h=t.readUInt8(0),_=(h&128)>>>7,E=(h&64)>>>6,O=t.readUInt8(1),$=(O&128)>>>7,H=O&127;this._state.state=2,this._state.readLen=2+($?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(E)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const t=this._incomingData.read(this._state.readLen),h=t.readUInt8(1),_=(h&128)>>>7;let E=h&127,O=1;E===126?E=t.readUInt8(++O)*2**8+t.readUInt8(++O):E===127&&(E=t.readUInt8(++O)*0+t.readUInt8(++O)*0+t.readUInt8(++O)*0+t.readUInt8(++O)*0+t.readUInt8(++O)*2**24+t.readUInt8(++O)*2**16+t.readUInt8(++O)*2**8+t.readUInt8(++O));let $=0;_&&($=t.readUInt8(++O)*2**24+t.readUInt8(++O)*2**16+t.readUInt8(++O)*2**8+t.readUInt8(++O)),this._state.state=3,this._state.readLen=E,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const t=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),v(t,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(t,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await l.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class d extends A.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:o.VSBuffer.alloc(0)}constructor(i,t,h,_,E,O){super(),this._tracer=i,this._onData=E,this._writeFn=O,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new l.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new l.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,t?(this._zlibInflateStream=this._register(new u(this._tracer,_,h,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(i){this._writeQueue.push(i),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const i=this._writeQueue.shift();if(this._zlibDeflateStream){const t=await this._deflateMessage(this._zlibDeflateStream,i);this._writeFn(t,!0)}else this._writeFn(i,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(i,t){return new Promise((h,_)=>{i.write(t),i.flush(E=>h(E))})}acceptFrame(i,t,h){this._readQueue.push({data:i,isCompressed:t,isLastFrameOfMessage:h}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const i=this._readQueue.shift();if(this._zlibInflateStream&&i.isCompressed){const t=await this._inflateFrame(this._zlibInflateStream,i.data,i.isLastFrameOfMessage);this._onData.fire(t)}else this._onData.fire(i.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(i,t,h){return new Promise((_,E)=>{i.write(t),h&&i.write(o.VSBuffer.fromByteArray([0,0,255,255])),i.flush(O=>_(O))})}}class u extends A.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?o.VSBuffer.concat(this._recordedInflateBytes):o.VSBuffer.alloc(0)}constructor(i,t,h,_){super(),this._tracer=i,this._recordInflateBytes=t,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(_),this._zlibInflate.on("error",E=>{this._tracer.traceSocketEvent("zlibInflateError",{message:E?.message,code:E?.code}),this._onError.fire(E)}),this._zlibInflate.on("data",E=>{this._tracer.traceSocketEvent("zlibInflateData",E),this._pendingInflateData.push(o.VSBuffer.wrap(E))}),h&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(i){this._recordInflateBytes&&this._recordedInflateBytes.push(i.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",i),this._zlibInflate.write(i.buffer)}flush(i){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const t=o.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,i(t)})}}class m extends A.Disposable{constructor(i,t){super(),this._tracer=i,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",h=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this._onError.fire(h)}),this._zlibDeflate.on("data",h=>{this._tracer.traceSocketEvent("zlibDeflateData",h),this._pendingDeflateData.push(o.VSBuffer.wrap(h))})}write(i){this._tracer.traceSocketEvent("zlibDeflateWrite",i.buffer),this._zlibDeflate.write(i.buffer)}flush(i){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let t=o.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,t=t.slice(0,t.byteLength-4),i(t)})}}function v(g,i){if(i===0)return;const t=g.byteLength>>>2;for(let H=0;H<t;H++){const X=g.readUInt32BE(H*4);g.writeUInt32BE(X^i,H*4)}const h=t*4,_=g.byteLength-h,E=i>>>24&255,O=i>>>16&255,$=i>>>8&255;_>=1&&g.writeUInt8(g.readUInt8(h)^E,h),_>=2&&g.writeUInt8(g.readUInt8(h+1)^O,h+1),_>=3&&g.writeUInt8(g.readUInt8(h+2)^$,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const D={[2]:107,[1]:103};function p(){const g=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let i;return e.XDG_RUNTIME_DIR?i=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):i=(0,w.join)(k().os.tmpdir(),`vscode-ipc-${g}.sock`),s(i),i}e.createRandomIPCHandle=p;function n(g,i,t){const h=k().crypto.createHash("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${t}-${i}-sock`;const _=t.substr(0,4),E=i.substr(0,6),O=h.substr(0,8);let $;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?$=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${O}-${_}-${E}.sock`):$=(0,w.join)(g,`${_}-${E}.sock`),s($),$}e.createStaticIPCHandle=n;function s(g){const i=D[P.platform];typeof i=="number"&&g.length>=i&&console.warn(`WARNING: IPC handle "${g}" is longer than ${i} chars, try a shorter --user-data-dir`)}class r extends C.IPCServer{static toClientConnectionEvent(i){const t=l.Event.fromNodeEventEmitter(i,"connection");return l.Event.map(t,h=>({protocol:new L.Protocol(new b(h,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(h,"close"))}))}constructor(i){super(r.toClientConnectionEvent(i)),this.server=i}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(g){return new Promise((i,t)=>{const h=k().net.createServer();h.on("error",t),h.listen(g,()=>{h.removeListener("error",t),i(new r(h))})})}e.serve=a;function c(g,i){return new Promise((t,h)=>{const _=k().net.createConnection(g,()=>{_.removeListener("error",h),t(L.Client.fromSocket(new b(_,`ipc-client${i}`),i))});_.once("error",h)})}e.connect=c}),define(Se[164],ye([1,0,38,12]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(A,w,P,S,C,L){if(Array.isArray(A)){let k=0;for(const b of A){const I=l(b,w,P,S,C,L);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof A=="string")return S?A==="*"?5:A===P?10:0:0;if(A){const{language:k,pattern:b,scheme:I,hasAccessToAllModels:y,notebookType:f}=A;if(!S&&!y)return 0;f&&C&&(w=C);let d=0;if(I)if(I===w.scheme)d=10;else if(I==="*")d=5;else return 0;if(k)if(k===P)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(f)if(f===L)d=10;else if(f==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(b){let u;if(typeof b=="string"?u=b:u={...b,base:(0,R.normalize)(b.base)},u===w.fsPath||(0,o.match)(u,w.fsPath))d=10;else return 0}return d}else return 0}}e.score=l}),define(Se[165],ye([1,0,8,52,155]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(P,S,C,L){this._uri=P,this._lines=S,this._eol=C,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const S=P.changes;for(const C of S)this._acceptDeleteRange(C.range),this._acceptInsertText(new R.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,S=this._lines.length,C=new Uint32Array(S);for(let L=0;L<S;L++)C[L]=this._lines[L].length+P;this._lineStarts=new l.PrefixSumComputer(C)}}_setLineText(P,S){this._lines[P]=S,this._lineStarts&&this._lineStarts.setValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,S){if(S.length===0)return;const C=(0,o.splitLines)(S);if(C.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+C[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}C[C.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+C[0]);const L=new Uint32Array(C.length-1);for(let k=1;k<C.length;k++)this._lines.splice(P.lineNumber+k-1,0,C[k]),L[k-1]=C[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,L)}}e.MirrorTextModel=A}),define(Se[166],ye([1,0,8,152,52,32,107]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(m,v,D,p){this.searchString=m,this.isRegex=v,this.matchCase=D,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=C(this.searchString):m=this.searchString.indexOf(`
`)>=0;let v=null;try{v=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch{return null}if(!v)return null;let D=!this.isRegex&&!m;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new w.SearchData(v,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=S;function C(u){if(!u||u.length===0)return!1;for(let m=0,v=u.length;m<v;m++){const D=u.charCodeAt(m);if(D===10)return!0;if(D===92){if(m++,m>=v)break;const p=u.charCodeAt(m);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=C;function L(u,m,v){if(!v)return new w.FindMatch(u,null);const D=[];for(let p=0,n=m.length;p<n;p++)D[p]=m[p];return new w.FindMatch(u,D)}e.createFindMatch=L;class k{constructor(m){const v=[];let D=0;for(let p=0,n=m.length;p<n;p++)m.charCodeAt(p)===10&&(v[D++]=p);this._lineFeedsOffsets=v}findLineFeedCountBeforeOffset(m){const v=this._lineFeedsOffsets;let D=0,p=v.length-1;if(p===-1||m<=v[0])return 0;for(;D<p;){const n=D+((p-D)/2>>0);v[n]>=m?p=n-1:v[n+1]>=m?(D=n,p=n):D=n+1}return D+1}}class b{static findMatches(m,v,D,p,n){const s=v.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(m,D,new d(s.wordSeparators,s.regex),p,n):this._doFindMatchesLineByLine(m,D,s,p,n):[]}static _getMultilineMatchRange(m,v,D,p,n,s){let r,a=0;p?(a=p.findLineFeedCountBeforeOffset(n),r=v+n+a):r=v+n;let c;if(p){const h=p.findLineFeedCountBeforeOffset(n+s.length)-a;c=r+s.length+h}else c=r+s.length;const g=m.getPositionAt(r),i=m.getPositionAt(c);return new A.Range(g.lineNumber,g.column,i.lineNumber,i.column)}static _doFindMatchesMultiline(m,v,D,p,n){const s=m.getOffsetAt(v.getStartPosition()),r=m.getValueInRange(v,1),a=m.getEOL()===`\r
`?new k(r):null,c=[];let g=0,i;for(D.reset(0);i=D.next(r);)if(c[g++]=L(this._getMultilineMatchRange(m,s,r,a,i.index,i[0]),i,p),g>=n)return c;return c}static _doFindMatchesLineByLine(m,v,D,p,n){const s=[];let r=0;if(v.startLineNumber===v.endLineNumber){const c=m.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return r=this._findMatchesInLine(D,c,v.startLineNumber,v.startColumn-1,r,s,p,n),s}const a=m.getLineContent(v.startLineNumber).substring(v.startColumn-1);r=this._findMatchesInLine(D,a,v.startLineNumber,v.startColumn-1,r,s,p,n);for(let c=v.startLineNumber+1;c<v.endLineNumber&&r<n;c++)r=this._findMatchesInLine(D,m.getLineContent(c),c,0,r,s,p,n);if(r<n){const c=m.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);r=this._findMatchesInLine(D,c,v.endLineNumber,0,r,s,p,n)}return s}static _findMatchesInLine(m,v,D,p,n,s,r,a){const c=m.wordSeparators;if(!r&&m.simpleSearch){const t=m.simpleSearch,h=t.length,_=v.length;let E=-h;for(;(E=v.indexOf(t,E+h))!==-1;)if((!c||f(c,v,_,E,h))&&(s[n++]=new w.FindMatch(new A.Range(D,E+1+p,D,E+1+h+p),null),n>=a))return n;return n}const g=new d(m.wordSeparators,m.regex);let i;g.reset(0);do if(i=g.next(v),i&&(s[n++]=L(new A.Range(D,i.index+1+p,D,i.index+1+i[0].length+p),i,r),n>=a))return n;while(i);return n}static findNextMatch(m,v,D,p){const n=v.parseSearchRequest();if(!n)return null;const s=new d(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(m,D,s,p):this._doFindNextMatchLineByLine(m,D,s,p)}static _doFindNextMatchMultiline(m,v,D,p){const n=new l.Position(v.lineNumber,1),s=m.getOffsetAt(n),r=m.getLineCount(),a=m.getValueInRange(new A.Range(n.lineNumber,n.column,r,m.getLineMaxColumn(r)),1),c=m.getEOL()===`\r
`?new k(a):null;D.reset(v.column-1);const g=D.next(a);return g?L(this._getMultilineMatchRange(m,s,a,c,g.index,g[0]),g,p):v.lineNumber!==1||v.column!==1?this._doFindNextMatchMultiline(m,new l.Position(1,1),D,p):null}static _doFindNextMatchLineByLine(m,v,D,p){const n=m.getLineCount(),s=v.lineNumber,r=m.getLineContent(s),a=this._findFirstMatchInLine(D,r,s,v.column,p);if(a)return a;for(let c=1;c<=n;c++){const g=(s+c-1)%n,i=m.getLineContent(g+1),t=this._findFirstMatchInLine(D,i,g+1,1,p);if(t)return t}return null}static _findFirstMatchInLine(m,v,D,p,n){m.reset(p-1);const s=m.next(v);return s?L(new A.Range(D,s.index+1,D,s.index+1+s[0].length),s,n):null}static findPreviousMatch(m,v,D,p){const n=v.parseSearchRequest();if(!n)return null;const s=new d(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(m,D,s,p):this._doFindPreviousMatchLineByLine(m,D,s,p)}static _doFindPreviousMatchMultiline(m,v,D,p){const n=this._doFindMatchesMultiline(m,new A.Range(1,1,v.lineNumber,v.column),D,p,10*P);if(n.length>0)return n[n.length-1];const s=m.getLineCount();return v.lineNumber!==s||v.column!==m.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(m,new l.Position(s,m.getLineMaxColumn(s)),D,p):null}static _doFindPreviousMatchLineByLine(m,v,D,p){const n=m.getLineCount(),s=v.lineNumber,r=m.getLineContent(s).substring(0,v.column-1),a=this._findLastMatchInLine(D,r,s,p);if(a)return a;for(let c=1;c<=n;c++){const g=(n+s-c-1)%n,i=m.getLineContent(g+1),t=this._findLastMatchInLine(D,i,g+1,p);if(t)return t}return null}static _findLastMatchInLine(m,v,D,p){let n=null,s;for(m.reset(0);s=m.next(v);)n=L(new A.Range(D,s.index+1,D,s.index+1+s[0].length),s,p);return n}}e.TextModelSearch=b;function I(u,m,v,D,p){if(D===0)return!0;const n=m.charCodeAt(D-1);if(u.get(n)!==0||n===13||n===10)return!0;if(p>0){const s=m.charCodeAt(D);if(u.get(s)!==0)return!0}return!1}function y(u,m,v,D,p){if(D+p===v)return!0;const n=m.charCodeAt(D+p);if(u.get(n)!==0||n===13||n===10)return!0;if(p>0){const s=m.charCodeAt(D+p-1);if(u.get(s)!==0)return!0}return!1}function f(u,m,v,D,p){return I(u,m,v,D,p)&&y(u,m,v,D,p)}e.isValidMatch=f;class d{constructor(m,v){this._wordSeparators=m,this._searchRegex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(m){this._searchRegex.lastIndex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(m){const v=m.length;let D;do{if(this._prevMatchStartIndex+this._prevMatchLength===v||(D=this._searchRegex.exec(m),!D))return null;const p=D.index,n=D[0].length;if(p===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){o.getNextCodePoint(m,v,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=n,!this._wordSeparators||f(this._wordSeparators,m,v,p,n))return D}while(D);return null}}e.Searcher=d}),define(Se[120],ye([1,0,22,11]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(l||(l={}));function A(k){for(let b=0,I=k.length;b<I;b+=4){const y=k[b+0],f=k[b+1],d=k[b+2],u=k[b+3];k[b+0]=u,k[b+1]=d,k[b+2]=f,k[b+3]=y}}function w(k){const b=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return R.isLittleEndian()||A(b),o.VSBuffer.wrap(b)}function P(k){const b=k.buffer;if(R.isLittleEndian()||A(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const I=new Uint8Array(b.byteLength);return I.set(b),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function S(k){const b=new Uint32Array(C(k));let I=0;if(b[I++]=k.id,k.type==="full")b[I++]=1,b[I++]=k.data.length,b.set(k.data,I),I+=k.data.length;else{b[I++]=2,b[I++]=k.deltas.length;for(const y of k.deltas)b[I++]=y.start,b[I++]=y.deleteCount,y.data?(b[I++]=y.data.length,b.set(y.data,I),I+=y.data.length):b[I++]=0}return w(b)}e.encodeSemanticTokensDto=S;function C(k){let b=0;if(b+=1+1,k.type==="full")b+=1+k.data.length;else{b+=1,b+=(1+1+1)*k.deltas.length;for(const I of k.deltas)I.data&&(b+=I.data.length)}return b}function L(k){const b=P(k);let I=0;const y=b[I++];if(b[I++]===1){const m=b[I++],v=b.subarray(I,I+m);return I+=m,{id:y,type:"full",data:v}}const d=b[I++],u=[];for(let m=0;m<d;m++){const v=b[I++],D=b[I++],p=b[I++];let n;p>0&&(n=b.subarray(I,I+p),I+=p),u[m]={start:v,deleteCount:D,data:n}}return{id:y,type:"delta",deltas:u}}e.decodeSemanticTokensDto=L}),define(Se[167],ye([1,0,3,6]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new o.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,S){return this._map.set(P,S),this.fire([P]),(0,R.toDisposable)(()=>{this._map.get(P)===S&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,S){this._factories.get(P)?.dispose();const C=new A(this,P,S);return this._factories.set(P,C),(0,R.toDisposable)(()=>{const L=this._factories.get(P);!L||L!==C||(this._factories.delete(P),L.dispose())})}async getOrCreate(P){const S=this.get(P);if(S)return S;const C=this._factories.get(P);return!C||C.isResolved?null:(await C.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const C=this._factories.get(P);return!!(!C||C.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=l;class A extends R.Disposable{get isResolved(){return this._isResolved}constructor(P,S,C){super(),this._registry=P,this._languageId=S,this._factory=C,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(Se[72],ye([1,0,67,2,32,167]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class w{constructor(h,_,E){this.offset=h,this.type=_,this.language=E,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=w;class P{constructor(h,_){this.tokens=h,this.endState=_,this._tokenizationResultBrand=void 0}}e.TokenizationResult=P;class S{constructor(h,_){this.tokens=h,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=S;var C;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(t){const h=new Map;h.set(0,o.Codicon.symbolMethod),h.set(1,o.Codicon.symbolFunction),h.set(2,o.Codicon.symbolConstructor),h.set(3,o.Codicon.symbolField),h.set(4,o.Codicon.symbolVariable),h.set(5,o.Codicon.symbolClass),h.set(6,o.Codicon.symbolStruct),h.set(7,o.Codicon.symbolInterface),h.set(8,o.Codicon.symbolModule),h.set(9,o.Codicon.symbolProperty),h.set(10,o.Codicon.symbolEvent),h.set(11,o.Codicon.symbolOperator),h.set(12,o.Codicon.symbolUnit),h.set(13,o.Codicon.symbolValue),h.set(15,o.Codicon.symbolEnum),h.set(14,o.Codicon.symbolConstant),h.set(15,o.Codicon.symbolEnum),h.set(16,o.Codicon.symbolEnumMember),h.set(17,o.Codicon.symbolKeyword),h.set(27,o.Codicon.symbolSnippet),h.set(18,o.Codicon.symbolText),h.set(19,o.Codicon.symbolColor),h.set(20,o.Codicon.symbolFile),h.set(21,o.Codicon.symbolReference),h.set(22,o.Codicon.symbolCustomColor),h.set(23,o.Codicon.symbolFolder),h.set(24,o.Codicon.symbolTypeParameter),h.set(25,o.Codicon.account),h.set(26,o.Codicon.issues);function _($){let H=h.get($);return H||(console.info("No codicon found for CompletionItemKind "+$),H=o.Codicon.symbolProperty),H}t.toIcon=_;const E=new Map;E.set("method",0),E.set("function",1),E.set("constructor",2),E.set("field",3),E.set("variable",4),E.set("class",5),E.set("struct",6),E.set("interface",7),E.set("module",8),E.set("property",9),E.set("event",10),E.set("operator",11),E.set("unit",12),E.set("value",13),E.set("constant",14),E.set("enum",15),E.set("enum-member",16),E.set("enumMember",16),E.set("keyword",17),E.set("snippet",27),E.set("text",18),E.set("color",19),E.set("file",20),E.set("reference",21),E.set("customcolor",22),E.set("folder",23),E.set("type-parameter",24),E.set("typeParameter",24),E.set("account",25),E.set("issue",26);function O($,H){let X=E.get($);return typeof X>"u"&&!H&&(X=9),X}t.fromString=O})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(t){t[t.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(t){return t&&R.URI.isUri(t.uri)&&l.Range.isIRange(t.range)&&(l.Range.isIRange(t.originSelectionRange)||l.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=m;var v;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var D;(function(t){t[t.Deprecated=1]="Deprecated"})(D=e.SymbolTag||(e.SymbolTag={}));var p;(function(t){const h=new Map;h.set(0,o.Codicon.symbolFile),h.set(1,o.Codicon.symbolModule),h.set(2,o.Codicon.symbolNamespace),h.set(3,o.Codicon.symbolPackage),h.set(4,o.Codicon.symbolClass),h.set(5,o.Codicon.symbolMethod),h.set(6,o.Codicon.symbolProperty),h.set(7,o.Codicon.symbolField),h.set(8,o.Codicon.symbolConstructor),h.set(9,o.Codicon.symbolEnum),h.set(10,o.Codicon.symbolInterface),h.set(11,o.Codicon.symbolFunction),h.set(12,o.Codicon.symbolVariable),h.set(13,o.Codicon.symbolConstant),h.set(14,o.Codicon.symbolString),h.set(15,o.Codicon.symbolNumber),h.set(16,o.Codicon.symbolBoolean),h.set(17,o.Codicon.symbolArray),h.set(18,o.Codicon.symbolObject),h.set(19,o.Codicon.symbolKey),h.set(20,o.Codicon.symbolNull),h.set(21,o.Codicon.symbolEnumMember),h.set(22,o.Codicon.symbolStruct),h.set(23,o.Codicon.symbolEvent),h.set(24,o.Codicon.symbolOperator),h.set(25,o.Codicon.symbolTypeParameter);function _(E){let O=h.get(E);return O||(console.info("No codicon found for SymbolKind "+E),O=o.Codicon.symbolProperty),O}t.toIcon=_})(p=e.SymbolKinds||(e.SymbolKinds={}));class n{static fromValue(h){switch(h){case"comment":return n.Comment;case"imports":return n.Imports;case"region":return n.Region}return new n(h)}constructor(h){this.value=h}}n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region"),e.FoldingRangeKind=n;var s;(function(t){function h(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}t.is=h})(s=e.Command||(e.Command={}));var r;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(a=e.CommentThreadState||(e.CommentThreadState={}));var c;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var g;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(g=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var i;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[168],ye([17,18]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Se[121],ye([1,0,168,11,106,16,23,151]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(G){this._values=G}hasChanged(G){return this._values[G]}}e.ConfigurationChangedEvent=C;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor(G,he,Re,Oe){this.id=G,this.name=he,this.defaultValue=Re,this.schema=Oe}applyUpdate(G,he){return I(G,he)}compute(G,he,Re){return Re}}class b{constructor(G,he){this.newValue=G,this.didChange=he}}e.ApplyUpdateResult=b;function I(x,G){if(typeof x!="object"||typeof G!="object"||!x||!G)return new b(G,x!==G);if(Array.isArray(x)||Array.isArray(G)){const Re=Array.isArray(x)&&Array.isArray(G)&&A.equals(x,G);return new b(G,!Re)}let he=!1;for(const Re in G)if(G.hasOwnProperty(Re)){const Oe=I(x[Re],G[Re]);Oe.didChange&&(x[Re]=Oe.newValue,he=!0)}return new b(x,he)}class y{constructor(G){this.schema=void 0,this.id=G,this.name="_never_",this.defaultValue=void 0}applyUpdate(G,he){return I(G,he)}validate(G){return this.defaultValue}}class f{constructor(G,he,Re,Oe){this.id=G,this.name=he,this.defaultValue=Re,this.schema=Oe}applyUpdate(G,he){return I(G,he)}validate(G){return typeof G>"u"?this.defaultValue:G}compute(G,he,Re){return Re}}function d(x,G){return typeof x>"u"?G:x==="false"?!1:Boolean(x)}e.boolean=d;class u extends f{constructor(G,he,Re,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Re),super(G,he,Re,Oe)}validate(G){return d(G,this.defaultValue)}}function m(x,G,he,Re){if(typeof x>"u")return G;let Oe=parseInt(x,10);return isNaN(Oe)?G:(Oe=Math.max(he,Oe),Oe=Math.min(Re,Oe),Oe|0)}e.clampedInt=m;class v extends f{static clampedInt(G,he,Re,Oe){return m(G,he,Re,Oe)}constructor(G,he,Re,Oe,Ve,$e=void 0){typeof $e<"u"&&($e.type="integer",$e.default=Re,$e.minimum=Oe,$e.maximum=Ve),super(G,he,Re,$e),this.minimum=Oe,this.maximum=Ve}validate(G){return v.clampedInt(G,this.defaultValue,this.minimum,this.maximum)}}class D extends f{static clamp(G,he,Re){return G<he?he:G>Re?Re:G}static float(G,he){if(typeof G=="number")return G;if(typeof G>"u")return he;const Re=parseFloat(G);return isNaN(Re)?he:Re}constructor(G,he,Re,Oe,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Re),super(G,he,Re,Ve),this.validationFn=Oe}validate(G){return this.validationFn(D.float(G,this.defaultValue))}}class p extends f{static string(G,he){return typeof G!="string"?he:G}constructor(G,he,Re,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Re),super(G,he,Re,Oe)}validate(G){return p.string(G,this.defaultValue)}}function n(x,G,he){return typeof x!="string"||he.indexOf(x)===-1?G:x}e.stringSet=n;class s extends f{constructor(G,he,Re,Oe,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=Oe,Ve.default=Re),super(G,he,Re,Ve),this._allowedValues=Oe}validate(G){return n(G,this.defaultValue,this._allowedValues)}}class r extends k{constructor(G,he,Re,Oe,Ve,$e,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ve,Ze.default=Oe),super(G,he,Re,Ze),this._allowedValues=Ve,this._convert=$e}validate(G){return typeof G!="string"?this.defaultValue:this._allowedValues.indexOf(G)===-1?this.defaultValue:this._convert(G)}}function a(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(G){switch(G){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(G,he,Re){return Re===0?G.accessibilitySupport:Re}}class g extends k{constructor(){const G={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",G,{"editor.comments.insertSpace":{type:"boolean",default:G.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:G.ignoreEmptyLines,description:o.localize(5,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{insertSpace:d(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(x){switch(x){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function E(x){switch(x){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class O extends y{constructor(){super(135)}compute(G,he,Re){const Oe=["monaco-editor"];return he.get(36)&&Oe.push(he.get(36)),G.extraEditorClassName&&Oe.push(G.extraEditorClassName),he.get(70)==="default"?Oe.push("mouse-default"):he.get(70)==="copy"&&Oe.push("mouse-copy"),he.get(105)&&Oe.push("showUnused"),he.get(133)&&Oe.push("showDeprecated"),Oe.join(" ")}}class $ extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(G,he,Re){return Re&&G.emptySelectionClipboard}}class H extends k{constructor(){const G={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",G,{"editor.find.cursorMoveOnType":{type:"boolean",default:G.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:G.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:G.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:G.globalFindClipboard,description:o.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:G.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:G.loop,description:o.localize(18,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{cursorMoveOnType:d(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof G.seedSearchStringFromSelection=="boolean"?G.seedSearchStringFromSelection?"always":"never":n(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof G.autoFindInSelection=="boolean"?G.autoFindInSelection?"always":"never":n(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(he.loop,this.defaultValue.loop)}}}class X extends k{constructor(){super(48,"fontLigatures",X.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?X.OFF:G==="true"?X.ON:G:Boolean(G)?X.ON:X.OFF}}X.OFF='"liga" off, "calt" off',X.ON='"liga" on, "calt" on',e.EditorFontLigatures=X;class V extends k{constructor(){super(51,"fontVariations",V.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?V.OFF:G==="true"?V.TRANSLATE:G:Boolean(G)?V.TRANSLATE:V.OFF}compute(G,he,Re){return G.fontInfo.fontVariationSettings}}V.OFF="normal",V.TRANSLATE="translate",e.EditorFontVariations=V;class N extends y{constructor(){super(47)}compute(G,he,Re){return G.fontInfo}}class T extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(G){const he=D.float(G,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(he,6,100)}compute(G,he,Re){return G.fontInfo.fontSize}}class F extends k{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(G){return G==="normal"||G==="bold"?G:String(v.clampedInt(G,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class U extends k{constructor(){const G={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:G.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",G,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...he},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...he},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...he},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:G.alternativeDefinitionCommand,enum:Re,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:G.alternativeTypeDefinitionCommand,enum:Re,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:G.alternativeDeclarationCommand,enum:Re,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:G.alternativeImplementationCommand,enum:Re,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:G.alternativeReferenceCommand,enum:Re,description:o.localize(41,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{multiple:n(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??n(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??n(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??n(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??n(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??n(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends k{constructor(){const G={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",G,{"editor.hover.enabled":{type:"boolean",default:G.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:G.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:G.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:G.above,description:o.localize(45,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{enabled:d(he.enabled,this.defaultValue.enabled),delay:v.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:d(he.sticky,this.defaultValue.sticky),above:d(he.above,this.defaultValue.above)}}}var J;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(J=e.RenderMinimap||(e.RenderMinimap={}));class z extends y{constructor(){super(138)}compute(G,he,Re){return z.computeLayout(he,{memory:G.memory,outerWidth:G.outerWidth,outerHeight:G.outerHeight,isDominatedByLongLines:G.isDominatedByLongLines,lineHeight:G.fontInfo.lineHeight,viewLineCount:G.viewLineCount,lineNumbersDigitCount:G.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:G.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:G.fontInfo.maxDigitWidth,pixelRatio:G.pixelRatio})}static computeContainedMinimapLineCount(G){const he=G.height/G.lineHeight,Re=Math.floor(G.paddingTop/G.lineHeight);let Oe=Math.floor(G.paddingBottom/G.lineHeight);G.scrollBeyondLastLine&&(Oe=Math.max(Oe,he-1));const Ve=(Re+G.viewLineCount+Oe)/(G.pixelRatio*G.height),$e=Math.floor(G.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeforeFirstLine:Re,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:$e}}static _computeMinimapLayout(G,he){const Re=G.outerWidth,Oe=G.outerHeight,Ve=G.pixelRatio;if(!G.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const $e=he.stableMinimapLayoutInput,Ze=$e&&G.outerHeight===$e.outerHeight&&G.lineHeight===$e.lineHeight&&G.typicalHalfwidthCharacterWidth===$e.typicalHalfwidthCharacterWidth&&G.pixelRatio===$e.pixelRatio&&G.scrollBeyondLastLine===$e.scrollBeyondLastLine&&G.paddingTop===$e.paddingTop&&G.paddingBottom===$e.paddingBottom&&G.minimap.enabled===$e.minimap.enabled&&G.minimap.side===$e.minimap.side&&G.minimap.size===$e.minimap.size&&G.minimap.showSlider===$e.minimap.showSlider&&G.minimap.renderCharacters===$e.minimap.renderCharacters&&G.minimap.maxColumn===$e.minimap.maxColumn&&G.minimap.scale===$e.minimap.scale&&G.verticalScrollbarWidth===$e.verticalScrollbarWidth&&G.isViewportWrapping===$e.isViewportWrapping,st=G.lineHeight,at=G.typicalHalfwidthCharacterWidth,mt=G.scrollBeyondLastLine,gt=G.minimap.renderCharacters;let wt=Ve>=2?Math.round(G.minimap.scale*2):G.minimap.scale;const lt=G.minimap.maxColumn,pt=G.minimap.size,jt=G.minimap.side,$t=G.verticalScrollbarWidth,It=G.viewLineCount,ft=G.remainingWidth,kt=G.isViewportWrapping,Ut=gt?2:3;let Pt=Math.floor(Ve*Oe);const Ke=Pt/Ve;let Ot=!1,qt=!1,Ft=Ut*wt,vt=wt/Ve,Pe=1;if(pt==="fill"||pt==="fit"){const{typicalViewportLineCount:He,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:ut,desiredRatio:Tt,minimapLineCount:_t}=z.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:mt,paddingTop:G.paddingTop,paddingBottom:G.paddingBottom,height:Oe,lineHeight:st,pixelRatio:Ve});if(It/_t>1)Ot=!0,qt=!0,wt=1,Ft=1,vt=wt/Ve;else{let Et=!1,At=wt+1;if(pt==="fit"){const St=Math.ceil((et+It+ut)*Ft);kt&&Ze&&ft<=he.stableFitRemainingWidth?(Et=!0,At=he.stableFitMaxMinimapScale):Et=St>Pt}if(pt==="fill"||Et){Ot=!0;const St=wt;Ft=Math.min(st*Ve,Math.max(1,Math.floor(1/Tt))),kt&&Ze&&ft<=he.stableFitRemainingWidth&&(At=he.stableFitMaxMinimapScale),wt=Math.min(At,Math.max(1,Math.floor(Ft/Ut))),wt>St&&(Pe=Math.min(2,wt/St)),vt=wt/Ve/Pe,Pt=Math.ceil(Math.max(He,et+It+ut)*Ft),kt?(he.stableMinimapLayoutInput=G,he.stableFitRemainingWidth=ft,he.stableFitMaxMinimapScale=wt):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Le=Math.floor(lt*vt),_e=Math.min(Le,Math.max(0,Math.floor((ft-$t-2)*vt/(at+vt)))+e.MINIMAP_GUTTER_WIDTH);let se=Math.floor(Ve*_e);const Fe=se/Ve;se=Math.floor(se*Pe);const We=gt?1:2,Qe=jt==="left"?0:Re-_e-$t;return{renderMinimap:We,minimapLeft:Qe,minimapWidth:_e,minimapHeightIsEditorHeight:Ot,minimapIsSampling:qt,minimapScale:wt,minimapLineHeight:Ft,minimapCanvasInnerWidth:se,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Ke}}static computeLayout(G,he){const Re=he.outerWidth|0,Oe=he.outerHeight|0,Ve=he.lineHeight|0,$e=he.lineNumbersDigitCount|0,Ze=he.typicalHalfwidthCharacterWidth,st=he.maxDigitWidth,at=he.pixelRatio,mt=he.viewLineCount,gt=G.get(130),wt=gt==="inherit"?G.get(129):gt,lt=wt==="inherit"?G.get(125):wt,pt=G.get(128),jt=he.isDominatedByLongLines,$t=G.get(54),It=G.get(64).renderType!==0,ft=G.get(65),kt=G.get(99),Ut=G.get(80),Pt=G.get(69),Ke=G.get(97),Ot=Ke.verticalScrollbarSize,qt=Ke.verticalHasArrows,Ft=Ke.arrowSize,vt=Ke.horizontalScrollbarSize,Pe=G.get(40),Le=G.get(104)!=="never";let _e=G.get(62);Pe&&Le&&(_e+=16);let se=0;if(It){const ei=Math.max($e,ft);se=Math.round(ei*st)}let Fe=0;$t&&(Fe=Ve);let We=0,Qe=We+Fe,He=Qe+se,et=He+_e;const ut=Re-Fe-se-_e;let Tt=!1,_t=!1,yt=-1;wt==="inherit"&&jt?(Tt=!0,_t=!0):lt==="on"||lt==="bounded"?_t=!0:lt==="wordWrapColumn"&&(yt=pt);const Et=z._computeMinimapLayout({outerWidth:Re,outerHeight:Oe,lineHeight:Ve,typicalHalfwidthCharacterWidth:Ze,pixelRatio:at,scrollBeyondLastLine:kt,paddingTop:Ut.top,paddingBottom:Ut.bottom,minimap:Pt,verticalScrollbarWidth:Ot,viewLineCount:mt,remainingWidth:ut,isViewportWrapping:_t},he.memory||new L);Et.renderMinimap!==0&&Et.minimapLeft===0&&(We+=Et.minimapWidth,Qe+=Et.minimapWidth,He+=Et.minimapWidth,et+=Et.minimapWidth);const At=ut-Et.minimapWidth,St=Math.max(1,Math.floor((At-Ot-2)/Ze)),ri=qt?Ft:0;return _t&&(yt=Math.max(1,St),lt==="bounded"&&(yt=Math.min(yt,pt))),{width:Re,height:Oe,glyphMarginLeft:We,glyphMarginWidth:Fe,lineNumbersLeft:Qe,lineNumbersWidth:se,decorationsLeft:He,decorationsWidth:_e,contentLeft:et,contentWidth:At,minimap:Et,viewportColumn:St,isWordWrapMinified:Tt,isViewportWrapping:_t,wrappingColumn:yt,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:vt,overviewRuler:{top:ri,width:Ot,height:Oe-2*ri,right:0}}}}e.EditorLayoutInfoComputer=z;class Q extends k{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate(G){return n(G,"simple",["simple","advanced"])}compute(G,he,Re){return he.get(2)===2?"advanced":Re}}class ie extends k{constructor(){const G={enabled:!0};super(61,"lightbulb",G,{"editor.lightbulb.enabled":{type:"boolean",default:G.enabled,description:o.localize(49,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:d(G.enabled,this.defaultValue.enabled)}}}class ge extends k{constructor(){const G={enabled:!1,maxLineCount:5};super(109,"stickyScroll",G,{"editor.stickyScroll.enabled":{type:"boolean",default:G.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:G.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{enabled:d(he.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class K extends k{constructor(){const G={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",G,{"editor.inlayHints.enabled":{type:"string",default:G.enabled,description:o.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(53,null),o.localize(54,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(55,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:G.fontSize,markdownDescription:o.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:G.fontFamily,markdownDescription:o.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:G.padding,description:o.localize(59,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:n(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(he.fontFamily,this.defaultValue.fontFamily),padding:d(he.padding,this.defaultValue.padding)}}}class Y extends k{constructor(){super(62,"lineDecorationsWidth",10)}validate(G){return typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)?-parseFloat(G.substring(0,G.length-2)):v.clampedInt(G,this.defaultValue,0,1e3)}compute(G,he,Re){return Re<0?v.clampedInt(-Re*G.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Re}}class ee extends D{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,G=>D.clamp(G,0,150),{markdownDescription:o.localize(60,null)})}compute(G,he,Re){return G.fontInfo.lineHeight}}class me extends k{constructor(){const G={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",G,{"editor.minimap.enabled":{type:"boolean",default:G.enabled,description:o.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:G.autohide,description:o.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)],default:G.size,description:o.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:G.side,description:o.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:G.showSlider,description:o.localize(68,null)},"editor.minimap.scale":{type:"number",default:G.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:G.renderCharacters,description:o.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:G.maxColumn,description:o.localize(71,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{enabled:d(he.enabled,this.defaultValue.enabled),autohide:d(he.autohide,this.defaultValue.autohide),size:n(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(he.side,this.defaultValue.side,["right","left"]),showSlider:n(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(he.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(he.scale,1,1,3),maxColumn:v.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(x){return x==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class De extends k{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{top:v.clampedInt(he.top,0,0,1e3),bottom:v.clampedInt(he.bottom,0,0,1e3)}}}class Ae extends k{constructor(){const G={enabled:!0,cycle:!0};super(81,"parameterHints",G,{"editor.parameterHints.enabled":{type:"boolean",default:G.enabled,description:o.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:G.cycle,description:o.localize(75,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{enabled:d(he.enabled,this.defaultValue.enabled),cycle:d(he.cycle,this.defaultValue.cycle)}}}class ae extends y{constructor(){super(136)}compute(G,he,Re){return G.pixelRatio}}class le extends k{constructor(){const G={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(76,null),o.localize(77,null),o.localize(78,null)]}];super(84,"quickSuggestions",G,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:G.strings,description:o.localize(79,null)},comments:{anyOf:he,default:G.comments,description:o.localize(80,null)},other:{anyOf:he,default:G.other,description:o.localize(81,null)}},default:G,markdownDescription:o.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=G}validate(G){if(typeof G=="boolean"){const at=G?"on":"off";return{comments:at,strings:at,other:at}}if(!G||typeof G!="object")return this.defaultValue;const{other:he,comments:Re,strings:Oe}=G,Ve=["on","inline","off"];let $e,Ze,st;return typeof he=="boolean"?$e=he?"on":"off":$e=n(he,this.defaultValue.other,Ve),typeof Re=="boolean"?Ze=Re?"on":"off":Ze=n(Re,this.defaultValue.comments,Ve),typeof Oe=="boolean"?st=Oe?"on":"off":st=n(Oe,this.defaultValue.strings,Ve),{other:$e,comments:Ze,strings:st}}}var ue;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ne extends k{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(83,null),o.localize(84,null),o.localize(85,null),o.localize(86,null)],default:"on",description:o.localize(87,null)})}validate(G){let he=this.defaultValue.renderType,Re=this.defaultValue.renderFn;return typeof G<"u"&&(typeof G=="function"?(he=4,Re=G):G==="interval"?he=3:G==="relative"?he=2:G==="on"?he=1:he=0),{renderType:he,renderFn:Re}}}function ce(x){const G=x.get(92);return G==="editable"?x.get(86):G!=="on"}e.filterValidationDecorations=ce;class oe extends k{constructor(){const G=[],he={type:"number",description:o.localize(88,null)};super(96,"rulers",G,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:o.localize(89,null),format:"color-hex"}}}]},default:G,description:o.localize(90,null)})}validate(G){if(Array.isArray(G)){const he=[];for(const Re of G)if(typeof Re=="number")he.push({column:v.clampedInt(Re,0,0,1e4),color:null});else if(Re&&typeof Re=="object"){const Oe=Re;he.push({column:v.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return he.sort((Re,Oe)=>Re.column-Oe.column),he}return this.defaultValue}}function M(x,G){if(typeof x!="string")return G;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends k{constructor(){const G={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",G,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(91,null),o.localize(92,null),o.localize(93,null)],default:"auto",description:o.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(95,null),o.localize(96,null),o.localize(97,null)],default:"auto",description:o.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:G.verticalScrollbarSize,description:o.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:G.horizontalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:G.scrollByPage,description:o.localize(101,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G,Re=v.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=v.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(he.vertical,this.defaultValue.vertical),horizontal:M(he.horizontal,this.defaultValue.horizontal),useShadows:d(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Re,horizontalSliderSize:v.clampedInt(he.horizontalSliderSize,Re,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:v.clampedInt(he.verticalSliderSize,Oe,0,1e3),scrollByPage:d(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends k{constructor(){const G={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",G,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.nonBasicASCII,description:o.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:G.invisibleCharacters,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:G.ambiguousCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeComments,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeStrings,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:G.allowedCharacters,description:o.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:G.allowedLocales,description:o.localize(108,null)}})}applyUpdate(G,he){let Re=!1;he.allowedCharacters&&G&&(w.equals(G.allowedCharacters,he.allowedCharacters)||(G={...G,allowedCharacters:he.allowedCharacters},Re=!0)),he.allowedLocales&&G&&(w.equals(G.allowedLocales,he.allowedLocales)||(G={...G,allowedLocales:he.allowedLocales},Re=!0));const Oe=super.applyUpdate(G,he);return Re?new b(Oe.newValue,!0):Oe}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{nonBasicASCII:Te(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Te(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Te(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(G.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(G.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(G,he){if(typeof G!="object"||!G)return he;const Re={};for(const[Oe,Ve]of Object.entries(G))Ve===!0&&(Re[Oe]=!0);return Re}}class te extends k{constructor(){const G={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",G,{"editor.inlineSuggest.enabled":{type:"boolean",default:G.enabled,description:o.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:G.showToolbar,enum:["always","onHover"],enumDescriptions:[o.localize(110,null),o.localize(111,null)],description:o.localize(112,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{enabled:d(he.enabled,this.defaultValue.enabled),mode:n(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(he.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class de extends k{constructor(){const G={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",G,{"editor.bracketPairColorization.enabled":{type:"boolean",default:G.enabled,markdownDescription:o.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:G.independentColorPoolPerBracketType,description:o.localize(114,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{enabled:d(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ee extends k{constructor(){const G={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",G,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(115,null),o.localize(116,null),o.localize(117,null)],default:G.bracketPairs,description:o.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(119,null),o.localize(120,null),o.localize(121,null)],default:G.bracketPairsHorizontal,description:o.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:G.highlightActiveBracketPair,description:o.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:G.indentation,description:o.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(125,null),o.localize(126,null),o.localize(127,null)],default:G.highlightActiveIndentation,description:o.localize(128,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{bracketPairs:Te(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Te(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:Te(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Te(x,G,he){const Re=he.indexOf(x);return Re===-1?G:he[Re]}class ve extends k{constructor(){const G={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",G,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(129,null),o.localize(130,null)],default:G.insertMode,description:o.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:G.filterGraceful,description:o.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:G.localityBonus,description:o.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:G.shareSuggestSelections,markdownDescription:o.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(135,null),o.localize(136,null),o.localize(137,null),o.localize(138,null)],default:G.selectionMode,markdownDescription:o.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:G.snippetsPreventQuickSuggestions,description:o.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:G.showIcons,description:o.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:G.showStatusBar,description:o.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:G.preview,description:o.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:G.showInlineDetails,description:o.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const he=G;return{insertMode:n(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(he.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(he.showIcons,this.defaultValue.showIcons),showStatusBar:d(he.showStatusBar,this.defaultValue.showStatusBar),preview:d(he.preview,this.defaultValue.preview),previewMode:n(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(he.showMethods,this.defaultValue.showMethods),showFunctions:d(he.showFunctions,this.defaultValue.showFunctions),showConstructors:d(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(he.showFields,this.defaultValue.showFields),showVariables:d(he.showVariables,this.defaultValue.showVariables),showClasses:d(he.showClasses,this.defaultValue.showClasses),showStructs:d(he.showStructs,this.defaultValue.showStructs),showInterfaces:d(he.showInterfaces,this.defaultValue.showInterfaces),showModules:d(he.showModules,this.defaultValue.showModules),showProperties:d(he.showProperties,this.defaultValue.showProperties),showEvents:d(he.showEvents,this.defaultValue.showEvents),showOperators:d(he.showOperators,this.defaultValue.showOperators),showUnits:d(he.showUnits,this.defaultValue.showUnits),showValues:d(he.showValues,this.defaultValue.showValues),showConstants:d(he.showConstants,this.defaultValue.showConstants),showEnums:d(he.showEnums,this.defaultValue.showEnums),showEnumMembers:d(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(he.showKeywords,this.defaultValue.showKeywords),showWords:d(he.showWords,this.defaultValue.showWords),showColors:d(he.showColors,this.defaultValue.showColors),showFiles:d(he.showFiles,this.defaultValue.showFiles),showReferences:d(he.showReferences,this.defaultValue.showReferences),showFolders:d(he.showFolders,this.defaultValue.showFolders),showTypeParameters:d(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(he.showSnippets,this.defaultValue.showSnippets),showUsers:d(he.showUsers,this.defaultValue.showUsers),showIssues:d(he.showIssues,this.defaultValue.showIssues)}}}class Ce extends k{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(177,null),default:!0,type:"boolean"}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(G.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Ie;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Ie=e.WrappingIndent||(e.WrappingIndent={}));class ze extends k{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(178,null),o.localize(179,null),o.localize(180,null),o.localize(181,null)],description:o.localize(182,null),default:"same"}})}validate(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(G,he,Re){return he.get(2)===2?0:Re}}class qe extends y{constructor(){super(139)}compute(G,he,Re){const Oe=he.get(138);return{isDominatedByLongLines:G.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class nt extends k{constructor(){const G={enabled:!0};super(33,"dropIntoEditor",G,{"editor.dropIntoEditor.enabled":{type:"boolean",default:G.enabled,markdownDescription:o.localize(183,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:d(G.enabled,this.defaultValue.enabled)}}}const Xe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?tt:R.isLinux?rt:Xe,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(x){return e.editorOptionsRegistry[x.id]=x,x}var it;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.autoClosingBrackets=5]="autoClosingBrackets",x[x.autoClosingDelete=6]="autoClosingDelete",x[x.autoClosingOvertype=7]="autoClosingOvertype",x[x.autoClosingQuotes=8]="autoClosingQuotes",x[x.autoIndent=9]="autoIndent",x[x.automaticLayout=10]="automaticLayout",x[x.autoSurround=11]="autoSurround",x[x.bracketPairColorization=12]="bracketPairColorization",x[x.guides=13]="guides",x[x.codeLens=14]="codeLens",x[x.codeLensFontFamily=15]="codeLensFontFamily",x[x.codeLensFontSize=16]="codeLensFontSize",x[x.colorDecorators=17]="colorDecorators",x[x.colorDecoratorsLimit=18]="colorDecoratorsLimit",x[x.columnSelection=19]="columnSelection",x[x.comments=20]="comments",x[x.contextmenu=21]="contextmenu",x[x.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",x[x.cursorBlinking=23]="cursorBlinking",x[x.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",x[x.cursorStyle=25]="cursorStyle",x[x.cursorSurroundingLines=26]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",x[x.cursorWidth=28]="cursorWidth",x[x.disableLayerHinting=29]="disableLayerHinting",x[x.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",x[x.domReadOnly=31]="domReadOnly",x[x.dragAndDrop=32]="dragAndDrop",x[x.dropIntoEditor=33]="dropIntoEditor",x[x.emptySelectionClipboard=34]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",x[x.extraEditorClassName=36]="extraEditorClassName",x[x.fastScrollSensitivity=37]="fastScrollSensitivity",x[x.find=38]="find",x[x.fixedOverflowWidgets=39]="fixedOverflowWidgets",x[x.folding=40]="folding",x[x.foldingStrategy=41]="foldingStrategy",x[x.foldingHighlight=42]="foldingHighlight",x[x.foldingImportsByDefault=43]="foldingImportsByDefault",x[x.foldingMaximumRegions=44]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=46]="fontFamily",x[x.fontInfo=47]="fontInfo",x[x.fontLigatures=48]="fontLigatures",x[x.fontSize=49]="fontSize",x[x.fontWeight=50]="fontWeight",x[x.fontVariations=51]="fontVariations",x[x.formatOnPaste=52]="formatOnPaste",x[x.formatOnType=53]="formatOnType",x[x.glyphMargin=54]="glyphMargin",x[x.gotoLocation=55]="gotoLocation",x[x.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",x[x.hover=57]="hover",x[x.inDiffEditor=58]="inDiffEditor",x[x.inlineSuggest=59]="inlineSuggest",x[x.letterSpacing=60]="letterSpacing",x[x.lightbulb=61]="lightbulb",x[x.lineDecorationsWidth=62]="lineDecorationsWidth",x[x.lineHeight=63]="lineHeight",x[x.lineNumbers=64]="lineNumbers",x[x.lineNumbersMinChars=65]="lineNumbersMinChars",x[x.linkedEditing=66]="linkedEditing",x[x.links=67]="links",x[x.matchBrackets=68]="matchBrackets",x[x.minimap=69]="minimap",x[x.mouseStyle=70]="mouseStyle",x[x.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=72]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",x[x.multiCursorModifier=74]="multiCursorModifier",x[x.multiCursorPaste=75]="multiCursorPaste",x[x.multiCursorLimit=76]="multiCursorLimit",x[x.occurrencesHighlight=77]="occurrencesHighlight",x[x.overviewRulerBorder=78]="overviewRulerBorder",x[x.overviewRulerLanes=79]="overviewRulerLanes",x[x.padding=80]="padding",x[x.parameterHints=81]="parameterHints",x[x.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",x[x.quickSuggestions=84]="quickSuggestions",x[x.quickSuggestionsDelay=85]="quickSuggestionsDelay",x[x.readOnly=86]="readOnly",x[x.renameOnType=87]="renameOnType",x[x.renderControlCharacters=88]="renderControlCharacters",x[x.renderFinalNewline=89]="renderFinalNewline",x[x.renderLineHighlight=90]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=92]="renderValidationDecorations",x[x.renderWhitespace=93]="renderWhitespace",x[x.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",x[x.roundedSelection=95]="roundedSelection",x[x.rulers=96]="rulers",x[x.scrollbar=97]="scrollbar",x[x.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=99]="scrollBeyondLastLine",x[x.scrollPredominantAxis=100]="scrollPredominantAxis",x[x.selectionClipboard=101]="selectionClipboard",x[x.selectionHighlight=102]="selectionHighlight",x[x.selectOnLineNumbers=103]="selectOnLineNumbers",x[x.showFoldingControls=104]="showFoldingControls",x[x.showUnused=105]="showUnused",x[x.snippetSuggestions=106]="snippetSuggestions",x[x.smartSelect=107]="smartSelect",x[x.smoothScrolling=108]="smoothScrolling",x[x.stickyScroll=109]="stickyScroll",x[x.stickyTabStops=110]="stickyTabStops",x[x.stopRenderingLineAfter=111]="stopRenderingLineAfter",x[x.suggest=112]="suggest",x[x.suggestFontSize=113]="suggestFontSize",x[x.suggestLineHeight=114]="suggestLineHeight",x[x.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",x[x.suggestSelection=116]="suggestSelection",x[x.tabCompletion=117]="tabCompletion",x[x.tabIndex=118]="tabIndex",x[x.unicodeHighlighting=119]="unicodeHighlighting",x[x.unusualLineTerminators=120]="unusualLineTerminators",x[x.useShadowDOM=121]="useShadowDOM",x[x.useTabStops=122]="useTabStops",x[x.wordBreak=123]="wordBreak",x[x.wordSeparators=124]="wordSeparators",x[x.wordWrap=125]="wordWrap",x[x.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=128]="wordWrapColumn",x[x.wordWrapOverride1=129]="wordWrapOverride1",x[x.wordWrapOverride2=130]="wordWrapOverride2",x[x.wrappingIndent=131]="wrappingIndent",x[x.wrappingStrategy=132]="wrappingStrategy",x[x.showDeprecated=133]="showDeprecated",x[x.inlayHints=134]="inlayHints",x[x.editorClassName=135]="editorClassName",x[x.pixelRatio=136]="pixelRatio",x[x.tabFocusMode=137]="tabFocusMode",x[x.layoutInfo=138]="layoutInfo",x[x.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(184,null)})),acceptSuggestionOnEnter:Ue(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(185,null),""],markdownDescription:o.localize(186,null)})),accessibilitySupport:Ue(new c),accessibilityPageSize:Ue(new v(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(187,null),tags:["accessibility"]})),ariaLabel:Ue(new p(4,"ariaLabel",o.localize(188,null))),autoClosingBrackets:Ue(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(189,null),o.localize(190,null),""],description:o.localize(191,null)})),autoClosingDelete:Ue(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(192,null),""],description:o.localize(193,null)})),autoClosingOvertype:Ue(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(194,null),""],description:o.localize(195,null)})),autoClosingQuotes:Ue(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(196,null),o.localize(197,null),""],description:o.localize(198,null)})),autoIndent:Ue(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[o.localize(199,null),o.localize(200,null),o.localize(201,null),o.localize(202,null),o.localize(203,null)],description:o.localize(204,null)})),automaticLayout:Ue(new u(10,"automaticLayout",!1)),autoSurround:Ue(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(205,null),o.localize(206,null),o.localize(207,null),""],description:o.localize(208,null)})),bracketPairColorization:Ue(new de),bracketPairGuides:Ue(new Ee),stickyTabStops:Ue(new u(110,"stickyTabStops",!1,{description:o.localize(209,null)})),codeLens:Ue(new u(14,"codeLens",!0,{description:o.localize(210,null)})),codeLensFontFamily:Ue(new p(15,"codeLensFontFamily","",{description:o.localize(211,null)})),codeLensFontSize:Ue(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(212,null)})),colorDecorators:Ue(new u(17,"colorDecorators",!0,{description:o.localize(213,null)})),colorDecoratorsLimit:Ue(new v(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(214,null)})),columnSelection:Ue(new u(19,"columnSelection",!1,{description:o.localize(215,null)})),comments:Ue(new g),contextmenu:Ue(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new u(22,"copyWithSyntaxHighlighting",!0,{description:o.localize(216,null)})),cursorBlinking:Ue(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:o.localize(217,null)})),cursorSmoothCaretAnimation:Ue(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(218,null),o.localize(219,null),o.localize(220,null)],description:o.localize(221,null)})),cursorStyle:Ue(new r(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:o.localize(222,null)})),cursorSurroundingLines:Ue(new v(26,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(223,null)})),cursorSurroundingLinesStyle:Ue(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(224,null),o.localize(225,null)],description:o.localize(226,null)})),cursorWidth:Ue(new v(28,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(227,null)})),disableLayerHinting:Ue(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new u(31,"domReadOnly",!1)),dragAndDrop:Ue(new u(32,"dragAndDrop",!0,{description:o.localize(228,null)})),emptySelectionClipboard:Ue(new $),dropIntoEditor:Ue(new nt),stickyScroll:Ue(new ge),experimentalWhitespaceRendering:Ue(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(229,null),o.localize(230,null),o.localize(231,null)],description:o.localize(232,null)})),extraEditorClassName:Ue(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Ue(new D(37,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:o.localize(233,null)})),find:Ue(new H),fixedOverflowWidgets:Ue(new u(39,"fixedOverflowWidgets",!1)),folding:Ue(new u(40,"folding",!0,{description:o.localize(234,null)})),foldingStrategy:Ue(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(235,null),o.localize(236,null)],description:o.localize(237,null)})),foldingHighlight:Ue(new u(42,"foldingHighlight",!0,{description:o.localize(238,null)})),foldingImportsByDefault:Ue(new u(43,"foldingImportsByDefault",!1,{description:o.localize(239,null)})),foldingMaximumRegions:Ue(new v(44,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(240,null)})),unfoldOnClickAfterEndOfLine:Ue(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(241,null)})),fontFamily:Ue(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(242,null)})),fontInfo:Ue(new N),fontLigatures2:Ue(new X),fontSize:Ue(new T),fontWeight:Ue(new F),fontVariations:Ue(new V),formatOnPaste:Ue(new u(52,"formatOnPaste",!1,{description:o.localize(243,null)})),formatOnType:Ue(new u(53,"formatOnType",!1,{description:o.localize(244,null)})),glyphMargin:Ue(new u(54,"glyphMargin",!0,{description:o.localize(245,null)})),gotoLocation:Ue(new U),hideCursorInOverviewRuler:Ue(new u(56,"hideCursorInOverviewRuler",!1,{description:o.localize(246,null)})),hover:Ue(new Z),inDiffEditor:Ue(new u(58,"inDiffEditor",!1)),letterSpacing:Ue(new D(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>D.clamp(x,-5,20),{description:o.localize(247,null)})),lightbulb:Ue(new ie),lineDecorationsWidth:Ue(new Y),lineHeight:Ue(new ee),lineNumbers:Ue(new ne),lineNumbersMinChars:Ue(new v(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new u(66,"linkedEditing",!1,{description:o.localize(248,null)})),links:Ue(new u(67,"links",!0,{description:o.localize(249,null)})),matchBrackets:Ue(new s(68,"matchBrackets","always",["always","near","never"],{description:o.localize(250,null)})),minimap:Ue(new me),mouseStyle:Ue(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new D(71,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:o.localize(251,null)})),mouseWheelZoom:Ue(new u(72,"mouseWheelZoom",!1,{markdownDescription:o.localize(252,null)})),multiCursorMergeOverlapping:Ue(new u(73,"multiCursorMergeOverlapping",!0,{description:o.localize(253,null)})),multiCursorModifier:Ue(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[o.localize(254,null),o.localize(255,null)],markdownDescription:o.localize(256,null)})),multiCursorPaste:Ue(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(257,null),o.localize(258,null)],markdownDescription:o.localize(259,null)})),multiCursorLimit:Ue(new v(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(260,null)})),occurrencesHighlight:Ue(new u(77,"occurrencesHighlight",!0,{description:o.localize(261,null)})),overviewRulerBorder:Ue(new u(78,"overviewRulerBorder",!0,{description:o.localize(262,null)})),overviewRulerLanes:Ue(new v(79,"overviewRulerLanes",3,0,3)),padding:Ue(new De),parameterHints:Ue(new Ae),peekWidgetDefaultFocus:Ue(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(263,null),o.localize(264,null)],description:o.localize(265,null)})),definitionLinkOpensInPeek:Ue(new u(83,"definitionLinkOpensInPeek",!1,{description:o.localize(266,null)})),quickSuggestions:Ue(new le),quickSuggestionsDelay:Ue(new v(85,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(267,null)})),readOnly:Ue(new u(86,"readOnly",!1)),renameOnType:Ue(new u(87,"renameOnType",!1,{description:o.localize(268,null),markdownDeprecationMessage:o.localize(269,null)})),renderControlCharacters:Ue(new u(88,"renderControlCharacters",!0,{description:o.localize(270,null),restricted:!0})),renderFinalNewline:Ue(new s(89,"renderFinalNewline",R.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(271,null)})),renderLineHighlight:Ue(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(272,null)],description:o.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Ue(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(274,null)})),renderValidationDecorations:Ue(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(275,null),o.localize(276,null),o.localize(277,null),""],description:o.localize(278,null)})),revealHorizontalRightPadding:Ue(new v(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new u(95,"roundedSelection",!0,{description:o.localize(279,null)})),rulers:Ue(new oe),scrollbar:Ue(new B),scrollBeyondLastColumn:Ue(new v(98,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(280,null)})),scrollBeyondLastLine:Ue(new u(99,"scrollBeyondLastLine",!0,{description:o.localize(281,null)})),scrollPredominantAxis:Ue(new u(100,"scrollPredominantAxis",!0,{description:o.localize(282,null)})),selectionClipboard:Ue(new u(101,"selectionClipboard",!0,{description:o.localize(283,null),included:R.isLinux})),selectionHighlight:Ue(new u(102,"selectionHighlight",!0,{description:o.localize(284,null)})),selectOnLineNumbers:Ue(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(285,null),o.localize(286,null),o.localize(287,null)],description:o.localize(288,null)})),showUnused:Ue(new u(105,"showUnused",!0,{description:o.localize(289,null)})),showDeprecated:Ue(new u(133,"showDeprecated",!0,{description:o.localize(290,null)})),inlayHints:Ue(new K),snippetSuggestions:Ue(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(291,null),o.localize(292,null),o.localize(293,null),o.localize(294,null)],description:o.localize(295,null)})),smartSelect:Ue(new Ce),smoothScrolling:Ue(new u(108,"smoothScrolling",!1,{description:o.localize(296,null)})),stopRenderingLineAfter:Ue(new v(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ve),inlineSuggest:Ue(new te),suggestFontSize:Ue(new v(113,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new v(114,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new u(115,"suggestOnTriggerCharacters",!0,{description:o.localize(299,null)})),suggestSelection:Ue(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(300,null),o.localize(301,null),o.localize(302,null)],description:o.localize(303,null)})),tabCompletion:Ue(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(304,null),o.localize(305,null),o.localize(306,null)],description:o.localize(307,null)})),tabIndex:Ue(new v(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new q),unusualLineTerminators:Ue(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(308,null),o.localize(309,null),o.localize(310,null)],description:o.localize(311,null)})),useShadowDOM:Ue(new u(121,"useShadowDOM",!0)),useTabStops:Ue(new u(122,"useTabStops",!0,{description:o.localize(312,null)})),wordBreak:Ue(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(313,null),o.localize(314,null)],description:o.localize(315,null)})),wordSeparators:Ue(new p(124,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:o.localize(316,null)})),wordWrap:Ue(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(317,null),o.localize(318,null),o.localize(319,null),o.localize(320,null)],description:o.localize(321,null)})),wordWrapBreakAfterCharacters:Ue(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new v(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(322,null)})),wordWrapOverride1:Ue(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new O),pixelRatio:Ue(new ae),tabFocusMode:Ue(new u(137,"tabFocusMode",!1,{markdownDescription:o.localize(323,null)})),layoutInfo:Ue(new z),wrappingInfo:Ue(new qe),wrappingIndent:Ue(new ze),wrappingStrategy:Ue(new Q)}}),define(Se[169],ye([17,18]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[170],ye([17,18]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[171],ye([17,18]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[172],ye([17,18]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[173],ye([17,18]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Se[174],ye([17,18]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Se[175],ye([17,18]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[176],ye([17,18]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(Se[177],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[178],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[179],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[180],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[181],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[182],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[183],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[184],ye([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[185],ye([17,18]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[186],ye([17,18]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Se[187],ye([17,18]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Se[188],ye([17,18]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(Se[189],ye([17,18]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[190],ye([17,18]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[191],ye([17,18]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[192],ye([17,18]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[193],ye([17,18]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[194],ye([17,18]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[195],ye([17,18]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[196],ye([17,18]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[197],ye([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var R;(function(A){A[A.LParen=0]="LParen",A[A.RParen=1]="RParen",A[A.Neg=2]="Neg",A[A.Eq=3]="Eq",A[A.NotEq=4]="NotEq",A[A.Lt=5]="Lt",A[A.LtEq=6]="LtEq",A[A.Gt=7]="Gt",A[A.GtEq=8]="GtEq",A[A.RegexOp=9]="RegexOp",A[A.RegexStr=10]="RegexStr",A[A.True=11]="True",A[A.False=12]="False",A[A.In=13]="In",A[A.Not=14]="Not",A[A.And=15]="And",A[A.Or=16]="Or",A[A.Str=17]="Str",A[A.QuotedStr=18]="QuotedStr",A[A.Error=19]="Error",A[A.EOF=20]="EOF"})(R=e.TokenType||(e.TokenType={}));class l{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errorTokens=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(w){if(w.type!==19)throw(0,o.illegalArgument)(`expected an error token but got ${JSON.stringify(w)}`);switch(w.lexeme){case"=":return`Unexpected token '${w.lexeme}' at offset ${w.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${w.lexeme}' at offset ${w.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${w.lexeme}' at offset ${w.offset}. Did you mean '||'?`;default:{const P=w.lexeme;return P&&P.length>1&&P.startsWith("'")?`Unexpected token '${w.lexeme}' at offset ${w.offset}. Did you forget to close the string?`:P&&P.length>1&&P.endsWith("'")?`Unexpected token '${w.lexeme}' at offset ${w.offset}. Did you forget to open the string?`:`Unexpected token '${w.lexeme}' at offset ${w.offset}`}}}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,o.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}get errorTokens(){return this._errorTokens}reset(w){return this._input=w,this._start=0,this._current=0,this._tokens=[],this._errorTokens=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:this._addToken(this._match(61)?4:2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:this._match(61)?this._addToken(3):this._match(126)?this._addToken(9):this._error();break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error();break;case 124:this._match(124)?this._addToken(16):this._error();break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(w){return this._isAtEnd()||this._input.charCodeAt(this._current)!==w?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(w){this._tokens.push({type:w,offset:this._start})}_error(){const w={type:19,offset:this._start,lexeme:this._input.substring(this._start,this._current)};this._errorTokens.push(w),this._tokens.push(w)}_string(){this.stringRe.lastIndex=this._start;const w=this.stringRe.exec(this._input);if(w){this._current=this._start+w[0].length;const P=this._input.substring(this._start,this._current),S=l._keywords.get(P);S?this._addToken(S):this._tokens.push({type:17,lexeme:P,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error();return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let w=this._current,P=!1,S=!1;for(;;){if(w>=this._input.length){this._current=w,this._error();return}const L=this._input.charCodeAt(w);if(P)P=!1;else if(L===47&&!S){w++;break}else L===91?S=!0:L===92?P=!0:L===93&&(S=!1);w++}for(;w<this._input.length&&l._regexFlags.has(this._input.charCodeAt(w));)w++;this._current=w;const C=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:C,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}l._regexFlags=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0))),l._keywords=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=l}),function(){"use strict";function re(e,o,R){function l(w,P){const S=A(w,P),C=[S];return e.isAbsolute(S)||C.unshift(R),e.resolve(...C)}function A(w,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,P);const L=w["user-data-dir"];if(L)return L;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(k,"AppData","Roaming")}break;case"darwin":C=e.join(o.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(o.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,P)}return{getUserDataPath:l}}if(typeof define=="function")define(Se[198],ye([321,71,33]),function(e,o,R){return re(e,o,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),o=require("os");module.exports=re(e,o,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Se[199],ye([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this._generators=new Map}register(A,w){this._generators.set(A,w)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const w in A.contributes){const P=this._generators.get(w);if(!P)continue;const S=A.contributes[w],C=Array.isArray(S)?S:[S];try{P(C,A.activationEvents)}catch(L){(0,o.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Se[200],ye([1,0,24,37,171,322]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const w=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||w.test(u)}e.isValidVersionStr=S;function C(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(w);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=C;function L(u){if(!u)return null;const m=u.majorBase,v=u.majorMustEqual,D=u.minorBase;let p=u.minorMustEqual;const n=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(m===0||(p=!1),s=!1);let r=0;if(u.preRelease){const a=P.exec(u.preRelease);if(a){const[,c,g,i]=a;r=Date.UTC(Number(c),Number(g)-1,Number(i))}}return{majorBase:m,majorMustEqual:v,minorBase:D,minorMustEqual:p,patchBase:n,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function k(u,m,v){let D;typeof u=="string"?D=L(C(u)):D=u;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let n;if(typeof v=="string"?n=L(C(v)):n=v,!D||!n)return!1;const s=D.majorBase,r=D.minorBase,a=D.patchBase;let c=n.majorBase,g=n.minorBase,i=n.patchBase;const t=n.notBefore;let h=n.majorMustEqual,_=n.minorMustEqual,E=n.patchMustEqual;return n.isMinimum?s>c?!0:s<c?!1:r>g?!0:r<g||p&&p<t?!1:a>=i:(s===1&&c===0&&(!h||!_||!E)&&(c=1,g=0,i=0,h=!0,_=!1,E=!1),s<c?!1:s>c?!h:r<g?!1:r>g?!_:a<i?!1:a>i?!E:!(p&&p<t))}e.isValidVersion=k;function b(u,m,v,D,p){const n=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return n.push([R.default.Error,l.localize(0,null)]),n;if(typeof D.name!="string")return n.push([R.default.Error,l.localize(1,null,"name")]),n;if(typeof D.version!="string")return n.push([R.default.Error,l.localize(2,null,"version")]),n;if(!D.engines)return n.push([R.default.Error,l.localize(3,null,"engines")]),n;if(typeof D.engines.vscode!="string")return n.push([R.default.Error,l.localize(4,null,"engines.vscode")]),n;if(typeof D.extensionDependencies<"u"&&!d(D.extensionDependencies))return n.push([R.default.Error,l.localize(5,null,"extensionDependencies")]),n;if(typeof D.activationEvents<"u"){if(!d(D.activationEvents))return n.push([R.default.Error,l.localize(6,null,"activationEvents")]),n;if(typeof D.main>"u"&&typeof D.browser>"u")return n.push([R.default.Error,l.localize(7,null,"activationEvents","main")]),n}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&n.push([R.default.Warning,l.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return n.push([R.default.Error,l.localize(9,null,"main")]),n;{const a=(0,o.joinPath)(v,D.main);(0,o.isEqualOrParent)(a,v)||n.push([R.default.Warning,l.localize(10,null,a.path,v.path)])}if(typeof D.activationEvents>"u")return n.push([R.default.Error,l.localize(11,null,"activationEvents","main")]),n}if(typeof D.browser<"u"){if(typeof D.browser!="string")return n.push([R.default.Error,l.localize(12,null,"browser")]),n;{const a=(0,o.joinPath)(v,D.browser);(0,o.isEqualOrParent)(a,v)||n.push([R.default.Warning,l.localize(13,null,a.path,v.path)])}if(typeof D.activationEvents>"u")return n.push([R.default.Error,l.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(D.version))return n.push([R.default.Error,l.localize(15,null)]),n;const s=[];if(!I(u,m,D,p,s))for(const a of s)n.push([R.default.Error,a]);return n}e.validateExtensionManifest=b;function I(u,m,v,D,p){return D||typeof v.main>"u"&&typeof v.browser>"u"?!0:f(u,m,v.engines.vscode,p)}e.isValidExtensionVersion=I;function y(u,m,v){return u==="*"||f(m,v,u)}e.isEngineValid=y;function f(u,m,v,D=[]){const p=L(C(v));if(!p)return D.push(l.localize(16,null,v)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return D.push(l.localize(17,null,v)),!1}else if(!p.majorMustEqual)return D.push(l.localize(18,null,v)),!1;return k(u,m,p)?!0:(D.push(l.localize(19,null,u,v)),!1)}function d(u){if(!Array.isArray(u))return!1;for(let m=0,v=u.length;m<v;m++)if(typeof u[m]!="string")return!1;return!0}}),define(Se[122],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(l,A=[],w=!1){this.ctor=l,this.staticArguments=A,this.supportsDelayedInstantiation=w}}e.SyncDescriptor=o}),define(Se[90],ye([1,0,122]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function A(P,S,C){S instanceof o.SyncDescriptor||(S=new o.SyncDescriptor(S,[],Boolean(C))),R.push([P,S])}e.registerSingleton=A;function w(){return R}e.getSingletonServiceDescriptors=w}),define(Se[201],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(A,w){this.key=A,this.data=w,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class R{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const w of this._nodes.values())w.outgoing.size===0&&A.push(w);return A}insertEdge(A,w){const P=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(w);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(A){const w=this._hashFn(A);this._nodes.delete(w);for(const P of this._nodes.values())P.outgoing.delete(w),P.incoming.delete(w)}lookupOrInsertNode(A){const w=this._hashFn(A);let P=this._nodes.get(w);return P||(P=new o(w,A),this._nodes.set(w,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[w,P]of this._nodes)A.push(`${w}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,w]of this._nodes){const P=new Set([A]),S=this._findCycle(w,P);if(S)return S}}_findCycle(A,w){for(const[P,S]of A.outgoing){if(w.has(P))return[...w,P].join(" -> ");w.add(P);const C=this._findCycle(S,w);if(C)return C;w.delete(P)}}}e.Graph=R}),define(Se[4],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=P})(o=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function R(w,P,S){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:w,index:S}):(P[o.DI_DEPENDENCIES]=[{id:w,index:S}],P[o.DI_TARGET]=P)}function l(w){if(o.serviceIds.has(w))return o.serviceIds.get(w);const P=function(S,C,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,S,L)};return P.toString=()=>w,o.serviceIds.set(w,P),P}e.createDecorator=l;function A(w){return w}e.refineServiceDecorator=A}),define(Se[53],ye([1,0,9,2,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof R.URI)}e.isConfigurationOverrides=A;function w(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=w;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(d,u){const m=Object.create(null);for(const v in d)L(m,v,d[v],u);return m}e.toValuesTree=C;function L(d,u,m,v){const D=u.split("."),p=D.pop();let n=d;for(let s=0;s<D.length;s++){const r=D[s];let a=n[r];switch(typeof a){case"undefined":a=n[r]=Object.create(null);break;case"object":break;default:v(`Ignoring ${u} as ${D.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[p]=m}catch{v(`Ignoring ${u} as ${D.join(".")} is ${JSON.stringify(n)}`)}else v(`Ignoring ${u} as ${D.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=L;function k(d,u){const m=u.split(".");b(d,m)}e.removeFromValueTree=k;function b(d,u){const m=u.shift();if(u.length===0){delete d[m];return}if(Object.keys(d).indexOf(m)!==-1){const v=d[m];typeof v=="object"&&!Array.isArray(v)&&(b(v,u),Object.keys(v).length===0&&delete d[m])}}function I(d,u,m){function v(n,s){let r=n;for(const a of s){if(typeof r!="object"||r===null)return;r=r[a]}return r}const D=u.split("."),p=v(d,D);return typeof p>"u"?m:p}e.getConfigurationValue=I;function y(d,u,m){Object.keys(u).forEach(v=>{v!=="__proto__"&&(v in d?o.isObject(d[v])&&o.isObject(u[v])?y(d[v],u[v],m):m&&(d[v]=u[v]):d[v]=u[v])})}e.merge=y;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(Se[54],ye([1,0,11,8,197,4]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",o.isMacintosh),w.set("isLinux",o.isLinux),w.set("isWindows",o.isWindows),w.set("isWeb",o.isWeb),w.set("isMacNative",o.isMacintosh&&!o.isWeb),w.set("isEdge",o.isEdge),w.set("isFirefox",o.isFirefox),w.set("isChrome",o.isChrome),w.set("isSafari",o.isSafari);const P=Object.prototype.hasOwnProperty;var S;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return y.INSTANCE}static true(){return f.INSTANCE}static has(T){return d.create(T)}static equals(T,F){return u.create(T,F)}static notEquals(T,F){return D.create(T,F)}static regex(T,F){return g.create(T,F)}static in(T,F){return m.create(T,F)}static notIn(T,F){return v.create(T,F)}static not(T){return p.create(T)}static and(...T){return h.create(T,null,!0)}static or(...T){return _.create(T,null,!0)}static greater(T,F){return s.create(T,F)}static greaterEquals(T,F){return r.create(T,F)}static smaller(T,F){return a.create(T,F)}static smallerEquals(T,F){return c.create(T,F)}static deserializeOrErrorNew(T){if(!T)return{type:"error",lexingErrors:[],parsingErrors:[]};const F=new k,U=F.parse(T);return U===void 0?{type:"error",lexingErrors:F.lexingErrors.map(Z=>l.Scanner.reportError(Z)),parsingErrors:F.parsingErrors}:{type:"ok",expr:U}}static deserialize(T){if(!!T)return this._deserializeOrExpression(T)}static _deserializeOrExpression(T){const F=T.split("||");return _.create(F.map(U=>this._deserializeAndExpression(U)),null,!0)}static _deserializeAndExpression(T){const F=T.split("&&");return h.create(F.map(U=>this._deserializeOne(U)),null,!0)}static _deserializeOne(T){if(T=T.trim(),T.indexOf("!=")>=0){const F=T.split("!=");return D.create(F[0].trim(),this._deserializeValue(F[1]))}if(T.indexOf("==")>=0){const F=T.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1]))}if(T.indexOf("=~")>=0){const F=T.split("=~");return g.create(F[0].trim(),this._deserializeRegexValue(F[1]))}if(T.indexOf(" not in ")>=0){const F=T.split(" not in ");return v.create(F[0].trim(),this._deserializeValue(F[1]))}if(T.indexOf(" in ")>=0){const F=T.split(" in ");return m.create(F[0].trim(),this._deserializeValue(F[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const F=T.split(">=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const F=T.split(">");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const F=T.split("<=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const F=T.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(T)?p.create(T.substr(1).trim()):d.create(T)}static _deserializeValue(T){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const F=/^'([^']*)'$/.exec(T);return F?F[1].trim():T}static _deserializeRegexValue(T){if((0,R.isFalsyOrWhitespace)(T))return null;const F=T.indexOf("/"),U=T.lastIndexOf("/");if(F===U||F<0)return null;const Z=T.slice(F+1,U),J=T[U+1]==="i"?"i":"";try{return new RegExp(Z,J)}catch{return null}}}e.ContextKeyExpr=C;class L extends Error{}class k{constructor(){this._scanner=new l.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[]}get lexingErrors(){return this._scanner.errorTokens}get parsingErrors(){return this._parsingErrors}parse(T){if(T===""){this._parsingErrors.push("Expected an expression but got an empty string");return}this._tokens=this._scanner.reset(T).scan(),this._current=0,this._parsingErrors=[];try{const F=this._expr();if(!this._isAtEnd())throw this._errUnexpected(this._peek());return F}catch(F){if(!(F instanceof L)){const U=this._peek();this._parsingErrors.push(`Unexpected error: ${F} for token ${l.Scanner.getLexeme(U)} at offset ${U.offset}.`)}return}}_expr(){return this._or()}_or(){const T=[this._and()];for(;this._matchOne(16);){const F=this._and();T.push(F)}return T.length===1?T[0]:C.or(...T)}_and(){const T=[this._term()];for(;this._matchOne(15);){const F=this._term();T.push(F)}return T.length===1?T[0]:C.and(...T)}_term(){if(this._matchOne(2)){const T=this._peek();switch(T.type){case 17:return this._advance(),C.not(T.lexeme);case 11:return this._advance(),C.false();case 12:return this._advance(),C.true();default:throw this._errExpectedButGot("KEY, 'true', or 'false'",T)}}return this._primary()}_primary(){const T=this._peek();switch(T.type){case 11:return this._advance(),C.true();case 12:return this._advance(),C.false();case 0:{this._advance();const F=this._expr();return this._consume(1,"')'"),F}case 17:{const F=T.lexeme;if(this._advance(),this._matchOne(9)){const Z=this._peek();switch(Z.type){case 10:case 19:{const J=[Z.lexeme];this._advance();let z=this._peek(),Q=0;for(let ee=0;ee<Z.lexeme.length;ee++)Z.lexeme.charCodeAt(ee)===40?Q++:Z.lexeme.charCodeAt(ee)===41&&Q--;for(;!this._isAtEnd()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:Q++;break;case 1:Q--;break;case 10:case 18:for(let ee=0;ee<z.lexeme.length;ee++)z.lexeme.charCodeAt(ee)===40?Q++:Z.lexeme.charCodeAt(ee)===41&&Q--}if(Q<0)break;J.push(l.Scanner.getLexeme(z)),this._advance(),z=this._peek()}const ie=J.join(""),ge=ie.lastIndexOf("/"),K=ge===ie.length-1?void 0:ie.substring(ge+1),Y=new RegExp(ie.substring(1,ge),K);return C.regex(F,Y)}case 18:{const J=Z.lexeme;this._advance();let z=null;if(!(0,R.isFalsyOrWhitespace)(J)){const Q=J.indexOf("/"),ie=J.lastIndexOf("/");if(Q!==ie&&Q>=0){const ge=J.slice(Q+1,ie),K=J[ie+1]==="i"?"i":"";try{z=new RegExp(ge,K)}catch{}}}if(z===null)throw this._errExpectedButGot("REGEX",Z);return g.create(F,z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,"'in' after 'not'");const Z=this._value();return C.notIn(F,Z)}switch(this._peek().type){case 3:{this._advance();const Z=this._value();switch(Z){case"true":return C.has(F);case"false":return C.not(F);default:return C.equals(F,Z)}}case 4:{this._advance();const Z=this._value();switch(Z){case"true":return C.not(F);case"false":return C.has(F);default:return C.notEquals(F,Z)}}case 5:return this._advance(),a.create(F,this._value());case 6:return this._advance(),c.create(F,this._value());case 7:return this._advance(),s.create(F,this._value());case 8:return this._advance(),r.create(F,this._value());case 13:return this._advance(),C.in(F,this._value());default:return C.has(F)}}default:throw this._errExpectedButGot("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this._peek())}}_value(){const T=this._peek();switch(T.type){case 17:case 18:return this._advance(),T.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_previous(){return this._tokens[this._current-1]}_matchOne(T){return this._check(T)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(T,F){if(this._check(T))return this._advance();throw this._errExpectedButGot(F,this._peek())}_errExpectedButGot(T,F){return this._error(`Expected ${T} but got '${l.Scanner.getLexeme(F)}' at offset ${F.offset}.`)}_errUnexpected(T){return this._error(`Unexpected '${l.Scanner.getLexeme(T)}' at offset ${T.offset}.`)}_error(T){return this._parsingErrors.push(T),new L}_check(T){return this._peek().type===T}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=k;function b(N,T){const F=N?N.substituteConstants():void 0,U=T?T.substituteConstants():void 0;return!F&&!U?!0:!F||!U?!1:F.equals(U)}e.expressionsAreEqualWithConstantSubstitution=b;function I(N,T){return N.cmp(T)}class y{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return f.INSTANCE}}y.INSTANCE=new y,e.ContextKeyFalseExpr=y;class f{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return y.INSTANCE}}f.INSTANCE=new f,e.ContextKeyTrueExpr=f;class d{static create(T,F=null){const U=w.get(T);return typeof U=="boolean"?U?f.INSTANCE:y.INSTANCE:new d(T,F)}constructor(T,F){this.key=T,this.negated=F,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=w.get(this.key);return typeof T=="boolean"?T?f.INSTANCE:y.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class u{static create(T,F,U=null){if(typeof F=="boolean")return F?d.create(T,U):p.create(T,U);const Z=w.get(T);return typeof Z=="boolean"?F===(Z?"true":"false")?f.INSTANCE:y.INSTANCE:new u(T,F,U)}constructor(T,F,U){this.key=T,this.value=F,this.negated=U,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:$(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=w.get(this.key);if(typeof T=="boolean"){const F=T?"true":"false";return this.value===F?f.INSTANCE:y.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class m{static create(T,F){return new m(T,F)}constructor(T,F){this.key=T,this.valueKey=F,this.type=10,this.negated=null}cmp(T){return T.type!==this.type?this.type-T.type:$(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.valueKey),U=T.getValue(this.key);return Array.isArray(F)?F.includes(U):typeof U=="string"&&typeof F=="object"&&F!==null?P.call(F,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=m;class v{static create(T,F){return new v(T,F)}constructor(T,F){this.key=T,this.valueKey=F,this.type=11,this._negated=m.create(T,F)}cmp(T){return T.type!==this.type?this.type-T.type:this._negated.cmp(T._negated)}equals(T){return T.type===this.type?this._negated.equals(T._negated):!1}substituteConstants(){return this}evaluate(T){return!this._negated.evaluate(T)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(T){return T.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class D{static create(T,F,U=null){if(typeof F=="boolean")return F?p.create(T,U):d.create(T,U);const Z=w.get(T);return typeof Z=="boolean"?F===(Z?"true":"false")?y.INSTANCE:f.INSTANCE:new D(T,F,U)}constructor(T,F,U){this.key=T,this.value=F,this.negated=U,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:$(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=w.get(this.key);if(typeof T=="boolean"){const F=T?"true":"false";return this.value===F?y.INSTANCE:f.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=D;class p{static create(T,F=null){const U=w.get(T);return typeof U=="boolean"?U?y.INSTANCE:f.INSTANCE:new p(T,F)}constructor(T,F){this.key=T,this.negated=F,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=w.get(this.key);return typeof T=="boolean"?T?y.INSTANCE:f.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function n(N,T){if(typeof N=="string"){const F=parseFloat(N);isNaN(F)||(N=F)}return typeof N=="string"||typeof N=="number"?T(N):y.INSTANCE}class s{static create(T,F,U=null){return n(F,Z=>new s(T,Z,U))}constructor(T,F,U){this.key=T,this.value=F,this.negated=U,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:$(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class r{static create(T,F,U=null){return n(F,Z=>new r(T,Z,U))}constructor(T,F,U){this.key=T,this.value=F,this.negated=U,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:$(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{static create(T,F,U=null){return n(F,Z=>new a(T,Z,U))}constructor(T,F,U){this.key=T,this.value=F,this.negated=U,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:$(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class c{static create(T,F,U=null){return n(F,Z=>new c(T,Z,U))}constructor(T,F,U){this.key=T,this.value=F,this.negated=U,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:$(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class g{static create(T,F){return new g(T,F)}constructor(T,F){this.key=T,this.regexp=F,this.type=7,this.negated=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const F=this.regexp?this.regexp.source:"",U=T.regexp?T.regexp.source:"";return F<U?-1:F>U?1:0}equals(T){if(T.type===this.type){const F=this.regexp?this.regexp.source:"",U=T.regexp?T.regexp.source:"";return this.key===T.key&&F===U}return!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=g;class i{static create(T){return new i(T)}constructor(T){this._actual=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new i(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function t(N){let T=null;for(let F=0,U=N.length;F<U;F++){const Z=N[F].substituteConstants();if(N[F]!==Z&&T===null){T=[];for(let J=0;J<F;J++)T[J]=N[J]}T!==null&&(T[F]=Z)}return T===null?N:T}class h{static create(T,F,U){return h._normalizeArr(T,F,U)}constructor(T,F){this.expr=T,this.negated=F,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const Z=I(this.expr[F],T.expr[F]);if(Z!==0)return Z}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=t(this.expr);return T===this.expr?this:h.create(T,this.negated,!1)}evaluate(T){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(T))return!1;return!0}static _normalizeArr(T,F,U){const Z=[];let J=!1;for(const z of T)if(!!z){if(z.type===1){J=!0;continue}if(z.type===0)return y.INSTANCE;if(z.type===6){Z.push(...z.expr);continue}Z.push(z)}if(Z.length===0&&J)return f.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(I);for(let z=1;z<Z.length;z++)Z[z-1].equals(Z[z])&&(Z.splice(z,1),z--);if(Z.length===1)return Z[0];for(;Z.length>1;){const z=Z[Z.length-1];if(z.type!==9)break;Z.pop();const Q=Z.pop(),ie=Z.length===0,ge=_.create(z.expr.map(K=>h.create([K,Q],null,U)),null,ie);ge&&(Z.push(ge),Z.sort(I))}if(Z.length===1)return Z[0];if(U){for(let z=0;z<Z.length;z++)for(let Q=z+1;Q<Z.length;Q++)if(Z[z].negate().equals(Z[Q]))return y.INSTANCE;if(Z.length===1)return Z[0]}return new h(Z,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new h(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.negated){const T=[];for(const F of this.expr)T.push(F.negate());this.negated=_.create(T,this,!0)}return this.negated}}class _{static create(T,F,U){return _._normalizeArr(T,F,U)}constructor(T,F){this.expr=T,this.negated=F,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const Z=I(this.expr[F],T.expr[F]);if(Z!==0)return Z}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=t(this.expr);return T===this.expr?this:_.create(T,this.negated,!1)}evaluate(T){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(T))return!0;return!1}static _normalizeArr(T,F,U){let Z=[],J=!1;if(T){for(let z=0,Q=T.length;z<Q;z++){const ie=T[z];if(!!ie){if(ie.type===0){J=!0;continue}if(ie.type===1)return f.INSTANCE;if(ie.type===9){Z=Z.concat(ie.expr);continue}Z.push(ie)}}if(Z.length===0&&J)return y.INSTANCE;Z.sort(I)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let z=1;z<Z.length;z++)Z[z-1].equals(Z[z])&&(Z.splice(z,1),z--);if(Z.length===1)return Z[0];if(U){for(let z=0;z<Z.length;z++)for(let Q=z+1;Q<Z.length;Q++)if(Z[z].negate().equals(Z[Q]))return f.INSTANCE;if(Z.length===1)return Z[0]}return new _(Z,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new _(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.negated){const T=[];for(const F of this.expr)T.push(F.negate());for(;T.length>1;){const F=T.shift(),U=T.shift(),Z=[];for(const J of V(F))for(const z of V(U))Z.push(h.create([J,z],null,!1));T.unshift(_.create(Z,null,!1))}this.negated=_.create(T,this,!0)}return this.negated}}class E extends d{static all(){return E._info.values()}constructor(T,F,U){super(T,null),this._defaultValue=F,typeof U=="object"?E._info.push({...U,key:T}):U!==!0&&E._info.push({key:T,description:U,type:F!=null?typeof F:void 0})}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return u.create(this.key,T)}notEqualsTo(T){return D.create(this.key,T)}}E._info=[],e.RawContextKey=E,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function O(N,T){return N<T?-1:N>T?1:0}function $(N,T,F,U){return N<F?-1:N>F?1:T<U?-1:T>U?1:0}function H(N,T){if(N.type===0||T.type===1)return!0;if(N.type===9)return T.type===9?X(N.expr,T.expr):!1;if(T.type===9){for(const F of T.expr)if(H(N,F))return!0;return!1}if(N.type===6){if(T.type===6)return X(T.expr,N.expr);for(const F of N.expr)if(H(F,T))return!0;return!1}return N.equals(T)}e.implies=H;function X(N,T){let F=0,U=0;for(;F<N.length&&U<T.length;){const Z=N[F].cmp(T[U]);if(Z<0)return!1;Z===0&&F++,U++}return F===N.length}function V(N){return N.type===9?N.expr:[N]}}),define(Se[202],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[123],ye([1,0,170,4]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function w(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function P(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function S(u,m,v){return P(m,v)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===v?!0:C(v).includes(u)}e.isTargetPlatformCompatible=S;function C(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function L(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=L;var k;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var I;(function(u){u.Install="install",u.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var y;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var f;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(m,v){super(m),this.code=v,this.name=v}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,o.localize)(1,null),original:"Preferences"}}),define(Se[203],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(Se[204],ye([1,0,46,15,12,11,109,29,116,172,203]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=C.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends b{openTerminal(D,p){return this.spawnTerminal(o,D,S.getWindowsShell(),p)}spawnTerminal(D,p,n,s){const r=p.windowsExec||I.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=l.basename(r,".exe").toLowerCase();if(a==="cmder")return D.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return r.indexOf(" ")>=0&&c.push('""'),c.push(r),a==="wt"&&c.push("-d ."),new Promise((g,i)=>{const t=d(process),h=D.spawn(n,c,{cwd:s,env:t});h.on("error",i),h.on("exit",()=>g())})}runInTerminal(D,p,n,s,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:I.getDefaultTerminalWindows();return new Promise((c,g)=>{const i=`"${p} - ${k}"`,t=`""${n.join('" "')}" & pause"`,h=Object.assign({},d(process),s);Object.keys(h).filter(H=>h[H]===null).forEach(H=>delete h[H]);const _={cwd:p,env:h,windowsVerbatimArguments:!0};let E,O;l.basename(a,".exe")==="wt"?(E=a,O=["-d",".",I.CMD,"/c",t]):(E=I.CMD,O=["/c","start",i,"/wait",a,"/c",t]),o.spawn(E,O,_).on("error",H=>{g(u(H))}),c(void 0)})}static getDefaultTerminalWindows(){if(!I._DEFAULT_TERMINAL_WINDOWS){const D=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${D?"Sysnative":"System32"}\\cmd.exe`}return I._DEFAULT_TERMINAL_WINDOWS}}I.CMD="cmd.exe",e.WindowsExternalTerminalService=I;class y extends b{openTerminal(D,p){return this.spawnTerminal(o,D,p)}runInTerminal(D,p,n,s,r){const a=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((c,g)=>{if(a===L.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const i=a===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",D||k,"-w",p];for(const O of n)h.push("-a"),h.push(O);if(s){const O=Object.assign({},d(process),s);for(const $ in O){const H=O[$];H===null?(h.push("-u"),h.push($)):(h.push("-e"),h.push(`${$}=${H}`))}}let _="";const E=o.spawn(y.OSASCRIPT,h);E.on("error",O=>{g(u(O))}),E.stderr.on("data",O=>{_+=O.toString()}),E.on("exit",O=>{if(O===0)c(void 0);else if(_){const $=_.split(`
`,1);g(new Error($[0]))}else g(new Error(C.localize(1,null,i,O)))})}else g(new Error(C.localize(2,null,a)))})}spawnTerminal(D,p,n){const s=p.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const c=["-a",s];n&&c.push(n);const g=d(process),i=D.spawn("/usr/bin/open",c,{cwd:n,env:g});i.on("error",a),i.on("exit",()=>r())})}}y.OSASCRIPT="/usr/bin/osascript",e.MacExternalTerminalService=y;class f extends b{openTerminal(D,p){return this.spawnTerminal(o,D,p)}runInTerminal(D,p,n,s,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,g)=>{const i=[];a.then(t=>{t.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const h=`${m(n)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;i.push(`''${h}''`);const _=Object.assign({},d(process),s);Object.keys(_).filter(H=>_[H]===null).forEach(H=>delete _[H]);const E={cwd:p,env:_};let O="";const $=o.spawn(t,i,E);$.on("error",H=>{g(u(H))}),$.stderr.on("data",H=>{O+=H.toString()}),$.on("exit",H=>{if(H===0)c(void 0);else if(O){const X=O.split(`
`,1);g(new Error(X[0]))}else g(new Error(C.localize(4,null,t,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const D=await P.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{D?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(D,p,n){const s=p.linuxExec?Promise.resolve(p.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{s.then(c=>{const g=d(process),i=D.spawn(c,[],{cwd:n,env:g});i.on("error",a),i.on("exit",()=>r())})})}}f.WAIT_MESSAGE=C.localize(3,null),e.LinuxExternalTerminalService=f;function d(v){const D={...v.env};return(0,w.sanitizeProcessEnvironment)(D),D}function u(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(C.localize(5,null,v.path)):v}function m(v){let D="";for(const p of v)p.indexOf(" ")>=0?D+='"'+p+'"':D+=p,D+=" ";return D}}),define(Se[44],ye([1,0,68,12,8,9,2,173,4,11,15]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var b;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var I;(function(z){z[z.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var y;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=f;function d(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=d;function u(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=u;function m(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function v(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=v;function D(z){return f(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var p;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class n extends Error{static create(Q,ie){const ge=new n(Q.toString(),ie);return a(ge,ie),ge}constructor(Q,ie){super(Q),this.code=ie}}e.FileSystemProviderError=n;function s(z,Q){return n.create(z,Q)}e.createFileSystemProviderError=s;function r(z){return z||s((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function a(z,Q){return z.name=Q?`${Q} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=a;function c(z){if(!z)return p.Unknown;if(z instanceof n)return z.code;const Q=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!Q)return p.Unknown;switch(Q[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=c;function g(z){if(z instanceof O)return z.fileOperationResult;switch(c(z)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=g;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(Q,ie,ge){this.resource=Q,this.operation=ie,this.target=ge}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=t;var h;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class _{constructor(Q,ie){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ge=new Map;for(const K of Q){const Y=ge.get(K.type);switch(Y?Y.push([K.resource,K]):ge.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,Y]of ge)switch(K){case 1:this.added=o.TernarySearchTree.forUris(()=>ie),this.added.fill(Y);break;case 0:this.updated=o.TernarySearchTree.forUris(()=>ie),this.updated.fill(Y);break;case 2:this.deleted=o.TernarySearchTree.forUris(()=>ie),this.deleted.fill(Y);break}}contains(Q,...ie){return this.doContains(Q,{includeChildren:!1},...ie)}affects(Q,...ie){return this.doContains(Q,{includeChildren:!0},...ie)}doContains(Q,ie,...ge){if(!Q)return!1;const K=ge.length>0;return!!((!K||ge.includes(1))&&(this.added?.get(Q)||ie.includeChildren&&this.added?.findSuperstr(Q))||(!K||ge.includes(0))&&(this.updated?.get(Q)||ie.includeChildren&&this.updated?.findSuperstr(Q))||(!K||ge.includes(2))&&(this.deleted?.findSubstr(Q)||ie.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=_;function E(z,Q,ie){return!z||!Q||z===Q||Q.length>z.length?!1:(Q.charAt(Q.length-1)!==R.sep&&(Q+=R.sep),ie?(0,l.startsWithIgnoreCase)(z,Q):z.indexOf(Q)===0)}e.isParent=E;class O extends Error{constructor(Q,ie,ge){super(Q),this.fileOperationResult=ie,this.options=ge}}e.FileOperationError=O;class $ extends O{constructor(Q,ie,ge,K){super(Q,ie,K),this.fileOperationResult=ie,this.size=ge}}e.TooLargeFileOperationError=$;class H extends O{constructor(Q,ie,ge){super(Q,2,ge),this.stat=ie}}e.NotModifiedSinceFileOperationError=H;var X;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(X=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=N;async function T(z,Q){if(!Q.hasProvider(w.URI.from({scheme:z.scheme})))return new Promise(ie=>{const ge=Q.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===z.scheme&&K.added&&(ge.dispose(),ie())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(Q){return(0,A.isNumber)(Q)||(Q=0),Q<F.KB?(0,P.localize)(1,null,Q.toFixed(0)):Q<F.MB?(0,P.localize)(2,null,(Q/F.KB).toFixed(2)):Q<F.GB?(0,P.localize)(3,null,(Q/F.MB).toFixed(2)):Q<F.TB?(0,P.localize)(4,null,(Q/F.GB).toFixed(2)):(0,P.localize)(5,null,(Q/F.TB).toFixed(2))}}F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB,e.ByteSize=F;var U;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function Z(z){return{maxFileSize:z===0?300*F.MB:16*F.GB,maxHeapSize:z===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=Z;function J(z){const Q=typeof z=="string"||z?.scheme===L.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===L.Schemas.file?1024*F.MB:Q?10*F.MB:C.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=J}),define(Se[91],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...l){this._entries=new Map;for(const[A,w]of l)this.set(A,w)}set(l,A){const w=this._entries.get(l);return this._entries.set(l,A),w}has(l){return this._entries.has(l)}get(l){return this._entries.get(l)}}e.ServiceCollection=o}),define(Se[205],ye([1,0,19,10,6,122,201,4,91,66]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class k extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class b{constructor(d=new S.ServiceCollection,u=!1,m,v=L){this._services=d,this._strict=u,this._parent=m,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=v?m?._globalGraph??new w.Graph(D=>D):void 0}createChild(d){return new b(d,this._strict,this,this._enableTracing)}invokeFunction(d,...u){const m=y.traceInvocation(this._enableTracing,d);let v=!1;try{return d({get:p=>{if(v)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(p,m);if(!n)throw new Error(`[invokeFunction] unknown service '${p}'`);return n}},...u)}finally{v=!0,m.stop()}}createInstance(d,...u){let m,v;return d instanceof A.SyncDescriptor?(m=y.traceCreation(this._enableTracing,d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(u),m)):(m=y.traceCreation(this._enableTracing,d),v=this._createInstance(d,u,m)),m.stop(),v}_createInstance(d,u=[],m){const v=P._util.getServiceDependencies(d).sort((n,s)=>n.index-s.index),D=[];for(const n of v){const s=this._getOrCreateServiceInstance(n.id,m);s||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${n.id}.`,!1),D.push(s)}const p=v.length>0?v[0].index:u.length;if(u.length!==p){console.trace(`[createInstance] First service dependency of ${d.name} at position ${p+1} conflicts with ${u.length} static arguments`);const n=p-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,p)}return Reflect.construct(d,u.concat(D))}_setServiceInstance(d,u){if(this._services.get(d)instanceof A.SyncDescriptor)this._services.set(d,u);else if(this._parent)this._parent._setServiceInstance(d,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const u=this._services.get(d);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):u}_getOrCreateServiceInstance(d,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(d));const m=this._getServiceInstanceOrDescriptor(d);return m instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,m,u.branch(d,!0)):(u.branch(d,!1),m)}_safeCreateAndCacheServiceInstance(d,u,m){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,u,m)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,u,m){const v=new w.Graph(n=>n.id.toString());let D=0;const p=[{id:d,desc:u,_trace:m}];for(;p.length;){const n=p.pop();if(v.lookupOrInsertNode(n),D++>1e3)throw new k(v);for(const s of P._util.getServiceDependencies(n.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(s.id);if(r||this._throwIfStrict(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),r instanceof A.SyncDescriptor){const a={id:s.id,desc:r,_trace:n._trace.branch(s.id,!0)};v.insertEdge(n,a),p.push(a)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new k(v);break}for(const{data:s}of n){if(this._getServiceInstanceOrDescriptor(s.id)instanceof A.SyncDescriptor){const a=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,a)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,u,m=[],v,D){if(this._services.get(d)instanceof A.SyncDescriptor)return this._createServiceInstance(d,u,m,v,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,u,m,v,D);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(d,u,m=[],v,D){if(v){const p=new b(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(d);const n=new Map,s=new o.IdleValue(()=>{const r=p._createInstance(u,m,D);for(const[a,c]of n){const g=r[a];if(typeof g=="function")for(const i of c)g.apply(r,i)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let i=n.get(a);return i||(i=new C.LinkedList,n.set(a,i)),(h,_,E)=>{const O=i.push([h,_,E]);return(0,l.toDisposable)(O)}}if(a in r)return r[a];const c=s.value;let g=c[a];return typeof g!="function"||(g=g.bind(c),r[a]=g),g},set(r,a,c){return s.value[a]=c,!0},getPrototypeOf(r){return u.prototype}})}else return this._createInstance(u,m,D)}_throwIfStrict(d,u){if(u&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=b;var I;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(I||(I={}));class y{static traceInvocation(d,u){return d?new y(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y._None}static traceCreation(d,u){return d?new y(1,u.name):y._None}constructor(d,u){this.type=d,this.name=u,this._start=Date.now(),this._dep=[]}branch(d,u){const m=new y(3,d.toString());return this._dep.push([d,u,m]),m}stop(){const d=Date.now()-this._start;y._totals+=d;let u=!1;function m(D,p){const n=[],s=new Array(D+1).join("	");for(const[r,a,c]of p._dep)if(a&&c){u=!0,n.push(`${s}CREATES -> ${r}`);const g=m(D+1,c);g&&n.push(g)}else n.push(`${s}uses -> ${r}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(d>2||u)&&y.all.add(v.join(`
`))}}y.all=new Set,y._None=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y._totals=0,e.Trace=y}),define(Se[13],ye([1,0,45,3,6,28,11,9,2,4]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function L(){return new Date().toISOString()}function k(i){return(0,P.isNumber)(i)}e.isLogLevel=k;var b;(function(i){i[i.Off=0]="Off",i[i.Trace=1]="Trace",i[i.Debug=2]="Debug",i[i.Info=3]="Info",i[i.Warning=4]="Warning",i[i.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function I(i,t,h){switch(t){case b.Trace:i.trace(h);break;case b.Debug:i.debug(h);break;case b.Info:i.info(h);break;case b.Warning:i.warn(h);break;case b.Error:i.error(h);break;case b.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=I;function y(i){let t="";for(let h=0;h<i.length;h++){let _=i[h];if(typeof _=="object")try{_=JSON.stringify(_)}catch{}t+=(h>0?" ":"")+_}return t}e.format=y;class f extends l.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(t){return this.level!==b.Off&&this.level<=t}}e.AbstractLogger=f;class d extends f{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||super.checkLogLevel(t)}trace(t,...h){this.checkLogLevel(b.Trace)&&this.log(b.Trace,y([t,...h]))}debug(t,...h){this.checkLogLevel(b.Debug)&&this.log(b.Debug,y([t,...h]))}info(t,...h){this.checkLogLevel(b.Info)&&this.log(b.Info,y([t,...h]))}warn(t,...h){this.checkLogLevel(b.Warning)&&this.log(b.Warning,y([t,...h]))}error(t,...h){if(this.checkLogLevel(b.Error))if(t instanceof Error){const _=Array.prototype.slice.call(arguments);_[0]=t.stack,this.log(b.Error,y(_))}else this.log(b.Error,y([t,...h]))}flush(){}}e.AbstractMessageLogger=d;class u extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!w.isWindows}trace(t,...h){this.checkLogLevel(b.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...h):console.log(`[main ${L()}]`,t,...h))}debug(t,...h){this.checkLogLevel(b.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...h):console.log(`[main ${L()}]`,t,...h))}info(t,...h){this.checkLogLevel(b.Info)&&(this.useColors?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...h):console.log(`[main ${L()}]`,t,...h))}warn(t,...h){this.checkLogLevel(b.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${L()}]\x1B[0m`,t,...h):console.warn(`[main ${L()}]`,t,...h))}error(t,...h){this.checkLogLevel(b.Error)&&(this.useColors?console.error(`\x1B[91m[main ${L()}]\x1B[0m`,t,...h):console.error(`[main ${L()}]`,t,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class m extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...h){this.checkLogLevel(b.Trace)&&console.log("%cTRACE","color: #888",t,...h)}debug(t,...h){this.checkLogLevel(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...h)}info(t,...h){this.checkLogLevel(b.Info)&&console.log("%c INFO","color: #33f",t,...h)}warn(t,...h){this.checkLogLevel(b.Warning)&&console.log("%c WARN","color: #993",t,...h)}error(t,...h){this.checkLogLevel(b.Error)&&console.log("%c  ERR","color: #f33",t,...h)}dispose(){}flush(){}}e.ConsoleLogger=m;class v extends f{constructor(t,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(h)}trace(t,...h){this.checkLogLevel(b.Trace)&&this.adapter.log(b.Trace,[this.extractMessage(t),...h])}debug(t,...h){this.checkLogLevel(b.Debug)&&this.adapter.log(b.Debug,[this.extractMessage(t),...h])}info(t,...h){this.checkLogLevel(b.Info)&&this.adapter.log(b.Info,[this.extractMessage(t),...h])}warn(t,...h){this.checkLogLevel(b.Warning)&&this.adapter.log(b.Warning,[this.extractMessage(t),...h])}error(t,...h){this.checkLogLevel(b.Error)&&this.adapter.log(b.Error,[this.extractMessage(t),...h])}extractMessage(t){return typeof t=="string"?t:(0,o.toErrorMessage)(t,this.checkLogLevel(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=v;class D extends f{constructor(t){super(),this.loggers=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const h of this.loggers)h.setLevel(t);super.setLevel(t)}trace(t,...h){for(const _ of this.loggers)_.trace(t,...h)}debug(t,...h){for(const _ of this.loggers)_.debug(t,...h)}info(t,...h){for(const _ of this.loggers)_.info(t,...h)}warn(t,...h){for(const _ of this.loggers)_.warn(t,...h)}error(t,...h){for(const _ of this.loggers)_.error(t,...h)}flush(){for(const t of this.loggers)t.flush()}dispose(){for(const t of this.loggers)t.dispose()}}e.MultiplexLogger=D;class p extends l.Disposable{constructor(t,h){if(super(),this.logLevel=t,this._loggers=new A.ResourceMap,this._loggerResources=new A.ResourceMap,this._onDidChangeLoggers=this._register(new R.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,h)for(const _ of h)this._loggerResources.set(_.resource,_)}getLogger(t){return this._loggers.get(t)}createLogger(t,h){let _=this._loggers.get(t);const E=h?.logLevel==="always"?b.Trace:h?.logLevel;return _||(_=this.doCreateLogger(t,E??this.getLogLevel(t)??this.logLevel,h),this._loggers.set(t,_)),this.registerLogger({resource:t,id:h?.id??t.toString(),logLevel:E,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId}),_}setLogLevel(t,h){if(S.URI.isUri(t)){const _=t,E=h,O=this._loggerResources.get(_);O&&E!==O.logLevel&&(O.logLevel=E===this.logLevel?void 0:E,this._loggers.get(_)?.setLevel(E),this._loggerResources.set(O.resource,O),this._onDidChangeLogLevel.fire([_,E]))}else{this.logLevel=t;for(const[_,E]of this._loggers.entries())this._loggerResources.get(_)?.logLevel===void 0&&E.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(t,h){const _=this._loggerResources.get(t);_&&h!==!_.hidden&&(_.hidden=!h,this._loggerResources.set(_.resource,_),this._onDidChangeVisibility.fire([t,h]))}getLogLevel(t){let h;return t&&(h=this._loggerResources.get(t)?.logLevel),h??this.logLevel}registerLogger(t){const h=this._loggerResources.get(t.resource);h?h.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this._loggerResources.set(t.resource,t),this._onDidChangeLoggers.fire({added:[t],removed:[]}))}deregisterLogger(t){const h=this._loggerResources.get(t);if(h){this._loggerResources.delete(t);const _=this._loggers.get(t);_&&(this._loggers.delete(t),_.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[h]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(t){return this._loggerResources.get(t)}dispose(){this._loggers.forEach(t=>t.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=p;class n{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return b.Info}trace(t,...h){}debug(t,...h){}info(t,...h){}warn(t,...h){}error(t,...h){}critical(t,...h){}dispose(){}flush(){}}e.NullLogger=n;class s extends n{}e.NullLogService=s;class r extends p{constructor(){super(b.Info)}doCreateLogger(t,h,_){return new n}}e.NullLoggerService=r;function a(i){if(i.verbose)return b.Trace;if(typeof i.logLevel=="string"){const t=g(i.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function c(i){switch(i){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=c;function g(i){switch(i){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=g}),define(Se[206],ye([1,0,6,13]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends o.Disposable{constructor(w,P=[]){super(),this.logger=new R.MultiplexLogger([w,...P]),this._register(w.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(w){this.logger.setLevel(w)}getLevel(){return this.logger.getLevel()}trace(w,...P){this.logger.trace(w,...P)}debug(w,...P){this.logger.debug(w,...P)}info(w,...P){this.logger.info(w,...P)}warn(w,...P){this.logger.warn(w,...P)}error(w,...P){this.logger.error(w,...P)}flush(){this.logger.flush()}}e.LogService=l}),define(Se[207],ye([1,0,44,13]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(l||(l={}));async function A(C,L,k,b,I){try{const y=await new Promise((d,u)=>{re(["spdlog"],d,u)});y.setFlushOn(l.Trace);const f=await y.createAsyncRotatingLogger(C,L,k,b);return I?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(y){console.error(y)}return null}function w(C,L,k){switch(L){case R.LogLevel.Trace:C.trace(k);break;case R.LogLevel.Debug:C.debug(k);break;case R.LogLevel.Info:C.info(k);break;case R.LogLevel.Warning:C.warn(k);break;case R.LogLevel.Error:C.error(k);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function P(C,L){switch(L){case R.LogLevel.Trace:C.setLevel(l.Trace);break;case R.LogLevel.Debug:C.setLevel(l.Debug);break;case R.LogLevel.Info:C.setLevel(l.Info);break;case R.LogLevel.Warning:C.setLevel(l.Warning);break;case R.LogLevel.Error:C.setLevel(l.Error);break;case R.LogLevel.Off:C.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class S extends R.AbstractMessageLogger{constructor(L,k,b,I,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(L,k,b,I),this._register(this.onDidChangeLogLevel(f=>{this._logger&&P(this._logger,f)}))}async _createSpdLogLogger(L,k,b,I){const y=b?6:1,f=30/y*o.ByteSize.MB,d=await A(L,k,f,y,I);if(d){this._logger=d,P(this._logger,this.getLevel());for(const{level:u,message:m}of this.buffer)w(this._logger,u,m);this.buffer=[]}}log(L,k){this._logger?w(this._logger,L,k):this.getLevel()<=L&&this.buffer.push({level:L,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(Se[124],ye([1,0,37,174,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var w;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(w=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(y,f){return f-y}S.compare=C;const L=Object.create(null);L[S.Error]=(0,R.localize)(0,null),L[S.Warning]=(0,R.localize)(1,null),L[S.Info]=(0,R.localize)(2,null);function k(y){return L[y]||""}S.toString=k;function b(y){switch(y){case o.default.Error:return S.Error;case o.default.Warning:return S.Warning;case o.default.Info:return S.Info;case o.default.Ignore:return S.Hint}}S.fromSeverity=b;function I(y){switch(y){case S.Error:return o.default.Error;case S.Warning:return o.default.Warning;case S.Info:return o.default.Info;case S.Hint:return o.default.Ignore}}S.toSeverity=I}(w=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const C="";function L(b){return k(b,!0)}S.makeKey=L;function k(b,I){const y=[C];return b.source?y.push(b.source.replace("\xA6","\\\xA6")):y.push(C),b.code?typeof b.code=="string"?y.push(b.code.replace("\xA6","\\\xA6")):y.push(b.code.value.replace("\xA6","\\\xA6")):y.push(C),b.severity!==void 0&&b.severity!==null?y.push(w.toString(b.severity)):y.push(C),b.message&&I?y.push(b.message.replace("\xA6","\\\xA6")):y.push(C),b.startLineNumber!==void 0&&b.startLineNumber!==null?y.push(b.startLineNumber.toString()):y.push(C),b.startColumn!==void 0&&b.startColumn!==null?y.push(b.startColumn.toString()):y.push(C),b.endLineNumber!==void 0&&b.endLineNumber!==null?y.push(b.endLineNumber.toString()):y.push(C),b.endColumn!==void 0&&b.endColumn!==null?y.push(b.endColumn.toString()):y.push(C),y.push(C),y.join("\xA6")}S.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(Se[208],ye([1,0,3,37,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,l.createDecorator)("notificationService");var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var w;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(w=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(Se[125],ye([1,0,8,2,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function A(C,L){return R.URI.isUri(C)?(0,o.equalsIgnoreCase)(C.scheme,L):(0,o.startsWithIgnoreCase)(C,L+":")}e.matchesScheme=A;function w(C,...L){return L.some(k=>A(C,k))}e.matchesSomeScheme=w;function P(C,L){return C.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=P;function S(C){let L;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return k&&(L={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},C=C.with({fragment:""})),{selection:L,uri:C}}e.extractSelection=S}),define(Se[209],ye([1,0,15,11,33,198]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let w;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.context<"u"){const P=R.globals.vscode.context.configuration();if(P)w=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){w=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:P,searchUrl:S,itemUrl:C,controlUrl:L}=w.extensionsGallery||{};Object.assign(w,{extensionsGallery:{serviceUrl:l.env.VSCODE_GALLERY_SERVICE_URL||P,searchUrl:l.env.VSCODE_GALLERY_SEARCH_URL||S,itemUrl:l.env.VSCODE_GALLERY_ITEM_URL||C,controlUrl:l.env.VSCODE_GALLERY_CONTROL_URL||L}});try{const k=(...f)=>f.reduce((d,u)=>(Object.keys(u).forEach(m=>{Array.isArray(d[m])&&Array.isArray(u[m])?d[m]=u[m]:typeof d[m]=="object"&&typeof u[m]=="object"?d[m]=k(d[m],u[m]):d[m]=u[m]}),d),{}),b=(0,A.getUserDataPath)({},w.nameShort),I=R.isWindows?`file:///${b}/product.json`:`file://${b}/product.json`,y=re.__$__nodeRequire(o.FileAccess.asFileUri(I).fsPath);w=k(w,y)}catch{}if(l.env.VSCODE_DEV&&Object.assign(w,{nameShort:`${w.nameShort} Dev`,nameLong:`${w.nameLong} Dev`,dataFolderName:`${w.dataFolderName}-dev`,serverDataFolderName:w.serverDataFolderName?`${w.serverDataFolderName}-dev`:void 0}),!w.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(w,{version:k.version,release:k.release})}}else w={},Object.keys(w).length===0&&Object.assign(w,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=w}),define(Se[210],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(re,e){return function(o,R){e(o,R,re)}};define(Se[126],ye([1,0,19,21,6,4]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var w;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(w=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this._value}constructor(k){this.callback=k}report(k){this._value=k,this.callback(this._value)}}P.None=Object.freeze({report(){}}),e.Progress=P;let S=class extends l.Disposable{constructor(k,b){super(),this.deferred=new o.DeferredPromise,b.withProgress(k,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,l.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=je([Be(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends l.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new l.DisposableStore)}start(k){this.stop();const b=++this.currentOperationId,I=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,l.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,l.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,l.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:I.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Se[39],ye([1,0,50,9]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.data=new Map}add(w,P){o.ok(R.isString(w)),o.ok(R.isObject(P)),o.ok(!this.data.has(w),"There is already an extension with this id"),this.data.set(w,P)}knows(w){return this.data.has(w)}as(w){return this.data.get(w)||null}}e.Registry=new l}),define(Se[92],ye([1,0,3,39]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[l(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const w=new A;R.Registry.add(e.Extensions.JSONContribution,w)}),define(Se[127],ye([1,0,16,3,9,169,53,92,39]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=S.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const r=new Set;this.doRegisterConfigurations(n,s,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(n){const s=new Set;this.doDeregisterConfigurations(n,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const r=new Set;this.doDeregisterConfigurations(s,r),this.doRegisterConfigurations(n,!1,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(n){const s=new Set;this.doRegisterDefaultConfigurations(n,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,s){const r=[];for(const{overrides:a,source:c}of n)for(const g in a)if(s.add(g),e.OVERRIDE_PROPERTY_REGEX.test(g)){const i=this.configurationDefaultsOverrides.get(g),t=i?.valuesSources??new Map;if(c)for(const O of Object.keys(a[g]))t.set(O,c);const h={...i?.value||{},...a[g]};this.configurationDefaultsOverrides.set(g,{source:c,value:h,valuesSources:t});const _=(0,w.getLanguageTagSettingPlainKey)(g),E={type:"object",default:h,description:A.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:l.isString(c)?void 0:c,defaultValueSource:c};r.push(...f(g)),this.configurationProperties[g]=E,this.defaultLanguageConfigurationOverridesNode.properties[g]=E}else{this.configurationDefaultsOverrides.set(g,{value:a[g],source:c});const i=this.configurationProperties[g];i&&(this.updatePropertyDefaultValue(g,i),this.updateSchema(g,i))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(n){const s=new Set;this.doDeregisterDefaultConfigurations(n,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,s){for(const{overrides:r,source:a}of n)for(const c in r){const g=this.configurationDefaultsOverrides.get(c),i=l.isString(a)?a:a?.id,t=l.isString(g?.source)?g?.source:g?.source?.id;if(i===t)if(s.add(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const h=this.configurationProperties[c];h&&(this.updatePropertyDefaultValue(c,h),this.updateSchema(c,h))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let s=!1;const r=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,r),s=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,r),s=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,r),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s,r){n.forEach(a=>{this.validateAndRegisterProperties(a,s,a.extensionInfo,a.restrictedProperties,void 0,r),this.configurationContributors.push(a),this.registerJSONConfiguration(a)})}doDeregisterConfigurations(n,s){const r=a=>{if(a.properties)for(const c in a.properties){s.add(c);const g=this.configurationProperties[c];g?.policy?.name&&this.policyConfigurations.delete(g.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,a.properties[c])}a.allOf?.forEach(c=>r(c))};for(const a of n){r(a);const c=this.configurationContributors.indexOf(a);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(n,s=!0,r,a,c=3,g){c=l.isUndefinedOrNull(n.scope)?c:n.scope;const i=n.properties;if(i)for(const h in i){const _=i[h];if(s&&v(h,_)){delete i[h];continue}if(_.source=r,_.defaultDefaultValue=i[h].default,this.updatePropertyDefaultValue(h,_),e.OVERRIDE_PROPERTY_REGEX.test(h)?_.scope=void 0:(_.scope=l.isUndefinedOrNull(_.scope)?c:_.scope,_.restricted=l.isUndefinedOrNull(_.restricted)?!!a?.includes(h):_.restricted),i[h].hasOwnProperty("included")&&!i[h].included){this.excludedConfigurationProperties[h]=i[h],delete i[h];continue}else this.configurationProperties[h]=i[h],i[h].policy?.name&&this.policyConfigurations.set(i[h].policy.name,h);!i[h].deprecationMessage&&i[h].markdownDeprecationMessage&&(i[h].deprecationMessage=i[h].markdownDeprecationMessage),g.add(h)}const t=n.allOf;if(t)for(const h of t)this.validateAndRegisterProperties(h,s,r,a,c,g)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=r=>{const a=r.properties;if(a)for(const g in a)this.updateSchema(g,a[g]);r.allOf?.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}registerOverridePropertyPatternKey(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const r=this.configurationDefaultsOverrides.get(n);let a=r?.value,c=r?.source;l.isUndefined(a)&&(a=s.defaultDefaultValue,c=void 0),l.isUndefined(a)&&(a=u(s.type)),s.default=a,s.defaultValueSource=c}}const I="\\[([^\\]]+)\\]",y=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(p){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let s=y.exec(p);for(;s?.length;){const r=s[1].trim();r&&n.push(r),s=y.exec(p)}}return(0,o.distinct)(n)}e.overrideIdentifiersFromKey=f;function d(p){return p.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function u(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new b;S.Registry.add(e.Extensions.Configuration,m);function v(p,n){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?A.localize(7,null,p):m.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,p,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=v;function D(){const p=[],n=m.getConfigurationProperties();for(const s of Object.keys(n))p.push([s,n[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=D}),define(Se[211],ye([1,0,16,3,146,6,28,23,9,2,53,127,39]),function(re,e,o,R,l,A,w,P,S,C,L,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function I(s){return Object.isFrozen(s)?s:P.deepFreeze(s)}class y{constructor(r={},a=[],c=[],g){this._contents=r,this._keys=a,this._overrides=c,this.raw=g,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof y)return a;const c=new f("");return c.parseRaw(a),c.configurationModel});this._rawConfiguration=r.reduce((a,c)=>c===a?c:a.merge(c),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const c=this.rawConfiguration.getValue(r),g=a?this.rawConfiguration.getOverrideValue(r,a):void 0,i=a?this.rawConfiguration.override(a).getValue(r):c;return{value:c,override:g,merged:i}}getOverrideValue(r,a){const c=this.getContentsForOverrideIdentifer(a);return c?r?(0,L.getConfigurationValue)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const c of this.overrides)c.identifiers.includes(r)&&a.push(...c.keys);return o.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return o.distinct(r)}override(r){let a=this.overrideConfigurations.get(r);return a||(a=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,a)),a}merge(...r){const a=P.deepClone(this.contents),c=P.deepClone(this.overrides),g=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const t of r)if(i.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.mergeContents(a,t.contents);for(const h of t.overrides){const[_]=c.filter(E=>o.equals(E.identifiers,h.identifiers));_?(this.mergeContents(_.contents,h.contents),_.keys.push(...h.keys),_.keys=o.distinct(_.keys)):c.push(P.deepClone(h))}for(const h of t.keys)g.indexOf(h)===-1&&g.push(h)}return new y(a,g,c,i.every(t=>t instanceof y)?void 0:i)}createOverrideConfigurationModel(r){const a=this.getContentsForOverrideIdentifer(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const c={};for(const g of o.distinct([...Object.keys(this.contents),...Object.keys(a)])){let i=this.contents[g];const t=a[g];t&&(typeof i=="object"&&typeof t=="object"?(i=P.deepClone(i),this.mergeContents(i,t)):i=t),c[g]=i}return new y(c,this.keys,this.overrides)}mergeContents(r,a){for(const c of Object.keys(a)){if(c in r&&S.isObject(r[c])&&S.isObject(a[c])){this.mergeContents(r[c],a[c]);continue}r[c]=P.deepClone(a[c])}}getContentsForOverrideIdentifer(r){let a=null,c=null;const g=i=>{i&&(c?this.mergeContents(c,i):c=P.deepClone(i))};for(const i of this.overrides)o.equals(i.identifiers,[r])?a=i.contents:i.identifiers.includes(r)&&g(i.contents);return g(a),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.updateValue(r,a,!0)}setValue(r,a){this.updateValue(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,L.removeFromValueTree)(this.contents,r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(c=>o.equals(c.identifiers,(0,k.overrideIdentifiersFromKey)(r))),1))}updateValue(r,a,c){(0,L.addToValueTree)(this.contents,r,a,g=>console.error(g)),c=c||this.keys.indexOf(r)===-1,c&&this.keys.push(r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,L.toValuesTree)(this.contents[r],g=>console.error(g))})}}e.ConfigurationModel=y;class f{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,a){if(!S.isUndefinedOrNull(r)){const c=this.doParseContent(r);this.parseRaw(c,a)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,a){this._raw=r;const{contents:c,keys:g,overrides:i,restricted:t,hasExcludedProperties:h}=this.doParseRaw(r,a);this._configurationModel=new y(c,g,i,h?[r]:void 0),this._restrictedConfigurations=t||[]}doParseContent(r){let a={},c=null,g=[];const i=[],t=[];function h(E){Array.isArray(g)?g.push(E):c!==null&&(g[c]=E)}const _={onObjectBegin:()=>{const E={};h(E),i.push(g),g=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{g=i.pop()},onArrayBegin:()=>{const E=[];h(E),i.push(g),g=E,c=null},onArrayEnd:()=>{g=i.pop()},onLiteralValue:h,onError:(E,O,$)=>{t.push({error:E,offset:O,length:$})}};if(r)try{l.visit(r,_),a=g[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return a}doParseRaw(r,a){const c=b.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),g=this.filter(r,c,!0,a);r=g.raw;const i=(0,L.toValuesTree)(r,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),t=Object.keys(r),h=this.toOverrides(r,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:i,keys:t,overrides:h,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}filter(r,a,c,g){let i=!1;if(!g?.scopes&&!g?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:i};const t={},h=[];for(const _ in r)if(k.OVERRIDE_PROPERTY_REGEX.test(_)&&c){const E=this.filter(r[_],a,!1,g);t[_]=E.raw,i=i||E.hasExcludedProperties,h.push(...E.restricted)}else{const E=a[_],O=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&h.push(_),(O===void 0||g.scopes===void 0||g.scopes.includes(O))&&!(g.skipRestricted&&E?.restricted)?t[_]=r[_]:i=!0}return{raw:t,restricted:h,hasExcludedProperties:i}}toOverrides(r,a){const c=[];for(const g of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(g)){const i={};for(const t in r[g])i[t]=r[g][t];c.push({identifiers:(0,k.overrideIdentifiersFromKey)(g),keys:Object.keys(i),contents:(0,L.toValuesTree)(i,a)})}return c}}e.ConfigurationModelParser=f;class d extends A.Disposable{constructor(r,a,c,g){super(),this.userSettingsResource=r,this.scopes=a,this.fileService=g,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,i=>i.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&c.isEqual(i.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class u{constructor(r,a,c,g,i,t,h,_,E,O,$,H,X){this.key=r,this.overrides=a,this._value=c,this.overrideIdentifiers=g,this.defaultConfiguration=i,this.policyConfiguration=t,this.applicationConfiguration=h,this.userConfiguration=_,this.localUserConfiguration=E,this.remoteUserConfiguration=O,this.workspaceConfiguration=$,this.folderConfigurationModel=H,this.memoryConfigurationModel=X}get value(){return I(this._value)}inspect(r,a,c){const g=r.inspect(a,c);return{get value(){return I(g.value)},get override(){return I(g.override)},get merged(){return I(g.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class m{constructor(r,a,c,g,i=new y,t=new y,h=new w.ResourceMap,_=new y,E=new w.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=a,this._applicationConfiguration=c,this._localUserConfiguration=g,this._remoteUserConfiguration=i,this._workspaceConfiguration=t,this._folderConfigurations=h,this._memoryConfiguration=_,this._memoryConfigurationByResource=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new w.ResourceMap,this._userConfiguration=null}getValue(r,a,c){return this.getConsolidatedConfigurationModel(r,a,c).getValue(r)}updateValue(r,a,c={}){let g;c.resource?(g=this._memoryConfigurationByResource.get(c.resource),g||(g=new y,this._memoryConfigurationByResource.set(c.resource,g))):g=this._memoryConfiguration,a===void 0?g.removeValue(r):g.setValue(r,a),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,a,c){const g=this.getConsolidatedConfigurationModel(r,a,c),i=this.getFolderConfigurationModelForResource(a.resource,c),t=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,h=new Set;for(const _ of g.overrides)for(const E of _.identifiers)g.getOverrideValue(r,E)!==void 0&&h.add(E);return new u(r,a,g.getValue(r),h.size?[...h]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this._workspaceConfiguration:void 0,i||void 0,t)}keys(r){const a=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,a){this._folderConfigurations.set(r,a),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const c=[];if(!a){const{added:g,updated:i,removed:t}=p(this._defaultConfiguration,r);a=[...g,...i,...t]}for(const g of a)for(const i of(0,k.overrideIdentifiersFromKey)(g)){const t=this._defaultConfiguration.getKeysForOverrideIdentifier(i),h=r.getKeysForOverrideIdentifier(i),_=[...h.filter(E=>t.indexOf(E)===-1),...t.filter(E=>h.indexOf(E)===-1),...t.filter(E=>!P.equals(this._defaultConfiguration.override(i).getValue(E),r.override(i).getValue(E)))];c.push([i,_])}return this.updateDefaultConfiguration(r),{keys:a,overrides:c}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:c,removed:g}=p(this._policyConfiguration,r),i=[...a,...c,...g];return i.length&&this.updatePolicyConfiguration(r),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.applicationConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateApplicationConfiguration(r),{keys:t,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.localUserConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateLocalUserConfiguration(r),{keys:t,overrides:i}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.remoteUserConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateRemoteUserConfiguration(r),{keys:t,overrides:i}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.workspaceConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateWorkspaceConfiguration(r),{keys:t,overrides:i}}compareAndUpdateFolderConfiguration(r,a){const c=this.folderConfigurations.get(r),{added:g,updated:i,removed:t,overrides:h}=p(c,a),_=[...g,...i,...t];return(_.length||!c)&&this.updateFolderConfiguration(r,a),{keys:_,overrides:h}}compareAndDeleteFolderConfiguration(r){const a=this.folderConfigurations.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:g,removed:i,overrides:t}=p(a,void 0);return{keys:[...c,...g,...i],overrides:t}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,a,c){let g=this.getConsolidatedConfigurationModelForResource(a,c);return a.overrideIdentifier&&(g=g.override(a.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(g=g.merge(this._policyConfiguration)),g}getConsolidatedConfigurationModelForResource({resource:r},a){let c=this.getWorkspaceConsolidatedConfiguration();if(a&&r){const g=a.getFolder(r);g&&(c=this.getFolderConsolidatedConfiguration(g.uri)||c);const i=this._memoryConfigurationByResource.get(r);i&&(c=c.merge(i))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let a=this._foldersConsolidatedConfigurations.get(r);if(!a){const c=this.getWorkspaceConsolidatedConfiguration(),g=this._folderConfigurations.get(r);g?(a=c.merge(g),this._foldersConsolidatedConfigurations.set(r,a)):a=c}return a}getFolderConfigurationModelForResource(r,a){if(a&&r){const c=a.getFolder(r);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,a)=>{const{contents:c,overrides:g,keys:i}=this._folderConfigurations.get(a);return r.push([a,{contents:c,overrides:g,keys:i}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this._workspaceConfiguration.keys.forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.keys.forEach(c=>r.add(c))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(g=>a.add(g))),[...a.values()]}static parse(r){const a=this.parseConfigurationModel(r.defaults),c=this.parseConfigurationModel(r.policy),g=this.parseConfigurationModel(r.application),i=this.parseConfigurationModel(r.user),t=this.parseConfigurationModel(r.workspace),h=r.folders.reduce((_,E)=>(_.set(C.URI.revive(E[0]),this.parseConfigurationModel(E[1])),_),new w.ResourceMap);return new m(a,c,g,i,new y,t,h,new y,new w.ResourceMap)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides)}}e.Configuration=m;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const g of s)g.keys.forEach(i=>r.add(i)),g.overrides.forEach(([i,t])=>{const h=(0,w.getOrSet)(a,i,new Set);t.forEach(_=>h.add(_))});const c=[];return a.forEach((g,i)=>c.push([i,[...g.values()]])),{keys:[...r.values()],overrides:c}}e.mergeChanges=v;class D{constructor(r,a,c,g){this.change=r,this.previous=a,this.currentConfiguraiton=c,this.currentWorkspace=g,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const i of r.keys)this.affectedKeys.add(i);for(const[,i]of r.overrides)for(const t of i)this.affectedKeys.add(t);this._affectsConfigStr=this._marker;for(const i of this.affectedKeys)this._affectsConfigStr+=i+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,a){const c=this._marker+r,g=this._affectsConfigStr.indexOf(c);if(g<0)return!1;const i=g+c.length;if(i>=this._affectsConfigStr.length)return!1;const t=this._affectsConfigStr.charCodeAt(i);if(t!==this._markerCode1&&t!==this._markerCode2)return!1;if(a){const h=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.previous?.workspace):void 0,_=this.currentConfiguraiton.getValue(r,a,this.currentWorkspace);return!P.equals(h,_)}return!0}}e.ConfigurationChangeEvent=D;function p(s,r){const{added:a,removed:c,updated:g}=n(r?.rawConfiguration,s?.rawConfiguration),i=[],t=s?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const _=h.filter(E=>!t.includes(E));for(const E of _)i.push([E,r.getKeysForOverrideIdentifier(E)])}if(s){const _=t.filter(E=>!h.includes(E));for(const E of _)i.push([E,s.getKeysForOverrideIdentifier(E)])}if(r&&s){for(const _ of t)if(h.includes(_)){const E=n({contents:s.getOverrideValue(void 0,_)||{},keys:s.getKeysForOverrideIdentifier(_)},{contents:r.getOverrideValue(void 0,_)||{},keys:r.getKeysForOverrideIdentifier(_)});i.push([_,[...E.added,...E.removed,...E.updated]])}}return{added:a,removed:c,updated:g,overrides:i}}function n(s,r){const a=s?r?s.keys.filter(i=>r.keys.indexOf(i)===-1):[...s.keys]:[],c=r?s?r.keys.filter(i=>s.keys.indexOf(i)===-1):[...r.keys]:[],g=[];if(s&&r){for(const i of r.keys)if(s.keys.indexOf(i)!==-1){const t=(0,L.getConfigurationValue)(r.contents,i),h=(0,L.getConfigurationValue)(s.contents,i);P.equals(t,h)||g.push(i)}}return{added:a,removed:c,updated:g}}}),define(Se[128],ye([1,0,10,4]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends o.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof A&&S._code===l.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof A&&S._code===l.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof A&&S._code===l.NoResolverFound}static isHandled(S){return S instanceof A&&S.isHandled}constructor(S,C=l.Unknown,L){super(S),this._message=S,this._code=C,this._detail=L,this.isHandled=C===l.NotAvailable&&L===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function w(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.getRemoteAuthorityPrefix=w}),define(Se[73],ye([1,0,15]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(C){return C.scheme===o.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=R;function l(C){if(!C)return;const L=C.indexOf("+");return L<0?C:C.substr(0,L)}e.getRemoteName=l;function A(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=A;function w(C){const{host:L,port:k}=S(C);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:k}}e.parseAuthorityWithPort=w;function P(C,L){let{host:k,port:b}=S(C);return typeof b>"u"&&(b=L),{host:k,port:b}}e.parseAuthorityWithOptionalPort=P;function S(C){const L=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const k=C.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const b=C.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:C,port:void 0}}}),define(Se[27],ye([1,0,8,4,73]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(w=e.ExtensionType||(e.ExtensionType={}));var P;(function(I){I.WIN32_X64="win32-x64",I.WIN32_IA32="win32-ia32",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const d=typeof y=="string"?y:y.value,u=typeof f=="string"?f:f.value;return o.equalsIgnoreCase(d,u)}return y._lower===f._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=S;function C(I){return L(I)}e.isApplicationScopedExtension=C;function L(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function k(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=k;function b(I,y){if(y){const f=`onResolveRemoteAuthority:${(0,l.getRemoteName)(y)}`;return!!I.activationEvents?.includes(f)}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[212],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.validators=new Map}vsda(){return new Promise((l,A)=>re(["vsda"],l,A))}async createNewMessage(l){try{const A=await this.vsda(),w=new A.validator;if(w){const P=String(o._nextId++);return this.validators.set(P,w),{id:P,data:w.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,A){if(!l.id)return!0;const w=this.validators.get(l.id);if(!w)return!1;this.validators.delete(l.id);try{return w.validate(A)==="ok"}catch{return!1}}async sign(l){try{const A=await this.vsda(),w=new A.signer;if(w)return w.sign(l)}catch{}return l}}o._nextId=1,e.SignService=o}),define(Se[213],ye([1,0,11,33,2,30]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function w(C){if(o.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function P(C,L,k,b,I,y,f,d,u,m){const v=Object.create(null);v["common.machineId"]=f,v.sessionID=(0,A.generateUuid)()+Date.now(),v.commitHash=I,v.version=y,v["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,o.PlatformToString)(o.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=b,v["common.product"]=m||"desktop",d&&(v["common.msftInternal"]=d);let D=0;const p=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),o.isLinuxSnap&&(v["common.snap"]="true");const n=w(k);n&&(v["common.platformDetail"]=n);try{const s=await C.readFile(l.URI.file(u));v["common.source"]=s.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=P;function S(C){const L=R.env.USERDNSDOMAIN;if(!L)return!1;const k=L.toLowerCase();return C.some(b=>k===b)}e.verifyMicrosoftInternalDomain=S}),define(Se[214],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Se[74],ye([1,0,23,9,3,53,73,213,214]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class C{constructor(c){this.value=c}}e.TelemetryTrustedValue=C;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,g){return Promise.resolve(void 0)}publicLog2(c,g){return this.publicLog(c,g)}publicLogError(c,g){return Promise.resolve(void 0)}publicLogError2(c,g){return this.publicLogError(c,g)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class k{async publicLog(c,g,i){}async publicLogError(c,g,i){}}e.NullEndpointTelemetryService=k,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(a,c){return l.Event.debounce(c.onDidChangeConfiguration,(i,t)=>{const h=i?new Set([...i.affectedKeys,...t.affectedKeys]):t.affectedKeys;return{...t,affectedKeys:h}},1e3,!0)(i=>{i.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(i.source),configurationKeys:Array.from(i.affectedKeys)})})}e.configurationTelemetry=b;function I(a,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!a.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=I;function y(a,c){return!(c.isBuilt||c.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=y;function f(a){const c=a.getValue(S.TELEMETRY_SETTING_ID),g=a.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||g===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function d(a){const c={},g={},i={};v(a,i);for(let t in i){t=t.length>150?t.substr(t.length-149):t;const h=i[t];typeof h=="number"?g[t]=h:typeof h=="boolean"?g[t]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${h.length}`),c[t]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(c[t]=h)}return{properties:c,measurements:g}}e.validateTelemetryData=d;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(a){if(!a)return"none";const c=(0,w.getRemoteName)(a);return u.has(c)?c:"other"}e.cleanRemoteAuthority=m;function v(a,c,g=0,i){if(!!a)for(const t of Object.getOwnPropertyNames(a)){const h=a[t],_=i?i+t:t;Array.isArray(h)?c[_]=(0,o.safeStringify)(h):h instanceof Date?c[_]=h.toISOString():(0,R.isObject)(h)?g<2?v(h,c,g+1,_+"."):c[_]=(0,o.safeStringify)(h):c[_]=h}}function D(a,c){const g=a.msftInternalDomains||[],i=c.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(g)||i}e.isInternalTelemetry=D;function p(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=p;function n(a,c){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let g=a;const i=[];for(const E of c)for(;;){const O=E.exec(a);if(!O)break;i.push([O.index,E.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let _=0;for(g="";;){const E=h.exec(a);if(!E)break;const O=i.some(([$,H])=>E.index<H&&$<h.lastIndex);!t.test(E[0])&&!O&&(g+=a.substring(_,E.index)+"<REDACTED: user-file-path>",_=h.lastIndex)}return _<a.length&&(g+=a.substr(_)),g}function s(a){if(!a)return a;const c=a.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of g)if(i.regex.test(c))return`<REDACTED: ${i.label}>`;return a}function r(a,c){return(0,o.cloneAndChange)(a,g=>{if(g instanceof C)return g.value;if(typeof g=="string"){let i=g.replaceAll("%20"," ");i=n(i,c);for(const t of c)i=i.replace(t,"");return i=s(i),i}})}e.cleanData=r}),define(Se[215],ye([1,0,8,123,27,11,2,10,33,74]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,o.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=L;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(a){const c=a.manifest?a.manifest.version:a.version,g=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new b(a.identifier,c,g)}static parse(a){const c=k.exec(a);return c&&c[1]&&c[2]?new b({id:c[1]},c[2],c[4]||void 0):null}constructor(a,c,g="undefined"){this.version=c,this.targetPlatform=g,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof b?L(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=b;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const a=I.exec(r);return a&&a[1]?[d(a[1]),a[2]]:[d(r),void 0]}e.getIdAndVersion=y;function f(r,a){return`${r}.${a}`}e.getExtensionId=f;function d(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function u(r,a){return d(f(r,a))}e.getGalleryExtensionId=u;function m(r,a){const c=[],g=i=>{for(const t of c)if(t.some(h=>L(a(h),a(i))))return t;return null};for(const i of r){const t=g(i);t?t.push(i):c.push([i])}return c}e.groupByExtension=m;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function D(r){return{id:new C.TelemetryTrustedValue(r.identifier.id),name:new C.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(r,a){const c=[],g=a.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const i=g.shift();if(i&&c.every(t=>!L(t.identifier,{id:i}))){const t=r.filter(h=>L(h.identifier,{id:i}));t.length===1&&(c.push(t[0]),g.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=p;async function n(r,a){if(!A.isLinux)return!1;let c;try{c=(await r.readFile(w.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await r.readFile(w.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){a.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(i))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,a){const c=await n(r,a),g=(0,R.getTargetPlatform)(c?"alpine":A.platform,S.arch);return a.debug("ComputeTargetPlatform:",g),g}e.computeTargetPlatform=s}),define(Se[216],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=o;function R(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=R;function l(w){return Array.from(w.entries()).map(P=>[P[0],o(P[1].map)])}e.serializeEnvironmentVariableCollections=l;function A(w){return new Map(w.map(P=>[P[0],{map:R(P[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Se[217],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(l){this._callback=l,this._terminalBufferMap=new Map}dispose(){for(const l of this._terminalBufferMap.values())l.dispose()}startBuffering(l,A,w=5){const P=A(S=>{const C=typeof S=="string"?S:S.data;let L=this._terminalBufferMap.get(l);if(L){L.data.push(C);return}const k=setTimeout(()=>this.flushBuffer(l),w);L={data:[C],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(l),P.dispose()}},this._terminalBufferMap.set(l,L)});return P}stopBuffering(l){this._terminalBufferMap.get(l)?.dispose()}flushBuffer(l){const A=this._terminalBufferMap.get(l);A&&(this._terminalBufferMap.delete(l),this._callback(l,A.data.join("")))}}e.TerminalDataBufferer=o}),define(Se[218],ye([1,0,19,67,51,3,9,2,175,92,39]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(D){function p(n,s){let r=n.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const a=y.getIcon(r.id);if(!a)return;r=a.defaults}return r}D.getDefinition=p})(k=e.IconContribution||(e.IconContribution={}));var b;(function(D){function p(s){return{weight:s.weight,style:s.style,src:s.src.map(r=>({format:r.format,location:r.location.toString()}))}}D.toJSONObject=p;function n(s){const r=a=>(0,w.isString)(a)?a:void 0;if(s&&Array.isArray(s.src)&&s.src.every(a=>(0,w.isString)(a.format)&&(0,w.isString)(a.location)))return{weight:r(s.weight),style:r(s.style),src:s.src.map(a=>({format:a.format,location:P.URI.parse(a.location)}))}}D.fromJSONObject=n})(b=e.IconFontDefinition||(e.IconFontDefinition={}));class I{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,n,s,r){const a=this.iconsById[p];if(a){if(s&&!a.description){a.description=s,this.iconSchema.properties[p].markdownDescription=`${s} $(${p})`;const i=this.iconReferenceSchema.enum.indexOf(p);i!==-1&&(this.iconReferenceSchema.enumDescriptions[i]=s),this._onDidChange.fire()}return a}const c={id:p,description:s,defaults:n,deprecationMessage:r};this.iconsById[p]=c;const g={$ref:"#/definitions/icons"};return r&&(g.deprecationMessage=r),s&&(g.markdownDescription=`${s}: $(${p})`),this.iconSchema.properties[p]=g,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const n=this.iconReferenceSchema.enum.indexOf(p);n!==-1&&(this.iconReferenceSchema.enum.splice(n,1),this.iconReferenceSchema.enumDescriptions.splice(n,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,n){const s=this.iconFontsById[p];return s||(this.iconFontsById[p]=n,this._onDidChange.fire(),n)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(a,c)=>a.id.localeCompare(c.id),n=a=>{for(;l.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of r.filter(c=>!!c.description).sort(p))s.push(`|<i class="${n(a)}"></i>|${a.id}|${l.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const a of r.filter(c=>!l.ThemeIcon.isThemeIcon(c.defaults)).sort(p))s.push(`|<i class="${n(a)}"></i>|${a.id}|`);return s.join(`
`)}}const y=new I;L.Registry.add(e.Extensions.IconContribution,y);function f(D,p,n,s){return y.registerIcon(D,p,n,s)}e.registerIcon=f;function d(){return y}e.getIconRegistry=d;function u(){const D=(0,R.getCodiconFontCharacters)();for(const p in D){const n="\\"+D[p].toString(16);y.registerIcon(p,{fontCharacter:n})}}u(),e.iconsSchemaId="vscode://schemas/icons";const m=L.Registry.as(C.Extensions.JSONContribution);m.registerSchema(e.iconsSchemaId,y.getIconSchema());const v=new o.RunOnceScheduler(()=>m.notifySchemaChanged(e.iconsSchemaId),200);y.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=f("widget-close",R.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",R.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",R.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=l.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(Se[129],ye([1,0,3,53,4,13]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var w;(function(f){f.Http="http",f.Https="https"})(w=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=k;function b(f,d,u,m){if(u===1)return!1;if(u===2&&k(d)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(v?.length===4&&parseInt(v[1])>=18)return!1}return f<1024}e.isPortPrivileged=b;class I{constructor(d,u,m){this.remoteAddress=d,this.localAddress=u,this._dispose=m,this._onDispose=new o.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=I;let y=class{constructor(d,u){this.logService=d,this.configurationService=u,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],u=Array.from(this._tunnels.values());for(const m of u){const v=Array.from(m.values());for(const D of v){const p=await D.value;p&&d.push(p)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:u}of d.values())await u.then(m=>m?.dispose());d.clear()}this._tunnels.clear()}setEnvironmentTunnel(d,u,m,v,D){this.addTunnelToMap(d,u,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:u,localAddress:m,privacy:v,protocol:D,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,u){(k(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const m=this.getTunnelFromMap(d,u);if(m)return++m.refcount,m.value}openTunnel(d,u,m,v,D,p=!1,n,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${D}.`),!d)return;if(u||(u="localhost"),v||(v=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(d,u,m,v,D,p,n,s);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(a);return(a.tunnelRemoteHost!==u||a.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const u=this._tunnels.get(d.tunnelRemoteHost);if(u){const m=u.get(d.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,m))}}}}async tryDisposeTunnel(d,u,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${u}.`);const v=m.value.then(async D=>{D&&(await D.dispose(!0),this._onTunnelClosed.fire({host:D.tunnelRemoteHost,port:D.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(u),v}}async closeTunnel(d,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${u} `);const m=this._tunnels.get(d);if(m&&m.has(u)){const v=m.get(u);v.refcount=0,await this.tryDisposeTunnel(d,u,v)}}addTunnelToMap(d,u,m){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(u,{refcount:1,value:m})}async removeEmptyTunnelFromMap(d,u){const m=this._tunnels.get(d);m&&(await m.get(u)||m.delete(u),m.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,u){const m=[d];L(d)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):k(d)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const v=m.map(D=>this._tunnels.get(D));for(const D of v){const p=D?.get(u);if(p)return p}}canTunnel(d){return!!C(d)}createWithProvider(d,u,m,v,D,p,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${v}.`);const s=m;this._factoryInProgress.add(s);const r=v===void 0?m:v,a={elevationRequired:D?this.isPortPrivileged(r):!1},c={remoteAddress:{host:u,port:m},localAddressPort:v,privacy:p,public:p?p!==P.Private:void 0,protocol:n},g=d.forwardPort(c,a);return g?(this.addTunnelToMap(u,m,g),g.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),g}};y=je([Be(0,A.ILogService),Be(1,R.IConfigurationService)],y),e.AbstractTunnelService=y}),define(Se[219],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var R;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(R=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Se[220],ye([1,0,15]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(S){return S.scheme!==o.Schemas.file&&S.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=R;function l(S){if(S.folders.length)return S.folders.every(C=>R(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&R(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=l;function A(S){return l(S)?.scheme}e.getVirtualWorkspaceScheme=A;function w(S){return l(S)?.authority}e.getVirtualWorkspaceAuthority=w;function P(S){return l(S)!==void 0}e.isVirtualWorkspace=P}),define(Se[47],ye([1,0,176,12,68,24,2,4,15]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function C(r){const a=r;return typeof a?.id=="string"&&w.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=C;function L(r){return typeof r?.id=="string"&&!C(r)&&!b(r)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,R.basename)(r)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=r;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=k;function b(r){const a=r;return typeof a?.id=="string"&&w.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=b;function I(r){const a=r;if(a?.uri)return{id:a.id,uri:w.URI.revive(a.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:w.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=I;var y;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=f;function d(r){const a=r;return!!(a&&typeof a=="object"&&w.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=d;class u{constructor(a,c,g,i,t){this._id=a,this._transient=g,this._configuration=i,this._ignorePathCasing=t,this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=c}update(a){this._id=a.id,this._configuration=a.configuration,this._transient=a.transient,this._ignorePathCasing=a._ignorePathCasing,this.folders=a.folders}get folders(){return this._folders}set folders(a){this._folders=a,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(a){this._configuration=a}getFolder(a){return a&&this._foldersMap.findSubstr(a)||null}updateFoldersMap(){this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const a of this.folders)this._foldersMap.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class m{constructor(a,c){this.raw=c,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function v(r){return new m({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(r,a){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,a.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function p(r){let a;return w.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=p;function n(r,a){return!D(r,a)&&!p(r)}e.isSavedWorkspace=n;function s(r){return(typeof r=="string"?(0,R.extname)(r):(0,A.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Se[75],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(l){this.id=l,this._data=new Map,this._idPool=1}add(l){const A=this._idPool++;return this._data.set(A,l),this.logDebugInfo(),A}get(l,A){return this._data.has(l)?this._data.get(l)[A]:void 0}delete(l){this._data.delete(l),this.logDebugInfo()}logDebugInfo(){!o.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}o.enableDebugLogging=!1,e.Cache=o}),define(Se[48],ye([1,0,15,24,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new R.ExtUri(P=>{const S=this._providerInfo.get(P.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(P,S){S===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,S)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(Se[25],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(Se[221],ye([1,0,13,206,25]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends R.LogService{constructor(P,S){super(P.createLogger(S.logFile,{name:S.logName}))}};A=je([Be(0,o.ILoggerService),Be(1,l.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(Se[222],ye([1,0,19]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(w,P,S){this._deferredPromises=new Map,this._id=w,this._shared=P,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of C.values())L.complete()}catch(L){for(const k of C.values())k.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,w])=>w!==void 0).map(([w])=>w)}get whenReady(){return this._init}get(w,P){let S=this._value[w];return typeof S>"u"&&(S=P),S}update(w,P){this._value[w]=P;const S=this._deferredPromises.get(w);if(S!==void 0)return S.p;const C=new o.DeferredPromise;return this._deferredPromises.set(w,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class l extends R{setKeysForSync(w){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},w)}constructor(w,P){super(w.identifier.value,!0,P),this._extension=w}}e.ExtensionGlobalMemento=l}),define(Se[223],ye([1,0,3,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(w){this._notebooksAndEditors=w,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new o.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(w,P,S,C){const k=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(w)).acceptModelChanged(P.value,S,C);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(w,P){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(w)).acceptDirty(P)}$acceptModelSaved(w){const P=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(w));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(Se[20],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class R{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=R});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[224],ye([1,0,27,3]),function(re,e,o,R){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,S){l.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(P.identifier),Je(this,l,S,"f"),Ne(this,l,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(P){return Ne(this,l,"f").get(this._id,P)}store(P,S){return Ne(this,l,"f").store(this._id,P,S)}delete(P){return Ne(this,l,"f").delete(this._id,P)}}e.ExtensionSecrets=A,l=new WeakMap}),define(Se[55],ye([1,0,4,129,3,20]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var w;(function(S){function C(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?R.TunnelPrivacyId.Public:R.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=C;function L(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==R.TunnelPrivacyId.ConstantPrivate&&k.privacy!==R.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=L})(w=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let P=class{constructor(C){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,L){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,L){return{dispose:()=>{}}}async $providePortAttributes(C,L,k,b,I){return[]}async $forwardPort(C,L){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=je([Be(0,A.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(Se[56],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class R{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=w=>w,this.transformOutgoing=w=>w,this.transformOutgoingURI=w=>w,this.transformOutgoingScheme=w=>w)}}e.URITransformerService=R}),define(Se[225],ye([1,0,22]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function l(P,S){if(S.serializeBuffersForPostMessage){const C=new R,L=(I,y)=>{if(y instanceof ArrayBuffer){const f=C.add(y);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(y)){const f=A(y);if(f){const d=C.add(y.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:f,byteLength:y.byteLength,byteOffset:y.byteOffset}}}}return y},k=JSON.stringify(P,L),b=C.buffers.map(I=>{const y=new Uint8Array(I);return o.VSBuffer.wrap(y)});return{message:k,buffers:b}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=l;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function w(P,S){const C=S.map(b=>{const I=new ArrayBuffer(b.byteLength);return new Uint8Array(I).set(b.buffer),I}),L=S.length?(b,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const y=I,{index:f}=y,d=C[f];if(y.view)switch(y.view.type){case 1:return new Int8Array(d,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return I}:void 0;return{message:JSON.parse(P,L),arrayBuffers:C}}e.deserializeWebviewMessage=w}),define(Se[226],ye([1,0,114]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function R(A){return{transformIncoming:w=>w.scheme==="vscode-remote"?{scheme:"file",path:w.path,query:w.query,fragment:w.fragment}:w.scheme==="file"?{scheme:"vscode-local",path:w.path,query:w.query,fragment:w.fragment}:w,transformOutgoing:w=>w.scheme==="file"?{scheme:"vscode-remote",authority:A,path:w.path,query:w.query,fragment:w.fragment}:w.scheme==="vscode-local"?{scheme:"file",path:w.path,query:w.query,fragment:w.fragment}:w,transformOutgoingScheme:w=>w==="file"?"vscode-remote":w==="vscode-local"?"file":w}}function l(A){return new o.URITransformer(R(A))}e.createURITransformer=l}),define(Se[130],ye([1,0,187,9,2,6,4,39,44,15,45,161,37]),function(re,e,o,R,l,A,w,P,S,C,L,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var y;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(y=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(K){const Y=K;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.isEditorPaneWithSelection=f;function d(K,Y,ee){for(const me of ee.visibleEditorPanes)if(me.group.id===Y&&K.matches(me.input))return me.getViewState()}e.findViewStateForEditor=d;function u(K){if(t(K))return!1;const Y=K;return l.URI.isUri(Y?.resource)}e.isResourceEditorInput=u;function m(K){if(t(K))return!1;const Y=K;return Y?.original!==void 0&&Y.modified!==void 0}e.isResourceDiffEditorInput=m;function v(K){if(t(K)||m(K))return!1;const Y=K;return Y?.primary!==void 0&&Y.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function D(K){if(t(K))return!1;const Y=K;return Y?Y.resource===void 0||Y.resource.scheme===C.Schemas.untitled||Y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;const p=/Untitled-\d+/;function n(K){return K.scheme===C.Schemas.untitled&&K.path.length>1&&!p.test(K.path)}e.isUntitledWithAssociatedResource=n;function s(K){if(t(K))return!1;const Y=K;return l.URI.isUri(Y?.base?.resource)&&l.URI.isUri(Y?.input1?.resource)&&l.URI.isUri(Y?.input2?.resource)&&l.URI.isUri(Y?.result?.resource)}e.isResourceMergeEditorInput=s;var r;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var a;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(Y,ee){let me=this.mapIdToSaveSource.get(Y);return me||(me={source:Y,label:ee},this.mapIdToSaveSource.set(Y,me)),me.source}getSourceLabel(Y){return this.mapIdToSaveSource.get(Y)?.label??Y}}e.SaveSourceRegistry=new c;var g;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(g=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends A.Disposable{}e.AbstractEditorInput=i;function t(K){return K instanceof i}e.isEditorInput=t;function h(K){const Y=K;return l.URI.isUri(Y?.preferredResource)}function _(K){const Y=K;return t(Y?.primary)&&t(Y?.secondary)}e.isSideBySideEditorInput=_;function E(K){const Y=K;return t(Y?.modified)&&t(Y?.original)}e.isDiffEditorInput=E;function O(K,Y,ee,me,be){return ge(me,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const De={...ee,limits:{size:Number.MAX_VALUE}};K.openEditor(Y,De)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.createTooLargeFileError=O;function $(K){return t(K?.editor)}e.isEditorInputWithOptions=$;function H(K){const Y=K;return $(K)&&Y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=H;function X(K){const Y=K;return typeof Y?.groupId=="number"&&t(Y.editor)}e.isEditorIdentifier=X;var V;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(V=e.EditorCloseContext||(e.EditorCloseContext={}));var N;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(N=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var T;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(T=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(Y,ee){if(!Y)return;if(s(Y))return e.EditorResourceAccessor.getOriginalUri(Y.result,ee);if(ee?.supportSideBySide){const{primary:be,secondary:De}=this.getSideEditors(Y);if(be&&De){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getOriginalUri(be,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(De,{filterByScheme:ee.filterByScheme});Y=ee.supportSideBySide===T.PRIMARY?be:De}}if(m(Y)||v(Y)||s(Y))return;const me=h(Y)?Y.preferredResource:Y.resource;return!me||!ee||!ee.filterByScheme?me:this.filterUri(me,ee.filterByScheme)}getSideEditors(Y){return _(Y)||v(Y)?{primary:Y.primary,secondary:Y.secondary}:E(Y)||m(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,ee){if(!Y)return;if(s(Y))return e.EditorResourceAccessor.getCanonicalUri(Y.result,ee);if(ee?.supportSideBySide){const{primary:be,secondary:De}=this.getSideEditors(Y);if(be&&De){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getCanonicalUri(be,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:ee.filterByScheme});Y=ee.supportSideBySide===T.PRIMARY?be:De}}if(m(Y)||v(Y)||s(Y))return;const me=Y.resource;return!me||!ee||!ee.filterByScheme?me:this.filterUri(me,ee.filterByScheme)}filterUri(Y,ee){if(Array.isArray(ee)){if(ee.some(me=>Y.scheme===me))return Y}else if(ee===Y.scheme)return Y}}e.EditorResourceAccessor=new F;var U;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(U=e.CloseDirection||(e.CloseDirection={}));class Z{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Y){const ee=this.instantiationService=Y.get(w.IInstantiationService);for(const[me,be]of this.editorSerializerConstructors)this.createEditorSerializer(me,be,ee);this.editorSerializerConstructors.clear()}createEditorSerializer(Y,ee,me){const be=me.createInstance(ee);this.editorSerializerInstances.set(Y,be)}registerFileEditorFactory(Y){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Y}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Y,ee){if(this.editorSerializerConstructors.has(Y)||this.editorSerializerInstances.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Y,ee,this.instantiationService):this.editorSerializerConstructors.set(Y,ee),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(Y),this.editorSerializerInstances.delete(Y)})}getEditorSerializer(Y){return this.editorSerializerInstances.get(typeof Y=="string"?Y:Y.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function J(K,Y,ee){return!K||!K.length?[]:await Promise.all(K.map(async me=>{const be=l.URI.revive(me.fileUri);if(!be){ee.info("Cannot resolve the path because it is not valid.",me);return}if(!await Y.canHandleResource(be)){ee.info("Cannot resolve the path because it cannot be handled",me);return}let Ae=me.exists,ae=me.type;if(typeof Ae!="boolean"||typeof ae!="number")try{ae=(await Y.stat(be)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Ae=!0}catch(ue){ee.error(ue),Ae=!1}if(!Ae&&me.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",me);return}if(ae===S.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",me);return}const le={...me.options,pinned:!0};return Ae?{resource:be,options:le}:{resource:be,options:le,forceUntitled:!0}}))}e.pathsToEditors=J;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function Q(K){const Y=K;if(!Y)return!1;const ee=Y;if(ee.modified)return Q(ee.modified);const me=Y;return!!(me.contributionsState&&me.viewState&&Array.isArray(me.cursorState))}e.isTextEditorViewState=Q;function ie(K){return(0,L.isErrorWithActions)(K)}e.isEditorOpenError=ie;function ge(K,Y,ee){const me=(0,L.createErrorWithActions)(K,Y);return me.forceMessage=ee?.forceMessage,me.forceSeverity=ee?.forceSeverity,me.allowDialog=ee?.allowDialog,me}e.createEditorOpenError=ge}),define(Se[227],ye([1,0,3,188,4,6,28,39,16,61,23,67,218]),function(re,e,o,R,l,A,w,P,S,C,L,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,b.registerIcon)("default-view-icon",k.Codicon.window,(0,R.localize)(0,null));var I;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(I=e.Extensions||(e.Extensions={}));var y;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(y=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class d extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new o.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new o.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,S.flatten)([...this.viewContainers.values()])}registerViewContainer(a,c,g){const i=this.get(a.id);if(i)return i;const t=a;return t.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,w.getOrSet)(this.viewContainers,c,[]).push(t),g?.isDefault&&this.defaultViewContainers.push(t),this._onDidRegister.fire({viewContainer:t,viewContainerLocation:c}),t}deregisterViewContainer(a){for(const c of this.viewContainers.keys()){const g=this.viewContainers.get(c),i=g?.indexOf(a);if(i!==-1){g?.splice(i,1),g.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:c});return}}}get(a){return this.all.filter(c=>c.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(g=>g?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===a)}}P.Registry.add(I.ViewContainersRegistry,new d);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function m(r,a){const c=r.group??u.More,g=a.group??u.More;return c!==g?c.localeCompare(g):(r.order??5)-(a.order??5)}class v extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new o.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new o.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new o.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new o.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new C.SetMap}registerViews(a,c){this.registerViews2([{views:a,viewContainer:c}])}registerViews2(a){a.forEach(({views:c,viewContainer:g})=>this.addViews(c,g)),this._onViewsRegistered.fire(a)}deregisterViews(a,c){const g=this.removeViews(a,c);g.length&&this._onViewsDeregistered.fire({views:g,viewContainer:c})}moveViews(a,c){for(const g of this._views.keys())if(g!==c){const i=this.removeViews(a,g);i.length&&(this.addViews(i,c),this._onDidChangeContainer.fire({views:i,from:g,to:c}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const c of this._viewContainers){const g=(this._views.get(c)||[]).filter(i=>i.id===a)[0];if(g)return g}return null}getViewContainer(a){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(i=>i.id===a)[0])return c;return null}registerViewWelcomeContent(a,c){return this._viewWelcomeContents.add(a,c),this._onDidChangeViewWelcomeContent.fire(a),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(a,c),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,c){const g=new Map;for(const[i,t]of c)this._viewWelcomeContents.add(a,t),g.set(i,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(a,t),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),g}getViewWelcomeContent(a){const c=[];return this._viewWelcomeContents.forEach(a,g=>c.push(g)),c.sort(m)}addViews(a,c){let g=this._views.get(c);g||(g=[],this._views.set(c,g),this._viewContainers.push(c));for(const i of a){if(this.getView(i.id)!==null)throw new Error((0,R.localize)(1,null,i.id));g.push(i)}}removeViews(a,c){const g=this._views.get(c);if(!g)return[];const i=[],t=[];for(const h of g)a.includes(h)?i.push(h):t.push(h);return i.length&&(t.length?this._views.set(c,t):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),i}}P.Registry.add(I.ViewsRegistry,new v),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var D;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(D=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(a,c){this.resolved=!1,this._hasResolve=!1,(0,L.mixin)(this,a),this._hasResolve=!!c,this.resolve=async g=>{if(c&&!this.resolved){const i=await c(g);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}g.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class s extends Error{constructor(a){super((0,R.localize)(2,null,a))}}e.NoTreeViewError=s}),define(Se[131],ye([1,0,3,19,189]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,S,C,L){const k={command:P};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof L=="number"){const b=setTimeout(()=>{clearTimeout(b);const I=this.pendingRequests.get(k.seq);if(I){this.pendingRequests.delete(k.seq);const y={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,l.localize)(0,null,L,P)};I(y)}},L)}return C&&this.pendingRequests.set(k.seq,C),k.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,S){return P.type!=="event"||S.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,R.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const S=P,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}}internalSend(P,S){S.type=P,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((S,C)=>P.set(C,S)),await(0,R.timeout)(500),P.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Se[228],ye([1,0,190,54,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const A=b=>o.localize(51,null,b);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var w;(function(b){b[b.Inactive=0]="Inactive",b[b.Initializing=1]="Initializing",b[b.Stopped=2]="Stopped",b[b.Running=3]="Running"})(w=e.State||(e.State={}));function P(b){switch(b){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var S;(function(b){b[b.Valid=0]="Valid",b[b.Unreadable=1]="Unreadable",b[b.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(b){b[b.Initial=1]="Initial",b[b.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(b){b.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,l.createDecorator)("debugService");var k;(function(b){b[b.CONDITION=0]="CONDITION",b[b.HIT_COUNT=1]="HIT_COUNT",b[b.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[229],ye([1,0,8,2,12,23,15,32,21,16]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function k(i,t,h){return i.replace(L,function(_,E){return t&&E.length>0&&E[0]!=="_"?_:h&&h.hasOwnProperty(E)?h[E]:_})}e.formatPII=k;function b(i){const t={};for(const h of Object.keys(i))h.startsWith("!")||(t[h]=i[h]);return t}e.filterExceptionsFromTelemetry=b;function I(i){return i.configuration.request==="attach"&&!y(i)&&(!i.parentSession||I(i.parentSession))}e.isSessionAttach=I;function y(i){let t=i.configuration.type;if(!!t)return t==="vslsShare"&&(t=i.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(t,"extensionhost")||(0,o.equalsIgnoreCase)(t,"pwa-extensionhost")?i:i.parentSession?y(i.parentSession):void 0}e.getExtensionHostDebugSession=y;function f(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=f;function d(i,t,h){let _,E=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let $=null;for(;$=O.exec(i);){const H=$.index+1,X=H+$[0].length;if(H<=t&&X>=h){_=$[0],E=H;break}}if(_){const H=/\w+/g;let X=null;for(;(X=H.exec(_))&&!(X.index+1+E+X[0].length>=h););X&&(_=_.substring(0,H.lastIndex))}return _?{start:E,end:E+_.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;async function u(i,t,h,_){if(i.evaluatableExpressionProvider.has(t)){const E=i.evaluatableExpressionProvider.ordered(t),O=(0,C.coalesce)(await Promise.all(E.map(async $=>{try{return await $.provideEvaluatableExpression(t,h,_??S.CancellationToken.None)}catch{return}})));if(O.length>0){let $=O[0].expression;const H=O[0].range;return $||($=t.getLineContent(h.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:$}}}else{const E=t.getLineContent(h.lineNumber),{start:O,end:$}=d(E,h.column,h.column),H=E.substring(O-1,$);return{matchingExpression:H,range:new P.Range(h.lineNumber,O,h.lineNumber,O+H.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(i){return!!(i&&i.match(m))}e.isUri=v;function D(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(v(i.path))return R.URI.parse(i.path);if((0,l.isAbsolute)(i.path))return R.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const t=R.URI.revive(i.path);if(t)return t.scheme===w.Schemas.file?t.fsPath:t.toString()}return i.path}function n(i,t){const h=t?D:p,_=(0,A.deepClone)(i);return r(_,(E,O)=>{E&&O&&(O.path=h(O))}),_}e.convertToDAPaths=n;function s(i,t){const h=t?D:p,_=(0,A.deepClone)(i);return r(_,(E,O)=>{!E&&O&&(O.path=h(O))}),_}e.convertToVSCPaths=s;function r(i,t){switch(i.type){case"event":{const h=i;switch(h.event){case"output":t(!1,h.body.source);break;case"loadedSource":t(!1,h.body.source);break;case"breakpoint":t(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=i;switch(h.command){case"setBreakpoints":t(!0,h.arguments.source);break;case"breakpointLocations":t(!0,h.arguments.source);break;case"source":t(!0,h.arguments.source);break;case"gotoTargets":t(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(_=>t(!1,_));break;default:break}break}case"response":{const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(_=>t(!1,_.source));break;case"loadedSources":h.body.sources.forEach(_=>t(!1,_));break;case"scopes":h.body.scopes.forEach(_=>t(!1,_.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(_=>t(!1,_.source));break;case"setBreakpoints":h.body.breakpoints.forEach(_=>t(!1,_.source));break;case"disassemble":h.body?.instructions.forEach(E=>t(!1,E.location));break;default:break}break}}}function a(i){return i.filter(t=>!t.presentation?.hidden).sort((t,h)=>t.presentation?h.presentation?t.presentation.group?h.presentation.group?t.presentation.group!==h.presentation.group?t.presentation.group.localeCompare(h.presentation.group):c(t.presentation.order,h.presentation.order):-1:h.presentation.group?1:c(t.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=a;function c(i,t){return typeof i!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:i-t}async function g(i,t){const h=i.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(h!=="none"&&(await t.saveAll(),h==="allEditorsInActiveGroup")){const _=t.activeEditorPane;_&&_.input.resource?.scheme===w.Schemas.untitled&&await t.save({editor:_.input,groupId:_.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(Se[230],ye([1,0,46,231,23,12,11,8,29,191,131]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends L.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(u,m){this.outputStream=m,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,u.on("data",v=>this.handleData(v))}sendMessage(u){if(this.outputStream){const m=JSON.stringify(u);this.outputStream.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${k.TWO_CRLF}${m}`,"utf8")}}handleData(u){for(this.rawData=Buffer.concat([this.rawData,u]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const m=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(v){this._onError.fire(new Error((v.message||v)+`
`+m))}continue}}else{const m=this.rawData.indexOf(k.TWO_CRLF);if(m!==-1){const D=this.rawData.toString("utf8",0,m).split(k.HEADER_LINESEPARATOR);for(const p of D){const n=p.split(k.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(m+k.TWO_CRLF.length);continue}}break}}}k.TWO_CRLF=`\r
\r
`,k.HEADER_LINESEPARATOR=/\r?\n/,k.HEADER_FIELDSEPARATOR=/: */,e.StreamDebugAdapter=k;class b extends k{startSession(){return new Promise((u,m)=>{let v=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),u(),v=!0}),this.socket.on("close",()=>{v?this._onError.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.socket.on("error",D=>{v?this._onError.fire(D):m(D)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class I extends b{constructor(u){super(),this.adapterServer=u}createConnection(u){return R.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",u)}}e.SocketDebugAdapter=I;class y extends b{constructor(u){super(),this.adapterServer=u}createConnection(u){return R.createConnection(this.adapterServer.path,u)}}e.NamedPipeDebugAdapter=y;class f extends k{constructor(u,m){super(),this.adapterExecutable=u,this.debugType=m}async startSession(){const u=this.adapterExecutable.command,m=this.adapterExecutable.args,v=this.adapterExecutable.options||{};try{if(u)if(A.isAbsolute(u)){if(!await S.Promises.exists(u))throw new Error(C.localize(0,null,u))}else u.indexOf("/")<0&&u.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let D=process.env;if(v.env&&Object.keys(v.env).length>0&&(D=l.mixin(l.deepClone(process.env),v.env)),u==="node")if(Array.isArray(m)&&m.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:D,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};v.cwd&&(n.cwd=v.cwd);const s=o.fork(m[0],m.slice(1),n);if(!s.pid)throw new Error(C.localize(2,null,m[0]));this.serverProcess=s}else throw new Error(C.localize(3,null));else{const p={env:D};v.cwd&&(p.cwd=v.cwd),this.serverProcess=o.spawn(u,m,p)}this.serverProcess.on("error",p=>{this._onError.fire(p)}),this.serverProcess.on("exit",(p,n)=>{this._onExit.fire(p)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stdin.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(D){this._onError.fire(D)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),w.isWindows?new Promise((u,m)=>{const v=o.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(D,p,n){if(D)return m(D)});v.on("exit",u),v.on("error",m)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(u,m){if(!u)return;const v=Object.create(null);u.runtime&&(u.runtime.indexOf("./")===0?v.runtime=A.join(m,u.runtime):v.runtime=u.runtime),u.runtimeArgs&&(v.runtimeArgs=u.runtimeArgs),u.program&&(A.isAbsolute(u.program)?v.program=u.program:v.program=A.join(m,u.program)),u.args&&(v.args=u.args);const D=u;return D.win&&(v.win=f.extract(D.win,m)),D.winx86&&(v.winx86=f.extract(D.winx86,m)),D.windows&&(v.windows=f.extract(D.windows,m)),D.osx&&(v.osx=f.extract(D.osx,m)),D.linux&&(v.linux=f.extract(D.linux,m)),v}static platformAdapterExecutable(u,m){let v=Object.create(null);m=m.toLowerCase();for(const a of u)if(a.contributes){const c=a.contributes.debuggers;c&&c.length>0&&c.filter(g=>typeof g.type=="string"&&P.equalsIgnoreCase(g.type,m)).forEach(g=>{const i=f.extract(g,a.extensionLocation.fsPath);v=l.mixin(v,i,a.isBuiltin)})}let D;w.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?D=v.winx86||v.win||v.windows:w.isWindows?D=v.win||v.windows:w.isMacintosh?D=v.osx:w.isLinux&&(D=v.linux),D=D||v;const p=D.program||v.program,n=D.args||v.args,s=D.runtime||v.runtime,r=D.runtimeArgs||v.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(n||[])};if(p)return{type:"executable",command:p,args:n||[]}}}e.ExecutableDebugAdapter=f}),define(Se[232],ye([1,0,46,34,11]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(C,L){return new Promise((k,b)=>{let I="";const y=o.spawn(C,L);y.pid&&y.stdout.on("data",f=>{I+=f.toString()}),y.on("error",f=>{b(f)}),y.on("close",f=>{k(I)})})}async function w(C){if(C)if(l.isWindows){const L=await new Promise((k,b)=>{re(["windows-process-tree"],k,b)});return new Promise(k=>{L.getProcessTree(C,b=>{k(!!b&&b.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(C)]).then(L=>{const k=L.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=w;var P;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(P||(P={}));function S(C,L,k,b,I){C=C.trim().toLowerCase();let y;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?y=1:C.indexOf("cmd.exe")>=0?y=0:C.indexOf("bash")>=0?y=2:l.isWindows?y=0:y=2;let f,d=" ";switch(y){case 1:if(f=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),b){const u=(0,R.getDriveLetter)(b);u&&(d+=`${u}:; `),d+=`cd ${f(b)}; `}if(I)for(const u in I){const m=I[u];m===null?d+=`Remove-Item env:${u}; `:d+=`\${env:${u}}='${m}'; `}if(L.length>0){const u=L.shift(),m=k?u:f(u);d+=m[0]==="'"?`& ${m} `:`${m} `;for(const v of L)d+=v==="<"||v===">"||k?v:f(v),d+=" "}break;case 0:if(f=u=>(u=u.replace(/\"/g,'""'),u=u.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>u.includes(m))||u.length===0?`"${u}"`:u),b){const u=(0,R.getDriveLetter)(b);u&&(d+=`${u}: && `),d+=`cd ${f(b)} && `}if(I){d+='cmd /C "';for(const u in I){let m=I[u];m===null?d+=`set "${u}=" && `:(m=m.replace(/[&^|<>]/g,v=>`^${v}`),d+=`set "${u}=${m}" && `)}}for(const u of L)d+=u==="<"||u===">"||k?u:f(u),d+=" ";I&&(d+='"');break;case 2:{f=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),m.length===0?'""':m);const u=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(b&&(d+=`cd ${f(b)} ; `),I){d+="/usr/bin/env";for(const m in I){const v=I[m];v===null?d+=` -u ${u(m)}`:d+=` ${u(`${m}=${v}`)}`}d+=" "}for(const m of L)d+=m==="<"||m===">"||k?m:f(m),d+=" ";break}}return d}e.prepareCommand=S}),define(Se[93],ye([1,0,22,38,64,88,15,12,11,54]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var y;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(y=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var m;(function(T){T.scheme=w.Schemas.vscodeNotebookCell;const F=["W","X","Y","Z","a","b","c","d","e","f"],U=new RegExp(`^[${F.join("")}]+`),Z=7;function J(Y,ee){const me=ee.toString(Z),De=`${me.length<F.length?F[me.length-1]:"z"}${me}s${(0,o.encodeBase64)(o.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:T.scheme,fragment:De})}T.generate=J;function z(Y){if(Y.scheme!==T.scheme)return;const ee=Y.fragment.indexOf("s");if(ee<0)return;const me=parseInt(Y.fragment.substring(0,ee).replace(U,""),Z),be=(0,o.decodeBase64)(Y.fragment.substring(ee+1)).toString();if(!isNaN(me))return{handle:me,notebook:Y.with({scheme:be,fragment:null})}}T.parse=z;function Q(Y,ee){return Y.with({scheme:w.Schemas.vscodeNotebookCellOutput,fragment:`op${ee??""},${Y.scheme!==w.Schemas.file?Y.scheme:""}`})}T.generateCellOutputUri=Q;function ie(Y){if(Y.scheme!==w.Schemas.vscodeNotebookCellOutput)return;const ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!ee)return;const me=ee[1]&&ee[1]!==""?ee[1]:void 0,be=ee[2];return{outputId:me,notebook:Y.with({scheme:be||w.Schemas.file,fragment:null})}}T.parseCellOutputUri=ie;function ge(Y,ee,me){return T.generate(Y,ee).with({scheme:me})}T.generateCellPropertyUri=ge;function K(Y,ee){if(Y.scheme===ee)return T.parse(Y.with({scheme:T.scheme}))}T.parseCellPropertyUri=K})(m=e.CellUri||(e.CellUri={}));const v=T=>S.isWindows?T.replace(/\//g,"\\"):T;class D{constructor(F=[],U=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=U,this.order=[...new Set(F)].map(Z=>({pattern:Z,matches:R.parse(v(Z))}))}sort(F){const U=new Map(l.Iterable.map(F,J=>[J,v(J)]));let Z=[];for(const{matches:J}of this.order)for(const[z,Q]of U)if(J(Q)){Z.push(z),U.delete(z);break}return U.size&&(Z=Z.concat([...U.keys()].sort((J,z)=>this.defaultOrder.indexOf(J)-this.defaultOrder.indexOf(z)))),Z}prioritize(F,U){const Z=this.findIndex(F);if(Z===-1){this.order.unshift({pattern:F,matches:R.parse(v(F))});return}const J=new Set(U.map(Q=>this.findIndex(Q,Z)));J.delete(-1);const z=Array.from(J).sort();this.order.splice(Z+1,0,...z.map(Q=>this.order[Q]));for(let Q=z.length-1;Q>=0;Q--)this.order.splice(z[Q],1)}toArray(){return this.order.map(F=>F.pattern)}findIndex(F,U=this.order.length){const Z=v(F);for(let J=0;J<U;J++)if(this.order[J].matches(Z))return J;return-1}}e.MimeTypeDisplayOrder=D;function p(T,F,U,Z=(J,z)=>J===z){const J=[];function z(ge,K,Y){if(K===0&&Y.length===0)return;const ee=J[J.length-1];ee&&ee.start+ee.deleteCount===ge?(ee.deleteCount+=K,ee.toInsert.push(...Y)):J.push({start:ge,deleteCount:K,toInsert:Y})}let Q=0,ie=0;for(;;){if(Q===T.length){z(Q,0,F.slice(ie));break}if(ie===F.length){z(Q,T.length-Q,[]);break}const ge=T[Q],K=F[ie];if(Z(ge,K)){Q+=1,ie+=1;continue}U(K)?(z(Q,1,[]),Q+=1):(z(Q,0,[K]),ie+=1)}return J}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(T){T.default="default",T.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(T){const F=T;return!!((typeof F.include=="string"||R.isRelativePattern(F.include))&&(typeof F.exclude=="string"||R.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=s;function r(T,F,U){if(Array.isArray(T.viewType)&&T.viewType.indexOf(F)>=0||T.viewType===F)return!0;if(T.filenamePattern){const Z=s(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,J=s(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(R.match(Z,(0,P.basename)(U.fsPath).toLowerCase()))return!(J&&R.match(J,(0,P.basename)(U.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var a;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(F){return`${c._prefix}${F}`}static parse(F){if(F.startsWith(c._prefix))return F.substring(c._prefix.length)}}c._prefix="notebook/",e.NotebookWorkingCopyTypeIdentifier=c;function g(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.isTextStreamMime=g;const i=new TextDecoder;function t(T){const F=[];let U=!1;for(const Z of T)(F.length===0||U)&&(F.push(Z),U=!0);return O(F),N(o.VSBuffer.concat(F.map(Z=>o.VSBuffer.wrap(Z))))}e.compressOutputItemStreams=t;const h=`${String.fromCharCode(27)}[A`,_=h.split("").map(T=>T.charCodeAt(0)),E=10;function O(T){T.forEach((F,U)=>{if(U===0||F.length<h.length)return;const Z=T[U-1],J=F.subarray(0,h.length);if(J[0]===_[0]&&J[1]===_[1]&&J[2]===_[2]){const z=Z.lastIndexOf(E);if(z===-1)return;T[U-1]=Z.subarray(0,z),T[U]=F.subarray(h.length)}})}function $(T){let F=T;do T=F,F=T.replace(/[^\n]\x08/gm,"");while(F.length<T.length);return T}function H(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const F=T.match(/^(.*)\r+/m)[1];let U=T.match(/\r+(.*)$/m)[1];U=U+F.slice(U.length,F.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,U)}return T}const X="\b".charCodeAt(0),V="\r".charCodeAt(0);function N(T){return!T.buffer.includes(X)&&!T.buffer.includes(V)?T:o.VSBuffer.fromString(H($(i.decode(T.buffer))))}}),define(Se[233],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(R=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(Se[57],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(A){A.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(w,P,S=w.parent){if(w._isRoot)return new l([P]);const C=[w.id];for(let L=S;L&&L.id!==P;L=L.parent)C.push(L.id);return C.push(P),new l(C.reverse())}static isRoot(w){return!w.includes("\0")}static root(w){const P=w.indexOf("\0");return P===-1?w:w.slice(0,P)}static fromString(w){return new l(w.split("\0"))}static join(w,P){return new l([...w.path,P])}static joinToString(w,P){return w.toString()+"\0"+P}static parentId(w){const P=w.lastIndexOf("\0");return P===-1?void 0:w.slice(0,P)}static localId(w){const P=w.lastIndexOf("\0");return P===-1?w:w.slice(P+1)}static compare(w,P){return w===P?0:P.startsWith(w+"\0")?2:w.startsWith(P+"\0")?3:1}constructor(w,P=w.length){if(this.path=w,this.viewEnd=P,w.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new l(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let w=1;w<=this.viewEnd;w++)yield new l(this.path,w)}*idsToRoot(){for(let w=this.viewEnd;w>0;w--)yield new l(this.path,w)}compare(w){if(typeof w=="string")return l.compare(this.toString(),w);for(let P=0;P<w.viewEnd&&P<this.viewEnd;P++)if(w.path[P]!==this.path[P])return 1;return w.viewEnd>this.viewEnd?2:w.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let w=1;w<this.viewEnd;w++)this.stringifed+="\0",this.stringifed+=this.path[w]}return this.stringifed}}e.TestId=l}),define(Se[76],ye([1,0,2,32,57]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var w;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(w=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=i=>"runId"in i;e.isStartControllerTests=P;var S;(function(i){i.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),i.deserialize=t=>({range:R.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var C;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(C=e.TestMessageType||(e.TestMessageType={}));var L;(function(i){i.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.deserialize(t.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const k=(i,t)=>`${t?"s":"e"}${i}`;e.getMarkId=k;var b;(function(i){i.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.deserialize(t.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var I;(function(i){i.serialize=t=>t.type===0?L.serialize(t):b.serialize(t),i.deserialize=t=>t.type===0?L.deserialize(t):b.deserialize(t)})(I=e.ITestMessage||(e.ITestMessage={}));var y;(function(i){i.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),i.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(I.serialize)}),i.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(I.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",d=(i,t)=>i+f+t;e.namespaceTestTag=d;const u=i=>{const t=i.indexOf(f);return{ctrlId:i.slice(0,t),tagId:i.slice(t+1)}};e.denamespaceTestTag=u;var m;(function(i){i.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),i.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?R.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(m=e.ITestItem||(e.ITestItem={}));var v;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(i){i.serialize=t=>({expand:t.expand,item:m.serialize(t.item)}),i.deserialize=t=>({controllerId:l.TestId.root(t.item.extId),expand:t.expand,item:m.deserialize(t.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=t=>{let h;return t.item&&(h={},t.item.label!==void 0&&(h.label=t.item.label),t.item.tags!==void 0&&(h.tags=t.item.tags),t.item.busy!==void 0&&(h.busy=t.item.busy),t.item.uri!==void 0&&(h.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(h.range=t.item.range?.toJSON()),t.item.description!==void 0&&(h.description=t.item.description),t.item.error!==void 0&&(h.error=t.item.error),t.item.sortText!==void 0&&(h.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:h}},i.deserialize=t=>{let h;return t.item&&(h={},t.item.label!==void 0&&(h.label=t.item.label),t.item.tags!==void 0&&(h.tags=t.item.tags),t.item.busy!==void 0&&(h.busy=t.item.busy),t.item.range!==void 0&&(h.range=t.item.range?R.Range.lift(t.item.range):null),t.item.description!==void 0&&(h.description=t.item.description),t.item.error!==void 0&&(h.error=t.item.error),t.item.sortText!==void 0&&(h.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:h}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const n=(i,t)=>{t.expand!==void 0&&(i.expand=t.expand),t.item!==void 0&&(i.item=i.item?Object.assign(i.item,t.item):t.item)};e.applyTestItemUpdate=n;var s;(function(i){i.serializeWithoutMessages=t=>({...D.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serializeWithoutMessages),retired:t.retired}),i.serialize=t=>({...D.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serialize),retired:t.retired}),i.deserialize=t=>({...D.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var a;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var c;(function(i){i.deserialize=t=>t.op===0?{op:t.op,item:D.deserialize(t.item)}:t.op===1?{op:t.op,item:p.deserialize(t.item)}:t.op===2?{op:t.op,uri:o.URI.revive(t.uri),docv:t.docv}:t,i.serialize=t=>t.op===0?{op:t.op,item:D.serialize(t.item)}:t.op===1?{op:t.op,item:p.serialize(t.item)}:t})(c=e.TestsDiffOp||(e.TestsDiffOp={}));class g{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const h=this.createChangeCollector();for(const _ of t)switch(_.op){case 0:this.add(D.deserialize(_.item),h);break;case 1:this.update(p.deserialize(_.item),h);break;case 3:this.remove(_.itemId,h);break;case 5:this.retireTest(_.itemId);break;case 4:this.updatePendingRoots(_.amount);break;case 6:this._tags.set(_.tag.id,_.tag);break;case 7:this._tags.delete(_.id);break}h.complete?.()}add(t,h){const _=l.TestId.parentId(t.item.extId)?.toString();let E;if(!_)E=this.createItem(t),this.roots.add(E),this.items.set(t.item.extId,E);else if(this.items.has(_)){const O=this.items.get(_);O.children.add(t.item.extId),E=this.createItem(t,O),this.items.set(t.item.extId,E)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return h.add?.(E),t.expand===2&&this.busyControllerCount++,E}update(t,h){const _=this.items.get(t.extId);if(!!_)return t.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,t.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,t),h.update?.(_),_}remove(t,h){const _=this.items.get(t);if(!_)return;const E=l.TestId.parentId(_.item.extId)?.toString();E?this.items.get(E).children.delete(_.item.extId):this.roots.delete(_);const O=[[t]];for(;O.length;)for(const $ of O.pop()){const H=this.items.get($);H&&(O.push(H.children),this.items.delete($),h.remove?.(H,H!==_),H.expand===2&&this.busyControllerCount--)}}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=g}),define(Se[94],ye([1,0,19,3,6,50,76,57]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(m,v)=>m===v,k=Object.entries({range:(m,v)=>m===v?!0:!m||!v?!1:m.equalsRange(v),busy:C,label:C,description:C,error:C,sortText:C,tags:(m,v)=>!(m.length!==v.length||m.some(D=>!v.includes(D)))}),b=(m,v)=>{let D;for(const[p,n]of k)n(m[p],v[p])||(D?D[p]=v[p]:D={[p]:v[p]});return D};class I extends l.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const D of this.tree.values())this.updateExpandability(D)}get resolveHandler(){return this._resolveHandler}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const D of this.diff)if(D.op===2&&D.uri===v.uri){D.docv=v.docv;return}break}case 1:{const D=this.diff[this.diff.length-1];if(D){if(D.op===1&&D.item.extId===v.item.extId){(0,w.applyTestItemUpdate)(D.item,v.item);return}if(D.op===0&&D.item.item.extId===v.item.extId){(0,w.applyTestItemUpdate)(D.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,D){const p=this.tree.get(v);if(!!p){if((p.expandLevels===void 0||D>p.expandLevels)&&(p.expandLevels=D),p.expand===1){const n=this.resolveChildren(p);return n.isOpen()?this.expandChildren(p,D-1):n.wait().then(()=>this.expandChildren(p,D-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,D-1)):this.expandChildren(p,D-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,D){switch(D.op){case 3:this.removeItem(P.TestId.joinToString(v.fullId,D.id));break;case 0:this.upsertItem(D.item,v);break;case 5:for(const p of D.ops)this.onTestItemEvent(v,p);break;case 1:this.diffTagRefs(D.new,D.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:D.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,A.assertNever)(D)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,D){const p=P.TestId.fromExtHostTestItem(v,this.root.id,D?.actual),n=this.options.getApiFor(v);n.parent&&n.parent!==D?.actual&&this.options.getChildren(n.parent).delete(v.id);let s=this.tree.get(p.toString());if(!s){s={fullId:p,actual:v,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(v,D),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,s,D);return}if(s.actual===v){this.connectItem(v,s,D);return}if(s.actual.uri?.toString()!==v.uri?.toString())return this.removeItem(p.toString()),this.upsertItem(v,D);const r=this.options.getChildren(s.actual),a=s.actual,c=b(this.options.toITestItem(a),this.options.toITestItem(v));this.options.getApiFor(a).listener=void 0,s.actual=v,s.expand=0,c&&(c.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,a.tags,p.toString()),delete c.tags),this.onTestItemEvent(s,{op:4,update:c})),this.connectItemAndChildren(v,s,D);for(const[g,i]of r)this.options.getChildren(v).get(i.id)||this.removeItem(P.TestId.joinToString(p,i.id));this.documentSynced(s.actual.uri)}diffTagRefs(v,D,p){const n=new Set(D.map(s=>s.id));for(const s of v)n.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:p,item:{tags:v.map(s=>(0,w.namespaceTestTag)(this.options.controllerId,s.id))}}}),n.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const D=this.tags.get(v.id);D?D.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,w.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const D=this.tags.get(v);D&&!--D.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,w.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,D){this.options.getApiFor(v).parent=D&&D.actual!==this.root?D.actual:void 0}connectItem(v,D,p){this.setItemParent(v,p);const n=this.options.getApiFor(v);n.parent=p?.actual,n.listener=s=>this.onTestItemEvent(D,s),this.updateExpandability(D)}connectItemAndChildren(v,D,p){this.connectItem(v,D,p);for(const[n,s]of this.options.getChildren(v))this.upsertItem(s,D)}updateExpandability(v){let D;this._resolveHandler?v.resolveBarrier?D=v.resolveBarrier.isOpen()?3:2:D=v.actual.canResolveChildren?1:0:D=0,D!==v.expand&&(v.expand=D,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:D}}),D===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,D){if(D<0)return;const p=[];for(const[n,s]of this.options.getChildren(v.actual)){const r=this.expand(P.TestId.joinToString(v.fullId,s.id),D);(0,o.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const s=new o.Barrier;return s.open(),s}v.expand=2,this.pushExpandStateUpdate(v);const D=v.resolveBarrier=new o.Barrier,p=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let n;try{n=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(s){p(s)}return(0,o.isThenable)(n)?n.catch(p).then(()=>{D.open(),this.updateExpandability(v)}):(D.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const D=this.tree.get(v);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const p=[D];for(;p.length;){const n=p.pop();if(!!n){this.options.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(n.fullId.toString());for(const[s,r]of this.options.getChildren(n.actual))p.push(this.tree.get(P.TestId.joinToString(n.fullId,r.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=I;class y extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=y;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(v,D,p){super(`TestItem with ID "${v}" is from controller "${D}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=d;const u=(m,v,D)=>{let p=new Map;return{get size(){return p.size},forEach(n,s){for(const r of p.values())n.call(s,r,this)},[Symbol.iterator](){return p.entries()},replace(n){const s=new Map,r=new Set(p.keys()),a={op:5,ops:[]};for(const c of n){if(!(c instanceof D))throw new f(c.id);const g=v(c).controllerId;if(g!==m.controllerId)throw new d(c.id,g,m.controllerId);if(s.has(c.id))throw new y(c.id);s.set(c.id,c),r.delete(c.id),a.ops.push({op:0,item:c})}for(const c of r.keys())a.ops.push({op:3,id:c});m.listener?.(a),p=s},add(n){if(!(n instanceof D))throw new f(n.id);p.set(n.id,n),m.listener?.({op:0,item:n})},delete(n){p.delete(n)&&m.listener?.({op:3,id:n})},get(n){return p.get(n)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=u}),define(Se[132],ye([1,0,94]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,l=(w,P)=>{const S={controllerId:P};return R.set(w,S),S};e.createPrivateApiFor=l;const A=w=>{const P=R.get(w);if(!P)throw new o.InvalidTestItemError(w?.id||"<unknown>");return P};e.getPrivateApiFor=A}),define(Se[95],ye([1,0,15,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(P,S){return P.scheme===o.Schemas.http||P.scheme===o.Schemas.https?P:(S&&S.authority&&S.isRemote&&P.scheme===o.Schemas.file&&(P=R.URI.from({scheme:o.Schemas.vscodeRemote,authority:S.authority,path:P.path})),R.URI.from({scheme:o.Schemas.https,authority:`${P.scheme}+${A(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=l;function A(P){return P.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function w(P){return P.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=w}),define(Se[234],ye([1,0,3,6,95]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(P,S,C){this._proxy=P,this._editors=S,this._remoteInfo=C,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const k of this._insets.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,S,C,L,k){let b;for(const v of this._editors.getVisibleTextEditors(!0))if(v.value===P){b=v;break}if(!b)throw new Error("not a visible editor");const I=this,y=this._handlePool++,f=new o.Emitter,d=new o.Emitter,u=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(v){return(0,l.asWebviewUri)(v,I._remoteInfo)}get cspSource(){return l.webviewGenericCspSource}set options(v){this._options=v,I._proxy.$setOptions(y,v)}get options(){return this._options}set html(v){this._html=v,I._proxy.$setHtml(y,v)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(v){return I._proxy.$postMessage(y,v)}},m=new class{constructor(){this.editor=P,this.line=S,this.height=C,this.webview=u,this.onDidDispose=d.event}dispose(){I._insets.has(y)&&(I._insets.delete(y),I._proxy.$disposeEditorInset(y),d.fire(),d.dispose(),f.dispose())}};return this._proxy.$createEditorInset(y,b.id,b.value.document.uri,S+1,C,L||{},k.identifier,k.extensionLocation),this._insets.set(y,{editor:P,inset:m,onDidReceiveMessage:f}),m}$onDidDispose(P){const S=this._insets.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){this._insets.get(P)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Se[235],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var R;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(R=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(w,P){super(P),this.variable=w}}e.VariableError=l}),define(Se[236],ye([1,0,12,33,9,23,11,113,194,235,8]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,y,f,d){this._contributedVariables=new Map,this._context=I,this._labelService=y,this._userHomePromise=f,d&&(this._envVariablesPromise=d.then(u=>this.prepareEnv(u)))}prepareEnv(I){if(w.isWindows){const y=Object.create(null);return Object.keys(I).forEach(f=>{y[f.toLowerCase()]=I[f]}),y}return I}resolveWithEnvironment(I,y,f){return this.recursiveResolve({env:this.prepareEnv(I),userHome:void 0},y?y.uri:void 0,f)}async resolveAsync(I,y){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,I?I.uri:void 0,y)}async resolveAnyBase(I,y,f,d){const u=A.deepClone(y);w.isWindows&&u.windows?Object.keys(u.windows).forEach(v=>u[v]=u.windows[v]):w.isMacintosh&&u.osx?Object.keys(u.osx).forEach(v=>u[v]=u.osx[v]):w.isLinux&&u.linux&&Object.keys(u.linux).forEach(v=>u[v]=u.linux[v]),delete u.windows,delete u.osx,delete u.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,I?I.uri:void 0,u,f,d)}async resolveAnyAsync(I,y,f){return this.resolveAnyBase(I,y,f)}async resolveAnyMap(I,y,f){const d=new Map;return{newConfig:await this.resolveAnyBase(I,y,f,d),resolvedVariables:d}}resolveWithInteractionReplace(I,y,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,y,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,y){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,y)}async recursiveResolve(I,y,f,d,u){if(l.isString(f))return this.resolveString(I,y,f,d,u);if(Array.isArray(f))return Promise.all(f.map(m=>this.recursiveResolve(I,y,m,d,u)));if(l.isObject(f)){const m=Object.create(null),v=await Promise.all(Object.keys(f).map(async D=>[await this.resolveString(I,y,D,d,u),await this.recursiveResolve(I,y,f[D],d,u)]));for(const[D,p]of v)m[D]=p;return m}return f}resolveString(I,y,f,d,u){return(0,L.replaceAsync)(f,k.VARIABLE_REGEXP,async(m,v)=>{if(v.includes(k.VARIABLE_LHS))return m;let D=await this.evaluateSingleVariable(I,m,v,y,d);return u?.set(v,D),D!==m&&l.isString(D)&&D.match(k.VARIABLE_REGEXP)&&(D=await this.resolveString(I,y,D,d,u)),D})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}async evaluateSingleVariable(I,y,f,d,u){let m;const v=f.split(":");v.length>1&&(f=v[0],m=v[1]);const D=s=>{const r=this._context.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new C.VariableError(s,(0,S.localize)(0,null,y))},p=s=>{const r=D(s);if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return(0,P.normalizeDriveLetter)(a)}throw new C.VariableError(s,(0,S.localize)(1,null,y,o.basename(r)))},n=s=>{if(m){const r=this._context.getFolderUri(m);if(r)return r;throw new C.VariableError(s,(0,S.localize)(2,null,y,m))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new C.VariableError(s,(0,S.localize)(3,null,y)):new C.VariableError(s,(0,S.localize)(4,null,y))};switch(f){case"env":if(m){if(I.env){const s=I.env[w.isWindows?m.toLowerCase():m];if(l.isString(s))return s}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,y));case"config":if(m){const s=this._context.getConfigurationValue(d,m);if(l.isUndefinedOrNull(s))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,y,m));if(l.isObject(s))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,y,m));return s}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,y));case"command":return this.resolveFromMap(C.VariableKind.Command,y,m,u,"command");case"input":return this.resolveFromMap(C.VariableKind.Input,y,m,u,"input");case"extensionInstallFolder":if(m){const s=await this._context.getExtension(m);if(!s)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,y,m));return this.fsPath(s.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,y));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(n(C.VariableKind.WorkspaceFolder)));case"cwd":return d||m?(0,P.normalizeDriveLetter)(this.fsPath(n(C.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(o.basename(this.fsPath(n(C.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(I.userHome)return I.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,y))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,y))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,y))}case"file":return D(C.VariableKind.File);case"fileWorkspaceFolder":return p(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||m?o.relative(this.fsPath(n(C.VariableKind.RelativeFile)),D(C.VariableKind.RelativeFile)):D(C.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(D(C.VariableKind.RelativeFileDirname));if(d||m){const r=o.relative(this.fsPath(n(C.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return o.dirname(D(C.VariableKind.FileDirname));case"fileExtname":return o.extname(D(C.VariableKind.FileExtname));case"fileBasename":return o.basename(D(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(D(C.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(D(C.VariableKind.FileDirnameBasename)));case"execPath":{const s=this._context.getExecPath();return s||y}case"execInstallFolder":{const s=this._context.getAppRoot();return s||y}case"pathSeparator":return o.sep;default:try{const s=m?`${f}:${m}`:f;return this.resolveFromMap(C.VariableKind.Unknown,y,s,u,void 0)}catch{return y}}}}resolveFromMap(I,y,f,d,u){if(f&&d){const m=u===void 0?d[f]:d[u+":"+f];if(typeof m=="string")return m;throw new C.VariableError(I,(0,S.localize)(14,null,y))}return y}}k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=k}),define(Se[133],ye([1,0,4,130]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var l;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var A;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var w;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(w=e.GroupLocation||(e.GroupLocation={}));var P;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EVEN=1]="EVEN",y[y.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(y){const f=y;return(0,R.isEditorInput)(f?.editor)&&(0,R.isEditorInput)(f?.replacement)}e.isEditorReplacement=C;var L;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function b(y){const f=y;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=b;function I(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(Se[237],ye([1,0,4,133]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(A){const w=A;return typeof A=="number"||(0,R.isEditorGroup)(w)}e.isPreferredGroup=l}),define(Se[238],ye([1,0,4,202]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(R.IEnvironmentService)}),define(Se[134],ye([1,0,27,3,12]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=A;class w{static isHostExtension(k,b,I){if(b.getExtensionDescription(k))return!1;const y=I.getExtensionDescription(k);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(k){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(o.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(o.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let b of k.activationEvents)b==="onUri"&&(b=`onUri:${o.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,b){this._extensionDescriptions=C(this._extensionDescriptions,b),this._extensionDescriptions=this._extensionDescriptions.concat(k);const I=w._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=C(this._extensionDescriptions,I.map(y=>y.identifier)),this._initialize(),this._onDidChange.fire(void 0),new A(I)}static _findLoopingExtensions(k){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,m){this.addNode(u),this.addNode(m),this._arcs.has(u)?this._arcs.get(u).push(m):this._arcs.set(u,[m])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,m){const v=b.getArcs(u);for(let D=0;D<v.length;D++)if(!m.has(v[D]))return!1;return!0}getNodes(){return this._nodesArr}},I=new Map;for(const u of k){const m=o.ExtensionIdentifier.toKey(u.identifier);if(I.set(m,u),u.extensionDependencies)for(const v of u.extensionDependencies){const D=o.ExtensionIdentifier.toKey(v);b.addArc(m,D)}}const y=new Set;b.getNodes().filter(u=>b.getArcs(u).length===0).forEach(u=>y.add(u));const f=b.getNodes().filter(u=>!y.has(u));let d;do{d=!1;for(let u=0;u<f.length;u++){const m=f[u];b.hasOnlyGoodArcs(m,y)&&(f.splice(u,1),u--,y.add(m),d=!0)}}while(d);return f.map(u=>I.get(u))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(o.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const b=this._activationMap.get(k);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const b=this._extensionsMap.get(o.ExtensionIdentifier.toKey(k));return b||void 0}getExtensionDescriptionByUUID(k){for(const b of this._extensionsArr)if(b.uuid===k)return b}getExtensionDescriptionByIdOrUUID(k,b){return this.getExtensionDescription(k)??(b?this.getExtensionDescriptionByUUID(b):void 0)}}e.ExtensionDescriptionRegistry=w;var P;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(P||(P={}));function S(L,k){const b=L.isBuiltin?0:L.isUnderDevelopment?2:1,I=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(b!==I)return b-I;const y=l.posix.basename(L.extensionLocation.path),f=l.posix.basename(k.extensionLocation.path);return y<f?-1:y>f?1:0}function C(L,k){const b=new Set;return k.forEach(I=>b.add(o.ExtensionIdentifier.toKey(I))),L.filter(I=>!b.has(o.ExtensionIdentifier.toKey(I.identifier)))}}),define(Se[239],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(o=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class R{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[R.ENV_KEY]=this.pipeName}}R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=R;class l{constructor(){this.type=2}serialize(k){k[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class A{constructor(){this.type=3}serialize(k){k[A.ENV_KEY]="1"}}A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=A;function w(L){delete L[R.ENV_KEY],delete L[l.ENV_KEY],delete L[A.ENV_KEY]}function P(L,k){w(k),L.serialize(k)}e.writeExtHostConnection=P;function S(L){if(L[R.ENV_KEY])return C(L,new R(L[R.ENV_KEY]));if(L[l.ENV_KEY])return C(L,new l);if(L[A.ENV_KEY])return C(L,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function C(L,k){return w(L),k}}),define(Se[96],ye([1,0,22]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var l;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function w(C){const L=o.VSBuffer.alloc(1);switch(C){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=w;function P(C,L){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=P;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Se[77],ye([1,0,4,3,13,25,96,73,74,23,2,6,181]),function(re,e,o,R,l,A,w,P,S,C,L,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class extends k.Disposable{constructor(u,m){super(),this.initData=u,this.loggerService=m,this._onDidChangeTelemetryEnabled=this._register(new R.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new R.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=L.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=m.createLogger(this.extHostTelemetryLogFile,{id:S.extensionTelemetryLogChannelId,name:(0,b.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(m.onDidChangeLogLevel(v=>{(0,l.isLogLevel)(v)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(u,m,v){const D=this.getTelemetryDetails(),p=new y(m,v,u,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(u),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled});return this._telemetryLoggers.set(u.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(u,m,v){this._level=u,this._telemetryIsSupported=m,this._productConfig=v??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(u){const m={};switch(m["common.extname"]=`${u.publisher}.${u.name}`,m["common.extversion"]=u.version,m["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,m["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,m["common.vscodeversion"]=this.initData.version,m["common.isnewappinstall"]=f(this.initData.telemetryInfo.firstSessionDate),m["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case w.UIKind.Web:m["common.uikind"]="web";break;case w.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,P.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),m}$onDidChangeTelemetryLevel(u){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=u;const m=this.getTelemetryDetails();this._telemetryLoggers.forEach(v=>{v.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(u,m){const v=this._telemetryLoggers.get(u.value);return!v||v.ignoreUnhandledExtHostErrors?!1:(v.logError(m),!0)}};I=je([Be(0,A.IExtHostInitDataService),Be(1,l.ILoggerService)],I),e.ExtHostTelemetry=I;class y{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,m,v,D,p,n,s){this._extension=v,this._logger=D,this._inLoggingOnlyMode=p,this._commonProperties=n,this._onDidChangeEnableStates=new R.Emitter,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=m?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=m?.additionalCommonProperties,this._sender=u,this._telemetryEnablements={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(u,m){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:u,isErrorsEnabled:m},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(u){let m=u.properties??u;return m=(0,S.cleanData)(m,[]),this._additionalCommonProperties&&(m=(0,C.mixin)(m,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(m=(0,C.mixin)(m,this._commonProperties)),u.properties?u.properties=m:u=m,u}logEvent(u,m){!this._sender||(this._extension.publisher==="vscode"?u=this._extension.name+"/"+u:u=this._extension.identifier.value+"/"+u,m=this.mixInCommonPropsAndCleanData(m||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(u,m),this._logger.trace(u,m))}logUsage(u,m){!this._telemetryEnablements.isUsageEnabled||this.logEvent(u,m)}logError(u,m){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof u=="string"?this.logEvent(u,m):this._sender.sendErrorData(u,m))}get apiTelemetryLogger(){if(!this._apiObject){const u=this,m={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return u._telemetryEnablements.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u._onDidChangeEnableStates.event.bind(u)};this._apiObject=Object.freeze(m)}return this._apiObject}dispose(){this._sender?.flush&&(Promise.resolve(this._sender.flush()).then(this._sender=void 0),this._apiObject=void 0)}}e.ExtHostTelemetryLogger=y;function f(d){const u=Date.now()-new Date(d).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(Se[26],ye([1,0,3,2,4,27,215]),function(re,e,o,R,l,A,w){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class S{constructor(g){this.affinity=g,this.kind=1}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(g){this.affinity=g,this.kind=2}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class L{constructor(){this.kind=3,this.affinity=0}equals(g){return this.kind===g.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class k{constructor(g){this.dependency=g}}e.MissingExtensionDependency=k;var b;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(b=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class y{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(g,i){const t=[],h=[],_=[],E=[],O=u(this._allExtensions),$=u(g),H=(T,F)=>T.extensionLocation.toString()===F.extensionLocation.toString()||T.isBuiltin===F.isBuiltin||T.isUserBuiltin===F.isUserBuiltin||T.isUnderDevelopment===F.isUnderDevelopment;for(const T of this._allExtensions){const F=$.get(A.ExtensionIdentifier.toKey(T.identifier));if(!F){t.push(T.identifier),O.delete(A.ExtensionIdentifier.toKey(T.identifier));continue}if(!H(T,F)){t.push(T.identifier),O.delete(A.ExtensionIdentifier.toKey(T.identifier));continue}}for(const T of g){const F=O.get(A.ExtensionIdentifier.toKey(T.identifier));if(!F){h.push(T);continue}if(!H(F,T)){t.push(F.identifier),O.delete(A.ExtensionIdentifier.toKey(F.identifier));continue}}const X=d(this._myExtensions),V=d(i);for(const T of this._myExtensions)V.has(A.ExtensionIdentifier.toKey(T))||_.push(T);for(const T of i)X.has(A.ExtensionIdentifier.toKey(T))||E.push(T);const N={toRemove:t,toAdd:h,myToRemove:_,myToAdd:E};return this.delta(N),N}delta(g){const{toRemove:i,toAdd:t,myToRemove:h,myToAdd:_}=g,E=d(i),O=d(h);for(let $=0;$<this._allExtensions.length;$++)E.has(A.ExtensionIdentifier.toKey(this._allExtensions[$].identifier))&&(this._allExtensions.splice($,1),$--);for(let $=0;$<this._myExtensions.length;$++)O.has(A.ExtensionIdentifier.toKey(this._myExtensions[$]))&&(this._myExtensions.splice($,1),$--);for(const $ of t)this._allExtensions.push($);for(const $ of _)this._myExtensions.push($)}containsExtension(g){for(const i of this._myExtensions)if(A.ExtensionIdentifier.equals(i,g))return!0;return!1}}e.ExtensionHostExtensions=y;class f{constructor(g){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=A.ExtensionIdentifier.toKey,g)for(const i of g)this.add(i)}get size(){return this._map.size}add(g){return this._map.set(this._toKey(g),g),this}clear(){this._map.clear()}delete(g){return this._map.delete(this._toKey(g))}has(g){return this._map.has(this._toKey(g))}forEach(g,i){this._map.forEach(t=>g.call(i,t,t,this))}*entries(){for(const[g,i]of this._map)yield[i,i]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=f;function d(c){const g=new Set;for(const i of c)g.add(A.ExtensionIdentifier.toKey(i));return g}e.extensionIdentifiersArrayToSet=d;function u(c){const g=new Map;for(const i of c)g.set(A.ExtensionIdentifier.toKey(i.identifier),i);return g}function m(c,g){return c.enabledApiProposals?c.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=m;function v(c,g){if(!m(c,g))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=v;class D{constructor(g,i,t,h){this.codeLoadingTime=g,this.activateCallTime=i,this.activateResolvedTime=t,this.activationReason=h}}e.ActivationTimes=D;class p{constructor(g,i){this.description=g,this.value=i}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var n;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,w.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function r(c,g){return{identifier:new A.ExtensionIdentifier((0,w.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!g,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=r;class a{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g,i){return Promise.resolve(0)}getInspectPorts(g,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=a}),define(Se[240],ye([1,0,10,134,27,26,13,19]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(u,m,v,D){this.startup=u,this.codeLoadingTime=m,this.activateCallTime=v,this.activateResolvedTime=D}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,m){return u===-1||m===-1?-1:m-u}build(){return new S(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class L{constructor(u,m,v,D,p,n){this.activationFailed=u,this.activationFailedError=m,this.activationTimes=v,this.module=D,this.exports=p,this.subscriptions=n}}e.ActivatedExtension=L;class k extends L{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class b extends L{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class I extends L{constructor(u){super(!0,u,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(u,m,v,D){this._logService=D,this._registry=u,this._globalRegistry=m,this._host=v,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,m]of this._operations)m.dispose()}isActivated(u){const m=this._operations.get(l.ExtensionIdentifier.toKey(u));return Boolean(m&&m.value)}getActivatedExtension(u){const m=this._operations.get(l.ExtensionIdentifier.toKey(u));if(!m||!m.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return m.value}async activateByEvent(u,m){if(this._alreadyActivatedEvents[u])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(v.map(D=>({id:D.identifier,reason:{startup:m,extensionId:D.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,m){const v=this._registry.getExtensionDescription(u);if(!v)throw new Error(`Extension '${u}' is not known`);return this._activateExtensions([{id:v.identifier,reason:m}])}async _activateExtensions(u){const m=u.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(m.map(v=>v.wait()))}_handleActivationRequest(u){if(this._operations.has(l.ExtensionIdentifier.toKey(u.id)))return this._operations.get(l.ExtensionIdentifier.toKey(u.id));if(this._isHostExtension(u.id))return this._createAndSaveOperation(u,null,[],null);const m=this._registry.getExtensionDescription(u.id);if(!m){const p=new Error(`Cannot activate unknown extension '${u.id.value}'`),n=this._createAndSaveOperation(u,null,[],new I(p));return this._host.onExtensionActivationError(u.id,p,new A.MissingExtensionDependency(u.id.value)),n}const v=[],D=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const p of D){if(this._isResolvedExtension(p))continue;const n=this._operations.get(l.ExtensionIdentifier.toKey(p));if(n){v.push(n);continue}if(this._isHostExtension(p)){v.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(p).identifier,reason:u.reason}));continue}const s=this._registry.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;v.push(this._handleActivationRequest({id:s.identifier,reason:u.reason}));continue}const r=m.displayName||m.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),c=this._createAndSaveOperation(u,m.displayName,[],new I(a));return this._host.onExtensionActivationError(m.identifier,a,new A.MissingExtensionDependency(p)),c}return this._createAndSaveOperation(u,m.displayName,v,null)}_createAndSaveOperation(u,m,v,D){const p=new f(u.id,m,u.reason,v,D,this._host,this._logService);return this._operations.set(l.ExtensionIdentifier.toKey(u.id),p),p}_isHostExtension(u){return R.ExtensionDescriptionRegistry.isHostExtension(u,this._registry,this._globalRegistry)}_isResolvedExtension(u){const m=this._globalRegistry.getExtensionDescription(u);return m?!m.main&&!m.browser:!1}};y=je([Be(3,w.ILogService)],y),e.ExtensionsActivator=y;let f=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(u,m,v,D,p,n,s){this._id=u,this._displayName=m,this._reason=v,this._deps=D,this._value=p,this._host=n,this._logService=s,this._barrier=new P.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const m=this._deps[u];if(m.value&&!m.value.activationFailed){this._deps.splice(u,1),u--;continue}if(m.value&&m.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);v.detail=m.value.activationFailedError,this._value=new I(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const m=new Error;if(u&&u.name&&(m.name=u.name),u&&u.message?m.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:m.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(m.stack=u.stack),this._value=new I(m),this._isDisposed&&o.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,m,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};f=je([Be(6,w.ILogService)],f)});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[7],ye([1,0,16,10,112,28,88,8,9,2,30,44,128,93,26]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y){"use strict";var f,d,u,m,v,D,p,n,s,r,a,c,g,i,t,h,_,E,O,$,H,X,V;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function N(j){return Object.assign(j,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(j,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(j,[]);{const[fe,...ke]=arguments;return Reflect.construct(j,ke,fe.constructor)}}})}var T;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(T=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var F;(function(j){j[j.Command=0]="Command",j[j.Opener=1]="Opener"})(F=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let U=D=class{static from(...W){let fe=W;return new D(function(){if(fe){for(const ke of fe)ke&&typeof ke.dispose=="function"&&ke.dispose();fe=void 0}})}constructor(W){f.set(this,void 0),Je(this,f,W,"f")}dispose(){typeof Ne(this,f,"f")=="function"&&(Ne(this,f,"f").call(this),Je(this,f,void 0,"f"))}};f=new WeakMap,U=D=je([N],U),e.Disposable=U;let Z=p=class{static Min(...W){if(W.length===0)throw new TypeError;let fe=W[0];for(let ke=1;ke<W.length;ke++){const Ge=W[ke];Ge.isBefore(fe)&&(fe=Ge)}return fe}static Max(...W){if(W.length===0)throw new TypeError;let fe=W[0];for(let ke=1;ke<W.length;ke++){const Ge=W[ke];Ge.isAfter(fe)&&(fe=Ge)}return fe}static isPosition(W){if(!W)return!1;if(W instanceof p)return!0;const{line:fe,character:ke}=W;return typeof fe=="number"&&typeof ke=="number"}static of(W){if(W instanceof p)return W;if(this.isPosition(W))return new p(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,fe){if(W<0)throw(0,R.illegalArgument)("line must be non-negative");if(fe<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=W,this._character=fe}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,fe=0){if(W===null||fe===null)throw(0,R.illegalArgument)();let ke;return typeof W>"u"?ke=0:typeof W=="number"?ke=W:(ke=typeof W.lineDelta=="number"?W.lineDelta:0,fe=typeof W.characterDelta=="number"?W.characterDelta:0),ke===0&&fe===0?this:new p(this.line+ke,this.character+fe)}with(W,fe=this.character){if(W===null||fe===null)throw(0,R.illegalArgument)();let ke;return typeof W>"u"?ke=this.line:typeof W=="number"?ke=W:(ke=typeof W.line=="number"?W.line:this.line,fe=typeof W.character=="number"?W.character:this.character),ke===this.line&&fe===this.character?this:new p(ke,fe)}toJSON(){return{line:this.line,character:this.character}}};Z=p=je([N],Z),e.Position=Z;let J=n=class{static isRange(W){return W instanceof n?!0:W?Z.isPosition(W.start)&&Z.isPosition(W.end):!1}static of(W){if(W instanceof n)return W;if(this.isRange(W))return new n(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,fe,ke,Ge){let Ye,ct;if(typeof W=="number"&&typeof fe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(Ye=new Z(W,fe),ct=new Z(ke,Ge)):Z.isPosition(W)&&Z.isPosition(fe)&&(Ye=Z.of(W),ct=Z.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this._start=Ye,this._end=ct):(this._start=ct,this._end=Ye)}contains(W){return n.isRange(W)?this.contains(W.start)&&this.contains(W.end):Z.isPosition(W)?!(Z.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const fe=Z.Max(W.start,this._start),ke=Z.Min(W.end,this._end);if(!fe.isAfter(ke))return new n(fe,ke)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const fe=Z.Min(W.start,this._start),ke=Z.Max(W.end,this.end);return new n(fe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,fe=this.end){if(W===null||fe===null)throw(0,R.illegalArgument)();let ke;return W?Z.isPosition(W)?ke=W:(ke=W.start||this.start,fe=W.end||this.end):ke=this.start,ke.isEqual(this._start)&&fe.isEqual(this.end)?this:new n(ke,fe)}toJSON(){return[this.start,this.end]}};J=n=je([N],J),e.Range=J;let z=s=class extends J{static isSelection(W){return W instanceof s?!0:W?J.isRange(W)&&Z.isPosition(W.anchor)&&Z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,fe,ke,Ge){let Ye,ct;if(typeof W=="number"&&typeof fe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(Ye=new Z(W,fe),ct=new Z(ke,Ge)):Z.isPosition(W)&&Z.isPosition(fe)&&(Ye=Z.of(W),ct=Z.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this._anchor=Ye,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=s=je([N],z),e.Selection=z;class Q{constructor(W,fe,ke){if(typeof W!="string"||W.length===0)throw(0,R.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,R.illegalArgument)("port");if(typeof ke<"u"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z_\-]+$/.test(ke)))throw(0,R.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(fe),this.connectionToken=ke}}e.ResolvedAuthority=Q;class ie extends Error{static NotAvailable(W,fe){return new ie(W,b.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(W){return new ie(W,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,fe=b.RemoteAuthorityResolverErrorCode.Unknown,ke){super(W),this._message=W,this._code=fe,this._detail=ke,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var ge;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var K;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(K=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=r=class{static isTextEdit(W){return W instanceof r?!0:W?J.isRange(W)&&typeof W.newText=="string":!1}static replace(W,fe){return new r(W,fe)}static insert(W,fe){return r.replace(new J(W,W),fe)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const fe=new r(new J(new Z(0,0),new Z(0,0)),"");return fe.newEol=W,fe}get range(){return this._range}set range(W){if(W&&!J.isRange(W))throw(0,R.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,R.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,R.illegalArgument)("newEol");this._newEol=W}constructor(W,fe){this._range=W,this._newText=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Y=r=je([N],Y),e.TextEdit=Y;let ee=a=class{static isNotebookCellEdit(W){return W instanceof a?!0:W?Ht.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,fe){return new a(W,fe)}static insertCells(W,fe){return new a(new Ht(W,W),fe)}static deleteCells(W){return new a(W,[])}static updateCellMetadata(W,fe){const ke=new a(new Ht(W,W),[]);return ke.newCellMetadata=fe,ke}static updateNotebookMetadata(W){const fe=new a(new Ht(0,0),[]);return fe.newNotebookMetadata=W,fe}constructor(W,fe){this.range=W,this.newCells=fe}};ee=a=je([N],ee),e.NotebookEdit=ee;class me{static isSnippetTextEdit(W){return W instanceof me?!0:W?J.isRange(W.range)&&Ae.isSnippetString(W.snippet):!1}static replace(W,fe){return new me(W,fe)}static insert(W,fe){return me.replace(new J(W,W),fe)}constructor(W,fe){this.range=W,this.snippet=fe}}e.SnippetTextEdit=me;var be;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(be=e.FileEditType||(e.FileEditType={}));let De=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,fe,ke,Ge){this._edits.push({_type:1,from:W,to:fe,options:ke,metadata:Ge})}createFile(W,fe,ke){this._edits.push({_type:1,from:void 0,to:W,options:fe,metadata:ke})}deleteFile(W,fe,ke){this._edits.push({_type:1,from:W,to:void 0,options:fe,metadata:ke})}replaceNotebookMetadata(W,fe,ke){this._edits.push({_type:3,metadata:ke,uri:W,edit:{editType:5,metadata:fe},notebookMetadata:fe})}replaceNotebookCells(W,fe,ke,Ge){const Ye=fe.start,ct=fe.end;(Ye!==ct||ke.length>0)&&this._edits.push({_type:5,uri:W,index:Ye,count:ct-Ye,cells:ke,metadata:Ge})}replaceNotebookCellMetadata(W,fe,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:W,edit:{editType:8,index:fe,metadata:ke}})}replace(W,fe,ke,Ge){this._edits.push({_type:2,uri:W,edit:new Y(fe,ke),metadata:Ge})}insert(W,fe,ke,Ge){this.replace(W,new J(fe,fe),ke,Ge)}delete(W,fe,ke){this.replace(W,fe,"",ke)}has(W){return this._edits.some(fe=>fe._type===2&&fe.uri.toString()===W.toString())}set(W,fe){if(fe)for(const ke of fe){if(!ke)continue;let Ge,Ye;Array.isArray(ke)?(Ge=ke[0],Ye=ke[1]):Ge=ke,ee.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.replaceNotebookCellMetadata(W,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.replaceNotebookMetadata(W,Ge.newNotebookMetadata,Ye):this.replaceNotebookCells(W,Ge.range,Ge.newCells,Ye):me.isSnippetTextEdit(Ge)?this._edits.push({_type:6,uri:W,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this._edits.push({_type:2,uri:W,edit:Ge,metadata:Ye})}else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===W.toString()&&(this._edits[ke]=void 0);break}}(0,o.coalesceInPlace)(this._edits)}}get(W){const fe=[];for(const ke of this._edits)ke._type===2&&ke.uri.toString()===W.toString()&&fe.push(ke.edit);return fe}entries(){const W=new A.ResourceMap;for(const fe of this._edits)if(fe._type===2){let ke=W.get(fe.uri);ke||(ke=[fe.uri,[]],W.set(fe.uri,ke)),ke[1].push(fe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};De=je([N],De),e.WorkspaceEdit=De;let Ae=c=class{static isSnippetString(W){return W instanceof c?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=c._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,fe=this._tabstop++){if(typeof W=="function"){const ke=new c;ke._tabstop=this._tabstop,W(ke),this._tabstop=ke._tabstop,W=ke.value}else W=c._escape(W);return this.value+="${",this.value+=fe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,fe=this._tabstop++){const ke=W.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(W,fe){if(typeof fe=="function"){const ke=new c;ke._tabstop=this._tabstop,fe(ke),this._tabstop=ke._tabstop,fe=ke.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};Ae=c=je([N],Ae),e.SnippetString=Ae;var ae;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ae=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=g=class{static isLocation(W){return W instanceof g?!0:W?J.isRange(W.range)&&C.URI.isUri(W.uri):!1}constructor(W,fe){if(this.uri=W,fe)if(J.isRange(fe))this.range=J.of(fe);else if(Z.isPosition(fe))this.range=new J(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ue=g=je([N],ue),e.Location=ue;let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&J.isRange(W.location.range)&&C.URI.isUri(W.location.uri):!1}constructor(W,fe){this.location=W,this.message=fe}static isEqual(W,fe){return W===fe?!0:!W||!fe?!1:W.message===fe.message&&W.location.range.isEqual(fe.location.range)&&W.location.uri.toString()===fe.location.uri.toString()}};ne=je([N],ne),e.DiagnosticRelatedInformation=ne;let ce=class{constructor(W,fe,ke=le.Error){if(!J.isRange(W))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=W,this.message=fe,this.severity=ke}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,fe){return W===fe?!0:!W||!fe?!1:W.message===fe.message&&W.severity===fe.severity&&W.code===fe.code&&W.severity===fe.severity&&W.source===fe.source&&W.range.isEqual(fe.range)&&(0,o.equals)(W.tags,fe.tags)&&(0,o.equals)(W.relatedInformation,fe.relatedInformation,ne.isEqual)}};ce=je([N],ce),e.Diagnostic=ce;let oe=class{constructor(W,fe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=fe}};oe=je([N],oe),e.Hover=oe;var M;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(M=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let B=class{constructor(W,fe=M.Text){this.range=W,this.kind=fe}toJSON(){return{range:this.range,kind:M[this.kind]}}};B=je([N],B),e.DocumentHighlight=B;var q;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(q=e.SymbolKind||(e.SymbolKind={}));var te;(function(j){j[j.Deprecated=1]="Deprecated"})(te=e.SymbolTag||(e.SymbolTag={}));let de=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,fe,ke,Ge,Ye){this.name=W,this.kind=fe,this.containerName=Ye,typeof ke=="string"&&(this.containerName=ke),Ge instanceof ue?this.location=Ge:ke instanceof J&&(this.location=new ue(Ge,ke)),i.validate(this)}toJSON(){return{name:this.name,kind:q[this.kind],location:this.location,containerName:this.containerName}}};de=i=je([N],de),e.SymbolInformation=de;let Ee=t=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(t.validate)}constructor(W,fe,ke,Ge,Ye){this.name=W,this.detail=fe,this.kind=ke,this.range=Ge,this.selectionRange=Ye,this.children=[],t.validate(this)}};Ee=t=je([N],Ee),e.DocumentSymbol=Ee;var Te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ve=class{constructor(W,fe){this.title=W,this.kind=fe}};ve=je([N],ve),e.CodeAction=ve;let Ce=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.sep)}};Ce.sep=".",Ce=h=je([N],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let Ie=class{constructor(W,fe){if(this.range=W,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ie=je([N],Ie),e.SelectionRange=Ie;class ze{constructor(W,fe,ke,Ge,Ye,ct){this.kind=W,this.name=fe,this.detail=ke,this.uri=Ge,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=ze;class qe{constructor(W,fe){this.fromRanges=fe,this.from=W}}e.CallHierarchyIncomingCall=qe;class nt{constructor(W,fe){this.fromRanges=fe,this.to=W}}e.CallHierarchyOutgoingCall=nt;var Xe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(W,fe){this.range=W,this.command=fe}get isResolved(){return!!this.command}};tt=je([N],tt),e.CodeLens=tt;let rt=_=class{static isMarkdownString(W){return W instanceof _?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,fe=!1){d.set(this,void 0),Je(this,d,new l.MarkdownString(W,{supportThemeIcons:fe}),"f")}get value(){return Ne(this,d,"f").value}set value(W){Ne(this,d,"f").value=W}get isTrusted(){return Ne(this,d,"f").isTrusted}set isTrusted(W){Ne(this,d,"f").isTrusted=W}get supportThemeIcons(){return Ne(this,d,"f").supportThemeIcons}set supportThemeIcons(W){Ne(this,d,"f").supportThemeIcons=W}get supportHtml(){return Ne(this,d,"f").supportHtml}set supportHtml(W){Ne(this,d,"f").supportHtml=W}get baseUri(){return Ne(this,d,"f").baseUri}set baseUri(W){Ne(this,d,"f").baseUri=W}appendText(W){return Ne(this,d,"f").appendText(W),this}appendMarkdown(W){return Ne(this,d,"f").appendMarkdown(W),this}appendCodeblock(W,fe){return Ne(this,d,"f").appendCodeblock(fe??"",W),this}};d=new WeakMap,rt=_=je([N],rt),e.MarkdownString=rt;let Ue=class{constructor(W,fe){this.label=W,this.documentation=fe}};Ue=je([N],Ue),e.ParameterInformation=Ue;let it=class{constructor(W,fe){this.label=W,this.documentation=fe,this.parameters=[]}};it=je([N],it),e.SignatureInformation=it;let x=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};x=je([N],x),e.SignatureHelp=x;var G;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(G=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Re=class{constructor(W){this.value=W}};Re=je([N],Re),e.InlayHintLabelPart=Re;let Oe=class{constructor(W,fe,ke){this.position=W,this.label=fe,this.kind=ke}};Oe=je([N],Oe),e.InlayHint=Oe;var Ve;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(j){j[j.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let st=class{constructor(W,fe){this.label=W,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};st=je([N],st),e.CompletionItem=st;let at=class{constructor(W=[],fe=!1){this.items=W,this.isIncomplete=fe}};at=je([N],at),e.CompletionList=at;let mt=class{constructor(W,fe,ke){this.insertText=W,this.range=fe,this.command=ke}};mt=je([N],mt),e.InlineSuggestion=mt;let gt=class{constructor(W){this.commands=void 0,this.items=W}};gt=je([N],gt),e.InlineSuggestionList=gt;var wt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(wt=e.ViewColumn||(e.ViewColumn={}));var lt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var jt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(jt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var $t;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})($t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var It;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(fe){switch(fe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ut=class{constructor(W,fe){if(fe&&!C.URI.isUri(fe))throw(0,R.illegalArgument)("target");if(!J.isRange(W)||W.isEmpty)throw(0,R.illegalArgument)("range");this.range=W,this.target=fe}};Ut=je([N],Ut),e.DocumentLink=Ut;let Pt=class{constructor(W,fe,ke,Ge){this.red=W,this.green=fe,this.blue=ke,this.alpha=Ge}};Pt=je([N],Pt),e.Color=Pt;let Ke=class{constructor(W,fe){if(fe&&!(fe instanceof Pt))throw(0,R.illegalArgument)("color");if(!J.isRange(W)||W.isEmpty)throw(0,R.illegalArgument)("range");this.range=W,this.color=fe}};Ke=je([N],Ke),e.ColorInformation=Ke;let Ot=class{constructor(W){if(!W||typeof W!="string")throw(0,R.illegalArgument)("label");this.label=W}};Ot=je([N],Ot),e.ColorPresentation=Ot;var qt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(qt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var vt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(vt=e.TerminalExitReason||(e.TerminalExitReason={}));class Pe{constructor(W,fe,ke){if(this.startIndex=W,this.length=fe,this.tooltip=ke,typeof W!="number"||W<0)throw(0,R.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,R.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Pe;class Le{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Le;class _e{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=_e;var se;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(se=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(W){if(this.options=W,typeof W!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Fe;var We;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(We=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let He=E=class{static from(W){switch(W){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(W,fe){if(this.label=fe,typeof W!="string"||typeof fe!="string")throw(0,R.illegalArgument)("name");this._id=W}get id(){return this._id}};He.Clean=new E("clean","Clean"),He.Build=new E("build","Build"),He.Rebuild=new E("rebuild","Rebuild"),He.Test=new E("test","Test"),He=E=je([N],He),e.TaskGroup=He;function et(j){let W="";for(let fe=0;fe<j.length;fe++)W+=j[fe].replace(/,/g,",,")+",";return W}let ut=class{constructor(W,fe,ke){if(typeof W!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=W,fe!==void 0&&(Array.isArray(fe)?(this._args=fe,this._options=ke):this._options=fe)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,R.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const fe of this._args)W.push(fe);return et(W)}};ut=je([N],ut),e.ProcessExecution=ut;let Tt=class{constructor(W,fe,ke){if(this._args=[],Array.isArray(fe)){if(!W)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,R.illegalArgument)("command");this._command=W,this._args=fe,this._options=ke}else{if(typeof W!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=W,this._options=fe}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,R.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const fe of this._args)W.push(typeof fe=="string"?fe:fe.value);return et(W)}};Tt=je([N],Tt),e.ShellExecution=Tt;var _t;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(_t=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class Et{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Et;let At=O=class{constructor(W,fe,ke,Ge,Ye,ct){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof fe=="string"?(this._name=this.name=fe,this._source=this.source=ke,this.execution=Ge,ht=Ye,this.__deprecated=!0):fe===yt.Global||fe===yt.Workspace?(this.target=fe,this._name=this.name=ke,this._source=this.source=Ge,this.execution=Ye,ht=ct):(this.target=fe,this._name=this.name=ke,this._source=this.source=Ge,this.execution=Ye,ht=ct),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ut?this._definition={type:O.ProcessType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:O.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:O.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:O.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const fe=this._definition.type;(O.EmptyType===fe||O.ProcessType===fe||O.ShellType===fe||O.ExtensionCallbackType===fe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};At.ExtensionCallbackType="customExecution",At.ProcessType="process",At.ShellType="shell",At.EmptyType="$empty",At=O=je([N],At),e.Task=At;var St;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));var ri;(function(j){function W(fe){const ke=fe;return(0,S.isNumber)(ke.value)?ke.tooltip&&!(0,S.isString)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=W})(ri=e.ViewBadge||(e.ViewBadge={}));let ei=$=class{static isTreeItem(W,fe){const ke=W;if(ke.checkboxState!==void 0){(0,y.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ge=(0,S.isNumber)(ke.checkboxState)?ke.checkboxState:(0,S.isObject)(ke.checkboxState)&&(0,S.isNumber)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ye=!(0,S.isNumber)(ke.checkboxState)&&(0,S.isObject)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==si.Checked&&Ge!==si.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(W instanceof $)return!0;if(ke.label!==void 0&&!(0,S.isString)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,S.isString)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,S.isString)(ke.iconPath)&&!C.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,S.isString)(ke.iconPath.id))){const Ge=ke.iconPath;if(!Ge||!(0,S.isString)(Ge.light)&&!C.URI.isUri(Ge.light)&&!(0,S.isString)(Ge.dark)&&!C.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,S.isString)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!C.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,S.isString)(ke.tooltip)&&!(ke.tooltip instanceof rt)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Ct.None&&ke.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,S.isString)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(W,fe=Ct.None){this.collapsibleState=fe,C.URI.isUri(W)?this.resourceUri=W:this.label=W}};ei=$=je([N],ei),e.TreeItem=ei;var Ct;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,fe){this.value=W,this.id=fe??(0,L.generateUuid)()}};oi=je([N],oi),e.DataTransferItem=oi;let Yt=class{constructor(W){u.set(this,new Map);for(const[fe,ke]of W??[]){const Ge=Ne(this,u,"f").get(fe);Ge?Ge.push(ke):Ne(this,u,"f").set(fe,[ke])}}get(W){return Ne(this,u,"f").get(W)?.[0]}set(W,fe){Ne(this,u,"f").set(W,[fe])}forEach(W,fe){for(const[ke,Ge]of Ne(this,u,"f"))for(const Ye of Ge)W.call(fe,Ye,ke,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[W,fe]of Ne(this,u,"f"))for(const ke of fe)yield[W,ke]}};Yt=je([N],Yt),e.DataTransfer=Yt;let vi=class{constructor(W){this.insertText=W}};vi=je([N],vi),e.DocumentDropEdit=vi;let Rt=class{constructor(W){this.insertText=W}};Rt=je([N],Rt),e.DocumentPasteEdit=Rt;let Bt=class{constructor(W,fe){this.id=W,this.color=fe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Bt=je([N],Bt),e.ThemeIcon=Bt,Bt.File=new Bt("file"),Bt.Folder=new Bt("folder");let bi=class{constructor(W){this.id=W}};bi=je([N],bi),e.ThemeColor=bi;var ai;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=C.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,fe){if(typeof W!="string"&&(!W||!C.URI.isUri(W)&&!C.URI.isUri(W.uri)))throw(0,R.illegalArgument)("base");if(typeof fe!="string")throw(0,R.illegalArgument)("pattern");typeof W=="string"?this.baseUri=C.URI.file(W):C.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=je([N],Jt),e.RelativePattern=Jt;const dt=new WeakMap;function Ui(j,W){dt.set(j,W)}e.setBreakpointId=Ui;let Nt=class{constructor(W,fe,ke,Ge){this.enabled=typeof W=="boolean"?W:!0,typeof fe=="string"&&(this.condition=fe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=dt.get(this)??(0,L.generateUuid)()),this._id}};Nt=je([N],Nt),e.Breakpoint=Nt;let Kt=class extends Nt{constructor(W,fe,ke,Ge,Ye){if(super(fe,ke,Ge,Ye),W===null)throw(0,R.illegalArgument)("location");this.location=W}};Kt=je([N],Kt),e.SourceBreakpoint=Kt;let ci=class extends Nt{constructor(W,fe,ke,Ge,Ye){super(fe,ke,Ge,Ye),this.functionName=W}};ci=je([N],ci),e.FunctionBreakpoint=ci;let Ei=class extends Nt{constructor(W,fe,ke,Ge,Ye,ct,ht){if(super(Ge,Ye,ct,ht),!fe)throw(0,R.illegalArgument)("dataId");this.label=W,this.dataId=fe,this.canPersist=ke}};Ei=je([N],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(W,fe,ke){this.command=W,this.args=fe||[],this.options=ke}};wi=je([N],wi),e.DebugAdapterExecutable=wi;let li=class{constructor(W,fe){this.port=W,this.host=fe}};li=je([N],li),e.DebugAdapterServer=li;let _i=class{constructor(W){this.path=W}};_i=je([N],_i),e.DebugAdapterNamedPipeServer=_i;let ui=class{constructor(W){this.implementation=W}};ui=je([N],ui),e.DebugAdapterInlineImplementation=ui;let Zt=class{constructor(W,fe){this.range=W,this.expression=fe}};Zt=je([N],Zt),e.EvaluatableExpression=Zt;var xi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(xi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(W,fe){this.range=W,this.text=fe}};ti=je([N],ti),e.InlineValueText=ti;let ii=class{constructor(W,fe,ke=!0){this.range=W,this.variableName=fe,this.caseSensitiveLookup=ke}};ii=je([N],ii),e.InlineValueVariableLookup=ii;let Si=class{constructor(W,fe){this.range=W,this.expression=fe}};Si=je([N],Si),e.InlineValueEvaluatableExpression=Si;let yi=class{constructor(W,fe){this.frameId=W,this.stoppedLocation=fe}};yi=je([N],yi),e.InlineValueContext=yi;var ni;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(ni=e.FileChangeType||(e.FileChangeType={}));let Ci=H=class extends Error{static FileExists(W){return new H(W,k.FileSystemProviderErrorCode.FileExists,H.FileExists)}static FileNotFound(W){return new H(W,k.FileSystemProviderErrorCode.FileNotFound,H.FileNotFound)}static FileNotADirectory(W){return new H(W,k.FileSystemProviderErrorCode.FileNotADirectory,H.FileNotADirectory)}static FileIsADirectory(W){return new H(W,k.FileSystemProviderErrorCode.FileIsADirectory,H.FileIsADirectory)}static NoPermissions(W){return new H(W,k.FileSystemProviderErrorCode.NoPermissions,H.NoPermissions)}static Unavailable(W){return new H(W,k.FileSystemProviderErrorCode.Unavailable,H.Unavailable)}constructor(W,fe=k.FileSystemProviderErrorCode.Unknown,ke){super(C.URI.isUri(W)?W.toString(!0):W),this.code=ke?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,H.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};Ci=H=je([N],Ci),e.FileSystemError=Ci;let Di=class{constructor(W,fe,ke){this.start=W,this.end=fe,this.kind=ke}};Di=je([N],Di),e.FoldingRange=Di;var Bi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(zi=e.CommentMode||(e.CommentMode={}));var Ii;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Ii=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(W,fe=[]){this.tokenTypes=W,this.tokenModifiers=fe}}e.SemanticTokensLegend=Ai;function Ri(j){return typeof j>"u"||(0,S.isStringArray)(j)}class xe{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let fe=0,ke=W.tokenTypes.length;fe<ke;fe++)this._tokenTypeStrToInt.set(W.tokenTypes[fe],fe);for(let fe=0,ke=W.tokenModifiers.length;fe<ke;fe++)this._tokenModifierStrToInt.set(W.tokenModifiers[fe],fe)}}push(W,fe,ke,Ge,Ye){if(typeof W=="number"&&typeof fe=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(W,fe,ke,Ge,Ye);if(J.isRange(W)&&typeof fe=="string"&&Ri(ke))return this._push(W,fe,ke);throw(0,R.illegalArgument)()}_push(W,fe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ge=W.start.line,Ye=W.start.character,ct=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(fe);let Mt=0;if(ke)for(const zt of ke){if(!this._tokenModifierStrToInt.has(zt))throw new Error("`tokenModifier` is not in the provided legend");const Vt=this._tokenModifierStrToInt.get(zt);Mt|=1<<Vt>>>0}this._pushEncoded(Ge,Ye,ct,ht,Mt)}_pushEncoded(W,fe,ke,Ge,Ye){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&fe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Mt=this._data.length/5|0;let zt=0,Vt=0;for(let Gt=0;Gt<Mt;Gt++){let Xt=this._data[5*Gt],Ti=this._data[5*Gt+1];Xt===0?(Xt=zt,Ti+=Vt):Xt+=zt,this._data[5*Gt]=Xt,this._data[5*Gt+1]=Ti,zt=Xt,Vt=Ti}}let ct=W,ht=fe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Ye,this._prevLine=W,this._prevChar=fe}static _sortAndDeltaEncode(W){const fe=[],ke=W.length/5|0;for(let ht=0;ht<ke;ht++)fe[ht]=ht;fe.sort((ht,Mt)=>{const zt=W[5*ht],Vt=W[5*Mt];if(zt===Vt){const Gt=W[5*ht+1],Xt=W[5*Mt+1];return Gt-Xt}return zt-Vt});const Ge=new Uint32Array(W.length);let Ye=0,ct=0;for(let ht=0;ht<ke;ht++){const Mt=5*fe[ht],zt=W[Mt+0],Vt=W[Mt+1],Gt=W[Mt+2],Xt=W[Mt+3],Ti=W[Mt+4],sn=zt-Ye,An=sn===0?Vt-ct:Vt,Pi=5*ht;Ge[Pi+0]=sn,Ge[Pi+1]=An,Ge[Pi+2]=Gt,Ge[Pi+3]=Xt,Ge[Pi+4]=Ti,Ye=zt,ct=Vt}return Ge}build(W){return this._dataIsSortedAndDeltaEncoded?new Wt(new Uint32Array(this._data),W):new Wt(xe._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=xe;class Wt{constructor(W,fe){this.resultId=fe,this.data=W}}e.SemanticTokens=Wt;class Li{constructor(W,fe,ke){this.start=W,this.deleteCount=fe,this.data=ke}}e.SemanticTokensEdit=Li;class bt{constructor(W,fe){this.resultId=fe,this.edits=W}}e.SemanticTokensEdits=bt;var $i;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})($i=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Bt("arrow-left")},di=je([N],di),e.QuickInputButtons=di;var Oi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Oi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Hi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Hi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class Vi{static validate(W){if(typeof W.badge=="string"){let fe=(0,P.nextCharLength)(W.badge,0);if(fe<W.badge.length&&(fe+=(0,P.nextCharLength)(W.badge,fe)),W.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Bt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,fe,ke){this.badge=W,this.tooltip=fe,this.color=ke}}e.FileDecoration=Vi;let ki=class{constructor(W){this.kind=W}};ki=je([N],ki),e.ColorTheme=ki;var ji;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(ji=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{static isNotebookRange(W){return W instanceof Ht?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,fe){if(W<0)throw(0,R.illegalArgument)("start must be positive");if(fe<0)throw(0,R.illegalArgument)("end must be positive");W<=fe?(this._start=W,this._end=fe):(this._start=fe,this._end=W)}with(W){let fe=this._start,ke=this._end;return W.start!==void 0&&(fe=W.start),W.end!==void 0&&(ke=W.end),fe===this._start&&ke===this._end?this:new Ht(fe,ke)}}e.NotebookRange=Ht;class fi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(fe=>fi.isNotebookCellData(fe))}static isNotebookCellData(W){return!0}constructor(W,fe,ke,Ge,Ye,ct,ht){this.kind=W,this.value=fe,this.languageId=ke,this.mime=Ge,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=ht,fi.validate(this)}}e.NotebookCellData=fi;class qi{constructor(W){this.cells=W}}e.NotebookData=qi;class xt{static isNotebookCellOutputItem(W){return W instanceof xt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const fe={name:W.name,message:W.message,stack:W.stack};return xt.json(fe,"application/vnd.code.notebook.error")}static stdout(W){return xt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return xt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,fe="application/octet-stream"){return new xt(W,fe)}static text(W,fe=w.Mimes.text){const ke=Ne(xt,m,"f",v).encode(String(W));return new xt(ke,fe)}static json(W,fe="text/x-json"){const ke=JSON.stringify(W,void 0,"	");return xt.text(ke,fe)}constructor(W,fe){this.data=W,this.mime=fe;const ke=(0,w.normalizeMimeType)(fe,!0);if(!ke)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}m=xt,v={value:new TextEncoder},e.NotebookCellOutputItem=xt;class mi{static isNotebookCellOutput(W){return W instanceof mi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,fe=!1){const ke=new Set,Ge=new Set;for(let Ye=0;Ye<W.length;Ye++){const ct=W[Ye],ht=(0,w.normalizeMimeType)(ct.mime);if(!ke.has(ht)||(0,I.isTextStreamMime)(ht)){ke.add(ht);continue}Ge.add(Ye),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ge.size===0?W:W.filter((Ye,ct)=>!Ge.has(ct))}constructor(W,fe,ke){this.items=mi.ensureUniqueMimeTypes(W,!0),typeof fe=="string"?(this.id=fe,this.metadata=ke):(this.id=(0,L.generateUuid)(),this.metadata=fe??ke)}}e.NotebookCellOutput=mi;var Gi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ki;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(pe=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var we;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(we=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(W,fe){this.text=W,this.alignment=fe}}e.NotebookCellStatusBarItem=Me;var ot;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Lt{constructor(W,fe=[]){this.uri=W,this.provides=(0,o.asArray)(fe)}}e.NotebookRendererScript=Lt;class ln{constructor(W){this.label=W}}e.NotebookKernelSourceAction=ln;let Xi=class{constructor(W,fe){this.label=W,this.timestamp=fe}};Xi=je([N],Xi),e.TimelineItem=Xi;var un;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(W,fe){this.ranges=W,this.wordPattern=fe}}e.LinkedEditingRanges=fn;class mn{constructor(W,fe){this._port=W,this._autoForwardAction=fe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=mn;var gn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(W=void 0,fe=void 0,ke=void 0){this.include=W,this.exclude=fe,this.profile=ke}};Fi=je([N],Fi),e.TestRunRequest=Fi;let Qi=class extends Fi{constructor(W=void 0,fe=void 0,ke=void 0,Ge=!1){super(W,fe,ke),this.continuous=Ge}};Qi=je([N],Qi),e.TestRunRequest2=Qi;let Yi=X=class{static diff(W,fe,ke){const Ge=new X(W);return Ge.expectedOutput=fe,Ge.actualOutput=ke,Ge}constructor(W){this.message=W}};Yi=X=je([N],Yi),e.TestMessage=Yi;let Ji=class{constructor(W){this.id=W}};Ji=je([N],Ji),e.TestTag=Ji;let gi=class{constructor(W,fe){this.covered=W,this.total=fe}};gi=je([N],gi),e.CoveredCount=gi;let Zi=V=class{static fromDetails(W,fe){const ke=new gi(0,0),Ge=new gi(0,0),Ye=new gi(0,0);for(const ht of fe)if("branches"in ht){ke.total+=1,ke.covered+=ht.executionCount>0?1:0;for(const Mt of ht.branches)Ge.total+=1,Ge.covered+=Mt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ht.executionCount>0?1:0;const ct=new V(W,ke,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=fe,ct}constructor(W,fe,ke,Ge){this.uri=W,this.statementCoverage=fe,this.branchCoverage=ke,this.functionCoverage=Ge}};Zi=V=je([N],Zi),e.FileCoverage=Zi;let en=class{constructor(W,fe,ke=[]){this.executionCount=W,this.location=fe,this.branches=ke}};en=je([N],en),e.StatementCoverage=en;let tn=class{constructor(W,fe){this.executionCount=W,this.location=fe}};tn=je([N],tn),e.BranchCoverage=tn;let nn=class{constructor(W,fe){this.executionCount=W,this.location=fe}};nn=je([N],nn),e.FunctionCoverage=nn;var vn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(W,fe,ke,Ge,Ye,ct){this.kind=W,this.name=fe,this.detail=ke,this.uri=Ge,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=wn;class _n{constructor(W){this.uri=W}}e.TextTabInput=_n;class Sn{constructor(W,fe){this.original=W,this.modified=fe}}e.TextDiffTabInput=Sn;class yn{constructor(W,fe,ke,Ge){this.base=W,this.input1=fe,this.input2=ke,this.result=Ge}}e.TextMergeTabInput=yn;class Cn{constructor(W,fe){this.uri=W,this.viewType=fe}}e.CustomEditorTabInput=Cn;class Dn{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Dn;class In{constructor(W,fe){this.uri=W,this.notebookType=fe}}e.NotebookEditorTabInput=In;class kn{constructor(W,fe,ke){this.original=W,this.modified=fe,this.notebookType=ke}}e.NotebookDiffEditorTabInput=kn;class Tn{constructor(){}}e.TerminalEditorTabInput=Tn;class Pn{constructor(W,fe){this.uri=W,this.inputBoxUri=fe}}e.InteractiveWindowInput=Pn}),define(Se[135],ye([1,0,50,15,8,165,106,7,16]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function L(y,f){f?C.set(y,f):C.delete(y)}e.setWordDefinitionFor=L;function k(y){return C.get(y)}class b extends A.MirrorTextModel{constructor(f,d,u,m,v,D,p,n){super(d,u,m,v),this._proxy=f,this._languageId=D,this._isDirty=p,this.notebook=n,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,S.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===R.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},save(){return f._save()},getText(d){return d?f._getTextInRange(d):f.getText()},get eol(){return f._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(d){return f._lineAt(d)},offsetAt(d){return f._offsetAt(d)},positionAt(d){return f._positionAt(d)},validateRange(d){return f._validateRange(d)},validatePosition(d){return f._validatePosition(d)},getWordRangeAtPosition(d,u){return f._getWordRangeAtPosition(d,u)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,o.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,o.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const d=this._validateRange(f);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const u=this._eol,m=d.start.line,v=d.end.line,D=[];D.push(this._lines[m].substring(d.start.character));for(let p=m+1;p<v;p++)D.push(this._lines[p]);return D.push(this._lines[v].substring(0,d.end.character)),D.join(u)}_lineAt(f){let d;if(f instanceof P.Position?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new I(d,this._lines[d],d===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(f),u=this._lines[d.index].length;return new P.Position(d.index,Math.min(d.remainder,u))}_validateRange(f){if(!(f instanceof P.Range))throw new Error("Invalid argument");const d=this._validatePosition(f.start),u=this._validatePosition(f.end);return d===f.start&&u===f.end?f:new P.Range(d.line,d.character,u.line,u.character)}_validatePosition(f){if(!(f instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:d,character:u}=f,m=!1;if(d<0)d=0,u=0,m=!0;else if(d>=this._lines.length)d=this._lines.length-1,u=this._lines[d].length,m=!0;else{const v=this._lines[d].length;u<0?(u=0,m=!0):u>v&&(u=v,m=!0)}return m?new P.Position(d,u):f}_getWordRangeAtPosition(f,d){const u=this._validatePosition(f);if(!d)d=k(this._languageId);else if((0,l.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const m=(0,w.getWordAtText)(u.character+1,(0,w.ensureValidWordDefinition)(d),this._lines[u.line],0);if(m)return new P.Range(u.line,m.startColumn-1,u.line,m.endColumn-1)}}e.ExtHostDocumentData=b;class I{constructor(f,d,u){this._line=f,this._text=d,this._isLastLine=u}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(Se[241],ye([1,0,7,20,3]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new l.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let S;switch(P){case"light":S=o.ColorThemeKind.Light;break;case"hcDark":S=o.ColorThemeKind.HighContrast;break;case"hcLight":S=o.ColorThemeKind.HighContrastLight;break;default:S=o.ColorThemeKind.Dark}this._actual=new o.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([Be(0,R.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Se[14],ye([1,0,16,22,149,63,112,28,147,69,88,23,9,2,32,72,124,132,130,93,57,76,237,7]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Pe){function Le(se){const{selectionStartLineNumber:Fe,selectionStartColumn:We,positionLineNumber:Qe,positionColumn:He}=se,et=new s.Position(Fe-1,We-1),ut=new s.Position(Qe-1,He-1);return new s.Selection(et,ut)}Pe.to=Le;function _e(se){const{anchor:Fe,active:We}=se;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Pe.from=_e})(r=e.Selection||(e.Selection={}));var a;(function(Pe){function Le(se){if(!se)return;const{start:Fe,end:We}=se;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Pe.from=Le;function _e(se){if(!se)return;const{startLineNumber:Fe,startColumn:We,endLineNumber:Qe,endColumn:He}=se;return new s.Range(Fe-1,We-1,Qe-1,He-1)}Pe.to=_e})(a=e.Range||(e.Range={}));var c;(function(Pe){function Le(_e){switch(_e){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Pe.to=Le})(c=e.TokenType||(e.TokenType={}));var g;(function(Pe){function Le(se){return new s.Position(se.lineNumber-1,se.column-1)}Pe.to=Le;function _e(se){return{lineNumber:se.line+1,column:se.character+1}}Pe.from=_e})(g=e.Position||(e.Position={}));var i;(function(Pe){function Le(Fe,We){return(0,o.coalesce)((0,o.asArray)(Fe).map(Qe=>_e(Qe,We)))}Pe.from=Le;function _e(Fe,We){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:se(Fe.scheme,We),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function se(Fe,We){return We&&typeof Fe=="string"?We.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Pe){function Le(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function _e(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Pe.to=_e})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Pe){function Le(se){let Fe;return se.code&&((0,b.isString)(se.code)||(0,b.isNumber)(se.code)?Fe=String(se.code):Fe={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Fe,severity:E.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(_.from),tags:Array.isArray(se.tags)?(0,o.coalesce)(se.tags.map(t.from)):void 0}}Pe.from=Le;function _e(se){const Fe=new s.Diagnostic(a.to(se),se.message,E.to(se.severity));return Fe.source=se.source,Fe.code=(0,b.isString)(se.code)?se.code:se.code?.value,Fe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(_.to),Fe.tags=se.tags&&(0,o.coalesce)(se.tags.map(t.to)),Fe}Pe.to=_e})(h=e.Diagnostic||(e.Diagnostic={}));var _;(function(Pe){function Le(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Pe.from=Le;function _e(se){return new s.DiagnosticRelatedInformation(new s.Location(se.resource,a.to(se)),se.message)}Pe.to=_e})(_=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var E;(function(Pe){function Le(se){switch(se){case s.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Pe.from=Le;function _e(se){switch(se){case d.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Pe.to=_e})(E=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Pe){function Le(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Pe.from=Le;function _e(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=_e})(O=e.ViewColumn||(e.ViewColumn={}));function $(Pe){return typeof Pe.range<"u"}function H(Pe){return Pe.length===0?!0:!!$(Pe[0])}e.isDecorationOptionsArr=H;var X;(function(Pe){function Le(He){return He.map(Pe.from)}Pe.fromMany=Le;function _e(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function se(He){let et;if(_e(He)){const{language:yt,value:Et}=He;et={value:"```"+yt+`
`+Et+"\n```\n"}}else s.MarkdownString.isMarkdownString(He)?et={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?et={value:He}:et={value:""};const ut=Object.create(null);et.uris=ut;const Tt=yt=>{try{let Et=I.URI.parse(yt,!0);Et=Et.with({query:Fe(Et.query,ut)}),ut[yt]=Et}catch{}return""},_t=new S.marked.Renderer;return _t.link=Tt,_t.image=yt=>typeof yt=="string"?Tt(w.parseHrefAndDimensions(yt).href):"",(0,S.marked)(et.value,{renderer:_t}),et}Pe.from=se;function Fe(He,et){if(!He)return He;let ut;try{ut=(0,C.parse)(He)}catch{}if(!ut)return He;let Tt=!1;return ut=(0,k.cloneAndChange)(ut,_t=>{if(I.URI.isUri(_t)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[yt]=_t,Tt=!0,yt}else return}),Tt?JSON.stringify(ut):He}function We(He){const et=new s.MarkdownString(He.value,He.supportThemeIcons);return et.isTrusted=He.isTrusted,et.supportHtml=He.supportHtml,et.baseUri=He.baseUri?I.URI.from(He.baseUri):void 0,et}Pe.to=We;function Qe(He){if(!!He)return typeof He=="string"?He:Pe.from(He)}Pe.fromStrict=Qe})(X=e.MarkdownString||(e.MarkdownString={}));function V(Pe){return H(Pe)?Pe.map(Le=>({range:a.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?X.fromMany(Le.hoverMessage):Le.hoverMessage?X.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:a.from(Le)}))}e.fromRangeOrRangeWithMessage=V;function N(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?I.URI.file(Pe):Pe}e.pathOrURIToURI=N;var T;(function(Pe){function Le(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?N(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Pe.from=Le})(T=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Pe){function Le(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?N(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?T.from(_e.before):void 0,after:_e.after?T.from(_e.after):void 0}}Pe.from=Le})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(Pe){function Le(_e){if(typeof _e>"u")return _e;switch(_e){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Z;(function(Pe){function Le(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?U.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?F.from(_e.light):void 0,dark:_e.dark?F.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?N(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?T.from(_e.before):void 0,after:_e.after?T.from(_e.after):void 0}}Pe.from=Le})(Z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var J;(function(Pe){function Le(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Pe.from=Le;function _e(se){const Fe=new s.TextEdit(a.to(se.range),se.text);return Fe.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Fe}Pe.to=_e})(J=e.TextEdit||(e.TextEdit={}));var z;(function(Pe){function Le(se,Fe){const We={edits:[]};if(se instanceof s.WorkspaceEdit){const Qe=new P.ResourceSet;for(const He of se._allEntries())He._type===1&&I.URI.isUri(He.to)&&He.from===void 0&&Qe.add(He.to);for(const He of se._allEntries())He._type===1?We.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contentsBase64:He.options?.contents&&(0,R.encodeBase64)(R.VSBuffer.wrap(He.options.contents))},metadata:He.metadata}):He._type===2?We.edits.push({resource:He.uri,textEdit:J.from(He.edit),versionId:Qe.has(He.uri)?void 0:Fe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?We.edits.push({resource:He.uri,textEdit:{range:a.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Qe.has(He.uri)?void 0:Fe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?We.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(He.uri)}):He._type===5&&We.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(at.from)}})}return We}Pe.from=Le;function _e(se){const Fe=new s.WorkspaceEdit;for(const We of se.edits)We.textEdit?Fe.replace(I.URI.revive(We.resource),a.to(We.textEdit.range),We.textEdit.text):Fe.renameFile(I.URI.revive(We.oldResource),I.URI.revive(We.newResource),We.options);return Fe}Pe.to=_e})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Pe){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Le[Fe]=="number"?Le[Fe]:6}Pe.from=_e;function se(Fe){for(const We in Le)if(Le[We]===Fe)return Number(We);return s.SymbolKind.Property}Pe.to=se})(Q=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Pe){function Le(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Pe.from=Le;function _e(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Pe.to=_e})(ie=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Pe){function Le(se){return{name:se.name,kind:Q.from(se.kind),tags:se.tags&&se.tags.map(ie.from),containerName:se.containerName,location:be.from(se.location)}}Pe.from=Le;function _e(se){const Fe=new s.SymbolInformation(se.name,Q.to(se.kind),se.containerName,be.to(se.location));return Fe.tags=se.tags&&se.tags.map(ie.to),Fe}Pe.to=_e})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(Pe){function Le(se){const Fe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:Q.from(se.kind),tags:se.tags?.map(ie.from)??[]};return se.children&&(Fe.children=se.children.map(Le)),Fe}Pe.from=Le;function _e(se){const Fe=new s.DocumentSymbol(se.name,se.detail,Q.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,o.isNonEmptyArray)(se.tags)&&(Fe.tags=se.tags.map(ie.to)),se.children&&(Fe.children=se.children.map(_e)),Fe}Pe.to=_e})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(Pe){function Le(se){const Fe=new s.CallHierarchyItem(Q.to(se.kind),se.name,se.detail||"",I.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Pe.to=Le;function _e(se,Fe,We){if(Fe=Fe??se._sessionId,We=We??se._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,name:se.name,detail:se.detail,kind:Q.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ie.from)}}Pe.from=_e})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ee;(function(Pe){function Le(_e){return new s.CallHierarchyIncomingCall(Y.to(_e.from),_e.fromRanges.map(se=>a.to(se)))}Pe.to=Le})(ee=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(Pe){function Le(_e){return new s.CallHierarchyOutgoingCall(Y.to(_e.to),_e.fromRanges.map(se=>a.to(se)))}Pe.to=Le})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var be;(function(Pe){function Le(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Pe.from=Le;function _e(se){return new s.Location(I.URI.revive(se.uri),a.to(se.range))}Pe.to=_e})(be=e.location||(e.location={}));var De;(function(Pe){function Le(se){const Fe=se,We=se;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:We.uri,range:a.from(Fe.targetRange?Fe.targetRange:We.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}Pe.from=Le;function _e(se){return{targetUri:I.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Pe.to=_e})(De=e.DefinitionLink||(e.DefinitionLink={}));var Ae;(function(Pe){function Le(se){return{range:a.from(se.range),contents:X.fromMany(se.contents)}}Pe.from=Le;function _e(se){return new s.Hover(se.contents.map(X.to),a.to(se.range))}Pe.to=_e})(Ae=e.Hover||(e.Hover={}));var ae;(function(Pe){function Le(se){return{range:a.from(se.range),expression:se.expression}}Pe.from=Le;function _e(se){return new s.EvaluatableExpression(a.to(se.range),se.expression)}Pe.to=_e})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Pe){function Le(se){if(se instanceof s.InlineValueText)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof s.InlineValueVariableLookup)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function _e(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Pe.to=_e})(le=e.InlineValue||(e.InlineValue={}));var ue;(function(Pe){function Le(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Pe.from=Le;function _e(se){return new s.InlineValueContext(se.frameId,a.to(se.stoppedLocation))}Pe.to=_e})(ue=e.InlineValueContext||(e.InlineValueContext={}));var ne;(function(Pe){function Le(se){return{range:a.from(se.range),kind:se.kind}}Pe.from=Le;function _e(se){return new s.DocumentHighlight(a.to(se.range),se.kind)}Pe.to=_e})(ne=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Pe){function Le(_e){switch(_e){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Pe.to=Le})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(Pe){function Le(_e){return{triggerKind:ce.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Pe.to=Le})(oe=e.CompletionContext||(e.CompletionContext={}));var M;(function(Pe){function Le(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function _e(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Pe.to=_e})(M=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(Pe){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function _e(We){return Le.get(We)??9}Pe.from=_e;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(We){return se.get(We)??s.CompletionItemKind.Property}Pe.to=Fe})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var q;(function(Pe){function Le(_e,se){const Fe=new s.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=B.to(_e.kind),Fe.tags=_e.tags?.map(M.to),Fe.detail=_e.detail,Fe.documentation=w.isMarkdownString(_e.documentation)?X.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,y.Range.isIRange(_e.range)?Fe.range=a.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:a.to(_e.range.insert),replacing:a.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new s.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof s.Range?new s.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(We=>J.to(We))),Fe.command=se&&_e.command?se.fromInternal(_e.command):void 0,Fe}Pe.to=Le})(q=e.CompletionItem||(e.CompletionItem={}));var te;(function(Pe){function Le(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:X.fromStrict(se.documentation)}}Pe.from=Le;function _e(se){return{label:se.label,documentation:w.isMarkdownString(se.documentation)?X.to(se.documentation):se.documentation}}Pe.to=_e})(te=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Pe){function Le(se){return{label:se.label,documentation:X.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(te.from):[],activeParameter:se.activeParameter}}Pe.from=Le;function _e(se){return{label:se.label,documentation:w.isMarkdownString(se.documentation)?X.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(te.to):[],activeParameter:se.activeParameter}}Pe.to=_e})(de=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(Pe){function Le(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.from):[]}}Pe.from=Le;function _e(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.to):[]}}Pe.to=_e})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Pe){function Le(_e,se){const Fe=new s.InlayHint(g.to(se.position),typeof se.label=="string"?se.label:se.label.map(ve.to.bind(void 0,_e)),se.kind&&Ce.to(se.kind));return Fe.textEdits=se.textEdits&&se.textEdits.map(J.to),Fe.tooltip=w.isMarkdownString(se.tooltip)?X.to(se.tooltip):se.tooltip,Fe.paddingLeft=se.paddingLeft,Fe.paddingRight=se.paddingRight,Fe}Pe.to=Le})(Te=e.InlayHint||(e.InlayHint={}));var ve;(function(Pe){function Le(_e,se){const Fe=new s.InlayHintLabelPart(se.label);return Fe.tooltip=w.isMarkdownString(se.tooltip)?X.to(se.tooltip):se.tooltip,f.Command.is(se.command)&&(Fe.command=_e.fromInternal(se.command)),se.location&&(Fe.location=be.to(se.location)),Fe}Pe.to=Le})(ve=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Pe){function Le(se){return se}Pe.from=Le;function _e(se){return se}Pe.to=_e})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(Pe){function Le(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Pe.from=Le;function _e(se){let Fe;if(se.url)try{Fe=typeof se.url=="string"?I.URI.parse(se.url,!0):I.URI.revive(se.url)}catch{}return new s.DocumentLink(a.to(se.range),Fe)}Pe.to=_e})(Ie=e.DocumentLink||(e.DocumentLink={}));var ze;(function(Pe){function Le(se){const Fe=new s.ColorPresentation(se.label);return se.textEdit&&(Fe.textEdit=J.to(se.textEdit)),se.additionalTextEdits&&(Fe.additionalTextEdits=se.additionalTextEdits.map(We=>J.to(We))),Fe}Pe.to=Le;function _e(se){return{label:se.label,textEdit:se.textEdit?J.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Fe=>J.from(Fe)):void 0}}Pe.from=_e})(ze=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Pe){function Le(se){return new s.Color(se[0],se[1],se[2],se[3])}Pe.to=Le;function _e(se){return[se.red,se.green,se.blue,se.alpha]}Pe.from=_e})(qe=e.Color||(e.Color={}));var nt;(function(Pe){function Le(se){return{range:a.from(se.range)}}Pe.from=Le;function _e(se){return new s.SelectionRange(a.to(se.range))}Pe.to=_e})(nt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Pe){function Le(_e){switch(_e){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Pe){function Le(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function _e(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Pe.to=_e})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Pe){function Le(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Pe.from=Le;function _e(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Pe.to=_e})(rt=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(Pe){function Le(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Pe){function Le(se){const Fe={start:se.start+1,end:se.end+1};return se.kind&&(Fe.kind=x.from(se.kind)),Fe}Pe.from=Le;function _e(se){const Fe={start:se.start-1,end:se.end-1};return se.kind&&(Fe.kind=x.to(se.kind)),Fe}Pe.to=_e})(it=e.FoldingRange||(e.FoldingRange={}));var x;(function(Pe){function Le(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Pe.from=Le;function _e(se){if(se)switch(se.value){case f.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Pe.to=_e})(x=e.FoldingRangeKind||(e.FoldingRangeKind={}));var G;(function(Pe){function Le(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?a.from(_e.selection):void 0,override:typeof _e.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Le})(G=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Pe){function Le(We){return We instanceof s.RelativePattern?We.toJSON():typeof We=="string"?We:_e(We)||se(We)?new s.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Pe.from=Le;function _e(We){const Qe=We;return Qe?I.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function se(We){const Qe=We;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Fe(We){return typeof We=="string"?We:new s.RelativePattern(I.URI.revive(We.baseUri),We.pattern)}Pe.to=Fe})(he=e.GlobPattern||(e.GlobPattern={}));var Re;(function(Pe){function Le(_e){if(_e){if(Array.isArray(_e))return _e.map(Le);if(typeof _e=="string")return _e;{const se=_e;return{language:se.language,scheme:se.scheme,pattern:he.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Pe.from=Le})(Re=e.LanguageSelector||(e.LanguageSelector={}));var Oe;(function(Pe){function Le(se){return{start:se.start,end:se.end}}Pe.from=Le;function _e(se){return new s.NotebookRange(se.start,se.end)}Pe.to=_e})(Oe=e.NotebookRange||(e.NotebookRange={}));var Ve;(function(Pe){function Le(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Pe.to=Le;function _e(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Pe.from=_e})(Ve=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(Pe){function Le(_e){if(_e===v.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(_e===v.NotebookCellExecutionState.Pending)return;if(_e===v.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Pe.to=Le})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ze;(function(Pe){function Le(se){switch(se){case s.NotebookCellKind.Markup:return v.CellKind.Markup;case s.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Le;function _e(se){switch(se){case v.CellKind.Markup:return s.NotebookCellKind.Markup;case v.CellKind.Code:default:return s.NotebookCellKind.Code}}Pe.to=_e})(Ze=e.NotebookCellKind||(e.NotebookCellKind={}));var st;(function(Pe){function Le(se){const Fe={metadata:se.metadata??Object.create(null),cells:[]};for(const We of se.cells)s.NotebookCellData.validate(We),Fe.cells.push(at.from(We));return Fe}Pe.from=Le;function _e(se){const Fe=new s.NotebookData(se.cells.map(at.to));return(0,b.isEmptyObject)(se.metadata)||(Fe.metadata=se.metadata),Fe}Pe.to=_e})(st=e.NotebookData||(e.NotebookData={}));var at;(function(Pe){function Le(se){return{cellKind:Ze.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ve.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(gt.from):[]}}Pe.from=Le;function _e(se){return new s.NotebookCellData(Ze.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(gt.to):void 0,se.metadata,se.internalMetadata?Ve.to(se.internalMetadata):void 0)}Pe.to=_e})(at=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Pe){function Le(se){return{mime:se.mime,valueBytes:R.VSBuffer.wrap(se.data)}}Pe.from=Le;function _e(se){return new s.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Pe.to=_e})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var gt;(function(Pe){function Le(se){return{outputId:se.id,items:se.items.map(mt.from),metadata:se.metadata}}Pe.from=Le;function _e(se){const Fe=se.items.map(mt.to);return new s.NotebookCellOutput(Fe,se.outputId,se.metadata)}Pe.to=_e})(gt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var wt;(function(Pe){function Le(Fe){return se(Fe)?{include:(0,b.withNullAsUndefined)(he.from(Fe.include)),exclude:(0,b.withNullAsUndefined)(he.from(Fe.exclude))}:(0,b.withNullAsUndefined)(he.from(Fe))}Pe.from=Le;function _e(Fe){return se(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Pe.to=_e;function se(Fe){const We=Fe;return We?!(0,b.isUndefinedOrNull)(We.include)&&!(0,b.isUndefinedOrNull)(We.exclude):!1}})(wt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Pe){function Le(_e,se,Fe){const We=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(We,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Pe.from=Le})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var pt;(function(Pe){function Le(_e,se,Fe){const We=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{command:se.toInternal(We,Fe),label:_e.label,description:_e.description,detail:_e.detail,documentation:_e.documentation}}Pe.from=Le})(pt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var jt;(function(Pe){function Le(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{},cellContentMetadata:_e?.cellContentMetadata??{}}}Pe.from=Le})(jt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var $t;(function(Pe){function Le(se){return{uri:se.uri,provides:se.provides}}Pe.from=Le;function _e(se){return new s.NotebookRendererScript(I.URI.revive(se.uri),se.provides)}Pe.to=_e})($t=e.NotebookRendererScript||(e.NotebookRendererScript={}));var It;(function(Pe){function Le(se){return{message:X.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Pe.from=Le;function _e(se){const Fe=new s.TestMessage(typeof se.message=="string"?se.message:X.to(se.message));return Fe.actualOutput=se.actual,Fe.expectedOutput=se.expected,Fe.location=se.location?be.to(se.location):void 0,Fe}Pe.to=_e})(It=e.TestMessage||(e.TestMessage={}));var ft;(function(Pe){Pe.namespace=p.namespaceTestTag,Pe.denamespace=p.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var kt;(function(Pe){function Le(se){const Fe=(0,u.getPrivateApiFor)(se).controllerId;return{extId:D.TestId.fromExtHostTestItem(se,Fe).toString(),label:se.label,uri:I.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(We=>ft.namespace(Fe,We.id)),range:y.Range.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&X.fromStrict(se.error)||null}}Pe.from=Le;function _e(se){return{parent:void 0,error:void 0,id:D.TestId.fromString(se.extId).localId,label:se.label,uri:I.URI.revive(se.uri),tags:(se.tags||[]).map(Fe=>{const{tagId:We}=ft.denamespace(Fe);return new s.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Pe.toPlain=_e})(kt=e.TestItem||(e.TestItem={})),function(Pe){function Le(se){return{id:se.id}}Pe.from=Le;function _e(se){return new s.TestTag(se.id)}Pe.to=_e}(ft=e.TestTag||(e.TestTag={}));var Ut;(function(Pe){const Le=(se,Fe)=>{const We=[];for(const[He,et]of Fe)D.TestId.compare(et.item.extId,He)===2&&(Fe.delete(He),We.push(et));const Qe={...kt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(et=>et.type===0).map(It.to)})),children:We.map(He=>Le(He,Fe))};for(const He of Qe.children)He.parent=Qe;return Qe};function _e(se){const Fe=[],We=new Map;for(const Qe of se.items){We.set(Qe.item.extId,Qe);const He=D.TestId.root(Qe.item.extId);se.request.targets.some(et=>et.controllerId===He&&et.testIds.includes(Qe.item.extId))&&Fe.push(Qe)}return{completedAt:se.completedAt,results:Fe.map(Qe=>Le(Qe,We))}}Pe.to=_e})(Ut=e.TestResults||(e.TestResults={}));var Pt;(function(Pe){function Le(We){return{covered:We.covered,total:We.covered}}function _e(We){return"line"in We?g.from(We):a.from(We)}function se(We){return"branches"in We?{count:We.executionCount,location:_e(We.location),type:1,branches:We.branches.length?We.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&_e(Qe.location)})):void 0}:{type:0,count:We.executionCount,location:_e(We.location)}}Pe.fromDetailed=se;function Fe(We){return{uri:We.uri,statement:Le(We.statementCoverage),branch:We.branchCoverage&&Le(We.branchCoverage),function:We.functionCoverage&&Le(We.functionCoverage),details:We.detailedCoverage?.map(se)}}Pe.fromFile=Fe})(Pt=e.TestCoverage||(e.TestCoverage={}));var Ke;(function(Pe){function Le(_e){switch(_e){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Pe.to=Le})(Ke=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(Pe){function Le(se){const Fe=new s.TypeHierarchyItem(Q.to(se.kind),se.name,se.detail||"",I.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Pe.to=Le;function _e(se,Fe,We){if(Fe=Fe??se._sessionId,We=We??se._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,kind:Q.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ie.from)}}Pe.from=_e})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var qt;(function(Pe){function Le(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Pe.from=Le})(qt=e.ViewBadge||(e.ViewBadge={}));var Ft;(function(Pe){function Le(We,Qe,He){const et=Qe.fileData;return et?new class extends s.DataTransferItem{asFile(){return{name:et.name,uri:I.URI.revive(et.uri),data:(0,A.once)(()=>He())}}}("",Qe.id):We===L.Mimes.uriList&&Qe.uriListData?new s.DataTransferItem(Fe(Qe.uriListData)):new s.DataTransferItem(Qe.asString)}Pe.to=Le;async function _e(We,Qe){const He=await Qe.asString();if(We===L.Mimes.uriList)return{id:Qe.id,asString:He,fileData:void 0,uriListData:se(He)};const et=Qe.asFile();return{id:Qe.id,asString:He,fileData:et?{name:et.name,uri:et.uri}:void 0}}Pe.from=_e;function se(We){return l.UriList.split(We).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return I.URI.parse(Qe)}catch{}return Qe})}function Fe(We){return l.UriList.create(We.map(Qe=>typeof Qe=="string"?Qe:I.URI.revive(Qe)))}})(Ft=e.DataTransferItem||(e.DataTransferItem={}));var vt;(function(Pe){function Le(se,Fe){const We=se.items.map(([Qe,He])=>[Qe,Ft.to(Qe,He,()=>Fe(He.id))]);return new s.DataTransfer(We)}Pe.toDataTransfer=Le;async function _e(se){const Fe={items:[]},We=[];return se.forEach((Qe,He)=>{We.push((async()=>{Fe.items.push([He,await Ft.from(He,Qe)])})())}),await Promise.all(We),Fe}Pe.toDataTransferDTO=_e})(vt=e.DataTransfer||(e.DataTransfer={}))}),define(Se[242],ye([1,0,2,10,7,14,66]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(C,L,k,b={timeout:1500,errors:3}){this._logService=C,this._documents=L,this._mainThreadBulkEdits=k,this._thresholds=b,this._callbacks=new w.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(L,k,b)=>{const y={dispose:this._callbacks.push([L,k,C])};return Array.isArray(b)&&b.push(y),y}}async $participateInSave(C,L){const k=o.URI.revive(C);let b=!1;const I=setTimeout(()=>b=!0,this._thresholds.timeout),y=[];try{for(const f of[...this._callbacks]){if(b)break;const d=this._documents.getDocument(k),u=await this._deliverEventAsyncAndBlameBadListeners(f,{document:d,reason:A.TextDocumentSaveReason.to(L)});y.push(u)}}finally{clearTimeout(I)}return y}_deliverEventAsyncAndBlameBadListeners([C,L,k],b){const I=this._badListeners.get(C);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,C,L,b).then(()=>!0,y=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const f=this._badListeners.get(C);this._badListeners.set(C,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,L,k,b){const I=[],y=Date.now(),{document:f,reason:d}=b,{version:u}=f,m=Object.freeze({document:f,reason:d,waitUntil(v){if(Object.isFrozen(I))throw(0,R.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(v))}});try{L.apply(k,[m])}catch(v){return Promise.reject(v)}return Object.freeze(I),new Promise((v,D)=>{const p=setTimeout(()=>D(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(p),v(n)}).catch(n=>{clearTimeout(p),D(n)})}).then(v=>{const D={edits:[]};for(const p of v)if(Array.isArray(p)&&p.every(n=>n instanceof l.TextEdit))for(const{newText:n,newEol:s,range:r}of p)D.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:r&&A.Range.from(r),text:n,eol:s&&A.EndOfLine.from(s)}});if(D.edits.length!==0)return u===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Se[243],ye([1,0,15,2,14,7,93]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(k,b,I,y){this.start=k,this.deletedCount=b,this.deletedItems=I,this.items=y}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(k,b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,b,I){this.notebook=k,this._extHostDocument=b,this._cellData=I,this.handle=I.handle,this.uri=R.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(l.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,b=this._extHostDocument.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:l.NotebookCellKind.to(this._cellData.cellKind),document:b.document,get mime(){return k._mime},set mime(y){k._mime=y},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(k){this._outputs=k.map(l.NotebookCellOutput.to)}setOutputItems(k,b,I){const y=I.map(l.NotebookCellOutputItem.to),f=this._outputs.find(d=>d.id===k);if(f&&(b||(f.items.length=0),f.items.push(...y),f.items.length>1&&f.items.every(d=>w.isTextStreamMime(d.mime)))){const d=new Map,u=[];f.items.forEach(m=>{let v;d.has(m.mime)?v=d.get(m.mime):(v=[],d.set(m.mime,v),u.push(m.mime)),v.push(m.data)}),f.items.length=0,u.forEach(m=>{const v=w.compressOutputItemStreams(d.get(m));f.items.push({mime:m,data:v.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=S;class C{constructor(k,b,I,y,f){this._proxy=k,this._textDocumentsAndEditors=b,this._textDocuments=I,this.uri=y,this.handle=C._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=f.viewType,this._metadata=Object.freeze(f.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,f.cells]],!0,void 0),this._versionId=f.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,b={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===o.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(I){return I=k._validateIndex(I),k._cells[I].apiCell},getCells(I){return(I?k._getCells(I):k._cells).map(f=>f.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(b)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,b,I){this._versionId=k.versionId,this._isDirty=b,this.acceptDocumentPropertiesChanged({metadata:I});const y={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},f=[];for(const u of k.rawEvents)u.kind===w.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1,y.contentChanges):u.kind===w.NotebookCellsChangeType.Move?this._moveCells(u.index,u.length,u.newIdx,y.contentChanges):u.kind===w.NotebookCellsChangeType.Output?(this._setCellOutputs(u.index,u.outputs),f.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===w.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems),f.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===w.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(u.index,u.language),f.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document})):u.kind===w.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document}):u.kind===w.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===w.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(u.index,u.metadata),f.push({cell:this._cells[u.index].apiCell,metadata:this._cells[u.index].apiCell.metadata})):u.kind===w.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(u.index,u.internalMetadata),f.push({cell:this._cells[u.index].apiCell,executionSummary:this._cells[u.index].apiCell.executionSummary}));const d=new Map;for(let u=0;u<f.length;u++){const m=f[u],v=d.get(m.cell);if(v===void 0){const D=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});d.set(m.cell,D-1)}else y.cellChanges[v]={...y.cellChanges[v],...m}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let b=k.start|0,I=k.end|0;return b<0&&(b=0),I>this._cells.length&&(I=this._cells.length),k.with({start:b,end:I})}_getCells(k){k=this._validateRange(k);const b=[];for(let I=k.start;I<k.end;I++)b.push(this._cells[I]);return b}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,b,I){if(this._disposed)return;const y=[],f=[],d=[];if(k.reverse().forEach(u=>{const v=u[2].map(n=>{const s=new S(this,this._textDocumentsAndEditors,n);return b||f.push(S.asModelAddData(this.apiNotebook,n)),s}),D=new P(u[0],u[1],[],v),p=this._cells.splice(u[0],u[1],...v);for(const n of p)d.push(n.uri),D.deletedItems.push(n.apiCell);y.push(D)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),I)for(const u of y)I.push(u.asApiEvent())}_moveCells(k,b,I,y){const f=this._cells.splice(k,b);this._cells.splice(I,0,...f);const d=[new P(k,b,f.map(u=>u.apiCell),[]),new P(I,0,[],f)];for(const u of d)y.push(u.asApiEvent())}_setCellOutputs(k,b){this._cells[k].setOutputs(b)}_setCellOutputItems(k,b,I,y){this._cells[k].setOutputItems(b,I,y)}_changeCellLanguage(k,b){const I=this._cells[k];I.apiCell.document.languageId!==b&&this._textDocuments.$acceptModelLanguageChanged(I.uri,b)}_changeCellMime(k,b){const I=this._cells[k];I.apiCell.mime=b}_changeCellMetadata(k,b){this._cells[k].setMetadata(b)}_changeCellInternalMetadata(k,b){this._cells[k].setInternalMetadata(b)}getCellFromApiCell(k){return this._cells.find(b=>b.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(b=>b.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}C._handlePool=0,e.ExtHostNotebookDocument=C}),define(Se[136],ye([1,0,10,14,7]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(P,S,C,L,k,b){this.id=P,this._proxy=S,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=L,this._viewColumn=b}get apiEditor(){if(!this._editor){const P=this;this._editor={get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(S){this.selections=[S]},get selections(){return P._selections},set selections(S){if(!Array.isArray(S)||!S.every(l.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");P._selections=S,P._trySetSelections(S)},get visibleRanges(){return P._visibleRanges},revealRange(S,C){P._proxy.$tryRevealRange(P.id,R.NotebookRange.from(S),C??l.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(R.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}A.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=A}),define(Se[244],ye([1,0,3,13,14]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(P,S){this._logService=P,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new o.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new o.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(P,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,S);const C=this._notebooksAndEditors.getEditorById(P);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(l.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(l.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const S in P)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(l.ViewColumn.to(P[S]))}};A=je([Be(0,R.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Se[245],ye([1,0,14,126,179,21,62,10]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}async withProgress(b,I,y){const f=this._handles++,{title:d,location:u,cancellable:m}=I,v={label:(0,l.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this._proxy.$startProgress(f,{location:o.ProgressLocation.from(u),title:d,source:v,cancellable:m},b.isUnderDevelopment?void 0:b.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(f,y,!!m)}_withProgress(b,I,y){let f;y&&(f=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,f));const d=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),f?.dispose()};let u;try{u=I(new L(this._proxy,b),y&&f?f.token:A.CancellationToken.None)}catch(m){throw d(b),m}return u.then(m=>d(b),m=>d(b)),u}$acceptProgressCanceled(b){const I=this._mapHandleToCancellationSource.get(b);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=S;function C(k,b){return k.message=b.message,typeof b.increment=="number"&&(typeof k.increment=="number"?k.increment+=b.increment:k.increment=b.increment),k}class L extends R.Progress{constructor(b,I){super(y=>this.throttledReport(y)),this._proxy=b,this._handle=I}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}je([(0,w.throttle)(100,(k,b)=>C(k,b),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Se[137],ye([1,0,32,132,57,94,76,14,2]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(v,D,p,n)=>{let s=D;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!p(s,r)){const a=s;s=r,v.listener?.(n(r,a))}}}},L=(v,D)=>v===D,k={range:(v,D)=>v===D?!0:!v||!D?!1:v.isEqual(D),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(v,D)=>!(v.length!==D.length||v.some(p=>!D.find(n=>p.id===n.id)))},b=v=>D=>({op:4,update:v(D)}),I=(v,D)=>({range:(()=>{let p;const n=b(s=>({range:o.Range.lift(P.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return p},set(s){v.listener?.({op:6}),k.range(p,s)||(p=s,v.listener?.(n(s)))}}})(),label:C(v,D,k.label,b(p=>({label:p}))),description:C(v,void 0,k.description,b(p=>({description:p}))),sortText:C(v,void 0,k.sortText,b(p=>({sortText:p}))),canResolveChildren:C(v,!1,k.canResolveChildren,p=>({op:2,state:p})),busy:C(v,!1,k.busy,b(p=>({busy:p}))),error:C(v,void 0,k.error,b(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:C(v,[],k.tags,(p,n)=>({op:1,new:p.map(P.TestTag.from),old:n.map(P.TestTag.from)}))}),y=v=>{const D=l.TestId.fromString(v.extId),p=new d(D.controllerId,D.localId,v.label,S.URI.revive(v.uri)||void 0);return p.range=P.Range.to(v.range||void 0),p.description=v.description||void 0,p.sortText=v.sortText||void 0,p.tags=v.tags.map(n=>P.TestTag.to({id:(0,w.denamespaceTestTag)(n).tagId})),p},f=v=>{let D;for(const p of v.tests){const n=y(p.item);(0,R.getPrivateApiFor)(n).parent=D,D=n}return D};e.toItemFromContext=f;class d{constructor(D,p,n,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,R.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,R.getPrivateApiFor,d),enumerable:!0,writable:!1},...I(r,n)})}}e.TestItemImpl=d;class u extends d{constructor(D,p){super(D,D,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class m extends A.TestItemCollection{constructor(D,p,n){super({controllerId:D,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:R.getPrivateApiFor,getChildren:s=>s.children,root:new u(D,p),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(Se[138],ye([1,0,50,10,101,14,7]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(b,I,y){const f=P._Keys.nextId();b.$registerTextEditorDecorationType(I.identifier,f,A.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:f,dispose(){b.$removeTextEditorDecorationType(f)}})}}P._Keys=new l.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class S{constructor(b,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,I){this._throwIfFinalized();let y=null;if(b instanceof w.Position)y=new w.Range(b,b);else if(b instanceof w.Range)y=b;else throw new Error("Unrecognized location");this._pushEdit(y,I,!1)}insert(b,I){this._throwIfFinalized(),this._pushEdit(new w.Range(b,b),I,!0)}delete(b){this._throwIfFinalized();let I=null;if(b instanceof w.Range)I=b;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(b,I,y){const f=this._document.validateRange(b);this._collectedEdits.push({range:f,text:I,forceMoveMarkers:y})}setEndOfLine(b){if(this._throwIfFinalized(),b!==w.EndOfLine.LF&&b!==w.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=b}}class C{constructor(b,I,y,f){this._proxy=b,this._id=I,this._accept(y),this._logService=f;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(u){d._setTabSize(u)},get indentSize(){return d._indentSize},set indentSize(u){d._setIndentSize(u)},get insertSpaces(){return d._insertSpaces},set insertSpaces(u){d._setInsertSpaces(u)},get cursorStyle(){return d._cursorStyle},set cursorStyle(u){d._setCursorStyle(u)},get lineNumbers(){return d._lineNumbers},set lineNumbers(u){d._setLineNumbers(u)}}}_accept(b){this._tabSize=b.tabSize,this._indentSize=b.indentSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const I=Math.floor(b);return I>0?I:null}if(typeof b=="string"){const I=parseInt(b,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(b){const I=this._validateTabSize(b);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateIndentSize(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const I=Math.floor(b);return I>0?I:null}if(typeof b=="string"){const I=parseInt(b,10);return isNaN(I)?null:I>0?I:null}return null}_setIndentSize(b){const I=this._validateIndentSize(b);if(I!==null){if(typeof I=="number"){if(this._indentSize===I)return;this._indentSize=I}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:I}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const I=this._validateInsertSpaces(b);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(b)})))}assign(b){const I={};let y=!1;if(typeof b.tabSize<"u"){const f=this._validateTabSize(b.tabSize);f==="auto"?(y=!0,I.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,y=!0,I.tabSize=f)}if(typeof b.indentSize<"u"){const f=this._validateIndentSize(b.indentSize);f==="tabSize"?(y=!0,I.indentSize=f):typeof f=="number"&&this._indentSize!==f&&(this._indentSize=f,y=!0,I.indentSize=f)}if(typeof b.insertSpaces<"u"){const f=this._validateInsertSpaces(b.insertSpaces);f==="auto"?(y=!0,I.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,y=!0,I.insertSpaces=f)}typeof b.cursorStyle<"u"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,y=!0,I.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,y=!0,I.lineNumbers=A.TextEditorLineNumbersStyle.from(b.lineNumbers)),y&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(b,I){I.catch(y=>{this._logService.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this._logService.warn(y)})}}e.ExtHostTextEditorOptions=C;class L{constructor(b,I,y,f,d,u,m,v){this.id=b,this._proxy=I,this._logService=y,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new C(this._proxy,this.id,u,y),this._visibleRanges=m,this._viewColumn=v;const D=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw(0,R.readonly)("document")},get selection(){return D._selections&&D._selections[0]},set selection(p){if(!(p instanceof w.Selection))throw(0,R.illegalArgument)("selection");D._selections=[p],D._trySetSelection()},get selections(){return D._selections},set selections(p){if(!Array.isArray(p)||p.some(n=>!(n instanceof w.Selection)))throw(0,R.illegalArgument)("selections");D._selections=p,D._trySetSelection()},get visibleRanges(){return D._visibleRanges},set visibleRanges(p){throw(0,R.readonly)("visibleRanges")},get options(){return D._options.value},set options(p){D._disposed||D._options.assign(p)},get viewColumn(){return D._viewColumn},set viewColumn(p){throw(0,R.readonly)("viewColumn")},edit(p,n={undoStopBefore:!0,undoStopAfter:!0}){if(D._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(f.value,n);return p(s),D._applyEdit(s)},insertSnippet(p,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(D._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=D._selections.map(a=>A.Range.from(a));else if(n instanceof w.Position){const{lineNumber:a,column:c}=A.Position.from(n);r=[{startLineNumber:a,startColumn:c,endLineNumber:a,endColumn:c}]}else if(n instanceof w.Range)r=[A.Range.from(n)];else{r=[];for(const a of n)if(a instanceof w.Range)r.push(A.Range.from(a));else{const{lineNumber:c,column:g}=A.Position.from(a);r.push({startLineNumber:c,startColumn:g,endLineNumber:c,endColumn:g})}}return I.$tryInsertSnippet(b,f.value.version,p.value,r,s)},setDecorations(p,n){const s=n.length===0;s&&!D._hasDecorationsForKey.has(p.key)||(s?D._hasDecorationsForKey.delete(p.key):D._hasDecorationsForKey.add(p.key),D._runOnProxy(()=>{if(A.isDecorationOptionsArr(n))return I.$trySetDecorations(b,p.key,A.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let a=0,c=n.length;a<c;a++){const g=n[a];r[4*a]=g.start.line+1,r[4*a+1]=g.start.character+1,r[4*a+2]=g.end.line+1,r[4*a+3]=g.end.character+1}return I.$trySetDecorationsFast(b,p.key,r)}}))},revealRange(p,n){D._runOnProxy(()=>I.$tryRevealRange(b,A.Range.from(p),n||w.TextEditorRevealType.Default))},show(p){I.$tryShowEditor(b,A.ViewColumn.from(p))},hide(){I.$tryHideEditor(b)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,o.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,o.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,o.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,o.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const I=b.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const y=I.edits.map(d=>d.range);y.sort((d,u)=>d.end.line===u.end.line?d.end.character===u.end.character?d.start.line===u.start.line?d.start.character-u.start.character:d.start.line-u.start.line:d.end.character-u.end.character:d.end.line-u.end.line);for(let d=0,u=y.length-1;d<u;d++){const m=y[d].end;if(y[d+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=I.edits.map(d=>({range:A.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,f,{setEndOfLine:typeof I.setEndOfLine=="number"?A.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=L}),define(Se[246],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[247],ye([1,0,195,10,37,123,92,39,27,246,210,199]),function(re,e,o,R,l,A,w,P,S,C,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=P.Registry.as(w.Extensions.JSONContribution);class I{constructor(p,n,s){this._messageHandler=p,this._extension=n,this._extensionPointId=s}_msg(p,n){this._messageHandler({type:p,message:n,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(l.default.Error,p)}warn(p){this._msg(l.default.Warning,p)}info(p){this._msg(l.default.Info,p)}}e.ExtensionMessageCollector=I;class y{static _toSet(p){const n=new Set;for(let s=0,r=p.length;s<r;s++)n.add(S.ExtensionIdentifier.toKey(p[s].description.identifier));return n}static compute(p,n){if(!p||!p.length)return new y(n,[]);if(!n||!n.length)return new y([],p);const s=this._toSet(p),r=this._toSet(n),a=n.filter(g=>!s.has(S.ExtensionIdentifier.toKey(g.description.identifier))),c=p.filter(g=>!r.has(S.ExtensionIdentifier.toKey(g.description.identifier)));return new y(a,c)}constructor(p,n){this.added=p,this.removed=n}}e.ExtensionPointUserDelta=y;class f{constructor(p,n){this.name=p,this.defaultExtensionKind=n,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=y.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,R.onUnexpectedError)(p)}}}e.ExtensionPoint=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class m{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const n=new f(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,n),p.activationEventsGenerator&&k.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,b.registerSchema(u,e.schema),n}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=m;const v={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(v.ExtensionsRegistry,new m),e.ExtensionsRegistry=P.Registry.as(v.ExtensionsRegistry),b.registerSchema(u,e.schema),b.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(Se[248],ye([1,0,192,9,23,247,54,3]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var C;(function(b){function I(y,f,d){if(!y)return;const u=R.isString(y.type)?y.type:void 0;if(!u||u.length===0){d.error(o.localize(3,null));return}const m=[];if(Array.isArray(y.required))for(const v of y.required)R.isString(v)&&m.push(v);return{extensionId:f.value,taskType:u,required:m,properties:y.properties?l.deepClone(y.properties):{},when:y.when?w.ContextKeyExpr.deserialize(y.when):void 0}}b.from=I})(C||(C={}));const L=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,I)=>{for(const y of b)y.type&&I.push(`onTaskType:${y.type}`)},jsonSchema:{description:o.localize(4,null),type:"array",items:S}});class k{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,y)=>{L.setHandler((f,d)=>{this._schema=void 0;try{for(const u of d.removed){const m=u.value;for(const v of m)this.taskTypes&&v.type&&this.taskTypes[v.type]&&delete this.taskTypes[v.type]}for(const u of d.added){const m=u.value;for(const v of m){const D=C.from(v,u.description.identifier,u.collector);D&&(this.taskTypes[D.taskType]=D)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){const I=[];for(const y of this.all()){const f={type:"object",additionalProperties:!1};y.required.length>0&&(f.required=y.required.slice(0)),y.properties!==void 0?f.properties=l.deepClone(y.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[y.taskType]},I.push(f)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(Se[249],ye([1,0,193,9,24,23,54,248]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new w.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var S;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function T(F){if(!F)return N.Strong;switch(F.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=T}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(N){function T(F){switch(F.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=T}(L=e.RevealKind||(e.RevealKind={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function T(F){switch(F.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=T}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var b;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(b=e.PanelKind||(e.PanelKind={})),function(N){function T(F){switch(F.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=T}(b=e.PanelKind||(e.PanelKind={}));var I;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:k.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var y;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(y=e.RuntimeType||(e.RuntimeType={})),function(N){function T(U){switch(U.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=T;function F(U){switch(U){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=F}(y=e.RuntimeType||(e.RuntimeType={}));var f;(function(N){function T(F){return R.isString(F)?F:F.value}N.value=T})(f=e.CommandString||(e.CommandString={}));var d;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function T(U){return U===N.Clean._id||U===N.Build._id||U===N.Rebuild._id||U===N.Test._id}N.is=T;function F(U){if(U!==void 0)return R.isString(U)?T(U)?{_id:U,isDefault:!1}:void 0:U}N.from=F})(d=e.TaskGroup||(e.TaskGroup={}));var u;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var m;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function T(F){switch(F){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=T})(m=e.TaskSourceKind||(e.TaskSourceKind={}));var v;(function(N){N.parallel="parallel",N.sequence="sequence"})(v=e.DependsOrder||(e.DependsOrder={}));var D;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(D=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class n{constructor(T,F,U,Z,J,z){this._label="",this._id=T,F&&(this._label=F),U&&(this.type=U),this.runOptions=Z,this.configurationProperties=J,this._source=z}getDefinition(T){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const T={folder:this.getFolderId(),id:this._id};return JSON.stringify(T)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,F=!1){if(T===void 0)return!1;if(R.isString(T))return T===this._label||T===this.configurationProperties.identifier||F&&T===this._id;const U=this.getDefinition(!0);return U!==void 0&&U._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),T&&(this._taskLoadMessages=this._taskLoadMessages.concat(T))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class s extends n{constructor(T,F,U,Z,J,z,Q,ie){super(T,U,void 0,Q,ie,F),this.command={},this._source=F,this.hasDefinedMatchers=z,J&&(this.command=J)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case y.Shell:F="shell";break;case y.Process:F="process";break;case y.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(T){return T instanceof s}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const T=this.getFolderId();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(F+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:T,id:F};return JSON.stringify(U)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(T){return new s(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.CustomTask=s;class r extends n{constructor(T,F,U,Z,J,z,Q){super(T,U,Z,z,Q,F),this._source=F,this.configures=J}static is(T){return T instanceof r}fromObject(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const T=this.getFolderId();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(F+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:T,id:F};return JSON.stringify(U)}}e.ConfiguringTask=r;class a extends n{constructor(T,F,U,Z,J,z,Q,ie,ge){super(T,U,Z,ie,ge,F),this.defines=J,this.hasDefinedMatchers=Q,this.command=z,this.icon=ge.icon,this.hide=ge.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof a}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.getFolderId(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(T){return new a(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.ContributedTask=a;class c extends n{constructor(T,F,U,Z,J,z){super(T,U,Z,J,z,F),this._source=F}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.InMemoryTask=c;var g;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(g=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(g=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(T){this._order=new Map;for(let F=0;F<T.length;F++)this._order.set(T[F].uri.toString(),F)}compare(T,F){const U=T.getWorkspaceFolder(),Z=F.getWorkspaceFolder();if(U&&Z){let J=this._order.get(U.uri.toString());J=J===void 0?0:J+1;let z=this._order.get(Z.uri.toString());return z=z===void 0?0:z+1,J===z?T._label.localeCompare(F._label):J-z}else return!U&&Z?-1:U&&!Z?1:0}}e.TaskSorter=t;var h;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var _;(function(N){N.SingleRun="singleRun",N.Background="background"})(_=e.TaskRunType||(e.TaskRunType={}));var E;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(E=e.TaskRunSource||(e.TaskRunSource={}));var O;(function(N){function T(F,U,Z,J){if(U){const z={kind:F,taskId:U._id,taskName:U.configurationProperties.name,runType:U.configurationProperties.isBackground?"background":"singleRun",group:U.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Z,__task:U};return F==="start"?z.resolvedVariables=J:F==="processStarted"?z.processId=J:F==="processEnded"&&(z.exitCode=J),Object.freeze(z)}else return Object.freeze({kind:"changed"})}N.create=T})(O=e.TaskEvent||(e.TaskEvent={}));var $;(function(N){function T(U){const Z=Object.keys(U).sort();let J="";for(const z of Z){let Q=U[z];Q instanceof Object?Q=T(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),J+=z+","+Q+","}return J}function F(U){const J={_key:T(U),type:U.taskType};return Object.assign(J,U),J}N.create=F})($=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var H;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(H=e.TaskSettingId||(e.TaskSettingId={}));var X;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(X=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var V;(function(N){function T(F,U){const Z=P.TaskDefinitionRegistry.get(F.type);if(Z===void 0){const ie=A.deepClone(F);return delete ie._key,$.create(ie)}const J=Object.create(null);J.type=Z.taskType;const z=new Set;Z.required.forEach(ie=>z.add(ie));const Q=Z.properties;for(const ie of Object.keys(Q)){const ge=F[ie];if(ge!=null)J[ie]=ge;else if(z.has(ie)){const K=Q[ie];if(K.default!==void 0)J[ie]=A.deepClone(K.default);else switch(K.type){case"boolean":J[ie]=!1;break;case"number":case"integer":J[ie]=0;break;case"string":J[ie]="";break;default:U.error(o.localize(2,null,JSON.stringify(F,void 0,0),ie));return}}}return $.create(J)}N.createTaskIdentifier=T})(V=e.TaskDefinition||(e.TaskDefinition={}))}),define(Se[250],ye([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((w,P)=>{this._actualOk=w,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(w){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=w,this._actual&&this._actualOk(w))}resolveErr(w){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=w,this._actual?this._actualErr(w):(0,o.onUnexpectedError)(w))}then(w,P){return this._ensureActual().then(w,P)}catch(w){return this._ensureActual().then(void 0,w)}finally(w){return this._ensureActual().finally(w)}}e.LazyPromise=R;class l extends R{constructor(){super(),this._hasErr=!0,this._err=new o.CancellationError}}e.CanceledLazyPromise=l}),define(Se[58],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++o.count}}o.count=0,e.ProxyIdentifier=o;const R=[];function l(P){const S=new o(P);return R[S.nid]=S,S}e.createProxyIdentifier=l;function A(P){return R[P].sid}e.getStringIdentifierForProxy=A;class w{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=w}),define(Se[5],ye([1,0,58]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var A;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var w;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(w=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(d){return d._id=k._n++,d}}k._n=0,e.IdObject=k;var b;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,o.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization")}}),define(Se[78],ye([1,0,4,13,5,20]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let w=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(l.MainContext.MainThreadTelemetry)}report(S,C,L){const k=this.getUsageKey(S,C);this._reportedUsages.has(k)||(this._reportedUsages.add(k),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};w=je([Be(0,A.IExtHostRpcService),Be(1,R.ILogService)],w),e.ExtHostApiDeprecationService=w,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,C){}})}),define(Se[251],ye([1,0,3,5,7,27]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class w{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,C,L,k={}){const b=A.ExtensionIdentifier.toKey(S.identifier),I=this._inFlightRequests.get(b)||[],y=[...L].sort().join(" ");let f=I.find(d=>d.providerId===C&&d.scopes===y);if(f)return f.result;{const d=this._getSession(S,b,C,L,k);f={providerId:C,scopes:y,result:d},I.push(f),this._inFlightRequests.set(b,I);try{await d}finally{const u=I.findIndex(m=>m.providerId===C&&m.scopes===y);u>-1&&(I.splice(u),this._inFlightRequests.set(b,I))}return d}}async _getSession(S,C,L,k,b={}){await this._proxy.$ensureProvider(L);const I=S.displayName||S.name;return this._proxy.$getSession(L,k,C,I,b)}async removeSession(S,C){const L=this._authenticationProviders.get(S);return L?L.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,L,k){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:L,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===S)||this._providers.push({id:S,label:C});const b=L.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(S,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,C,k?.supportsMultipleAccounts??!1),new l.Disposable(()=>{b.dispose(),this._authenticationProviders.delete(S);const I=this._providers.findIndex(y=>y.id===S);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const L=this._authenticationProviders.get(S);if(L)return Promise.resolve(L.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const L=this._authenticationProviders.get(S);if(L)return Promise.resolve(L.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const L=this._authenticationProviders.get(S);if(L)return Promise.resolve(L.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=w}),define(Se[252],ye([1,0,5,20,14]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,S){this._proxy=P.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,S,C){const L=l.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,C?.isRefactoring??!1)}};A=je([Be(0,R.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Se[253],ye([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(A){const w=A.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return w.$readText()},writeText(P){return w.$writeText(P)}})}}e.ExtHostClipboard=R});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[40],ye([1,0,9,7,14,23,5,16,13,69,32,52,2,6,4,20,137,22,58,45,43,74,77]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p,n){"use strict";var s,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(E,O,$){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,r.set(this,void 0),a.set(this,void 0),Je(this,s,E.getProxy(w.MainContext.MainThreadCommands),"f"),this._logService=O,Je(this,a,$,"f"),Je(this,r,E.getProxy(w.MainContext.MainThreadTelemetry),"f"),this.converter=new g(this,H=>{const X=this._apiCommands.get(H);return X?.result===t.Void?X:void 0},O),this._argumentProcessors=[{processArgument(H){return(0,C.revive)(H)}},{processArgument(H){return(0,A.cloneAndChange)(H,function(X){if(L.Range.isIRange(X))return l.Range.to(X);if(k.Position.isIPosition(X))return l.Position.to(X);if(L.Range.isIRange(X.range)&&b.URI.isUri(X.uri))return l.location.to(X);if(X instanceof u.VSBuffer)return X.buffer.buffer;if(!Array.isArray(X))return X})}}]}registerArgumentProcessor(E){this._argumentProcessors.push(E)}registerApiCommand(E){const O=this.registerCommand(!1,E.id,async(...$)=>{const H=E.args.map((V,N)=>{if(!V.validate($[N]))throw new Error(`Invalid argument '${V.name}' when running '${E.id}', received: ${$[N]}`);return V.convert($[N])}),X=await this.executeCommand(E.internalId,...H);return E.result.convert(X,$,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this._apiCommands.set(E.id,E),new R.Disposable(()=>{O.dispose(),this._apiCommands.delete(E.id)})}registerCommand(E,O,$,H,X,V){if(this._logService.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this._commands.has(O))throw new Error(`command '${O}' already exists`);return this._commands.set(O,{callback:$,thisArg:H,description:X,extension:V}),E&&Ne(this,s,"f").$registerCommand(O),new R.Disposable(()=>{this._commands.delete(O)&&E&&Ne(this,s,"f").$unregisterCommand(O)})}executeCommand(E,...O){return this._logService.trace("ExtHostCommands#executeCommand",E),this._doExecuteCommand(E,O,!0)}async _doExecuteCommand(E,O,$){if(this._commands.has(E))return Ne(this,s,"f").$fireCommandActivationEvent(E),this._executeContributedCommand(E,O,!1);{let H=!1;const X=(0,A.cloneAndChange)(O,function(V){if(V instanceof R.Position)return l.Position.from(V);if(V instanceof R.Range)return l.Range.from(V);if(V instanceof R.Location)return l.location.from(V);if(R.NotebookRange.isNotebookRange(V))return l.NotebookRange.from(V);if(V instanceof ArrayBuffer)return H=!0,u.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return H=!0,u.VSBuffer.wrap(V);if(V instanceof u.VSBuffer)return H=!0,V;if(!Array.isArray(V))return V});try{const V=await Ne(this,s,"f").$executeCommand(E,H?new m.SerializableObjectWithBuffers(X):X,$);return(0,C.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(E,O,!1);throw V}}}async _executeContributedCommand(E,O,$){const H=this._commands.get(E);if(!H)throw new Error("Unknown command");const{callback:X,thisArg:V,description:N}=H;if(N)for(let F=0;F<N.args.length;F++)try{(0,o.validateConstraint)(O[F],N.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${N.args[F].name}' - ${N.args[F].description}`)}const T=D.StopWatch.create();try{return await X.apply(V,O)}catch(F){if(E===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...O);U&&(E=U.command)}if(this._logService.error(F,E,H.extension?.identifier),!$)throw F;if(H.extension?.identifier){const U=Ne(this,a,"f").onExtensionError(H.extension.identifier,F);this._logService.trace("forwarded error to extension?",U,H.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.toErrorMessage)(F)),this.id=E,this.source=H.extension?.displayName??H.extension?.name}}}finally{this._reportTelemetry(H,E,T.elapsed())}}_reportTelemetry(E,O,$){!E.extension||Ne(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new p.TelemetryTrustedValue(O),duration:$})}$executeContributedCommand(E,...O){this._logService.trace("ExtHostCommands#$executeContributedCommand",E);const $=this._commands.get(E);return $?(O=O.map(H=>this._argumentProcessors.reduce((X,V)=>V.processArgument(X,$.extension?.identifier),H)),this._executeContributedCommand(E,O,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this._logService.trace("ExtHostCommands#getCommands",E),Ne(this,s,"f").$getCommands().then(O=>(E&&(O=O.filter($=>$[0]!=="_")),O))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[O,$]of this._commands){const{description:H}=$;H&&(E[O]=H)}return Promise.resolve(E)}};s=new WeakMap,r=new WeakMap,a=new WeakMap,c=je([Be(0,f.IExtHostRpcService),Be(1,S.ILogService),Be(2,n.IExtHostTelemetry)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,y.createDecorator)("IExtHostCommands");class g{constructor(E,O,$){this._commands=E,this._lookupApiCommand=O,this._logService=$,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(E,O){if(!E)return;const $={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return $;const H=this._lookupApiCommand(E.command);if(H)$.id=H.internalId,$.arguments=H.args.map((X,V)=>X.convert(E.arguments&&E.arguments[V]));else if((0,P.isNonEmptyArray)(E.arguments)){const X=`${E.command}/${++this._cachIdPool}`;this._cache.set(X,E),O.add((0,I.toDisposable)(()=>{this._cache.delete(X),this._logService.trace("CommandsConverter#DISPOSE",X)})),$.$ident=X,$.id=this.delegatingCommandId,$.arguments=[X],this._logService.trace("CommandsConverter#CREATE",E.command,X)}return $}fromInternal(E){return typeof E.$ident=="string"?this._cache.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this._cache.get(E[0])}_executeConvertedCommand(...E){const O=this.getActualCommand(...E);return this._logService.trace("CommandsConverter#EXECUTE",E[0],O?O.command:"MISSING"),O?this._commands.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.CommandsConverter=g;class i{constructor(E,O,$,H){this.name=E,this.description=O,this.validate=$,this.convert=H}optional(){return new i(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,O){return new i(E??this.name,O??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",_=>b.URI.isUri(_),_=>_),i.Position=new i("position","A position in a text document",_=>R.Position.isPosition(_),l.Position.from),i.Range=new i("range","A range in a text document",_=>R.Range.isRange(_),l.Range.from),i.Selection=new i("selection","A selection in a text document",_=>R.Selection.isSelection(_),l.Selection.from),i.Number=new i("number","",_=>typeof _=="number",_=>_),i.String=new i("string","",_=>typeof _=="string",_=>_),i.CallHierarchyItem=new i("item","A call hierarchy item",_=>_ instanceof R.CallHierarchyItem,l.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",_=>_ instanceof R.TypeHierarchyItem,l.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",_=>_ instanceof d.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=i;class t{constructor(E,O){this.description=E,this.convert=O}}t.Void=new t("no result",_=>_),e.ApiCommandResult=t;class h{constructor(E,O,$,H,X){this.id=E,this.internalId=O,this.description=$,this.args=H,this.result=X}}e.ApiCommand=h}),define(Se[254],ye([1,0,2,14,7,72,40,16,120,125,15]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new w.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(R.DocumentHighlight.to))),new w.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[w.ApiCommandArgument.Uri],new w.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,P.isFalsyOrEmpty)(f))return;class u extends l.SymbolInformation{static to(v){const D=new u(v.name,R.SymbolKind.to(v.kind),v.containerName||"",new l.Location(d[0],R.Range.to(v.range)));return D.detail=v.detail,D.range=D.location.range,D.selectionRange=R.Range.to(v.selectionRange),D.children=v.children?v.children.map(u.to):[],D}}return f.map(u.to)})),new w.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[w.ApiCommandArgument.Uri,new w.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new w.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(R.TextEdit.to))),new w.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Range,new w.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new w.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(R.TextEdit.to))),new w.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position,new w.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new w.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new w.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(R.TextEdit.to))),new w.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new w.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new w.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new w.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new w.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(R.location.to))),new w.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(R.Hover.to))),new w.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[w.ApiCommandArgument.Uri,new w.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>l.Position.isPosition(d)),f=>f.map(R.Position.from))],new w.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(d=>{let u;for(const m of d.reverse())u=new l.SelectionRange(R.Range.to(m),u);return u}))),new w.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[w.ApiCommandArgument.String.with("query","Search string")],new w.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(R.WorkspaceSymbol.to))),new w.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(R.CallHierarchyItem.to))),new w.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[w.ApiCommandArgument.CallHierarchyItem],new w.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(R.CallHierarchyIncomingCall.to))),new w.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[w.ApiCommandArgument.CallHierarchyItem],new w.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(R.CallHierarchyOutgoingCall.to))),new w.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:R.Range.to(f.range),placeholder:f.text}})),new w.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position,w.ApiCommandArgument.String.with("newName","The new symbol name")],new w.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return R.WorkspaceEdit.to(f)}})),new w.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new w.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(R.DocumentLink.to))),new w.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[w.ApiCommandArgument.Uri],new w.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new w.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[w.ApiCommandArgument.Uri],new w.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,S.decodeSemanticTokensDto)(f);if(d.type==="full")return new l.SemanticTokens(d.data,void 0)})),new w.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Range.optional()],new w.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new w.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Range],new w.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,S.decodeSemanticTokensDto)(f);if(d.type==="full")return new l.SemanticTokens(d.data,void 0)})),new w.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position,w.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),w.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new w.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,d,u)=>{if(!f)return new l.CompletionList([]);const m=f.suggestions.map(v=>R.CompletionItem.to(v,u));return new l.CompletionList(m,f.incomplete)})),new w.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position,w.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new w.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return R.SignatureHelp.to(f)})),new w.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new w.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,d,u)=>I(m=>new l.CodeLens(R.Range.to(m.range),m.command&&u.fromInternal(m.command)))(f))),new w.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[w.ApiCommandArgument.Uri,new w.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>l.Range.isRange(f),f=>l.Selection.isSelection(f)?R.Selection.from(f):R.Range.from(f)),w.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),w.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new w.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,d,u)=>I(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(m.command)}else{const v=new l.CodeAction(m.title,m.kind?new l.CodeActionKind(m.kind):void 0);return m.edit&&(v.edit=R.WorkspaceEdit.to(m.edit)),m.command&&(v.command=u.fromInternal(m.command)),v.isPreferred=m.isPreferred,v}})(f))),new w.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[w.ApiCommandArgument.Uri],new w.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new l.ColorInformation(R.Range.to(d.range),R.Color.to(d.color))):[])),new w.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new w.ApiCommandArgument("color","The color to show and insert",f=>f instanceof l.Color,R.Color.from),new w.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:R.Range.from(f.range)}))],new w.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(R.ColorPresentation.to):[])),new w.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Range],new w.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,d,u)=>f.map(R.InlayHint.to.bind(void 0,u)))),new w.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[w.ApiCommandArgument.Uri],new w.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(f,d)=>{if(f)return f.map(R.FoldingRange.to)})),new w.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new w.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>R.NotebookExclusiveDocumentPattern.to(d))})))),new w.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Range],new w.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(R.InlineValue.to))),new w.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new w.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>o.URI.isUri(f)||typeof f=="string"&&(0,C.matchesSomeScheme)(f,L.Schemas.http,L.Schemas.https),f=>f),new w.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[R.ViewColumn.from(f),void 0]:[R.ViewColumn.from(f.viewColumn),R.TextEditorOpenOptions.from(f)])).optional(),w.ApiCommandArgument.String.with("label","").optional()],w.ApiCommandResult.Void),new w.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[w.ApiCommandArgument.Uri.with("resource","Resource to open"),w.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new w.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[R.ViewColumn.from(f),void 0]:[R.ViewColumn.from(f.viewColumn),R.TextEditorOpenOptions.from(f)])).optional()],w.ApiCommandResult.Void),new w.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[w.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),w.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),w.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new w.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[R.ViewColumn.from(f.viewColumn),R.TextEditorOpenOptions.from(f)]).optional()],w.ApiCommandResult.Void),new w.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[w.ApiCommandArgument.Uri,w.ApiCommandArgument.Position],new w.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(R.TypeHierarchyItem.to))),new w.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[w.ApiCommandArgument.TypeHierarchyItem],new w.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(R.TypeHierarchyItem.to))),new w.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[w.ApiCommandArgument.TypeHierarchyItem],new w.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(R.TypeHierarchyItem.to))),new w.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[w.ApiCommandArgument.TestItem],w.ApiCommandResult.Void),new w.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[w.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],w.ApiCommandResult.Void),new w.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[w.ApiCommandArgument.String.with("name","The context key name"),new w.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],w.ApiCommandResult.Void)];class b{static register(d){k.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=b;function I(f){return d=>{if(Array.isArray(d))return d.map(f)}}function y(f){if(!Array.isArray(f))return;const d=[];for(const u of f)A.isLocationLink(u)?d.push(R.DefinitionLink.to(u)):d.push(R.location.to(u));return d}}),define(Se[255],ye([1,0,19,62,3,6,2,72,27,14,7,5]),function(re,e,o,R,l,A,w,P,S,C,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(I,y,f){const d=I.getProxy(k.MainContext.MainThreadComments);class u{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,y.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const g=this._commentControllers.get(c.handle);return g?g.value:c}else if(c&&c.$mid===7){const g=this._commentControllers.get(c.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.commentThreadHandle);return i?i.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const g=this._commentControllers.get(c.thread.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.thread.commentThreadHandle);return i?c.$mid===8?i.value:{thread:i.value,text:c.text}:c}else if(c&&c.$mid===10){const g=this._commentControllers.get(c.thread.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.thread.commentThreadHandle);if(!i)return c;const t=c.commentUniqueId,h=i.getCommentByUniqueId(t);return h||c}else if(c&&c.$mid===11){const g=this._commentControllers.get(c.thread.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.thread.commentThreadHandle);if(!i)return c;const t=c.text,h=c.commentUniqueId,_=i.getCommentByUniqueId(h);return _?(typeof _.body=="string"?_.body=t:_.body=new L.MarkdownString(t),_):c}return c}})}createCommentController(c,g,i){const t=u.handlePool++,h=new v(c,t,g,i);this._commentControllers.set(h.handle,h);const _=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(c.identifier))||[];return _.push(h),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(c.identifier),_),h.value}$createCommentThreadTemplate(c,g,i){const t=this._commentControllers.get(c);!t||t.$createCommentThreadTemplate(g,i)}async $updateCommentThreadTemplate(c,g,i){const t=this._commentControllers.get(c);!t||t.$updateCommentThreadTemplate(g,i)}$deleteCommentThread(c,g){this._commentControllers.get(c)?.$deleteCommentThread(g)}$provideCommentingRanges(c,g,i){const t=this._commentControllers.get(c);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const h=f.getDocument(w.URI.revive(g));return(0,o.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(h,i)).then(_=>_?_.map(E=>C.Range.from(E)):void 0)}$toggleReaction(c,g,i,t,h){const _=this._commentControllers.get(c);return!_||!_.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const E=_.getCommentThread(g);if(E){const O=E.getCommentByUniqueId(t.uniqueIdInThread);if(_!==void 0&&O&&_.reactionHandler)return _.reactionHandler(O,n(h))}return Promise.resolve(void 0)})}dispose(){}}u.handlePool=0;class m{set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(c){this._state=c,this.modifications.state=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(c,g,i,t,h,_,E,O){this._commentControllerHandle=g,this._id=i,this._uri=t,this._range=h,this._comments=_,this.extensionDescription=E,this._isTemplate=O,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new l.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${c}.${this.handle}`),d.$createCommentThread(g,this.handle,this._id,this._uri,C.Range.from(this._range),E.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=_,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(g,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(H){$.range=H},get comments(){return $.comments},set comments(H){$.comments=H},get collapsibleState(){return $.collapsibleState},set collapsibleState(H){$.collapsibleState=H},get canReply(){return $.canReply},set canReply(H){$.canReply=H},get contextValue(){return $.contextValue},set contextValue(H){$.contextValue=H},get label(){return $.label},set label(H){$.label=H},get state(){return $.state},set state(H){$.state=H},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const c=i=>Object.prototype.hasOwnProperty.call(this.modifications,i),g={};c("range")&&(g.range=C.Range.from(this._range)),c("label")&&(g.label=this.label),c("contextValue")&&(g.contextValue=this.contextValue??null),c("comments")&&(g.comments=this._comments.map(i=>D(this,i,this._commentsMap))),c("collapsibleState")&&(g.collapseState=s(this._collapseState)),c("canReply")&&(g.canReply=this.canReply),c("state")&&(g.state=r(this._state)),c("isTemplate")&&(g.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(c){for(const g of this._commentsMap){const i=g[0],t=g[1];if(c===t)return i}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose())}}m._handlePool=0,je([(0,R.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(c){this._commentingRangeProvider=c,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(c,g,i,t){this._extension=c,this._handle=g,this._id=i,this._label=t,this._threads=new Map,d.$registerCommentController(this.handle,i,t);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(_){h.options=_},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(_){h.commentingRangeProvider=_},get reactionHandler(){return h.reactionHandler},set reactionHandler(_){h.reactionHandler=_},createCommentThread(_,E,O){return h.createCommentThread(_,E,O).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(c,g,i,t){if(typeof c=="string"){const h=new m(this.id,this.handle,c,g,i,t,this._extension,!1);return this._threads.set(h.handle,h),h}else{const h=new m(this.id,this.handle,void 0,c,g,i,this._extension,!1);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(c,g){const i=new m(this.id,this.handle,void 0,w.URI.revive(c),C.Range.to(g),[],this._extension,!0);return i.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(c,g){const i=this._threads.get(c);i&&(i.range=C.Range.to(g))}$deleteCommentThread(c){this._threads.get(c)?.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._localDisposables.forEach(c=>c.dispose())}}function D(a,c,g){let i=g.get(c);i||(i=++a.commentHandle,g.set(c,i));const t=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:i,body:typeof c.body=="string"?c.body:C.MarkdownString.from(c.body),userName:c.author.name,userIconPath:t,label:c.label,commentReactions:c.reactions?c.reactions.map(h=>p(h)):void 0,timestamp:c.timestamp?.toJSON()}}function p(a){return{label:a.label,iconPath:a.iconPath?C.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?w.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function s(a){if(a!==void 0)switch(a){case L.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function r(a){if(a!==void 0)switch(a){case L.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new u}e.createExtHostComments=b}),define(Se[256],ye([1,0,23,5,25,20]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let w=class{constructor(L,k){this._mainThreadConsole=L.getProxy(R.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,k){const b=this,I=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){b._handleConsoleCall(L,k,I,arguments)}})}_handleConsoleCall(L,k,b,I){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:S(I,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,b,I)}};w=je([Be(0,A.IExtHostRpcService),Be(1,l.IExtHostInitDataService)],w),e.AbstractExtHostConsoleForwarder=w;const P=1e5;function S(C,L){const k=[];if(C.length)for(let b=0;b<C.length;b++){let I=C[b];if(typeof I>"u")I="undefined";else if(I instanceof Error){const y=I;y.stack?I=y.stack:I=y.toString()}k.push(I)}if(L){const b=new Error().stack;b&&k.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,o.safeStringify)(k);return b.length>P?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(Se[139],ye([1,0,2,5,7,4,20,13,16,8,12,26]),function(re,e,o,R,l,A,w,P,S,C,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class Mi{constructor(y,f){this._logService=f,this._provider=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(y,f){const d=Mi._handlePool++;this._provider.set(d,{provider:y,extensionDescription:f}),this._proxy.$registerDecorationProvider(d,f.identifier.value);const u=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(d,null);return}const v=(0,S.asArray)(m);if(v.length<=Mi._maxEventSize){this._proxy.$onDidChange(d,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,v.length);const D=v.map(s=>({uri:s,rank:(0,C.count)(s.path,"/")})),p=(0,S.groupBy)(D,(s,r)=>s.rank-r.rank||(0,C.compare)(s.uri.path,r.uri.path)),n=[];e:for(const s of p){let r;for(const a of s){const c=(0,L.dirname)(a.uri.path);if(r!==c&&(r=c,n.push(a.uri)>=Mi._maxEventSize))break e}}this._proxy.$onDidChange(d,n)});return new l.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(y,f,d){if(!this._provider.has(y))return Object.create(null);const u=Object.create(null),{provider:m,extensionDescription:v}=this._provider.get(y);return await Promise.all(f.map(async D=>{try{const{uri:p,id:n}=D,s=await Promise.resolve(m.provideFileDecoration(o.URI.revive(p),d));if(!s)return;try{l.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.checkProposedApiEnabled)(v,"codiconDecoration"),u[n]=[s.propagate,s.tooltip,s.badge,s.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${v}': ${r}`)}}catch(p){this._logService.error(p)}})),u}};b._handlePool=0,b._maxEventSize=250,b=je([Be(0,w.IExtHostRpcService),Be(1,P.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[257],ye([1,0,177,124,2,5,7,14,3,13,28,48]),function(re,e,o,R,l,A,w,P,S,C,L,k){"use strict";var b,I,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(m,v,D,p,n,s,r){this._name=m,this._owner=v,this._maxDiagnosticsPerFile=D,this._modelVersionIdProvider=p,b.set(this,void 0),I.set(this,void 0),y.set(this,void 0),this._isDisposed=!1,Je(this,y,new L.ResourceMap(a=>n.getComparisonKey(a)),"f"),Je(this,b,s,"f"),Je(this,I,r,"f")}dispose(){this._isDisposed||(Ne(this,I,"f").fire([...Ne(this,y,"f").keys()]),Ne(this,b,"f")?.$clear(this._owner),Ne(this,y,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,v){if(!m){this.clear();return}this._checkDisposed();let D=[];if(l.URI.isUri(m)){if(!v){this.delete(m);return}Ne(this,y,"f").set(m,v.slice()),D=[m]}else if(Array.isArray(m)){D=[];let n;m=[...m].sort(f._compareIndexedTuplesByUri);for(const s of m){const[r,a]=s;if((!n||r.toString()!==n.toString())&&(n&&Ne(this,y,"f").get(n).length===0&&Ne(this,y,"f").delete(n),n=r,D.push(r),Ne(this,y,"f").set(r,[])),a)Ne(this,y,"f").get(r)?.push(...a);else{const c=Ne(this,y,"f").get(r);c&&(c.length=0)}}}if(Ne(this,I,"f").fire(D),!Ne(this,b,"f"))return;const p=[];for(const n of D){let s=[];const r=Ne(this,y,"f").get(n);if(r)if(r.length>this._maxDiagnosticsPerFile){s=[];const a=[w.DiagnosticSeverity.Error,w.DiagnosticSeverity.Warning,w.DiagnosticSeverity.Information,w.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const g of r)if(g.severity===a[c]&&s.push({...P.Diagnostic.from(g),modelVersionId:this._modelVersionIdProvider(n)})===this._maxDiagnosticsPerFile)break e;s.push({severity:R.MarkerSeverity.Info,message:(0,o.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(a=>({...P.Diagnostic.from(a),modelVersionId:this._modelVersionIdProvider(n)}));p.push([n,s])}Ne(this,b,"f").$changeMany(this._owner,p)}delete(m){this._checkDisposed(),Ne(this,I,"f").fire([m]),Ne(this,y,"f").delete(m),Ne(this,b,"f")?.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),Ne(this,I,"f").fire([...Ne(this,y,"f").keys()]),Ne(this,y,"f").clear(),Ne(this,b,"f")?.$clear(this._owner)}forEach(m,v){this._checkDisposed();for(const[D,p]of this)m.call(v,D,p,this)}*[(b=new WeakMap,I=new WeakMap,y=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const m of Ne(this,y,"f").keys())yield[m,this.get(m)]}get(m){this._checkDisposed();const v=Ne(this,y,"f").get(m);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(Ne(this,y,"f").get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,v){return m[0].toString()<v[0].toString()?-1:m[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=f;let d=class pi{static _mapper(m){const v=new L.ResourceMap;for(const D of m)v.set(D,D);return{uris:Object.freeze(Array.from(v.values()))}}constructor(m,v,D,p){this._logService=v,this._fileSystemInfoService=D,this._extHostDocumentsAndEditors=p,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,pi._mapper),this._proxy=m.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,v){const{_collections:D,_proxy:p,_onDidChangeDiagnostics:n,_logService:s,_fileSystemInfoService:r,_extHostDocumentsAndEditors:a}=this,c=new class{$changeMany(t,h){p.$changeMany(t,h),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,t,h.length===0?"CLEARING":h)}$clear(t){p.$clear(t),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,t)}dispose(){p.dispose()}};let g;if(!v)v="_generated_diagnostic_collection_name_#"+pi._idPool++,g=v;else if(!D.has(v))g=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do g=v+pi._idPool++;while(D.has(g))}return new class extends f{constructor(){super(v,g,pi._maxDiagnosticsPerFile,t=>a.getDocument(t)?.version,r.extUri,c,n),D.set(g,this)}dispose(){super.dispose(),D.delete(g)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const v=new Map,D=[];for(const p of this._collections.values())p.forEach((n,s)=>{let r=v.get(n.toString());typeof r>"u"&&(r=D.length,v.set(n.toString(),r),D.push([n,[]])),D[r][1]=D[r][1].concat(...s)});return D}}_getDiagnostics(m){let v=[];for(const D of this._collections.values())D.has(m)&&(v=v.concat(D.get(m)));return v}$acceptMarkersChange(m){if(!this._mirrorCollection){const v="_generated_mirror",D=new f(v,v,pi._maxDiagnosticsPerFile,p=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(v,D),this._mirrorCollection=D}for(const[v,D]of m)this._mirrorCollection.set(l.URI.revive(v),D.map(P.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=je([Be(1,C.ILogService),Be(2,k.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(Se[258],ye([1,0,2,5,26]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(P){this._proxy=P.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(P,S){return S?.allowUIResources&&(0,l.checkProposedApiEnabled)(P,"showLocal"),this._proxy.$showOpenDialog(S).then(C=>C?C.map(L=>o.URI.revive(L)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(S=>S?o.URI.revive(S):void 0)}}e.ExtHostDialogs=A}),define(Se[259],ye([1,0,10,2,7,5,15,21,8]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(k,b,I){this._documentsAndEditors=b,this._logService=I,this._documentContentProviders=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,b){if(Object.keys(w.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const I=C._handlePool++;this._documentContentProviders.set(I,b),this._proxy.$registerTextContentProvider(I,k);let y;return typeof b.onDidChange=="function"&&(y=b.onDidChange(f=>{if(f.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(I,f).then(d=>{if(!d&&typeof d!="string")return;const u=this._documentsAndEditors.getDocument(f);if(!u)return;const m=(0,S.splitLines)(d);if(!u.equalLines(m))return this._proxy.$onVirtualDocumentChange(f,d)},o.onUnexpectedError)})),new l.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(k,b){const I=this._documentContentProviders.get(k);return I?Promise.resolve(I.provideTextDocumentContent(R.URI.revive(b),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}C._handlePool=0,e.ExtHostDocumentContentProvider=C}),define(Se[260],ye([1,0,3,6,2,5,135,14,9,23,7]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(I,y){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=y,this._documentsAndEditors.onDidRemoveDocuments(f=>{for(const d of f)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(f=>{for(const d of f)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const y=this._documentsAndEditors.getDocument(I);if(y)return y}getDocument(I){const y=this.getDocumentData(I);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return y.document}ensureDocumentData(I){const y=this._documentsAndEditors.getDocument(I);if(y)return Promise.resolve(y);let f=this._documentLoader.get(I.toString());return f||(f=this._proxy.$tryOpenDocument(I).then(d=>{this._documentLoader.delete(I.toString());const u=l.URI.revive(d);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(u))},d=>(this._documentLoader.delete(I.toString()),Promise.reject(d))),this._documentLoader.set(I.toString(),f)),f}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(y=>l.URI.revive(y))}$acceptModelLanguageChanged(I,y){const f=l.URI.revive(I),d=this._documentsAndEditors.getDocument(f);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(y),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(I){const y=l.URI.revive(I),f=this._documentsAndEditors.getDocument(y);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(f.document)}$acceptDirtyStateChanged(I,y){const f=l.URI.revive(I),d=this._documentsAndEditors.getDocument(f);if(!d)throw new Error("unknown document");d._acceptIsDirty(y),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,y,f){const d=l.URI.revive(I),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");u._acceptIsDirty(f),u.onEvents(y);let m;y.isUndoing?m=L.TextDocumentChangeReason.Undo:y.isRedoing&&(m=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:u.document,contentChanges:y.changes.map(v=>({range:P.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text})),reason:m}))}setWordDefinitionFor(I,y){(0,w.setWordDefinitionFor)(I,y)}}e.ExtHostDocuments=k}),define(Se[59],ye([1,0,50,3,6,2,4,5,135,20,138,14,13,28,15,64,65]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(D){this.value=D,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let m=class{constructor(D,p){this._extHostRpc=D,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const p=[],n=[],s=[];if(D.removedDocuments)for(const r of D.removedDocuments){const a=A.URI.revive(r),c=this._documents.get(a);c?.unref()&&(this._documents.delete(a),p.push(c.value))}if(D.addedDocuments)for(const r of D.addedDocuments){const a=A.URI.revive(r.uri);let c=this._documents.get(a);if(c&&a.scheme!==y.Schemas.vscodeNotebookCell&&a.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);c||(c=new u(new S.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(a,c),n.push(c.value)),c.ref()}if(D.removedEditors)for(const r of D.removedEditors){const a=this._editors.get(r);this._editors.delete(r),a&&s.push(a)}if(D.addedEditors)for(const r of D.addedEditors){const a=A.URI.revive(r.documentUri);o.ok(this._documents.has(a),`document '${a}' does not exist`),o.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const c=this._documents.get(a).value,g=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>c.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(i=>k.Range.to(i)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,g)}D.newActiveEditor!==void 0&&(o.ok(D.newActiveEditor===null||this._editors.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this._activeEditorId=D.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(s),D.removedDocuments&&this._onDidRemoveDocuments.fire(p),D.addedDocuments&&this._onDidAddDocuments.fire(n),(D.removedEditors||D.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),D.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(D){return this._documents.get(D)?.value}allDocuments(){return f.Iterable.map(this._documents.values(),D=>D.value)}getEditor(D){return this._editors.get(D)}activeEditor(D){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return D?p:p?.value}allEditors(){return[...this._editors.values()]}};m=je([Be(0,C.IExtHostRpcService),Be(1,b.ILogService)],m),e.ExtHostDocumentsAndEditors=m,e.IExtHostDocumentsAndEditors=(0,w.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[60],ye([1,0,14,5,2,3,4,7,20,9,61]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,w.createDecorator)("IExtHostEditorTabs");class k{constructor(d,u,m){this._activeTabIdGetter=m,this._parentGroup=u,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,u={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(u)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(l.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(l.URI.revive(this._dto.input.base),l.URI.revive(this._dto.input.input1),l.URI.revive(this._dto.input.input2),l.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(l.URI.revive(this._dto.input.uri),l.URI.revive(this._dto.input.inputBoxUri));default:return}}}class b{constructor(d,u){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=u;for(const m of d.tabs)m.isActive&&(this._activeTabId=m.id),this._tabs.push(new k(m,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,u={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return o.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(m=>m.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(m=>m.apiObject))}};this._apiObject=Object.freeze(u)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const m=new k(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,m),d.tabDto.isActive&&(this._activeTabId=m.tabId),m}else if(d.kind===1){const m=this._tabs.splice(d.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return m.tabId===this._activeTabId&&(this._activeTabId=""),m}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this._tabs.splice(d.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,m),m}const u=this._tabs.find(m=>m.tabId===d.tabDto.id);if(!u)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),u.acceptDtoUpdate(d.tabDto),u}activeTabId(){return this._activeTabId}}let I=class{constructor(d){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,u={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(m=>m.apiObject))},get activeTabGroup(){const m=d._activeGroupId;return(0,C.assertIsDefined)(d._extHostTabGroups.find(D=>D.groupId===m)?.apiObject)},close:async(m,v)=>{const D=Array.isArray(m)?m:[m];return D.length?y(D[0])?this._closeGroups(D,v):this._closeTabs(D,v):!0}};this._apiObject=Object.freeze(u)}return this._apiObject}$acceptEditorTabModel(d){const u=new Set(this._extHostTabGroups.map(r=>r.groupId)),m=new Set(d.map(r=>r.groupId)),v=(0,L.diffSets)(u,m),D=this._extHostTabGroups.filter(r=>v.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],n=[];this._extHostTabGroups=d.map(r=>{const a=new b(r,()=>this._activeGroupId);return v.added.includes(a.groupId)?p.push(a.apiObject):n.push(a.apiObject),a});const s=(0,C.assertIsDefined)(d.find(r=>r.isActive===!0)?.groupId);s!==void 0&&this._activeGroupId!==s&&(this._activeGroupId=s),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:D,changed:n}))}$acceptTabGroupUpdate(d){const u=this._extHostTabGroups.find(m=>m.groupId===d.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const u=this._extHostTabGroups.find(v=>v.groupId===d.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const m=u.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}_findExtHostTabFromApi(d){for(const u of this._extHostTabGroups)for(const m of u.tabs)if(m.apiObject===d)return m}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(u=>u.apiObject===d)}async _closeTabs(d,u){const m=[];for(const v of d){const D=this._findExtHostTabFromApi(v);if(!D)throw new Error("Tab close: Invalid tab not found!");m.push(D.tabId)}return this._proxy.$closeTab(m,u)}async _closeGroups(d,u){const m=[];for(const v of d){const D=this._findExtHostTabGroupFromApi(v);if(!D)throw new Error("Group close: Invalid group not found!");m.push(D.groupId)}return this._proxy.$closeGroup(m,u)}};I=je([Be(0,S.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function y(f){return f.tabs!==void 0}}),define(Se[261],ye([1,0,2,5,6,7,14,154,8,22,26]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(y){this._stateMachine=void 0,this._schemes.push(y)}delete(y){const f=this._schemes.indexOf(y);f>=0&&(this._schemes.splice(f,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const y=this._schemes.sort(),f=[];let d,u,m=14,v=14;for(const D of y){let p=d?(0,S.commonPrefixLength)(d,D):0;for(p===0?u=1:u=v;p<D.length;p++)p+1===D.length?(m=v,v=9):v+=1,f.push([u,D.toUpperCase().charCodeAt(p),v]),f.push([u,D.toLowerCase().charCodeAt(p),v]),u=v;d=D,v=m}f.push([9,58,10]),f.push([10,47,12]),this._stateMachine=new P.StateMachine(f)}}provideDocumentLinks(y){this._initStateMachine();const f=[],d=P.LinkComputer.computeLinks({getLineContent(u){return y.lineAt(u-1).text},getLineCount(){return y.lineCount}},this._stateMachine);for(const u of d){const m=w.DocumentLink.to(u);m.target&&f.push(m)}return f}}class b{constructor(y,f){this._extHostLanguageFeatures=f,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=y.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(y,f,d,u={}){if(this._registeredSchemes.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(y,"*",this._linkProvider));const m=this._handlePool++;this._linkProvider.add(f),this._registeredSchemes.add(f),this._fsProvider.set(m,d);let v=2;u.isCaseSensitive&&(v+=1024),u.isReadonly&&(v+=2048),typeof d.copy=="function"&&(v+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(y,"fsChunks"),v+=4),this._proxy.$registerFileSystemProvider(m,f,v).catch(p=>{console.error(`FAILED to register filesystem provider of ${y.identifier.value}-extension for the scheme ${f}`),console.error(p)});const D=d.onDidChangeFile(p=>{const n=[];for(const s of p){const{uri:r,type:a}=s;if(r.scheme!==f)continue;let c;switch(a){case A.FileChangeType.Changed:c=0;break;case A.FileChangeType.Created:c=1;break;case A.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:r,type:c})}this._proxy.$onFileSystemChange(m,n)});return(0,l.toDisposable)(()=>{D.dispose(),this._linkProvider.delete(f),this._registeredSchemes.delete(f),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(y){const{type:f,ctime:d,mtime:u,size:m,permissions:v}=y;return{type:f,ctime:d,mtime:u,size:m,permissions:v}}$stat(y,f){return Promise.resolve(this._getFsProvider(y).stat(o.URI.revive(f))).then(d=>b._asIStat(d))}$readdir(y,f){return Promise.resolve(this._getFsProvider(y).readDirectory(o.URI.revive(f)))}$readFile(y,f){return Promise.resolve(this._getFsProvider(y).readFile(o.URI.revive(f))).then(d=>C.VSBuffer.wrap(d))}$writeFile(y,f,d,u){return Promise.resolve(this._getFsProvider(y).writeFile(o.URI.revive(f),d.buffer,u))}$delete(y,f,d){return Promise.resolve(this._getFsProvider(y).delete(o.URI.revive(f),d))}$rename(y,f,d,u){return Promise.resolve(this._getFsProvider(y).rename(o.URI.revive(f),o.URI.revive(d),u))}$copy(y,f,d,u){const m=this._getFsProvider(y);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(o.URI.revive(f),o.URI.revive(d),u))}$mkdir(y,f){return Promise.resolve(this._getFsProvider(y).createDirectory(o.URI.revive(f)))}$watch(y,f,d,u){const m=this._getFsProvider(y).watch(o.URI.revive(d),u);this._watches.set(f,m)}$unwatch(y,f){const d=this._watches.get(f);d&&(d.dispose(),this._watches.delete(f))}$open(y,f,d){const u=this._getFsProvider(y);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(o.URI.revive(f),d))}$close(y,f){const d=this._getFsProvider(y);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(f))}$read(y,f,d,u){const m=this._getFsProvider(y);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const v=C.VSBuffer.alloc(u);return Promise.resolve(m.read(f,d,v.buffer,0,u)).then(D=>v.slice(0,D))}$write(y,f,d,u){const m=this._getFsProvider(y);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(f,d,u.buffer,0,u.byteLength))}_getFsProvider(y){const f=this._fsProvider.get(y);if(!f){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return f}}e.ExtHostFileSystem=b}),define(Se[79],ye([1,0,5,44,7,22,4,20,48,6]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Qt{constructor(b,I){this._fileSystemProvider=new Map,this._proxy=b.getProxy(o.MainContext.MainThreadFileSystem);const y=this;this.value=Object.freeze({async stat(f){try{const d=y._fileSystemProvider.get(f.scheme);if(!d)return await y._proxy.$stat(f);await y._proxy.$ensureActivation(f.scheme);const u=await d.stat(f);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(d){Qt._handleError(d)}},async readDirectory(f){try{const d=y._fileSystemProvider.get(f.scheme);return d?(await y._proxy.$ensureActivation(f.scheme),(await d.readDirectory(f)).slice()):await y._proxy.$readdir(f)}catch(d){return Qt._handleError(d)}},async createDirectory(f){try{return await y._proxy.$mkdir(f)}catch(d){return Qt._handleError(d)}},async readFile(f){try{const d=y._fileSystemProvider.get(f.scheme);return d?(await y._proxy.$ensureActivation(f.scheme),(await d.readFile(f)).slice()):(await y._proxy.$readFile(f)).buffer}catch(d){return Qt._handleError(d)}},async writeFile(f,d){try{return await y._proxy.$writeFile(f,A.VSBuffer.wrap(d))}catch(u){return Qt._handleError(u)}},async delete(f,d){try{const u=y._fileSystemProvider.get(f.scheme);return u?(await y._proxy.$ensureActivation(f.scheme),await u.delete(f,{recursive:!1,...d})):await y._proxy.$delete(f,{recursive:!1,useTrash:!1,...d})}catch(u){return Qt._handleError(u)}},async rename(f,d,u){try{return await y._proxy.$rename(f,d,{overwrite:!1,...u})}catch(m){return Qt._handleError(m)}},async copy(f,d,u){try{return await y._proxy.$copy(f,d,{overwrite:!1,...u})}catch(m){return Qt._handleError(m)}},isWritableFileSystem(f){const d=I.getCapabilities(f);if(typeof d=="number")return!(d&2048)}})}static _handleError(b){if(b instanceof l.FileSystemError)throw b;if(!(b instanceof Error))throw new l.FileSystemError(String(b));if(b.name==="ENOPRO"||b.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(b.message);switch(b.name){case R.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(b.message);case R.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(b.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(b.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(b.message);case R.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(b.message);case R.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(b.message);default:throw new l.FileSystemError(b.message,b.name)}}addFileSystemProvider(b,I){return this._fileSystemProvider.set(b,I),(0,C.toDisposable)(()=>this._fileSystemProvider.delete(b))}};L=je([Be(0,P.IExtHostRpcService),Be(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,w.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[262],ye([1,0,3,38,2,5,14,7]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(k,b,I,y,f,d,u,m){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const v=this.ensureWatching(k,I,f);this._config=0,d&&(this._config+=1),u&&(this._config+=2),m&&(this._config+=4);const D=(0,R.parse)(f),p=typeof f=="string",n=y(s=>{if(!d)for(const r of s.created){const a=l.URI.revive(r);D(a.fsPath)&&(!p||b.getWorkspaceFolder(a))&&this._onDidCreate.fire(a)}if(!u)for(const r of s.changed){const a=l.URI.revive(r);D(a.fsPath)&&(!p||b.getWorkspaceFolder(a))&&this._onDidChange.fire(a)}if(!m)for(const r of s.deleted){const a=l.URI.revive(r);D(a.fsPath)&&(!p||b.getWorkspaceFolder(a))&&this._onDidDelete.fire(a)}});this._disposable=P.Disposable.from(v,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(k,b,I){const y=P.Disposable.from();if(typeof I=="string")return y;const f=k.getProxy(A.MainContext.MainThreadFileSystem);let d=!1;(I.pattern.includes(R.GLOBSTAR)||I.pattern.includes(R.GLOB_SPLIT))&&(d=!0);const u=Math.random();return f.$watch(b.identifier.value,u,I.baseUri,{recursive:d,excludes:[]}),P.Disposable.from({dispose:()=>f.$unwatch(u)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(k,b,I){this._mainContext=k,this._logService=b,this._extHostDocumentsAndEditors=I,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,b,I,y,f,d){return new S(this._mainContext,k,b,this._onFileSystemEvent.event,w.GlobPattern.from(I),y,f,d)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,b){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(I=>({oldUri:l.URI.revive(I.source),newUri:l.URI.revive(I.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(I=>l.URI.revive(I.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:b.map(I=>l.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,b){return(I,y,f)=>{const d=function(m){I.call(y,m)};return d.extension=k,b.event(d,void 0,f)}}async $onWillRunFileOperation(k,b,I,y){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(f=>({oldUri:l.URI.revive(f.source),newUri:l.URI.revive(f.target)}))},I,y);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(f=>l.URI.revive(f.target))},I,y);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(f=>l.URI.revive(f.target))},I,y)}}async _fireWillEvent(k,b,I,y){const f=new Set,d=[];if(await k.fireAsync(b,y,async(m,v)=>{const D=Date.now(),p=await Promise.resolve(m);p instanceof P.WorkspaceEdit&&(d.push([v.extension,p]),f.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-D>I&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),y.isCancellationRequested||d.length===0)return;const u={edits:[]};for(const[,m]of d){const{edits:v}=w.WorkspaceEdit.from(m,{getTextDocumentVersion:D=>this._extHostDocumentsAndEditors.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(v)}return{edit:u,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=C}),define(Se[263],ye([1,0,2,40]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(w,P,S,C,L){this._extHostNotebooks=P,this._textDocumentsAndEditors=S,this._commands=C;const k=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new R.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new R.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new R.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new R.ApiCommandResult("Notebook and input URI",b=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const I=this._extHostNotebooks.getEditorById(b.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri),notebookEditor:I.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(w,P,S,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:S,uri:w,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(w,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[w]})}}e.ExtHostInteractive=l}),define(Se[264],ye([1,0,6,5]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(w){this._handlePool=0,this._proxy=w.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(w){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,w),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=l}),define(Se[265],ye([1,0,2,23,14,7,72,5,8,32,16,9,150,21,6,120,101,75,43,10,19,26]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(M,B){this._documents=M,this._provider=B}async provideDocumentSymbols(M,B){const q=this._documents.getDocument(M),te=await this._provider.provideDocumentSymbols(q,B);if(!(0,L.isFalsyOrEmpty)(te))return te[0]instanceof A.DocumentSymbol?te.map(l.DocumentSymbol.from):n._asDocumentSymbolTree(te)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((te,de)=>{let Ee=te.location.range.start.compareTo(de.location.range.start);return Ee===0&&(Ee=de.location.range.end.compareTo(te.location.range.end)),Ee});const B=[],q=[];for(const te of M){const de={name:te.name||"!!MISSING: name!!",kind:l.SymbolKind.from(te.kind),tags:te.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:te.containerName,range:l.Range.from(te.location.range),selectionRange:l.Range.from(te.location.range),children:[]};for(;;){if(q.length===0){q.push(de),B.push(de);break}const Ee=q[q.length-1];if(C.Range.containsRange(Ee.range,de.range)&&!C.Range.equalsRange(Ee.range,de.range)){Ee.children?.push(de),q.push(de);break}q.pop()}}return B}}class s{constructor(M,B,q){this._documents=M,this._commands=B,this._provider=q,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,B){const q=this._documents.getDocument(M),te=await this._provider.provideCodeLenses(q,B);if(!te||B.isCancellationRequested)return;const de=this._cache.add(te),Ee=new y.DisposableStore;this._disposables.set(de,Ee);const Te={cacheId:de,lenses:[]};for(let ve=0;ve<te.length;ve++)Te.lenses.push({cacheId:[de,ve],range:l.Range.from(te[ve].range),command:this._commands.toInternal(te[ve].command,Ee)});return Te}async resolveCodeLens(M,B){const q=M.cacheId&&this._cache.get(...M.cacheId);if(!q)return;let te;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?te=q:te=await this._provider.resolveCodeLens(q,B),te||(te=q),B.isCancellationRequested)return;const de=M.cacheId&&this._disposables.get(M.cacheId[0]);if(!!de)return M.command=this._commands.toInternal(te.command??s._badCmd,de),M}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(oe){return Array.isArray(oe)?oe.map(l.DefinitionLink.from):oe?[l.DefinitionLink.from(oe)]:[]}class a{constructor(M,B){this._documents=M,this._provider=B}async provideDefinition(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideDefinition(te,de,q);return r(Ee)}}class c{constructor(M,B){this._documents=M,this._provider=B}async provideDeclaration(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideDeclaration(te,de,q);return r(Ee)}}class g{constructor(M,B){this._documents=M,this._provider=B}async provideImplementation(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideImplementation(te,de,q);return r(Ee)}}class i{constructor(M,B){this._documents=M,this._provider=B}async provideTypeDefinition(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideTypeDefinition(te,de,q);return r(Ee)}}class t{constructor(M,B){this._documents=M,this._provider=B}async provideHover(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideHover(te,de,q);if(!(!Ee||(0,L.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=te.getWordRangeAtPosition(de)),Ee.range||(Ee.range=new A.Range(de,de)),l.Hover.from(Ee)}}class h{constructor(M,B){this._documents=M,this._provider=B}async provideEvaluatableExpression(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideEvaluatableExpression(te,de,q);if(Ee)return l.EvaluatableExpression.from(Ee)}}class _{constructor(M,B){this._documents=M,this._provider=B}async provideInlineValues(M,B,q,te){const de=this._documents.getDocument(M),Ee=await this._provider.provideInlineValues(de,l.Range.to(B),l.InlineValueContext.to(q),te);if(Array.isArray(Ee))return Ee.map(Te=>l.InlineValue.from(Te))}}class E{constructor(M,B){this._documents=M,this._provider=B}async provideDocumentHighlights(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideDocumentHighlights(te,de,q);if(Array.isArray(Ee))return Ee.map(l.DocumentHighlight.from)}}class O{constructor(M,B){this._documents=M,this._provider=B}async provideLinkedEditingRanges(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.provideLinkedEditingRanges(te,de,q);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,L.coalesce)(Ee.ranges.map(l.Range.from)),wordPattern:Ee.wordPattern}}}class ${constructor(M,B){this._documents=M,this._provider=B}async provideReferences(M,B,q,te){const de=this._documents.getDocument(M),Ee=l.Position.to(B),Te=await this._provider.provideReferences(de,Ee,q,te);if(Array.isArray(Te))return Te.map(l.location.from)}}class H{constructor(M,B,q,te,de,Ee,Te){this._documents=M,this._commands=B,this._diagnostics=q,this._provider=te,this._logService=de,this._extension=Ee,this._apiDeprecation=Te,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(M,B,q,te){const de=this._documents.getDocument(M),Ee=b.Selection.isISelection(B)?l.Selection.to(B):l.Range.to(B),Te=[];for(const nt of this._diagnostics.getDiagnostics(M))if(Ee.intersection(nt.range)&&Te.push(nt)>H._maxCodeActionsPerFile)break;const ve={diagnostics:Te,only:q.only?new A.CodeActionKind(q.only):void 0,triggerKind:l.CodeActionTriggerKind.to(q.trigger)},Ce=await this._provider.provideCodeActions(de,Ee,ve,te);if(!(0,L.isNonEmptyArray)(Ce)||te.isCancellationRequested)return;const Ie=this._cache.add(Ce),ze=new y.DisposableStore;this._disposables.set(Ie,ze);const qe=[];for(let nt=0;nt<Ce.length;nt++){const Xe=Ce[nt];!Xe||(H._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,ze)})):(ve.only&&(Xe.kind?ve.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Ie,nt],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,ze),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(l.Diagnostic.from),edit:Xe.edit&&l.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ie,actions:qe}}async resolveCodeAction(M,B){const[q,te]=M,de=this._cache.get(q,te);if(!de||H._isCommand(de)||!this._provider.resolveCodeAction)return;const Ee=await this._provider.resolveCodeAction(de,B)??de;return Ee?.edit?l.WorkspaceEdit.from(Ee.edit,void 0):void 0}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}H._maxCodeActionsPerFile=1e3;class X{constructor(M,B,q,te){this._proxy=M,this._documents=B,this._provider=q,this._handle=te}async prepareDocumentPaste(M,B,q,te){if(!this._provider.prepareDocumentPaste)return;const de=this._documents.getDocument(M),Ee=B.map(ve=>l.Range.to(ve)),Te=l.DataTransfer.toDataTransfer(q,()=>{throw new v.NotImplementedError});return await this._provider.prepareDocumentPaste(de,Ee,Te,te),l.DataTransfer.toDataTransferDTO(Te)}async providePasteEdits(M,B,q,te,de){const Ee=this._documents.getDocument(B),Te=q.map(Ie=>l.Range.to(Ie)),ve=l.DataTransfer.toDataTransfer(te,async Ie=>(await this._proxy.$resolvePasteFileData(this._handle,M,Ie)).buffer),Ce=await this._provider.provideDocumentPasteEdits(Ee,Te,ve,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class V{constructor(M,B){this._documents=M,this._provider=B}async provideDocumentFormattingEdits(M,B,q){const te=this._documents.getDocument(M),de=await this._provider.provideDocumentFormattingEdits(te,B,q);if(Array.isArray(de))return de.map(l.TextEdit.from)}}class N{constructor(M,B){this._documents=M,this._provider=B}async provideDocumentRangeFormattingEdits(M,B,q,te){const de=this._documents.getDocument(M),Ee=l.Range.to(B),Te=await this._provider.provideDocumentRangeFormattingEdits(de,Ee,q,te);if(Array.isArray(Te))return Te.map(l.TextEdit.from)}}class T{constructor(M,B){this._documents=M,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,B,q,te,de){const Ee=this._documents.getDocument(M),Te=l.Position.to(B),ve=await this._provider.provideOnTypeFormattingEdits(Ee,Te,q,te,de);if(Array.isArray(ve))return ve.map(l.TextEdit.from)}}class F{constructor(M,B){this._provider=M,this._logService=B,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,B){const q=await this._provider.provideWorkspaceSymbols(M,B);if(!(0,L.isNonEmptyArray)(q))return{symbols:[]};const te=this._cache.add(q),de={cacheId:te,symbols:[]};for(let Ee=0;Ee<q.length;Ee++){const Te=q[Ee];if(!Te||!Te.name){this._logService.warn("INVALID SymbolInformation",Te);continue}de.symbols.push({...l.WorkspaceSymbol.from(Te),cacheId:[te,Ee]})}return de}async resolveWorkspaceSymbol(M,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const q=this._cache.get(...M.cacheId);if(q){const te=await this._provider.resolveWorkspaceSymbol(q,B);return te&&(0,R.mixin)(M,l.WorkspaceSymbol.from(te),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class U{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,B,q){this._documents=M,this._provider=B,this._logService=q}async provideRenameEdits(M,B,q,te){const de=this._documents.getDocument(M),Ee=l.Position.to(B);try{const Te=await this._provider.provideRenameEdits(de,Ee,q,te);return Te?l.WorkspaceEdit.from(Te):void 0}catch(Te){const ve=U._asMessage(Te);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(M,B,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const te=this._documents.getDocument(M),de=l.Position.to(B);try{const Ee=await this._provider.prepareRename(te,de,q);let Te,ve;if(A.Range.isRange(Ee)?(Te=Ee,ve=te.getText(Ee)):(0,k.isObject)(Ee)&&(Te=Ee.range,ve=Ee.placeholder),!Te||!ve)return;if(Te.start.line>de.line||Te.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(Te),text:ve}}catch(Ee){const Te=U._asMessage(Ee);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Z{constructor(M,B){this.resultId=M,this.tokens=B}}class J{constructor(M,B){this._documents=M,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,B,q){const te=this._documents.getDocument(M),de=B!==0?this._previousResults.get(B):null;let Ee=typeof de?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(te,de.resultId,q):await this._provider.provideDocumentSemanticTokens(te,q);return de&&this._previousResults.delete(B),Ee?(Ee=J._fixProvidedSemanticTokens(Ee),this._send(J._convertToEdits(de,Ee),Ee)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return J._isSemanticTokens(M)?J._isCorrectSemanticTokens(M)?M:new A.SemanticTokens(new Uint32Array(M.data),M.resultId):J._isSemanticTokensEdits(M)?J._isCorrectSemanticTokensEdits(M)?M:new A.SemanticTokensEdits(M.edits.map(B=>new A.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const B of M.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,B){if(!J._isSemanticTokens(B)||!M||!M.tokens)return B;const q=M.tokens,te=q.length,de=B.data,Ee=de.length;let Te=0;const ve=Math.min(te,Ee);for(;Te<ve&&q[Te]===de[Te];)Te++;if(Te===te&&Te===Ee)return new A.SemanticTokensEdits([],B.resultId);let Ce=0;const Ie=ve-Te;for(;Ce<Ie&&q[te-Ce-1]===de[Ee-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Te,deleteCount:te-Te-Ce,data:de.subarray(Te,Ee-Ce)}],B.resultId)}_send(M,B){if(J._isSemanticTokens(M)){const q=this._nextResultId++;return this._previousResults.set(q,new Z(M.resultId,M.data)),(0,f.encodeSemanticTokensDto)({id:q,type:"full",data:M.data})}if(J._isSemanticTokensEdits(M)){const q=this._nextResultId++;return J._isSemanticTokens(B)?this._previousResults.set(q,new Z(B.resultId,B.data)):this._previousResults.set(q,new Z(M.resultId)),(0,f.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(M.edits||[]).map(te=>({start:te.start,deleteCount:te.deleteCount,data:te.data}))})}return null}}class z{constructor(M,B){this._documents=M,this._provider=B}async provideDocumentRangeSemanticTokens(M,B,q){const te=this._documents.getDocument(M),de=await this._provider.provideDocumentRangeSemanticTokens(te,l.Range.to(B),q);return de?this._send(de):null}_send(M){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}class Q{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,B,q,te,de){this._documents=M,this._commands=B,this._provider=q,this._apiDeprecation=te,this._extension=de,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(M,B,q,te){const de=this._documents.getDocument(M),Ee=l.Position.to(B),Te=de.getWordRangeAtPosition(Ee)||new A.Range(Ee,Ee),ve=Te.with({end:Ee}),Ce=new m.StopWatch(!0),Ie=await this._provider.provideCompletionItems(de,Ee,te,l.CompletionContext.to(q));if(!Ie||te.isCancellationRequested)return;const ze=Array.isArray(Ie)?new A.CompletionList(Ie):Ie,qe=Q.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),nt=new y.DisposableStore;this._disposables.set(qe,nt);const Xe=[],tt={x:qe,b:Xe,a:{replace:l.Range.from(Te),insert:l.Range.from(ve)},c:ze.isIncomplete||void 0,d:Ce.elapsed()};for(let rt=0;rt<ze.items.length;rt++){const Ue=ze.items[rt],it=this._convertCompletionItem(Ue,[qe,rt],ve,Te);Xe.push(it)}return tt}async resolveCompletionItem(M,B){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...M);if(!q)return;const te=await this._provider.resolveCompletionItem(q,B);if(!!te)return this._convertCompletionItem(te,M)}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,B,q,te){const de=this._disposables.get(B[0]);if(!de)throw Error("DisposableStore is missing...");const Ee=this._commands.toInternal(M.command,de),Te={x:B,a:M.label,b:M.kind!==void 0?l.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(l.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:l.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(l.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=M.textEdit.newText):typeof M.insertText=="string"?Te.h=M.insertText:M.insertText instanceof A.SnippetString&&(Te.h=M.insertText.value,Te.i|=4);let ve;return M.textEdit?ve=M.textEdit.range:M.range&&(ve=M.range),A.Range.isRange(ve)?Te.j=l.Range.from(ve):ve&&(!q?.isEqual(ve.inserting)||!te?.isEqual(ve.replacing))&&(Te.j={insert:l.Range.from(ve.inserting),replace:l.Range.from(ve.replacing)}),Te}}class ie{async provideInlineCompletions(M,B,q,te){}disposeCompletions(M){}handleDidShowCompletionItem(M,B){}handlePartialAccept(M,B,q){}}class ge extends ie{constructor(M,B,q,te){super(),this._extension=M,this._documents=B,this._provider=q,this._commands=te,this._references=new K,this._isAdditionsProposedApiEnabled=(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[w.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[w.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,B,q,te){const de=this._documents.getDocument(M),Ee=l.Position.to(B),Te=await this._provider.provideInlineCompletionItems(de,Ee,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:l.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},te);if(!Te||te.isCancellationRequested)return;const ve=Array.isArray(Te)?Te:Te.items,Ce=this._isAdditionsProposedApiEnabled?Array.isArray(Te)?[]:Te.commands||[]:[];let Ie;return{pid:this._references.createReferenceId({dispose(){Ie?.dispose()},items:ve}),items:ve.map((qe,nt)=>{let Xe;qe.command&&(Ie||(Ie=new y.DisposableStore),Xe=this._commands.toInternal(qe.command,Ie));const tt=qe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:qe.filterText,range:qe.range?l.Range.from(qe.range):void 0,command:Xe,idx:nt,completeBracketPairs:this._isAdditionsProposedApiEnabled?qe.completeBracketPairs:!1}}),commands:Ce.map(qe=>(Ie||(Ie=new y.DisposableStore),this._commands.toInternal(qe,Ie)))}}disposeCompletions(M){this._references.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,B){const q=this._references.get(M)?.items[B];q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q)}handlePartialAccept(M,B,q){const te=this._references.get(M)?.items[B];te&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(te,q)}}class K{constructor(){this._references=new Map,this._idPool=1}createReferenceId(M){const B=this._idPool++;return this._references.set(B,M),B}disposeReferenceId(M){const B=this._references.get(M);return this._references.delete(M),B}get(M){return this._references.get(M)}}class Y{constructor(M,B){this._documents=M,this._provider=B,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(M,B,q,te){const de=this._documents.getDocument(M),Ee=l.Position.to(B),Te=this.reviveContext(q),ve=await this._provider.provideSignatureHelp(de,Ee,te,Te);if(ve){const Ce=this._cache.add([ve]);return{...l.SignatureHelp.from(ve),id:Ce}}}reviveContext(M){let B;if(M.activeSignatureHelp){const q=l.SignatureHelp.to(M.activeSignatureHelp),te=this._cache.get(M.activeSignatureHelp.id,0);te?(B=te,B.activeSignature=q.activeSignature,B.activeParameter=q.activeParameter):B=q}return{...M,activeSignatureHelp:B}}releaseSignatureHelp(M){this._cache.delete(M)}}class ee{constructor(M,B,q,te,de){this._documents=M,this._commands=B,this._provider=q,this._logService=te,this._extension=de,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,B,q){const te=this._documents.getDocument(M),de=l.Range.to(B),Ee=await this._provider.provideInlayHints(te,de,q);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(q.isCancellationRequested)return;const Te=this._cache.add(Ee);this._disposables.set(Te,new y.DisposableStore);const ve={hints:[],cacheId:Te};for(let Ce=0;Ce<Ee.length;Ce++)this._isValidInlayHint(Ee[Ce],de)&&ve.hints.push(this._convertInlayHint(Ee[Ce],[Te,Ce]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),ve}async resolveInlayHint(M,B){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...M);if(!q)return;const te=await this._provider.resolveInlayHint(q,B);if(!!te&&!!this._isValidInlayHint(te))return this._convertInlayHint(te,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,B){return M.label.length===0||Array.isArray(M.label)&&M.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(B&&!B.contains(M.position))}_convertInlayHint(M,B){const q=this._disposables.get(B[0]);if(!q)throw Error("DisposableStore is missing...");const te={label:"",cacheId:B,tooltip:l.MarkdownString.fromStrict(M.tooltip),position:l.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(l.TextEdit.from),kind:M.kind&&l.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?te.label=M.label:te.label=M.label.map(de=>{const Ee={label:de.value};return Ee.tooltip=l.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(Ee.location=l.location.from(de.location)),de.command&&(Ee.command=this._commands.toInternal(de.command,q)),Ee}),te}}class me{constructor(M,B){this._documents=M,this._provider=B,this._cache=new u.Cache("DocumentLink")}async provideLinks(M,B){const q=this._documents.getDocument(M),te=await this._provider.provideDocumentLinks(q,B);if(!(!Array.isArray(te)||te.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:te.filter(me._validateLink).map(l.DocumentLink.from)};{const de=this._cache.add(te),Ee={links:[],cacheId:de};for(let Te=0;Te<te.length;Te++){if(!me._validateLink(te[Te]))continue;const ve=l.DocumentLink.from(te[Te]);ve.cacheId=[de,Te],Ee.links.push(ve)}return Ee}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,B){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...M);if(!q)return;const te=await this._provider.resolveDocumentLink(q,B);if(!(!te||!me._validateLink(te)))return l.DocumentLink.from(te)}releaseLinks(M){this._cache.delete(M)}}class be{constructor(M,B){this._documents=M,this._provider=B}async provideColors(M,B){const q=this._documents.getDocument(M),te=await this._provider.provideDocumentColors(q,B);return Array.isArray(te)?te.map(Ee=>({color:l.Color.from(Ee.color),range:l.Range.from(Ee.range)})):[]}async provideColorPresentations(M,B,q){const te=this._documents.getDocument(M),de=l.Range.to(B.range),Ee=l.Color.to(B.color),Te=await this._provider.provideColorPresentations(Ee,{document:te,range:de},q);if(!!Array.isArray(Te))return Te.map(l.ColorPresentation.from)}}class De{constructor(M,B){this._documents=M,this._provider=B}async provideFoldingRanges(M,B,q){const te=this._documents.getDocument(M),de=await this._provider.provideFoldingRanges(te,B,q);if(!!Array.isArray(de))return de.map(l.FoldingRange.from)}}class Ae{constructor(M,B,q){this._documents=M,this._provider=B,this._logService=q}async provideSelectionRanges(M,B,q){const te=this._documents.getDocument(M),de=B.map(l.Position.to),Ee=await this._provider.provideSelectionRanges(te,de,q);if(!(0,L.isNonEmptyArray)(Ee))return[];if(Ee.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let ve=0;ve<de.length;ve++){const Ce=[];Te.push(Ce);let Ie=de[ve],ze=Ee[ve];for(;;){if(!ze.range.contains(Ie))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(l.SelectionRange.from(ze)),!ze.parent)break;Ie=ze.range,ze=ze.parent}}return Te}}class ae{constructor(M,B){this._documents=M,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.prepareCallHierarchy(te,de,q);if(!Ee)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(Ee)?Ee.map(ve=>this._cacheAndConvertItem(Te,ve)):[this._cacheAndConvertItem(Te,Ee)]}async provideCallsTo(M,B,q){const te=this._itemFromCache(M,B);if(!te)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(te,q);if(!!de)return de.map(Ee=>({from:this._cacheAndConvertItem(M,Ee.from),fromRanges:Ee.fromRanges.map(Te=>l.Range.from(Te))}))}async provideCallsFrom(M,B,q){const te=this._itemFromCache(M,B);if(!te)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(te,q);if(!!de)return de.map(Ee=>({to:this._cacheAndConvertItem(M,Ee.to),fromRanges:Ee.fromRanges.map(Te=>l.Range.from(Te))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,B){const q=this._cache.get(M),te=l.CallHierarchyItem.from(B,M,q.size.toString(36));return q.set(te._itemId,B),te}_itemFromCache(M,B){return this._cache.get(M)?.get(B)}}class le{constructor(M,B){this._documents=M,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(M,B,q){const te=this._documents.getDocument(M),de=l.Position.to(B),Ee=await this._provider.prepareTypeHierarchy(te,de,q);if(!Ee)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(Ee)?Ee.map(ve=>this._cacheAndConvertItem(Te,ve)):[this._cacheAndConvertItem(Te,Ee)]}async provideSupertypes(M,B,q){const te=this._itemFromCache(M,B);if(!te)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySupertypes(te,q);if(!!de)return de.map(Ee=>this._cacheAndConvertItem(M,Ee))}async provideSubtypes(M,B,q){const te=this._itemFromCache(M,B);if(!te)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySubtypes(te,q);if(!!de)return de.map(Ee=>this._cacheAndConvertItem(M,Ee))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,B){const q=this._cache.get(M),te=l.TypeHierarchyItem.from(B,M,q.size.toString(36));return q.set(te._itemId,B),te}_itemFromCache(M,B){return this._cache.get(M)?.get(B)}}class ue{constructor(M,B,q,te){this._proxy=M,this._documents=B,this._provider=q,this._handle=te}async provideDocumentOnDropEdits(M,B,q,te,de){const Ee=this._documents.getDocument(B),Te=l.Position.to(q),ve=l.DataTransfer.toDataTransfer(te,async Ie=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,M,Ie)).buffer),Ce=await this._provider.provideDocumentDropEdits(Ee,Te,ve,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ne{constructor(M,B){this.adapter=M,this.extension=B}}class ce{constructor(M,B,q,te,de,Ee,Te,ve){this._uriTransformer=B,this._documents=q,this._commands=te,this._diagnostics=de,this._logService=Ee,this._apiDeprecation=Te,this._extensionTelemetry=ve,this._adapter=new Map,this._proxy=M.getProxy(P.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(M){return l.DocumentSelector.from(M,this._uriTransformer)}_createDisposable(M){return new A.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return ce._handlePool++}async _withAdapter(M,B,q,te,de,Ee=!1){const Te=this._adapter.get(M);if(!Te||!(Te.adapter instanceof B))return te;const ve=Date.now();Ee||this._logService.trace(`[${Te.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const Ce=q(Te.adapter,Te.extension);return Promise.resolve(Ce).catch(Ie=>{(0,v.isCancellationError)(Ie)||(this._logService.error(`[${Te.extension.identifier.value}] provider FAILED`),this._logService.error(Ie),this._extensionTelemetry.onExtensionError(Te.extension.identifier,Ie))}).finally(()=>{Ee||this._logService.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),I.CancellationToken.isCancellationToken(de)?(0,D.raceCancellationError)(Ce,de):Ce}_addNewAdapter(M,B){const q=this._nextHandle();return this._adapter.set(q,new ne(M,B)),q}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,B,q,te){const de=this._addNewAdapter(new n(this._documents,q),M),Ee=te&&te.label||ce._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector(B),Ee),this._createDisposable(de)}$provideDocumentSymbols(M,B,q){return this._withAdapter(M,n,te=>te.provideDocumentSymbols(o.URI.revive(B),q),void 0,q)}registerCodeLensProvider(M,B,q){const te=this._nextHandle(),de=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(te,new ne(new s(this._documents,this._commands.converter,q),M)),this._proxy.$registerCodeLensSupport(te,this._transformDocumentSelector(B),de);let Ee=this._createDisposable(te);if(de!==void 0){const Te=q.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(de));Ee=A.Disposable.from(Ee,Te)}return Ee}$provideCodeLenses(M,B,q){return this._withAdapter(M,s,te=>te.provideCodeLenses(o.URI.revive(B),q),void 0,q)}$resolveCodeLens(M,B,q){return this._withAdapter(M,s,te=>te.resolveCodeLens(B,q),void 0,void 0)}$releaseCodeLenses(M,B){this._withAdapter(M,s,q=>Promise.resolve(q.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(M,B,q){const te=this._addNewAdapter(new a(this._documents,q),M);return this._proxy.$registerDefinitionSupport(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideDefinition(M,B,q,te){return this._withAdapter(M,a,de=>de.provideDefinition(o.URI.revive(B),q,te),[],te)}registerDeclarationProvider(M,B,q){const te=this._addNewAdapter(new c(this._documents,q),M);return this._proxy.$registerDeclarationSupport(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideDeclaration(M,B,q,te){return this._withAdapter(M,c,de=>de.provideDeclaration(o.URI.revive(B),q,te),[],te)}registerImplementationProvider(M,B,q){const te=this._addNewAdapter(new g(this._documents,q),M);return this._proxy.$registerImplementationSupport(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideImplementation(M,B,q,te){return this._withAdapter(M,g,de=>de.provideImplementation(o.URI.revive(B),q,te),[],te)}registerTypeDefinitionProvider(M,B,q){const te=this._addNewAdapter(new i(this._documents,q),M);return this._proxy.$registerTypeDefinitionSupport(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideTypeDefinition(M,B,q,te){return this._withAdapter(M,i,de=>de.provideTypeDefinition(o.URI.revive(B),q,te),[],te)}registerHoverProvider(M,B,q,te){const de=this._addNewAdapter(new t(this._documents,q),M);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector(B)),this._createDisposable(de)}$provideHover(M,B,q,te){return this._withAdapter(M,t,de=>de.provideHover(o.URI.revive(B),q,te),void 0,te)}registerEvaluatableExpressionProvider(M,B,q,te){const de=this._addNewAdapter(new h(this._documents,q),M);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector(B)),this._createDisposable(de)}$provideEvaluatableExpression(M,B,q,te){return this._withAdapter(M,h,de=>de.provideEvaluatableExpression(o.URI.revive(B),q,te),void 0,te)}registerInlineValuesProvider(M,B,q,te){const de=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new _(this._documents,q),M);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(B),de);let Te=this._createDisposable(Ee);if(de!==void 0){const ve=q.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(de));Te=A.Disposable.from(Te,ve)}return Te}$provideInlineValues(M,B,q,te,de){return this._withAdapter(M,_,Ee=>Ee.provideInlineValues(o.URI.revive(B),q,te,de),void 0,de)}registerDocumentHighlightProvider(M,B,q){const te=this._addNewAdapter(new E(this._documents,q),M);return this._proxy.$registerDocumentHighlightProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideDocumentHighlights(M,B,q,te){return this._withAdapter(M,E,de=>de.provideDocumentHighlights(o.URI.revive(B),q,te),void 0,te)}registerLinkedEditingRangeProvider(M,B,q){const te=this._addNewAdapter(new O(this._documents,q),M);return this._proxy.$registerLinkedEditingRangeProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideLinkedEditingRanges(M,B,q,te){return this._withAdapter(M,O,async de=>{const Ee=await de.provideLinkedEditingRanges(o.URI.revive(B),q,te);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?ce._serializeRegExp(Ee.wordPattern):void 0}},void 0,te)}registerReferenceProvider(M,B,q){const te=this._addNewAdapter(new $(this._documents,q),M);return this._proxy.$registerReferenceSupport(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideReferences(M,B,q,te,de){return this._withAdapter(M,$,Ee=>Ee.provideReferences(o.URI.revive(B),q,te,de),void 0,de)}registerCodeActionProvider(M,B,q,te){const de=new y.DisposableStore,Ee=this._addNewAdapter(new H(this._documents,this._commands.converter,this._diagnostics,q,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector(B),{providedKinds:te?.providedCodeActionKinds?.map(Te=>Te.value),documentation:te?.documentation?.map(Te=>({kind:Te.kind.value,command:this._commands.converter.toInternal(Te.command,de)}))},ce._extLabel(M),Boolean(q.resolveCodeAction)),de.add(this._createDisposable(Ee)),de}$provideCodeActions(M,B,q,te,de){return this._withAdapter(M,H,Ee=>Ee.provideCodeActions(o.URI.revive(B),q,te,de),void 0,de)}$resolveCodeAction(M,B,q){return this._withAdapter(M,H,te=>te.resolveCodeAction(B,q),void 0,void 0)}$releaseCodeActions(M,B){this._withAdapter(M,H,q=>Promise.resolve(q.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(M,B,q){const te=this._addNewAdapter(new V(this._documents,q),M);return this._proxy.$registerDocumentFormattingSupport(te,this._transformDocumentSelector(B),M.identifier,M.displayName||M.name),this._createDisposable(te)}$provideDocumentFormattingEdits(M,B,q,te){return this._withAdapter(M,V,de=>de.provideDocumentFormattingEdits(o.URI.revive(B),q,te),void 0,te)}registerDocumentRangeFormattingEditProvider(M,B,q){const te=this._addNewAdapter(new N(this._documents,q),M);return this._proxy.$registerRangeFormattingSupport(te,this._transformDocumentSelector(B),M.identifier,M.displayName||M.name),this._createDisposable(te)}$provideDocumentRangeFormattingEdits(M,B,q,te,de){return this._withAdapter(M,N,Ee=>Ee.provideDocumentRangeFormattingEdits(o.URI.revive(B),q,te,de),void 0,de)}registerOnTypeFormattingEditProvider(M,B,q,te){const de=this._addNewAdapter(new T(this._documents,q),M);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector(B),te,M.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(M,B,q,te,de,Ee){return this._withAdapter(M,T,Te=>Te.provideOnTypeFormattingEdits(o.URI.revive(B),q,te,de,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(M,B){const q=this._addNewAdapter(new F(B,this._logService),M);return this._proxy.$registerNavigateTypeSupport(q,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(M,B,q){return this._withAdapter(M,F,te=>te.provideWorkspaceSymbols(B,q),{symbols:[]},q)}$resolveWorkspaceSymbol(M,B,q){return this._withAdapter(M,F,te=>te.resolveWorkspaceSymbol(B,q),void 0,void 0)}$releaseWorkspaceSymbols(M,B){this._withAdapter(M,F,q=>q.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(M,B,q){const te=this._addNewAdapter(new U(this._documents,q,this._logService),M);return this._proxy.$registerRenameSupport(te,this._transformDocumentSelector(B),U.supportsResolving(q)),this._createDisposable(te)}$provideRenameEdits(M,B,q,te,de){return this._withAdapter(M,U,Ee=>Ee.provideRenameEdits(o.URI.revive(B),q,te,de),void 0,de)}$resolveRenameLocation(M,B,q,te){return this._withAdapter(M,U,de=>de.resolveRenameLocation(o.URI.revive(B),q,te),void 0,te)}registerDocumentSemanticTokensProvider(M,B,q,te){const de=this._addNewAdapter(new J(this._documents,q),M),Ee=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector(B),te,Ee);let Te=this._createDisposable(de);if(Ee){const ve=q.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Te=A.Disposable.from(Te,ve)}return Te}$provideDocumentSemanticTokens(M,B,q,te){return this._withAdapter(M,J,de=>de.provideDocumentSemanticTokens(o.URI.revive(B),q,te),null,te)}$releaseDocumentSemanticTokens(M,B){this._withAdapter(M,J,q=>q.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,B,q,te){const de=this._addNewAdapter(new z(this._documents,q),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector(B),te),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(M,B,q,te){return this._withAdapter(M,z,de=>de.provideDocumentRangeSemanticTokens(o.URI.revive(B),q,te),null,te)}registerCompletionItemProvider(M,B,q,te){const de=this._addNewAdapter(new Q(this._documents,this._commands.converter,q,this._apiDeprecation,M),M);return this._proxy.$registerCompletionsProvider(de,this._transformDocumentSelector(B),te,Q.supportsResolving(q),`${M.identifier.value}(${te.join("")})`),this._createDisposable(de)}$provideCompletionItems(M,B,q,te,de){return this._withAdapter(M,Q,Ee=>Ee.provideCompletionItems(o.URI.revive(B),q,te,de),void 0,de)}$resolveCompletionItem(M,B,q){return this._withAdapter(M,Q,te=>te.resolveCompletionItem(B,q),void 0,q)}$releaseCompletionItems(M,B){this._withAdapter(M,Q,q=>q.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(M,B,q){const te=new ge(M,this._documents,q,this._commands.converter),de=this._addNewAdapter(te,M);return this._proxy.$registerInlineCompletionsSupport(de,this._transformDocumentSelector(B),te.supportsHandleEvents),this._createDisposable(de)}$provideInlineCompletions(M,B,q,te,de){return this._withAdapter(M,ie,Ee=>Ee.provideInlineCompletions(o.URI.revive(B),q,te,de),void 0,de)}$handleInlineCompletionDidShow(M,B,q){this._withAdapter(M,ie,async te=>{te.handleDidShowCompletionItem(B,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,B,q,te){this._withAdapter(M,ie,async de=>{de.handlePartialAccept(B,q,te)},void 0,void 0)}$freeInlineCompletionsList(M,B){this._withAdapter(M,ie,async q=>{q.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(M,B,q,te){const de=Array.isArray(te)?{triggerCharacters:te,retriggerCharacters:[]}:te,Ee=this._addNewAdapter(new Y(this._documents,q),M);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(B),de),this._createDisposable(Ee)}$provideSignatureHelp(M,B,q,te,de){return this._withAdapter(M,Y,Ee=>Ee.provideSignatureHelp(o.URI.revive(B),q,te,de),void 0,de)}$releaseSignatureHelp(M,B){this._withAdapter(M,Y,q=>q.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(M,B,q){const te=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new ee(this._documents,this._commands.converter,q,this._logService,M),M);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector(B),typeof q.resolveInlayHint=="function",te,ce._extLabel(M));let Ee=this._createDisposable(de);if(te!==void 0){const Te=q.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(te));Ee=A.Disposable.from(Ee,Te)}return Ee}$provideInlayHints(M,B,q,te){return this._withAdapter(M,ee,de=>de.provideInlayHints(o.URI.revive(B),q,te),void 0,te)}$resolveInlayHint(M,B,q){return this._withAdapter(M,ee,te=>te.resolveInlayHint(B,q),void 0,q)}$releaseInlayHints(M,B){this._withAdapter(M,ee,q=>q.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(M,B,q){const te=this._addNewAdapter(new me(this._documents,q),M);return this._proxy.$registerDocumentLinkProvider(te,this._transformDocumentSelector(B),typeof q.resolveDocumentLink=="function"),this._createDisposable(te)}$provideDocumentLinks(M,B,q){return this._withAdapter(M,me,te=>te.provideLinks(o.URI.revive(B),q),void 0,q,B.scheme==="output")}$resolveDocumentLink(M,B,q){return this._withAdapter(M,me,te=>te.resolveLink(B,q),void 0,void 0,!0)}$releaseDocumentLinks(M,B){this._withAdapter(M,me,q=>q.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(M,B,q){const te=this._addNewAdapter(new be(this._documents,q),M);return this._proxy.$registerDocumentColorProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideDocumentColors(M,B,q){return this._withAdapter(M,be,te=>te.provideColors(o.URI.revive(B),q),[],q)}$provideColorPresentations(M,B,q,te){return this._withAdapter(M,be,de=>de.provideColorPresentations(o.URI.revive(B),q,te),void 0,te)}registerFoldingRangeProvider(M,B,q){const te=this._nextHandle(),de=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(te,new ne(new De(this._documents,q),M)),this._proxy.$registerFoldingRangeProvider(te,this._transformDocumentSelector(B),M.identifier,de);let Ee=this._createDisposable(te);if(de!==void 0){const Te=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));Ee=A.Disposable.from(Ee,Te)}return Ee}$provideFoldingRanges(M,B,q,te){return this._withAdapter(M,De,de=>de.provideFoldingRanges(o.URI.revive(B),q,te),void 0,te)}registerSelectionRangeProvider(M,B,q){const te=this._addNewAdapter(new Ae(this._documents,q,this._logService),M);return this._proxy.$registerSelectionRangeProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideSelectionRanges(M,B,q,te){return this._withAdapter(M,Ae,de=>de.provideSelectionRanges(o.URI.revive(B),q,te),[],te)}registerCallHierarchyProvider(M,B,q){const te=this._addNewAdapter(new ae(this._documents,q),M);return this._proxy.$registerCallHierarchyProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$prepareCallHierarchy(M,B,q,te){return this._withAdapter(M,ae,de=>Promise.resolve(de.prepareSession(o.URI.revive(B),q,te)),void 0,te)}$provideCallHierarchyIncomingCalls(M,B,q,te){return this._withAdapter(M,ae,de=>de.provideCallsTo(B,q,te),void 0,te)}$provideCallHierarchyOutgoingCalls(M,B,q,te){return this._withAdapter(M,ae,de=>de.provideCallsFrom(B,q,te),void 0,te)}$releaseCallHierarchy(M,B){this._withAdapter(M,ae,q=>Promise.resolve(q.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(M,B,q){const te=this._addNewAdapter(new le(this._documents,q),M);return this._proxy.$registerTypeHierarchyProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$prepareTypeHierarchy(M,B,q,te){return this._withAdapter(M,le,de=>Promise.resolve(de.prepareSession(o.URI.revive(B),q,te)),void 0,te)}$provideTypeHierarchySupertypes(M,B,q,te){return this._withAdapter(M,le,de=>de.provideSupertypes(B,q,te),void 0,te)}$provideTypeHierarchySubtypes(M,B,q,te){return this._withAdapter(M,le,de=>de.provideSubtypes(B,q,te),void 0,te)}$releaseTypeHierarchy(M,B){this._withAdapter(M,le,q=>Promise.resolve(q.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(M,B,q){const te=this._nextHandle();return this._adapter.set(te,new ne(new ue(this._proxy,this._documents,q,te),M)),this._proxy.$registerDocumentOnDropEditProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideDocumentOnDropEdits(M,B,q,te,de,Ee){return this._withAdapter(M,ue,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(B,o.URI.revive(q),te,de,Ee)),void 0,void 0)}registerDocumentPasteEditProvider(M,B,q,te){const de=this._nextHandle();return this._adapter.set(de,new ne(new X(this._proxy,this._documents,q,de),M)),this._proxy.$registerPasteEditProvider(de,this._transformDocumentSelector(B),!!q.prepareDocumentPaste,te.pasteMimeTypes),this._createDisposable(de)}$prepareDocumentPaste(M,B,q,te,de){return this._withAdapter(M,X,Ee=>Ee.prepareDocumentPaste(o.URI.revive(B),q,te,de),void 0,de)}$providePasteEdits(M,B,q,te,de,Ee){return this._withAdapter(M,X,Te=>Te.providePasteEdits(B,o.URI.revive(q),te,de,Ee),void 0,Ee)}static _serializeRegExp(M){return{pattern:M.source,flags:(0,S.regExpFlags)(M)}}static _serializeIndentationRule(M){return{decreaseIndentPattern:ce._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:ce._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ce._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ce._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:ce._serializeRegExp(M.beforeText),afterText:M.afterText?ce._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?ce._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(ce._serializeOnEnterRule)}setLanguageConfiguration(M,B,q){const{wordPattern:te}=q;if(te&&(0,S.regExpLeadsToEndlessLoop)(te))throw new Error(`Invalid language configuration: wordPattern '${te}' is not allowed to match the empty string.`);te?this._documents.setWordDefinitionFor(B,te):this._documents.setWordDefinitionFor(B,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const de=this._nextHandle(),Ee={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ce._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?ce._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ce._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,B,Ee),this._createDisposable(de)}$setWordDefinitions(M){for(const B of M)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}ce._handlePool=0,e.ExtHostLanguageFeatures=ce}),define(Se[266],ye([1,0,5,14,7,37,19,6]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,k,b,I){this._documents=k,this._commands=b,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,k){await this._proxy.$changeLanguage(L,k);const b=this._documents.getDocumentData(L);if(!b)throw new Error(`document '${L.toString()}' NOT found`);return b.document}async tokenAtPosition(L,k){const b=L.version,I=R.Position.from(k),y=await this._proxy.$tokensAtPosition(L.uri,I),f={type:l.StandardTokenType.Other,range:L.getWordRangeAtPosition(k)??new l.Range(k.line,k.character,k.line,k.character)};if(!y)return f;const d={range:R.Range.to(y.range),type:R.TokenType.to(y.type)};return!d.range.contains(k)||b!==L.version?f:d}createLanguageStatusItem(L,k,b){const I=this._handlePool++,y=this._proxy,f=this._ids,d=`${L.identifier.value}/${k}`;if(f.has(d))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);f.add(d);const u={selector:b,id:k,name:L.displayName??L.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let m;const v=new P.DisposableStore,D=()=>{m?.dispose(),m=(0,w.disposableTimeout)(()=>{v.clear(),this._proxy.$setLanguageStatus(I,{id:d,name:u.name??L.displayName??L.name,source:L.displayName??L.name,selector:R.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===l.LanguageStatusSeverity.Error?A.default.Error:u.severity===l.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:u.command&&this._commands.toInternal(u.command,v),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},p={dispose(){v.dispose(),m?.dispose(),y.$removeLanguageStatus(I),f.delete(d)},get id(){return u.id},get name(){return u.name},set name(n){u.name=n,D()},get selector(){return u.selector},set selector(n){u.selector=n,D()},get text(){return u.text},set text(n){u.text=n,D()},get detail(){return u.detail},set detail(n){u.detail=n,D()},get severity(){return u.severity},set severity(n){u.severity=n,D()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(n){u.accessibilityInformation=n,D()},get command(){return u.command},set command(n){u.command=n,D()},get busy(){return u.busy},set busy(n){u.busy=n,D()}};return D(),p}}e.ExtHostLanguages=S}),define(Se[97],ye([1,0,11,8,2,4,13,5,25,20]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(b,I,y){this.logService=y,this.bundleCache=new Map,this._proxy=I.getProxy(P.MainContext.MainThreadLocalization),this.currentLanguage=b.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===o.LANGUAGE_DEFAULT}getMessage(b,I){const{message:y,args:f,comment:d}=I;if(this.isDefaultLanguage)return(0,R.format2)(y,f??{});let u=y;d&&d.length>0&&(u+=`/${Array.isArray(d)?d.join(""):d}`);const m=this.bundleCache.get(b)?.contents[u];return m||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,R.format2)(m??y,f??{})}getBundle(b){return this.bundleCache.get(b)?.contents}getBundleUri(b){return this.bundleCache.get(b)?.uri}async initializeLocalizedMessages(b){if(this.isDefaultLanguage||!b.l10n&&!b.isBuiltin||this.bundleCache.has(b.identifier.value))return;let I;const y=await this.getBundleLocation(b);if(!y){this.logService.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const f=await this._proxy.$fetchBundleContents(y),d=JSON.parse(f);I=b.isBuiltin?d.contents?.bundle:d}catch(f){this.logService.error(`Failed to load translations for ${b.identifier.value} from ${y}: ${f.message}`);return}I&&this.bundleCache.set(b.identifier.value,{contents:I,uri:y})}async getBundleLocation(b){if(b.isBuiltin){const I=await this._proxy.$fetchBuiltInBundleUri(b.identifier.value,this.currentLanguage);return l.URI.revive(I)}return b.l10n?l.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};L=je([Be(0,S.IExtHostInitDataService),Be(1,C.IExtHostRpcService),Be(2,w.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Se[140],ye([1,0,13,5,25,20,2,69]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends o.AbstractLoggerService{constructor(k,b){super(b.logLevel,b.loggers.map(I=>(0,P.revive)(I))),this._proxy=k.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(k,b){b?this.setLogLevel(w.URI.revive(b),k):this.setLogLevel(k)}setVisibility(k,b){super.setVisibility(k,b),this._proxy.$setVisibility(k,b)}doCreateLogger(k,b,I){return new C(this._proxy,k,b,I)}};S=je([Be(0,A.IExtHostRpcService),Be(1,l.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class C extends o.AbstractMessageLogger{constructor(k,b,I,y){super(y?.logLevel==="always"),this.proxy=k,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(I),this.proxy.$createLogger(b,y).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,b){const I=[[k,b]];this.isLoggerCreated?this.doLog(I):this.buffer.push(...I)}doLog(k){this.proxy.$log(this.file,k)}}}),define(Se[267],ye([1,0,5,13,26]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let w=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(o.MainContext.MainThreadMessageService)}showMessage(S,C,L,k,b){const I={source:{identifier:S.identifier,label:S.displayName||S.name}};let y;typeof k=="string"||A(k)?y=[k,...b]:(I.modal=k?.modal,I.useCustom=k?.useCustom,I.detail=k?.detail,y=b),I.useCustom&&(0,l.checkProposedApiEnabled)(S,"resolvers");const f=[];for(let d=0;d<y.length;d++){const u=y[d];if(typeof u=="string")f.push({title:u,handle:d,isCloseAffordance:!1});else if(typeof u=="object"){const{title:m,isCloseAffordance:v}=u;f.push({title:m,isCloseAffordance:!!v,handle:d})}else this._logService.warn("Invalid message item:",u)}return this._proxy.$showMessage(C,L,I,f).then(d=>{if(typeof d=="number")return y[d]})}};w=je([Be(1,R.ILogService)],w),e.ExtHostMessageService=w}),define(Se[268],ye([1,0,22,3,6,28,8,9,2,75,5,40,14,7,58,243,136]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(v=>v.apiEditor)}constructor(v,D,p,n){this._textDocumentsAndEditors=p,this._textDocuments=n,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new C.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=v.getProxy(L.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=v.getProxy(L.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=v.getProxy(L.MainContext.MainThreadNotebookEditors),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const r=s.notebookEditor?.notebookUri,a=s.cell.handle,g=this._documents.get(r)?.getCell(a);if(g)return g.apiCell}if(s&&s.$mid===14){const r=s.uri,a=this._documents.get(r);if(a)return a.apiNotebook}return s}}),u._registerApiCommands(D)}getEditorById(v){const D=this._editors.get(v);if(!D)throw new Error(`unknown text editor: ${v}. known editors: ${[...this._editors.keys()]} `);return D}getIdByEditor(v){for(const[D,p]of this._editors)if(p.apiEditor===v)return D}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(v,D){const p=this._documents.get(v);if(!p&&!D)throw new Error(`NO notebook document for '${v}'`);return p}static _convertNotebookRegistrationData(v,D){if(!D)return;const p=D.filenamePattern.map(n=>b.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(D.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:D.displayName,filenamePattern:p,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,D,p){const n=u._notebookStatusBarItemProviderHandlePool++,s=typeof p.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,s,D);let r;return s!==void 0&&(r=p.onDidChangeCellStatusBarItems(a=>this._notebookProxy.$emitCellStatusBarEvent(s))),new I.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,s),r?.dispose()})}async createNotebookDocument(v){const D=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:v.viewType,content:v.content&&b.NotebookData.from(v.content)});return S.URI.revive(D)}async openNotebookDocument(v){const D=this._documents.get(v);if(D)return D.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(v),n=this._documents.get(S.URI.revive(p));return(0,P.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(v,D){S.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let p;typeof D=="object"?p={position:b.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(b.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(v.uri,v.notebookType,p),s=n&&this._editors.get(n)?.apiEditor;if(s)return s;throw n?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,D,p,n){const s=this._notebookStatusBarItemProviders.get(v),r=S.URI.revive(D),a=this._documents.get(r);if(!a||!s)return;const c=a.getCellFromIndex(p);if(!c)return;const g=await s.provideCellStatusBarItems(c.apiCell,n);if(!g)return;const i=new l.DisposableStore,t=this._statusBarCache.add([i]),_=(Array.isArray(g)?g:[g]).map(E=>b.NotebookStatusBarItem.from(E,this._commandsConverter,i));return{cacheId:t,items:_}}$releaseNotebookCellStatusBarItems(v){this._statusBarCache.delete(v)}registerNotebookSerializer(v,D,p,n,s){if((0,w.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,p),this._notebookProxy.$registerNotebookSerializer(r,{id:v.identifier,location:v.extensionLocation},D,b.NotebookDocumentContentOptions.from(n),u._convertNotebookRegistrationData(v,s)),(0,l.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(v,D,p){const n=this._notebookSerializer.get(v);if(!n)throw new Error("NO serializer found");const s=await n.deserializeNotebook(D.buffer,p);return new y.SerializableObjectWithBuffers(b.NotebookData.from(s))}async $notebookToData(v,D,p){const n=this._notebookSerializer.get(v);if(!n)throw new Error("NO serializer found");const s=await n.serializeNotebook(b.NotebookData.to(D.value),p);return o.VSBuffer.wrap(s)}_createExtHostEditor(v,D,p){if(this._editors.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const n=new d.ExtHostNotebookEditor(D,this._notebookEditorsProxy,v,p.visibleRanges.map(b.NotebookRange.to),p.selections.map(b.NotebookRange.to),typeof p.viewColumn=="number"?b.ViewColumn.to(p.viewColumn):void 0);this._editors.set(D,n)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const p of v.value.removedDocuments){const n=S.URI.revive(p),s=this._documents.get(n);s&&(s.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===n.toString()&&this._editors.delete(r.id)}if(v.value.addedDocuments){const p=[];for(const n of v.value.addedDocuments){const s=S.URI.revive(n.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const r=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,s,n);p.push(...n.cells.map(a=>f.ExtHostCell.asModelAddData(r.apiNotebook,a))),this._documents.get(s)?.dispose(),this._documents.set(s,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(v.value.addedEditors)for(const p of v.value.addedEditors){if(this._editors.has(p.id))return;const n=S.URI.revive(p.documentUri),s=this._documents.get(n);s&&this._createExtHostEditor(s,p.id,p)}const D=[];if(v.value.removedEditors)for(const p of v.value.removedEditors){const n=this._editors.get(p);n&&(this._editors.delete(p),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),D.push(n))}if(v.value.visibleEditors){this._visibleNotebookEditors=v.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const p=new Set;this._visibleNotebookEditors.forEach(n=>p.add(n.id));for(const n of this._editors.values()){const s=p.has(n.id);n._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this._activeNotebookEditor=void 0:v.value.newActiveEditor&&(this._editors.get(v.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${v.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(v){const D=k.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new k.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>o.VSBuffer.wrap(s))],new k.ApiCommandResult("Notebook Data",s=>b.NotebookData.to(s.value))),n=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new y.SerializableObjectWithBuffers(b.NotebookData.from(s)))],new k.ApiCommandResult("Bytes",s=>s.buffer));v.registerApiCommand(p),v.registerApiCommand(n)}}u._notebookStatusBarItemProviderHandlePool=0,e.ExtHostNotebookController=u}),define(Se[269],ye([1,0,16,19,21,3,6,28,2,27,13,75,5,40,14,7,95,233,26,58]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let D=class{constructor(c,g,i,t,h){this._initData=g,this._extHostNotebook=i,this._commands=t,this._logService=h,this._activeExecutions=new P.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new k.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=c.getProxy(b.MainContext.MainThreadNotebookKernels);const _=new I.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new I.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const O=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:O}}else if(E&&"notebookEditor"in E){const O=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return E})],I.ApiCommandResult.Void);this._commands.registerApiCommand(_)}createNotebookController(c,g,i,t,h,_){for(const ie of this._kernelData.values())if(ie.controller.id===g&&C.ExtensionIdentifier.equals(c.identifier,ie.extensionId))throw new Error(`notebook controller with id '${g}' ALREADY exist`);const E=this._handlePool++,O=this;this._logService.trace(`NotebookController[${E}], CREATED by ${c.identifier.value}, ${g}`);const $=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${c.identifier}'`);let H=!1;const X=new w.DisposableStore,V=new A.Emitter,N=new A.Emitter,T={id:r(c.identifier,g),notebookType:i,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:t||c.identifier.value,preloads:_?_.map(y.NotebookRendererScript.from):[]};let F=h??$,U;this._proxy.$addKernel(E,T).catch(ie=>{console.log(ie),H=!0});let Z=0;const J=()=>{if(H)return;const ie=++Z;Promise.resolve().then(()=>{ie===Z&&this._proxy.$updateKernel(E,T)})},z=new P.ResourceMap,Q={get id(){return g},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return T.label},set label(ie){T.label=ie??c.displayName??c.name,J()},get detail(){return T.detail??""},set detail(ie){T.detail=ie,J()},get description(){return T.description??""},set description(ie){T.description=ie,J()},get kind(){return(0,m.checkProposedApiEnabled)(c,"notebookControllerKind"),T.kind??""},set kind(ie){(0,m.checkProposedApiEnabled)(c,"notebookControllerKind"),T.kind=ie,J()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ie){T.supportedLanguages=ie,J()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){T.supportsExecutionOrder=ie,J()},get rendererScripts(){return T.preloads?T.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return F},set executeHandler(ie){F=ie??$},get interruptHandler(){return U},set interruptHandler(ie){U=ie,T.supportsInterrupt=Boolean(ie),J()},createNotebookCellExecution(ie){if(H)throw new Error("notebook controller is DISPOSED");if(!z.has(ie.notebook.uri))throw O._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return O._createNotebookCellExecution(ie,r(c.identifier,this.id))},dispose:()=>{H||(this._logService.trace(`NotebookController[${E}], DISPOSED`),H=!0,this._kernelData.delete(E),X.dispose(),V.dispose(),N.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(ie,ge){ge===f.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),O._proxy.$updateNotebookPriority(E,ie.uri,ge)},onDidReceiveMessage:N.event,postMessage(ie,ge){return(0,m.checkProposedApiEnabled)(c,"notebookMessaging"),O._proxy.$postMessage(E,ge&&O._extHostNotebook.getIdByEditor(ge),ie)},asWebviewUri(ie){return(0,m.checkProposedApiEnabled)(c,"notebookMessaging"),(0,d.asWebviewUri)(ie,O._initData.remote)}};return this._kernelData.set(E,{extensionId:c.identifier,controller:Q,onDidReceiveMessage:N,onDidChangeSelection:V,associatedNotebooks:z}),Q}getIdByController(c){for(const[g,i]of this._kernelData)if(i.controller===c)return r(i.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,g){const i=this._kernelDetectionTaskHandlePool++,t=this;this._logService.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelDetectionTask(i,g);const h={dispose:()=>{this._kernelDetectionTask.delete(i),t._proxy.$removeKernelDetectionTask(i)}};return this._kernelDetectionTask.set(i,h),h}registerKernelSourceActionProvider(c,g,i){const t=this._kernelSourceActionProviderHandlePool++,h=typeof i.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,_=this;this._kernelSourceActionProviders.set(t,i),this._logService.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelSourceActionProvider(t,t,g);let E;return h!==void 0&&(E=i.onDidChangeNotebookKernelSourceActions(O=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(h))),{dispose:()=>{this._kernelSourceActionProviders.delete(t),_._proxy.$removeKernelSourceActionProvider(t,t),E?.dispose()}}}async $provideKernelSourceActions(c,g){const i=this._kernelSourceActionProviders.get(c);if(i){const t=new w.DisposableStore;return this._kernelSourceActionProviderCache.add([t]),(await i.provideNotebookKernelSourceActions(g)??[]).map(_=>y.NotebookKernelSourceAction.from(_,this._commands.converter,t))}return[]}$acceptNotebookAssociation(c,g,i){const t=this._kernelData.get(c);if(t){const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(g));i?t.associatedNotebooks.set(h.uri,!0):t.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,h.uri.toString(),i),t.onDidChangeSelection.fire({selected:i,notebook:h.apiNotebook})}}async $executeCells(c,g,i){const t=this._kernelData.get(c);if(!t)return;const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(g)),_=[];for(const E of i){const O=h.getCell(E);O&&_.push(O.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,h.uri.toString(),_.length),await t.controller.executeHandler.call(t.controller,_,h.apiNotebook,t.controller)}catch(E){this._logService.error(`NotebookController[${c}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(c,g,i){const t=this._kernelData.get(c);if(!t)return;const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(g));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,h.apiNotebook);else for(const _ of i){const E=h.getCell(_);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,g,i){const t=this._kernelData.get(c);if(!t)return;const h=this._extHostNotebook.getEditorById(g);t.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:i}))}$cellExecutionChanged(c,g,i){const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(c)).getCell(g);if(h){const _=i?y.NotebookCellExecutionState.to(i):f.NotebookCellExecutionState.Idle;_!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:_})}}_createNotebookCellExecution(c,g){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const h=new n(g,t,this._proxy);this._activeExecutions.set(t.uri,h);const _=h.onDidChangeState(()=>{h.state===p.Resolved&&(h.dispose(),_.dispose(),this._activeExecutions.delete(t.uri))});return h.asApiObject()}};D=je([Be(4,L.ILogService)],D),e.ExtHostNotebookKernels=D;var p;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(p||(p={}));class n extends w.Disposable{get state(){return this._state}constructor(c,g,i){super(),this._cell=g,this._proxy=i,this._handle=n.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new s(10,t=>this.update(t)),this._executionOrder=g.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,c,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(c){await this._collector.addItem(c)}async update(c){const g=Array.isArray(c)?c:[c];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(g))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(c){let g=this._cell;if(c&&(g=this._cell.notebook.getCellFromApiCell(c)),!g)throw new Error("INVALID cell");return g.handle}validateAndConvertOutputs(c){return c.map(g=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(g.items,!0);return i===g.items?y.NotebookCellOutput.from(g):y.NotebookCellOutput.from({items:i,id:g.id,metadata:g.metadata})})}async updateOutputs(c,g,i){const t=this.cellIndexToHandle(g),h=this.validateAndConvertOutputs((0,o.asArray)(c));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:t,append:i,outputs:h})}async updateOutputItems(c,g,i){return c=f.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(c),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:c.map(y.NotebookCellOutputItem.from),outputId:g.id,append:i})}asApiObject(){const c=this;return Object.freeze({get token(){return c._tokenSource.token},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(i){c._executionOrder=i,c.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:c._executionOrder}])},start(i){if(c._state===p.Resolved||c._state===p.Started)throw new Error("Cannot call start again");c._state=p.Started,c._onDidChangeState.fire(),c.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,t){if(c._state===p.Resolved)throw new Error("Cannot call resolve twice");c._state=p.Resolved,c._onDidChangeState.fire(),c._collector.flush(),c._proxy.$completeExecution(c._handle,new v.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:i}))},clearOutput(i){return c.verifyStateForOutput(),c.updateOutputs([],i,!1)},appendOutput(i,t){return c.verifyStateForOutput(),c.updateOutputs(i,t,!0)},replaceOutput(i,t){return c.verifyStateForOutput(),c.updateOutputs(i,t,!1)},appendOutputItems(i,t){return c.verifyStateForOutput(),c.updateOutputItems(i,t,!0)},replaceOutputItems(i,t){return c.verifyStateForOutput(),c.updateOutputItems(i,t,!1)}})}}n.HANDLE=0;class s{constructor(c,g){this.delay=c,this.callback=g,this.batch=[],this.startedTimer=Date.now()}addItem(c){return this.batch.push(c),this.currentDeferred||(this.currentDeferred=new R.DeferredPromise,this.startedTimer=Date.now(),(0,R.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const c=this.currentDeferred;this.currentDeferred=void 0;const g=this.batch;return this.batch=[],this.callback(g).finally(()=>c.complete())}}function r(a,c){return`${a.value}/${c}`}e.createKernelId=r}),define(Se[270],ye([1,0,3,5,136]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(P,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,C){const L=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(S)?.fire({editor:L.apiEditor,message:C})}createRendererMessaging(P,S){if(!P.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,k,b)=>this.getOrCreateEmitterFor(S).event(L,k,b),postMessage:(L,k)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,k]=[k,L]);const b=k&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(b?.id,S,L)}}}getOrCreateEmitterFor(P){let S=this._rendererMessageEmitters.get(P);return S||(S=new o.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,S),S)}}e.ExtHostNotebookRenderers=A}),define(Se[271],ye([1,0,6,9,2,26,5]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(C){this.handlers=new Map,this.proxy=C.getProxy(w.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(C,L,k){if((0,A.checkProposedApiEnabled)(C,"profileContentHandlers"),this.handlers.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.handlers.set(L,k),this.proxy.$registerProfileContentHandler(L,k.name,k.description,C.identifier.value),(0,o.toDisposable)(()=>{this.handlers.delete(L),this.proxy.$unregisterProfileContentHandler(L)})}async $saveProfile(C,L,k,b){const I=this.handlers.get(C);if(!I)throw new Error(`Unknown handler with id: ${C}`);return I.saveProfile(L,k,b)}async $readProfile(C,L,k){const b=this.handlers.get(C);if(!b)throw new Error(`Unknown handler with id: ${C}`);return b.readProfile((0,R.isString)(L)?L:l.URI.revive(L),k)}}e.ExtHostProfileContentHandlers=P}),define(Se[272],ye([1,0,2,5,19,14]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class w{constructor(S,C){this.uriTransformer=C,this.providers=new Map,this.proxy=S.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,C,L){const k=o.URI.revive(C),b=this.providers.get(S);return b?(0,l.asPromise)(()=>b.provideOriginalResource(k,L)).then(I=>I||null):Promise.resolve(null)}registerQuickDiffProvider(S,C,L,k){const b=w.handlePool++;return this.providers.set(b,C),this.proxy.$registerQuickDiffProvider(b,A.DocumentSelector.from(S,this.uriTransformer),L,k),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(b),this.providers.delete(b)}}}}w.handlePool=0,e.ExtHostQuickDiff=w}),define(Se[273],ye([1,0,21,3,6,5,2,7,10,16,37,51,26,14]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function y(f,d,u){const m=f.getProxy(A.MainContext.MainThreadQuickOpen);class v{constructor(i,t){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=t}showQuickPick(i,t,h,_=o.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(t),O=++this._instances,$=m.$show(O,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},_),H={},X=$.then(()=>H);return Promise.race([X,E]).then(V=>{if(V===H)return;const N=(0,b.isProposedApiEnabled)(i,"quickPickItemTooltip");return E.then(T=>{const F=[];for(let U=0;U<T.length;U++){const Z=T[U];typeof Z=="string"?F.push({label:Z,handle:U}):Z.kind===P.QuickPickItemKind.Separator?F.push({type:"separator",label:Z.label}):(Z.tooltip&&!N&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),F.push({label:Z.label,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:N?I.MarkdownString.fromStrict(Z.tooltip):void 0,handle:U}))}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{h.onDidSelectItem(T[U])}),m.$setItems(O,F),$.then(U=>{if(typeof U=="number")return T[U];if(Array.isArray(U))return U.map(Z=>T[Z])})})}).then(void 0,V=>{if(!(0,S.isCancellationError)(V))return m.$setError(O,V),Promise.reject(V)})}$onItemSelected(i){this._onDidSelectItem?.(i)}showInput(i,t=o.CancellationToken.None){return this._validateInput=i?.validateInput,m.$input(i,typeof this._validateInput=="function",t).then(void 0,h=>{if(!(0,S.isCancellationError)(h))return Promise.reject(h)})}async $validateInput(i){if(!this._validateInput)return;const t=await this._validateInput(i);if(!t||typeof t=="string")return t;let h;switch(t.severity){case P.InputBoxValidationSeverity.Info:h=L.default.Info;break;case P.InputBoxValidationSeverity.Warning:h=L.default.Warning;break;case P.InputBoxValidationSeverity.Error:h=L.default.Error;break;default:h=t.message?L.default.Error:L.default.Ignore;break}return{content:t.message,severity:h}}async showWorkspaceFolderPick(i,t=o.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!h)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(E=>E.uri.toString()===h.uri.toString())}createQuickPick(i){const t=new a(i,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(i){const t=new c(i,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(i,t){this._sessions.get(i)?._fireDidChangeValue(t)}$onDidAccept(i){this._sessions.get(i)?._fireDidAccept()}$onDidChangeActive(i,t){const h=this._sessions.get(i);h instanceof a&&h._fireDidChangeActive(t)}$onDidChangeSelection(i,t){const h=this._sessions.get(i);h instanceof a&&h._fireDidChangeSelection(t)}$onDidTriggerButton(i,t){this._sessions.get(i)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(i,t,h){const _=this._sessions.get(i);_ instanceof a&&_._fireDidTriggerItemButton(t,h)}$onDidHide(i){this._sessions.get(i)?._fireDidHide()}}class D{constructor(i,t){this._extensionId=i,this._onDidDispose=t,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((t,h)=>{const _=t===P.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(_,t)}),this.update({buttons:i.map((t,h)=>({...r(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const t=this._handlesToButtons.get(i);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,l.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),m.$dispose(this._id))}update(i){if(!this._disposed){for(const t of Object.keys(i)){const h=i[t];this._pendingUpdate[t]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){m.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}D._nextId=1;function p(g){if(g instanceof P.ThemeIcon)return{id:g.id};const i=s(g),t=n(g);return{dark:typeof i=="string"?w.URI.file(i):i,light:typeof t=="string"?w.URI.file(t):t}}function n(g){return typeof g=="object"&&"light"in g?g.light:g}function s(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const i=p(g.iconPath);let t,h;return"id"in i?h=k.ThemeIcon.asClassName(i):t=i,{iconPath:t,iconClass:h}}class a extends D{constructor(i,t){super(i.identifier,t),this.extension=i,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this._onDidTriggerItemButtonEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((_,E)=>{this._handlesToItems.set(E,_),this._itemsToHandles.set(_,E)});const t=(0,b.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),h=[];for(let _=0;_<i.length;_++){const E=i[_];E.kind===P.QuickPickItemKind.Separator?h.push({type:"separator",label:E.label}):(E.tooltip&&!t&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),h.push({handle:_,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:t?I.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((O,$)=>({...r(O),tooltip:O.tooltip,handle:$}))}))}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(i){const t=(0,C.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(i){const t=(0,C.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(i,t){const h=this._handlesToItems.get(i);if(!h||!h.buttons||!h.buttons.length)return;const _=h.buttons[t];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:h})}}class c extends D{constructor(i,t){super(i.identifier,t),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get valueSelection(){return this._valueSelection}set valueSelection(i){this._valueSelection=i,this.update({valueSelection:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,i?typeof i=="string"?this.update({validationMessage:i,severity:L.default.Error}):this.update({validationMessage:i.message,severity:i.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new v(d,u)}e.createExtHostQuickOpen=y});var Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)},Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o};define(Se[274],ye([1,0,2,3,62,6,19,5,16,108,13,27,51,14,26]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y){"use strict";var f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(t){if(t)return typeof t.iconPath=="string"?o.URI.file(t.iconPath):o.URI.isUri(t.iconPath)||b.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function m(t,h){if(!t.iconPath&&!h.iconPath)return 0;if(t.iconPath){if(!h.iconPath)return 1}else return-1;const _=typeof t.iconPath=="string"?t.iconPath:o.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,E=typeof h.iconPath=="string"?h.iconPath:o.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,C.comparePaths)(_,E)}function v(t,h){let _=0;if(t.strikeThrough!==h.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==h.faded)return t.faded?1:-1;if(t.tooltip!==h.tooltip)return(t.tooltip||"").localeCompare(h.tooltip||"");if(_=m(t,h),_!==0)return _;if(t.light&&h.light)_=m(t.light,h.light);else{if(t.light)return 1;if(h.light)return-1}if(_!==0)return _;if(t.dark&&h.dark)_=m(t.dark,h.dark);else{if(t.dark)return 1;if(h.dark)return-1}return _}function D(t,h){if(t.command!==h.command)return t.command<h.command?-1:1;if(t.title!==h.title)return t.title<h.title?-1:1;if(t.tooltip!==h.tooltip){if(t.tooltip!==void 0&&h.tooltip!==void 0)return t.tooltip<h.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(t.arguments===h.arguments)return 0;if(t.arguments)if(h.arguments){if(t.arguments.length!==h.arguments.length)return t.arguments.length-h.arguments.length}else return 1;else return-1;for(let _=0;_<t.arguments.length;_++){const E=t.arguments[_],O=h.arguments[_];if(E!==O)return E<O?-1:1}return 0}function p(t,h){let _=(0,C.comparePaths)(t.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(_!==0)return _;if(t.command&&h.command)_=D(t.command,h.command);else{if(t.command)return 1;if(h.command)return-1}if(_!==0)return _;if(t.decorations&&h.decorations)_=v(t.decorations,h.decorations);else{if(t.decorations)return 1;if(h.decorations)return-1}return _}function n(t,h){for(let _=0;_<t.length;_++)if(t[_]!==h[_])return!1;return!0}function s(t,h){return t.command===h.command&&t.title===h.title&&t.tooltip===h.tooltip&&(t.arguments&&h.arguments?n(t.arguments,h.arguments):t.arguments===h.arguments)}function r(t,h){return(0,S.equals)(t,h,s)}class a{get value(){return this._value}set value(h){h=h??"",Ne(this,f,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Ne(this,f,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,y.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,y.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Ne(this,f,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Ne(this,f,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Ne(this,f,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}constructor(h,_,E){this._extension=h,this._sourceControlHandle=E,f.set(this,void 0),this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,f,_,"f")}showValidationMessage(h,_){(0,y.checkProposedApiEnabled)(this._extension,"scmValidation"),Ne(this,f,"f").$showValidationMessage(this._sourceControlHandle,h,_)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=a,f=new WeakMap;class c{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}constructor(h,_,E,O,$){this._proxy=h,this._commands=_,this._sourceControlHandle=E,this._id=O,this._label=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,_){const E=this._resourceStatesCommandsMap.get(h);return E?(0,w.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(p),E=(0,S.sortedDiff)(this._resourceSnapshot,h,p).map(H=>{const X=H.toInsert.map(V=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,V);const T=V.resourceUri;let F;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const ee=new A.DisposableStore;F=this._commands.converter.toInternal(V.command,ee),this._resourceStatesDisposablesMap.set(N,ee)}else this._resourceStatesCommandsMap.set(N,V.command);const U=u(V.decorations),Z=V.decorations&&u(V.decorations.light)||U,J=V.decorations&&u(V.decorations.dark)||U,z=[Z,J],Q=V.decorations&&V.decorations.tooltip||"",ie=V.decorations&&!!V.decorations.strikeThrough,ge=V.decorations&&!!V.decorations.faded,K=V.contextValue||"";return{rawResource:[N,T,z,Q,ie,ge,K,F],handle:N}});return{start:H.start,deleteCount:H.deleteCount,toInsert:X}}),O=E.map(({start:H,deleteCount:X,toInsert:V})=>[H,X,V.map(N=>N.rawResource)]),$=E.reverse();for(const{start:H,deleteCount:X,toInsert:V}of $){const N=V.map(F=>F.handle),T=this._handlesSnapshot.splice(H,X,...N);for(const F of T)this._resourceStatesMap.delete(F),this._resourceStatesCommandsMap.delete(F),this._resourceStatesDisposablesMap.get(F)?.dispose(),this._resourceStatesDisposablesMap.delete(F)}return this._resourceSnapshot=h,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}c._handlePool=0;class g{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Ne(this,d,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h;let _;(0,y.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(_=h?.label),Ne(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h,quickDiffLabel:_})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Ne(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=h;const _=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Ne(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:_})}get actionButton(){return(0,y.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,y.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=h;const _=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(E=>E.map(O=>this._commands.converter.toInternal(O,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Ne(this,d,"f").$updateSourceControl(this.handle,{actionButton:_??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&r(this._statusBarCommands,h))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=h;const _=(h||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));Ne(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}constructor(h,_,E,O,$,H){this._extension=h,this._commands=E,this._id=O,this._label=$,this._rootUri=H,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=g._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,d,_,"f"),this._inputBox=new a(h,Ne(this,d,"f"),this.handle),Ne(this,d,"f").$registerSourceControl(this.handle,O,$,H)}createResourceGroup(h,_){const E=new c(Ne(this,d,"f"),this._commands,this.handle,h,_),O=R.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,O),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const h=[],_=[];for(const[E,O]of this.createdResourceGroups){O.dispose();const $=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});R.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),$.dispose(),this._groups.delete(E.handle),Ne(this,d,"f").$unregisterGroup(this.handle,E.handle)}),h.push([E.handle,E.id,E.label,E.features]);const H=E._takeResourceStateSnapshot();H.length>0&&_.push([E.handle,H]),this._groups.set(E.handle,E)}Ne(this,d,"f").$registerGroups(this.handle,h,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(_=>{const E=_._takeResourceStateSnapshot();E.length!==0&&h.push([_.handle,E])}),h.length>0&&Ne(this,d,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Ne(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,g._handlePool=0,je([(0,l.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),je([(0,l.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let i=class on{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(h,_,E){this._commands=_,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=h.getProxy(P.MainContext.MainThreadSCM),this._telemetry=h.getProxy(P.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const $=this._sourceControls.get(O.sourceControlHandle);if(!$)return O;const H=$.getResourceGroup(O.groupHandle);return H?H.getResourceState(O.handle):O}else if(O&&O.$mid===4){const $=this._sourceControls.get(O.sourceControlHandle);return $?$.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const $=this._sourceControls.get(O.handle);return $||O}return O}})}createSourceControl(h,_,E,O){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,_,E,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const $=on._handlePool++,H=new g(h,this._proxy,this._commands,_,E,O);this._sourceControls.set($,H);const X=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier))||[];return X.push(H),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(h.identifier),X),H}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const _=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier)),E=_&&_[_.length-1];return E&&E.inputBox}$provideOriginalResource(h,_,E){const O=o.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,O.toString());const $=this._sourceControls.get(h);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,w.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(O,E)).then(H=>H||null)}$onInputBoxValueChange(h,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const E=this._sourceControls.get(h);return E&&E.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(h,_,E,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,_,E);const $=this._sourceControls.get(h);if(!$)return Promise.resolve(void 0);const H=$.getResourceGroup(_);return H?H.$executeResourceCommand(E,O):Promise.resolve(void 0)}$validateInput(h,_,E){this.logService.trace("ExtHostSCM#$validateInput",h);const O=this._sourceControls.get(h);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,w.asPromise)(()=>O.inputBox.validateInput(_,E)).then($=>{if(!$)return Promise.resolve(void 0);const H=I.MarkdownString.fromStrict($.message);return H?Promise.resolve([H,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};i._handlePool=0,i=je([Be(2,L.ILogService)],i),e.ExtHostSCM=i}),define(Se[98],ye([1,0,5,3,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,S){return this._proxy.$getPassword(P,S)}store(P,S,C){return this._proxy.$setPassword(P,S,C)}delete(P,S){return this._proxy.$deletePassword(P,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[275],ye([1,0,7,5,180,6,14,9]),function(re,e,o,R,l,A,w,P){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(y,f,d,u,m=o.StatusBarAlignment.Left,v){S.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,Je(this,S,y,"f"),Je(this,C,f,"f"),this._entryId=L.ID_GEN++,this._extension=d,this._id=u,this._alignment=m,this._priority=this.validatePriority(v)}validatePriority(y){if(!!(0,P.isNumber)(y))return y===Number.POSITIVE_INFINITY?Number.MAX_VALUE:y===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:y}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(y){this._text=y,this.update()}set name(y){this._name=y,this.update()}set tooltip(y){this._tooltip=y,this.update()}set color(y){this._color=y,this.update()}set backgroundColor(y){y&&!L.ALLOWED_BACKGROUND_COLORS.has(y.id)&&(y=void 0),this._backgroundColor=y,this.update()}set command(y){this._command?.fromApi!==y&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof y=="string"?this._command={fromApi:y,internal:Ne(this,C,"f").toInternal({title:"",command:y},this._latestCommandRegistration)}:y?this._command={fromApi:y,internal:Ne(this,C,"f").toInternal(y,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(y){this._accessibilityInformation=y,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let y;this._extension?this._id?y=`${this._extension.identifier.value}.${this._id}`:y=this._extension.identifier.value:y=this._id;let f;this._name?f=this._name:f=(0,l.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const u=w.MarkdownString.fromStrict(this._tooltip);Ne(this,S,"f").$setEntry(this._entryId,y,f,this._text,u,this._command?.internal,d,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}S=new WeakMap,C=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class k{constructor(y){this._messages=[],this._item=y.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,l.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(y){const f={message:y};return this._messages.unshift(f),this._update(),new o.Disposable(()=>{const d=this._messages.indexOf(f);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class b{constructor(y,f){this._proxy=y.getProxy(R.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new k(this)}createStatusBarEntry(y,f,d,u){return new L(this._proxy,this._commands,y,f,d,u)}setStatusBarMessage(y,f){const d=this._statusMessage.setMessage(y);let u;return typeof f=="number"?u=setTimeout(()=>d.dispose(),f):typeof f<"u"&&f.then(()=>d.dispose(),()=>d.dispose()),new o.Disposable(()=>{d.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=b}),define(Se[99],ye([1,0,5,3,4]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P,S){this._logService=S,this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this._proxy.$registerExtensionStorageKeysToSync(P,S)}async initializeExtensionStorage(P,S,C){const L=await this._proxy.$initializeExtensionStorage(P,S);let k;return L&&(k=this.safeParseValue(P,S,L)),k||C}setValue(P,S,C){return this._proxy.$setValue(P,S,C)}$acceptValue(P,S,C){const L=this.safeParseValue(P,S,C);L&&this._onDidChangeStorage.fire({shared:P,key:S,value:L})}safeParseValue(P,S,C){try{return JSON.parse(C)}catch(L){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${P}): ${L}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(Se[80],ye([1,0,4,25,13,79,2]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let P=class{constructor(C,L,k){this._logService=L,this._extHostFileSystem=k,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(b=>this._value=b)}async _getWorkspaceStorageURI(C){return w.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,L=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(w.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:w.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(C){if(this._value)return w.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return w.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=je([Be(0,R.IExtHostInitDataService),Be(1,l.ILogService),Be(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Se[41],ye([1,0,3,5,4,2,20,6,7,182,10,216,21,30,217,51,9,19,14]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class v{constructor(i,t,h,_){this._proxy=i,this._id=t,this._creationOptions=h,this._name=_,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(O=>this._pidPromiseComplete=O);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(O,$=!0){E._checkDisposed(),E._proxy.$sendText(E._id,O,$)},show(O){E._checkDisposed(),E._proxy.$show(E._id,O)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(i,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,d.withNullAsUndefined)(i.shellPath),shellArgs:(0,d.withNullAsUndefined)(i.shellArgs),cwd:(0,d.withNullAsUndefined)(i.cwd),env:(0,d.withNullAsUndefined)(i.env),icon:(0,d.withNullAsUndefined)(a(i.iconPath)),color:f.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,d.withNullAsUndefined)(i.message),strictEnv:(0,d.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this._serializeParentTerminal(i.location,t?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,t,h,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:f.ThemeColor.isThemeColor(_)?_.id:void 0,location:this._serializeParentTerminal(i,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(i,t){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in i?{viewColumn:m.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitStatus(i,t){this._exitStatus=Object.freeze({code:i,reason:t})}setDimensions(i,t){return i===this._cols&&t===this._rows||i===0||t===0?!1:(this._cols=i,this._rows=t,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(t=>{t!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=v;class D{get onProcessReady(){return this._onProcessReady.event}constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${t}`)}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput?.(i)}resize(i,t){this._pty.setDimensions?.({columns:i,rows:t})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(t=>this._onProcessData.fire(t)),this._pty.onDidClose?.((t=void 0)=>{this._onProcessExit.fire(t===void 0?void 0:t)}),this._pty.onDidOverrideDimensions?.(t=>{t&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this._pty.onDidChangeName?.(t=>{this._onDidChangeProperty.fire({type:"title",value:t})}),this._pty.open(i||void 0),i&&this._pty.setDimensions?.(i),this._onProcessReady.fire({pid:-1,cwd:""})}}let p=1,n=class extends P.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(i,t){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new o.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=t.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new y.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[h,_]of this._terminalProcesses)_.shutdown(!0)}})}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,t){const h=new v(this._proxy,(0,I.generateUuid)(),i,i.name),_=new D(i.pty);return h.createExtensionTerminal(i.location,this._serializeParentTerminal(i,t).resolvedExtHostIdentifier,a(i.iconPath),c(i.color)).then(E=>{const O=this._setupExtHostProcessListeners(E,_);this._terminalProcessDisposables[E]=O}),this._terminals.push(h),h.value}_serializeParentTerminal(i,t){if(t=t||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const h=i.location.parentTerminal;if(h){const _=this._terminals.find(E=>E.value===h);_&&(t.resolvedExtHostIdentifier=_._id)}}else i.location&&typeof i.location!="object"?t.location=i.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(i,t){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const _=new D(t),E=this._setupExtHostProcessListeners(i,_);this._terminalProcessDisposables[i]=E}async $acceptActiveTerminalChanged(i){const t=this._activeTerminal;if(i===null){this._activeTerminal=void 0,t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(i);h&&(this._activeTerminal=h,t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,t){const h=this._getTerminalById(i);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:t})}async $acceptTerminalDimensions(i,t,h){const _=this._getTerminalById(i);_&&_.setDimensions(t,h)&&this._onDidChangeTerminalDimensions.fire({terminal:_.value,dimensions:_.value.dimensions})}async $acceptTerminalMaximumDimensions(i,t,h){this._terminalProcesses.get(i)?.resize(t,h)}async $acceptTerminalTitleChange(i,t){const h=this._getTerminalById(i);h&&(h.name=t)}async $acceptTerminalClosed(i,t,h){const _=this._getTerminalObjectIndexById(this._terminals,i);if(_!==null){const E=this._terminals.splice(_,1)[0];E.setExitStatus(t,h),this._onDidCloseTerminal.fire(E.value)}}$acceptTerminalOpened(i,t,h,_){if(t){const $=this._getTerminalObjectIndexById(this._terminals,t);if($!==null){this._terminals[$]._id=i,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const E={name:_.name,shellPath:_.executable,shellArgs:_.args,cwd:typeof _.cwd=="string"?_.cwd:A.URI.revive(_.cwd),env:_.env,hideFromUser:_.hideFromUser},O=new v(this._proxy,i,E,h);this._terminals.push(O),this._onDidOpenTerminal.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(i,t){this._getTerminalById(i)?._setProcessId(t)}async $startExtensionTerminal(i,t){const h=this._getTerminalById(i);if(!h)return{message:(0,C.localize)(0,null,i)};h.isOpen||await new Promise(E=>{const O=this.onDidOpenTerminal(async $=>{$===h.value&&(O.dispose(),E())})});const _=this._terminalProcesses.get(i);_?_.startSendingEvents(t):this._extensionTerminalAwaitingStart[i]={initialDimensions:t}}_setupExtHostProcessListeners(i,t){const h=new P.DisposableStore;h.add(t.onProcessReady(E=>this._proxy.$sendProcessReady(i,E.pid,E.cwd))),h.add(t.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(i,E))),this._bufferer.startBuffering(i,t.onProcessData),h.add(t.onProcessExit(E=>this._onProcessExit(i,E))),this._terminalProcesses.set(i,t);const _=this._extensionTerminalAwaitingStart[i];return _&&t instanceof D&&(t.startSendingEvents(_.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),h}$acceptProcessAckDataEvent(i,t){this._terminalProcesses.get(i)?.acknowledgeDataEvent(t)}$acceptProcessInput(i,t){this._terminalProcesses.get(i)?.input(t)}$acceptTerminalInteraction(i){const t=this._getTerminalById(i);t?.setInteractedWith()&&this._onDidChangeTerminalState.fire(t.value)}$acceptProcessResize(i,t,h){try{this._terminalProcesses.get(i)?.resize(t,h)}catch(_){if(_.code!=="EPIPE"&&_.code!=="ERR_IPC_CHANNEL_CLOSED")throw _}}$acceptProcessShutdown(i,t){this._terminalProcesses.get(i)?.shutdown(t)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(t=>this._proxy.$sendProcessProperty(i,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(t=>this._proxy.$sendProcessProperty(i,{type:"cwd",value:t}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,t,h){if(this._profileProviders.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this._profileProviders.set(t,h),this._proxy.$registerProfileProvider(t,i.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(t),this._proxy.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(i,t,h){if(this._quickFixProviders.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this._quickFixProviders.set(i,h),this._proxy.$registerQuickFixProvider(i,t),new S.Disposable(()=>{this._quickFixProviders.delete(i),this._proxy.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,t){const h=new b.CancellationTokenSource().token;if(h.isCancellationRequested)return;const _=this._quickFixProviders.get(i);if(!_)return;const E=await _.provideTerminalQuickFixes(t,h);if(E!==null)return E}async $createContributedProfileTerminal(i,t){const h=new b.CancellationTokenSource().token;let _=await this._profileProviders.get(i)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(_&&!("options"in _)&&(_={options:_}),!_||!("options"in _))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in _.options){this.createExtensionTerminal(_.options,t);return}this.createTerminalFromOptions(_.options,t)}}async $provideLinks(i,t){const h=this._getTerminalById(i);if(!h)return[];this._terminalLinkCache.delete(i),this._terminalLinkCancellationSource.get(i)?.dispose(!0);const E=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,E);const O=[],$={terminal:h.value,line:t},H=[];for(const N of this._linkProviders)H.push(u.Promises.withAsyncBody(async T=>{E.token.onCancellationRequested(()=>T({provider:N,links:[]}));const F=await N.provideTerminalLinks($,E.token)||[];E.token.isCancellationRequested||T({provider:N,links:F})}));const X=await Promise.all(H);if(E.token.isCancellationRequested)return[];const V=new Map;for(const N of X)N&&N.links.length>0&&O.push(...N.links.map(T=>{const F={id:p++,startIndex:T.startIndex,length:T.length,label:T.tooltip};return V.set(F.id,{provider:N.provider,link:T}),F}));return this._terminalLinkCache.set(i,V),O}$activateLink(i,t){const h=this._terminalLinkCache.get(i)?.get(t);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(i,t){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const h=this._terminalProcessDisposables[i];h&&(h.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,t)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,t){const h=this._getTerminalObjectIndexById(i,t);return h!==null?i[h]:null}_getTerminalObjectIndexById(i,t){let h=null;return i.some((_,E)=>_._id===t?(h=E,!0):!1),h}getEnvironmentVariableCollection(i){let t=this._environmentVariableCollections.get(i.identifier.value);return t||(t=new s,this._setEnvironmentVariableCollection(i.identifier.value,t)),t}_syncEnvironmentVariableCollection(i,t){const h=(0,k.serializeEnvironmentVariableCollection)(t.map);this._proxy.$setEnvironmentVariableCollection(i,t.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(i){i.forEach(t=>{const h=t[0],_=new s(t[1]);this._setEnvironmentVariableCollection(h,_)})}$acceptDefaultProfile(i,t){const h=this._defaultProfile;this._defaultProfile=i,this._defaultAutomationProfile=t,h?.path!==i.path&&this._onDidChangeShell.fire(i.path)}_setEnvironmentVariableCollection(i,t){this._environmentVariableCollections.set(i,t),t.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,t)})}};n=je([Be(1,w.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class s{get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,t){this._setIfDiffers(i,{value:t,type:S.EnvironmentVariableMutatorType.Replace})}append(i,t){this._setIfDiffers(i,{value:t,type:S.EnvironmentVariableMutatorType.Append})}prepend(i,t){this._setIfDiffers(i,{value:t,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,t){const h=this.map.get(i);(!h||h.value!==t.value||h.type!==t.type)&&(this.map.set(i,t),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,t){this.map.forEach((h,_)=>i.call(t,_,h,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}let r=class extends n{constructor(i){super(!1,i)}createTerminal(i,t,h){throw new L.NotSupportedError}createTerminalFromOptions(i,t){throw new L.NotSupportedError}};r=je([Be(0,w.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function a(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function c(g){return f.ThemeColor.isThemeColor(g)?g:void 0}});var Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)},Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o};define(Se[276],ye([1,0,16,19,22,21,3,63,89,6,23,9,30,5,20,137,14,7,57,94,76,26]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p){"use strict";var n,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(N,T,F){this.editors=F,this.resultsChangedEmitter=new w.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(I.MainContext.MainThreadTesting),this.observer=new $(this.proxy),this.runTracker=new i(this.proxy),T.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const Z=U,J=Z.tests[Z.tests.length-1].item.extId;return this.controllers.get(m.TestId.root(J))?.collection.tree.get(J)?.actual??(0,f.toItemFromContext)(U)}})}createTestController(N,T,F,U){if(this.controllers.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const Z=new C.DisposableStore,J=Z.add(new f.ExtHostTestItemCollection(T,F,this.editors));J.root.label=F;const z=new Map,Q=this.proxy,ie={items:J.root.children,get label(){return F},set label(K){F=K,J.root.label=K,Q.$updateController(T,{label:F})},get refreshHandler(){return U},set refreshHandler(K){U=K,Q.$updateController(T,{canRefresh:!!K})},get id(){return T},createRunProfile:(K,Y,ee,me,be,De)=>{let Ae=(0,S.hash)(K);for(;z.has(Ae);)Ae++;return De!==void 0&&(0,p.checkProposedApiEnabled)(N,"testContinuousRun"),new H(this.proxy,z,T,Ae,K,Y,ee,me,be,De)},createTestItem(K,Y,ee){return new f.TestItemImpl(T,K,Y,ee)},createTestRun:(K,Y,ee=!0)=>this.runTracker.createTestRun(T,J,K,Y,ee),set resolveHandler(K){J.resolveHandler=K},get resolveHandler(){return J.resolveHandler},dispose:()=>{Z.dispose()}};Q.$registerTestController(T,F,!!U),Z.add((0,C.toDisposable)(()=>Q.$unregisterTestController(T)));const ge={controller:ie,collection:J,profiles:z};return this.controllers.set(T,ge),Z.add((0,C.toDisposable)(()=>this.controllers.delete(T))),Z.add(J.onDidGenerateDiff(K=>Q.$publishDiff(T,K.map(D.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.observer.checkout()}async runTests(N,T=A.CancellationToken.None){const F=t(N);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(F.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(Z=>m.TestId.fromExtHostTestItem(Z,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:X[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:N.exclude?.map(Z=>Z.id)},T)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,T,F){return(0,o.mapFind)(this.runTracker.trackers,Z=>Z.id===N?Z.getCoverage(T):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(N,T,F,U){return(0,o.mapFind)(this.runTracker.trackers,J=>J.id===N?J.getCoverage(T):void 0)?.resolveFileCoverage(F,U)??Promise.resolve([])}$configureRunProfile(N,T){this.controllers.get(N)?.profiles.get(T)?.configureHandler?.()}async $refreshTests(N,T){await this.controllers.get(N)?.controller.refreshHandler?.(T)}$publishTestResults(N){this.results=Object.freeze(N.map(T=>(0,L.deepFreeze)(d.TestResults.to(T))).concat(this.results).sort((T,F)=>F.completedAt-T.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,T){const F=this.controllers.get(m.TestId.fromString(N).controllerId)?.collection;F&&(await F.expand(N,T<0?1/0:T),F.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(D.TestsDiffOp.deserialize))}async $runControllerTests(N,T){return Promise.all(N.map(F=>this.runControllerTestRequest(F,!1,T)))}async $startContinuousRun(N,T){const F=new A.CancellationTokenSource(T),U=await Promise.all(N.map(Z=>this.runControllerTestRequest(Z,!0,F.token)));return!T.isCancellationRequested&&!U.some(Z=>Z.error)&&await new Promise(Z=>T.onCancellationRequested(Z)),F.dispose(!0),U}async runControllerTestRequest(N,T,F){const U=this.controllers.get(N.controllerId);if(!U)return{};const{collection:Z,profiles:J}=U,z=J.get(N.profileId);if(!z)return{};const Q=N.testIds.map(Y=>Z.tree.get(Y)).filter(k.isDefined),ie=N.excludeExtIds.map(Y=>U.collection.tree.get(Y)).filter(k.isDefined).filter(Y=>Q.some(ee=>ee.fullId.compare(Y.fullId)===2));if(!Q.length)return{};const ge=new u.TestRunRequest2(Q.some(Y=>Y.actual instanceof f.TestItemRootImpl)?void 0:Q.map(Y=>Y.actual),ie.map(Y=>Y.actual),z,T),K=(0,D.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(ge,h.fromInternal(N,U.collection),F);try{return await z.runHandler(ge,F),{}}catch(Y){return{error:String(Y)}}finally{K&&(K.hasRunningTasks&&!F.isCancellationRequested&&await w.Event.toPromise(K.onEnd),K.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};r=je([Be(0,y.IExtHostRpcService)],r),e.ExtHostTesting=r;const a=1e4;var c;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(c||(c={}));class g extends C.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,T,F){super(),this.dto=N,this.proxy=T,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new w.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new A.CancellationTokenSource(F));const U=this._register(new R.RunOnceScheduler(()=>this.forciblyEndTasks(),a));this._register(this.cts.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const T=this.dto.id,F=this.dto.controllerId,U=(0,b.generateUuid)(),Z=new _(this.proxy,T,U),J=ge=>(K,...Y)=>{if(Q){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ge(K,...Y))},z=(ge,K)=>{const Y=K instanceof Array?K.map(d.TestMessage.from):[d.TestMessage.from(K)];if(ge.uri&&ge.range){const ee={range:d.Range.from(ge.range),uri:ge.uri};for(const me of Y)me.location=me.location||ee}this.proxy.$appendTestMessagesInRun(T,U,m.TestId.fromExtHostTestItem(ge,F).toString(),Y)};let Q=!1;const ie={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return Z.coverageProvider},set coverageProvider(ge){Z.coverageProvider=ge},enqueued:J(ge=>{this.proxy.$updateTestStateInRun(T,U,m.TestId.fromExtHostTestItem(ge,F).toString(),1)}),skipped:J(ge=>{this.proxy.$updateTestStateInRun(T,U,m.TestId.fromExtHostTestItem(ge,F).toString(),5)}),started:J(ge=>{this.proxy.$updateTestStateInRun(T,U,m.TestId.fromExtHostTestItem(ge,F).toString(),2)}),errored:J((ge,K,Y)=>{z(ge,K),this.proxy.$updateTestStateInRun(T,U,m.TestId.fromExtHostTestItem(ge,F).toString(),6,Y)}),failed:J((ge,K,Y)=>{z(ge,K),this.proxy.$updateTestStateInRun(T,U,m.TestId.fromExtHostTestItem(ge,F).toString(),4,Y)}),passed:J((ge,K)=>{this.proxy.$updateTestStateInRun(T,U,m.TestId.fromExtHostTestItem(ge,this.dto.controllerId).toString(),3,K)}),appendOutput:(ge,K,Y)=>{Q||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(T,U,l.VSBuffer.fromString(ge),K&&d.location.from(K),Y&&m.TestId.fromExtHostTestItem(Y,F).toString()))},end:()=>{Q||(Q=!0,this.proxy.$finishedTestRunTask(T,U),this.tasks.delete(U),this.tasks.size||this.markEnded())}};return this.tasks.set(U,{run:ie,coverage:Z}),this.proxy.$startedTestRunTask(T,{id:U,name:N,running:!0}),ie}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof f.TestItemImpl))throw new v.InvalidTestItemError(N.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const T=[],F=this.dto.colllection.root;for(;;){const U=d.TestItem.from(N);if(T.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),N===F))break;N=N.parent||F}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,T)}}class i{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,T,F){return this.getTracker(N,T,F)}cancelRunById(N){for(const T of this.tracked.values())if(T.id===N){T.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,T,F,U,Z){const J=this.tracked.get(F);if(J)return J.createRun(U);const z=h.fromPublic(N,T,F,Z),Q=t(F);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!F.continuous,profile:Q&&{group:X[Q.kind],id:Q.profileId},exclude:F.exclude?.map(ge=>m.TestId.fromExtHostTestItem(ge,T.root.id).toString())??[],id:z.id,include:F.include?.map(ge=>m.TestId.fromExtHostTestItem(ge,T.root.id).toString())??[T.root.id],persist:Z});const ie=this.getTracker(F,z);return ie.onEnd(()=>{this.proxy.$finishedExtensionTestRun(z.id),ie.dispose()}),ie.createRun(U)}getTracker(N,T,F){const U=new g(T,this.proxy,F);return this.tracked.set(N,U),U.onEnd(()=>this.tracked.delete(N)),U}}e.TestRunCoordinator=i;const t=V=>{if(!!V.profile){if(!(V.profile instanceof H))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class h{static fromPublic(N,T,F,U){return new h(N,(0,b.generateUuid)(),F.include?.map(Z=>m.TestId.fromExtHostTestItem(Z,N).toString())??[N],F.exclude?.map(Z=>m.TestId.fromExtHostTestItem(Z,N).toString())??[],U,T)}static fromInternal(N,T){return new h(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,T)}constructor(N,T,F,U,Z,J){this.controllerId=N,this.id=T,this.isPersisted=Z,this.colllection=J,this.includePrefix=F.map(z=>z+"\0"),this.excludePrefix=U.map(z=>z+"\0")}isIncluded(N){const T=m.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const F of this.excludePrefix)if(T===F||T.startsWith(F))return!1;for(const F of this.includePrefix)if(T===F||T.startsWith(F))return!0;return!1}}e.TestRunDto=h;class _{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!N||(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,T,F){this.proxy=N,this.runId=T,this.taskId=F}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(T){throw this.fileCoverage=void 0,T}}async resolveFileCoverage(N,T){const F=await this.fileCoverage;let U=F?.[N];return!this._coverageProvider||!F||!U?[]:(U.detailedCoverage||(U=F[N]=await this._coverageProvider.resolveFileCoverage?.(U,T)??U),U.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class E{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,d.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const T=m.TestId.parentId(N.item.extId);if(T&&this.alreadyRemoved.has(T.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:T,removed:F}=this;return{get added(){return[...N].map(U=>U.revived)},get updated(){return[...T].map(U=>U.revived)},get removed(){return[...F].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class O extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new w.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,T){return{...N,revived:d.TestItem.toPlain(N.item),depth:T?T.depth+1:0,children:new Set}}createChangeCollector(){return new E(this.changeEmitter)}}class ${constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(T=>T.revived)},dispose:(0,P.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new O;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class H{get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?d.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Ne(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,T,F,U,Z,J,z,Q=!1,ie=void 0,ge=!1){this.controllerId=F,this.profileId=U,this._label=Z,this.kind=J,this.runHandler=z,this._isDefault=Q,this._tag=ie,this._supportsContinuousRun=ge,n.set(this,void 0),s.set(this,void 0),Je(this,n,N,"f"),Je(this,s,T,"f"),T.set(U,this);const K=X[J];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);Ne(this,n,"f").$publishTestRunProfile({profileId:U,controllerId:F,tag:ie?d.TestTag.namespace(this.controllerId,ie.id):null,label:Z,group:K,isDefault:Q,hasConfigurationHandler:!1,supportsContinuousRun:ge})}dispose(){Ne(this,s,"f")?.delete(this.profileId)&&(Je(this,s,void 0,"f"),Ne(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=H,n=new WeakMap,s=new WeakMap;const X={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Se[277],ye([1,0,16,3,5,138,14,7]),function(re,e,o,R,l,A,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new R.Emitter,this._onDidChangeTextEditorOptions=new R.Emitter,this._onDidChangeTextEditorVisibleRanges=new R.Emitter,this._onDidChangeTextEditorViewColumn=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(l.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const k=this._extHostDocumentsAndEditors.allEditors();return L?k:k.map(b=>b.value)}async showTextDocument(L,k,b){let I;typeof k=="number"?I={position:w.ViewColumn.from(k),preserveFocus:b}:typeof k=="object"?I={position:w.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?w.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:I={preserveFocus:!1};const y=await this._proxy.$tryShowTextDocument(L.uri,I),f=y&&this._extHostDocumentsAndEditors.getEditor(y);if(f)return f.value;throw y?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,k){return new A.TextEditorDecorationType(this._proxy,L,k).value}$acceptEditorPropertiesChanged(L,k){const b=this._extHostDocumentsAndEditors.getEditor(L);if(!b)throw new Error("unknown text editor");if(k.options&&b._acceptOptions(k.options),k.selections){const I=k.selections.selections.map(w.Selection.to);b._acceptSelections(I)}if(k.visibleRanges){const I=o.coalesce(k.visibleRanges.map(w.Range.to));b._acceptVisibleRanges(I)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:{...k.options,lineNumbers:w.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const I=P.TextEditorSelectionChangeKind.fromValue(k.selections.source),y=k.selections.selections.map(w.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:y,kind:I})}if(k.visibleRanges){const I=o.coalesce(k.visibleRanges.map(w.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:I})}}$acceptEditorPositionData(L){for(const k in L){const b=this._extHostDocumentsAndEditors.getEditor(k);if(!b)throw new Error("Unknown text editor");const I=w.ViewColumn.to(L[k]);b.value.viewColumn!==I&&(b._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:I}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(Se[278],ye([1,0,2,4,5,6,7,14,27,9]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class L{constructor(I,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=I.getProxy(l.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this._providers.get(f.source)&&S.ExtensionIdentifier.equals(d,this._providers.get(f.source)?.extension)){const u=f.uri===void 0?void 0:o.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(k(u))?.get(f.handle)}else return;return f}})}async $getTimeline(I,y,f,d){return this._providers.get(I)?.provider.provideTimeline(o.URI.revive(y),f,d)}registerTimelineProvider(I,y,f,d){const u=new A.DisposableStore,m=this.convertTimelineItem(y.id,d,u).bind(this);let v;y.onDidChange&&(v=y.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:y.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:I,onDidChange:void 0,async provideTimeline(p,n,s){n?.resetCache&&(u.clear(),D.get(y.id)?.clear());const r=await y.provideTimeline(p,n,s);if(r==null)return;const a=m(p,n);return{...r,source:y.id,items:r.items.map(a)}},dispose(){for(const p of D.values())p.get(y.id)?.clear();v?.dispose(),u.dispose()}},f)}convertTimelineItem(I,y,f){return(d,u)=>{let m;if(u?.cacheResults){let v=this._itemsBySourceAndUriMap.get(I);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(I,v));const D=k(d);m=v.get(D),m===void 0&&(m=new Map,v.set(D,m))}return v=>{const{iconPath:D,...p}=v,n=`${I}|${v.id??v.timestamp}`;m?.set(n,v);let s,r,a;v.iconPath&&(D instanceof w.ThemeIcon?a={id:D.id,color:D.color}:o.URI.isUri(D)?(s=D,r=D):{light:s,dark:r}=D);let c;return w.MarkdownString.isMarkdownString(p.tooltip)?c=P.MarkdownString.from(p.tooltip):(0,C.isString)(p.tooltip)?c=p.tooltip:w.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=P.MarkdownString.from(p.detail)):(0,C.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=p.detail),{...p,id:p.id??void 0,handle:n,source:I,command:v.command?y.toInternal(v.command,f):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:c,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(I,y){if(this._providers.get(I.id))throw new Error(`Timeline Provider ${I.id} already exists.`);return this._proxy.$registerTimelineProvider({id:I.id,label:I.label,scheme:I.scheme}),this._providers.set(I.id,{provider:I,extension:y}),(0,A.toDisposable)(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(I.id)?.clear();this._providers.delete(I.id),this._proxy.$unregisterTimelineProvider(I.id),I.dispose()})}}e.ExtHostTimeline=L;function k(b){return b?.toString()}}),define(Se[279],ye([1,0,6,15,2,5]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class w{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,L,k){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const b=k.schemes.find(I=>!w.supportedSchemes.has(I));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,L),this._proxy.$registerUriOpener(C,k.schemes,S,k.label),(0,o.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,L){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const b=l.URI.revive(C);return k.canOpenExternalUri(b,L)}async $openUri(S,C,L){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(l.URI.revive(C.resolvedUri),{sourceUri:l.URI.revive(C.sourceUri)},L)}}w.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https]),e.ExtHostUriOpeners=w}),define(Se[280],ye([1,0,5,2,6,10,27]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(C,L){if(this.handles.has(w.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const k=P.HandlePool++;return this.handles.add(w.ExtensionIdentifier.toKey(C)),this.handlers.set(k,L),this._proxy.$registerUriHandler(k,C),(0,l.toDisposable)(()=>{this.handles.delete(w.ExtensionIdentifier.toKey(C)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(C,L){const k=this.handlers.get(C);if(!k)return Promise.resolve(void 0);try{k.handleUri(R.URI.revive(L))}catch(b){(0,A.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(C){return R.URI.revive(await this._proxy.$createAppUri(C))}}P.HandlePool=0,e.ExtHostUrls=P});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[81],ye([1,0,3,15,23,2,200,225,95,5]),function(re,e,o,R,l,A,w,P,S,C){"use strict";var L,k,b,I,y,f,d,u,m,v,D,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(E,O,$,H,X,V,N){L.set(this,void 0),k.set(this,void 0),b.set(this,void 0),I.set(this,void 0),y.set(this,void 0),f.set(this,void 0),d.set(this,""),u.set(this,void 0),m.set(this,!1),v.set(this,!1),D.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new o.Emitter),this._onDidDispose=Ne(this,n,"f").event,Je(this,L,E,"f"),Je(this,k,O,"f"),Je(this,u,$,"f"),Je(this,I,H,"f"),Je(this,y,X,"f"),Je(this,f,V,"f"),Je(this,D,r(V),"f"),Je(this,p,a(V),"f"),Je(this,b,N,"f")}dispose(){Je(this,m,!0,"f"),Ne(this,n,"f").fire(),Ne(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return Je(this,v,!0,"f"),(0,S.asWebviewUri)(E,Ne(this,I,"f"))}get cspSource(){const E=Ne(this,f,"f").extensionLocation;if(E.scheme===R.Schemas.https||E.scheme===R.Schemas.http){let O=E.toString();return O.endsWith("/")||(O+="/"),O+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,d,"f")}set html(E){this.assertNotDisposed(),Ne(this,d,"f")!==E&&(Je(this,d,E,"f"),Ne(this,p,"f")&&!Ne(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(Je(this,v,!0,"f"),Ne(this,b,"f").report("Webview vscode-resource: uris",Ne(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,k,"f").$setHtml(Ne(this,L,"f"),this.rewriteOldResourceUrlsIfNeeded(E)))}get options(){return this.assertNotDisposed(),Ne(this,u,"f")}set options(E){this.assertNotDisposed(),l.equals(Ne(this,u,"f"),E)||Ne(this,k,"f").$setOptions(Ne(this,L,"f"),i(Ne(this,f,"f"),Ne(this,y,"f"),E)),Je(this,u,E,"f")}async postMessage(E){if(Ne(this,m,"f"))return!1;const O=(0,P.serializeWebviewMessage)(E,{serializeBuffersForPostMessage:Ne(this,D,"f")});return Ne(this,k,"f").$postMessage(Ne(this,L,"f"),O.message,...O.buffers)}assertNotDisposed(){if(Ne(this,m,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(E){if(!Ne(this,p,"f"))return E;const O=Ne(this,f,"f").extensionLocation?.scheme===R.Schemas.vscodeRemote,$=Ne(this,f,"f").extensionLocation.scheme===R.Schemas.vscodeRemote?Ne(this,f,"f").extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,X,V,N,T,F)=>{const U=A.URI.from({scheme:N||"file",path:decodeURIComponent(T)}),Z=(0,S.asWebviewUri)(U,{isRemote:O,authority:$}).toString();return`${X}${Z}${F}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,X,V,N,T,F)=>{const U=A.URI.from({scheme:N||"file",path:decodeURIComponent(T)}),Z=(0,S.asWebviewUri)(U,{isRemote:O,authority:$}).toString();return`${X}${Z}${F}`})}}e.ExtHostWebview=s,L=new WeakMap,k=new WeakMap,b=new WeakMap,I=new WeakMap,y=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap,v=new WeakMap,D=new WeakMap,p=new WeakMap,n=new WeakMap;function r(_){try{const E=(0,w.normalizeVersion)((0,w.parseVersion)(_.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function a(_){try{const E=(0,w.normalizeVersion)((0,w.parseVersion)(_.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class c{constructor(E,O,$,H,X){this.remoteInfo=O,this.workspace=$,this._logService=H,this._deprecationService=X,this._webviews=new Map,this._webviewProxy=E.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(E,O,$){const H=this.getWebview(E);if(H){const{message:X}=(0,P.deserializeWebviewMessage)(O,$.value);H._onMessageEmitter.fire(X)}}$onMissingCsp(E,O){this._logService.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,O,$){const H=new s(E,this._webviewProxy,t(O),this.remoteInfo,this.workspace,$,this._deprecationService);return this._webviews.set(E,H),H._onDidDispose(()=>{this._webviews.delete(E)}),H}deleteWebview(E){this._webviews.delete(E)}getWebview(E){return this._webviews.get(E)}}e.ExtHostWebviews=c;function g(_){return{id:_.identifier,location:_.extensionLocation}}e.toExtensionData=g;function i(_,E,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||h(_,E)}}e.serializeWebviewOptions=i;function t(_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,enableForms:_.enableForms,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots?.map(E=>A.URI.from(E))}}function h(_,E){return[...(E?.getWorkspaceFolders()||[]).map(O=>O.uri),_.extensionLocation]}}),define(Se[281],ye([1,0,21,89,6,15,24,2,14,81,75,5,7]),function(re,e,o,R,l,A,w,P,S,C,L,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(s,r){this.document=s,this._storagePath=r,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,r){await this.getEdit(s).undo(),r||this.disposeBackup()}async redo(s,r){await this.getEdit(s).redo(),r||this.disposeBackup()}disposeEdits(s){for(const r of s)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=p(this.document.uri)+this._backupCounter++;return(0,w.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const r=this._edits.get(s,0);if(!r)throw new Error("No edit found");return r}}class y{constructor(){this._documents=new Map}get(s,r){return this._documents.get(this.key(s,r))}add(s,r,a){const c=this.key(s,r.uri);if(this._documents.has(c))throw new Error(`Document already exists for viewType:${s} resource:${r.uri}`);const g=new I(r,a);return this._documents.set(c,g),g}delete(s,r){const a=this.key(s,r.uri);this._documents.delete(a)}key(s,r){return`${s}@@@${r}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this._providers=new Map}addTextProvider(s,r,a){return this.add(0,s,r,a)}addCustomProvider(s,r,a){return this.add(1,s,r,a)}get(s){return this._providers.get(s)}add(s,r,a,c){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:s,extension:a,provider:c}),new b.Disposable(()=>this._providers.delete(r))}}class u{constructor(s,r,a,c,g){this._extHostDocuments=r,this._extensionStoragePaths=a,this._extHostWebview=c,this._extHostWebviewPanels=g,this._editorProviders=new d,this._documents=new y,this._proxy=s.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,r,a,c){const g=new l.DisposableStore;return v(a)?(g.add(this._editorProviders.addTextProvider(r,s,a)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(s),r,c.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(s))):(g.add(this._editorProviders.addCustomProvider(r,s,a)),m(a)&&g.add(a.onDidChangeCustomDocument(i=>{const t=this.getCustomDocumentEntry(r,i.document.uri);if(D(i)){const h=t.addEdit(i);this._proxy.$onDidEdit(i.document.uri,r,h,i.label)}else this._proxy.$onContentChange(i.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(s),r,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(s))),b.Disposable.from(g,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(s,r,a,c,g){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const t=P.URI.revive(s),h=await i.provider.openCustomDocument(t,{backupId:a,untitledDocumentData:c?.buffer},g);let _;return m(i.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension)),this._documents.add(r,h,_),{editable:m(i.provider)}}async $disposeCustomDocument(s,r){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const c=P.URI.revive(s),{document:g}=this.getCustomDocumentEntry(r,c);this._documents.delete(r,g),g.dispose()}async $resolveCustomEditor(s,r,a,c,g,i){const t=this._editorProviders.get(a);if(!t)throw new Error(`No provider found for '${a}'`);const h=S.ViewColumn.to(g),_=this._extHostWebview.createNewWebview(r,c.contentOptions,t.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(r,a,c.title,h,c.options,_,!0),O=P.URI.revive(s);switch(t.type){case 1:{const{document:$}=this.getCustomDocumentEntry(a,O);return t.provider.resolveCustomEditor($,E,i)}case 0:{const $=this._extHostDocuments.getDocument(O);return t.provider.resolveCustomTextEditor($,E,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,r,a){this.getCustomDocumentEntry(r,s).disposeEdits(a)}async $onMoveCustomEditor(s,r,a){const c=this._editorProviders.get(a);if(!c)throw new Error(`No provider found for '${a}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const g=this._extHostWebviewPanels.getWebviewPanel(s);if(!g)throw new Error("No webview found");const i=P.URI.revive(r),t=this._extHostDocuments.getDocument(i);await c.provider.moveCustomTextEditor(t,g,o.CancellationToken.None)}async $undo(s,r,a,c){return this.getCustomDocumentEntry(r,s).undo(a,c)}async $redo(s,r,a,c){return this.getCustomDocumentEntry(r,s).redo(a,c)}async $revert(s,r,a){const c=this.getCustomDocumentEntry(r,s);await this.getCustomEditorProvider(r).revertCustomDocument(c.document,a),c.disposeBackup()}async $onSave(s,r,a){const c=this.getCustomDocumentEntry(r,s);await this.getCustomEditorProvider(r).saveCustomDocument(c.document,a),c.disposeBackup()}async $onSaveAs(s,r,a,c){const g=this.getCustomDocumentEntry(r,s);return this.getCustomEditorProvider(r).saveCustomDocumentAs(g.document,P.URI.revive(a),c)}async $backup(s,r,a){const c=this.getCustomDocumentEntry(r,s),i=await this.getCustomEditorProvider(r).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},a);return c.updateBackup(i),i.id}getCustomDocumentEntry(s,r){const a=this._documents.get(s,P.URI.revive(r));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(s){const a=this._editorProviders.get(s)?.provider;if(!a||!m(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=u;function m(n){return!!n.onDidChangeCustomDocument}function v(n){return typeof n.resolveCustomTextEditor=="function"}function D(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function p(n){const s=n.scheme===A.Schemas.file||n.scheme===A.Schemas.untitled?n.fsPath:n.toString();return(0,R.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[282],ye([1,0,3,6,2,30,14,81,5,7]),function(re,e,o,R,l,A,w,P,S,C){"use strict";var L,k,b,I,y,f,d,u,m,v,D,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends R.Disposable{constructor(g,i,t,h){super(),L.set(this,void 0),k.set(this,void 0),b.set(this,void 0),I.set(this,void 0),y.set(this,void 0),f.set(this,void 0),d.set(this,void 0),u.set(this,void 0),m.set(this,!0),v.set(this,void 0),D.set(this,!1),p.set(this,this._register(new o.Emitter)),this.onDidDispose=Ne(this,p,"f").event,n.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=Ne(this,n,"f").event,Je(this,L,g,"f"),Je(this,k,i,"f"),Je(this,I,t,"f"),Je(this,b,h.viewType,"f"),Je(this,y,h.panelOptions,"f"),Je(this,u,h.viewColumn,"f"),Je(this,f,h.title,"f"),Je(this,v,h.active,"f")}dispose(){Ne(this,D,"f")||(Je(this,D,!0,"f"),Ne(this,p,"f").fire(),Ne(this,k,"f").$disposeWebview(Ne(this,L,"f")),Ne(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,I,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,b,"f")}get title(){return this.assertNotDisposed(),Ne(this,f,"f")}set title(g){this.assertNotDisposed(),Ne(this,f,"f")!==g&&(Je(this,f,g,"f"),Ne(this,k,"f").$setTitle(Ne(this,L,"f"),g))}get iconPath(){return this.assertNotDisposed(),Ne(this,d,"f")}set iconPath(g){this.assertNotDisposed(),Ne(this,d,"f")!==g&&(Je(this,d,g,"f"),Ne(this,k,"f").$setIconPath(Ne(this,L,"f"),l.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ne(this,y,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,u,"f")=="number"&&Ne(this,u,"f")<0))return Ne(this,u,"f")}get active(){return this.assertNotDisposed(),Ne(this,v,"f")}get visible(){return this.assertNotDisposed(),Ne(this,m,"f")}_updateViewState(g){Ne(this,D,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Je(this,v,g.active,"f"),Je(this,m,g.visible,"f"),Je(this,u,g.viewColumn,"f"),Ne(this,n,"f").fire({webviewPanel:this}))}reveal(g,i){this.assertNotDisposed(),Ne(this,k,"f").$reveal(Ne(this,L,"f"),{viewColumn:typeof g>"u"?void 0:w.ViewColumn.from(g),preserveFocus:!!i})}assertNotDisposed(){if(Ne(this,D,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,k=new WeakMap,b=new WeakMap,I=new WeakMap,y=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap,v=new WeakMap,D=new WeakMap,p=new WeakMap,n=new WeakMap;class r{static newHandle(){return(0,A.generateUuid)()}constructor(g,i,t){this.webviews=i,this.workspace=t,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(g,i,t,h,_={}){const E=typeof h=="object"?h.viewColumn:h,O={viewColumn:w.ViewColumn.from(E),preserveFocus:typeof h=="object"&&!!h.preserveFocus},$=(0,P.shouldSerializeBuffersForPostMessage)(g),H=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(g),H,i,{title:t,panelOptions:a(_),webviewOptions:(0,P.serializeWebviewOptions)(g,this.workspace,_),serializeBuffersForPostMessage:$},O);const X=this.webviews.createNewWebview(H,_,g);return this.createNewWebviewPanel(H,i,t,E,_,X,!0)}$onDidChangeWebviewPanelViewStates(g){const i=Object.keys(g);i.sort((t,h)=>{const _=g[t],E=g[h];return _.active?1:E.active?-1:+_.visible-+E.visible});for(const t of i){const h=this.getWebviewPanel(t);if(!h)continue;const _=g[t];h._updateViewState({active:_.active,visible:_.visible,viewColumn:w.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,i,t){if(this._serializers.has(i))throw new Error(`Serializer for '${i}' already registered`);return this._serializers.set(i,{serializer:t,extension:g}),this._proxy.$registerSerializer(i,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(g)}),new C.Disposable(()=>{this._serializers.delete(i),this._proxy.$unregisterSerializer(i)})}async $deserializeWebviewPanel(g,i,t,h){const _=this._serializers.get(i);if(!_)throw new Error(`No serializer found for '${i}'`);const{serializer:E,extension:O}=_,$=this.webviews.createNewWebview(g,t.webviewOptions,O),H=this.createNewWebviewPanel(g,i,t.title,h,t.panelOptions,$,t.active);await E.deserializeWebviewPanel(H,t.state)}createNewWebviewPanel(g,i,t,h,_,E,O){const $=new s(g,this._proxy,E,{viewType:i,title:t,viewColumn:h,panelOptions:_,active:O});return this._webviewPanels.set(g,$),$}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=r;function a(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[283],ye([1,0,3,6,81,14,5,7]),function(re,e,o,R,l,A,w,P){"use strict";var S,C,L,k,b,I,y,f,d,u,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends R.Disposable{constructor(n,s,r,a,c,g){super(),S.set(this,void 0),C.set(this,void 0),L.set(this,void 0),k.set(this,void 0),b.set(this,!1),I.set(this,void 0),y.set(this,void 0),f.set(this,void 0),d.set(this,void 0),u.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=Ne(this,u,"f").event,m.set(this,this._register(new o.Emitter)),this.onDidDispose=Ne(this,m,"f").event,Je(this,L,r,"f"),Je(this,y,a,"f"),Je(this,S,n,"f"),Je(this,C,s,"f"),Je(this,k,c,"f"),Je(this,I,g,"f")}dispose(){Ne(this,b,"f")||(Je(this,b,!0,"f"),Ne(this,m,"f").fire(),Ne(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,y,"f")}set title(n){this.assertNotDisposed(),Ne(this,y,"f")!==n&&(Je(this,y,n,"f"),Ne(this,C,"f").$setWebviewViewTitle(Ne(this,S,"f"),n))}get description(){return this.assertNotDisposed(),Ne(this,f,"f")}set description(n){this.assertNotDisposed(),Ne(this,f,"f")!==n&&(Je(this,f,n,"f"),Ne(this,C,"f").$setWebviewViewDescription(Ne(this,S,"f"),n))}get visible(){return Ne(this,I,"f")}get webview(){return Ne(this,k,"f")}get viewType(){return Ne(this,L,"f")}_setVisible(n){n===Ne(this,I,"f")||Ne(this,b,"f")||(Je(this,I,n,"f"),Ne(this,u,"f").fire())}get badge(){return this.assertNotDisposed(),Ne(this,d,"f")}set badge(n){this.assertNotDisposed(),!(n?.value===Ne(this,d,"f")?.value&&n?.tooltip===Ne(this,d,"f")?.tooltip)&&(Je(this,d,A.ViewBadge.from(n),"f"),Ne(this,C,"f").$setWebviewViewBadge(Ne(this,S,"f"),n))}show(n){this.assertNotDisposed(),Ne(this,C,"f").$show(Ne(this,S,"f"),!!n)}assertNotDisposed(){if(Ne(this,b,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,L=new WeakMap,k=new WeakMap,b=new WeakMap,I=new WeakMap,y=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap;class D{constructor(n,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(w.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,s,r,a){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:r,extension:n}),this._proxy.$registerWebviewViewProvider((0,l.toExtensionData)(n),s,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(n)}),new P.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(n,s,r,a,c){const g=this._viewProviders.get(s);if(!g)throw new Error(`No view provider found for '${s}'`);const{provider:i,extension:t}=g,h=this._extHostWebview.createNewWebview(n,{},t),_=new v(n,this._proxy,s,r,h,!0);this._webviewViews.set(n,_),await i.resolveWebviewView(_,{state:a},c)}async $onDidChangeWebviewViewVisibility(n,s){this.getWebviewView(n)._setVisible(s)}async $disposeWebviewView(n){const s=this.getWebviewView(n);this._webviewViews.delete(n),s.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const s=this._webviewViews.get(n);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=D}),define(Se[141],ye([1,0,3,5,2,15,8,4,20]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class an{get state(){return this._state}constructor(k){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=an.InitialState,this._proxy=k.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,b){let I;if(typeof k=="string"){I=k;try{k=l.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,w.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,I,b)}async asExternalUri(k,b){if((0,w.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(k,b);return l.URI.from(I)}};C.InitialState={focused:!0},C=je([Be(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Se[284],ye([1,0,119,285,70,40,2,13,47]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(b,I,y){this._commands=b,this.logService=I,this._ipcHandlePath=y,this._server=R.createServer((f,d)=>this.onRequest(f,d)),this.setup().catch(f=>(I.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,I){const y=(d,u)=>{I.writeHead(d,{"content-type":"application/json"}),I.end(JSON.stringify(u||null),m=>m&&this.logService.error(m))},f=[];b.setEncoding("utf8"),b.on("data",d=>f.push(d)),b.on("end",async()=>{try{const d=JSON.parse(f.join(""));let u;switch(d.type){case"open":u=await this.open(d);break;case"openExternal":u=await this.openExternal(d);break;case"status":u=await this.getStatus(d);break;case"extensionManagement":u=await this.manageExtensions(d);break;default:y(404,`Unknown message type: ${d.type}`);break}y(200,u)}catch(d){const u=d instanceof Error?d.message:JSON.stringify(d);y(500,u),this.logService.error("Error while processing pipe request",d)}})}async open(b){const{fileURIs:I,folderURIs:y,forceNewWindow:f,diffMode:d,mergeMode:u,addMode:m,forceReuseWindow:v,gotoLineMode:D,waitMarkerFilePath:p,remoteAuthority:n}=b,s=[];if(Array.isArray(y))for(const g of y)try{s.push({folderUri:w.URI.parse(g)})}catch{}if(Array.isArray(I))for(const g of I)try{(0,S.hasWorkspaceFileExtension)(g)?s.push({workspaceUri:w.URI.parse(g)}):s.push({fileUri:w.URI.parse(g)})}catch{}const r=p?w.URI.file(p):void 0,c={forceNewWindow:f,diffMode:d,mergeMode:u,addMode:m,gotoLineMode:D,forceReuseWindow:v,preferNewWindow:!v&&!r&&!m,waitMarkerFileURI:r,remoteAuthority:n};return this._commands.executeCommand("_remoteCLI.windowOpen",s,c),""}async openExternal(b){for(const I of b.uris){const y=w.URI.parse(I),f=y.scheme==="file"?y:I;await this._commands.executeCommand("_remoteCLI.openExternal",f)}}async manageExtensions(b){const I=f=>f?.map(d=>/\.vsix$/i.test(d)?w.URI.parse(d):d),y={list:b.list,install:I(b.install),uninstall:I(b.uninstall),force:b.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",y)}async getStatus(b){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&l.existsSync(this._ipcHandlePath)&&l.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let L=class extends C{constructor(b,I){super(b,I,(0,o.createRandomIPCHandle)())}};L=je([Be(0,A.IExtHostCommands),Be(1,P.ILogService)],L),e.CLIServer=L}),define(Se[286],ye([1,0,256,25,20]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let w=class extends o.AbstractExtHostConsoleForwarder{constructor(S,C){super(S,C),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,C,L){const k=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),C.apply(console,L),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,C){const L=process[S],k=L.write;let b="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(I,y,f)=>{if(!this._isMakingConsoleCall){b+=I.toString(y);const d=b.length>A?b.length:b.lastIndexOf(`
`);d!==-1&&(console[C](b.slice(0,d)),b=b.slice(d+1))}k.call(L,I,y,f)}})}};w=je([Be(0,l.IExtHostRpcService),Be(1,R.IExtHostInitDataService)],w),e.ExtHostConsoleForwarder=w}),define(Se[287],ye([1,0,12,71,30,40,6,5,2,20]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends w.Disposable{constructor(b,I){super();const y=b.getProxy(P.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=S.URI.file((0,o.join)((0,R.tmpdir)(),(0,l.generateUuid)()));return await y.$download(f,d),d})}};L=je([Be(0,C.IExtHostRpcService),Be(1,A.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Se[288],ye([1,0,140,15,207,30]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class w extends o.ExtHostLoggerService{doCreateLogger(S,C,L){return S.scheme===R.Schemas.file?new l.SpdLogLogger(L?.name||(0,A.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,C):super.doCreateLogger(S,C,L)}registerLogger(S){super.registerLogger(S),this._proxy.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this._proxy.$deregisterLogger(S)}}e.ExtHostLoggerService=w}),define(Se[289],ye([1,0,70,12,2,80,6,15,19,29]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const s=await super._getWorkspaceStorageURI(n);if(s.scheme!==P.Schemas.file)return s;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const r=s.fsPath;let a=0;do{let c;a===0?c=r:c=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${a}`:`${r}-${a}`,await k(c);const g=R.join(c,"vscode.lock"),i=await f(this._logService,g,!1);if(i)return this._workspaceStorageLock=i,process.on("exit",()=>{i.dispose()}),l.URI.file(c);a++}while(a<10);return s}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function k(p){try{await C.Promises.stat(p);return}catch{}try{await C.Promises.mkdir(p,{recursive:!0})}catch{}}const b=1e3,I=10*60*1e3;class y extends w.Disposable{constructor(n,s){super(),this.logService=n,this.filename=s,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await d(n,s);(!r||r.pid!==process.pid)&&(n.info(`Lock '${s}': The lock was lost unexpectedly.`),this._timer.cancel());try{await C.Promises.utimes(s,new Date,new Date)}catch(a){n.error(a),n.info(`Lock '${s}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{o.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+n};await C.Promises.writeFile(this.filename,JSON.stringify(s),{flag:"w"})}catch(s){this.logService.error(s)}}}async function f(p,n,s){try{const a={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(n,JSON.stringify(a),{flag:"wx"})}catch(a){p.error(a)}const r=await d(p,n);return!r||r.pid!==process.pid?s?(p.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),v(p,n)):(p.info(`Lock '${n}': Lock acquired.`),new y(p,n))}async function d(p,n){let s;try{s=await C.Promises.readFile(n)}catch(r){return p.error(r),null}try{return JSON.parse(String(s))}catch(r){return p.error(r),null}}async function u(p,n){let s;try{s=await C.Promises.stat(n)}catch(r){return p.error(r),0}return s.mtime.getTime()}function m(p){try{return process.kill(p,0),!0}catch{return!1}}async function v(p,n){const s=await d(p,n);if(!s)return p.info(`Lock '${n}': Could not read pid of lock holder.`),D(p,n);if(s.willReleaseAt){let i=s.willReleaseAt-Date.now();if(i<5e3){for(i>0?p.info(`Lock '${n}': The lockfile is scheduled to be released in ${i} ms.`):p.info(`Lock '${n}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,S.timeout)(Math.min(100,i)),await u(p,n)===0)return D(p,n);i=s.willReleaseAt-Date.now()}return D(p,n)}}if(!m(s.pid))return p.info(`Lock '${n}': The pid ${s.pid} appears to be gone.`),D(p,n);const r=await u(p,n),a=Date.now()-r;if(a<=I)return p.info(`Lock '${n}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;p.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const c=await u(p,n),g=Date.now()-c;return g<=I?(p.info(`Lock '${n}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(p.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),D(p,n))}async function D(p,n){p.info(`Lock '${n}': Deleting a stale lock.`);try{await C.Promises.unlink(n)}catch{}return f(p,n,!0)}}),define(Se[290],ye([1,0,30,20,41]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends l.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,S,C){return this.createTerminalFromOptions({name:P,shellPath:S,shellArgs:C})}createTerminalFromOptions(P,S){const C=new l.ExtHostTerminal(this._proxy,(0,o.generateUuid)(),P,P.name);return this._terminals.push(C),C.create(P,this._serializeParentTerminal(P,S)),C.value}};A=je([Be(0,R.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Se[291],ye([1,0,5,20,186,6,25,2,46,24,29,7,11,55,3,129,102,13]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class m extends f.DisposableTunnel{}function v(i){const t=i.trim().split(`
`),h=[];return t.forEach(E=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(E);O&&O.length>=3&&h.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),h.reduce((E,O)=>(E[O.socket]=O,E),{})}e.getSockets=v;function D(...i){const t=[].concat(...i.map(n));return[...new Map(t.filter(h=>h.st==="0A").map(h=>{const _=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:p(_[0]),port:parseInt(_[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=D;function p(i){let t="";if(i.length===8)for(let h=i.length-2;h>=0;h-=2)t+=parseInt(i.substr(h,2),16),h!==0&&(t+=".");else for(let h=i.length-4;h>=0;h-=4)t+=parseInt(i.substr(h,4),16).toString(16),h!==0&&(t+=":");return t}function n(i){const t=i.trim().split(`
`),h=t.shift().trim().split(/\s+/).filter(E=>E!=="rx_queue"&&E!=="tm->when");return t.map(E=>E.trim().split(/\s+/).reduce((O,$,H)=>(O[h[H]||H]=$,O),{}))}e.loadConnectionTable=n;function s(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function r(i){const t=i.trim().split(`
`),h=[];return t.forEach(_=>{const E=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);E&&E.length>=4&&h.push({pid:parseInt(E[1],10),ppid:parseInt(E[2]),cmd:E[3]})}),h}e.getRootProcesses=r;async function a(i,t,h){const _=h.reduce((O,$)=>(O[$.pid]=$,O),{}),E=[];return i.forEach(({socket:O,ip:$,port:H})=>{const X=t[O]?t[O].pid:void 0,V=X?_[X]?.cmd:void 0;X&&V&&!s(V)&&E.push({host:$,port:H,detail:V,pid:X})}),E}e.findPorts=a;function c(i,t,h){const _=new Map,E=r(t);for(const O of i){const $=h.get(O.port);if($){_.set(O.port,$);continue}const H=E.find(X=>X.cmd.includes(`${O.port}`));if(H){let X=H,V;do V=E.find(N=>N.ppid===X.pid),V&&(X=V);while(V);_.set(O.port,{host:O.ip,port:O.port,pid:X.pid,detail:X.cmd,ppid:X.ppid})}else _.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=c;let g=class extends A.Disposable{constructor(t,h,_){super(),this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new y.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=t.getProxy(o.MainContext.MainThreadTunnelService),b.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(t,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(h,t.displayName);if(_){const E=new m(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(E),E}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(t){return Math.max(t*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(t,h){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:t,provider:h}),this._proxy.$registerPortsAttributesProvider(t,_),new k.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(t,h,_,E,O){const $=[];for(const X of t){const V=this._portAttributesProviders.get(X);if(!V)return[];$.push(...await Promise.all(h.map(async N=>V.provider.providePortAttributes(N,_,E,O))))}const H=$.filter(X=>!!X);return H.length>0?H.map(X=>({autoForwardAction:X.autoForwardAction,port:X.port})):[]}async $registerCandidateFinder(t){if(t&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=t;const h=new d.MovingAverage;let _;for(;this._candidateFindingEnabled;){const E=new Date().getTime(),O=(await this.findCandidatePorts()).filter(H=>(0,f.isLocalhost)(H.host)||(0,f.isAllInterfaces)(H.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(H=>H.port).join(", ")}`);const $=new Date().getTime()-E;h.update($),(!_||JSON.stringify(_)!==JSON.stringify(O))&&(_=O,await this._proxy.$onFoundNewCandidates(_)),await new Promise(H=>setTimeout(()=>H(),this.calculateDelay(h.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this._showCandidatePort=t.showCandidatePort,this._proxy.$setCandidateFilter()),t.tunnelFactory){this._forwardPortProvider=t.tunnelFactory;let h=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const _=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(_)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(t,h){if(this._extensionTunnels.has(t.host)){const _=this._extensionTunnels.get(t.host);_.has(t.port)&&(h&&_.get(t.port).disposeListener.dispose(),await _.get(t.port).tunnel.dispose(),_.delete(t.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(t,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(t,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const E=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(t.remoteAddress.host)||this._extensionTunnels.set(t.remoteAddress.host,new Map);const O=this._register(E.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(E.remoteAddress))));return this._extensionTunnels.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:E,disposeListener:O}),I.TunnelDtoConverter.fromApiTunnel(E)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const h=await Promise.all(t.map(E=>this._showCandidatePort(E.host,E.port,E.detail??""))),_=t.filter((E,O)=>h[O]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(E=>E.port).join(", ")} to ${_.map(E=>E.port).join(", ")}`),_}async findCandidatePorts(){let t="",h="";try{t=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const _=D(t,h),E=await new Promise(F=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,Z,J)=>{F(Z)})}),O=v(E),$=await L.Promises.readdir("/proc"),H=[];for(const F of $)try{const U=Number(F),Z=C.joinPath(P.URI.file("/proc"),F);if((await L.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(U)){const z=await L.Promises.readlink(C.joinPath(Z,"cwd").fsPath),Q=await L.Promises.readFile(C.joinPath(Z,"cmdline").fsPath,"utf8");H.push({pid:U,cwd:z,cmd:Q})}}catch{}const X=[],V=_.filter(F=>{const U=O[F.socket];return U||X.push(F),U}),N=a(V,O,H);let T;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${X.length}`),X.length>0){const F=await new Promise(U=>{(0,S.exec)("ps -F -A -l | grep root",(Z,J,z)=>{U(J)})});this._foundRootPorts=c(X,F,this._foundRootPorts),T=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${T.map(U=>U.port).join(", ")}`)}return N.then(F=>T?F.concat(T):F)}};g=je([Be(0,R.IExtHostRpcService),Be(1,w.IExtHostInitDataService),Be(2,u.ILogService)],g),e.ExtHostTunnelService=g}),define(Se[292],ye([1,0,19,22,21,10,3,6,114,250,58]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function b(_,E){try{return JSON.stringify(_,E)}catch{return"null"}}const I="$$ref$$",y={[I]:-1};class f{constructor(E,O){this.jsonString=E,this.referencedBuffers=O}}function d(_,E=null,O=!1){const $=[];return{jsonString:(O?b:JSON.stringify)(_,(X,V)=>{if(typeof V>"u")return y;if(typeof V=="object"){if(V instanceof R.VSBuffer){const N=$.push(V)-1;return{[I]:N}}if(E)return E(X,V)}return V}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=d;function u(_,E,O){return JSON.parse(_,($,H)=>{if(H){const X=H[I];if(typeof X=="number")return E[X];if(O&&H.$mid===1)return O.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=u;function m(_,E){return JSON.stringify(_,E)}function v(_){return _?(E,O)=>O&&O.$mid===1?_.transformOutgoing(O):O:null}var D;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends P.Disposable{constructor(E,O=null,$=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new w.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=E,this._logger=O,this._uriTransformer=$,this._uriReplacer=v(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,X=L.ProxyIdentifier.count;H<X;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(H=>this._receiveOneMessage(H))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(E=>{this._pendingRPCReplies[E].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(E){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(E){this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(E){this._responsiveState!==E&&(this._responsiveState=E,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(E){return this._uriTransformer?(0,S.transformIncomingURIs)(E,this._uriTransformer):E}getProxy(E){const{nid:O,sid:$}=E;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,$)),this._proxies[O]}_createProxy(E,O){const $={get:(H,X)=>(typeof X=="string"&&!H[X]&&X.charCodeAt(0)===36&&(H[X]=(...V)=>this._remoteCall(E,X,V)),X===r?O:H[X])};return new Proxy(Object.create(null),$)}set(E,O){return this._locals[E.nid]=O,O}assertRegistered(E){for(let O=0,$=E.length;O<$;O++){const H=E[O];if(!this._locals[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}_receiveOneMessage(E){if(this._isDisposed)return;const O=E.byteLength,$=c.read(E,0),H=$.readUInt8(),X=$.readUInt32();switch(H){case 1:case 2:{let{rpcId:V,method:N,args:T}=i.deserializeRequestJSONArgs($);this._uriTransformer&&(T=(0,S.transformIncomingURIs)(T,this._uriTransformer)),this._receiveRequest(O,X,V,N,T,H===2);break}case 3:case 4:{let{rpcId:V,method:N,args:T}=i.deserializeRequestMixedArgs($);this._uriTransformer&&(T=(0,S.transformIncomingURIs)(T,this._uriTransformer)),this._receiveRequest(O,X,V,N,T,H===4);break}case 5:{this._logger?.logIncoming(O,X,0,"ack"),this._onDidReceiveAcknowledge(X);break}case 6:{this._receiveCancel(O,X);break}case 7:{this._receiveReply(O,X,void 0);break}case 9:{let V=i.deserializeReplyOKJSON($);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReply(O,X,V);break}case 10:{const V=i.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(O,X,V);break}case 8:{const V=i.deserializeReplyOKVSBuffer($);this._receiveReply(O,X,V);break}case 11:{let V=i.deserializeReplyErrError($);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReplyErr(O,X,V);break}case 12:{this._receiveReplyErr(O,X,void 0);break}default:console.error("received unexpected message"),console.error(E)}}_receiveRequest(E,O,$,H,X,V){this._logger?.logIncoming(E,O,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)($)}.${H}(`,X);const N=String(O);let T,F;if(V){const Z=new l.CancellationTokenSource;X.push(Z.token),T=this._invokeHandler($,H,X),F=()=>Z.cancel()}else T=this._invokeHandler($,H,X),F=n;this._cancelInvokedHandlers[N]=F;const U=i.serializeAcknowledged(O);this._logger?.logOutgoing(U.byteLength,O,1,"ack"),this._protocol.send(U),T.then(Z=>{delete this._cancelInvokedHandlers[N];const J=i.serializeReplyOK(O,Z,this._uriReplacer);this._logger?.logOutgoing(J.byteLength,O,1,"reply:",Z),this._protocol.send(J)},Z=>{delete this._cancelInvokedHandlers[N];const J=i.serializeReplyErr(O,Z);this._logger?.logOutgoing(J.byteLength,O,1,"replyErr:",Z),this._protocol.send(J)})}_receiveCancel(E,O){this._logger?.logIncoming(E,O,1,"receiveCancel");const $=String(O);this._cancelInvokedHandlers[$]?.()}_receiveReply(E,O,$){this._logger?.logIncoming(E,O,0,"receiveReply:",$);const H=String(O);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const X=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],X.resolveOk($)}_receiveReplyErr(E,O,$){this._logger?.logIncoming(E,O,0,"receiveReplyErr:",$);const H=String(O);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const X=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let V;$&&($.$isError?(V=new Error,V.name=$.name,V.message=$.message,V.stack=$.stack):V=$),X.resolveErr(V)}_invokeHandler(E,O,$){try{return Promise.resolve(this._doInvokeHandler(E,O,$))}catch(H){return Promise.reject(H)}}_doInvokeHandler(E,O,$){const H=this._locals[E];if(!H)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(E));const X=H[O];if(typeof X!="function")throw new Error("Unknown method "+O+" on actor "+(0,L.getStringIdentifierForProxy)(E));return X.apply(H,$)}_remoteCall(E,O,$){if(this._isDisposed)return new C.CanceledLazyPromise;let H=null;if($.length>0&&l.CancellationToken.isCancellationToken($[$.length-1])&&(H=$.pop()),H&&H.isCancellationRequested)return Promise.reject(A.canceled());const X=i.serializeRequestArguments($,this._uriReplacer),V=++this._lastMessageId,N=String(V),T=new C.LazyPromise;H&&H.onCancellationRequested(()=>{const U=i.serializeCancel(V);this._logger?.logOutgoing(U.byteLength,V,0,"cancel"),this._protocol.send(i.serializeCancel(V))}),this._pendingRPCReplies[N]=T,this._onWillSendRequest(V);const F=i.serializeRequest(V,E,O,X,!!H);return this._logger?.logOutgoing(F.byteLength,V,0,`request: ${(0,L.getStringIdentifierForProxy)(E)}.${O}(`,$),this._protocol.send(F),T}}k=s,a.UNRESPONSIVE_TIME=3*1e3,e.RPCProtocol=a;class c{static alloc(E,O,$){const H=new c(R.VSBuffer.alloc($+1+4),0);return H.writeUInt8(E),H.writeUInt32(O),H}static read(E,O){return new c(E,O)}get buffer(){return this._buff}constructor(E,O){this._buff=E,this._offset=O}static sizeUInt8(){return 1}writeUInt8(E){this._buff.writeUInt8(E,this._offset),this._offset+=1}readUInt8(){const E=this._buff.readUInt8(this._offset);return this._offset+=1,E}writeUInt32(E){this._buff.writeUInt32BE(E,this._offset),this._offset+=4}readUInt32(){const E=this._buff.readUInt32BE(this._offset);return this._offset+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this._buff.writeUInt8(E.byteLength,this._offset),this._offset+=1,this._buff.set(E,this._offset),this._offset+=E.byteLength}readShortString(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,$}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readLongString(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,$}writeBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readVSBuffer(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+E);return this._offset+=E,O}static sizeMixedArray(E){let O=0;O+=1;for(let $=0,H=E.length;$<H;$++){const X=E[$];switch(O+=1,X.type){case 1:O+=this.sizeLongString(X.value);break;case 2:O+=this.sizeVSBuffer(X.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(X.value);for(let V=0;V<X.buffers.length;++V)O+=this.sizeVSBuffer(X.buffers[V]);break;case 4:break}}return O}writeMixedArray(E){this._buff.writeUInt8(E.length,this._offset),this._offset+=1;for(let O=0,$=E.length;O<$;O++){const H=E[O];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let X=0;X<H.buffers.length;++X)this.writeBuffer(H.buffers[X]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const O=new Array(E);for(let $=0;$<E;$++)switch(this.readUInt8()){case 1:O[$]=this.readLongString();break;case 2:O[$]=this.readVSBuffer();break;case 3:{const X=this.readUInt32(),V=this.readLongString(),N=[];for(let T=0;T<X;++T)N.push(this.readVSBuffer());O[$]=new L.SerializableObjectWithBuffers(u(V,N,null));break}case 4:O[$]=void 0;break}return O}}c.sizeUInt32=4;var g;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(g||(g={}));class i{static _useMixedArgSerialization(E){for(let O=0,$=E.length;O<$;O++)if(E[O]instanceof R.VSBuffer||E[O]instanceof L.SerializableObjectWithBuffers||typeof E[O]>"u")return!0;return!1}static serializeRequestArguments(E,O){if(this._useMixedArgSerialization(E)){const $=[];for(let H=0,X=E.length;H<X;H++){const V=E[H];if(V instanceof R.VSBuffer)$[H]={type:2,value:V};else if(typeof V>"u")$[H]={type:4};else if(V instanceof L.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:T}=d(V.value,O);$[H]={type:3,value:R.VSBuffer.fromString(N),buffers:T}}else $[H]={type:1,value:R.VSBuffer.fromString(m(V,O))}}return{type:1,args:$}}return{type:0,args:m(E,O)}}static serializeRequest(E,O,$,H,X){switch(H.type){case 0:return this._requestJSONArgs(E,O,$,H.args,X);case 1:return this._requestMixedArgs(E,O,$,H.args,X)}}static _requestJSONArgs(E,O,$,H,X){const V=R.VSBuffer.fromString($),N=R.VSBuffer.fromString(H);let T=0;T+=c.sizeUInt8(),T+=c.sizeShortString(V),T+=c.sizeLongString(N);const F=c.alloc(X?2:1,E,T);return F.writeUInt8(O),F.writeShortString(V),F.writeLongString(N),F.buffer}static deserializeRequestJSONArgs(E){const O=E.readUInt8(),$=E.readShortString(),H=E.readLongString();return{rpcId:O,method:$,args:JSON.parse(H)}}static _requestMixedArgs(E,O,$,H,X){const V=R.VSBuffer.fromString($);let N=0;N+=c.sizeUInt8(),N+=c.sizeShortString(V),N+=c.sizeMixedArray(H);const T=c.alloc(X?4:3,E,N);return T.writeUInt8(O),T.writeShortString(V),T.writeMixedArray(H),T.buffer}static deserializeRequestMixedArgs(E){const O=E.readUInt8(),$=E.readShortString(),H=E.readMixedArray(),X=new Array(H.length);for(let V=0,N=H.length;V<N;V++){const T=H[V];typeof T=="string"?X[V]=JSON.parse(T):X[V]=T}return{rpcId:O,method:$,args:X}}static serializeAcknowledged(E){return c.alloc(5,E,0).buffer}static serializeCancel(E){return c.alloc(6,E,0).buffer}static serializeReplyOK(E,O,$){if(typeof O>"u")return this._serializeReplyOKEmpty(E);if(O instanceof R.VSBuffer)return this._serializeReplyOKVSBuffer(E,O);if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:X}=d(O.value,$,!0);return this._serializeReplyOKJSONWithBuffers(E,H,X)}else return this._serializeReplyOKJSON(E,b(O,$))}static _serializeReplyOKEmpty(E){return c.alloc(7,E,0).buffer}static _serializeReplyOKVSBuffer(E,O){let $=0;$+=c.sizeVSBuffer(O);const H=c.alloc(8,E,$);return H.writeVSBuffer(O),H.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static _serializeReplyOKJSON(E,O){const $=R.VSBuffer.fromString(O);let H=0;H+=c.sizeLongString($);const X=c.alloc(9,E,H);return X.writeLongString($),X.buffer}static _serializeReplyOKJSONWithBuffers(E,O,$){const H=R.VSBuffer.fromString(O);let X=0;X+=c.sizeUInt32,X+=c.sizeLongString(H);for(const N of $)X+=c.sizeVSBuffer(N);const V=c.alloc(10,E,X);V.writeUInt32($.length),V.writeLongString(H);for(const N of $)V.writeBuffer(N);return V.buffer}static deserializeReplyOKJSON(E){const O=E.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(E,O){const $=E.readUInt32(),H=E.readLongString(),X=[];for(let V=0;V<$;++V)X.push(E.readVSBuffer());return new L.SerializableObjectWithBuffers(u(H,X,O))}static serializeReplyErr(E,O){const $=O?b(A.transformErrorForSerialization(O),null):void 0;if(typeof $!="string")return this._serializeReplyErrEmpty(E);const H=R.VSBuffer.fromString($);let X=0;X+=c.sizeLongString(H);const V=c.alloc(11,E,X);return V.writeLongString(H),V.buffer}static deserializeReplyErrError(E){const O=E.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(E){return c.alloc(12,E,0).buffer}}var t;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var h;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(h||(h={}))}),define(Se[293],ye([1,0,3,39,54,4]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var w;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.channels=new Map,this._onDidRegisterChannel=new o.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new o.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(C){this.channels.has(C.id)||(this.channels.set(C.id,C),this._onDidRegisterChannel.fire(C.id))}getChannels(){const C=[];return this.channels.forEach(L=>C.push(L)),C}getChannel(C){return this.channels.get(C)}removeChannel(C){this.channels.delete(C),this._onDidRemoveChannel.fire(C)}}R.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(Se[142],ye([1,0,5,4,20,27,13,293,79,25,48,158,22,9,44,3,6]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends w.AbstractMessageLogger{get disposed(){return this._disposed}constructor(p,n,s,r,a){super(),this.id=p,this.name=n,this.logger=s,this.proxy=r,this.extension=a,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(s.getLevel()),this._register(s.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,p)}replace(p){const n=this.offset;this.info(p),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,n),this.visible&&this.logger.flush()}show(p,n){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:n))}hide(){this.proxy.$close(this.id)}log(p,n){this.offset+=b.VSBuffer.fromString(n).byteLength,(0,w.log)(this.logger,p,n),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class m extends u{appendLine(p){this.append(p)}}let v=class{constructor(p,n,s,r,a,c){this.initData=n,this.extHostFileSystem=s,this.extHostFileSystemInfo=r,this.loggerService=a,this.logService=c,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[n,s]of this.channels)s.visible=n===this.visibleChannelId}createOutputChannel(p,n,s){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,a=(0,I.isString)(n)?n:void 0;if((0,I.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const g=this.initData.environment.extensionLogLevel?.find(([t])=>A.ExtensionIdentifier.equals(s.identifier,t))?.[1];g&&(c=(0,w.parseLogLevel)(g));const i=r?this.doCreateLogOutputChannel(p,c,s):this.doCreateOutputChannel(p,a,s);return i.then(t=>{this.channels.set(t.id,t),t.visible=t.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(p,c??this.logService.getLevel(),i):this.createExtHostOutputChannel(p,i)}async doCreateOutputChannel(p,n,s){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,a=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.proxy.$register(p,a,n,s.identifier.value);return new u(g,p,c,this.proxy,s)}async doCreateLogOutputChannel(p,n,s){const r=await this.createExtensionLogDirectory(s),a=this.extHostFileSystemInfo.extUri.joinPath(r,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=a.toString(),g=this.loggerService.createLogger(a,{id:c,name:p,logLevel:n,extensionId:s.identifier.value});return new m(c,p,g,this.proxy,s)}createExtensionLogDirectory(p){let n=this.extensionLogDirectoryPromise.get(p.identifier.value);if(!n){const s=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,p.identifier.value);this.extensionLogDirectoryPromise.set(p.identifier.value,n=(async()=>{try{await this.extHostFileSystem.value.createDirectory(s)}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileExists)throw r}return s})())}return n}createExtHostOutputChannel(p,n){let s=!1;const r=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return p},append(a){r(),n.then(c=>c.append(a))},appendLine(a){r(),n.then(c=>c.appendLine(a))},clear(){r(),n.then(a=>a.clear())},replace(a){r(),n.then(c=>c.replace(a))},show(a,c){r(),n.then(g=>g.show(a,c))},hide(){r(),n.then(a=>a.hide())},dispose(){s=!0,n.then(a=>a.dispose())}}}createExtHostLogOutputChannel(p,n,s){const r=new d.DisposableStore,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},c=r.add(new f.Emitter);function g(i){n=i,c.fire(i)}return s.then(i=>{r.add(i),i.logLevel!==n&&g(i.logLevel),r.add(i.onDidChangeLogLevel(t=>g(t)))}),{...this.createExtHostOutputChannel(p,s),get logLevel(){return n},onDidChangeLogLevel:c.event,trace(i,...t){a(),s.then(h=>h.trace(i,...t))},debug(i,...t){a(),s.then(h=>h.debug(i,...t))},info(i,...t){a(),s.then(h=>h.info(i,...t))},warn(i,...t){a(),s.then(h=>h.warn(i,...t))},error(i,...t){a(),s.then(h=>h.error(i,...t))},dispose(){r.dispose()}}}};v=je([Be(0,l.IExtHostRpcService),Be(1,C.IExtHostInitDataService),Be(2,S.IExtHostConsumerFileSystem),Be(3,L.IExtHostFileSystemInfo),Be(4,w.ILoggerService),Be(5,w.ILogService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(Se[294],ye([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(Se[295],ye([1,0,34,15,12,11,24,2,4,220,47,238,294]),function(re,e,o,R,l,A,w,P,S,C,L,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let I=class cn{constructor(f,d,u,m){this.localUserHome=f,this.remoteAgentService=d,this.environmentService=u,this.contextService=m,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=v?.userHome??f})()}hasValidBasename(f,d,u){return typeof d=="string"||typeof d>"u"?this.resolveOS.then(m=>this.doHasValidBasename(f,m,d)):this.doHasValidBasename(f,d,u)}doHasValidBasename(f,d,u){return f.scheme===R.Schemas.file||f.scheme===R.Schemas.vscodeRemote?(0,o.isValidBasename)(u??(0,w.basename)(f),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return R.Schemas.vscodeRemote;const u=(0,C.getVirtualWorkspaceScheme)(d.getWorkspace());if(u)return u;const m=d.getWorkspace().folders[0];if(m)return m.uri.scheme;const v=d.getWorkspace().configuration;return v?v.scheme:R.Schemas.file}userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?l.win32:l.posix)}async fileURI(f){let d="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const m=f.indexOf("/",2);m===-1?(d=f.substring(2),f="/"):(d=f.substring(2,m),f=f.substring(m)||"/")}return P.URI.from({scheme:R.Schemas.file,authority:d,path:f,query:"",fragment:""})}};I=je([Be(1,b.IRemoteAgentService),Be(2,k.IWorkbenchEnvironmentService),Be(3,L.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(Se[82],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(w,P){this.line=w,this.character=P}isBefore(w){return!1}isBeforeOrEqual(w){return!1}isAfter(w){return!1}isAfterOrEqual(w){return!1}isEqual(w){return!1}compareTo(w){return 0}translate(w,P){return new o(0,0)}with(w){return new o(0,0)}}e.Position=o;class R{constructor(w,P,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(w,P),this.end=new o(S,C)}contains(w){return!1}isEqual(w){return!1}intersection(w){}union(w){return new R(0,0,0,0)}with(w){return new R(0,0,0,0)}}e.Range=R;var l;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(l=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[31],ye([1,0,16,38,23,34,8,4,12,10,82,19]),function(re,e,o,R,l,A,w,P,S,C,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const b="\u27EA ",I=" characters skipped \u27EB",y=(b.length+I.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var f;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function u(Q){return!!Q.preview}e.resultIsMatch=u;function m(Q){return!!Q.resource}e.isFileMatch=m;function v(Q){return!!Q.message}e.isProgressMessage=v;var D;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(D=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=p;class n{constructor(ie,ge,K){this.ranges=ge;const Y=Array.isArray(ge)?ge:[ge];if(K&&K.matchLines===1&&s(Y)){ie=(0,w.getNLines)(ie,K.matchLines);let ee="",me=0,be=0;const De=Math.floor(K.charsPerLine/5),Ae=[];for(const ae of Y){const le=Math.max(ae.startColumn-De,0),ue=ae.startColumn+K.charsPerLine;if(le>be+De+y){const ne=b+(le-be)+I;ee+=ne+ie.slice(le,ue),me+=le-(be+ne.length)}else ee+=ie.slice(be,ue);Ae.push(new a(0,ae.startColumn-me,ae.endColumn-me)),be=ue}this.preview={text:ee,matches:Array.isArray(this.ranges)?Ae:Ae[0]}}else{const ee=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:ie,matches:(0,o.mapArrayOrNot)(ge,me=>new r(me.startLineNumber-ee,me.startColumn,me.endLineNumber-ee,me.endColumn))}}}}e.TextSearchMatch=n;function s(Q){const ie=Q[0].startLineNumber;for(const ge of Q)if(ge.startLineNumber!==ie||ge.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,ge,K,Y){this.startLineNumber=ie,this.startColumn=ge,this.endLineNumber=K,this.endColumn=Y}}e.SearchRange=r;class a extends r{constructor(ie,ge,K){super(ie,ge,ie,K)}}e.OneLineRange=a;var c;(function(Q){Q.List="list",Q.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var g;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function i(Q,ie=!0){const ge=Q&&Q.files&&Q.files.exclude,K=ie&&Q&&Q.search&&Q.search.exclude;if(!ge&&!K)return;if(!ge||!K)return ge||K;let Y=Object.create(null);return Y=l.mixin(Y,l.deepClone(ge)),Y=l.mixin(Y,l.deepClone(K),!0),Y}e.getExcludes=i;function t(Q,ie){return Q.excludePattern&&R.match(Q.excludePattern,ie)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&R.match(Q.includePattern,ie)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ge=>{const K=ge.folder.fsPath;if(A.isEqualOrParent(ie,K)){const Y=S.relative(K,ie);return!ge.includePattern||!!R.match(ge.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var h;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(ie,ge){super(ie),this.code=ge}}e.SearchError=_;function E(Q){const ie=Q.message;if((0,C.isCancellationError)(Q))return new _(ie,h.canceled);try{const ge=JSON.parse(ie);return new _(ge.message,ge.code)}catch{return new _(ie,h.other)}}e.deserializeSearchError=E;function O(Q){const ie={message:Q.message,code:Q.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=O;function $(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=$;function H(Q){return Q.type==="success"}e.isSerializedSearchSuccess=H;function X(Q){return!!Q.path}e.isSerializedFileMatch=X;function V(Q,ie){const ge=Q.searchPath?Q.searchPath:Q.relativePath;return(0,w.fuzzyContains)(ge,ie)}e.isFilePatternMatch=V;class N{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function T(Q,ie){const ge={...Q||{},...ie||{}};return Object.keys(ge).filter(K=>{const Y=ge[K];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=T;class F{constructor(ie,ge){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...ge.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let K=ie.includePattern;ge.includePattern&&(K?K={...K,...ge.includePattern}:K=ge.includePattern),K&&(this._parsedIncludeExpression=R.parse(K))}matchesExcludesSync(ie,ge,K){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ge,K))}includedInQuerySync(ie,ge,K){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ge,K)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,ge,K))}includedInQuery(ie,ge,K){const Y=this._parsedExcludeExpression(ie,ge,K),ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,ge,K):!0;return(0,k.isThenable)(Y)?Y.then(me=>me?!1:ee()):ee()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=F;function U(Q){for(const ie in Q)if(typeof Q[ie]!="boolean")return!0;return!1}function Z(Q){if(!Q)return;let ie;return ge=>(ie||(ie=(Q()||Promise.resolve([])).then(K=>K?z(K):{})),ie.then(K=>!!K[ge]))}e.hasSiblingPromiseFn=Z;function J(Q){if(!Q)return;let ie;return ge=>{if(!ie){const K=Q();ie=K?z(K):{}}return!!ie[ge]}}e.hasSiblingFn=J;function z(Q){const ie={};for(const ge of Q)ie[ge]=!0;return ie}}),define(Se[35],ye([1,0,16,19,21,3,6,68,15,102,24,8,9,2,184,4,13,208,47,48,25,20,14,7,56,31,5]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p,n,s,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function g(H,X,V){return new L.ExtUri(N=>_(N,V)).isEqual(H,X)}function i(H,X,V){return g(H.uri,X.uri,V)?0:(0,k.compare)(H.uri.toString(),X.uri.toString())}function t(H,X,V){return H.index!==X.index?H.index<X.index?-1:1:g(H.uri,X.uri,V)?(0,k.compare)(H.name,X.name):(0,k.compare)(H.uri.toString(),X.uri.toString())}function h(H,X,V,N){const T=H.slice(0).sort((U,Z)=>V(U,Z,N)),F=X.slice(0).sort((U,Z)=>V(U,Z,N));return(0,o.delta)(T,F,(U,Z)=>V(U,Z,N))}function _(H,X){const V=X.getCapabilities(H.scheme);return!(V&&V&1024)}class E extends m.Workspace{static toExtHostWorkspace(X,V,N,T){if(!X)return{workspace:null,added:[],removed:[]};const{id:F,name:U,folders:Z,configuration:J,transient:z,isUntitled:Q}=X,ie=[],ge=V;V?Z.forEach((me,be)=>{const De=I.URI.revive(me.uri),Ae=E._findFolder(N||V,De,T);Ae?(Ae.name=me.name,Ae.index=me.index,ie.push(Ae)):ie.push({uri:De,name:me.name,index:be})}):ie.push(...Z.map(({uri:me,name:be,index:De})=>({uri:I.URI.revive(me),name:be,index:De}))),ie.sort((me,be)=>me.index<be.index?-1:1);const K=new E(F,U,ie,!!z,J?I.URI.revive(J):null,!!Q,me=>_(me,T)),{added:Y,removed:ee}=h(ge?ge.workspaceFolders:[],K.workspaceFolders,i,T);return{workspace:K,added:Y,removed:ee}}static _findFolder(X,V,N){for(let T=0;T<X.folders.length;T++){const F=X.workspaceFolders[T];if(g(F.uri,V,N))return F}}constructor(X,V,N,T,F,U,Z){super(X,N.map(J=>new m.WorkspaceFolder(J)),T,F,Z),this._name=V,this._isUntitled=U,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(Z),N.forEach(J=>{this._workspaceFolders.push(J),this._structure.set(J.uri,J)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(X,V){return V&&this._structure.get(X)&&(X=(0,L.dirname)(X)),this._structure.findSubstr(X)}resolveWorkspaceFolder(X){return this._structure.get(X)}}let O=class{constructor(X,V,N,T,F){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._logService=T,this._extHostFileSystemInfo=N,this._uriTransformerService=F,this._requestIdProvider=new C.Counter,this._barrier=new R.Barrier,this._proxy=X.getProxy(c.MainContext.MainThreadWorkspace),this._messageService=X.getProxy(c.MainContext.MainThreadMessageService);const U=V.workspace;this._confirmedWorkspace=U?new E(U.id,U.name,[],!!U.transient,U.configuration?I.URI.revive(U.configuration):null,!!U.isUntitled,Z=>_(Z,N)):void 0}$initializeWorkspace(X,V){this._trusted=V,this.$acceptWorkspaceData(X),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?I.URI.from({scheme:S.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(X,V,N,...T){const F=[];if(Array.isArray(T)&&T.forEach(Q=>{I.URI.isUri(Q.uri)&&!F.some(ie=>g(ie.uri,Q.uri,this._extHostFileSystemInfo))&&F.push({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[V,N].some(Q=>typeof Q!="number"||Q<0)||N===0&&F.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(V+N>U.length)return!1;const Z=U.slice(0);Z.splice(V,N,...F.map(Q=>({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<Z.length;Q++){const ie=Z[Q];if(Z.some((ge,K)=>K!==Q&&g(ie.uri,ge.uri,this._extHostFileSystemInfo)))return!1}Z.forEach((Q,ie)=>Q.index=ie);const{added:J,removed:z}=h(U,Z,t,this._extHostFileSystemInfo);if(J.length===0&&z.length===0)return!1;if(this._proxy){const Q=X.displayName||X.name;this._proxy.$updateWorkspaceFolders(Q,V,N,F).then(void 0,ie=>{this._unconfirmedWorkspace=void 0;const ge={source:{identifier:X.identifier,label:X.displayName||X.name}};this._messageService.$showMessage(u.Severity.Error,(0,y.localize)(0,null,Q,ie.toString()),ge,[])})}return this.trySetWorkspaceFolders(Z),!0}getWorkspaceFolder(X,V){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(X,V)}async getWorkspaceFolder2(X,V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(X,V)}async resolveWorkspaceFolder(X){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(X)}getPath(){if(!this._actualWorkspace)return;const{folders:X}=this._actualWorkspace;if(X.length!==0)return X[0].uri.fsPath}getRelativePath(X,V){let N,T="";if(typeof X=="string"?(N=I.URI.file(X),T=X):typeof X<"u"&&(N=X,T=X.fsPath),!N)return T;const F=this.getWorkspaceFolder(N,!0);if(!F)return T;typeof V>"u"&&this._actualWorkspace&&(V=this._actualWorkspace.folders.length>1);let U=(0,L.relativePath)(F.uri,N);return V&&F.name&&(U=`${F.name}/${U}`),U}trySetWorkspaceFolders(X){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:X,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(X){const{workspace:V,added:N,removed:T}=E.toExtHostWorkspace(X,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=V||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:T}))}findFiles(X,V,N,T,F=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let U;if(V===null?U=!1:V&&(typeof V=="string"?U=V:U=V.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:J}=$(n.GlobPattern.from(X));return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(Z),(0,b.withUndefinedAsNull)(J),(0,b.withUndefinedAsNull)(U),(0,b.withUndefinedAsNull)(N),F).then(z=>Array.isArray(z)?z.map(Q=>I.URI.revive(Q)):[])}async findTextInFiles(X,V,N,T,F=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),Z=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:J,folder:z}=$(n.GlobPattern.from(V.include)),Q=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,ie={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:Z,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:J,excludePattern:Q},ge=!1;if(this._activeSearchCallbacks[U]=K=>{if(ge)return;const Y=I.URI.revive(K.resource);K.results.forEach(ee=>{(0,a.resultIsMatch)(ee)?N({uri:Y,preview:{text:ee.preview.text,matches:(0,o.mapArrayOrNot)(ee.preview.matches,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))},ranges:(0,o.mapArrayOrNot)(ee.ranges,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))}):N({uri:Y,text:ee.text,lineNumber:ee.lineNumber})})},F.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(X,(0,b.withUndefinedAsNull)(z),ie,U,F);return delete this._activeSearchCallbacks[U],K||{}}catch(K){throw delete this._activeSearchCallbacks[U],K}}$handleTextSearchResult(X,V){this._activeSearchCallbacks[V]?.(X)}saveAll(X){return this._proxy.$saveAll(X)}resolveProxy(X){return this._proxy.$resolveProxy(X)}get trusted(){return this._trusted}requestWorkspaceTrust(X){return this._proxy.$requestWorkspaceTrust(X)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(X,V){if(this._editSessionIdentityProviders.has(X))throw new Error(`A provider has already been registered for scheme ${X}`);this._editSessionIdentityProviders.set(X,V);const N=this._uriTransformerService.transformOutgoingScheme(X),T=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(T,N),(0,w.toDisposable)(()=>{this._editSessionIdentityProviders.delete(X),this._proxy.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(X,V){this._logService.info("Getting edit session identifier for workspaceFolder",X);const N=await this.resolveWorkspaceFolder(I.URI.revive(X));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const T=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!T),!T)return;const F=await T.provideEditSessionIdentity(N,V);if(this._logService.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(X,V,N,T){this._logService.info("Getting edit session identifier for workspaceFolder",X);const F=await this.resolveWorkspaceFolder(I.URI.revive(X));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const U=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!U),!U)return;const Z=await U.provideEditSessionIdentityMatch?.(V,N,T);if(this._logService.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(X){return(V,N,T)=>{const F=function(Z){V.call(N,Z)};return F.extension=X,this._onWillCreateEditSessionIdentityEvent.event(F,void 0,T)}}async $onWillCreateEditSessionIdentity(X,V,N){const T=await this.resolveWorkspaceFolder(I.URI.revive(X));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:T},V,async(F,U)=>{const Z=Date.now();await Promise.resolve(F),Date.now()-Z>N&&this._logService.warn("SLOW edit session create-participant",U.extension.identifier)}),V.isCancellationRequested}};O=je([Be(0,p.IExtHostRpcService),Be(1,D.IExtHostInitDataService),Be(2,v.IExtHostFileSystemInfo),Be(3,d.ILogService),Be(4,r.IURITransformerService)],O),e.ExtHostWorkspace=O,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function $(H){let X,V;return H&&(typeof H=="string"?X=H:(X=H.pattern,V=I.URI.revive(H.baseUri))),{includePattern:X,folder:V}}}),define(Se[36],ye([1,0,23,3,35,5,7,211,127,9,19,4,20,13,2]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(s,r){if(r){const a=r.split(".");let c=s;for(let g=0;c&&g<a.length;g++)c=c[a[g]];return c}}function d(s){return s instanceof y.URI}function u(s){return s&&s.uri instanceof y.URI&&s.languageId&&typeof s.languageId=="string"}function m(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function v(s){return s&&s.uri instanceof y.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function D(s){if(d(s))return{resource:s};if(u(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(m(s))return{overrideIdentifier:s.languageId};if(v(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(r,a,c){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=c,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,a))}};p=je([Be(0,b.IExtHostRpcService),Be(1,l.IExtHostWorkspace),Be(2,I.ILogService)],p),e.ExtHostConfiguration=p;class n{constructor(r,a,c,g){this._onDidChangeConfiguration=new R.Emitter,this._proxy=r,this._logService=g,this._extHostWorkspace=a,this._configuration=P.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,a){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,c))}getConfiguration(r,a,c){const g=D(a)||{},i=this._toReadonlyValue(r?f(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,g,c?.identifier);function t(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case w.ConfigurationTarget.Global:return 2;case w.ConfigurationTarget.Workspace:return 5;case w.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(_){return typeof f(i,_)<"u"},get:(_,E)=>{this._validateConfigurationAccess(r?`${r}.${_}`:_,g,c?.identifier);let O=f(i,_);if(typeof O>"u")O=E;else{let $;const H=(X,V)=>{let N;const T=()=>{$=$||(0,o.deepClone)(i),N=N||f($,V)};return(0,C.isObject)(X)?new Proxy(X,{get:(F,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return T(),()=>N;if($)return N=N||f($,V),N[U];const Z=F[U];return typeof U=="string"?H(Z,`${V}.${U}`):Z},set:(F,U,Z)=>(T(),N&&(N[U]=Z),!0),deleteProperty:(F,U)=>(T(),N&&delete N[U],!0),defineProperty:(F,U,Z)=>(T(),N&&Object.defineProperty(N,U,Z),!0)}):X};O=H(O,_)}return O},update:(_,E,O,$)=>{_=r?`${r}.${_}`:_;const H=t(O);return E!==void 0?this._proxy.$updateConfigurationOption(H,_,E,g,$):this._proxy.$removeConfigurationOption(H,_,g,$)},inspect:_=>{_=r?`${r}.${_}`:_;const E=this._configuration.inspect(_,g,this._extHostWorkspace.workspace);if(E)return{key:_,defaultValue:(0,o.deepClone)(E.policy?.value??E.default?.value),globalValue:(0,o.deepClone)(E.user?.value??E.application?.value),workspaceValue:(0,o.deepClone)(E.workspace?.value),workspaceFolderValue:(0,o.deepClone)(E.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(E.default?.override),globalLanguageValue:(0,o.deepClone)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,o.deepClone)(E.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(E.workspaceFolder?.override),languageIds:(0,o.deepClone)(E.overrideIdentifiers)}}};return typeof i=="object"&&(0,o.mixin)(h,i,!1),Object.freeze(h)}_toReadonlyValue(r){const a=c=>(0,C.isObject)(c)?new Proxy(c,{get:(g,i)=>a(g[i]),set:(g,i,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(g,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(g,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return a(r)}_validateConfigurationAccess(r,a,c){const g=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),i=c?`[${c.value}] `:"";if(g===4){typeof a?.resource>"u"&&this._logService.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){a?.resource&&this._logService.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,a){const c=new P.ConfigurationChangeEvent(r,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,i)=>c.affectsConfiguration(g,D(i))})}_toMap(r){return r.reduce((a,c)=>(a.set(c[0],c[1]),a),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[83],ye([1,0,2,19,3,5,7,35,59,36,21,41,20,25,4,15,11,13,78,249,10]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(X){function V(T){if(T!=null)return T}X.from=V;function N(T){if(T!=null)return T}X.to=N})(n||(n={}));var s;(function(X){function V(T){if(T!=null)return T}X.from=V;function N(T){if(T!=null)return T}X.to=N})(s||(s={}));var r;(function(X){function V(T){if(T!=null)return T}X.from=V;function N(T){if(T!=null)return T}X.to=N})(r||(r={}));var a;(function(X){function V(F){if(F){const U=F;return U&&!!U.process}else return!1}X.is=V;function N(F){if(F==null)return;const U={process:F.process,args:F.args};return F.options&&(U.options=r.from(F.options)),U}X.from=N;function T(F){if(F!=null)return new w.ProcessExecution(F.process,F.args,F.options)}X.to=T})(a||(a={}));var c;(function(X){function V(T){if(T!=null)return T}X.from=V;function N(T){if(T!=null)return T}X.to=N})(c||(c={}));var g;(function(X){function V(F){if(F){const U=F;return U&&(!!U.commandLine||!!U.command)}else return!1}X.is=V;function N(F){if(F==null)return;const U={};return F.commandLine!==void 0?U.commandLine=F.commandLine:(U.command=F.command,U.args=F.args),F.options&&(U.options=c.from(F.options)),U}X.from=N;function T(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new w.ShellExecution(F.commandLine,F.options):new w.ShellExecution(F.command,F.args?F.args:[],F.options)}X.to=T})(g||(g={}));var i;(function(X){function V(F){if(F){const U=F;return U&&U.customExecution==="customExecution"}else return!1}X.is=V;function N(F){return{customExecution:"customExecution"}}X.from=N;function T(F,U){return U.get(F)}X.to=T})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(X){function V(N,T){let F;return N.scope!==void 0&&typeof N.scope!="number"?F=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===w.TaskScope.Workspace&&T&&T.workspaceFile?F=T.workspaceFile:F=v.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:F}}X.from=V})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(X){function V(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}X.from=V})(h||(h={}));var _;(function(X){function V(F,U){if(F==null)return[];const Z=[];for(const J of F){const z=N(J,U);z&&Z.push(z)}return Z}X.fromMany=V;function N(F,U){if(F==null)return;let Z;F.execution instanceof w.ProcessExecution?Z=a.from(F.execution):F.execution instanceof w.ShellExecution?Z=g.from(F.execution):F.execution&&F.execution instanceof w.CustomExecution&&(Z=i.from(F.execution));const J=n.from(F.definition);let z;return F.scope?typeof F.scope=="number"?z=F.scope:z=F.scope.uri:z=w.TaskScope.Workspace,!J||!z?void 0:{_id:F._id,definition:J,name:F.name,source:{extensionId:U.identifier.value,label:F.source,scope:z},execution:Z,isBackground:F.isBackground,group:h.from(F.group),presentationOptions:s.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}X.from=N;async function T(F,U,Z){if(F==null)return;let J;a.is(F.execution)?J=a.to(F.execution):g.is(F.execution)?J=g.to(F.execution):i.is(F.execution)&&(J=i.to(F._id,Z));const z=n.to(F.definition);let Q;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Q=F.source.scope:Q=await U.resolveWorkspaceFolder(o.URI.revive(F.source.scope)):Q=w.TaskScope.Workspace),!z||!Q)return;const ie=new w.Task(z,Q,F.name,F.source.label,J,F.problemMatchers);return F.isBackground!==void 0&&(ie.isBackground=F.isBackground),F.group!==void 0&&(ie.group=w.TaskGroup.from(F.group._id),ie.group&&F.group.isDefault&&(ie.group=new w.TaskGroup(ie.group.id,ie.group.label),F.group.isDefault===!0&&(ie.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ie.presentationOptions=s.to(F.presentationOptions)),F._id&&(ie._id=F._id),F.detail&&(ie.detail=F.detail),ie}X.to=T})(_=e.TaskDTO||(e.TaskDTO={}));var E;(function(X){function V(T){return T}X.from=V;function N(T){if(!!T)return Object.assign(Object.create(null),T)}X.to=N})(E||(E={}));class O{constructor(V,N,T){this._id=N,this._task=T,p.set(this,void 0),Je(this,p,V,"f")}get task(){return this._task}terminate(){Ne(this,p,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}p=new WeakMap;let $=class{constructor(V,N,T,F,U,Z,J,z){this._onDidExecuteTask=new l.Emitter,this._onDidTerminateTask=new l.Emitter,this._onDidTaskProcessStarted=new l.Emitter,this._onDidTaskProcessEnded=new l.Emitter,this._proxy=V.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=T,this._editorService=F,this._configurationService=U,this._terminalService=Z,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=J,this._deprecationService=z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,N,T){if(!T)return new w.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:N,provider:T,extension:V}),this._proxy.$registerTaskProvider(F,N),new w.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(V,N){this._proxy.$registerTaskSystem(V,N)}fetchTasks(V){return this._proxy.$fetchTasks(E.from(V)).then(async N=>{const T=[];for(const F of N){const U=await _.to(F,this._workspaceProvider,this._providedCustomExecutions2);U&&T.push(U)}return T})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(N=>V.push(N)),V}terminateTask(V){if(!(V instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,N,T){const F=this._providedCustomExecutions2.get(V.id);F&&(this._activeCustomExecutions2.set(V.id,F),this._terminalService.attachPtyToTerminal(N,await F.callback(T))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const N=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const N=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:N,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const N=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:V.exitCode})}$provideTasks(V,N){const T=this._handlers.get(V);if(!T)return Promise.reject(new Error("no handler found"));const F=[],U=(0,R.asPromise)(()=>T.provider.provideTasks(L.CancellationToken.None)).then(Z=>this.provideTasksInternal(N,F,T,Z));return new Promise(Z=>{U.then(J=>{Promise.all(F).then(()=>{Z(J)})})})}async $resolveTask(V,N){const T=this._handlers.get(V);if(!T)return Promise.reject(new Error("no handler found"));if(N.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${T.type}].`);const F=await _.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const U=await T.provider.resolveTask(F,L.CancellationToken.None);if(!U)return;this.checkDeprecation(U,T);const Z=_.from(U,T.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(Z.execution)&&await this.addCustomExecution(Z,U,!0),await this.resolveTaskInternal(Z)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,N,T){const F=await this._proxy.$createTaskId(V);!T&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,N.execution)),this._providedCustomExecutions2.set(F,N.execution)}async getTaskExecution(V,N){if(typeof V=="string"){const U=this._taskExecutionPromises.get(V);if(!U)throw new D.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return U}const T=this._taskExecutionPromises.get(V.id);if(T)return T;const F=new Promise((U,Z)=>{function J(z,Q,ie){ie?U(new O(z,Q.id,ie)):Z("Unexpected: Task does not exist.")}N?J(this,V,N):_.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(z=>J(this,V,z))});return this._taskExecutionPromises.set(V.id,F),F.then(U=>(this._taskExecutions.set(V.id,U),U),U=>Promise.reject(U))}checkDeprecation(V,N){V._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));const T=this._notProvidedCustomExecutions.values();let F=T.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=T.next()}};$=je([Be(0,b.IExtHostRpcService),Be(1,I.IExtHostInitDataService),Be(2,P.IExtHostWorkspace),Be(3,S.IExtHostDocumentsAndEditors),Be(4,C.IExtHostConfiguration),Be(5,k.IExtHostTerminalService),Be(6,u.ILogService),Be(7,m.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let H=class extends ${constructor(V,N,T,F,U,Z,J,z){super(V,N,T,F,U,Z,J,z),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(V,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const T=_.from(N,V);if(T===void 0)throw new Error("Task is not valid");if(i.is(T.execution))await this.addCustomExecution(T,N,!1);else throw new D.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(T),N);return this._proxy.$executeTask(T).catch(U=>{throw new Error(U)}),F}provideTasksInternal(V,N,T,F){const U=[];if(F)for(const Z of F){this.checkDeprecation(Z,T),(!Z.definition||!V[Z.definition.type])&&this._logService.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const J=_.from(Z,T.extension);J&&i.is(J.execution)?(U.push(J),N.push(this.addCustomExecution(J,Z,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:T.extension}}async resolveTaskInternal(V){if(i.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,N,T){}};H=je([Be(0,b.IExtHostRpcService),Be(1,I.IExtHostInitDataService),Be(2,P.IExtHostWorkspace),Be(3,S.IExtHostDocumentsAndEditors),Be(4,C.IExtHostConfiguration),Be(5,k.IExtHostTerminalService),Be(6,u.ILogService),Be(7,m.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,y.createDecorator)("IExtHostTask")}),define(Se[296],ye([1,0,12,21,45,38,24,43,31]),function(re,e,o,R,l,A,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(b,I,y){this.config=b,this.provider=I,this.sessionToken=y,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=b.filePattern,this.includePattern=b.includePattern&&A.parse(b.includePattern),this.maxResults=b.maxResults||void 0,this.exists=b.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=b.excludePattern&&A.parse(b.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(b=>b.cancel()),this.activeCancellationTokens=new Set}search(b){const I=this.config.folderQueries||[];return new Promise((y,f)=>{const d=u=>{this.resultCount++,b(u)};if(this.isCanceled)return y({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(u=>{const m=u.toString(),v=o.basename(m);this.globalExcludePattern&&this.globalExcludePattern(m,v)||this.matchFile(d,{base:u,basename:v})}),Promise.all(I.map(u=>this.searchInFolder(u,d))).then(u=>{y({limitHit:this.isLimitHit,stats:u[0]||void 0})},u=>{f(new Error((0,l.toErrorMessage)(u)))})})}async searchInFolder(b,I){const y=new R.CancellationTokenSource,f=this.getSearchOptionsForFolder(b),d=this.initDirectoryTree(),u=new S.QueryGlobTester(this.config,b),m=!u.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(y),v=P.StopWatch.create();const D=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,y.token),p=v.elapsed(),n=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(D&&D.forEach(s=>{const r=o.posix.relative(b.folder.path,s.path);if(m){const a=o.basename(s.path);this.matchFile(I,{base:b.folder,relativePath:r,basename:a});return}this.addDirectoryEntries(d,b.folder,r,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,u,I),{providerTime:p,postProcessTime:n.elapsed()})}finally{y.dispose(),this.activeCancellationTokens.delete(y)}}getSearchOptionsForFolder(b){const I=(0,S.resolvePatternsForProvider)(this.config.includePattern,b.includePattern),y=(0,S.resolvePatternsForProvider)(this.config.excludePattern,b.excludePattern);return{folder:b.folder,excludes:y,includes:I,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}addDirectoryEntries({pathToEntries:b},I,y,f){if(y===this.filePattern){const u=o.basename(this.filePattern);this.matchFile(f,{base:I,relativePath:this.filePattern,basename:u})}function d(u){const m=o.basename(u),v=o.dirname(u);let D=b[v];D||(D=b[v]=[],d(v)),D.push({base:I,relativePath:u,basename:m})}d(y)}matchDirectoryTree({rootEntries:b,pathToEntries:I},y,f){const d=this,u=this.filePattern;function m(v){const D=(0,S.hasSiblingFn)(()=>v.map(p=>p.basename));for(let p=0,n=v.length;p<n;p++){const s=v[p],{relativePath:r,basename:a}=s;if(y.matchesExcludesSync(r,a,u!==a?D:void 0))continue;const c=I[r];if(c)m(c);else{if(r===u)continue;d.matchFile(f,s)}if(d.isLimitHit)break}}m(b)}matchFile(b,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||b(I))}}class L{constructor(){this.sessions=new Map}fileSearch(b,I,y,f){const d=this.getSessionTokenSource(b.cacheKey),u=new C(b,I,d&&d.token);let m=0;const v=D=>{m+=D.length,y(D.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(u,L.BATCH_SIZE,v,f).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:D.stats}}))}clearCache(b){this.getSessionTokenSource(b)?.cancel()}getSessionTokenSource(b){if(!!b)return this.sessions.has(b)||this.sessions.set(b,new R.CancellationTokenSource),this.sessions.get(b)}rawMatchToSearchItem(b){return b.relativePath?{resource:w.joinPath(b.base,b.relativePath)}:{resource:b.base}}doSearch(b,I,y,f){f.onCancellationRequested(()=>{b.cancel()});const d=m=>{m&&(u.push(m),I>0&&u.length>=I&&(y(u),u=[]))};let u=[];return b.search(d).then(m=>(u.length&&y(u),m),m=>(u.length&&y(u),Promise.reject(m)))}}L.BATCH_SIZE=512,e.FileSearchManager=L}),define(Se[297],ye([1,0,16,61,38,113,28,15,12,24,8,9,2,166,196,53,13,47,133,295,31]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(_,E,O,$,H){this.configurationService=_,this.workspaceContextService=E,this.editorGroupsService=O,this.logService=$,this.pathService=H}text(_,E,O={}){_=this.getContentPattern(_,O);const $=this.configurationService.getValue(),H=E&&E.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(E?.map(u.toWorkspaceFolder),O),type:2,contentPattern:_,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:$.search.usePCRE2||H||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}getContentPattern(_,E){const O=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const $={..._,wordSeparators:O.editor.wordSeparators};return this.isCaseSensitive(_,E)&&($.isCaseSensitive=!0),this.isMultiline(_)&&($.isMultiline=!0),$}file(_,E={}){return{...this.commonQuery(_,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(_,E){return _?(_=Array.isArray(_)?_.map(c):c(_),E?this.parseSearchPaths(_):{pattern:s(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],E={}){const O=this.handleIncludeExclude(E.includePattern,E.expandPatterns),$=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),H=_.length>1,X=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(T=>this.getFolderQueryForSearchPath(T,E,$)):_.map(T=>this.getFolderQueryForRoot(T,E,$,H))).filter(T=>!!T),V={_reason:E._reason,folderQueries:X,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:$.pattern,includePattern:O.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const T=o.coalesce(o.flatten(this.editorGroupsService.groups.map(Z=>Z.editors.map(J=>J.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const F=T.filter(Z=>(0,D.pathIncludedInQuery)(V,Z.fsPath)),U=this.commonQueryFromFileList(F);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...V,...U}}const N=E.extraFileResources&&E.extraFileResources.filter(T=>(0,D.pathIncludedInQuery)(V,T.fsPath));return V.extraFileResources=N&&N.length?N:void 0,V}commonQueryFromFileList(_){const E=[],O=new w.ResourceMap,$={};let H=!1;return _.forEach(X=>{if(X.scheme===P.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(X)){const N=this.workspaceContextService.getWorkspaceFolder(X)?.uri??X.with({path:S.dirname(X.fsPath)});let T=O.get(N);T||(H=!0,T={folder:N,includePattern:{}},E.push(T),O.set(N,T));const F=S.relative(N.fsPath,X.fsPath);(0,k.assertIsDefined)(T.includePattern)[F.replace(/\\/g,"/")]=!0}else X.fsPath&&(H=!0,$[X.fsPath]=!0)}),{folderQueries:E,includePattern:$,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(_,E){if(E.isSmartCase){if(_.isRegExp){if(L.containsUppercaseCharacter(_.pattern,!0))return!0}else if(L.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,I.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const E=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),$=(Array.isArray(_)?_:r(_)).map(U=>{const Z=this.pathService.resolvedUserHome;return Z?(0,A.untildify)(U,Z.scheme===P.Schemas.file?Z.fsPath:Z.path):U}),H=R.groupBy($,U=>E(U)?"searchPaths":"exprSegments"),X=(H.exprSegments||[]).map(U=>L.rtrim(U,"/")).map(U=>L.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),a(U))),V={},N=this.expandSearchPathPatterns(H.searchPaths||[]);N&&N.length&&(V.searchPaths=N);const T=o.flatten(X),F=s(...T);return F&&(V.pattern=F),V}getExcludesForFolder(_,E){return E.disregardExcludeSettings?void 0:(0,D.getExcludes)(_,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const E=_.flatMap($=>{let{pathPortion:H,globPortion:X}=n($);return X&&(X=g(X)),this.expandOneSearchPath(H).flatMap(N=>this.resolveOneSearchPathPattern(N,X))}),O=new Map;return E.forEach($=>{const H=$.searchPath.toString(),X=O.get(H);X?$.pattern&&(X.pattern=X.pattern||{},X.pattern[$.pattern]=!0):O.set(H,{searchPath:$.searchPath,pattern:$.pattern?s($.pattern):void 0})}),Array.from(O.values())}expandOneSearchPath(_){if(S.isAbsolute(_)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==P.Schemas.file?[{searchPath:E[0].uri.with({path:_})}]:[{searchPath:b.URI.file(S.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=c(_),_.startsWith("../")||_===".."){const $=S.posix.resolve(E.path,_);return[{searchPath:E.with({path:$})}]}const O=g(_);return[{searchPath:E,pattern:O}]}else{if(_==="./"||_===".\\")return[];{const E=_.replace(/^\.[\/\\]/,""),$=this.workspaceContextService.getWorkspace().folders.map(H=>{const X=E.match(new RegExp(`^${L.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return X?{match:X,folder:H}:null}).filter(k.isDefined);if($.length)return $.map(H=>{const X=H.match[1];return{searchPath:H.folder.uri,pattern:X&&g(X)}});{const H=_.match(/\.[\/\\](.+)[\/\\]?/),X=H?H[1]:_,V=y.localize(0,null,X);throw new Error(V)}}}}resolveOneSearchPathPattern(_,E){const O=_.pattern&&E?`${_.pattern}/${E}`:_.pattern||E,$=[{searchPath:_.searchPath,pattern:O}];return O&&!O.endsWith("**")&&$.push({searchPath:_.searchPath,pattern:O+"/**"}),$}getFolderQueryForSearchPath(_,E,O){const $=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(_.searchPath),E,O,!1);return $?{...$,includePattern:_.pattern}:null}getFolderQueryForRoot(_,E,O,$){let H;const X=b.URI.isUri(_)?_:_.uri;if(O.searchPaths){const U=O.searchPaths.filter(Z=>(0,C.isEqual)(Z.searchPath,X))[0];if(U&&!U.pattern)return null;U&&(H=U.pattern)}const V=this.configurationService.getValue({resource:X}),T={...this.getExcludesForFolder(V,E)||{},...H||{}},F=b.URI.isUri(_)?(0,C.basename)(_):_.name;return{folder:X,folderName:$?F:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!V.search.followSymlinks}}};p=je([Be(0,f.IConfigurationService),Be(1,u.IWorkspaceContextService),Be(2,m.IEditorGroupsService),Be(3,d.ILogService),Be(4,v.IPathService)],p),e.QueryBuilder=p;function n(h){const _=h.match(/[\*\{\}\(\)\[\]\?]/);if(_){const E=_.index,O=h.substr(0,E).match(/[/|\\][^/\\]*$/);if(O){let $=h.substr(0,O.index);return $.match(/[/\\]/)||($+="/"),{pathPortion:$,globPortion:h.substr((O.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((_,E)=>(_[E]=!0,_),Object.create(null)):void 0}function r(h){return l.splitGlobAware(h,",").map(_=>_.trim()).filter(_=>!!_.length)}function a(h){return[`**/${h}/**`,`**/${h}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(h){return h.replace(/\\/g,"/")}function g(h){return c(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(h){return h.replace(/([?*[\]])/g,"[$1]")}function t(h,_){h=o.distinct(h,$=>$.toString());const E=[],O=_.getWorkspace();return h&&h.forEach($=>{let H;if(_.getWorkbenchState()===2)H=(0,C.relativePath)(O.folders[0].uri,$),H&&H!=="."&&(H="./"+H);else{const X=_.getWorkspaceFolder($);if(X){const V=X.name;if(O.folders.filter(T=>T.name===V).length===1){const T=(0,C.relativePath)(X.uri,$);T===""?H=`./${X.name}`:H=`./${X.name}/${T}`}else H=$.fsPath}}H&&E.push(i(H))}),E}e.resolveResourcesForSearchIncludes=t}),define(Se[298],ye([1,0,24,2,21,10,4,297,31,47]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function k(f,d){const u=d.activationEvents;if(!u)return Promise.resolve(void 0);const m=[],v=[];for(const a of u)if(/^workspaceContains:/.test(a)){const c=a.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||f.forceUsingSearch?v.push(c):m.push(c)}if(m.length===0&&v.length===0)return Promise.resolve(void 0);let D;const p=new Promise((a,c)=>{D=a}),n=a=>D({activationEvent:a}),s=Promise.all(m.map(a=>b(f,a,n))).then(()=>{}),r=I(f,d.identifier,v,n);return Promise.all([s,r]).then(()=>{D(void 0)}),p}e.checkActivateWorkspaceContainsExtension=k;async function b(f,d,u){for(const m of f.folders)if(await f.exists(o.joinPath(R.URI.revive(m),d))){u(`workspaceContains:${d}`);return}}async function I(f,d,u,m){if(u.length===0)return Promise.resolve(void 0);const v=new l.CancellationTokenSource,D=f.checkExists(f.folders,u,v.token),p=setTimeout(async()=>{v.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},L);let n=!1;try{n=await D}catch(s){A.isCancellationError(s)||A.onUnexpectedError(s)}v.dispose(),clearTimeout(p),n&&m(`workspaceContains:${u.join(",")}`)}function y(f,d,u,m){const v=f.get(w.IInstantiationService),D=f.get(S.ISearchService),n=v.createInstance(P.QueryBuilder).file(d.map(s=>(0,C.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:u,exists:!0});return D.fileSearch(n,m).then(s=>!!s.limitHit,s=>A.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=y});var Je=this&&this.__classPrivateFieldSet||function(re,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ne=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Se[42],ye([1,0,178,12,84,24,19,6,68,2,13,5,36,240,99,35,26,134,10,27,22,222,7,128,4,25,80,20,91,55,41,3,298,98,224,15,97,43,11]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p,n,s,r,a,c,g,i,t,h,_,E,O,$,H,X,V,N){"use strict";var T,F,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Z=class Ni extends P.Disposable{constructor(K,Y,ee,me,be,De,Ae,ae,le,ue,ne){super(),this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Y,this._extHostContext=ee,this._initData=Ae,this._extHostWorkspace=me,this._extHostConfiguration=be,this._logService=De,this._extHostTunnelService=le,this._extHostTerminalService=ue,this._extHostLocalizationService=ne,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new w.Barrier,this._readyToStartExtensionHost=new w.Barrier,this._readyToRunExtensions=new w.Barrier,this._eagerExtensionsActivated=new w.Barrier,this._globalRegistry=new u.ExtensionDescriptionRegistry(this._initData.allExtensions);const ce=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new u.ExtensionDescriptionRegistry(Q(this._globalRegistry,ce)),this._storage=new y.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=ae,this._instaService=K.createChild(new i.ServiceCollection([y.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState])),this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(oe,M,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(oe,m.transformErrorForSerialization(M),B)},actualActivateExtension:async(oe,M)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(oe,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(oe,M),new I.HostExtension;const B=this._myRegistry.getExtensionDescription(oe);return this._activateExtension(B,M)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),l.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){m.onUnexpectedError(K)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(K)}terminate(K,Y=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${K}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),m.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const ee=this._deactivateAll();Promise.race([(0,w.timeout)(5e3),ee]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Y}`):this._logService.info(`Extension host exiting with code ${Y}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Y)})}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}async getExtension(K){const Y=await this._mainThreadExtensionsProxy.$getExtension(K);let ee;if(Y?.browserNlsBundleUris){ee={};for(const me of Object.keys(Y.browserNlsBundleUris))ee[me]=C.URI.revive(Y.browserNlsBundleUris[me])}return Y&&{...Y,identifier:new v.ExtensionIdentifier(Y.identifier.value),extensionLocation:C.URI.revive(Y.extensionLocation),browserNlsBundleUris:ee}}_activateByEvent(K,Y){return this._activator.activateByEvent(K,Y)}_activateById(K,Y){return this._activator.activateById(K,Y)}activateByIdWithErrors(K,Y){return this._activateById(K,Y).then(()=>{const ee=this._activator.getActivatedExtension(K);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._myRegistry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==H.Schemas.file)return K;const Y=await this._hostUtils.realpath(K.fsPath);return C.URI.file(Y)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(K=>new ie(K))),this._extensionPathIndex}async _createExtensionPathIndex(K){const Y=S.TernarySearchTree.forUris(ee=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ee));return await Promise.all(K.map(async ee=>{if(this._getEntryPoint(ee)){const me=await this._realPathExtensionUri(ee.extensionLocation);Y.set(me,ee)}})),Y}_deactivate(K){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return Y;const ee=this._activator.getActivatedExtension(K);if(!ee)return Y;try{typeof ee.module.deactivate=="function"&&(Y=Promise.resolve(ee.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${K.value}':`),this._logService.error(me)}try{(0,P.dispose)(ee.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this._logService.error(me)}return Y}async _activateExtension(K,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,Y).then(ee=>{const me=ee.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,Y),this._logExtensionActivationTimes(K,Y,"success",me),ee},ee=>{throw this._logExtensionActivationTimes(K,Y,"failure"),ee})}_logExtensionActivationTimes(K,Y,ee,me){const be=J(K,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...me||{},outcome:ee})}_doActivateExtension(K,Y){const ee=J(K,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ee);const me=this._getEntryPoint(K);if(!me)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${K.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this._logService.flush();const be=new I.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(K,(0,A.joinPath)(K.extensionLocation,me),be),this._loadExtensionContext(K)]).then(De=>(l.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),Ni._callActivate(this._logService,K.identifier,De[0],De[1],be))).then(De=>(l.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),De))}_loadExtensionContext(K){const Y=new p.ExtensionGlobalMemento(K,this._storage),ee=new p.ExtensionMemento(K.identifier.value,!1,this._storage),me=new $.ExtensionSecrets(K,this._secretState),be=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,De=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([Y.whenReady,ee.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let ae,le;const ue=(0,d.isProposedApiEnabled)(K,"ipc")?this._initData.messagePorts?.get(v.ExtensionIdentifier.toKey(K.identifier)):void 0;return Object.freeze({globalState:Y,workspaceState:ee,secrets:me,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(ne){return R.join(K.extensionLocation.fsPath,ne)},get storagePath(){return Ae._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(K).fsPath},get logPath(){return R.join(Ae._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return C.URI.joinPath(Ae._initData.logsLocation,K.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(K)},get globalStorageUri(){return Ae._storagePath.globalValue(K)},get extensionMode(){return be},get extension(){return ae===void 0&&(ae=new z(Ae,K.identifier,K,De,!1)),ae},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(K,"extensionRuntime"),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!le){if(!ue)return;const ne=_.Event.buffer(_.Event.fromDOMEventEmitter(ue,"message",ce=>ce.data));ue.start(),le={onDidReceiveMessage:ne,postMessage:ue.postMessage.bind(ue)}}return le}})})}static _callActivate(K,Y,ee,me,be){return ee=ee||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,Y,ee,me,be).then(De=>new I.ActivatedExtension(!1,null,be.build(),ee,De,me.subscriptions))}static _callActivateOptional(K,Y,ee,me,be){if(typeof ee.activate=="function")try{be.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const De=typeof global=="object"?global:self,Ae=ee.activate.apply(De,[me]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Ae).then(ae=>(be.activateResolveStop(),ae))}catch(De){return Promise.reject(De)}else return Promise.resolve(ee)}_activateOneStartupFinished(K,Y){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:Y}).then(void 0,ee=>{this._logService.error(ee)})}_activateAllStartupFinishedDeferred(K,Y=0){const me=Date.now();(0,N.setTimeout0)(()=>{for(let be=Y;be<K.length;be+=1){const De=K[be];for(const Ae of De.activationEvents??[])if(Ae==="onStartupFinished")if(Date.now()-me>50){this._activateAllStartupFinishedDeferred(K,be);break}else this._activateOneStartupFinished(De,Ae)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(l.getMarks()),this._extHostConfiguration.getConfigProvider().then(K=>{const Y=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ee=this._myRegistry.getAllExtensionDescriptions();if(Y)this._activateAllStartupFinishedDeferred(ee);else for(const me of ee)if(me.activationEvents)for(const be of me.activationEvents)be==="onStartupFinished"&&this._activateOneStartupFinished(me,be)})}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ee=this._handleWorkspaceContainsEagerExtensions(Y),me=Promise.all([K,ee]).then(()=>{});return Promise.race([me,(0,w.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),me}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(K,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,Y){if(this.isActivated(Y.identifier))return;const ee=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:K.map(De=>De.uri),forceUsingSearch:ee,exists:De=>this._hostUtils.exists(De.fsPath),checkExists:(De,Ae,ae)=>this._mainThreadWorkspaceProxy.$checkExists(De,Ae,ae)},be=await(0,E.checkActivateWorkspaceContainsExtension)(me,Y);if(!!be)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:be.activationEvent}).then(void 0,De=>this._logService.error(De))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:Y}=this._initData.environment;if(!K||!Y)throw new Error(o.localize(0,null));const ee=await this._loadCommonJSModule(null,Y,new I.ExtensionActivationTimesBuilder(!1));if(!ee||typeof ee.run!="function")throw new Error(o.localize(1,null,Y.toString()));return new Promise((me,be)=>{const De=(le,ue)=>{le?be(le):me(typeof ue=="number"&&ue>0?1:0)},Ae=(0,A.originalFSPath)(Y),ae=ee.run(Ae,De);ae&&ae.then&&ae.then(()=>{me(0)}).catch(le=>{be(le instanceof Error&&le.stack?le.stack:String(le))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,Y){return this._resolvers[K]=Y,(0,P.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const Y=K.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ee=K.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this._resolvers[ee]}}async $resolveAuthority(K,Y){const ee=V.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(K)},${Y})][${ee.elapsed()}ms] `,be=ue=>this._logService.info(`${me()}${ue}`),De=(ue,ne=void 0)=>this._logService.error(`${me()}${ue}`,ne);be("activating resolver...");const{authorityPrefix:Ae,resolver:ae}=await this._activateAndGetResolver(K);if(!ae)return De("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ae}.`,detail:void 0}};const le=new w.IntervalTimer;try{be("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(ae)),le.cancelAndSet(()=>be("waiting..."),1e3),be("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${Ae}`);const ue=await ae.resolve(K,{resolveAttempt:Y});l.mark(`code/extHost/didResolveAuthorityOK/${Ae}`),le.dispose(),be(`returned ${ue.host}:${ue.port}`);const ne={authority:K,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ce={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:ce,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(l.mark(`code/extHost/didResolveAuthorityError/${Ae}`),le.dispose(),De("returned an error",ue),ue instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(K,Y){this._logService.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(K)})`);const{resolver:ee}=await this._activateAndGetResolver(K);if(!ee)return null;const me=C.URI.revive(Y);if(typeof ee.getCanonicalURI>"u")return me;const be=await(0,w.asPromise)(()=>ee.getCanonicalURI(me));return be||me}static _applyExtensionsDelta(K,Y,ee){const me=new u.ExtensionDescriptionRegistry(K.getAllExtensionDescriptions());me.deltaExtensions(ee.toAdd,ee.toRemove);const be=(0,d.extensionIdentifiersArrayToSet)(Y.getAllExtensionDescriptions().map(Ae=>Ae.identifier));for(const Ae of ee.myToRemove)be.delete(v.ExtensionIdentifier.toKey(Ae));for(const Ae of ee.myToAdd)be.add(v.ExtensionIdentifier.toKey(Ae));const De=Q(me,be);return{globalRegistry:me,myExtensions:De}}$startExtensionHost(K){K.toAdd.forEach(me=>me.extensionLocation=C.URI.revive(me.extensionLocation));const{globalRegistry:Y,myExtensions:ee}=Ni._applyExtensionsDelta(this._globalRegistry,this._myRegistry,K);return this._globalRegistry.set(Y.getAllExtensionDescriptions()),this._myRegistry.set(ee),this._startExtensionHost()}$activateByEvent(K,Y){return Y===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(ee=>this._activateByEvent(K,!1))}async $activate(K,Y){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(K)?(await this._activateById(K,Y),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(De=>De.extensionLocation=C.URI.revive(De.extensionLocation));const{globalRegistry:Y,myExtensions:ee}=Ni._applyExtensionsDelta(this._globalRegistry,this._myRegistry,K),me=await this._createExtensionPathIndex(ee);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(Y.getAllExtensionDescriptions()),this._myRegistry.set(ee),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const Y=D.VSBuffer.alloc(K),ee=Math.random()%256;for(let me=0;me<K;me++)Y.writeUInt8(ee,me);return Y}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};Z=je([Be(0,r.IInstantiationService),Be(1,e.IHostUtils),Be(2,g.IExtHostRpcService),Be(3,f.IExtHostWorkspace),Be(4,b.IExtHostConfiguration),Be(5,L.ILogService),Be(6,a.IExtHostInitDataService),Be(7,c.IExtensionStoragePaths),Be(8,t.IExtHostTunnelService),Be(9,h.IExtHostTerminalService),Be(10,X.IExtHostLocalizationService)],Z),e.AbstractExtHostExtensionService=Z;function J(ge,K){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class z{constructor(K,Y,ee,me,be){T.set(this,void 0),F.set(this,void 0),U.set(this,void 0),Je(this,T,K,"f"),Je(this,F,Y,"f"),Je(this,U,ee.identifier,"f"),this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=R.normalize((0,A.originalFSPath)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=me,this.isFromDifferentExtensionHost=be}get isActive(){return Ne(this,T,"f").isActivated(Ne(this,U,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,T,"f").getExtensionExports(Ne(this,U,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,T,"f").activateByIdWithErrors(Ne(this,U,"f"),{startup:!1,extensionId:Ne(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=z,T=new WeakMap,F=new WeakMap,U=new WeakMap;function Q(ge,K){return ge.getAllExtensionDescriptions().filter(Y=>K.has(v.ExtensionIdentifier.toKey(Y.identifier)))}class ie{constructor(K){this._searchTree=K}setSearchTree(K){this._searchTree=K}findSubstr(K){return this._searchTree.findSubstr(K)}forEach(K){return this._searchTree.forEach(K)}}e.ExtensionPaths=ie}),define(Se[299],ye([1,0,84,2,5,36,26,27,20,25,4,42,33,13,8]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(p,n,s,r,a,c,g){this._apiFactory=p,this._extensionRegistry=n,this._instaService=s,this._extHostConfiguration=r,this._extHostExtensionService=a,this._initData=c,this._logService=g,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,n,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(m,n)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,n,this._initData.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const n of p.nodeModuleName)this._factories.set(n,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(n=>p.alternativeModuleName(n))}};f=je([Be(2,L.IInstantiationService),Be(3,A.IExtHostConfiguration),Be(4,k.IExtHostExtensionService),Be(5,C.IExtHostInitDataService),Be(6,I.ILogService)],f),e.RequireInterceptor=f;let d=class rn{constructor(p){if(p.environment.appRoot&&rn.aliased.size){const n=(0,y.escapeRegExpCharacters)(this.forceForwardSlashes(p.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(p));if(!n)return;const[,s,r,a]=n,c=rn.aliased.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),s+c+a}forceForwardSlashes(p){return p.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=je([Be(0,C.IExtHostInitDataService)],d);class u{constructor(p,n,s,r,a){this._apiFactory=p,this._extensionPaths=n,this._extensionRegistry=s,this._configProvider=r,this._logService=a,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,n){const s=this._extensionPaths.findSubstr(n);if(s){let r=this._extApiImpl.get(P.ExtensionIdentifier.toKey(s.identifier));return r||(r=this._apiFactory(s,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(s.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((a,c)=>r+=`	${c} -> ${a.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(w.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let m=class{constructor(p,n,s){this._extensionPaths=p,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=s,a=n.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let c=r.appRoot.fsPath;b.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${c}/node_modules.asar/keytar`),this.alternativeNames.add(`${c}/node_modules/keytar`)}this._impl={getPassword:(c,g)=>a.$getPassword(c,g),setPassword:(c,g,i)=>a.$setPassword(c,g,i),deletePassword:(c,g)=>a.$deletePassword(c,g),findPassword:c=>a.$findPassword(c),findCredentials(c){return a.$findCredentials(c)}}}load(p,n){const s=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(p){const n=p.length;if(n<=7||!this.alternativeNames)return;const s=n-7;if((p.charAt(s)==="/"||p.charAt(s)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}};m=je([Be(1,S.IExtHostRpcService),Be(2,C.IExtHostInitDataService)],m);let v=class{constructor(p,n,s){this._extensionPaths=p,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=s.getProxy(l.MainContext.MainThreadTelemetry);const r=s.getProxy(l.MainContext.MainThreadWindow);this._impl=(a,c)=>{const g=R.URI.parse(a);return c?this.callOriginal(a,c):g.scheme==="http"||g.scheme==="https"?r.$openUri(g,a,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this._appUriScheme?r.$openUri(g,a,{}):this.callOriginal(a,c)}}load(p,n,s){const r=this._extensionPaths.findSubstr(n);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=s(p),this._impl}callOriginal(p,n){return this.sendNoForwardTelemetry(),this._original(p,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([Be(2,S.IExtHostRpcService)],v)}),define(Se[49],ye([1,0,65,6,12,33,4,59,60,42,7,35,236,36]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,w.createDecorator)("IExtHostVariableResolverProvider");class y extends b.AbstractVariableResolverService{constructor(u,m,v,D,p,n,s){function r(){if(v){const a=v.activeEditor();if(a)return a.document.uri;const c=D.tabGroups.all.find(g=>g.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof L.TextDiffTabInput||c.input instanceof L.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof L.TextTabInput||c.input instanceof L.NotebookEditorTabInput||c.input instanceof L.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:a=>{const c=n.folders.filter(g=>g.name===a);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(a,c)=>p.getConfiguration(void 0,a).get(c),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return l.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const a=r();if(a){const c=m.getWorkspaceFolder(a);if(c)return l.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(v){const a=v.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(v){const a=v.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>u.getExtension(a)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(A.env))}}let f=class extends R.Disposable{constructor(u,m,v,D,p){super(),this.extensionService=u,this.workspaceService=m,this.editorService=v,this.configurationService=D,this.editorTabs=p,this._resolver=new o.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async a=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new y(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};f=je([Be(0,C.IExtHostExtensionService),Be(1,k.IExtHostWorkspace),Be(2,P.IExtHostDocumentsAndEditors),Be(3,I.IExtHostConfiguration),Be(4,S.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(Se[85],ye([1,0,19,3,9,2,4,5,60,42,20,7,35,131,229,36,49]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,a,c,g,i,t){this._workspaceService=a,this._extensionService=c,this._configurationService=g,this._editorTabs=i,this._variableResolver=t,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=r.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(_=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}asDebugSourceUri(r,a){const c=r;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let g=`debug:${encodeURIComponent(c.path||"")}`,i="?";return a&&(g+=`${i}session=${encodeURIComponent(a.id)}`,i="&"),g+=`${i}ref=${c.sourceReference}`,A.URI.parse(g)}else{if(c.path)return A.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const a=[];for(const c of r.getAllExtensionDescriptions())if(c.contributes){const g=c.contributes.debuggers;if(g&&g.length>0)for(const i of g)(0,y.isDebuggerMainContribution)(i)&&a.push(i.type)}this._debugServiceProxy.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(a=>r.push(a)),r}addBreakpoints(r){this.startBreakpoints();const a=r.filter(i=>{const t=i.id;return this._breakpoints.has(t)?!1:(this._breakpoints.set(t,i),!0)});this.fireBreakpointChanges(a,[],[]);const c=[],g=new Map;for(const i of a)if(i instanceof k.SourceBreakpoint){let t=g.get(i.location.uri.toString());t||(t={type:"sourceMulti",uri:i.location.uri,lines:[]},g.set(i.location.uri.toString(),t),c.push(t)),t.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof k.FunctionBreakpoint&&c.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this._debugServiceProxy.$registerBreakpoints(c)}removeBreakpoints(r){this.startBreakpoints();const a=r.filter(t=>this._breakpoints.delete(t.id));this.fireBreakpointChanges([],a,[]);const c=a.filter(t=>t instanceof k.SourceBreakpoint).map(t=>t.id),g=a.filter(t=>t instanceof k.FunctionBreakpoint).map(t=>t.id),i=a.filter(t=>t instanceof k.DataBreakpoint).map(t=>t.id);return this._debugServiceProxy.$unregisterBreakpoints(c,g,i)}startDebugging(r,a,c){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,a,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,c){if(!a)return new k.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:g,provider:a}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,c,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,g),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(i=>i.provider!==a),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(r,a,c){if(!c)return new k.Disposable(()=>{});if(!this.definesDebugType(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.getAdapterDescriptorFactoryByType(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:a,handle:g,factory:c}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(a,g),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(i=>i.factory!==c),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new k.Disposable(()=>{});const c=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:c,factory:a}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let c;const g=await this.getFolder(r);return g&&(c={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(c,a)}createDebugAdapter(r,a){if(r.type==="implementation")return new p(r.implementation)}createSignService(){}async $startDASession(r,a){const c=this,g=await this.getSession(a);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const t=this.convertToDto(i),h=this.createDebugAdapter(t,g);if(!h)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const _=h;return this._debugAdapters.set(r,_),this.getDebugAdapterTrackers(g).then(E=>(E&&this._debugAdaptersTrackers.set(r,E),_.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const $=O,H={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const X=await this._signService.sign($.arguments.value);H.body={signature:X},_.sendResponse(H)}else throw new Error("no signer")}catch(X){H.success=!1,H.message=X.message,_.sendResponse(H)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(O),O=(0,y.convertToVSCPaths)(O,!0),c._debugServiceProxy.$acceptDAMessage(r,O)}),_.onError(O=>{E&&E.onError&&E.onError(O),this._debugServiceProxy.$acceptDAError(r,O.name,O.message,O.stack)}),_.onExit(O=>{E&&E.onExit&&E.onExit((0,l.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,l.withNullAsUndefined)(O),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),_.startSession()))})}$sendDAMessage(r,a){a=(0,y.convertToDAPaths)(a,!1);const c=this._debugAdaptersTrackers.get(r);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(a),this._debugAdapters.get(r)?.sendMessage(a)}$stopDASession(r){const a=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const c=this._debugAdapters.get(r);return this._debugAdapters.delete(r),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],c=[],g=[];if(r.added)for(const i of r.added){const t=i.id;if(t&&!this._breakpoints.has(t)){let h;if(i.type==="function")h=new k.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")h=new k.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const _=A.URI.revive(i.uri);h=new k.SourceBreakpoint(new k.Location(_,new k.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,k.setBreakpointId)(h,t),this._breakpoints.set(t,h),a.push(h)}}if(r.removed)for(const i of r.removed){const t=this._breakpoints.get(i);t&&(this._breakpoints.delete(i),c.push(t))}if(r.changed){for(const i of r.changed)if(i.id){const t=this._breakpoints.get(i.id);if(t){if(t instanceof k.FunctionBreakpoint&&i.type==="function"){const h=t;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.functionName=i.functionName}else if(t instanceof k.SourceBreakpoint&&i.type==="source"){const h=t;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.location=new k.Location(A.URI.revive(i.uri),new k.Position(i.line,i.character))}g.push(t)}}}this.fireBreakpointChanges(a,c,g)}$provideDebugConfigurations(r,a,c){return(0,o.asPromise)(async()=>{const g=this.getConfigProviderByHandle(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.getFolder(a);return g.provideDebugConfigurations(i,c)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(r,a,c,g){return(0,o.asPromise)(async()=>{const i=this.getConfigProviderByHandle(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.getFolder(a);return i.resolveDebugConfiguration(t,c,g)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,c,g){return(0,o.asPromise)(async()=>{const i=this.getConfigProviderByHandle(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.getFolder(a);return i.resolveDebugConfigurationWithSubstitutedVariables(t,c,g)})}async $provideDebugAdapter(r,a){const c=this.getAdapterDescriptorFactoryByHandle(r);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(a);return this.getAdapterDescriptor(c,g).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(i)})}async $acceptDebugSessionStarted(r){const a=await this.getSession(r);this._onDidStartDebugSession.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.getSession(r);a&&(this._onDidTerminateDebugSession.fire(a),this._debugSessions.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,a){(await this.getSession(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const g={session:await this.getSession(r),event:a.event,body:a.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const a=this._adapterFactories.filter(c=>c.type===r);if(a.length>0)return a[0].factory}getAdapterDescriptorFactoryByHandle(r){const a=this._adapterFactories.filter(c=>c.handle===r);if(a.length>0)return a[0].factory}getConfigProviderByHandle(r){const a=this._configProviders.filter(c=>c.handle===r);if(a.length>0)return a[0].provider}definesDebugType(r,a){if(r.contributes){const c=r.contributes.debuggers;if(c&&c.length>0){for(const g of c)if(g.label&&g.type&&g.type===a)return!0}}return!1}getDebugAdapterTrackers(r){const c=r.configuration.type,g=this._trackerFactories.filter(i=>i.type===c||i.type==="*").map(i=>(0,o.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(t=>t,t=>null));return Promise.race([Promise.all(g).then(i=>{const t=i.filter(h=>!!h);if(t.length>0)return new D(t)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async getAdapterDescriptor(r,a){const c=a.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new k.DebugAdapterServer(c));if(r){const i=await this._extensionService.getExtensionRegistry();return(0,o.asPromise)(()=>r.createDebugAdapterDescriptor(a,this.daExecutableFromPackage(a,i))).then(t=>{if(t)return t})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(a,g))}daExecutableFromPackage(r,a){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,a,c){(r.length>0||a.length>0||c.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:a,changed:c}))}async getSession(r){if(r)if(typeof r=="string"){const a=this._debugSessions.get(r);if(a)return a}else{let a=this._debugSessions.get(r.id);if(!a){const c=await this.getFolder(r.folderUri),g=r.parent?this._debugSessions.get(r.parent):void 0;a=new m(this._debugServiceProxy,r.id,r.type,r.name,c,r.configuration,g),this._debugSessions.set(a.id,a),this._debugServiceProxy.$sessionCached(a.id)}return a}throw new Error("cannot find session")}getFolder(r){if(r){const a=A.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};u=je([Be(0,L.IExtHostRpcService),Be(1,b.IExtHostWorkspace),Be(2,C.IExtHostExtensionService),Be(3,f.IExtHostConfiguration),Be(4,S.IExtHostEditorTabs),Be(5,d.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class m{constructor(r,a,c,g,i,t,h){this._debugServiceProxy=r,this._id=a,this._type=c,this._name=g,this._workspaceFolder=i,this._configuration=t,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,a){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,a)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=m;class v{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=v;class D{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.trackers.forEach(c=>c.onExit?c.onExit(r,a):void 0)}}class p extends I.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends u{constructor(r,a,c,g,i,t){super(r,a,c,g,i,t)}};n=je([Be(0,L.IExtHostRpcService),Be(1,b.IExtHostWorkspace),Be(2,C.IExtHostExtensionService),Be(3,f.IExtHostConfiguration),Be(4,S.IExtHostEditorTabs),Be(5,d.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(Se[300],ye([1,0,10,84,2,5,292,13,90,91,25,205,20,56,42,77]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(v){const D=v.get(P.ILogService),n=v.get(b.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{D.error(s);const r=o.transformErrorForSerialization(s);n.$onUnexpectedError(r)})}static async installFullHandler(v){const D=v.get(P.ILogService),p=v.get(b.IExtHostRpcService),n=v.get(y.IExtHostExtensionService),s=v.get(f.IExtHostTelemetry),r=p.getProxy(A.MainContext.MainThreadExtensionService),a=p.getProxy(A.MainContext.MainThreadErrors),c=await n.getExtensionPathIndex(),g=new WeakMap;Error.prepareStackTrace=(i,t)=>{let h="",_,E;for(const O of t)h+=`
	at ${O.toString()}`,E=O.getFileName(),!_&&E&&(_=c.findSubstr(l.URI.file(E)));return g.set(i,_?.identifier),`${i.name||"Error"}: ${i.message||""}${h}`},o.setUnexpectedErrorHandler(i=>{D.error(i);const t=o.transformErrorForSerialization(i),h=g.get(i);if(!h){a.$onUnexpectedError(t);return}r.$onExtensionRuntimeError(h,t);const _=s.onExtensionError(h,i);D.trace("forwarded error to extension?",_,h)})}}Error.stackTraceLimit=100;class u{constructor(v,D,p,n,s){this._hostUtils=p,this._rpcProtocol=new w.RPCProtocol(v,null,n),D=u._transform(D,this._rpcProtocol);const r=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:s}),r.set(b.IExtHostRpcService,new b.ExtHostRpcService(this._rpcProtocol)),r.set(I.IURITransformerService,new I.URITransformerService(n)),r.set(y.IHostUtils,p);const a=new k.InstantiationService(r,!0);a.invokeFunction(d.installEarlyHandler),this._logService=a.invokeFunction(c=>c.get(P.ILogService)),R.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=a.invokeFunction(c=>c.get(y.IExtHostExtensionService)),this._extensionService.initialize(),a.invokeFunction(d.installFullHandler)}async asBrowserUri(v){const D=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return l.URI.revive(await D.$asBrowserUri(v))}terminate(v){this._extensionService.terminate(v)}static _transform(v,D){v.allExtensions.forEach(n=>{n.extensionLocation=l.URI.revive(D.transformIncomingURIs(n.extensionLocation));const s={};n.browserNlsBundleUris&&(Object.keys(n.browserNlsBundleUris).forEach(r=>s[r]=l.URI.revive(D.transformIncomingURIs(n.browserNlsBundleUris[r]))),n.browserNlsBundleUris=s)}),v.environment.appRoot=l.URI.revive(D.transformIncomingURIs(v.environment.appRoot));const p=v.environment.extensionDevelopmentLocationURI;return p&&(v.environment.extensionDevelopmentLocationURI=p.map(n=>l.URI.revive(D.transformIncomingURIs(n)))),v.environment.extensionTestsLocationURI=l.URI.revive(D.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=l.URI.revive(D.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=l.URI.revive(D.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=l.URI.revive(D.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=l.URI.revive(D.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=l.URI.revive(D.transformIncomingURIs(v.logsLocation)),v.logFile=l.URI.revive(D.transformIncomingURIs(v.logFile)),v.workspace=D.transformIncomingURIs(v.workspace),v}}e.ExtensionHostMain=u}),define(Se[301],ye([1,0,19,11,185,204,212,85,60,42,20,41,7,49,35,230,232,36]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let m=class extends P.ExtHostDebugServiceBase{constructor(s,r,a,c,g,i,t){super(s,r,a,c,i,t),this._terminalService=g,this._integratedTerminalInstances=new p}createDebugAdapter(s,r){switch(s.type){case"server":return new f.SocketDebugAdapter(s);case"pipeServer":return new f.NamedPipeDebugAdapter(s);case"executable":return new f.ExecutableDebugAdapter(s,r.type)}return super.createDebugAdapter(s,r)}daExecutableFromPackage(s,r){const a=f.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),s.type);if(a)return new b.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new w.SignService}async $runInTerminal(s,r){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(X=>{this._integratedTerminalInstances.onTerminalClosed(X)}));const a=await this._configurationService.getConfigProvider(),c=this._terminalService.getDefaultShell(!0),g=this._terminalService.getDefaultShellArgs(!0),i=s.title||l.localize(0,null),t=JSON.stringify({shell:c,shellArgs:g});let h=await this._integratedTerminalInstances.checkout(t,i),_,E=!1;if(h)_=s.cwd;else{const X={shellPath:c,shellArgs:g,cwd:s.cwd,name:i,iconPath:new b.ThemeIcon("debug")};E=!0,h=this._terminalService.createTerminalFromOptions(X,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,t)}h.show(!0);const O=await h.processId;E?await new Promise(X=>setTimeout(X,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?h.sendText("cls"):c.indexOf("bash")>=0?h.sendText("clear"):R.isWindows?h.sendText("cls"):h.sendText("clear"));const $=(0,d.prepareCommand)(c,s.args,!!s.argsCanBeInterpretedByShell,_,s.env);h.sendText($);const H=this.onDidTerminateDebugSession(X=>{X.id===r&&(this._integratedTerminalInstances.free(h),H.dispose())});return O}else if(s.kind==="external")return D(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,r)}};m=je([Be(0,L.IExtHostRpcService),Be(1,y.IExtHostWorkspace),Be(2,C.IExtHostExtensionService),Be(3,u.IExtHostConfiguration),Be(4,k.IExtHostTerminalService),Be(5,S.IExtHostEditorTabs),Be(6,I.IExtHostVariableResolverProvider)],m),e.ExtHostDebugService=m;let v;function D(n,s){if(!v)if(R.isWindows)v=new A.WindowsExternalTerminalService;else if(R.isMacintosh)v=new A.MacExternalTerminalService;else if(R.isLinux)v=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=s.getConfiguration("terminal");return v.runInTerminal(n.title,n.cwd,n.args,n.env||{},r.external||{})}class p{constructor(){this._terminalInstances=new Map}async checkout(s,r){const c=[...this._terminalInstances.entries()].map(([g,i])=>(0,o.createCancelablePromise)(async t=>{if(g.name!==r||i.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await g.processId))return null;const h=Date.now();return i.lastUsedAt+p.minUseDelay>h||t.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=h,g)}));return await(0,o.firstParallel)(c,g=>!!g)}insert(s,r){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:r})}free(s){const r=this._terminalInstances.get(s);r&&(r.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}p.minUseDelay=1e3}),define(Se[302],ye([1,0,12,2,116,35,59,36,47,41,20,25,83,15,13,78,24,71,49]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let v=class extends b.ExtHostTaskBase{constructor(p,n,s,r,a,c,g,i,t){super(p,n,s,r,a,c,g,i),this.workspaceService=s,this.variableResolver=t,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,n){const s=n;if(!n.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const r=b.TaskHandleDTO.from(s,this.workspaceService),a=await this._proxy.$getTaskExecution(r);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(a,n);return this._proxy.$executeTask(r).catch(()=>{}),c}else{const r=b.TaskDTO.from(n,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,n,!1);const a=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),n);return this._proxy.$executeTask(r).catch(()=>{}),a}}provideTasksInternal(p,n,s,r){const a=[];if(r)for(const c of r){this.checkDeprecation(c,s),(!c.definition||!p[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const g=b.TaskDTO.from(c,s.extension);g&&(a.push(g),b.CustomExecutionDTO.is(g.execution)&&n.push(this.addCustomExecution(g,c,!0)))}return{tasks:a,extension:s.extension}}async resolveTaskInternal(p){return p}async getAFolder(p){let n=p&&p.length>0?p[0]:void 0;if(!n){const s=R.URI.file((0,u.homedir)());n=new S.WorkspaceFolder({uri:s,name:d.basename(s),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,n){const s=R.URI.revive(p),r={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(s),c=await this._workspaceProvider.getWorkspaceFolders2()??[],g=await this.variableResolver.getResolver(),i=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(const t of n.variables)r.variables[t]=await g.resolveAsync(i,t);if(n.process!==void 0){let t;if(n.process.path!==void 0){t=n.process.path.split(o.delimiter);for(let h=0;h<t.length;h++)t[h]=await g.resolveAsync(i,t[h])}r.process=await l.win32.findExecutable(await g.resolveAsync(i,n.process.name),n.process.cwd!==void 0?await g.resolveAsync(i,n.process.cwd):void 0,t)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,n,s){return l.win32.findExecutable(p,n,s)}};v=je([Be(0,L.IExtHostRpcService),Be(1,k.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,w.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,y.ILogService),Be(7,f.IExtHostApiDeprecationService),Be(8,m.IExtHostVariableResolverProvider)],v),e.ExtHostTask=v}),define(Se[303],ye([1,0,71,49]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends R.ExtHostVariableResolverProviderService{homeDir(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(Se[143],ye([1,0,16,19,21,45,15,12,24,2,31]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(m,v,D,p){this.query=m,this.provider=v,this.fileUtils=D,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,v){const D=this.query.folderQueries||[],p=new l.CancellationTokenSource;return v.onCancellationRequested(()=>p.cancel()),new Promise((n,s)=>{this.collector=new I(m);let r=!1;const a=(c,g)=>{if(!r&&!this.isLimitHit){const i=this.resultSize(c);f(c)&&typeof this.query.maxResults=="number"&&this.resultCount+i>this.query.maxResults&&(this.isLimitHit=!0,r=!0,p.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const t=this.resultSize(c);this.resultCount+=t,(t>0||!f(c))&&this.collector.add(c,g)}};Promise.all(D.map((c,g)=>this.searchInFolder(c,i=>a(i,g),p.token))).then(c=>{p.dispose(),this.collector.flush();const g=c.some(i=>!!i&&!!i.limitHit);n({limitHit:this.isLimitHit||g,messages:(0,o.flatten)(c.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.processType}})},c=>{p.dispose();const g=(0,A.toErrorMessage)(c);s(new Error(g))})})}resultSize(m){return f(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,v){const D=Array.isArray(m.ranges)?m.ranges:[m.ranges],p=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:D.slice(0,v),preview:{matches:p.slice(0,v),text:m.preview.text},uri:m.uri}}async searchInFolder(m,v,D){const p=new L.QueryGlobTester(this.query,m),n=[],s={report:c=>{if(!this.validateProviderResult(c))return;const g=m.folder.scheme===w.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(c.uri))):void 0,i=S.relativePath(m.folder,c.uri);if(i){const t=p.includedInQuery(i,P.basename(i),g);(0,R.isThenable)(t)?n.push(t.then(h=>{h&&v(c)})):t&&v(c)}}},r=this.getSearchOptionsForFolder(m),a=await this.provider.provideTextSearchResults(b(this.query.contentPattern),r,s,D);return n.length&&await Promise.all(n),a}validateProviderResult(m){if(f(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const v=(0,L.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),D=(0,L.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),p={folder:C.URI.from(m.folder),excludes:D,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=k;function b(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class I{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,v=>this.sendItems(v))}add(m,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!S.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(y(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=I;function y(u){return f(u)?{preview:{matches:(0,o.mapArrayOrNot)(u.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:u.preview.text},ranges:(0,o.mapArrayOrNot)(u.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function f(u){return!!u.preview}e.extensionResultIsMatch=f;class d{constructor(m,v){this.maxBatchSize=m,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,v){!m||this.addItemToBatch(m,v)}addItems(m,v){!m||this.addItemsToBatch(m,v)}addItemToBatch(m,v){this.batch.push(m),this.batchSize+=v,this.onUpdate()}addItemsToBatch(m,v){this.batch=this.batch.concat(m),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}d.TIMEOUT=4e3,d.START_BATCH_AFTER_COUNT=50,e.BatchedCollector=d}),define(Se[86],ye([1,0,6,5,4,296,20,56,13,2,143]),function(re,e,o,R,l,A,w,P,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let k=class{constructor(f,d,u){this.extHostRpc=f,this._uriTransformer=d,this._logService=u,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const u=this._handlePool++;return this._textSearchProvider.set(u,d),this._proxy.$registerTextSearchProvider(u,this._transformScheme(f)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}registerFileSearchProvider(f,d){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const u=this._handlePool++;return this._fileSearchProvider.set(u,d),this._proxy.$registerFileSearchProvider(u,this._transformScheme(f)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(f,d,u,m){const v=b(u),D=this._fileSearchProvider.get(f);if(D)return this._fileSearchManager.fileSearch(v,D,p=>{this._proxy.$handleFileMatch(f,d,p.map(n=>n.resource))},m);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,u,m){const v=this._textSearchProvider.get(f);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const D=b(u);return this.createTextSearchManager(D,v).search(n=>this._proxy.$handleTextMatch(f,d,n),m)}$enableExtensionHostSearch(){}createTextSearchManager(f,d){return new L.TextSearchManager(f,d,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};k=je([Be(0,w.IExtHostRpcService),Be(1,P.IURITransformerService),Be(2,S.ILogService)],k),e.ExtHostSearch=k;function b(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(I),extraFileResources:y.extraFileResources&&y.extraFileResources.map(f=>C.URI.revive(f))}}e.reviveQuery=b;function I(y){return{...y,folder:C.URI.revive(y.folder)}}}),define(Se[304],ye([1,0,90,142,35,139,36,40,59,41,83,85,86,99,55,78,141,79,48,98,77,60,140,13,221,49,97]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p,n,s,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,n.ExtHostLoggerService,1),(0,o.registerSingleton)(s.ILogService,r.ExtHostLogService,1),(0,o.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,o.registerSingleton)(w.IExtHostConfiguration,w.ExtHostConfiguration,0),(0,o.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,o.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,o.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,o.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch,0),(0,o.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,0),(0,o.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,o.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(y.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,o.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,o.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,o.registerSingleton)(v.IExtHostSecretState,v.ExtHostSecretState,0),(0,o.registerSingleton)(D.IExtHostTelemetry,D.ExtHostTelemetry,0),(0,o.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,o.registerSingleton)(a.IExtHostVariableResolverProvider,a.ExtHostVariableResolverProviderService,0)}),define(Se[100],ye([1,0,16,13,31,82]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function w(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=w;function P(k,b,I,y){const f=(0,o.mapArrayOrNot)(I,S),d=new l.TextSearchMatch(b,f,y),u=d.preview.matches;return{ranges:(0,o.mapArrayOrNot)(f,C),uri:k,preview:{text:d.preview.text,matches:(0,o.mapArrayOrNot)(u,C)}}}e.createTextSearchResult=P;function S(k){return new l.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function C(k){return new A.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let L=class{constructor(b,I){this.prefix=b,this.logService=I}appendLine(b){this.logService.debug(`${this.prefix}#search`,b)}};L=je([Be(1,R.ILogService)],L),e.OutputChannel=L}),define(Se[305],ye([1,0,46,12,87,34,11,8,100,306]),function(re,e,o,R,l,A,w,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(v,D,p,n){const s=b(v,D,p,n),r=D.folder.fsPath;return{cmd:o.spawn(L,s.args,{cwd:r}),rgDiskPath:L,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=k;function b(v,D,p,n){const s=["--files","--hidden","--case-sensitive"];y([D],p,!1).forEach(a=>{const c=(0,S.anchorGlob)(a);if(s.push("-g",c),w.isMacintosh){const g=(0,l.normalizeNFD)(c);g!==c&&s.push("-g",g)}});const r=I([D],n,void 0,!1);return r.globArgs.forEach(a=>{const c=`!${(0,S.anchorGlob)(a)}`;if(s.push("-g",c),w.isMacintosh){const g=(0,l.normalizeNFD)(c);g!==c&&s.push("-g",g)}}),D.disregardIgnoreFiles!==!1?s.push("--no-ignore"):D.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),D.ignoreSymlinks||s.push("--follow"),v.exists&&s.push("--quiet"),s.push("--no-config"),D.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function I(v,D,p,n=!0){const s=[];let r={};return v.forEach(a=>{const c=Object.assign({},a.excludePattern||{},D||{}),g=f(c,n?a.folder.fsPath:void 0,p);s.push(...g.globArgs),g.siblingClauses&&(r=Object.assign(r,g.siblingClauses))}),{globArgs:s,siblingClauses:r}}function y(v,D,p=!0){const n=[];return v.forEach(s=>{const r=Object.assign({},D||{},s.includePattern||{}),a=f(r,p?s.folder.fsPath:void 0);n.push(...a.globArgs)}),n}function f(v,D,p){const n=[],s={};return Object.keys(v).forEach(r=>{if(p&&p.has(r)||!r)return;const a=v[r];r=u(D?d(D,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof a=="boolean"&&a?(r.startsWith("\\\\")&&(r+="**"),n.push(m(r))):a&&a.when&&(s[r]=a)}),{globArgs:n,siblingClauses:s}}function d(v,D){return R.isAbsolute(D)?D:R.join(v,D)}e.getAbsoluteGlob=d;function u(v){return v=P.rtrim(v,"\\"),P.rtrim(v,"/")}function m(v){return A.getRoot(v).toLowerCase()==="c:/"?v.replace(/^c:[/\\]/i,"/"):v}e.fixDriveC=m}),define(Se[307],ye([1,0,46,70,12,308,16,45,38,87,34,11,43,8,9,29,31,305,111]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const v=new Set;process.on("exit",()=>{v.forEach(r=>r())});class D{constructor(a){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=a,this.filePattern=a.filePattern||"",this.includePattern=a.includePattern&&S.parse(a.includePattern),this.maxResults=a.maxResults||null,this.exists=!!a.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,m.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=a.excludePattern&&S.parse(a.excludePattern),this.folderExcludePatterns=new Map,a.folderQueries.forEach(c=>{const g=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),i=c.folder.fsPath;a.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==i).forEach(t=>{(0,L.isEqualOrParent)(t,i)&&(g[l.relative(i,t)]=!0)}),this.folderExcludePatterns.set(i,new n(g,i))})}cancel(){this.isCanceled=!0,v.forEach(a=>a())}walk(a,c,g,i,t){if(this.fileWalkSW=b.StopWatch.create(!1),this.isCanceled)return t(null,this.isLimitHit);c.forEach(h=>{const _=l.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,_)||this.matchFile(g,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=b.StopWatch.create(!1),this.parallel(a,(h,_)=>{this.call(this.cmdTraversal,this,h,g,i,E=>{if(E){const O=(0,P.toErrorMessage)(E);console.error(O),this.errors.push(O),_(E,void 0)}else _(null,void 0)})},(h,_)=>{this.fileWalkSW.stop();const E=h?w.coalesce(h)[0]:null;t(E,this.isLimitHit)})}parallel(a,c,g){const i=new Array(a.length),t=new Array(a.length);let h=!1,_=0;if(a.length===0)return g(null,[]);a.forEach((E,O)=>{c(E,($,H)=>{if($?(h=!0,i[O]=null,t[O]=$):(i[O]=H,t[O]=null),++_===a.length)return g(h?t:null,i)})})}call(a,c,...g){try{a.apply(c,g)}catch(i){g[g.length-1](i)}}cmdTraversal(a,c,g,i){const t=a.folder.fsPath,h=k.isMacintosh,_=()=>X&&X.kill();v.add(_);let E=F=>{v.delete(_),E=()=>{},i(F)},O="";const $=this.initDirectoryTree(),H=(0,u.spawnRipgrepCmd)(this.config,a,this.config.includePattern,this.folderExcludePatterns.get(a.folder.fsPath).expression),X=H.cmd,V=!Object.keys(H.siblingClauses).length,N=H.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let T=`${H.rgDiskPath} ${N}
 - cwd: ${H.cwd}`;H.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(H.rgArgs.siblingClauses)}`),g({message:T}),this.cmdResultCount=0,this.collectStdout(X,"utf8",g,(F,U,Z)=>{if(F){E(F);return}if(this.isLimitHit){E();return}const z=(O+(h?C.normalizeNFC(U||""):U)).split(`
`);if(Z){const Q=z.length;z[Q-1]=z[Q-1].trim(),z[Q-1]||z.pop()}else O=z.pop()||"";if(z.length&&z[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=z.length,V){for(const Q of z)if(this.matchFile(c,{base:t,relativePath:Q,searchPath:this.getSearchPath(a,Q)}),this.isLimitHit){_();break}(Z||this.isLimitHit)&&E();return}this.addDirectoryEntries(a,$,t,z,c),Z&&(this.matchDirectoryTree($,t,c),E())})}spawnFindCmd(a){const c=this.folderExcludePatterns.get(a.folder.fsPath),g=c.getBasenameTerms(),i=c.getPathTerms(),t=["-L","."];if(g.length||i.length){t.push("-not","(","(");for(const h of g)t.push("-name",h),t.push("-o");for(const h of i)t.push("-path",h),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),o.spawn("find",t,{cwd:a.folder.fsPath})}readStdout(a,c,g){let i="";this.collectStdout(a,c,()=>{},(t,h,_)=>{if(t){g(t);return}i+=h,_&&g(null,i)})}collectStdout(a,c,g,i){let t=(E,O,$)=>{(E||$)&&(t=()=>{},this.cmdSW?.stop()),i(E,O,$)},h=!1;a.stdout?(this.forwardData(a.stdout,c,t),a.stdout.once("data",()=>h=!0)):g({message:"stdout is null"});let _;a.stderr?_=this.collectData(a.stderr):g({message:"stderr is null"}),a.on("error",E=>{t(E)}),a.on("close",E=>{let O;!h&&(O=this.decodeData(_,c))&&s(O)?t(new Error(`command failed with error code ${E}: ${this.decodeData(_,c)}`)):(this.exists&&E===0&&(this.isLimitHit=!0),t(null,"",!0))})}forwardData(a,c,g){const i=new A.StringDecoder(c);return a.on("data",t=>{g(null,i.write(t))}),i}collectData(a){const c=[];return a.on("data",g=>{c.push(g)}),c}decodeData(a,c){const g=new A.StringDecoder(c);return a.map(i=>g.write(i)).join("")}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries(a,{pathToEntries:c},g,i,t){i.indexOf(this.filePattern)!==-1&&this.matchFile(t,{base:g,relativePath:this.filePattern,searchPath:this.getSearchPath(a,this.filePattern)});const h=_=>{const E=l.basename(_),O=l.dirname(_);let $=c[O];$||($=c[O]=[],h(O)),$.push({base:g,relativePath:_,basename:E,searchPath:this.getSearchPath(a,_)})};i.forEach(h)}matchDirectoryTree({rootEntries:a,pathToEntries:c},g,i){const t=this,h=this.folderExcludePatterns.get(g),_=this.filePattern;function E(O){t.directoriesWalked++;const $=(0,d.hasSiblingFn)(()=>O.map(H=>H.basename));for(let H=0,X=O.length;H<X;H++){const V=O[H],{relativePath:N,basename:T}=V;if(h.test(N,T,_!==T?$:void 0))continue;const F=c[N];if(F)E(F);else{if(t.filesWalked++,N===_)continue;t.matchFile(i,V)}if(t.isLimitHit)break}}E(a)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(a,c,g,i,t){const h=a.folder,_=(0,d.hasSiblingFn)(()=>g);this.parallel(g,(E,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const $=c?[c,E].join(l.sep):E;if(this.folderExcludePatterns.get(a.folder.fsPath).test($,E,this.config.filePattern!==E?_:void 0))return O(null);const H=[h.fsPath,$].join(l.sep);R.lstat(H,(X,V)=>{if(X||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(H,V,(N,T)=>N||this.isCanceled||this.isLimitHit?O(null):T.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(H,V,(F,U)=>F||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?O(null):(this.walkedPaths[U]=!0,f.Promises.readdir(H).then(Z=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(a,$,Z,i,J=>O(J||null))},Z=>{O(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&y.isNumber(T.size)&&T.size>this.maxFilesize||this.matchFile(i,{base:h.fsPath,relativePath:$,searchPath:this.getSearchPath(a,$)}),O(null,void 0)))})},E=>{const O=E&&w.coalesce(E);return t(O&&O.length>0?O[0]:void 0)})}matchFile(a,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,l.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||a(c))}isFileMatch(a){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,d.isFilePatternMatch)(a,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(a,c,g){return c.isSymbolicLink()?R.stat(a,g):g(null,c)}realPathIfNeeded(a,c,g){return c.isSymbolicLink()?R.realpath(a,(i,t)=>i?g(i):g(null,t)):g(null,a)}getSearchPath(a,c){return a.folderName?l.join(a.folderName,c):c}}e.FileWalker=D;class p{constructor(a){this.folderQueries=a.folderQueries,this.extraFiles=a.extraFileResources||[],this.walker=new D(a)}search(a,c,g){this.walker.walk(this.folderQueries,this.extraFiles,a,c,(i,t)=>{g(i,{limitHit:t,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class n{constructor(a,c){this.expression=a,this.root=c,this.init(a)}init(a){let c,g;Object.keys(a).filter(i=>a[i]).forEach(i=>{l.isAbsolute(i)?(c=c||S.getEmptyExpression(),c[i]=a[i]):(g=g||S.getEmptyExpression(),g[i]=a[i])}),this.absoluteParsedExpr=c&&S.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=g&&S.parse(g,{trimForExclusions:!0})}test(a,c,g){return this.relativeParsedExpr&&this.relativeParsedExpr(a,c,g)||this.absoluteParsedExpr&&this.absoluteParsedExpr(l.join(this.root,a),c,g)}getBasenameTerms(){const a=[];return this.absoluteParsedExpr&&a.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&a.push(...S.getBasenameTerms(this.relativeParsedExpr)),a}getPathTerms(){const a=[];return this.absoluteParsedExpr&&a.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&a.push(...S.getPathTerms(this.relativeParsedExpr)),a}}function s(r){const a=r.trim().split(`
`),c=a[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return I.uppercaseFirstLetter(a[a.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Se[309],ye([1,0,103,22]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,w=512,P=512*8,S=512*128;var C;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(a,c){super(a),this.decodeStreamErrorKind=c}}e.DecodeStreamError=L;class k{static async create(a){let c;if(a!==e.UTF8)c=(await new Promise((i,t)=>{re(["@vscode/iconv-lite-umd"],i,t)})).getDecoder(f(a));else{const g=new TextDecoder;c={write(i){return g.decode(i,{stream:!0})},end(){return g.decode()}}}return new k(c)}constructor(a){this.iconvLiteDecoder=a}write(a){return this.iconvLiteDecoder.write(a)}end(){return this.iconvLiteDecoder.end()}}function b(r,a){const c=a.minBytesRequiredForDetection??a.guessEncoding?P:w;return new Promise((g,i)=>{const t=(0,o.newWriteableStream)(H=>H.join("")),h=[];let _=0,E;const O=async()=>{try{const H=await s({buffer:R.VSBuffer.concat(h),bytesRead:_},a.guessEncoding);if(H.seemsBinary&&a.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);H.encoding=await a.overwriteEncoding(H.encoding),E=await k.create(H.encoding);const X=E.write(R.VSBuffer.concat(h).buffer);t.write(X),h.length=0,_=0,g({stream:t,detected:H})}catch(H){$?.dispose(),t.destroy(),i(H)}},$=(0,o.listenStream)(r,{onData:async H=>{E?t.write(E.write(H.buffer)):(h.push(H),_+=H.byteLength,_>=c&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:H=>t.error(H),onEnd:async()=>{E||await O(),t.end(E?.end())}})})}e.toDecodeStream=b;async function I(r,a,c){const i=(await new Promise((_,E)=>{re(["@vscode/iconv-lite-umd"],_,E)})).getEncoder(f(a),c);let t=!1,h=!1;return{read(){if(h)return null;const _=r.read();if(typeof _!="string"){if(h=!0,!t&&c?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=i.end();return E&&E.length>0?(t=!0,R.VSBuffer.wrap(E)):null}return t=!0,R.VSBuffer.wrap(i.write(_))}}}e.toEncodeReadable=I;async function y(r){return(await new Promise((c,g)=>{re(["@vscode/iconv-lite-umd"],c,g)})).encodingExists(f(r))}e.encodingExists=y;function f(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=f;function d(r,a){if(!r||a<e.UTF16be_BOM.length)return null;const c=r.readUInt8(0),g=r.readUInt8(1);if(c===e.UTF16be_BOM[0]&&g===e.UTF16be_BOM[1])return e.UTF16be;if(c===e.UTF16le_BOM[0]&&g===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const i=r.readUInt8(2);return c===e.UTF8_BOM[0]&&g===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const u=["ascii","utf-16","utf-32"];async function m(r){const a=await new Promise((h,_)=>{re(["jschardet"],h,_)}),c=r.slice(0,S),g=p(c.buffer),i=a.detect(g);if(!i||!i.encoding)return null;const t=i.encoding.toLowerCase();return 0<=u.indexOf(t)?null:D(i.encoding)}const v={ibm866:"cp866",big5:"cp950"};function D(r){const a=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[a]||a}function p(r){let a="";for(let c=0;c<r.length;c++)a+=String.fromCharCode(r[c]);return a}function n(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=r.match(/windows(\d+)/);return a?"windows-"+a[1]:r}}}e.toCanonicalName=n;function s({buffer:r,bytesRead:a},c){let g=d(r,a),i=!1;if(g!==e.UTF16be&&g!==e.UTF16le&&r){let t=!0,h=!0,_=!1;for(let E=0;E<a&&E<A;E++){const O=E%2===1,$=r.readUInt8(E)===0;if($&&(_=!0),t&&(O&&!$||!O&&$)&&(t=!1),h&&(O&&$||!O&&!$)&&(h=!1),$&&!t&&!h)break}_&&(t?g=e.UTF16le:h?g=e.UTF16be:i=!0)}return c&&!i&&!g&&r?m(r.slice(0,a)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:i,encoding:g}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[144],ye([1,0,309,29,143]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends l.TextSearchManager{constructor(P,S,C=R,L="searchProcess"){super(P,S,{readdir:k=>C.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,o.toCanonicalName)(k)},L)}}e.NativeTextSearchManager=A}),define(Se[310],ye([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(l){if(l&&this._dragOperations.has(l)){const A=this._dragOperations.get(l);return this._dragOperations.delete(l),A}}addDragOperationTransfer(l,A){this._dragOperations.set(l,A)}getRenderedTreeElement(l){if(this._renderedElements.has(l))return this._renderedElements.get(l)}addRenderedTreeItemElement(l,A){this._renderedElements.set(l,A)}removeRenderedTreeItemElement(l){this._renderedElements.has(l)&&this._renderedElements.delete(l)}}e.TreeviewsService=o}),define(Se[311],ye([1,0,183,7,24,2,3,6,227,19,7,9,16,14,21,310,26]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(D,p){if((0,k.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let n;return Array.isArray(D.highlights)&&(n=D.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:D.label,highlights:n}}}class m{constructor(p,n,s){this._proxy=p,this.commands=n,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:a=>r(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(c=>r(c)?this.convertArgument(c):c):a})}registerTreeDataProvider(p,n,s){const r=this.createTreeView(p,{treeDataProvider:n},s);return{dispose:()=>r.dispose()}}createTreeView(p,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=n.dragAndDropController?.dropMimeTypes??[],a=n.dragAndDropController?.dragMimeTypes??[],c=!!n.dragAndDropController?.handleDrag,g=!!n.dragAndDropController?.handleDrop,i=this.createExtHostTreeView(p,n,s),t=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:c,hasHandleDrop:g});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(s,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(h){i.message=h},get title(){return i.title},set title(h){i.title=h},get description(){return i.description},set description(h){i.description=h},get badge(){return i.badge},set badge(h){h!==void 0&&L.ViewBadge.isViewBadge(h)?i.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(i.badge=void 0)},reveal:(h,_)=>i.reveal(h,_),dispose:async()=>{await t,this.treeViews.delete(p),i.dispose()}}}$getChildren(p,n){const s=this.treeViews.get(p);return s?s.getChildren(n):Promise.reject(new S.NoTreeViewError(p))}async $handleDrop(p,n,s,r,a,c,g,i){const t=this.treeViews.get(p);if(!t)return Promise.reject(new S.NoTreeViewError(p));const h=I.DataTransfer.toDataTransfer(s,async _=>(await this._proxy.$resolveDropFileData(p,n,_)).buffer);return g===p&&i&&await this.addAdditionalTransferItems(h,t,i,a,c),t.onDrop(h,r,a)}async addAdditionalTransferItems(p,n,s,r,a){const c=this.treeDragAndDropService.removeDragOperationTransfer(a);if(c)(await c)?.forEach((g,i)=>{g&&p.set(i,g)});else if(a&&n.handleDrag){const g=n.handleDrag(s,p,r);this.treeDragAndDropService.addDragOperationTransfer(a,g),await g}return p}async $handleDrag(p,n,s,r){const a=this.treeViews.get(p);if(!a)return Promise.reject(new S.NoTreeViewError(p));const c=await this.addAdditionalTransferItems(new R.DataTransfer,a,n,r,s);if(!!c)return I.DataTransfer.toDataTransferDTO(c)}async $hasResolve(p){const n=this.treeViews.get(p);if(!n)throw new S.NoTreeViewError(p);return n.hasResolve}$resolve(p,n,s){const r=this.treeViews.get(p);if(!r)throw new S.NoTreeViewError(p);return r.resolveTreeItem(n,s)}$setExpanded(p,n,s){const r=this.treeViews.get(p);if(!r)throw new S.NoTreeViewError(p);r.setExpanded(n,s)}$setSelection(p,n){const s=this.treeViews.get(p);if(!s)throw new S.NoTreeViewError(p);s.setSelection(n)}$setFocus(p,n){const s=this.treeViews.get(p);if(!s)throw new S.NoTreeViewError(p);s.setFocus(n)}$setVisible(p,n){const s=this.treeViews.get(p);if(!s)throw new S.NoTreeViewError(p);s.setVisible(n)}$changeCheckboxState(p,n){const s=this.treeViews.get(p);if(!s)throw new S.NoTreeViewError(p);s.setCheckboxState(n)}createExtHostTreeView(p,n,s){const r=new v(p,n,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(p,r),r}convertArgument(p){const n=this.treeViews.get(p.$treeViewId);return n&&"$treeItemHandle"in p?n.getExtensionElement(p.$treeItemHandle):n&&"$focusedTreeItem"in p&&p.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=m;class v extends P.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,k.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,n,s,r,a,c){if(super(),this.viewId=p,this.proxy=s,this.commands=r,this.logService=a,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new w.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new w.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new w.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new w.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new w.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new w.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new y.CancellationTokenSource,c.contributes&&c.contributes.views)for(const t in c.contributes.views)for(const h of c.contributes.views[t])h.id===p&&(this._title=h.name);this.dataProvider=n.treeDataProvider,this.dndController=n.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let g,i;this._register(w.Event.debounce(this._onDidChangeData.event,(t,h)=>(t||(t={message:!1,elements:[]}),h.element!==!1&&(g||(g=new Promise(_=>i=_),this.refreshPromise=this.refreshPromise.then(()=>g)),Array.isArray(h.element)?t.elements.push(...h.element):t.elements.push(h.element)),h.message&&(t.message=!0),t),200,!0)(({message:t,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const _=i;return g=null,this.refresh(h).then(()=>_())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(p){const n=p?this.getExtensionElement(p):void 0;if(p&&!n)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(p);return s||(s=await this.fetchChildrenNodes(n)),s?s.map(r=>r.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,n){n=n||{select:!0,focus:!1};const s=(0,k.isUndefinedOrNull)(n.select)?!0:n.select,r=(0,k.isUndefinedOrNull)(n.focus)?!1:n.focus,a=(0,k.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(c=>this.resolveTreeNode(p,c[c.length-1]).then(g=>this.proxy.$reveal(this.viewId,{item:g.item,parentChain:c.map(i=>i.item)},{select:s,focus:r,expand:a})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:r,expand:a})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=I.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,n){const s=this.getExtensionElement(p);s&&(n?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(p){(0,b.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this._focusedHandle=p}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const n=(await Promise.all(p.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:s.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,n,s){const r=[];for(const a of p){const c=this.getExtensionElement(a);c&&r.push(c)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,n,s),n}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,n,s){const r=n?this.getExtensionElement(n):void 0;if(!(!r&&n||!this.dndController?.handleDrop))return(0,C.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,p,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,n){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(p);if(s){const r=this.nodes.get(s);if(r){const a=await this.dataProvider.resolveTreeItem(r.extensionItem,s,n)??r.extensionItem;return this.validateTreeItem(a),r.item.tooltip=this.getTooltip(a.tooltip),r.item.command=this.getCommand(r.disposableStore,a.command),r.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(n=>n?this.resolveUnknownParentChain(n).then(s=>this.resolveTreeNode(n,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}resolveParent(p){const n=this.nodes.get(p);return n?Promise.resolve(n.parent?this.elements.get(n.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,n){const s=this.nodes.get(p);return s?Promise.resolve(s):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(r=>this.createHandle(p,r,n,!0)).then(r=>this.getChildren(n?n.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const c=this.nodes.get(a);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(p){if(p){let n;if(typeof p=="string"){const s=this.getExtensionElement(p);n=s?this.nodes.get(s):void 0}else n=p;return n&&n.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const n=new y.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=p?this.nodes.get(p):void 0,r=await this.dataProvider.getChildren(p);if(n.token.isCancellationRequested)return;const a=await Promise.all((0,b.coalesce)(r||[]).map(async c=>{const g=await this.dataProvider.getTreeItem(c);return g&&!n.token.isCancellationRequested?this.createAndRegisterTreeNode(c,g,s):null}));return n.token.isCancellationRequested?void 0:(0,b.coalesce)(a)}finally{n.dispose()}}refresh(p){if(p.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new y.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(p);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const n=new Set,s=p.map(a=>this.nodes.get(a));for(const a of s)if(a&&!n.has(a.item.handle)){let c=a;for(;c&&c.parent&&s.findIndex(g=>c&&c.parent&&g&&g.item.handle===c.parent.item.handle)===-1;){const g=this.elements.get(c.parent.item.handle);c=g?this.nodes.get(g):void 0}c&&!c.parent&&n.add(a.item.handle)}const r=[];return n.forEach(a=>{const c=this.elements.get(a);if(c){const g=this.nodes.get(c);g&&(!g.parent||!n.has(g.parent.item.handle))&&r.push(a)}}),r}refreshHandles(p){const n={};return Promise.all(p.map(s=>this.refreshNode(s).then(r=>{r&&(n[s]=r.item)}))).then(()=>Object.keys(n).length?this.proxy.$refresh(this.viewId,n):void 0)}refreshNode(p){const n=this.getExtensionElement(p);if(n){const s=this.nodes.get(n);if(s)return this.clearChildren(n),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(n)).then(r=>{if(r){const a=this.createTreeNode(n,r,s.parent);return this.updateNodeCache(n,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,n,s){const r=this.createTreeNode(p,n,s);if(n.id&&this.elements.has(r.item.handle))throw new Error((0,o.localize)(0,null,n.id));return this.addNodeToCache(p,r),this.addNodeToParentCache(r,s),r}getTooltip(p){return L.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}getCommand(p,n){return n?{...this.commands.toInternal(n,p),originalId:n.command}:void 0}getCheckbox(p){if(!p.checkboxState)return;let n,s;return typeof p.checkboxState=="number"?n=p.checkboxState:(n=p.checkboxState.state,s=p.checkboxState.tooltip),{isChecked:n===L.TreeItemCheckboxState.Checked,tooltip:s}}validateTreeItem(p){if(!L.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,n,s){this.validateTreeItem(n);const r=new P.DisposableStore,a=this.createHandle(p,n,s),c=this.getLightIconPath(n);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:u(n.label,this.extension),description:n.description,resourceUri:n.resourceUri,tooltip:this.getTooltip(n.tooltip),command:this.getCommand(r,n.command),contextValue:n.contextValue,icon:c,iconDark:this.getDarkIconPath(n)||c,themeIcon:this.getThemeIcon(n),collapsibleState:(0,k.isUndefinedOrNull)(n.collapsibleState)?L.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.getCheckbox(n)},extensionItem:n,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(p){return p.iconPath instanceof L.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:n,label:s,resourceUri:r},a,c){if(n)return`${v.ID_HANDLE_PREFIX}/${n}`;const g=u(s,this.extension),i=a?a.item.handle:v.LABEL_HANDLE_PREFIX;let t=g?g.label:r?(0,l.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const h=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,_=this.getChildrenNodes(a)||[];let E,O=0;do{if(E=`${i}/${O}:${t}`,c||!this.elements.has(E)||h===E)break;O++}while(O<=_.length);return E}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon))return typeof p.iconPath=="string"||A.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return A.URI.isUri(p)?p:A.URI.file(p)}addNodeToCache(p,n){this.elements.set(n.item.handle,p),this.nodes.set(p,n)}updateNodeCache(p,n,s,r){this.elements.delete(n.item.handle),this.nodes.delete(p),n.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(p,n);const a=this.getChildrenNodes(r)||[],c=a.filter(g=>g.item.handle===s.item.handle)[0];c&&a.splice(a.indexOf(c),1,n)}addNodeToParentCache(p,n){n?(n.children||(n.children=[]),n.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const n=this.nodes.get(p);if(n){if(n.children)for(const s of n.children){const r=this.elements.get(s.item.handle);r&&this.clear(r)}n.children=void 0}}else this.clearAll()}clear(p){const n=this.nodes.get(p);if(n){if(n.children)for(const s of n.children){const r=this.elements.get(s.item.handle);r&&this.clear(r)}this.nodes.delete(p),this.elements.delete(n.item.handle),n.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Se[312],ye([1,0,21,10,3,37,2,121,107,153,164,44,5,96,254,253,40,255,36,257,258,259,242,260,59,42,261,262,265,266,267,142,245,273,274,275,99,41,277,311,14,7,74,280,81,141,35,234,264,73,139,83,85,86,13,56,20,25,268,241,55,78,251,278,80,79,283,281,282,252,48,276,279,98,60,77,269,82,270,15,125,244,223,263,6,26,228,97,219,271,272]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D,p,n,s,r,a,c,g,i,t,h,_,E,O,$,H,X,V,N,T,F,U,Z,J,z,Q,ie,ge,K,Y,ee,me,be,De,Ae,ae,le,ue,ne,ce,oe,M,B,q,te,de,Ee,Te,ve,Ce,Ie,ze,qe,nt,Xe,tt,rt,Ue,it,x,G,he,Re,Oe,Ve,$e,Ze,st,at,mt,gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function wt(lt){const pt=lt.get(ue.IExtHostInitDataService),jt=lt.get(Ie.IExtHostFileSystemInfo),$t=lt.get(de.IExtHostConsumerFileSystem),It=lt.get(a.IExtHostExtensionService),ft=lt.get(ie.IExtHostWorkspace),kt=lt.get(tt.IExtHostTelemetry),Ut=lt.get(m.IExtHostConfiguration),Pt=lt.get(ae.IURITransformerService),Ke=lt.get(le.IExtHostRpcService),Ot=lt.get(X.IExtHostStorage),qt=lt.get(te.IExtensionStoragePaths),Ft=lt.get(Ae.ILoggerService),vt=lt.get(Ae.ILogService),Pe=lt.get(oe.IExtHostTunnelService),Le=lt.get(M.IExtHostApiDeprecationService),_e=lt.get(Q.IExtHostWindow),se=lt.get(nt.IExtHostSecretState),Fe=lt.get(Xe.IExtHostEditorTabs);Ke.set(b.ExtHostContext.ExtHostFileSystemInfo,jt),Ke.set(b.ExtHostContext.ExtHostLogLevelServiceShape,Ft),Ke.set(b.ExtHostContext.ExtHostWorkspace,ft),Ke.set(b.ExtHostContext.ExtHostConfiguration,Ut),Ke.set(b.ExtHostContext.ExtHostExtensionService,It),Ke.set(b.ExtHostContext.ExtHostStorage,Ot),Ke.set(b.ExtHostContext.ExtHostTunnelService,Pe),Ke.set(b.ExtHostContext.ExtHostWindow,_e),Ke.set(b.ExtHostContext.ExtHostSecretState,se),Ke.set(b.ExtHostContext.ExtHostTelemetry,kt),Ke.set(b.ExtHostContext.ExtHostEditorTabs,Fe);const We=Ke.set(b.ExtHostContext.ExtHostDecorations,lt.get(ee.IExtHostDecorations)),Qe=Ke.set(b.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),He=Ke.set(b.ExtHostContext.ExtHostCommands,lt.get(d.IExtHostCommands)),et=Ke.set(b.ExtHostContext.ExtHostTerminalService,lt.get(V.IExtHostTerminalService)),ut=Ke.set(b.ExtHostContext.ExtHostDebugService,lt.get(be.IExtHostDebugService)),Tt=Ke.set(b.ExtHostContext.ExtHostSearch,lt.get(De.IExtHostSearch)),_t=Ke.set(b.ExtHostContext.ExtHostTask,lt.get(me.IExtHostTask)),yt=Ke.set(b.ExtHostContext.ExtHostOutputService,lt.get(_.IExtHostOutputService)),Et=Ke.set(b.ExtHostContext.ExtHostLocalization,lt.get(st.IExtHostLocalizationService)),At=Ke.set(b.ExtHostContext.ExtHostUrls,new J.ExtHostUrls(Ke)),St=Ke.set(b.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Ke,Qe)),ri=Ke.set(b.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,Qe,vt)),ei=Ke.set(b.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(vt,St,Ke.getProxy(b.MainContext.MainThreadBulkEdits))),Ct=Ke.set(b.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(Ke,He,Qe,St)),si=Ke.set(b.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(Ct)),oi=Ke.set(b.ExtHostContext.ExtHostNotebookEditors,new he.ExtHostNotebookEditors(vt,Ct)),Yt=Ke.set(b.ExtHostContext.ExtHostNotebookKernels,new rt.ExtHostNotebookKernels(Ke,pt,Ct,He,vt)),vi=Ke.set(b.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(Ke,Ct)),Rt=Ke.set(b.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ke,Qe)),Bt=Ke.set(b.ExtHostContext.ExtHostTreeViews,new T.ExtHostTreeViews(Ke.getProxy(b.MainContext.MainThreadTreeViews),He,vt)),bi=Ke.set(b.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Ke.getProxy(b.MainContext.MainThreadEditorInsets),Rt,pt.remote)),ai=Ke.set(b.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Ke,vt,jt,Qe)),Jt=Ke.set(b.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Ke,St,He.converter,Pt)),dt=Ke.set(b.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ke,Pt,St,He,ai,vt,Le,kt)),Ui=Ke.set(b.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ke,dt)),Nt=Ke.set(b.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(Ke,vt,Qe)),Kt=Ke.set(b.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Ke,ft,He)),ci=Ke.set(b.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(Ke,He,vt)),Ei=Ke.set(b.ExtHostContext.ExtHostQuickDiff,new gt.ExtHostQuickDiff(Ke,Pt)),wi=Ke.set(b.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ke,He,St)),li=Ke.set(b.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Ke.getProxy(b.MainContext.MainThreadProgress))),_i=Ke.set(b.ExtHostContext.ExtHosLabelService,new K.ExtHostLabelService(Ke)),ui=Ke.set(b.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ke)),Zt=Ke.set(b.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ke)),xi=Ke.set(b.ExtHostContext.ExtHostTimeline,new q.ExtHostTimeline(Ke,He)),ti=Ke.set(b.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(Ke,pt.remote,ft,vt,Le)),ii=Ke.set(b.ExtHostContext.ExtHostWebviewPanels,new ve.ExtHostWebviewPanels(Ke,ti,ft)),Si=Ke.set(b.ExtHostContext.ExtHostCustomEditors,new Te.ExtHostCustomEditors(Ke,St,qt,ti,ii)),yi=Ke.set(b.ExtHostContext.ExtHostWebviewViews,new Ee.ExtHostWebviewViews(Ke,ti)),ni=Ke.set(b.ExtHostContext.ExtHostTesting,new ze.ExtHostTesting(Ke,He,Qe)),Ci=Ke.set(b.ExtHostContext.ExtHostUriOpeners,new qe.ExtHostUriOpeners(Ke)),Di=Ke.set(b.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Ke));Ke.set(b.ExtHostContext.ExtHostInteractive,new Oe.ExtHostInteractive(Ke,Ct,Qe,He,vt));const Bi=Object.values(b.ExtHostContext);Ke.assertRegistered(Bi);const Wi=new Ce.ExtHostBulkEdits(Ke,Qe),zi=new f.ExtHostClipboard(Ke),Ii=new h.ExtHostMessageService(Ke,vt),Ai=new D.ExtHostDialogs(Ke),Ri=new H.ExtHostStatusBar(Ke,He.converter);return y.ExtHostApiCommands.register(He),function(xe,Wt,Li){const bt=function(){let pe=!xe.isUnderDevelopment;function we(){pe||(vt.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")we();else{const Dt=ot;typeof Dt.scheme>"u"&&we(),typeof Dt.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return ot}}(),$i={getSession(pe,we,Me){return Zt.getSession(xe,pe,we,Me)},async hasSession(pe,we){return(0,$e.checkProposedApiEnabled)(xe,"authSession"),!!await Zt.getSession(xe,pe,we,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(pe,we,Me,ot){return Zt.registerAuthenticationProvider(pe,we,Me,ot)}},di={registerCommand(pe,we,Me){return He.registerCommand(!0,pe,we,Me,void 0,xe)},registerTextEditorCommand(pe,we,Me){return He.registerCommand(!0,pe,(...ot)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){vt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return Dt.edit(Lt=>{we.apply(Me,[Dt,Lt,...ot])}).then(Lt=>{Lt||vt.warn("Edits from command "+pe+" were not applied.")},Lt=>{vt.warn("An error occurred while running command "+pe,Lt)})},void 0,void 0,xe)},registerDiffInformationCommand:(pe,we,Me)=>((0,$e.checkProposedApiEnabled)(xe,"diffCommand"),He.registerCommand(!0,pe,async(...ot)=>{const Dt=Qe.activeEditor(!0);if(!Dt){vt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Lt=await Rt.getDiffInformation(Dt.id);we.apply(Me,[Lt,...ot])},void 0,void 0,xe)),executeCommand(pe,...we){return He.executeCommand(pe,...we)},getCommands(pe=!1){return He.getCommands(pe)}},Oi={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return et.getDefaultShell(!1)},get onDidChangeShell(){return(0,$e.checkProposedApiEnabled)(xe,"envShellEvent"),et.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(xe,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(xe,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe){return tt.ExtHostTelemetryLogger.validateSender(pe),kt.instantiateLogger(xe,pe)},openExternal(pe,we){return _e.openUri(pe,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===pt.environment.appUriScheme)return At.createAppUri(pe);try{return await _e.asExternalUri(pe,{allowTunneling:!!pt.remote.authority})}catch(we){if((0,G.matchesScheme)(pe,x.Schemas.http)||(0,G.matchesScheme)(pe,x.Schemas.https))return pe;throw we}},get remoteName(){return(0,Y.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(xe,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return vt.onDidChangeLogLevel}};pt.environment.extensionTestsLocationURI||Object.freeze(Oi);const Hi={createTestController(pe,we,Me){return ni.createTestController(xe,pe,we,Me)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(xe,"testObserver"),ni.createTestObserver()},runTests(pe){return(0,$e.checkProposedApiEnabled)(xe,"testObserver"),ni.runTests(pe)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(xe,"testObserver"),ni.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(xe,"testObserver"),ni.results}},hi=pt.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Vi={getExtension(pe,we){(0,$e.isProposedApiEnabled)(xe,"extensionsAny")||(we=!1);const Me=Wt.mine.getExtensionDescription(pe);if(Me)return new a.Extension(It,xe.identifier,Me,hi,!1);if(we){const ot=Wt.all.getExtensionDescription(pe);if(ot)return new a.Extension(It,xe.identifier,ot,hi,!0)}},get all(){const pe=[];for(const we of Wt.mine.getAllExtensionDescriptions())pe.push(new a.Extension(It,xe.identifier,we,hi,!1));return pe},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(xe,"extensionsAny");const pe=new $e.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),we=[];for(const Me of Wt.all.getAllExtensionDescriptions()){const ot=!pe.has(Me.identifier);we.push(new a.Extension(It,xe.identifier,Me,hi,ot))}return we},get onDidChange(){return(0,$e.isProposedApiEnabled)(xe,"extensionsAny")?l.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},ki={createDiagnosticCollection(pe){return ai.createDiagnosticCollection(xe.identifier,pe)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:pe=>ai.getDiagnostics(pe),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(pe,we){return Jt.changeLanguage(pe.uri,we)},match(pe,we){const Me=St.getDocumentData(we.uri)?.notebook;return(0,L.score)(F.LanguageSelector.from(pe),we.uri,we.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(pe,we,Me){return dt.registerCodeActionProvider(xe,bt(pe),we,Me)},registerDocumentPasteEditProvider(pe,we,Me){return(0,$e.checkProposedApiEnabled)(xe,"documentPaste"),dt.registerDocumentPasteEditProvider(xe,bt(pe),we,Me)},registerCodeLensProvider(pe,we){return dt.registerCodeLensProvider(xe,bt(pe),we)},registerDefinitionProvider(pe,we){return dt.registerDefinitionProvider(xe,bt(pe),we)},registerDeclarationProvider(pe,we){return dt.registerDeclarationProvider(xe,bt(pe),we)},registerImplementationProvider(pe,we){return dt.registerImplementationProvider(xe,bt(pe),we)},registerTypeDefinitionProvider(pe,we){return dt.registerTypeDefinitionProvider(xe,bt(pe),we)},registerHoverProvider(pe,we){return dt.registerHoverProvider(xe,bt(pe),we,xe.identifier)},registerEvaluatableExpressionProvider(pe,we){return dt.registerEvaluatableExpressionProvider(xe,bt(pe),we,xe.identifier)},registerInlineValuesProvider(pe,we){return dt.registerInlineValuesProvider(xe,bt(pe),we,xe.identifier)},registerDocumentHighlightProvider(pe,we){return dt.registerDocumentHighlightProvider(xe,bt(pe),we)},registerLinkedEditingRangeProvider(pe,we){return dt.registerLinkedEditingRangeProvider(xe,bt(pe),we)},registerReferenceProvider(pe,we){return dt.registerReferenceProvider(xe,bt(pe),we)},registerRenameProvider(pe,we){return dt.registerRenameProvider(xe,bt(pe),we)},registerDocumentSymbolProvider(pe,we,Me){return dt.registerDocumentSymbolProvider(xe,bt(pe),we,Me)},registerWorkspaceSymbolProvider(pe){return dt.registerWorkspaceSymbolProvider(xe,pe)},registerDocumentFormattingEditProvider(pe,we){return dt.registerDocumentFormattingEditProvider(xe,bt(pe),we)},registerDocumentRangeFormattingEditProvider(pe,we){return dt.registerDocumentRangeFormattingEditProvider(xe,bt(pe),we)},registerOnTypeFormattingEditProvider(pe,we,Me,...ot){return dt.registerOnTypeFormattingEditProvider(xe,bt(pe),we,[Me].concat(ot))},registerDocumentSemanticTokensProvider(pe,we,Me){return dt.registerDocumentSemanticTokensProvider(xe,bt(pe),we,Me)},registerDocumentRangeSemanticTokensProvider(pe,we,Me){return dt.registerDocumentRangeSemanticTokensProvider(xe,bt(pe),we,Me)},registerSignatureHelpProvider(pe,we,Me,...ot){return typeof Me=="object"?dt.registerSignatureHelpProvider(xe,bt(pe),we,Me):dt.registerSignatureHelpProvider(xe,bt(pe),we,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(pe,we,...Me){return dt.registerCompletionItemProvider(xe,bt(pe),we,Me)},registerInlineCompletionItemProvider(pe,we){return we.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),we.handleDidPartiallyAcceptCompletionItem&&(0,$e.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(xe,bt(pe),we)},registerDocumentLinkProvider(pe,we){return dt.registerDocumentLinkProvider(xe,bt(pe),we)},registerColorProvider(pe,we){return dt.registerColorProvider(xe,bt(pe),we)},registerFoldingRangeProvider(pe,we){return dt.registerFoldingRangeProvider(xe,bt(pe),we)},registerSelectionRangeProvider(pe,we){return dt.registerSelectionRangeProvider(xe,pe,we)},registerCallHierarchyProvider(pe,we){return dt.registerCallHierarchyProvider(xe,pe,we)},registerTypeHierarchyProvider(pe,we){return dt.registerTypeHierarchyProvider(xe,pe,we)},setLanguageConfiguration:(pe,we)=>dt.setLanguageConfiguration(xe,pe,we),getTokenInformationAtPosition(pe,we){return(0,$e.checkProposedApiEnabled)(xe,"tokenInformation"),Jt.tokenAtPosition(pe,we)},registerInlayHintsProvider(pe,we){return dt.registerInlayHintsProvider(xe,pe,we)},createLanguageStatusItem(pe,we){return Jt.createLanguageStatusItem(xe,pe,we)},registerDocumentDropEditProvider(pe,we){return dt.registerDocumentOnDropEditProvider(xe,pe,we)}},ji={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return et.activeTerminal},get terminals(){return et.terminals},async showTextDocument(pe,we,Me){const ot=await(w.URI.isUri(pe)?Promise.resolve(Ht.openTextDocument(pe)):Promise.resolve(pe));return Rt.showTextDocument(ot,we,Me)},createTextEditorDecorationType(pe){return Rt.createTextEditorDecorationType(xe,pe)},onDidChangeActiveTextEditor(pe,we,Me){return Rt.onDidChangeActiveTextEditor(pe,we,Me)},onDidChangeVisibleTextEditors(pe,we,Me){return Rt.onDidChangeVisibleTextEditors(pe,we,Me)},onDidChangeTextEditorSelection(pe,we,Me){return Rt.onDidChangeTextEditorSelection(pe,we,Me)},onDidChangeTextEditorOptions(pe,we,Me){return Rt.onDidChangeTextEditorOptions(pe,we,Me)},onDidChangeTextEditorVisibleRanges(pe,we,Me){return Rt.onDidChangeTextEditorVisibleRanges(pe,we,Me)},onDidChangeTextEditorViewColumn(pe,we,Me){return Rt.onDidChangeTextEditorViewColumn(pe,we,Me)},onDidCloseTerminal(pe,we,Me){return et.onDidCloseTerminal(pe,we,Me)},onDidOpenTerminal(pe,we,Me){return et.onDidOpenTerminal(pe,we,Me)},onDidChangeActiveTerminal(pe,we,Me){return et.onDidChangeActiveTerminal(pe,we,Me)},onDidChangeTerminalDimensions(pe,we,Me){return(0,$e.checkProposedApiEnabled)(xe,"terminalDimensions"),et.onDidChangeTerminalDimensions(pe,we,Me)},onDidChangeTerminalState(pe,we,Me){return et.onDidChangeTerminalState(pe,we,Me)},onDidWriteTerminalData(pe,we,Me){return(0,$e.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),et.onDidWriteTerminalData(pe,we,Me)},get state(){return _e.state},onDidChangeWindowState(pe,we,Me){return _e.onDidChangeWindowState(pe,we,Me)},showInformationMessage(pe,...we){return Ii.showMessage(xe,A.default.Info,pe,we[0],we.slice(1))},showWarningMessage(pe,...we){return Ii.showMessage(xe,A.default.Warning,pe,we[0],we.slice(1))},showErrorMessage(pe,...we){return Ii.showMessage(xe,A.default.Error,pe,we[0],we.slice(1))},showQuickPick(pe,we,Me){return Kt.showQuickPick(xe,pe,we,Me)},showWorkspaceFolderPick(pe){return Kt.showWorkspaceFolderPick(pe)},showInputBox(pe,we){return Kt.showInput(pe,we)},showOpenDialog(pe){return Ai.showOpenDialog(xe,pe)},showSaveDialog(pe){return Ai.showSaveDialog(pe)},createStatusBarItem(pe,we,Me){let ot,Dt,Lt;return typeof pe=="string"?(ot=pe,Dt=we,Lt=Me):(Dt=pe,Lt=we),Ri.createStatusBarEntry(xe,ot,Dt,Lt)},setStatusBarMessage(pe,we){return Ri.setStatusBarMessage(pe,we)},withScmProgress(pe){return Le.report("window.withScmProgress",xe,"Use 'withProgress' instead."),li.withProgress(xe,{location:U.ProgressLocation.SourceControl},(we,Me)=>pe({report(ot){}}))},withProgress(pe,we){return li.withProgress(xe,pe,we)},createOutputChannel(pe,we){return yt.createOutputChannel(pe,we,xe)},createWebviewPanel(pe,we,Me,ot){return ii.createWebviewPanel(xe,pe,we,Me,ot)},createWebviewTextEditorInset(pe,we,Me,ot){return(0,$e.checkProposedApiEnabled)(xe,"editorInsets"),bi.createWebviewEditorInset(pe,we,Me,ot,xe)},createTerminal(pe,we,Me){return typeof pe=="object"?"pty"in pe?et.createExtensionTerminal(pe):et.createTerminalFromOptions(pe):et.createTerminal(pe,we,Me)},registerTerminalLinkProvider(pe){return et.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,we){return et.registerProfileProvider(xe,pe,we)},registerTerminalQuickFixProvider(pe,we){return(0,$e.checkProposedApiEnabled)(xe,"terminalQuickFixProvider"),et.registerTerminalQuickFixProvider(pe,xe.identifier.value,we)},registerTreeDataProvider(pe,we){return Bt.registerTreeDataProvider(pe,we,xe)},createTreeView(pe,we){return Bt.createTreeView(pe,we,xe)},registerWebviewPanelSerializer:(pe,we)=>ii.registerWebviewPanelSerializer(xe,pe,we),registerCustomEditorProvider:(pe,we,Me={})=>Si.registerCustomEditorProvider(xe,pe,we,Me),registerFileDecorationProvider(pe){return We.registerFileDecorationProvider(pe,xe)},registerUriHandler(pe){return At.registerUriHandler(xe.identifier,pe)},createQuickPick(){return Kt.createQuickPick(xe)},createInputBox(){return Kt.createInputBox(xe)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(pe,we,Me){return ui.onDidChangeActiveColorTheme(pe,we,Me)},registerWebviewViewProvider(pe,we,Me){return yi.registerWebviewViewProvider(xe,pe,we,Me?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,we,Me){return Ct.onDidChangeActiveNotebookEditor(pe,we,Me)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,we,Me){return oi.onDidChangeNotebookEditorSelection(pe,we,Me)},onDidChangeNotebookEditorVisibleRanges(pe,we,Me){return oi.onDidChangeNotebookEditorVisibleRanges(pe,we,Me)},showNotebookDocument(pe,we){return Ct.showNotebookDocument(pe,we)},registerExternalUriOpener(pe,we,Me){return(0,$e.checkProposedApiEnabled)(xe,"externalUriOpener"),Ci.registerExternalUriOpener(xe.identifier,pe,we,Me)},registerProfileContentHandler(pe,we){return(0,$e.checkProposedApiEnabled)(xe,"profileContentHandlers"),Di.registrProfileContentHandler(xe,pe,we)},registerQuickDiffProvider(pe,we,Me,ot){return(0,$e.checkProposedApiEnabled)(xe,"quickDiffProvider"),Ei.registerQuickDiffProvider(bt(pe),we,Me,ot)},get tabGroups(){return Fe.tabGroups}},Ht={get rootPath(){return Le.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(pe){throw R.readonly()},getWorkspaceFolder(pe){return ft.getWorkspaceFolder(pe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(pe){throw R.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(pe){throw R.readonly()},updateWorkspaceFolders:(pe,we,...Me)=>ft.updateWorkspaceFolders(xe,pe,we||0,...Me),onDidChangeWorkspaceFolders:function(pe,we,Me){return ft.onDidChangeWorkspace(pe,we,Me)},asRelativePath:(pe,we)=>ft.getRelativePath(pe,we),findFiles:(pe,we,Me,ot)=>ft.findFiles(pe,we,Me,xe.identifier,ot),findTextInFiles:(pe,we,Me,ot)=>{(0,$e.checkProposedApiEnabled)(xe,"findTextInFiles");let Dt,Lt;return typeof we=="object"?(Dt=we,Lt=Me):(Dt={},Lt=we,ot=Me),ft.findTextInFiles(pe,Dt||{},Lt,xe.identifier,ot)},saveAll:pe=>ft.saveAll(pe),applyEdit(pe,we){return Wi.applyWorkspaceEdit(pe,xe,we)},createFileSystemWatcher:(pe,we,Me,ot)=>Nt.createFileSystemWatcher(ft,xe,pe,we,Me,ot),get textDocuments(){return St.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw R.readonly()},openTextDocument(pe){let we;const Me=pe;if(typeof pe=="string")we=Promise.resolve(w.URI.file(pe));else if(w.URI.isUri(pe))we=Promise.resolve(pe);else if(!Me||typeof Me=="object")we=St.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ot=>St.ensureDocumentData(ot).then(Dt=>Dt.document))},onDidOpenTextDocument:(pe,we,Me)=>St.onDidAddDocument(pe,we,Me),onDidCloseTextDocument:(pe,we,Me)=>St.onDidRemoveDocument(pe,we,Me),onDidChangeTextDocument:(pe,we,Me)=>St.onDidChangeDocument(pe,we,Me),onDidSaveTextDocument:(pe,we,Me)=>St.onDidSaveDocument(pe,we,Me),onWillSaveTextDocument:(pe,we,Me)=>ei.getOnWillSaveTextDocumentEvent(xe)(pe,we,Me),get notebookDocuments(){return Ct.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,we){let Me;if(w.URI.isUri(pe))Me=pe,await Ct.openNotebookDocument(pe);else if(typeof pe=="string")Me=w.URI.revive(await Ct.createNotebookDocument({viewType:pe,content:we}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(pe,we,Me){return si.onDidSaveNotebookDocument(pe,we,Me)},onDidChangeNotebookDocument(pe,we,Me){return si.onDidChangeNotebookDocument(pe,we,Me)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(pe,we,Me,ot){return Ct.registerNotebookSerializer(xe,pe,we,Me,(0,$e.isProposedApiEnabled)(xe,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(pe,we,Me)=>Li.onDidChangeConfiguration(pe,we,Me),getConfiguration(pe,we){return we=arguments.length===1?void 0:we,Li.getConfiguration(pe,we,xe)},registerTextDocumentContentProvider(pe,we){return ri.registerTextDocumentContentProvider(pe,we)},registerTaskProvider:(pe,we)=>(Le.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(xe,pe,we)),registerFileSystemProvider(pe,we,Me){return(0,Ve.combinedDisposable)(Ui.registerFileSystemProvider(xe,pe,we,Me),$t.addFileSystemProvider(pe,we))},get fs(){return $t.value},registerFileSearchProvider:(pe,we)=>((0,$e.checkProposedApiEnabled)(xe,"fileSearchProvider"),Tt.registerFileSearchProvider(pe,we)),registerTextSearchProvider:(pe,we)=>((0,$e.checkProposedApiEnabled)(xe,"textSearchProvider"),Tt.registerTextSearchProvider(pe,we)),registerRemoteAuthorityResolver:(pe,we)=>((0,$e.checkProposedApiEnabled)(xe,"resolvers"),It.registerRemoteAuthorityResolver(pe,we)),registerResourceLabelFormatter:pe=>((0,$e.checkProposedApiEnabled)(xe,"resolvers"),_i.$registerResourceLabelFormatter(pe)),onDidCreateFiles:(pe,we,Me)=>Nt.onDidCreateFile(pe,we,Me),onDidDeleteFiles:(pe,we,Me)=>Nt.onDidDeleteFile(pe,we,Me),onDidRenameFiles:(pe,we,Me)=>Nt.onDidRenameFile(pe,we,Me),onWillCreateFiles:(pe,we,Me)=>Nt.getOnWillCreateFileEvent(xe)(pe,we,Me),onWillDeleteFiles:(pe,we,Me)=>Nt.getOnWillDeleteFileEvent(xe)(pe,we,Me),onWillRenameFiles:(pe,we,Me)=>Nt.getOnWillRenameFileEvent(xe)(pe,we,Me),openTunnel:pe=>((0,$e.checkProposedApiEnabled)(xe,"tunnels"),Pe.openTunnel(xe,pe).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,$e.checkProposedApiEnabled)(xe,"tunnels"),Pe.getTunnels()},onDidChangeTunnels:(pe,we,Me)=>((0,$e.checkProposedApiEnabled)(xe,"tunnels"),Pe.onDidChangeTunnels(pe,we,Me)),registerPortAttributesProvider:(pe,we)=>((0,$e.checkProposedApiEnabled)(xe,"portsAttributes"),Pe.registerPortsAttributesProvider(pe,we)),registerTimelineProvider:(pe,we)=>((0,$e.checkProposedApiEnabled)(xe,"timeline"),xi.registerTimelineProvider(pe,we,xe.identifier,He.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:pe=>((0,$e.checkProposedApiEnabled)(xe,"workspaceTrust"),ft.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,we,Me)=>ft.onDidGrantWorkspaceTrust(pe,we,Me),registerEditSessionIdentityProvider:(pe,we)=>((0,$e.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(pe,we)),onWillCreateEditSessionIdentity:(pe,we,Me)=>((0,$e.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(xe)(pe,we,Me))},fi={get inputBox(){return Le.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(xe)},createSourceControl(pe,we,Me){return ci.createSourceControl(xe,pe,we,Me)}},qi={createCommentController(pe,we){return wi.createCommentController(xe,pe,we)}},xt={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(pe,we,Me){return ut.onDidStartDebugSession(pe,we,Me)},onDidTerminateDebugSession(pe,we,Me){return ut.onDidTerminateDebugSession(pe,we,Me)},onDidChangeActiveDebugSession(pe,we,Me){return ut.onDidChangeActiveDebugSession(pe,we,Me)},onDidReceiveDebugSessionCustomEvent(pe,we,Me){return ut.onDidReceiveDebugSessionCustomEvent(pe,we,Me)},onDidChangeBreakpoints(pe,we,Me){return ut.onDidChangeBreakpoints(pe,we,Me)},registerDebugConfigurationProvider(pe,we,Me){return ut.registerDebugConfigurationProvider(pe,we,Me||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,we){return ut.registerDebugAdapterDescriptorFactory(xe,pe,we)},registerDebugAdapterTrackerFactory(pe,we){return ut.registerDebugAdapterTrackerFactory(pe,we)},startDebugging(pe,we,Me){return!Me||typeof Me=="object"&&"configuration"in Me?ut.startDebugging(pe,we,{parentSession:Me}):ut.startDebugging(pe,we,Me||{})},stopDebugging(pe){return ut.stopDebugging(pe)},addBreakpoints(pe){return ut.addBreakpoints(pe)},removeBreakpoints(pe){return ut.removeBreakpoints(pe)},asDebugSourceUri(pe,we){return ut.asDebugSourceUri(pe,we)}},mi={registerTaskProvider:(pe,we)=>_t.registerTaskProvider(xe,pe,we),fetchTasks:pe=>_t.fetchTasks(pe),executeTask:pe=>_t.executeTask(xe,pe),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(pe,we,Me)=>_t.onDidStartTask(pe,we,Me),onDidEndTask:(pe,we,Me)=>_t.onDidEndTask(pe,we,Me),onDidStartTaskProcess:(pe,we,Me)=>_t.onDidStartTaskProcess(pe,we,Me),onDidEndTaskProcess:(pe,we,Me)=>_t.onDidEndTaskProcess(pe,we,Me)},Gi={createNotebookController(pe,we,Me,ot,Dt){return Yt.createNotebookController(xe,pe,we,Me,ot,(0,$e.isProposedApiEnabled)(xe,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,we)=>Ct.registerNotebookCellStatusBarItemProvider(xe,pe,we),createRendererMessaging(pe){return vi.createRendererMessaging(xe,pe)},createNotebookControllerDetectionTask(pe){return(0,$e.checkProposedApiEnabled)(xe,"notebookKernelSource"),Yt.createNotebookControllerDetectionTask(xe,pe)},registerKernelSourceActionProvider(pe,we){return(0,$e.checkProposedApiEnabled)(xe,"notebookKernelSource"),Yt.registerKernelSourceActionProvider(xe,pe,we)},onDidChangeNotebookCellExecutionState(pe,we,Me){return(0,$e.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(pe,we,Me)}},Ki={t(...pe){if(typeof pe[0]=="string"){const we=pe.shift(),Me=!pe||typeof pe[0]!="object"?pe:pe[0];return Et.getMessage(xe.identifier.value,{message:we,args:Me})}return Et.getMessage(xe.identifier.value,pe[0])},get bundle(){return Et.getBundle(xe.identifier.value)},get uri(){return Et.getBundleUri(xe.identifier.value)}};return{version:pt.version,authentication:$i,commands:di,comments:qi,debug:xt,env:Oi,extensions:Vi,l10n:Ki,languages:ki,notebooks:Gi,scm:fi,tasks:mi,tests:Hi,window:ji,workspace:Ht,Breakpoint:U.Breakpoint,TerminalOutputAnchor:U.TerminalOutputAnchor,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:b.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileDecoration2:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestionList,Hover:U.Hover,IndentAction:C.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalQuickFixCommand:U.TerminalQuickFixCommand,TerminalQuickFixOpener:U.TerminalQuickFixOpener,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TerminalExitReason:U.TerminalExitReason,TerminalQuickFixType:U.TerminalQuickFixType,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,SnippetTextEdit:U.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItem2:U.TreeItem,TreeItemCheckboxState:U.TreeItemCheckboxState,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:I.UIKind,Uri:w.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,DocumentDropEdit:U.DocumentDropEdit,DocumentPasteEdit:U.DocumentPasteEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,NotebookControllerAffinity2:U.NotebookControllerAffinity2,NotebookEdit:U.NotebookEdit,NotebookKernelSourceAction:U.NotebookKernelSourceAction,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestRunRequest2:U.TestRunRequest2,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:Ue.TextSearchCompleteMessageType,DataTransfer:U.DataTransfer,DataTransferItem:U.DataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind,InputBoxValidationSeverity:U.InputBoxValidationSeverity,TabInputText:U.TextTabInput,TabInputTextDiff:U.TextDiffTabInput,TabInputTextMerge:U.TextMergeTabInput,TabInputCustom:U.CustomEditorTabInput,TabInputNotebook:U.NotebookEditorTabInput,TabInputNotebookDiff:U.NotebookDiffEditorTabInput,TabInputWebview:U.WebviewEditorTabInput,TabInputTerminal:U.TerminalEditorTabInput,TabInputInteractiveWindow:U.InteractiveWindowInput,TelemetryTrustedValue:Z.TelemetryTrustedValue,LogLevel:Ae.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=wt}),define(Se[313],ye([1,0,285,323,324,2,325]),function(re,e,o,R,l,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,b,I,y,f,d){const u=d.environment.useHostProxy,m=typeof u=="boolean"?u:!d.remote.isRemote,v=(0,w.createProxyResolver)({resolveProxy:p=>k.resolveProxy(p),getHttpProxySetting:()=>b.getConfiguration("http").get("proxy"),log:(p,n,...s)=>{switch(p){case w.LogLevel.Trace:y.trace(n,...s);break;case w.LogLevel.Debug:y.debug(n,...s);break;case w.LogLevel.Info:y.info(n,...s);break;case w.LogLevel.Warning:y.warn(n,...s);break;case w.LogLevel.Error:y.error(n,...s);break;case w.LogLevel.Critical:y.error(n,...s);break;case w.LogLevel.Off:break;default:r(p,n,s);break}function r(a,c,...g){y.error("Unknown log level",a),y.error(c,...g)}},getLogLevel:()=>y.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:m,env:process.env}),D=S(b,v);return L(I,D)}e.connectProxyResolver=P;function S(k,b){const I={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(f=>{I.config=k.getConfiguration("http").get("proxySupport")||"off"});const y={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(f=>{y.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,w.createHttpPatch)(o,b,{config:"off"},y,!0)),on:Object.assign({},o,(0,w.createHttpPatch)(o,b,{config:"on"},y,!0)),override:Object.assign({},o,(0,w.createHttpPatch)(o,b,{config:"override"},y,!0)),onRequest:Object.assign({},o,(0,w.createHttpPatch)(o,b,I,y,!0)),default:Object.assign(o,(0,w.createHttpPatch)(o,b,I,y,!1))},https:{off:Object.assign({},R,(0,w.createHttpPatch)(R,b,{config:"off"},y,!0)),on:Object.assign({},R,(0,w.createHttpPatch)(R,b,{config:"on"},y,!0)),override:Object.assign({},R,(0,w.createHttpPatch)(R,b,{config:"override"},y,!0)),onRequest:Object.assign({},R,(0,w.createHttpPatch)(R,b,I,y,!0)),default:Object.assign(R,(0,w.createHttpPatch)(R,b,I,y,!1))},tls:Object.assign(l,(0,w.createTlsPatch)(l))}}const C=new Map;function L(k,b){return k.getExtensionPathIndex().then(I=>{const y=globalThis._VSCODE_NODE_MODULES.module,f=y._load;y._load=function(u,m,v){if(u==="tls")return b.tls;if(u!=="http"&&u!=="https")return f.apply(this,arguments);const D=b[u],p=I.findSubstr(A.URI.file(m.filename));let n=C.get(p);if(n||C.set(p,n={}),!n[u]){const s=D.default;n[u]={...s}}return n[u]}})}}),define(Se[314],ye([1,0,84,312,299,313,42,287,2,15,7,284,115,286]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends l.RequireInterceptor{_installInterceptor(){const u=this,m=globalThis._VSCODE_NODE_MODULES.module,v=m._load;m._load=function(s,r,a){return s=p(s),u._factories.has(s)?u._factories.get(s).load(s,S.URI.file((0,b.realpathSync)(r.filename)),c=>v.apply(this,[c,r,a])):v.apply(this,arguments)};const D=m._resolveLookupPaths;m._resolveLookupPaths=(n,s)=>D.call(this,p(n),s);const p=n=>{for(const s of u._alternatives){const r=s(n);if(r){n=r;break}}return n}}}class f extends w.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(I.ExtHostConsoleForwarder);const u=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(P.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const D=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=D.ipcHandlePath}await this._instaService.createInstance(y,u,{mine:this._myRegistry,all:this._globalRegistry}).install(),o.mark("code/extHost/didInitAPI");const v=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,v,this,this._logService,this._mainThreadTelemetryProxy,this._initData),o.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(u){return u.main}async _loadCommonJSModule(u,m,v){if(m.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${m}', must be of file-scheme`);let D=null;v.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${m.toString(!0)}`),this._logService.flush();const p=u?.identifier.value;u&&await this._extHostLocalizationService.initializeLocalizedMessages(u);try{p&&o.mark(`code/extHost/willLoadExtensionCode/${p}`),D=re.__$__nodeRequire(m.fsPath)}finally{p&&o.mark(`code/extHost/didLoadExtensionCode/${p}`),v.codeLoadingStop()}return D}async $setRemoteEnvironment(u){if(!!this._initData.remote.isRemote)for(const m in u){const v=u[m];v===null?delete process.env[m]:process.env[m]=v}}}e.ExtHostExtensionService=f}),define(Se[145],ye([1,0,46,326,308,16,61,38,12,8,2,31,82,327,306,100]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class u{constructor(E){this.outputChannel=E}provideTextSearchResults(E,O,$,H){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...O,folder:O.folder.toString()})}`),new Promise((X,V)=>{H.onCancellationRequested(()=>Q());const N=s(E,O),T=O.folder.fsPath,F=N.map(ee=>ee.match(/^-/)?ee:`'${ee}'`).join(" ");this.outputChannel.appendLine(`${d} ${F}
 - cwd: ${T}`);let U=o.spawn(d,N,{cwd:T});U.on("error",ee=>{console.error(ee),this.outputChannel.appendLine("Error: "+(ee&&ee.message)),V((0,k.serializeSearchError)(new k.SearchError(ee&&ee.message,k.SearchErrorCode.rgProcessError)))});let Z=!1;const J=new D(O.maxResults,T,O.previewOptions);J.on("result",ee=>{Z=!0,ge="",$.report(ee)});let z=!1;const Q=()=>{z=!0,U?.kill(),J?.cancel()};let ie=!1;J.on("hitLimit",()=>{ie=!0,Q()});let ge="";U.stdout.on("data",ee=>{J.handleData(ee),Z||(ge+=ee)});let K=!1;U.stdout.once("data",()=>K=!0);let Y="";U.stderr.on("data",ee=>{const me=ee.toString();this.outputChannel.appendLine(me),Y.length+me.length<1e6&&(Y+=me)}),U.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(Z?"Got result from parser":"No result from parser"),ge&&this.outputChannel.appendLine(`Got data without result: ${ge}`),this.outputChannel.appendLine(""),z)X({limitHit:ie});else{J.flush(),U=null;let ee;Y&&!K&&(ee=m(Y))?V((0,k.serializeSearchError)(new k.SearchError(ee.message,ee.code))):X({limitHit:ie})}})})}}e.RipgrepTextSearchEngine=u;function m(_){const E=_.split(`
`),O=E[0].trim();if(E.some(H=>H.startsWith("regex parse error")))return new k.SearchError(v(E),k.SearchErrorCode.regexParseError);const $=O.match(/grep config error: unknown encoding: (.*)/);if($)return new k.SearchError(`Unknown encoding: ${$[1]}`,k.SearchErrorCode.unknownEncoding);if(O.startsWith("error parsing glob"))return new k.SearchError(O.charAt(0).toUpperCase()+O.substr(1),k.SearchErrorCode.globParseError);if(O.startsWith("the literal"))return new k.SearchError(O.charAt(0).toUpperCase()+O.substr(1),k.SearchErrorCode.invalidLiteral);if(O.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(O,k.SearchErrorCode.regexParseError)}function v(_){const E=["Regex parse error"],O=_.filter($=>$.startsWith("PCRE2:"));if(O.length>=1){const $=O[0].replace("PCRE2:","");if($.indexOf(":")!==-1&&$.split(":").length>=2){const H=$.split(":")[1];E.push(":"+H)}}return E.join("")}class D extends R.EventEmitter{constructor(E,O,$){super(),this.maxResults=E,this.rootFolder=O,this.previewOptions=$,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new l.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,O){return super.on(E,O),this}handleData(E){if(this.isDone)return;const O=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(O)}handleDecodedData(E){let O=E.indexOf(`
`);const $=this.remainder+E;if(O>=0)O+=this.remainder.length;else{this.remainder=$;return}let H=0;for(;O>=0;)this.handleLine($.substring(H,O).trim()),H=O+1,O=$.indexOf(`
`,H);this.remainder=$.substring(H)}handleLine(E){if(this.isDone||!E)return;let O;try{O=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(O.type==="match"){const $=p(O.data.path),H=L.URI.file(S.join(this.rootFolder,$)),X=this.createTextSearchMatch(O.data,H);this.onResult(X),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(O.type==="context"){const $=p(O.data.path),H=L.URI.file(S.join(this.rootFolder,$));this.createTextSearchContext(O.data,H).forEach(V=>this.onResult(V))}}createTextSearchMatch(E,O){const $=E.line_number-1,H=p(E.lines),X=Buffer.from(H);let V=0,N=0,T=$;E.submatches.length===0&&E.submatches.push(H.length?{start:0,end:1,match:{text:H[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(E.submatches.map((U,Z)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const J=p(U.match),z=X.slice(V,U.start).toString(),Q=n(z),ie=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+N,ge=n(J),K=Q.numLines+T,Y=ge.numLines+K,ee=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+ie;return V=U.end,N=ee,T=Y,new b.Range(K,ie,Y,ee)}));return(0,f.createTextSearchResult)(O,H,F,this.previewOptions)}createTextSearchContext(E,O){const $=p(E.lines),H=E.line_number;return $.replace(/\r?\n$/,"").split(`
`).map((X,V)=>({text:X,uri:O,lineNumber:H+V}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=D;function p(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function n(_){const E=/\n/g;let O=0,$=-1,H;for(;H=E.exec(_);)O++,$=H.index;const X=$>=0?_.length-$-1:_.length;return{numLines:O,lastLineLength:X}}function s(_,E){const O=["--hidden"];O.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:$,otherIncludes:H}=(0,w.groupBy)(E.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(H&&H.length){const V=new Set;H.forEach(N=>{V.add(N)}),O.push("-g","!*"),V.forEach(N=>{r(N).map(f.anchorGlob).forEach(T=>{O.push("-g",T)})})}$&&$.length&&$.forEach(V=>{O.push("-g",V)}),E.excludes.map(f.anchorGlob).forEach(V=>O.push("-g",`!${V}`)),E.maxFileSize&&O.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||O.push("--no-ignore-parent"):O.push("--no-ignore"),E.followSymlinks&&O.push("--follow"),E.encoding&&E.encoding!=="utf8"&&O.push("--encoding",E.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=(0,C.escapeRegExpCharacters)(_.pattern),_.isRegExp=!0),E.usePCRE2&&O.push("--pcre2"),O.push("--crlf"),_.isRegExp&&(_.pattern=a(_.pattern),O.push("--engine","auto"));let X;if(_.isWordMatch){const N=(0,C.createRegExp)(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");O.push("--regexp",N)}else if(_.isRegExp){let V=g(_.pattern);V=i(V),O.push("--regexp",V)}else X=_.pattern,O.push("--fixed-strings");return O.push("--no-config"),E.useGlobalIgnoreFiles||O.push("--no-ignore-global"),O.push("--json"),_.isMultiline&&O.push("--multiline"),E.beforeContext&&O.push("--before-context",E.beforeContext+""),E.afterContext&&O.push("--after-context",E.afterContext+""),O.push("--"),X&&O.push(X),O.push("."),O}e.getRgArgs=s;function r(_){return h(_).flatMap(O=>{const $=(0,P.splitGlobAware)(O,"/");return $.map((H,X)=>$.slice(0,X+1).join("/"))})}function a(_){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(E);)_=_.replace(E,"$1\\x{$2}");const O=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(O);)_=_.replace(O,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=a;const c=_=>_.type==="Assertion"&&_.kind==="lookbehind";function g(_){let E;try{E=new I.RegExpParser().parsePattern(_)}catch{return _}let O="",$=0;const H=(N,T,F)=>{O+=_.slice($,N)+F,$=T},X=[];return new I.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const T=X[0];if(!T)H(N.start,N.end,"\\r?\\n");else if(!X.some(c))if(T.type==="CharacterClass")if(T.negate){const F=_.slice(T.start+2,N.start)+_.slice(N.end,T.end-1);T.parent?.type==="Quantifier"?H(T.start,T.end,F?`[^${F}]`:"."):H(T.start,T.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=_.slice(T.start+1,N.start)+_.slice(N.end,T.end-1);H(T.start,T.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else T.type==="Quantifier"&&H(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){X.unshift(N)},onQuantifierLeave(){X.shift()},onCharacterClassRangeEnter(N){X.unshift(N)},onCharacterClassRangeLeave(){X.shift()},onCharacterClassEnter(N){X.unshift(N)},onCharacterClassLeave(){X.shift()},onAssertionEnter(N){c(N)&&X.push(N)},onAssertionLeave(N){X[0]===N&&X.shift()}}).visit(E),O+=_.slice($),O}e.fixRegexNewline=g;function i(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function t(_){let E=!1,O=!1,$="",H="";for(let X=0;X<_.length;X++){const V=_[X];switch(V){case"\\":O?(E?H+="\\"+V:$+="\\"+V,O=!1):O=!0;break;case"{":if(O)E?H+=V:$+=V,O=!1;else{if(E)return{strInBraces:$+"{"+H+"{"+_.substring(X+1)};E=!0}break;case"}":if(O)E?H+=V:$+=V,O=!1;else{if(E)return{fixedStart:$,strInBraces:H,fixedEnd:_.substring(X+1)};$+=V}break;default:E?H+=(O?"\\":"")+V:$+=(O?"\\":"")+V,O=!1;break}}return{strInBraces:$+(E?"{"+H:"")}}function h(_){const{fixedStart:E,strInBraces:O,fixedEnd:$}=t(_);if(E===void 0||$===void 0)return[O];let H=(0,P.splitGlobAware)(O,",");H.length||(H=[""]);const X=h($);return H.flatMap(V=>{const N=E+V;return X.map(T=>N+T)})}e.performBraceExpansionForRipgrep=h}),define(Se[315],ye([1,0,21,145,126,15]),function(re,e,o,R,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class w{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,L,k,b){const I=new R.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===A.Schemas.vscodeUserData){const y={...L,folder:L.folder.with({scheme:A.Schemas.file})},f=new l.Progress(d=>k.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.withToken(b,d=>I.provideTextSearchResults(C,y,f,d))}else return this.withToken(b,y=>I.provideTextSearchResults(C,L,k,y))}async withToken(C,L){const k=P(C);this.inProgress.add(k);const b=await L(k.token);return this.inProgress.delete(k),b}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=w;function P(S){const C=new o.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(Se[316],ye([1,0,29,145,144]),function(re,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.query=S}search(S,C,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(I){L({message:I})}},b=new l.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(k),o);return new Promise((I,y)=>b.search(f=>{C(f.map(w))},S).then(f=>I({limitHit:f.limitHit,type:"success",stats:f.stats}),y))}}e.TextSearchEngineAdapter=A;function w(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((S,C)=>{if(C.ranges){const L=C;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(Se[317],ye([1,0,16,19,10,3,111,12,43,2,44,31,307,316]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class y{constructor(D="searchProcess"){this.processType=D,this.caches=Object.create(null)}fileSearch(D){let p;const n=u(D),s=new A.Emitter({onDidAddFirstListener:()=>{p=(0,R.createCancelablePromise)(r=>this.doFileSearchWithEngine(b.Engine,n,a=>s.fire(a),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}textSearch(D){let p;const n=u(D),s=new A.Emitter({onDidAddFirstListener:()=>{p=(0,R.createCancelablePromise)(r=>this.ripgrepTextSearch(n,a=>s.fire(a),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}ripgrepTextSearch(D,p,n){return D.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(D).search(n,p,p)}doFileSearch(D,p,n){return this.doFileSearchWithEngine(b.Engine,D,p,n)}doFileSearchWithEngine(D,p,n,s,r=y.BATCH_SIZE){let a=0;const c=i=>{Array.isArray(i)?(a+=i.length,n(i.map(t=>this.rawMatchToSearchItem(t)))):i.relativePath?(a++,n(this.rawMatchToSearchItem(i))):n(i)};if(p.sortByScore){let i=this.trySortedSearchFromCache(p,c,s);if(!i){const t=p.maxResults?Object.assign({},p,{maxResults:null}):p,h=new D(t);i=this.doSortedSearch(h,p,n,c,s)}return new Promise((t,h)=>{i.then(([_,E])=>{const O=E.map($=>this.rawMatchToSearchItem($));this.sendProgress(O,n,r),t(_)},h)})}const g=new D(p);return this.doSearch(g,c,r,s).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.processType,fromCache:!1,resultCount:a,sortingTime:void 0}}))}rawMatchToSearchItem(D){return{path:D.base?(0,P.join)(D.base,D.relativePath):D.relativePath}}doSortedSearch(D,p,n,s,r){const a=new A.Emitter;let c=(0,R.createCancelablePromise)(i=>{let t=[];const h=_=>{Array.isArray(_)?t=_:(s(_),a.fire(_))};return this.doSearch(D,h,-1,i).then(_=>[_,t])}),g;if(p.cacheKey){g=this.getOrCreateCache(p.cacheKey);const i={promise:c,event:a.event,resolved:!1};g.resultsToSearchCache[p.filePattern||""]=i,c.then(()=>{i.resolved=!0},t=>{delete g.resultsToSearchCache[p.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([i,t])=>{const h=g?g.scorerCache:Object.create(null),_=(typeof p.maxResults!="number"||p.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(p,t,h,r).then(E=>{const O=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:E.length},messages:i.messages,limitHit:i.limitHit||typeof p.maxResults=="number"&&t.length>p.maxResults},E]})})}getOrCreateCache(D){const p=this.caches[D];return p||(this.caches[D]=new f)}trySortedSearchFromCache(D,p,n){const s=D.cacheKey&&this.caches[D.cacheKey];if(!s)return;const r=this.getResultsFromCache(s,D.filePattern||"",p,n);if(r)return r.then(([a,c,g])=>{const i=S.StopWatch.create(!1);return this.sortResults(D,c,s.scorerCache,n).then(t=>{const h=i.elapsed(),_={fromCache:!0,detailStats:g,type:this.processType,resultCount:c.length,sortingTime:h};return[{type:"success",limitHit:a.limitHit||typeof D.maxResults=="number"&&c.length>D.maxResults,stats:_},t]})})}sortResults(D,p,n,s){const r=(0,w.prepareQuery)(D.filePattern||""),a=(g,i)=>(0,w.compareItemsByFuzzyScore)(g,i,r,!0,d,n),c=typeof D.maxResults=="number"?D.maxResults:Number.MAX_VALUE;return o.topAsync(p,a,c,1e4,s)}sendProgress(D,p,n){if(n&&n>0)for(let s=0;s<D.length;s+=n)p(D.slice(s,s+n));else p(D)}getResultsFromCache(D,p,n,s){const r=S.StopWatch.create(!1),a=p.indexOf(P.sep)>=0;let c;for(const h in D.resultsToSearchCache)if(p.startsWith(h)){if(a&&h.indexOf(P.sep)<0&&h!=="")continue;const _=D.resultsToSearchCache[h];c={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!c)return null;const g=r.elapsed(),i=S.StopWatch.create(!1),t=c.event(n);return s&&s.onCancellationRequested(()=>{t.dispose()}),c.promise.then(([h,_])=>{if(s&&s.isCancellationRequested)throw(0,l.canceled)();const E=[],O=(0,w.prepareQuery)(p).normalizedLowercase;for(const $ of _)!(0,k.isFilePatternMatch)($,O)||E.push($);return[h,E,{cacheWasResolved:c.resolved,cacheLookupTime:g,cacheFilterTime:i.elapsed(),cacheEntryCount:_.length}]})}doSearch(D,p,n,s){return new Promise((r,a)=>{let c=[];s?.onCancellationRequested(()=>D.cancel()),D.search(g=>{g&&(n?(c.push(g),n>0&&c.length>=n&&(p(c),c=[])):p(g))},g=>{p(g)},(g,i)=>{c.length&&p(c),g?a(g):r(i)})})}clearCache(D){return delete this.caches[D],Promise.resolve(void 0)}preventCancellation(D){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,n){return D.then(p,n)}catch(p){return this.then(void 0,p)}finally(p){return D.finally(p)}}}}y.BATCH_SIZE=512,e.SearchService=y;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(v){return(0,P.basename)(v.relativePath)}getItemDescription(v){return(0,P.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function u(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(m),extraFileResources:v.extraFileResources&&v.extraFileResources.map(D=>C.URI.revive(D))}}function m(v){return{...v,folder:C.URI.revive(v.folder)}}}),define(Se[318],ye([1,0,6,15,2,29,13,25,20,86,56,31,317,315,100,144]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends C.ExtHostSearch{constructor(m,v,D,p){super(m,D,p),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new y.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(R.Schemas.vscodeUserData,new I.RipgrepSearchProvider(n)),v.remote.isRemote&&v.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const m=new y.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(R.Schemas.file,new I.RipgrepSearchProvider(m)),this.registerInternalFileSearchProvider(R.Schemas.file,new b.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(m,v){const D=this._handlePool++;return this._internalFileSearchProvider=v,this._internalFileSearchHandle=D,this._proxy.$registerFileSearchProvider(D,this._transformScheme(m)),(0,o.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(m,v,D,p){const n=(0,C.reviveQuery)(D);return m===this._internalFileSearchHandle?this.doInternalFileSearch(m,v,n,p):super.$provideFileSearchResults(m,v,D,p)}doInternalFileSearch(m,v,D,p){const n=s=>{if((0,k.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(m,v,s.map(r=>l.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(D,n,p)}$clearCache(m){return this._internalFileSearchProvider?.clearCache(m),super.$clearCache(m)}createTextSearchManager(m,v){return new f.NativeTextSearchManager(m,v,void 0,"textSearchProvider")}};d=je([Be(0,S.IExtHostRpcService),Be(1,P.IExtHostInitDataService),Be(2,L.IURITransformerService),Be(3,w.ILogService)],d),e.NativeExtHostSearch=d}),define(Se[319],ye([1,0,90,290,302,301,318,314,291,85,42,86,83,41,55,80,289,288,13,303,49]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u,m,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(L.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,o.registerSingleton)(m.ILoggerService,u.ExtHostLoggerService,1),(0,o.registerSingleton)(f.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,o.registerSingleton)(C.IExtHostDebugService,A.ExtHostDebugService,0),(0,o.registerSingleton)(k.IExtHostSearch,w.NativeExtHostSearch,0),(0,o.registerSingleton)(b.IExtHostTask,l.ExtHostTask,0),(0,o.registerSingleton)(I.IExtHostTerminalService,R.ExtHostTerminalService,0),(0,o.registerSingleton)(y.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,o.registerSingleton)(D.IExtHostVariableResolverProvider,v.NodeExtHostVariableResolverProviderService,0)}),define(Se[328],ye([1,0,231,329,84,10,118,119,209,96,300,22,29,115,19,121,226,239,304,319]),function(re,e,o,R,l,A,w,P,S,C,L,k,b,I,y,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const m=R(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,g=c._load;c._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const v=process.exit.bind(process);function D(c){process.exit=function(g){if(c)v(g);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(c){v()};function n(){const c=(0,u.readExtHostConnection)(process.env);if(c.type===3)return new Promise((g,i)=>{const t=h=>{const _=h[0],E=new w.BufferedEmitter;_.on("message",O=>E.fire(k.VSBuffer.wrap(O.data))),_.on("close",()=>{p("renderer closed the MessagePort")}),_.start(),g({onMessage:E.event,send:O=>_.postMessage(O.buffer)})};process.parentPort.on("message",h=>t(h.ports))});if(c.type===2)return new Promise((g,i)=>{let t=null;const h=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),_=108e5,E=3e5,O=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),_),$=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),E);process.on("message",(X,V)=>{if(X&&X.type==="VSCODE_EXTHOST_IPC_SOCKET"){V.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from(X.initialDataChunk,"base64"));let T;if(X.skipWebSocketFrames)T=new P.NodeSocket(V,"extHost-socket");else{const F=k.VSBuffer.wrap(Buffer.from(X.inflateBytes,"base64"));T=new P.WebSocketNodeSocket(new P.NodeSocket(V,"extHost-socket"),X.permessageDeflate,F,!1)}t?(O.cancel(),$.cancel(),t.beginAcceptReconnection(T,N),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(h),t=new w.PersistentProtocol({socket:T,initialChunk:N}),t.sendResume(),t.onDidDispose(()=>p("renderer disconnected")),g(t),t.onSocketClose(()=>{O.schedule()}))}if(X&&X.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if($.isScheduled())return;O.isScheduled()&&$.schedule()}});const H={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(H)});{const g=c.pipeName;return new Promise((i,t)=>{const h=o.createConnection(g,()=>{h.removeListener("error",t);const _=new w.PersistentProtocol({socket:new P.NodeSocket(h,"extHost-renderer")});_.sendResume(),i(_)});h.once("error",t),h.on("close",()=>{p("renderer closed the socket")})})}}async function s(){const c=await n();return new class{constructor(){this._onMessage=new w.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,c.onMessage(g=>{(0,C.isMessageOfType)(g,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(g)})}send(g){this._terminating||c.send(g)}async drain(){if(c.drain)return c.drain()}}}function r(c){return new Promise(g=>{const i=c.onMessage(t=>{i.dispose();const h=JSON.parse(t.toString()),_=h.commit,E=S.default.commit;if(_&&E&&_!==E&&v(55),h.parentPid){let O=0;setInterval(function(){try{process.kill(h.parentPid,0),O=0}catch(H){H&&H.code==="EPERM"?(O++,O>=3&&p(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${H.message} (code: ${H.code}) (errno: ${H.errno})`)):p(`parent process ${h.parentPid} does not exist anymore: ${H.message} (code: ${H.code}) (errno: ${H.errno})`)}},1e3);let $;try{$=globalThis._VSCODE_NODE_MODULES["native-watchdog"],$.start(h.parentPid)}catch(H){(0,A.onUnexpectedError)(H)}}c.send((0,C.createMessageOfType)(0)),g({protocol:c,initData:h})});c.send((0,C.createMessageOfType)(1))})}async function a(){const c=[];process.on("unhandledRejection",(O,$)=>{c.push($),setTimeout(()=>{const H=c.indexOf($);H>=0&&$.catch(X=>{c.splice(H,1),(0,A.isCancellationError)(X)||(console.warn(`rejected promise not handled within 1 second: ${X}`),X&&X.stack&&console.warn(`stack trace: ${X.stack}`),O&&(0,A.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const $=c.indexOf(O);$>=0&&c.splice($,1)}),process.on("uncaughtException",function(O){(0,A.isSigPipeError)(O)||(0,A.onUnexpectedError)(O)}),l.mark("code/extHost/willConnectToRenderer");const g=await s();l.mark("code/extHost/didConnectToRenderer");const i=await r(g);l.mark("code/extHost/didWaitForInitData");const{initData:t}=i;D(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,f.boolean)(m.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit($){v($)}exists($){return b.Promises.exists($)}realpath($){return(0,I.realpath)($)}};let _=null;t.remote.authority&&m.transformURIs&&(_=(0,d.createURITransformer)(t.remote.authority));const E=new L.ExtensionHostMain(i.protocol,t,h,_);p=O=>E.terminate(O)}a().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/22a808587994126e19125c6a1a03c00b990223f4/core/vs/workbench/api/node/extensionHostProcess.js.map
