/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],ke=function(ne){for(var e=[],i=0,k=ne.length;i<k;i++)e[i]=Ie[ne[i]];return e};define(Ie[63],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(b,A){const _=Object.create(null);for(const I of b){const N=A(I);let y=_[N];y||(y=_[N]=[]),y.push(I)}return _}e.groupBy=i;function k(b,A){const _=[],I=[];for(const N of b)A.has(N)||_.push(N);for(const N of A)b.has(N)||I.push(N);return{removed:_,added:I}}e.diffSets=k;function D(b,A){const _=[],I=[];for(const[N,y]of b)A.has(N)||_.push(y);for(const[N,y]of A)b.has(N)||I.push(y);return{removed:_,added:I}}e.diffMaps=D;class F{constructor(){this.map=new Map}add(A,_){let I=this.map.get(A);I||(I=new Set,this.map.set(A,I)),I.add(_)}delete(A,_){const I=this.map.get(A);!I||(I.delete(_),I.size===0&&this.map.delete(A))}forEach(A,_){const I=this.map.get(A);!I||I.forEach(_)}}e.SetMap=F}),define(Ie[64],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(b){return(A,_,I)=>{let N=null,y=null;if(typeof I.value=="function"?(N="value",y=I.value):typeof I.get=="function"&&(N="get",y=I.get),!y)throw new Error("not supported");I[N]=b(y,_)}}function k(b,A,_){let I=null,N=null;if(typeof _.value=="function"?(I="value",N=_.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",N=_.get),!N)throw new Error("not supported");const y=`$memoize$${A}`;_[I]=function(...h){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,h)}),this[y]}}e.memoize=k;function D(b,A,_){return i((I,N)=>{const y=`$debounce$${N}`,h=`$debounce$result$${N}`;return function(...E){this[h]||(this[h]=_?_():void 0),clearTimeout(this[y]),A&&(this[h]=A(this[h],...E),E=[this[h]]),this[y]=setTimeout(()=>{I.apply(this,E),this[h]=_?_():void 0},b)}})}e.debounce=D;function F(b,A,_){return i((I,N)=>{const y=`$throttle$timer$${N}`,h=`$throttle$result$${N}`,E=`$throttle$lastRun$${N}`,g=`$throttle$pending$${N}`;return function(...a){if(this[h]||(this[h]=_?_():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),A&&(this[h]=A(this[h],...a)),this[g])return;const o=this[E]+b;o<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[h]]),this[h]=_?_():void 0):(this[g]=!0,this[y]=setTimeout(()=>{this[g]=!1,this[E]=Date.now(),I.apply(this,[this[h]]),this[h]=_?_():void 0},o-Date.now()))}})}e.throttle=F}),define(Ie[83],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ie[111],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F=e.ParseOptions||(e.ParseOptions={}));function b(t,d=!1){let r=0;const l=t.length;let c="",S=0,n=16,s=0;function f(H){let O=0,m=0;for(;O<H;){const L=t.charCodeAt(r);if(L>=48&&L<=57)m=m*16+L-48;else if(L>=65&&L<=70)m=m*16+L-65+10;else if(L>=97&&L<=102)m=m*16+L-97+10;else break;r++,O++}return O<H&&(m=-1),m}function P(H){r=H,c="",S=0,n=16,s=0}function T(){const H=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&I(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&I(t.charCodeAt(r)))for(r++;r<t.length&&I(t.charCodeAt(r));)r++;else return s=3,t.substring(H,r);let O=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&I(t.charCodeAt(r))){for(r++;r<t.length&&I(t.charCodeAt(r));)r++;O=r}else s=3;return t.substring(H,O)}function z(){let H="",O=r;for(;;){if(r>=l){H+=t.substring(O,r),s=2;break}const m=t.charCodeAt(r);if(m===34){H+=t.substring(O,r),r++;break}if(m===92){if(H+=t.substring(O,r),r++,r>=l){s=2;break}switch(t.charCodeAt(r++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:{const B=f(4);B>=0?H+=String.fromCharCode(B):s=4;break}default:s=5}O=r;continue}if(m>=0&&m<=31)if(_(m)){H+=t.substring(O,r),s=2;break}else s=6;r++}return H}function Q(){if(c="",s=0,S=r,r>=l)return S=l,n=17;let H=t.charCodeAt(r);if(A(H)){do r++,c+=String.fromCharCode(H),H=t.charCodeAt(r);while(A(H));return n=15}if(_(H))return r++,c+=String.fromCharCode(H),H===13&&t.charCodeAt(r)===10&&(r++,c+=`
`),n=14;switch(H){case 123:return r++,n=1;case 125:return r++,n=2;case 91:return r++,n=3;case 93:return r++,n=4;case 58:return r++,n=6;case 44:return r++,n=5;case 34:return r++,c=z(),n=10;case 47:{const O=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<l&&!_(t.charCodeAt(r));)r++;return c=t.substring(O,r),n=12}if(t.charCodeAt(r+1)===42){r+=2;const m=l-1;let L=!1;for(;r<m;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,L=!0;break}r++}return L||(r++,s=1),c=t.substring(O,r),n=13}return c+=String.fromCharCode(H),r++,n=16}case 45:if(c+=String.fromCharCode(H),r++,r===l||!I(t.charCodeAt(r)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=T(),n=11;default:for(;r<l&&Z(H);)r++,H=t.charCodeAt(r);if(S!==r){switch(c=t.substring(S,r),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(H),r++,n=16}}function Z(H){if(A(H)||_(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let H;do H=Q();while(H>=12&&H<=15);return H}return{setPosition:P,getPosition:()=>r,scan:d?Y:Q,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>S,getTokenLength:()=>r-S,getTokenError:()=>s}}e.createScanner=b;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function y(t,d){const r=[],l=new Object;let c;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function s(f,P,T,z){S.value=f,S.offset=P,S.length=T,S.type=z,S.colonOffset=void 0,c=S}try{w(t,{onObjectBegin:(f,P)=>{if(d<=f)throw l;c=void 0,n=d>f,r.push("")},onObjectProperty:(f,P,T)=>{if(d<P||(s(f,P,T,"property"),r[r.length-1]=f,d<=P+T))throw l},onObjectEnd:(f,P)=>{if(d<=f)throw l;c=void 0,r.pop()},onArrayBegin:(f,P)=>{if(d<=f)throw l;c=void 0,r.push(0)},onArrayEnd:(f,P)=>{if(d<=f)throw l;c=void 0,r.pop()},onLiteralValue:(f,P,T)=>{if(d<P||(s(f,P,T,v(f)),d<=P+T))throw l},onSeparator:(f,P,T)=>{if(d<=P)throw l;if(f===":"&&c&&c.type==="property")c.colonOffset=P,n=!1,c=void 0;else if(f===","){const z=r[r.length-1];typeof z=="number"?r[r.length-1]=z+1:(n=!0,r[r.length-1]=""),c=void 0}}})}catch(f){if(f!==l)throw f}return{path:r,previousNode:c,isAtPropertyKey:n,matches:f=>{let P=0;for(let T=0;P<f.length&&T<r.length;T++)if(f[P]===r[T]||f[P]==="*")P++;else if(f[P]!=="**")return!1;return P===f.length}}}e.getLocation=y;function h(t,d=[],r=F.DEFAULT){let l=null,c=[];const S=[];function n(f){Array.isArray(c)?c.push(f):l!==null&&(c[l]=f)}return w(t,{onObjectBegin:()=>{const f={};n(f),S.push(c),c=f,l=null},onObjectProperty:f=>{l=f},onObjectEnd:()=>{c=S.pop()},onArrayBegin:()=>{const f=[];n(f),S.push(c),c=f,l=null},onArrayEnd:()=>{c=S.pop()},onLiteralValue:n,onError:(f,P,T)=>{d.push({error:f,offset:P,length:T})}},r),c[0]}e.parse=h;function E(t,d=[],r=F.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){l.type==="property"&&(l.length=f-l.offset,l=l.parent)}function S(f){return l.children.push(f),f}w(t,{onObjectBegin:f=>{l=S({type:"object",offset:f,length:-1,parent:l,children:[]})},onObjectProperty:(f,P,T)=>{l=S({type:"property",offset:P,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:f,offset:P,length:T,parent:l})},onObjectEnd:(f,P)=>{l.length=f+P-l.offset,l=l.parent,c(f+P)},onArrayBegin:(f,P)=>{l=S({type:"array",offset:f,length:-1,parent:l,children:[]})},onArrayEnd:(f,P)=>{l.length=f+P-l.offset,l=l.parent,c(f+P)},onLiteralValue:(f,P,T)=>{S({type:v(f),offset:P,length:T,parent:l,value:f}),c(P+T)},onSeparator:(f,P,T)=>{l.type==="property"&&(f===":"?l.colonOffset=P:f===","&&c(P))},onError:(f,P,T)=>{d.push({error:f,offset:P,length:T})}},r);const s=l.children[0];return s&&delete s.parent,s}e.parseTree=E;function g(t,d){if(!t)return;let r=t;for(const l of d)if(typeof l=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const S of r.children)if(Array.isArray(S.children)&&S.children[0].value===l){r=S.children[1],c=!0;break}if(!c)return}else{const c=l;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=g;function a(t){if(!t.parent||!t.parent.children)return[];const d=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;d.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&d.push(r)}return d}e.getNodePath=a;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const d=Object.create(null);for(const r of t.children){const l=r.children[1];l&&(d[r.children[0].value]=o(l))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function u(t,d,r=!1){return d>=t.offset&&d<t.offset+t.length||r&&d===t.offset+t.length}e.contains=u;function p(t,d,r=!1){if(u(t,d,r)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=d;c++){const S=p(l[c],d,r);if(S)return S}return t}}e.findNodeAtOffset=p;function w(t,d,r=F.DEFAULT){const l=b(t,!1);function c(we){return we?()=>we(l.getTokenOffset(),l.getTokenLength()):()=>!0}function S(we){return we?V=>we(V,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=c(d.onObjectBegin),s=S(d.onObjectProperty),f=c(d.onObjectEnd),P=c(d.onArrayBegin),T=c(d.onArrayEnd),z=S(d.onLiteralValue),Q=S(d.onSeparator),Z=c(d.onComment),Y=S(d.onError),H=r&&r.disallowComments,O=r&&r.allowTrailingComma;function m(){for(;;){const we=l.scan();switch(l.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:H||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(we){case 12:case 13:H?L(10):Z();break;case 16:L(1);break;case 15:case 14:break;default:return we}}}function L(we,V=[],q=[]){if(Y(we),V.length+q.length>0){let G=l.getToken();for(;G!==17;){if(V.indexOf(G)!==-1){m();break}else if(q.indexOf(G)!==-1)break;G=m()}}}function B(we){const V=l.getTokenValue();return we?z(V):s(V),m(),!0}function J(){switch(l.getToken()){case 11:{let we=0;try{we=JSON.parse(l.getTokenValue()),typeof we!="number"&&(L(2),we=0)}catch{L(2)}z(we);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return m(),!0}function me(){return l.getToken()!==10?(L(3,[],[2,5]),!1):(B(!1),l.getToken()===6?(Q(":"),m(),ce()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function te(){n(),m();let we=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(we||L(4,[],[]),Q(","),m(),l.getToken()===2&&O)break}else we&&L(6,[],[]);me()||L(4,[],[2,5]),we=!0}return f(),l.getToken()!==2?L(7,[2],[]):m(),!0}function oe(){P(),m();let we=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(we||L(4,[],[]),Q(","),m(),l.getToken()===4&&O)break}else we&&L(6,[],[]);ce()||L(4,[],[4,5]),we=!0}return T(),l.getToken()!==4?L(8,[4],[]):m(),!0}function ce(){switch(l.getToken()){case 3:return oe();case 1:return te();case 10:return B(!0);default:return J()}}return m(),l.getToken()===17?r.allowEmptyContent?!0:(L(4,[],[]),!1):ce()?(l.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=w;function R(t,d){const r=b(t),l=[];let c,S=0,n;do switch(n=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:S!==n&&l.push(t.substring(S,n)),d!==void 0&&l.push(r.getTokenValue().replace(/[^\r\n]/g,d)),S=r.getPosition();break}while(c!==17);return l.join("")}e.stripComments=R;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ie[28],ke([1,0]),function(ne,e){"use strict";var i,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function F(g,a,o){let u=g.get(a);return u===void 0&&(u=o,g.set(a,u)),u}e.getOrSet=F;function b(g){const a=[];return g.forEach((o,u)=>{a.push(`${u} => ${o}`)}),`Map(${g.size}) {${a.join(", ")}}`}e.mapToString=b;function A(g){const a=[];return g.forEach(o=>{a.push(o)}),`Set(${g.size}) {${a.join(", ")}}`}e.setToString=A;class _{constructor(a,o){this.uri=a,this.value=o}}class I{constructor(a,o){this[i]="ResourceMap",a instanceof I?(this.map=new Map(a.map),this.toKey=o??I.defaultToKey):(this.map=new Map,this.toKey=a??I.defaultToKey)}set(a,o){return this.map.set(this.toKey(a),new _(a,o)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,o){typeof o<"u"&&(a=a.bind(o));for(const[u,p]of this.map)a(p.value,p.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}I.defaultToKey=g=>g.toString(),e.ResourceMap=I;class N{constructor(a,o){this[k]="ResourceSet",!a||typeof a=="function"?this._map=new I(a):(this._map=new I(o),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,o){this._map.forEach((u,p)=>a.call(o,p,p,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var y;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class h{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,o=0){const u=this._map.get(a);if(!!u)return o!==0&&this.touch(u,o),u.value}set(a,o,u=0){let p=this._map.get(a);if(p)p.value=o,u!==0&&this.touch(p,u);else{switch(p={key:a,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(a,p),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const o=this._map.get(a);if(!!o)return this._map.delete(a),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,o){const u=this._state;let p=this._head;for(;p;){if(o?a.bind(o)(p.value,p.key,this):a(p.value,p.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const a=this,o=this._state;let u=this._head;const p={[Symbol.iterator](){return p},next(){if(a._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:u.key,done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return p}values(){const a=this,o=this._state;let u=this._head;const p={[Symbol.iterator](){return p},next(){if(a._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:u.value,done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return p}entries(){const a=this,o=this._state;let u=this._head;const p={[Symbol.iterator](){return p},next(){if(a._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:[u.key,u.value],done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return p}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>a;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const o=a.next,u=a.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}a.next=void 0,a.previous=void 0,this._state++}touch(a,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(a===this._head)return;const u=a.next,p=a.previous;a===this._tail?(p.next=void 0,this._tail=p):(u.previous=p,p.next=u),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(o===2){if(a===this._tail)return;const u=a.next,p=a.previous;a===this._head?(u.previous=void 0,this._head=u):(u.previous=p,p.next=u),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((o,u)=>{a.push([u,o])}),a}fromJSON(a){this.clear();for(const[o,u]of a)this.set(o,u)}}e.LinkedMap=h;class E extends h{constructor(a,o=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,o=2){return super.get(a,o)}peek(a){return super.get(a,0)}set(a,o){return super.set(a,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[112],ke([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(Te,De){for(var _e=0;_e<De.length;_e++){var ae=De[_e];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Te,ae.key,ae)}}function i(Te,De,_e){return De&&e(Te.prototype,De),_e&&e(Te,_e),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function k(Te,De){if(!!Te){if(typeof Te=="string")return D(Te,De);var _e=Object.prototype.toString.call(Te).slice(8,-1);if(_e==="Object"&&Te.constructor&&(_e=Te.constructor.name),_e==="Map"||_e==="Set")return Array.from(Te);if(_e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_e))return D(Te,De)}}function D(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var _e=0,ae=new Array(De);_e<De;_e++)ae[_e]=Te[_e];return ae}function F(Te,De){var _e=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(_e)return(_e=_e.call(Te)).next.bind(_e);if(Array.isArray(Te)||(_e=k(Te))||De&&Te&&typeof Te.length=="number"){_e&&(Te=_e);var ae=0;return function(){return ae>=Te.length?{done:!0}:{done:!1,value:Te[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function b(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=b();function A(Te){ne.defaults=Te}var _=/[&<>"']/,I=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(De){return h[De]};function g(Te,De){if(De){if(_.test(Te))return Te.replace(I,E)}else if(N.test(Te))return Te.replace(y,E);return Te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(a,function(De,_e){return _e=_e.toLowerCase(),_e==="colon"?":":_e.charAt(0)==="#"?_e.charAt(1)==="x"?String.fromCharCode(parseInt(_e.substring(2),16)):String.fromCharCode(+_e.substring(1)):""})}var u=/(^|[^\[])\^/g;function p(Te,De){Te=typeof Te=="string"?Te:Te.source,De=De||"";var _e={replace:function(ue,ee){return ee=ee.source||ee,ee=ee.replace(u,"$1"),Te=Te.replace(ue,ee),_e},getRegex:function(){return new RegExp(Te,De)}};return _e}var w=/[^\w:]/g,R=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Te,De,_e){if(Te){var ae;try{ae=decodeURIComponent(o(_e)).replace(w,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}De&&!R.test(_e)&&(_e=c(De,_e));try{_e=encodeURI(_e).replace(/%25/g,"%")}catch{return null}return _e}var t={},d=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Te,De){t[" "+Te]||(d.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=f(Te,"/",!0)),Te=t[" "+Te];var _e=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?_e?De:Te.replace(r,"$1")+De:De.charAt(0)==="/"?_e?De:Te.replace(l,"$1")+De:Te+De}var S={exec:function(){}};function n(Te){for(var De=1,_e,ae;De<arguments.length;De++){_e=arguments[De];for(ae in _e)Object.prototype.hasOwnProperty.call(_e,ae)&&(Te[ae]=_e[ae])}return Te}function s(Te,De){var _e=Te.replace(/\|/g,function(ee,C,U){for(var $=!1,W=C;--W>=0&&U[W]==="\\";)$=!$;return $?"|":" |"}),ae=_e.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>De)ae.splice(De);else for(;ae.length<De;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function f(Te,De,_e){var ae=Te.length;if(ae===0)return"";for(var ue=0;ue<ae;){var ee=Te.charAt(ae-ue-1);if(ee===De&&!_e)ue++;else if(ee!==De&&_e)ue++;else break}return Te.slice(0,ae-ue)}function P(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var _e=Te.length,ae=0,ue=0;ue<_e;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===De[0])ae++;else if(Te[ue]===De[1]&&(ae--,ae<0))return ue;return-1}function T(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(Te,De){if(De<1)return"";for(var _e="";De>1;)De&1&&(_e+=Te),De>>=1,Te+=Te;return _e+Te}function Q(Te,De,_e,ae){var ue=De.href,ee=De.title?g(De.title):null,C=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ae.state.inLink=!0;var U={type:"link",raw:_e,href:ue,title:ee,text:C,tokens:ae.inlineTokens(C)};return ae.state.inLink=!1,U}return{type:"image",raw:_e,href:ue,title:ee,text:g(C)}}function Z(Te,De){var _e=Te.match(/^(\s+)(?:```)/);if(_e===null)return De;var ae=_e[1];return De.split(`
`).map(function(ue){var ee=ue.match(/^\s+/);if(ee===null)return ue;var C=ee[0];return C.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var Y=function(){function Te(_e){this.options=_e||ne.defaults}var De=Te.prototype;return De.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},De.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:f(ee,`
`)}}},De.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var ee=ue[0],C=Z(ee,ue[3]||"");return{type:"code",raw:ee,lang:ue[2]?ue[2].trim():ue[2],text:C}}},De.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var ee=ue[2].trim();if(/#$/.test(ee)){var C=f(ee,"#");(this.options.pedantic||!C||/ $/.test(C))&&(ee=C.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:ee,tokens:this.lexer.inline(ee)}}},De.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var ee=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},De.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var ee,C,U,$,W,ie,fe,ye,le,ve,Ee,ze,He=ue[1].trim(),it=He.length>1,Ge={type:"list",raw:"",ordered:it,start:it?+He.slice(0,-1):"",loose:!1,items:[]};He=it?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=it?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(ze=!1,!(!(ue=et.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=ue[0],ae=ae.substring(ee.length),ye=ue[2].split(`
`,1)[0],le=ae.split(`
`,1)[0],this.options.pedantic?($=2,Ee=ye.trimLeft()):($=ue[2].search(/[^ ]/),$=$>4?1:$,Ee=ye.slice($),$+=ue[1].length),ie=!1,!ye&&/^ *$/.test(le)&&(ee+=le+`
`,ae=ae.substring(le.length+1),ze=!0),!ze)for(var nt=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Fe=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:```|~~~)"),K=new RegExp("^ {0,"+Math.min(3,$-1)+"}#");ae&&(ve=ae.split(`
`,1)[0],ye=ve,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ye)||K.test(ye)||nt.test(ye)||Fe.test(ae)));){if(ye.search(/[^ ]/)>=$||!ye.trim())Ee+=`
`+ye.slice($);else if(!ie)Ee+=`
`+ye;else break;!ie&&!ye.trim()&&(ie=!0),ee+=ve+`
`,ae=ae.substring(ve.length+1)}Ge.loose||(fe?Ge.loose=!0:/\n *\n *$/.test(ee)&&(fe=!0)),this.options.gfm&&(C=/^\[[ xX]\] /.exec(Ee),C&&(U=C[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ee,task:!!C,checked:U,loose:!1,text:Ee}),Ge.raw+=ee}Ge.items[Ge.items.length-1].raw=ee.trimRight(),Ge.items[Ge.items.length-1].text=Ee.trimRight(),Ge.raw=Ge.raw.trimRight();var X=Ge.items.length;for(W=0;W<X;W++){this.lexer.state.top=!1,Ge.items[W].tokens=this.lexer.blockTokens(Ge.items[W].text,[]);var pe=Ge.items[W].tokens.filter(function(Ue){return Ue.type==="space"}),$e=pe.every(function(Ue){for(var Xe=Ue.raw.split(""),je=0,tt=F(Xe),at;!(at=tt()).done;){var bt=at.value;if(bt===`
`&&(je+=1),je>1)return!0}return!1});!Ge.loose&&pe.length&&$e&&(Ge.loose=!0,Ge.items[W].loose=!0)}return Ge}},De.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var C=this.options.sanitizer?this.options.sanitizer(ue[0]):g(ue[0]);ee.type="paragraph",ee.text=C,ee.tokens=this.lexer.inline(C)}return ee}},De.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var ee={type:"table",header:s(ue[1]).map(function(fe){return{text:fe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ue[0];var C=ee.align.length,U,$,W,ie;for(U=0;U<C;U++)/^ *-+: *$/.test(ee.align[U])?ee.align[U]="right":/^ *:-+: *$/.test(ee.align[U])?ee.align[U]="center":/^ *:-+ *$/.test(ee.align[U])?ee.align[U]="left":ee.align[U]=null;for(C=ee.rows.length,U=0;U<C;U++)ee.rows[U]=s(ee.rows[U],ee.header.length).map(function(fe){return{text:fe}});for(C=ee.header.length,$=0;$<C;$++)ee.header[$].tokens=this.lexer.inline(ee.header[$].text);for(C=ee.rows.length,$=0;$<C;$++)for(ie=ee.rows[$],W=0;W<ie.length;W++)ie[W].tokens=this.lexer.inline(ie[W].text);return ee}}},De.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},De.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var ee=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:ee,tokens:this.lexer.inline(ee)}}},De.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},De.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:g(ue[1])}},De.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):g(ue[0]):ue[0]}},De.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var C=f(ee.slice(0,-1),"\\");if((ee.length-C.length)%2===0)return}else{var U=P(ue[2],"()");if(U>-1){var $=ue[0].indexOf("!")===0?5:4,W=$+ue[1].length+U;ue[2]=ue[2].substring(0,U),ue[0]=ue[0].substring(0,W).trim(),ue[3]=""}}var ie=ue[2],fe="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ie);ye&&(ie=ye[1],fe=ye[3])}else fe=ue[3]?ue[3].slice(1,-1):"";return ie=ie.trim(),/^</.test(ie)&&(this.options.pedantic&&!/>$/.test(ee)?ie=ie.slice(1):ie=ie.slice(1,-1)),Q(ue,{href:ie&&ie.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(ae,ue){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var C=(ee[2]||ee[1]).replace(/\s+/g," ");if(C=ue[C.toLowerCase()],!C||!C.href){var U=ee[0].charAt(0);return{type:"text",raw:U,text:U}}return Q(ee,C,ee[0],this.lexer)}},De.emStrong=function(ae,ue,ee){ee===void 0&&(ee="");var C=this.rules.inline.emStrong.lDelim.exec(ae);if(!!C&&!(C[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=C[1]||C[2]||"";if(!U||U&&(ee===""||this.rules.inline.punctuation.exec(ee))){var $=C[0].length-1,W,ie,fe=$,ye=0,le=C[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,ue=ue.slice(-1*ae.length+$);(C=le.exec(ue))!=null;)if(W=C[1]||C[2]||C[3]||C[4]||C[5]||C[6],!!W){if(ie=W.length,C[3]||C[4]){fe+=ie;continue}else if((C[5]||C[6])&&$%3&&!(($+ie)%3)){ye+=ie;continue}if(fe-=ie,!(fe>0)){if(ie=Math.min(ie,ie+fe+ye),Math.min($,ie)%2){var ve=ae.slice(1,$+C.index+ie);return{type:"em",raw:ae.slice(0,$+C.index+ie+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var Ee=ae.slice(2,$+C.index+ie-1);return{type:"strong",raw:ae.slice(0,$+C.index+ie+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},De.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var ee=ue[2].replace(/\n/g," "),C=/[^ ]/.test(ee),U=/^ /.test(ee)&&/ $/.test(ee);return C&&U&&(ee=ee.substring(1,ee.length-1)),ee=g(ee,!0),{type:"codespan",raw:ue[0],text:ee}}},De.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},De.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},De.autolink=function(ae,ue){var ee=this.rules.inline.autolink.exec(ae);if(ee){var C,U;return ee[2]==="@"?(C=g(this.options.mangle?ue(ee[1]):ee[1]),U="mailto:"+C):(C=g(ee[1]),U=C),{type:"link",raw:ee[0],text:C,href:U,tokens:[{type:"text",raw:C,text:C}]}}},De.url=function(ae,ue){var ee;if(ee=this.rules.inline.url.exec(ae)){var C,U;if(ee[2]==="@")C=g(this.options.mangle?ue(ee[0]):ee[0]),U="mailto:"+C;else{var $;do $=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while($!==ee[0]);C=g(ee[0]),ee[1]==="www."?U="http://"+C:U=C}return{type:"link",raw:ee[0],text:C,href:U,tokens:[{type:"text",raw:C,text:C}]}}},De.inlineText=function(ae,ue){var ee=this.rules.inline.text.exec(ae);if(ee){var C;return this.lexer.state.inRawBlock?C=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):g(ee[0]):ee[0]:C=g(this.options.smartypants?ue(ee[0]):ee[0]),{type:"text",raw:ee[0],text:C}}},Te}(),H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=p(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.listItemStart=p(/^( *)(bull) */).replace("bull",H.bullet).getRegex(),H.list=p(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=p(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=p(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.blockquote=p(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=n({},H),H.gfm=n({},H.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.table=p(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.gfm.paragraph=p(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",H.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.pedantic=n({},H.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:p(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=p(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=p(H._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=p(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=p(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=p(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=p(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=p(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=p(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=p(O.reflink).replace("label",O._label).replace("ref",H._label).getRegex(),O.nolink=p(O.nolink).replace("ref",H._label).getRegex(),O.reflinkSearch=p(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=n({},O),O.pedantic=n({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=n({},O.normal,{escape:p(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=p(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=n({},O.gfm,{br:p(O.br).replace("{2,}","*").getRegex(),text:p(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function m(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function L(Te){var De="",_e,ae,ue=Te.length;for(_e=0;_e<ue;_e++)ae=Te.charCodeAt(_e),Math.random()>.5&&(ae="x"+ae.toString(16)),De+="&#"+ae+";";return De}var B=function(){function Te(_e){this.tokens=[],this.tokens.links=Object.create(null),this.options=_e||ne.defaults,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:H.normal,inline:O.normal};this.options.pedantic?(ae.block=H.pedantic,ae.inline=O.pedantic):this.options.gfm&&(ae.block=H.gfm,this.options.breaks?ae.inline=O.breaks:ae.inline=O.gfm),this.tokenizer.rules=ae}Te.lex=function(ae,ue){var ee=new Te(ue);return ee.lex(ae)},Te.lexInline=function(ae,ue){var ee=new Te(ue);return ee.inlineTokens(ae)};var De=Te.prototype;return De.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(fe,ye,le){return ye+"    ".repeat(le.length)});for(var C,U,$,W;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(C=fe.call({lexer:ee},ae,ue))?(ae=ae.substring(C.raw.length),ue.push(C),!0):!1}))){if(C=this.tokenizer.space(ae)){ae=ae.substring(C.raw.length),C.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(C);continue}if(C=this.tokenizer.code(ae)){ae=ae.substring(C.raw.length),U=ue[ue.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+C.raw,U.text+=`
`+C.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(C);continue}if(C=this.tokenizer.fences(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.heading(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.hr(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.blockquote(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.list(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.html(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.def(ae)){ae=ae.substring(C.raw.length),U=ue[ue.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+C.raw,U.text+=`
`+C.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[C.tag]||(this.tokens.links[C.tag]={href:C.href,title:C.title});continue}if(C=this.tokenizer.table(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.lheading(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if($=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,ye=ae.slice(1),le=void 0;ee.options.extensions.startBlock.forEach(function(ve){le=ve.call({lexer:this},ye),typeof le=="number"&&le>=0&&(fe=Math.min(fe,le))}),fe<1/0&&fe>=0&&($=ae.substring(0,fe+1))}(),this.state.top&&(C=this.tokenizer.paragraph($))){U=ue[ue.length-1],W&&U.type==="paragraph"?(U.raw+=`
`+C.raw,U.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(C),W=$.length!==ae.length,ae=ae.substring(C.raw.length);continue}if(C=this.tokenizer.text(ae)){ae=ae.substring(C.raw.length),U=ue[ue.length-1],U&&U.type==="text"?(U.raw+=`
`+C.raw,U.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):ue.push(C);continue}if(ae){var ie="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ie);break}else throw new Error(ie)}}return this.state.top=!0,ue},De.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},De.inlineTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]);var C,U,$,W=ae,ie,fe,ye;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(ie=this.tokenizer.rules.inline.reflinkSearch.exec(W))!=null;)le.includes(ie[0].slice(ie[0].lastIndexOf("[")+1,-1))&&(W=W.slice(0,ie.index)+"["+z("a",ie[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ie=this.tokenizer.rules.inline.blockSkip.exec(W))!=null;)W=W.slice(0,ie.index)+"["+z("a",ie[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ie=this.tokenizer.rules.inline.escapedEmSt.exec(W))!=null;)W=W.slice(0,ie.index)+"++"+W.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(fe||(ye=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(C=Ee.call({lexer:ee},ae,ue))?(ae=ae.substring(C.raw.length),ue.push(C),!0):!1}))){if(C=this.tokenizer.escape(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.tag(ae)){ae=ae.substring(C.raw.length),U=ue[ue.length-1],U&&C.type==="text"&&U.type==="text"?(U.raw+=C.raw,U.text+=C.text):ue.push(C);continue}if(C=this.tokenizer.link(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(C.raw.length),U=ue[ue.length-1],U&&C.type==="text"&&U.type==="text"?(U.raw+=C.raw,U.text+=C.text):ue.push(C);continue}if(C=this.tokenizer.emStrong(ae,W,ye)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.codespan(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.br(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.del(ae)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(C=this.tokenizer.autolink(ae,L)){ae=ae.substring(C.raw.length),ue.push(C);continue}if(!this.state.inLink&&(C=this.tokenizer.url(ae,L))){ae=ae.substring(C.raw.length),ue.push(C);continue}if($=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,ze=ae.slice(1),He=void 0;ee.options.extensions.startInline.forEach(function(it){He=it.call({lexer:this},ze),typeof He=="number"&&He>=0&&(Ee=Math.min(Ee,He))}),Ee<1/0&&Ee>=0&&($=ae.substring(0,Ee+1))}(),C=this.tokenizer.inlineText($,m)){ae=ae.substring(C.raw.length),C.raw.slice(-1)!=="_"&&(ye=C.raw.slice(-1)),fe=!0,U=ue[ue.length-1],U&&U.type==="text"?(U.raw+=C.raw,U.text+=C.text):ue.push(C);continue}if(ae){var ve="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},i(Te,null,[{key:"rules",get:function(){return{block:H,inline:O}}}]),Te}(),J=function(){function Te(_e){this.options=_e||ne.defaults}var De=Te.prototype;return De.code=function(ae,ue,ee){var C=(ue||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(ae,C);U!=null&&U!==ae&&(ee=!0,ae=U)}return ae=ae.replace(/\n$/,"")+`
`,C?'<pre><code class="'+this.options.langPrefix+g(C,!0)+'">'+(ee?ae:g(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:g(ae,!0))+`</code></pre>
`},De.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},De.html=function(ae){return ae},De.heading=function(ae,ue,ee,C){if(this.options.headerIds){var U=this.options.headerPrefix+C.slug(ee);return"<h"+ue+' id="'+U+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ae,ue,ee){var C=ue?"ol":"ul",U=ue&&ee!==1?' start="'+ee+'"':"";return"<"+C+U+`>
`+ae+"</"+C+`>
`},De.listitem=function(ae){return"<li>"+ae+`</li>
`},De.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ae){return"<p>"+ae+`</p>
`},De.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},De.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},De.tablecell=function(ae,ue){var ee=ue.header?"th":"td",C=ue.align?"<"+ee+' align="'+ue.align+'">':"<"+ee+">";return C+ae+("</"+ee+`>
`)},De.strong=function(ae){return"<strong>"+ae+"</strong>"},De.em=function(ae){return"<em>"+ae+"</em>"},De.codespan=function(ae){return"<code>"+ae+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ae){return"<del>"+ae+"</del>"},De.link=function(ae,ue,ee){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var C='<a href="'+g(ae)+'"';return ue&&(C+=' title="'+ue+'"'),C+=">"+ee+"</a>",C},De.image=function(ae,ue,ee){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var C='<img src="'+ae+'" alt="'+ee+'"';return ue&&(C+=' title="'+ue+'"'),C+=this.options.xhtml?"/>":">",C},De.text=function(ae){return ae},Te}(),me=function(){function Te(){}var De=Te.prototype;return De.strong=function(ae){return ae},De.em=function(ae){return ae},De.codespan=function(ae){return ae},De.del=function(ae){return ae},De.html=function(ae){return ae},De.text=function(ae){return ae},De.link=function(ae,ue,ee){return""+ee},De.image=function(ae,ue,ee){return""+ee},De.br=function(){return""},Te}(),te=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ae,ue){var ee=ae,C=0;if(this.seen.hasOwnProperty(ee)){C=this.seen[ae];do C++,ee=ae+"-"+C;while(this.seen.hasOwnProperty(ee))}return ue||(this.seen[ae]=C,this.seen[ee]=0),ee},De.slug=function(ae,ue){ue===void 0&&(ue={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,ue.dryrun)},Te}(),oe=function(){function Te(_e){this.options=_e||ne.defaults,this.options.renderer=this.options.renderer||new J,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new te}Te.parse=function(ae,ue){var ee=new Te(ue);return ee.parse(ae)},Te.parseInline=function(ae,ue){var ee=new Te(ue);return ee.parseInline(ae)};var De=Te.prototype;return De.parse=function(ae,ue){ue===void 0&&(ue=!0);var ee="",C,U,$,W,ie,fe,ye,le,ve,Ee,ze,He,it,Ge,et,nt,Fe,rt,K,X=ae.length;for(C=0;C<X;C++){if(Ee=ae[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(K=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),K!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){ee+=K||"";continue}switch(Ee.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,o(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(le="",ye="",W=Ee.header.length,U=0;U<W;U++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[U].tokens),{header:!0,align:Ee.align[U]});for(le+=this.renderer.tablerow(ye),ve="",W=Ee.rows.length,U=0;U<W;U++){for(fe=Ee.rows[U],ye="",ie=fe.length,$=0;$<ie;$++)ye+=this.renderer.tablecell(this.parseInline(fe[$].tokens),{header:!1,align:Ee.align[$]});ve+=this.renderer.tablerow(ye)}ee+=this.renderer.table(le,ve);continue}case"blockquote":{ve=this.parse(Ee.tokens),ee+=this.renderer.blockquote(ve);continue}case"list":{for(ze=Ee.ordered,He=Ee.start,it=Ee.loose,W=Ee.items.length,ve="",U=0;U<W;U++)et=Ee.items[U],nt=et.checked,Fe=et.task,Ge="",et.task&&(rt=this.renderer.checkbox(nt),it?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=rt+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=rt+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:rt}):Ge+=rt),Ge+=this.parse(et.tokens,it),ve+=this.renderer.listitem(Ge,Fe,nt);ee+=this.renderer.list(ve,ze,He);continue}case"html":{ee+=this.renderer.html(Ee.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ve=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;C+1<X&&ae[C+1].type==="text";)Ee=ae[++C],ve+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);ee+=ue?this.renderer.paragraph(ve):ve;continue}default:{var pe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(pe);return}else throw new Error(pe)}}}return ee},De.parseInline=function(ae,ue){ue=ue||this.renderer;var ee="",C,U,$,W=ae.length;for(C=0;C<W;C++){if(U=ae[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&($=this.options.extensions.renderers[U.type].call({parser:this},U),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){ee+=$||"";continue}switch(U.type){case"escape":{ee+=ue.text(U.text);break}case"html":{ee+=ue.html(U.text);break}case"link":{ee+=ue.link(U.href,U.title,this.parseInline(U.tokens,ue));break}case"image":{ee+=ue.image(U.href,U.title,U.text);break}case"strong":{ee+=ue.strong(this.parseInline(U.tokens,ue));break}case"em":{ee+=ue.em(this.parseInline(U.tokens,ue));break}case"codespan":{ee+=ue.codespan(U.text);break}case"br":{ee+=ue.br();break}case"del":{ee+=ue.del(this.parseInline(U.tokens,ue));break}case"text":{ee+=ue.text(U.text);break}default:{var ie='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(ie);return}else throw new Error(ie)}}}return ee},Te}();function ce(Te,De,_e){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(_e=De,De=null),De=n({},ce.defaults,De||{}),T(De),_e){var ae=De.highlight,ue;try{ue=B.lex(Te,De)}catch(W){return _e(W)}var ee=function(ie){var fe;if(!ie)try{De.walkTokens&&ce.walkTokens(ue,De.walkTokens),fe=oe.parse(ue,De)}catch(ye){ie=ye}return De.highlight=ae,ie?_e(ie):_e(null,fe)};if(!ae||ae.length<3||(delete De.highlight,!ue.length))return ee();var C=0;ce.walkTokens(ue,function(W){W.type==="code"&&(C++,setTimeout(function(){ae(W.text,W.lang,function(ie,fe){if(ie)return ee(ie);fe!=null&&fe!==W.text&&(W.text=fe,W.escaped=!0),C--,C===0&&ee()})},0))}),C===0&&ee();return}function U(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+g(W.message+"",!0)+"</pre>";throw W}try{var $=B.lex(Te,De);if(De.walkTokens){if(De.async)return Promise.all(ce.walkTokens($,De.walkTokens)).then(function(){return oe.parse($,De)}).catch(U);ce.walkTokens($,De.walkTokens)}return oe.parse($,De)}catch(W){U(W)}}ce.options=ce.setOptions=function(Te){return n(ce.defaults,Te),A(ce.defaults),ce},ce.getDefaults=b,ce.defaults=ne.defaults,ce.use=function(){for(var Te=arguments.length,De=new Array(Te),_e=0;_e<Te;_e++)De[_e]=arguments[_e];var ae=n.apply(void 0,[{}].concat(De)),ue=ce.defaults.extensions||{renderers:{},childTokens:{}},ee;De.forEach(function(C){if(C.extensions&&(ee=!0,C.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var W=ue.renderers?ue.renderers[$.name]:null;W?ue.renderers[$.name]=function(){for(var ie=arguments.length,fe=new Array(ie),ye=0;ye<ie;ye++)fe[ye]=arguments[ye];var le=$.renderer.apply(this,fe);return le===!1&&(le=W.apply(this,fe)),le}:ue.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[$.level]?ue[$.level].unshift($.tokenizer):ue[$.level]=[$.tokenizer],$.start&&($.level==="block"?ue.startBlock?ue.startBlock.push($.start):ue.startBlock=[$.start]:$.level==="inline"&&(ue.startInline?ue.startInline.push($.start):ue.startInline=[$.start]))}$.childTokens&&(ue.childTokens[$.name]=$.childTokens)})),C.renderer&&function(){var $=ce.defaults.renderer||new J,W=function(ye){var le=$[ye];$[ye]=function(){for(var ve=arguments.length,Ee=new Array(ve),ze=0;ze<ve;ze++)Ee[ze]=arguments[ze];var He=C.renderer[ye].apply($,Ee);return He===!1&&(He=le.apply($,Ee)),He}};for(var ie in C.renderer)W(ie);ae.renderer=$}(),C.tokenizer&&function(){var $=ce.defaults.tokenizer||new Y,W=function(ye){var le=$[ye];$[ye]=function(){for(var ve=arguments.length,Ee=new Array(ve),ze=0;ze<ve;ze++)Ee[ze]=arguments[ze];var He=C.tokenizer[ye].apply($,Ee);return He===!1&&(He=le.apply($,Ee)),He}};for(var ie in C.tokenizer)W(ie);ae.tokenizer=$}(),C.walkTokens){var U=ce.defaults.walkTokens;ae.walkTokens=function($){var W=[];return W.push(C.walkTokens.call(this,$)),U&&(W=W.concat(U.call(this,$))),W}}ee&&(ae.extensions=ue),ce.setOptions(ae)})},ce.walkTokens=function(Te,De){for(var _e=[],ae=function(){var U=ee.value;switch(_e=_e.concat(De.call(ce,U)),U.type){case"table":{for(var $=F(U.header),W;!(W=$()).done;){var ie=W.value;_e=_e.concat(ce.walkTokens(ie.tokens,De))}for(var fe=F(U.rows),ye;!(ye=fe()).done;)for(var le=ye.value,ve=F(le),Ee;!(Ee=ve()).done;){var ze=Ee.value;_e=_e.concat(ce.walkTokens(ze.tokens,De))}break}case"list":{_e=_e.concat(ce.walkTokens(U.items,De));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[U.type]?ce.defaults.extensions.childTokens[U.type].forEach(function(He){_e=_e.concat(ce.walkTokens(U[He],De))}):U.tokens&&(_e=_e.concat(ce.walkTokens(U.tokens,De)))}},ue=F(Te),ee;!(ee=ue()).done;)ae();return _e},ce.parseInline=function(Te,De){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=n({},ce.defaults,De||{}),T(De);try{var _e=B.lexInline(Te,De);return De.walkTokens&&ce.walkTokens(_e,De.walkTokens),oe.parseInline(_e,De)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+g(ae.message+"",!0)+"</pre>";throw ae}},ce.Parser=oe,ce.parser=oe.parse,ce.Renderer=J,ce.TextRenderer=me,ce.Lexer=B,ce.lexer=B.lex,ce.Tokenizer=Y,ce.Slugger=te,ce.parse=ce;var we=ce.options,V=ce.setOptions,q=ce.use,G=ce.walkTokens,de=ce.parseInline,Se=ce,Le=oe.parse,xe=B.lex;ne.Lexer=B,ne.Parser=oe,ne.Renderer=J,ne.Slugger=te,ne.TextRenderer=me,ne.Tokenizer=Y,ne.getDefaults=b,ne.lexer=xe,ne.marked=ce,ne.options=we,ne.parse=Se,ne.parseInline=de,ne.parser=Le,ne.setOptions=V,ne.use=q,ne.walkTokens=G,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Ie[113],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(A,_,I){return Math.min(Math.max(A,_),I)}e.clamp=i;function k(A,_){return(_+A%_)%_}e.rot=k;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class F{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=F;class b{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const I=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=b}),function(){function ne(D){const F=[];typeof D=="number"&&F.push("code/timeOrigin",D);function b(_){F.push(_,Date.now())}function A(){const _=[];for(let I=0;I<F.length;I+=2)_.push({name:F[I],startTime:F[I+1]});return _}return{mark:b,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const b of performance.getEntriesByType("mark"))F.push({name:b.name,startTime:Math.round(D+b.startTime)});return F}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function i(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=i(k))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var k in i)(typeof exports=="object"?exports:ne)[k]=i[k]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function i(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return ne[k].call(D.exports,D,D.exports,i),D.l=!0,D.exports}return i.m=ne,i.c=e,i.d=function(k,D,F){i.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:F})},i.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},i.t=function(k,D){if(1&D&&(k=i(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var F=Object.create(null);if(i.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var b in k)i.d(F,b,function(A){return k[A]}.bind(null,b));return F},i.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return i.d(D,"a",D),D},i.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},i.p="",i(i.s=0)}([function(ne,e,i){(function(k){var D;e=ne.exports=q,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,b=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],_=e.src=[],I=0,N=I++;_[N]="0|[1-9]\\d*";var y=I++;_[y]="[0-9]+";var h=I++;_[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=I++;_[E]="("+_[N]+")\\.("+_[N]+")\\.("+_[N]+")";var g=I++;_[g]="("+_[y]+")\\.("+_[y]+")\\.("+_[y]+")";var a=I++;_[a]="(?:"+_[N]+"|"+_[h]+")";var o=I++;_[o]="(?:"+_[y]+"|"+_[h]+")";var u=I++;_[u]="(?:-("+_[a]+"(?:\\."+_[a]+")*))";var p=I++;_[p]="(?:-?("+_[o]+"(?:\\."+_[o]+")*))";var w=I++;_[w]="[0-9A-Za-z-]+";var R=I++;_[R]="(?:\\+("+_[w]+"(?:\\."+_[w]+")*))";var v=I++,t="v?"+_[E]+_[u]+"?"+_[R]+"?";_[v]="^"+t+"$";var d="[v=\\s]*"+_[g]+_[p]+"?"+_[R]+"?",r=I++;_[r]="^"+d+"$";var l=I++;_[l]="((?:<|>)?=?)";var c=I++;_[c]=_[y]+"|x|X|\\*";var S=I++;_[S]=_[N]+"|x|X|\\*";var n=I++;_[n]="[v=\\s]*("+_[S]+")(?:\\.("+_[S]+")(?:\\.("+_[S]+")(?:"+_[u]+")?"+_[R]+"?)?)?";var s=I++;_[s]="[v=\\s]*("+_[c]+")(?:\\.("+_[c]+")(?:\\.("+_[c]+")(?:"+_[p]+")?"+_[R]+"?)?)?";var f=I++;_[f]="^"+_[l]+"\\s*"+_[n]+"$";var P=I++;_[P]="^"+_[l]+"\\s*"+_[s]+"$";var T=I++;_[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=I++;_[z]="(?:~>?)";var Q=I++;_[Q]="(\\s*)"+_[z]+"\\s+",A[Q]=new RegExp(_[Q],"g");var Z=I++;_[Z]="^"+_[z]+_[n]+"$";var Y=I++;_[Y]="^"+_[z]+_[s]+"$";var H=I++;_[H]="(?:\\^)";var O=I++;_[O]="(\\s*)"+_[H]+"\\s+",A[O]=new RegExp(_[O],"g");var m=I++;_[m]="^"+_[H]+_[n]+"$";var L=I++;_[L]="^"+_[H]+_[s]+"$";var B=I++;_[B]="^"+_[l]+"\\s*("+d+")$|^$";var J=I++;_[J]="^"+_[l]+"\\s*("+t+")$|^$";var me=I++;_[me]="(\\s*)"+_[l]+"\\s*("+d+"|"+_[n]+")",A[me]=new RegExp(_[me],"g");var te=I++;_[te]="^\\s*("+_[n]+")\\s+-\\s+("+_[n]+")\\s*$";var oe=I++;_[oe]="^\\s*("+_[s]+")\\s+-\\s+("+_[s]+")\\s*$";var ce=I++;_[ce]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)D(we,_[we]),A[we]||(A[we]=new RegExp(_[we]));function V(le,ve){if(le instanceof q)return le;if(typeof le!="string"||le.length>F||!(ve?A[r]:A[v]).test(le))return null;try{return new q(le,ve)}catch{return null}}function q(le,ve){if(le instanceof q){if(le.loose===ve)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof q))return new q(le,ve);D("SemVer",le,ve),this.loose=ve;var Ee=le.trim().match(ve?A[r]:A[v]);if(!Ee)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>b||this.major<0)throw new TypeError("Invalid major version");if(this.minor>b||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>b||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var He=+ze;if(He>=0&&He<b)return He}return ze}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=V,e.valid=function(le,ve){var Ee=V(le,ve);return Ee?Ee.version:null},e.clean=function(le,ve){var Ee=V(le.trim().replace(/^[=v]+/,""),ve);return Ee?Ee.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(le){return D("SemVer.compare",this.version,this.loose,le),le instanceof q||(le=new q(le,this.loose)),this.compareMain(le)||this.comparePre(le)},q.prototype.compareMain=function(le){return le instanceof q||(le=new q(le,this.loose)),de(this.major,le.major)||de(this.minor,le.minor)||de(this.patch,le.patch)},q.prototype.comparePre=function(le){if(le instanceof q||(le=new q(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ve=0;do{var Ee=this.prerelease[ve],ze=le.prerelease[ve];if(D("prerelease compare",ve,Ee,ze),Ee===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==ze)return de(Ee,ze)}while(++ve)},q.prototype.inc=function(le,ve){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ve,Ee,ze){typeof Ee=="string"&&(ze=Ee,Ee=void 0);try{return new q(le,Ee).inc(ve,ze).version}catch{return null}},e.diff=function(le,ve){if(Te(le,ve))return null;var Ee=V(le),ze=V(ve);if(Ee.prerelease.length||ze.prerelease.length){for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==ze[He])return"pre"+He;return"prerelease"}for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==ze[He])return He},e.compareIdentifiers=de;var G=/^[0-9]+$/;function de(le,ve){var Ee=G.test(le),ze=G.test(ve);return Ee&&ze&&(le=+le,ve=+ve),Ee&&!ze?-1:ze&&!Ee?1:le<ve?-1:le>ve?1:0}function Se(le,ve,Ee){return new q(le,Ee).compare(new q(ve,Ee))}function Le(le,ve,Ee){return Se(le,ve,Ee)>0}function xe(le,ve,Ee){return Se(le,ve,Ee)<0}function Te(le,ve,Ee){return Se(le,ve,Ee)===0}function De(le,ve,Ee){return Se(le,ve,Ee)!==0}function _e(le,ve,Ee){return Se(le,ve,Ee)>=0}function ae(le,ve,Ee){return Se(le,ve,Ee)<=0}function ue(le,ve,Ee,ze){var He;switch(ve){case"===":typeof le=="object"&&(le=le.version),typeof Ee=="object"&&(Ee=Ee.version),He=le===Ee;break;case"!==":typeof le=="object"&&(le=le.version),typeof Ee=="object"&&(Ee=Ee.version),He=le!==Ee;break;case"":case"=":case"==":He=Te(le,Ee,ze);break;case"!=":He=De(le,Ee,ze);break;case">":He=Le(le,Ee,ze);break;case">=":He=_e(le,Ee,ze);break;case"<":He=xe(le,Ee,ze);break;case"<=":He=ae(le,Ee,ze);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function ee(le,ve){if(le instanceof ee){if(le.loose===ve)return le;le=le.value}if(!(this instanceof ee))return new ee(le,ve);D("comparator",le,ve),this.loose=ve,this.parse(le),this.semver===C?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(le,ve){return de(ve,le)},e.major=function(le,ve){return new q(le,ve).major},e.minor=function(le,ve){return new q(le,ve).minor},e.patch=function(le,ve){return new q(le,ve).patch},e.compare=Se,e.compareLoose=function(le,ve){return Se(le,ve,!0)},e.rcompare=function(le,ve,Ee){return Se(ve,le,Ee)},e.sort=function(le,ve){return le.sort(function(Ee,ze){return e.compare(Ee,ze,ve)})},e.rsort=function(le,ve){return le.sort(function(Ee,ze){return e.rcompare(Ee,ze,ve)})},e.gt=Le,e.lt=xe,e.eq=Te,e.neq=De,e.gte=_e,e.lte=ae,e.cmp=ue,e.Comparator=ee;var C={};function U(le,ve){if(le instanceof U)return le.loose===ve?le:new U(le.raw,ve);if(le instanceof ee)return new U(le.value,ve);if(!(this instanceof U))return new U(le,ve);if(this.loose=ve,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function $(le){return!le||le.toLowerCase()==="x"||le==="*"}function W(le,ve,Ee,ze,He,it,Ge,et,nt,Fe,rt,K,X){return((ve=$(Ee)?"":$(ze)?">="+Ee+".0.0":$(He)?">="+Ee+"."+ze+".0":">="+ve)+" "+(et=$(nt)?"":$(Fe)?"<"+(+nt+1)+".0.0":$(rt)?"<"+nt+"."+(+Fe+1)+".0":K?"<="+nt+"."+Fe+"."+rt+"-"+K:"<="+et)).trim()}function ie(le,ve){for(var Ee=0;Ee<le.length;Ee++)if(!le[Ee].test(ve))return!1;if(ve.prerelease.length){for(Ee=0;Ee<le.length;Ee++)if(D(le[Ee].semver),le[Ee].semver!==C&&le[Ee].semver.prerelease.length>0){var ze=le[Ee].semver;if(ze.major===ve.major&&ze.minor===ve.minor&&ze.patch===ve.patch)return!0}return!1}return!0}function fe(le,ve,Ee){try{ve=new U(ve,Ee)}catch{return!1}return ve.test(le)}function ye(le,ve,Ee,ze){var He,it,Ge,et,nt;switch(le=new q(le,ze),ve=new U(ve,ze),Ee){case">":He=Le,it=ae,Ge=xe,et=">",nt=">=";break;case"<":He=xe,it=_e,Ge=Le,et="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(le,ve,ze))return!1;for(var Fe=0;Fe<ve.set.length;++Fe){var rt=ve.set[Fe],K=null,X=null;if(rt.forEach(function(pe){pe.semver===C&&(pe=new ee(">=0.0.0")),K=K||pe,X=X||pe,He(pe.semver,K.semver,ze)?K=pe:Ge(pe.semver,X.semver,ze)&&(X=pe)}),K.operator===et||K.operator===nt||(!X.operator||X.operator===et)&&it(le,X.semver)||X.operator===nt&&Ge(le,X.semver))return!1}return!0}ee.prototype.parse=function(le){var ve=this.loose?A[B]:A[J],Ee=le.match(ve);if(!Ee)throw new TypeError("Invalid comparator: "+le);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new q(Ee[2],this.loose):this.semver=C},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(le){return D("Comparator.test",le,this.loose),this.semver===C||(typeof le=="string"&&(le=new q(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(le,ve){if(!(le instanceof ee))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new U(le.value,ve),fe(this.value,Ee,ve);if(le.operator==="")return Ee=new U(this.value,ve),fe(le.semver,Ee,ve);var ze=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),it=this.semver.version===le.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),et=ue(this.semver,"<",le.semver,ve)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),nt=ue(this.semver,">",le.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return ze||He||it&&Ge||et||nt},e.Range=U,U.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},U.prototype.toString=function(){return this.range},U.prototype.parseRange=function(le){var ve=this.loose;le=le.trim(),D("range",le,ve);var Ee=ve?A[oe]:A[te];le=le.replace(Ee,W),D("hyphen replace",le),le=le.replace(A[me],"$1$2$3"),D("comparator trim",le,A[me]),le=(le=(le=le.replace(A[Q],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var ze=ve?A[B]:A[J],He=le.split(" ").map(function(it){return function(Ge,et){return D("comp",Ge),Ge=function(nt,Fe){return nt.trim().split(/\s+/).map(function(rt){return function(K,X){D("caret",K,X);var pe=X?A[L]:A[m];return K.replace(pe,function($e,Ue,Xe,je,tt){var at;return D("caret",K,$e,Ue,Xe,je,tt),$(Ue)?at="":$(Xe)?at=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":$(je)?at=Ue==="0"?">="+Ue+"."+Xe+".0 <"+Ue+"."+(+Xe+1)+".0":">="+Ue+"."+Xe+".0 <"+(+Ue+1)+".0.0":tt?(D("replaceCaret pr",tt),tt.charAt(0)!=="-"&&(tt="-"+tt),at=Ue==="0"?Xe==="0"?">="+Ue+"."+Xe+"."+je+tt+" <"+Ue+"."+Xe+"."+(+je+1):">="+Ue+"."+Xe+"."+je+tt+" <"+Ue+"."+(+Xe+1)+".0":">="+Ue+"."+Xe+"."+je+tt+" <"+(+Ue+1)+".0.0"):(D("no pr"),at=Ue==="0"?Xe==="0"?">="+Ue+"."+Xe+"."+je+" <"+Ue+"."+Xe+"."+(+je+1):">="+Ue+"."+Xe+"."+je+" <"+Ue+"."+(+Xe+1)+".0":">="+Ue+"."+Xe+"."+je+" <"+(+Ue+1)+".0.0"),D("caret return",at),at})}(rt,Fe)}).join(" ")}(Ge,et),D("caret",Ge),Ge=function(nt,Fe){return nt.trim().split(/\s+/).map(function(rt){return function(K,X){var pe=X?A[Y]:A[Z];return K.replace(pe,function($e,Ue,Xe,je,tt){var at;return D("tilde",K,$e,Ue,Xe,je,tt),$(Ue)?at="":$(Xe)?at=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":$(je)?at=">="+Ue+"."+Xe+".0 <"+Ue+"."+(+Xe+1)+".0":tt?(D("replaceTilde pr",tt),tt.charAt(0)!=="-"&&(tt="-"+tt),at=">="+Ue+"."+Xe+"."+je+tt+" <"+Ue+"."+(+Xe+1)+".0"):at=">="+Ue+"."+Xe+"."+je+" <"+Ue+"."+(+Xe+1)+".0",D("tilde return",at),at})}(rt,Fe)}).join(" ")}(Ge,et),D("tildes",Ge),Ge=function(nt,Fe){return D("replaceXRanges",nt,Fe),nt.split(/\s+/).map(function(rt){return function(K,X){K=K.trim();var pe=X?A[P]:A[f];return K.replace(pe,function($e,Ue,Xe,je,tt,at){D("xRange",K,$e,Ue,Xe,je,tt,at);var bt=$(Xe),Ct=bt||$(je),Dt=Ct||$(tt);return Ue==="="&&Dt&&(Ue=""),bt?$e=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&Dt?(Ct&&(je=0),Dt&&(tt=0),Ue===">"?(Ue=">=",Ct?(Xe=+Xe+1,je=0,tt=0):Dt&&(je=+je+1,tt=0)):Ue==="<="&&(Ue="<",Ct?Xe=+Xe+1:je=+je+1),$e=Ue+Xe+"."+je+"."+tt):Ct?$e=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":Dt&&($e=">="+Xe+"."+je+".0 <"+Xe+"."+(+je+1)+".0"),D("xRange return",$e),$e})}(rt,Fe)}).join(" ")}(Ge,et),D("xrange",Ge),Ge=function(nt,Fe){return D("replaceStars",nt,Fe),nt.trim().replace(A[ce],"")}(Ge,et),D("stars",Ge),Ge}(it,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(it){return!!it.match(ze)})),He=He.map(function(it){return new ee(it,ve)})},U.prototype.intersects=function(le,ve){if(!(le instanceof U))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(ze){return le.set.some(function(He){return He.every(function(it){return ze.intersects(it,ve)})})})})},e.toComparators=function(le,ve){return new U(le,ve).set.map(function(Ee){return Ee.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},U.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new q(le,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ie(this.set[ve],le))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(le,ve,Ee){var ze=null,He=null;try{var it=new U(ve,Ee)}catch{return null}return le.forEach(function(Ge){it.test(Ge)&&(ze&&He.compare(Ge)!==-1||(He=new q(ze=Ge,Ee)))}),ze},e.minSatisfying=function(le,ve,Ee){var ze=null,He=null;try{var it=new U(ve,Ee)}catch{return null}return le.forEach(function(Ge){it.test(Ge)&&(ze&&He.compare(Ge)!==1||(He=new q(ze=Ge,Ee)))}),ze},e.validRange=function(le,ve){try{return new U(le,ve).range||"*"}catch{return null}},e.ltr=function(le,ve,Ee){return ye(le,ve,"<",Ee)},e.gtr=function(le,ve,Ee){return ye(le,ve,">",Ee)},e.outside=ye,e.prerelease=function(le,ve){var Ee=V(le,ve);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(le,ve,Ee){return le=new U(le,Ee),ve=new U(ve,Ee),le.intersects(ve)},e.coerce=function(le){if(le instanceof q)return le;if(typeof le!="string")return null;var ve=le.match(A[T]);return ve==null?null:V((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,i(1))},function(ne,e){var i,k,D=ne.exports={};function F(){throw new Error("setTimeout has not been defined")}function b(){throw new Error("clearTimeout has not been defined")}function A(o){if(i===setTimeout)return setTimeout(o,0);if((i===F||!i)&&setTimeout)return i=setTimeout,setTimeout(o,0);try{return i(o,0)}catch{try{return i.call(null,o,0)}catch{return i.call(this,o,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:F}catch{i=F}try{k=typeof clearTimeout=="function"?clearTimeout:b}catch{k=b}})();var _,I=[],N=!1,y=-1;function h(){N&&_&&(N=!1,_.length?I=_.concat(I):y=-1,I.length&&E())}function E(){if(!N){var o=A(h);N=!0;for(var u=I.length;u;){for(_=I,I=[];++y<u;)_&&_[y].run();y=-1,u=I.length}_=null,N=!1,function(p){if(k===clearTimeout)return clearTimeout(p);if((k===b||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(p);try{k(p)}catch{try{return k.call(null,p)}catch{return k.call(this,p)}}}(o)}}function g(o,u){this.fun=o,this.array=u}function a(){}D.nextTick=function(o){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];I.push(new g(o,u)),I.length!==1||N||A(E)},g.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=a,D.addListener=a,D.once=a,D.off=a,D.removeListener=a,D.removeAllListeners=a,D.emit=a,D.prependListener=a,D.prependOnceListener=a,D.listeners=function(o){return[]},D.binding=function(o){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(o){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ie[114],ke([1,0,11,6]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(R){const v=R;return v?typeof v.read=="function":!1}e.isReadable=D;function F(R){const v=R;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=F;function b(R){const v=R;return v?F(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=b;function A(R,v){return new _(R,v)}e.newWriteableStream=A;class _{constructor(v,t){this.reducer=v,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(t=>t(v))}emitError(v){this.listeners.error.length===0?(0,i.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(t=>t(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,t){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(v,t){if(this.state.destroyed)return;let d;switch(v){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const r=d.indexOf(t);r>=0&&d.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(R,v){const t=[];let d;for(;(d=R.read())!==null;)t.push(d);return v(t)}e.consumeReadable=I;function N(R,v,t){const d=[];let r;for(;(r=R.read())!==null&&d.length<t;)d.push(r);return r===null&&d.length>0?v(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r<"u"){const l=r;return r=void 0,l}return R.read()}}}e.peekReadable=N;function y(R,v){return new Promise((t,d)=>{const r=[];h(R,{onData:l=>{v&&r.push(l)},onError:l=>{v?d(l):t(void 0)},onEnd:()=>{t(v?v(r):void 0)}})})}e.consumeStream=y;function h(R,v){let t=!1;return R.on("error",d=>{t||v.onError(d)}),R.on("end",()=>{t||v.onEnd()}),R.on("data",d=>{t||v.onData(d)}),(0,k.toDisposable)(()=>t=!0)}e.listenStream=h;function E(R,v){return new Promise((t,d)=>{const r=new k.DisposableStore,l=[],c=s=>{if(l.push(s),l.length>v)return r.dispose(),R.pause(),t({stream:R,buffer:l,ended:!1})},S=s=>d(s),n=()=>t({stream:R,buffer:l,ended:!0});r.add((0,k.toDisposable)(()=>R.removeListener("error",S))),R.on("error",S),r.add((0,k.toDisposable)(()=>R.removeListener("end",n))),R.on("end",n),r.add((0,k.toDisposable)(()=>R.removeListener("data",c))),R.on("data",c)})}e.peekStream=E;function g(R,v){const t=A(v);return t.end(R),t}e.toStream=g;function a(){const R=A(()=>{throw new Error("not supported")});return R.end(),R}e.emptyStream=a;function o(R){let v=!1;return{read:()=>v?null:(v=!0,R)}}e.toReadable=o;function u(R,v,t){const d=A(t);return h(R,{onData:r=>d.write(v.data(r)),onError:r=>d.error(v.error?v.error(r):r),onEnd:()=>d.end()}),d}e.transform=u;function p(R,v,t){let d=!1;return{read:()=>{const r=v.read();return d?r:(d=!0,r!==null?t([R,r]):R)}}}e.prefixedReadable=p;function w(R,v,t){let d=!1;const r=A(t);return h(v,{onData:l=>d?r.write(l):(d=!0,r.write(t([R,l]))),onError:l=>r.error(l),onEnd:()=>{d||(d=!0,r.write(R)),r.end()}}),r}e.prefixedStream=w}),define(Ie[23],ke([1,0,114]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let D,F;class b{static alloc(s){return k?new b(Buffer.allocUnsafe(s)):new b(new Uint8Array(s))}static wrap(s){return k&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new b(s)}static fromString(s,f){return!(f?.dontUseNodeBuffer||!1)&&k?new b(Buffer.from(s)):(D||(D=new TextEncoder),new b(D.encode(s)))}static fromByteArray(s){const f=b.alloc(s.length);for(let P=0,T=s.length;P<T;P++)f.buffer[P]=s[P];return f}static concat(s,f){if(typeof f>"u"){f=0;for(let z=0,Q=s.length;z<Q;z++)f+=s[z].byteLength}const P=b.alloc(f);let T=0;for(let z=0,Q=s.length;z<Q;z++){const Z=s[z];P.set(Z,T),T+=Z.byteLength}return P}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=b.alloc(this.byteLength);return s.set(this),s}toString(){return k?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(s,f){return new b(this.buffer.subarray(s,f))}set(s,f){if(s instanceof b)this.buffer.set(s.buffer,f);else if(s instanceof Uint8Array)this.buffer.set(s,f);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),f);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return I(this.buffer,s)}writeUInt32BE(s,f){N(this.buffer,s,f)}readUInt32LE(s){return y(this.buffer,s)}writeUInt32LE(s,f){h(this.buffer,s,f)}readUInt8(s){return E(this.buffer,s)}writeUInt8(s,f){g(this.buffer,s,f)}}e.VSBuffer=b;function A(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}e.readUInt16LE=A;function _(n,s,f){n[f+0]=s&255,s=s>>>8,n[f+1]=s&255}e.writeUInt16LE=_;function I(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}e.readUInt32BE=I;function N(n,s,f){n[f+3]=s,s=s>>>8,n[f+2]=s,s=s>>>8,n[f+1]=s,s=s>>>8,n[f]=s}e.writeUInt32BE=N;function y(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}e.readUInt32LE=y;function h(n,s,f){n[f+0]=s&255,s=s>>>8,n[f+1]=s&255,s=s>>>8,n[f+2]=s&255,s=s>>>8,n[f+3]=s&255}e.writeUInt32LE=h;function E(n,s){return n[s]}e.readUInt8=E;function g(n,s,f){n[f]=s}e.writeUInt8=g;function a(n){return i.consumeReadable(n,s=>b.concat(s))}e.readableToBuffer=a;function o(n){return i.toReadable(n)}e.bufferToReadable=o;function u(n){return i.consumeStream(n,s=>b.concat(s))}e.streamToBuffer=u;async function p(n){return n.ended?b.concat(n.buffer):b.concat([...n.buffer,await u(n.stream)])}e.bufferedStreamToBuffer=p;function w(n){return i.toStream(n,s=>b.concat(s))}e.bufferToStream=w;function R(n){return i.transform(n,{data:s=>typeof s=="string"?b.fromString(s):b.wrap(s)},s=>b.concat(s))}e.streamToBufferReadableStream=R;function v(n){return i.newWriteableStream(s=>b.concat(s),n)}e.newWriteableBufferStream=v;function t(n,s){return i.prefixedReadable(n,s,f=>b.concat(f))}e.prefixedBufferReadable=t;function d(n,s){return i.prefixedStream(n,s,f=>b.concat(f))}e.prefixedBufferStream=d;function r(n){let s=0,f=0,P=0;const T=new Uint8Array(Math.floor(n.length/4*3)),z=Z=>{switch(f){case 3:T[P++]=s|Z,f=0;break;case 2:T[P++]=s|Z>>>2,s=Z<<6,f=3;break;case 1:T[P++]=s|Z>>>4,s=Z<<4,f=2;break;default:s=Z<<2,f=1}};for(let Z=0;Z<n.length;Z++){const Y=n.charCodeAt(Z);if(Y>=65&&Y<=90)z(Y-65);else if(Y>=97&&Y<=122)z(Y-97+26);else if(Y>=48&&Y<=57)z(Y-48+52);else if(Y===43||Y===45)z(62);else if(Y===47||Y===95)z(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${n[Z]}`)}}const Q=P;for(;f>0;)z(0);return b.wrap(T).slice(0,Q)}e.decodeBase64=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:n},s=!0,f=!1){const P=f?c:l;let T="";const z=n.byteLength%3;let Q=0;for(;Q<n.byteLength-z;Q+=3){const Z=n[Q+0],Y=n[Q+1],H=n[Q+2];T+=P[Z>>>2],T+=P[(Z<<4|Y>>>4)&63],T+=P[(Y<<2|H>>>6)&63],T+=P[H&63]}if(z===1){const Z=n[Q+0];T+=P[Z>>>2],T+=P[Z<<4&63],s&&(T+="==")}else if(z===2){const Z=n[Q+0],Y=n[Q+1];T+=P[Z>>>2],T+=P[(Z<<4|Y>>>4)&63],T+=P[Y<<2&63],s&&(T+="=")}return T}e.encodeBase64=S}),define(Ie[115],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ie[38],ke([1,0,84]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var k;(function(b){function A(_){return _&&typeof _=="object"&&typeof _.id=="string"}b.isThemeColor=A})(k=e.ThemeColor||(e.ThemeColor={}));function D(b){return{id:b}}e.themeColorFromId=D;var F;(function(b){b.iconNameSegment="[A-Za-z0-9]+",b.iconNameExpression="[A-Za-z0-9-]+",b.iconModifierExpression="~[A-Za-z]+",b.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${b.iconNameExpression})(${b.iconModifierExpression})?$`);function _(p){const w=A.exec(p.id);if(!w)return _(i.Codicon.error);const[,R,v]=w,t=["codicon","codicon-"+R];return v&&t.push("codicon-modifier-"+v.substring(1)),t}b.asClassNameArray=_;function I(p){return _(p).join(" ")}b.asClassName=I;function N(p){return"."+_(p).join(".")}b.asCSSSelector=N;function y(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||k.isThemeColor(p.color))}b.isThemeIcon=y;const h=new RegExp(`^\\$\\((${b.iconNameExpression}(?:${b.iconModifierExpression})?)\\)$`);function E(p){const w=h.exec(p);if(!w)return;const[,R]=w;return{id:R}}b.fromString=E;function g(p){return{id:p}}b.fromId=g;function a(p,w){let R=p.id;const v=R.lastIndexOf("~");return v!==-1&&(R=R.substring(0,v)),w&&(R=`${R}~${w}`),{id:R}}b.modify=a;function o(p){const w=p.id.lastIndexOf("~");if(w!==-1)return p.id.substring(w+1)}b.getModifier=o;function u(p,w){return p.id===w.id&&p.color?.id===w.color?.id}b.isEqual=u})(F=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ie[34],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return i.test(D)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(A){for(let _=0;_<A.length;_++)A[_]=Math.floor(Math.random()*256);return A};const F=new Uint8Array(16),b=[];for(let A=0;A<256;A++)b.push(A.toString(16).padStart(2,"0"));return function(){D(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let _=0,I="";return I+=b[F[_++]],I+=b[F[_++]],I+=b[F[_++]],I+=b[F[_++]],I+="-",I+=b[F[_++]],I+=b[F[_++]],I+="-",I+=b[F[_++]],I+=b[F[_++]],I+="-",I+=b[F[_++]],I+=b[F[_++]],I+="-",I+=b[F[_++]],I+=b[F[_++]],I+=b[F[_++]],I+=b[F[_++]],I+=b[F[_++]],I+=b[F[_++]],I}}()}),define(Ie[116],ke([1,0,16,34]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(A){return{id:(0,k.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=D;function F(A,_,I){return{id:(0,k.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:_,data:I}),value:void 0}}e.createFileDataTransferItem=F;class b{constructor(){this._entries=new Map}get size(){return this._entries.size}has(_){return this._entries.has(this.toKey(_))}get(_){return this._entries.get(this.toKey(_))?.[0]}append(_,I){const N=this._entries.get(_);N?N.push(I):this._entries.set(this.toKey(_),[I])}replace(_,I){this._entries.set(this.toKey(_),[I])}delete(_){this._entries.delete(this.toKey(_))}*entries(){for(const[_,I]of this._entries.entries())for(const N of I)yield[_,N]}values(){return Array.from(this._entries.values()).flat()}forEach(_){for(const[I,N]of this.entries())_(N,I)}toKey(_){return _.toLowerCase()}}e.VSDataTransfer=b,e.UriList=Object.freeze({create:A=>(0,i.distinct)(A.map(_=>_.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(_=>!_.startsWith("#"))})}),define(Ie[117],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[118],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(b){b[b.None=0]="None",b[b.Indent=1]="Indent",b[b.IndentOutdent=2]="IndentOutdent",b[b.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class k{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let _=0,I=A.notIn.length;_<I;_++)switch(A.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,_){if(A.getTokenCount()===0)return!0;const I=A.findTokenIndexAtOffset(_-2),N=A.getStandardTokenType(I);return this.isOK(N)}_findNeutralCharacterInRange(A,_){for(let I=A;I<=_;I++){const N=String.fromCharCode(I);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=k;class D{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of A)F(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),F(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),F(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),F(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&F(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=D;function F(b,A,_){b.has(A)?b.get(A).push(_):b.set(A,[_])}}),define(Ie[119],ke([13,14]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(Ie[120],ke([13,14]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Ie[121],ke([1,0,120]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,F=D*24,b=F*7,A=F*30,_=F*365;function I(y,h,E,g){typeof y!="number"&&(y=y.getTime());const a=Math.round((new Date().getTime()-y)/1e3);if(a<-30)return(0,i.localize)(0,null,I(new Date().getTime()+a*1e3,!1));if(!g&&a<30)return(0,i.localize)(1,null);let o;return a<k?(o=a,h?o===1?E?(0,i.localize)(2,null,o):(0,i.localize)(3,null,o):E?(0,i.localize)(4,null,o):(0,i.localize)(5,null,o):o===1?E?(0,i.localize)(6,null,o):(0,i.localize)(7,null,o):E?(0,i.localize)(8,null,o):(0,i.localize)(9,null,o)):a<D?(o=Math.floor(a/k),h?o===1?E?(0,i.localize)(10,null,o):(0,i.localize)(11,null,o):E?(0,i.localize)(12,null,o):(0,i.localize)(13,null,o):o===1?E?(0,i.localize)(14,null,o):(0,i.localize)(15,null,o):E?(0,i.localize)(16,null,o):(0,i.localize)(17,null,o)):a<F?(o=Math.floor(a/D),h?o===1?E?(0,i.localize)(18,null,o):(0,i.localize)(19,null,o):E?(0,i.localize)(20,null,o):(0,i.localize)(21,null,o):o===1?E?(0,i.localize)(22,null,o):(0,i.localize)(23,null,o):E?(0,i.localize)(24,null,o):(0,i.localize)(25,null,o)):a<b?(o=Math.floor(a/F),h?o===1?(0,i.localize)(26,null,o):(0,i.localize)(27,null,o):o===1?(0,i.localize)(28,null,o):(0,i.localize)(29,null,o)):a<A?(o=Math.floor(a/b),h?o===1?E?(0,i.localize)(30,null,o):(0,i.localize)(31,null,o):E?(0,i.localize)(32,null,o):(0,i.localize)(33,null,o):o===1?E?(0,i.localize)(34,null,o):(0,i.localize)(35,null,o):E?(0,i.localize)(36,null,o):(0,i.localize)(37,null,o)):a<_?(o=Math.floor(a/A),h?o===1?E?(0,i.localize)(38,null,o):(0,i.localize)(39,null,o):E?(0,i.localize)(40,null,o):(0,i.localize)(41,null,o):o===1?E?(0,i.localize)(42,null,o):(0,i.localize)(43,null,o):E?(0,i.localize)(44,null,o):(0,i.localize)(45,null,o)):(o=Math.floor(a/_),h?o===1?E?(0,i.localize)(46,null,o):(0,i.localize)(47,null,o):E?(0,i.localize)(48,null,o):(0,i.localize)(49,null,o):o===1?E?(0,i.localize)(50,null,o):(0,i.localize)(51,null,o):E?(0,i.localize)(52,null,o):(0,i.localize)(53,null,o))}e.fromNow=I;function N(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ie[122],ke([13,14]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Ie[39],ke([1,0,16,9,122]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(y,h){return h&&(y.stack||y.stacktrace)?D.localize(0,null,A(y),b(y.stack)||b(y.stacktrace)):A(y)}function b(y){return Array.isArray(y)?y.join(`
`):y}function A(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function _(y=null,h=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const E=i.coalesce(y),g=_(E[0],h);return E.length>1?D.localize(4,null,g,E.length):g}if(k.isString(y))return y;if(y.detail){const E=y.detail;if(E.error)return F(E.error,h);if(E.exception)return F(E.exception,h)}return y.stack?F(y,h):y.message?y.message:D.localize(5,null)}e.toErrorMessage=_;function I(y){const h=y;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=I;function N(y,h){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=h,E}e.createErrorWithActions=N}),define(Ie[123],ke([1,0,85,19]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new i.Lazy(()=>{const s=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:s,collatorIsNumeric:s.resolvedOptions().numeric}}),F=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),b=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(s,f,P=!1){const T=s||"",z=f||"",Q=D.value.collator.compare(T,z);return D.value.collatorIsNumeric&&Q===0&&T!==z?T<z?-1:1:Q}e.compareFileNames=A;function _(s,f){const P=F.value.collator;return s=s||"",f=f||"",R(P,s,f)}e.compareFileNamesDefault=_;function I(s,f){const P=F.value.collator;return s=s||"",f=f||"",r(s,f)||R(P,s,f)}e.compareFileNamesUpper=I;function N(s,f){const P=F.value.collator;return s=s||"",f=f||"",d(s,f)||R(P,s,f)}e.compareFileNamesLower=N;function y(s,f){return s=s||"",f=f||"",s===f?0:s<f?-1:1}e.compareFileNamesUnicode=y;function h(s,f){const[P,T]=p(s),[z,Q]=p(f);let Z=D.value.collator.compare(T,Q);if(Z===0){if(D.value.collatorIsNumeric&&T!==Q)return T<Q?-1:1;if(Z=D.value.collator.compare(P,z),D.value.collatorIsNumeric&&Z===0&&P!==z)return P<z?-1:1}return Z}e.compareFileExtensions=h;function E(s,f){s=s||"",f=f||"";const P=w(s),T=w(f),z=F.value.collator,Q=b.value.collator;return R(Q,P,T)||R(z,s,f)}e.compareFileExtensionsDefault=E;function g(s,f){s=s||"",f=f||"";const P=w(s),T=w(f),z=F.value.collator,Q=b.value.collator;return R(Q,P,T)||r(s,f)||R(z,s,f)}e.compareFileExtensionsUpper=g;function a(s,f){s=s||"",f=f||"";const P=w(s),T=w(f),z=F.value.collator,Q=b.value.collator;return R(Q,P,T)||d(s,f)||R(z,s,f)}e.compareFileExtensionsLower=a;function o(s,f){s=s||"",f=f||"";const P=w(s).toLowerCase(),T=w(f).toLowerCase();return P!==T?P<T?-1:1:s!==f?s<f?-1:1:0}e.compareFileExtensionsUnicode=o;const u=/^(.*?)(\.([^.]*))?$/;function p(s,f=!1){const P=s?u.exec(s):[];let T=[P&&P[1]||"",P&&P[3]||""];return f&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function w(s){const f=s?u.exec(s):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function R(s,f,P){const T=s.compare(f,P);return T!==0?T:f.length!==P.length?f.length<P.length?-1:1:0}function v(s){const f=s.charAt(0);return f.toLocaleUpperCase()!==f}function t(s){const f=s.charAt(0);return f.toLocaleLowerCase()!==f}function d(s,f){return v(s)&&t(f)?-1:t(s)&&v(f)?1:0}function r(s,f){return t(s)&&v(f)?-1:v(s)&&t(f)?1:0}function l(s,f,P=!1){return P||(s=s&&s.toLowerCase(),f=f&&f.toLowerCase()),s===f?0:s<f?-1:1}function c(s,f,P=!1){const T=s.split(k.sep),z=f.split(k.sep),Q=T.length-1,Z=z.length-1;let Y,H;for(let O=0;;O++){if(Y=Q===O,H=Z===O,Y&&H)return A(T[O],z[O],P);if(Y)return-1;if(H)return 1;const m=l(T[O],z[O],P);if(m!==0)return m}}e.comparePaths=c;function S(s,f,P){const T=s.toLowerCase(),z=f.toLowerCase(),Q=n(s,f,P);if(Q)return Q;const Z=T.endsWith(P),Y=z.endsWith(P);if(Z!==Y)return Z?-1:1;const H=A(T,z);return H!==0?H:T.localeCompare(z)}e.compareAnything=S;function n(s,f,P){const T=s.toLowerCase(),z=f.toLowerCase(),Q=T.startsWith(P),Z=z.startsWith(P);if(Q!==Z)return Q?-1:1;if(Q&&Z){if(T.length<z.length)return-1;if(T.length>z.length)return 1}return 0}e.compareByPrefix=n}),define(Ie[65],ke([1,0,19]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(N){const y=(0,i.extname)(N),h=k[y.toLowerCase()];return h!==void 0?h:b(N)}e.getMediaOrTextMime=F;function b(N){const y=(0,i.extname)(N);return D[y.toLowerCase()]}e.getMediaMime=b;function A(N){for(const y in D)if(D[y]===N)return y}e.getExtensionForMimeType=A;const _=/^(.+)\/(.+?)(;.+)?$/;function I(N,y){const h=_.exec(N);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:y?void 0:N}e.normalizeMimeType=I}),define(Ie[124],ke([1,0,4,6,119]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class F extends k.Disposable{constructor(h,E="",g="",a=!0,o){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=h,this._label=E,this._cssClass=g,this._enabled=a,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(h){this._setLabel(h)}_setLabel(h){this._label!==h&&(this._label=h,this._onDidChange.fire({label:h}))}get tooltip(){return this._tooltip||""}set tooltip(h){this._setTooltip(h)}_setTooltip(h){this._tooltip!==h&&(this._tooltip=h,this._onDidChange.fire({tooltip:h}))}get class(){return this._cssClass}set class(h){this._setClass(h)}_setClass(h){this._cssClass!==h&&(this._cssClass=h,this._onDidChange.fire({class:h}))}get enabled(){return this._enabled}set enabled(h){this._setEnabled(h)}_setEnabled(h){this._enabled!==h&&(this._enabled=h,this._onDidChange.fire({enabled:h}))}get checked(){return this._checked}set checked(h){this._setChecked(h)}_setChecked(h){this._checked!==h&&(this._checked=h,this._onDidChange.fire({checked:h}))}async run(h,E){this._actionCallback&&await this._actionCallback(h)}}e.Action=F;class b extends k.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(h,E){if(!h.enabled)return;this._onWillRun.fire({action:h});let g;try{await this.runAction(h,E)}catch(a){g=a}this._onDidRun.fire({action:h,error:g})}async runAction(h,E){await h.run(E)}}e.ActionRunner=b;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let E=[];for(const g of h)g.length&&(E.length?E=[...E,new A,...g]:E=g);return E}async run(){}}A.ID="vs.actions.separator",e.Separator=A;class _{get actions(){return this._actions}constructor(h,E,g,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=E,this.class=a,this._actions=g}async run(){}}e.SubmenuAction=_;class I extends F{constructor(){super(I.ID,D.localize(0,null),void 0,!1)}}I.ID="vs.actions.empty",e.EmptySubmenuAction=I;function N(y){return{id:y.id,label:y.label,class:void 0,enabled:y.enabled??!0,checked:y.checked??!1,run:async()=>y.run(),tooltip:y.label}}e.toAction=N}),define(Ie[40],ke([1,0,19,20,10,9]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function b(c){return c===47||c===92}e.isPathSeparator=b;function A(c){return c.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=A;function _(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=_;function I(c,S=i.posix.sep){if(!c)return"";const n=c.length,s=c.charCodeAt(0);if(b(s)){if(b(c.charCodeAt(1))&&!b(c.charCodeAt(2))){let P=3;const T=P;for(;P<n&&!b(c.charCodeAt(P));P++);if(T!==P&&!b(c.charCodeAt(P+1))){for(P+=1;P<n;P++)if(b(c.charCodeAt(P)))return c.slice(0,P+1).replace(/[\\/]/g,S)}}return S}else if(u(s)&&c.charCodeAt(1)===58)return b(c.charCodeAt(2))?c.slice(0,2)+S:c.slice(0,2);let f=c.indexOf("://");if(f!==-1){for(f+=3;f<n;f++)if(b(c.charCodeAt(f)))return c.slice(0,f+1)}return""}e.getRoot=I;function N(c){if(!k.isWindows||!c||c.length<5)return!1;let S=c.charCodeAt(0);if(S!==92||(S=c.charCodeAt(1),S!==92))return!1;let n=2;const s=n;for(;n<c.length&&(S=c.charCodeAt(n),S!==92);n++);return!(s===n||(S=c.charCodeAt(n+1),isNaN(S)||S===92))}e.isUNC=N;const y=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(c,S=k.isWindows){const n=S?y:h;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||S&&E.test(c)||c==="."||c===".."||S&&c[c.length-1]==="."||S&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=g;function a(c,S,n){const s=c===S;return!n||s?s:!c||!S?!1:(0,D.equalsIgnoreCase)(c,S)}e.isEqual=a;function o(c,S,n,s=i.sep){if(c===S)return!0;if(!c||!S||S.length>c.length)return!1;if(n){if(!(0,D.startsWithIgnoreCase)(c,S))return!1;if(S.length===c.length)return!0;let P=S.length;return S.charAt(S.length-1)===s&&P--,c.charAt(P)===s}return S.charAt(S.length-1)!==s&&(S+=s),c.indexOf(S)===0}e.isEqualOrParent=o;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=u;function p(c,S){return k.isWindows&&c.endsWith(":")&&(c+=i.sep),(0,i.isAbsolute)(c)||(c=(0,i.join)(S,c)),c=(0,i.normalize)(c),k.isWindows?(c=(0,D.rtrim)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,D.rtrim)(c,i.sep),c||(c=i.sep)),c}e.sanitizeFilePath=p;function w(c){const S=(0,i.normalize)(c);return k.isWindows?c.length>3?!1:R(S)&&(c.length===2||S.charCodeAt(2)===92):S===i.posix.sep}e.isRootOrDriveLetter=w;function R(c,S=k.isWindows){return S?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=R;function v(c){return R(c)?c[0]:void 0}e.getDriveLetter=v;function t(c,S,n){return S.length>c.length?-1:c===S?0:(n&&(c=c.toLowerCase(),S=S.toLowerCase()),c.indexOf(S))}e.indexOfPath=t;function d(c){const S=c.split(":");let n,s,f;for(const P of S){const T=Number(P);(0,F.isNumber)(T)?s===void 0?s=T:f===void 0&&(f=T):n=n?[n,P].join(":"):P}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:s!==void 0?s:void 0,column:f!==void 0?f:s!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(c,S,n=8){let s="";for(let P=0;P<n;P++)s+=r.charAt(Math.floor(Math.random()*r.length));let f;return S?f=`${S}-${s}`:f=s,c?(0,i.join)(c,f):f}e.randomPath=l}),define(Ie[125],ke([1,0,28,10]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ee){return function(C,U){for(let $=0,W=ee.length;$<W;$++){const ie=ee[$](C,U);if(ie)return ie}return null}}e.or=D,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(ee,C,U){if(!U||U.length<C.length)return null;let $;return ee?$=k.startsWithIgnoreCase(U,C):$=U.indexOf(C)===0,$?C.length>0?[{start:0,end:C.length}]:[]:null}function b(ee,C){const U=C.toLowerCase().indexOf(ee.toLowerCase());return U===-1?null:[{start:U,end:U+ee.length}]}e.matchesContiguousSubString=b;function A(ee,C){return _(ee.toLowerCase(),C.toLowerCase(),0,0)}e.matchesSubString=A;function _(ee,C,U,$){if(U===ee.length)return[];if($===C.length)return null;if(ee[U]===C[$]){let W=null;return(W=_(ee,C,U+1,$+1))?u({start:$,end:$+1},W):null}return _(ee,C,U,$+1)}function I(ee){return 97<=ee&&ee<=122}function N(ee){return 65<=ee&&ee<=90}e.isUpper=N;function y(ee){return 48<=ee&&ee<=57}function h(ee){return ee===32||ee===9||ee===10||ee===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>E.add(ee.charCodeAt(0)));function g(ee){return h(ee)||E.has(ee)}function a(ee,C){return ee===C||g(ee)&&g(C)}function o(ee){return I(ee)||N(ee)||y(ee)}function u(ee,C){return C.length===0?C=[ee]:ee.end===C[0].start?C[0].start=ee.start:C.unshift(ee),C}function p(ee,C){for(let U=C;U<ee.length;U++){const $=ee.charCodeAt(U);if(N($)||y($)||U>0&&!o(ee.charCodeAt(U-1)))return U}return ee.length}function w(ee,C,U,$){if(U===ee.length)return[];if($===C.length)return null;if(ee[U]!==C[$].toLowerCase())return null;{let W=null,ie=$+1;for(W=w(ee,C,U+1,$+1);!W&&(ie=p(C,ie))<C.length;)W=w(ee,C,U+1,ie),ie++;return W===null?null:u({start:$,end:$+1},W)}}function R(ee){let C=0,U=0,$=0,W=0,ie=0;for(let Ee=0;Ee<ee.length;Ee++)ie=ee.charCodeAt(Ee),N(ie)&&C++,I(ie)&&U++,o(ie)&&$++,y(ie)&&W++;const fe=C/ee.length,ye=U/ee.length,le=$/ee.length,ve=W/ee.length;return{upperPercent:fe,lowerPercent:ye,alphaPercent:le,numericPercent:ve}}function v(ee){const{upperPercent:C,lowerPercent:U}=ee;return U===0&&C>.6}function t(ee){const{upperPercent:C,lowerPercent:U,alphaPercent:$,numericPercent:W}=ee;return U>.2&&C<.8&&$>.6&&W<.2}function d(ee){let C=0,U=0,$=0,W=0;for(let ie=0;ie<ee.length;ie++)$=ee.charCodeAt(ie),N($)&&C++,I($)&&U++,h($)&&W++;return(C===0||U===0)&&W===0?ee.length<=30:C<=5}function r(ee,C){if(!C||(C=C.trim(),C.length===0)||!d(ee)||C.length>60)return null;const U=R(C);if(!t(U)){if(!v(U))return null;C=C.toLowerCase()}let $=null,W=0;for(ee=ee.toLowerCase();W<C.length&&($=w(ee,C,0,W))===null;)W=p(C,W+1);return $}e.matchesCamelCase=r;function l(ee,C,U=!1){if(!C||C.length===0)return null;let $=null,W=0;for(ee=ee.toLowerCase(),C=C.toLowerCase();W<C.length&&($=c(ee,C,0,W,U))===null;)W=S(C,W+1);return $}e.matchesWords=l;function c(ee,C,U,$,W){if(U===ee.length)return[];if($===C.length)return null;if(a(ee.charCodeAt(U),C.charCodeAt($))){let ie=null,fe=$+1;if(ie=c(ee,C,U+1,$+1,W),!W)for(;!ie&&(fe=S(C,fe))<C.length;)ie=c(ee,C,U+1,fe,W),fe++;return ie?ee.charCodeAt(U)!==C.charCodeAt($)?ie:u({start:$,end:$+1},ie):null}else return null}function S(ee,C){for(let U=C;U<ee.length;U++)if(g(ee.charCodeAt(U))||U>0&&g(ee.charCodeAt(U-1)))return U;return ee.length}const n=D(e.matchesPrefix,r,b),s=D(e.matchesPrefix,r,A),f=new i.LRUCache(1e4);function P(ee,C,U=!1){if(typeof ee!="string"||typeof C!="string")return null;let $=f.get(ee);$||($=new RegExp(k.convertSimple2RegExpPattern(ee),"i"),f.set(ee,$));const W=$.exec(C);return W?[{start:W.index,end:W.index+W[0].length}]:U?s(ee,C):n(ee,C)}e.matchesFuzzy=P;function T(ee,C){const U=Le(ee,ee.toLowerCase(),0,C,C.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?Q(U):null}e.matchesFuzzy2=T;function z(ee,C,U,$,W,ie){const fe=Math.min(13,ee.length);for(;U<fe;U++){const ye=Le(ee,C,U,$,W,ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ie]}e.anyScore=z;function Q(ee){if(typeof ee>"u")return[];const C=[],U=ee[1];for(let $=ee.length-1;$>1;$--){const W=ee[$]+U,ie=C[C.length-1];ie&&ie.end===W?ie.end=W+1:C.push({start:W,end:W+1})}return C}e.createMatches=Q;const Z=128;function Y(){const ee=[],C=[];for(let U=0;U<=Z;U++)C[U]=0;for(let U=0;U<=Z;U++)ee.push(C.slice(0));return ee}function H(ee){const C=[];for(let U=0;U<=ee;U++)C[U]=0;return C}const O=H(2*Z),m=H(2*Z),L=Y(),B=Y(),J=Y(),me=!1;function te(ee,C,U,$,W){function ie(ye,le,ve=" "){for(;ye.length<le;)ye=ve+ye;return ye}let fe=` |   |${$.split("").map(ye=>ie(ye,3)).join("|")}
`;for(let ye=0;ye<=U;ye++)ye===0?fe+=" |":fe+=`${C[ye-1]}|`,fe+=ee[ye].slice(0,W+1).map(le=>ie(le.toString(),3)).join("|")+`
`;return fe}function oe(ee,C,U,$){ee=ee.substr(C),U=U.substr($),console.log(te(B,ee,ee.length,U,U.length)),console.log(te(J,ee,ee.length,U,U.length)),console.log(te(L,ee,ee.length,U,U.length))}function ce(ee,C){if(C<0||C>=ee.length)return!1;const U=ee.codePointAt(C);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(U)}}function we(ee,C){if(C<0||C>=ee.length)return!1;switch(ee.charCodeAt(C)){case 32:case 9:return!0;default:return!1}}function V(ee,C,U){return C[ee]!==U[ee]}function q(ee,C,U,$,W,ie,fe=!1){for(;C<U&&W<ie;)ee[C]===$[W]&&(fe&&(O[C]=W),C+=1),W+=1;return C===U}e.isPatternInWord=q;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var de;(function(ee){ee.Default=[-100,0];function C(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}ee.isDefault=C})(de=e.FuzzyScore||(e.FuzzyScore={}));class Se{constructor(C,U){this.firstMatchCanBeWeak=C,this.boostFullMatch=U}}Se.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=Se;function Le(ee,C,U,$,W,ie,fe=Se.default){const ye=ee.length>Z?Z:ee.length,le=$.length>Z?Z:$.length;if(U>=ye||ie>=le||ye-U>le-ie||!q(C,U,ye,W,ie,le,!0))return;xe(ye,le,U,ie,C,W);let ve=1,Ee=1,ze=U,He=ie;const it=[!1];for(ve=1,ze=U;ze<ye;ve++,ze++){const rt=O[ze],K=m[ze],X=ze+1<ye?m[ze+1]:le;for(Ee=rt-ie+1,He=rt;He<X;Ee++,He++){let pe=Number.MIN_SAFE_INTEGER,$e=!1;He<=K&&(pe=Te(ee,C,ze,U,$,W,He,le,ie,L[ve-1][Ee-1]===0,it));let Ue=0;pe!==Number.MAX_SAFE_INTEGER&&($e=!0,Ue=pe+B[ve-1][Ee-1]);const Xe=He>rt,je=Xe?B[ve][Ee-1]+(L[ve][Ee-1]>0?-5:0):0,tt=He>rt+1&&L[ve][Ee-1]>0,at=tt?B[ve][Ee-2]+(L[ve][Ee-2]>0?-5:0):0;if(tt&&(!Xe||at>=je)&&(!$e||at>=Ue))B[ve][Ee]=at,J[ve][Ee]=3,L[ve][Ee]=0;else if(Xe&&(!$e||je>=Ue))B[ve][Ee]=je,J[ve][Ee]=2,L[ve][Ee]=0;else if($e)B[ve][Ee]=Ue,J[ve][Ee]=1,L[ve][Ee]=L[ve-1][Ee-1]+1;else throw new Error("not possible")}}if(me&&oe(ee,U,$,ie),!it[0]&&!fe.firstMatchCanBeWeak)return;ve--,Ee--;const Ge=[B[ve][Ee],ie];let et=0,nt=0;for(;ve>=1;){let rt=Ee;do{const K=J[ve][rt];if(K===3)rt=rt-2;else if(K===2)rt=rt-1;else break}while(rt>=1);et>1&&C[U+ve-1]===W[ie+Ee-1]&&!V(rt+ie-1,$,W)&&et+1>L[ve][rt]&&(rt=Ee),rt===Ee?et++:et=1,nt||(nt=rt),ve--,Ee=rt-1,Ge.push(Ee)}le===ye&&fe.boostFullMatch&&(Ge[0]+=2);const Fe=nt-ye;return Ge[0]-=Fe,Ge}e.fuzzyScore=Le;function xe(ee,C,U,$,W,ie){let fe=ee-1,ye=C-1;for(;fe>=U&&ye>=$;)W[fe]===ie[ye]&&(m[fe]=ye,fe--),ye--}function Te(ee,C,U,$,W,ie,fe,ye,le,ve,Ee){if(C[U]!==ie[fe])return Number.MIN_SAFE_INTEGER;let ze=1,He=!1;return fe===U-$?ze=ee[U]===W[fe]?7:5:V(fe,W,ie)&&(fe===0||!V(fe-1,W,ie))?(ze=ee[U]===W[fe]?7:5,He=!0):ce(ie,fe)&&(fe===0||!ce(ie,fe-1))?ze=5:(ce(ie,fe-1)||we(ie,fe-1))&&(ze=5,He=!0),ze>1&&U===$&&(Ee[0]=!0),He||(He=V(fe,W,ie)||ce(ie,fe-1)||we(ie,fe-1)),U===$?fe>le&&(ze-=He?3:5):ve?ze+=He?2:0:ze+=He?0:1,fe+1===ye&&(ze-=He?3:5),ze}function De(ee,C,U,$,W,ie,fe){return ae(ee,C,U,$,W,ie,!0,fe)}e.fuzzyScoreGracefulAggressive=De;function _e(ee,C,U,$,W,ie,fe){return ae(ee,C,U,$,W,ie,!1,fe)}e.fuzzyScoreGraceful=_e;function ae(ee,C,U,$,W,ie,fe,ye){let le=Le(ee,C,U,$,W,ie,ye);if(le&&!fe)return le;if(ee.length>=3){const ve=Math.min(7,ee.length-1);for(let Ee=U+1;Ee<ve;Ee++){const ze=ue(ee,Ee);if(ze){const He=Le(ze,ze.toLowerCase(),U,$,W,ie,ye);He&&(He[0]-=3,(!le||He[0]>le[0])&&(le=He))}}}return le}function ue(ee,C){if(C+1>=ee.length)return;const U=ee[C],$=ee[C+1];if(U!==$)return ee.slice(0,C)+$+U+ee.slice(C+2)}}),define(Ie[126],ke([1,0,125,10,38]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const F="$(",b=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${b.source}`,"g");function _(u){return u.replace(A,(p,w)=>w?p:`\\${p}`)}e.escapeIcons=_;const I=new RegExp(`\\\\${b.source}`,"g");function N(u){return u.replace(I,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=N;const y=new RegExp(`(\\s)?(\\\\)?${b.source}(\\s)?`,"g");function h(u){return u.indexOf(F)===-1?u:u.replace(y,(p,w,R,v)=>R?p:w||v||"")}e.stripIcons=h;function E(u){return u?u.replace(/\$\((.*?)\)/g,(p,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=E;const g=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(u){g.lastIndex=0;let p="";const w=[];let R=0;for(;;){const v=g.lastIndex,t=g.exec(u),d=u.substring(v,t?.index);if(d.length>0){p+=d;for(let r=0;r<d.length;r++)w.push(R)}if(!t)break;R+=t[0].length}return{text:p,iconOffsets:w}}e.parseLabelWithIcons=a;function o(u,p,w=!1){const{text:R,iconOffsets:v}=p;if(!v||v.length===0)return(0,i.matchesFuzzy)(u,R,w);const t=(0,k.ltrim)(R," "),d=R.length-t.length,r=(0,i.matchesFuzzy)(u,t,w);if(r)for(const l of r){const c=v[l.start+d]+d;l.start+=c,l.end+=c}return r}e.matchesFuzzyIconAware=o}),define(Ie[29],ke([1,0,10]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(k||(k={})),function(D){const F="error",b="warning",A="warn",_="info",I="ignore";function N(h){return h?i.equalsIgnoreCase(F,h)?D.Error:i.equalsIgnoreCase(b,h)||i.equalsIgnoreCase(A,h)?D.Warning:i.equalsIgnoreCase(_,h)?D.Info:D.Ignore:D.Ignore}D.fromValue=N;function y(h){switch(h){case D.Error:return F;case D.Warning:return b;case D.Info:return _;default:return I}}D.toString=y}(k||(k={})),e.default=k}),define(Ie[48],ke([1,0,16,10]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const g=E.charCodeAt(0),a=this._value.charCodeAt(this._pos);return g-a}value(){return this._value[this._pos]}}e.StringIterator=D;class F{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,k.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=F;class b{constructor(E=!0,g=!0){this._splitOnBackslash=E,this._caseSensitive=g}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let g=E.length-1;g>=0;g--,this._valueLen--){const a=this._value.charCodeAt(g);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,k.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var A;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(A||(A={}));class _{constructor(E,g){this._ignorePathCasing=E,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,k.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=_;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(N||(N={}));class y{static forUris(E=()=>!1,g=()=>!1){return new y(new _(E,g))}static forPaths(E=!1){return new y(new b(void 0,!E))}static forStrings(){return new y(new D)}static forConfigKeys(){return new y(new F)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,g){if(g){const a=g.slice(0);(0,i.shuffle)(a);for(const o of a)this.set(o,E)}else{const a=E.slice(0);(0,i.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(E,g){const a=this._iter.reset(E);let o;this._root||(this._root=new I,this._root.segment=a.value());const u=[];for(o=this._root;;){const w=a.cmp(o.segment);if(w>0)o.left||(o.left=new I,o.left.segment=a.value()),u.push([-1,o]),o=o.left;else if(w<0)o.right||(o.right=new I,o.right.segment=a.value()),u.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new I,o.mid.segment=a.value()),u.push([0,o]),o=o.mid;else break}const p=o.value;o.value=g,o.key=E;for(let w=u.length-1;w>=0;w--){const R=u[w][1];R.updateHeight();const v=R.balanceFactor();if(v<-1||v>1){const t=u[w][0],d=u[w+1][0];if(t===1&&d===1)u[w][1]=R.rotateLeft();else if(t===-1&&d===-1)u[w][1]=R.rotateRight();else if(t===1&&d===-1)R.right=u[w+1][1]=u[w+1][1].rotateRight(),u[w][1]=R.rotateLeft();else if(t===-1&&d===1)R.left=u[w+1][1]=u[w+1][1].rotateLeft(),u[w][1]=R.rotateRight();else throw new Error;if(w>0)switch(u[w-1][0]){case-1:u[w-1][1].left=u[w][1];break;case 1:u[w-1][1].right=u[w][1];break;case 0:u[w-1][1].mid=u[w][1];break}else this._root=u[0][1]}}return p}get(E){return this._getNode(E)?.value}_getNode(E){const g=this._iter.reset(E);let a=this._root;for(;a;){const o=g.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(g.hasNext())g.next(),a=a.mid;else break}return a}has(E){const g=this._getNode(E);return!(g?.value===void 0&&g?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,g){const a=this._iter.reset(E),o=[];let u=this._root;for(;u;){const p=a.cmp(u.segment);if(p>0)o.push([-1,u]),u=u.left;else if(p<0)o.push([1,u]),u=u.right;else if(a.hasNext())a.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(g?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this._min(u.right);if(p.key){const{key:w,value:R,segment:v}=p;this._delete(p.key,!1),u.key=w,u.value=R,u.segment=v}}else{const p=u.left??u.right;if(o.length>0){const[w,R]=o[o.length-1];switch(w){case-1:R.left=p;break;case 0:R.mid=p;break;case 1:R.right=p;break}}else this._root=p}for(let p=o.length-1;p>=0;p--){const w=o[p][1];w.updateHeight();const R=w.balanceFactor();if(R>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),o[p][1]=w.rotateLeft()):R<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),o[p][1]=w.rotateRight()),p>0)switch(o[p-1][0]){case-1:o[p-1][1].left=o[p][1];break;case 1:o[p-1][1].right=o[p][1];break;case 0:o[p-1][1].mid=o[p][1];break}else this._root=o[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const g=this._iter.reset(E);let a=this._root,o;for(;a;){const u=g.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(g.hasNext())g.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(E){return this._findSuperstrOrElement(E,!1)}_findSuperstrOrElement(E,g){const a=this._iter.reset(E);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):g?o.value:void 0}}hasElementOrSubtree(E){return this._findSuperstrOrElement(E,!0)!==void 0}forEach(E){for(const[g,a]of this)E(a,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const g=[];return this._dfsEntries(E,g),g[Symbol.iterator]()}_dfsEntries(E,g){!E||(E.left&&this._dfsEntries(E.left,g),E.value&&g.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,g),E.right&&this._dfsEntries(E.right,g))}_isBalanced(){const E=g=>{if(!g)return!0;const a=g.balanceFactor();return a<-1||a>1?!1:E(g.left)&&E(g.right)};return E(this._root)}}e.TernarySearchTree=y}),define(Ie[66],ke([1,0,23,10,2]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function F(I){return JSON.stringify(I,A)}e.stringify=F;function b(I){let N=JSON.parse(I);return N=_(N),N}e.parse=b;function A(I,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,k.regExpFlags)(N)}:N}function _(I,N=0){if(!I||N>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof i.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let y=0;y<I.length;++y)I[y]=_(I[y],N+1);else for(const y in I)Object.hasOwnProperty.call(I,y)&&(I[y]=_(I[y],N+1))}return I}e.revive=_}),define(Ie[15],ke([1,0,11,20,2]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var F;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(F=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(N){this._preferredWebSchema=N}setDelegate(N){this._delegate=N}setServerRootPath(N){this._remoteResourcesPath=`${N}/${F.vscodeRemoteResource}`}set(N,y,h){this._hosts[N]=y,this._ports[N]=h}setConnectionToken(N,y){this._connectionTokens[N]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(N){if(this._delegate)try{return this._delegate(N)}catch(o){return i.onUnexpectedError(o),N}const y=N.authority;let h=this._hosts[y];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const E=this._ports[y],g=this._connectionTokens[y];let a=`path=${encodeURIComponent(N.path)}`;return typeof g=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),D.URI.from({scheme:k.isWeb?this._preferredWebSchema:F.vscodeRemoteResource,authority:`${h}:${E}`,path:this._remoteResourcesPath,query:a})}}e.RemoteAuthorities=new b,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(N){const y=this.toUri(N,ne);return this.uriToBrowserUri(y)}uriToBrowserUri(N){return N.scheme===F.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===F.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${F.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?N.with({scheme:F.vscodeFileResource,authority:N.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):N}asFileUri(N){const y=this.toUri(N,ne);return this.uriToFileUri(y)}uriToFileUri(N){return N.scheme===F.vscodeFileResource?N.with({scheme:F.file,authority:N.authority!==A.FALLBACK_AUTHORITY?N.authority:null,query:null,fragment:null}):N}toUri(N,y){return D.URI.isUri(N)?N:D.URI.parse(y.toUrl(N))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A;var _;(function(I){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(N.get("3"));const y="vscode-coi";function h(g){let a;typeof g=="string"?a=new URL(g).searchParams:g instanceof URL?a=g.searchParams:D.URI.isUri(g)&&(a=new URL(g.toString(!0)).searchParams);const o=a?.get(y);if(!!o)return N.get(o)}I.getHeadersFromQuery=h;function E(g,a,o){if(!globalThis.crossOriginIsolated)return;const u=a&&o?"3":o?"2":"1";g instanceof URLSearchParams?g.set(y,u):g[y]=u}I.addSearchParam=E})(_=e.COI||(e.COI={}))}),define(Ie[24],ke([1,0,40,15,19,20,10,2]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(E){return(0,A.uriToFsPath)(E,!0)}e.originalFSPath=_;class I{constructor(g){this._ignorePathCasing=g}compare(g,a,o=!1){return g===a?0:(0,b.compare)(this.getComparisonKey(g,o),this.getComparisonKey(a,o))}isEqual(g,a,o=!1){return g===a?!0:!g||!a?!1:this.getComparisonKey(g,o)===this.getComparisonKey(a,o)}getComparisonKey(g,a=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,a,o=!1){if(g.scheme===a.scheme){if(g.scheme===k.Schemas.file)return i.isEqualOrParent(_(g),_(a),this._ignorePathCasing(g))&&g.query===a.query&&(o||g.fragment===a.fragment);if((0,e.isEqualAuthority)(g.authority,a.authority))return i.isEqualOrParent(g.path,a.path,this._ignorePathCasing(g),"/")&&g.query===a.query&&(o||g.fragment===a.fragment)}return!1}joinPath(g,...a){return A.URI.joinPath(g,...a)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return D.posix.basename(g.path)}extname(g){return D.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let a;return g.scheme===k.Schemas.file?a=A.URI.file(D.dirname(_(g))).path:(a=D.posix.dirname(g.path),g.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),a="/")),g.with({path:a})}normalizePath(g){if(!g.path.length)return g;let a;return g.scheme===k.Schemas.file?a=A.URI.file(D.normalize(_(g))).path:a=D.posix.normalize(g.path),g.with({path:a})}relativePath(g,a){if(g.scheme!==a.scheme||!(0,e.isEqualAuthority)(g.authority,a.authority))return;if(g.scheme===k.Schemas.file){const p=D.relative(_(g),_(a));return F.isWindows?i.toSlashes(p):p}let o=g.path||"/";const u=a.path||"/";if(this._ignorePathCasing(g)){let p=0;for(const w=Math.min(o.length,u.length);p<w&&!(o.charCodeAt(p)!==u.charCodeAt(p)&&o.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);o=u.substr(0,p)+o.substr(p)}return D.posix.relative(o,u)}resolvePath(g,a){if(g.scheme===k.Schemas.file){const o=A.URI.file(D.resolve(_(g),a));return g.with({authority:o.authority,path:o.path})}return a=i.toPosixPath(a),g.with({path:D.posix.resolve(g.path,a)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,a){return g===a||g!==void 0&&a!==void 0&&(0,b.equalsIgnoreCase)(g,a)}hasTrailingPathSeparator(g,a=D.sep){if(g.scheme===k.Schemas.file){const o=_(g);return o.length>i.getRoot(o).length&&o[o.length-1]===a}else{const o=g.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,a=D.sep){return(0,e.hasTrailingPathSeparator)(g,a)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,a=D.sep){let o=!1;if(g.scheme===k.Schemas.file){const u=_(g);o=u!==void 0&&u.length===i.getRoot(u).length&&u[u.length-1]===a}else{a="/";const u=g.path;o=u.length===1&&u.charCodeAt(u.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(g,a)?g.with({path:g.path+"/"}):g}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===k.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(E,g){const a=[];for(let o=0;o<E.length;o++){const u=g(E[o]);E.some((p,w)=>w===o?!1:(0,e.isEqualOrParent)(u,g(p)))||a.push(E[o])}return a}e.distinctParents=N;var y;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function g(a){const o=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(w=>{const[R,v]=w.split(":");R&&v&&o.set(R,v)});const p=a.path.substring(0,a.path.indexOf(";"));return p&&o.set(E.META_DATA_MIME,p),o}E.parseMetaData=g})(y=e.DataUri||(e.DataUri={}));function h(E,g,a){if(g){let o=E.path;return o&&o[0]!==D.posix.sep&&(o=D.posix.sep+o),E.with({scheme:a,authority:g,path:o})}return E.with({scheme:a})}e.toLocalResource=h}),define(Ie[17],ke([1,0,21,11,4,6,24,20,115]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(q){return!!q&&typeof q.then=="function"}e.isThenable=I;function N(q){const G=new i.CancellationTokenSource,de=q(G.token),Se=new Promise((Le,xe)=>{const Te=G.token.onCancellationRequested(()=>{Te.dispose(),G.dispose(),xe(new k.CancellationError)});Promise.resolve(de).then(De=>{Te.dispose(),G.dispose(),Le(De)},De=>{Te.dispose(),G.dispose(),xe(De)})});return new class{cancel(){G.cancel()}then(Le,xe){return Se.then(Le,xe)}catch(Le){return this.then(void 0,Le)}finally(Le){return Se.finally(Le)}}}e.createCancelablePromise=N;function y(q,G,de){return new Promise((Se,Le)=>{const xe=G.onCancellationRequested(()=>{xe.dispose(),Se(de)});q.then(Se,Le).finally(()=>xe.dispose())})}e.raceCancellation=y;function h(q,G){return new Promise((de,Se)=>{const Le=G.onCancellationRequested(()=>{Le.dispose(),Se(new k.CancellationError)});q.then(de,Se).finally(()=>Le.dispose())})}e.raceCancellationError=h;async function E(q){let G=-1;const de=q.map((Le,xe)=>Le.then(Te=>(G=xe,Te))),Se=await Promise.race(de);return q.forEach((Le,xe)=>{xe!==G&&Le.cancel()}),Se}e.raceCancellablePromises=E;function g(q,G,de){let Se;const Le=setTimeout(()=>{Se?.(void 0),de?.()},G);return Promise.race([q.finally(()=>clearTimeout(Le)),new Promise(xe=>Se=xe)])}e.raceTimeout=g;function a(q){return new Promise((G,de)=>{const Se=q();I(Se)?Se.then(G,de):G(Se)})}e.asPromise=a;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const de=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(de,de).then(Se)})}return new Promise((de,Se)=>{this.queuedPromise.then(de,Se)})}return this.activePromise=G(),new Promise((de,Se)=>{this.activePromise.then(Le=>{this.activePromise=null,de(Le)},Le=>{this.activePromise=null,Se(Le)})})}}e.Throttler=o;class u{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=u;class p{constructor(){this.promiseMap=new Map}queue(G,de){const Le=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.promiseMap.get(G)===Le&&this.promiseMap.delete(G)});return this.promiseMap.set(G,Le),Le}}e.SequencerByKey=p;const w=(q,G)=>{let de=!0;const Se=setTimeout(()=>{de=!1,G()},q);return{isTriggered:()=>de,dispose:()=>{clearTimeout(Se),de=!1}}},R=q=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,q())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class v{constructor(G){this.defaultDelay=G,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,de=this.defaultDelay){this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Le,xe)=>{this.doResolve=Le,this.doReject=xe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Le=this.task;return this.task=null,Le()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=de===_.MicrotaskDelay?R(Se):w(de,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=v;class t{constructor(G){this.delayer=new v(G),this.throttler=new o}trigger(G,de){return this.delayer.trigger(()=>this.throttler.queue(G),de)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class d{constructor(){this._isOpen=!1,this._promise=new Promise((G,de)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class r extends d{constructor(G){super(),this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function l(q,G){return G?new Promise((de,Se)=>{const Le=setTimeout(()=>{xe.dispose(),de()},q),xe=G.onCancellationRequested(()=>{clearTimeout(Le),xe.dispose(),Se(new k.CancellationError)})}):N(de=>l(q,de))}e.timeout=l;function c(q,G=0){const de=setTimeout(q,G);return(0,F.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=c;function S(q){const G=[];let de=0;const Se=q.length;function Le(){return de<Se?q[de++]():null}function xe(Te){Te!=null&&G.push(Te);const De=Le();return De?De.then(xe):Promise.resolve(G)}return Promise.resolve(null).then(xe)}e.sequence=S;function n(q,G=Se=>!!Se,de=null){let Se=0;const Le=q.length,xe=()=>{if(Se>=Le)return Promise.resolve(de);const Te=q[Se++];return Promise.resolve(Te()).then(_e=>G(_e)?Promise.resolve(_e):xe())};return xe()}e.first=n;function s(q,G=Se=>!!Se,de=null){if(q.length===0)return Promise.resolve(de);let Se=q.length;const Le=()=>{Se=-1;for(const xe of q)xe.cancel?.()};return new Promise((xe,Te)=>{for(const De of q)De.then(_e=>{--Se>=0&&G(_e)?(Le(),xe(_e)):Se===0&&xe(de)}).catch(_e=>{--Se>=0&&(Le(),Te(_e))})})}e.firstParallel=s;class f{constructor(G){this._size=0,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(G){return this._size++,new Promise((de,Se)=>{this.outstandingPromises.push({factory:G,c:de,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const de=G.factory();de.then(G.c,G.e),de.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class P extends f{constructor(){super(1)}}e.Queue=P;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const G=new me;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueFor(G,de=b.extUri){const Se=de.getComparisonKey(G);let Le=this.queues.get(Se);return Le||(Le=new P,D.Event.once(Le.onDrained)(()=>{Le?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Le)),Le}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class z{constructor(G,de){this._token=-1,typeof G=="function"&&typeof de=="number"&&this.setIfNotSet(G,de)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,de){this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},de)}setIfNotSet(G,de){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},de))}}e.TimeoutTimer=z;class Q{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(G,de){this.cancel(),this._token=setInterval(()=>{G()},de)}}e.IntervalTimer=Q;class Z{constructor(G,de){this.timeoutToken=-1,this.runner=G,this.timeout=de,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Z;class Y{constructor(G,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=de,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Y;class H extends Z{constructor(G,de){super(G,de),this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner?.(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class O extends F.Disposable{constructor(G,de){super(),this.options=G,this.handler=de,this.pendingWork=[],this.throttler=this._register(new F.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.options.maxBufferedWork)return!1}else if(this.pending+G.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const de of G)this.pendingWork.push(de);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Z(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,A.setTimeout0)(()=>{if(G)return;const de=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(q,G)=>{const de=requestIdleCallback(q,typeof G=="number"?{timeout:G}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(de))}}}}();class m{constructor(G){this._didRun=!1,this._executor=()=>{try{this._value=G()}catch(de){this._error=de}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=m;async function L(q,G,de){let Se;for(let Le=0;Le<de;Le++)try{return await q()}catch(xe){Se=xe,await l(G)}throw Se}e.retry=L;class B{hasPending(G){return this._pending?typeof G=="number"?this._pending.taskId===G:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(G,de,Se){return this._pending={taskId:G,cancel:()=>Se?.(),promise:de},de.then(()=>this.donePending(G),()=>this.donePending(G)),de}donePending(G){this._pending&&G===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const G=this._next;this._next=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this._next)this._next.run=G;else{let de,Se;const Le=new Promise((xe,Te)=>{de=xe,Se=Te});this._next={run:G,promise:Le,promiseResolve:de,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class J{constructor(G,de=()=>Date.now()){this.interval=G,this.nowFn=de,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class me{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((G,de)=>{this.completeCallback=G,this.errorCallback=de})}complete(G){return new Promise(de=>{this.completeCallback(G),this.resolved=!0,de()})}error(G){return new Promise(de=>{this.errorCallback(G),this.rejected=!0,de()})}cancel(){new Promise(G=>{this.errorCallback(new k.CancellationError),this.rejected=!0,G()})}}e.DeferredPromise=me;var te;(function(q){async function G(Se){let Le;const xe=await Promise.all(Se.map(Te=>Te.then(De=>De,De=>{Le||(Le=De)})));if(typeof Le<"u")throw Le;return xe}q.settled=G;function de(Se){return new Promise(async(Le,xe)=>{try{await Se(Le,xe)}catch(Te){xe(Te)}})}q.withAsyncBody=de})(te=e.Promises||(e.Promises={}));var oe;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(oe||(oe={}));class ce{static fromArray(G){return new ce(de=>{de.emitMany(G)})}static fromPromise(G){return new ce(async de=>{de.emitMany(await G)})}static fromPromises(G){return new ce(async de=>{await Promise.all(G.map(async Se=>de.emitOne(await Se)))})}static merge(G){return new ce(async de=>{await Promise.all(G.map(async Se=>{for await(const Le of Se)de.emitOne(Le)}))})}constructor(G){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const de={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(G(de)),this.resolve()}catch(Se){this.reject(Se)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(G,de){return new ce(async Se=>{for await(const Le of G)Se.emitOne(de(Le))})}map(G){return ce.map(this,G)}static filter(G,de){return new ce(async Se=>{for await(const Le of G)de(Le)&&Se.emitOne(Le)})}filter(G){return ce.filter(this,G)}static coalesce(G){return ce.filter(G,de=>!!de)}coalesce(){return ce.coalesce(this)}static async toPromise(G){const de=[];for await(const Se of G)de.push(Se);return de}toPromise(){return ce.toPromise(this)}emitOne(G){this._state===0&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===0&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(G){this._state===0&&(this._state=2,this._error=G,this._onStateChanged.fire())}}ce.EMPTY=ce.fromArray([]),e.AsyncIterableObject=ce;class we extends ce{constructor(G,de){super(de),this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function V(q){const G=new i.CancellationTokenSource,de=q(G.token);return new we(G,async Se=>{const Le=G.token.onCancellationRequested(()=>{Le.dispose(),G.dispose(),Se.reject(new k.CancellationError)});try{for await(const xe of de){if(G.token.isCancellationRequested)return;Se.emitOne(xe)}Le.dispose(),G.dispose()}catch(xe){Le.dispose(),G.dispose(),Se.reject(xe)}})}e.createCancelableAsyncIterable=V}),define(Ie[35],ke([1,0,16,17,40,28,19,20,10]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",y="[^/\\\\]",h=/\//g;function E(J,me){switch(J){case 0:return"";case 1:return`${y}*?`;default:return`(?:${N}|${y}+${N}${me?`|${N}${y}+`:""})*?`}}function g(J,me){if(!J)return[];const te=[];let oe=!1,ce=!1,we="";for(const V of J){switch(V){case me:if(!oe&&!ce){te.push(we),we="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}we+=V}return we&&te.push(we),te}e.splitGlobAware=g;function a(J){if(!J)return"";let me="";const te=g(J,e.GLOB_SPLIT);if(te.every(oe=>oe===e.GLOBSTAR))me=".*";else{let oe=!1;te.forEach((ce,we)=>{if(ce===e.GLOBSTAR){if(oe)return;me+=E(2,we===te.length-1)}else{let V=!1,q="",G=!1,de="";for(const Se of ce){if(Se!=="}"&&V){q+=Se;continue}if(G&&(Se!=="]"||!de)){let Le;Se==="-"?Le=Se:(Se==="^"||Se==="!")&&!de?Le="^":Se===e.GLOB_SPLIT?Le="":Le=(0,_.escapeRegExpCharacters)(Se),de+=Le;continue}switch(Se){case"{":V=!0;continue;case"[":G=!0;continue;case"}":{me+=`(?:${g(q,",").map(Te=>a(Te)).join("|")})`,V=!1,q="";break}case"]":{me+="["+de+"]",G=!1,de="";break}case"?":me+=y;continue;case"*":me+=E(1);continue;default:me+=(0,_.escapeRegExpCharacters)(Se)}}we<te.length-1&&(te[we+1]!==e.GLOBSTAR||we+2<te.length)&&(me+=N)}oe=ce===e.GLOBSTAR})}return me}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,R=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.LRUCache(1e4),d=function(){return!1},r=function(){return null};function l(J,me){if(!J)return r;let te;typeof J!="string"?te=J.pattern:te=J,te=te.trim();const oe=`${te}_${!!me.trimForExclusions}`;let ce=t.get(oe);if(ce)return c(ce,J);let we;return o.test(te)?ce=n(te.substr(4),te):(we=u.exec(S(te,me)))?ce=s(we[1],te):(me.trimForExclusions?w:p).test(te)?ce=f(te,me):(we=R.exec(S(te,me)))?ce=P(we[1].substr(1),te,!0):(we=v.exec(S(te,me)))?ce=P(we[1],te,!1):ce=T(te),t.set(oe,ce),c(ce,J)}function c(J,me){if(typeof me=="string")return J;const te=function(oe,ce){return(0,D.isEqualOrParent)(oe,me.base,!A.isLinux)?J((0,_.ltrim)(oe.substr(me.base.length),b.sep),ce):null};return te.allBasenames=J.allBasenames,te.allPaths=J.allPaths,te.basenames=J.basenames,te.patterns=J.patterns,te}function S(J,me){return me.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function n(J,me){return function(te,oe){return typeof te=="string"&&te.endsWith(J)?me:null}}function s(J,me){const te=`/${J}`,oe=`\\${J}`,ce=function(V,q){return typeof V!="string"?null:q?q===J?me:null:V===J||V.endsWith(te)||V.endsWith(oe)?me:null},we=[J];return ce.basenames=we,ce.patterns=[me],ce.allBasenames=we,ce}function f(J,me){const te=L(J.slice(1,-1).split(",").map(q=>l(q,me)).filter(q=>q!==r),J),oe=te.length;if(!oe)return r;if(oe===1)return te[0];const ce=function(q,G){for(let de=0,Se=te.length;de<Se;de++)if(te[de](q,G))return J;return null},we=te.find(q=>!!q.allBasenames);we&&(ce.allBasenames=we.allBasenames);const V=te.reduce((q,G)=>G.allPaths?q.concat(G.allPaths):q,[]);return V.length&&(ce.allPaths=V),ce}function P(J,me,te){const oe=b.sep===b.posix.sep,ce=oe?J:J.replace(h,b.sep),we=b.sep+ce,V=b.posix.sep+J;let q;return te?q=function(G,de){return typeof G=="string"&&(G===ce||G.endsWith(we)||!oe&&(G===J||G.endsWith(V)))?me:null}:q=function(G,de){return typeof G=="string"&&(G===ce||!oe&&G===J)?me:null},q.allPaths=[(te?"*/":"./")+J],q}function T(J){try{const me=new RegExp(`^${a(J)}$`);return function(te){return me.lastIndex=0,typeof te=="string"&&me.test(te)?J:null}}catch{return r}}function z(J,me,te){return!J||typeof me!="string"?!1:Q(J)(me,void 0,te)}e.match=z;function Q(J,me={}){if(!J)return d;if(typeof J=="string"||Z(J)){const te=l(J,me);if(te===r)return d;const oe=function(ce,we){return!!te(ce,we)};return te.allBasenames&&(oe.allBasenames=te.allBasenames),te.allPaths&&(oe.allPaths=te.allPaths),oe}return O(J,me)}e.parse=Q;function Z(J){const me=J;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}e.isRelativePattern=Z;function Y(J){return J.allBasenames||[]}e.getBasenameTerms=Y;function H(J){return J.allPaths||[]}e.getPathTerms=H;function O(J,me){const te=L(Object.getOwnPropertyNames(J).map(q=>m(q,J[q],me)).filter(q=>q!==r)),oe=te.length;if(!oe)return r;if(!te.some(q=>!!q.requiresSiblings)){if(oe===1)return te[0];const q=function(Se,Le){let xe;for(let Te=0,De=te.length;Te<De;Te++){const _e=te[Te](Se,Le);if(typeof _e=="string")return _e;(0,k.isThenable)(_e)&&(xe||(xe=[]),xe.push(_e))}return xe?(async()=>{for(const Te of xe){const De=await Te;if(typeof De=="string")return De}return null})():null},G=te.find(Se=>!!Se.allBasenames);G&&(q.allBasenames=G.allBasenames);const de=te.reduce((Se,Le)=>Le.allPaths?Se.concat(Le.allPaths):Se,[]);return de.length&&(q.allPaths=de),q}const ce=function(q,G,de){let Se,Le;for(let xe=0,Te=te.length;xe<Te;xe++){const De=te[xe];De.requiresSiblings&&de&&(G||(G=(0,b.basename)(q)),Se||(Se=G.substr(0,G.length-(0,b.extname)(q).length)));const _e=De(q,G,Se,de);if(typeof _e=="string")return _e;(0,k.isThenable)(_e)&&(Le||(Le=[]),Le.push(_e))}return Le?(async()=>{for(const xe of Le){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},we=te.find(q=>!!q.allBasenames);we&&(ce.allBasenames=we.allBasenames);const V=te.reduce((q,G)=>G.allPaths?q.concat(G.allPaths):q,[]);return V.length&&(ce.allPaths=V),ce}function m(J,me,te){if(me===!1)return r;const oe=l(J,te);if(oe===r)return r;if(typeof me=="boolean")return oe;if(me){const ce=me.when;if(typeof ce=="string"){const we=(V,q,G,de)=>{if(!de||!oe(V,q))return null;const Se=ce.replace("$(basename)",()=>G),Le=de(Se);return(0,k.isThenable)(Le)?Le.then(xe=>xe?J:null):Le?J:null};return we.requiresSiblings=!0,we}}return oe}function L(J,me){const te=J.filter(q=>!!q.basenames);if(te.length<2)return J;const oe=te.reduce((q,G)=>{const de=G.basenames;return de?q.concat(de):q},[]);let ce;if(me){ce=[];for(let q=0,G=oe.length;q<G;q++)ce.push(me)}else ce=te.reduce((q,G)=>{const de=G.patterns;return de?q.concat(de):q},[]);const we=function(q,G){if(typeof q!="string")return null;if(!G){let Se;for(Se=q.length;Se>0;Se--){const Le=q.charCodeAt(Se-1);if(Le===47||Le===92)break}G=q.substr(Se)}const de=oe.indexOf(G);return de!==-1?ce[de]:null};we.basenames=oe,we.patterns=ce,we.allBasenames=oe;const V=J.filter(q=>!q.basenames);return V.push(we),V}function B(J,me){return(0,i.equals)(J,me,(te,oe)=>typeof te=="string"&&typeof oe=="string"?te===oe:typeof te!="string"&&typeof oe!="string"?te.base===oe.base&&te.pattern===oe.pattern:!1)}e.patternsEquals=B}),define(Ie[86],ke([1,0,11,126,24,10,2]),function(ne,e,i,k,D,F,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(u="",p=!1){if(this.value=u,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(u,p=0){return this.value+=h(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(w,R)=>"&nbsp;".repeat(R.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,p){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(u,p,w){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(u),")"),w&&(this.value+=` "${this._escape(this._escape(w,'"'),")")}"`),this.value+=")",this}_escape(u,p){const w=new RegExp((0,F.escapeRegExpCharacters)(p),"g");return u.replace(w,(R,v)=>u.charAt(v-1)!=="\\"?`\\${R}`:R)}}e.MarkdownString=_;function I(o){return N(o)?!o.value:Array.isArray(o)?o.every(I):!0}e.isEmptyMarkdownString=I;function N(o){return o instanceof _?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function y(o,u){return o===u?!0:!o||!u?!1:o.value===u.value&&o.isTrusted===u.isTrusted&&o.supportThemeIcons===u.supportThemeIcons&&o.supportHtml===u.supportHtml&&(o.baseUri===u.baseUri||!!o.baseUri&&!!u.baseUri&&(0,D.isEqual)(b.URI.from(o.baseUri),b.URI.from(u.baseUri)))}e.markdownStringEqual=y;function h(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=h;function E(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function g(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function a(o){const u=[],p=o.split("|").map(R=>R.trim());o=p[0];const w=p[1];if(w){const R=/height=(\d+)/.exec(w),v=/width=(\d+)/.exec(w),t=R?R[1]:"",d=v?v[1]:"",r=isFinite(parseInt(d)),l=isFinite(parseInt(t));r&&u.push(`width="${d}"`),l&&u.push(`height="${t}"`)}return{href:o,dimensions:u}}e.parseHrefAndDimensions=a}),define(Ie[87],ke([1,0,16,40,19,20,24,10]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function _(r,l){const{os:c,tildify:S,relative:n}=l;if(n){const P=I(r,n,c);if(typeof P=="string")return P}let s=r.fsPath;if(c===1&&!F.isWindows?s=s.replace(/\//g,"\\"):c!==1&&F.isWindows&&(s=s.replace(/\\/g,"/")),c!==1&&S?.userHome){const P=S.userHome.fsPath;let T;r.scheme!==S.userHome.scheme&&r.path.startsWith(D.posix.sep)?T=S.userHome.with({path:r.path}).fsPath:T=r.fsPath,s=h(T,P,c)}return(c===1?D.win32:D.posix).normalize(N(s,c===1))}e.getPathLabel=_;function I(r,l,c){const S=c===1?D.win32:D.posix,n=c===3?b.extUri:b.extUriIgnorePathCase,s=l.getWorkspace(),f=(0,i.firstOrDefault)(s.folders);if(!f)return;r.scheme!==f.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=f.uri.with({path:r.path}));const P=l.getWorkspaceFolder(r);if(!P)return;let T;if(n.isEqual(P.uri,r)?T="":T=n.relativePath(P.uri,r)??"",T&&(T=S.normalize(T)),s.folders.length>1&&!l.noPrefix){const z=P.name?P.name:n.basenameOrAuthority(P.uri);T=T?`${z} \u2022 ${T}`:z}return T}function N(r,l=F.isWindows){return(0,k.hasDriveLetter)(r,l)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=N;let y=Object.create(null);function h(r,l,c=F.OS){if(c===1||!r||!l)return r;let S=y.original===l?y.normalized:void 0;S||(S=l,F.isWindows&&(S=(0,k.toSlashes)(S)),S=`${(0,A.rtrim)(S,D.posix.sep)}${D.posix.sep}`,y={original:l,normalized:S});let n=r;return F.isWindows&&(n=(0,k.toSlashes)(n)),(c===3?n.startsWith(S):(0,A.startsWithIgnoreCase)(n,S))?`~/${n.substr(S.length)}`:r}e.tildify=h;function E(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=E;const g="\u2026",a="\\\\",o="~";function u(r,l=D.sep){const c=new Array(r.length);let S=!1;for(let n=0;n<r.length;n++){const s=r[n];if(s===""){c[n]=`.${l}`;continue}if(!s){c[n]=s;continue}S=!0;let f="",P=s;P.indexOf(a)===0?(f=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length)):P.indexOf(l)===0?(f=P.substr(0,P.indexOf(l)+l.length),P=P.substr(P.indexOf(l)+l.length)):P.indexOf(o)===0&&(f=P.substr(0,P.indexOf(o)+o.length),P=P.substr(P.indexOf(o)+o.length));const T=P.split(l);for(let z=1;S&&z<=T.length;z++)for(let Q=T.length-z;S&&Q>=0;Q--){S=!1;let Z=T.slice(Q,Q+z).join(l);for(let Y=0;!S&&Y<r.length;Y++)if(Y!==n&&r[Y]&&r[Y].indexOf(Z)>-1){const H=Q+z===T.length,O=Q>0&&r[Y].indexOf(l)>-1?l+Z:Z,m=r[Y].endsWith(O);S=!H||m}if(!S){let Y="";(T[0].endsWith(":")||f!=="")&&(Q===1&&(Q=0,z++,Z=T[0]+l+Z),Q>0&&(Y=T[0]+l),Y=f+Y),Q>0&&(Y=Y+g+l),Y=Y+Z,Q+z<T.length&&(Y=Y+l+g),c[n]=Y}}S&&(c[n]=s)}return c}e.shorten=u;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function w(r,l=Object.create(null)){const c=[];let S=!1,n="";for(const s of r)if(s==="$"||S&&s==="{")n&&c.push({value:n,type:p.TEXT}),n="",S=!0;else if(s==="}"&&S){const f=l[n];if(typeof f=="string")f.length&&c.push({value:f,type:p.VARIABLE});else if(f){const P=c[c.length-1];(!P||P.type!==p.SEPARATOR)&&c.push({value:f.label,type:p.SEPARATOR})}n="",S=!1}else n+=s;return n&&!S&&c.push({value:n,type:p.TEXT}),c.filter((s,f)=>{if(s.type===p.SEPARATOR){const P=c[f-1],T=c[f+1];return[P,T].every(z=>z&&(z.type===p.VARIABLE||z.type===p.TEXT)&&z.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=w;function R(r,l){return F.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=R;function v(r,l){return F.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):F.isWindows?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(r){const l=r.indexOf("/")!==-1?D.posix:D.win32,c=l.basename(r),S=l.dirname(r);return c.length?{name:c,parentPath:S}:{name:S,parentPath:""}}e.splitName=d}),define(Ie[127],ke([1,0,23,2]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(y){return y.toJSON()}class F{constructor(h){this._uriTransformer=h}transformIncoming(h){const E=this._uriTransformer.transformIncoming(h);return E===h?h:D(k.URI.from(E))}transformOutgoing(h){const E=this._uriTransformer.transformOutgoing(h);return E===h?h:D(k.URI.from(E))}transformOutgoingURI(h){const E=this._uriTransformer.transformOutgoing(h);return E===h?h:k.URI.from(E)}transformOutgoingScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}}e.URITransformer=F,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function b(y,h,E){if(!y||E>200)return null;if(typeof y=="object"){if(y instanceof k.URI)return h.transformOutgoing(y);for(const g in y)if(Object.hasOwnProperty.call(y,g)){const a=b(y[g],h,E+1);a!==null&&(y[g]=a)}}return null}function A(y,h){const E=b(y,h,0);return E===null?y:E}e.transformOutgoingURIs=A;function _(y,h,E,g){if(!y||g>200)return null;if(typeof y=="object"){if(y.$mid===1)return E?k.URI.revive(h.transformIncoming(y)):h.transformIncoming(y);if(y instanceof i.VSBuffer)return null;for(const a in y)if(Object.hasOwnProperty.call(y,a)){const o=_(y[a],h,E,g+1);o!==null&&(y[a]=o)}}return null}function I(y,h){const E=_(y,h,!1,0);return E===null?y:E}e.transformIncomingURIs=I;function N(y,h){const E=_(y,h,!0,0);return E===null?y:E}e.transformAndReviveIncomingURIs=N}),define(Ie[128],ke([1,0,35,19]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(F,b,A,_,I,N){if(Array.isArray(F)){let y=0;for(const h of F){const E=D(h,b,A,_,I,N);if(E===10)return E;E>y&&(y=E)}return y}else{if(typeof F=="string")return _?F==="*"?5:F===A?10:0:0;if(F){const{language:y,pattern:h,scheme:E,hasAccessToAllModels:g,notebookType:a}=F;if(!_&&!g)return 0;a&&I&&(b=I);let o=0;if(E)if(E===b.scheme)o=10;else if(E==="*")o=5;else return 0;if(y)if(y===A)o=10;else if(y==="*")o=Math.max(o,5);else return 0;if(a)if(a===N)o=10;else if(a==="*"&&N!==void 0)o=Math.max(o,5);else return 0;if(h){let u;if(typeof h=="string"?u=h:u={...h,base:(0,k.normalize)(h.base)},u===b.fsPath||(0,i.match)(u,b.fsPath))o=10;else return 0}return o}else return 0}}e.score=D}),define(Ie[88],ke([1,0,23,20]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(D||(D={}));function F(y){for(let h=0,E=y.length;h<E;h+=4){const g=y[h+0],a=y[h+1],o=y[h+2],u=y[h+3];y[h+0]=u,y[h+1]=o,y[h+2]=a,y[h+3]=g}}function b(y){const h=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return k.isLittleEndian()||F(h),i.VSBuffer.wrap(h)}function A(y){const h=y.buffer;if(k.isLittleEndian()||F(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const E=new Uint8Array(h.byteLength);return E.set(h),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function _(y){const h=new Uint32Array(I(y));let E=0;if(h[E++]=y.id,y.type==="full")h[E++]=1,h[E++]=y.data.length,h.set(y.data,E),E+=y.data.length;else{h[E++]=2,h[E++]=y.deltas.length;for(const g of y.deltas)h[E++]=g.start,h[E++]=g.deleteCount,g.data?(h[E++]=g.data.length,h.set(g.data,E),E+=g.data.length):h[E++]=0}return b(h)}e.encodeSemanticTokensDto=_;function I(y){let h=0;if(h+=1+1,y.type==="full")h+=1+y.data.length;else{h+=1,h+=(1+1+1)*y.deltas.length;for(const E of y.deltas)E.data&&(h+=E.data.length)}return h}function N(y){const h=A(y);let E=0;const g=h[E++];if(h[E++]===1){const p=h[E++],w=h.subarray(E,E+p);return E+=p,{id:g,type:"full",data:w}}const o=h[E++],u=[];for(let p=0;p<o;p++){const w=h[E++],R=h[E++],v=h[E++];let t;v>0&&(t=h.subarray(E,E+v),E+=v),u[p]={start:w,deleteCount:R,data:t}}return{id:g,type:"delta",deltas:u}}e.decodeSemanticTokensDto=N}),define(Ie[129],ke([13,14]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Ie[130],ke([1,0,129,20,131,16,22,117]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(_=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=I;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class y{constructor(X,pe,$e,Ue){this.id=X,this.name=pe,this.defaultValue=$e,this.schema=Ue}applyUpdate(X,pe){return E(X,pe)}compute(X,pe,$e){return $e}}class h{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=h;function E(K,X){if(typeof K!="object"||typeof X!="object"||!K||!X)return new h(X,K!==X);if(Array.isArray(K)||Array.isArray(X)){const $e=Array.isArray(K)&&Array.isArray(X)&&F.equals(K,X);return new h(X,!$e)}let pe=!1;for(const $e in X)if(X.hasOwnProperty($e)){const Ue=E(K[$e],X[$e]);Ue.didChange&&(K[$e]=Ue.newValue,pe=!0)}return new h(K,pe)}class g{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return E(X,pe)}validate(X){return this.defaultValue}}class a{constructor(X,pe,$e,Ue){this.id=X,this.name=pe,this.defaultValue=$e,this.schema=Ue}applyUpdate(X,pe){return E(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,$e){return $e}}function o(K,X){return typeof K>"u"?X:K==="false"?!1:Boolean(K)}e.boolean=o;class u extends a{constructor(X,pe,$e,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=$e),super(X,pe,$e,Ue)}validate(X){return o(X,this.defaultValue)}}function p(K,X,pe,$e){if(typeof K>"u")return X;let Ue=parseInt(K,10);return isNaN(Ue)?X:(Ue=Math.max(pe,Ue),Ue=Math.min($e,Ue),Ue|0)}e.clampedInt=p;class w extends a{static clampedInt(X,pe,$e,Ue){return p(X,pe,$e,Ue)}constructor(X,pe,$e,Ue,Xe,je=void 0){typeof je<"u"&&(je.type="integer",je.default=$e,je.minimum=Ue,je.maximum=Xe),super(X,pe,$e,je),this.minimum=Ue,this.maximum=Xe}validate(X){return w.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class R extends a{static clamp(X,pe,$e){return X<pe?pe:X>$e?$e:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const $e=parseFloat(X);return isNaN($e)?pe:$e}constructor(X,pe,$e,Ue,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=$e),super(X,pe,$e,Xe),this.validationFn=Ue}validate(X){return this.validationFn(R.float(X,this.defaultValue))}}class v extends a{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,$e,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=$e),super(X,pe,$e,Ue)}validate(X){return v.string(X,this.defaultValue)}}function t(K,X,pe){return typeof K!="string"||pe.indexOf(K)===-1?X:K}e.stringSet=t;class d extends a{constructor(X,pe,$e,Ue,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ue,Xe.default=$e),super(X,pe,$e,Xe),this._allowedValues=Ue}validate(X){return t(X,this.defaultValue,this._allowedValues)}}class r extends y{constructor(X,pe,$e,Ue,Xe,je,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Xe,tt.default=Ue),super(X,pe,$e,tt),this._allowedValues=Xe,this._convert=je}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function l(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,$e){return $e===0?X.accessibilitySupport:$e}}class S extends y{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:i.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(K){switch(K){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function T(K){switch(K){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class z extends g{constructor(){super(135)}compute(X,pe,$e){const Ue=["monaco-editor"];return pe.get(36)&&Ue.push(pe.get(36)),X.extraEditorClassName&&Ue.push(X.extraEditorClassName),pe.get(70)==="default"?Ue.push("mouse-default"):pe.get(70)==="copy"&&Ue.push("mouse-copy"),pe.get(105)&&Ue.push("showUnused"),pe.get(133)&&Ue.push("showDeprecated"),Ue.join(" ")}}class Q extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(X,pe,$e){return $e&&X.emptySelectionClipboard}}class Z extends y{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:i.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:i.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":t(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":t(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class Y extends y{constructor(){super(48,"fontLigatures",Y.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?Y.OFF:X==="true"?Y.ON:X:Boolean(X)?Y.ON:Y.OFF}}Y.OFF='"liga" off, "calt" off',Y.ON='"liga" on, "calt" on',e.EditorFontLigatures=Y;class H extends y{constructor(){super(51,"fontVariations",H.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?H.OFF:X==="true"?H.TRANSLATE:X:Boolean(X)?H.TRANSLATE:H.OFF}compute(X,pe,$e){return X.fontInfo.fontVariationSettings}}H.OFF="normal",H.TRANSLATE="translate",e.EditorFontVariations=H;class O extends g{constructor(){super(47)}compute(X,pe,$e){return X.fontInfo}}class m extends a{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(X){const pe=R.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:R.clamp(pe,6,100)}compute(X,pe,$e){return X.fontInfo.fontSize}}class L extends y{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(w.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class B extends y{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:$e,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:$e,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:$e,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:$e,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:$e,description:i.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:t(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??t(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??t(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??t(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??t(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??t(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends y{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:i.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:w.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),above:o(pe.above,this.defaultValue.above)}}}var me;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(me=e.RenderMinimap||(e.RenderMinimap={}));class te extends g{constructor(){super(138)}compute(X,pe,$e){return te.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,$e=Math.floor(X.paddingTop/X.lineHeight);let Ue=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ue=Math.max(Ue,pe-1));const Xe=($e+X.viewLineCount+Ue)/(X.pixelRatio*X.height),je=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:$e,extraLinesBeyondLastLine:Ue,desiredRatio:Xe,minimapLineCount:je}}static _computeMinimapLayout(X,pe){const $e=X.outerWidth,Ue=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const je=pe.stableMinimapLayoutInput,tt=je&&X.outerHeight===je.outerHeight&&X.lineHeight===je.lineHeight&&X.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&X.pixelRatio===je.pixelRatio&&X.scrollBeyondLastLine===je.scrollBeyondLastLine&&X.paddingTop===je.paddingTop&&X.paddingBottom===je.paddingBottom&&X.minimap.enabled===je.minimap.enabled&&X.minimap.side===je.minimap.side&&X.minimap.size===je.minimap.size&&X.minimap.showSlider===je.minimap.showSlider&&X.minimap.renderCharacters===je.minimap.renderCharacters&&X.minimap.maxColumn===je.minimap.maxColumn&&X.minimap.scale===je.minimap.scale&&X.verticalScrollbarWidth===je.verticalScrollbarWidth&&X.isViewportWrapping===je.isViewportWrapping,at=X.lineHeight,bt=X.typicalHalfwidthCharacterWidth,Ct=X.scrollBeyondLastLine,Dt=X.minimap.renderCharacters;let yt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const lt=X.minimap.maxColumn,ft=X.minimap.size,jt=X.minimap.side,Wt=X.verticalScrollbarWidth,It=X.viewLineCount,ht=X.remainingWidth,kt=X.isViewportWrapping,Ut=Dt?2:3;let Pt=Math.floor(Xe*Ue);const Ke=Pt/Xe;let Lt=!1,qt=!1,Ft=Ut*yt,mt=yt/Xe,Ce=1;if(ft==="fill"||ft==="fit"){const{typicalViewportLineCount:Be,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:ct,desiredRatio:Tt,minimapLineCount:vt}=te.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:Ct,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ue,lineHeight:at,pixelRatio:Xe});if(It/vt>1)Lt=!0,qt=!0,yt=1,Ft=1,mt=yt/Xe;else{let pt=!1,At=yt+1;if(ft==="fit"){const Et=Math.ceil((Ze+It+ct)*Ft);kt&&tt&&ht<=pe.stableFitRemainingWidth?(pt=!0,At=pe.stableFitMaxMinimapScale):pt=Et>Pt}if(ft==="fill"||pt){Lt=!0;const Et=yt;Ft=Math.min(at*Xe,Math.max(1,Math.floor(1/Tt))),kt&&tt&&ht<=pe.stableFitRemainingWidth&&(At=pe.stableFitMaxMinimapScale),yt=Math.min(At,Math.max(1,Math.floor(Ft/Ut))),yt>Et&&(Ce=Math.min(2,yt/Et)),mt=yt/Xe/Ce,Pt=Math.ceil(Math.max(Be,Ze+It+ct)*Ft),kt?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=ht,pe.stableFitMaxMinimapScale=yt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Pe=Math.floor(lt*mt),ge=Math.min(Pe,Math.max(0,Math.floor((ht-Wt-2)*mt/(bt+mt)))+e.MINIMAP_GUTTER_WIDTH);let j=Math.floor(Xe*ge);const Ae=j/Xe;j=Math.floor(j*Ce);const Me=Dt?1:2,Qe=jt==="left"?0:$e-ge-Wt;return{renderMinimap:Me,minimapLeft:Qe,minimapWidth:ge,minimapHeightIsEditorHeight:Lt,minimapIsSampling:qt,minimapScale:yt,minimapLineHeight:Ft,minimapCanvasInnerWidth:j,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:Ae,minimapCanvasOuterHeight:Ke}}static computeLayout(X,pe){const $e=pe.outerWidth|0,Ue=pe.outerHeight|0,Xe=pe.lineHeight|0,je=pe.lineNumbersDigitCount|0,tt=pe.typicalHalfwidthCharacterWidth,at=pe.maxDigitWidth,bt=pe.pixelRatio,Ct=pe.viewLineCount,Dt=X.get(130),yt=Dt==="inherit"?X.get(129):Dt,lt=yt==="inherit"?X.get(125):yt,ft=X.get(128),jt=pe.isDominatedByLongLines,Wt=X.get(54),It=X.get(64).renderType!==0,ht=X.get(65),kt=X.get(99),Ut=X.get(80),Pt=X.get(69),Ke=X.get(97),Lt=Ke.verticalScrollbarSize,qt=Ke.verticalHasArrows,Ft=Ke.arrowSize,mt=Ke.horizontalScrollbarSize,Ce=X.get(40),Pe=X.get(104)!=="never";let ge=X.get(62);Ce&&Pe&&(ge+=16);let j=0;if(It){const ei=Math.max(je,ht);j=Math.round(ei*at)}let Ae=0;Wt&&(Ae=Xe);let Me=0,Qe=Me+Ae,Be=Qe+j,Ze=Be+ge;const ct=$e-Ae-j-ge;let Tt=!1,vt=!1,wt=-1;yt==="inherit"&&jt?(Tt=!0,vt=!0):lt==="on"||lt==="bounded"?vt=!0:lt==="wordWrapColumn"&&(wt=ft);const pt=te._computeMinimapLayout({outerWidth:$e,outerHeight:Ue,lineHeight:Xe,typicalHalfwidthCharacterWidth:tt,pixelRatio:bt,scrollBeyondLastLine:kt,paddingTop:Ut.top,paddingBottom:Ut.bottom,minimap:Pt,verticalScrollbarWidth:Lt,viewLineCount:Ct,remainingWidth:ct,isViewportWrapping:vt},pe.memory||new N);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Me+=pt.minimapWidth,Qe+=pt.minimapWidth,Be+=pt.minimapWidth,Ze+=pt.minimapWidth);const At=ct-pt.minimapWidth,Et=Math.max(1,Math.floor((At-Lt-2)/tt)),ri=qt?Ft:0;return vt&&(wt=Math.max(1,Et),lt==="bounded"&&(wt=Math.min(wt,ft))),{width:$e,height:Ue,glyphMarginLeft:Me,glyphMarginWidth:Ae,lineNumbersLeft:Qe,lineNumbersWidth:j,decorationsLeft:Be,decorationsWidth:ge,contentLeft:Ze,contentWidth:At,minimap:pt,viewportColumn:Et,isWordWrapMinified:Tt,isViewportWrapping:vt,wrappingColumn:wt,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:mt,overviewRuler:{top:ri,width:Lt,height:Ue-2*ri,right:0}}}}e.EditorLayoutInfoComputer=te;class oe extends y{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(X){return t(X,"simple",["simple","advanced"])}compute(X,pe,$e){return pe.get(2)===2?"advanced":$e}}class ce extends y{constructor(){const X={enabled:!0};super(61,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:i.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:o(X.enabled,this.defaultValue.enabled)}}}class we extends y{constructor(){const X={enabled:!1,maxLineCount:5};super(109,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class V extends y{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:i.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:t(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class q extends y{constructor(){super(62,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):w.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,$e){return $e<0?w.clampedInt(-$e*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):$e}}class G extends R{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>R.clamp(X,0,150),{markdownDescription:i.localize(60,null)})}compute(X,pe,$e){return X.fontInfo.lineHeight}}class de extends y{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:X.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:i.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:t(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(pe.side,this.defaultValue.side,["right","left"]),showSlider:t(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(pe.scale,1,1,3),maxColumn:w.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Se(K){return K==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Le extends y{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:w.clampedInt(pe.top,0,0,1e3),bottom:w.clampedInt(pe.bottom,0,0,1e3)}}}class xe extends y{constructor(){const X={enabled:!0,cycle:!0};super(81,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:i.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class Te extends g{constructor(){super(136)}compute(X,pe,$e){return X.pixelRatio}}class De extends y{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:i.localize(79,null)},comments:{anyOf:pe,default:X.comments,description:i.localize(80,null)},other:{anyOf:pe,default:X.other,description:i.localize(81,null)}},default:X,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const bt=X?"on":"off";return{comments:bt,strings:bt,other:bt}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:$e,strings:Ue}=X,Xe=["on","inline","off"];let je,tt,at;return typeof pe=="boolean"?je=pe?"on":"off":je=t(pe,this.defaultValue.other,Xe),typeof $e=="boolean"?tt=$e?"on":"off":tt=t($e,this.defaultValue.comments,Xe),typeof Ue=="boolean"?at=Ue?"on":"off":at=t(Ue,this.defaultValue.strings,Xe),{other:je,comments:tt,strings:at}}}var _e;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ae extends y{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(X){let pe=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,$e=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:$e}}}function ue(K){const X=K.get(92);return X==="editable"?K.get(86):X!=="on"}e.filterValidationDecorations=ue;class ee extends y{constructor(){const X=[],pe={type:"number",description:i.localize(88,null)};super(96,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:X,description:i.localize(90,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const $e of X)if(typeof $e=="number")pe.push({column:w.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const Ue=$e;pe.push({column:w.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return pe.sort(($e,Ue)=>$e.column-Ue.column),pe}return this.defaultValue}}function C(K,X){if(typeof K!="string")return X;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends y{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:i.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,$e=w.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=w.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:C(pe.vertical,this.defaultValue.vertical),horizontal:C(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:w.clampedInt(pe.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:w.clampedInt(pe.verticalSliderSize,Ue,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class $ extends y{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:i.localize(108,null)}})}applyUpdate(X,pe){let $e=!1;pe.allowedCharacters&&X&&(b.equals(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},$e=!0)),pe.allowedLocales&&X&&(b.equals(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},$e=!0));const Ue=super.applyUpdate(X,pe);return $e?new h(Ue.newValue,!0):Ue}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:ye(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,pe){if(typeof X!="object"||!X)return pe;const $e={};for(const[Ue,Xe]of Object.entries(X))Xe===!0&&($e[Ue]=!0);return $e}}class W extends y{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:i.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[i.localize(110,null),i.localize(111,null)],description:i.localize(112,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:t(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ie extends y{constructor(){const X={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:i.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends y{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(115,null),i.localize(116,null),i.localize(117,null)],default:X.bracketPairs,description:i.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(119,null),i.localize(120,null),i.localize(121,null)],default:X.bracketPairsHorizontal,description:i.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:i.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:i.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(125,null),i.localize(126,null),i.localize(127,null)],default:X.highlightActiveIndentation,description:i.localize(128,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:ye(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(K,X,pe){const $e=pe.indexOf(K);return $e===-1?X:pe[$e]}class le extends y{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(129,null),i.localize(130,null)],default:X.insertMode,description:i.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:i.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:i.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:i.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[i.localize(135,null),i.localize(136,null),i.localize(137,null),i.localize(138,null)],default:X.selectionMode,markdownDescription:i.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:i.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:i.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:i.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:i.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:i.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(176,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:t(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:t(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends y{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(177,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Ee;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));class ze extends y{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(178,null),i.localize(179,null),i.localize(180,null),i.localize(181,null)],description:i.localize(182,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,$e){return pe.get(2)===2?0:$e}}class He extends g{constructor(){super(139)}compute(X,pe,$e){const Ue=pe.get(138);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends y{constructor(){const X={enabled:!0};super(33,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(183,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:o(X.enabled,this.defaultValue.enabled)}}}const Ge="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?et:k.isLinux?nt:Ge,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(K){return e.editorOptionsRegistry[K.id]=K,K}var rt;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.bracketPairColorization=12]="bracketPairColorization",K[K.guides=13]="guides",K[K.codeLens=14]="codeLens",K[K.codeLensFontFamily=15]="codeLensFontFamily",K[K.codeLensFontSize=16]="codeLensFontSize",K[K.colorDecorators=17]="colorDecorators",K[K.colorDecoratorsLimit=18]="colorDecoratorsLimit",K[K.columnSelection=19]="columnSelection",K[K.comments=20]="comments",K[K.contextmenu=21]="contextmenu",K[K.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",K[K.cursorBlinking=23]="cursorBlinking",K[K.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",K[K.cursorStyle=25]="cursorStyle",K[K.cursorSurroundingLines=26]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",K[K.cursorWidth=28]="cursorWidth",K[K.disableLayerHinting=29]="disableLayerHinting",K[K.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",K[K.domReadOnly=31]="domReadOnly",K[K.dragAndDrop=32]="dragAndDrop",K[K.dropIntoEditor=33]="dropIntoEditor",K[K.emptySelectionClipboard=34]="emptySelectionClipboard",K[K.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",K[K.extraEditorClassName=36]="extraEditorClassName",K[K.fastScrollSensitivity=37]="fastScrollSensitivity",K[K.find=38]="find",K[K.fixedOverflowWidgets=39]="fixedOverflowWidgets",K[K.folding=40]="folding",K[K.foldingStrategy=41]="foldingStrategy",K[K.foldingHighlight=42]="foldingHighlight",K[K.foldingImportsByDefault=43]="foldingImportsByDefault",K[K.foldingMaximumRegions=44]="foldingMaximumRegions",K[K.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=46]="fontFamily",K[K.fontInfo=47]="fontInfo",K[K.fontLigatures=48]="fontLigatures",K[K.fontSize=49]="fontSize",K[K.fontWeight=50]="fontWeight",K[K.fontVariations=51]="fontVariations",K[K.formatOnPaste=52]="formatOnPaste",K[K.formatOnType=53]="formatOnType",K[K.glyphMargin=54]="glyphMargin",K[K.gotoLocation=55]="gotoLocation",K[K.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",K[K.hover=57]="hover",K[K.inDiffEditor=58]="inDiffEditor",K[K.inlineSuggest=59]="inlineSuggest",K[K.letterSpacing=60]="letterSpacing",K[K.lightbulb=61]="lightbulb",K[K.lineDecorationsWidth=62]="lineDecorationsWidth",K[K.lineHeight=63]="lineHeight",K[K.lineNumbers=64]="lineNumbers",K[K.lineNumbersMinChars=65]="lineNumbersMinChars",K[K.linkedEditing=66]="linkedEditing",K[K.links=67]="links",K[K.matchBrackets=68]="matchBrackets",K[K.minimap=69]="minimap",K[K.mouseStyle=70]="mouseStyle",K[K.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=72]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",K[K.multiCursorModifier=74]="multiCursorModifier",K[K.multiCursorPaste=75]="multiCursorPaste",K[K.multiCursorLimit=76]="multiCursorLimit",K[K.occurrencesHighlight=77]="occurrencesHighlight",K[K.overviewRulerBorder=78]="overviewRulerBorder",K[K.overviewRulerLanes=79]="overviewRulerLanes",K[K.padding=80]="padding",K[K.parameterHints=81]="parameterHints",K[K.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",K[K.quickSuggestions=84]="quickSuggestions",K[K.quickSuggestionsDelay=85]="quickSuggestionsDelay",K[K.readOnly=86]="readOnly",K[K.renameOnType=87]="renameOnType",K[K.renderControlCharacters=88]="renderControlCharacters",K[K.renderFinalNewline=89]="renderFinalNewline",K[K.renderLineHighlight=90]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=92]="renderValidationDecorations",K[K.renderWhitespace=93]="renderWhitespace",K[K.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",K[K.roundedSelection=95]="roundedSelection",K[K.rulers=96]="rulers",K[K.scrollbar=97]="scrollbar",K[K.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=99]="scrollBeyondLastLine",K[K.scrollPredominantAxis=100]="scrollPredominantAxis",K[K.selectionClipboard=101]="selectionClipboard",K[K.selectionHighlight=102]="selectionHighlight",K[K.selectOnLineNumbers=103]="selectOnLineNumbers",K[K.showFoldingControls=104]="showFoldingControls",K[K.showUnused=105]="showUnused",K[K.snippetSuggestions=106]="snippetSuggestions",K[K.smartSelect=107]="smartSelect",K[K.smoothScrolling=108]="smoothScrolling",K[K.stickyScroll=109]="stickyScroll",K[K.stickyTabStops=110]="stickyTabStops",K[K.stopRenderingLineAfter=111]="stopRenderingLineAfter",K[K.suggest=112]="suggest",K[K.suggestFontSize=113]="suggestFontSize",K[K.suggestLineHeight=114]="suggestLineHeight",K[K.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",K[K.suggestSelection=116]="suggestSelection",K[K.tabCompletion=117]="tabCompletion",K[K.tabIndex=118]="tabIndex",K[K.unicodeHighlighting=119]="unicodeHighlighting",K[K.unusualLineTerminators=120]="unusualLineTerminators",K[K.useShadowDOM=121]="useShadowDOM",K[K.useTabStops=122]="useTabStops",K[K.wordBreak=123]="wordBreak",K[K.wordSeparators=124]="wordSeparators",K[K.wordWrap=125]="wordWrap",K[K.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=128]="wordWrapColumn",K[K.wordWrapOverride1=129]="wordWrapOverride1",K[K.wordWrapOverride2=130]="wordWrapOverride2",K[K.wrappingIndent=131]="wrappingIndent",K[K.wrappingStrategy=132]="wrappingStrategy",K[K.showDeprecated=133]="showDeprecated",K[K.inlayHints=134]="inlayHints",K[K.editorClassName=135]="editorClassName",K[K.pixelRatio=136]="pixelRatio",K[K.tabFocusMode=137]="tabFocusMode",K[K.layoutInfo=138]="layoutInfo",K[K.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(184,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(185,null),""],markdownDescription:i.localize(186,null)})),accessibilitySupport:Fe(new c),accessibilityPageSize:Fe(new w(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(187,null),tags:["accessibility"]})),ariaLabel:Fe(new v(4,"ariaLabel",i.localize(188,null))),autoClosingBrackets:Fe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(189,null),i.localize(190,null),""],description:i.localize(191,null)})),autoClosingDelete:Fe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(192,null),""],description:i.localize(193,null)})),autoClosingOvertype:Fe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(194,null),""],description:i.localize(195,null)})),autoClosingQuotes:Fe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(196,null),i.localize(197,null),""],description:i.localize(198,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[i.localize(199,null),i.localize(200,null),i.localize(201,null),i.localize(202,null),i.localize(203,null)],description:i.localize(204,null)})),automaticLayout:Fe(new u(10,"automaticLayout",!1)),autoSurround:Fe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(205,null),i.localize(206,null),i.localize(207,null),""],description:i.localize(208,null)})),bracketPairColorization:Fe(new ie),bracketPairGuides:Fe(new fe),stickyTabStops:Fe(new u(110,"stickyTabStops",!1,{description:i.localize(209,null)})),codeLens:Fe(new u(14,"codeLens",!0,{description:i.localize(210,null)})),codeLensFontFamily:Fe(new v(15,"codeLensFontFamily","",{description:i.localize(211,null)})),codeLensFontSize:Fe(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(212,null)})),colorDecorators:Fe(new u(17,"colorDecorators",!0,{description:i.localize(213,null)})),colorDecoratorsLimit:Fe(new w(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(214,null)})),columnSelection:Fe(new u(19,"columnSelection",!1,{description:i.localize(215,null)})),comments:Fe(new S),contextmenu:Fe(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new u(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(216,null)})),cursorBlinking:Fe(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:i.localize(217,null)})),cursorSmoothCaretAnimation:Fe(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(218,null),i.localize(219,null),i.localize(220,null)],description:i.localize(221,null)})),cursorStyle:Fe(new r(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:i.localize(222,null)})),cursorSurroundingLines:Fe(new w(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(223,null)})),cursorSurroundingLinesStyle:Fe(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(224,null),i.localize(225,null)],description:i.localize(226,null)})),cursorWidth:Fe(new w(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(227,null)})),disableLayerHinting:Fe(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new u(31,"domReadOnly",!1)),dragAndDrop:Fe(new u(32,"dragAndDrop",!0,{description:i.localize(228,null)})),emptySelectionClipboard:Fe(new Q),dropIntoEditor:Fe(new it),stickyScroll:Fe(new we),experimentalWhitespaceRendering:Fe(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(229,null),i.localize(230,null),i.localize(231,null)],description:i.localize(232,null)})),extraEditorClassName:Fe(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new R(37,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:i.localize(233,null)})),find:Fe(new Z),fixedOverflowWidgets:Fe(new u(39,"fixedOverflowWidgets",!1)),folding:Fe(new u(40,"folding",!0,{description:i.localize(234,null)})),foldingStrategy:Fe(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(235,null),i.localize(236,null)],description:i.localize(237,null)})),foldingHighlight:Fe(new u(42,"foldingHighlight",!0,{description:i.localize(238,null)})),foldingImportsByDefault:Fe(new u(43,"foldingImportsByDefault",!1,{description:i.localize(239,null)})),foldingMaximumRegions:Fe(new w(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(240,null)})),unfoldOnClickAfterEndOfLine:Fe(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(241,null)})),fontFamily:Fe(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(242,null)})),fontInfo:Fe(new O),fontLigatures2:Fe(new Y),fontSize:Fe(new m),fontWeight:Fe(new L),fontVariations:Fe(new H),formatOnPaste:Fe(new u(52,"formatOnPaste",!1,{description:i.localize(243,null)})),formatOnType:Fe(new u(53,"formatOnType",!1,{description:i.localize(244,null)})),glyphMargin:Fe(new u(54,"glyphMargin",!0,{description:i.localize(245,null)})),gotoLocation:Fe(new B),hideCursorInOverviewRuler:Fe(new u(56,"hideCursorInOverviewRuler",!1,{description:i.localize(246,null)})),hover:Fe(new J),inDiffEditor:Fe(new u(58,"inDiffEditor",!1)),letterSpacing:Fe(new R(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>R.clamp(K,-5,20),{description:i.localize(247,null)})),lightbulb:Fe(new ce),lineDecorationsWidth:Fe(new q),lineHeight:Fe(new G),lineNumbers:Fe(new ae),lineNumbersMinChars:Fe(new w(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new u(66,"linkedEditing",!1,{description:i.localize(248,null)})),links:Fe(new u(67,"links",!0,{description:i.localize(249,null)})),matchBrackets:Fe(new d(68,"matchBrackets","always",["always","near","never"],{description:i.localize(250,null)})),minimap:Fe(new de),mouseStyle:Fe(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new R(71,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:i.localize(251,null)})),mouseWheelZoom:Fe(new u(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(252,null)})),multiCursorMergeOverlapping:Fe(new u(73,"multiCursorMergeOverlapping",!0,{description:i.localize(253,null)})),multiCursorModifier:Fe(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Se,{markdownEnumDescriptions:[i.localize(254,null),i.localize(255,null)],markdownDescription:i.localize(256,null)})),multiCursorPaste:Fe(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(257,null),i.localize(258,null)],markdownDescription:i.localize(259,null)})),multiCursorLimit:Fe(new w(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(260,null)})),occurrencesHighlight:Fe(new u(77,"occurrencesHighlight",!0,{description:i.localize(261,null)})),overviewRulerBorder:Fe(new u(78,"overviewRulerBorder",!0,{description:i.localize(262,null)})),overviewRulerLanes:Fe(new w(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Le),parameterHints:Fe(new xe),peekWidgetDefaultFocus:Fe(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(263,null),i.localize(264,null)],description:i.localize(265,null)})),definitionLinkOpensInPeek:Fe(new u(83,"definitionLinkOpensInPeek",!1,{description:i.localize(266,null)})),quickSuggestions:Fe(new De),quickSuggestionsDelay:Fe(new w(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(267,null)})),readOnly:Fe(new u(86,"readOnly",!1)),renameOnType:Fe(new u(87,"renameOnType",!1,{description:i.localize(268,null),markdownDeprecationMessage:i.localize(269,null)})),renderControlCharacters:Fe(new u(88,"renderControlCharacters",!0,{description:i.localize(270,null),restricted:!0})),renderFinalNewline:Fe(new d(89,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(271,null)})),renderLineHighlight:Fe(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(272,null)],description:i.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Fe(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(274,null)})),renderValidationDecorations:Fe(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(275,null),i.localize(276,null),i.localize(277,null),""],description:i.localize(278,null)})),revealHorizontalRightPadding:Fe(new w(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new u(95,"roundedSelection",!0,{description:i.localize(279,null)})),rulers:Fe(new ee),scrollbar:Fe(new U),scrollBeyondLastColumn:Fe(new w(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(280,null)})),scrollBeyondLastLine:Fe(new u(99,"scrollBeyondLastLine",!0,{description:i.localize(281,null)})),scrollPredominantAxis:Fe(new u(100,"scrollPredominantAxis",!0,{description:i.localize(282,null)})),selectionClipboard:Fe(new u(101,"selectionClipboard",!0,{description:i.localize(283,null),included:k.isLinux})),selectionHighlight:Fe(new u(102,"selectionHighlight",!0,{description:i.localize(284,null)})),selectOnLineNumbers:Fe(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(285,null),i.localize(286,null),i.localize(287,null)],description:i.localize(288,null)})),showUnused:Fe(new u(105,"showUnused",!0,{description:i.localize(289,null)})),showDeprecated:Fe(new u(133,"showDeprecated",!0,{description:i.localize(290,null)})),inlayHints:Fe(new V),snippetSuggestions:Fe(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(291,null),i.localize(292,null),i.localize(293,null),i.localize(294,null)],description:i.localize(295,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new u(108,"smoothScrolling",!1,{description:i.localize(296,null)})),stopRenderingLineAfter:Fe(new w(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new le),inlineSuggest:Fe(new W),suggestFontSize:Fe(new w(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new w(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new u(115,"suggestOnTriggerCharacters",!0,{description:i.localize(299,null)})),suggestSelection:Fe(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(300,null),i.localize(301,null),i.localize(302,null)],description:i.localize(303,null)})),tabCompletion:Fe(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(304,null),i.localize(305,null),i.localize(306,null)],description:i.localize(307,null)})),tabIndex:Fe(new w(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new $),unusualLineTerminators:Fe(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(308,null),i.localize(309,null),i.localize(310,null)],description:i.localize(311,null)})),useShadowDOM:Fe(new u(121,"useShadowDOM",!0)),useTabStops:Fe(new u(122,"useTabStops",!0,{description:i.localize(312,null)})),wordBreak:Fe(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(313,null),i.localize(314,null)],description:i.localize(315,null)})),wordSeparators:Fe(new v(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:i.localize(316,null)})),wordWrap:Fe(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(317,null),i.localize(318,null),i.localize(319,null),i.localize(320,null)],description:i.localize(321,null)})),wordWrapBreakAfterCharacters:Fe(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new w(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(322,null)})),wordWrapOverride1:Fe(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new z),pixelRatio:Fe(new Te),tabFocusMode:Fe(new u(137,"tabFocusMode",!1,{markdownDescription:i.localize(323,null)})),layoutInfo:Fe(new te),wrappingInfo:Fe(new He),wrappingIndent:Fe(new ze),wrappingStrategy:Fe(new oe)}}),define(Ie[132],ke([13,14]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[133],ke([13,14]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[134],ke([13,14]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[135],ke([13,14]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Ie[136],ke([13,14]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Ie[137],ke([13,14]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[138],ke([13,14]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Ie[139],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[140],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[141],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[142],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[143],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ie[144],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[145],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[146],ke([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[147],ke([13,14]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Ie[148],ke([13,14]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(Ie[149],ke([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[150],ke([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[151],ke([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[152],ke([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[153],ke([13,14]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[154],ke([13,14]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[155],ke([13,14]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[156],ke([1,0,11]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(F){F[F.LParen=0]="LParen",F[F.RParen=1]="RParen",F[F.Neg=2]="Neg",F[F.Eq=3]="Eq",F[F.NotEq=4]="NotEq",F[F.Lt=5]="Lt",F[F.LtEq=6]="LtEq",F[F.Gt=7]="Gt",F[F.GtEq=8]="GtEq",F[F.RegexOp=9]="RegexOp",F[F.RegexStr=10]="RegexStr",F[F.True=11]="True",F[F.False=12]="False",F[F.In=13]="In",F[F.Not=14]="Not",F[F.And=15]="And",F[F.Or=16]="Or",F[F.Str=17]="Str",F[F.QuotedStr=18]="QuotedStr",F[F.Error=19]="Error",F[F.EOF=20]="EOF"})(k=e.TokenType||(e.TokenType={}));class D{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errorTokens=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(b){if(b.type!==19)throw(0,i.illegalArgument)(`expected an error token but got ${JSON.stringify(b)}`);switch(b.lexeme){case"=":return`Unexpected token '${b.lexeme}' at offset ${b.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${b.lexeme}' at offset ${b.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${b.lexeme}' at offset ${b.offset}. Did you mean '||'?`;default:{const A=b.lexeme;return A&&A.length>1&&A.startsWith("'")?`Unexpected token '${b.lexeme}' at offset ${b.offset}. Did you forget to close the string?`:A&&A.length>1&&A.endsWith("'")?`Unexpected token '${b.lexeme}' at offset ${b.offset}. Did you forget to open the string?`:`Unexpected token '${b.lexeme}' at offset ${b.offset}`}}}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,i.illegalState)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}get errorTokens(){return this._errorTokens}reset(b){return this._input=b,this._start=0,this._current=0,this._tokens=[],this._errorTokens=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:this._addToken(this._match(61)?4:2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:this._match(61)?this._addToken(3):this._match(126)?this._addToken(9):this._error();break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error();break;case 124:this._match(124)?this._addToken(16):this._error();break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(b){return this._isAtEnd()||this._input.charCodeAt(this._current)!==b?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(b){this._tokens.push({type:b,offset:this._start})}_error(){const b={type:19,offset:this._start,lexeme:this._input.substring(this._start,this._current)};this._errorTokens.push(b),this._tokens.push(b)}_string(){this.stringRe.lastIndex=this._start;const b=this.stringRe.exec(this._input);if(b){this._current=this._start+b[0].length;const A=this._input.substring(this._start,this._current),_=D._keywords.get(A);_?this._addToken(_):this._tokens.push({type:17,lexeme:A,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error();return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let b=this._current,A=!1,_=!1;for(;;){if(b>=this._input.length){this._current=b,this._error();return}const N=this._input.charCodeAt(b);if(A)A=!1;else if(N===47&&!_){b++;break}else N===91?_=!0:N===92?A=!0:N===93&&(_=!1);b++}for(;b<this._input.length&&D._regexFlags.has(this._input.charCodeAt(b));)b++;this._current=b;const I=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:I,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}D._regexFlags=new Set(["i","g","s","m","y","u"].map(F=>F.charCodeAt(0))),D._keywords=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=D}),define(Ie[157],ke([1,0,11]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this._generators=new Map}register(F,b){this._generators.set(F,b)}updateManifest(F){if(!(typeof F.main>"u"&&typeof F.browser>"u")&&(F.activationEvents===void 0&&Object.assign(F,{activationEvents:[]}),!(!Array.isArray(F.activationEvents)||!F.contributes)))for(const b in F.contributes){const A=this._generators.get(b);if(!A)continue;const _=F.contributes[b],I=Array.isArray(_)?_:[_];try{A(I,F.activationEvents)}catch(N){(0,i.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Ie[158],ke([1,0,24,29,134,258]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function _(u){return u=u.trim(),u==="*"||b.test(u)}e.isValidVersionStr=_;function I(u){if(!_(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(b);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=I;function N(u){if(!u)return null;const p=u.majorBase,w=u.majorMustEqual,R=u.minorBase;let v=u.minorMustEqual;const t=u.patchBase;let d=u.patchMustEqual;u.hasCaret&&(p===0||(v=!1),d=!1);let r=0;if(u.preRelease){const l=A.exec(u.preRelease);if(l){const[,c,S,n]=l;r=Date.UTC(Number(c),Number(S)-1,Number(n))}}return{majorBase:p,majorMustEqual:w,minorBase:R,minorMustEqual:v,patchBase:t,patchMustEqual:d,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=N;function y(u,p,w){let R;typeof u=="string"?R=N(I(u)):R=u;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let t;if(typeof w=="string"?t=N(I(w)):t=w,!R||!t)return!1;const d=R.majorBase,r=R.minorBase,l=R.patchBase;let c=t.majorBase,S=t.minorBase,n=t.patchBase;const s=t.notBefore;let f=t.majorMustEqual,P=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?d>c?!0:d<c?!1:r>S?!0:r<S||v&&v<s?!1:l>=n:(d===1&&c===0&&(!f||!P||!T)&&(c=1,S=0,n=0,f=!0,P=!1,T=!1),d<c?!1:d>c?!f:r<S?!1:r>S?!P:l<n?!1:l>n?!T:!(v&&v<s))}e.isValidVersion=y;function h(u,p,w,R,v){const t=[];if(typeof R.publisher<"u"&&typeof R.publisher!="string")return t.push([k.default.Error,D.localize(0,null)]),t;if(typeof R.name!="string")return t.push([k.default.Error,D.localize(1,null,"name")]),t;if(typeof R.version!="string")return t.push([k.default.Error,D.localize(2,null,"version")]),t;if(!R.engines)return t.push([k.default.Error,D.localize(3,null,"engines")]),t;if(typeof R.engines.vscode!="string")return t.push([k.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof R.extensionDependencies<"u"&&!o(R.extensionDependencies))return t.push([k.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof R.activationEvents<"u"){if(!o(R.activationEvents))return t.push([k.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof R.main>"u"&&typeof R.browser>"u")return t.push([k.default.Error,D.localize(7,null,"activationEvents","main")]),t}if(typeof R.extensionKind<"u"&&typeof R.main>"u"&&t.push([k.default.Warning,D.localize(8,null,"extensionKind")]),typeof R.main<"u"){if(typeof R.main!="string")return t.push([k.default.Error,D.localize(9,null,"main")]),t;{const l=(0,i.joinPath)(w,R.main);(0,i.isEqualOrParent)(l,w)||t.push([k.default.Warning,D.localize(10,null,l.path,w.path)])}if(typeof R.activationEvents>"u")return t.push([k.default.Error,D.localize(11,null,"activationEvents","main")]),t}if(typeof R.browser<"u"){if(typeof R.browser!="string")return t.push([k.default.Error,D.localize(12,null,"browser")]),t;{const l=(0,i.joinPath)(w,R.browser);(0,i.isEqualOrParent)(l,w)||t.push([k.default.Warning,D.localize(13,null,l.path,w.path)])}if(typeof R.activationEvents>"u")return t.push([k.default.Error,D.localize(14,null,"activationEvents","browser")]),t}if(!F.valid(R.version))return t.push([k.default.Error,D.localize(15,null)]),t;const d=[];if(!E(u,p,R,v,d))for(const l of d)t.push([k.default.Error,l]);return t}e.validateExtensionManifest=h;function E(u,p,w,R,v){return R||typeof w.main>"u"&&typeof w.browser>"u"?!0:a(u,p,w.engines.vscode,v)}e.isValidExtensionVersion=E;function g(u,p,w){return u==="*"||a(p,w,u)}e.isEngineValid=g;function a(u,p,w,R=[]){const v=N(I(w));if(!v)return R.push(D.localize(16,null,w)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return R.push(D.localize(17,null,w)),!1}else if(!v.majorMustEqual)return R.push(D.localize(18,null,w)),!1;return y(u,p,v)?!0:(R.push(D.localize(19,null,u,w)),!1)}function o(u){if(!Array.isArray(u))return!1;for(let p=0,w=u.length;p<w;p++)if(typeof u[p]!="string")return!1;return!0}}),define(Ie[89],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(D,F=[],b=!1){this.ctor=D,this.staticArguments=F,this.supportsDelayedInstantiation=b}}e.SyncDescriptor=i}),define(Ie[67],ke([1,0,89]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var D;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function F(A,_,I){_ instanceof i.SyncDescriptor||(_=new i.SyncDescriptor(_,[],Boolean(I))),k.push([A,_])}e.registerSingleton=F;function b(){return k}e.getSingletonServiceDescriptors=b}),define(Ie[159],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(F,b){this.key=F,this.data=b,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class k{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(const b of this._nodes.values())b.outgoing.size===0&&F.push(b);return F}insertEdge(F,b){const A=this.lookupOrInsertNode(F),_=this.lookupOrInsertNode(b);A.outgoing.set(_.key,_),_.incoming.set(A.key,A)}removeNode(F){const b=this._hashFn(F);this._nodes.delete(b);for(const A of this._nodes.values())A.outgoing.delete(b),A.incoming.delete(b)}lookupOrInsertNode(F){const b=this._hashFn(F);let A=this._nodes.get(b);return A||(A=new i(b,F),this._nodes.set(b,A)),A}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){const F=[];for(const[b,A]of this._nodes)F.push(`${b}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,b]of this._nodes){const A=new Set([F]),_=this._findCycle(b,A);if(_)return _}}_findCycle(F,b){for(const[A,_]of F.outgoing){if(b.has(A))return[...b,A].join(" -> ");b.add(A);const I=this._findCycle(_,b);if(I)return I;b.delete(A)}}}e.Graph=k}),define(Ie[3],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(b){b.serviceIds=new Map,b.DI_TARGET="$di$target",b.DI_DEPENDENCIES="$di$dependencies";function A(_){return _[b.DI_DEPENDENCIES]||[]}b.getServiceDependencies=A})(i=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function k(b,A,_){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:b,index:_}):(A[i.DI_DEPENDENCIES]=[{id:b,index:_}],A[i.DI_TARGET]=A)}function D(b){if(i.serviceIds.has(b))return i.serviceIds.get(b);const A=function(_,I,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(A,_,N)};return A.toString=()=>b,i.serviceIds.set(b,A),A}e.createDecorator=D;function F(b){return b}e.refineServiceDecorator=F}),define(Ie[41],ke([1,0,9,2,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function F(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof k.URI)}e.isConfigurationOverrides=F;function b(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=b;var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=_;function I(o,u){const p=Object.create(null);for(const w in o)N(p,w,o[w],u);return p}e.toValuesTree=I;function N(o,u,p,w){const R=u.split("."),v=R.pop();let t=o;for(let d=0;d<R.length;d++){const r=R[d];let l=t[r];switch(typeof l){case"undefined":l=t[r]=Object.create(null);break;case"object":break;default:w(`Ignoring ${u} as ${R.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}t=l}if(typeof t=="object"&&t!==null)try{t[v]=p}catch{w(`Ignoring ${u} as ${R.join(".")} is ${JSON.stringify(t)}`)}else w(`Ignoring ${u} as ${R.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=N;function y(o,u){const p=u.split(".");h(o,p)}e.removeFromValueTree=y;function h(o,u){const p=u.shift();if(u.length===0){delete o[p];return}if(Object.keys(o).indexOf(p)!==-1){const w=o[p];typeof w=="object"&&!Array.isArray(w)&&(h(w,u),Object.keys(w).length===0&&delete o[p])}}function E(o,u,p){function w(t,d){let r=t;for(const l of d){if(typeof r!="object"||r===null)return;r=r[l]}return r}const R=u.split("."),v=w(o,R);return typeof v>"u"?p:v}e.getConfigurationValue=E;function g(o,u,p){Object.keys(u).forEach(w=>{w!=="__proto__"&&(w in o?i.isObject(o[w])&&i.isObject(u[w])?g(o[w],u[w],p):p&&(o[w]=u[w]):o[w]=u[w])})}e.merge=g;function a(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(Ie[42],ke([1,0,20,10,156,3]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",i.isMacintosh),b.set("isLinux",i.isLinux),b.set("isWindows",i.isWindows),b.set("isWeb",i.isWeb),b.set("isMacNative",i.isMacintosh&&!i.isWeb),b.set("isEdge",i.isEdge),b.set("isFirefox",i.isFirefox),b.set("isChrome",i.isChrome),b.set("isSafari",i.isSafari);const A=Object.prototype.hasOwnProperty;var _;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return g.INSTANCE}static true(){return a.INSTANCE}static has(m){return o.create(m)}static equals(m,L){return u.create(m,L)}static notEquals(m,L){return R.create(m,L)}static regex(m,L){return S.create(m,L)}static in(m,L){return p.create(m,L)}static notIn(m,L){return w.create(m,L)}static not(m){return v.create(m)}static and(...m){return f.create(m,null,!0)}static or(...m){return P.create(m,null,!0)}static greater(m,L){return d.create(m,L)}static greaterEquals(m,L){return r.create(m,L)}static smaller(m,L){return l.create(m,L)}static smallerEquals(m,L){return c.create(m,L)}static deserializeOrErrorNew(m){if(!m)return{type:"error",lexingErrors:[],parsingErrors:[]};const L=new y,B=L.parse(m);return B===void 0?{type:"error",lexingErrors:L.lexingErrors.map(J=>D.Scanner.reportError(J)),parsingErrors:L.parsingErrors}:{type:"ok",expr:B}}static deserialize(m){if(!!m)return this._deserializeOrExpression(m)}static _deserializeOrExpression(m){const L=m.split("||");return P.create(L.map(B=>this._deserializeAndExpression(B)),null,!0)}static _deserializeAndExpression(m){const L=m.split("&&");return f.create(L.map(B=>this._deserializeOne(B)),null,!0)}static _deserializeOne(m){if(m=m.trim(),m.indexOf("!=")>=0){const L=m.split("!=");return R.create(L[0].trim(),this._deserializeValue(L[1]))}if(m.indexOf("==")>=0){const L=m.split("==");return u.create(L[0].trim(),this._deserializeValue(L[1]))}if(m.indexOf("=~")>=0){const L=m.split("=~");return S.create(L[0].trim(),this._deserializeRegexValue(L[1]))}if(m.indexOf(" not in ")>=0){const L=m.split(" not in ");return w.create(L[0].trim(),this._deserializeValue(L[1]))}if(m.indexOf(" in ")>=0){const L=m.split(" in ");return p.create(L[0].trim(),this._deserializeValue(L[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const L=m.split(">=");return r.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const L=m.split(">");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const L=m.split("<=");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const L=m.split("<");return l.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(m)?v.create(m.substr(1).trim()):o.create(m)}static _deserializeValue(m){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;const L=/^'([^']*)'$/.exec(m);return L?L[1].trim():m}static _deserializeRegexValue(m){if((0,k.isFalsyOrWhitespace)(m))return null;const L=m.indexOf("/"),B=m.lastIndexOf("/");if(L===B||L<0)return null;const J=m.slice(L+1,B),me=m[B+1]==="i"?"i":"";try{return new RegExp(J,me)}catch{return null}}}e.ContextKeyExpr=I;class N extends Error{}class y{constructor(){this._scanner=new D.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[]}get lexingErrors(){return this._scanner.errorTokens}get parsingErrors(){return this._parsingErrors}parse(m){if(m===""){this._parsingErrors.push("Expected an expression but got an empty string");return}this._tokens=this._scanner.reset(m).scan(),this._current=0,this._parsingErrors=[];try{const L=this._expr();if(!this._isAtEnd())throw this._errUnexpected(this._peek());return L}catch(L){if(!(L instanceof N)){const B=this._peek();this._parsingErrors.push(`Unexpected error: ${L} for token ${D.Scanner.getLexeme(B)} at offset ${B.offset}.`)}return}}_expr(){return this._or()}_or(){const m=[this._and()];for(;this._matchOne(16);){const L=this._and();m.push(L)}return m.length===1?m[0]:I.or(...m)}_and(){const m=[this._term()];for(;this._matchOne(15);){const L=this._term();m.push(L)}return m.length===1?m[0]:I.and(...m)}_term(){if(this._matchOne(2)){const m=this._peek();switch(m.type){case 17:return this._advance(),I.not(m.lexeme);case 11:return this._advance(),I.false();case 12:return this._advance(),I.true();default:throw this._errExpectedButGot("KEY, 'true', or 'false'",m)}}return this._primary()}_primary(){const m=this._peek();switch(m.type){case 11:return this._advance(),I.true();case 12:return this._advance(),I.false();case 0:{this._advance();const L=this._expr();return this._consume(1,"')'"),L}case 17:{const L=m.lexeme;if(this._advance(),this._matchOne(9)){const J=this._peek();switch(J.type){case 10:case 19:{const me=[J.lexeme];this._advance();let te=this._peek(),oe=0;for(let G=0;G<J.lexeme.length;G++)J.lexeme.charCodeAt(G)===40?oe++:J.lexeme.charCodeAt(G)===41&&oe--;for(;!this._isAtEnd()&&te.type!==15&&te.type!==16;){switch(te.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let G=0;G<te.lexeme.length;G++)te.lexeme.charCodeAt(G)===40?oe++:J.lexeme.charCodeAt(G)===41&&oe--}if(oe<0)break;me.push(D.Scanner.getLexeme(te)),this._advance(),te=this._peek()}const ce=me.join(""),we=ce.lastIndexOf("/"),V=we===ce.length-1?void 0:ce.substring(we+1),q=new RegExp(ce.substring(1,we),V);return I.regex(L,q)}case 18:{const me=J.lexeme;this._advance();let te=null;if(!(0,k.isFalsyOrWhitespace)(me)){const oe=me.indexOf("/"),ce=me.lastIndexOf("/");if(oe!==ce&&oe>=0){const we=me.slice(oe+1,ce),V=me[ce+1]==="i"?"i":"";try{te=new RegExp(we,V)}catch{}}}if(te===null)throw this._errExpectedButGot("REGEX",J);return S.create(L,te)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,"'in' after 'not'");const J=this._value();return I.notIn(L,J)}switch(this._peek().type){case 3:{this._advance();const J=this._value();switch(J){case"true":return I.has(L);case"false":return I.not(L);default:return I.equals(L,J)}}case 4:{this._advance();const J=this._value();switch(J){case"true":return I.not(L);case"false":return I.has(L);default:return I.notEquals(L,J)}}case 5:return this._advance(),l.create(L,this._value());case 6:return this._advance(),c.create(L,this._value());case 7:return this._advance(),d.create(L,this._value());case 8:return this._advance(),r.create(L,this._value());case 13:return this._advance(),I.in(L,this._value());default:return I.has(L)}}default:throw this._errExpectedButGot("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this._peek())}}_value(){const m=this._peek();switch(m.type){case 17:case 18:return this._advance(),m.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_previous(){return this._tokens[this._current-1]}_matchOne(m){return this._check(m)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(m,L){if(this._check(m))return this._advance();throw this._errExpectedButGot(L,this._peek())}_errExpectedButGot(m,L){return this._error(`Expected ${m} but got '${D.Scanner.getLexeme(L)}' at offset ${L.offset}.`)}_errUnexpected(m){return this._error(`Unexpected '${D.Scanner.getLexeme(m)}' at offset ${m.offset}.`)}_error(m){return this._parsingErrors.push(m),new N}_check(m){return this._peek().type===m}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=y;function h(O,m){const L=O?O.substituteConstants():void 0,B=m?m.substituteConstants():void 0;return!L&&!B?!0:!L||!B?!1:L.equals(B)}e.expressionsAreEqualWithConstantSubstitution=h;function E(O,m){return O.cmp(m)}class g{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return a.INSTANCE}}g.INSTANCE=new g,e.ContextKeyFalseExpr=g;class a{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return g.INSTANCE}}a.INSTANCE=new a,e.ContextKeyTrueExpr=a;class o{static create(m,L=null){const B=b.get(m);return typeof B=="boolean"?B?a.INSTANCE:g.INSTANCE:new o(m,L)}constructor(m,L){this.key=m,this.negated=L,this.type=2}cmp(m){return m.type!==this.type?this.type-m.type:z(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=b.get(this.key);return typeof m=="boolean"?m?a.INSTANCE:g.INSTANCE:this}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class u{static create(m,L,B=null){if(typeof L=="boolean")return L?o.create(m,B):v.create(m,B);const J=b.get(m);return typeof J=="boolean"?L===(J?"true":"false")?a.INSTANCE:g.INSTANCE:new u(m,L,B)}constructor(m,L,B){this.key=m,this.value=L,this.negated=B,this.type=4}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=b.get(this.key);if(typeof m=="boolean"){const L=m?"true":"false";return this.value===L?a.INSTANCE:g.INSTANCE}return this}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class p{static create(m,L){return new p(m,L)}constructor(m,L){this.key=m,this.valueKey=L,this.type=10,this.negated=null}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}substituteConstants(){return this}evaluate(m){const L=m.getValue(this.valueKey),B=m.getValue(this.key);return Array.isArray(L)?L.includes(B):typeof B=="string"&&typeof L=="object"&&L!==null?A.call(L,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class w{static create(m,L){return new w(m,L)}constructor(m,L){this.key=m,this.valueKey=L,this.type=11,this._negated=p.create(m,L)}cmp(m){return m.type!==this.type?this.type-m.type:this._negated.cmp(m._negated)}equals(m){return m.type===this.type?this._negated.equals(m._negated):!1}substituteConstants(){return this}evaluate(m){return!this._negated.evaluate(m)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(m){return m.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class R{static create(m,L,B=null){if(typeof L=="boolean")return L?v.create(m,B):o.create(m,B);const J=b.get(m);return typeof J=="boolean"?L===(J?"true":"false")?g.INSTANCE:a.INSTANCE:new R(m,L,B)}constructor(m,L,B){this.key=m,this.value=L,this.negated=B,this.type=5}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=b.get(this.key);if(typeof m=="boolean"){const L=m?"true":"false";return this.value===L?g.INSTANCE:a.INSTANCE}return this}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=R;class v{static create(m,L=null){const B=b.get(m);return typeof B=="boolean"?B?g.INSTANCE:a.INSTANCE:new v(m,L)}constructor(m,L){this.key=m,this.negated=L,this.type=3}cmp(m){return m.type!==this.type?this.type-m.type:z(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=b.get(this.key);return typeof m=="boolean"?m?g.INSTANCE:a.INSTANCE:this}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function t(O,m){if(typeof O=="string"){const L=parseFloat(O);isNaN(L)||(O=L)}return typeof O=="string"||typeof O=="number"?m(O):g.INSTANCE}class d{static create(m,L,B=null){return t(L,J=>new d(m,J,B))}constructor(m,L,B){this.key=m,this.value=L,this.negated=B,this.type=12}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class r{static create(m,L,B=null){return t(L,J=>new r(m,J,B))}constructor(m,L,B){this.key=m,this.value=L,this.negated=B,this.type=13}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class l{static create(m,L,B=null){return t(L,J=>new l(m,J,B))}constructor(m,L,B){this.key=m,this.value=L,this.negated=B,this.type=14}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=l;class c{static create(m,L,B=null){return t(L,J=>new c(m,J,B))}constructor(m,L,B){this.key=m,this.value=L,this.negated=B,this.type=15}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class S{static create(m,L){return new S(m,L)}constructor(m,L){this.key=m,this.regexp=L,this.type=7,this.negated=null}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const L=this.regexp?this.regexp.source:"",B=m.regexp?m.regexp.source:"";return L<B?-1:L>B?1:0}equals(m){if(m.type===this.type){const L=this.regexp?this.regexp.source:"",B=m.regexp?m.regexp.source:"";return this.key===m.key&&L===B}return!1}substituteConstants(){return this}evaluate(m){const L=m.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=S;class n{static create(m){return new n(m)}constructor(m){this._actual=m,this.type=8}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}substituteConstants(){return this}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new n(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(O){let m=null;for(let L=0,B=O.length;L<B;L++){const J=O[L].substituteConstants();if(O[L]!==J&&m===null){m=[];for(let me=0;me<L;me++)m[me]=O[me]}m!==null&&(m[L]=J)}return m===null?O:m}class f{static create(m,L,B){return f._normalizeArr(m,L,B)}constructor(m,L){this.expr=m,this.negated=L,this.type=6}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const J=E(this.expr[L],m.expr[L]);if(J!==0)return J}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(m.expr[L]))return!1;return!0}return!1}substituteConstants(){const m=s(this.expr);return m===this.expr?this:f.create(m,this.negated,!1)}evaluate(m){for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].evaluate(m))return!1;return!0}static _normalizeArr(m,L,B){const J=[];let me=!1;for(const te of m)if(!!te){if(te.type===1){me=!0;continue}if(te.type===0)return g.INSTANCE;if(te.type===6){J.push(...te.expr);continue}J.push(te)}if(J.length===0&&me)return a.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(E);for(let te=1;te<J.length;te++)J[te-1].equals(J[te])&&(J.splice(te,1),te--);if(J.length===1)return J[0];for(;J.length>1;){const te=J[J.length-1];if(te.type!==9)break;J.pop();const oe=J.pop(),ce=J.length===0,we=P.create(te.expr.map(V=>f.create([V,oe],null,B)),null,ce);we&&(J.push(we),J.sort(E))}if(J.length===1)return J[0];if(B){for(let te=0;te<J.length;te++)for(let oe=te+1;oe<J.length;oe++)if(J[te].negate().equals(J[oe]))return g.INSTANCE;if(J.length===1)return J[0]}return new f(J,L)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(const L of this.expr)m.push(...L.keys());return m}map(m){return new f(this.expr.map(L=>L.map(m)),null)}negate(){if(!this.negated){const m=[];for(const L of this.expr)m.push(L.negate());this.negated=P.create(m,this,!0)}return this.negated}}class P{static create(m,L,B){return P._normalizeArr(m,L,B)}constructor(m,L){this.expr=m,this.negated=L,this.type=9}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const J=E(this.expr[L],m.expr[L]);if(J!==0)return J}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(m.expr[L]))return!1;return!0}return!1}substituteConstants(){const m=s(this.expr);return m===this.expr?this:P.create(m,this.negated,!1)}evaluate(m){for(let L=0,B=this.expr.length;L<B;L++)if(this.expr[L].evaluate(m))return!0;return!1}static _normalizeArr(m,L,B){let J=[],me=!1;if(m){for(let te=0,oe=m.length;te<oe;te++){const ce=m[te];if(!!ce){if(ce.type===0){me=!0;continue}if(ce.type===1)return a.INSTANCE;if(ce.type===9){J=J.concat(ce.expr);continue}J.push(ce)}}if(J.length===0&&me)return g.INSTANCE;J.sort(E)}if(J.length!==0){if(J.length===1)return J[0];for(let te=1;te<J.length;te++)J[te-1].equals(J[te])&&(J.splice(te,1),te--);if(J.length===1)return J[0];if(B){for(let te=0;te<J.length;te++)for(let oe=te+1;oe<J.length;oe++)if(J[te].negate().equals(J[oe]))return a.INSTANCE;if(J.length===1)return J[0]}return new P(J,L)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(const L of this.expr)m.push(...L.keys());return m}map(m){return new P(this.expr.map(L=>L.map(m)),null)}negate(){if(!this.negated){const m=[];for(const L of this.expr)m.push(L.negate());for(;m.length>1;){const L=m.shift(),B=m.shift(),J=[];for(const me of H(L))for(const te of H(B))J.push(f.create([me,te],null,!1));m.unshift(P.create(J,null,!1))}this.negated=P.create(m,this,!0)}return this.negated}}class T extends o{static all(){return T._info.values()}constructor(m,L,B){super(m,null),this._defaultValue=L,typeof B=="object"?T._info.push({...B,key:m}):B!==!0&&T._info.push({key:m,description:B,type:L!=null?typeof L:void 0})}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return u.create(this.key,m)}notEqualsTo(m){return R.create(this.key,m)}}T._info=[],e.RawContextKey=T,e.IContextKeyService=(0,F.createDecorator)("contextKeyService");function z(O,m){return O<m?-1:O>m?1:0}function Q(O,m,L,B){return O<L?-1:O>L?1:m<B?-1:m>B?1:0}function Z(O,m){if(O.type===0||m.type===1)return!0;if(O.type===9)return m.type===9?Y(O.expr,m.expr):!1;if(m.type===9){for(const L of m.expr)if(Z(O,L))return!0;return!1}if(O.type===6){if(m.type===6)return Y(m.expr,O.expr);for(const L of O.expr)if(Z(L,m))return!0;return!1}return O.equals(m)}e.implies=Z;function Y(O,m){let L=0,B=0;for(;L<O.length&&B<m.length;){const J=O[L].cmp(m[B]);if(J<0)return!1;J===0&&L++,B++}return L===O.length}function H(O){return O.type===9?O.expr:[O]}}),define(Ie[160],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[90],ke([1,0,133,3]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function F(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function b(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=b;function A(u,p){return p==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function _(u,p,w){return A(p,w)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===w?!0:I(w).includes(u)}e.isTargetPlatformCompatible=_;function I(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function N(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=N;var y;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var h;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var E;(function(u){u.Install="install",u.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var g;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var a;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(p,w){super(p),this.code=w,this.name=w}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,i.localize)(1,null),original:"Preferences"}}),define(Ie[43],ke([1,0,48,19,10,9,2,135,3,20,15]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function y(te){return te.create===!0}e.isFileOpenForWriteOptions=y;var h;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(h=e.FileType||(e.FileType={}));var E;(function(te){te[te.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var g;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function a(te){return!!(te.capabilities&2)}e.hasReadWriteCapability=a;function o(te){return!!(te.capabilities&8)}e.hasFileFolderCopyCapability=o;function u(te){return!!(te.capabilities&32768)}e.hasFileCloneCapability=u;function p(te){return!!(te.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function w(te){return!!(te.capabilities&16)}e.hasFileReadStreamCapability=w;function R(te){return a(te)?!!(te.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var v;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(oe,ce){const we=new t(oe.toString(),ce);return l(we,ce),we}constructor(oe,ce){super(oe),this.code=ce}}e.FileSystemProviderError=t;function d(te,oe){return t.create(te,oe)}e.createFileSystemProviderError=d;function r(te){return te||d((0,A.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=r;function l(te,oe){return te.name=oe?`${oe} (FileSystemError)`:"FileSystemError",te}e.markAsFileSystemProviderError=l;function c(te){if(!te)return v.Unknown;if(te instanceof t)return te.code;const oe=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!oe)return v.Unknown;switch(oe[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=c;function S(te){if(te instanceof z)return te.fileOperationResult;switch(c(te)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=S;var n;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(oe,ce,we){this.resource=oe,this.operation=ce,this.target=we}isOperation(oe){return this.operation===oe}}e.FileOperationEvent=s;var f;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class P{constructor(oe,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const we=new Map;for(const V of oe){const q=we.get(V.type);switch(q?q.push([V.resource,V]):we.set(V.type,[[V.resource,V]]),V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}}for(const[V,q]of we)switch(V){case 1:this.added=i.TernarySearchTree.forUris(()=>ce),this.added.fill(q);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>ce),this.updated.fill(q);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>ce),this.deleted.fill(q);break}}contains(oe,...ce){return this.doContains(oe,{includeChildren:!1},...ce)}affects(oe,...ce){return this.doContains(oe,{includeChildren:!0},...ce)}doContains(oe,ce,...we){if(!oe)return!1;const V=we.length>0;return!!((!V||we.includes(1))&&(this.added?.get(oe)||ce.includeChildren&&this.added?.findSuperstr(oe))||(!V||we.includes(0))&&(this.updated?.get(oe)||ce.includeChildren&&this.updated?.findSuperstr(oe))||(!V||we.includes(2))&&(this.deleted?.findSubstr(oe)||ce.includeChildren&&this.deleted?.findSuperstr(oe)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function T(te,oe,ce){return!te||!oe||te===oe||oe.length>te.length?!1:(oe.charAt(oe.length-1)!==k.sep&&(oe+=k.sep),ce?(0,D.startsWithIgnoreCase)(te,oe):te.indexOf(oe)===0)}e.isParent=T;class z extends Error{constructor(oe,ce,we){super(oe),this.fileOperationResult=ce,this.options=we}}e.FileOperationError=z;class Q extends z{constructor(oe,ce,we,V){super(oe,ce,V),this.fileOperationResult=ce,this.size=we}}e.TooLargeFileOperationError=Q;class Z extends z{constructor(oe,ce,we){super(oe,2,we),this.stat=ce}}e.NotModifiedSinceFileOperationError=Z;var Y;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",te[te.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.etag=O;async function m(te,oe){if(!oe.hasProvider(b.URI.from({scheme:te.scheme})))return new Promise(ce=>{const we=oe.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===te.scheme&&V.added&&(we.dispose(),ce())})})}e.whenProviderRegistered=m,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(oe){return(0,F.isNumber)(oe)||(oe=0),oe<L.KB?(0,A.localize)(1,null,oe.toFixed(0)):oe<L.MB?(0,A.localize)(2,null,(oe/L.KB).toFixed(2)):oe<L.GB?(0,A.localize)(3,null,(oe/L.MB).toFixed(2)):oe<L.TB?(0,A.localize)(4,null,(oe/L.GB).toFixed(2)):(0,A.localize)(5,null,(oe/L.TB).toFixed(2))}}L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB,e.ByteSize=L;var B;(function(te){te[te.IA32=0]="IA32",te[te.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function J(te){return{maxFileSize:te===0?300*L.MB:16*L.GB,maxHeapSize:te===0?700*L.MB:2*700*L.MB}}e.getPlatformFileLimits=J;function me(te){const oe=typeof te=="string"||te?.scheme===N.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===N.Schemas.file?1024*L.MB:oe?10*L.MB:I.isWeb?50*L.MB:1024*L.MB}e.getLargeFileConfirmationLimit=me}),define(Ie[68],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...D){this._entries=new Map;for(const[F,b]of D)this.set(F,b)}set(D,F){const b=this._entries.get(D);return this._entries.set(D,F),b}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=i}),define(Ie[161],ke([1,0,17,11,6,89,159,3,68,162]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class h{constructor(o=new _.ServiceCollection,u=!1,p,w=N){this._services=o,this._strict=u,this._parent=p,this._enableTracing=w,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=w?p?._globalGraph??new b.Graph(R=>R):void 0}createChild(o){return new h(o,this._strict,this,this._enableTracing)}invokeFunction(o,...u){const p=g.traceInvocation(this._enableTracing,o);let w=!1;try{return o({get:v=>{if(w)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(v,p);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...u)}finally{w=!0,p.stop()}}createInstance(o,...u){let p,w;return o instanceof F.SyncDescriptor?(p=g.traceCreation(this._enableTracing,o.ctor),w=this._createInstance(o.ctor,o.staticArguments.concat(u),p)):(p=g.traceCreation(this._enableTracing,o),w=this._createInstance(o,u,p)),p.stop(),w}_createInstance(o,u=[],p){const w=A._util.getServiceDependencies(o).sort((t,d)=>t.index-d.index),R=[];for(const t of w){const d=this._getOrCreateServiceInstance(t.id,p);d||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),R.push(d)}const v=w.length>0?w[0].index:u.length;if(u.length!==v){console.trace(`[createInstance] First service dependency of ${o.name} at position ${v+1} conflicts with ${u.length} static arguments`);const t=v-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,v)}return Reflect.construct(o,u.concat(R))}_setServiceInstance(o,u){if(this._services.get(o)instanceof F.SyncDescriptor)this._services.set(o,u);else if(this._parent)this._parent._setServiceInstance(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const u=this._services.get(o);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):u}_getOrCreateServiceInstance(o,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const p=this._getServiceInstanceOrDescriptor(o);return p instanceof F.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,p,u.branch(o,!0)):(u.branch(o,!1),p)}_safeCreateAndCacheServiceInstance(o,u,p){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,u,p)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,u,p){const w=new b.Graph(t=>t.id.toString());let R=0;const v=[{id:o,desc:u,_trace:p}];for(;v.length;){const t=v.pop();if(w.lookupOrInsertNode(t),R++>1e3)throw new y(w);for(const d of A._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(d.id);if(r||this._throwIfStrict(`[createInstance] ${o} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),r instanceof F.SyncDescriptor){const l={id:d.id,desc:r,_trace:t._trace.branch(d.id,!0)};w.insertEdge(t,l),v.push(l)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new y(w);break}for(const{data:d}of t){if(this._getServiceInstanceOrDescriptor(d.id)instanceof F.SyncDescriptor){const l=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,l)}w.removeNode(d)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,u,p=[],w,R){if(this._services.get(o)instanceof F.SyncDescriptor)return this._createServiceInstance(o,u,p,w,R);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,u,p,w,R);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(o,u,p=[],w,R){if(w){const v=new h(void 0,this._strict,this,this._enableTracing);v._globalGraphImplicitDependency=String(o);const t=new Map,d=new i.IdleValue(()=>{const r=v._createInstance(u,p,R);for(const[l,c]of t){const S=r[l];if(typeof S=="function")for(const n of c)S.apply(r,n)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,l){if(!d.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=t.get(l);return n||(n=new I.LinkedList,t.set(l,n)),(f,P,T)=>{const z=n.push([f,P,T]);return(0,D.toDisposable)(z)}}if(l in r)return r[l];const c=d.value;let S=c[l];return typeof S!="function"||(S=S.bind(c),r[l]=S),S},set(r,l,c){return d.value[l]=c,!0},getPrototypeOf(r){return u.prototype}})}else return this._createInstance(u,p,R)}_throwIfStrict(o,u){if(u&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=h;var E;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(E||(E={}));class g{static traceInvocation(o,u){return o?new g(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(o,u){return o?new g(1,u.name):g._None}constructor(o,u){this.type=o,this.name=u,this._start=Date.now(),this._dep=[]}branch(o,u){const p=new g(3,o.toString());return this._dep.push([o,u,p]),p}stop(){const o=Date.now()-this._start;g._totals+=o;let u=!1;function p(R,v){const t=[],d=new Array(R+1).join("	");for(const[r,l,c]of v._dep)if(l&&c){u=!0,t.push(`${d}CREATES -> ${r}`);const S=p(R+1,c);S&&t.push(S)}else t.push(`${d}uses -> ${r}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(o>2||u)&&g.all.add(w.join(`
`))}}g.all=new Set,g._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g._totals=0,e.Trace=g}),define(Ie[12],ke([1,0,39,4,6,28,20,9,2,3]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function N(){return new Date().toISOString()}function y(n){return(0,A.isNumber)(n)}e.isLogLevel=y;var h;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function E(n,s,f){switch(s){case h.Trace:n.trace(f);break;case h.Debug:n.debug(f);break;case h.Info:n.info(f);break;case h.Warning:n.warn(f);break;case h.Error:n.error(f);break;case h.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=E;function g(n){let s="";for(let f=0;f<n.length;f++){let P=n[f];if(typeof P=="object")try{P=JSON.stringify(P)}catch{}s+=(f>0?" ":"")+P}return s}e.format=g;class a extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(s){return this.level!==h.Off&&this.level<=s}}e.AbstractLogger=a;class o extends a{constructor(s){super(),this.logAlways=s}checkLogLevel(s){return this.logAlways||super.checkLogLevel(s)}trace(s,...f){this.checkLogLevel(h.Trace)&&this.log(h.Trace,g([s,...f]))}debug(s,...f){this.checkLogLevel(h.Debug)&&this.log(h.Debug,g([s,...f]))}info(s,...f){this.checkLogLevel(h.Info)&&this.log(h.Info,g([s,...f]))}warn(s,...f){this.checkLogLevel(h.Warning)&&this.log(h.Warning,g([s,...f]))}error(s,...f){if(this.checkLogLevel(h.Error))if(s instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=s.stack,this.log(h.Error,g(P))}else this.log(h.Error,g([s,...f]))}flush(){}}e.AbstractMessageLogger=o;class u extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.useColors=!b.isWindows}trace(s,...f){this.checkLogLevel(h.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...f):console.log(`[main ${N()}]`,s,...f))}debug(s,...f){this.checkLogLevel(h.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...f):console.log(`[main ${N()}]`,s,...f))}info(s,...f){this.checkLogLevel(h.Info)&&(this.useColors?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...f):console.log(`[main ${N()}]`,s,...f))}warn(s,...f){this.checkLogLevel(h.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${N()}]\x1B[0m`,s,...f):console.warn(`[main ${N()}]`,s,...f))}error(s,...f){this.checkLogLevel(h.Error)&&(this.useColors?console.error(`\x1B[91m[main ${N()}]\x1B[0m`,s,...f):console.error(`[main ${N()}]`,s,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class p extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...f){this.checkLogLevel(h.Trace)&&console.log("%cTRACE","color: #888",s,...f)}debug(s,...f){this.checkLogLevel(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...f)}info(s,...f){this.checkLogLevel(h.Info)&&console.log("%c INFO","color: #33f",s,...f)}warn(s,...f){this.checkLogLevel(h.Warning)&&console.log("%c WARN","color: #993",s,...f)}error(s,...f){this.checkLogLevel(h.Error)&&console.log("%c  ERR","color: #f33",s,...f)}dispose(){}flush(){}}e.ConsoleLogger=p;class w extends a{constructor(s,f=e.DEFAULT_LOG_LEVEL){super(),this.adapter=s,this.setLevel(f)}trace(s,...f){this.checkLogLevel(h.Trace)&&this.adapter.log(h.Trace,[this.extractMessage(s),...f])}debug(s,...f){this.checkLogLevel(h.Debug)&&this.adapter.log(h.Debug,[this.extractMessage(s),...f])}info(s,...f){this.checkLogLevel(h.Info)&&this.adapter.log(h.Info,[this.extractMessage(s),...f])}warn(s,...f){this.checkLogLevel(h.Warning)&&this.adapter.log(h.Warning,[this.extractMessage(s),...f])}error(s,...f){this.checkLogLevel(h.Error)&&this.adapter.log(h.Error,[this.extractMessage(s),...f])}extractMessage(s){return typeof s=="string"?s:(0,i.toErrorMessage)(s,this.checkLogLevel(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=w;class R extends a{constructor(s){super(),this.loggers=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const f of this.loggers)f.setLevel(s);super.setLevel(s)}trace(s,...f){for(const P of this.loggers)P.trace(s,...f)}debug(s,...f){for(const P of this.loggers)P.debug(s,...f)}info(s,...f){for(const P of this.loggers)P.info(s,...f)}warn(s,...f){for(const P of this.loggers)P.warn(s,...f)}error(s,...f){for(const P of this.loggers)P.error(s,...f)}flush(){for(const s of this.loggers)s.flush()}dispose(){for(const s of this.loggers)s.dispose()}}e.MultiplexLogger=R;class v extends D.Disposable{constructor(s,f){if(super(),this.logLevel=s,this._loggers=new F.ResourceMap,this._loggerResources=new F.ResourceMap,this._onDidChangeLoggers=this._register(new k.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,f)for(const P of f)this._loggerResources.set(P.resource,P)}getLogger(s){return this._loggers.get(s)}createLogger(s,f){let P=this._loggers.get(s);const T=f?.logLevel==="always"?h.Trace:f?.logLevel;return P||(P=this.doCreateLogger(s,T??this.getLogLevel(s)??this.logLevel,f),this._loggers.set(s,P)),this.registerLogger({resource:s,id:f?.id??s.toString(),logLevel:T,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId}),P}setLogLevel(s,f){if(_.URI.isUri(s)){const P=s,T=f,z=this._loggerResources.get(P);z&&T!==z.logLevel&&(z.logLevel=T===this.logLevel?void 0:T,this._loggers.get(P)?.setLevel(T),this._loggerResources.set(z.resource,z),this._onDidChangeLogLevel.fire([P,T]))}else{this.logLevel=s;for(const[P,T]of this._loggers.entries())this._loggerResources.get(P)?.logLevel===void 0&&T.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(s,f){const P=this._loggerResources.get(s);P&&f!==!P.hidden&&(P.hidden=!f,this._loggerResources.set(P.resource,P),this._onDidChangeVisibility.fire([s,f]))}getLogLevel(s){let f;return s&&(f=this._loggerResources.get(s)?.logLevel),f??this.logLevel}registerLogger(s){const f=this._loggerResources.get(s.resource);f?f.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this._loggerResources.set(s.resource,s),this._onDidChangeLoggers.fire({added:[s],removed:[]}))}deregisterLogger(s){const f=this._loggerResources.get(s);if(f){this._loggerResources.delete(s);const P=this._loggers.get(s);P&&(this._loggers.delete(s),P.dispose()),this._onDidChangeLoggers.fire({added:[],removed:[f]})}}getRegisteredLoggers(){return this._loggerResources.values()}getRegisteredLogger(s){return this._loggerResources.get(s)}dispose(){this._loggers.forEach(s=>s.dispose()),this._loggers.clear(),this._loggerResources.clear(),super.dispose()}}e.AbstractLoggerService=v;class t{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(s){}getLevel(){return h.Info}trace(s,...f){}debug(s,...f){}info(s,...f){}warn(s,...f){}error(s,...f){}critical(s,...f){}dispose(){}flush(){}}e.NullLogger=t;class d extends t{}e.NullLogService=d;class r extends v{constructor(){super(h.Info)}doCreateLogger(s,f,P){return new t}}e.NullLoggerService=r;function l(n){if(n.verbose)return h.Trace;if(typeof n.logLevel=="string"){const s=S(n.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(n){switch(n){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=c;function S(n){switch(n){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=S}),define(Ie[163],ke([1,0,6,12]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends i.Disposable{constructor(b,A=[]){super(),this.logger=new k.MultiplexLogger([b,...A]),this._register(b.onDidChangeLogLevel(_=>this.setLevel(_)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(b){this.logger.setLevel(b)}getLevel(){return this.logger.getLevel()}trace(b,...A){this.logger.trace(b,...A)}debug(b,...A){this.logger.debug(b,...A)}info(b,...A){this.logger.info(b,...A)}warn(b,...A){this.logger.warn(b,...A)}error(b,...A){this.logger.error(b,...A)}flush(){this.logger.flush()}}e.LogService=D}),define(Ie[91],ke([1,0,29,136,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(F=e.MarkerTag||(e.MarkerTag={}));var b;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(b=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(g,a){return a-g}_.compare=I;const N=Object.create(null);N[_.Error]=(0,k.localize)(0,null),N[_.Warning]=(0,k.localize)(1,null),N[_.Info]=(0,k.localize)(2,null);function y(g){return N[g]||""}_.toString=y;function h(g){switch(g){case i.default.Error:return _.Error;case i.default.Warning:return _.Warning;case i.default.Info:return _.Info;case i.default.Ignore:return _.Hint}}_.fromSeverity=h;function E(g){switch(g){case _.Error:return i.default.Error;case _.Warning:return i.default.Warning;case _.Info:return i.default.Info;case _.Hint:return i.default.Ignore}}_.toSeverity=E}(b=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(_){const I="";function N(h){return y(h,!0)}_.makeKey=N;function y(h,E){const g=[I];return h.source?g.push(h.source.replace("\xA6","\\\xA6")):g.push(I),h.code?typeof h.code=="string"?g.push(h.code.replace("\xA6","\\\xA6")):g.push(h.code.value.replace("\xA6","\\\xA6")):g.push(I),h.severity!==void 0&&h.severity!==null?g.push(b.toString(h.severity)):g.push(I),h.message&&E?g.push(h.message.replace("\xA6","\\\xA6")):g.push(I),h.startLineNumber!==void 0&&h.startLineNumber!==null?g.push(h.startLineNumber.toString()):g.push(I),h.startColumn!==void 0&&h.startColumn!==null?g.push(h.startColumn.toString()):g.push(I),h.endLineNumber!==void 0&&h.endLineNumber!==null?g.push(h.endLineNumber.toString()):g.push(I),h.endColumn!==void 0&&h.endColumn!==null?g.push(h.endColumn.toString()):g.push(I),g.push(I),g.join("\xA6")}_.makeKeyOptionalMessage=y})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ie[164],ke([1,0,4,29,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,D.createDecorator)("notificationService");var F;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(F=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var b;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(b=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new _,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=A;class _{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=_}),define(Ie[92],ke([1,0,10,2,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function F(I,N){return k.URI.isUri(I)?(0,i.equalsIgnoreCase)(I.scheme,N):(0,i.startsWithIgnoreCase)(I,N+":")}e.matchesScheme=F;function b(I,...N){return N.some(y=>F(I,y))}e.matchesSomeScheme=b;function A(I,N){return I.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=A;function _(I){let N;const y=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return y&&(N={startLineNumber:parseInt(y[1]),startColumn:y[2]?parseInt(y[2]):1,endLineNumber:y[4]?parseInt(y[4]):void 0,endColumn:y[4]?y[5]?parseInt(y[5]):1:void 0},I=I.with({fragment:""})),{selection:N,uri:I}}e.extractSelection=_}),define(Ie[165],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(ne,e,i,k){var D=arguments.length,F=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,i):k,b;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ne,e,i,k);else for(var A=ne.length-1;A>=0;A--)(b=ne[A])&&(F=(D<3?b(F):D>3?b(e,i,F):b(e,i))||F);return D>3&&F&&Object.defineProperty(e,i,F),F},We=this&&this.__param||function(ne,e){return function(i,k){e(i,k,ne)}};define(Ie[166],ke([1,0,17,21,6,3]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var b;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(b=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(y){this.callback=y}report(y){this._value=y,this.callback(this._value)}}A.None=Object.freeze({report(){}}),e.Progress=A;let _=class extends D.Disposable{constructor(y,h){super(),this.deferred=new i.DeferredPromise,h.withProgress(y,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};_=Ve([We(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends D.Disposable{constructor(y){super(),this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(y){this.stop();const h=++this.currentOperationId,E=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{h===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:h,token:E.token,stop:()=>this.doStop(h),isCurrent:()=>this.currentOperationId===h}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(Ie[30],ke([1,0,49,9]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(b,A){i.ok(k.isString(b)),i.ok(k.isObject(A)),i.ok(!this.data.has(b),"There is already an extension with this id"),this.data.set(b,A)}knows(b){return this.data.has(b)}as(b){return this.data.get(b)||null}}e.Registry=new D}),define(Ie[69],ke([1,0,4,30]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class F{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[D(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const b=new F;k.Registry.add(e.Extensions.JSONContribution,b)}),define(Ie[93],ke([1,0,16,4,9,132,41,69,30]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=_.Registry.as(A.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const r=new Set;this.doRegisterConfigurations(t,d,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const d=new Set;this.doDeregisterConfigurations(t,d),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:t,remove:d}){const r=new Set;this.doDeregisterConfigurations(d,r),this.doRegisterConfigurations(t,!1,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const d=new Set;this.doRegisterDefaultConfigurations(t,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,d){const r=[];for(const{overrides:l,source:c}of t)for(const S in l)if(d.add(S),e.OVERRIDE_PROPERTY_REGEX.test(S)){const n=this.configurationDefaultsOverrides.get(S),s=n?.valuesSources??new Map;if(c)for(const z of Object.keys(l[S]))s.set(z,c);const f={...n?.value||{},...l[S]};this.configurationDefaultsOverrides.set(S,{source:c,value:f,valuesSources:s});const P=(0,b.getLanguageTagSettingPlainKey)(S),T={type:"object",default:f,description:F.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:D.isString(c)?void 0:c,defaultValueSource:c};r.push(...a(S)),this.configurationProperties[S]=T,this.defaultLanguageConfigurationOverridesNode.properties[S]=T}else{this.configurationDefaultsOverrides.set(S,{value:l[S],source:c});const n=this.configurationProperties[S];n&&(this.updatePropertyDefaultValue(S,n),this.updateSchema(S,n))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const d=new Set;this.doDeregisterDefaultConfigurations(t,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,d){for(const{overrides:r,source:l}of t)for(const c in r){const S=this.configurationDefaultsOverrides.get(c),n=D.isString(l)?l:l?.id,s=D.isString(S?.source)?S?.source:S?.source?.id;if(n===s)if(d.add(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const f=this.configurationProperties[c];f&&(this.updatePropertyDefaultValue(c,f),this.updateSchema(c,f))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let d=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),d=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),d=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const d of t)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,d,r){t.forEach(l=>{this.validateAndRegisterProperties(l,d,l.extensionInfo,l.restrictedProperties,void 0,r),this.configurationContributors.push(l),this.registerJSONConfiguration(l)})}doDeregisterConfigurations(t,d){const r=l=>{if(l.properties)for(const c in l.properties){d.add(c);const S=this.configurationProperties[c];S?.policy?.name&&this.policyConfigurations.delete(S.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,l.properties[c])}l.allOf?.forEach(c=>r(c))};for(const l of t){r(l);const c=this.configurationContributors.indexOf(l);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(t,d=!0,r,l,c=3,S){c=D.isUndefinedOrNull(t.scope)?c:t.scope;const n=t.properties;if(n)for(const f in n){const P=n[f];if(d&&w(f,P)){delete n[f];continue}if(P.source=r,P.defaultDefaultValue=n[f].default,this.updatePropertyDefaultValue(f,P),e.OVERRIDE_PROPERTY_REGEX.test(f)?P.scope=void 0:(P.scope=D.isUndefinedOrNull(P.scope)?c:P.scope,P.restricted=D.isUndefinedOrNull(P.restricted)?!!l?.includes(f):P.restricted),n[f].hasOwnProperty("included")&&!n[f].included){this.excludedConfigurationProperties[f]=n[f],delete n[f];continue}else this.configurationProperties[f]=n[f],n[f].policy?.name&&this.policyConfigurations.set(n[f].policy.name,f);!n[f].deprecationMessage&&n[f].markdownDeprecationMessage&&(n[f].deprecationMessage=n[f].markdownDeprecationMessage),S.add(f)}const s=t.allOf;if(s)for(const f of s)this.validateAndRegisterProperties(f,d,r,l,c,S)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const d=r=>{const l=r.properties;if(l)for(const S in l)this.updateSchema(S,l[S]);r.allOf?.forEach(d)};d(t)}updateSchema(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.resourceLanguageSettingsSchema.properties[t]=d;break}}removeFromSchema(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const d=`[${t}]`,r={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,d){const r=this.configurationDefaultsOverrides.get(t);let l=r?.value,c=r?.source;D.isUndefined(l)&&(l=d.defaultDefaultValue,c=void 0),D.isUndefined(l)&&(l=u(d.type)),d.default=l,d.defaultValueSource=c}}const E="\\[([^\\]]+)\\]",g=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let d=g.exec(v);for(;d?.length;){const r=d[1].trim();r&&t.push(r),d=g.exec(v)}}return(0,i.distinct)(t)}e.overrideIdentifiersFromKey=a;function o(v){return v.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=o;function u(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const p=new h;_.Registry.add(e.Extensions.Configuration,p);function w(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?F.localize(7,null,v):p.getConfigurationProperties()[v]!==void 0?F.localize(8,null,v):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,v,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}e.validateProperty=w;function R(){const v=[],t=p.getConfigurationProperties();for(const d of Object.keys(t))v.push([d,t[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=R}),define(Ie[167],ke([1,0,16,4,111,6,28,22,9,2,41,93,30]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(d){return Object.isFrozen(d)?d:A.deepFreeze(d)}class g{constructor(r={},l=[],c=[],S){this._contents=r,this._keys=l,this._overrides=c,this.raw=S,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(l=>{if(l instanceof g)return l;const c=new a("");return c.parseRaw(l),c.configurationModel});this._rawConfiguration=r.reduce((l,c)=>c===l?c:l.merge(c),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}inspect(r,l){const c=this.rawConfiguration.getValue(r),S=l?this.rawConfiguration.getOverrideValue(r,l):void 0,n=l?this.rawConfiguration.override(l).getValue(r):c;return{value:c,override:S,merged:n}}getOverrideValue(r,l){const c=this.getContentsForOverrideIdentifer(l);return c?r?(0,N.getConfigurationValue)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const l=[];for(const c of this.overrides)c.identifiers.includes(r)&&l.push(...c.keys);return i.distinct(l)}getAllOverrideIdentifiers(){const r=[];for(const l of this.overrides)r.push(...l.identifiers);return i.distinct(r)}override(r){let l=this.overrideConfigurations.get(r);return l||(l=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,l)),l}merge(...r){const l=A.deepClone(this.contents),c=A.deepClone(this.overrides),S=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const s of r)if(n.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.mergeContents(l,s.contents);for(const f of s.overrides){const[P]=c.filter(T=>i.equals(T.identifiers,f.identifiers));P?(this.mergeContents(P.contents,f.contents),P.keys.push(...f.keys),P.keys=i.distinct(P.keys)):c.push(A.deepClone(f))}for(const f of s.keys)S.indexOf(f)===-1&&S.push(f)}return new g(l,S,c,n.every(s=>s instanceof g)?void 0:n)}createOverrideConfigurationModel(r){const l=this.getContentsForOverrideIdentifer(r);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const S of i.distinct([...Object.keys(this.contents),...Object.keys(l)])){let n=this.contents[S];const s=l[S];s&&(typeof n=="object"&&typeof s=="object"?(n=A.deepClone(n),this.mergeContents(n,s)):n=s),c[S]=n}return new g(c,this.keys,this.overrides)}mergeContents(r,l){for(const c of Object.keys(l)){if(c in r&&_.isObject(r[c])&&_.isObject(l[c])){this.mergeContents(r[c],l[c]);continue}r[c]=A.deepClone(l[c])}}getContentsForOverrideIdentifer(r){let l=null,c=null;const S=n=>{n&&(c?this.mergeContents(c,n):c=A.deepClone(n))};for(const n of this.overrides)i.equals(n.identifiers,[r])?l=n.contents:n.identifiers.includes(r)&&S(n.contents);return S(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,l){this.updateValue(r,l,!0)}setValue(r,l){this.updateValue(r,l,!1)}removeValue(r){const l=this.keys.indexOf(r);l!==-1&&(this.keys.splice(l,1),(0,N.removeFromValueTree)(this.contents,r),y.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(c=>i.equals(c.identifiers,(0,y.overrideIdentifiersFromKey)(r))),1))}updateValue(r,l,c){(0,N.addToValueTree)(this.contents,r,l,S=>console.error(S)),c=c||this.keys.indexOf(r)===-1,c&&this.keys.push(r),y.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,N.toValuesTree)(this.contents[r],S=>console.error(S))})}}e.ConfigurationModel=g;class a{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,l){if(!_.isUndefinedOrNull(r)){const c=this.doParseContent(r);this.parseRaw(c,l)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,l){this._raw=r;const{contents:c,keys:S,overrides:n,restricted:s,hasExcludedProperties:f}=this.doParseRaw(r,l);this._configurationModel=new g(c,S,n,f?[r]:void 0),this._restrictedConfigurations=s||[]}doParseContent(r){let l={},c=null,S=[];const n=[],s=[];function f(T){Array.isArray(S)?S.push(T):c!==null&&(S[c]=T)}const P={onObjectBegin:()=>{const T={};f(T),n.push(S),S=T,c=null},onObjectProperty:T=>{c=T},onObjectEnd:()=>{S=n.pop()},onArrayBegin:()=>{const T=[];f(T),n.push(S),S=T,c=null},onArrayEnd:()=>{S=n.pop()},onLiteralValue:f,onError:(T,z,Q)=>{s.push({error:T,offset:z,length:Q})}};if(r)try{D.visit(r,P),l=S[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return l}doParseRaw(r,l){const c=h.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),S=this.filter(r,c,!0,l);r=S.raw;const n=(0,N.toValuesTree)(r,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),s=Object.keys(r),f=this.toOverrides(r,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:n,keys:s,overrides:f,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}filter(r,l,c,S){let n=!1;if(!S?.scopes&&!S?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:n};const s={},f=[];for(const P in r)if(y.OVERRIDE_PROPERTY_REGEX.test(P)&&c){const T=this.filter(r[P],l,!1,S);s[P]=T.raw,n=n||T.hasExcludedProperties,f.push(...T.restricted)}else{const T=l[P],z=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&f.push(P),(z===void 0||S.scopes===void 0||S.scopes.includes(z))&&!(S.skipRestricted&&T?.restricted)?s[P]=r[P]:n=!0}return{raw:s,restricted:f,hasExcludedProperties:n}}toOverrides(r,l){const c=[];for(const S of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(S)){const n={};for(const s in r[S])n[s]=r[S][s];c.push({identifiers:(0,y.overrideIdentifiersFromKey)(S),keys:Object.keys(n),contents:(0,N.toValuesTree)(n,l)})}return c}}e.ConfigurationModelParser=a;class o extends F.Disposable{constructor(r,l,c,S){super(),this.userSettingsResource=r,this.scopes=l,this.fileService=S,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.any(k.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource)),k.Event.filter(this.fileService.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&c.isEqual(n.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class u{constructor(r,l,c,S,n,s,f,P,T,z,Q,Z,Y){this.key=r,this.overrides=l,this._value=c,this.overrideIdentifiers=S,this.defaultConfiguration=n,this.policyConfiguration=s,this.applicationConfiguration=f,this.userConfiguration=P,this.localUserConfiguration=T,this.remoteUserConfiguration=z,this.workspaceConfiguration=Q,this.folderConfigurationModel=Z,this.memoryConfigurationModel=Y}get value(){return E(this._value)}inspect(r,l,c){const S=r.inspect(l,c);return{get value(){return E(S.value)},get override(){return E(S.override)},get merged(){return E(S.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class p{constructor(r,l,c,S,n=new g,s=new g,f=new b.ResourceMap,P=new g,T=new b.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=l,this._applicationConfiguration=c,this._localUserConfiguration=S,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=f,this._memoryConfiguration=P,this._memoryConfigurationByResource=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new b.ResourceMap,this._userConfiguration=null}getValue(r,l,c){return this.getConsolidatedConfigurationModel(r,l,c).getValue(r)}updateValue(r,l,c={}){let S;c.resource?(S=this._memoryConfigurationByResource.get(c.resource),S||(S=new g,this._memoryConfigurationByResource.set(c.resource,S))):S=this._memoryConfiguration,l===void 0?S.removeValue(r):S.setValue(r,l),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,l,c){const S=this.getConsolidatedConfigurationModel(r,l,c),n=this.getFolderConfigurationModelForResource(l.resource,c),s=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,f=new Set;for(const P of S.overrides)for(const T of P.identifiers)S.getOverrideValue(r,T)!==void 0&&f.add(T);return new u(r,l,S.getValue(r),f.size?[...f]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this._workspaceConfiguration:void 0,n||void 0,s)}keys(r){const l=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,l){this._folderConfigurations.set(r,l),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,l){const c=[];if(!l){const{added:S,updated:n,removed:s}=v(this._defaultConfiguration,r);l=[...S,...n,...s]}for(const S of l)for(const n of(0,y.overrideIdentifiersFromKey)(S)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(n),f=r.getKeysForOverrideIdentifier(n),P=[...f.filter(T=>s.indexOf(T)===-1),...s.filter(T=>f.indexOf(T)===-1),...s.filter(T=>!A.equals(this._defaultConfiguration.override(n).getValue(T),r.override(n).getValue(T)))];c.push([n,P])}return this.updateDefaultConfiguration(r),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(r){const{added:l,updated:c,removed:S}=v(this._policyConfiguration,r),n=[...l,...c,...S];return n.length&&this.updatePolicyConfiguration(r),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:l,updated:c,removed:S,overrides:n}=v(this.applicationConfiguration,r),s=[...l,...c,...S];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:l,updated:c,removed:S,overrides:n}=v(this.localUserConfiguration,r),s=[...l,...c,...S];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:n}}compareAndUpdateRemoteUserConfiguration(r){const{added:l,updated:c,removed:S,overrides:n}=v(this.remoteUserConfiguration,r),s=[...l,...c,...S];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:n}}compareAndUpdateWorkspaceConfiguration(r){const{added:l,updated:c,removed:S,overrides:n}=v(this.workspaceConfiguration,r),s=[...l,...c,...S];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:n}}compareAndUpdateFolderConfiguration(r,l){const c=this.folderConfigurations.get(r),{added:S,updated:n,removed:s,overrides:f}=v(c,l),P=[...S,...n,...s];return(P.length||!c)&&this.updateFolderConfiguration(r,l),{keys:P,overrides:f}}compareAndDeleteFolderConfiguration(r){const l=this.folderConfigurations.get(r);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:S,removed:n,overrides:s}=v(l,void 0);return{keys:[...c,...S,...n],overrides:s}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,l,c){let S=this.getConsolidatedConfigurationModelForResource(l,c);return l.overrideIdentifier&&(S=S.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(S=S.merge(this._policyConfiguration)),S}getConsolidatedConfigurationModelForResource({resource:r},l){let c=this.getWorkspaceConsolidatedConfiguration();if(l&&r){const S=l.getFolder(r);S&&(c=this.getFolderConsolidatedConfiguration(S.uri)||c);const n=this._memoryConfigurationByResource.get(r);n&&(c=c.merge(n))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let l=this._foldersConsolidatedConfigurations.get(r);if(!l){const c=this.getWorkspaceConsolidatedConfiguration(),S=this._folderConfigurations.get(r);S?(l=c.merge(S),this._foldersConsolidatedConfigurations.set(r,l)):l=c}return l}getFolderConfigurationModelForResource(r,l){if(l&&r){const c=l.getFolder(r);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,l)=>{const{contents:c,overrides:S,keys:n}=this._folderConfigurations.get(l);return r.push([l,{contents:c,overrides:S,keys:n}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(l=>r.add(l)),this.userConfiguration.keys.forEach(l=>r.add(l)),this._workspaceConfiguration.keys.forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.keys.forEach(c=>r.add(c))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>l.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>l.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(S=>l.add(S))),[...l.values()]}static parse(r){const l=this.parseConfigurationModel(r.defaults),c=this.parseConfigurationModel(r.policy),S=this.parseConfigurationModel(r.application),n=this.parseConfigurationModel(r.user),s=this.parseConfigurationModel(r.workspace),f=r.folders.reduce((P,T)=>(P.set(I.URI.revive(T[0]),this.parseConfigurationModel(T[1])),P),new b.ResourceMap);return new p(l,c,S,n,new g,s,f,new g,new b.ResourceMap)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides)}}e.Configuration=p;function w(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const r=new Set,l=new Map;for(const S of d)S.keys.forEach(n=>r.add(n)),S.overrides.forEach(([n,s])=>{const f=(0,b.getOrSet)(l,n,new Set);s.forEach(P=>f.add(P))});const c=[];return l.forEach((S,n)=>c.push([n,[...S.values()]])),{keys:[...r.values()],overrides:c}}e.mergeChanges=w;class R{constructor(r,l,c,S){this.change=r,this.previous=l,this.currentConfiguraiton=c,this.currentWorkspace=S,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const n of r.keys)this.affectedKeys.add(n);for(const[,n]of r.overrides)for(const s of n)this.affectedKeys.add(s);this._affectsConfigStr=this._marker;for(const n of this.affectedKeys)this._affectsConfigStr+=n+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,l){const c=this._marker+r,S=this._affectsConfigStr.indexOf(c);if(S<0)return!1;const n=S+c.length;if(n>=this._affectsConfigStr.length)return!1;const s=this._affectsConfigStr.charCodeAt(n);if(s!==this._markerCode1&&s!==this._markerCode2)return!1;if(l){const f=this.previousConfiguration?this.previousConfiguration.getValue(r,l,this.previous?.workspace):void 0,P=this.currentConfiguraiton.getValue(r,l,this.currentWorkspace);return!A.equals(f,P)}return!0}}e.ConfigurationChangeEvent=R;function v(d,r){const{added:l,removed:c,updated:S}=t(r?.rawConfiguration,d?.rawConfiguration),n=[],s=d?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const P=f.filter(T=>!s.includes(T));for(const T of P)n.push([T,r.getKeysForOverrideIdentifier(T)])}if(d){const P=s.filter(T=>!f.includes(T));for(const T of P)n.push([T,d.getKeysForOverrideIdentifier(T)])}if(r&&d){for(const P of s)if(f.includes(P)){const T=t({contents:d.getOverrideValue(void 0,P)||{},keys:d.getKeysForOverrideIdentifier(P)},{contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)});n.push([P,[...T.added,...T.removed,...T.updated]])}}return{added:l,removed:c,updated:S,overrides:n}}function t(d,r){const l=d?r?d.keys.filter(n=>r.keys.indexOf(n)===-1):[...d.keys]:[],c=r?d?r.keys.filter(n=>d.keys.indexOf(n)===-1):[...r.keys]:[],S=[];if(d&&r){for(const n of r.keys)if(d.keys.indexOf(n)!==-1){const s=(0,N.getConfigurationValue)(r.contents,n),f=(0,N.getConfigurationValue)(d.contents,n);A.equals(s,f)||S.push(n)}}return{added:l,removed:c,updated:S}}}),define(Ie[94],ke([1,0,11,3]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var D;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class F extends i.ErrorNoTelemetry{static isNotAvailable(_){return _ instanceof F&&_._code===D.NotAvailable}static isTemporarilyNotAvailable(_){return _ instanceof F&&_._code===D.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof F&&_._code===D.NoResolverFound}static isHandled(_){return _ instanceof F&&_.isHandled}constructor(_,I=D.Unknown,N){super(_),this._message=_,this._code=I,this._detail=N,this.isHandled=I===D.NotAvailable&&N===!0,Object.setPrototypeOf(this,F.prototype)}}e.RemoteAuthorityResolverError=F;function b(A){const _=A.indexOf("+");return _===-1?A:A.substring(0,_)}e.getRemoteAuthorityPrefix=b}),define(Ie[50],ke([1,0,15]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(I){return I.scheme===i.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=k;function D(I){if(!I)return;const N=I.indexOf("+");return N<0?I:I.substr(0,N)}e.getRemoteName=D;function F(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=F;function b(I){const{host:N,port:y}=_(I);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:y}}e.parseAuthorityWithPort=b;function A(I,N){let{host:y,port:h}=_(I);return typeof h>"u"&&(h=N),{host:y,port:h}}e.parseAuthorityWithOptionalPort=A;function _(I){const N=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const y=I.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const h=I.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:I,port:void 0}}}),define(Ie[26],ke([1,0,10,3,50]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var A;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));class _{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,a){if(typeof g>"u"||g===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof g=="string"||typeof a=="string"){const o=typeof g=="string"?g:g.value,u=typeof a=="string"?a:a.value;return i.equalsIgnoreCase(o,u)}return g._lower===a._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=_;function I(E){return N(E)}e.isApplicationScopedExtension=I;function N(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=N;function y(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function h(E,g){if(g){const a=`onResolveRemoteAuthority:${(0,D.getRemoteName)(g)}`;return!!E.activationEvents?.includes(a)}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[168],ke([1,0,20,51,2,34]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function b(I){if(i.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function A(I,N,y,h,E,g,a,o,u,p){const w=Object.create(null);w["common.machineId"]=a,w.sessionID=(0,F.generateUuid)()+Date.now(),w.commitHash=E,w.version=g,w["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,i.PlatformToString)(i.platform),w["common.nodePlatform"]=k.platform,w["common.nodeArch"]=h,w["common.product"]=p||"desktop",o&&(w["common.msftInternal"]=o);let R=0;const v=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),i.isLinuxSnap&&(w["common.snap"]="true");const t=b(y);t&&(w["common.platformDetail"]=t);try{const d=await I.readFile(D.URI.file(u));w["common.source"]=d.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=A;function _(I){const N=k.env.USERDNSDOMAIN;if(!N)return!1;const y=N.toLowerCase();return I.some(h=>y===h)}e.verifyMicrosoftInternalDomain=_}),define(Ie[169],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[52],ke([1,0,22,9,4,41,50,168,169]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(c){this.value=c}}e.TelemetryTrustedValue=I;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,S){return Promise.resolve(void 0)}publicLog2(c,S){return this.publicLog(c,S)}publicLogError(c,S){return Promise.resolve(void 0)}publicLogError2(c,S){return this.publicLogError(c,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class y{async publicLog(c,S,n){}async publicLogError(c,S,n){}}e.NullEndpointTelemetryService=y,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(l,c){return D.Event.debounce(c.onDidChangeConfiguration,(n,s)=>{const f=n?new Set([...n.affectedKeys,...s.affectedKeys]):s.affectedKeys;return{...s,affectedKeys:f}},1e3,!0)(n=>{n.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(n.source),configurationKeys:Array.from(n.affectedKeys)})})}e.configurationTelemetry=h;function E(l,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!l.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=E;function g(l,c){return!(c.isBuilt||c.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=g;function a(l){const c=l.getValue(_.TELEMETRY_SETTING_ID),S=l.getValue(_.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=a;function o(l){const c={},S={},n={};w(l,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const f=n[s];typeof f=="number"?S[s]=f:typeof f=="boolean"?S[s]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${f.length}`),c[s]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(c[s]=f)}return{properties:c,measurements:S}}e.validateTelemetryData=o;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(l){if(!l)return"none";const c=(0,b.getRemoteName)(l);return u.has(c)?c:"other"}e.cleanRemoteAuthority=p;function w(l,c,S=0,n){if(!!l)for(const s of Object.getOwnPropertyNames(l)){const f=l[s],P=n?n+s:s;Array.isArray(f)?c[P]=(0,i.safeStringify)(f):f instanceof Date?c[P]=f.toISOString():(0,k.isObject)(f)?S<2?w(f,c,S+1,P+"."):c[P]=(0,i.safeStringify)(f):c[P]=f}}function R(l,c){const S=l.msftInternalDomains||[],n=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(S)||n}e.isInternalTelemetry=R;function v(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=v;function t(l,c){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let S=l;const n=[];for(const T of c)for(;;){const z=T.exec(l);if(!z)break;n.push([z.index,T.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(S="";;){const T=f.exec(l);if(!T)break;const z=n.some(([Q,Z])=>T.index<Z&&Q<f.lastIndex);!s.test(T[0])&&!z&&(S+=l.substring(P,T.index)+"<REDACTED: user-file-path>",P=f.lastIndex)}return P<l.length&&(S+=l.substr(P)),S}function d(l){if(!l)return l;const c=l.toLowerCase(),S=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of S)if(n.regex.test(c))return`<REDACTED: ${n.label}>`;return l}function r(l,c){return(0,i.cloneAndChange)(l,S=>{if(S instanceof I)return S.value;if(typeof S=="string"){let n=S.replaceAll("%20"," ");n=t(n,c);for(const s of c)n=n.replace(s,"");return n=d(n),n}})}e.cleanData=r}),define(Ie[170],ke([1,0,10,90,26,20,2,11,51,52]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(r,l){return r.uuid&&l.uuid?r.uuid===l.uuid:r.id===l.id?!0:(0,i.compareIgnoreCase)(r.id,l.id)===0}e.areSameExtensions=N;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(l){const c=l.manifest?l.manifest.version:l.version,S=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new h(l.identifier,c,S)}static parse(l){const c=y.exec(l);return c&&c[1]&&c[2]?new h({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,S="undefined"){this.version=c,this.targetPlatform=S,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof h?N(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=h;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const l=E.exec(r);return l&&l[1]?[o(l[1]),l[2]]:[o(r),void 0]}e.getIdAndVersion=g;function a(r,l){return`${r}.${l}`}e.getExtensionId=a;function o(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function u(r,l){return o(a(r,l))}e.getGalleryExtensionId=u;function p(r,l){const c=[],S=n=>{for(const s of c)if(s.some(f=>N(l(f),l(n))))return s;return null};for(const n of r){const s=S(n);s?s.push(n):c.push([n])}return c}e.groupByExtension=p;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function R(r){return{id:new I.TelemetryTrustedValue(r.identifier.id),name:new I.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=R,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(r,l){const c=[],S=l.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const n=S.shift();if(n&&c.every(s=>!N(s.identifier,{id:n}))){const s=r.filter(f=>N(f.identifier,{id:n}));s.length===1&&(c.push(s[0]),S.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=v;async function t(r,l){if(!F.isLinux)return!1;let c;try{c=(await r.readFile(b.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await r.readFile(b.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){l.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(n))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(r,l){const c=await t(r,l),S=(0,k.getTargetPlatform)(c?"alpine":F.platform,_.arch);return l.debug("ComputeTargetPlatform:",S),S}e.computeTargetPlatform=d}),define(Ie[171],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=i;function k(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=k;function D(b){return Array.from(b.entries()).map(A=>[A[0],i(A[1].map)])}e.serializeEnvironmentVariableCollections=D;function F(b){return new Map(b.map(A=>[A[0],{map:k(A[1])}]))}e.deserializeEnvironmentVariableCollections=F}),define(Ie[172],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,F,b=5){const A=F(_=>{const I=typeof _=="string"?_:_.data;let N=this._terminalBufferMap.get(D);if(N){N.data.push(I);return}const y=setTimeout(()=>this.flushBuffer(D),b);N={data:[I],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(D),A.dispose()}},this._terminalBufferMap.set(D,N)});return A}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const F=this._terminalBufferMap.get(D);F&&(this._terminalBufferMap.delete(D),this._callback(D,F.data.join("")))}}e.TerminalDataBufferer=i}),define(Ie[173],ke([1,0,17,84,38,4,9,2,137,69,30]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var y;(function(R){function v(t,d){let r=t.defaults;for(;D.ThemeIcon.isThemeIcon(r);){const l=g.getIcon(r.id);if(!l)return;r=l.defaults}return r}R.getDefinition=v})(y=e.IconContribution||(e.IconContribution={}));var h;(function(R){function v(d){return{weight:d.weight,style:d.style,src:d.src.map(r=>({format:r.format,location:r.location.toString()}))}}R.toJSONObject=v;function t(d){const r=l=>(0,b.isString)(l)?l:void 0;if(d&&Array.isArray(d.src)&&d.src.every(l=>(0,b.isString)(l.format)&&(0,b.isString)(l.location)))return{weight:r(d.weight),style:r(d.style),src:d.src.map(l=>({format:l.format,location:A.URI.parse(l.location)}))}}R.fromJSONObject=t})(h=e.IconFontDefinition||(e.IconFontDefinition={}));class E{constructor(){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,t,d,r){const l=this.iconsById[v];if(l){if(d&&!l.description){l.description=d,this.iconSchema.properties[v].markdownDescription=`${d} $(${v})`;const n=this.iconReferenceSchema.enum.indexOf(v);n!==-1&&(this.iconReferenceSchema.enumDescriptions[n]=d),this._onDidChange.fire()}return l}const c={id:v,description:d,defaults:t,deprecationMessage:r};this.iconsById[v]=c;const S={$ref:"#/definitions/icons"};return r&&(S.deprecationMessage=r),d&&(S.markdownDescription=`${d}: $(${v})`),this.iconSchema.properties[v]=S,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const t=this.iconReferenceSchema.enum.indexOf(v);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,t){const d=this.iconFontsById[v];return d||(this.iconFontsById[v]=t,this._onDidChange.fire(),t)}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(l,c)=>l.id.localeCompare(c.id),t=l=>{for(;D.ThemeIcon.isThemeIcon(l.defaults);)l=this.iconsById[l.defaults.id];return`codicon codicon-${l?l.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(l=>this.iconsById[l]);for(const l of r.filter(c=>!!c.description).sort(v))d.push(`|<i class="${t(l)}"></i>|${l.id}|${D.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const l of r.filter(c=>!D.ThemeIcon.isThemeIcon(c.defaults)).sort(v))d.push(`|<i class="${t(l)}"></i>|${l.id}|`);return d.join(`
`)}}const g=new E;N.Registry.add(e.Extensions.IconContribution,g);function a(R,v,t,d){return g.registerIcon(R,v,t,d)}e.registerIcon=a;function o(){return g}e.getIconRegistry=o;function u(){const R=(0,k.getCodiconFontCharacters)();for(const v in R){const t="\\"+R[v].toString(16);g.registerIcon(v,{fontCharacter:t})}}u(),e.iconsSchemaId="vscode://schemas/icons";const p=N.Registry.as(I.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,g.getIconSchema());const w=new i.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=a("widget-close",k.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=a("goto-previous-location",k.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=a("goto-next-location",k.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=D.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(Ie[174],ke([1,0,4,41,3,12]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var b;(function(a){a.Http="http",a.Https="https"})(b=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=y;function h(a,o,u,p){if(u===1)return!1;if(u===2&&y(o)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(w?.length===4&&parseInt(w[1])>=18)return!1}return a<1024}e.isPortPrivileged=h;class E{constructor(o,u,p){this.remoteAddress=o,this.localAddress=u,this._dispose=p,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let g=class{constructor(o,u){this.logService=o,this.configurationService=u,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],u=Array.from(this._tunnels.values());for(const p of u){const w=Array.from(p.values());for(const R of w){const v=await R.value;v&&o.push(v)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:u}of o.values())await u.then(p=>p?.dispose());o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,u,p,w,R){this.addTunnelToMap(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:p,privacy:w,protocol:R,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(y(o)||N(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const p=this.getTunnelFromMap(o,u);if(p)return++p.refcount,p.value}openTunnel(o,u,p,w,R,v=!1,t,d){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${p} on local port ${R}.`),!o)return;if(u||(u="localhost"),w||(w=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(o,u,p,w,R,v,t,d);return r?r.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(l);return(l.tunnelRemoteHost!==u||l.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this._tunnels.get(o.tunnelRemoteHost);if(u){const p=u.get(o.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,p))}}}}async tryDisposeTunnel(o,u,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const w=p.value.then(async R=>{R&&(await R.dispose(!0),this._onTunnelClosed.fire({host:R.tunnelRemoteHost,port:R.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(u),w}}async closeTunnel(o,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const p=this._tunnels.get(o);if(p&&p.has(u)){const w=p.get(u);w.refcount=0,await this.tryDisposeTunnel(o,u,w)}}addTunnelToMap(o,u,p){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(u,{refcount:1,value:p})}async removeEmptyTunnelFromMap(o,u){const p=this._tunnels.get(o);p&&(await p.get(u)||p.delete(u),p.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,u){const p=[o];N(o)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):y(o)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const w=p.map(R=>this._tunnels.get(R));for(const R of w){const v=R?.get(u);if(v)return v}}canTunnel(o){return!!I(o)}createWithProvider(o,u,p,w,R,v,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${p} on local port ${w}.`);const d=p;this._factoryInProgress.add(d);const r=w===void 0?p:w,l={elevationRequired:R?this.isPortPrivileged(r):!1},c={remoteAddress:{host:u,port:p},localAddressPort:w,privacy:v,public:v?v!==A.Private:void 0,protocol:t},S=o.forwardPort(c,l);return S?(this.addTunnelToMap(u,p,S),S.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),S}};g=Ve([We(0,F.ILogService),We(1,k.IConfigurationService)],g),e.AbstractTunnelService=g}),define(Ie[175],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var k;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(k=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[176],ke([1,0,15]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(_){return _.scheme!==i.Schemas.file&&_.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=k;function D(_){if(_.folders.length)return _.folders.every(I=>k(I.uri))?_.folders[0].uri:void 0;if(_.configuration&&k(_.configuration))return _.configuration}e.getVirtualWorkspaceLocation=D;function F(_){return D(_)?.scheme}e.getVirtualWorkspaceScheme=F;function b(_){return D(_)?.authority}e.getVirtualWorkspaceAuthority=b;function A(_){return D(_)!==void 0}e.isVirtualWorkspace=A}),define(Ie[53],ke([1,0,138,19,48,24,2,3,15]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function I(r){const l=r;return typeof l?.id=="string"&&b.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=I;function N(r){return typeof r?.id=="string"&&!I(r)&&!h(r)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(r,l){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,k.basename)(r)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=r;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=y;function h(r){const l=r;return typeof l?.id=="string"&&b.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=h;function E(r){const l=r;if(l?.uri)return{id:l.id,uri:b.URI.revive(l.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:b.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=E;var g;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function a(r){const l=r;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=a;function o(r){const l=r;return!!(l&&typeof l=="object"&&b.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=o;class u{constructor(l,c,S,n,s){this._id=l,this._transient=S,this._configuration=n,this._ignorePathCasing=s,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=c}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class p{constructor(l,c){this.raw=c,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,F.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function w(r){return new p({uri:r,index:0,name:(0,F.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function R(r,l){return F.extUriBiasedIgnorePathCase.isEqualOrParent(r,l.untitledWorkspacesHome)}e.isUntitledWorkspace=R;function v(r){let l;return b.URI.isUri(r)?l=r:l=r.configuration,l?.scheme===_.Schemas.tmp}e.isTemporaryWorkspace=v;function t(r,l){return!R(r,l)&&!v(r)}e.isSavedWorkspace=t;function d(r){return(typeof r=="string"?(0,k.extname)(r):(0,F.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=d}),define(Ie[54],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const F=this._idPool++;return this._data.set(F,D),this.logDebugInfo(),F}get(D,F){return this._data.has(D)?this._data.get(D)[F]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!i.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}i.enableDebugLogging=!1,e.Cache=i}),define(Ie[36],ke([1,0,15,24,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this._systemSchemes=new Set(Object.keys(i.Schemas)),this._providerInfo=new Map,this.extUri=new k.ExtUri(A=>{const _=this._providerInfo.get(A.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(A,_){_===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,_)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ie[177],ke([1,0,12,163,27]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends k.LogService{constructor(A,_){super(A.createLogger(_.logFile,{name:_.logName}))}};F=Ve([We(0,i.ILoggerService),We(1,D.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(Ie[178],ke([1,0,17]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(b,A,_){this._deferredPromises=new Map,this._id=b,this._shared=A,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new i.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of I.values())N.complete()}catch(N){for(const y of I.values())y.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,b])=>b!==void 0).map(([b])=>b)}get whenReady(){return this._init}get(b,A){let _=this._value[b];return typeof _>"u"&&(_=A),_}update(b,A){this._value[b]=A;const _=this._deferredPromises.get(b);if(_!==void 0)return _.p;const I=new i.DeferredPromise;return this._deferredPromises.set(b,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class D extends k{setKeysForSync(b){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},b)}constructor(b,A){super(b.identifier.value,!0,A),this._extension=b}}e.ExtensionGlobalMemento=D}),define(Ie[179],ke([1,0,4,2]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(b){this._notebooksAndEditors=b,this._onDidSaveNotebookDocument=new i.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new i.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(b,A,_,I){const y=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(b)).acceptModelChanged(A.value,_,I);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(b,A){this._notebooksAndEditors.getNotebookDocument(k.URI.revive(b)).acceptDirty(A)}$acceptModelSaved(b){const A=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(b));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ie[18],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class k{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=k});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[180],ke([1,0,26,4]),function(ne,e,i,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class F{constructor(A,_){D.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=i.ExtensionIdentifier.toKey(A.identifier),Je(this,D,_,"f"),Oe(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(A){return Oe(this,D,"f").get(this._id,A)}store(A,_){return Oe(this,D,"f").store(this._id,A,_)}delete(A){return Oe(this,D,"f").delete(this._id,A)}}e.ExtensionSecrets=F,D=new WeakMap}),define(Ie[70],ke([1,0,3,174,4,18]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var b;(function(_){function I(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:y.protocol}}_.fromApiTunnel=I;function N(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==k.TunnelPrivacyId.ConstantPrivate&&y.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}_.fromServiceTunnel=N})(b=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let A=class{constructor(I){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,N){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,N){return{dispose:()=>{}}}async $providePortAttributes(I,N,y,h,E){return[]}async $forwardPort(I,N){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ve([We(0,F.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ie[55],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class k{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=b=>b,this.transformOutgoing=b=>b,this.transformOutgoingURI=b=>b,this.transformOutgoingScheme=b=>b)}}e.URITransformerService=k}),define(Ie[181],ke([1,0,23]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function D(A,_){if(_.serializeBuffersForPostMessage){const I=new k,N=(E,g)=>{if(g instanceof ArrayBuffer){const a=I.add(g);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(g)){const a=F(g);if(a){const o=I.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:a,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},y=JSON.stringify(A,N),h=I.buffers.map(E=>{const g=new Uint8Array(E);return i.VSBuffer.wrap(g)});return{message:y,buffers:h}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=D;function F(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function b(A,_){const I=_.map(h=>{const E=new ArrayBuffer(h.byteLength);return new Uint8Array(E).set(h.buffer),E}),N=_.length?(h,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const g=E,{index:a}=g,o=I[a];if(g.view)switch(g.view.type){case 1:return new Int8Array(o,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return E}:void 0;return{message:JSON.parse(A,N),arrayBuffers:I}}e.deserializeWebviewMessage=b}),define(Ie[95],ke([1,0,147,9,2,6,3,30,43,15,39,124,29]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(E=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var g;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(g=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function a(V){const q=V;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.isEditorPaneWithSelection=a;function o(V,q,G){for(const de of G.visibleEditorPanes)if(de.group.id===q&&V.matches(de.input))return de.getViewState()}e.findViewStateForEditor=o;function u(V){if(s(V))return!1;const q=V;return D.URI.isUri(q?.resource)}e.isResourceEditorInput=u;function p(V){if(s(V))return!1;const q=V;return q?.original!==void 0&&q.modified!==void 0}e.isResourceDiffEditorInput=p;function w(V){if(s(V)||p(V))return!1;const q=V;return q?.primary!==void 0&&q.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function R(V){if(s(V))return!1;const q=V;return q?q.resource===void 0||q.resource.scheme===I.Schemas.untitled||q.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=R;const v=/Untitled-\d+/;function t(V){return V.scheme===I.Schemas.untitled&&V.path.length>1&&!v.test(V.path)}e.isUntitledWithAssociatedResource=t;function d(V){if(s(V))return!1;const q=V;return D.URI.isUri(q?.base?.resource)&&D.URI.isUri(q?.input1?.resource)&&D.URI.isUri(q?.input2?.resource)&&D.URI.isUri(q?.result?.resource)}e.isResourceMergeEditorInput=d;var r;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var l;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(q,G){let de=this.mapIdToSaveSource.get(q);return de||(de={source:q,label:G},this.mapIdToSaveSource.set(q,de)),de.source}getSourceLabel(q){return this.mapIdToSaveSource.get(q)?.label??q}}e.SaveSourceRegistry=new c;var S;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor",V[V.MultipleEditors=256]="MultipleEditors"})(S=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends F.Disposable{}e.AbstractEditorInput=n;function s(V){return V instanceof n}e.isEditorInput=s;function f(V){const q=V;return D.URI.isUri(q?.preferredResource)}function P(V){const q=V;return s(q?.primary)&&s(q?.secondary)}e.isSideBySideEditorInput=P;function T(V){const q=V;return s(q?.modified)&&s(q?.original)}e.isDiffEditorInput=T;function z(V,q,G,de,Se){return we(de,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const Le={...G,limits:{size:Number.MAX_VALUE}};V.openEditor(q,Le)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>Se.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.createTooLargeFileError=z;function Q(V){return s(V?.editor)}e.isEditorInputWithOptions=Q;function Z(V){const q=V;return Q(V)&&q?.group!==void 0}e.isEditorInputWithOptionsAndGroup=Z;function Y(V){const q=V;return typeof q?.groupId=="number"&&s(q.editor)}e.isEditorIdentifier=Y;var H;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(H=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LOCKED=2]="GROUP_LOCKED",V[V.EDITOR_OPEN=3]="EDITOR_OPEN",V[V.EDITOR_CLOSE=4]="EDITOR_CLOSE",V[V.EDITOR_MOVE=5]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=7]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=9]="EDITOR_PIN",V[V.EDITOR_STICKY=10]="EDITOR_STICKY",V[V.EDITOR_DIRTY=11]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var m;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri(q,G){if(!q)return;if(d(q))return e.EditorResourceAccessor.getOriginalUri(q.result,G);if(G?.supportSideBySide){const{primary:Se,secondary:Le}=this.getSideEditors(q);if(Se&&Le){if(G?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(Se,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(Le,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===m.ANY)return this.getOriginalUri(Se,{filterByScheme:G.filterByScheme})??this.getOriginalUri(Le,{filterByScheme:G.filterByScheme});q=G.supportSideBySide===m.PRIMARY?Se:Le}}if(p(q)||w(q)||d(q))return;const de=f(q)?q.preferredResource:q.resource;return!de||!G||!G.filterByScheme?de:this.filterUri(de,G.filterByScheme)}getSideEditors(q){return P(q)||w(q)?{primary:q.primary,secondary:q.secondary}:T(q)||p(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,G){if(!q)return;if(d(q))return e.EditorResourceAccessor.getCanonicalUri(q.result,G);if(G?.supportSideBySide){const{primary:Se,secondary:Le}=this.getSideEditors(q);if(Se&&Le){if(G?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(Se,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(Le,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===m.ANY)return this.getCanonicalUri(Se,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(Le,{filterByScheme:G.filterByScheme});q=G.supportSideBySide===m.PRIMARY?Se:Le}}if(p(q)||w(q)||d(q))return;const de=q.resource;return!de||!G||!G.filterByScheme?de:this.filterUri(de,G.filterByScheme)}filterUri(q,G){if(Array.isArray(G)){if(G.some(de=>q.scheme===de))return q}else if(G===q.scheme)return q}}e.EditorResourceAccessor=new L;var B;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class J{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(q){const G=this.instantiationService=q.get(b.IInstantiationService);for(const[de,Se]of this.editorSerializerConstructors)this.createEditorSerializer(de,Se,G);this.editorSerializerConstructors.clear()}createEditorSerializer(q,G,de){const Se=de.createInstance(G);this.editorSerializerInstances.set(q,Se)}registerFileEditorFactory(q){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=q}getFileEditorFactory(){return(0,k.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(q,G){if(this.editorSerializerConstructors.has(q)||this.editorSerializerInstances.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.instantiationService?this.createEditorSerializer(q,G,this.instantiationService):this.editorSerializerConstructors.set(q,G),(0,F.toDisposable)(()=>{this.editorSerializerConstructors.delete(q),this.editorSerializerInstances.delete(q)})}getEditorSerializer(q){return this.editorSerializerInstances.get(typeof q=="string"?q:q.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new J);async function me(V,q,G){return!V||!V.length?[]:await Promise.all(V.map(async de=>{const Se=D.URI.revive(de.fileUri);if(!Se){G.info("Cannot resolve the path because it is not valid.",de);return}if(!await q.canHandleResource(Se)){G.info("Cannot resolve the path because it cannot be handled",de);return}let xe=de.exists,Te=de.type;if(typeof xe!="boolean"||typeof Te!="number")try{Te=(await q.stat(Se)).isDirectory?_.FileType.Directory:_.FileType.Unknown,xe=!0}catch(_e){G.error(_e),xe=!1}if(!xe&&de.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",de);return}if(Te===_.FileType.Directory){G.info("Cannot resolve the path because it is a directory",de);return}const De={...de.options,pinned:!0};return xe?{resource:Se,options:De}:{resource:Se,options:De,forceUntitled:!0}}))}e.pathsToEditors=me;var te;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(te=e.EditorsOrder||(e.EditorsOrder={}));function oe(V){const q=V;if(!q)return!1;const G=q;if(G.modified)return oe(G.modified);const de=q;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.isTextEditorViewState=oe;function ce(V){return(0,N.isErrorWithActions)(V)}e.isEditorOpenError=ce;function we(V,q,G){const de=(0,N.createErrorWithActions)(V,q);return de.forceMessage=G?.forceMessage,de.forceSeverity=G?.forceSeverity,de.allowDialog=G?.allowDialog,de}e.createEditorOpenError=we}),define(Ie[182],ke([1,0,4,148,3,6,28,30,16,63,22,84,173]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",y.Codicon.window,(0,k.localize)(0,null));var E;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(E=e.Extensions||(e.Extensions={}));var g;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function a(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=a;class o extends F.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new i.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new i.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,_.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,S){const n=this.get(l.id);if(n)return n;const s=l;return s.openCommandActionDescriptor=S?.doNotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,b.getOrSet)(this.viewContainers,c,[]).push(s),S?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:c}),s}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const S=this.viewContainers.get(c),n=S?.indexOf(l);if(n!==-1){S?.splice(n,1),S.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(S=>S?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}A.Registry.add(E.ViewContainersRegistry,new o);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function p(r,l){const c=r.group??u.More,S=l.group??u.More;return c!==S?c.localeCompare(S):(r.order??5)-(l.order??5)}class w extends F.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new i.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new i.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new i.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new i.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new I.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:S})=>this.addViews(c,S)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const S=this.removeViews(l,c);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:c})}moveViews(l,c){for(const S of this._views.keys())if(S!==c){const n=this.removeViews(l,S);n.length&&(this.addViews(n,c),this._onDidChangeContainer.fire({views:n,from:S,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const S=(this._views.get(c)||[]).filter(n=>n.id===l)[0];if(S)return S}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(n=>n.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const S=new Map;for(const[n,s]of c)this._viewWelcomeContents.add(l,s),S.set(n,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,s),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),S}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,S=>c.push(S)),c.sort(p)}addViews(l,c){let S=this._views.get(c);S||(S=[],this._views.set(c,S),this._viewContainers.push(c));for(const n of l){if(this.getView(n.id)!==null)throw new Error((0,k.localize)(1,null,n.id));S.push(n)}}removeViews(l,c){const S=this._views.get(c);if(!S)return[];const n=[],s=[];for(const f of S)l.includes(f)?n.push(f):s.push(f);return n.length&&(s.length?this._views.set(c,s):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),n}}A.Registry.add(E.ViewsRegistry,new w),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var R;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(R=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,N.mixin)(this,l),this._hasResolve=!!c,this.resolve=async S=>{if(c&&!this.resolved){const n=await c(S);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class d extends Error{constructor(l){super((0,k.localize)(2,null,l))}}e.NoTreeViewError=d}),define(Ie[183],ke([1,0,4,17,149]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,_,I,N){const y={command:A};if(_&&Object.keys(_).length>0&&(y.arguments=_),this.internalSend("request",y),typeof N=="number"){const h=setTimeout(()=>{clearTimeout(h);const E=this.pendingRequests.get(y.seq);if(E){this.pendingRequests.delete(y.seq);const g={type:"response",seq:0,request_seq:y.seq,success:!1,command:A,message:(0,D.localize)(0,null,N,A)};E(g)}},N)}return I&&this.pendingRequests.set(y.seq,I),y.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,_){return A.type!=="event"||_.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,k.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const _=A,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}}internalSend(A,_){_.type=A,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((_,I)=>A.set(I,_)),await(0,k.timeout)(500),A.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=F}),define(Ie[184],ke([1,0,150,42,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const F=h=>i.localize(51,null,h);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var b;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(b=e.State||(e.State={}));function A(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var _;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(_=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var y;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(y=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[185],ke([1,0,10,2,19,22,15,44,21,16]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const N=/{([^}]+)}/g;function y(n,s,f){return n.replace(N,function(P,T){return s&&T.length>0&&T[0]!=="_"?P:f&&f.hasOwnProperty(T)?f[T]:P})}e.formatPII=y;function h(n){const s={};for(const f of Object.keys(n))f.startsWith("!")||(s[f]=n[f]);return s}e.filterExceptionsFromTelemetry=h;function E(n){return n.configuration.request==="attach"&&!g(n)&&(!n.parentSession||E(n.parentSession))}e.isSessionAttach=E;function g(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(s,"extensionhost")||(0,i.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?g(n.parentSession):void 0}e.getExtensionHostDebugSession=g;function a(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=a;function o(n,s,f){let P,T=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Q=null;for(;Q=z.exec(n);){const Z=Q.index+1,Y=Z+Q[0].length;if(Z<=s&&Y>=f){P=Q[0],T=Z;break}}if(P){const Z=/\w+/g;let Y=null;for(;(Y=Z.exec(P))&&!(Y.index+1+T+Y[0].length>=f););Y&&(P=P.substring(0,Z.lastIndex))}return P?{start:T,end:T+P.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=o;async function u(n,s,f,P){if(n.evaluatableExpressionProvider.has(s)){const T=n.evaluatableExpressionProvider.ordered(s),z=(0,I.coalesce)(await Promise.all(T.map(async Q=>{try{return await Q.provideEvaluatableExpression(s,f,P??_.CancellationToken.None)}catch{return}})));if(z.length>0){let Q=z[0].expression;const Z=z[0].range;return Q||(Q=s.getLineContent(f.lineNumber).substring(Z.startColumn-1,Z.endColumn-1)),{range:Z,matchingExpression:Q}}}else{const T=s.getLineContent(f.lineNumber),{start:z,end:Q}=o(T,f.column,f.column),Z=T.substring(z-1,Q);return{matchingExpression:Z,range:new A.Range(f.lineNumber,z,f.lineNumber,z+Z.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(n){return!!(n&&n.match(p))}e.isUri=w;function R(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(w(n.path))return k.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return k.URI.file(n.path)}return n.path}function v(n){if(typeof n.path=="object"){const s=k.URI.revive(n.path);if(s)return s.scheme===b.Schemas.file?s.fsPath:s.toString()}return n.path}function t(n,s){const f=s?R:v,P=(0,F.deepClone)(n);return r(P,(T,z)=>{T&&z&&(z.path=f(z))}),P}e.convertToDAPaths=t;function d(n,s){const f=s?R:v,P=(0,F.deepClone)(n);return r(P,(T,z)=>{!T&&z&&(z.path=f(z))}),P}e.convertToVSCPaths=d;function r(n,s){switch(n.type){case"event":{const f=n;switch(f.event){case"output":s(!1,f.body.source);break;case"loadedSource":s(!1,f.body.source);break;case"breakpoint":s(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=n;switch(f.command){case"setBreakpoints":s(!0,f.arguments.source);break;case"breakpointLocations":s(!0,f.arguments.source);break;case"source":s(!0,f.arguments.source);break;case"gotoTargets":s(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(P=>s(!1,P));break;default:break}break}case"response":{const f=n;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(P=>s(!1,P.source));break;case"loadedSources":f.body.sources.forEach(P=>s(!1,P));break;case"scopes":f.body.scopes.forEach(P=>s(!1,P.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(P=>s(!1,P.source));break;case"setBreakpoints":f.body.breakpoints.forEach(P=>s(!1,P.source));break;case"disassemble":f.body?.instructions.forEach(T=>s(!1,T.location));break;default:break}break}}}function l(n){return n.filter(s=>!s.presentation?.hidden).sort((s,f)=>s.presentation?f.presentation?s.presentation.group?f.presentation.group?s.presentation.group!==f.presentation.group?s.presentation.group.localeCompare(f.presentation.group):c(s.presentation.order,f.presentation.order):-1:f.presentation.group?1:c(s.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=l;function c(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}async function S(n,s){const f=n.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(f!=="none"&&(await s.saveAll(),f==="allEditorsInActiveGroup")){const P=s.activeEditorPane;P&&P.input.resource?.scheme===b.Schemas.untitled&&await s.save({editor:P.input,groupId:P.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(Ie[71],ke([1,0,23,35,186,65,15,19,20,42]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(m){m[m.Markup=1]="Markup",m[m.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(m){m[m.Running=1]="Running",m[m.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={}));var h;(function(m){m[m.Unconfirmed=1]="Unconfirmed",m[m.Pending=2]="Pending",m[m.Executing=3]="Executing"})(h=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(m){m[m.WithHardKernelDependency=0]="WithHardKernelDependency",m[m.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",m[m.Pure=2]="Pure",m[m.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(m){m.Always="always",m.Never="never",m.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(m){m[m.ModelChange=1]="ModelChange",m[m.Move=2]="Move",m[m.ChangeCellLanguage=5]="ChangeCellLanguage",m[m.Initialize=6]="Initialize",m[m.ChangeCellMetadata=7]="ChangeCellMetadata",m[m.Output=8]="Output",m[m.OutputItem=9]="OutputItem",m[m.ChangeCellContent=10]="ChangeCellContent",m[m.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",m[m.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",m[m.ChangeCellMime=13]="ChangeCellMime",m[m.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(m){m[m.Handle=0]="Handle",m[m.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(m){m[m.Replace=1]="Replace",m[m.Output=2]="Output",m[m.Metadata=3]="Metadata",m[m.CellLanguage=4]="CellLanguage",m[m.DocumentMetadata=5]="DocumentMetadata",m[m.Move=6]="Move",m[m.OutputItems=7]="OutputItems",m[m.PartialMetadata=8]="PartialMetadata",m[m.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var p;(function(m){m.scheme=b.Schemas.vscodeNotebookCell;const L=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${L.join("")}]+`),J=7;function me(q,G){const de=G.toString(J),Le=`${de.length<L.length?L[de.length-1]:"z"}${de}s${(0,i.encodeBase64)(i.VSBuffer.fromString(q.scheme),!0,!0)}`;return q.with({scheme:m.scheme,fragment:Le})}m.generate=me;function te(q){if(q.scheme!==m.scheme)return;const G=q.fragment.indexOf("s");if(G<0)return;const de=parseInt(q.fragment.substring(0,G).replace(B,""),J),Se=(0,i.decodeBase64)(q.fragment.substring(G+1)).toString();if(!isNaN(de))return{handle:de,notebook:q.with({scheme:Se,fragment:null})}}m.parse=te;function oe(q,G){return q.with({scheme:b.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${q.scheme!==b.Schemas.file?q.scheme:""}`})}m.generateCellOutputUri=oe;function ce(q){if(q.scheme!==b.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(q.fragment);if(!G)return;const de=G[1]&&G[1]!==""?G[1]:void 0,Se=G[2];return{outputId:de,notebook:q.with({scheme:Se||b.Schemas.file,fragment:null})}}m.parseCellOutputUri=ce;function we(q,G,de){return m.generate(q,G).with({scheme:de})}m.generateCellPropertyUri=we;function V(q,G){if(q.scheme===G)return m.parse(q.with({scheme:m.scheme}))}m.parseCellPropertyUri=V})(p=e.CellUri||(e.CellUri={}));const w=m=>_.isWindows?m.replace(/\//g,"\\"):m;class R{constructor(L=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=B,this.order=[...new Set(L)].map(J=>({pattern:J,matches:k.parse(w(J))}))}sort(L){const B=new Map(D.Iterable.map(L,me=>[me,w(me)]));let J=[];for(const{matches:me}of this.order)for(const[te,oe]of B)if(me(oe)){J.push(te),B.delete(te);break}return B.size&&(J=J.concat([...B.keys()].sort((me,te)=>this.defaultOrder.indexOf(me)-this.defaultOrder.indexOf(te)))),J}prioritize(L,B){const J=this.findIndex(L);if(J===-1){this.order.unshift({pattern:L,matches:k.parse(w(L))});return}const me=new Set(B.map(oe=>this.findIndex(oe,J)));me.delete(-1);const te=Array.from(me).sort();this.order.splice(J+1,0,...te.map(oe=>this.order[oe]));for(let oe=te.length-1;oe>=0;oe--)this.order.splice(te[oe],1)}toArray(){return this.order.map(L=>L.pattern)}findIndex(L,B=this.order.length){const J=w(L);for(let me=0;me<B;me++)if(this.order[me].matches(J))return me;return-1}}e.MimeTypeDisplayOrder=R;function v(m,L,B,J=(me,te)=>me===te){const me=[];function te(we,V,q){if(V===0&&q.length===0)return;const G=me[me.length-1];G&&G.start+G.deleteCount===we?(G.deleteCount+=V,G.toInsert.push(...q)):me.push({start:we,deleteCount:V,toInsert:q})}let oe=0,ce=0;for(;;){if(oe===m.length){te(oe,0,L.slice(ce));break}if(ce===L.length){te(oe,m.length-oe,[]);break}const we=m[oe],V=L[ce];if(J(we,V)){oe+=1,ce+=1;continue}B(V)?(te(oe,1,[]),oe+=1):(te(oe,0,[V]),ce+=1)}return me}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(m){m.default="default",m.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(m){const L=m;return!!((typeof L.include=="string"||k.isRelativePattern(L.include))&&(typeof L.exclude=="string"||k.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=d;function r(m,L,B){if(Array.isArray(m.viewType)&&m.viewType.indexOf(L)>=0||m.viewType===L)return!0;if(m.filenamePattern){const J=d(m.filenamePattern)?m.filenamePattern.include:m.filenamePattern,me=d(m.filenamePattern)?m.filenamePattern.exclude:void 0;if(k.match(J,(0,A.basename)(B.fsPath).toLowerCase()))return!(me&&k.match(me,(0,A.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var l;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(L){return`${c._prefix}${L}`}static parse(L){if(L.startsWith(c._prefix))return L.substring(c._prefix.length)}}c._prefix="notebook/",e.NotebookWorkingCopyTypeIdentifier=c;function S(m){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(m)}e.isTextStreamMime=S;const n=new TextDecoder;function s(m){const L=[];let B=!1;for(const J of m)(L.length===0||B)&&(L.push(J),B=!0);return z(L),O(i.VSBuffer.concat(L.map(J=>i.VSBuffer.wrap(J))))}e.compressOutputItemStreams=s;const f=`${String.fromCharCode(27)}[A`,P=f.split("").map(m=>m.charCodeAt(0)),T=10;function z(m){m.forEach((L,B)=>{if(B===0||L.length<f.length)return;const J=m[B-1],me=L.subarray(0,f.length);if(me[0]===P[0]&&me[1]===P[1]&&me[2]===P[2]){const te=J.lastIndexOf(T);if(te===-1)return;m[B-1]=J.subarray(0,te),m[B]=L.subarray(f.length)}})}function Q(m){let L=m;do m=L,L=m.replace(/[^\n]\x08/gm,"");while(L.length<m.length);return m}function Z(m){for(m=m.replace(/\r+\n/gm,`
`);m.search(/\r[^$]/g)>-1;){const L=m.match(/^(.*)\r+/m)[1];let B=m.match(/\r+(.*)$/m)[1];B=B+L.slice(B.length,L.length),m=m.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return m}const Y="\b".charCodeAt(0),H="\r".charCodeAt(0);function O(m){return!m.buffer.includes(Y)&&!m.buffer.includes(H)?m:i.VSBuffer.fromString(Z(Q(n.decode(m.buffer))))}}),define(Ie[187],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ie[45],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(F){F.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(b,A,_=b.parent){if(b._isRoot)return new D([A]);const I=[b.id];for(let N=_;N&&N.id!==A;N=N.parent)I.push(N.id);return I.push(A),new D(I.reverse())}static isRoot(b){return!b.includes("\0")}static root(b){const A=b.indexOf("\0");return A===-1?b:b.slice(0,A)}static fromString(b){return new D(b.split("\0"))}static join(b,A){return new D([...b.path,A])}static joinToString(b,A){return b.toString()+"\0"+A}static parentId(b){const A=b.lastIndexOf("\0");return A===-1?void 0:b.slice(0,A)}static localId(b){const A=b.lastIndexOf("\0");return A===-1?b:b.slice(A+1)}static compare(b,A){return b===A?0:A.startsWith(b+"\0")?2:b.startsWith(A+"\0")?3:1}constructor(b,A=b.length){if(this.path=b,this.viewEnd=A,b.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let b=1;b<=this.viewEnd;b++)yield new D(this.path,b)}*idsToRoot(){for(let b=this.viewEnd;b>0;b--)yield new D(this.path,b)}compare(b){if(typeof b=="string")return D.compare(this.toString(),b);for(let A=0;A<b.viewEnd&&A<this.viewEnd;A++)if(b.path[A]!==this.path[A])return 1;return b.viewEnd>this.viewEnd?2:b.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let b=1;b<this.viewEnd;b++)this.stringifed+="\0",this.stringifed+=this.path[b]}return this.stringifed}}e.TestId=D}),define(Ie[56],ke([1,0,2,44,45]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var F;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(F=e.TestResultState||(e.TestResultState={}));var b;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(b=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=n=>"runId"in n;e.isStartControllerTests=A;var _;(function(n){n.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),n.deserialize=s=>({range:k.Range.lift(s.range),uri:i.URI.revive(s.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var I;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var N;(function(n){n.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&_.serialize(s.location)}),n.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&_.deserialize(s.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const y=(n,s)=>`${s?"s":"e"}${n}`;e.getMarkId=y;var h;(function(n){n.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&_.serialize(s.location)}),n.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&_.deserialize(s.location)})})(h=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(n){n.serialize=s=>s.type===0?N.serialize(s):h.serialize(s),n.deserialize=s=>s.type===0?N.deserialize(s):h.deserialize(s)})(E=e.ITestMessage||(e.ITestMessage={}));var g;(function(n){n.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),n.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(E.serialize)}),n.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(E.deserialize)})})(g=e.ITestTaskState||(e.ITestTaskState={}));const a="\0",o=(n,s)=>n+a+s;e.namespaceTestTag=o;const u=n=>{const s=n.indexOf(a);return{ctrlId:n.slice(0,s),tagId:n.slice(s+1)}};e.denamespaceTestTag=u;var p;(function(n){n.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),n.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?i.URI.revive(s.uri):void 0,range:s.range?k.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(p=e.ITestItem||(e.ITestItem={}));var w;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var R;(function(n){n.serialize=s=>({expand:s.expand,item:p.serialize(s.item)}),n.deserialize=s=>({controllerId:D.TestId.root(s.item.extId),expand:s.expand,item:p.deserialize(s.item)})})(R=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(n){n.serialize=s=>{let f;return s.item&&(f={},s.item.label!==void 0&&(f.label=s.item.label),s.item.tags!==void 0&&(f.tags=s.item.tags),s.item.busy!==void 0&&(f.busy=s.item.busy),s.item.uri!==void 0&&(f.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(f.range=s.item.range?.toJSON()),s.item.description!==void 0&&(f.description=s.item.description),s.item.error!==void 0&&(f.error=s.item.error),s.item.sortText!==void 0&&(f.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:f}},n.deserialize=s=>{let f;return s.item&&(f={},s.item.label!==void 0&&(f.label=s.item.label),s.item.tags!==void 0&&(f.tags=s.item.tags),s.item.busy!==void 0&&(f.busy=s.item.busy),s.item.range!==void 0&&(f.range=s.item.range?k.Range.lift(s.item.range):null),s.item.description!==void 0&&(f.description=s.item.description),s.item.error!==void 0&&(f.error=s.item.error),s.item.sortText!==void 0&&(f.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:f}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(n,s)=>{s.expand!==void 0&&(n.expand=s.expand),s.item!==void 0&&(n.item=n.item?Object.assign(n.item,s.item):s.item)};e.applyTestItemUpdate=t;var d;(function(n){n.serializeWithoutMessages=s=>({...R.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(g.serializeWithoutMessages),retired:s.retired}),n.serialize=s=>({...R.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(g.serialize),retired:s.retired}),n.deserialize=s=>({...R.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(g.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var r;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var l;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var c;(function(n){n.deserialize=s=>s.op===0?{op:s.op,item:R.deserialize(s.item)}:s.op===1?{op:s.op,item:v.deserialize(s.item)}:s.op===2?{op:s.op,uri:i.URI.revive(s.uri),docv:s.docv}:s,n.serialize=s=>s.op===0?{op:s.op,item:R.serialize(s.item)}:s.op===1?{op:s.op,item:v.serialize(s.item)}:s})(c=e.TestsDiffOp||(e.TestsDiffOp={}));class S{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const f=this.createChangeCollector();for(const P of s)switch(P.op){case 0:this.add(R.deserialize(P.item),f);break;case 1:this.update(v.deserialize(P.item),f);break;case 3:this.remove(P.itemId,f);break;case 5:this.retireTest(P.itemId);break;case 4:this.updatePendingRoots(P.amount);break;case 6:this._tags.set(P.tag.id,P.tag);break;case 7:this._tags.delete(P.id);break}f.complete?.()}add(s,f){const P=D.TestId.parentId(s.item.extId)?.toString();let T;if(!P)T=this.createItem(s),this.roots.add(T),this.items.set(s.item.extId,T);else if(this.items.has(P)){const z=this.items.get(P);z.children.add(s.item.extId),T=this.createItem(s,z),this.items.set(s.item.extId,T)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return f.add?.(T),s.expand===2&&this.busyControllerCount++,T}update(s,f){const P=this.items.get(s.extId);if(!!P)return s.expand!==void 0&&(P.expand===2&&this.busyControllerCount--,s.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(P,s),f.update?.(P),P}remove(s,f){const P=this.items.get(s);if(!P)return;const T=D.TestId.parentId(P.item.extId)?.toString();T?this.items.get(T).children.delete(P.item.extId):this.roots.delete(P);const z=[[s]];for(;z.length;)for(const Q of z.pop()){const Z=this.items.get(Q);Z&&(z.push(Z.children),this.items.delete(Q),f.remove?.(Z,Z!==P),Z.expand===2&&this.busyControllerCount--)}}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=S}),define(Ie[72],ke([1,0,17,4,6,49,56,45]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var _;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(_=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(p,w)=>p===w,y=Object.entries({range:(p,w)=>p===w?!0:!p||!w?!1:p.equalsRange(w),busy:I,label:I,description:I,error:I,sortText:I,tags:(p,w)=>!(p.length!==w.length||p.some(R=>!w.includes(R)))}),h=(p,w)=>{let R;for(const[v,t]of y)t(p[v],w[v])||(R?R[v]=w[v]:R={[v]:w[v]});return R};class E extends D.Disposable{get root(){return this.options.root}constructor(w){super(),this.options=w,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new k.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(w){this._resolveHandler=w;for(const R of this.tree.values())this.updateExpandability(R)}get resolveHandler(){return this._resolveHandler}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){switch(w.op){case 2:{for(const R of this.diff)if(R.op===2&&R.uri===w.uri){R.docv=w.docv;return}break}case 1:{const R=this.diff[this.diff.length-1];if(R){if(R.op===1&&R.item.extId===w.item.extId){(0,b.applyTestItemUpdate)(R.item,w.item);return}if(R.op===0&&R.item.item.extId===w.item.extId){(0,b.applyTestItemUpdate)(R.item,w.item);return}}break}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,R){const v=this.tree.get(w);if(!!v){if((v.expandLevels===void 0||R>v.expandLevels)&&(v.expandLevels=R),v.expand===1){const t=this.resolveChildren(v);return t.isOpen()?this.expandChildren(v,R-1):t.wait().then(()=>this.expandChildren(v,R-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.expandChildren(v,R-1)):this.expandChildren(v,R-1)}}dispose(){for(const w of this.tree.values())this.options.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(w,R){switch(R.op){case 3:this.removeItem(A.TestId.joinToString(w.fullId,R.id));break;case 0:this.upsertItem(R.item,w);break;case 5:for(const v of R.ops)this.onTestItemEvent(w,v);break;case 1:this.diffTagRefs(R.new,R.old,w.fullId.toString());break;case 2:this.updateExpandability(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:R.update}});break;case 6:this.documentSynced(w.actual.uri);break;default:(0,F.assertNever)(R)}}documentSynced(w){w&&this.pushDiff({op:2,uri:w,docv:this.options.getDocumentVersion(w)})}upsertItem(w,R){const v=A.TestId.fromExtHostTestItem(w,this.root.id,R?.actual),t=this.options.getApiFor(w);t.parent&&t.parent!==R?.actual&&this.options.getChildren(t.parent).delete(w.id);let d=this.tree.get(v.toString());if(!d){d={fullId:v,actual:w,expandLevels:R?.expandLevels?R.expandLevels-1:void 0,expand:0},w.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(w,R),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:d.expand,item:this.options.toITestItem(w)}}),this.connectItemAndChildren(w,d,R);return}if(d.actual===w){this.connectItem(w,d,R);return}if(d.actual.uri?.toString()!==w.uri?.toString())return this.removeItem(v.toString()),this.upsertItem(w,R);const r=this.options.getChildren(d.actual),l=d.actual,c=h(this.options.toITestItem(l),this.options.toITestItem(w));this.options.getApiFor(l).listener=void 0,d.actual=w,d.expand=0,c&&(c.hasOwnProperty("tags")&&(this.diffTagRefs(w.tags,l.tags,v.toString()),delete c.tags),this.onTestItemEvent(d,{op:4,update:c})),this.connectItemAndChildren(w,d,R);for(const[S,n]of r)this.options.getChildren(w).get(n.id)||this.removeItem(A.TestId.joinToString(v,n.id));this.documentSynced(d.actual.uri)}diffTagRefs(w,R,v){const t=new Set(R.map(d=>d.id));for(const d of w)t.delete(d.id)||this.incrementTagRefs(d);this.pushDiff({op:1,item:{extId:v,item:{tags:w.map(d=>(0,b.namespaceTestTag)(this.options.controllerId,d.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(w){const R=this.tags.get(w.id);R?R.refCount++:(this.tags.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,b.namespaceTestTag)(this.options.controllerId,w.id)}}))}decrementTagRefs(w){const R=this.tags.get(w);R&&!--R.refCount&&(this.tags.delete(w),this.pushDiff({op:7,id:(0,b.namespaceTestTag)(this.options.controllerId,w)}))}setItemParent(w,R){this.options.getApiFor(w).parent=R&&R.actual!==this.root?R.actual:void 0}connectItem(w,R,v){this.setItemParent(w,v);const t=this.options.getApiFor(w);t.parent=v?.actual,t.listener=d=>this.onTestItemEvent(R,d),this.updateExpandability(R)}connectItemAndChildren(w,R,v){this.connectItem(w,R,v);for(const[t,d]of this.options.getChildren(w))this.upsertItem(d,R)}updateExpandability(w){let R;this._resolveHandler?w.resolveBarrier?R=w.resolveBarrier.isOpen()?3:2:R=w.actual.canResolveChildren?1:0:R=0,R!==w.expand&&(w.expand=R,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:R}}),R===1&&w.expandLevels!==void 0&&this.resolveChildren(w))}expandChildren(w,R){if(R<0)return;const v=[];for(const[t,d]of this.options.getChildren(w.actual)){const r=this.expand(A.TestId.joinToString(w.fullId,d.id),R);(0,i.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}resolveChildren(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this._resolveHandler){const d=new i.Barrier;return d.open(),d}w.expand=2,this.pushExpandStateUpdate(w);const R=w.resolveBarrier=new i.Barrier,v=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,d)};let t;try{t=this._resolveHandler(w.actual===this.root?void 0:w.actual)}catch(d){v(d)}return(0,i.isThenable)(t)?t.catch(v).then(()=>{R.open(),this.updateExpandability(w)}):(R.open(),this.updateExpandability(w)),w.resolveBarrier}pushExpandStateUpdate(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}removeItem(w){const R=this.tree.get(w);if(!R)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const v=[R];for(;v.length;){const t=v.pop();if(!!t){this.options.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(t.fullId.toString());for(const[d,r]of this.options.getChildren(t.actual))v.push(this.tree.get(A.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.diffOpEmitter.fire(w)}}e.TestItemCollection=E;class g extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=g;class a extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class o extends Error{constructor(w,R,v){super(`TestItem with ID "${w}" is from controller "${R}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=o;const u=(p,w,R)=>{let v=new Map;return{get size(){return v.size},forEach(t,d){for(const r of v.values())t.call(d,r,this)},[Symbol.iterator](){return v.entries()},replace(t){const d=new Map,r=new Set(v.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof R))throw new a(c.id);const S=w(c).controllerId;if(S!==p.controllerId)throw new o(c.id,S,p.controllerId);if(d.has(c.id))throw new g(c.id);d.set(c.id,c),r.delete(c.id),l.ops.push({op:0,item:c})}for(const c of r.keys())l.ops.push({op:3,id:c});p.listener?.(l),v=d},add(t){if(!(t instanceof R))throw new a(t.id);v.set(t.id,t),p.listener?.({op:0,item:t})},delete(t){v.delete(t)&&p.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=u}),define(Ie[96],ke([1,0,72]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,D=(b,A)=>{const _={controllerId:A};return k.set(b,_),_};e.createPrivateApiFor=D;const F=b=>{const A=k.get(b);if(!A)throw new i.InvalidTestItemError(b?.id||"<unknown>");return A};e.getPrivateApiFor=F}),define(Ie[73],ke([1,0,15,2]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(A,_){return A.scheme===i.Schemas.http||A.scheme===i.Schemas.https?A:(_&&_.authority&&_.isRemote&&A.scheme===i.Schemas.file&&(A=k.URI.from({scheme:i.Schemas.vscodeRemote,authority:_.authority,path:A.path})),k.URI.from({scheme:i.Schemas.https,authority:`${A.scheme}+${F(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=D;function F(A){return A.replace(/./g,_=>{const I=_.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?_:"-"+I.toString(16).padStart(4,"0")})}function b(A){return A.replace(/-([0-9a-f]{4})/g,(_,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=b}),define(Ie[188],ke([1,0,4,6,73]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(A,_,I){this._proxy=A,this._editors=_,this._remoteInfo=I,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const N=_.getVisibleTextEditors();for(const y of this._insets.values())N.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,_,I,N,y){let h;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===A){h=w;break}if(!h)throw new Error("not a visible editor");const E=this,g=this._handlePool++,a=new i.Emitter,o=new i.Emitter,u=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,D.asWebviewUri)(w,E._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(w){this._options=w,E._proxy.$setOptions(g,w)}get options(){return this._options}set html(w){this._html=w,E._proxy.$setHtml(g,w)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(w){return E._proxy.$postMessage(g,w)}},p=new class{constructor(){this.editor=A,this.line=_,this.height=I,this.webview=u,this.onDidDispose=o.event}dispose(){E._insets.has(g)&&(E._insets.delete(g),E._proxy.$disposeEditorInset(g),o.fire(),o.dispose(),a.dispose())}};return this._proxy.$createEditorInset(g,h.id,h.value.document.uri,_+1,I,N||{},y.identifier,y.extensionLocation),this._insets.set(g,{editor:A,inset:p,onDidReceiveMessage:a}),p}$onDidDispose(A){const _=this._insets.get(A);_&&_.inset.dispose()}$onDidReceiveMessage(A,_){this._insets.get(A)?.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=F}),define(Ie[189],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var k;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(k=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(b,A){super(A),this.variable=b}}e.VariableError=D}),define(Ie[190],ke([1,0,19,51,9,22,20,87,153,189,10]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(E,g,a,o){this._contributedVariables=new Map,this._context=E,this._labelService=g,this._userHomePromise=a,o&&(this._envVariablesPromise=o.then(u=>this.prepareEnv(u)))}prepareEnv(E){if(b.isWindows){const g=Object.create(null);return Object.keys(E).forEach(a=>{g[a.toLowerCase()]=E[a]}),g}return E}resolveWithEnvironment(E,g,a){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},g?g.uri:void 0,a)}async resolveAsync(E,g){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,E?E.uri:void 0,g)}async resolveAnyBase(E,g,a,o){const u=F.deepClone(g);b.isWindows&&u.windows?Object.keys(u.windows).forEach(w=>u[w]=u.windows[w]):b.isMacintosh&&u.osx?Object.keys(u.osx).forEach(w=>u[w]=u.osx[w]):b.isLinux&&u.linux&&Object.keys(u.linux).forEach(w=>u[w]=u.linux[w]),delete u.windows,delete u.osx,delete u.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,E?E.uri:void 0,u,a,o)}async resolveAnyAsync(E,g,a){return this.resolveAnyBase(E,g,a)}async resolveAnyMap(E,g,a){const o=new Map;return{newConfig:await this.resolveAnyBase(E,g,a,o),resolvedVariables:o}}resolveWithInteractionReplace(E,g,a,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,g,a,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,g){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,g)}async recursiveResolve(E,g,a,o,u){if(D.isString(a))return this.resolveString(E,g,a,o,u);if(Array.isArray(a))return Promise.all(a.map(p=>this.recursiveResolve(E,g,p,o,u)));if(D.isObject(a)){const p=Object.create(null),w=await Promise.all(Object.keys(a).map(async R=>[await this.resolveString(E,g,R,o,u),await this.recursiveResolve(E,g,a[R],o,u)]));for(const[R,v]of w)p[R]=v;return p}return a}resolveString(E,g,a,o,u){return(0,N.replaceAsync)(a,y.VARIABLE_REGEXP,async(p,w)=>{if(w.includes(y.VARIABLE_LHS))return p;let R=await this.evaluateSingleVariable(E,p,w,g,o);return u?.set(w,R),R!==p&&D.isString(R)&&R.match(y.VARIABLE_REGEXP)&&(R=await this.resolveString(E,g,R,o,u)),R})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,g,a,o,u){let p;const w=a.split(":");w.length>1&&(a=w[0],p=w[1]);const R=d=>{const r=this._context.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new I.VariableError(d,(0,_.localize)(0,null,g))},v=d=>{const r=R(d);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return(0,A.normalizeDriveLetter)(l)}throw new I.VariableError(d,(0,_.localize)(1,null,g,i.basename(r)))},t=d=>{if(p){const r=this._context.getFolderUri(p);if(r)return r;throw new I.VariableError(d,(0,_.localize)(2,null,g,p))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new I.VariableError(d,(0,_.localize)(3,null,g)):new I.VariableError(d,(0,_.localize)(4,null,g))};switch(a){case"env":if(p){if(E.env){const d=E.env[b.isWindows?p.toLowerCase():p];if(D.isString(d))return d}return""}throw new I.VariableError(I.VariableKind.Env,(0,_.localize)(5,null,g));case"config":if(p){const d=this._context.getConfigurationValue(o,p);if(D.isUndefinedOrNull(d))throw new I.VariableError(I.VariableKind.Config,(0,_.localize)(6,null,g,p));if(D.isObject(d))throw new I.VariableError(I.VariableKind.Config,(0,_.localize)(7,null,g,p));return d}throw new I.VariableError(I.VariableKind.Config,(0,_.localize)(8,null,g));case"command":return this.resolveFromMap(I.VariableKind.Command,g,p,u,"command");case"input":return this.resolveFromMap(I.VariableKind.Input,g,p,u,"input");case"extensionInstallFolder":if(p){const d=await this._context.getExtension(p);if(!d)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,_.localize)(9,null,g,p));return this.fsPath(d.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,_.localize)(10,null,g));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(I.VariableKind.WorkspaceFolder)));case"cwd":return o||p?(0,A.normalizeDriveLetter)(this.fsPath(t(I.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(i.basename(this.fsPath(t(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,_.localize)(11,null,g))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new I.VariableError(I.VariableKind.LineNumber,(0,_.localize)(12,null,g))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new I.VariableError(I.VariableKind.SelectedText,(0,_.localize)(13,null,g))}case"file":return R(I.VariableKind.File);case"fileWorkspaceFolder":return v(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||p?i.relative(this.fsPath(t(I.VariableKind.RelativeFile)),R(I.VariableKind.RelativeFile)):R(I.VariableKind.RelativeFile);case"relativeFileDirname":{const d=i.dirname(R(I.VariableKind.RelativeFileDirname));if(o||p){const r=i.relative(this.fsPath(t(I.VariableKind.RelativeFileDirname)),d);return r.length===0?".":r}return d}case"fileDirname":return i.dirname(R(I.VariableKind.FileDirname));case"fileExtname":return i.extname(R(I.VariableKind.FileExtname));case"fileBasename":return i.basename(R(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=i.basename(R(I.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-i.extname(d).length)}case"fileDirnameBasename":return i.basename(i.dirname(R(I.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||g}case"execInstallFolder":{const d=this._context.getAppRoot();return d||g}case"pathSeparator":return i.sep;default:try{const d=p?`${a}:${p}`:a;return this.resolveFromMap(I.VariableKind.Unknown,g,d,u,void 0)}catch{return g}}}}resolveFromMap(E,g,a,o,u){if(a&&o){const p=u===void 0?o[a]:o[u+":"+a];if(typeof p=="string")return p;throw new I.VariableError(E,(0,_.localize)(14,null,g))}return g}}y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=y}),define(Ie[97],ke([1,0,3,95]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var D;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var F;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(F=e.GroupOrientation||(e.GroupOrientation={}));var b;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(b=e.GroupLocation||(e.GroupLocation={}));var A;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function I(g){const a=g;return(0,k.isEditorInput)(a?.editor)&&(0,k.isEditorInput)(a?.replacement)}e.isEditorReplacement=I;var N;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const a=g;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=h;function E(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Ie[191],ke([1,0,3,97]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(F){const b=F;return typeof F=="number"||(0,k.isEditorGroup)(b)}e.isPreferredGroup=D}),define(Ie[192],ke([1,0,3,160]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(k.IEnvironmentService)}),define(Ie[98],ke([1,0,26,4,19]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class F{constructor(y){this.removedDueToLooping=y}}e.DeltaExtensionsResult=F;class b{static isHostExtension(y,h,E){if(h.getExtensionDescription(y))return!1;const g=E.getExtensionDescription(y);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(y){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=y,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const y of this._extensionDescriptions){if(this._extensionsMap.has(i.ExtensionIdentifier.toKey(y.identifier))){console.error("Extension `"+y.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(i.ExtensionIdentifier.toKey(y.identifier),y),this._extensionsArr.push(y),Array.isArray(y.activationEvents))for(let h of y.activationEvents)h==="onUri"&&(h=`onUri:${i.ExtensionIdentifier.toKey(y.identifier)}`),this._activationMap.has(h)||this._activationMap.set(h,[]),this._activationMap.get(h).push(y)}}set(y){this._extensionDescriptions=y,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(y,h){this._extensionDescriptions=I(this._extensionDescriptions,h),this._extensionDescriptions=this._extensionDescriptions.concat(y);const E=b._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,E.map(g=>g.identifier)),this._initialize(),this._onDidChange.fire(void 0),new F(E)}static _findLoopingExtensions(y){const h=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,p){this.addNode(u),this.addNode(p),this._arcs.has(u)?this._arcs.get(u).push(p):this._arcs.set(u,[p])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,p){const w=h.getArcs(u);for(let R=0;R<w.length;R++)if(!p.has(w[R]))return!1;return!0}getNodes(){return this._nodesArr}},E=new Map;for(const u of y){const p=i.ExtensionIdentifier.toKey(u.identifier);if(E.set(p,u),u.extensionDependencies)for(const w of u.extensionDependencies){const R=i.ExtensionIdentifier.toKey(w);h.addArc(p,R)}}const g=new Set;h.getNodes().filter(u=>h.getArcs(u).length===0).forEach(u=>g.add(u));const a=h.getNodes().filter(u=>!g.has(u));let o;do{o=!1;for(let u=0;u<a.length;u++){const p=a[u];h.hasOnlyGoodArcs(p,g)&&(a.splice(u,1),u--,g.add(p),o=!0)}}while(o);return a.map(u=>E.get(u))}containsActivationEvent(y){return this._activationMap.has(y)}containsExtension(y){return this._extensionsMap.has(i.ExtensionIdentifier.toKey(y))}getExtensionDescriptionsForActivationEvent(y){const h=this._activationMap.get(y);return h?h.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(y){const h=this._extensionsMap.get(i.ExtensionIdentifier.toKey(y));return h||void 0}getExtensionDescriptionByUUID(y){for(const h of this._extensionsArr)if(h.uuid===y)return h}getExtensionDescriptionByIdOrUUID(y,h){return this.getExtensionDescription(y)??(h?this.getExtensionDescriptionByUUID(h):void 0)}}e.ExtensionDescriptionRegistry=b;var A;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(A||(A={}));function _(N,y){const h=N.isBuiltin?0:N.isUnderDevelopment?2:1,E=y.isBuiltin?0:y.isUnderDevelopment?2:1;if(h!==E)return h-E;const g=D.posix.basename(N.extensionLocation.path),a=D.posix.basename(y.extensionLocation.path);return g<a?-1:g>a?1:0}function I(N,y){const h=new Set;return y.forEach(E=>h.add(i.ExtensionIdentifier.toKey(E))),N.filter(E=>!h.has(i.ExtensionIdentifier.toKey(E.identifier)))}}),define(Ie[74],ke([1,0,23]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var D;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var F;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(F=e.MessageType||(e.MessageType={}));function b(I){const N=i.VSBuffer.alloc(1);switch(I){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=b;function A(I,N){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=A;var _;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(_=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[57],ke([1,0,3,4,12,27,74,50,52,22,2,6,143]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class extends y.Disposable{constructor(u,p){super(),this.initData=u,this.loggerService=p,this._onDidChangeTelemetryEnabled=this._register(new k.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new k.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=N.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=p.createLogger(this.extHostTelemetryLogFile,{id:_.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(p.onDidChangeLogLevel(w=>{(0,D.isLogLevel)(w)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(u,p,w){const R=this.getTelemetryDetails(),v=new g(p,w,u,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(u),{isUsageEnabled:R.isUsageEnabled,isErrorsEnabled:R.isErrorsEnabled});return this._telemetryLoggers.set(u.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(u,p,w){this._level=u,this._telemetryIsSupported=p,this._productConfig=w??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(u){const p={};switch(p["common.extname"]=`${u.publisher}.${u.name}`,p["common.extversion"]=u.version,p["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,p["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,p["common.vscodeversion"]=this.initData.version,p["common.isnewappinstall"]=a(this.initData.telemetryInfo.firstSessionDate),p["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case b.UIKind.Web:p["common.uikind"]="web";break;case b.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,A.getRemoteName)((0,_.cleanRemoteAuthority)(this.initData.remote.authority)),p}$onDidChangeTelemetryLevel(u){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=u;const p=this.getTelemetryDetails();this._telemetryLoggers.forEach(w=>{w.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(u,p){const w=this._telemetryLoggers.get(u.value);return!w||w.ignoreUnhandledExtHostErrors?!1:(w.logError(p),!0)}};E=Ve([We(0,F.IExtHostInitDataService),We(1,D.ILoggerService)],E),e.ExtHostTelemetry=E;class g{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,p,w,R,v,t,d){this._extension=w,this._logger=R,this._inLoggingOnlyMode=v,this._commonProperties=t,this._onDidChangeEnableStates=new k.Emitter,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=p?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=p?.additionalCommonProperties,this._sender=u,this._telemetryEnablements={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(u,p){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:u,isErrorsEnabled:p},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(u){let p=u.properties??u;return p=(0,_.cleanData)(p,[]),this._additionalCommonProperties&&(p=(0,I.mixin)(p,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(p=(0,I.mixin)(p,this._commonProperties)),u.properties?u.properties=p:u=p,u}logEvent(u,p){!this._sender||(this._extension.publisher==="vscode"?u=this._extension.name+"/"+u:u=this._extension.identifier.value+"/"+u,p=this.mixInCommonPropsAndCleanData(p||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(u,p),this._logger.trace(u,p))}logUsage(u,p){!this._telemetryEnablements.isUsageEnabled||this.logEvent(u,p)}logError(u,p){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof u=="string"?this.logEvent(u,p):this._sender.sendErrorData(u,p))}get apiTelemetryLogger(){if(!this._apiObject){const u=this,p={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return u._telemetryEnablements.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u._onDidChangeEnableStates.event.bind(u)};this._apiObject=Object.freeze(p)}return this._apiObject}dispose(){this._sender?.flush&&(Promise.resolve(this._sender.flush()).then(this._sender=void 0),this._apiObject=void 0)}}e.ExtHostTelemetryLogger=g;function a(o){const u=Date.now()-new Date(o).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=a,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ie[25],ke([1,0,4,2,3,26,170]),function(ne,e,i,k,D,F,b){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new F.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class _{constructor(S){this.affinity=S,this.kind=1}equals(S){return this.kind===S.kind&&this.affinity===S.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=_;class I{constructor(S){this.affinity=S,this.kind=2}equals(S){return this.kind===S.kind&&this.affinity===S.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=I;class N{constructor(){this.kind=3,this.affinity=0}equals(S){return this.kind===S.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class y{constructor(S){this.dependency=S}}e.MissingExtensionDependency=y;var h;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(h=e.ExtensionHostKind||(e.ExtensionHostKind={}));function E(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=E;class g{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(S,n){const s=[],f=[],P=[],T=[],z=u(this._allExtensions),Q=u(S),Z=(m,L)=>m.extensionLocation.toString()===L.extensionLocation.toString()||m.isBuiltin===L.isBuiltin||m.isUserBuiltin===L.isUserBuiltin||m.isUnderDevelopment===L.isUnderDevelopment;for(const m of this._allExtensions){const L=Q.get(F.ExtensionIdentifier.toKey(m.identifier));if(!L){s.push(m.identifier),z.delete(F.ExtensionIdentifier.toKey(m.identifier));continue}if(!Z(m,L)){s.push(m.identifier),z.delete(F.ExtensionIdentifier.toKey(m.identifier));continue}}for(const m of S){const L=z.get(F.ExtensionIdentifier.toKey(m.identifier));if(!L){f.push(m);continue}if(!Z(L,m)){s.push(L.identifier),z.delete(F.ExtensionIdentifier.toKey(L.identifier));continue}}const Y=o(this._myExtensions),H=o(n);for(const m of this._myExtensions)H.has(F.ExtensionIdentifier.toKey(m))||P.push(m);for(const m of n)Y.has(F.ExtensionIdentifier.toKey(m))||T.push(m);const O={toRemove:s,toAdd:f,myToRemove:P,myToAdd:T};return this.delta(O),O}delta(S){const{toRemove:n,toAdd:s,myToRemove:f,myToAdd:P}=S,T=o(n),z=o(f);for(let Q=0;Q<this._allExtensions.length;Q++)T.has(F.ExtensionIdentifier.toKey(this._allExtensions[Q].identifier))&&(this._allExtensions.splice(Q,1),Q--);for(let Q=0;Q<this._myExtensions.length;Q++)z.has(F.ExtensionIdentifier.toKey(this._myExtensions[Q]))&&(this._myExtensions.splice(Q,1),Q--);for(const Q of s)this._allExtensions.push(Q);for(const Q of P)this._myExtensions.push(Q)}containsExtension(S){for(const n of this._myExtensions)if(F.ExtensionIdentifier.equals(n,S))return!0;return!1}}e.ExtensionHostExtensions=g;class a{constructor(S){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=F.ExtensionIdentifier.toKey,S)for(const n of S)this.add(n)}get size(){return this._map.size}add(S){return this._map.set(this._toKey(S),S),this}clear(){this._map.clear()}delete(S){return this._map.delete(this._toKey(S))}has(S){return this._map.has(this._toKey(S))}forEach(S,n){this._map.forEach(s=>S.call(n,s,s,this))}*entries(){for(const[S,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=a;function o(c){const S=new Set;for(const n of c)S.add(F.ExtensionIdentifier.toKey(n));return S}e.extensionIdentifiersArrayToSet=o;function u(c){const S=new Map;for(const n of c)S.set(F.ExtensionIdentifier.toKey(n.identifier),n);return S}function p(c,S){return c.enabledApiProposals?c.enabledApiProposals.includes(S):!1}e.isProposedApiEnabled=p;function w(c,S){if(!p(c,S))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${S}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${S}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=w;class R{constructor(S,n,s,f){this.codeLoadingTime=S,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=f}}e.ActivationTimes=R;class v{constructor(S,n){this.description=S,this.value=n}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var t;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function d(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,b.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function r(c,S){return{identifier:new F.ExtensionIdentifier((0,b.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!S,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=r;class l{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(S){return Promise.resolve(void 0)}activationEventIsDone(S){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S,n){return Promise.resolve(0)}getInspectPorts(S,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(Ie[193],ke([1,0,11,98,26,25,12,17]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class _{constructor(u,p,w,R){this.startup=u,this.codeLoadingTime=p,this.activateCallTime=w,this.activateResolvedTime=R}}_.NONE=new _(!1,-1,-1,-1),e.ExtensionActivationTimes=_;class I{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,p){return u===-1||p===-1?-1:p-u}build(){return new _(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class N{constructor(u,p,w,R,v,t){this.activationFailed=u,this.activationFailedError=p,this.activationTimes=w,this.module=R,this.exports=v,this.subscriptions=t}}e.ActivatedExtension=N;class y extends N{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=y;class h extends N{constructor(){super(!1,null,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class E extends N{constructor(u){super(!0,u,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(u,p,w,R){this._logService=R,this._registry=u,this._globalRegistry=p,this._host=w,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,p]of this._operations)p.dispose()}isActivated(u){const p=this._operations.get(D.ExtensionIdentifier.toKey(u));return Boolean(p&&p.value)}getActivatedExtension(u){const p=this._operations.get(D.ExtensionIdentifier.toKey(u));if(!p||!p.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return p.value}async activateByEvent(u,p){if(this._alreadyActivatedEvents[u])return;const w=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(w.map(R=>({id:R.identifier,reason:{startup:p,extensionId:R.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,p){const w=this._registry.getExtensionDescription(u);if(!w)throw new Error(`Extension '${u}' is not known`);return this._activateExtensions([{id:w.identifier,reason:p}])}async _activateExtensions(u){const p=u.filter(w=>!this.isActivated(w.id)).map(w=>this._handleActivationRequest(w));await Promise.all(p.map(w=>w.wait()))}_handleActivationRequest(u){if(this._operations.has(D.ExtensionIdentifier.toKey(u.id)))return this._operations.get(D.ExtensionIdentifier.toKey(u.id));if(this._isHostExtension(u.id))return this._createAndSaveOperation(u,null,[],null);const p=this._registry.getExtensionDescription(u.id);if(!p){const v=new Error(`Cannot activate unknown extension '${u.id.value}'`),t=this._createAndSaveOperation(u,null,[],new E(v));return this._host.onExtensionActivationError(u.id,v,new F.MissingExtensionDependency(u.id.value)),t}const w=[],R=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const v of R){if(this._isResolvedExtension(v))continue;const t=this._operations.get(D.ExtensionIdentifier.toKey(v));if(t){w.push(t);continue}if(this._isHostExtension(v)){w.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(v).identifier,reason:u.reason}));continue}const d=this._registry.getExtensionDescription(v);if(d){if(!d.main&&!d.browser)continue;w.push(this._handleActivationRequest({id:d.identifier,reason:u.reason}));continue}const r=p.displayName||p.identifier.value,l=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),c=this._createAndSaveOperation(u,p.displayName,[],new E(l));return this._host.onExtensionActivationError(p.identifier,l,new F.MissingExtensionDependency(v)),c}return this._createAndSaveOperation(u,p.displayName,w,null)}_createAndSaveOperation(u,p,w,R){const v=new a(u.id,p,u.reason,w,R,this._host,this._logService);return this._operations.set(D.ExtensionIdentifier.toKey(u.id),v),v}_isHostExtension(u){return k.ExtensionDescriptionRegistry.isHostExtension(u,this._registry,this._globalRegistry)}_isResolvedExtension(u){const p=this._globalRegistry.getExtensionDescription(u);return p?!p.main&&!p.browser:!1}};g=Ve([We(3,b.ILogService)],g),e.ExtensionsActivator=g;let a=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(u,p,w,R,v,t,d){this._id=u,this._displayName=p,this._reason=w,this._deps=R,this._value=v,this._host=t,this._logService=d,this._barrier=new A.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const p=this._deps[u];if(p.value&&!p.value.activationFailed){this._deps.splice(u,1),u--;continue}if(p.value&&p.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);w.detail=p.value.activationFailedError,this._value=new E(w),this._host.onExtensionActivationError(this._id,w,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const p=new Error;if(u&&u.name&&(p.name=u.name),u&&u.message?p.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:p.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(p.stack=u.stack),this._value=new E(p),this._isDisposed&&i.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,p,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};a=Ve([We(6,b.ILogService)],a)});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[7],ke([1,0,16,11,86,28,65,10,9,2,34,43,94,71,25]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g){"use strict";var a,o,u,p,w,R,v,t,d,r,l,c,S,n,s,f,P,T,z,Q,Z,Y,H;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(x){return Object.assign(x,{apply:function(){const re=arguments.length===1?[]:arguments[1];return Reflect.construct(x,re,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[re,...be]=arguments;return Reflect.construct(x,be,re.constructor)}}})}var m;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(m=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var L;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(L=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let B=R=class{static from(...M){let re=M;return new R(function(){if(re){for(const be of re)be&&typeof be.dispose=="function"&&be.dispose();re=void 0}})}constructor(M){a.set(this,void 0),Je(this,a,M,"f")}dispose(){typeof Oe(this,a,"f")=="function"&&(Oe(this,a,"f").call(this),Je(this,a,void 0,"f"))}};a=new WeakMap,B=R=Ve([O],B),e.Disposable=B;let J=v=class{static Min(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let be=1;be<M.length;be++){const qe=M[be];qe.isBefore(re)&&(re=qe)}return re}static Max(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let be=1;be<M.length;be++){const qe=M[be];qe.isAfter(re)&&(re=qe)}return re}static isPosition(M){if(!M)return!1;if(M instanceof v)return!0;const{line:re,character:be}=M;return typeof re=="number"&&typeof be=="number"}static of(M){if(M instanceof v)return M;if(this.isPosition(M))return new v(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(M,re){if(M<0)throw(0,k.illegalArgument)("line must be non-negative");if(re<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=M,this._character=re}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,re=0){if(M===null||re===null)throw(0,k.illegalArgument)();let be;return typeof M>"u"?be=0:typeof M=="number"?be=M:(be=typeof M.lineDelta=="number"?M.lineDelta:0,re=typeof M.characterDelta=="number"?M.characterDelta:0),be===0&&re===0?this:new v(this.line+be,this.character+re)}with(M,re=this.character){if(M===null||re===null)throw(0,k.illegalArgument)();let be;return typeof M>"u"?be=this.line:typeof M=="number"?be=M:(be=typeof M.line=="number"?M.line:this.line,re=typeof M.character=="number"?M.character:this.character),be===this.line&&re===this.character?this:new v(be,re)}toJSON(){return{line:this.line,character:this.character}}};J=v=Ve([O],J),e.Position=J;let me=t=class{static isRange(M){return M instanceof t?!0:M?J.isPosition(M.start)&&J.isPosition(M.end):!1}static of(M){if(M instanceof t)return M;if(this.isRange(M))return new t(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(M,re,be,qe){let Ye,ot;if(typeof M=="number"&&typeof re=="number"&&typeof be=="number"&&typeof qe=="number"?(Ye=new J(M,re),ot=new J(be,qe)):J.isPosition(M)&&J.isPosition(re)&&(Ye=J.of(M),ot=J.of(re)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this._start=Ye,this._end=ot):(this._start=ot,this._end=Ye)}contains(M){return t.isRange(M)?this.contains(M.start)&&this.contains(M.end):J.isPosition(M)?!(J.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const re=J.Max(M.start,this._start),be=J.Min(M.end,this._end);if(!re.isAfter(be))return new t(re,be)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const re=J.Min(M.start,this._start),be=J.Max(M.end,this.end);return new t(re,be)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,re=this.end){if(M===null||re===null)throw(0,k.illegalArgument)();let be;return M?J.isPosition(M)?be=M:(be=M.start||this.start,re=M.end||this.end):be=this.start,be.isEqual(this._start)&&re.isEqual(this.end)?this:new t(be,re)}toJSON(){return[this.start,this.end]}};me=t=Ve([O],me),e.Range=me;let te=d=class extends me{static isSelection(M){return M instanceof d?!0:M?me.isRange(M)&&J.isPosition(M.anchor)&&J.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(M,re,be,qe){let Ye,ot;if(typeof M=="number"&&typeof re=="number"&&typeof be=="number"&&typeof qe=="number"?(Ye=new J(M,re),ot=new J(be,qe)):J.isPosition(M)&&J.isPosition(re)&&(Ye=J.of(M),ot=J.of(re)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this._anchor=Ye,this._active=ot}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=d=Ve([O],te),e.Selection=te;class oe{constructor(M,re,be){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,k.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,k.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(re),this.connectionToken=be}}e.ResolvedAuthority=oe;class ce extends Error{static NotAvailable(M,re){return new ce(M,h.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(M){return new ce(M,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,re=h.RemoteAuthorityResolverErrorCode.Unknown,be){super(M),this._message=M,this._code=re,this._detail=be,Object.setPrototypeOf(this,ce.prototype)}}e.RemoteAuthorityResolverError=ce;var we;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(we=e.EndOfLine||(e.EndOfLine={}));var V;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=r=class{static isTextEdit(M){return M instanceof r?!0:M?me.isRange(M)&&typeof M.newText=="string":!1}static replace(M,re){return new r(M,re)}static insert(M,re){return r.replace(new me(M,M),re)}static delete(M){return r.replace(M,"")}static setEndOfLine(M){const re=new r(new me(new J(0,0),new J(0,0)),"");return re.newEol=M,re}get range(){return this._range}set range(M){if(M&&!me.isRange(M))throw(0,k.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,k.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,k.illegalArgument)("newEol");this._newEol=M}constructor(M,re){this._range=M,this._newText=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=r=Ve([O],q),e.TextEdit=q;let G=l=class{static isNotebookCellEdit(M){return M instanceof l?!0:M?Ht.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,re){return new l(M,re)}static insertCells(M,re){return new l(new Ht(M,M),re)}static deleteCells(M){return new l(M,[])}static updateCellMetadata(M,re){const be=new l(new Ht(M,M),[]);return be.newCellMetadata=re,be}static updateNotebookMetadata(M){const re=new l(new Ht(0,0),[]);return re.newNotebookMetadata=M,re}constructor(M,re){this.range=M,this.newCells=re}};G=l=Ve([O],G),e.NotebookEdit=G;class de{static isSnippetTextEdit(M){return M instanceof de?!0:M?me.isRange(M.range)&&xe.isSnippetString(M.snippet):!1}static replace(M,re){return new de(M,re)}static insert(M,re){return de.replace(new me(M,M),re)}constructor(M,re){this.range=M,this.snippet=re}}e.SnippetTextEdit=de;var Se;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Se=e.FileEditType||(e.FileEditType={}));let Le=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,re,be,qe){this._edits.push({_type:1,from:M,to:re,options:be,metadata:qe})}createFile(M,re,be){this._edits.push({_type:1,from:void 0,to:M,options:re,metadata:be})}deleteFile(M,re,be){this._edits.push({_type:1,from:M,to:void 0,options:re,metadata:be})}replaceNotebookMetadata(M,re,be){this._edits.push({_type:3,metadata:be,uri:M,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(M,re,be,qe){const Ye=re.start,ot=re.end;(Ye!==ot||be.length>0)&&this._edits.push({_type:5,uri:M,index:Ye,count:ot-Ye,cells:be,metadata:qe})}replaceNotebookCellMetadata(M,re,be,qe){this._edits.push({_type:3,metadata:qe,uri:M,edit:{editType:8,index:re,metadata:be}})}replace(M,re,be,qe){this._edits.push({_type:2,uri:M,edit:new q(re,be),metadata:qe})}insert(M,re,be,qe){this.replace(M,new me(re,re),be,qe)}delete(M,re,be){this.replace(M,re,"",be)}has(M){return this._edits.some(re=>re._type===2&&re.uri.toString()===M.toString())}set(M,re){if(re)for(const be of re){if(!be)continue;let qe,Ye;Array.isArray(be)?(qe=be[0],Ye=be[1]):qe=be,G.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(M,qe.range.start,qe.newCellMetadata,Ye):qe.newNotebookMetadata?this.replaceNotebookMetadata(M,qe.newNotebookMetadata,Ye):this.replaceNotebookCells(M,qe.range,qe.newCells,Ye):de.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:M,range:qe.range,edit:qe.snippet,metadata:Ye}):this._edits.push({_type:2,uri:M,edit:qe,metadata:Ye})}else{for(let be=0;be<this._edits.length;be++){const qe=this._edits[be];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===M.toString()&&(this._edits[be]=void 0);break}}(0,i.coalesceInPlace)(this._edits)}}get(M){const re=[];for(const be of this._edits)be._type===2&&be.uri.toString()===M.toString()&&re.push(be.edit);return re}entries(){const M=new F.ResourceMap;for(const re of this._edits)if(re._type===2){let be=M.get(re.uri);be||(be=[re.uri,[]],M.set(re.uri,be)),be[1].push(re.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Le=Ve([O],Le),e.WorkspaceEdit=Le;let xe=c=class{static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this._tabstop=1,this.value=M||""}appendText(M){return this.value+=c._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,re=this._tabstop++){if(typeof M=="function"){const be=new c;be._tabstop=this._tabstop,M(be),this._tabstop=be._tabstop,M=be.value}else M=c._escape(M);return this.value+="${",this.value+=re,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,re=this._tabstop++){const be=M.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(M,re){if(typeof re=="function"){const be=new c;be._tabstop=this._tabstop,re(be),this._tabstop=be._tabstop,re=be.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,re&&(this.value+=":",this.value+=re),this.value+="}",this}};xe=c=Ve([O],xe),e.SnippetString=xe;var Te;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var De;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(De=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let _e=S=class{static isLocation(M){return M instanceof S?!0:M?me.isRange(M.range)&&I.URI.isUri(M.uri):!1}constructor(M,re){if(this.uri=M,re)if(me.isRange(re))this.range=me.of(re);else if(J.isPosition(re))this.range=new me(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};_e=S=Ve([O],_e),e.Location=_e;let ae=class{static is(M){return M?typeof M.message=="string"&&M.location&&me.isRange(M.location.range)&&I.URI.isUri(M.location.uri):!1}constructor(M,re){this.location=M,this.message=re}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.location.range.isEqual(re.location.range)&&M.location.uri.toString()===re.location.uri.toString()}};ae=Ve([O],ae),e.DiagnosticRelatedInformation=ae;let ue=class{constructor(M,re,be=De.Error){if(!me.isRange(M))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=M,this.message=re,this.severity=be}toJSON(){return{severity:De[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.severity===re.severity&&M.code===re.code&&M.severity===re.severity&&M.source===re.source&&M.range.isEqual(re.range)&&(0,i.equals)(M.tags,re.tags)&&(0,i.equals)(M.relatedInformation,re.relatedInformation,ae.isEqual)}};ue=Ve([O],ue),e.Diagnostic=ue;let ee=class{constructor(M,re){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=re}};ee=Ve([O],ee),e.Hover=ee;var C;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(C=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let U=class{constructor(M,re=C.Text){this.range=M,this.kind=re}toJSON(){return{range:this.range,kind:C[this.kind]}}};U=Ve([O],U),e.DocumentHighlight=U;var $;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})($=e.SymbolKind||(e.SymbolKind={}));var W;(function(x){x[x.Deprecated=1]="Deprecated"})(W=e.SymbolTag||(e.SymbolTag={}));let ie=n=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,re,be,qe,Ye){this.name=M,this.kind=re,this.containerName=Ye,typeof be=="string"&&(this.containerName=be),qe instanceof _e?this.location=qe:be instanceof me&&(this.location=new _e(qe,be)),n.validate(this)}toJSON(){return{name:this.name,kind:$[this.kind],location:this.location,containerName:this.containerName}}};ie=n=Ve([O],ie),e.SymbolInformation=ie;let fe=s=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(s.validate)}constructor(M,re,be,qe,Ye){this.name=M,this.detail=re,this.kind=be,this.range=qe,this.selectionRange=Ye,this.children=[],s.validate(this)}};fe=s=Ve([O],fe),e.DocumentSymbol=fe;var ye;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(M,re){this.title=M,this.kind=re}};le=Ve([O],le),e.CodeAction=le;let ve=f=class{constructor(M){this.value=M}append(M){return new f(this.value?this.value+f.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+f.sep)}};ve.sep=".",ve=f=Ve([O],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let Ee=class{constructor(M,re){if(this.range=M,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=Ve([O],Ee),e.SelectionRange=Ee;class ze{constructor(M,re,be,qe,Ye,ot){this.kind=M,this.name=re,this.detail=be,this.uri=qe,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=ze;class He{constructor(M,re){this.fromRanges=re,this.from=M}}e.CallHierarchyIncomingCall=He;class it{constructor(M,re){this.fromRanges=re,this.to=M}}e.CallHierarchyOutgoingCall=it;var Ge;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Ge=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(M,re){this.range=M,this.command=re}get isResolved(){return!!this.command}};et=Ve([O],et),e.CodeLens=et;let nt=P=class{static isMarkdownString(M){return M instanceof P?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,re=!1){o.set(this,void 0),Je(this,o,new D.MarkdownString(M,{supportThemeIcons:re}),"f")}get value(){return Oe(this,o,"f").value}set value(M){Oe(this,o,"f").value=M}get isTrusted(){return Oe(this,o,"f").isTrusted}set isTrusted(M){Oe(this,o,"f").isTrusted=M}get supportThemeIcons(){return Oe(this,o,"f").supportThemeIcons}set supportThemeIcons(M){Oe(this,o,"f").supportThemeIcons=M}get supportHtml(){return Oe(this,o,"f").supportHtml}set supportHtml(M){Oe(this,o,"f").supportHtml=M}get baseUri(){return Oe(this,o,"f").baseUri}set baseUri(M){Oe(this,o,"f").baseUri=M}appendText(M){return Oe(this,o,"f").appendText(M),this}appendMarkdown(M){return Oe(this,o,"f").appendMarkdown(M),this}appendCodeblock(M,re){return Oe(this,o,"f").appendCodeblock(re??"",M),this}};o=new WeakMap,nt=P=Ve([O],nt),e.MarkdownString=nt;let Fe=class{constructor(M,re){this.label=M,this.documentation=re}};Fe=Ve([O],Fe),e.ParameterInformation=Fe;let rt=class{constructor(M,re){this.label=M,this.documentation=re,this.parameters=[]}};rt=Ve([O],rt),e.SignatureInformation=rt;let K=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};K=Ve([O],K),e.SignatureHelp=K;var X;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(M){this.value=M}};$e=Ve([O],$e),e.InlayHintLabelPart=$e;let Ue=class{constructor(M,re,be){this.position=M,this.label=re,this.kind=be}};Ue=Ve([O],Ue),e.InlayHint=Ue;var Xe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var tt;(function(x){x[x.Deprecated=1]="Deprecated"})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));let at=class{constructor(M,re){this.label=M,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};at=Ve([O],at),e.CompletionItem=at;let bt=class{constructor(M=[],re=!1){this.items=M,this.isIncomplete=re}};bt=Ve([O],bt),e.CompletionList=bt;let Ct=class{constructor(M,re,be){this.insertText=M,this.range=re,this.command=be}};Ct=Ve([O],Ct),e.InlineSuggestion=Ct;let Dt=class{constructor(M){this.commands=void 0,this.items=M}};Dt=Ve([O],Dt),e.InlineSuggestionList=Dt;var yt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(yt=e.ViewColumn||(e.ViewColumn={}));var lt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var jt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(jt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Wt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Wt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var It;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function M(re){switch(re){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=M}(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ut=class{constructor(M,re){if(re&&!I.URI.isUri(re))throw(0,k.illegalArgument)("target");if(!me.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.target=re}};Ut=Ve([O],Ut),e.DocumentLink=Ut;let Pt=class{constructor(M,re,be,qe){this.red=M,this.green=re,this.blue=be,this.alpha=qe}};Pt=Ve([O],Pt),e.Color=Pt;let Ke=class{constructor(M,re){if(re&&!(re instanceof Pt))throw(0,k.illegalArgument)("color");if(!me.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.color=re}};Ke=Ve([O],Ke),e.ColorInformation=Ke;let Lt=class{constructor(M){if(!M||typeof M!="string")throw(0,k.illegalArgument)("label");this.label=M}};Lt=Ve([O],Lt),e.ColorPresentation=Lt;var qt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(qt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var mt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(mt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ce{constructor(M,re,be){if(this.startIndex=M,this.length=re,this.tooltip=be,typeof M!="number"||M<0)throw(0,k.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,k.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Ce;class Pe{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=Pe;class ge{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=ge;var j;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(j=e.TerminalLocation||(e.TerminalLocation={}));class Ae{constructor(M){if(this.options=M,typeof M!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=Ae;var Me;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Me=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=T=class{static from(M){switch(M){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}constructor(M,re){if(this.label=re,typeof M!="string"||typeof re!="string")throw(0,k.illegalArgument)("name");this._id=M}get id(){return this._id}};Be.Clean=new T("clean","Clean"),Be.Build=new T("build","Build"),Be.Rebuild=new T("rebuild","Rebuild"),Be.Test=new T("test","Test"),Be=T=Ve([O],Be),e.TaskGroup=Be;function Ze(x){let M="";for(let re=0;re<x.length;re++)M+=x[re].replace(/,/g,",,")+",";return M}let ct=class{constructor(M,re,be){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=M,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=be):this._options=re)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(const re of this._args)M.push(re);return Ze(M)}};ct=Ve([O],ct),e.ProcessExecution=ct;let Tt=class{constructor(M,re,be){if(this._args=[],Array.isArray(re)){if(!M)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M,this._args=re,this._options=be}else{if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M,this._options=re}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const re of this._args)M.push(typeof re=="string"?re:re.value);return Ze(M)}};Tt=Ve([O],Tt),e.ShellExecution=Tt;var vt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(vt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class pt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=pt;let At=z=class{constructor(M,re,be,qe,Ye,ot){this.__deprecated=!1,this._definition=this.definition=M;let dt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=be,this.execution=qe,dt=Ye,this.__deprecated=!0):re===wt.Global||re===wt.Workspace?(this.target=re,this._name=this.name=be,this._source=this.source=qe,this.execution=Ye,dt=ot):(this.target=re,this._name=this.name=be,this._source=this.source=qe,this.execution=Ye,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ct?this._definition={type:z.ProcessType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:z.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:z.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:z.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const re=this._definition.type;(z.EmptyType===re||z.ProcessType===re||z.ShellType===re||z.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};At.ExtensionCallbackType="customExecution",At.ProcessType="process",At.ShellType="shell",At.EmptyType="$empty",At=z=Ve([O],At),e.Task=At;var Et;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));var ri;(function(x){function M(re){const be=re;return(0,_.isNumber)(be.value)?be.tooltip&&!(0,_.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}x.isViewBadge=M})(ri=e.ViewBadge||(e.ViewBadge={}));let ei=Q=class{static isTreeItem(M,re){const be=M;if(be.checkboxState!==void 0){(0,g.checkProposedApiEnabled)(re,"treeItemCheckbox");const qe=(0,_.isNumber)(be.checkboxState)?be.checkboxState:(0,_.isObject)(be.checkboxState)&&(0,_.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,Ye=!(0,_.isNumber)(be.checkboxState)&&(0,_.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(qe===void 0||qe!==si.Checked&&qe!==si.Unchecked||Ye!==void 0&&!(0,_.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}if(M instanceof Q)return!0;if(be.label!==void 0&&!(0,_.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,_.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,_.isString)(be.iconPath)&&!I.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,_.isString)(be.iconPath.id))){const qe=be.iconPath;if(!qe||!(0,_.isString)(qe.light)&&!I.URI.isUri(qe.light)&&!(0,_.isString)(qe.dark)&&!I.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}return be.description!==void 0&&!(0,_.isString)(be.description)&&typeof be.description!="boolean"?(console.log("INVALID tree item, invalid description",be.description),!1):be.resourceUri!==void 0&&!I.URI.isUri(be.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1):be.tooltip!==void 0&&!(0,_.isString)(be.tooltip)&&!(be.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",be.tooltip),!1):be.command!==void 0&&!be.command.command?(console.log("INVALID tree item, invalid command",be.command),!1):be.collapsibleState!==void 0&&be.collapsibleState<_t.None&&be.collapsibleState>_t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1):be.contextValue!==void 0&&!(0,_.isString)(be.contextValue)?(console.log("INVALID tree item, invalid contextValue",be.contextValue),!1):be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1):!0}constructor(M,re=_t.None){this.collapsibleState=re,I.URI.isUri(M)?this.resourceUri=M:this.label=M}};ei=Q=Ve([O],ei),e.TreeItem=ei;var _t;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M,re){this.value=M,this.id=re??(0,N.generateUuid)()}};oi=Ve([O],oi),e.DataTransferItem=oi;let Yt=class{constructor(M){u.set(this,new Map);for(const[re,be]of M??[]){const qe=Oe(this,u,"f").get(re);qe?qe.push(be):Oe(this,u,"f").set(re,[be])}}get(M){return Oe(this,u,"f").get(M)?.[0]}set(M,re){Oe(this,u,"f").set(M,[re])}forEach(M,re){for(const[be,qe]of Oe(this,u,"f"))for(const Ye of qe)M.call(re,Ye,be,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[M,re]of Oe(this,u,"f"))for(const be of re)yield[M,be]}};Yt=Ve([O],Yt),e.DataTransfer=Yt;let vi=class{constructor(M){this.insertText=M}};vi=Ve([O],vi),e.DocumentDropEdit=vi;let Rt=class{constructor(M){this.insertText=M}};Rt=Ve([O],Rt),e.DocumentPasteEdit=Rt;let xt=class{constructor(M,re){this.id=M,this.color=re}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};xt=Ve([O],xt),e.ThemeIcon=xt,xt.File=new xt("file"),xt.Folder=new xt("folder");let Ei=class{constructor(M){this.id=M}};Ei=Ve([O],Ei),e.ThemeColor=Ei;var ai;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base(M){this._base=M,this._baseUri=I.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}constructor(M,re){if(typeof M!="string"&&(!M||!I.URI.isUri(M)&&!I.URI.isUri(M.uri)))throw(0,k.illegalArgument)("base");if(typeof re!="string")throw(0,k.illegalArgument)("pattern");typeof M=="string"?this.baseUri=I.URI.file(M):I.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=Ve([O],Jt),e.RelativePattern=Jt;const ut=new WeakMap;function Ui(x,M){ut.set(x,M)}e.setBreakpointId=Ui;let Mt=class{constructor(M,re,be,qe){this.enabled=typeof M=="boolean"?M:!0,typeof re=="string"&&(this.condition=re),typeof be=="string"&&(this.hitCondition=be),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=ut.get(this)??(0,N.generateUuid)()),this._id}};Mt=Ve([O],Mt),e.Breakpoint=Mt;let Gt=class extends Mt{constructor(M,re,be,qe,Ye){if(super(re,be,qe,Ye),M===null)throw(0,k.illegalArgument)("location");this.location=M}};Gt=Ve([O],Gt),e.SourceBreakpoint=Gt;let ci=class extends Mt{constructor(M,re,be,qe,Ye){super(re,be,qe,Ye),this.functionName=M}};ci=Ve([O],ci),e.FunctionBreakpoint=ci;let bi=class extends Mt{constructor(M,re,be,qe,Ye,ot,dt){if(super(qe,Ye,ot,dt),!re)throw(0,k.illegalArgument)("dataId");this.label=M,this.dataId=re,this.canPersist=be}};bi=Ve([O],bi),e.DataBreakpoint=bi;let wi=class{constructor(M,re,be){this.command=M,this.args=re||[],this.options=be}};wi=Ve([O],wi),e.DebugAdapterExecutable=wi;let li=class{constructor(M,re){this.port=M,this.host=re}};li=Ve([O],li),e.DebugAdapterServer=li;let _i=class{constructor(M){this.path=M}};_i=Ve([O],_i),e.DebugAdapterNamedPipeServer=_i;let ui=class{constructor(M){this.implementation=M}};ui=Ve([O],ui),e.DebugAdapterInlineImplementation=ui;let Zt=class{constructor(M,re){this.range=M,this.expression=re}};Zt=Ve([O],Zt),e.EvaluatableExpression=Zt;var Bi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(M,re){this.range=M,this.text=re}};ti=Ve([O],ti),e.InlineValueText=ti;let ii=class{constructor(M,re,be=!0){this.range=M,this.variableName=re,this.caseSensitiveLookup=be}};ii=Ve([O],ii),e.InlineValueVariableLookup=ii;let Si=class{constructor(M,re){this.range=M,this.expression=re}};Si=Ve([O],Si),e.InlineValueEvaluatableExpression=Si;let yi=class{constructor(M,re){this.frameId=M,this.stoppedLocation=re}};yi=Ve([O],yi),e.InlineValueContext=yi;var ni;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(ni=e.FileChangeType||(e.FileChangeType={}));let Di=Z=class extends Error{static FileExists(M){return new Z(M,y.FileSystemProviderErrorCode.FileExists,Z.FileExists)}static FileNotFound(M){return new Z(M,y.FileSystemProviderErrorCode.FileNotFound,Z.FileNotFound)}static FileNotADirectory(M){return new Z(M,y.FileSystemProviderErrorCode.FileNotADirectory,Z.FileNotADirectory)}static FileIsADirectory(M){return new Z(M,y.FileSystemProviderErrorCode.FileIsADirectory,Z.FileIsADirectory)}static NoPermissions(M){return new Z(M,y.FileSystemProviderErrorCode.NoPermissions,Z.NoPermissions)}static Unavailable(M){return new Z(M,y.FileSystemProviderErrorCode.Unavailable,Z.Unavailable)}constructor(M,re=y.FileSystemProviderErrorCode.Unknown,be){super(I.URI.isUri(M)?M.toString(!0):M),this.code=be?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,re),Object.setPrototypeOf(this,Z.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};Di=Z=Ve([O],Di),e.FileSystemError=Di;let Ci=class{constructor(M,re,be){this.start=M,this.end=re,this.kind=be}};Ci=Ve([O],Ci),e.FoldingRange=Ci;var xi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(xi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $i;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})($i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var zi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(zi=e.CommentMode||(e.CommentMode={}));var Ii;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Ii=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(M,re=[]){this.tokenTypes=M,this.tokenModifiers=re}}e.SemanticTokensLegend=Ai;function Ri(x){return typeof x>"u"||(0,_.isStringArray)(x)}class Ne{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let re=0,be=M.tokenTypes.length;re<be;re++)this._tokenTypeStrToInt.set(M.tokenTypes[re],re);for(let re=0,be=M.tokenModifiers.length;re<be;re++)this._tokenModifierStrToInt.set(M.tokenModifiers[re],re)}}push(M,re,be,qe,Ye){if(typeof M=="number"&&typeof re=="number"&&typeof be=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(M,re,be,qe,Ye);if(me.isRange(M)&&typeof re=="string"&&Ri(be))return this._push(M,re,be);throw(0,k.illegalArgument)()}_push(M,re,be){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const qe=M.start.line,Ye=M.start.character,ot=M.end.character-M.start.character,dt=this._tokenTypeStrToInt.get(re);let Nt=0;if(be)for(const zt of be){if(!this._tokenModifierStrToInt.has(zt))throw new Error("`tokenModifier` is not in the provided legend");const Vt=this._tokenModifierStrToInt.get(zt);Nt|=1<<Vt>>>0}this._pushEncoded(qe,Ye,ot,dt,Nt)}_pushEncoded(M,re,be,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Nt=this._data.length/5|0;let zt=0,Vt=0;for(let Kt=0;Kt<Nt;Kt++){let Xt=this._data[5*Kt],Ti=this._data[5*Kt+1];Xt===0?(Xt=zt,Ti+=Vt):Xt+=zt,this._data[5*Kt]=Xt,this._data[5*Kt+1]=Ti,zt=Xt,Vt=Ti}}let ot=M,dt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=be,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=M,this._prevChar=re}static _sortAndDeltaEncode(M){const re=[],be=M.length/5|0;for(let dt=0;dt<be;dt++)re[dt]=dt;re.sort((dt,Nt)=>{const zt=M[5*dt],Vt=M[5*Nt];if(zt===Vt){const Kt=M[5*dt+1],Xt=M[5*Nt+1];return Kt-Xt}return zt-Vt});const qe=new Uint32Array(M.length);let Ye=0,ot=0;for(let dt=0;dt<be;dt++){const Nt=5*re[dt],zt=M[Nt+0],Vt=M[Nt+1],Kt=M[Nt+2],Xt=M[Nt+3],Ti=M[Nt+4],sn=zt-Ye,An=sn===0?Vt-ot:Vt,Pi=5*dt;qe[Pi+0]=sn,qe[Pi+1]=An,qe[Pi+2]=Kt,qe[Pi+3]=Xt,qe[Pi+4]=Ti,Ye=zt,ot=Vt}return qe}build(M){return this._dataIsSortedAndDeltaEncoded?new $t(new Uint32Array(this._data),M):new $t(Ne._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Ne;class $t{constructor(M,re){this.resultId=re,this.data=M}}e.SemanticTokens=$t;class Oi{constructor(M,re,be){this.start=M,this.deleteCount=re,this.data=be}}e.SemanticTokensEdit=Oi;class gt{constructor(M,re){this.resultId=re,this.edits=M}}e.SemanticTokensEdits=gt;var Wi;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Wi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new xt("arrow-left")},di=Ve([O],di),e.QuickInputButtons=di;var Li;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Li=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Hi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Hi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class Vi{static validate(M){if(typeof M.badge=="string"){let re=(0,A.nextCharLength)(M.badge,0);if(re<M.badge.length&&(re+=(0,A.nextCharLength)(M.badge,re)),M.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!xt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,re,be){this.badge=M,this.tooltip=re,this.color=be}}e.FileDecoration=Vi;let ki=class{constructor(M){this.kind=M}};ki=Ve([O],ki),e.ColorTheme=ki;var ji;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(ji=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{static isNotebookRange(M){return M instanceof Ht?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(M,re){if(M<0)throw(0,k.illegalArgument)("start must be positive");if(re<0)throw(0,k.illegalArgument)("end must be positive");M<=re?(this._start=M,this._end=re):(this._start=re,this._end=M)}with(M){let re=this._start,be=this._end;return M.start!==void 0&&(re=M.start),M.end!==void 0&&(be=M.end),re===this._start&&be===this._end?this:new Ht(re,be)}}e.NotebookRange=Ht;class fi{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(re=>fi.isNotebookCellData(re))}static isNotebookCellData(M){return!0}constructor(M,re,be,qe,Ye,ot,dt){this.kind=M,this.value=re,this.languageId=be,this.mime=qe,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class qi{constructor(M){this.cells=M}}e.NotebookData=qi;class Bt{static isNotebookCellOutputItem(M){return M instanceof Bt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const re={name:M.name,message:M.message,stack:M.stack};return Bt.json(re,"application/vnd.code.notebook.error")}static stdout(M){return Bt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Bt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,re="application/octet-stream"){return new Bt(M,re)}static text(M,re=b.Mimes.text){const be=Oe(Bt,p,"f",w).encode(String(M));return new Bt(be,re)}static json(M,re="text/x-json"){const be=JSON.stringify(M,void 0,"	");return Bt.text(be,re)}constructor(M,re){this.data=M,this.mime=re;const be=(0,b.normalizeMimeType)(re,!0);if(!be)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}p=Bt,w={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class mi{static isNotebookCellOutput(M){return M instanceof mi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,re=!1){const be=new Set,qe=new Set;for(let Ye=0;Ye<M.length;Ye++){const ot=M[Ye],dt=(0,b.normalizeMimeType)(ot.mime);if(!be.has(dt)||(0,E.isTextStreamMime)(dt)){be.add(dt);continue}qe.add(Ye),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return qe.size===0?M:M.filter((Ye,ot)=>!qe.has(ot))}constructor(M,re,be){this.items=mi.ensureUniqueMimeTypes(M,!0),typeof re=="string"?(this.id=re,this.metadata=be):(this.id=(0,N.generateUuid)(),this.metadata=re??be)}}e.NotebookCellOutput=mi;var Ki;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Gi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Gi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var se;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(se=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var he;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(he=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Re{constructor(M,re){this.text=M,this.alignment=re}}e.NotebookCellStatusBarItem=Re;var st;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var St;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(St=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(M,re=[]){this.uri=M,this.provides=(0,i.asArray)(re)}}e.NotebookRendererScript=Ot;class ln{constructor(M){this.label=M}}e.NotebookKernelSourceAction=ln;let Xi=class{constructor(M,re){this.label=M,this.timestamp=re}};Xi=Ve([O],Xi),e.TimelineItem=Xi;var un;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(M,re){this.ranges=M,this.wordPattern=re}}e.LinkedEditingRanges=fn;class mn{constructor(M,re){this._port=M,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=mn;var gn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(M=void 0,re=void 0,be=void 0){this.include=M,this.exclude=re,this.profile=be}};Fi=Ve([O],Fi),e.TestRunRequest=Fi;let Qi=class extends Fi{constructor(M=void 0,re=void 0,be=void 0,qe=!1){super(M,re,be),this.continuous=qe}};Qi=Ve([O],Qi),e.TestRunRequest2=Qi;let Yi=Y=class{static diff(M,re,be){const qe=new Y(M);return qe.expectedOutput=re,qe.actualOutput=be,qe}constructor(M){this.message=M}};Yi=Y=Ve([O],Yi),e.TestMessage=Yi;let Ji=class{constructor(M){this.id=M}};Ji=Ve([O],Ji),e.TestTag=Ji;let gi=class{constructor(M,re){this.covered=M,this.total=re}};gi=Ve([O],gi),e.CoveredCount=gi;let Zi=H=class{static fromDetails(M,re){const be=new gi(0,0),qe=new gi(0,0),Ye=new gi(0,0);for(const dt of re)if("branches"in dt){be.total+=1,be.covered+=dt.executionCount>0?1:0;for(const Nt of dt.branches)qe.total+=1,qe.covered+=Nt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ot=new H(M,be,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=re,ot}constructor(M,re,be,qe){this.uri=M,this.statementCoverage=re,this.branchCoverage=be,this.functionCoverage=qe}};Zi=H=Ve([O],Zi),e.FileCoverage=Zi;let en=class{constructor(M,re,be=[]){this.executionCount=M,this.location=re,this.branches=be}};en=Ve([O],en),e.StatementCoverage=en;let tn=class{constructor(M,re){this.executionCount=M,this.location=re}};tn=Ve([O],tn),e.BranchCoverage=tn;let nn=class{constructor(M,re){this.executionCount=M,this.location=re}};nn=Ve([O],nn),e.FunctionCoverage=nn;var vn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var En;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(En=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(M,re,be,qe,Ye,ot){this.kind=M,this.name=re,this.detail=be,this.uri=qe,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=wn;class _n{constructor(M){this.uri=M}}e.TextTabInput=_n;class Sn{constructor(M,re){this.original=M,this.modified=re}}e.TextDiffTabInput=Sn;class yn{constructor(M,re,be,qe){this.base=M,this.input1=re,this.input2=be,this.result=qe}}e.TextMergeTabInput=yn;class Dn{constructor(M,re){this.uri=M,this.viewType=re}}e.CustomEditorTabInput=Dn;class Cn{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=Cn;class In{constructor(M,re){this.uri=M,this.notebookType=re}}e.NotebookEditorTabInput=In;class kn{constructor(M,re,be){this.original=M,this.modified=re,this.notebookType=be}}e.NotebookDiffEditorTabInput=kn;class Tn{constructor(){}}e.TerminalEditorTabInput=Tn;class Pn{constructor(M,re){this.uri=M,this.inputBoxUri=re}}e.InteractiveWindowInput=Pn}),define(Ie[99],ke([1,0,49,15,10,259,131,7,16]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function N(g,a){a?I.set(g,a):I.delete(g)}e.setWordDefinitionFor=N;function y(g){return I.get(g)}class h extends F.MirrorTextModel{constructor(a,o,u,p,w,R,v,t){super(o,u,p,w),this._proxy=a,this._languageId=R,this._isDirty=v,this.notebook=t,this._isDisposed=!1}dispose(){(0,i.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,_.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===k.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(o){return o?a._getTextInRange(o):a.getText()},get eol(){return a._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(o){return a._lineAt(o)},offsetAt(o){return a._offsetAt(o)},positionAt(o){return a._positionAt(o)},validateRange(o){return a._validateRange(o)},validatePosition(o){return a._validatePosition(o)},getWordRangeAtPosition(o,u){return a._getWordRangeAtPosition(o,u)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,i.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,i.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const o=this._validateRange(a);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const u=this._eol,p=o.start.line,w=o.end.line,R=[];R.push(this._lines[p].substring(o.start.character));for(let v=p+1;v<w;v++)R.push(this._lines[v]);return R.push(this._lines[w].substring(0,o.end.character)),R.join(u)}_lineAt(a){let o;if(a instanceof A.Position?o=a.line:typeof a=="number"&&(o=a),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this._lines[o],o===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(a),u=this._lines[o.index].length;return new A.Position(o.index,Math.min(o.remainder,u))}_validateRange(a){if(!(a instanceof A.Range))throw new Error("Invalid argument");const o=this._validatePosition(a.start),u=this._validatePosition(a.end);return o===a.start&&u===a.end?a:new A.Range(o.line,o.character,u.line,u.character)}_validatePosition(a){if(!(a instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:o,character:u}=a,p=!1;if(o<0)o=0,u=0,p=!0;else if(o>=this._lines.length)o=this._lines.length-1,u=this._lines[o].length,p=!0;else{const w=this._lines[o].length;u<0?(u=0,p=!0):u>w&&(u=w,p=!0)}return p?new A.Position(o,u):a}_getWordRangeAtPosition(a,o){const u=this._validatePosition(a);if(!o)o=y(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const p=(0,b.getWordAtText)(u.character+1,(0,b.ensureValidWordDefinition)(o),this._lines[u.line],0);if(p)return new A.Range(u.line,p.startColumn-1,u.line,p.endColumn-1)}}e.ExtHostDocumentData=h;class E{constructor(a,o,u){this._line=a,this._text=o,this._isLastLine=u}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(Ie[194],ke([1,0,7,18,4]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=class{constructor(A){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let _;switch(A){case"light":_=i.ColorThemeKind.Light;break;case"hcDark":_=i.ColorThemeKind.HighContrast;break;case"hcLight":_=i.ColorThemeKind.HighContrastLight;break;default:_=i.ColorThemeKind.Dark}this._actual=new i.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};F=Ve([We(0,k.IExtHostRpcService)],F),e.ExtHostTheming=F}),define(Ie[8],ke([1,0,16,23,116,195,86,28,112,66,65,22,9,2,44,75,91,96,95,71,45,56,191,7]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ce){function Pe(j){const{selectionStartLineNumber:Ae,selectionStartColumn:Me,positionLineNumber:Qe,positionColumn:Be}=j,Ze=new d.Position(Ae-1,Me-1),ct=new d.Position(Qe-1,Be-1);return new d.Selection(Ze,ct)}Ce.to=Pe;function ge(j){const{anchor:Ae,active:Me}=j;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}Ce.from=ge})(r=e.Selection||(e.Selection={}));var l;(function(Ce){function Pe(j){if(!j)return;const{start:Ae,end:Me}=j;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}Ce.from=Pe;function ge(j){if(!j)return;const{startLineNumber:Ae,startColumn:Me,endLineNumber:Qe,endColumn:Be}=j;return new d.Range(Ae-1,Me-1,Qe-1,Be-1)}Ce.to=ge})(l=e.Range||(e.Range={}));var c;(function(Ce){function Pe(ge){switch(ge){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Ce.to=Pe})(c=e.TokenType||(e.TokenType={}));var S;(function(Ce){function Pe(j){return new d.Position(j.lineNumber-1,j.column-1)}Ce.to=Pe;function ge(j){return{lineNumber:j.line+1,column:j.character+1}}Ce.from=ge})(S=e.Position||(e.Position={}));var n;(function(Ce){function Pe(Ae,Me){return(0,i.coalesce)((0,i.asArray)(Ae).map(Qe=>ge(Qe,Me)))}Ce.from=Pe;function ge(Ae,Me){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:j(Ae.scheme,Me),pattern:pe.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function j(Ae,Me){return Me&&typeof Ae=="string"?Me.transformOutgoingScheme(Ae):Ae}})(n=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Ce){function Pe(j){switch(j){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Ce.from=Pe;function ge(j){switch(j){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Ce){function Pe(j){let Ae;return j.code&&((0,h.isString)(j.code)||(0,h.isNumber)(j.code)?Ae=String(j.code):Ae={value:String(j.code.value),target:j.code.target}),{...l.from(j.range),message:j.message,source:j.source,code:Ae,severity:T.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(P.from),tags:Array.isArray(j.tags)?(0,i.coalesce)(j.tags.map(s.from)):void 0}}Ce.from=Pe;function ge(j){const Ae=new d.Diagnostic(l.to(j),j.message,T.to(j.severity));return Ae.source=j.source,Ae.code=(0,h.isString)(j.code)?j.code:j.code?.value,Ae.relatedInformation=j.relatedInformation&&j.relatedInformation.map(P.to),Ae.tags=j.tags&&(0,i.coalesce)(j.tags.map(s.to)),Ae}Ce.to=ge})(f=e.Diagnostic||(e.Diagnostic={}));var P;(function(Ce){function Pe(j){return{...l.from(j.location.range),message:j.message,resource:j.location.uri}}Ce.from=Pe;function ge(j){return new d.DiagnosticRelatedInformation(new d.Location(j.resource,l.to(j)),j.message)}Ce.to=ge})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var T;(function(Ce){function Pe(j){switch(j){case d.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Ce.from=Pe;function ge(j){switch(j){case o.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Ce.to=ge})(T=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var z;(function(Ce){function Pe(j){return typeof j=="number"&&j>=d.ViewColumn.One?j-1:j===d.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Ce.from=Pe;function ge(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(z=e.ViewColumn||(e.ViewColumn={}));function Q(Ce){return typeof Ce.range<"u"}function Z(Ce){return Ce.length===0?!0:!!Q(Ce[0])}e.isDecorationOptionsArr=Z;var Y;(function(Ce){function Pe(Be){return Be.map(Ce.from)}Ce.fromMany=Pe;function ge(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function j(Be){let Ze;if(ge(Be)){const{language:wt,value:pt}=Be;Ze={value:"```"+wt+`
`+pt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Tt=wt=>{try{let pt=E.URI.parse(wt,!0);pt=pt.with({query:Ae(pt.query,ct)}),ct[wt]=pt}catch{}return""},vt=new _.marked.Renderer;return vt.link=Tt,vt.image=wt=>typeof wt=="string"?Tt(b.parseHrefAndDimensions(wt).href):"",(0,_.marked)(Ze.value,{renderer:vt}),Ze}Ce.from=j;function Ae(Be,Ze){if(!Be)return Be;let ct;try{ct=(0,I.parse)(Be)}catch{}if(!ct)return Be;let Tt=!1;return ct=(0,y.cloneAndChange)(ct,vt=>{if(E.URI.isUri(vt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[wt]=vt,Tt=!0,wt}else return}),Tt?JSON.stringify(ct):Be}function Me(Be){const Ze=new d.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?E.URI.from(Be.baseUri):void 0,Ze}Ce.to=Me;function Qe(Be){if(!!Be)return typeof Be=="string"?Be:Ce.from(Be)}Ce.fromStrict=Qe})(Y=e.MarkdownString||(e.MarkdownString={}));function H(Ce){return Z(Ce)?Ce.map(Pe=>({range:l.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?Y.fromMany(Pe.hoverMessage):Pe.hoverMessage?Y.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Ce.map(Pe=>({range:l.from(Pe)}))}e.fromRangeOrRangeWithMessage=H;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?E.URI.file(Ce):Ce}e.pathOrURIToURI=O;var m;(function(Ce){function Pe(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?O(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Pe})(m=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(Ce){function Pe(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?m.from(ge.before):void 0,after:ge.after?m.from(ge.after):void 0}}Ce.from=Pe})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Ce){function Pe(ge){if(typeof ge>"u")return ge;switch(ge){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Pe})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var J;(function(Ce){function Pe(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?B.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?L.from(ge.light):void 0,dark:ge.dark?L.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?m.from(ge.before):void 0,after:ge.after?m.from(ge.after):void 0}}Ce.from=Pe})(J=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var me;(function(Ce){function Pe(j){return{text:j.newText,eol:j.newEol&&nt.from(j.newEol),range:l.from(j.range)}}Ce.from=Pe;function ge(j){const Ae=new d.TextEdit(l.to(j.range),j.text);return Ae.newEol=typeof j.eol>"u"?void 0:nt.to(j.eol),Ae}Ce.to=ge})(me=e.TextEdit||(e.TextEdit={}));var te;(function(Ce){function Pe(j,Ae){const Me={edits:[]};if(j instanceof d.WorkspaceEdit){const Qe=new A.ResourceSet;for(const Be of j._allEntries())Be._type===1&&E.URI.isUri(Be.to)&&Be.from===void 0&&Qe.add(Be.to);for(const Be of j._allEntries())Be._type===1?Me.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,k.encodeBase64)(k.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Me.edits.push({resource:Be.uri,textEdit:me.from(Be.edit),versionId:Qe.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Me.edits.push({resource:Be.uri,textEdit:{range:l.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Qe.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Me.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Me.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(bt.from)}})}return Me}Ce.from=Pe;function ge(j){const Ae=new d.WorkspaceEdit;for(const Me of j.edits)Me.textEdit?Ae.replace(E.URI.revive(Me.resource),l.to(Me.textEdit.range),Me.textEdit.text):Ae.renameFile(E.URI.revive(Me.oldResource),E.URI.revive(Me.newResource),Me.options);return Ae}Ce.to=ge})(te=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(Ce){const Pe=Object.create(null);Pe[d.SymbolKind.File]=0,Pe[d.SymbolKind.Module]=1,Pe[d.SymbolKind.Namespace]=2,Pe[d.SymbolKind.Package]=3,Pe[d.SymbolKind.Class]=4,Pe[d.SymbolKind.Method]=5,Pe[d.SymbolKind.Property]=6,Pe[d.SymbolKind.Field]=7,Pe[d.SymbolKind.Constructor]=8,Pe[d.SymbolKind.Enum]=9,Pe[d.SymbolKind.Interface]=10,Pe[d.SymbolKind.Function]=11,Pe[d.SymbolKind.Variable]=12,Pe[d.SymbolKind.Constant]=13,Pe[d.SymbolKind.String]=14,Pe[d.SymbolKind.Number]=15,Pe[d.SymbolKind.Boolean]=16,Pe[d.SymbolKind.Array]=17,Pe[d.SymbolKind.Object]=18,Pe[d.SymbolKind.Key]=19,Pe[d.SymbolKind.Null]=20,Pe[d.SymbolKind.EnumMember]=21,Pe[d.SymbolKind.Struct]=22,Pe[d.SymbolKind.Event]=23,Pe[d.SymbolKind.Operator]=24,Pe[d.SymbolKind.TypeParameter]=25;function ge(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}Ce.from=ge;function j(Ae){for(const Me in Pe)if(Pe[Me]===Ae)return Number(Me);return d.SymbolKind.Property}Ce.to=j})(oe=e.SymbolKind||(e.SymbolKind={}));var ce;(function(Ce){function Pe(j){switch(j){case d.SymbolTag.Deprecated:return 1}}Ce.from=Pe;function ge(j){switch(j){case 1:return d.SymbolTag.Deprecated}}Ce.to=ge})(ce=e.SymbolTag||(e.SymbolTag={}));var we;(function(Ce){function Pe(j){return{name:j.name,kind:oe.from(j.kind),tags:j.tags&&j.tags.map(ce.from),containerName:j.containerName,location:Se.from(j.location)}}Ce.from=Pe;function ge(j){const Ae=new d.SymbolInformation(j.name,oe.to(j.kind),j.containerName,Se.to(j.location));return Ae.tags=j.tags&&j.tags.map(ce.to),Ae}Ce.to=ge})(we=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(Ce){function Pe(j){const Ae={name:j.name||"!!MISSING: name!!",detail:j.detail,range:l.from(j.range),selectionRange:l.from(j.selectionRange),kind:oe.from(j.kind),tags:j.tags?.map(ce.from)??[]};return j.children&&(Ae.children=j.children.map(Pe)),Ae}Ce.from=Pe;function ge(j){const Ae=new d.DocumentSymbol(j.name,j.detail,oe.to(j.kind),l.to(j.range),l.to(j.selectionRange));return(0,i.isNonEmptyArray)(j.tags)&&(Ae.tags=j.tags.map(ce.to)),j.children&&(Ae.children=j.children.map(ge)),Ae}Ce.to=ge})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var q;(function(Ce){function Pe(j){const Ae=new d.CallHierarchyItem(oe.to(j.kind),j.name,j.detail||"",E.URI.revive(j.uri),l.to(j.range),l.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}Ce.to=Pe;function ge(j,Ae,Me){if(Ae=Ae??j._sessionId,Me=Me??j._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,name:j.name,detail:j.detail,kind:oe.from(j.kind),uri:j.uri,range:l.from(j.range),selectionRange:l.from(j.selectionRange),tags:j.tags?.map(ce.from)}}Ce.from=ge})(q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var G;(function(Ce){function Pe(ge){return new d.CallHierarchyIncomingCall(q.to(ge.from),ge.fromRanges.map(j=>l.to(j)))}Ce.to=Pe})(G=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var de;(function(Ce){function Pe(ge){return new d.CallHierarchyOutgoingCall(q.to(ge.to),ge.fromRanges.map(j=>l.to(j)))}Ce.to=Pe})(de=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Se;(function(Ce){function Pe(j){return{range:j.range&&l.from(j.range),uri:j.uri}}Ce.from=Pe;function ge(j){return new d.Location(E.URI.revive(j.uri),l.to(j.range))}Ce.to=ge})(Se=e.location||(e.location={}));var Le;(function(Ce){function Pe(j){const Ae=j,Me=j;return{originSelectionRange:Ae.originSelectionRange?l.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Me.uri,range:l.from(Ae.targetRange?Ae.targetRange:Me.range),targetSelectionRange:Ae.targetSelectionRange?l.from(Ae.targetSelectionRange):void 0}}Ce.from=Pe;function ge(j){return{targetUri:E.URI.revive(j.uri),targetRange:l.to(j.range),targetSelectionRange:j.targetSelectionRange?l.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?l.to(j.originSelectionRange):void 0}}Ce.to=ge})(Le=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(Ce){function Pe(j){return{range:l.from(j.range),contents:Y.fromMany(j.contents)}}Ce.from=Pe;function ge(j){return new d.Hover(j.contents.map(Y.to),l.to(j.range))}Ce.to=ge})(xe=e.Hover||(e.Hover={}));var Te;(function(Ce){function Pe(j){return{range:l.from(j.range),expression:j.expression}}Ce.from=Pe;function ge(j){return new d.EvaluatableExpression(l.to(j.range),j.expression)}Ce.to=ge})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(Ce){function Pe(j){if(j instanceof d.InlineValueText)return{type:"text",range:l.from(j.range),text:j.text};if(j instanceof d.InlineValueVariableLookup)return{type:"variable",range:l.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Pe;function ge(j){switch(j.type){case"text":return{range:l.to(j.range),text:j.text};case"variable":return{range:l.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:l.to(j.range),expression:j.expression}}}Ce.to=ge})(De=e.InlineValue||(e.InlineValue={}));var _e;(function(Ce){function Pe(j){return{frameId:j.frameId,stoppedLocation:l.from(j.stoppedLocation)}}Ce.from=Pe;function ge(j){return new d.InlineValueContext(j.frameId,l.to(j.stoppedLocation))}Ce.to=ge})(_e=e.InlineValueContext||(e.InlineValueContext={}));var ae;(function(Ce){function Pe(j){return{range:l.from(j.range),kind:j.kind}}Ce.from=Pe;function ge(j){return new d.DocumentHighlight(l.to(j.range),j.kind)}Ce.to=ge})(ae=e.DocumentHighlight||(e.DocumentHighlight={}));var ue;(function(Ce){function Pe(ge){switch(ge){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Ce.to=Pe})(ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ee;(function(Ce){function Pe(ge){return{triggerKind:ue.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Pe})(ee=e.CompletionContext||(e.CompletionContext={}));var C;(function(Ce){function Pe(j){switch(j){case d.CompletionItemTag.Deprecated:return 1}}Ce.from=Pe;function ge(j){switch(j){case 1:return d.CompletionItemTag.Deprecated}}Ce.to=ge})(C=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(Ce){const Pe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ge(Me){return Pe.get(Me)??9}Ce.from=ge;const j=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Ae(Me){return j.get(Me)??d.CompletionItemKind.Property}Ce.to=Ae})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var $;(function(Ce){function Pe(ge,j){const Ae=new d.CompletionItem(ge.label);return Ae.insertText=ge.insertText,Ae.kind=U.to(ge.kind),Ae.tags=ge.tags?.map(C.to),Ae.detail=ge.detail,Ae.documentation=b.isMarkdownString(ge.documentation)?Y.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,g.Range.isIRange(ge.range)?Ae.range=l.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:l.to(ge.range.insert),replacing:l.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Ae.insertText=new d.SnippetString(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof d.Range?new d.TextEdit(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Me=>me.to(Me))),Ae.command=j&&ge.command?j.fromInternal(ge.command):void 0,Ae}Ce.to=Pe})($=e.CompletionItem||(e.CompletionItem={}));var W;(function(Ce){function Pe(j){if(typeof j.label!="string"&&!Array.isArray(j.label))throw new TypeError("Invalid label");return{label:j.label,documentation:Y.fromStrict(j.documentation)}}Ce.from=Pe;function ge(j){return{label:j.label,documentation:b.isMarkdownString(j.documentation)?Y.to(j.documentation):j.documentation}}Ce.to=ge})(W=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(Ce){function Pe(j){return{label:j.label,documentation:Y.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(W.from):[],activeParameter:j.activeParameter}}Ce.from=Pe;function ge(j){return{label:j.label,documentation:b.isMarkdownString(j.documentation)?Y.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(W.to):[],activeParameter:j.activeParameter}}Ce.to=ge})(ie=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(Ce){function Pe(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(ie.from):[]}}Ce.from=Pe;function ge(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(ie.to):[]}}Ce.to=ge})(fe=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(Ce){function Pe(ge,j){const Ae=new d.InlayHint(S.to(j.position),typeof j.label=="string"?j.label:j.label.map(le.to.bind(void 0,ge)),j.kind&&ve.to(j.kind));return Ae.textEdits=j.textEdits&&j.textEdits.map(me.to),Ae.tooltip=b.isMarkdownString(j.tooltip)?Y.to(j.tooltip):j.tooltip,Ae.paddingLeft=j.paddingLeft,Ae.paddingRight=j.paddingRight,Ae}Ce.to=Pe})(ye=e.InlayHint||(e.InlayHint={}));var le;(function(Ce){function Pe(ge,j){const Ae=new d.InlayHintLabelPart(j.label);return Ae.tooltip=b.isMarkdownString(j.tooltip)?Y.to(j.tooltip):j.tooltip,a.Command.is(j.command)&&(Ae.command=ge.fromInternal(j.command)),j.location&&(Ae.location=Se.to(j.location)),Ae}Ce.to=Pe})(le=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(Ce){function Pe(j){return j}Ce.from=Pe;function ge(j){return j}Ce.to=ge})(ve=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(Ce){function Pe(j){return{range:l.from(j.range),url:j.target,tooltip:j.tooltip}}Ce.from=Pe;function ge(j){let Ae;if(j.url)try{Ae=typeof j.url=="string"?E.URI.parse(j.url,!0):E.URI.revive(j.url)}catch{}return new d.DocumentLink(l.to(j.range),Ae)}Ce.to=ge})(Ee=e.DocumentLink||(e.DocumentLink={}));var ze;(function(Ce){function Pe(j){const Ae=new d.ColorPresentation(j.label);return j.textEdit&&(Ae.textEdit=me.to(j.textEdit)),j.additionalTextEdits&&(Ae.additionalTextEdits=j.additionalTextEdits.map(Me=>me.to(Me))),Ae}Ce.to=Pe;function ge(j){return{label:j.label,textEdit:j.textEdit?me.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ae=>me.from(Ae)):void 0}}Ce.from=ge})(ze=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(Ce){function Pe(j){return new d.Color(j[0],j[1],j[2],j[3])}Ce.to=Pe;function ge(j){return[j.red,j.green,j.blue,j.alpha]}Ce.from=ge})(He=e.Color||(e.Color={}));var it;(function(Ce){function Pe(j){return{range:l.from(j.range)}}Ce.from=Pe;function ge(j){return new d.SelectionRange(l.to(j.range))}Ce.to=ge})(it=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(Ce){function Pe(ge){switch(ge){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Ce.to=Pe})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(Ce){function Pe(j){switch(j){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Pe;function ge(j){switch(j){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}Ce.to=ge})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(Ce){function Pe(j){if(j===d.EndOfLine.CRLF)return 1;if(j===d.EndOfLine.LF)return 0}Ce.from=Pe;function ge(j){if(j===1)return d.EndOfLine.CRLF;if(j===0)return d.EndOfLine.LF}Ce.to=ge})(nt=e.EndOfLine||(e.EndOfLine={}));var Fe;(function(Ce){function Pe(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Pe})(Fe=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Ce){function Pe(j){const Ae={start:j.start+1,end:j.end+1};return j.kind&&(Ae.kind=K.from(j.kind)),Ae}Ce.from=Pe;function ge(j){const Ae={start:j.start-1,end:j.end-1};return j.kind&&(Ae.kind=K.to(j.kind)),Ae}Ce.to=ge})(rt=e.FoldingRange||(e.FoldingRange={}));var K;(function(Ce){function Pe(j){if(j)switch(j){case d.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}Ce.from=Pe;function ge(j){if(j)switch(j.value){case a.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}Ce.to=ge})(K=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(Ce){function Pe(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?l.from(ge.selection):void 0,override:typeof ge.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ce.from=Pe})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var pe;(function(Ce){function Pe(Me){return Me instanceof d.RelativePattern?Me.toJSON():typeof Me=="string"?Me:ge(Me)||j(Me)?new d.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}Ce.from=Pe;function ge(Me){const Qe=Me;return Qe?E.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function j(Me){const Qe=Me;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ae(Me){return typeof Me=="string"?Me:new d.RelativePattern(E.URI.revive(Me.baseUri),Me.pattern)}Ce.to=Ae})(pe=e.GlobPattern||(e.GlobPattern={}));var $e;(function(Ce){function Pe(ge){if(ge){if(Array.isArray(ge))return ge.map(Pe);if(typeof ge=="string")return ge;{const j=ge;return{language:j.language,scheme:j.scheme,pattern:pe.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}Ce.from=Pe})($e=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(Ce){function Pe(j){return{start:j.start,end:j.end}}Ce.from=Pe;function ge(j){return new d.NotebookRange(j.start,j.end)}Ce.to=ge})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(Ce){function Pe(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}Ce.to=Pe;function ge(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}Ce.from=ge})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Ce){function Pe(ge){if(ge===w.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(ge===w.NotebookCellExecutionState.Pending)return;if(ge===w.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var tt;(function(Ce){function Pe(j){switch(j){case d.NotebookCellKind.Markup:return w.CellKind.Markup;case d.NotebookCellKind.Code:default:return w.CellKind.Code}}Ce.from=Pe;function ge(j){switch(j){case w.CellKind.Markup:return d.NotebookCellKind.Markup;case w.CellKind.Code:default:return d.NotebookCellKind.Code}}Ce.to=ge})(tt=e.NotebookCellKind||(e.NotebookCellKind={}));var at;(function(Ce){function Pe(j){const Ae={metadata:j.metadata??Object.create(null),cells:[]};for(const Me of j.cells)d.NotebookCellData.validate(Me),Ae.cells.push(bt.from(Me));return Ae}Ce.from=Pe;function ge(j){const Ae=new d.NotebookData(j.cells.map(bt.to));return(0,h.isEmptyObject)(j.metadata)||(Ae.metadata=j.metadata),Ae}Ce.to=ge})(at=e.NotebookData||(e.NotebookData={}));var bt;(function(Ce){function Pe(j){return{cellKind:tt.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Xe.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(Dt.from):[]}}Ce.from=Pe;function ge(j){return new d.NotebookCellData(tt.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(Dt.to):void 0,j.metadata,j.internalMetadata?Xe.to(j.internalMetadata):void 0)}Ce.to=ge})(bt=e.NotebookCellData||(e.NotebookCellData={}));var Ct;(function(Ce){function Pe(j){return{mime:j.mime,valueBytes:k.VSBuffer.wrap(j.data)}}Ce.from=Pe;function ge(j){return new d.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}Ce.to=ge})(Ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Dt;(function(Ce){function Pe(j){return{outputId:j.id,items:j.items.map(Ct.from),metadata:j.metadata}}Ce.from=Pe;function ge(j){const Ae=j.items.map(Ct.to);return new d.NotebookCellOutput(Ae,j.outputId,j.metadata)}Ce.to=ge})(Dt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var yt;(function(Ce){function Pe(Ae){return j(Ae)?{include:(0,h.withNullAsUndefined)(pe.from(Ae.include)),exclude:(0,h.withNullAsUndefined)(pe.from(Ae.exclude))}:(0,h.withNullAsUndefined)(pe.from(Ae))}Ce.from=Pe;function ge(Ae){return j(Ae)?{include:pe.to(Ae.include),exclude:pe.to(Ae.exclude)}:pe.to(Ae)}Ce.to=ge;function j(Ae){const Me=Ae;return Me?!(0,h.isUndefinedOrNull)(Me.include)&&!(0,h.isUndefinedOrNull)(Me.exclude):!1}})(yt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Ce){function Pe(ge,j,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Me,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Pe})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Ce){function Pe(ge,j,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:j.toInternal(Me,Ae),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Pe})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var jt;(function(Ce){function Pe(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Pe})(jt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Wt;(function(Ce){function Pe(j){return{uri:j.uri,provides:j.provides}}Ce.from=Pe;function ge(j){return new d.NotebookRendererScript(E.URI.revive(j.uri),j.provides)}Ce.to=ge})(Wt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var It;(function(Ce){function Pe(j){return{message:Y.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location&&{range:l.from(j.location.range),uri:j.location.uri}}}Ce.from=Pe;function ge(j){const Ae=new d.TestMessage(typeof j.message=="string"?j.message:Y.to(j.message));return Ae.actualOutput=j.actual,Ae.expectedOutput=j.expected,Ae.location=j.location?Se.to(j.location):void 0,Ae}Ce.to=ge})(It=e.TestMessage||(e.TestMessage={}));var ht;(function(Ce){Ce.namespace=v.namespaceTestTag,Ce.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var kt;(function(Ce){function Pe(j){const Ae=(0,u.getPrivateApiFor)(j).controllerId;return{extId:R.TestId.fromExtHostTestItem(j,Ae).toString(),label:j.label,uri:E.URI.revive(j.uri),busy:j.busy,tags:j.tags.map(Me=>ht.namespace(Ae,Me.id)),range:g.Range.lift(l.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&Y.fromStrict(j.error)||null}}Ce.from=Pe;function ge(j){return{parent:void 0,error:void 0,id:R.TestId.fromString(j.extId).localId,label:j.label,uri:E.URI.revive(j.uri),tags:(j.tags||[]).map(Ae=>{const{tagId:Me}=ht.denamespace(Ae);return new d.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(j.range||void 0),canResolveChildren:!1,busy:j.busy,description:j.description||void 0,sortText:j.sortText||void 0}}Ce.toPlain=ge})(kt=e.TestItem||(e.TestItem={})),function(Ce){function Pe(j){return{id:j.id}}Ce.from=Pe;function ge(j){return new d.TestTag(j.id)}Ce.to=ge}(ht=e.TestTag||(e.TestTag={}));var Ut;(function(Ce){const Pe=(j,Ae)=>{const Me=[];for(const[Be,Ze]of Ae)R.TestId.compare(Ze.item.extId,Be)===2&&(Ae.delete(Be),Me.push(Ze));const Qe={...kt.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(It.to)})),children:Me.map(Be=>Pe(Be,Ae))};for(const Be of Qe.children)Be.parent=Qe;return Qe};function ge(j){const Ae=[],Me=new Map;for(const Qe of j.items){Me.set(Qe.item.extId,Qe);const Be=R.TestId.root(Qe.item.extId);j.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Qe.item.extId))&&Ae.push(Qe)}return{completedAt:j.completedAt,results:Ae.map(Qe=>Pe(Qe,Me))}}Ce.to=ge})(Ut=e.TestResults||(e.TestResults={}));var Pt;(function(Ce){function Pe(Me){return{covered:Me.covered,total:Me.covered}}function ge(Me){return"line"in Me?S.from(Me):l.from(Me)}function j(Me){return"branches"in Me?{count:Me.executionCount,location:ge(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ge(Qe.location)})):void 0}:{type:0,count:Me.executionCount,location:ge(Me.location)}}Ce.fromDetailed=j;function Ae(Me){return{uri:Me.uri,statement:Pe(Me.statementCoverage),branch:Me.branchCoverage&&Pe(Me.branchCoverage),function:Me.functionCoverage&&Pe(Me.functionCoverage),details:Me.detailedCoverage?.map(j)}}Ce.fromFile=Ae})(Pt=e.TestCoverage||(e.TestCoverage={}));var Ke;(function(Ce){function Pe(ge){switch(ge){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Ce.to=Pe})(Ke=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(Ce){function Pe(j){const Ae=new d.TypeHierarchyItem(oe.to(j.kind),j.name,j.detail||"",E.URI.revive(j.uri),l.to(j.range),l.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}Ce.to=Pe;function ge(j,Ae,Me){if(Ae=Ae??j._sessionId,Me=Me??j._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,kind:oe.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:l.from(j.range),selectionRange:l.from(j.selectionRange),tags:j.tags?.map(ce.from)}}Ce.from=ge})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var qt;(function(Ce){function Pe(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Pe})(qt=e.ViewBadge||(e.ViewBadge={}));var Ft;(function(Ce){function Pe(Me,Qe,Be){const Ze=Qe.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:E.URI.revive(Ze.uri),data:(0,F.once)(()=>Be())}}}("",Qe.id):Me===N.Mimes.uriList&&Qe.uriListData?new d.DataTransferItem(Ae(Qe.uriListData)):new d.DataTransferItem(Qe.asString)}Ce.to=Pe;async function ge(Me,Qe){const Be=await Qe.asString();if(Me===N.Mimes.uriList)return{id:Qe.id,asString:Be,fileData:void 0,uriListData:j(Be)};const Ze=Qe.asFile();return{id:Qe.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}Ce.from=ge;function j(Me){return D.UriList.split(Me).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return E.URI.parse(Qe)}catch{}return Qe})}function Ae(Me){return D.UriList.create(Me.map(Qe=>typeof Qe=="string"?Qe:E.URI.revive(Qe)))}})(Ft=e.DataTransferItem||(e.DataTransferItem={}));var mt;(function(Ce){function Pe(j,Ae){const Me=j.items.map(([Qe,Be])=>[Qe,Ft.to(Qe,Be,()=>Ae(Be.id))]);return new d.DataTransfer(Me)}Ce.toDataTransfer=Pe;async function ge(j){const Ae={items:[]},Me=[];return j.forEach((Qe,Be)=>{Me.push((async()=>{Ae.items.push([Be,await Ft.from(Be,Qe)])})())}),await Promise.all(Me),Ae}Ce.toDataTransferDTO=ge})(mt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[196],ke([1,0,2,11,7,8,162]),function(ne,e,i,k,D,F,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(I,N,y,h={timeout:1500,errors:3}){this._logService=I,this._documents=N,this._mainThreadBulkEdits=y,this._thresholds=h,this._callbacks=new b.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(N,y,h)=>{const g={dispose:this._callbacks.push([N,y,I])};return Array.isArray(h)&&h.push(g),g}}async $participateInSave(I,N){const y=i.URI.revive(I);let h=!1;const E=setTimeout(()=>h=!0,this._thresholds.timeout),g=[];try{for(const a of[...this._callbacks]){if(h)break;const o=this._documents.getDocument(y),u=await this._deliverEventAsyncAndBlameBadListeners(a,{document:o,reason:F.TextDocumentSaveReason.to(N)});g.push(u)}}finally{clearTimeout(E)}return g}_deliverEventAsyncAndBlameBadListeners([I,N,y],h){const E=this._badListeners.get(I);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,I,N,h).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const a=this._badListeners.get(I);this._badListeners.set(I,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,N,y,h){const E=[],g=Date.now(),{document:a,reason:o}=h,{version:u}=a,p=Object.freeze({document:a,reason:o,waitUntil(w){if(Object.isFrozen(E))throw(0,k.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(w))}});try{N.apply(y,[p])}catch(w){return Promise.reject(w)}return Object.freeze(E),new Promise((w,R)=>{const v=setTimeout(()=>R(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(v),w(t)}).catch(t=>{clearTimeout(v),R(t)})}).then(w=>{const R={edits:[]};for(const v of w)if(Array.isArray(v)&&v.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:d,range:r}of v)R.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:r&&F.Range.from(r),text:t,eol:d&&F.EndOfLine.from(d)}});if(R.edits.length!==0)return u===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(R):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ie[197],ke([1,0,15,2,8,7,71]),function(ne,e,i,k,D,F,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(y,h,E,g){this.start=y,this.deletedCount=h,this.deletedItems=E,this.items=g}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class _{static asModelAddData(y,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:y}}constructor(y,h,E){this.notebook=y,this._extHostDocument=h,this._cellData=E,this.handle=E.handle,this.uri=k.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return y._mime},set mime(g){y._mime=g},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(y){this._outputs=y.map(D.NotebookCellOutput.to)}setOutputItems(y,h,E){const g=E.map(D.NotebookCellOutputItem.to),a=this._outputs.find(o=>o.id===y);if(a&&(h||(a.items.length=0),a.items.push(...g),a.items.length>1&&a.items.every(o=>b.isTextStreamMime(o.mime)))){const o=new Map,u=[];a.items.forEach(p=>{let w;o.has(p.mime)?w=o.get(p.mime):(w=[],o.set(p.mime,w),u.push(p.mime)),w.push(p.data)}),a.items.length=0,u.forEach(p=>{const w=b.compressOutputItemStreams(o.get(p));a.items.push({mime:p,data:w.buffer})})}}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=_;class I{constructor(y,h,E,g,a){this._proxy=y,this._textDocumentsAndEditors=h,this._textDocuments=E,this.uri=g,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this,h={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===i.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(E){return E=y._validateIndex(E),y._cells[E].apiCell},getCells(E){return(E?y._getCells(E):y._cells).map(a=>a.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(h)}return this._notebook}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,h,E){this._versionId=y.versionId,this._isDirty=h,this.acceptDocumentPropertiesChanged({metadata:E});const g={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},a=[];for(const u of y.rawEvents)u.kind===b.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1,g.contentChanges):u.kind===b.NotebookCellsChangeType.Move?this._moveCells(u.index,u.length,u.newIdx,g.contentChanges):u.kind===b.NotebookCellsChangeType.Output?(this._setCellOutputs(u.index,u.outputs),a.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===b.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems),a.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===b.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(u.index,u.language),a.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document})):u.kind===b.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document}):u.kind===b.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===b.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(u.index,u.metadata),a.push({cell:this._cells[u.index].apiCell,metadata:this._cells[u.index].apiCell.metadata})):u.kind===b.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(u.index,u.internalMetadata),a.push({cell:this._cells[u.index].apiCell,executionSummary:this._cells[u.index].apiCell.executionSummary}));const o=new Map;for(let u=0;u<a.length;u++){const p=a[u],w=o.get(p.cell);if(w===void 0){const R=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});o.set(p.cell,R-1)}else g.cellChanges[w]={...g.cellChanges[w],...p}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let h=y.start|0,E=y.end|0;return h<0&&(h=0),E>this._cells.length&&(E=this._cells.length),y.with({start:h,end:E})}_getCells(y){y=this._validateRange(y);const h=[];for(let E=y.start;E<y.end;E++)h.push(this._cells[E]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,h,E){if(this._disposed)return;const g=[],a=[],o=[];if(y.reverse().forEach(u=>{const w=u[2].map(t=>{const d=new _(this,this._textDocumentsAndEditors,t);return h||a.push(_.asModelAddData(this.apiNotebook,t)),d}),R=new A(u[0],u[1],[],w),v=this._cells.splice(u[0],u[1],...w);for(const t of v)o.push(t.uri),R.deletedItems.push(t.apiCell);g.push(R)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:o}),E)for(const u of g)E.push(u.asApiEvent())}_moveCells(y,h,E,g){const a=this._cells.splice(y,h);this._cells.splice(E,0,...a);const o=[new A(y,h,a.map(u=>u.apiCell),[]),new A(E,0,[],a)];for(const u of o)g.push(u.asApiEvent())}_setCellOutputs(y,h){this._cells[y].setOutputs(h)}_setCellOutputItems(y,h,E,g){this._cells[y].setOutputItems(h,E,g)}_changeCellLanguage(y,h){const E=this._cells[y];E.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelLanguageChanged(E.uri,h)}_changeCellMime(y,h){const E=this._cells[y];E.apiCell.mime=h}_changeCellMetadata(y,h){this._cells[y].setMetadata(h)}_changeCellInternalMetadata(y,h){this._cells[y].setInternalMetadata(h)}getCellFromApiCell(y){return this._cells.find(h=>h.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(h=>h.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}I._handlePool=0,e.ExtHostNotebookDocument=I}),define(Ie[100],ke([1,0,11,8,7]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{constructor(A,_,I,N,y,h){this.id=A,this._proxy=_,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=y,this._visibleRanges=N,this._viewColumn=h}get apiEditor(){if(!this._editor){const A=this;this._editor={get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(_){this.selections=[_]},get selections(){return A._selections},set selections(_){if(!Array.isArray(_)||!_.every(D.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");A._selections=_,A._trySetSelections(_)},get visibleRanges(){return A._visibleRanges},revealRange(_,I){A._proxy.$tryRevealRange(A.id,k.NotebookRange.from(_),I??D.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(k.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}F.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=F}),define(Ie[198],ke([1,0,4,12,8]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let F=class{constructor(A,_){this._logService=A,this._notebooksAndEditors=_,this._onDidChangeNotebookEditorSelection=new i.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new i.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,_){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,_);const I=this._notebooksAndEditors.getEditorById(A);_.visibleRanges&&I._acceptVisibleRanges(_.visibleRanges.ranges.map(D.NotebookRange.to)),_.selections&&I._acceptSelections(_.selections.selections.map(D.NotebookRange.to)),_.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),_.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const _ in A)this._notebooksAndEditors.getEditorById(_)._acceptViewColumn(D.ViewColumn.to(A[_]))}};F=Ve([We(0,k.ILogService)],F),e.ExtHostNotebookEditors=F}),define(Ie[199],ke([1,0,8,166,141,21,64,11]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(h){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=h}async withProgress(h,E,g){const a=this._handles++,{title:o,location:u,cancellable:p}=E,w={label:(0,D.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this._proxy.$startProgress(a,{location:i.ProgressLocation.from(u),title:o,source:w,cancellable:p},h.isUnderDevelopment?void 0:h.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(a,g,!!p)}_withProgress(h,E,g){let a;g&&(a=new F.CancellationTokenSource,this._mapHandleToCancellationSource.set(h,a));const o=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),a?.dispose()};let u;try{u=E(new N(this._proxy,h),g&&a?a.token:F.CancellationToken.None)}catch(p){throw o(h),p}return u.then(p=>o(h),p=>o(h)),u}$acceptProgressCanceled(h){const E=this._mapHandleToCancellationSource.get(h);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(h))}}e.ExtHostProgress=_;function I(y,h){return y.message=h.message,typeof h.increment=="number"&&(typeof y.increment=="number"?y.increment+=h.increment:y.increment=h.increment),y}class N extends k.Progress{constructor(h,E){super(g=>this.throttledReport(g)),this._proxy=h,this._handle=E}throttledReport(h){this._proxy.$progressReport(this._handle,h)}}Ve([(0,b.throttle)(100,(y,h)=>I(y,h),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ie[101],ke([1,0,44,96,45,72,56,8,2]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(w,R,v,t)=>{let d=R;return{enumerable:!0,configurable:!1,get(){return d},set(r){if(!v(d,r)){const l=d;d=r,w.listener?.(t(r,l))}}}},N=(w,R)=>w===R,y={range:(w,R)=>w===R?!0:!w||!R?!1:w.isEqual(R),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(w,R)=>!(w.length!==R.length||w.some(v=>!R.find(t=>v.id===t.id)))},h=w=>R=>({op:4,update:w(R)}),E=(w,R)=>({range:(()=>{let v;const t=h(d=>({range:i.Range.lift(A.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return v},set(d){w.listener?.({op:6}),y.range(v,d)||(v=d,w.listener?.(t(d)))}}})(),label:I(w,R,y.label,h(v=>({label:v}))),description:I(w,void 0,y.description,h(v=>({description:v}))),sortText:I(w,void 0,y.sortText,h(v=>({sortText:v}))),canResolveChildren:I(w,!1,y.canResolveChildren,v=>({op:2,state:v})),busy:I(w,!1,y.busy,h(v=>({busy:v}))),error:I(w,void 0,y.error,h(v=>({error:A.MarkdownString.fromStrict(v)||null}))),tags:I(w,[],y.tags,(v,t)=>({op:1,new:v.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),g=w=>{const R=D.TestId.fromString(w.extId),v=new o(R.controllerId,R.localId,w.label,_.URI.revive(w.uri)||void 0);return v.range=A.Range.to(w.range||void 0),v.description=w.description||void 0,v.sortText=w.sortText||void 0,v.tags=w.tags.map(t=>A.TestTag.to({id:(0,b.denamespaceTestTag)(t).tagId})),v},a=w=>{let R;for(const v of w.tests){const t=g(v.item);(0,k.getPrivateApiFor)(t).parent=R,R=t}return R};e.toItemFromContext=a;class o{constructor(R,v,t,d){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,k.createPrivateApiFor)(this,R);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,F.createTestItemChildren)(r,k.getPrivateApiFor,o),enumerable:!0,writable:!1},...E(r,t)})}}e.TestItemImpl=o;class u extends o{constructor(R,v){super(R,R,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class p extends F.TestItemCollection{constructor(R,v,t){super({controllerId:R,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:k.getPrivateApiFor,getChildren:d=>d.children,root:new u(R,v),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(Ie[102],ke([1,0,49,11,83,8,7]),function(ne,e,i,k,D,F,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(h,E,g){const a=A._Keys.nextId();h.$registerTextEditorDecorationType(E.identifier,a,F.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:a,dispose(){h.$removeTextEditorDecorationType(a)}})}}A._Keys=new D.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=A;class _{constructor(h,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,E){this._throwIfFinalized();let g=null;if(h instanceof b.Position)g=new b.Range(h,h);else if(h instanceof b.Range)g=h;else throw new Error("Unrecognized location");this._pushEdit(g,E,!1)}insert(h,E){this._throwIfFinalized(),this._pushEdit(new b.Range(h,h),E,!0)}delete(h){this._throwIfFinalized();let E=null;if(h instanceof b.Range)E=h;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(h,E,g){const a=this._document.validateRange(h);this._collectedEdits.push({range:a,text:E,forceMoveMarkers:g})}setEndOfLine(h){if(this._throwIfFinalized(),h!==b.EndOfLine.LF&&h!==b.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=h}}class I{constructor(h,E,g,a){this._proxy=h,this._id=E,this._accept(g),this._logService=a;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(u){o._setTabSize(u)},get indentSize(){return o._indentSize},set indentSize(u){o._setIndentSize(u)},get insertSpaces(){return o._insertSpaces},set insertSpaces(u){o._setInsertSpaces(u)},get cursorStyle(){return o._cursorStyle},set cursorStyle(u){o._setCursorStyle(u)},get lineNumbers(){return o._lineNumbers},set lineNumbers(u){o._setLineNumbers(u)}}}_accept(h){this._tabSize=h.tabSize,this._indentSize=h.indentSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=F.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(h){const E=this._validateTabSize(h);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateIndentSize(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}_setIndentSize(h){const E=this._validateIndentSize(h);if(E!==null){if(typeof E=="number"){if(this._indentSize===E)return;this._indentSize=E}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:E}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}_setInsertSpaces(h){const E=this._validateInsertSpaces(h);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:F.TextEditorLineNumbersStyle.from(h)})))}assign(h){const E={};let g=!1;if(typeof h.tabSize<"u"){const a=this._validateTabSize(h.tabSize);a==="auto"?(g=!0,E.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,g=!0,E.tabSize=a)}if(typeof h.indentSize<"u"){const a=this._validateIndentSize(h.indentSize);a==="tabSize"?(g=!0,E.indentSize=a):typeof a=="number"&&this._indentSize!==a&&(this._indentSize=a,g=!0,E.indentSize=a)}if(typeof h.insertSpaces<"u"){const a=this._validateInsertSpaces(h.insertSpaces);a==="auto"?(g=!0,E.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,g=!0,E.insertSpaces=a)}typeof h.cursorStyle<"u"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,g=!0,E.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,g=!0,E.lineNumbers=F.TextEditorLineNumbersStyle.from(h.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(h,E){E.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=I;class N{constructor(h,E,g,a,o,u,p,w){this.id=h,this._proxy=E,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new I(this._proxy,this.id,u,g),this._visibleRanges=p,this._viewColumn=w;const R=this;this.value=Object.freeze({get document(){return a.value},set document(v){throw(0,k.readonly)("document")},get selection(){return R._selections&&R._selections[0]},set selection(v){if(!(v instanceof b.Selection))throw(0,k.illegalArgument)("selection");R._selections=[v],R._trySetSelection()},get selections(){return R._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof b.Selection)))throw(0,k.illegalArgument)("selections");R._selections=v,R._trySetSelection()},get visibleRanges(){return R._visibleRanges},set visibleRanges(v){throw(0,k.readonly)("visibleRanges")},get options(){return R._options.value},set options(v){R._disposed||R._options.assign(v)},get viewColumn(){return R._viewColumn},set viewColumn(v){throw(0,k.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(R._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new _(a.value,t);return v(d),R._applyEdit(d)},insertSnippet(v,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(R._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=R._selections.map(l=>F.Range.from(l));else if(t instanceof b.Position){const{lineNumber:l,column:c}=F.Position.from(t);r=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof b.Range)r=[F.Range.from(t)];else{r=[];for(const l of t)if(l instanceof b.Range)r.push(F.Range.from(l));else{const{lineNumber:c,column:S}=F.Position.from(l);r.push({startLineNumber:c,startColumn:S,endLineNumber:c,endColumn:S})}}return E.$tryInsertSnippet(h,a.value.version,v.value,r,d)},setDecorations(v,t){const d=t.length===0;d&&!R._hasDecorationsForKey.has(v.key)||(d?R._hasDecorationsForKey.delete(v.key):R._hasDecorationsForKey.add(v.key),R._runOnProxy(()=>{if(F.isDecorationOptionsArr(t))return E.$trySetDecorations(h,v.key,F.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const S=t[l];r[4*l]=S.start.line+1,r[4*l+1]=S.start.character+1,r[4*l+2]=S.end.line+1,r[4*l+3]=S.end.character+1}return E.$trySetDecorationsFast(h,v.key,r)}}))},revealRange(v,t){R._runOnProxy(()=>E.$tryRevealRange(h,F.Range.from(v),t||b.TextEditorRevealType.Default))},show(v){E.$tryShowEditor(h,F.ViewColumn.from(v))},hide(){E.$tryHideEditor(h)}})}dispose(){(0,i.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,i.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,i.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,i.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,i.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(F.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const E=h.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const g=E.edits.map(o=>o.range);g.sort((o,u)=>o.end.line===u.end.line?o.end.character===u.end.character?o.start.line===u.start.line?o.start.character-u.start.character:o.start.line-u.start.line:o.end.character-u.end.character:o.end.line-u.end.line);for(let o=0,u=g.length-1;o<u;o++){const p=g[o].end;if(g[o+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=E.edits.map(o=>({range:F.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,a,{setEndOfLine:typeof E.setEndOfLine=="number"?F.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=N}),define(Ie[200],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[201],ke([1,0,154,11,29,90,69,30,26,200,165,157]),function(ne,e,i,k,D,F,b,A,_,I,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=A.Registry.as(b.Extensions.JSONContribution);class E{constructor(v,t,d){this._messageHandler=v,this._extension=t,this._extensionPointId=d}_msg(v,t){this._messageHandler({type:v,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(v){this._msg(D.default.Error,v)}warn(v){this._msg(D.default.Warning,v)}info(v){this._msg(D.default.Info,v)}}e.ExtensionMessageCollector=E;class g{static _toSet(v){const t=new Set;for(let d=0,r=v.length;d<r;d++)t.add(_.ExtensionIdentifier.toKey(v[d].description.identifier));return t}static compute(v,t){if(!v||!v.length)return new g(t,[]);if(!t||!t.length)return new g([],v);const d=this._toSet(v),r=this._toSet(t),l=t.filter(S=>!d.has(_.ExtensionIdentifier.toKey(S.description.identifier))),c=v.filter(S=>!r.has(_.ExtensionIdentifier.toKey(S.description.identifier)));return new g(l,c)}constructor(v,t){this.added=v,this.removed=t}}e.ExtensionPointUserDelta=g;class a{constructor(v,t){this.name=v,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(v){if(this._handler!==null)throw new Error("Handler already set!");this._handler=v,this._handle()}acceptUsers(v){this._delta=g.compute(this._users,v),this._users=v,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(v){(0,k.onUnexpectedError)(v)}}}e.ExtensionPoint=a;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:_.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class p{constructor(){this._extensionPoints=new Map}registerExtensionPoint(v){if(this._extensionPoints.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const t=new a(v.extensionPoint,v.defaultExtensionKind);return this._extensionPoints.set(v.extensionPoint,t),v.activationEventsGenerator&&y.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,h.registerSchema(u,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=p;const w={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(w.ExtensionsRegistry,new p),e.ExtensionsRegistry=A.Registry.as(w.ExtensionsRegistry),h.registerSchema(u,e.schema),h.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(Ie[202],ke([1,0,151,9,22,201,42,4]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const _={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var I;(function(h){function E(g,a,o){if(!g)return;const u=k.isString(g.type)?g.type:void 0;if(!u||u.length===0){o.error(i.localize(3,null));return}const p=[];if(Array.isArray(g.required))for(const w of g.required)k.isString(w)&&p.push(w);return{extensionId:a.value,taskType:u,required:p,properties:g.properties?D.deepClone(g.properties):{},when:g.when?b.ContextKeyExpr.deserialize(g.when):void 0}}h.from=E})(I||(I={}));const N=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,E)=>{for(const g of h)g.type&&E.push(`onTaskType:${g.type}`)},jsonSchema:{description:i.localize(4,null),type:"array",items:_}});class y{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,g)=>{N.setHandler((a,o)=>{this._schema=void 0;try{for(const u of o.removed){const p=u.value;for(const w of p)this.taskTypes&&w.type&&this.taskTypes[w.type]&&delete this.taskTypes[w.type]}for(const u of o.added){const p=u.value;for(const w of p){const R=I.from(w,u.description.identifier,u.collector);R&&(this.taskTypes[R.taskType]=R)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const g of this.all()){const a={type:"object",additionalProperties:!1};g.required.length>0&&(a.required=g.required.slice(0)),g.properties!==void 0?a.properties=D.deepClone(g.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[g.taskType]},E.push(a)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new y}),define(Ie[203],ke([1,0,152,9,24,22,42,202]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new b.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var _;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(_=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function m(L){if(!L)return O.Strong;switch(L.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=m}(_=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var N;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(O){function m(L){switch(L.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=m}(N=e.RevealKind||(e.RevealKind={}));var y;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(y=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function m(L){switch(L.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=m}(y=e.RevealProblemKind||(e.RevealProblemKind={}));var h;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(h=e.PanelKind||(e.PanelKind={})),function(O){function m(L){switch(L.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=m}(h=e.PanelKind||(e.PanelKind={}));var E;(function(O){O.defaults={echo:!0,reveal:N.Always,revealProblems:y.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var g;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(g=e.RuntimeType||(e.RuntimeType={})),function(O){function m(B){switch(B.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=m;function L(B){switch(B){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=L}(g=e.RuntimeType||(e.RuntimeType={}));var a;(function(O){function m(L){return k.isString(L)?L:L.value}O.value=m})(a=e.CommandString||(e.CommandString={}));var o;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function m(B){return B===O.Clean._id||B===O.Build._id||B===O.Rebuild._id||B===O.Test._id}O.is=m;function L(B){if(B!==void 0)return k.isString(B)?m(B)?{_id:B,isDefault:!1}:void 0:B}O.from=L})(o=e.TaskGroup||(e.TaskGroup={}));var u;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var p;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function m(L){switch(L){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=m})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(O){O.parallel="parallel",O.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var R;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(R=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:R.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(m,L,B,J,me,te){this._label="",this._id=m,L&&(this._label=L),B&&(this.type=B),this.runOptions=J,this.configurationProperties=me,this._source=te}getDefinition(m){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const m={folder:this.getFolderId(),id:this._id};return JSON.stringify(m)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(m,L=!1){if(m===void 0)return!1;if(k.isString(m))return m===this._label||m===this.configurationProperties.identifier||L&&m===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===m._key}getQualifiedLabel(){const m=this.getWorkspaceFolder();return m?`${this._label} (${m.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(m){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),m&&(this._taskLoadMessages=this._taskLoadMessages.concat(m))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class d extends t{constructor(m,L,B,J,me,te,oe,ce){super(m,B,void 0,oe,ce,L),this.command={},this._source=L,this.hasDefinedMatchers=te,me&&(this.command=me)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(m=!1){if(m&&this._source.customizes!==void 0)return this._source.customizes;{let L;switch(this.command?this.command.runtime:void 0){case g.Shell:L="shell";break;case g.Process:L="process";break;case g.CustomExecution:L="customExecution";break;case void 0:L="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:L,_key:this._id,id:this._id}}}static is(m){return m instanceof d}getMapKey(){const m=this._source.config.workspaceFolder;return m?`${m.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const m=this.getFolderId();if(!m)return;let L=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(L+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:m,id:L};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(m){return new d(m._id,m._source,m._label,m.type,m.command,m.hasDefinedMatchers,m.runOptions,m.configurationProperties)}}e.CustomTask=d;class r extends t{constructor(m,L,B,J,me,te,oe){super(m,B,J,te,oe,L),this._source=L,this.configures=me}static is(m){return m instanceof r}fromObject(m){return m}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const m=this.getFolderId();if(!m)return;let L=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(L+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:m,id:L};return JSON.stringify(B)}}e.ConfiguringTask=r;class l extends t{constructor(m,L,B,J,me,te,oe,ce,we){super(m,B,J,ce,we,L),this.defines=me,this.hasDefinedMatchers=oe,this.command=te,this.icon=we.icon,this.hide=we.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(m){return m instanceof l}getMapKey(){const m=this._source.workspaceFolder;return m?`${this._source.scope.toString()}|${m.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const m={type:"contributed",scope:this._source.scope,id:this._id};return m.folder=this.getFolderId(),JSON.stringify(m)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(m){return new l(m._id,m._source,m._label,m.type,m.defines,m.command,m.hasDefinedMatchers,m.runOptions,m.configurationProperties)}}e.ContributedTask=l;class c extends t{constructor(m,L,B,J,me,te){super(m,B,J,me,te,L),this._source=L}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(m){return m instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(m){return new c(m._id,m._source,m._label,m.type,m.runOptions,m.configurationProperties)}}e.InMemoryTask=c;var S;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(S=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(S=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class s{constructor(m){this._order=new Map;for(let L=0;L<m.length;L++)this._order.set(m[L].uri.toString(),L)}compare(m,L){const B=m.getWorkspaceFolder(),J=L.getWorkspaceFolder();if(B&&J){let me=this._order.get(B.uri.toString());me=me===void 0?0:me+1;let te=this._order.get(J.uri.toString());return te=te===void 0?0:te+1,me===te?m._label.localeCompare(L._label):me-te}else return!B&&J?-1:B&&!J?1:0}}e.TaskSorter=s;var f;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(O){O.SingleRun="singleRun",O.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var T;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(T=e.TaskRunSource||(e.TaskRunSource={}));var z;(function(O){function m(L,B,J,me){if(B){const te={kind:L,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:J,__task:B};return L==="start"?te.resolvedVariables=me:L==="processStarted"?te.processId=me:L==="processEnded"&&(te.exitCode=me),Object.freeze(te)}else return Object.freeze({kind:"changed"})}O.create=m})(z=e.TaskEvent||(e.TaskEvent={}));var Q;(function(O){function m(B){const J=Object.keys(B).sort();let me="";for(const te of J){let oe=B[te];oe instanceof Object?oe=m(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),me+=te+","+oe+","}return me}function L(B){const me={_key:m(B),type:B.taskType};return Object.assign(me,B),me}O.create=L})(Q=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var Z;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(Z=e.TaskSettingId||(e.TaskSettingId={}));var Y;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(Y=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var H;(function(O){function m(L,B){const J=A.TaskDefinitionRegistry.get(L.type);if(J===void 0){const ce=F.deepClone(L);return delete ce._key,Q.create(ce)}const me=Object.create(null);me.type=J.taskType;const te=new Set;J.required.forEach(ce=>te.add(ce));const oe=J.properties;for(const ce of Object.keys(oe)){const we=L[ce];if(we!=null)me[ce]=we;else if(te.has(ce)){const V=oe[ce];if(V.default!==void 0)me[ce]=F.deepClone(V.default);else switch(V.type){case"boolean":me[ce]=!1;break;case"number":case"integer":me[ce]=0;break;case"string":me[ce]="";break;default:B.error(i.localize(2,null,JSON.stringify(L,void 0,0),ce));return}}}return Q.create(me)}O.createTaskIdentifier=m})(H=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[204],ke([1,0,11]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((b,A)=>{this._actualOk=b,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(b){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=b,this._actual&&this._actualOk(b))}resolveErr(b){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=b,this._actual?this._actualErr(b):(0,i.onUnexpectedError)(b))}then(b,A){return this._ensureActual().then(b,A)}catch(b){return this._ensureActual().then(void 0,b)}finally(b){return this._ensureActual().finally(b)}}e.LazyPromise=k;class D extends k{constructor(){super(),this._hasErr=!0,this._err=new i.CancellationError}}e.CanceledLazyPromise=D}),define(Ie[46],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(_){this._proxyIdentifierBrand=void 0,this.sid=_,this.nid=++i.count}}i.count=0,e.ProxyIdentifier=i;const k=[];function D(A){const _=new i(A);return k[_.nid]=_,_}e.createProxyIdentifier=D;function F(A){return k[A].sid}e.getStringIdentifierForProxy=F;class b{constructor(_){this.value=_}}e.SerializableObjectWithBuffers=b}),define(Ie[5],ke([1,0,46]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var F;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(F=e.TabModelOperationKind||(e.TabModelOperationKind={}));var b;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(b=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var _;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(_=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class y{static mixin(o){return o._id=y._n++,o}}y._n=0,e.IdObject=y;var h;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,i.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,i.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[76],ke([1,0,3,12,5,18]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let b=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(D.MainContext.MainThreadTelemetry)}report(_,I,N){const y=this.getUsageKey(_,I);this._reportedUsages.has(y)||(this._reportedUsages.add(y),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};b=Ve([We(0,F.IExtHostRpcService),We(1,k.ILogService)],b),e.ExtHostApiDeprecationService=b,e.NullApiDeprecationService=Object.freeze(new class{report(A,_,I){}})}),define(Ie[205],ke([1,0,4,5,7,26]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class b{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,I,N,y={}){const h=F.ExtensionIdentifier.toKey(_.identifier),E=this._inFlightRequests.get(h)||[],g=[...N].sort().join(" ");let a=E.find(o=>o.providerId===I&&o.scopes===g);if(a)return a.result;{const o=this._getSession(_,h,I,N,y);a={providerId:I,scopes:g,result:o},E.push(a),this._inFlightRequests.set(h,E);try{await o}finally{const u=E.findIndex(p=>p.providerId===I&&p.scopes===g);u>-1&&(E.splice(u),this._inFlightRequests.set(h,E))}return o}}async _getSession(_,I,N,y,h={}){await this._proxy.$ensureProvider(N);const E=_.displayName||_.name;return this._proxy.$getSession(N,y,I,E,h)}async removeSession(_,I){const N=this._authenticationProviders.get(_);return N?N.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,N,y){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:N,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===_)||this._providers.push({id:_,label:I});const h=N.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(_,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,I,y?.supportsMultipleAccounts??!1),new D.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(_);const E=this._providers.findIndex(g=>g.id===_);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const N=this._authenticationProviders.get(_);if(N)return Promise.resolve(N.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const N=this._authenticationProviders.get(_);if(N)return Promise.resolve(N.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const N=this._authenticationProviders.get(_);if(N)return Promise.resolve(N.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=b}),define(Ie[206],ke([1,0,5,18,8]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=class{constructor(A,_){this._proxy=A.getProxy(i.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:I=>_.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,_,I){const N=D.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(N,void 0,I?.isRefactoring??!1)}};F=Ve([We(0,k.IExtHostRpcService)],F),e.ExtHostBulkEdits=F}),define(Ie[207],ke([1,0,5]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(F){const b=F.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return b.$readText()},writeText(A){return b.$writeText(A)}})}}e.ExtHostClipboard=k});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[37],ke([1,0,9,7,8,22,5,16,12,66,44,260,2,6,3,18,101,23,46,39,77,52,57]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v,t){"use strict";var d,r,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(T,z,Q){d.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,r.set(this,void 0),l.set(this,void 0),Je(this,d,T.getProxy(b.MainContext.MainThreadCommands),"f"),this._logService=z,Je(this,l,Q,"f"),Je(this,r,T.getProxy(b.MainContext.MainThreadTelemetry),"f"),this.converter=new S(this,Z=>{const Y=this._apiCommands.get(Z);return Y?.result===s.Void?Y:void 0},z),this._argumentProcessors=[{processArgument(Z){return(0,I.revive)(Z)}},{processArgument(Z){return(0,F.cloneAndChange)(Z,function(Y){if(N.Range.isIRange(Y))return D.Range.to(Y);if(y.Position.isIPosition(Y))return D.Position.to(Y);if(N.Range.isIRange(Y.range)&&h.URI.isUri(Y.uri))return D.location.to(Y);if(Y instanceof u.VSBuffer)return Y.buffer.buffer;if(!Array.isArray(Y))return Y})}}]}registerArgumentProcessor(T){this._argumentProcessors.push(T)}registerApiCommand(T){const z=this.registerCommand(!1,T.id,async(...Q)=>{const Z=T.args.map((H,O)=>{if(!H.validate(Q[O]))throw new Error(`Invalid argument '${H.name}' when running '${T.id}', received: ${Q[O]}`);return H.convert(Q[O])}),Y=await this.executeCommand(T.internalId,...Z);return T.result.convert(Y,Q,this.converter)},void 0,{description:T.description,args:T.args,returns:T.result.description});return this._apiCommands.set(T.id,T),new k.Disposable(()=>{z.dispose(),this._apiCommands.delete(T.id)})}registerCommand(T,z,Q,Z,Y,H){if(this._logService.trace("ExtHostCommands#registerCommand",z),!z.trim().length)throw new Error("invalid id");if(this._commands.has(z))throw new Error(`command '${z}' already exists`);return this._commands.set(z,{callback:Q,thisArg:Z,description:Y,extension:H}),T&&Oe(this,d,"f").$registerCommand(z),new k.Disposable(()=>{this._commands.delete(z)&&T&&Oe(this,d,"f").$unregisterCommand(z)})}executeCommand(T,...z){return this._logService.trace("ExtHostCommands#executeCommand",T),this._doExecuteCommand(T,z,!0)}async _doExecuteCommand(T,z,Q){if(this._commands.has(T))return Oe(this,d,"f").$fireCommandActivationEvent(T),this._executeContributedCommand(T,z,!1);{let Z=!1;const Y=(0,F.cloneAndChange)(z,function(H){if(H instanceof k.Position)return D.Position.from(H);if(H instanceof k.Range)return D.Range.from(H);if(H instanceof k.Location)return D.location.from(H);if(k.NotebookRange.isNotebookRange(H))return D.NotebookRange.from(H);if(H instanceof ArrayBuffer)return Z=!0,u.VSBuffer.wrap(new Uint8Array(H));if(H instanceof Uint8Array)return Z=!0,u.VSBuffer.wrap(H);if(H instanceof u.VSBuffer)return Z=!0,H;if(!Array.isArray(H))return H});try{const H=await Oe(this,d,"f").$executeCommand(T,Z?new p.SerializableObjectWithBuffers(Y):Y,Q);return(0,I.revive)(H)}catch(H){if(H instanceof Error&&H.message==="$executeCommand:retry")return this._doExecuteCommand(T,z,!1);throw H}}}async _executeContributedCommand(T,z,Q){const Z=this._commands.get(T);if(!Z)throw new Error("Unknown command");const{callback:Y,thisArg:H,description:O}=Z;if(O)for(let L=0;L<O.args.length;L++)try{(0,i.validateConstraint)(z[L],O.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${T}' failed. Illegal argument '${O.args[L].name}' - ${O.args[L].description}`)}const m=R.StopWatch.create();try{return await Y.apply(H,z)}catch(L){if(T===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...z);B&&(T=B.command)}if(this._logService.error(L,T,Z.extension?.identifier),!Q)throw L;if(Z.extension?.identifier){const B=Oe(this,l,"f").onExtensionError(Z.extension.identifier,L);this._logService.trace("forwarded error to extension?",B,Z.extension?.identifier)}throw new class extends Error{constructor(){super((0,w.toErrorMessage)(L)),this.id=T,this.source=Z.extension?.displayName??Z.extension?.name}}}finally{this._reportTelemetry(Z,T,m.elapsed())}}_reportTelemetry(T,z,Q){!T.extension||Oe(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:T.extension.identifier.value,id:new v.TelemetryTrustedValue(z),duration:Q})}$executeContributedCommand(T,...z){this._logService.trace("ExtHostCommands#$executeContributedCommand",T);const Q=this._commands.get(T);return Q?(z=z.map(Z=>this._argumentProcessors.reduce((Y,H)=>H.processArgument(Y,Q.extension?.identifier),Z)),this._executeContributedCommand(T,z,!0)):Promise.reject(new Error(`Contributed command '${T}' does not exist.`))}getCommands(T=!1){return this._logService.trace("ExtHostCommands#getCommands",T),Oe(this,d,"f").$getCommands().then(z=>(T&&(z=z.filter(Q=>Q[0]!=="_")),z))}$getContributedCommandHandlerDescriptions(){const T=Object.create(null);for(const[z,Q]of this._commands){const{description:Z}=Q;Z&&(T[z]=Z)}return Promise.resolve(T)}};d=new WeakMap,r=new WeakMap,l=new WeakMap,c=Ve([We(0,a.IExtHostRpcService),We(1,_.ILogService),We(2,t.IExtHostTelemetry)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class S{constructor(T,z,Q){this._commands=T,this._lookupApiCommand=z,this._logService=Q,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(T,z){if(!T)return;const Q={$ident:void 0,id:T.command,title:T.title,tooltip:T.tooltip};if(!T.command)return Q;const Z=this._lookupApiCommand(T.command);if(Z)Q.id=Z.internalId,Q.arguments=Z.args.map((Y,H)=>Y.convert(T.arguments&&T.arguments[H]));else if((0,A.isNonEmptyArray)(T.arguments)){const Y=`${T.command}/${++this._cachIdPool}`;this._cache.set(Y,T),z.add((0,E.toDisposable)(()=>{this._cache.delete(Y),this._logService.trace("CommandsConverter#DISPOSE",Y)})),Q.$ident=Y,Q.id=this.delegatingCommandId,Q.arguments=[Y],this._logService.trace("CommandsConverter#CREATE",T.command,Y)}return Q}fromInternal(T){return typeof T.$ident=="string"?this._cache.get(T.$ident):{command:T.id,title:T.title,arguments:T.arguments}}getActualCommand(...T){return this._cache.get(T[0])}_executeConvertedCommand(...T){const z=this.getActualCommand(...T);return this._logService.trace("CommandsConverter#EXECUTE",T[0],z?z.command:"MISSING"),z?this._commands.executeCommand(z.command,...z.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${T[0]}`)}}e.CommandsConverter=S;class n{constructor(T,z,Q,Z){this.name=T,this.description=z,this.validate=Q,this.convert=Z}optional(){return new n(this.name,`(optional) ${this.description}`,T=>T==null||this.validate(T),T=>T===void 0?void 0:T===null?null:this.convert(T))}with(T,z){return new n(T??this.name,z??this.description,this.validate,this.convert)}}n.Uri=new n("uri","Uri of a text document",P=>h.URI.isUri(P),P=>P),n.Position=new n("position","A position in a text document",P=>k.Position.isPosition(P),D.Position.from),n.Range=new n("range","A range in a text document",P=>k.Range.isRange(P),D.Range.from),n.Selection=new n("selection","A selection in a text document",P=>k.Selection.isSelection(P),D.Selection.from),n.Number=new n("number","",P=>typeof P=="number",P=>P),n.String=new n("string","",P=>typeof P=="string",P=>P),n.CallHierarchyItem=new n("item","A call hierarchy item",P=>P instanceof k.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",P=>P instanceof k.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",P=>P instanceof o.TestItemImpl,D.TestItem.from),e.ApiCommandArgument=n;class s{constructor(T,z){this.description=T,this.convert=z}}s.Void=new s("no result",P=>P),e.ApiCommandResult=s;class f{constructor(T,z,Q,Z,Y){this.id=T,this.internalId=z,this.description=Q,this.args=Z,this.result=Y}}e.ApiCommand=f}),define(Ie[208],ke([1,0,2,8,7,75,37,16,88,92,15]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new b.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new b.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,o)=>{if((0,A.isFalsyOrEmpty)(a))return;class u extends D.SymbolInformation{static to(w){const R=new u(w.name,k.SymbolKind.to(w.kind),w.containerName||"",new D.Location(o[0],k.Range.to(w.range)));return R.detail=w.detail,R.range=R.location.range,R.selectionRange=k.Range.to(w.selectionRange),R.children=w.children?w.children.map(u.to):[],R}}return a.map(u.to)})),new b.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.ApiCommandArgument.Uri,new b.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new b.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new b.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range,new b.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new b.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new b.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,new b.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new b.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new b.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new b.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new b.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new b.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new b.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new b.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(k.location.to))),new b.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new b.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.ApiCommandArgument.Uri,new b.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(o=>D.Position.isPosition(o)),a=>a.map(k.Position.from))],new b.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(o=>{let u;for(const p of o.reverse())u=new D.SelectionRange(k.Range.to(p),u);return u}))),new b.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.ApiCommandArgument.String.with("query","Search string")],new b.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(k.WorkspaceSymbol.to))),new b.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(k.CallHierarchyItem.to))),new b.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.ApiCommandArgument.CallHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(k.CallHierarchyIncomingCall.to))),new b.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.ApiCommandArgument.CallHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(k.CallHierarchyOutgoingCall.to))),new b.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:k.Range.to(a.range),placeholder:a.text}})),new b.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,b.ApiCommandArgument.String.with("newName","The new symbol name")],new b.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return k.WorkspaceEdit.to(a)}})),new b.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(k.DocumentLink.to))),new b.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new b.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,_.decodeSemanticTokensDto)(a);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new b.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range.optional()],new b.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new b.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range],new b.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,_.decodeSemanticTokensDto)(a);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new b.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,b.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,o,u)=>{if(!a)return new D.CompletionList([]);const p=a.suggestions.map(w=>k.CompletionItem.to(w,u));return new D.CompletionList(p,a.incomplete)})),new b.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position,b.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return k.SignatureHelp.to(a)})),new b.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,o,u)=>E(p=>new D.CodeLens(k.Range.to(p.range),p.command&&u.fromInternal(p.command)))(a))),new b.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.ApiCommandArgument.Uri,new b.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>D.Range.isRange(a),a=>D.Selection.isSelection(a)?k.Selection.from(a):k.Range.from(a)),b.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),b.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,o,u)=>E(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(p.command)}else{const w=new D.CodeAction(p.title,p.kind?new D.CodeActionKind(p.kind):void 0);return p.edit&&(w.edit=k.WorkspaceEdit.to(p.edit)),p.command&&(w.command=u.fromInternal(p.command)),w.isPreferred=p.isPreferred,w}})(a))),new b.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(o=>new D.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new b.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.ApiCommandArgument("color","The color to show and insert",a=>a instanceof D.Color,k.Color.from),new b.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:k.Range.from(a.range)}))],new b.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(k.ColorPresentation.to):[])),new b.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range],new b.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,o,u)=>a.map(k.InlayHint.to.bind(void 0,u)))),new b.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.ApiCommandArgument.Uri],new b.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(a,o)=>{if(a)return a.map(k.FoldingRange.to)})),new b.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new b.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Range],new b.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(k.InlineValue.to))),new b.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>i.URI.isUri(a)||typeof a=="string"&&(0,I.matchesSomeScheme)(a,N.Schemas.http,N.Schemas.https),a=>a),new b.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[k.ViewColumn.from(a),void 0]:[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)])).optional(),b.ApiCommandArgument.String.with("label","").optional()],b.ApiCommandResult.Void),new b.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.ApiCommandArgument.Uri.with("resource","Resource to open"),b.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new b.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[k.ViewColumn.from(a),void 0]:[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)])).optional()],b.ApiCommandResult.Void),new b.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),b.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),b.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new b.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)]).optional()],b.ApiCommandResult.Void),new b.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.ApiCommandArgument.Uri,b.ApiCommandArgument.Position],new b.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(k.TypeHierarchyItem.to))),new b.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.ApiCommandArgument.TypeHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(k.TypeHierarchyItem.to))),new b.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.ApiCommandArgument.TypeHierarchyItem],new b.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(k.TypeHierarchyItem.to))),new b.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.ApiCommandArgument.TestItem],b.ApiCommandResult.Void),new b.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.ApiCommandResult.Void),new b.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.ApiCommandArgument.String.with("name","The context key name"),new b.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],b.ApiCommandResult.Void)];class h{static register(o){y.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=h;function E(a){return o=>{if(Array.isArray(o))return o.map(a)}}function g(a){if(!Array.isArray(a))return;const o=[];for(const u of a)F.isLocationLink(u)?o.push(k.DefinitionLink.to(u)):o.push(k.location.to(u));return o}}),define(Ie[209],ke([1,0,17,64,4,6,2,75,26,8,7,5]),function(ne,e,i,k,D,F,b,A,_,I,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function h(E,g,a){const o=E.getProxy(y.MainContext.MainThreadComments);class u{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const S=this._commentControllers.get(c.handle);return S?S.value:c}else if(c&&c.$mid===7){const S=this._commentControllers.get(c.commentControlHandle);if(!S)return c;const n=S.getCommentThread(c.commentThreadHandle);return n?n.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const S=this._commentControllers.get(c.thread.commentControlHandle);if(!S)return c;const n=S.getCommentThread(c.thread.commentThreadHandle);return n?c.$mid===8?n.value:{thread:n.value,text:c.text}:c}else if(c&&c.$mid===10){const S=this._commentControllers.get(c.thread.commentControlHandle);if(!S)return c;const n=S.getCommentThread(c.thread.commentThreadHandle);if(!n)return c;const s=c.commentUniqueId,f=n.getCommentByUniqueId(s);return f||c}else if(c&&c.$mid===11){const S=this._commentControllers.get(c.thread.commentControlHandle);if(!S)return c;const n=S.getCommentThread(c.thread.commentThreadHandle);if(!n)return c;const s=c.text,f=c.commentUniqueId,P=n.getCommentByUniqueId(f);return P?(typeof P.body=="string"?P.body=s:P.body=new N.MarkdownString(s),P):c}return c}})}createCommentController(c,S,n){const s=u.handlePool++,f=new w(c,s,S,n);this._commentControllers.set(f.handle,f);const P=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(c.identifier))||[];return P.push(f),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(c.identifier),P),f.value}$createCommentThreadTemplate(c,S,n){const s=this._commentControllers.get(c);!s||s.$createCommentThreadTemplate(S,n)}async $updateCommentThreadTemplate(c,S,n){const s=this._commentControllers.get(c);!s||s.$updateCommentThreadTemplate(S,n)}$deleteCommentThread(c,S){this._commentControllers.get(c)?.$deleteCommentThread(S)}$provideCommentingRanges(c,S,n){const s=this._commentControllers.get(c);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const f=a.getDocument(b.URI.revive(S));return(0,i.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(f,n)).then(P=>P?P.map(T=>I.Range.from(T)):void 0)}$toggleReaction(c,S,n,s,f){const P=this._commentControllers.get(c);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const T=P.getCommentThread(S);if(T){const z=T.getCommentByUniqueId(s.uniqueIdInThread);if(P!==void 0&&z&&P.reactionHandler)return P.reactionHandler(z,t(f))}return Promise.resolve(void 0)})}dispose(){}}u.handlePool=0;class p{set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(c){this._state=c,this.modifications.state=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(c,S,n,s,f,P,T,z){this._commentControllerHandle=S,this._id=n,this._uri=s,this._range=f,this._comments=P,this.extensionDescription=T,this._isTemplate=z,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputDisposables.value=new F.DisposableStore,this._id===void 0&&(this._id=`${c}.${this.handle}`),o.$createCommentThread(S,this.handle,this._id,this._uri,I.Range.from(this._range),T.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(S,this.handle)}});const Q=this;this.value={get uri(){return Q.uri},get range(){return Q.range},set range(Z){Q.range=Z},get comments(){return Q.comments},set comments(Z){Q.comments=Z},get collapsibleState(){return Q.collapsibleState},set collapsibleState(Z){Q.collapsibleState=Z},get canReply(){return Q.canReply},set canReply(Z){Q.canReply=Z},get contextValue(){return Q.contextValue},set contextValue(Z){Q.contextValue=Z},get label(){return Q.label},set label(Z){Q.label=Z},get state(){return Q.state},set state(Z){Q.state=Z},dispose:()=>{Q.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new F.DisposableStore);const c=n=>Object.prototype.hasOwnProperty.call(this.modifications,n),S={};c("range")&&(S.range=I.Range.from(this._range)),c("label")&&(S.label=this.label),c("contextValue")&&(S.contextValue=this.contextValue??null),c("comments")&&(S.comments=this._comments.map(n=>R(this,n,this._commentsMap))),c("collapsibleState")&&(S.collapseState=d(this._collapseState)),c("canReply")&&(S.canReply=this.canReply),c("state")&&(S.state=r(this._state)),c("isTemplate")&&(S.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,S)}getCommentByUniqueId(c){for(const S of this._commentsMap){const n=S[0],s=S[1];if(c===s)return n}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose())}}p._handlePool=0,Ve([(0,k.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class w{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(c){this._commentingRangeProvider=c,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(c,S,n,s){this._extension=c,this._handle=S,this._id=n,this._label=s,this._threads=new Map,o.$registerCommentController(this.handle,n,s);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(P){f.options=P},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(P){f.commentingRangeProvider=P},get reactionHandler(){return f.reactionHandler},set reactionHandler(P){f.reactionHandler=P},createCommentThread(P,T,z){return f.createCommentThread(P,T,z).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(c,S,n,s){if(typeof c=="string"){const f=new p(this.id,this.handle,c,S,n,s,this._extension,!1);return this._threads.set(f.handle,f),f}else{const f=new p(this.id,this.handle,void 0,c,S,n,this._extension,!1);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(c,S){const n=new p(this.id,this.handle,void 0,b.URI.revive(c),I.Range.to(S),[],this._extension,!0);return n.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(n.handle,n),n}$updateCommentThreadTemplate(c,S){const n=this._threads.get(c);n&&(n.range=I.Range.to(S))}$deleteCommentThread(c){this._threads.get(c)?.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._localDisposables.forEach(c=>c.dispose())}}function R(l,c,S){let n=S.get(c);n||(n=++l.commentHandle,S.set(c,n));const s=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:n,body:typeof c.body=="string"?c.body:I.MarkdownString.from(c.body),userName:c.author.name,userIconPath:s,label:c.label,commentReactions:c.reactions?c.reactions.map(f=>v(f)):void 0,timestamp:c.timestamp?.toJSON()}}function v(l){return{label:l.label,iconPath:l.iconPath?I.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function t(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?b.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case N.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function r(l){if(l!==void 0)switch(l){case N.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new u}e.createExtHostComments=h}),define(Ie[210],ke([1,0,22,5,27,18]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let b=class{constructor(N,y){this._mainThreadConsole=N.getProxy(k.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(N,y){const h=this,E=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){h._handleConsoleCall(N,y,E,arguments)}})}_handleConsoleCall(N,y,h,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:_(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(N,h,E)}};b=Ve([We(0,F.IExtHostRpcService),We(1,D.IExtHostInitDataService)],b),e.AbstractExtHostConsoleForwarder=b;const A=1e5;function _(I,N){const y=[];if(I.length)for(let h=0;h<I.length;h++){let E=I[h];if(typeof E>"u")E="undefined";else if(E instanceof Error){const g=E;g.stack?E=g.stack:E=g.toString()}y.push(E)}if(N){const h=new Error().stack;h&&y.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,i.safeStringify)(y);return h.length>A?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Ie[103],ke([1,0,2,5,7,3,18,12,16,10,19,25]),function(ne,e,i,k,D,F,b,A,_,I,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let h=class Ni{constructor(g,a){this._logService=a,this._provider=new Map,this._proxy=g.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,a){const o=Ni._handlePool++;this._provider.set(o,{provider:g,extensionDescription:a}),this._proxy.$registerDecorationProvider(o,a.identifier.value);const u=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(o,null);return}const w=(0,_.asArray)(p);if(w.length<=Ni._maxEventSize){this._proxy.$onDidChange(o,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,w.length);const R=w.map(d=>({uri:d,rank:(0,I.count)(d.path,"/")})),v=(0,_.groupBy)(R,(d,r)=>d.rank-r.rank||(0,I.compare)(d.uri.path,r.uri.path)),t=[];e:for(const d of v){let r;for(const l of d){const c=(0,N.dirname)(l.uri.path);if(r!==c&&(r=c,t.push(l.uri)>=Ni._maxEventSize))break e}}this._proxy.$onDidChange(o,t)});return new D.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(g,a,o){if(!this._provider.has(g))return Object.create(null);const u=Object.create(null),{provider:p,extensionDescription:w}=this._provider.get(g);return await Promise.all(a.map(async R=>{try{const{uri:v,id:t}=R,d=await Promise.resolve(p.provideFileDecoration(i.URI.revive(v),o));if(!d)return;try{D.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,y.checkProposedApiEnabled)(w,"codiconDecoration"),u[t]=[d.propagate,d.tooltip,d.badge,d.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${w}': ${r}`)}}catch(v){this._logService.error(v)}})),u}};h._handlePool=0,h._maxEventSize=250,h=Ve([We(0,b.IExtHostRpcService),We(1,A.ILogService)],h),e.ExtHostDecorations=h,e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[211],ke([1,0,139,91,2,5,7,8,4,12,28,36]),function(ne,e,i,k,D,F,b,A,_,I,N,y){"use strict";var h,E,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(p,w,R,v,t,d,r){this._name=p,this._owner=w,this._maxDiagnosticsPerFile=R,this._modelVersionIdProvider=v,h.set(this,void 0),E.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Je(this,g,new N.ResourceMap(l=>t.getComparisonKey(l)),"f"),Je(this,h,d,"f"),Je(this,E,r,"f")}dispose(){this._isDisposed||(Oe(this,E,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,h,"f")?.$clear(this._owner),Oe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,w){if(!p){this.clear();return}this._checkDisposed();let R=[];if(D.URI.isUri(p)){if(!w){this.delete(p);return}Oe(this,g,"f").set(p,w.slice()),R=[p]}else if(Array.isArray(p)){R=[];let t;p=[...p].sort(a._compareIndexedTuplesByUri);for(const d of p){const[r,l]=d;if((!t||r.toString()!==t.toString())&&(t&&Oe(this,g,"f").get(t).length===0&&Oe(this,g,"f").delete(t),t=r,R.push(r),Oe(this,g,"f").set(r,[])),l)Oe(this,g,"f").get(r)?.push(...l);else{const c=Oe(this,g,"f").get(r);c&&(c.length=0)}}}if(Oe(this,E,"f").fire(R),!Oe(this,h,"f"))return;const v=[];for(const t of R){let d=[];const r=Oe(this,g,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){d=[];const l=[b.DiagnosticSeverity.Error,b.DiagnosticSeverity.Warning,b.DiagnosticSeverity.Information,b.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const S of r)if(S.severity===l[c]&&d.push({...A.Diagnostic.from(S),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;d.push({severity:k.MarkerSeverity.Info,message:(0,i.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=r.map(l=>({...A.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(t)}));v.push([t,d])}Oe(this,h,"f").$changeMany(this._owner,v)}delete(p){this._checkDisposed(),Oe(this,E,"f").fire([p]),Oe(this,g,"f").delete(p),Oe(this,h,"f")?.$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Oe(this,E,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,g,"f").clear(),Oe(this,h,"f")?.$clear(this._owner)}forEach(p,w){this._checkDisposed();for(const[R,v]of this)p.call(w,R,v,this)}*[(h=new WeakMap,E=new WeakMap,g=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const p of Oe(this,g,"f").keys())yield[p,this.get(p)]}get(p){this._checkDisposed();const w=Oe(this,g,"f").get(p);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Oe(this,g,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,w){return p[0].toString()<w[0].toString()?-1:p[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=a;let o=class pi{static _mapper(p){const w=new N.ResourceMap;for(const R of p)w.set(R,R);return{uris:Object.freeze(Array.from(w.values()))}}constructor(p,w,R,v){this._logService=w,this._fileSystemInfoService=R,this._extHostDocumentsAndEditors=v,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,pi._mapper),this._proxy=p.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,w){const{_collections:R,_proxy:v,_onDidChangeDiagnostics:t,_logService:d,_fileSystemInfoService:r,_extHostDocumentsAndEditors:l}=this,c=new class{$changeMany(s,f){v.$changeMany(s,f),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,s,f.length===0?"CLEARING":f)}$clear(s){v.$clear(s),d.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,s)}dispose(){v.dispose()}};let S;if(!w)w="_generated_diagnostic_collection_name_#"+pi._idPool++,S=w;else if(!R.has(w))S=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do S=w+pi._idPool++;while(R.has(S))}return new class extends a{constructor(){super(w,S,pi._maxDiagnosticsPerFile,s=>l.getDocument(s)?.version,r.extUri,c,t),R.set(S,this)}dispose(){super.dispose(),R.delete(S)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const w=new Map,R=[];for(const v of this._collections.values())v.forEach((t,d)=>{let r=w.get(t.toString());typeof r>"u"&&(r=R.length,w.set(t.toString(),r),R.push([t,[]])),R[r][1]=R[r][1].concat(...d)});return R}}_getDiagnostics(p){let w=[];for(const R of this._collections.values())R.has(p)&&(w=w.concat(R.get(p)));return w}$acceptMarkersChange(p){if(!this._mirrorCollection){const w="_generated_mirror",R=new a(w,w,pi._maxDiagnosticsPerFile,v=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,R),this._mirrorCollection=R}for(const[w,R]of p)this._mirrorCollection.set(D.URI.revive(w),R.map(A.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=Ve([We(1,I.ILogService),We(2,y.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ie[212],ke([1,0,2,5,25]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class F{constructor(A){this._proxy=A.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(A,_){return _?.allowUIResources&&(0,D.checkProposedApiEnabled)(A,"showLocal"),this._proxy.$showOpenDialog(_).then(I=>I?I.map(N=>i.URI.revive(N)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(_=>_?i.URI.revive(_):void 0)}}e.ExtHostDialogs=F}),define(Ie[213],ke([1,0,11,2,7,5,15,21,10]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(y,h,E){this._documentsAndEditors=h,this._logService=E,this._documentContentProviders=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,h){if(Object.keys(b.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=I._handlePool++;this._documentContentProviders.set(E,h),this._proxy.$registerTextContentProvider(E,y);let g;return typeof h.onDidChange=="function"&&(g=h.onDidChange(a=>{if(a.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(E,a).then(o=>{if(!o&&typeof o!="string")return;const u=this._documentsAndEditors.getDocument(a);if(!u)return;const p=(0,_.splitLines)(o);if(!u.equalLines(p))return this._proxy.$onVirtualDocumentChange(a,o)},i.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(y,h){const E=this._documentContentProviders.get(y);return E?Promise.resolve(E.provideTextDocumentContent(k.URI.revive(h),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}I._handlePool=0,e.ExtHostDocumentContentProvider=I}),define(Ie[214],ke([1,0,4,6,2,5,99,8,9,22,7]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(E,g){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(F.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const o of a)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const o of a)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const g=this._documentsAndEditors.getDocument(E);if(g)return g}getDocument(E){const g=this.getDocumentData(E);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return g.document}ensureDocumentData(E){const g=this._documentsAndEditors.getDocument(E);if(g)return Promise.resolve(g);let a=this._documentLoader.get(E.toString());return a||(a=this._proxy.$tryOpenDocument(E).then(o=>{this._documentLoader.delete(E.toString());const u=D.URI.revive(o);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(u))},o=>(this._documentLoader.delete(E.toString()),Promise.reject(o))),this._documentLoader.set(E.toString(),a)),a}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(g=>D.URI.revive(g))}$acceptModelLanguageChanged(E,g){const a=D.URI.revive(E),o=this._documentsAndEditors.getDocument(a);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(g),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(E){const g=D.URI.revive(E),a=this._documentsAndEditors.getDocument(g);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(E,g){const a=D.URI.revive(E),o=this._documentsAndEditors.getDocument(a);if(!o)throw new Error("unknown document");o._acceptIsDirty(g),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,g,a){const o=D.URI.revive(E),u=this._documentsAndEditors.getDocument(o);if(!u)throw new Error("unknown document");u._acceptIsDirty(a),u.onEvents(g);let p;g.isUndoing?p=N.TextDocumentChangeReason.Undo:g.isRedoing&&(p=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:u.document,contentChanges:g.changes.map(w=>({range:A.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:p}))}setWordDefinitionFor(E,g){(0,b.setWordDefinitionFor)(E,g)}}e.ExtHostDocuments=y}),define(Ie[58],ke([1,0,49,4,6,2,3,5,99,18,102,8,12,28,15,186,85]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(R){this.value=R,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let p=class{constructor(R,v){this._extHostRpc=R,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(R){this.acceptDocumentsAndEditorsDelta(R)}acceptDocumentsAndEditorsDelta(R){const v=[],t=[],d=[];if(R.removedDocuments)for(const r of R.removedDocuments){const l=F.URI.revive(r),c=this._documents.get(l);c?.unref()&&(this._documents.delete(l),v.push(c.value))}if(R.addedDocuments)for(const r of R.addedDocuments){const l=F.URI.revive(r.uri);let c=this._documents.get(l);if(c&&l.scheme!==g.Schemas.vscodeNotebookCell&&l.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new u(new _.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),l,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(l,c),t.push(c.value)),c.ref()}if(R.removedEditors)for(const r of R.removedEditors){const l=this._editors.get(r);this._editors.delete(r),l&&d.push(l)}if(R.addedEditors)for(const r of R.addedEditors){const l=F.URI.revive(r.documentUri);i.ok(this._documents.has(l),`document '${l}' does not exist`),i.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const c=this._documents.get(l).value,S=new N.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>c.document),r.selections.map(y.Selection.to),r.options,r.visibleRanges.map(n=>y.Range.to(n)),typeof r.editorPosition=="number"?y.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,S)}R.newActiveEditor!==void 0&&(i.ok(R.newActiveEditor===null||this._editors.has(R.newActiveEditor),`active editor '${R.newActiveEditor}' does not exist`),this._activeEditorId=R.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(d),R.removedDocuments&&this._onDidRemoveDocuments.fire(v),R.addedDocuments&&this._onDidAddDocuments.fire(t),(R.removedEditors||R.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),R.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(R){return this._documents.get(R)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),R=>R.value)}getEditor(R){return this._editors.get(R)}activeEditor(R){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return R?v:v?.value}allEditors(){return[...this._editors.values()]}};p=Ve([We(0,I.IExtHostRpcService),We(1,h.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,b.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[59],ke([1,0,8,5,2,4,3,7,18,9,63]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,b.createDecorator)("IExtHostEditorTabs");class y{constructor(o,u,p){this._activeTabIdGetter=p,this._parentGroup=u,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,u={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(u)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class h{constructor(o,u){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=u;for(const p of o.tabs)p.isActive&&(this._activeTabId=p.id),this._tabs.push(new y(p,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,u={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return i.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(p=>p.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(p=>p.apiObject))}};this._apiObject=Object.freeze(u)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const p=new y(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,p),o.tabDto.isActive&&(this._activeTabId=p.tabId),p}else if(o.kind===1){const p=this._tabs.splice(o.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return p.tabId===this._activeTabId&&(this._activeTabId=""),p}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this._tabs.splice(o.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,p),p}const u=this._tabs.find(p=>p.tabId===o.tabDto.id);if(!u)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),u.acceptDtoUpdate(o.tabDto),u}activeTabId(){return this._activeTabId}}let E=class{constructor(o){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,u={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(p=>p.apiObject))},get activeTabGroup(){const p=o._activeGroupId;return(0,I.assertIsDefined)(o._extHostTabGroups.find(R=>R.groupId===p)?.apiObject)},close:async(p,w)=>{const R=Array.isArray(p)?p:[p];return R.length?g(R[0])?this._closeGroups(R,w):this._closeTabs(R,w):!0}};this._apiObject=Object.freeze(u)}return this._apiObject}$acceptEditorTabModel(o){const u=new Set(this._extHostTabGroups.map(r=>r.groupId)),p=new Set(o.map(r=>r.groupId)),w=(0,N.diffSets)(u,p),R=this._extHostTabGroups.filter(r=>w.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],t=[];this._extHostTabGroups=o.map(r=>{const l=new h(r,()=>this._activeGroupId);return w.added.includes(l.groupId)?v.push(l.apiObject):t.push(l.apiObject),l});const d=(0,I.assertIsDefined)(o.find(r=>r.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:v,closed:R,changed:t}))}$acceptTabGroupUpdate(o){const u=this._extHostTabGroups.find(p=>p.groupId===o.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const u=this._extHostTabGroups.find(w=>w.groupId===o.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const p=u.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}_findExtHostTabFromApi(o){for(const u of this._extHostTabGroups)for(const p of u.tabs)if(p.apiObject===o)return p}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(u=>u.apiObject===o)}async _closeTabs(o,u){const p=[];for(const w of o){const R=this._findExtHostTabFromApi(w);if(!R)throw new Error("Tab close: Invalid tab not found!");p.push(R.tabId)}return this._proxy.$closeTab(p,u)}async _closeGroups(o,u){const p=[];for(const w of o){const R=this._findExtHostTabGroupFromApi(w);if(!R)throw new Error("Group close: Invalid group not found!");p.push(R.groupId)}return this._proxy.$closeGroup(p,u)}};E=Ve([We(0,_.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function g(a){return a.tabs!==void 0}}),define(Ie[215],ke([1,0,2,5,6,7,8,261,10,23,25]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const a=this._schemes.indexOf(g);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),a=[];let o,u,p=14,w=14;for(const R of g){let v=o?(0,_.commonPrefixLength)(o,R):0;for(v===0?u=1:u=w;v<R.length;v++)v+1===R.length?(p=w,w=9):w+=1,a.push([u,R.toUpperCase().charCodeAt(v),w]),a.push([u,R.toLowerCase().charCodeAt(v),w]),u=w;o=R,w=p}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new A.StateMachine(a)}}provideDocumentLinks(g){this._initStateMachine();const a=[],o=A.LinkComputer.computeLinks({getLineContent(u){return g.lineAt(u-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const u of o){const p=b.DocumentLink.to(u);p.target&&a.push(p)}return a}}class h{constructor(g,a){this._extHostLanguageFeatures=a,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,a,o,u={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const p=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(p,o);let w=2;u.isCaseSensitive&&(w+=1024),u.isReadonly&&(w+=2048),typeof o.copy=="function"&&(w+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.checkProposedApiEnabled)(g,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(p,a,w).catch(v=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${a}`),console.error(v)});const R=o.onDidChangeFile(v=>{const t=[];for(const d of v){const{uri:r,type:l}=d;if(r.scheme!==a)continue;let c;switch(l){case F.FileChangeType.Changed:c=0;break;case F.FileChangeType.Created:c=1;break;case F.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:c})}this._proxy.$onFileSystemChange(p,t)});return(0,D.toDisposable)(()=>{R.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(g){const{type:a,ctime:o,mtime:u,size:p,permissions:w}=g;return{type:a,ctime:o,mtime:u,size:p,permissions:w}}$stat(g,a){return Promise.resolve(this._getFsProvider(g).stat(i.URI.revive(a))).then(o=>h._asIStat(o))}$readdir(g,a){return Promise.resolve(this._getFsProvider(g).readDirectory(i.URI.revive(a)))}$readFile(g,a){return Promise.resolve(this._getFsProvider(g).readFile(i.URI.revive(a))).then(o=>I.VSBuffer.wrap(o))}$writeFile(g,a,o,u){return Promise.resolve(this._getFsProvider(g).writeFile(i.URI.revive(a),o.buffer,u))}$delete(g,a,o){return Promise.resolve(this._getFsProvider(g).delete(i.URI.revive(a),o))}$rename(g,a,o,u){return Promise.resolve(this._getFsProvider(g).rename(i.URI.revive(a),i.URI.revive(o),u))}$copy(g,a,o,u){const p=this._getFsProvider(g);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(i.URI.revive(a),i.URI.revive(o),u))}$mkdir(g,a){return Promise.resolve(this._getFsProvider(g).createDirectory(i.URI.revive(a)))}$watch(g,a,o,u){const p=this._getFsProvider(g).watch(i.URI.revive(o),u);this._watches.set(a,p)}$unwatch(g,a){const o=this._watches.get(a);o&&(o.dispose(),this._watches.delete(a))}$open(g,a,o){const u=this._getFsProvider(g);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(i.URI.revive(a),o))}$close(g,a){const o=this._getFsProvider(g);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(a))}$read(g,a,o,u){const p=this._getFsProvider(g);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const w=I.VSBuffer.alloc(u);return Promise.resolve(p.read(a,o,w.buffer,0,u)).then(R=>w.slice(0,R))}$write(g,a,o,u){const p=this._getFsProvider(g);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(a,o,u.buffer,0,u.byteLength))}_getFsProvider(g){const a=this._fsProvider.get(g);if(!a){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return a}}e.ExtHostFileSystem=h}),define(Ie[60],ke([1,0,5,43,7,23,3,18,36,6]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Qt{constructor(h,E){this._fileSystemProvider=new Map,this._proxy=h.getProxy(i.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(a){try{const o=g._fileSystemProvider.get(a.scheme);if(!o)return await g._proxy.$stat(a);await g._proxy.$ensureActivation(a.scheme);const u=await o.stat(a);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(o){Qt._handleError(o)}},async readDirectory(a){try{const o=g._fileSystemProvider.get(a.scheme);return o?(await g._proxy.$ensureActivation(a.scheme),(await o.readDirectory(a)).slice()):await g._proxy.$readdir(a)}catch(o){return Qt._handleError(o)}},async createDirectory(a){try{return await g._proxy.$mkdir(a)}catch(o){return Qt._handleError(o)}},async readFile(a){try{const o=g._fileSystemProvider.get(a.scheme);return o?(await g._proxy.$ensureActivation(a.scheme),(await o.readFile(a)).slice()):(await g._proxy.$readFile(a)).buffer}catch(o){return Qt._handleError(o)}},async writeFile(a,o){try{return await g._proxy.$writeFile(a,F.VSBuffer.wrap(o))}catch(u){return Qt._handleError(u)}},async delete(a,o){try{const u=g._fileSystemProvider.get(a.scheme);return u?(await g._proxy.$ensureActivation(a.scheme),await u.delete(a,{recursive:!1,...o})):await g._proxy.$delete(a,{recursive:!1,useTrash:!1,...o})}catch(u){return Qt._handleError(u)}},async rename(a,o,u){try{return await g._proxy.$rename(a,o,{overwrite:!1,...u})}catch(p){return Qt._handleError(p)}},async copy(a,o,u){try{return await g._proxy.$copy(a,o,{overwrite:!1,...u})}catch(p){return Qt._handleError(p)}},isWritableFileSystem(a){const o=E.getCapabilities(a);if(typeof o=="number")return!(o&2048)}})}static _handleError(h){if(h instanceof D.FileSystemError)throw h;if(!(h instanceof Error))throw new D.FileSystemError(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(h.message);switch(h.name){case k.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(h.message);case k.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(h.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(h.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(h.message);case k.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(h.message);case k.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(h.message);default:throw new D.FileSystemError(h.message,h.name)}}addFileSystemProvider(h,E){return this._fileSystemProvider.set(h,E),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(h))}};N=Ve([We(0,A.IExtHostRpcService),We(1,_.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,b.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[216],ke([1,0,4,35,2,5,8,7]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(y,h,E,g,a,o,u,p){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter;const w=this.ensureWatching(y,E,a);this._config=0,o&&(this._config+=1),u&&(this._config+=2),p&&(this._config+=4);const R=(0,k.parse)(a),v=typeof a=="string",t=g(d=>{if(!o)for(const r of d.created){const l=D.URI.revive(r);R(l.fsPath)&&(!v||h.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!u)for(const r of d.changed){const l=D.URI.revive(r);R(l.fsPath)&&(!v||h.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!p)for(const r of d.deleted){const l=D.URI.revive(r);R(l.fsPath)&&(!v||h.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=A.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(y,h,E){const g=A.Disposable.from();if(typeof E=="string")return g;const a=y.getProxy(F.MainContext.MainThreadFileSystem);let o=!1;(E.pattern.includes(k.GLOBSTAR)||E.pattern.includes(k.GLOB_SPLIT))&&(o=!0);const u=Math.random();return a.$watch(h.identifier.value,u,E.baseUri,{recursive:o,excludes:[]}),A.Disposable.from({dispose:()=>a.$unwatch(u)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(y,h,E){this._mainContext=y,this._logService=h,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,h,E,g,a,o){return new _(this._mainContext,y,h,this._onFileSystemEvent.event,b.GlobPattern.from(E),g,a,o)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,h){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:h.map(E=>({oldUri:D.URI.revive(E.source),newUri:D.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:h.map(E=>D.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:h.map(E=>D.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,h){return(E,g,a)=>{const o=function(p){E.call(g,p)};return o.extension=y,h.event(o,void 0,a)}}async $onWillRunFileOperation(y,h,E,g){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:h.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))},E,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:h.map(a=>D.URI.revive(a.target))},E,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:h.map(a=>D.URI.revive(a.target))},E,g)}}async _fireWillEvent(y,h,E,g){const a=new Set,o=[];if(await y.fireAsync(h,g,async(p,w)=>{const R=Date.now(),v=await Promise.resolve(p);v instanceof A.WorkspaceEdit&&(o.push([w.extension,v]),a.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-R>E&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),g.isCancellationRequested||o.length===0)return;const u={edits:[]};for(const[,p]of o){const{edits:w}=b.WorkspaceEdit.from(p,{getTextDocumentVersion:R=>this._extHostDocumentsAndEditors.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(w)}return{edit:u,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=I}),define(Ie[217],ke([1,0,2,37]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(b,A,_,I,N){this._extHostNotebooks=A,this._textDocumentsAndEditors=_,this._commands=I;const y=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new k.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new k.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new k.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new k.ApiCommandResult("Notebook and input URI",h=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(h.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:i.URI.revive(h.notebookUri),inputUri:i.URI.revive(h.inputUri),notebookEditor:E.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:i.URI.revive(h.notebookUri),inputUri:i.URI.revive(h.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(b,A,_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:_,uri:b,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(i.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(b,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[b]})}}e.ExtHostInteractive=D}),define(Ie[218],ke([1,0,6,5]),function(ne,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(b){this._handlePool=0,this._proxy=b.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(b){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,b),(0,i.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=D}),define(Ie[219],ke([1,0,2,22,8,7,75,5,10,44,16,9,262,21,6,88,83,54,77,11,17,25]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(C,U){this._documents=C,this._provider=U}async provideDocumentSymbols(C,U){const $=this._documents.getDocument(C),W=await this._provider.provideDocumentSymbols($,U);if(!(0,N.isFalsyOrEmpty)(W))return W[0]instanceof F.DocumentSymbol?W.map(D.DocumentSymbol.from):t._asDocumentSymbolTree(W)}static _asDocumentSymbolTree(C){C=C.slice(0).sort((W,ie)=>{let fe=W.location.range.start.compareTo(ie.location.range.start);return fe===0&&(fe=ie.location.range.end.compareTo(W.location.range.end)),fe});const U=[],$=[];for(const W of C){const ie={name:W.name||"!!MISSING: name!!",kind:D.SymbolKind.from(W.kind),tags:W.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:D.Range.from(W.location.range),selectionRange:D.Range.from(W.location.range),children:[]};for(;;){if($.length===0){$.push(ie),U.push(ie);break}const fe=$[$.length-1];if(I.Range.containsRange(fe.range,ie.range)&&!I.Range.equalsRange(fe.range,ie.range)){fe.children?.push(ie),$.push(ie);break}$.pop()}}return U}}class d{constructor(C,U,$){this._documents=C,this._commands=U,this._provider=$,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(C,U){const $=this._documents.getDocument(C),W=await this._provider.provideCodeLenses($,U);if(!W||U.isCancellationRequested)return;const ie=this._cache.add(W),fe=new g.DisposableStore;this._disposables.set(ie,fe);const ye={cacheId:ie,lenses:[]};for(let le=0;le<W.length;le++)ye.lenses.push({cacheId:[ie,le],range:D.Range.from(W[le].range),command:this._commands.toInternal(W[le].command,fe)});return ye}async resolveCodeLens(C,U){const $=C.cacheId&&this._cache.get(...C.cacheId);if(!$)return;let W;if(typeof this._provider.resolveCodeLens!="function"||$.isResolved?W=$:W=await this._provider.resolveCodeLens($,U),W||(W=$),U.isCancellationRequested)return;const ie=C.cacheId&&this._disposables.get(C.cacheId[0]);if(!!ie)return C.command=this._commands.toInternal(W.command??d._badCmd,ie),C}releaseCodeLenses(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ee){return Array.isArray(ee)?ee.map(D.DefinitionLink.from):ee?[D.DefinitionLink.from(ee)]:[]}class l{constructor(C,U){this._documents=C,this._provider=U}async provideDefinition(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideDefinition(W,ie,$);return r(fe)}}class c{constructor(C,U){this._documents=C,this._provider=U}async provideDeclaration(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideDeclaration(W,ie,$);return r(fe)}}class S{constructor(C,U){this._documents=C,this._provider=U}async provideImplementation(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideImplementation(W,ie,$);return r(fe)}}class n{constructor(C,U){this._documents=C,this._provider=U}async provideTypeDefinition(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideTypeDefinition(W,ie,$);return r(fe)}}class s{constructor(C,U){this._documents=C,this._provider=U}async provideHover(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideHover(W,ie,$);if(!(!fe||(0,N.isFalsyOrEmpty)(fe.contents)))return fe.range||(fe.range=W.getWordRangeAtPosition(ie)),fe.range||(fe.range=new F.Range(ie,ie)),D.Hover.from(fe)}}class f{constructor(C,U){this._documents=C,this._provider=U}async provideEvaluatableExpression(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideEvaluatableExpression(W,ie,$);if(fe)return D.EvaluatableExpression.from(fe)}}class P{constructor(C,U){this._documents=C,this._provider=U}async provideInlineValues(C,U,$,W){const ie=this._documents.getDocument(C),fe=await this._provider.provideInlineValues(ie,D.Range.to(U),D.InlineValueContext.to($),W);if(Array.isArray(fe))return fe.map(ye=>D.InlineValue.from(ye))}}class T{constructor(C,U){this._documents=C,this._provider=U}async provideDocumentHighlights(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideDocumentHighlights(W,ie,$);if(Array.isArray(fe))return fe.map(D.DocumentHighlight.from)}}class z{constructor(C,U){this._documents=C,this._provider=U}async provideLinkedEditingRanges(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.provideLinkedEditingRanges(W,ie,$);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,N.coalesce)(fe.ranges.map(D.Range.from)),wordPattern:fe.wordPattern}}}class Q{constructor(C,U){this._documents=C,this._provider=U}async provideReferences(C,U,$,W){const ie=this._documents.getDocument(C),fe=D.Position.to(U),ye=await this._provider.provideReferences(ie,fe,$,W);if(Array.isArray(ye))return ye.map(D.location.from)}}class Z{constructor(C,U,$,W,ie,fe,ye){this._documents=C,this._commands=U,this._diagnostics=$,this._provider=W,this._logService=ie,this._extension=fe,this._apiDeprecation=ye,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(C,U,$,W){const ie=this._documents.getDocument(C),fe=h.Selection.isISelection(U)?D.Selection.to(U):D.Range.to(U),ye=[];for(const it of this._diagnostics.getDiagnostics(C))if(fe.intersection(it.range)&&ye.push(it)>Z._maxCodeActionsPerFile)break;const le={diagnostics:ye,only:$.only?new F.CodeActionKind($.only):void 0,triggerKind:D.CodeActionTriggerKind.to($.trigger)},ve=await this._provider.provideCodeActions(ie,fe,le,W);if(!(0,N.isNonEmptyArray)(ve)||W.isCancellationRequested)return;const Ee=this._cache.add(ve),ze=new g.DisposableStore;this._disposables.set(Ee,ze);const He=[];for(let it=0;it<ve.length;it++){const Ge=ve[it];!Ge||(Z._isCommand(Ge)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Ge.title,command:this._commands.toInternal(Ge,ze)})):(le.only&&(Ge.kind?le.only.contains(Ge.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${le.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Ee,it],title:Ge.title,command:Ge.command&&this._commands.toInternal(Ge.command,ze),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(D.Diagnostic.from),edit:Ge.edit&&D.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})))}return{cacheId:Ee,actions:He}}async resolveCodeAction(C,U){const[$,W]=C,ie=this._cache.get($,W);if(!ie||Z._isCommand(ie)||!this._provider.resolveCodeAction)return;const fe=await this._provider.resolveCodeAction(ie,U)??ie;return fe?.edit?D.WorkspaceEdit.from(fe.edit,void 0):void 0}releaseCodeActions(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}static _isCommand(C){return typeof C.command=="string"&&typeof C.title=="string"}}Z._maxCodeActionsPerFile=1e3;class Y{constructor(C,U,$,W){this._proxy=C,this._documents=U,this._provider=$,this._handle=W}async prepareDocumentPaste(C,U,$,W){if(!this._provider.prepareDocumentPaste)return;const ie=this._documents.getDocument(C),fe=U.map(le=>D.Range.to(le)),ye=D.DataTransfer.toDataTransfer($,()=>{throw new w.NotImplementedError});return await this._provider.prepareDocumentPaste(ie,fe,ye,W),D.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(C,U,$,W,ie){const fe=this._documents.getDocument(U),ye=$.map(Ee=>D.Range.to(Ee)),le=D.DataTransfer.toDataTransfer(W,async Ee=>(await this._proxy.$resolvePasteFileData(this._handle,C,Ee)).buffer),ve=await this._provider.provideDocumentPasteEdits(fe,ye,le,ie);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class H{constructor(C,U){this._documents=C,this._provider=U}async provideDocumentFormattingEdits(C,U,$){const W=this._documents.getDocument(C),ie=await this._provider.provideDocumentFormattingEdits(W,U,$);if(Array.isArray(ie))return ie.map(D.TextEdit.from)}}class O{constructor(C,U){this._documents=C,this._provider=U}async provideDocumentRangeFormattingEdits(C,U,$,W){const ie=this._documents.getDocument(C),fe=D.Range.to(U),ye=await this._provider.provideDocumentRangeFormattingEdits(ie,fe,$,W);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class m{constructor(C,U){this._documents=C,this._provider=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,U,$,W,ie){const fe=this._documents.getDocument(C),ye=D.Position.to(U),le=await this._provider.provideOnTypeFormattingEdits(fe,ye,$,W,ie);if(Array.isArray(le))return le.map(D.TextEdit.from)}}class L{constructor(C,U){this._provider=C,this._logService=U,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,U){const $=await this._provider.provideWorkspaceSymbols(C,U);if(!(0,N.isNonEmptyArray)($))return{symbols:[]};const W=this._cache.add($),ie={cacheId:W,symbols:[]};for(let fe=0;fe<$.length;fe++){const ye=$[fe];if(!ye||!ye.name){this._logService.warn("INVALID SymbolInformation",ye);continue}ie.symbols.push({...D.WorkspaceSymbol.from(ye),cacheId:[W,fe]})}return ie}async resolveWorkspaceSymbol(C,U){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const $=this._cache.get(...C.cacheId);if($){const W=await this._provider.resolveWorkspaceSymbol($,U);return W&&(0,k.mixin)(C,D.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(C){this._cache.delete(C)}}class B{static supportsResolving(C){return typeof C.prepareRename=="function"}constructor(C,U,$){this._documents=C,this._provider=U,this._logService=$}async provideRenameEdits(C,U,$,W){const ie=this._documents.getDocument(C),fe=D.Position.to(U);try{const ye=await this._provider.provideRenameEdits(ie,fe,$,W);return ye?D.WorkspaceEdit.from(ye):void 0}catch(ye){const le=B._asMessage(ye);return le?{rejectReason:le,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(C,U,$){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const W=this._documents.getDocument(C),ie=D.Position.to(U);try{const fe=await this._provider.prepareRename(W,ie,$);let ye,le;if(F.Range.isRange(fe)?(ye=fe,le=W.getText(fe)):(0,y.isObject)(fe)&&(ye=fe.range,le=fe.placeholder),!ye||!le)return;if(ye.start.line>ie.line||ye.end.line<ie.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ye),text:le}}catch(fe){const ye=B._asMessage(fe);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(fe)}}static _asMessage(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class J{constructor(C,U){this.resultId=C,this.tokens=U}}class me{constructor(C,U){this._documents=C,this._provider=U,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(C,U,$){const W=this._documents.getDocument(C),ie=U!==0?this._previousResults.get(U):null;let fe=typeof ie?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(W,ie.resultId,$):await this._provider.provideDocumentSemanticTokens(W,$);return ie&&this._previousResults.delete(U),fe?(fe=me._fixProvidedSemanticTokens(fe),this._send(me._convertToEdits(ie,fe),fe)):null}async releaseDocumentSemanticColoring(C){this._previousResults.delete(C)}static _fixProvidedSemanticTokens(C){return me._isSemanticTokens(C)?me._isCorrectSemanticTokens(C)?C:new F.SemanticTokens(new Uint32Array(C.data),C.resultId):me._isSemanticTokensEdits(C)?me._isCorrectSemanticTokensEdits(C)?C:new F.SemanticTokensEdits(C.edits.map(U=>new F.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),C.resultId):C}static _isSemanticTokens(C){return C&&!!C.data}static _isCorrectSemanticTokens(C){return C.data instanceof Uint32Array}static _isSemanticTokensEdits(C){return C&&Array.isArray(C.edits)}static _isCorrectSemanticTokensEdits(C){for(const U of C.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(C,U){if(!me._isSemanticTokens(U)||!C||!C.tokens)return U;const $=C.tokens,W=$.length,ie=U.data,fe=ie.length;let ye=0;const le=Math.min(W,fe);for(;ye<le&&$[ye]===ie[ye];)ye++;if(ye===W&&ye===fe)return new F.SemanticTokensEdits([],U.resultId);let ve=0;const Ee=le-ye;for(;ve<Ee&&$[W-ve-1]===ie[fe-ve-1];)ve++;return new F.SemanticTokensEdits([{start:ye,deleteCount:W-ye-ve,data:ie.subarray(ye,fe-ve)}],U.resultId)}_send(C,U){if(me._isSemanticTokens(C)){const $=this._nextResultId++;return this._previousResults.set($,new J(C.resultId,C.data)),(0,a.encodeSemanticTokensDto)({id:$,type:"full",data:C.data})}if(me._isSemanticTokensEdits(C)){const $=this._nextResultId++;return me._isSemanticTokens(U)?this._previousResults.set($,new J(U.resultId,U.data)):this._previousResults.set($,new J(C.resultId)),(0,a.encodeSemanticTokensDto)({id:$,type:"delta",deltas:(C.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}class te{constructor(C,U){this._documents=C,this._provider=U}async provideDocumentRangeSemanticTokens(C,U,$){const W=this._documents.getDocument(C),ie=await this._provider.provideDocumentRangeSemanticTokens(W,D.Range.to(U),$);return ie?this._send(ie):null}_send(C){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}class oe{static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}constructor(C,U,$,W,ie){this._documents=C,this._commands=U,this._provider=$,this._apiDeprecation=W,this._extension=ie,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(C,U,$,W){const ie=this._documents.getDocument(C),fe=D.Position.to(U),ye=ie.getWordRangeAtPosition(fe)||new F.Range(fe,fe),le=ye.with({end:fe}),ve=new p.StopWatch(!0),Ee=await this._provider.provideCompletionItems(ie,fe,W,D.CompletionContext.to($));if(!Ee||W.isCancellationRequested)return;const ze=Array.isArray(Ee)?new F.CompletionList(Ee):Ee,He=oe.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),it=new g.DisposableStore;this._disposables.set(He,it);const Ge=[],et={x:He,b:Ge,a:{replace:D.Range.from(ye),insert:D.Range.from(le)},c:ze.isIncomplete||void 0,d:ve.elapsed()};for(let nt=0;nt<ze.items.length;nt++){const Fe=ze.items[nt],rt=this._convertCompletionItem(Fe,[He,nt],le,ye);Ge.push(rt)}return et}async resolveCompletionItem(C,U){if(typeof this._provider.resolveCompletionItem!="function")return;const $=this._cache.get(...C);if(!$)return;const W=await this._provider.resolveCompletionItem($,U);if(!!W)return this._convertCompletionItem(W,C)}releaseCompletionItems(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_convertCompletionItem(C,U,$,W){const ie=this._disposables.get(U[0]);if(!ie)throw Error("DisposableStore is missing...");const fe=this._commands.toInternal(C.command,ie),ye={x:U,a:C.label,b:C.kind!==void 0?D.CompletionItemKind.from(C.kind):void 0,m:C.tags&&C.tags.map(D.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:D.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters?.join(""),l:C.additionalTextEdits&&C.additionalTextEdits.map(D.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};C.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=C.textEdit.newText):typeof C.insertText=="string"?ye.h=C.insertText:C.insertText instanceof F.SnippetString&&(ye.h=C.insertText.value,ye.i|=4);let le;return C.textEdit?le=C.textEdit.range:C.range&&(le=C.range),F.Range.isRange(le)?ye.j=D.Range.from(le):le&&(!$?.isEqual(le.inserting)||!W?.isEqual(le.replacing))&&(ye.j={insert:D.Range.from(le.inserting),replace:D.Range.from(le.replacing)}),ye}}class ce{async provideInlineCompletions(C,U,$,W){}disposeCompletions(C){}handleDidShowCompletionItem(C,U){}handlePartialAccept(C,U,$){}}class we extends ce{constructor(C,U,$,W){super(),this._extension=C,this._documents=U,this._provider=$,this._commands=W,this._references=new V,this._isAdditionsProposedApiEnabled=(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[b.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[b.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(C,U,$,W){const ie=this._documents.getDocument(C),fe=D.Position.to(U),ye=await this._provider.provideInlineCompletionItems(ie,fe,{selectedCompletionInfo:$.selectedSuggestionInfo?{range:D.Range.to($.selectedSuggestionInfo.range),text:$.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[$.triggerKind]},W);if(!ye||W.isCancellationRequested)return;const le=Array.isArray(ye)?ye:ye.items,ve=this._isAdditionsProposedApiEnabled?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this._references.createReferenceId({dispose(){Ee?.dispose()},items:le}),items:le.map((He,it)=>{let Ge;He.command&&(Ee||(Ee=new g.DisposableStore),Ge=this._commands.toInternal(He.command,Ee));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?D.Range.from(He.range):void 0,command:Ge,idx:it,completeBracketPairs:this._isAdditionsProposedApiEnabled?He.completeBracketPairs:!1}}),commands:ve.map(He=>(Ee||(Ee=new g.DisposableStore),this._commands.toInternal(He,Ee)))}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,U){const $=this._references.get(C)?.items[U];$&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem($)}handlePartialAccept(C,U,$){const W=this._references.get(C)?.items[U];W&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(W,$)}}class V{constructor(){this._references=new Map,this._idPool=1}createReferenceId(C){const U=this._idPool++;return this._references.set(U,C),U}disposeReferenceId(C){const U=this._references.get(C);return this._references.delete(C),U}get(C){return this._references.get(C)}}class q{constructor(C,U){this._documents=C,this._provider=U,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(C,U,$,W){const ie=this._documents.getDocument(C),fe=D.Position.to(U),ye=this.reviveContext($),le=await this._provider.provideSignatureHelp(ie,fe,W,ye);if(le){const ve=this._cache.add([le]);return{...D.SignatureHelp.from(le),id:ve}}}reviveContext(C){let U;if(C.activeSignatureHelp){const $=D.SignatureHelp.to(C.activeSignatureHelp),W=this._cache.get(C.activeSignatureHelp.id,0);W?(U=W,U.activeSignature=$.activeSignature,U.activeParameter=$.activeParameter):U=$}return{...C,activeSignatureHelp:U}}releaseSignatureHelp(C){this._cache.delete(C)}}class G{constructor(C,U,$,W,ie){this._documents=C,this._commands=U,this._provider=$,this._logService=W,this._extension=ie,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(C,U,$){const W=this._documents.getDocument(C),ie=D.Range.to(U),fe=await this._provider.provideInlayHints(W,ie,$);if(!Array.isArray(fe)||fe.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${U}`);return}if($.isCancellationRequested)return;const ye=this._cache.add(fe);this._disposables.set(ye,new g.DisposableStore);const le={hints:[],cacheId:ye};for(let ve=0;ve<fe.length;ve++)this._isValidInlayHint(fe[ve],ie)&&le.hints.push(this._convertInlayHint(fe[ve],[ye,ve]));return this._logService.trace(`[InlayHints] ${le.hints.length} inlay hints from '${this._extension.identifier.value}' for ${U}`),le}async resolveInlayHint(C,U){if(typeof this._provider.resolveInlayHint!="function")return;const $=this._cache.get(...C);if(!$)return;const W=await this._provider.resolveInlayHint($,U);if(!!W&&!!this._isValidInlayHint(W))return this._convertInlayHint(W,C)}releaseHints(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_isValidInlayHint(C,U){return C.label.length===0||Array.isArray(C.label)&&C.label.every($=>$.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(U&&!U.contains(C.position))}_convertInlayHint(C,U){const $=this._disposables.get(U[0]);if(!$)throw Error("DisposableStore is missing...");const W={label:"",cacheId:U,tooltip:D.MarkdownString.fromStrict(C.tooltip),position:D.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(D.TextEdit.from),kind:C.kind&&D.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?W.label=C.label:W.label=C.label.map(ie=>{const fe={label:ie.value};return fe.tooltip=D.MarkdownString.fromStrict(ie.tooltip),F.Location.isLocation(ie.location)&&(fe.location=D.location.from(ie.location)),ie.command&&(fe.command=this._commands.toInternal(ie.command,$)),fe}),W}}class de{constructor(C,U){this._documents=C,this._provider=U,this._cache=new u.Cache("DocumentLink")}async provideLinks(C,U){const $=this._documents.getDocument(C),W=await this._provider.provideDocumentLinks($,U);if(!(!Array.isArray(W)||W.length===0)&&!U.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:W.filter(de._validateLink).map(D.DocumentLink.from)};{const ie=this._cache.add(W),fe={links:[],cacheId:ie};for(let ye=0;ye<W.length;ye++){if(!de._validateLink(W[ye]))continue;const le=D.DocumentLink.from(W[ye]);le.cacheId=[ie,ye],fe.links.push(le)}return fe}}}static _validateLink(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,U){if(typeof this._provider.resolveDocumentLink!="function")return;const $=this._cache.get(...C);if(!$)return;const W=await this._provider.resolveDocumentLink($,U);if(!(!W||!de._validateLink(W)))return D.DocumentLink.from(W)}releaseLinks(C){this._cache.delete(C)}}class Se{constructor(C,U){this._documents=C,this._provider=U}async provideColors(C,U){const $=this._documents.getDocument(C),W=await this._provider.provideDocumentColors($,U);return Array.isArray(W)?W.map(fe=>({color:D.Color.from(fe.color),range:D.Range.from(fe.range)})):[]}async provideColorPresentations(C,U,$){const W=this._documents.getDocument(C),ie=D.Range.to(U.range),fe=D.Color.to(U.color),ye=await this._provider.provideColorPresentations(fe,{document:W,range:ie},$);if(!!Array.isArray(ye))return ye.map(D.ColorPresentation.from)}}class Le{constructor(C,U){this._documents=C,this._provider=U}async provideFoldingRanges(C,U,$){const W=this._documents.getDocument(C),ie=await this._provider.provideFoldingRanges(W,U,$);if(!!Array.isArray(ie))return ie.map(D.FoldingRange.from)}}class xe{constructor(C,U,$){this._documents=C,this._provider=U,this._logService=$}async provideSelectionRanges(C,U,$){const W=this._documents.getDocument(C),ie=U.map(D.Position.to),fe=await this._provider.provideSelectionRanges(W,ie,$);if(!(0,N.isNonEmptyArray)(fe))return[];if(fe.length!==ie.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let le=0;le<ie.length;le++){const ve=[];ye.push(ve);let Ee=ie[le],ze=fe[le];for(;;){if(!ze.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(D.SelectionRange.from(ze)),!ze.parent)break;Ee=ze.range,ze=ze.parent}}return ye}}class Te{constructor(C,U){this._documents=C,this._provider=U,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.prepareCallHierarchy(W,ie,$);if(!fe)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(fe)?fe.map(le=>this._cacheAndConvertItem(ye,le)):[this._cacheAndConvertItem(ye,fe)]}async provideCallsTo(C,U,$){const W=this._itemFromCache(C,U);if(!W)throw new Error("missing call hierarchy item");const ie=await this._provider.provideCallHierarchyIncomingCalls(W,$);if(!!ie)return ie.map(fe=>({from:this._cacheAndConvertItem(C,fe.from),fromRanges:fe.fromRanges.map(ye=>D.Range.from(ye))}))}async provideCallsFrom(C,U,$){const W=this._itemFromCache(C,U);if(!W)throw new Error("missing call hierarchy item");const ie=await this._provider.provideCallHierarchyOutgoingCalls(W,$);if(!!ie)return ie.map(fe=>({to:this._cacheAndConvertItem(C,fe.to),fromRanges:fe.fromRanges.map(ye=>D.Range.from(ye))}))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,U){const $=this._cache.get(C),W=D.CallHierarchyItem.from(U,C,$.size.toString(36));return $.set(W._itemId,U),W}_itemFromCache(C,U){return this._cache.get(C)?.get(U)}}class De{constructor(C,U){this._documents=C,this._provider=U,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(C,U,$){const W=this._documents.getDocument(C),ie=D.Position.to(U),fe=await this._provider.prepareTypeHierarchy(W,ie,$);if(!fe)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(fe)?fe.map(le=>this._cacheAndConvertItem(ye,le)):[this._cacheAndConvertItem(ye,fe)]}async provideSupertypes(C,U,$){const W=this._itemFromCache(C,U);if(!W)throw new Error("missing type hierarchy item");const ie=await this._provider.provideTypeHierarchySupertypes(W,$);if(!!ie)return ie.map(fe=>this._cacheAndConvertItem(C,fe))}async provideSubtypes(C,U,$){const W=this._itemFromCache(C,U);if(!W)throw new Error("missing type hierarchy item");const ie=await this._provider.provideTypeHierarchySubtypes(W,$);if(!!ie)return ie.map(fe=>this._cacheAndConvertItem(C,fe))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,U){const $=this._cache.get(C),W=D.TypeHierarchyItem.from(U,C,$.size.toString(36));return $.set(W._itemId,U),W}_itemFromCache(C,U){return this._cache.get(C)?.get(U)}}class _e{constructor(C,U,$,W){this._proxy=C,this._documents=U,this._provider=$,this._handle=W}async provideDocumentOnDropEdits(C,U,$,W,ie){const fe=this._documents.getDocument(U),ye=D.Position.to($),le=D.DataTransfer.toDataTransfer(W,async Ee=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,C,Ee)).buffer),ve=await this._provider.provideDocumentDropEdits(fe,ye,le,ie);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class ae{constructor(C,U){this.adapter=C,this.extension=U}}class ue{constructor(C,U,$,W,ie,fe,ye,le){this._uriTransformer=U,this._documents=$,this._commands=W,this._diagnostics=ie,this._logService=fe,this._apiDeprecation=ye,this._extensionTelemetry=le,this._adapter=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(C){return D.DocumentSelector.from(C,this._uriTransformer)}_createDisposable(C){return new F.Disposable(()=>{this._adapter.delete(C),this._proxy.$unregister(C)})}_nextHandle(){return ue._handlePool++}async _withAdapter(C,U,$,W,ie,fe=!1){const ye=this._adapter.get(C);if(!ye||!(ye.adapter instanceof U))return W;const le=Date.now();fe||this._logService.trace(`[${ye.extension.identifier.value}] INVOKE provider '${$.toString().replace(/[\r\n]/g,"")}'`);const ve=$(ye.adapter,ye.extension);return Promise.resolve(ve).catch(Ee=>{(0,w.isCancellationError)(Ee)||(this._logService.error(`[${ye.extension.identifier.value}] provider FAILED`),this._logService.error(Ee),this._extensionTelemetry.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{fe||this._logService.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-le}ms`)}),E.CancellationToken.isCancellationToken(ie)?(0,R.raceCancellationError)(ve,ie):ve}_addNewAdapter(C,U){const $=this._nextHandle();return this._adapter.set($,new ae(C,U)),$}static _extLabel(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,U,$,W){const ie=this._addNewAdapter(new t(this._documents,$),C),fe=W&&W.label||ue._extLabel(C);return this._proxy.$registerDocumentSymbolProvider(ie,this._transformDocumentSelector(U),fe),this._createDisposable(ie)}$provideDocumentSymbols(C,U,$){return this._withAdapter(C,t,W=>W.provideDocumentSymbols(i.URI.revive(U),$),void 0,$)}registerCodeLensProvider(C,U,$){const W=this._nextHandle(),ie=typeof $.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(W,new ae(new d(this._documents,this._commands.converter,$),C)),this._proxy.$registerCodeLensSupport(W,this._transformDocumentSelector(U),ie);let fe=this._createDisposable(W);if(ie!==void 0){const ye=$.onDidChangeCodeLenses(le=>this._proxy.$emitCodeLensEvent(ie));fe=F.Disposable.from(fe,ye)}return fe}$provideCodeLenses(C,U,$){return this._withAdapter(C,d,W=>W.provideCodeLenses(i.URI.revive(U),$),void 0,$)}$resolveCodeLens(C,U,$){return this._withAdapter(C,d,W=>W.resolveCodeLens(U,$),void 0,void 0)}$releaseCodeLenses(C,U){this._withAdapter(C,d,$=>Promise.resolve($.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(C,U,$){const W=this._addNewAdapter(new l(this._documents,$),C);return this._proxy.$registerDefinitionSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDefinition(C,U,$,W){return this._withAdapter(C,l,ie=>ie.provideDefinition(i.URI.revive(U),$,W),[],W)}registerDeclarationProvider(C,U,$){const W=this._addNewAdapter(new c(this._documents,$),C);return this._proxy.$registerDeclarationSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDeclaration(C,U,$,W){return this._withAdapter(C,c,ie=>ie.provideDeclaration(i.URI.revive(U),$,W),[],W)}registerImplementationProvider(C,U,$){const W=this._addNewAdapter(new S(this._documents,$),C);return this._proxy.$registerImplementationSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideImplementation(C,U,$,W){return this._withAdapter(C,S,ie=>ie.provideImplementation(i.URI.revive(U),$,W),[],W)}registerTypeDefinitionProvider(C,U,$){const W=this._addNewAdapter(new n(this._documents,$),C);return this._proxy.$registerTypeDefinitionSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideTypeDefinition(C,U,$,W){return this._withAdapter(C,n,ie=>ie.provideTypeDefinition(i.URI.revive(U),$,W),[],W)}registerHoverProvider(C,U,$,W){const ie=this._addNewAdapter(new s(this._documents,$),C);return this._proxy.$registerHoverProvider(ie,this._transformDocumentSelector(U)),this._createDisposable(ie)}$provideHover(C,U,$,W){return this._withAdapter(C,s,ie=>ie.provideHover(i.URI.revive(U),$,W),void 0,W)}registerEvaluatableExpressionProvider(C,U,$,W){const ie=this._addNewAdapter(new f(this._documents,$),C);return this._proxy.$registerEvaluatableExpressionProvider(ie,this._transformDocumentSelector(U)),this._createDisposable(ie)}$provideEvaluatableExpression(C,U,$,W){return this._withAdapter(C,f,ie=>ie.provideEvaluatableExpression(i.URI.revive(U),$,W),void 0,W)}registerInlineValuesProvider(C,U,$,W){const ie=typeof $.onDidChangeInlineValues=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new P(this._documents,$),C);this._proxy.$registerInlineValuesProvider(fe,this._transformDocumentSelector(U),ie);let ye=this._createDisposable(fe);if(ie!==void 0){const le=$.onDidChangeInlineValues(ve=>this._proxy.$emitInlineValuesEvent(ie));ye=F.Disposable.from(ye,le)}return ye}$provideInlineValues(C,U,$,W,ie){return this._withAdapter(C,P,fe=>fe.provideInlineValues(i.URI.revive(U),$,W,ie),void 0,ie)}registerDocumentHighlightProvider(C,U,$){const W=this._addNewAdapter(new T(this._documents,$),C);return this._proxy.$registerDocumentHighlightProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDocumentHighlights(C,U,$,W){return this._withAdapter(C,T,ie=>ie.provideDocumentHighlights(i.URI.revive(U),$,W),void 0,W)}registerLinkedEditingRangeProvider(C,U,$){const W=this._addNewAdapter(new z(this._documents,$),C);return this._proxy.$registerLinkedEditingRangeProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideLinkedEditingRanges(C,U,$,W){return this._withAdapter(C,z,async ie=>{const fe=await ie.provideLinkedEditingRanges(i.URI.revive(U),$,W);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?ue._serializeRegExp(fe.wordPattern):void 0}},void 0,W)}registerReferenceProvider(C,U,$){const W=this._addNewAdapter(new Q(this._documents,$),C);return this._proxy.$registerReferenceSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideReferences(C,U,$,W,ie){return this._withAdapter(C,Q,fe=>fe.provideReferences(i.URI.revive(U),$,W,ie),void 0,ie)}registerCodeActionProvider(C,U,$,W){const ie=new g.DisposableStore,fe=this._addNewAdapter(new Z(this._documents,this._commands.converter,this._diagnostics,$,this._logService,C,this._apiDeprecation),C);return this._proxy.$registerQuickFixSupport(fe,this._transformDocumentSelector(U),{providedKinds:W?.providedCodeActionKinds?.map(ye=>ye.value),documentation:W?.documentation?.map(ye=>({kind:ye.kind.value,command:this._commands.converter.toInternal(ye.command,ie)}))},ue._extLabel(C),Boolean($.resolveCodeAction)),ie.add(this._createDisposable(fe)),ie}$provideCodeActions(C,U,$,W,ie){return this._withAdapter(C,Z,fe=>fe.provideCodeActions(i.URI.revive(U),$,W,ie),void 0,ie)}$resolveCodeAction(C,U,$){return this._withAdapter(C,Z,W=>W.resolveCodeAction(U,$),void 0,void 0)}$releaseCodeActions(C,U){this._withAdapter(C,Z,$=>Promise.resolve($.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(C,U,$){const W=this._addNewAdapter(new H(this._documents,$),C);return this._proxy.$registerDocumentFormattingSupport(W,this._transformDocumentSelector(U),C.identifier,C.displayName||C.name),this._createDisposable(W)}$provideDocumentFormattingEdits(C,U,$,W){return this._withAdapter(C,H,ie=>ie.provideDocumentFormattingEdits(i.URI.revive(U),$,W),void 0,W)}registerDocumentRangeFormattingEditProvider(C,U,$){const W=this._addNewAdapter(new O(this._documents,$),C);return this._proxy.$registerRangeFormattingSupport(W,this._transformDocumentSelector(U),C.identifier,C.displayName||C.name),this._createDisposable(W)}$provideDocumentRangeFormattingEdits(C,U,$,W,ie){return this._withAdapter(C,O,fe=>fe.provideDocumentRangeFormattingEdits(i.URI.revive(U),$,W,ie),void 0,ie)}registerOnTypeFormattingEditProvider(C,U,$,W){const ie=this._addNewAdapter(new m(this._documents,$),C);return this._proxy.$registerOnTypeFormattingSupport(ie,this._transformDocumentSelector(U),W,C.identifier),this._createDisposable(ie)}$provideOnTypeFormattingEdits(C,U,$,W,ie,fe){return this._withAdapter(C,m,ye=>ye.provideOnTypeFormattingEdits(i.URI.revive(U),$,W,ie,fe),void 0,fe)}registerWorkspaceSymbolProvider(C,U){const $=this._addNewAdapter(new L(U,this._logService),C);return this._proxy.$registerNavigateTypeSupport($,typeof U.resolveWorkspaceSymbol=="function"),this._createDisposable($)}$provideWorkspaceSymbols(C,U,$){return this._withAdapter(C,L,W=>W.provideWorkspaceSymbols(U,$),{symbols:[]},$)}$resolveWorkspaceSymbol(C,U,$){return this._withAdapter(C,L,W=>W.resolveWorkspaceSymbol(U,$),void 0,void 0)}$releaseWorkspaceSymbols(C,U){this._withAdapter(C,L,$=>$.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(C,U,$){const W=this._addNewAdapter(new B(this._documents,$,this._logService),C);return this._proxy.$registerRenameSupport(W,this._transformDocumentSelector(U),B.supportsResolving($)),this._createDisposable(W)}$provideRenameEdits(C,U,$,W,ie){return this._withAdapter(C,B,fe=>fe.provideRenameEdits(i.URI.revive(U),$,W,ie),void 0,ie)}$resolveRenameLocation(C,U,$,W){return this._withAdapter(C,B,ie=>ie.resolveRenameLocation(i.URI.revive(U),$,W),void 0,W)}registerDocumentSemanticTokensProvider(C,U,$,W){const ie=this._addNewAdapter(new me(this._documents,$),C),fe=typeof $.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ie,this._transformDocumentSelector(U),W,fe);let ye=this._createDisposable(ie);if(fe){const le=$.onDidChangeSemanticTokens(ve=>this._proxy.$emitDocumentSemanticTokensEvent(fe));ye=F.Disposable.from(ye,le)}return ye}$provideDocumentSemanticTokens(C,U,$,W){return this._withAdapter(C,me,ie=>ie.provideDocumentSemanticTokens(i.URI.revive(U),$,W),null,W)}$releaseDocumentSemanticTokens(C,U){this._withAdapter(C,me,$=>$.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,U,$,W){const ie=this._addNewAdapter(new te(this._documents,$),C);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ie,this._transformDocumentSelector(U),W),this._createDisposable(ie)}$provideDocumentRangeSemanticTokens(C,U,$,W){return this._withAdapter(C,te,ie=>ie.provideDocumentRangeSemanticTokens(i.URI.revive(U),$,W),null,W)}registerCompletionItemProvider(C,U,$,W){const ie=this._addNewAdapter(new oe(this._documents,this._commands.converter,$,this._apiDeprecation,C),C);return this._proxy.$registerCompletionsProvider(ie,this._transformDocumentSelector(U),W,oe.supportsResolving($),`${C.identifier.value}(${W.join("")})`),this._createDisposable(ie)}$provideCompletionItems(C,U,$,W,ie){return this._withAdapter(C,oe,fe=>fe.provideCompletionItems(i.URI.revive(U),$,W,ie),void 0,ie)}$resolveCompletionItem(C,U,$){return this._withAdapter(C,oe,W=>W.resolveCompletionItem(U,$),void 0,$)}$releaseCompletionItems(C,U){this._withAdapter(C,oe,$=>$.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(C,U,$){const W=new we(C,this._documents,$,this._commands.converter),ie=this._addNewAdapter(W,C);return this._proxy.$registerInlineCompletionsSupport(ie,this._transformDocumentSelector(U),W.supportsHandleEvents),this._createDisposable(ie)}$provideInlineCompletions(C,U,$,W,ie){return this._withAdapter(C,ce,fe=>fe.provideInlineCompletions(i.URI.revive(U),$,W,ie),void 0,ie)}$handleInlineCompletionDidShow(C,U,$){this._withAdapter(C,ce,async W=>{W.handleDidShowCompletionItem(U,$)},void 0,void 0)}$handleInlineCompletionPartialAccept(C,U,$,W){this._withAdapter(C,ce,async ie=>{ie.handlePartialAccept(U,$,W)},void 0,void 0)}$freeInlineCompletionsList(C,U){this._withAdapter(C,ce,async $=>{$.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider(C,U,$,W){const ie=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,fe=this._addNewAdapter(new q(this._documents,$),C);return this._proxy.$registerSignatureHelpProvider(fe,this._transformDocumentSelector(U),ie),this._createDisposable(fe)}$provideSignatureHelp(C,U,$,W,ie){return this._withAdapter(C,q,fe=>fe.provideSignatureHelp(i.URI.revive(U),$,W,ie),void 0,ie)}$releaseSignatureHelp(C,U){this._withAdapter(C,q,$=>$.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(C,U,$){const W=typeof $.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new G(this._documents,this._commands.converter,$,this._logService,C),C);this._proxy.$registerInlayHintsProvider(ie,this._transformDocumentSelector(U),typeof $.resolveInlayHint=="function",W,ue._extLabel(C));let fe=this._createDisposable(ie);if(W!==void 0){const ye=$.onDidChangeInlayHints(le=>this._proxy.$emitInlayHintsEvent(W));fe=F.Disposable.from(fe,ye)}return fe}$provideInlayHints(C,U,$,W){return this._withAdapter(C,G,ie=>ie.provideInlayHints(i.URI.revive(U),$,W),void 0,W)}$resolveInlayHint(C,U,$){return this._withAdapter(C,G,W=>W.resolveInlayHint(U,$),void 0,$)}$releaseInlayHints(C,U){this._withAdapter(C,G,$=>$.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(C,U,$){const W=this._addNewAdapter(new de(this._documents,$),C);return this._proxy.$registerDocumentLinkProvider(W,this._transformDocumentSelector(U),typeof $.resolveDocumentLink=="function"),this._createDisposable(W)}$provideDocumentLinks(C,U,$){return this._withAdapter(C,de,W=>W.provideLinks(i.URI.revive(U),$),void 0,$,U.scheme==="output")}$resolveDocumentLink(C,U,$){return this._withAdapter(C,de,W=>W.resolveLink(U,$),void 0,void 0,!0)}$releaseDocumentLinks(C,U){this._withAdapter(C,de,$=>$.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(C,U,$){const W=this._addNewAdapter(new Se(this._documents,$),C);return this._proxy.$registerDocumentColorProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDocumentColors(C,U,$){return this._withAdapter(C,Se,W=>W.provideColors(i.URI.revive(U),$),[],$)}$provideColorPresentations(C,U,$,W){return this._withAdapter(C,Se,ie=>ie.provideColorPresentations(i.URI.revive(U),$,W),void 0,W)}registerFoldingRangeProvider(C,U,$){const W=this._nextHandle(),ie=typeof $.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(W,new ae(new Le(this._documents,$),C)),this._proxy.$registerFoldingRangeProvider(W,this._transformDocumentSelector(U),C.identifier,ie);let fe=this._createDisposable(W);if(ie!==void 0){const ye=$.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ie));fe=F.Disposable.from(fe,ye)}return fe}$provideFoldingRanges(C,U,$,W){return this._withAdapter(C,Le,ie=>ie.provideFoldingRanges(i.URI.revive(U),$,W),void 0,W)}registerSelectionRangeProvider(C,U,$){const W=this._addNewAdapter(new xe(this._documents,$,this._logService),C);return this._proxy.$registerSelectionRangeProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideSelectionRanges(C,U,$,W){return this._withAdapter(C,xe,ie=>ie.provideSelectionRanges(i.URI.revive(U),$,W),[],W)}registerCallHierarchyProvider(C,U,$){const W=this._addNewAdapter(new Te(this._documents,$),C);return this._proxy.$registerCallHierarchyProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$prepareCallHierarchy(C,U,$,W){return this._withAdapter(C,Te,ie=>Promise.resolve(ie.prepareSession(i.URI.revive(U),$,W)),void 0,W)}$provideCallHierarchyIncomingCalls(C,U,$,W){return this._withAdapter(C,Te,ie=>ie.provideCallsTo(U,$,W),void 0,W)}$provideCallHierarchyOutgoingCalls(C,U,$,W){return this._withAdapter(C,Te,ie=>ie.provideCallsFrom(U,$,W),void 0,W)}$releaseCallHierarchy(C,U){this._withAdapter(C,Te,$=>Promise.resolve($.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(C,U,$){const W=this._addNewAdapter(new De(this._documents,$),C);return this._proxy.$registerTypeHierarchyProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$prepareTypeHierarchy(C,U,$,W){return this._withAdapter(C,De,ie=>Promise.resolve(ie.prepareSession(i.URI.revive(U),$,W)),void 0,W)}$provideTypeHierarchySupertypes(C,U,$,W){return this._withAdapter(C,De,ie=>ie.provideSupertypes(U,$,W),void 0,W)}$provideTypeHierarchySubtypes(C,U,$,W){return this._withAdapter(C,De,ie=>ie.provideSubtypes(U,$,W),void 0,W)}$releaseTypeHierarchy(C,U){this._withAdapter(C,De,$=>Promise.resolve($.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(C,U,$){const W=this._nextHandle();return this._adapter.set(W,new ae(new _e(this._proxy,this._documents,$,W),C)),this._proxy.$registerDocumentOnDropEditProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDocumentOnDropEdits(C,U,$,W,ie,fe){return this._withAdapter(C,_e,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(U,i.URI.revive($),W,ie,fe)),void 0,void 0)}registerDocumentPasteEditProvider(C,U,$,W){const ie=this._nextHandle();return this._adapter.set(ie,new ae(new Y(this._proxy,this._documents,$,ie),C)),this._proxy.$registerPasteEditProvider(ie,this._transformDocumentSelector(U),!!$.prepareDocumentPaste,W.pasteMimeTypes),this._createDisposable(ie)}$prepareDocumentPaste(C,U,$,W,ie){return this._withAdapter(C,Y,fe=>fe.prepareDocumentPaste(i.URI.revive(U),$,W,ie),void 0,ie)}$providePasteEdits(C,U,$,W,ie,fe){return this._withAdapter(C,Y,ye=>ye.providePasteEdits(U,i.URI.revive($),W,ie,fe),void 0,fe)}static _serializeRegExp(C){return{pattern:C.source,flags:(0,_.regExpFlags)(C)}}static _serializeIndentationRule(C){return{decreaseIndentPattern:ue._serializeRegExp(C.decreaseIndentPattern),increaseIndentPattern:ue._serializeRegExp(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?ue._serializeRegExp(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?ue._serializeRegExp(C.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(C){return{beforeText:ue._serializeRegExp(C.beforeText),afterText:C.afterText?ue._serializeRegExp(C.afterText):void 0,previousLineText:C.previousLineText?ue._serializeRegExp(C.previousLineText):void 0,action:C.action}}static _serializeOnEnterRules(C){return C.map(ue._serializeOnEnterRule)}setLanguageConfiguration(C,U,$){const{wordPattern:W}=$;if(W&&(0,_.regExpLeadsToEndlessLoop)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this._documents.setWordDefinitionFor(U,W):this._documents.setWordDefinitionFor(U,void 0),$.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),$.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const ie=this._nextHandle(),fe={comments:$.comments,brackets:$.brackets,wordPattern:$.wordPattern?ue._serializeRegExp($.wordPattern):void 0,indentationRules:$.indentationRules?ue._serializeIndentationRule($.indentationRules):void 0,onEnterRules:$.onEnterRules?ue._serializeOnEnterRules($.onEnterRules):void 0,__electricCharacterSupport:$.__electricCharacterSupport,__characterPairSupport:$.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ie,U,fe),this._createDisposable(ie)}$setWordDefinitions(C){for(const U of C)this._documents.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}ue._handlePool=0,e.ExtHostLanguageFeatures=ue}),define(Ie[220],ke([1,0,5,8,7,29,17,6]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(N,y,h,E){this._documents=y,this._commands=h,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=N.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this._languageIds=N}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(N,y){await this._proxy.$changeLanguage(N,y);const h=this._documents.getDocumentData(N);if(!h)throw new Error(`document '${N.toString()}' NOT found`);return h.document}async tokenAtPosition(N,y){const h=N.version,E=k.Position.from(y),g=await this._proxy.$tokensAtPosition(N.uri,E),a={type:D.StandardTokenType.Other,range:N.getWordRangeAtPosition(y)??new D.Range(y.line,y.character,y.line,y.character)};if(!g)return a;const o={range:k.Range.to(g.range),type:k.TokenType.to(g.type)};return!o.range.contains(y)||h!==N.version?a:o}createLanguageStatusItem(N,y,h){const E=this._handlePool++,g=this._proxy,a=this._ids,o=`${N.identifier.value}/${y}`;if(a.has(o))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);a.add(o);const u={selector:h,id:y,name:N.displayName??N.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const w=new A.DisposableStore,R=()=>{p?.dispose(),p=(0,b.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(E,{id:o,name:u.name??N.displayName??N.name,source:N.displayName??N.name,selector:k.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===D.LanguageStatusSeverity.Error?F.default.Error:u.severity===D.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:u.command&&this._commands.toInternal(u.command,w),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},v={dispose(){w.dispose(),p?.dispose(),g.$removeLanguageStatus(E),a.delete(o)},get id(){return u.id},get name(){return u.name},set name(t){u.name=t,R()},get selector(){return u.selector},set selector(t){u.selector=t,R()},get text(){return u.text},set text(t){u.text=t,R()},get detail(){return u.detail},set detail(t){u.detail=t,R()},get severity(){return u.severity},set severity(t){u.severity=t,R()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(t){u.accessibilityInformation=t,R()},get command(){return u.command},set command(t){u.command=t,R()},get busy(){return u.busy},set busy(t){u.busy=t,R()}};return R(),v}}e.ExtHostLanguages=_}),define(Ie[78],ke([1,0,20,10,2,3,12,5,27,18]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(h,E,g){this.logService=g,this.bundleCache=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=h.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===i.LANGUAGE_DEFAULT}getMessage(h,E){const{message:g,args:a,comment:o}=E;if(this.isDefaultLanguage)return(0,k.format2)(g,a??{});let u=g;o&&o.length>0&&(u+=`/${Array.isArray(o)?o.join(""):o}`);const p=this.bundleCache.get(h)?.contents[u];return p||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,k.format2)(p??g,a??{})}getBundle(h){return this.bundleCache.get(h)?.contents}getBundleUri(h){return this.bundleCache.get(h)?.uri}async initializeLocalizedMessages(h){if(this.isDefaultLanguage||!h.l10n&&!h.isBuiltin||this.bundleCache.has(h.identifier.value))return;let E;const g=await this.getBundleLocation(h);if(!g){this.logService.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const a=await this._proxy.$fetchBundleContents(g),o=JSON.parse(a);E=h.isBuiltin?o.contents?.bundle:o}catch(a){this.logService.error(`Failed to load translations for ${h.identifier.value} from ${g}: ${a.message}`);return}E&&this.bundleCache.set(h.identifier.value,{contents:E,uri:g})}async getBundleLocation(h){if(h.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(h.identifier.value,this.currentLanguage);return D.URI.revive(E)}return h.l10n?D.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};N=Ve([We(0,_.IExtHostInitDataService),We(1,I.IExtHostRpcService),We(2,b.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(Ie[221],ke([1,0,12,5,27,18,2,66]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let _=class extends i.AbstractLoggerService{constructor(y,h){super(h.logLevel,h.loggers.map(E=>(0,A.revive)(E))),this._proxy=y.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(y,h){h?this.setLogLevel(b.URI.revive(h),y):this.setLogLevel(y)}setVisibility(y,h){super.setVisibility(y,h),this._proxy.$setVisibility(y,h)}doCreateLogger(y,h,E){return new I(this._proxy,y,h,E)}};_=Ve([We(0,F.IExtHostRpcService),We(1,D.IExtHostInitDataService)],_),e.ExtHostLoggerService=_;class I extends i.AbstractMessageLogger{constructor(y,h,E,g){super(g?.logLevel==="always"),this.proxy=y,this.file=h,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.proxy.$createLogger(h,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,h){const E=[[y,h]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(y){this.proxy.$log(this.file,y)}}}),define(Ie[222],ke([1,0,5,12,25]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(A){return A&&A.title}let b=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(i.MainContext.MainThreadMessageService)}showMessage(_,I,N,y,h){const E={source:{identifier:_.identifier,label:_.displayName||_.name}};let g;typeof y=="string"||F(y)?g=[y,...h]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,g=h),E.useCustom&&(0,D.checkProposedApiEnabled)(_,"resolvers");const a=[];for(let o=0;o<g.length;o++){const u=g[o];if(typeof u=="string")a.push({title:u,handle:o,isCloseAffordance:!1});else if(typeof u=="object"){const{title:p,isCloseAffordance:w}=u;a.push({title:p,isCloseAffordance:!!w,handle:o})}else this._logService.warn("Invalid message item:",u)}return this._proxy.$showMessage(I,N,E,a).then(o=>{if(typeof o=="number")return g[o]})}};b=Ve([We(1,k.ILogService)],b),e.ExtHostMessageService=b}),define(Ie[223],ke([1,0,23,4,6,28,10,9,2,54,5,37,8,7,46,197,100]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}constructor(w,R,v,t){this._textDocumentsAndEditors=v,this._textDocuments=t,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=w.getProxy(N.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(N.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(N.MainContext.MainThreadNotebookEditors),this._commandsConverter=R.converter,R.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const r=d.notebookEditor?.notebookUri,l=d.cell.handle,S=this._documents.get(r)?.getCell(l);if(S)return S.apiCell}if(d&&d.$mid===14){const r=d.uri,l=this._documents.get(r);if(l)return l.apiNotebook}return d}}),u._registerApiCommands(R)}getEditorById(w){const R=this._editors.get(w);if(!R)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return R}getIdByEditor(w){for(const[R,v]of this._editors)if(v.apiEditor===w)return R}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,R){const v=this._documents.get(w);if(!v&&!R)throw new Error(`NO notebook document for '${w}'`);return v}static _convertNotebookRegistrationData(w,R){if(!R)return;const v=R.filenamePattern.map(t=>h.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(R.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${R.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:R.displayName,filenamePattern:v,exclusive:R.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,R,v){const t=u._notebookStatusBarItemProviderHandlePool++,d=typeof v.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,d,R);let r;return d!==void 0&&(r=v.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(d))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,d),r?.dispose()})}async createNotebookDocument(w){const R=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&h.NotebookData.from(w.content)});return _.URI.revive(R)}async openNotebookDocument(w){const R=this._documents.get(w);if(R)return R.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(w),t=this._documents.get(_.URI.revive(v));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(w,R){_.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let v;typeof R=="object"?v={position:h.ViewColumn.from(R.viewColumn),preserveFocus:R.preserveFocus,selections:R.selections&&R.selections.map(h.NotebookRange.from),pinned:typeof R.preview=="boolean"?!R.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,v),d=t&&this._editors.get(t)?.apiEditor;if(d)return d;throw t?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,R,v,t){const d=this._notebookStatusBarItemProviders.get(w),r=_.URI.revive(R),l=this._documents.get(r);if(!l||!d)return;const c=l.getCellFromIndex(v);if(!c)return;const S=await d.provideCellStatusBarItems(c.apiCell,t);if(!S)return;const n=new D.DisposableStore,s=this._statusBarCache.add([n]),P=(Array.isArray(S)?S:[S]).map(T=>h.NotebookStatusBarItem.from(T,this._commandsConverter,n));return{cacheId:s,items:P}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,R,v,t,d){if((0,b.isFalsyOrWhitespace)(R))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,v),this._notebookProxy.$registerNotebookSerializer(r,{id:w.identifier,location:w.extensionLocation},R,h.NotebookDocumentContentOptions.from(t),u._convertNotebookRegistrationData(w,d)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(w,R,v){const t=this._notebookSerializer.get(w);if(!t)throw new Error("NO serializer found");const d=await t.deserializeNotebook(R.buffer,v);return new g.SerializableObjectWithBuffers(h.NotebookData.from(d))}async $notebookToData(w,R,v){const t=this._notebookSerializer.get(w);if(!t)throw new Error("NO serializer found");const d=await t.serializeNotebook(h.NotebookData.to(R.value),v);return i.VSBuffer.wrap(d)}_createExtHostEditor(w,R,v){if(this._editors.has(R))throw new Error(`editor with id ALREADY EXSIST: ${R}`);const t=new o.ExtHostNotebookEditor(R,this._notebookEditorsProxy,w,v.visibleRanges.map(h.NotebookRange.to),v.selections.map(h.NotebookRange.to),typeof v.viewColumn=="number"?h.ViewColumn.to(v.viewColumn):void 0);this._editors.set(R,t)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const v of w.value.removedDocuments){const t=_.URI.revive(v),d=this._documents.get(t);d&&(d.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(d.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(w.value.addedDocuments){const v=[];for(const t of w.value.addedDocuments){const d=_.URI.revive(t.uri);if(this._documents.has(d))throw new Error(`adding EXISTING notebook ${d} `);const r=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,d,t);v.push(...t.cells.map(l=>a.ExtHostCell.asModelAddData(r.apiNotebook,l))),this._documents.get(d)?.dispose(),this._documents.set(d,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(w.value.addedEditors)for(const v of w.value.addedEditors){if(this._editors.has(v.id))return;const t=_.URI.revive(v.documentUri),d=this._documents.get(t);d&&this._createExtHostEditor(d,v.id,v)}const R=[];if(w.value.removedEditors)for(const v of w.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),R.push(t))}if(w.value.visibleEditors){this._visibleNotebookEditors=w.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const d=v.has(t.id);t._acceptVisibility(d)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this._activeNotebookEditor=void 0:w.value.newActiveEditor&&(this._editors.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(w){const R=y.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new y.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[R,new y.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>i.VSBuffer.wrap(d))],new y.ApiCommandResult("Notebook Data",d=>h.NotebookData.to(d.value))),t=new y.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[R,new y.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new g.SerializableObjectWithBuffers(h.NotebookData.from(d)))],new y.ApiCommandResult("Bytes",d=>d.buffer));w.registerApiCommand(v),w.registerApiCommand(t)}}u._notebookStatusBarItemProviderHandlePool=0,e.ExtHostNotebookController=u}),define(Ie[224],ke([1,0,16,17,21,4,6,28,2,26,12,54,5,37,8,7,73,187,25,46]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let R=class{constructor(c,S,n,s,f){this._initData=S,this._extHostNotebook=n,this._commands=s,this._logService=f,this._activeExecutions=new A.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new y.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=c.getProxy(h.MainContext.MainThreadNotebookKernels);const P=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const z=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:z}}else if(T&&"notebookEditor"in T){const z=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return T})],E.ApiCommandResult.Void);this._commands.registerApiCommand(P)}createNotebookController(c,S,n,s,f,P){for(const ce of this._kernelData.values())if(ce.controller.id===S&&I.ExtensionIdentifier.equals(c.identifier,ce.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const T=this._handlePool++,z=this;this._logService.trace(`NotebookController[${T}], CREATED by ${c.identifier.value}, ${S}`);const Q=()=>console.warn(`NO execute handler from notebook controller '${m.id}' of extension: '${c.identifier}'`);let Z=!1;const Y=new b.DisposableStore,H=new F.Emitter,O=new F.Emitter,m={id:r(c.identifier,S),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:s||c.identifier.value,preloads:P?P.map(g.NotebookRendererScript.from):[]};let L=f??Q,B;this._proxy.$addKernel(T,m).catch(ce=>{console.log(ce),Z=!0});let J=0;const me=()=>{if(Z)return;const ce=++J;Promise.resolve().then(()=>{ce===J&&this._proxy.$updateKernel(T,m)})},te=new A.ResourceMap,oe={get id(){return S},get notebookType(){return m.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return m.label},set label(ce){m.label=ce??c.displayName??c.name,me()},get detail(){return m.detail??""},set detail(ce){m.detail=ce,me()},get description(){return m.description??""},set description(ce){m.description=ce,me()},get kind(){return(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),m.kind??""},set kind(ce){(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),m.kind=ce,me()},get supportedLanguages(){return m.supportedLanguages},set supportedLanguages(ce){m.supportedLanguages=ce,me()},get supportsExecutionOrder(){return m.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){m.supportsExecutionOrder=ce,me()},get rendererScripts(){return m.preloads?m.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return L},set executeHandler(ce){L=ce??Q},get interruptHandler(){return B},set interruptHandler(ce){B=ce,m.supportsInterrupt=Boolean(ce),me()},createNotebookCellExecution(ce){if(Z)throw new Error("notebook controller is DISPOSED");if(!te.has(ce.notebook.uri))throw z._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(te.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return z._createNotebookCellExecution(ce,r(c.identifier,this.id))},dispose:()=>{Z||(this._logService.trace(`NotebookController[${T}], DISPOSED`),Z=!0,this._kernelData.delete(T),Y.dispose(),H.dispose(),O.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(ce,we){we===a.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),z._proxy.$updateNotebookPriority(T,ce.uri,we)},onDidReceiveMessage:O.event,postMessage(ce,we){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),z._proxy.$postMessage(T,we&&z._extHostNotebook.getIdByEditor(we),ce)},asWebviewUri(ce){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),(0,o.asWebviewUri)(ce,z._initData.remote)}};return this._kernelData.set(T,{extensionId:c.identifier,controller:oe,onDidReceiveMessage:O,onDidChangeSelection:H,associatedNotebooks:te}),oe}getIdByController(c){for(const[S,n]of this._kernelData)if(n.controller===c)return r(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,S){const n=this._kernelDetectionTaskHandlePool++,s=this;this._logService.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelDetectionTask(n,S);const f={dispose:()=>{this._kernelDetectionTask.delete(n),s._proxy.$removeKernelDetectionTask(n)}};return this._kernelDetectionTask.set(n,f),f}registerKernelSourceActionProvider(c,S,n){const s=this._kernelSourceActionProviderHandlePool++,f=typeof n.onDidChangeNotebookKernelSourceActions=="function"?s:void 0,P=this;this._kernelSourceActionProviders.set(s,n),this._logService.trace(`NotebookKernelSourceActionProvider[${s}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelSourceActionProvider(s,s,S);let T;return f!==void 0&&(T=n.onDidChangeNotebookKernelSourceActions(z=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this._kernelSourceActionProviders.delete(s),P._proxy.$removeKernelSourceActionProvider(s,s),T?.dispose()}}}async $provideKernelSourceActions(c,S){const n=this._kernelSourceActionProviders.get(c);if(n){const s=new b.DisposableStore;return this._kernelSourceActionProviderCache.add([s]),(await n.provideNotebookKernelSourceActions(S)??[]).map(P=>g.NotebookKernelSourceAction.from(P,this._commands.converter,s))}return[]}$acceptNotebookAssociation(c,S,n){const s=this._kernelData.get(c);if(s){const f=this._extHostNotebook.getNotebookDocument(_.URI.revive(S));n?s.associatedNotebooks.set(f.uri,!0):s.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,f.uri.toString(),n),s.onDidChangeSelection.fire({selected:n,notebook:f.apiNotebook})}}async $executeCells(c,S,n){const s=this._kernelData.get(c);if(!s)return;const f=this._extHostNotebook.getNotebookDocument(_.URI.revive(S)),P=[];for(const T of n){const z=f.getCell(T);z&&P.push(z.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,f.uri.toString(),P.length),await s.controller.executeHandler.call(s.controller,P,f.apiNotebook,s.controller)}catch(T){this._logService.error(`NotebookController[${c}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(c,S,n){const s=this._kernelData.get(c);if(!s)return;const f=this._extHostNotebook.getNotebookDocument(_.URI.revive(S));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,f.apiNotebook);else for(const P of n){const T=f.getCell(P);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,S,n){const s=this._kernelData.get(c);if(!s)return;const f=this._extHostNotebook.getEditorById(S);s.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:n}))}$cellExecutionChanged(c,S,n){const f=this._extHostNotebook.getNotebookDocument(_.URI.revive(c)).getCell(S);if(f){const P=n?g.NotebookCellExecutionState.to(n):a.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:P})}}_createNotebookCellExecution(c,S){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const f=new t(S,s,this._proxy);this._activeExecutions.set(s.uri,f);const P=f.onDidChangeState(()=>{f.state===v.Resolved&&(f.dispose(),P.dispose(),this._activeExecutions.delete(s.uri))});return f.asApiObject()}};R=Ve([We(4,N.ILogService)],R),e.ExtHostNotebookKernels=R;var v;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(v||(v={}));class t extends b.Disposable{get state(){return this._state}constructor(c,S,n){super(),this._cell=S,this._proxy=n,this._handle=t.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new d(10,s=>this.update(s)),this._executionOrder=S.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,c,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(c){await this._collector.addItem(c)}async update(c){const S=Array.isArray(c)?c:[c];return this._proxy.$updateExecution(this._handle,new w.SerializableObjectWithBuffers(S))}verifyStateForOutput(){if(this._state===v.Init)throw new Error("Must call start before modifying cell output");if(this._state===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(c){let S=this._cell;if(c&&(S=this._cell.notebook.getCellFromApiCell(c)),!S)throw new Error("INVALID cell");return S.handle}validateAndConvertOutputs(c){return c.map(S=>{const n=a.NotebookCellOutput.ensureUniqueMimeTypes(S.items,!0);return n===S.items?g.NotebookCellOutput.from(S):g.NotebookCellOutput.from({items:n,id:S.id,metadata:S.metadata})})}async updateOutputs(c,S,n){const s=this.cellIndexToHandle(S),f=this.validateAndConvertOutputs((0,i.asArray)(c));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:s,append:n,outputs:f})}async updateOutputItems(c,S,n){return c=a.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(c),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:c.map(g.NotebookCellOutputItem.from),outputId:S.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c._tokenSource.token},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(n){c._executionOrder=n,c.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:c._executionOrder}])},start(n){if(c._state===v.Resolved||c._state===v.Started)throw new Error("Cannot call start again");c._state=v.Started,c._onDidChangeState.fire(),c.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,s){if(c._state===v.Resolved)throw new Error("Cannot call resolve twice");c._state=v.Resolved,c._onDidChangeState.fire(),c._collector.flush(),c._proxy.$completeExecution(c._handle,new w.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:n}))},clearOutput(n){return c.verifyStateForOutput(),c.updateOutputs([],n,!1)},appendOutput(n,s){return c.verifyStateForOutput(),c.updateOutputs(n,s,!0)},replaceOutput(n,s){return c.verifyStateForOutput(),c.updateOutputs(n,s,!1)},appendOutputItems(n,s){return c.verifyStateForOutput(),c.updateOutputItems(n,s,!0)},replaceOutputItems(n,s){return c.verifyStateForOutput(),c.updateOutputItems(n,s,!1)}})}}t.HANDLE=0;class d{constructor(c,S){this.delay=c,this.callback=S,this.batch=[],this.startedTimer=Date.now()}addItem(c){return this.batch.push(c),this.currentDeferred||(this.currentDeferred=new k.DeferredPromise,this.startedTimer=Date.now(),(0,k.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const c=this.currentDeferred;this.currentDeferred=void 0;const S=this.batch;return this.batch=[],this.callback(S).finally(()=>c.complete())}}function r(l,c){return`${l.value}/${c}`}e.createKernelId=r}),define(Ie[225],ke([1,0,4,5,100]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(A,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,_,I){const N=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(_)?.fire({editor:N.apiEditor,message:I})}createRendererMessaging(A,_){if(!A.contributes?.notebookRenderer?.some(N=>N.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);return{onDidReceiveMessage:(N,y,h)=>this.getOrCreateEmitterFor(_).event(N,y,h),postMessage:(N,y)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,y]=[y,N]);const h=y&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(h?.id,_,N)}}}getOrCreateEmitterFor(A){let _=this._rendererMessageEmitters.get(A);return _||(_=new i.Emitter({onDidRemoveLastListener:()=>{_?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,_),_)}}e.ExtHostNotebookRenderers=F}),define(Ie[226],ke([1,0,6,9,2,25,5]),function(ne,e,i,k,D,F,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(I){this.handlers=new Map,this.proxy=I.getProxy(b.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,N,y){if((0,F.checkProposedApiEnabled)(I,"profileContentHandlers"),this.handlers.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.handlers.set(N,y),this.proxy.$registerProfileContentHandler(N,y.name,y.description,I.identifier.value),(0,i.toDisposable)(()=>{this.handlers.delete(N),this.proxy.$unregisterProfileContentHandler(N)})}async $saveProfile(I,N,y,h){const E=this.handlers.get(I);if(!E)throw new Error(`Unknown handler with id: ${I}`);return E.saveProfile(N,y,h)}async $readProfile(I,N,y){const h=this.handlers.get(I);if(!h)throw new Error(`Unknown handler with id: ${I}`);return h.readProfile((0,k.isString)(N)?N:D.URI.revive(N),y)}}e.ExtHostProfileContentHandlers=A}),define(Ie[227],ke([1,0,2,5,17,8]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class b{constructor(_,I){this.uriTransformer=I,this.providers=new Map,this.proxy=_.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(_,I,N){const y=i.URI.revive(I),h=this.providers.get(_);return h?(0,D.asPromise)(()=>h.provideOriginalResource(y,N)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(_,I,N,y){const h=b.handlePool++;return this.providers.set(h,I),this.proxy.$registerQuickDiffProvider(h,F.DocumentSelector.from(_,this.uriTransformer),N,y),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(h),this.providers.delete(h)}}}}b.handlePool=0,e.ExtHostQuickDiff=b}),define(Ie[228],ke([1,0,21,4,6,5,2,7,11,16,29,38,25,8]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(a,o,u){const p=a.getProxy(F.MainContext.MainThreadQuickOpen);class w{constructor(n,s){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=s}showQuickPick(n,s,f,P=i.CancellationToken.None){this._onDidSelectItem=void 0;const T=Promise.resolve(s),z=++this._instances,Q=p.$show(z,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},P),Z={},Y=Q.then(()=>Z);return Promise.race([Y,T]).then(H=>{if(H===Z)return;const O=(0,h.isProposedApiEnabled)(n,"quickPickItemTooltip");return T.then(m=>{const L=[];for(let B=0;B<m.length;B++){const J=m[B];typeof J=="string"?L.push({label:J,handle:B}):J.kind===A.QuickPickItemKind.Separator?L.push({type:"separator",label:J.label}):(J.tooltip&&!O&&console.warn(`Extension '${n.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${n.identifier.value}`),L.push({label:J.label,description:J.description,detail:J.detail,picked:J.picked,alwaysShow:J.alwaysShow,tooltip:O?E.MarkdownString.fromStrict(J.tooltip):void 0,handle:B}))}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{f.onDidSelectItem(m[B])}),p.$setItems(z,L),Q.then(B=>{if(typeof B=="number")return m[B];if(Array.isArray(B))return B.map(J=>m[J])})})}).then(void 0,H=>{if(!(0,_.isCancellationError)(H))return p.$setError(z,H),Promise.reject(H)})}$onItemSelected(n){this._onDidSelectItem?.(n)}showInput(n,s=i.CancellationToken.None){return this._validateInput=n?.validateInput,p.$input(n,typeof this._validateInput=="function",s).then(void 0,f=>{if(!(0,_.isCancellationError)(f))return Promise.reject(f)})}async $validateInput(n){if(!this._validateInput)return;const s=await this._validateInput(n);if(!s||typeof s=="string")return s;let f;switch(s.severity){case A.InputBoxValidationSeverity.Info:f=N.default.Info;break;case A.InputBoxValidationSeverity.Warning:f=N.default.Warning;break;case A.InputBoxValidationSeverity.Error:f=N.default.Error;break;default:f=s.message?N.default.Error:N.default.Ignore;break}return{content:s.message,severity:f}}async showWorkspaceFolderPick(n,s=i.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!f)return;const P=await this._workspace.getWorkspaceFolders2();if(!!P)return P.find(T=>T.uri.toString()===f.uri.toString())}createQuickPick(n){const s=new l(n,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}createInputBox(n){const s=new c(n,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(n,s){this._sessions.get(n)?._fireDidChangeValue(s)}$onDidAccept(n){this._sessions.get(n)?._fireDidAccept()}$onDidChangeActive(n,s){const f=this._sessions.get(n);f instanceof l&&f._fireDidChangeActive(s)}$onDidChangeSelection(n,s){const f=this._sessions.get(n);f instanceof l&&f._fireDidChangeSelection(s)}$onDidTriggerButton(n,s){this._sessions.get(n)?._fireDidTriggerButton(s)}$onDidTriggerItemButton(n,s,f){const P=this._sessions.get(n);P instanceof l&&P._fireDidTriggerItemButton(s,f)}$onDidHide(n){this._sessions.get(n)?._fireDidHide()}}class R{constructor(n,s){this._extensionId=n,this._onDidDispose=s,this._id=l._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((s,f)=>{const P=s===A.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(P,s)}),this.update({buttons:n.map((s,f)=>({...r(s),tooltip:s.tooltip,handle:s===A.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const s=this._handlesToButtons.get(n);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(n){if(!this._disposed){for(const s of Object.keys(n)){const f=n[s];this._pendingUpdate[s]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}R._nextId=1;function v(S){if(S instanceof A.ThemeIcon)return{id:S.id};const n=d(S),s=t(S);return{dark:typeof n=="string"?b.URI.file(n):n,light:typeof s=="string"?b.URI.file(s):s}}function t(S){return typeof S=="object"&&"light"in S?S.light:S}function d(S){return typeof S=="object"&&"dark"in S?S.dark:S}function r(S){const n=v(S.iconPath);let s,f;return"id"in n?f=y.ThemeIcon.asClassName(n):s=n,{iconPath:s,iconClass:f}}class l extends R{constructor(n,s){super(n.identifier,s),this.extension=n,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((P,T)=>{this._handlesToItems.set(T,P),this._itemsToHandles.set(P,T)});const s=(0,h.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),f=[];for(let P=0;P<n.length;P++){const T=n[P];T.kind===A.QuickPickItemKind.Separator?f.push({type:"separator",label:T.label}):(T.tooltip&&!s&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),f.push({handle:P,label:T.label,description:T.description,detail:T.detail,picked:T.picked,alwaysShow:T.alwaysShow,tooltip:s?E.MarkdownString.fromStrict(T.tooltip):void 0,buttons:T.buttons?.map((z,Q)=>({...r(z),tooltip:z.tooltip,handle:Q}))}))}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(n){const s=(0,I.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(n){const s=(0,I.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}_fireDidTriggerItemButton(n,s){const f=this._handlesToItems.get(n);if(!f||!f.buttons||!f.buttons.length)return;const P=f.buttons[s];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:f})}}class c extends R{constructor(n,s){super(n.identifier,s),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get valueSelection(){return this._valueSelection}set valueSelection(n){this._valueSelection=n,this.update({valueSelection:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:N.default.Error}):this.update({validationMessage:n.message,severity:n.severity??N.default.Error}):this.update({validationMessage:void 0,severity:N.default.Ignore})}}return new w(o,u)}e.createExtHostQuickOpen=g});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i};define(Ie[229],ke([1,0,2,4,64,6,17,5,16,123,12,26,38,8,25]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g){"use strict";var a,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(s){if(s)return typeof s.iconPath=="string"?i.URI.file(s.iconPath):i.URI.isUri(s.iconPath)||h.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function p(s,f){if(!s.iconPath&&!f.iconPath)return 0;if(s.iconPath){if(!f.iconPath)return 1}else return-1;const P=typeof s.iconPath=="string"?s.iconPath:i.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,T=typeof f.iconPath=="string"?f.iconPath:i.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,I.comparePaths)(P,T)}function w(s,f){let P=0;if(s.strikeThrough!==f.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==f.faded)return s.faded?1:-1;if(s.tooltip!==f.tooltip)return(s.tooltip||"").localeCompare(f.tooltip||"");if(P=p(s,f),P!==0)return P;if(s.light&&f.light)P=p(s.light,f.light);else{if(s.light)return 1;if(f.light)return-1}if(P!==0)return P;if(s.dark&&f.dark)P=p(s.dark,f.dark);else{if(s.dark)return 1;if(f.dark)return-1}return P}function R(s,f){if(s.command!==f.command)return s.command<f.command?-1:1;if(s.title!==f.title)return s.title<f.title?-1:1;if(s.tooltip!==f.tooltip){if(s.tooltip!==void 0&&f.tooltip!==void 0)return s.tooltip<f.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(s.arguments===f.arguments)return 0;if(s.arguments)if(f.arguments){if(s.arguments.length!==f.arguments.length)return s.arguments.length-f.arguments.length}else return 1;else return-1;for(let P=0;P<s.arguments.length;P++){const T=s.arguments[P],z=f.arguments[P];if(T!==z)return T<z?-1:1}return 0}function v(s,f){let P=(0,I.comparePaths)(s.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(P!==0)return P;if(s.command&&f.command)P=R(s.command,f.command);else{if(s.command)return 1;if(f.command)return-1}if(P!==0)return P;if(s.decorations&&f.decorations)P=w(s.decorations,f.decorations);else{if(s.decorations)return 1;if(f.decorations)return-1}return P}function t(s,f){for(let P=0;P<s.length;P++)if(s[P]!==f[P])return!1;return!0}function d(s,f){return s.command===f.command&&s.title===f.title&&s.tooltip===f.tooltip&&(s.arguments&&f.arguments?t(s.arguments,f.arguments):s.arguments===f.arguments)}function r(s,f){return(0,_.equals)(s,f,d)}class l{get value(){return this._value}set value(f){f=f??"",Oe(this,a,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Oe(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Oe(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get enabled(){return this._enabled}set enabled(f){f=!!f,this._enabled!==f&&(this._enabled=f,Oe(this,a,"f").$setInputBoxEnablement(this._sourceControlHandle,f))}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Oe(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}constructor(f,P,T){this._extension=f,this._sourceControlHandle=T,a.set(this,void 0),this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,a,P,"f")}showValidationMessage(f,P){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,a,"f").$showValidationMessage(this._sourceControlHandle,f,P)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=l,a=new WeakMap;class c{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}constructor(f,P,T,z,Q){this._proxy=f,this._commands=P,this._sourceControlHandle=T,this._id=z,this._label=Q,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,P){const T=this._resourceStatesCommandsMap.get(f);return T?(0,b.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(v),T=(0,_.sortedDiff)(this._resourceSnapshot,f,v).map(Z=>{const Y=Z.toInsert.map(H=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,H);const m=H.resourceUri;let L;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const G=new F.DisposableStore;L=this._commands.converter.toInternal(H.command,G),this._resourceStatesDisposablesMap.set(O,G)}else this._resourceStatesCommandsMap.set(O,H.command);const B=u(H.decorations),J=H.decorations&&u(H.decorations.light)||B,me=H.decorations&&u(H.decorations.dark)||B,te=[J,me],oe=H.decorations&&H.decorations.tooltip||"",ce=H.decorations&&!!H.decorations.strikeThrough,we=H.decorations&&!!H.decorations.faded,V=H.contextValue||"";return{rawResource:[O,m,te,oe,ce,we,V,L],handle:O}});return{start:Z.start,deleteCount:Z.deleteCount,toInsert:Y}}),z=T.map(({start:Z,deleteCount:Y,toInsert:H})=>[Z,Y,H.map(O=>O.rawResource)]),Q=T.reverse();for(const{start:Z,deleteCount:Y,toInsert:H}of Q){const O=H.map(L=>L.handle),m=this._handlesSnapshot.splice(Z,Y,...O);for(const L of m)this._resourceStatesMap.delete(L),this._resourceStatesCommandsMap.delete(L),this._resourceStatesDisposablesMap.get(L)?.dispose(),this._resourceStatesDisposablesMap.delete(L)}return this._resourceSnapshot=f,z}dispose(){this._disposed=!0,this._onDidDispose.fire()}}c._handlePool=0;class S{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Oe(this,o,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f;let P;(0,g.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(P=f?.label),Oe(this,o,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f,quickDiffLabel:P})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Oe(this,o,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new F.DisposableStore,this._acceptInputCommand=f;const P=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Oe(this,o,"f").$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new F.DisposableStore,this._actionButton=f;const P=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),secondaryCommands:f.secondaryCommands?.map(T=>T.map(z=>this._commands.converter.toInternal(z,this._actionButtonDisposables.value))),description:f.description,enabled:f.enabled}:void 0;Oe(this,o,"f").$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&r(this._statusBarCommands,f))return;this._statusBarDisposables.value=new F.DisposableStore,this._statusBarCommands=f;const P=(f||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));Oe(this,o,"f").$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}constructor(f,P,T,z,Q,Z){this._extension=f,this._commands=T,this._id=z,this._label=Q,this._rootUri=Z,o.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new F.MutableDisposable,this._statusBarDisposables=new F.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=S._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,o,P,"f"),this._inputBox=new l(f,Oe(this,o,"f"),this.handle),Oe(this,o,"f").$registerSourceControl(this.handle,z,Q,Z)}createResourceGroup(f,P){const T=new c(Oe(this,o,"f"),this._commands,this.handle,f,P),z=k.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,z),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const f=[],P=[];for(const[T,z]of this.createdResourceGroups){z.dispose();const Q=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});k.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),Q.dispose(),this._groups.delete(T.handle),Oe(this,o,"f").$unregisterGroup(this.handle,T.handle)}),f.push([T.handle,T.id,T.label,T.features]);const Z=T._takeResourceStateSnapshot();Z.length>0&&P.push([T.handle,Z]),this._groups.set(T.handle,T)}Oe(this,o,"f").$registerGroups(this.handle,f,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(P=>{const T=P._takeResourceStateSnapshot();T.length!==0&&f.push([P.handle,T])}),f.length>0&&Oe(this,o,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Oe(this,o,"f").$unregisterSourceControl(this.handle)}}o=new WeakMap,S._handlePool=0,Ve([(0,D.debounce)(100)],S.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(f,P,T){this._commands=P,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=f.getProxy(A.MainContext.MainThreadSCM),this._telemetry=f.getProxy(A.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const Q=this._sourceControls.get(z.sourceControlHandle);if(!Q)return z;const Z=Q.getResourceGroup(z.groupHandle);return Z?Z.getResourceState(z.handle):z}else if(z&&z.$mid===4){const Q=this._sourceControls.get(z.sourceControlHandle);return Q?Q.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const Q=this._sourceControls.get(z.handle);return Q||z}return z}})}createSourceControl(f,P,T,z){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,P,T,z),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const Q=on._handlePool++,Z=new S(f,this._proxy,this._commands,P,T,z);this._sourceControls.set(Q,Z);const Y=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(f.identifier))||[];return Y.push(Z),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(f.identifier),Y),Z}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const P=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(f.identifier)),T=P&&P[P.length-1];return T&&T.inputBox}$provideOriginalResource(f,P,T){const z=i.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,z.toString());const Q=this._sourceControls.get(f);return!Q||!Q.quickDiffProvider||!Q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,b.asPromise)(()=>Q.quickDiffProvider.provideOriginalResource(z,T)).then(Z=>Z||null)}$onInputBoxValueChange(f,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const T=this._sourceControls.get(f);return T&&T.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(f,P,T,z){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,P,T);const Q=this._sourceControls.get(f);if(!Q)return Promise.resolve(void 0);const Z=Q.getResourceGroup(P);return Z?Z.$executeResourceCommand(T,z):Promise.resolve(void 0)}$validateInput(f,P,T){this.logService.trace("ExtHostSCM#$validateInput",f);const z=this._sourceControls.get(f);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,b.asPromise)(()=>z.inputBox.validateInput(P,T)).then(Q=>{if(!Q)return Promise.resolve(void 0);const Z=E.MarkdownString.fromStrict(Q.message);return Z?Promise.resolve([Z,Q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([We(2,N.ILogService)],n),e.ExtHostSCM=n}),define(Ie[79],ke([1,0,5,4,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(A){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,_){return this._proxy.$getPassword(A,_)}store(A,_,I){return this._proxy.$setPassword(A,_,I)}delete(A,_){return this._proxy.$deletePassword(A,_)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[230],ke([1,0,7,5,142,6,8,9]),function(ne,e,i,k,D,F,b,A){"use strict";var _,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(g,a,o,u,p=i.StatusBarAlignment.Left,w){_.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new F.DisposableStore,Je(this,_,g,"f"),Je(this,I,a,"f"),this._entryId=N.ID_GEN++,this._extension=o,this._id=u,this._alignment=p,this._priority=this.validatePriority(w)}validatePriority(g){if(!!(0,A.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!N.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new F.DisposableStore,typeof g=="string"?this._command={fromApi:g,internal:Oe(this,I,"f").toInternal({title:"",command:g},this._latestCommandRegistration)}:g?this._command={fromApi:g,internal:Oe(this,I,"f").toInternal(g,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let a;this._name?a=this._name:a=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let o=this._color;this._backgroundColor&&(o=N.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const u=b.MarkdownString.fromStrict(this._tooltip);Oe(this,_,"f").$setEntry(this._entryId,g,a,this._text,u,this._command?.internal,o,this._backgroundColor,this._alignment===i.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}_=new WeakMap,I=new WeakMap,N.ID_GEN=0,N.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=N;class y{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const a={message:g};return this._messages.unshift(a),this._update(),new i.Disposable(()=>{const o=this._messages.indexOf(a);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class h{constructor(g,a){this._proxy=g.getProxy(k.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new y(this)}createStatusBarEntry(g,a,o,u){return new N(this._proxy,this._commands,g,a,o,u)}setStatusBarMessage(g,a){const o=this._statusMessage.setMessage(g);let u;return typeof a=="number"?u=setTimeout(()=>o.dispose(),a):typeof a<"u"&&a.then(()=>o.dispose(),()=>o.dispose()),new i.Disposable(()=>{o.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=h}),define(Ie[80],ke([1,0,5,4,3]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(A,_){this._logService=_,this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,_){this._proxy.$registerExtensionStorageKeysToSync(A,_)}async initializeExtensionStorage(A,_,I){const N=await this._proxy.$initializeExtensionStorage(A,_);let y;return N&&(y=this.safeParseValue(A,_,N)),y||I}setValue(A,_,I){return this._proxy.$setValue(A,_,I)}$acceptValue(A,_,I){const N=this.safeParseValue(A,_,I);N&&this._onDidChangeStorage.fire({shared:A,key:_,value:N})}safeParseValue(A,_,I){try{return JSON.parse(I)}catch(N){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${_}, global: ${A}): ${N}`)}}}e.ExtHostStorage=F,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ie[81],ke([1,0,3,27,12,60,2]),function(ne,e,i,k,D,F,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let A=class{constructor(I,N,y){this._logService=N,this._extHostFileSystem=y,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getWorkspaceStorageURI(I){return b.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,N=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(b.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:b.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(I){if(this._value)return b.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return b.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Ve([We(0,k.IExtHostInitDataService),We(1,D.ILogService),We(2,F.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ie[61],ke([1,0,4,5,3,2,18,6,7,144,11,171,21,34,172,38,9,17,8]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class w{constructor(n,s,f,P){this._proxy=n,this._id=s,this._creationOptions=f,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(z=>this._pidPromiseComplete=z);const T=this;this.value={get name(){return T._name||""},get processId(){return T._pidPromise},get creationOptions(){return T._creationOptions},get exitStatus(){return T._exitStatus},get state(){return T._state},sendText(z,Q=!0){T._checkDisposed(),T._proxy.$sendText(T._id,z,Q)},show(z){T._checkDisposed(),T._proxy.$show(T._id,z)},hide(){T._checkDisposed(),T._proxy.$hide(T._id)},dispose(){T._disposed||(T._disposed=!0,T._proxy.$dispose(T._id))},get dimensions(){if(!(T._cols===void 0||T._rows===void 0))return{columns:T._cols,rows:T._rows}}}}async create(n,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,o.withNullAsUndefined)(n.shellPath),shellArgs:(0,o.withNullAsUndefined)(n.shellArgs),cwd:(0,o.withNullAsUndefined)(n.cwd),env:(0,o.withNullAsUndefined)(n.env),icon:(0,o.withNullAsUndefined)(l(n.iconPath)),color:a.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,o.withNullAsUndefined)(n.message),strictEnv:(0,o.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(n.location,s?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,s,f,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:a.ThemeColor.isThemeColor(P)?P.id:void 0,location:this._serializeParentTerminal(n,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,s){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in n?{viewColumn:p.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,s){this._exitStatus=Object.freeze({code:n,reason:s})}setDimensions(n,s){return n===this._cols&&s===this._rows||n===0||s===0?!1:(this._cols=n,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=w;class R{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new i.Emitter,this._onDidChangeProperty=new i.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,s){this._pty.setDimensions?.({columns:n,rows:s})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}let v=1,t=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,s){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new i.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new i.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new i.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new i.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new i.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new i.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=s.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[f,P]of this._terminalProcesses)P.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,s){const f=new w(this._proxy,(0,E.generateUuid)(),n,n.name),P=new R(n.pty);return f.createExtensionTerminal(n.location,this._serializeParentTerminal(n,s).resolvedExtHostIdentifier,l(n.iconPath),c(n.color)).then(T=>{const z=this._setupExtHostProcessListeners(T,P);this._terminalProcessDisposables[T]=z}),this._terminals.push(f),f.value}_serializeParentTerminal(n,s){if(s=s||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const f=n.location.parentTerminal;if(f){const P=this._terminals.find(T=>T.value===f);P&&(s.resolvedExtHostIdentifier=P._id)}}else n.location&&typeof n.location!="object"?s.location=n.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(n,s){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const P=new R(s),T=this._setupExtHostProcessListeners(n,P);this._terminalProcessDisposables[n]=T}async $acceptActiveTerminalChanged(n){const s=this._activeTerminal;if(n===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(n);f&&(this._activeTerminal=f,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,s){const f=this._getTerminalById(n);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:s})}async $acceptTerminalDimensions(n,s,f){const P=this._getTerminalById(n);P&&P.setDimensions(s,f)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(n,s,f){this._terminalProcesses.get(n)?.resize(s,f)}async $acceptTerminalTitleChange(n,s){const f=this._getTerminalById(n);f&&(f.name=s)}async $acceptTerminalClosed(n,s,f){const P=this._getTerminalObjectIndexById(this._terminals,n);if(P!==null){const T=this._terminals.splice(P,1)[0];T.setExitStatus(s,f),this._onDidCloseTerminal.fire(T.value)}}$acceptTerminalOpened(n,s,f,P){if(s){const Q=this._getTerminalObjectIndexById(this._terminals,s);if(Q!==null){this._terminals[Q]._id=n,this._onDidOpenTerminal.fire(this.terminals[Q]),this._terminals[Q].isOpen=!0;return}}const T={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:F.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new w(this._proxy,n,T,f);this._terminals.push(z),this._onDidOpenTerminal.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(n,s){this._getTerminalById(n)?._setProcessId(s)}async $startExtensionTerminal(n,s){const f=this._getTerminalById(n);if(!f)return{message:(0,I.localize)(0,null,n)};f.isOpen||await new Promise(T=>{const z=this.onDidOpenTerminal(async Q=>{Q===f.value&&(z.dispose(),T())})});const P=this._terminalProcesses.get(n);P?P.startSendingEvents(s):this._extensionTerminalAwaitingStart[n]={initialDimensions:s}}_setupExtHostProcessListeners(n,s){const f=new A.DisposableStore;f.add(s.onProcessReady(T=>this._proxy.$sendProcessReady(n,T.pid,T.cwd))),f.add(s.onDidChangeProperty(T=>this._proxy.$sendProcessProperty(n,T))),this._bufferer.startBuffering(n,s.onProcessData),f.add(s.onProcessExit(T=>this._onProcessExit(n,T))),this._terminalProcesses.set(n,s);const P=this._extensionTerminalAwaitingStart[n];return P&&s instanceof R&&(s.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),f}$acceptProcessAckDataEvent(n,s){this._terminalProcesses.get(n)?.acknowledgeDataEvent(s)}$acceptProcessInput(n,s){this._terminalProcesses.get(n)?.input(s)}$acceptTerminalInteraction(n){const s=this._getTerminalById(n);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(n,s,f){try{this._terminalProcesses.get(n)?.resize(s,f)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(n,s){this._terminalProcesses.get(n)?.shutdown(s)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(s=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:s}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,s,f){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,f),this._proxy.$registerProfileProvider(s,n.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(n,s,f){if(this._quickFixProviders.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this._quickFixProviders.set(n,f),this._proxy.$registerQuickFixProvider(n,s),new _.Disposable(()=>{this._quickFixProviders.delete(n),this._proxy.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,s){const f=new h.CancellationTokenSource().token;if(f.isCancellationRequested)return;const P=this._quickFixProviders.get(n);if(!P)return;const T=await P.provideTerminalQuickFixes(s,f);if(T!==null)return T}async $createContributedProfileTerminal(n,s){const f=new h.CancellationTokenSource().token;let P=await this._profileProviders.get(n)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,s);return}this.createTerminalFromOptions(P.options,s)}}async $provideLinks(n,s){const f=this._getTerminalById(n);if(!f)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const T=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,T);const z=[],Q={terminal:f.value,line:s},Z=[];for(const O of this._linkProviders)Z.push(u.Promises.withAsyncBody(async m=>{T.token.onCancellationRequested(()=>m({provider:O,links:[]}));const L=await O.provideTerminalLinks(Q,T.token)||[];T.token.isCancellationRequested||m({provider:O,links:L})}));const Y=await Promise.all(Z);if(T.token.isCancellationRequested)return[];const H=new Map;for(const O of Y)O&&O.links.length>0&&z.push(...O.links.map(m=>{const L={id:v++,startIndex:m.startIndex,length:m.length,label:m.tooltip};return H.set(L.id,{provider:O.provider,link:m}),L}));return this._terminalLinkCache.set(n,H),z}$activateLink(n,s){const f=this._terminalLinkCache.get(n)?.get(s);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(n,s){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const f=this._terminalProcessDisposables[n];f&&(f.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,s)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,s){const f=this._getTerminalObjectIndexById(n,s);return f!==null?n[f]:null}_getTerminalObjectIndexById(n,s){let f=null;return n.some((P,T)=>P._id===s?(f=T,!0):!1),f}getEnvironmentVariableCollection(n){let s=this._environmentVariableCollections.get(n.identifier.value);return s||(s=new d,this._setEnvironmentVariableCollection(n.identifier.value,s)),s}_syncEnvironmentVariableCollection(n,s){const f=(0,y.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(n,s.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(n){n.forEach(s=>{const f=s[0],P=new d(s[1]);this._setEnvironmentVariableCollection(f,P)})}$acceptDefaultProfile(n,s){const f=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=s,f?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,s){this._environmentVariableCollections.set(n,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,s)})}};t=Ve([We(1,b.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class d{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,s){this._setIfDiffers(n,{value:s,type:_.EnvironmentVariableMutatorType.Replace})}append(n,s){this._setIfDiffers(n,{value:s,type:_.EnvironmentVariableMutatorType.Append})}prepend(n,s){this._setIfDiffers(n,{value:s,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,s){const f=this.map.get(n);(!f||f.value!==s.value||f.type!==s.type)&&(this.map.set(n,s),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,s){this.map.forEach((f,P)=>n.call(s,P,f,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}let r=class extends t{constructor(n){super(!1,n)}createTerminal(n,s,f){throw new N.NotSupportedError}createTerminalFromOptions(n,s){throw new N.NotSupportedError}};r=Ve([We(0,b.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function l(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function c(S){return a.ThemeColor.isThemeColor(S)?S:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i};define(Ie[231],ke([1,0,16,17,23,21,4,195,232,6,22,9,34,5,18,101,8,7,45,72,56,25]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v){"use strict";var t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(O,m,L){this.editors=L,this.resultsChangedEmitter=new b.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(E.MainContext.MainThreadTesting),this.observer=new Q(this.proxy),this.runTracker=new n(this.proxy),m.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const J=B,me=J.tests[J.tests.length-1].item.extId;return this.controllers.get(p.TestId.root(me))?.collection.tree.get(me)?.actual??(0,a.toItemFromContext)(B)}})}createTestController(O,m,L,B){if(this.controllers.has(m))throw new Error(`Attempt to insert a duplicate controller with ID "${m}"`);const J=new I.DisposableStore,me=J.add(new a.ExtHostTestItemCollection(m,L,this.editors));me.root.label=L;const te=new Map,oe=this.proxy,ce={items:me.root.children,get label(){return L},set label(V){L=V,me.root.label=V,oe.$updateController(m,{label:L})},get refreshHandler(){return B},set refreshHandler(V){B=V,oe.$updateController(m,{canRefresh:!!V})},get id(){return m},createRunProfile:(V,q,G,de,Se,Le)=>{let xe=(0,_.hash)(V);for(;te.has(xe);)xe++;return Le!==void 0&&(0,v.checkProposedApiEnabled)(O,"testContinuousRun"),new Z(this.proxy,te,m,xe,V,q,G,de,Se,Le)},createTestItem(V,q,G){return new a.TestItemImpl(m,V,q,G)},createTestRun:(V,q,G=!0)=>this.runTracker.createTestRun(m,me,V,q,G),set resolveHandler(V){me.resolveHandler=V},get resolveHandler(){return me.resolveHandler},dispose:()=>{J.dispose()}};oe.$registerTestController(m,L,!!B),J.add((0,I.toDisposable)(()=>oe.$unregisterTestController(m)));const we={controller:ce,collection:me,profiles:te};return this.controllers.set(m,we),J.add((0,I.toDisposable)(()=>this.controllers.delete(m))),J.add(me.onDidGenerateDiff(V=>oe.$publishDiff(m,V.map(R.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.observer.checkout()}async runTests(O,m=F.CancellationToken.None){const L=s(O);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(L.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(J=>p.TestId.fromExtHostTestItem(J,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:Y[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:O.exclude?.map(J=>J.id)},m)}$syncTests(){for(const{collection:O}of this.controllers.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,m,L){return(0,i.mapFind)(this.runTracker.trackers,J=>J.id===O?J.getCoverage(m):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(O,m,L,B){return(0,i.mapFind)(this.runTracker.trackers,me=>me.id===O?me.getCoverage(m):void 0)?.resolveFileCoverage(L,B)??Promise.resolve([])}$configureRunProfile(O,m){this.controllers.get(O)?.profiles.get(m)?.configureHandler?.()}async $refreshTests(O,m){await this.controllers.get(O)?.controller.refreshHandler?.(m)}$publishTestResults(O){this.results=Object.freeze(O.map(m=>(0,N.deepFreeze)(o.TestResults.to(m))).concat(this.results).sort((m,L)=>L.completedAt-m.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(O,m){const L=this.controllers.get(p.TestId.fromString(O).controllerId)?.collection;L&&(await L.expand(O,m<0?1/0:m),L.flushDiff())}$acceptDiff(O){this.observer.applyDiff(O.map(R.TestsDiffOp.deserialize))}async $runControllerTests(O,m){return Promise.all(O.map(L=>this.runControllerTestRequest(L,!1,m)))}async $startContinuousRun(O,m){const L=new F.CancellationTokenSource(m),B=await Promise.all(O.map(J=>this.runControllerTestRequest(J,!0,L.token)));return!m.isCancellationRequested&&!B.some(J=>J.error)&&await new Promise(J=>m.onCancellationRequested(J)),L.dispose(!0),B}async runControllerTestRequest(O,m,L){const B=this.controllers.get(O.controllerId);if(!B)return{};const{collection:J,profiles:me}=B,te=me.get(O.profileId);if(!te)return{};const oe=O.testIds.map(q=>J.tree.get(q)).filter(y.isDefined),ce=O.excludeExtIds.map(q=>B.collection.tree.get(q)).filter(y.isDefined).filter(q=>oe.some(G=>G.fullId.compare(q.fullId)===2));if(!oe.length)return{};const we=new u.TestRunRequest2(oe.some(q=>q.actual instanceof a.TestItemRootImpl)?void 0:oe.map(q=>q.actual),ce.map(q=>q.actual),te,m),V=(0,R.isStartControllerTests)(O)&&this.runTracker.prepareForMainThreadTestRun(we,f.fromInternal(O,B.collection),L);try{return await te.runHandler(we,L),{}}catch(q){return{error:String(q)}}finally{V&&(V.hasRunningTasks&&!L.isCancellationRequested&&await b.Event.toPromise(V.onEnd),V.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}};r=Ve([We(0,g.IExtHostRpcService)],r),e.ExtHostTesting=r;const l=1e4;var c;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(c||(c={}));class S extends I.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(O,m,L){super(),this.dto=O,this.proxy=m,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new b.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(L));const B=this._register(new k.RunOnceScheduler(()=>this.forciblyEndTasks(),l));this._register(this.cts.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(O){return this.tasks.get(O)?.coverage}createRun(O){const m=this.dto.id,L=this.dto.controllerId,B=(0,h.generateUuid)(),J=new P(this.proxy,m,B),me=we=>(V,...q)=>{if(oe){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),we(V,...q))},te=(we,V)=>{const q=V instanceof Array?V.map(o.TestMessage.from):[o.TestMessage.from(V)];if(we.uri&&we.range){const G={range:o.Range.from(we.range),uri:we.uri};for(const de of q)de.location=de.location||G}this.proxy.$appendTestMessagesInRun(m,B,p.TestId.fromExtHostTestItem(we,L).toString(),q)};let oe=!1;const ce={isPersisted:this.dto.isPersisted,token:this.cts.token,name:O,get coverageProvider(){return J.coverageProvider},set coverageProvider(we){J.coverageProvider=we},enqueued:me(we=>{this.proxy.$updateTestStateInRun(m,B,p.TestId.fromExtHostTestItem(we,L).toString(),1)}),skipped:me(we=>{this.proxy.$updateTestStateInRun(m,B,p.TestId.fromExtHostTestItem(we,L).toString(),5)}),started:me(we=>{this.proxy.$updateTestStateInRun(m,B,p.TestId.fromExtHostTestItem(we,L).toString(),2)}),errored:me((we,V,q)=>{te(we,V),this.proxy.$updateTestStateInRun(m,B,p.TestId.fromExtHostTestItem(we,L).toString(),6,q)}),failed:me((we,V,q)=>{te(we,V),this.proxy.$updateTestStateInRun(m,B,p.TestId.fromExtHostTestItem(we,L).toString(),4,q)}),passed:me((we,V)=>{this.proxy.$updateTestStateInRun(m,B,p.TestId.fromExtHostTestItem(we,this.dto.controllerId).toString(),3,V)}),appendOutput:(we,V,q)=>{oe||(q&&(this.dto.isIncluded(q)?this.ensureTestIsKnown(q):q=void 0),this.proxy.$appendOutputToRun(m,B,D.VSBuffer.fromString(we),V&&o.location.from(V),q&&p.TestId.fromExtHostTestItem(q,L).toString()))},end:()=>{oe||(oe=!0,this.proxy.$finishedTestRunTask(m,B),this.tasks.delete(B),this.tasks.size||this.markEnded())}};return this.tasks.set(B,{run:ce,coverage:J}),this.proxy.$startedTestRunTask(m,{id:B,name:O,running:!0}),ce}forciblyEndTasks(){for(const{run:O}of this.tasks.values())O.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(O){if(!(O instanceof a.TestItemImpl))throw new w.InvalidTestItemError(O.id);if(this.sharedTestIds.has(p.TestId.fromExtHostTestItem(O,this.dto.controllerId).toString()))return;const m=[],L=this.dto.colllection.root;for(;;){const B=o.TestItem.from(O);if(m.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),O===L))break;O=O.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,m)}}class n{get trackers(){return this.tracked.values()}constructor(O){this.proxy=O,this.tracked=new Map}prepareForMainThreadTestRun(O,m,L){return this.getTracker(O,m,L)}cancelRunById(O){for(const m of this.tracked.values())if(m.id===O){m.cancel();return}}cancelAllRuns(){for(const O of this.tracked.values())O.cancel()}createTestRun(O,m,L,B,J){const me=this.tracked.get(L);if(me)return me.createRun(B);const te=f.fromPublic(O,m,L,J),oe=s(L);this.proxy.$startedExtensionTestRun({controllerId:O,continuous:!!L.continuous,profile:oe&&{group:Y[oe.kind],id:oe.profileId},exclude:L.exclude?.map(we=>p.TestId.fromExtHostTestItem(we,m.root.id).toString())??[],id:te.id,include:L.include?.map(we=>p.TestId.fromExtHostTestItem(we,m.root.id).toString())??[m.root.id],persist:J});const ce=this.getTracker(L,te);return ce.onEnd(()=>{this.proxy.$finishedExtensionTestRun(te.id),ce.dispose()}),ce.createRun(B)}getTracker(O,m,L){const B=new S(m,this.proxy,L);return this.tracked.set(O,B),B.onEnd(()=>this.tracked.delete(O)),B}}e.TestRunCoordinator=n;const s=H=>{if(!!H.profile){if(!(H.profile instanceof Z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class f{static fromPublic(O,m,L,B){return new f(O,(0,h.generateUuid)(),L.include?.map(J=>p.TestId.fromExtHostTestItem(J,O).toString())??[O],L.exclude?.map(J=>p.TestId.fromExtHostTestItem(J,O).toString())??[],B,m)}static fromInternal(O,m){return new f(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,m)}constructor(O,m,L,B,J,me){this.controllerId=O,this.id=m,this.isPersisted=J,this.colllection=me,this.includePrefix=L.map(te=>te+"\0"),this.excludePrefix=B.map(te=>te+"\0")}isIncluded(O){const m=p.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(m===L||m.startsWith(L))return!1;for(const L of this.includePrefix)if(m===L||m.startsWith(L))return!0;return!1}}e.TestRunDto=f;class P{set coverageProvider(O){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this._coverageProvider=O,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(O,m,L){this.proxy=O,this.runId=m,this.taskId=L}async provideFileCoverage(O){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(O))());try{return(await this.fileCoverage)?.map(o.TestCoverage.fromFile)??[]}catch(m){throw this.fileCoverage=void 0,m}}async resolveFileCoverage(O,m){const L=await this.fileCoverage;let B=L?.[O];return!this._coverageProvider||!L||!B?[]:(B.detailedCoverage||(B=L[O]=await this._coverageProvider.resolveFileCoverage?.(B,m)??B),B.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class T{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(O){this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(O){this.added.add(O)}update(O){Object.assign(O.revived,o.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}this.updated.delete(O);const m=p.TestId.parentId(O.item.extId);if(m&&this.alreadyRemoved.has(m.toString())){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:m,removed:L}=this;return{get added(){return[...O].map(B=>B.revived)},get updated(){return[...m].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class z extends R.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new b.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,m){return{...O,revived:o.TestItem.toPlain(O.item),depth:m?m.depth+1:0,children:new Set}}createChangeCollector(){return new T(this.changeEmitter)}}class Q{constructor(O){this.proxy=O}checkout(){this.current||(this.current=this.createObserverData());const O=this.current;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(m=>m.revived)},dispose:(0,A.once)(()=>{--O.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(O){return this.current?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.current?.tests.apply(O)}createObserverData(){const O=new z;return this.proxy.$subscribeToDiffs(),{observers:0,tests:O}}}class Z{get label(){return this._label}set label(O){O!==this._label&&(this._label=O,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(O){O!==this._supportsContinuousRun&&(this._supportsContinuousRun=O,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this._isDefault}set isDefault(O){O!==this._isDefault&&(this._isDefault=O,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?o.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(O){O!==this._configureHandler&&(this._configureHandler=O,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,m,L,B,J,me,te,oe=!1,ce=void 0,we=!1){this.controllerId=L,this.profileId=B,this._label=J,this.kind=me,this.runHandler=te,this._isDefault=oe,this._tag=ce,this._supportsContinuousRun=we,t.set(this,void 0),d.set(this,void 0),Je(this,t,O,"f"),Je(this,d,m,"f"),m.set(B,this);const V=Y[me];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${me}`);Oe(this,t,"f").$publishTestRunProfile({profileId:B,controllerId:L,tag:ce?o.TestTag.namespace(this.controllerId,ce.id):null,label:J,group:V,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:we})}dispose(){Oe(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Oe(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Z,t=new WeakMap,d=new WeakMap;const Y={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ie[233],ke([1,0,16,4,5,102,8,7]),function(ne,e,i,k,D,F,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(N,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new k.Emitter,this._onDidChangeTextEditorOptions=new k.Emitter,this._onDidChangeTextEditorVisibleRanges=new k.Emitter,this._onDidChangeTextEditorViewColumn=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=N.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(h=>this._onDidChangeVisibleTextEditors.fire(h)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(h=>this._onDidChangeActiveTextEditor.fire(h))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(N){const y=this._extHostDocumentsAndEditors.allEditors();return N?y:y.map(h=>h.value)}async showTextDocument(N,y,h){let E;typeof y=="number"?E={position:b.ViewColumn.from(y),preserveFocus:h}:typeof y=="object"?E={position:b.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?b.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:E={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(N.uri,E),a=g&&this._extHostDocumentsAndEditors.getEditor(g);if(a)return a.value;throw g?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,y){return new F.TextEditorDecorationType(this._proxy,N,y).value}$acceptEditorPropertiesChanged(N,y){const h=this._extHostDocumentsAndEditors.getEditor(N);if(!h)throw new Error("unknown text editor");if(y.options&&h._acceptOptions(y.options),y.selections){const E=y.selections.selections.map(b.Selection.to);h._acceptSelections(E)}if(y.visibleRanges){const E=i.coalesce(y.visibleRanges.map(b.Range.to));h._acceptVisibleRanges(E)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:h.value,options:{...y.options,lineNumbers:b.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const E=A.TextEditorSelectionChangeKind.fromValue(y.selections.source),g=y.selections.selections.map(b.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:h.value,selections:g,kind:E})}if(y.visibleRanges){const E=i.coalesce(y.visibleRanges.map(b.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:h.value,visibleRanges:E})}}$acceptEditorPositionData(N){for(const y in N){const h=this._extHostDocumentsAndEditors.getEditor(y);if(!h)throw new Error("Unknown text editor");const E=b.ViewColumn.to(N[y]);h.value.viewColumn!==E&&(h._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:h.value,viewColumn:E}))}}getDiffInformation(N){return Promise.resolve(this._proxy.$getDiffInformation(N))}}e.ExtHostEditors=_}),define(Ie[234],ke([1,0,2,3,5,6,7,8,26,9]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class N{constructor(E,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(D.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(a,o)=>{if(a&&a.$mid===12)if(this._providers.get(a.source)&&_.ExtensionIdentifier.equals(o,this._providers.get(a.source)?.extension)){const u=a.uri===void 0?void 0:i.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(y(u))?.get(a.handle)}else return;return a}})}async $getTimeline(E,g,a,o){return this._providers.get(E)?.provider.provideTimeline(i.URI.revive(g),a,o)}registerTimelineProvider(E,g,a,o){const u=new F.DisposableStore,p=this.convertTimelineItem(g.id,o,u).bind(this);let w;g.onDidChange&&(w=g.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:g.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:E,onDidChange:void 0,async provideTimeline(v,t,d){t?.resetCache&&(u.clear(),R.get(g.id)?.clear());const r=await g.provideTimeline(v,t,d);if(r==null)return;const l=p(v,t);return{...r,source:g.id,items:r.items.map(l)}},dispose(){for(const v of R.values())v.get(g.id)?.clear();w?.dispose(),u.dispose()}},a)}convertTimelineItem(E,g,a){return(o,u)=>{let p;if(u?.cacheResults){let w=this._itemsBySourceAndUriMap.get(E);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(E,w));const R=y(o);p=w.get(R),p===void 0&&(p=new Map,w.set(R,p))}return w=>{const{iconPath:R,...v}=w,t=`${E}|${w.id??w.timestamp}`;p?.set(t,w);let d,r,l;w.iconPath&&(R instanceof b.ThemeIcon?l={id:R.id,color:R.color}:i.URI.isUri(R)?(d=R,r=R):{light:d,dark:r}=R);let c;return b.MarkdownString.isMarkdownString(v.tooltip)?c=A.MarkdownString.from(v.tooltip):(0,I.isString)(v.tooltip)?c=v.tooltip:b.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=A.MarkdownString.from(v.detail)):(0,I.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=v.detail),{...v,id:v.id??void 0,handle:t,source:E,command:w.command?g.toInternal(w.command,a):void 0,icon:d,iconDark:r,themeIcon:l,tooltip:c,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(E,g){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,{provider:E,extension:g}),(0,F.toDisposable)(()=>{for(const o of this._itemsBySourceAndUriMap.values())o.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=N;function y(h){return h?.toString()}}),define(Ie[235],ke([1,0,6,15,2,5]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class b{constructor(_){this._openers=new Map,this._proxy=_.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,N,y){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const h=y.schemes.find(E=>!b.supportedSchemes.has(E));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,N),this._proxy.$registerUriOpener(I,y.schemes,_,y.label),(0,i.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,N){const y=this._openers.get(_);if(!y)throw new Error(`Unknown opener with id: ${_}`);const h=D.URI.revive(I);return y.canOpenExternalUri(h,N)}async $openUri(_,I,N){const y=this._openers.get(_);if(!y)throw new Error(`Unknown opener id: '${_}'`);return y.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},N)}}b.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https]),e.ExtHostUriOpeners=b}),define(Ie[236],ke([1,0,5,2,6,11,26]),function(ne,e,i,k,D,F,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(I,N){if(this.handles.has(b.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const y=A.HandlePool++;return this.handles.add(b.ExtensionIdentifier.toKey(I)),this.handlers.set(y,N),this._proxy.$registerUriHandler(y,I),(0,D.toDisposable)(()=>{this.handles.delete(b.ExtensionIdentifier.toKey(I)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(I,N){const y=this.handlers.get(I);if(!y)return Promise.resolve(void 0);try{y.handleUri(k.URI.revive(N))}catch(h){(0,F.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(I){return k.URI.revive(await this._proxy.$createAppUri(I))}}A.HandlePool=0,e.ExtHostUrls=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[62],ke([1,0,4,15,22,2,158,181,73,5]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";var N,y,h,E,g,a,o,u,p,w,R,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(T,z,Q,Z,Y,H,O){N.set(this,void 0),y.set(this,void 0),h.set(this,void 0),E.set(this,void 0),g.set(this,void 0),a.set(this,void 0),o.set(this,""),u.set(this,void 0),p.set(this,!1),w.set(this,!1),R.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new i.Emitter),this._onDidDispose=Oe(this,t,"f").event,Je(this,N,T,"f"),Je(this,y,z,"f"),Je(this,u,Q,"f"),Je(this,E,Z,"f"),Je(this,g,Y,"f"),Je(this,a,H,"f"),Je(this,R,r(H),"f"),Je(this,v,l(H),"f"),Je(this,h,O,"f")}dispose(){Je(this,p,!0,"f"),Oe(this,t,"f").fire(),Oe(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(T){return Je(this,w,!0,"f"),(0,_.asWebviewUri)(T,Oe(this,E,"f"))}get cspSource(){const T=Oe(this,a,"f").extensionLocation;if(T.scheme===k.Schemas.https||T.scheme===k.Schemas.http){let z=T.toString();return z.endsWith("/")||(z+="/"),z+" "+_.webviewGenericCspSource}return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,o,"f")}set html(T){this.assertNotDisposed(),Oe(this,o,"f")!==T&&(Je(this,o,T,"f"),Oe(this,v,"f")&&!Oe(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(T)&&(Je(this,w,!0,"f"),Oe(this,h,"f").report("Webview vscode-resource: uris",Oe(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,y,"f").$setHtml(Oe(this,N,"f"),this.rewriteOldResourceUrlsIfNeeded(T)))}get options(){return this.assertNotDisposed(),Oe(this,u,"f")}set options(T){this.assertNotDisposed(),D.equals(Oe(this,u,"f"),T)||Oe(this,y,"f").$setOptions(Oe(this,N,"f"),n(Oe(this,a,"f"),Oe(this,g,"f"),T)),Je(this,u,T,"f")}async postMessage(T){if(Oe(this,p,"f"))return!1;const z=(0,A.serializeWebviewMessage)(T,{serializeBuffersForPostMessage:Oe(this,R,"f")});return Oe(this,y,"f").$postMessage(Oe(this,N,"f"),z.message,...z.buffers)}assertNotDisposed(){if(Oe(this,p,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(T){if(!Oe(this,v,"f"))return T;const z=Oe(this,a,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,Q=Oe(this,a,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Oe(this,a,"f").extensionLocation.authority:void 0;return T.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Z,Y,H,O,m,L)=>{const B=F.URI.from({scheme:O||"file",path:decodeURIComponent(m)}),J=(0,_.asWebviewUri)(B,{isRemote:z,authority:Q}).toString();return`${Y}${J}${L}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Z,Y,H,O,m,L)=>{const B=F.URI.from({scheme:O||"file",path:decodeURIComponent(m)}),J=(0,_.asWebviewUri)(B,{isRemote:z,authority:Q}).toString();return`${Y}${J}${L}`})}}e.ExtHostWebview=d,N=new WeakMap,y=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,p=new WeakMap,w=new WeakMap,R=new WeakMap,v=new WeakMap,t=new WeakMap;function r(P){try{const T=(0,b.normalizeVersion)((0,b.parseVersion)(P.engines.vscode));return!!T&&T.majorBase>=1&&T.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function l(P){try{const T=(0,b.normalizeVersion)((0,b.parseVersion)(P.engines.vscode));return T?T.majorBase<1||T.majorBase===1&&T.minorBase<60:!1}catch{return!1}}class c{constructor(T,z,Q,Z,Y){this.remoteInfo=z,this.workspace=Q,this._logService=Z,this._deprecationService=Y,this._webviews=new Map,this._webviewProxy=T.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(T,z,Q){const Z=this.getWebview(T);if(Z){const{message:Y}=(0,A.deserializeWebviewMessage)(z,Q.value);Z._onMessageEmitter.fire(Y)}}$onMissingCsp(T,z){this._logService.warn(`${z} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(T,z,Q){const Z=new d(T,this._webviewProxy,s(z),this.remoteInfo,this.workspace,Q,this._deprecationService);return this._webviews.set(T,Z),Z._onDidDispose(()=>{this._webviews.delete(T)}),Z}deleteWebview(T){this._webviews.delete(T)}getWebview(T){return this._webviews.get(T)}}e.ExtHostWebviews=c;function S(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=S;function n(P,T,z){return{enableCommandUris:z.enableCommandUris,enableScripts:z.enableScripts,enableForms:z.enableForms,portMapping:z.portMapping,localResourceRoots:z.localResourceRoots||f(P,T)}}e.serializeWebviewOptions=n;function s(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(T=>F.URI.from(T))}}function f(P,T){return[...(T?.getWorkspaceFolders()||[]).map(z=>z.uri),P.extensionLocation]}}),define(Ie[237],ke([1,0,21,232,6,15,24,2,8,62,54,5,7]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(d,r){this.document=d,this._storagePath=r,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(d){return this._edits.add([d])}async undo(d,r){await this.getEdit(d).undo(),r||this.disposeBackup()}async redo(d,r){await this.getEdit(d).redo(),r||this.disposeBackup()}disposeEdits(d){for(const r of d)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const d=v(this.document.uri)+this._backupCounter++;return(0,b.joinPath)(this._storagePath,d)}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(d){const r=this._edits.get(d,0);if(!r)throw new Error("No edit found");return r}}class g{constructor(){this._documents=new Map}get(d,r){return this._documents.get(this.key(d,r))}add(d,r,l){const c=this.key(d,r.uri);if(this._documents.has(c))throw new Error(`Document already exists for viewType:${d} resource:${r.uri}`);const S=new E(r,l);return this._documents.set(c,S),S}delete(d,r){const l=this.key(d,r.uri);this._documents.delete(l)}key(d,r){return`${d}@@@${r}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class o{constructor(){this._providers=new Map}addTextProvider(d,r,l){return this.add(0,d,r,l)}addCustomProvider(d,r,l){return this.add(1,d,r,l)}get(d){return this._providers.get(d)}add(d,r,l,c){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:d,extension:l,provider:c}),new h.Disposable(()=>this._providers.delete(r))}}class u{constructor(d,r,l,c,S){this._extHostDocuments=r,this._extensionStoragePaths=l,this._extHostWebview=c,this._extHostWebviewPanels=S,this._editorProviders=new o,this._documents=new g,this._proxy=d.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,r,l,c){const S=new D.DisposableStore;return w(l)?(S.add(this._editorProviders.addTextProvider(r,d,l)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(d),r,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(d))):(S.add(this._editorProviders.addCustomProvider(r,d,l)),p(l)&&S.add(l.onDidChangeCustomDocument(n=>{const s=this.getCustomDocumentEntry(r,n.document.uri);if(R(n)){const f=s.addEdit(n);this._proxy.$onDidEdit(n.document.uri,r,f,n.label)}else this._proxy.$onContentChange(n.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(d),r,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(d))),h.Disposable.from(S,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(d,r,l,c,S){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${r}'`);const s=A.URI.revive(d),f=await n.provider.openCustomDocument(s,{backupId:l,untitledDocumentData:c?.buffer},S);let P;return p(n.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(r,f,P),{editable:p(n.provider)}}async $disposeCustomDocument(d,r){const l=this._editorProviders.get(r);if(!l)throw new Error(`No provider found for '${r}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${r}'`);const c=A.URI.revive(d),{document:S}=this.getCustomDocumentEntry(r,c);this._documents.delete(r,S),S.dispose()}async $resolveCustomEditor(d,r,l,c,S,n){const s=this._editorProviders.get(l);if(!s)throw new Error(`No provider found for '${l}'`);const f=_.ViewColumn.to(S),P=this._extHostWebview.createNewWebview(r,c.contentOptions,s.extension),T=this._extHostWebviewPanels.createNewWebviewPanel(r,l,c.title,f,c.options,P,!0),z=A.URI.revive(d);switch(s.type){case 1:{const{document:Q}=this.getCustomDocumentEntry(l,z);return s.provider.resolveCustomEditor(Q,T,n)}case 0:{const Q=this._extHostDocuments.getDocument(z);return s.provider.resolveCustomTextEditor(Q,T,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,r,l){this.getCustomDocumentEntry(r,d).disposeEdits(l)}async $onMoveCustomEditor(d,r,l){const c=this._editorProviders.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const S=this._extHostWebviewPanels.getWebviewPanel(d);if(!S)throw new Error("No webview found");const n=A.URI.revive(r),s=this._extHostDocuments.getDocument(n);await c.provider.moveCustomTextEditor(s,S,i.CancellationToken.None)}async $undo(d,r,l,c){return this.getCustomDocumentEntry(r,d).undo(l,c)}async $redo(d,r,l,c){return this.getCustomDocumentEntry(r,d).redo(l,c)}async $revert(d,r,l){const c=this.getCustomDocumentEntry(r,d);await this.getCustomEditorProvider(r).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(d,r,l){const c=this.getCustomDocumentEntry(r,d);await this.getCustomEditorProvider(r).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(d,r,l,c){const S=this.getCustomDocumentEntry(r,d);return this.getCustomEditorProvider(r).saveCustomDocumentAs(S.document,A.URI.revive(l),c)}async $backup(d,r,l){const c=this.getCustomDocumentEntry(r,d),n=await this.getCustomEditorProvider(r).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(n),n.id}getCustomDocumentEntry(d,r){const l=this._documents.get(d,A.URI.revive(r));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(d){const l=this._editorProviders.get(d)?.provider;if(!l||!p(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=u;function p(t){return!!t.onDidChangeCustomDocument}function w(t){return typeof t.resolveCustomTextEditor=="function"}function R(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function v(t){const d=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,k.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[238],ke([1,0,4,6,2,34,8,62,5,7]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";var N,y,h,E,g,a,o,u,p,w,R,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends k.Disposable{constructor(S,n,s,f){super(),N.set(this,void 0),y.set(this,void 0),h.set(this,void 0),E.set(this,void 0),g.set(this,void 0),a.set(this,void 0),o.set(this,void 0),u.set(this,void 0),p.set(this,!0),w.set(this,void 0),R.set(this,!1),v.set(this,this._register(new i.Emitter)),this.onDidDispose=Oe(this,v,"f").event,t.set(this,this._register(new i.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,N,S,"f"),Je(this,y,n,"f"),Je(this,E,s,"f"),Je(this,h,f.viewType,"f"),Je(this,g,f.panelOptions,"f"),Je(this,u,f.viewColumn,"f"),Je(this,a,f.title,"f"),Je(this,w,f.active,"f")}dispose(){Oe(this,R,"f")||(Je(this,R,!0,"f"),Oe(this,v,"f").fire(),Oe(this,y,"f").$disposeWebview(Oe(this,N,"f")),Oe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,E,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,h,"f")}get title(){return this.assertNotDisposed(),Oe(this,a,"f")}set title(S){this.assertNotDisposed(),Oe(this,a,"f")!==S&&(Je(this,a,S,"f"),Oe(this,y,"f").$setTitle(Oe(this,N,"f"),S))}get iconPath(){return this.assertNotDisposed(),Oe(this,o,"f")}set iconPath(S){this.assertNotDisposed(),Oe(this,o,"f")!==S&&(Je(this,o,S,"f"),Oe(this,y,"f").$setIconPath(Oe(this,N,"f"),D.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return Oe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,u,"f")=="number"&&Oe(this,u,"f")<0))return Oe(this,u,"f")}get active(){return this.assertNotDisposed(),Oe(this,w,"f")}get visible(){return this.assertNotDisposed(),Oe(this,p,"f")}_updateViewState(S){Oe(this,R,"f")||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(Je(this,w,S.active,"f"),Je(this,p,S.visible,"f"),Je(this,u,S.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(S,n){this.assertNotDisposed(),Oe(this,y,"f").$reveal(Oe(this,N,"f"),{viewColumn:typeof S>"u"?void 0:b.ViewColumn.from(S),preserveFocus:!!n})}assertNotDisposed(){if(Oe(this,R,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,y=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,p=new WeakMap,w=new WeakMap,R=new WeakMap,v=new WeakMap,t=new WeakMap;class r{static newHandle(){return(0,F.generateUuid)()}constructor(S,n,s){this.webviews=n,this.workspace=s,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=S.getProxy(_.MainContext.MainThreadWebviewPanels)}createWebviewPanel(S,n,s,f,P={}){const T=typeof f=="object"?f.viewColumn:f,z={viewColumn:b.ViewColumn.from(T),preserveFocus:typeof f=="object"&&!!f.preserveFocus},Q=(0,A.shouldSerializeBuffersForPostMessage)(S),Z=r.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(S),Z,n,{title:s,panelOptions:l(P),webviewOptions:(0,A.serializeWebviewOptions)(S,this.workspace,P),serializeBuffersForPostMessage:Q},z);const Y=this.webviews.createNewWebview(Z,P,S);return this.createNewWebviewPanel(Z,n,s,T,P,Y,!0)}$onDidChangeWebviewPanelViewStates(S){const n=Object.keys(S);n.sort((s,f)=>{const P=S[s],T=S[f];return P.active?1:T.active?-1:+P.visible-+T.visible});for(const s of n){const f=this.getWebviewPanel(s);if(!f)continue;const P=S[s];f._updateViewState({active:P.active,visible:P.visible,viewColumn:b.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this._webviewPanels.delete(S),this.webviews.deleteWebview(S)}registerWebviewPanelSerializer(S,n,s){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:s,extension:S}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(S)}),new I.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(S,n,s,f){const P=this._serializers.get(n);if(!P)throw new Error(`No serializer found for '${n}'`);const{serializer:T,extension:z}=P,Q=this.webviews.createNewWebview(S,s.webviewOptions,z),Z=this.createNewWebviewPanel(S,n,s.title,f,s.panelOptions,Q,s.active);await T.deserializeWebviewPanel(Z,s.state)}createNewWebviewPanel(S,n,s,f,P,T,z){const Q=new d(S,this._proxy,T,{viewType:n,title:s,viewColumn:f,panelOptions:P,active:z});return this._webviewPanels.set(S,Q),Q}getWebviewPanel(S){return this._webviewPanels.get(S)}}e.ExtHostWebviewPanels=r;function l(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[239],ke([1,0,4,6,62,8,5,7]),function(ne,e,i,k,D,F,b,A){"use strict";var _,I,N,y,h,E,g,a,o,u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends k.Disposable{constructor(t,d,r,l,c,S){super(),_.set(this,void 0),I.set(this,void 0),N.set(this,void 0),y.set(this,void 0),h.set(this,!1),E.set(this,void 0),g.set(this,void 0),a.set(this,void 0),o.set(this,void 0),u.set(this,this._register(new i.Emitter)),this.onDidChangeVisibility=Oe(this,u,"f").event,p.set(this,this._register(new i.Emitter)),this.onDidDispose=Oe(this,p,"f").event,Je(this,N,r,"f"),Je(this,g,l,"f"),Je(this,_,t,"f"),Je(this,I,d,"f"),Je(this,y,c,"f"),Je(this,E,S,"f")}dispose(){Oe(this,h,"f")||(Je(this,h,!0,"f"),Oe(this,p,"f").fire(),Oe(this,y,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,g,"f")}set title(t){this.assertNotDisposed(),Oe(this,g,"f")!==t&&(Je(this,g,t,"f"),Oe(this,I,"f").$setWebviewViewTitle(Oe(this,_,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(t){this.assertNotDisposed(),Oe(this,a,"f")!==t&&(Je(this,a,t,"f"),Oe(this,I,"f").$setWebviewViewDescription(Oe(this,_,"f"),t))}get visible(){return Oe(this,E,"f")}get webview(){return Oe(this,y,"f")}get viewType(){return Oe(this,N,"f")}_setVisible(t){t===Oe(this,E,"f")||Oe(this,h,"f")||(Je(this,E,t,"f"),Oe(this,u,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,o,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,o,"f")?.value&&t?.tooltip===Oe(this,o,"f")?.tooltip)&&(Je(this,o,F.ViewBadge.from(t),"f"),Oe(this,I,"f").$setWebviewViewBadge(Oe(this,_,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,I,"f").$show(Oe(this,_,"f"),!!t)}assertNotDisposed(){if(Oe(this,h,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,I=new WeakMap,N=new WeakMap,y=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,p=new WeakMap;class R{constructor(t,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,r,l){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:r,extension:t}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(t),d,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,r,l,c){const S=this._viewProviders.get(d);if(!S)throw new Error(`No view provider found for '${d}'`);const{provider:n,extension:s}=S,f=this._extHostWebview.createNewWebview(t,{},s),P=new w(t,this._proxy,d,r,f,!0);this._webviewViews.set(t,P),await n.resolveWebviewView(P,{state:l},c)}async $onDidChangeWebviewViewVisibility(t,d){this.getWebviewView(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.getWebviewView(t);this._webviewViews.delete(t),d.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const d=this._webviewViews.get(t);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=R}),define(Ie[104],ke([1,0,4,5,2,15,10,3,18]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this._state}constructor(y){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=an.InitialState,this._proxy=y.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,h){let E;if(typeof y=="string"){E=y;try{y=D.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,b.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,E,h)}async asExternalUri(y,h){if((0,b.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(y,h);return D.URI.from(E)}};I.InitialState={focused:!0},I=Ve([We(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ie[240],ke([1,0,210,27,18]),function(ne,e,i,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=class extends i.AbstractExtHostConsoleForwarder{constructor(A,_){super(A,_)}_nativeConsoleLogMessage(A,_,I){_.apply(console,I)}};F=Ve([We(0,D.IExtHostRpcService),We(1,k.IExtHostInitDataService)],F),e.ExtHostConsoleForwarder=F}),define(Ie[241],ke([1,0,17,23,21,11,4,6,127,204,46]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function h(P,T){try{return JSON.stringify(P,T)}catch{return"null"}}const E="$$ref$$",g={[E]:-1};class a{constructor(T,z){this.jsonString=T,this.referencedBuffers=z}}function o(P,T=null,z=!1){const Q=[];return{jsonString:(z?h:JSON.stringify)(P,(Y,H)=>{if(typeof H>"u")return g;if(typeof H=="object"){if(H instanceof k.VSBuffer){const O=Q.push(H)-1;return{[E]:O}}if(T)return T(Y,H)}return H}),referencedBuffers:Q}}e.stringifyJsonWithBufferRefs=o;function u(P,T,z){return JSON.parse(P,(Q,Z)=>{if(Z){const Y=Z[E];if(typeof Y=="number")return T[Y];if(z&&Z.$mid===1)return z.transformIncoming(Z)}return Z})}e.parseJsonAndRestoreBufferRefs=u;function p(P,T){return JSON.stringify(P,T)}function w(P){return P?(T,z)=>z&&z.$mid===1?P.transformOutgoing(z):z:null}var R;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(R=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},d=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class l extends A.Disposable{constructor(T,z=null,Q=null){super(),this[y]=!0,this._onDidChangeResponsiveState=this._register(new b.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=z,this._uriTransformer=Q,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let Z=0,Y=N.ProxyIdentifier.count;Z<Y;Z++)this._locals[Z]=null,this._proxies[Z]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(Z=>this._receiveOneMessage(Z))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(F.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,_.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:z,sid:Q}=T;return this._proxies[z]||(this._proxies[z]=this._createProxy(z,Q)),this._proxies[z]}_createProxy(T,z){const Q={get:(Z,Y)=>(typeof Y=="string"&&!Z[Y]&&Y.charCodeAt(0)===36&&(Z[Y]=(...H)=>this._remoteCall(T,Y,H)),Y===r?z:Z[Y])};return new Proxy(Object.create(null),Q)}set(T,z){return this._locals[T.nid]=z,z}assertRegistered(T){for(let z=0,Q=T.length;z<Q;z++){const Z=T[z];if(!this._locals[Z.nid])throw new Error(`Missing proxy instance ${Z.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const z=T.byteLength,Q=c.read(T,0),Z=Q.readUInt8(),Y=Q.readUInt32();switch(Z){case 1:case 2:{let{rpcId:H,method:O,args:m}=n.deserializeRequestJSONArgs(Q);this._uriTransformer&&(m=(0,_.transformIncomingURIs)(m,this._uriTransformer)),this._receiveRequest(z,Y,H,O,m,Z===2);break}case 3:case 4:{let{rpcId:H,method:O,args:m}=n.deserializeRequestMixedArgs(Q);this._uriTransformer&&(m=(0,_.transformIncomingURIs)(m,this._uriTransformer)),this._receiveRequest(z,Y,H,O,m,Z===4);break}case 5:{this._logger?.logIncoming(z,Y,0,"ack"),this._onDidReceiveAcknowledge(Y);break}case 6:{this._receiveCancel(z,Y);break}case 7:{this._receiveReply(z,Y,void 0);break}case 9:{let H=n.deserializeReplyOKJSON(Q);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReply(z,Y,H);break}case 10:{const H=n.deserializeReplyOKJSONWithBuffers(Q,this._uriTransformer);this._receiveReply(z,Y,H);break}case 8:{const H=n.deserializeReplyOKVSBuffer(Q);this._receiveReply(z,Y,H);break}case 11:{let H=n.deserializeReplyErrError(Q);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReplyErr(z,Y,H);break}case 12:{this._receiveReplyErr(z,Y,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,z,Q,Z,Y,H){this._logger?.logIncoming(T,z,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(Q)}.${Z}(`,Y);const O=String(z);let m,L;if(H){const J=new D.CancellationTokenSource;Y.push(J.token),m=this._invokeHandler(Q,Z,Y),L=()=>J.cancel()}else m=this._invokeHandler(Q,Z,Y),L=t;this._cancelInvokedHandlers[O]=L;const B=n.serializeAcknowledged(z);this._logger?.logOutgoing(B.byteLength,z,1,"ack"),this._protocol.send(B),m.then(J=>{delete this._cancelInvokedHandlers[O];const me=n.serializeReplyOK(z,J,this._uriReplacer);this._logger?.logOutgoing(me.byteLength,z,1,"reply:",J),this._protocol.send(me)},J=>{delete this._cancelInvokedHandlers[O];const me=n.serializeReplyErr(z,J);this._logger?.logOutgoing(me.byteLength,z,1,"replyErr:",J),this._protocol.send(me)})}_receiveCancel(T,z){this._logger?.logIncoming(T,z,1,"receiveCancel");const Q=String(z);this._cancelInvokedHandlers[Q]?.()}_receiveReply(T,z,Q){this._logger?.logIncoming(T,z,0,"receiveReply:",Q);const Z=String(z);if(!this._pendingRPCReplies.hasOwnProperty(Z))return;const Y=this._pendingRPCReplies[Z];delete this._pendingRPCReplies[Z],Y.resolveOk(Q)}_receiveReplyErr(T,z,Q){this._logger?.logIncoming(T,z,0,"receiveReplyErr:",Q);const Z=String(z);if(!this._pendingRPCReplies.hasOwnProperty(Z))return;const Y=this._pendingRPCReplies[Z];delete this._pendingRPCReplies[Z];let H;Q&&(Q.$isError?(H=new Error,H.name=Q.name,H.message=Q.message,H.stack=Q.stack):H=Q),Y.resolveErr(H)}_invokeHandler(T,z,Q){try{return Promise.resolve(this._doInvokeHandler(T,z,Q))}catch(Z){return Promise.reject(Z)}}_doInvokeHandler(T,z,Q){const Z=this._locals[T];if(!Z)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(T));const Y=Z[z];if(typeof Y!="function")throw new Error("Unknown method "+z+" on actor "+(0,N.getStringIdentifierForProxy)(T));return Y.apply(Z,Q)}_remoteCall(T,z,Q){if(this._isDisposed)return new I.CanceledLazyPromise;let Z=null;if(Q.length>0&&D.CancellationToken.isCancellationToken(Q[Q.length-1])&&(Z=Q.pop()),Z&&Z.isCancellationRequested)return Promise.reject(F.canceled());const Y=n.serializeRequestArguments(Q,this._uriReplacer),H=++this._lastMessageId,O=String(H),m=new I.LazyPromise;Z&&Z.onCancellationRequested(()=>{const B=n.serializeCancel(H);this._logger?.logOutgoing(B.byteLength,H,0,"cancel"),this._protocol.send(n.serializeCancel(H))}),this._pendingRPCReplies[O]=m,this._onWillSendRequest(H);const L=n.serializeRequest(H,T,z,Y,!!Z);return this._logger?.logOutgoing(L.byteLength,H,0,`request: ${(0,N.getStringIdentifierForProxy)(T)}.${z}(`,Q),this._protocol.send(L),m}}y=d,l.UNRESPONSIVE_TIME=3*1e3,e.RPCProtocol=l;class c{static alloc(T,z,Q){const Z=new c(k.VSBuffer.alloc(Q+1+4),0);return Z.writeUInt8(T),Z.writeUInt32(z),Z}static read(T,z){return new c(T,z)}get buffer(){return this._buff}constructor(T,z){this._buff=T,this._offset=z}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const Q=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,Q}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const Q=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,Q}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const z=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,z}static sizeMixedArray(T){let z=0;z+=1;for(let Q=0,Z=T.length;Q<Z;Q++){const Y=T[Q];switch(z+=1,Y.type){case 1:z+=this.sizeLongString(Y.value);break;case 2:z+=this.sizeVSBuffer(Y.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(Y.value);for(let H=0;H<Y.buffers.length;++H)z+=this.sizeVSBuffer(Y.buffers[H]);break;case 4:break}}return z}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let z=0,Q=T.length;z<Q;z++){const Z=T[z];switch(Z.type){case 1:this.writeUInt8(1),this.writeLongString(Z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(Z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(Z.buffers.length),this.writeLongString(Z.value);for(let Y=0;Y<Z.buffers.length;++Y)this.writeBuffer(Z.buffers[Y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const z=new Array(T);for(let Q=0;Q<T;Q++)switch(this.readUInt8()){case 1:z[Q]=this.readLongString();break;case 2:z[Q]=this.readVSBuffer();break;case 3:{const Y=this.readUInt32(),H=this.readLongString(),O=[];for(let m=0;m<Y;++m)O.push(this.readVSBuffer());z[Q]=new N.SerializableObjectWithBuffers(u(H,O,null));break}case 4:z[Q]=void 0;break}return z}}c.sizeUInt32=4;var S;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(S||(S={}));class n{static _useMixedArgSerialization(T){for(let z=0,Q=T.length;z<Q;z++)if(T[z]instanceof k.VSBuffer||T[z]instanceof N.SerializableObjectWithBuffers||typeof T[z]>"u")return!0;return!1}static serializeRequestArguments(T,z){if(this._useMixedArgSerialization(T)){const Q=[];for(let Z=0,Y=T.length;Z<Y;Z++){const H=T[Z];if(H instanceof k.VSBuffer)Q[Z]={type:2,value:H};else if(typeof H>"u")Q[Z]={type:4};else if(H instanceof N.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:m}=o(H.value,z);Q[Z]={type:3,value:k.VSBuffer.fromString(O),buffers:m}}else Q[Z]={type:1,value:k.VSBuffer.fromString(p(H,z))}}return{type:1,args:Q}}return{type:0,args:p(T,z)}}static serializeRequest(T,z,Q,Z,Y){switch(Z.type){case 0:return this._requestJSONArgs(T,z,Q,Z.args,Y);case 1:return this._requestMixedArgs(T,z,Q,Z.args,Y)}}static _requestJSONArgs(T,z,Q,Z,Y){const H=k.VSBuffer.fromString(Q),O=k.VSBuffer.fromString(Z);let m=0;m+=c.sizeUInt8(),m+=c.sizeShortString(H),m+=c.sizeLongString(O);const L=c.alloc(Y?2:1,T,m);return L.writeUInt8(z),L.writeShortString(H),L.writeLongString(O),L.buffer}static deserializeRequestJSONArgs(T){const z=T.readUInt8(),Q=T.readShortString(),Z=T.readLongString();return{rpcId:z,method:Q,args:JSON.parse(Z)}}static _requestMixedArgs(T,z,Q,Z,Y){const H=k.VSBuffer.fromString(Q);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(H),O+=c.sizeMixedArray(Z);const m=c.alloc(Y?4:3,T,O);return m.writeUInt8(z),m.writeShortString(H),m.writeMixedArray(Z),m.buffer}static deserializeRequestMixedArgs(T){const z=T.readUInt8(),Q=T.readShortString(),Z=T.readMixedArray(),Y=new Array(Z.length);for(let H=0,O=Z.length;H<O;H++){const m=Z[H];typeof m=="string"?Y[H]=JSON.parse(m):Y[H]=m}return{rpcId:z,method:Q,args:Y}}static serializeAcknowledged(T){return c.alloc(5,T,0).buffer}static serializeCancel(T){return c.alloc(6,T,0).buffer}static serializeReplyOK(T,z,Q){if(typeof z>"u")return this._serializeReplyOKEmpty(T);if(z instanceof k.VSBuffer)return this._serializeReplyOKVSBuffer(T,z);if(z instanceof N.SerializableObjectWithBuffers){const{jsonString:Z,referencedBuffers:Y}=o(z.value,Q,!0);return this._serializeReplyOKJSONWithBuffers(T,Z,Y)}else return this._serializeReplyOKJSON(T,h(z,Q))}static _serializeReplyOKEmpty(T){return c.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,z){let Q=0;Q+=c.sizeVSBuffer(z);const Z=c.alloc(8,T,Q);return Z.writeVSBuffer(z),Z.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,z){const Q=k.VSBuffer.fromString(z);let Z=0;Z+=c.sizeLongString(Q);const Y=c.alloc(9,T,Z);return Y.writeLongString(Q),Y.buffer}static _serializeReplyOKJSONWithBuffers(T,z,Q){const Z=k.VSBuffer.fromString(z);let Y=0;Y+=c.sizeUInt32,Y+=c.sizeLongString(Z);for(const O of Q)Y+=c.sizeVSBuffer(O);const H=c.alloc(10,T,Y);H.writeUInt32(Q.length),H.writeLongString(Z);for(const O of Q)H.writeBuffer(O);return H.buffer}static deserializeReplyOKJSON(T){const z=T.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(T,z){const Q=T.readUInt32(),Z=T.readLongString(),Y=[];for(let H=0;H<Q;++H)Y.push(T.readVSBuffer());return new N.SerializableObjectWithBuffers(u(Z,Y,z))}static serializeReplyErr(T,z){const Q=z?h(F.transformErrorForSerialization(z),null):void 0;if(typeof Q!="string")return this._serializeReplyErrEmpty(T);const Z=k.VSBuffer.fromString(Q);let Y=0;Y+=c.sizeLongString(Z);const H=c.alloc(11,T,Y);return H.writeLongString(Z),H.buffer}static deserializeReplyErrError(T){const z=T.readLongString();return JSON.parse(z)}static _serializeReplyErrEmpty(T){return c.alloc(12,T,0).buffer}}var s;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var f;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(f||(f={}))}),define(Ie[242],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(F){const b=A=>{self.removeEventListener("message",b);const _=A.data;Object.defineProperties(self,{postMessage:{value(I,N){_.postMessage(I,N)}},onmessage:{get(){return _.onmessage},set(I){_.onmessage=I}}}),_.addEventListener("message",I=>{self.dispatchEvent(new MessageEvent("message",{data:I.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};self.addEventListener("message",b)}.toString();class k extends EventTarget{constructor(F,b,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${i})('${b}'))`,I=new Blob([_],{type:"application/javascript"}),N=URL.createObjectURL(I),y=new MessageChannel,h=N,E={type:"_newWorker",id:h,port:y.port2,url:N,options:A};F(E,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{F({type:"_terminateWorker",id:h}),URL.revokeObjectURL(N),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(g){y.port1.onmessage=g}},onmessageerror:{get(){return y.port1.onmessageerror},set(g){y.port1.onmessageerror=g}}}),y.port1.addEventListener("messageerror",g=>{const a=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(a)}),y.port1.addEventListener("message",g=>{const a=new MessageEvent("message",{data:g.data});this.dispatchEvent(a)}),y.port1.start()}}e.NestedWorker=k}),define(Ie[243],ke([1,0,4,30,42,3]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)("outputService");var b;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(b=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new i.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new i.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(I){this.channels.has(I.id)||(this.channels.set(I.id,I),this._onDidRegisterChannel.fire(I.id))}getChannels(){const I=[];return this.channels.forEach(N=>I.push(N)),I}getChannel(I){return this.channels.get(I)}removeChannel(I){this.channels.delete(I),this._onDidRemoveChannel.fire(I)}}k.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Ie[105],ke([1,0,5,3,18,26,12,243,60,27,36,121,23,9,43,4,6]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends b.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,t,d,r,l){super(),this.id=v,this.name=t,this.logger=d,this.proxy=r,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(d.getLevel()),this._register(d.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,v)}replace(v){const t=this.offset;this.info(v),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(v,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:t))}hide(){this.proxy.$close(this.id)}log(v,t){this.offset+=h.VSBuffer.fromString(t).byteLength,(0,b.log)(this.logger,v,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class p extends u{appendLine(v){this.append(v)}}let w=class{constructor(v,t,d,r,l,c){this.initData=t,this.extHostFileSystem=d,this.extHostFileSystemInfo=r,this.loggerService=l,this.logService=c,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(i.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[t,d]of this.channels)d.visible=t===this.visibleChannelId}createOutputChannel(v,t,d){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,l=(0,E.isString)(t)?t:void 0;if((0,E.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const S=this.initData.environment.extensionLogLevel?.find(([s])=>F.ExtensionIdentifier.equals(d.identifier,s))?.[1];S&&(c=(0,b.parseLogLevel)(S));const n=r?this.doCreateLogOutputChannel(v,c,d):this.doCreateOutputChannel(v,l,d);return n.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(v,c??this.logService.getLevel(),n):this.createExtHostOutputChannel(v,n)}async doCreateOutputChannel(v,t,d){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.proxy.$register(v,l,t,d.identifier.value);return new u(S,v,c,this.proxy,d)}async doCreateLogOutputChannel(v,t,d){const r=await this.createExtensionLogDirectory(d),l=this.extHostFileSystemInfo.extUri.joinPath(r,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=l.toString(),S=this.loggerService.createLogger(l,{id:c,name:v,logLevel:t,extensionId:d.identifier.value});return new p(c,v,S,this.proxy,d)}createExtensionLogDirectory(v){let t=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!t){const d=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(d)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}return d})())}return t}createExtHostOutputChannel(v,t){let d=!1;const r=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return v},append(l){r(),t.then(c=>c.append(l))},appendLine(l){r(),t.then(c=>c.appendLine(l))},clear(){r(),t.then(l=>l.clear())},replace(l){r(),t.then(c=>c.replace(l))},show(l,c){r(),t.then(S=>S.show(l,c))},hide(){r(),t.then(l=>l.hide())},dispose(){d=!0,t.then(l=>l.dispose())}}}createExtHostLogOutputChannel(v,t,d){const r=new o.DisposableStore,l=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},c=r.add(new a.Emitter);function S(n){t=n,c.fire(n)}return d.then(n=>{r.add(n),n.logLevel!==t&&S(n.logLevel),r.add(n.onDidChangeLogLevel(s=>S(s)))}),{...this.createExtHostOutputChannel(v,d),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(n,...s){l(),d.then(f=>f.trace(n,...s))},debug(n,...s){l(),d.then(f=>f.debug(n,...s))},info(n,...s){l(),d.then(f=>f.info(n,...s))},warn(n,...s){l(),d.then(f=>f.warn(n,...s))},error(n,...s){l(),d.then(f=>f.error(n,...s))},dispose(){r.dispose()}}}};w=Ve([We(0,D.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,_.IExtHostConsumerFileSystem),We(3,N.IExtHostFileSystemInfo),We(4,b.ILoggerService),We(5,b.ILogService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(Ie[244],ke([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(Ie[245],ke([1,0,40,15,19,20,24,2,3,176,53,192,244]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let E=class cn{constructor(a,o,u,p){this.localUserHome=a,this.remoteAgentService=o,this.environmentService=u,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||F.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome??a})()}hasValidBasename(a,o,u){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(p=>this.doHasValidBasename(a,p,o)):this.doHasValidBasename(a,o,u)}doHasValidBasename(a,o,u){return a.scheme===k.Schemas.file||a.scheme===k.Schemas.vscodeRemote?(0,i.isValidBasename)(u??(0,b.basename)(a),o===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,o){if(a.remoteAuthority)return k.Schemas.vscodeRemote;const u=(0,I.getVirtualWorkspaceScheme)(o.getWorkspace());if(u)return u;const p=o.getWorkspace().folders[0];if(p)return p.uri.scheme;const w=o.getWorkspace().configuration;return w?w.scheme:k.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?D.win32:D.posix)}async fileURI(a){let o="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const p=a.indexOf("/",2);p===-1?(o=a.substring(2),a="/"):(o=a.substring(2,p),a=a.substring(p)||"/")}return A.URI.from({scheme:k.Schemas.file,authority:o,path:a,query:"",fragment:""})}};E=Ve([We(1,h.IRemoteAgentService),We(2,y.IWorkbenchEnvironmentService),We(3,N.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(Ie[106],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(b,A){this.line=b,this.character=A}isBefore(b){return!1}isBeforeOrEqual(b){return!1}isAfter(b){return!1}isAfterOrEqual(b){return!1}isEqual(b){return!1}compareTo(b){return 0}translate(b,A){return new i(0,0)}with(b){return new i(0,0)}}e.Position=i;class k{constructor(b,A,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(b,A),this.end=new i(_,I)}contains(b){return!1}isEqual(b){return!1}intersection(b){}union(b){return new k(0,0,0,0)}with(b){return new k(0,0,0,0)}}e.Range=k;var D;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[47],ke([1,0,16,35,22,40,10,3,19,11,106,17]),function(ne,e,i,k,D,F,b,A,_,I,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",E=" characters skipped \u27EB",g=(h.length+E.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var a;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function u(oe){return!!oe.preview}e.resultIsMatch=u;function p(oe){return!!oe.resource}e.isFileMatch=p;function w(oe){return!!oe.message}e.isProgressMessage=w;var R;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(R=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=v;class t{constructor(ce,we,V){this.ranges=we;const q=Array.isArray(we)?we:[we];if(V&&V.matchLines===1&&d(q)){ce=(0,b.getNLines)(ce,V.matchLines);let G="",de=0,Se=0;const Le=Math.floor(V.charsPerLine/5),xe=[];for(const Te of q){const De=Math.max(Te.startColumn-Le,0),_e=Te.startColumn+V.charsPerLine;if(De>Se+Le+g){const ae=h+(De-Se)+E;G+=ae+ce.slice(De,_e),de+=De-(Se+ae.length)}else G+=ce.slice(Se,_e);xe.push(new l(0,Te.startColumn-de,Te.endColumn-de)),Se=_e}this.preview={text:G,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const G=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:ce,matches:(0,i.mapArrayOrNot)(we,de=>new r(de.startLineNumber-G,de.startColumn,de.endLineNumber-G,de.endColumn))}}}}e.TextSearchMatch=t;function d(oe){const ce=oe[0].startLineNumber;for(const we of oe)if(we.startLineNumber!==ce||we.endLineNumber!==ce)return!1;return!0}class r{constructor(ce,we,V,q){this.startLineNumber=ce,this.startColumn=we,this.endLineNumber=V,this.endColumn=q}}e.SearchRange=r;class l extends r{constructor(ce,we,V){super(ce,we,ce,V)}}e.OneLineRange=l;var c;(function(oe){oe.List="list",oe.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var S;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(S=e.SearchSortOrder||(e.SearchSortOrder={}));function n(oe,ce=!0){const we=oe&&oe.files&&oe.files.exclude,V=ce&&oe&&oe.search&&oe.search.exclude;if(!we&&!V)return;if(!we||!V)return we||V;let q=Object.create(null);return q=D.mixin(q,D.deepClone(we)),q=D.mixin(q,D.deepClone(V),!0),q}e.getExcludes=n;function s(oe,ce){return oe.excludePattern&&k.match(oe.excludePattern,ce)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&k.match(oe.includePattern,ce)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(we=>{const V=we.folder.fsPath;if(F.isEqualOrParent(ce,V)){const q=_.relative(V,ce);return!we.includePattern||!!k.match(we.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var f;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(ce,we){super(ce),this.code=we}}e.SearchError=P;function T(oe){const ce=oe.message;if((0,I.isCancellationError)(oe))return new P(ce,f.canceled);try{const we=JSON.parse(ce);return new P(we.message,we.code)}catch{return new P(ce,f.other)}}e.deserializeSearchError=T;function z(oe){const ce={message:oe.message,code:oe.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=z;function Q(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=Q;function Z(oe){return oe.type==="success"}e.isSerializedSearchSuccess=Z;function Y(oe){return!!oe.path}e.isSerializedFileMatch=Y;function H(oe,ce){const we=oe.searchPath?oe.searchPath:oe.relativePath;return(0,b.fuzzyContains)(we,ce)}e.isFilePatternMatch=H;class O{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function m(oe,ce){const we={...oe||{},...ce||{}};return Object.keys(we).filter(V=>{const q=we[V];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=m;class L{constructor(ce,we){this._parsedIncludeExpression=null,this._excludeExpression={...ce.excludePattern||{},...we.excludePattern||{}},this._parsedExcludeExpression=k.parse(this._excludeExpression);let V=ce.includePattern;we.includePattern&&(V?V={...V,...we.includePattern}:V=we.includePattern),V&&(this._parsedIncludeExpression=k.parse(V))}matchesExcludesSync(ce,we,V){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,we,V))}includedInQuerySync(ce,we,V){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,we,V)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ce,we,V))}includedInQuery(ce,we,V){const q=this._parsedExcludeExpression(ce,we,V),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ce,we,V):!0;return(0,y.isThenable)(q)?q.then(de=>de?!1:G()):G()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=L;function B(oe){for(const ce in oe)if(typeof oe[ce]!="boolean")return!0;return!1}function J(oe){if(!oe)return;let ce;return we=>(ce||(ce=(oe()||Promise.resolve([])).then(V=>V?te(V):{})),ce.then(V=>!!V[we]))}e.hasSiblingPromiseFn=J;function me(oe){if(!oe)return;let ce;return we=>{if(!ce){const V=oe();ce=V?te(V):{}}return!!ce[we]}}e.hasSiblingFn=me;function te(oe){const ce={};for(const we of oe)ce[we]=!0;return ce}}),define(Ie[31],ke([1,0,16,17,21,4,6,48,15,113,24,10,9,2,146,3,12,164,53,36,27,18,8,7,55,47,5]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v,t,d,r,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function S(Z,Y,H){return new N.ExtUri(O=>P(O,H)).isEqual(Z,Y)}function n(Z,Y,H){return S(Z.uri,Y.uri,H)?0:(0,y.compare)(Z.uri.toString(),Y.uri.toString())}function s(Z,Y,H){return Z.index!==Y.index?Z.index<Y.index?-1:1:S(Z.uri,Y.uri,H)?(0,y.compare)(Z.name,Y.name):(0,y.compare)(Z.uri.toString(),Y.uri.toString())}function f(Z,Y,H,O){const m=Z.slice(0).sort((B,J)=>H(B,J,O)),L=Y.slice(0).sort((B,J)=>H(B,J,O));return(0,i.delta)(m,L,(B,J)=>H(B,J,O))}function P(Z,Y){const H=Y.getCapabilities(Z.scheme);return!(H&&H&1024)}class T extends p.Workspace{static toExtHostWorkspace(Y,H,O,m){if(!Y)return{workspace:null,added:[],removed:[]};const{id:L,name:B,folders:J,configuration:me,transient:te,isUntitled:oe}=Y,ce=[],we=H;H?J.forEach((de,Se)=>{const Le=E.URI.revive(de.uri),xe=T._findFolder(O||H,Le,m);xe?(xe.name=de.name,xe.index=de.index,ce.push(xe)):ce.push({uri:Le,name:de.name,index:Se})}):ce.push(...J.map(({uri:de,name:Se,index:Le})=>({uri:E.URI.revive(de),name:Se,index:Le}))),ce.sort((de,Se)=>de.index<Se.index?-1:1);const V=new T(L,B,ce,!!te,me?E.URI.revive(me):null,!!oe,de=>P(de,m)),{added:q,removed:G}=f(we?we.workspaceFolders:[],V.workspaceFolders,n,m);return{workspace:V,added:q,removed:G}}static _findFolder(Y,H,O){for(let m=0;m<Y.folders.length;m++){const L=Y.workspaceFolders[m];if(S(L.uri,H,O))return L}}constructor(Y,H,O,m,L,B,J){super(Y,O.map(me=>new p.WorkspaceFolder(me)),m,L,J),this._name=H,this._isUntitled=B,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(J),O.forEach(me=>{this._workspaceFolders.push(me),this._structure.set(me.uri,me)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(Y,H){return H&&this._structure.get(Y)&&(Y=(0,N.dirname)(Y)),this._structure.findSubstr(Y)}resolveWorkspaceFolder(Y){return this._structure.get(Y)}}let z=class{constructor(Y,H,O,m,L){this._onDidChangeWorkspace=new F.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new F.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new F.AsyncEmitter,this._logService=m,this._extHostFileSystemInfo=O,this._uriTransformerService=L,this._requestIdProvider=new I.Counter,this._barrier=new k.Barrier,this._proxy=Y.getProxy(c.MainContext.MainThreadWorkspace),this._messageService=Y.getProxy(c.MainContext.MainThreadMessageService);const B=H.workspace;this._confirmedWorkspace=B?new T(B.id,B.name,[],!!B.transient,B.configuration?E.URI.revive(B.configuration):null,!!B.isUntitled,J=>P(J,O)):void 0}$initializeWorkspace(Y,H){this._trusted=H,this.$acceptWorkspaceData(Y),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:_.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(Y,H,O,...m){const L=[];if(Array.isArray(m)&&m.forEach(oe=>{E.URI.isUri(oe.uri)&&!L.some(ce=>S(ce.uri,oe.uri,this._extHostFileSystemInfo))&&L.push({uri:oe.uri,name:oe.name||(0,N.basenameOrAuthority)(oe.uri)})}),this._unconfirmedWorkspace||[H,O].some(oe=>typeof oe!="number"||oe<0)||O===0&&L.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+O>B.length)return!1;const J=B.slice(0);J.splice(H,O,...L.map(oe=>({uri:oe.uri,name:oe.name||(0,N.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<J.length;oe++){const ce=J[oe];if(J.some((we,V)=>V!==oe&&S(ce.uri,we.uri,this._extHostFileSystemInfo)))return!1}J.forEach((oe,ce)=>oe.index=ce);const{added:me,removed:te}=f(B,J,s,this._extHostFileSystemInfo);if(me.length===0&&te.length===0)return!1;if(this._proxy){const oe=Y.displayName||Y.name;this._proxy.$updateWorkspaceFolders(oe,H,O,L).then(void 0,ce=>{this._unconfirmedWorkspace=void 0;const we={source:{identifier:Y.identifier,label:Y.displayName||Y.name}};this._messageService.$showMessage(u.Severity.Error,(0,g.localize)(0,null,oe,ce.toString()),we,[])})}return this.trySetWorkspaceFolders(J),!0}getWorkspaceFolder(Y,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(Y,H)}async getWorkspaceFolder2(Y,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(Y,H)}async resolveWorkspaceFolder(Y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(Y)}getPath(){if(!this._actualWorkspace)return;const{folders:Y}=this._actualWorkspace;if(Y.length!==0)return Y[0].uri.fsPath}getRelativePath(Y,H){let O,m="";if(typeof Y=="string"?(O=E.URI.file(Y),m=Y):typeof Y<"u"&&(O=Y,m=Y.fsPath),!O)return m;const L=this.getWorkspaceFolder(O,!0);if(!L)return m;typeof H>"u"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let B=(0,N.relativePath)(L.uri,O);return H&&L.name&&(B=`${L.name}/${B}`),B}trySetWorkspaceFolders(Y){this._actualWorkspace&&(this._unconfirmedWorkspace=T.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:Y,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(Y){const{workspace:H,added:O,removed:m}=T.toExtHostWorkspace(Y,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:m}))}findFiles(Y,H,O,m,L=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${m.value}, entryPoint: findFiles`);let B;if(H===null?B=!1:H&&(typeof H=="string"?B=H:B=H.pattern),L&&L.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:me}=Q(t.GlobPattern.from(Y));return this._proxy.$startFileSearch((0,h.withUndefinedAsNull)(J),(0,h.withUndefinedAsNull)(me),(0,h.withUndefinedAsNull)(B),(0,h.withUndefinedAsNull)(O),L).then(te=>Array.isArray(te)?te.map(oe=>E.URI.revive(oe)):[])}async findTextInFiles(Y,H,O,m,L=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${m.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),J=typeof H.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:me,folder:te}=Q(t.GlobPattern.from(H.include)),oe=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,ce={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof H.useParentIgnoreFiles=="boolean"?!H.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:J,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:me,excludePattern:oe},we=!1;if(this._activeSearchCallbacks[B]=V=>{if(we)return;const q=E.URI.revive(V.resource);V.results.forEach(G=>{(0,l.resultIsMatch)(G)?O({uri:q,preview:{text:G.preview.text,matches:(0,i.mapArrayOrNot)(G.preview.matches,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,i.mapArrayOrNot)(G.ranges,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):O({uri:q,text:G.text,lineNumber:G.lineNumber})})},L.isCancellationRequested)return{};try{const V=await this._proxy.$startTextSearch(Y,(0,h.withUndefinedAsNull)(te),ce,B,L);return delete this._activeSearchCallbacks[B],V||{}}catch(V){throw delete this._activeSearchCallbacks[B],V}}$handleTextSearchResult(Y,H){this._activeSearchCallbacks[H]?.(Y)}saveAll(Y){return this._proxy.$saveAll(Y)}resolveProxy(Y){return this._proxy.$resolveProxy(Y)}get trusted(){return this._trusted}requestWorkspaceTrust(Y){return this._proxy.$requestWorkspaceTrust(Y)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(Y,H){if(this._editSessionIdentityProviders.has(Y))throw new Error(`A provider has already been registered for scheme ${Y}`);this._editSessionIdentityProviders.set(Y,H);const O=this._uriTransformerService.transformOutgoingScheme(Y),m=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(m,O),(0,b.toDisposable)(()=>{this._editSessionIdentityProviders.delete(Y),this._proxy.$unregisterEditSessionIdentityProvider(m)})}async $getEditSessionIdentifier(Y,H){this._logService.info("Getting edit session identifier for workspaceFolder",Y);const O=await this.resolveWorkspaceFolder(E.URI.revive(Y));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const m=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!m),!m)return;const L=await m.provideEditSessionIdentity(O,H);if(this._logService.info("Provider returned edit session identifier: ",L),!!L)return L}async $provideEditSessionIdentityMatch(Y,H,O,m){this._logService.info("Getting edit session identifier for workspaceFolder",Y);const L=await this.resolveWorkspaceFolder(E.URI.revive(Y));if(!L){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const B=this._editSessionIdentityProviders.get(L.uri.scheme);if(this._logService.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!B),!B)return;const J=await B.provideEditSessionIdentityMatch?.(H,O,m);if(this._logService.info("Provider returned edit session identifier match result: ",J),!!J)return J}getOnWillCreateEditSessionIdentityEvent(Y){return(H,O,m)=>{const L=function(J){H.call(O,J)};return L.extension=Y,this._onWillCreateEditSessionIdentityEvent.event(L,void 0,m)}}async $onWillCreateEditSessionIdentity(Y,H,O){const m=await this.resolveWorkspaceFolder(E.URI.revive(Y));if(m===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:m},H,async(L,B)=>{const J=Date.now();await Promise.resolve(L),Date.now()-J>O&&this._logService.warn("SLOW edit session create-participant",B.extension.identifier)}),H.isCancellationRequested}};z=Ve([We(0,v.IExtHostRpcService),We(1,R.IExtHostInitDataService),We(2,w.IExtHostFileSystemInfo),We(3,o.ILogService),We(4,r.IURITransformerService)],z),e.ExtHostWorkspace=z,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function Q(Z){let Y,H;return Z&&(typeof Z=="string"?Y=Z:(Y=Z.pattern,H=E.URI.revive(Z.baseUri))),{includePattern:Y,folder:H}}}),define(Ie[32],ke([1,0,22,4,31,5,7,167,93,9,17,3,18,12,2]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(d,r){if(r){const l=r.split(".");let c=d;for(let S=0;c&&S<l.length;S++)c=c[l[S]];return c}}function o(d){return d instanceof g.URI}function u(d){return d&&d.uri instanceof g.URI&&d.languageId&&typeof d.languageId=="string"}function p(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function w(d){return d&&d.uri instanceof g.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function R(d){if(o(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(p(d))return{overrideIdentifier:d.languageId};if(w(d))return{resource:d.uri};if(d===null)return{resource:null}}let v=class{constructor(r,l,c){this._proxy=r.getProxy(F.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=c,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,l))}};v=Ve([We(0,h.IExtHostRpcService),We(1,D.IExtHostWorkspace),We(2,E.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,l,c,S){this._onDidChangeConfiguration=new k.Emitter,this._proxy=r,this._logService=S,this._extHostWorkspace=l,this._configuration=A.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,l){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,c))}getConfiguration(r,l,c){const S=R(l)||{},n=this._toReadonlyValue(r?a(this._configuration.getValue(void 0,S,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,S,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,S,c?.identifier);function s(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case b.ConfigurationTarget.Global:return 2;case b.ConfigurationTarget.Workspace:return 5;case b.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(P){return typeof a(n,P)<"u"},get:(P,T)=>{this._validateConfigurationAccess(r?`${r}.${P}`:P,S,c?.identifier);let z=a(n,P);if(typeof z>"u")z=T;else{let Q;const Z=(Y,H)=>{let O;const m=()=>{Q=Q||(0,i.deepClone)(n),O=O||a(Q,H)};return(0,I.isObject)(Y)?new Proxy(Y,{get:(L,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return m(),()=>O;if(Q)return O=O||a(Q,H),O[B];const J=L[B];return typeof B=="string"?Z(J,`${H}.${B}`):J},set:(L,B,J)=>(m(),O&&(O[B]=J),!0),deleteProperty:(L,B)=>(m(),O&&delete O[B],!0),defineProperty:(L,B,J)=>(m(),O&&Object.defineProperty(O,B,J),!0)}):Y};z=Z(z,P)}return z},update:(P,T,z,Q)=>{P=r?`${r}.${P}`:P;const Z=s(z);return T!==void 0?this._proxy.$updateConfigurationOption(Z,P,T,S,Q):this._proxy.$removeConfigurationOption(Z,P,S,Q)},inspect:P=>{P=r?`${r}.${P}`:P;const T=this._configuration.inspect(P,S,this._extHostWorkspace.workspace);if(T)return{key:P,defaultValue:(0,i.deepClone)(T.policy?.value??T.default?.value),globalValue:(0,i.deepClone)(T.user?.value??T.application?.value),workspaceValue:(0,i.deepClone)(T.workspace?.value),workspaceFolderValue:(0,i.deepClone)(T.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(T.default?.override),globalLanguageValue:(0,i.deepClone)(T.user?.override??T.application?.override),workspaceLanguageValue:(0,i.deepClone)(T.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(T.workspaceFolder?.override),languageIds:(0,i.deepClone)(T.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(f,n,!1),Object.freeze(f)}_toReadonlyValue(r){const l=c=>(0,I.isObject)(c)?new Proxy(c,{get:(S,n)=>l(S[n]),set:(S,n,s)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(S,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(S,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(r)}_validateConfigurationAccess(r,l,c){const S=_.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),n=c?`[${c.value}] `:"";if(S===4){typeof l?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(S===3){l?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,l){const c=new A.ConfigurationChangeEvent(r,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(S,n)=>c.affectsConfiguration(S,R(n))})}_toMap(r){return r.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[107],ke([1,0,2,17,4,5,7,31,58,32,21,61,18,27,3,15,20,12,76,203,11]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(Y){function H(m){if(m!=null)return m}Y.from=H;function O(m){if(m!=null)return m}Y.to=O})(t||(t={}));var d;(function(Y){function H(m){if(m!=null)return m}Y.from=H;function O(m){if(m!=null)return m}Y.to=O})(d||(d={}));var r;(function(Y){function H(m){if(m!=null)return m}Y.from=H;function O(m){if(m!=null)return m}Y.to=O})(r||(r={}));var l;(function(Y){function H(L){if(L){const B=L;return B&&!!B.process}else return!1}Y.is=H;function O(L){if(L==null)return;const B={process:L.process,args:L.args};return L.options&&(B.options=r.from(L.options)),B}Y.from=O;function m(L){if(L!=null)return new b.ProcessExecution(L.process,L.args,L.options)}Y.to=m})(l||(l={}));var c;(function(Y){function H(m){if(m!=null)return m}Y.from=H;function O(m){if(m!=null)return m}Y.to=O})(c||(c={}));var S;(function(Y){function H(L){if(L){const B=L;return B&&(!!B.commandLine||!!B.command)}else return!1}Y.is=H;function O(L){if(L==null)return;const B={};return L.commandLine!==void 0?B.commandLine=L.commandLine:(B.command=L.command,B.args=L.args),L.options&&(B.options=c.from(L.options)),B}Y.from=O;function m(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new b.ShellExecution(L.commandLine,L.options):new b.ShellExecution(L.command,L.args?L.args:[],L.options)}Y.to=m})(S||(S={}));var n;(function(Y){function H(L){if(L){const B=L;return B&&B.customExecution==="customExecution"}else return!1}Y.is=H;function O(L){return{customExecution:"customExecution"}}Y.from=O;function m(L,B){return B.get(L)}Y.to=m})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var s;(function(Y){function H(O,m){let L;return O.scope!==void 0&&typeof O.scope!="number"?L=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===b.TaskScope.Workspace&&m&&m.workspaceFile?L=m.workspaceFile:L=w.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:L}}Y.from=H})(s=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(Y){function H(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}Y.from=H})(f||(f={}));var P;(function(Y){function H(L,B){if(L==null)return[];const J=[];for(const me of L){const te=O(me,B);te&&J.push(te)}return J}Y.fromMany=H;function O(L,B){if(L==null)return;let J;L.execution instanceof b.ProcessExecution?J=l.from(L.execution):L.execution instanceof b.ShellExecution?J=S.from(L.execution):L.execution&&L.execution instanceof b.CustomExecution&&(J=n.from(L.execution));const me=t.from(L.definition);let te;return L.scope?typeof L.scope=="number"?te=L.scope:te=L.scope.uri:te=b.TaskScope.Workspace,!me||!te?void 0:{_id:L._id,definition:me,name:L.name,source:{extensionId:B.identifier.value,label:L.source,scope:te},execution:J,isBackground:L.isBackground,group:f.from(L.group),presentationOptions:d.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}Y.from=O;async function m(L,B,J){if(L==null)return;let me;l.is(L.execution)?me=l.to(L.execution):S.is(L.execution)?me=S.to(L.execution):n.is(L.execution)&&(me=n.to(L._id,J));const te=t.to(L.definition);let oe;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?oe=L.source.scope:oe=await B.resolveWorkspaceFolder(i.URI.revive(L.source.scope)):oe=b.TaskScope.Workspace),!te||!oe)return;const ce=new b.Task(te,oe,L.name,L.source.label,me,L.problemMatchers);return L.isBackground!==void 0&&(ce.isBackground=L.isBackground),L.group!==void 0&&(ce.group=b.TaskGroup.from(L.group._id),ce.group&&L.group.isDefault&&(ce.group=new b.TaskGroup(ce.group.id,ce.group.label),L.group.isDefault===!0&&(ce.group.isDefault=L.group.isDefault))),L.presentationOptions&&(ce.presentationOptions=d.to(L.presentationOptions)),L._id&&(ce._id=L._id),L.detail&&(ce.detail=L.detail),ce}Y.to=m})(P=e.TaskDTO||(e.TaskDTO={}));var T;(function(Y){function H(m){return m}Y.from=H;function O(m){if(!!m)return Object.assign(Object.create(null),m)}Y.to=O})(T||(T={}));class z{constructor(H,O,m){this._id=O,this._task=m,v.set(this,void 0),Je(this,v,H,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}v=new WeakMap;let Q=class{constructor(H,O,m,L,B,J,me,te){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=H.getProxy(F.MainContext.MainThreadTask),this._workspaceProvider=m,this._editorService=L,this._configurationService=B,this._terminalService=J,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=me,this._deprecationService=te,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,O,m){if(!m)return new b.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:O,provider:m,extension:H}),this._proxy.$registerTaskProvider(L,O),new b.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(H,O){this._proxy.$registerTaskSystem(H,O)}fetchTasks(H){return this._proxy.$fetchTasks(T.from(H)).then(async O=>{const m=[];for(const L of O){const B=await P.to(L,this._workspaceProvider,this._providedCustomExecutions2);B&&m.push(B)}return m})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(O=>H.push(O)),H}terminateTask(H){if(!(H instanceof z))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,O,m){const L=this._providedCustomExecutions2.get(H.id);L&&(this._activeCustomExecutions2.set(H.id,L),this._terminalService.attachPtyToTerminal(O,await L.callback(m))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const O=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:O})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const O=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:O,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const O=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:O,exitCode:H.exitCode})}$provideTasks(H,O){const m=this._handlers.get(H);if(!m)return Promise.reject(new Error("no handler found"));const L=[],B=(0,k.asPromise)(()=>m.provider.provideTasks(N.CancellationToken.None)).then(J=>this.provideTasksInternal(O,L,m,J));return new Promise(J=>{B.then(me=>{Promise.all(L).then(()=>{J(me)})})})}async $resolveTask(H,O){const m=this._handlers.get(H);if(!m)return Promise.reject(new Error("no handler found"));if(O.definition.type!==m.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${m.type}].`);const L=await P.to(O,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const B=await m.provider.resolveTask(L,N.CancellationToken.None);if(!B)return;this.checkDeprecation(B,m);const J=P.from(B,m.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(J.execution)&&await this.addCustomExecution(J,B,!0),await this.resolveTaskInternal(J)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,O,m){const L=await this._proxy.$createTaskId(H);!m&&!this._providedCustomExecutions2.has(L)&&(this._notProvidedCustomExecutions.add(L),this._activeCustomExecutions2.set(L,O.execution)),this._providedCustomExecutions2.set(L,O.execution)}async getTaskExecution(H,O){if(typeof H=="string"){const B=this._taskExecutionPromises.get(H);if(!B)throw new R.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const m=this._taskExecutionPromises.get(H.id);if(m)return m;const L=new Promise((B,J)=>{function me(te,oe,ce){ce?B(new z(te,oe.id,ce)):J("Unexpected: Task does not exist.")}O?me(this,H,O):P.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(te=>me(this,H,te))});return this._taskExecutionPromises.set(H.id,L),L.then(B=>(this._taskExecutions.set(H.id,B),B),B=>Promise.reject(B))}checkDeprecation(H,O){H._deprecated&&this._deprecationService.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));const m=this._notProvidedCustomExecutions.values();let L=m.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=m.next()}};Q=Ve([We(0,h.IExtHostRpcService),We(1,E.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,y.IExtHostTerminalService),We(6,u.ILogService),We(7,p.IExtHostApiDeprecationService)],Q),e.ExtHostTaskBase=Q;let Z=class extends Q{constructor(H,O,m,L,B,J,me,te){super(H,O,m,L,B,J,me,te),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(H,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const m=P.from(O,H);if(m===void 0)throw new Error("Task is not valid");if(n.is(m.execution))await this.addCustomExecution(m,O,!1);else throw new R.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(m),O);return this._proxy.$executeTask(m).catch(B=>{throw new Error(B)}),L}provideTasksInternal(H,O,m,L){const B=[];if(L)for(const J of L){this.checkDeprecation(J,m),(!J.definition||!H[J.definition.type])&&this._logService.warn(`The task [${J.source}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`);const me=P.from(J,m.extension);me&&n.is(me.execution)?(B.push(me),O.push(this.addCustomExecution(me,J,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:m.extension}}async resolveTaskInternal(H){if(n.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,O,m){}};Z=Ve([We(0,h.IExtHostRpcService),We(1,E.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,y.IExtHostTerminalService),We(6,u.ILogService),We(7,p.IExtHostApiDeprecationService)],Z),e.WorkerExtHostTask=Z,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Ie[246],ke([1,0,19,21,39,35,24,77,47]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(h,E,g){this.config=h,this.provider=E,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&F.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&F.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const E=this.config.folderQueries||[];return new Promise((g,a)=>{const o=u=>{this.resultCount++,h(u)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(u=>{const p=u.toString(),w=i.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,w)||this.matchFile(o,{base:u,basename:w})}),Promise.all(E.map(u=>this.searchInFolder(u,o))).then(u=>{g({limitHit:this.isLimitHit,stats:u[0]||void 0})},u=>{a(new Error((0,D.toErrorMessage)(u)))})})}async searchInFolder(h,E){const g=new k.CancellationTokenSource,a=this.getSearchOptionsForFolder(h),o=this.initDirectoryTree(),u=new _.QueryGlobTester(this.config,h),p=!u.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(g),w=A.StopWatch.create();const R=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,g.token),v=w.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(R&&R.forEach(d=>{const r=i.posix.relative(h.folder.path,d.path);if(p){const l=i.basename(d.path);this.matchFile(E,{base:h.folder,relativePath:r,basename:l});return}this.addDirectoryEntries(o,h.folder,r,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,u,E),{providerTime:v,postProcessTime:t.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(h){const E=(0,_.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),g=(0,_.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:g,includes:E,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},E,g,a){if(g===this.filePattern){const u=i.basename(this.filePattern);this.matchFile(a,{base:E,relativePath:this.filePattern,basename:u})}function o(u){const p=i.basename(u),w=i.dirname(u);let R=h[w];R||(R=h[w]=[],o(w)),R.push({base:E,relativePath:u,basename:p})}o(g)}matchDirectoryTree({rootEntries:h,pathToEntries:E},g,a){const o=this,u=this.filePattern;function p(w){const R=(0,_.hasSiblingFn)(()=>w.map(v=>v.basename));for(let v=0,t=w.length;v<t;v++){const d=w[v],{relativePath:r,basename:l}=d;if(g.matchesExcludesSync(r,l,u!==l?R:void 0))continue;const c=E[r];if(c)p(c);else{if(r===u)continue;o.matchFile(a,d)}if(o.isLimitHit)break}}p(h)}matchFile(h,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(E))}}class N{constructor(){this.sessions=new Map}fileSearch(h,E,g,a){const o=this.getSessionTokenSource(h.cacheKey),u=new I(h,E,o&&o.token);let p=0;const w=R=>{p+=R.length,g(R.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(u,N.BATCH_SIZE,w,a).then(R=>({limitHit:R.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:R.stats}}))}clearCache(h){this.getSessionTokenSource(h)?.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new k.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:b.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,E,g,a){a.onCancellationRequested(()=>{h.cancel()});const o=p=>{p&&(u.push(p),E>0&&u.length>=E&&(g(u),u=[]))};let u=[];return h.search(o).then(p=>(u.length&&g(u),p),p=>(u.length&&g(u),Promise.reject(p)))}}N.BATCH_SIZE=512,e.FileSearchManager=N}),define(Ie[247],ke([1,0,16,63,35,87,28,15,19,24,10,9,2,263,155,41,12,53,97,245,47]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(P,T,z,Q,Z){this.configurationService=P,this.workspaceContextService=T,this.editorGroupsService=z,this.logService=Q,this.pathService=Z}text(P,T,z={}){P=this.getContentPattern(P,z);const Q=this.configurationService.getValue(),Z=T&&T.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(T?.map(u.toWorkspaceFolder),z),type:2,contentPattern:P,previewOptions:z.previewOptions,maxFileSize:z.maxFileSize,usePCRE2:Q.search.usePCRE2||Z||!1,beforeContext:z.beforeContext,afterContext:z.afterContext,userDisabledExcludesAndIgnoreFiles:z.disregardExcludeSettings&&z.disregardIgnoreFiles}}getContentPattern(P,T){const z=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const Q={...P,wordSeparators:z.editor.wordSeparators};return this.isCaseSensitive(P,T)&&(Q.isCaseSensitive=!0),this.isMultiline(P)&&(Q.isMultiline=!0),Q}file(P,T={}){return{...this.commonQuery(P,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(P,T){return P?(P=Array.isArray(P)?P.map(c):c(P),T?this.parseSearchPaths(P):{pattern:d(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],T={}){const z=this.handleIncludeExclude(T.includePattern,T.expandPatterns),Q=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),Z=P.length>1,Y=(z.searchPaths&&z.searchPaths.length?z.searchPaths.map(m=>this.getFolderQueryForSearchPath(m,T,Q)):P.map(m=>this.getFolderQueryForRoot(m,T,Q,Z))).filter(m=>!!m),H={_reason:T._reason,folderQueries:Y,usingSearchPaths:!!(z.searchPaths&&z.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:Q.pattern,includePattern:z.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const m=i.coalesce(i.flatten(this.editorGroupsService.groups.map(J=>J.editors.map(me=>me.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(m));const L=m.filter(J=>(0,R.pathIncludedInQuery)(H,J.fsPath)),B=this.commonQueryFromFileList(L);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...H,...B}}const O=T.extraFileResources&&T.extraFileResources.filter(m=>(0,R.pathIncludedInQuery)(H,m.fsPath));return H.extraFileResources=O&&O.length?O:void 0,H}commonQueryFromFileList(P){const T=[],z=new b.ResourceMap,Q={};let Z=!1;return P.forEach(Y=>{if(Y.scheme===A.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(Y)){const O=this.workspaceContextService.getWorkspaceFolder(Y)?.uri??Y.with({path:_.dirname(Y.fsPath)});let m=z.get(O);m||(Z=!0,m={folder:O,includePattern:{}},T.push(m),z.set(O,m));const L=_.relative(O.fsPath,Y.fsPath);(0,y.assertIsDefined)(m.includePattern)[L.replace(/\\/g,"/")]=!0}else Y.fsPath&&(Z=!0,Q[Y.fsPath]=!0)}),{folderQueries:T,includePattern:Q,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}isCaseSensitive(P,T){if(T.isSmartCase){if(P.isRegExp){if(N.containsUppercaseCharacter(P.pattern,!0))return!0}else if(N.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&(0,E.isMultilineRegexSource)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const T=B=>_.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),Q=(Array.isArray(P)?P:r(P)).map(B=>{const J=this.pathService.resolvedUserHome;return J?(0,F.untildify)(B,J.scheme===A.Schemas.file?J.fsPath:J.path):B}),Z=k.groupBy(Q,B=>T(B)?"searchPaths":"exprSegments"),Y=(Z.exprSegments||[]).map(B=>N.rtrim(B,"/")).map(B=>N.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),H={},O=this.expandSearchPathPatterns(Z.searchPaths||[]);O&&O.length&&(H.searchPaths=O);const m=i.flatten(Y),L=d(...m);return L&&(H.pattern=L),H}getExcludesForFolder(P,T){return T.disregardExcludeSettings?void 0:(0,R.getExcludes)(P,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const T=P.flatMap(Q=>{let{pathPortion:Z,globPortion:Y}=t(Q);return Y&&(Y=S(Y)),this.expandOneSearchPath(Z).flatMap(O=>this.resolveOneSearchPathPattern(O,Y))}),z=new Map;return T.forEach(Q=>{const Z=Q.searchPath.toString(),Y=z.get(Z);Y?Q.pattern&&(Y.pattern=Y.pattern||{},Y.pattern[Q.pattern]=!0):z.set(Z,{searchPath:Q.searchPath,pattern:Q.pattern?d(Q.pattern):void 0})}),Array.from(z.values())}expandOneSearchPath(P){if(_.isAbsolute(P)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==A.Schemas.file?[{searchPath:T[0].uri.with({path:P})}]:[{searchPath:h.URI.file(_.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=c(P),P.startsWith("../")||P===".."){const Q=_.posix.resolve(T.path,P);return[{searchPath:T.with({path:Q})}]}const z=S(P);return[{searchPath:T,pattern:z}]}else{if(P==="./"||P===".\\")return[];{const T=P.replace(/^\.[\/\\]/,""),Q=this.workspaceContextService.getWorkspace().folders.map(Z=>{const Y=T.match(new RegExp(`^${N.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return Y?{match:Y,folder:Z}:null}).filter(y.isDefined);if(Q.length)return Q.map(Z=>{const Y=Z.match[1];return{searchPath:Z.folder.uri,pattern:Y&&S(Y)}});{const Z=P.match(/\.[\/\\](.+)[\/\\]?/),Y=Z?Z[1]:P,H=g.localize(0,null,Y);throw new Error(H)}}}}resolveOneSearchPathPattern(P,T){const z=P.pattern&&T?`${P.pattern}/${T}`:P.pattern||T,Q=[{searchPath:P.searchPath,pattern:z}];return z&&!z.endsWith("**")&&Q.push({searchPath:P.searchPath,pattern:z+"/**"}),Q}getFolderQueryForSearchPath(P,T,z){const Q=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(P.searchPath),T,z,!1);return Q?{...Q,includePattern:P.pattern}:null}getFolderQueryForRoot(P,T,z,Q){let Z;const Y=h.URI.isUri(P)?P:P.uri;if(z.searchPaths){const B=z.searchPaths.filter(J=>(0,I.isEqual)(J.searchPath,Y))[0];if(B&&!B.pattern)return null;B&&(Z=B.pattern)}const H=this.configurationService.getValue({resource:Y}),m={...this.getExcludesForFolder(H,T)||{},...Z||{}},L=h.URI.isUri(P)?(0,I.basename)(P):P.name;return{folder:Y,folderName:Q?L:void 0,excludePattern:Object.keys(m).length>0?m:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!H.search.followSymlinks}}};v=Ve([We(0,a.IConfigurationService),We(1,u.IWorkspaceContextService),We(2,p.IEditorGroupsService),We(3,o.ILogService),We(4,w.IPathService)],v),e.QueryBuilder=v;function t(f){const P=f.match(/[\*\{\}\(\)\[\]\?]/);if(P){const T=P.index,z=f.substr(0,T).match(/[/|\\][^/\\]*$/);if(z){let Q=f.substr(0,z.index);return Q.match(/[/\\]/)||(Q+="/"),{pathPortion:Q,globPortion:f.substr((z.index||0)+1)}}}return{pathPortion:f}}function d(...f){return f.length?f.reduce((P,T)=>(P[T]=!0,P),Object.create(null)):void 0}function r(f){return D.splitGlobAware(f,",").map(P=>P.trim()).filter(P=>!!P.length)}function l(f){return[`**/${f}/**`,`**/${f}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function c(f){return f.replace(/\\/g,"/")}function S(f){return c(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(f){return f.replace(/([?*[\]])/g,"[$1]")}function s(f,P){f=i.distinct(f,Q=>Q.toString());const T=[],z=P.getWorkspace();return f&&f.forEach(Q=>{let Z;if(P.getWorkbenchState()===2)Z=(0,I.relativePath)(z.folders[0].uri,Q),Z&&Z!=="."&&(Z="./"+Z);else{const Y=P.getWorkspaceFolder(Q);if(Y){const H=Y.name;if(z.folders.filter(m=>m.name===H).length===1){const m=(0,I.relativePath)(Y.uri,Q);m===""?Z=`./${Y.name}`:Z=`./${Y.name}/${m}`}else Z=Q.fsPath}}Z&&T.push(n(Z))}),T}e.resolveResourcesForSearchIncludes=s}),define(Ie[248],ke([1,0,24,2,21,11,3,247,47,53]),function(ne,e,i,k,D,F,b,A,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function y(a,o){const u=o.activationEvents;if(!u)return Promise.resolve(void 0);const p=[],w=[];for(const l of u)if(/^workspaceContains:/.test(l)){const c=l.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||a.forceUsingSearch?w.push(c):p.push(c)}if(p.length===0&&w.length===0)return Promise.resolve(void 0);let R;const v=new Promise((l,c)=>{R=l}),t=l=>R({activationEvent:l}),d=Promise.all(p.map(l=>h(a,l,t))).then(()=>{}),r=E(a,o.identifier,w,t);return Promise.all([d,r]).then(()=>{R(void 0)}),v}e.checkActivateWorkspaceContainsExtension=y;async function h(a,o,u){for(const p of a.folders)if(await a.exists(i.joinPath(k.URI.revive(p),o))){u(`workspaceContains:${o}`);return}}async function E(a,o,u,p){if(u.length===0)return Promise.resolve(void 0);const w=new D.CancellationTokenSource,R=a.checkExists(a.folders,u,w.token),v=setTimeout(async()=>{w.cancel(),a.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},N);let t=!1;try{t=await R}catch(d){F.isCancellationError(d)||F.onUnexpectedError(d)}w.dispose(),clearTimeout(v),t&&p(`workspaceContains:${u.join(",")}`)}function g(a,o,u,p){const w=a.get(b.IInstantiationService),R=a.get(_.ISearchService),t=w.createInstance(A.QueryBuilder).file(o.map(d=>(0,I.toWorkspaceFolder)(k.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return R.fileSearch(t,p).then(d=>!!d.limitHit,d=>F.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=g});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(ne,i):D?D.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(ne):k?k.value:e.get(ne)};define(Ie[33],ke([1,0,140,19,82,24,17,6,48,2,12,5,32,193,80,31,25,98,11,26,23,178,7,94,3,27,81,18,68,70,61,4,248,79,180,15,78,77,20]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v,t,d,r,l,c,S,n,s,f,P,T,z,Q,Z,Y,H,O){"use strict";var m,L,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let J=class Mi extends A.Disposable{constructor(V,q,G,de,Se,Le,xe,Te,De,_e,ae){super(),this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=q,this._extHostContext=G,this._initData=xe,this._extHostWorkspace=de,this._extHostConfiguration=Se,this._logService=Le,this._extHostTunnelService=De,this._extHostTerminalService=_e,this._extHostLocalizationService=ae,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new b.Barrier,this._readyToStartExtensionHost=new b.Barrier,this._readyToRunExtensions=new b.Barrier,this._eagerExtensionsActivated=new b.Barrier,this._globalRegistry=new u.ExtensionDescriptionRegistry(this._initData.allExtensions);const ue=(0,o.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new u.ExtensionDescriptionRegistry(oe(this._globalRegistry,ue)),this._storage=new g.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new z.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=V.createChild(new n.ServiceCollection([g.IExtHostStorage,this._storage],[z.IExtHostSecretState,this._secretState])),this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ee,C,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,p.transformErrorForSerialization(C),U)},actualActivateExtension:async(ee,C)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(ee,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ee,C),new E.HostExtension;const U=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(U,C)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){p.onUnexpectedError(V)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(V)}terminate(V,q=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${V}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),p.setUnexpectedErrorHandler(de=>{this._logService.error(de)}),this._extHostContext.dispose();const G=this._deactivateAll();Promise.race([(0,b.timeout)(5e3),G]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${q}`):this._logService.info(`Extension host exiting with code ${q}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(q)})}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}async getExtension(V){const q=await this._mainThreadExtensionsProxy.$getExtension(V);let G;if(q?.browserNlsBundleUris){G={};for(const de of Object.keys(q.browserNlsBundleUris))G[de]=I.URI.revive(q.browserNlsBundleUris[de])}return q&&{...q,identifier:new w.ExtensionIdentifier(q.identifier.value),extensionLocation:I.URI.revive(q.extensionLocation),browserNlsBundleUris:G}}_activateByEvent(V,q){return this._activator.activateByEvent(V,q)}_activateById(V,q){return this._activator.activateById(V,q)}activateByIdWithErrors(V,q){return this._activateById(V,q).then(()=>{const G=this._activator.getActivatedExtension(V);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._myRegistry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==Z.Schemas.file)return V;const q=await this._hostUtils.realpath(V.fsPath);return I.URI.file(q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(V=>new ce(V))),this._extensionPathIndex}async _createExtensionPathIndex(V){const q=_.TernarySearchTree.forUris(G=>F.extUriBiasedIgnorePathCase.ignorePathCasing(G));return await Promise.all(V.map(async G=>{if(this._getEntryPoint(G)){const de=await this._realPathExtensionUri(G.extensionLocation);q.set(de,G)}})),q}_deactivate(V){let q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return q;const G=this._activator.getActivatedExtension(V);if(!G)return q;try{typeof G.module.deactivate=="function"&&(q=Promise.resolve(G.module.deactivate()).then(void 0,de=>(this._logService.error(de),Promise.resolve(void 0))))}catch(de){this._logService.error(`An error occurred when deactivating the extension '${V.value}':`),this._logService.error(de)}try{(0,A.dispose)(G.subscriptions)}catch(de){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this._logService.error(de)}return q}async _activateExtension(V,q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,q).then(G=>{const de=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,q),this._logExtensionActivationTimes(V,q,"success",de),G},G=>{throw this._logExtensionActivationTimes(V,q,"failure"),G})}_logExtensionActivationTimes(V,q,G,de){const Se=me(V,q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...de||{},outcome:G})}_doActivateExtension(V,q){const G=me(V,q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const de=this._getEntryPoint(V);if(!de)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${V.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this._logService.flush();const Se=new E.ExtensionActivationTimesBuilder(q.startup);return Promise.all([this._loadCommonJSModule(V,(0,F.joinPath)(V.extensionLocation,de),Se),this._loadExtensionContext(V)]).then(Le=>(D.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Mi._callActivate(this._logService,V.identifier,Le[0],Le[1],Se))).then(Le=>(D.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),Le))}_loadExtensionContext(V){const q=new v.ExtensionGlobalMemento(V,this._storage),G=new v.ExtensionMemento(V.identifier.value,!1,this._storage),de=new Q.ExtensionSecrets(V,this._secretState),Se=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([q.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const xe=this;let Te,De;const _e=(0,o.isProposedApiEnabled)(V,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(V.identifier)):void 0;return Object.freeze({globalState:q,workspaceState:G,secrets:de,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(ae){return k.join(V.extensionLocation.fsPath,ae)},get storagePath(){return xe._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return xe._storagePath.globalValue(V).fsPath},get logPath(){return k.join(xe._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return I.URI.joinPath(xe._initData.logsLocation,V.identifier.value)},get storageUri(){return xe._storagePath.workspaceValue(V)},get globalStorageUri(){return xe._storagePath.globalValue(V)},get extensionMode(){return Se},get extension(){return Te===void 0&&(Te=new te(xe,V.identifier,V,Le,!1)),Te},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(V,"extensionRuntime"),xe.extensionRuntime},get environmentVariableCollection(){return xe._extHostTerminalService.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!De){if(!_e)return;const ae=P.Event.buffer(P.Event.fromDOMEventEmitter(_e,"message",ue=>ue.data));_e.start(),De={onDidReceiveMessage:ae,postMessage:_e.postMessage.bind(_e)}}return De}})})}static _callActivate(V,q,G,de,Se){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,q,G,de,Se).then(Le=>new E.ActivatedExtension(!1,null,Se.build(),G,Le,de.subscriptions))}static _callActivateOptional(V,q,G,de,Se){if(typeof G.activate=="function")try{Se.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${q.value}`);const Le=typeof global=="object"?global:self,xe=G.activate.apply(Le,[de]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(xe).then(Te=>(Se.activateResolveStop(),Te))}catch(Le){return Promise.reject(Le)}else return Promise.resolve(G)}_activateOneStartupFinished(V,q){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:q}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinishedDeferred(V,q=0){const de=Date.now();(0,O.setTimeout0)(()=>{for(let Se=q;Se<V.length;Se+=1){const Le=V[Se];for(const xe of Le.activationEvents??[])if(xe==="onStartupFinished")if(Date.now()-de>50){this._activateAllStartupFinishedDeferred(V,Se);break}else this._activateOneStartupFinished(Le,xe)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks()),this._extHostConfiguration.getConfigProvider().then(V=>{const q=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),G=this._myRegistry.getAllExtensionDescriptions();if(q)this._activateAllStartupFinishedDeferred(G);else for(const de of G)if(de.activationEvents)for(const Se of de.activationEvents)Se==="onStartupFinished"&&this._activateOneStartupFinished(de,Se)})}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(q),de=Promise.all([V,G]).then(()=>{});return Promise.race([de,(0,b.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),de}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(q=>this._handleWorkspaceContainsEagerExtension(V,q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,q){if(this.isActivated(q.identifier))return;const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,de={logService:this._logService,folders:V.map(Le=>Le.uri),forceUsingSearch:G,exists:Le=>this._hostUtils.exists(Le.fsPath),checkExists:(Le,xe,Te)=>this._mainThreadWorkspaceProxy.$checkExists(Le,xe,Te)},Se=await(0,T.checkActivateWorkspaceContainsExtension)(de,q);if(!!Se)return this._activateById(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:Se.activationEvent}).then(void 0,Le=>this._logService.error(Le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:q}=this._initData.environment;if(!V||!q)throw new Error(i.localize(0,null));const G=await this._loadCommonJSModule(null,q,new E.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(i.localize(1,null,q.toString()));return new Promise((de,Se)=>{const Le=(De,_e)=>{De?Se(De):de(typeof _e=="number"&&_e>0?1:0)},xe=(0,F.originalFSPath)(q),Te=G.run(xe,Le);Te&&Te.then&&Te.then(()=>{de(0)}).catch(De=>{Se(De instanceof Error&&De.stack?De.stack:String(De))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,q){return this._resolvers[V]=q,(0,A.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const q=V.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const G=V.substr(0,q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this._resolvers[G]}}async $resolveAuthority(V,q){const G=H.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(V)},${q})][${G.elapsed()}ms] `,Se=_e=>this._logService.info(`${de()}${_e}`),Le=(_e,ae=void 0)=>this._logService.error(`${de()}${_e}`,ae);Se("activating resolver...");const{authorityPrefix:xe,resolver:Te}=await this._activateAndGetResolver(V);if(!Te)return Le("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${xe}.`,detail:void 0}};const De=new b.IntervalTimer;try{Se("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Te)),De.cancelAndSet(()=>Se("waiting..."),1e3),Se("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${xe}`);const _e=await Te.resolve(V,{resolveAttempt:q});D.mark(`code/extHost/didResolveAuthorityOK/${xe}`),De.dispose(),Se(`returned ${_e.host}:${_e.port}`);const ae={authority:V,host:_e.host,port:_e.port,connectionToken:_e.connectionToken},ue={extensionHostEnv:_e.extensionHostEnv,isTrusted:_e.isTrusted,authenticationSession:_e.authenticationSessionForInitializingExtensions?{id:_e.authenticationSessionForInitializingExtensions.id,providerId:_e.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ae,options:ue,tunnelInformation:{environmentTunnels:_e.environmentTunnels,features:_e.tunnelFeatures}}}}catch(_e){if(D.mark(`code/extHost/didResolveAuthorityError/${xe}`),De.dispose(),Le("returned an error",_e),_e instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:_e._code,message:_e._message,detail:_e._detail}};throw _e}}async $getCanonicalURI(V,q){this._logService.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(V)})`);const{resolver:G}=await this._activateAndGetResolver(V);if(!G)return null;const de=I.URI.revive(q);if(typeof G.getCanonicalURI>"u")return de;const Se=await(0,b.asPromise)(()=>G.getCanonicalURI(de));return Se||de}static _applyExtensionsDelta(V,q,G){const de=new u.ExtensionDescriptionRegistry(V.getAllExtensionDescriptions());de.deltaExtensions(G.toAdd,G.toRemove);const Se=(0,o.extensionIdentifiersArrayToSet)(q.getAllExtensionDescriptions().map(xe=>xe.identifier));for(const xe of G.myToRemove)Se.delete(w.ExtensionIdentifier.toKey(xe));for(const xe of G.myToAdd)Se.add(w.ExtensionIdentifier.toKey(xe));const Le=oe(de,Se);return{globalRegistry:de,myExtensions:Le}}$startExtensionHost(V){V.toAdd.forEach(de=>de.extensionLocation=I.URI.revive(de.extensionLocation));const{globalRegistry:q,myExtensions:G}=Mi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,V);return this._globalRegistry.set(q.getAllExtensionDescriptions()),this._myRegistry.set(G),this._startExtensionHost()}$activateByEvent(V,q){return q===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(V,!1))}async $activate(V,q){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(V)?(await this._activateById(V,q),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(Le=>Le.extensionLocation=I.URI.revive(Le.extensionLocation));const{globalRegistry:q,myExtensions:G}=Mi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,V),de=await this._createExtensionPathIndex(G);return(await this.getExtensionPathIndex()).setSearchTree(de),this._globalRegistry.set(q.getAllExtensionDescriptions()),this._myRegistry.set(G),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const q=R.VSBuffer.alloc(V),G=Math.random()%256;for(let de=0;de<V;de++)q.writeUInt8(G,de);return q}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};J=Ve([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,S.IExtHostRpcService),We(3,a.IExtHostWorkspace),We(4,h.IExtHostConfiguration),We(5,N.ILogService),We(6,l.IExtHostInitDataService),We(7,c.IExtensionStoragePaths),We(8,s.IExtHostTunnelService),We(9,f.IExtHostTerminalService),We(10,Y.IExtHostLocalizationService)],J),e.AbstractExtHostExtensionService=J;function me(we,V){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class te{constructor(V,q,G,de,Se){m.set(this,void 0),L.set(this,void 0),B.set(this,void 0),Je(this,m,V,"f"),Je(this,L,q,"f"),Je(this,B,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=k.normalize((0,F.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=de,this.isFromDifferentExtensionHost=Se}get isActive(){return Oe(this,m,"f").isActivated(Oe(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,m,"f").getExtensionExports(Oe(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,m,"f").activateByIdWithErrors(Oe(this,B,"f"),{startup:!1,extensionId:Oe(this,L,"f"),activationEvent:"api"}),this.exports}}e.Extension=te,m=new WeakMap,L=new WeakMap,B=new WeakMap;function oe(we,V){return we.getAllExtensionDescriptions().filter(q=>V.has(w.ExtensionIdentifier.toKey(q.identifier)))}class ce{constructor(V){this._searchTree=V}setSearchTree(V){this._searchTree=V}findSubstr(V){return this._searchTree.findSubstr(V)}forEach(V){return this._searchTree.forEach(V)}}e.ExtensionPaths=ce}),define(Ie[249],ke([1,0,82,2,5,32,25,26,18,27,3,33,51,12,10]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(v,t,d,r,l,c,S){this._apiFactory=v,this._extensionRegistry=t,this._instaService=d,this._extHostConfiguration=r,this._extHostExtensionService=l,this._initData=c,this._logService=S,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),i.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,t,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(p,t)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,t,this._initData.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this._factories.set(t,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(t=>v.alternativeModuleName(t))}};a=Ve([We(2,N.IInstantiationService),We(3,F.IExtHostConfiguration),We(4,y.IExtHostExtensionService),We(5,I.IExtHostInitDataService),We(6,E.ILogService)],a),e.RequireInterceptor=a;let o=class rn{constructor(v){if(v.environment.appRoot&&rn.aliased.size){const t=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(v.environment.appRoot.fsPath)),d="[a-z0-9_.-]",r=`@${d}+\\/${d}+|${d}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${l}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(v));if(!t)return;const[,d,r,l]=t,c=rn.aliased.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),d+c+l}forceForwardSlashes(v){return v.replace(/\\/g,"/")}};o.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=Ve([We(0,I.IExtHostInitDataService)],o);class u{constructor(v,t,d,r,l){this._apiFactory=v,this._extensionPaths=t,this._extensionRegistry=d,this._configProvider=r,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,t){const d=this._extensionPaths.findSubstr(t);if(d){let r=this._extApiImpl.get(A.ExtensionIdentifier.toKey(d.identifier));return r||(r=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(d.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((l,c)=>r+=`	${c} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(b.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(v,t,d){this._extensionPaths=v,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=d,l=t.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let c=r.appRoot.fsPath;h.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${c}/node_modules.asar/keytar`),this.alternativeNames.add(`${c}/node_modules/keytar`)}this._impl={getPassword:(c,S)=>l.$getPassword(c,S),setPassword:(c,S,n)=>l.$setPassword(c,S,n),deletePassword:(c,S)=>l.$deletePassword(c,S),findPassword:c=>l.$findPassword(c),findCredentials(c){return l.$findCredentials(c)}}}load(v,t){const d=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(v){const t=v.length;if(t<=7||!this.alternativeNames)return;const d=t-7;if((v.charAt(d)==="/"||v.charAt(d)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}};p=Ve([We(1,_.IExtHostRpcService),We(2,I.IExtHostInitDataService)],p);let w=class{constructor(v,t,d){this._extensionPaths=v,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(D.MainContext.MainThreadTelemetry);const r=d.getProxy(D.MainContext.MainThreadWindow);this._impl=(l,c)=>{const S=k.URI.parse(l);return c?this.callOriginal(l,c):S.scheme==="http"||S.scheme==="https"?r.$openUri(S,l,{allowTunneling:!0}):S.scheme==="mailto"||S.scheme===this._appUriScheme?r.$openUri(S,l,{}):this.callOriginal(l,c)}}load(v,t,d){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=d(v),this._impl}callOriginal(v,t){return this.sendNoForwardTelemetry(),this._original(v,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([We(2,_.IExtHostRpcService)],w)}),define(Ie[108],ke([1,0,85,6,19,51,3,58,59,33,7,31,190,32]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,b.createDecorator)("IExtHostVariableResolverProvider");class g extends h.AbstractVariableResolverService{constructor(u,p,w,R,v,t,d){function r(){if(w){const l=w.activeEditor();if(l)return l.document.uri;const c=R.tabGroups.all.find(S=>S.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof N.TextDiffTabInput||c.input instanceof N.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof N.TextTabInput||c.input instanceof N.NotebookEditorTabInput||c.input instanceof N.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(S=>S.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>v.getConfiguration(void 0,l).get(c),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=r();if(l)return D.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const l=r();if(l){const c=p.getWorkspaceFolder(l);if(c)return D.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(w){const l=w.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(w){const l=w.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>u.getExtension(l)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(F.env))}}let a=class extends k.Disposable{constructor(u,p,w,R,v){super(),this.extensionService=u,this.workspaceService=p,this.editorService=w,this.configurationService=R,this.editorTabs=v,this._resolver=new i.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new g(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};a=Ve([We(0,I.IExtHostExtensionService),We(1,y.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,E.IExtHostConfiguration),We(4,_.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ie[109],ke([1,0,17,4,9,2,3,5,59,33,18,7,31,183,185,32,108]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,l,c,S,n,s){this._workspaceService=l,this._extensionService=c,this._configurationService=S,this._editorTabs=n,this._variableResolver=s,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=r.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(f=>{f.onDidChange(P=>{this.registerAllDebugTypes(f)}),this.registerAllDebugTypes(f)})}asDebugSourceUri(r,l){const c=r;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let S=`debug:${encodeURIComponent(c.path||"")}`,n="?";return l&&(S+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),S+=`${n}ref=${c.sourceReference}`,F.URI.parse(S)}else{if(c.path)return F.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const l=[];for(const c of r.getAllExtensionDescriptions())if(c.contributes){const S=c.contributes.debuggers;if(S&&S.length>0)for(const n of S)(0,g.isDebuggerMainContribution)(n)&&l.push(n.type)}this._debugServiceProxy.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(l=>r.push(l)),r}addBreakpoints(r){this.startBreakpoints();const l=r.filter(n=>{const s=n.id;return this._breakpoints.has(s)?!1:(this._breakpoints.set(s,n),!0)});this.fireBreakpointChanges(l,[],[]);const c=[],S=new Map;for(const n of l)if(n instanceof y.SourceBreakpoint){let s=S.get(n.location.uri.toString());s||(s={type:"sourceMulti",uri:n.location.uri,lines:[]},S.set(n.location.uri.toString(),s),c.push(s)),s.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof y.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(c)}removeBreakpoints(r){this.startBreakpoints();const l=r.filter(s=>this._breakpoints.delete(s.id));this.fireBreakpointChanges([],l,[]);const c=l.filter(s=>s instanceof y.SourceBreakpoint).map(s=>s.id),S=l.filter(s=>s instanceof y.FunctionBreakpoint).map(s=>s.id),n=l.filter(s=>s instanceof y.DataBreakpoint).map(s=>s.id);return this._debugServiceProxy.$unregisterBreakpoints(c,S,n)}startDebugging(r,l,c){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,l,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,l,c){if(!l)return new y.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:S,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,c,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,S),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(r,l,c){if(!c)return new y.Disposable(()=>{});if(!this.definesDebugType(r,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:S,factory:c}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,S),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==c),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(r,l){if(!l)return new y.Disposable(()=>{});const c=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:c,factory:l}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==l)})}async $runInTerminal(r,l){return Promise.resolve(void 0)}async $substituteVariables(r,l){let c;const S=await this.getFolder(r);return S&&(c={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(c,l)}createDebugAdapter(r,l){if(r.type==="implementation")return new v(r.implementation)}createSignService(){}async $startDASession(r,l){const c=this,S=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const s=this.convertToDto(n),f=this.createDebugAdapter(s,S);if(!f)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const P=f;return this._debugAdapters.set(r,P),this.getDebugAdapterTrackers(S).then(T=>(T&&this._debugAdaptersTrackers.set(r,T),P.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const Q=z,Z={type:"response",seq:0,command:Q.command,request_seq:Q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const Y=await this._signService.sign(Q.arguments.value);Z.body={signature:Y},P.sendResponse(Z)}else throw new Error("no signer")}catch(Y){Z.success=!1,Z.message=Y.message,P.sendResponse(Z)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(z),z=(0,g.convertToVSCPaths)(z,!0),c._debugServiceProxy.$acceptDAMessage(r,z)}),P.onError(z=>{T&&T.onError&&T.onError(z),this._debugServiceProxy.$acceptDAError(r,z.name,z.message,z.stack)}),P.onExit(z=>{T&&T.onExit&&T.onExit((0,D.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,D.withNullAsUndefined)(z),void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),P.startSession()))})}$sendDAMessage(r,l){l=(0,g.convertToDAPaths)(l,!1);const c=this._debugAdaptersTrackers.get(r);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(l),this._debugAdapters.get(r)?.sendMessage(l)}$stopDASession(r){const l=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),l&&l.onWillStopSession&&l.onWillStopSession();const c=this._debugAdapters.get(r);return this._debugAdapters.delete(r),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const l=[],c=[],S=[];if(r.added)for(const n of r.added){const s=n.id;if(s&&!this._breakpoints.has(s)){let f;if(n.type==="function")f=new y.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")f=new y.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const P=F.URI.revive(n.uri);f=new y.SourceBreakpoint(new y.Location(P,new y.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,y.setBreakpointId)(f,s),this._breakpoints.set(s,f),l.push(f)}}if(r.removed)for(const n of r.removed){const s=this._breakpoints.get(n);s&&(this._breakpoints.delete(n),c.push(s))}if(r.changed){for(const n of r.changed)if(n.id){const s=this._breakpoints.get(n.id);if(s){if(s instanceof y.FunctionBreakpoint&&n.type==="function"){const f=s;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.functionName=n.functionName}else if(s instanceof y.SourceBreakpoint&&n.type==="source"){const f=s;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.location=new y.Location(F.URI.revive(n.uri),new y.Position(n.line,n.character))}S.push(s)}}}this.fireBreakpointChanges(l,c,S)}$provideDebugConfigurations(r,l,c){return(0,i.asPromise)(async()=>{const S=this.getConfigProviderByHandle(r);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(l);return S.provideDebugConfigurations(n,c)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(r,l,c,S){return(0,i.asPromise)(async()=>{const n=this.getConfigProviderByHandle(r);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const s=await this.getFolder(l);return n.resolveDebugConfiguration(s,c,S)})}$resolveDebugConfigurationWithSubstitutedVariables(r,l,c,S){return(0,i.asPromise)(async()=>{const n=this.getConfigProviderByHandle(r);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const s=await this.getFolder(l);return n.resolveDebugConfigurationWithSubstitutedVariables(s,c,S)})}async $provideDebugAdapter(r,l){const c=this.getAdapterDescriptorFactoryByHandle(r);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(l);return this.getAdapterDescriptor(c,S).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(r){const l=await this.getSession(r);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(r){const l=await this.getSession(r);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,l){(await this.getSession(r))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(r,l){const S={session:await this.getSession(r),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(r){if(r instanceof y.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof y.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const l=this._adapterFactories.filter(c=>c.type===r);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(r){const l=this._adapterFactories.filter(c=>c.handle===r);if(l.length>0)return l[0].factory}getConfigProviderByHandle(r){const l=this._configProviders.filter(c=>c.handle===r);if(l.length>0)return l[0].provider}definesDebugType(r,l){if(r.contributes){const c=r.contributes.debuggers;if(c&&c.length>0){for(const S of c)if(S.label&&S.type&&S.type===l)return!0}}return!1}getDebugAdapterTrackers(r){const c=r.configuration.type,S=this._trackerFactories.filter(n=>n.type===c||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(r)).then(s=>s,s=>null));return Promise.race([Promise.all(S).then(n=>{const s=n.filter(f=>!!f);if(s.length>0)return new R(s)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async getAdapterDescriptor(r,l){const c=l.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new y.DebugAdapterServer(c));if(r){const n=await this._extensionService.getExtensionRegistry();return(0,i.asPromise)(()=>r.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,n))).then(s=>{if(s)return s})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,S))}daExecutableFromPackage(r,l){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,l,c){(r.length>0||l.length>0||c.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:l,changed:c}))}async getSession(r){if(r)if(typeof r=="string"){const l=this._debugSessions.get(r);if(l)return l}else{let l=this._debugSessions.get(r.id);if(!l){const c=await this.getFolder(r.folderUri),S=r.parent?this._debugSessions.get(r.parent):void 0;l=new p(this._debugServiceProxy,r.id,r.type,r.name,c,r.configuration,S),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(r){if(r){const l=F.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};u=Ve([We(0,N.IExtHostRpcService),We(1,h.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,a.IExtHostConfiguration),We(4,_.IExtHostEditorTabs),We(5,o.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class p{constructor(r,l,c,S,n,s,f){this._debugServiceProxy=r,this._id=l,this._type=c,this._name=S,this._workspaceFolder=n,this._configuration=s,this._parentSession=f}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,l)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=p;class w{constructor(r){this.value=Object.freeze({append(l){r.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=w;class R{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(l=>l.onError?l.onError(r):void 0)}onExit(r,l){this.trackers.forEach(c=>c.onExit?c.onExit(r,l):void 0)}}class v extends E.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends u{constructor(r,l,c,S,n,s){super(r,l,c,S,n,s)}};t=Ve([We(0,N.IExtHostRpcService),We(1,h.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,a.IExtHostConfiguration),We(4,_.IExtHostEditorTabs),We(5,o.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ie[250],ke([1,0,11,82,2,5,241,12,67,68,27,161,18,55,33,57]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(w){const R=w.get(A.ILogService),t=w.get(h.IExtHostRpcService).getProxy(F.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(d=>{R.error(d);const r=i.transformErrorForSerialization(d);t.$onUnexpectedError(r)})}static async installFullHandler(w){const R=w.get(A.ILogService),v=w.get(h.IExtHostRpcService),t=w.get(g.IExtHostExtensionService),d=w.get(a.IExtHostTelemetry),r=v.getProxy(F.MainContext.MainThreadExtensionService),l=v.getProxy(F.MainContext.MainThreadErrors),c=await t.getExtensionPathIndex(),S=new WeakMap;Error.prepareStackTrace=(n,s)=>{let f="",P,T;for(const z of s)f+=`
	at ${z.toString()}`,T=z.getFileName(),!P&&T&&(P=c.findSubstr(D.URI.file(T)));return S.set(n,P?.identifier),`${n.name||"Error"}: ${n.message||""}${f}`},i.setUnexpectedErrorHandler(n=>{R.error(n);const s=i.transformErrorForSerialization(n),f=S.get(n);if(!f){l.$onUnexpectedError(s);return}r.$onExtensionRuntimeError(f,s);const P=d.onExtensionError(f,n);R.trace("forwarded error to extension?",P,f)})}}Error.stackTraceLimit=100;class u{constructor(w,R,v,t,d){this._hostUtils=v,this._rpcProtocol=new b.RPCProtocol(w,null,t),R=u._transform(R,this._rpcProtocol);const r=new I.ServiceCollection(...(0,_.getSingletonServiceDescriptors)());r.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...R,messagePorts:d}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),r.set(E.IURITransformerService,new E.URITransformerService(t)),r.set(g.IHostUtils,v);const l=new y.InstantiationService(r,!0);l.invokeFunction(o.installEarlyHandler),this._logService=l.invokeFunction(c=>c.get(A.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",R),this._extensionService=l.invokeFunction(c=>c.get(g.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(w){const R=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService);return D.URI.revive(await R.$asBrowserUri(w))}terminate(w){this._extensionService.terminate(w)}static _transform(w,R){w.allExtensions.forEach(t=>{t.extensionLocation=D.URI.revive(R.transformIncomingURIs(t.extensionLocation));const d={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>d[r]=D.URI.revive(R.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=d)}),w.environment.appRoot=D.URI.revive(R.transformIncomingURIs(w.environment.appRoot));const v=w.environment.extensionDevelopmentLocationURI;return v&&(w.environment.extensionDevelopmentLocationURI=v.map(t=>D.URI.revive(R.transformIncomingURIs(t)))),w.environment.extensionTestsLocationURI=D.URI.revive(R.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=D.URI.revive(R.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=D.URI.revive(R.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=D.URI.revive(R.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=D.URI.revive(R.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=D.URI.revive(R.transformIncomingURIs(w.logsLocation)),w.logFile=D.URI.revive(R.transformIncomingURIs(w.logFile)),w.workspace=R.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=u}),define(Ie[251],ke([1,0,16,17,21,39,15,19,24,2,47]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(p,w,R,v){this.query=p,this.provider=w,this.fileUtils=R,this.processType=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(p,w){const R=this.query.folderQueries||[],v=new D.CancellationTokenSource;return w.onCancellationRequested(()=>v.cancel()),new Promise((t,d)=>{this.collector=new E(p);let r=!1;const l=(c,S)=>{if(!r&&!this.isLimitHit){const n=this.resultSize(c);a(c)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,r=!0,v.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const s=this.resultSize(c);this.resultCount+=s,(s>0||!a(c))&&this.collector.add(c,S)}};Promise.all(R.map((c,S)=>this.searchInFolder(c,n=>l(n,S),v.token))).then(c=>{v.dispose(),this.collector.flush();const S=c.some(n=>!!n&&!!n.limitHit);t({limitHit:this.isLimitHit||S,messages:(0,i.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},c=>{v.dispose();const S=(0,F.toErrorMessage)(c);d(new Error(S))})})}resultSize(p){return a(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}trimResultToSize(p,w){const R=Array.isArray(p.ranges)?p.ranges:[p.ranges],v=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:R.slice(0,w),preview:{matches:v.slice(0,w),text:p.preview.text},uri:p.uri}}async searchInFolder(p,w,R){const v=new N.QueryGlobTester(this.query,p),t=[],d={report:c=>{if(!this.validateProviderResult(c))return;const S=p.folder.scheme===b.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(_.dirname(c.uri))):void 0,n=_.relativePath(p.folder,c.uri);if(n){const s=v.includedInQuery(n,A.basename(n),S);(0,k.isThenable)(s)?t.push(s.then(f=>{f&&w(c)})):s&&w(c)}}},r=this.getSearchOptionsForFolder(p),l=await this.provider.provideTextSearchResults(h(this.query.contentPattern),r,d,R);return t.length&&await Promise.all(t),l}validateProviderResult(p){if(a(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(p){const w=(0,N.resolvePatternsForProvider)(this.query.includePattern,p.includePattern),R=(0,N.resolvePatternsForProvider)(this.query.excludePattern,p.excludePattern),v={folder:I.URI.from(p.folder),excludes:R,includes:w,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.fileUtils.toCanonicalName(p.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return v.usePCRE2=this.query.usePCRE2,v}}e.TextSearchManager=y;function h(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class E{constructor(p){this._onResult=p,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,w=>this.sendItems(w))}add(p,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!_.isEqual(this._currentUri,p.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:p.uri,results:[]}),this._currentFileMatch.results.push(g(p))}pushToCollector(){const p=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,p)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(p){this._onResult(p)}}e.TextSearchResultsCollector=E;function g(u){return a(u)?{preview:{matches:(0,i.mapArrayOrNot)(u.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:u.preview.text},ranges:(0,i.mapArrayOrNot)(u.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function a(u){return!!u.preview}e.extensionResultIsMatch=a;class o{constructor(p,w){this.maxBatchSize=p,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(p,w){!p||this.addItemToBatch(p,w)}addItems(p,w){!p||this.addItemsToBatch(p,w)}addItemToBatch(p,w){this.batch.push(p),this.batchSize+=w,this.onUpdate()}addItemsToBatch(p,w){this.batch=this.batch.concat(p),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}o.TIMEOUT=4e3,o.START_BATCH_AFTER_COUNT=50,e.BatchedCollector=o}),define(Ie[110],ke([1,0,6,5,3,246,18,55,12,2,251]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let y=class{constructor(a,o,u){this.extHostRpc=a,this._uriTransformer=o,this._logService=u,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new F.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,o){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const u=this._handlePool++;return this._textSearchProvider.set(u,o),this._proxy.$registerTextSearchProvider(u,this._transformScheme(a)),(0,i.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}registerFileSearchProvider(a,o){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const u=this._handlePool++;return this._fileSearchProvider.set(u,o),this._proxy.$registerFileSearchProvider(u,this._transformScheme(a)),(0,i.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(a,o,u,p){const w=h(u),R=this._fileSearchProvider.get(a);if(R)return this._fileSearchManager.fileSearch(w,R,v=>{this._proxy.$handleFileMatch(a,o,v.map(t=>t.resource))},p);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,o,u,p){const w=this._textSearchProvider.get(a);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const R=h(u);return this.createTextSearchManager(R,w).search(t=>this._proxy.$handleTextMatch(a,o,t),p)}$enableExtensionHostSearch(){}createTextSearchManager(a,o){return new N.TextSearchManager(a,o,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};y=Ve([We(0,b.IExtHostRpcService),We(1,A.IURITransformerService),We(2,_.ILogService)],y),e.ExtHostSearch=y;function h(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(E),extraFileResources:g.extraFileResources&&g.extraFileResources.map(a=>I.URI.revive(a))}}e.reviveQuery=h;function E(g){return{...g,folder:I.URI.revive(g.folder)}}}),define(Ie[252],ke([1,0,67,105,31,103,32,37,58,61,107,109,110,80,70,76,104,60,36,79,57,59,221,12,177,108,78]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v,t,d,r,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,i.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,1),(0,i.registerSingleton)(d.ILogService,r.ExtHostLogService,1),(0,i.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,i.registerSingleton)(b.IExtHostConfiguration,b.ExtHostConfiguration,0),(0,i.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService,0),(0,i.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,0),(0,i.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,i.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,i.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,i.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,i.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,i.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,i.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,i.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,i.registerSingleton)(R.IExtHostTelemetry,R.ExtHostTelemetry,0),(0,i.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,i.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(Ie[253],ke([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const F=this._dragOperations.get(D);return this._dragOperations.delete(D),F}}addDragOperationTransfer(D,F){this._dragOperations.set(D,F)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,F){this._renderedElements.set(D,F)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=i}),define(Ie[254],ke([1,0,145,7,24,2,4,6,182,17,7,9,16,8,21,253,25]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(R,v){if((0,y.isString)(R))return{label:R};if(R&&typeof R=="object"&&typeof R.label=="string"){let t;return Array.isArray(R.highlights)&&(t=R.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:R.label,highlights:t}}}class p{constructor(v,t,d){this._proxy=v,this.commands=t,this.logService=d,this.treeViews=new Map,this.treeDragAndDropService=new a.TreeviewsService;function r(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>r(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(c=>r(c)?this.convertArgument(c):c):l})}registerTreeDataProvider(v,t,d){const r=this.createTreeView(v,{treeDataProvider:t},d);return{dispose:()=>r.dispose()}}createTreeView(v,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,S=!!t.dragAndDropController?.handleDrop,n=this.createExtHostTreeView(v,t,d),s=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:S});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(d,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(f){n.message=f},get title(){return n.title},set title(f){n.title=f},get description(){return n.description},set description(f){n.description=f},get badge(){return n.badge},set badge(f){f!==void 0&&N.ViewBadge.isViewBadge(f)?n.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(n.badge=void 0)},reveal:(f,P)=>n.reveal(f,P),dispose:async()=>{await s,this.treeViews.delete(v),n.dispose()}}}$getChildren(v,t){const d=this.treeViews.get(v);return d?d.getChildren(t):Promise.reject(new _.NoTreeViewError(v))}async $handleDrop(v,t,d,r,l,c,S,n){const s=this.treeViews.get(v);if(!s)return Promise.reject(new _.NoTreeViewError(v));const f=E.DataTransfer.toDataTransfer(d,async P=>(await this._proxy.$resolveDropFileData(v,t,P)).buffer);return S===v&&n&&await this.addAdditionalTransferItems(f,s,n,l,c),s.onDrop(f,r,l)}async addAdditionalTransferItems(v,t,d,r,l){const c=this.treeDragAndDropService.removeDragOperationTransfer(l);if(c)(await c)?.forEach((S,n)=>{S&&v.set(n,S)});else if(l&&t.handleDrag){const S=t.handleDrag(d,v,r);this.treeDragAndDropService.addDragOperationTransfer(l,S),await S}return v}async $handleDrag(v,t,d,r){const l=this.treeViews.get(v);if(!l)return Promise.reject(new _.NoTreeViewError(v));const c=await this.addAdditionalTransferItems(new k.DataTransfer,l,t,r,d);if(!!c)return E.DataTransfer.toDataTransferDTO(c)}async $hasResolve(v){const t=this.treeViews.get(v);if(!t)throw new _.NoTreeViewError(v);return t.hasResolve}$resolve(v,t,d){const r=this.treeViews.get(v);if(!r)throw new _.NoTreeViewError(v);return r.resolveTreeItem(t,d)}$setExpanded(v,t,d){const r=this.treeViews.get(v);if(!r)throw new _.NoTreeViewError(v);r.setExpanded(t,d)}$setSelection(v,t){const d=this.treeViews.get(v);if(!d)throw new _.NoTreeViewError(v);d.setSelection(t)}$setFocus(v,t){const d=this.treeViews.get(v);if(!d)throw new _.NoTreeViewError(v);d.setFocus(t)}$setVisible(v,t){const d=this.treeViews.get(v);if(!d)throw new _.NoTreeViewError(v);d.setVisible(t)}$changeCheckboxState(v,t){const d=this.treeViews.get(v);if(!d)throw new _.NoTreeViewError(v);d.setCheckboxState(t)}createExtHostTreeView(v,t,d){const r=new w(v,t,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(v,r),r}convertArgument(v){const t=this.treeViews.get(v.$treeViewId);return t&&"$treeItemHandle"in v?t.getExtensionElement(v.$treeItemHandle):t&&"$focusedTreeItem"in v&&v.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=p;class w extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,y.isUndefinedOrNull)(v))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(v,t,d,r,l,c){if(super(),this.viewId=v,this.proxy=d,this.commands=r,this.logService=l,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new b.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new b.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new b.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new b.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new b.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new b.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,c.contributes&&c.contributes.views)for(const s in c.contributes.views)for(const f of c.contributes.views[s])f.id===v&&(this._title=f.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let S,n;this._register(b.Event.debounce(this._onDidChangeData.event,(s,f)=>(s||(s={message:!1,elements:[]}),f.element!==!1&&(S||(S=new Promise(P=>n=P),this.refreshPromise=this.refreshPromise.then(()=>S)),Array.isArray(f.element)?s.elements.push(...f.element):s.elements.push(f.element)),f.message&&(s.message=!0),s),200,!0)(({message:s,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const P=n;return S=null,this.refresh(f).then(()=>P())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(v){const t=v?this.getExtensionElement(v):void 0;if(v&&!t)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let d=this.getChildrenNodes(v);return d||(d=await this.fetchChildrenNodes(t)),d?d.map(r=>r.item):void 0}getExtensionElement(v){return this.elements.get(v)}reveal(v,t){t=t||{select:!0,focus:!1};const d=(0,y.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,y.isUndefinedOrNull)(t.focus)?!1:t.focus,l=(0,y.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(c=>this.resolveTreeNode(v,c[c.length-1]).then(S=>this.proxy.$reveal(this.viewId,{item:S.item,parentChain:c.map(n=>n.item)},{select:d,focus:r,expand:l})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:r,expand:l})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}get badge(){return this._badge}set badge(v){this._badge?.value===v?.value&&this._badge?.tooltip===v?.tooltip||(this._badge=E.ViewBadge.from(v),this.proxy.$setBadge(this.viewId,v))}setExpanded(v,t){const d=this.getExtensionElement(v);d&&(t?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(v){(0,h.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this._focusedHandle=v}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(v){const t=(await Promise.all(v.map(async d=>{const r=this.getExtensionElement(d.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(v,t,d){const r=[];for(const l of v){const c=this.getExtensionElement(l);c&&r.push(c)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,t,d),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(v,t,d){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.dndController?.handleDrop))return(0,I.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,v,d):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,t){if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(v);if(d){const r=this.nodes.get(d);if(r){const l=await this.dataProvider.resolveTreeItem(r.extensionItem,d,t)??r.extensionItem;return this.validateTreeItem(l),r.item.tooltip=this.getTooltip(l.tooltip),r.item.command=this.getCommand(r.disposableStore,l.command),r.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(t=>t?this.resolveUnknownParentChain(t).then(d=>this.resolveTreeNode(t,d[d.length-1]).then(r=>(d.push(r),d))):Promise.resolve([]))}resolveParent(v){const t=this.nodes.get(v);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,t){const d=this.nodes.get(v);return d?Promise.resolve(d):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(r=>this.createHandle(v,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(r);if(l){const c=this.nodes.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(v){if(v){let t;if(typeof v=="string"){const d=this.getExtensionElement(v);t=d?this.nodes.get(d):void 0}else t=v;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const t=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=v?this.nodes.get(v):void 0,r=await this.dataProvider.getChildren(v);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,h.coalesce)(r||[]).map(async c=>{const S=await this.dataProvider.getTreeItem(c);return S&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(c,S,d):null}));return t.token.isCancellationRequested?void 0:(0,h.coalesce)(l)}finally{t.dispose()}}refresh(v){if(v.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(v);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const t=new Set,d=v.map(l=>this.nodes.get(l));for(const l of d)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&d.findIndex(S=>c&&c.parent&&S&&S.item.handle===c.parent.item.handle)===-1;){const S=this.elements.get(c.parent.item.handle);c=S?this.nodes.get(S):void 0}c&&!c.parent&&t.add(l.item.handle)}const r=[];return t.forEach(l=>{const c=this.elements.get(l);if(c){const S=this.nodes.get(c);S&&(!S.parent||!t.has(S.parent.item.handle))&&r.push(l)}}),r}refreshHandles(v){const t={};return Promise.all(v.map(d=>this.refreshNode(d).then(r=>{r&&(t[d]=r.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(v){const t=this.getExtensionElement(v);if(t){const d=this.nodes.get(t);if(d)return this.clearChildren(t),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(r=>{if(r){const l=this.createTreeNode(t,r,d.parent);return this.updateNodeCache(t,l,d,d.parent),d.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,t,d){const r=this.createTreeNode(v,t,d);if(t.id&&this.elements.has(r.item.handle))throw new Error((0,i.localize)(0,null,t.id));return this.addNodeToCache(v,r),this.addNodeToParentCache(r,d),r}getTooltip(v){return N.MarkdownString.isMarkdownString(v)?E.MarkdownString.from(v):v}getCommand(v,t){return t?{...this.commands.toInternal(t,v),originalId:t.command}:void 0}getCheckbox(v){if(!v.checkboxState)return;let t,d;return typeof v.checkboxState=="number"?t=v.checkboxState:(t=v.checkboxState.state,d=v.checkboxState.tooltip),{isChecked:t===N.TreeItemCheckboxState.Checked,tooltip:d}}validateTreeItem(v){if(!N.TreeItem.isTreeItem(v,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(v,t,d){this.validateTreeItem(t);const r=new A.DisposableStore,l=this.createHandle(v,t,d),c=this.getLightIconPath(t);return{item:{handle:l,parentHandle:d?d.item.handle:void 0,label:u(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(r,t.command),contextValue:t.contextValue,icon:c,iconDark:this.getDarkIconPath(t)||c,themeIcon:this.getThemeIcon(t),collapsibleState:(0,y.isUndefinedOrNull)(t.collapsibleState)?N.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:d,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(v){return v.iconPath instanceof N.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:t,label:d,resourceUri:r},l,c){if(t)return`${w.ID_HANDLE_PREFIX}/${t}`;const S=u(d,this.extension),n=l?l.item.handle:w.LABEL_HANDLE_PREFIX;let s=S?S.label:r?(0,D.basename)(r):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const f=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,P=this.getChildrenNodes(l)||[];let T,z=0;do{if(T=`${n}/${z}:${s}`,c||!this.elements.has(T)||f===T)break;z++}while(z<=P.length);return T}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon))return typeof v.iconPath=="string"||F.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return F.URI.isUri(v)?v:F.URI.file(v)}addNodeToCache(v,t){this.elements.set(t.item.handle,v),this.nodes.set(v,t)}updateNodeCache(v,t,d,r){this.elements.delete(t.item.handle),this.nodes.delete(v),t.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(v,t);const l=this.getChildrenNodes(r)||[],c=l.filter(S=>S.item.handle===d.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}addNodeToParentCache(v,t){t?(t.children||(t.children=[]),t.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const t=this.nodes.get(v);if(t){if(t.children)for(const d of t.children){const r=this.elements.get(d.item.handle);r&&this.clear(r)}t.children=void 0}}else this.clearAll()}clear(v){const t=this.nodes.get(v);if(t){if(t.children)for(const d of t.children){const r=this.elements.get(d.item.handle);r&&this.clear(r)}this.nodes.delete(v),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(Ie[255],ke([1,0,21,11,4,29,2,130,264,118,128,43,5,74,208,207,37,209,32,211,212,213,196,214,58,33,215,216,219,220,222,105,199,228,229,230,80,61,233,254,8,7,52,236,62,104,31,188,218,50,103,107,109,110,12,55,18,27,223,194,70,76,205,234,81,60,239,237,238,206,36,231,235,79,59,57,224,106,225,15,92,198,179,217,6,25,184,78,175,226,227]),function(ne,e,i,k,D,F,b,A,_,I,N,y,h,E,g,a,o,u,p,w,R,v,t,d,r,l,c,S,n,s,f,P,T,z,Q,Z,Y,H,O,m,L,B,J,me,te,oe,ce,we,V,q,G,de,Se,Le,xe,Te,De,_e,ae,ue,ee,C,U,$,W,ie,fe,ye,le,ve,Ee,ze,He,it,Ge,et,nt,Fe,rt,K,X,pe,$e,Ue,Xe,je,tt,at,bt,Ct,Dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function yt(lt){const ft=lt.get(_e.IExtHostInitDataService),jt=lt.get(Ee.IExtHostFileSystemInfo),Wt=lt.get(ie.IExtHostConsumerFileSystem),It=lt.get(l.IExtHostExtensionService),ht=lt.get(ce.IExtHostWorkspace),kt=lt.get(et.IExtHostTelemetry),Ut=lt.get(p.IExtHostConfiguration),Pt=lt.get(Te.IURITransformerService),Ke=lt.get(De.IExtHostRpcService),Lt=lt.get(Y.IExtHostStorage),qt=lt.get(W.IExtensionStoragePaths),Ft=lt.get(xe.ILoggerService),mt=lt.get(xe.ILogService),Ce=lt.get(ee.IExtHostTunnelService),Pe=lt.get(C.IExtHostApiDeprecationService),ge=lt.get(oe.IExtHostWindow),j=lt.get(it.IExtHostSecretState),Ae=lt.get(Ge.IExtHostEditorTabs);Ke.set(h.ExtHostContext.ExtHostFileSystemInfo,jt),Ke.set(h.ExtHostContext.ExtHostLogLevelServiceShape,Ft),Ke.set(h.ExtHostContext.ExtHostWorkspace,ht),Ke.set(h.ExtHostContext.ExtHostConfiguration,Ut),Ke.set(h.ExtHostContext.ExtHostExtensionService,It),Ke.set(h.ExtHostContext.ExtHostStorage,Lt),Ke.set(h.ExtHostContext.ExtHostTunnelService,Ce),Ke.set(h.ExtHostContext.ExtHostWindow,ge),Ke.set(h.ExtHostContext.ExtHostSecretState,j),Ke.set(h.ExtHostContext.ExtHostTelemetry,kt),Ke.set(h.ExtHostContext.ExtHostEditorTabs,Ae);const Me=Ke.set(h.ExtHostContext.ExtHostDecorations,lt.get(G.IExtHostDecorations)),Qe=Ke.set(h.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),Be=Ke.set(h.ExtHostContext.ExtHostCommands,lt.get(o.IExtHostCommands)),Ze=Ke.set(h.ExtHostContext.ExtHostTerminalService,lt.get(H.IExtHostTerminalService)),ct=Ke.set(h.ExtHostContext.ExtHostDebugService,lt.get(Se.IExtHostDebugService)),Tt=Ke.set(h.ExtHostContext.ExtHostSearch,lt.get(Le.IExtHostSearch)),vt=Ke.set(h.ExtHostContext.ExtHostTask,lt.get(de.IExtHostTask)),wt=Ke.set(h.ExtHostContext.ExtHostOutputService,lt.get(P.IExtHostOutputService)),pt=Ke.set(h.ExtHostContext.ExtHostLocalization,lt.get(at.IExtHostLocalizationService)),At=Ke.set(h.ExtHostContext.ExtHostUrls,new me.ExtHostUrls(Ke)),Et=Ke.set(h.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ke,Qe)),ri=Ke.set(h.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ke,Qe,mt)),ei=Ke.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(mt,Et,Ke.getProxy(h.MainContext.MainThreadBulkEdits))),_t=Ke.set(h.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ke,Be,Qe,Et)),si=Ke.set(h.ExtHostContext.ExtHostNotebookDocuments,new $e.ExtHostNotebookDocuments(_t)),oi=Ke.set(h.ExtHostContext.ExtHostNotebookEditors,new pe.ExtHostNotebookEditors(mt,_t)),Yt=Ke.set(h.ExtHostContext.ExtHostNotebookKernels,new nt.ExtHostNotebookKernels(Ke,ft,_t,Be,mt)),vi=Ke.set(h.ExtHostContext.ExtHostNotebookRenderers,new rt.ExtHostNotebookRenderers(Ke,_t)),Rt=Ke.set(h.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Ke,Qe)),xt=Ke.set(h.ExtHostContext.ExtHostTreeViews,new m.ExtHostTreeViews(Ke.getProxy(h.MainContext.MainThreadTreeViews),Be,mt)),Ei=Ke.set(h.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(Ke.getProxy(h.MainContext.MainThreadEditorInsets),Rt,ft.remote)),ai=Ke.set(h.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ke,mt,jt,Qe)),Jt=Ke.set(h.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ke,Et,Be.converter,Pt)),ut=Ke.set(h.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ke,Pt,Et,Be,ai,mt,Pe,kt)),Ui=Ke.set(h.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ke,ut)),Mt=Ke.set(h.ExtHostContext.ExtHostFileSystemEventService,new S.ExtHostFileSystemEventService(Ke,mt,Qe)),Gt=Ke.set(h.ExtHostContext.ExtHostQuickOpen,(0,z.createExtHostQuickOpen)(Ke,ht,Be)),ci=Ke.set(h.ExtHostContext.ExtHostSCM,new Q.ExtHostSCM(Ke,Be,mt)),bi=Ke.set(h.ExtHostContext.ExtHostQuickDiff,new Dt.ExtHostQuickDiff(Ke,Pt)),wi=Ke.set(h.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ke,Be,Et)),li=Ke.set(h.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(Ke.getProxy(h.MainContext.MainThreadProgress))),_i=Ke.set(h.ExtHostContext.ExtHosLabelService,new V.ExtHostLabelService(Ke)),ui=Ke.set(h.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(Ke)),Zt=Ke.set(h.ExtHostContext.ExtHostAuthentication,new U.ExtHostAuthentication(Ke)),Bi=Ke.set(h.ExtHostContext.ExtHostTimeline,new $.ExtHostTimeline(Ke,Be)),ti=Ke.set(h.ExtHostContext.ExtHostWebviews,new te.ExtHostWebviews(Ke,ft.remote,ht,mt,Pe)),ii=Ke.set(h.ExtHostContext.ExtHostWebviewPanels,new le.ExtHostWebviewPanels(Ke,ti,ht)),Si=Ke.set(h.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ke,Et,qt,ti,ii)),yi=Ke.set(h.ExtHostContext.ExtHostWebviewViews,new fe.ExtHostWebviewViews(Ke,ti)),ni=Ke.set(h.ExtHostContext.ExtHostTesting,new ze.ExtHostTesting(Ke,Be,Qe)),Di=Ke.set(h.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ke)),Ci=Ke.set(h.ExtHostContext.ExtHostProfileContentHandlers,new Ct.ExtHostProfileContentHandlers(Ke));Ke.set(h.ExtHostContext.ExtHostInteractive,new Ue.ExtHostInteractive(Ke,_t,Qe,Be,mt));const xi=Object.values(h.ExtHostContext);Ke.assertRegistered(xi);const $i=new ve.ExtHostBulkEdits(Ke,Qe),zi=new a.ExtHostClipboard(Ke),Ii=new f.ExtHostMessageService(Ke,mt),Ai=new R.ExtHostDialogs(Ke),Ri=new Z.ExtHostStatusBar(Ke,Be.converter);return g.ExtHostApiCommands.register(Be),function(Ne,$t,Oi){const gt=function(){let se=!Ne.isUnderDevelopment;function he(){se||(mt.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he();else{const St=st;typeof St.scheme>"u"&&he(),typeof St.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return st}}(),Wi={getSession(se,he,Re){return Zt.getSession(Ne,se,he,Re)},async hasSession(se,he){return(0,je.checkProposedApiEnabled)(Ne,"authSession"),!!await Zt.getSession(Ne,se,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,he,Re,st){return Zt.registerAuthenticationProvider(se,he,Re,st)}},di={registerCommand(se,he,Re){return Be.registerCommand(!0,se,he,Re,void 0,Ne)},registerTextEditorCommand(se,he,Re){return Be.registerCommand(!0,se,(...st)=>{const St=Rt.getActiveTextEditor();if(!St){mt.warn("Cannot execute "+se+" because there is no active text editor.");return}return St.edit(Ot=>{he.apply(Re,[St,Ot,...st])}).then(Ot=>{Ot||mt.warn("Edits from command "+se+" were not applied.")},Ot=>{mt.warn("An error occurred while running command "+se,Ot)})},void 0,void 0,Ne)},registerDiffInformationCommand:(se,he,Re)=>((0,je.checkProposedApiEnabled)(Ne,"diffCommand"),Be.registerCommand(!0,se,async(...st)=>{const St=Qe.activeEditor(!0);if(!St){mt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Ot=await Rt.getDiffInformation(St.id);he.apply(Re,[Ot,...st])},void 0,void 0,Ne)),executeCommand(se,...he){return Be.executeCommand(se,...he)},getCommands(se=!1){return Be.getCommands(se)}},Li={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ne,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ne,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ne,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(se){return et.ExtHostTelemetryLogger.validateSender(se),kt.instantiateLogger(Ne,se)},openExternal(se,he){return ge.openUri(se,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===ft.environment.appUriScheme)return At.createAppUri(se);try{return await ge.asExternalUri(se,{allowTunneling:!!ft.remote.authority})}catch(he){if((0,X.matchesScheme)(se,K.Schemas.http)||(0,X.matchesScheme)(se,K.Schemas.https))return se;throw he}},get remoteName(){return(0,q.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ne,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Li);const Hi={createTestController(se,he,Re){return ni.createTestController(Ne,se,he,Re)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ne,"testObserver"),ni.createTestObserver()},runTests(se){return(0,je.checkProposedApiEnabled)(Ne,"testObserver"),ni.runTests(se)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ne,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ne,"testObserver"),ni.results}},hi=ft.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Vi={getExtension(se,he){(0,je.isProposedApiEnabled)(Ne,"extensionsAny")||(he=!1);const Re=$t.mine.getExtensionDescription(se);if(Re)return new l.Extension(It,Ne.identifier,Re,hi,!1);if(he){const st=$t.all.getExtensionDescription(se);if(st)return new l.Extension(It,Ne.identifier,st,hi,!0)}},get all(){const se=[];for(const he of $t.mine.getAllExtensionDescriptions())se.push(new l.Extension(It,Ne.identifier,he,hi,!1));return se},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ne,"extensionsAny");const se=new je.ExtensionIdentifierSet($t.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of $t.all.getAllExtensionDescriptions()){const st=!se.has(Re.identifier);he.push(new l.Extension(It,Ne.identifier,Re,hi,st))}return he},get onDidChange(){return(0,je.isProposedApiEnabled)(Ne,"extensionsAny")?D.Event.any($t.mine.onDidChange,$t.all.onDidChange):$t.mine.onDidChange}},ki={createDiagnosticCollection(se){return ai.createDiagnosticCollection(Ne.identifier,se)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:se=>ai.getDiagnostics(se),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(se,he){return Jt.changeLanguage(se.uri,he)},match(se,he){const Re=Et.getDocumentData(he.uri)?.notebook;return(0,N.score)(L.LanguageSelector.from(se),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,he,Re){return ut.registerCodeActionProvider(Ne,gt(se),he,Re)},registerDocumentPasteEditProvider(se,he,Re){return(0,je.checkProposedApiEnabled)(Ne,"documentPaste"),ut.registerDocumentPasteEditProvider(Ne,gt(se),he,Re)},registerCodeLensProvider(se,he){return ut.registerCodeLensProvider(Ne,gt(se),he)},registerDefinitionProvider(se,he){return ut.registerDefinitionProvider(Ne,gt(se),he)},registerDeclarationProvider(se,he){return ut.registerDeclarationProvider(Ne,gt(se),he)},registerImplementationProvider(se,he){return ut.registerImplementationProvider(Ne,gt(se),he)},registerTypeDefinitionProvider(se,he){return ut.registerTypeDefinitionProvider(Ne,gt(se),he)},registerHoverProvider(se,he){return ut.registerHoverProvider(Ne,gt(se),he,Ne.identifier)},registerEvaluatableExpressionProvider(se,he){return ut.registerEvaluatableExpressionProvider(Ne,gt(se),he,Ne.identifier)},registerInlineValuesProvider(se,he){return ut.registerInlineValuesProvider(Ne,gt(se),he,Ne.identifier)},registerDocumentHighlightProvider(se,he){return ut.registerDocumentHighlightProvider(Ne,gt(se),he)},registerLinkedEditingRangeProvider(se,he){return ut.registerLinkedEditingRangeProvider(Ne,gt(se),he)},registerReferenceProvider(se,he){return ut.registerReferenceProvider(Ne,gt(se),he)},registerRenameProvider(se,he){return ut.registerRenameProvider(Ne,gt(se),he)},registerDocumentSymbolProvider(se,he,Re){return ut.registerDocumentSymbolProvider(Ne,gt(se),he,Re)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Ne,se)},registerDocumentFormattingEditProvider(se,he){return ut.registerDocumentFormattingEditProvider(Ne,gt(se),he)},registerDocumentRangeFormattingEditProvider(se,he){return ut.registerDocumentRangeFormattingEditProvider(Ne,gt(se),he)},registerOnTypeFormattingEditProvider(se,he,Re,...st){return ut.registerOnTypeFormattingEditProvider(Ne,gt(se),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(se,he,Re){return ut.registerDocumentSemanticTokensProvider(Ne,gt(se),he,Re)},registerDocumentRangeSemanticTokensProvider(se,he,Re){return ut.registerDocumentRangeSemanticTokensProvider(Ne,gt(se),he,Re)},registerSignatureHelpProvider(se,he,Re,...st){return typeof Re=="object"?ut.registerSignatureHelpProvider(Ne,gt(se),he,Re):ut.registerSignatureHelpProvider(Ne,gt(se),he,typeof Re>"u"?[]:[Re,...st])},registerCompletionItemProvider(se,he,...Re){return ut.registerCompletionItemProvider(Ne,gt(se),he,Re)},registerInlineCompletionItemProvider(se,he){return he.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,je.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ne,gt(se),he)},registerDocumentLinkProvider(se,he){return ut.registerDocumentLinkProvider(Ne,gt(se),he)},registerColorProvider(se,he){return ut.registerColorProvider(Ne,gt(se),he)},registerFoldingRangeProvider(se,he){return ut.registerFoldingRangeProvider(Ne,gt(se),he)},registerSelectionRangeProvider(se,he){return ut.registerSelectionRangeProvider(Ne,se,he)},registerCallHierarchyProvider(se,he){return ut.registerCallHierarchyProvider(Ne,se,he)},registerTypeHierarchyProvider(se,he){return ut.registerTypeHierarchyProvider(Ne,se,he)},setLanguageConfiguration:(se,he)=>ut.setLanguageConfiguration(Ne,se,he),getTokenInformationAtPosition(se,he){return(0,je.checkProposedApiEnabled)(Ne,"tokenInformation"),Jt.tokenAtPosition(se,he)},registerInlayHintsProvider(se,he){return ut.registerInlayHintsProvider(Ne,se,he)},createLanguageStatusItem(se,he){return Jt.createLanguageStatusItem(Ne,se,he)},registerDocumentDropEditProvider(se,he){return ut.registerDocumentOnDropEditProvider(Ne,se,he)}},ji={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(se,he,Re){const st=await(b.URI.isUri(se)?Promise.resolve(Ht.openTextDocument(se)):Promise.resolve(se));return Rt.showTextDocument(st,he,Re)},createTextEditorDecorationType(se){return Rt.createTextEditorDecorationType(Ne,se)},onDidChangeActiveTextEditor(se,he,Re){return Rt.onDidChangeActiveTextEditor(se,he,Re)},onDidChangeVisibleTextEditors(se,he,Re){return Rt.onDidChangeVisibleTextEditors(se,he,Re)},onDidChangeTextEditorSelection(se,he,Re){return Rt.onDidChangeTextEditorSelection(se,he,Re)},onDidChangeTextEditorOptions(se,he,Re){return Rt.onDidChangeTextEditorOptions(se,he,Re)},onDidChangeTextEditorVisibleRanges(se,he,Re){return Rt.onDidChangeTextEditorVisibleRanges(se,he,Re)},onDidChangeTextEditorViewColumn(se,he,Re){return Rt.onDidChangeTextEditorViewColumn(se,he,Re)},onDidCloseTerminal(se,he,Re){return Ze.onDidCloseTerminal(se,he,Re)},onDidOpenTerminal(se,he,Re){return Ze.onDidOpenTerminal(se,he,Re)},onDidChangeActiveTerminal(se,he,Re){return Ze.onDidChangeActiveTerminal(se,he,Re)},onDidChangeTerminalDimensions(se,he,Re){return(0,je.checkProposedApiEnabled)(Ne,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(se,he,Re)},onDidChangeTerminalState(se,he,Re){return Ze.onDidChangeTerminalState(se,he,Re)},onDidWriteTerminalData(se,he,Re){return(0,je.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(se,he,Re)},get state(){return ge.state},onDidChangeWindowState(se,he,Re){return ge.onDidChangeWindowState(se,he,Re)},showInformationMessage(se,...he){return Ii.showMessage(Ne,F.default.Info,se,he[0],he.slice(1))},showWarningMessage(se,...he){return Ii.showMessage(Ne,F.default.Warning,se,he[0],he.slice(1))},showErrorMessage(se,...he){return Ii.showMessage(Ne,F.default.Error,se,he[0],he.slice(1))},showQuickPick(se,he,Re){return Gt.showQuickPick(Ne,se,he,Re)},showWorkspaceFolderPick(se){return Gt.showWorkspaceFolderPick(se)},showInputBox(se,he){return Gt.showInput(se,he)},showOpenDialog(se){return Ai.showOpenDialog(Ne,se)},showSaveDialog(se){return Ai.showSaveDialog(se)},createStatusBarItem(se,he,Re){let st,St,Ot;return typeof se=="string"?(st=se,St=he,Ot=Re):(St=se,Ot=he),Ri.createStatusBarEntry(Ne,st,St,Ot)},setStatusBarMessage(se,he){return Ri.setStatusBarMessage(se,he)},withScmProgress(se){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),li.withProgress(Ne,{location:B.ProgressLocation.SourceControl},(he,Re)=>se({report(st){}}))},withProgress(se,he){return li.withProgress(Ne,se,he)},createOutputChannel(se,he){return wt.createOutputChannel(se,he,Ne)},createWebviewPanel(se,he,Re,st){return ii.createWebviewPanel(Ne,se,he,Re,st)},createWebviewTextEditorInset(se,he,Re,st){return(0,je.checkProposedApiEnabled)(Ne,"editorInsets"),Ei.createWebviewEditorInset(se,he,Re,st,Ne)},createTerminal(se,he,Re){return typeof se=="object"?"pty"in se?Ze.createExtensionTerminal(se):Ze.createTerminalFromOptions(se):Ze.createTerminal(se,he,Re)},registerTerminalLinkProvider(se){return Ze.registerLinkProvider(se)},registerTerminalProfileProvider(se,he){return Ze.registerProfileProvider(Ne,se,he)},registerTerminalQuickFixProvider(se,he){return(0,je.checkProposedApiEnabled)(Ne,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(se,Ne.identifier.value,he)},registerTreeDataProvider(se,he){return xt.registerTreeDataProvider(se,he,Ne)},createTreeView(se,he){return xt.createTreeView(se,he,Ne)},registerWebviewPanelSerializer:(se,he)=>ii.registerWebviewPanelSerializer(Ne,se,he),registerCustomEditorProvider:(se,he,Re={})=>Si.registerCustomEditorProvider(Ne,se,he,Re),registerFileDecorationProvider(se){return Me.registerFileDecorationProvider(se,Ne)},registerUriHandler(se){return At.registerUriHandler(Ne.identifier,se)},createQuickPick(){return Gt.createQuickPick(Ne)},createInputBox(){return Gt.createInputBox(Ne)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(se,he,Re){return ui.onDidChangeActiveColorTheme(se,he,Re)},registerWebviewViewProvider(se,he,Re){return yi.registerWebviewViewProvider(Ne,se,he,Re?.webviewOptions)},get activeNotebookEditor(){return _t.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,he,Re){return _t.onDidChangeActiveNotebookEditor(se,he,Re)},get visibleNotebookEditors(){return _t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,he,Re){return oi.onDidChangeNotebookEditorSelection(se,he,Re)},onDidChangeNotebookEditorVisibleRanges(se,he,Re){return oi.onDidChangeNotebookEditorVisibleRanges(se,he,Re)},showNotebookDocument(se,he){return _t.showNotebookDocument(se,he)},registerExternalUriOpener(se,he,Re){return(0,je.checkProposedApiEnabled)(Ne,"externalUriOpener"),Di.registerExternalUriOpener(Ne.identifier,se,he,Re)},registerProfileContentHandler(se,he){return(0,je.checkProposedApiEnabled)(Ne,"profileContentHandlers"),Ci.registrProfileContentHandler(Ne,se,he)},registerQuickDiffProvider(se,he,Re,st){return(0,je.checkProposedApiEnabled)(Ne,"quickDiffProvider"),bi.registerQuickDiffProvider(gt(se),he,Re,st)},get tabGroups(){return Ae.tabGroups}},Ht={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(se){throw k.readonly()},getWorkspaceFolder(se){return ht.getWorkspaceFolder(se)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(se){throw k.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(se){throw k.readonly()},updateWorkspaceFolders:(se,he,...Re)=>ht.updateWorkspaceFolders(Ne,se,he||0,...Re),onDidChangeWorkspaceFolders:function(se,he,Re){return ht.onDidChangeWorkspace(se,he,Re)},asRelativePath:(se,he)=>ht.getRelativePath(se,he),findFiles:(se,he,Re,st)=>ht.findFiles(se,he,Re,Ne.identifier,st),findTextInFiles:(se,he,Re,st)=>{(0,je.checkProposedApiEnabled)(Ne,"findTextInFiles");let St,Ot;return typeof he=="object"?(St=he,Ot=Re):(St={},Ot=he,st=Re),ht.findTextInFiles(se,St||{},Ot,Ne.identifier,st)},saveAll:se=>ht.saveAll(se),applyEdit(se,he){return $i.applyWorkspaceEdit(se,Ne,he)},createFileSystemWatcher:(se,he,Re,st)=>Mt.createFileSystemWatcher(ht,Ne,se,he,Re,st),get textDocuments(){return Et.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw k.readonly()},openTextDocument(se){let he;const Re=se;if(typeof se=="string")he=Promise.resolve(b.URI.file(se));else if(b.URI.isUri(se))he=Promise.resolve(se);else if(!Re||typeof Re=="object")he=Et.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>Et.ensureDocumentData(st).then(St=>St.document))},onDidOpenTextDocument:(se,he,Re)=>Et.onDidAddDocument(se,he,Re),onDidCloseTextDocument:(se,he,Re)=>Et.onDidRemoveDocument(se,he,Re),onDidChangeTextDocument:(se,he,Re)=>Et.onDidChangeDocument(se,he,Re),onDidSaveTextDocument:(se,he,Re)=>Et.onDidSaveDocument(se,he,Re),onWillSaveTextDocument:(se,he,Re)=>ei.getOnWillSaveTextDocumentEvent(Ne)(se,he,Re),get notebookDocuments(){return _t.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,he){let Re;if(b.URI.isUri(se))Re=se,await _t.openNotebookDocument(se);else if(typeof se=="string")Re=b.URI.revive(await _t.createNotebookDocument({viewType:se,content:he}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,he,Re){return si.onDidSaveNotebookDocument(se,he,Re)},onDidChangeNotebookDocument(se,he,Re){return si.onDidChangeNotebookDocument(se,he,Re)},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(se,he,Re,st){return _t.registerNotebookSerializer(Ne,se,he,Re,(0,je.isProposedApiEnabled)(Ne,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(se,he,Re)=>Oi.onDidChangeConfiguration(se,he,Re),getConfiguration(se,he){return he=arguments.length===1?void 0:he,Oi.getConfiguration(se,he,Ne)},registerTextDocumentContentProvider(se,he){return ri.registerTextDocumentContentProvider(se,he)},registerTaskProvider:(se,he)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ne,se,he)),registerFileSystemProvider(se,he,Re){return(0,Xe.combinedDisposable)(Ui.registerFileSystemProvider(Ne,se,he,Re),Wt.addFileSystemProvider(se,he))},get fs(){return Wt.value},registerFileSearchProvider:(se,he)=>((0,je.checkProposedApiEnabled)(Ne,"fileSearchProvider"),Tt.registerFileSearchProvider(se,he)),registerTextSearchProvider:(se,he)=>((0,je.checkProposedApiEnabled)(Ne,"textSearchProvider"),Tt.registerTextSearchProvider(se,he)),registerRemoteAuthorityResolver:(se,he)=>((0,je.checkProposedApiEnabled)(Ne,"resolvers"),It.registerRemoteAuthorityResolver(se,he)),registerResourceLabelFormatter:se=>((0,je.checkProposedApiEnabled)(Ne,"resolvers"),_i.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,he,Re)=>Mt.onDidCreateFile(se,he,Re),onDidDeleteFiles:(se,he,Re)=>Mt.onDidDeleteFile(se,he,Re),onDidRenameFiles:(se,he,Re)=>Mt.onDidRenameFile(se,he,Re),onWillCreateFiles:(se,he,Re)=>Mt.getOnWillCreateFileEvent(Ne)(se,he,Re),onWillDeleteFiles:(se,he,Re)=>Mt.getOnWillDeleteFileEvent(Ne)(se,he,Re),onWillRenameFiles:(se,he,Re)=>Mt.getOnWillRenameFileEvent(Ne)(se,he,Re),openTunnel:se=>((0,je.checkProposedApiEnabled)(Ne,"tunnels"),Ce.openTunnel(Ne,se).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ne,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(se,he,Re)=>((0,je.checkProposedApiEnabled)(Ne,"tunnels"),Ce.onDidChangeTunnels(se,he,Re)),registerPortAttributesProvider:(se,he)=>((0,je.checkProposedApiEnabled)(Ne,"portsAttributes"),Ce.registerPortsAttributesProvider(se,he)),registerTimelineProvider:(se,he)=>((0,je.checkProposedApiEnabled)(Ne,"timeline"),Bi.registerTimelineProvider(se,he,Ne.identifier,Be.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:se=>((0,je.checkProposedApiEnabled)(Ne,"workspaceTrust"),ht.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,he,Re)=>ht.onDidGrantWorkspaceTrust(se,he,Re),registerEditSessionIdentityProvider:(se,he)=>((0,je.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(se,he)),onWillCreateEditSessionIdentity:(se,he,Re)=>((0,je.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ne)(se,he,Re))},fi={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ne)},createSourceControl(se,he,Re){return ci.createSourceControl(Ne,se,he,Re)}},qi={createCommentController(se,he){return wi.createCommentController(Ne,se,he)}},Bt={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(se,he,Re){return ct.onDidStartDebugSession(se,he,Re)},onDidTerminateDebugSession(se,he,Re){return ct.onDidTerminateDebugSession(se,he,Re)},onDidChangeActiveDebugSession(se,he,Re){return ct.onDidChangeActiveDebugSession(se,he,Re)},onDidReceiveDebugSessionCustomEvent(se,he,Re){return ct.onDidReceiveDebugSessionCustomEvent(se,he,Re)},onDidChangeBreakpoints(se,he,Re){return ct.onDidChangeBreakpoints(se,he,Re)},registerDebugConfigurationProvider(se,he,Re){return ct.registerDebugConfigurationProvider(se,he,Re||tt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,he){return ct.registerDebugAdapterDescriptorFactory(Ne,se,he)},registerDebugAdapterTrackerFactory(se,he){return ct.registerDebugAdapterTrackerFactory(se,he)},startDebugging(se,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(se,he,{parentSession:Re}):ct.startDebugging(se,he,Re||{})},stopDebugging(se){return ct.stopDebugging(se)},addBreakpoints(se){return ct.addBreakpoints(se)},removeBreakpoints(se){return ct.removeBreakpoints(se)},asDebugSourceUri(se,he){return ct.asDebugSourceUri(se,he)}},mi={registerTaskProvider:(se,he)=>vt.registerTaskProvider(Ne,se,he),fetchTasks:se=>vt.fetchTasks(se),executeTask:se=>vt.executeTask(Ne,se),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(se,he,Re)=>vt.onDidStartTask(se,he,Re),onDidEndTask:(se,he,Re)=>vt.onDidEndTask(se,he,Re),onDidStartTaskProcess:(se,he,Re)=>vt.onDidStartTaskProcess(se,he,Re),onDidEndTaskProcess:(se,he,Re)=>vt.onDidEndTaskProcess(se,he,Re)},Ki={createNotebookController(se,he,Re,st,St){return Yt.createNotebookController(Ne,se,he,Re,st,(0,je.isProposedApiEnabled)(Ne,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(se,he)=>_t.registerNotebookCellStatusBarItemProvider(Ne,se,he),createRendererMessaging(se){return vi.createRendererMessaging(Ne,se)},createNotebookControllerDetectionTask(se){return(0,je.checkProposedApiEnabled)(Ne,"notebookKernelSource"),Yt.createNotebookControllerDetectionTask(Ne,se)},registerKernelSourceActionProvider(se,he){return(0,je.checkProposedApiEnabled)(Ne,"notebookKernelSource"),Yt.registerKernelSourceActionProvider(Ne,se,he)},onDidChangeNotebookCellExecutionState(se,he,Re){return(0,je.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(se,he,Re)}},Gi={t(...se){if(typeof se[0]=="string"){const he=se.shift(),Re=!se||typeof se[0]!="object"?se:se[0];return pt.getMessage(Ne.identifier.value,{message:he,args:Re})}return pt.getMessage(Ne.identifier.value,se[0])},get bundle(){return pt.getBundle(Ne.identifier.value)},get uri(){return pt.getBundleUri(Ne.identifier.value)}};return{version:ft.version,authentication:Wi,commands:di,comments:qi,debug:Bt,env:Li,extensions:Vi,l10n:Gi,languages:ki,notebooks:Ki,scm:fi,tasks:mi,tests:Hi,window:ji,workspace:Ht,Breakpoint:B.Breakpoint,TerminalOutputAnchor:B.TerminalOutputAnchor,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:tt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileDecoration2:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:I.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalQuickFixCommand:B.TerminalQuickFixCommand,TerminalQuickFixOpener:B.TerminalQuickFixOpener,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TerminalExitReason:B.TerminalExitReason,TerminalQuickFixType:B.TerminalQuickFixType,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:E.UIKind,Uri:b.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,NotebookKernelSourceAction:B.NotebookKernelSourceAction,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestRunRequest2:B.TestRunRequest2,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TelemetryTrustedValue:J.TelemetryTrustedValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:bt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=yt}),define(Ie[256],ke([1,0,255,33,2,249,7,17,240]),function(ne,e,i,k,D,F,b,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class I extends F.RequireInterceptor{_installInterceptor(){}getModule(E,g){for(const a of this._alternatives){const o=a(E);if(o){E=o;break}}if(this._factories.has(E))return this._factories.get(E).load(E,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=b.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(_.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(I,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,g,a){g=g.with({path:y(g.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const u=D.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(g)),p=await fetch(u.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),p.status!==200)throw new Error(p.statusText);const w=await p.text(),R=`${g.toString(!0)}#vscode-extension`,v=`${w}
//# sourceURL=${R}`;let t;try{t=new Function("module","exports","require",v)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${g.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const d={},r={exports:d},l=c=>{const S=this._fakeModules.getModule(c,g);if(S===void 0)throw new Error(`Cannot load module '${c}'`);return S};try{return a.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(r,d,l),r.exports!==d?r.exports:d}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),a.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+E;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=N;function y(h,E){return h.endsWith(E)?h:h+E}}),define(Ie[257],ke([1,0,67,33,81,256]),function(ne,e,i,k,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(k.IExtHostExtensionService,F.ExtHostExtensionService,0),(0,i.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(Ie[265],ke([1,0,23,4,74,250,242,19,82,15,2,252,257]),function(ne,e,i,k,D,F,b,A,_,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function a(t){self.fetch=async function(d,r){return d instanceof Request||E(String(d))&&(d=(await t(N.URI.parse(String(d)))).toString(!0)),g(d,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,r,l,c,S){(async()=>(E(r.toString())&&(r=(await t(N.URI.parse(r.toString()))).toString(!0)),super.open(d,r,l??!0,c,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,r){if(/^file:/i.test(d.toString()))d=I.FileAccess.uriToBrowserUri(N.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(f){function P(Q){return typeof Q=="string"||Q instanceof URL?String(Q).replace(/^file:\/\//i,"vscode-file://vscode-app"):Q}const T=fetch.bind(self);self.fetch=function(Q,Z){return Q instanceof Request?T(Q,Z):T(P(Q),Z)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Q,Z,Y,H,O){return super.open(Q,P(Z),Y??!0,H,O)}};const z=importScripts.bind(self);self.importScripts=(...Q)=>{z(...Q.map(P))},z(f)}.toString()}('${d}'))`;r=r||{},r.name=r.name||A.basename(d.toString());const S=new Blob([c],{type:"application/javascript"}),n=URL.createObjectURL(S);return new t(n,r)}}else self.Worker=class extends b.NestedWorker{constructor(t,d){super(h,t,{name:A.basename(t.toString()),...d})}};const o=new class{constructor(){this.pid=void 0}exit(t){y()}async exists(t){return!0}async realpath(t){return t}};class u{constructor(){const d=new MessageChannel,r=new k.Emitter;let l=!1;h(d.port2,[d.port2]),d.port1.onmessage=c=>{const{data:S}=c;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const n=i.VSBuffer.wrap(new Uint8Array(S,0,S.byteLength));if((0,D.isMessageOfType)(n,2)){l=!0,w("received terminate message from renderer");return}r.fire(n)},this.protocol={onMessage:r.event,send:c=>{if(!l){const S=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);d.port1.postMessage(S,[S])}}}}}function p(t){return new Promise(d=>{const r=t.onMessage(l=>{r.dispose();const c=JSON.parse(l.toString());t.send((0,D.createMessageOfType)(0)),d({protocol:t,initData:c})});t.send((0,D.createMessageOfType)(1))})}let w=t=>y();function R(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){_.mark("code/extHost/willConnectToRenderer");const t=new u;return{onmessage(d){!R(d)||p(t.protocol).then(r=>{_.mark("code/extHost/didWaitForInitData");const l=new F.ExtensionHostMain(r.protocol,r.initData,o,null,d.data);a(c=>l.asBrowserUri(c)),w=c=>l.terminate(c)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/22a808587994126e19125c6a1a03c00b990223f4/core/vs/workbench/api/worker/extensionHostWorker.js.map
