/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/errors","vs/editor/common/core/eolCounter","vs/editor/common/tokens/lineTokens","vs/base/common/buffer","vs/editor/common/encodedTokenAttributes","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/arrays","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/languages/nullTokenize","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],j=function(p){for(var e=[],L=0,y=p.length;L<y;L++)e[L]=W[p[L]];return e};define(W[14],j([0,1,4,2]),function(p,e,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(z){const a=z;return a?typeof a.read=="function":!1}e.isReadable=w;function C(z){const a=z;return a?[a.on,a.pause,a.resume,a.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=C;function i(z){const a=z;return a?C(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=i;function h(z,a){return new n(z,a)}e.newWriteableStream=h;class n{constructor(a,f){this.reducer=a,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(f=>f(a))}emitError(a){this.listeners.error.length===0?(0,L.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(f=>f(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,f){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(a,f){if(this.state.destroyed)return;let _;switch(a){case"data":_=this.listeners.data;break;case"end":_=this.listeners.end;break;case"error":_=this.listeners.error;break}if(_){const E=_.indexOf(f);E>=0&&_.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(_=>_())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function t(z,a){const f=[];let _;for(;(_=z.read())!==null;)f.push(_);return a(f)}e.consumeReadable=t;function r(z,a,f){const _=[];let E;for(;(E=z.read())!==null&&_.length<f;)_.push(E);return E===null&&_.length>0?a(_):{read:()=>{if(_.length>0)return _.shift();if(typeof E<"u"){const A=E;return E=void 0,A}return z.read()}}}e.peekReadable=r;function l(z,a){return new Promise((f,_)=>{const E=[];k(z,{onData:A=>{a&&E.push(A)},onError:A=>{a?_(A):f(void 0)},onEnd:()=>{f(a?a(E):void 0)}})})}e.consumeStream=l;function k(z,a){let f=!1;return z.on("error",_=>{f||a.onError(_)}),z.on("end",()=>{f||a.onEnd()}),z.on("data",_=>{f||a.onData(_)}),(0,y.toDisposable)(()=>f=!0)}e.listenStream=k;function T(z,a){return new Promise((f,_)=>{const E=new y.DisposableStore,A=[],c=u=>{if(A.push(u),A.length>a)return E.dispose(),z.pause(),f({stream:z,buffer:A,ended:!1})},P=u=>_(u),m=()=>f({stream:z,buffer:A,ended:!0});E.add((0,y.toDisposable)(()=>z.removeListener("error",P))),z.on("error",P),E.add((0,y.toDisposable)(()=>z.removeListener("end",m))),z.on("end",m),E.add((0,y.toDisposable)(()=>z.removeListener("data",c))),z.on("data",c)})}e.peekStream=T;function o(z,a){const f=h(a);return f.end(z),f}e.toStream=o;function d(){const z=h(()=>{throw new Error("not supported")});return z.end(),z}e.emptyStream=d;function S(z){let a=!1;return{read:()=>a?null:(a=!0,z)}}e.toReadable=S;function R(z,a,f){const _=h(f);return k(z,{onData:E=>_.write(a.data(E)),onError:E=>_.error(a.error?a.error(E):E),onEnd:()=>_.end()}),_}e.transform=R;function N(z,a,f){let _=!1;return{read:()=>{const E=a.read();return _?E:(_=!0,E!==null?f([z,E]):z)}}}e.prefixedReadable=N;function q(z,a,f){let _=!1;const E=h(f);return k(a,{onData:A=>_?E.write(A):(_=!0,E.write(f([z,A]))),onError:A=>E.error(A),onEnd:()=>{_||(_=!0,E.write(z)),E.end()}}),E}e.prefixedStream=q}),define(W[7],j([0,1,14]),function(p,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const y=typeof Buffer<"u";let w,C;class i{static alloc(u){return y?new i(Buffer.allocUnsafe(u)):new i(new Uint8Array(u))}static wrap(u){return y&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new i(u)}static fromString(u,v){return!(v?.dontUseNodeBuffer||!1)&&y?new i(Buffer.from(u)):(w||(w=new TextEncoder),new i(w.encode(u)))}static fromByteArray(u){const v=i.alloc(u.length);for(let M=0,D=u.length;M<D;M++)v.buffer[M]=u[M];return v}static concat(u,v){if(typeof v>"u"){v=0;for(let K=0,$=u.length;K<$;K++)v+=u[K].byteLength}const M=i.alloc(v);let D=0;for(let K=0,$=u.length;K<$;K++){const B=u[K];M.set(B,D),D+=B.byteLength}return M}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=i.alloc(this.byteLength);return u.set(this),u}toString(){return y?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(u,v){return new i(this.buffer.subarray(u,v))}set(u,v){if(u instanceof i)this.buffer.set(u.buffer,v);else if(u instanceof Uint8Array)this.buffer.set(u,v);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),v);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return t(this.buffer,u)}writeUInt32BE(u,v){r(this.buffer,u,v)}readUInt32LE(u){return l(this.buffer,u)}writeUInt32LE(u,v){k(this.buffer,u,v)}readUInt8(u){return T(this.buffer,u)}writeUInt8(u,v){o(this.buffer,u,v)}}e.VSBuffer=i;function h(m,u){return m[u+0]<<0>>>0|m[u+1]<<8>>>0}e.readUInt16LE=h;function n(m,u,v){m[v+0]=u&255,u=u>>>8,m[v+1]=u&255}e.writeUInt16LE=n;function t(m,u){return m[u]*2**24+m[u+1]*2**16+m[u+2]*2**8+m[u+3]}e.readUInt32BE=t;function r(m,u,v){m[v+3]=u,u=u>>>8,m[v+2]=u,u=u>>>8,m[v+1]=u,u=u>>>8,m[v]=u}e.writeUInt32BE=r;function l(m,u){return m[u+0]<<0>>>0|m[u+1]<<8>>>0|m[u+2]<<16>>>0|m[u+3]<<24>>>0}e.readUInt32LE=l;function k(m,u,v){m[v+0]=u&255,u=u>>>8,m[v+1]=u&255,u=u>>>8,m[v+2]=u&255,u=u>>>8,m[v+3]=u&255}e.writeUInt32LE=k;function T(m,u){return m[u]}e.readUInt8=T;function o(m,u,v){m[v]=u}e.writeUInt8=o;function d(m){return L.consumeReadable(m,u=>i.concat(u))}e.readableToBuffer=d;function S(m){return L.toReadable(m)}e.bufferToReadable=S;function R(m){return L.consumeStream(m,u=>i.concat(u))}e.streamToBuffer=R;async function N(m){return m.ended?i.concat(m.buffer):i.concat([...m.buffer,await R(m.stream)])}e.bufferedStreamToBuffer=N;function q(m){return L.toStream(m,u=>i.concat(u))}e.bufferToStream=q;function z(m){return L.transform(m,{data:u=>typeof u=="string"?i.fromString(u):i.wrap(u)},u=>i.concat(u))}e.streamToBufferReadableStream=z;function a(m){return L.newWriteableStream(u=>i.concat(u),m)}e.newWriteableBufferStream=a;function f(m,u){return L.prefixedReadable(m,u,v=>i.concat(v))}e.prefixedBufferReadable=f;function _(m,u){return L.prefixedStream(m,u,v=>i.concat(v))}e.prefixedBufferStream=_;function E(m){let u=0,v=0,M=0;const D=new Uint8Array(Math.floor(m.length/4*3)),K=B=>{switch(v){case 3:D[M++]=u|B,v=0;break;case 2:D[M++]=u|B>>>2,u=B<<6,v=3;break;case 1:D[M++]=u|B>>>4,u=B<<4,v=2;break;default:u=B<<2,v=1}};for(let B=0;B<m.length;B++){const F=m.charCodeAt(B);if(F>=65&&F<=90)K(F-65);else if(F>=97&&F<=122)K(F-97+26);else if(F>=48&&F<=57)K(F-48+52);else if(F===43||F===45)K(62);else if(F===47||F===95)K(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${m[B]}`)}}const $=M;for(;v>0;)K(0);return i.wrap(D).slice(0,$)}e.decodeBase64=E;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:m},u=!0,v=!1){const M=v?c:A;let D="";const K=m.byteLength%3;let $=0;for(;$<m.byteLength-K;$+=3){const B=m[$+0],F=m[$+1],Z=m[$+2];D+=M[B>>>2],D+=M[(B<<4|F>>>4)&63],D+=M[(F<<2|Z>>>6)&63],D+=M[Z&63]}if(K===1){const B=m[$+0];D+=M[B>>>2],D+=M[B<<4&63],u&&(D+="==")}else if(K===2){const B=m[$+0],F=m[$+1];D+=M[B>>>2],D+=M[(B<<4|F>>>4)&63],D+=M[F<<2&63],u&&(D+="=")}return D}e.encodeBase64=P}),define(W[15],j([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[5],j([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var L;(function(w){w[w.Unknown=0]="Unknown",w[w.Invalid=3]="Invalid",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(L=e.StringEOL||(e.StringEOL={}));function y(w){let C=0,i=0,h=0,n=0;for(let t=0,r=w.length;t<r;t++){const l=w.charCodeAt(t);l===13?(C===0&&(i=t),C++,t+1<r&&w.charCodeAt(t+1)===10?(n|=2,t++):n|=3,h=t+1):l===10&&(n|=1,C===0&&(i=t),C++,h=t+1)}return C===0&&(i=w.length),[C,i,w.length-h,n]}e.countEOL=y}),define(W[8],j([0,1]),function(p,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var L;(function(n){n[n.Null=0]="Null",n[n.PlainText=1]="PlainText"})(L=e.LanguageId||(e.LanguageId={}));var y;(function(n){n[n.NotSet=-1]="NotSet",n[n.None=0]="None",n[n.Italic=1]="Italic",n[n.Bold=2]="Bold",n[n.Underline=4]="Underline",n[n.Strikethrough=8]="Strikethrough"})(y=e.FontStyle||(e.FontStyle={}));var w;(function(n){n[n.None=0]="None",n[n.DefaultForeground=1]="DefaultForeground",n[n.DefaultBackground=2]="DefaultBackground"})(w=e.ColorId||(e.ColorId={}));var C;(function(n){n[n.Other=0]="Other",n[n.Comment=1]="Comment",n[n.String=2]="String",n[n.RegEx=3]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var i;(function(n){n[n.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",n[n.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",n[n.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",n[n.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",n[n.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",n[n.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",n[n.ITALIC_MASK=2048]="ITALIC_MASK",n[n.BOLD_MASK=4096]="BOLD_MASK",n[n.UNDERLINE_MASK=8192]="UNDERLINE_MASK",n[n.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",n[n.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",n[n.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",n[n.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",n[n.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",n[n.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",n[n.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",n[n.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",n[n.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",n[n.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",n[n.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",n[n.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",n[n.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(i=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(t){return(t&255)>>>0}static getTokenType(t){return(t&768)>>>8}static containsBalancedBrackets(t){return(t&1024)!==0}static getFontStyle(t){return(t&30720)>>>11}static getForeground(t){return(t&16744448)>>>15}static getBackground(t){return(t&4278190080)>>>24}static getClassNameFromMetadata(t){const r=this.getForeground(t);let l="mtk"+r;const k=this.getFontStyle(t);return k&1&&(l+=" mtki"),k&2&&(l+=" mtkb"),k&4&&(l+=" mtku"),k&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(t,r){const l=this.getForeground(t),k=this.getFontStyle(t);let T=`color: ${r[l]};`;k&1&&(T+="font-style: italic;"),k&2&&(T+="font-weight: bold;");let o="";return k&4&&(o+=" underline"),k&8&&(o+=" line-through"),o&&(T+=`text-decoration:${o};`),T}static getPresentationFromMetadata(t){const r=this.getForeground(t),l=this.getFontStyle(t);return{foreground:r,italic:Boolean(l&1),bold:Boolean(l&2),underline:Boolean(l&4),strikethrough:Boolean(l&8)}}}e.TokenMetadata=h}),define(W[6],j([0,1,8]),function(p,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class y{static createEmpty(i,h){const n=y.defaultTokenMetadata,t=new Uint32Array(2);return t[0]=i.length,t[1]=n,new y(t,i,h)}constructor(i,h,n){this._lineTokensBrand=void 0,this._tokens=i,this._tokensCount=this._tokens.length>>>1,this._text=h,this._languageIdCodec=n}equals(i){return i instanceof y?this.slicedEquals(i,0,this._tokensCount):!1}slicedEquals(i,h,n){if(this._text!==i._text||this._tokensCount!==i._tokensCount)return!1;const t=h<<1,r=t+(n<<1);for(let l=t;l<r;l++)if(this._tokens[l]!==i._tokens[l])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(i){return i>0?this._tokens[i-1<<1]:0}getMetadata(i){return this._tokens[(i<<1)+1]}getLanguageId(i){const h=this._tokens[(i<<1)+1],n=L.TokenMetadata.getLanguageId(h);return this._languageIdCodec.decodeLanguageId(n)}getStandardTokenType(i){const h=this._tokens[(i<<1)+1];return L.TokenMetadata.getTokenType(h)}getForeground(i){const h=this._tokens[(i<<1)+1];return L.TokenMetadata.getForeground(h)}getClassName(i){const h=this._tokens[(i<<1)+1];return L.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(i,h){const n=this._tokens[(i<<1)+1];return L.TokenMetadata.getInlineStyleFromMetadata(n,h)}getPresentation(i){const h=this._tokens[(i<<1)+1];return L.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(i){return this._tokens[i<<1]}findTokenIndexAtOffset(i){return y.findIndexInTokensArray(this._tokens,i)}inflate(){return this}sliceAndInflate(i,h,n){return new w(this,i,h,n)}static convertToEndOffset(i,h){const t=(i.length>>>1)-1;for(let r=0;r<t;r++)i[r<<1]=i[r+1<<1];i[t<<1]=h}static findIndexInTokensArray(i,h){if(i.length<=2)return 0;let n=0,t=(i.length>>>1)-1;for(;n<t;){const r=n+Math.floor((t-n)/2),l=i[r<<1];if(l===h)return r+1;l<h?n=r+1:l>h&&(t=r)}return n}withInserted(i){if(i.length===0)return this;let h=0,n=0,t="";const r=new Array;let l=0;for(;;){const k=h<this._tokensCount?this._tokens[h<<1]:-1,T=n<i.length?i[n]:null;if(k!==-1&&(T===null||k<=T.offset)){t+=this._text.substring(l,k);const o=this._tokens[(h<<1)+1];r.push(t.length,o),h++,l=k}else if(T){if(T.offset>l){t+=this._text.substring(l,T.offset);const o=this._tokens[(h<<1)+1];r.push(t.length,o),l=T.offset}t+=T.text,r.push(t.length,T.tokenMetadata),n++}else break}return new y(new Uint32Array(r),t,this._languageIdCodec)}}y.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0,e.LineTokens=y;class w{constructor(i,h,n,t){this._source=i,this._startOffset=h,this._endOffset=n,this._deltaOffset=t,this._firstTokenIndex=i.findTokenIndexAtOffset(h),this._tokensCount=0;for(let r=this._firstTokenIndex,l=i.getCount();r<l&&!(i.getStartOffset(r)>=n);r++)this._tokensCount++}getMetadata(i){return this._source.getMetadata(this._firstTokenIndex+i)}getLanguageId(i){return this._source.getLanguageId(this._firstTokenIndex+i)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(i){return i instanceof w?this._startOffset===i._startOffset&&this._endOffset===i._endOffset&&this._deltaOffset===i._deltaOffset&&this._source.slicedEquals(i._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(i){return this._source.getForeground(this._firstTokenIndex+i)}getEndOffset(i){const h=this._source.getEndOffset(this._firstTokenIndex+i);return Math.min(this._endOffset,h)-this._startOffset+this._deltaOffset}getClassName(i){return this._source.getClassName(this._firstTokenIndex+i)}getInlineStyle(i,h){return this._source.getInlineStyle(this._firstTokenIndex+i,h)}getPresentation(i){return this._source.getPresentation(this._firstTokenIndex+i)}findTokenIndexAtOffset(i){return this._source.findTokenIndexAtOffset(i+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(W[16],j([0,1,6]),function(p,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class y{static deleteBeginning(i,h){return i===null||i===e.EMPTY_LINE_TOKENS?i:y.delete(i,0,h)}static deleteEnding(i,h){if(i===null||i===e.EMPTY_LINE_TOKENS)return i;const n=w(i),t=n[n.length-2];return y.delete(i,h,t)}static delete(i,h,n){if(i===null||i===e.EMPTY_LINE_TOKENS||h===n)return i;const t=w(i),r=t.length>>>1;if(h===0&&t[t.length-2]===n)return e.EMPTY_LINE_TOKENS;const l=L.LineTokens.findIndexInTokensArray(t,h),k=l>0?t[l-1<<1]:0,T=t[l<<1];if(n<T){const N=n-h;for(let q=l;q<r;q++)t[q<<1]-=N;return i}let o,d;k!==h?(t[l<<1]=h,o=l+1<<1,d=h):(o=l<<1,d=k);const S=n-h;for(let N=l+1;N<r;N++){const q=t[N<<1]-S;q>d&&(t[o++]=q,t[o++]=t[(N<<1)+1],d=q)}if(o===t.length)return i;const R=new Uint32Array(o);return R.set(t.subarray(0,o),0),R.buffer}static append(i,h){if(h===e.EMPTY_LINE_TOKENS)return i;if(i===e.EMPTY_LINE_TOKENS)return h;if(i===null)return i;if(h===null)return null;const n=w(i),t=w(h),r=t.length>>>1,l=new Uint32Array(n.length+t.length);l.set(n,0);let k=n.length;const T=n[n.length-2];for(let o=0;o<r;o++)l[k++]=t[o<<1]+T,l[k++]=t[(o<<1)+1];return l.buffer}static insert(i,h,n){if(i===null||i===e.EMPTY_LINE_TOKENS)return i;const t=w(i),r=t.length>>>1;let l=L.LineTokens.findIndexInTokensArray(t,h);l>0&&t[l-1<<1]===h&&l--;for(let k=l;k<r;k++)t[k<<1]+=n;return i}}e.ContiguousTokensEditing=y;function w(C){return C instanceof Uint32Array?C:new Uint32Array(C)}e.toUint32Array=w}),define(W[17],j([0,1,18,7,30,5,16]),function(p,e,L,y,w,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class h{static deserialize(t,r,l){const k=new Uint32Array(t.buffer),T=(0,y.readUInt32BE)(t,r);r+=4;const o=(0,y.readUInt32BE)(t,r);r+=4;const d=[];for(let S=0;S<o;S++){const R=(0,y.readUInt32BE)(t,r);r+=4,d.push(k.subarray(r/4,r/4+R/4)),r+=R}return l.push(new h(T,d)),r}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(t,r){this._startLineNumber=t,this._tokens=r}getLineTokens(t){return this._tokens[t-this._startLineNumber]}appendLineTokens(t){this._tokens.push(t)}serializeSize(){let t=0;t+=4,t+=4;for(let r=0;r<this._tokens.length;r++){const l=this._tokens[r];if(!(l instanceof Uint32Array))throw new Error("Not supported!");t+=4,t+=l.byteLength}return t}serialize(t,r){(0,y.writeUInt32BE)(t,this._startLineNumber,r),r+=4,(0,y.writeUInt32BE)(t,this._tokens.length,r),r+=4;for(let l=0;l<this._tokens.length;l++){const k=this._tokens[l];if(!(k instanceof Uint32Array))throw new Error("Not supported!");(0,y.writeUInt32BE)(t,k.byteLength,r),r+=4,t.set(new Uint8Array(k.buffer),r),r+=k.byteLength}return r}applyEdit(t,r){const[l,k]=(0,C.countEOL)(r);this._acceptDeleteRange(t),this._acceptInsertText(new w.Position(t.startLineNumber,t.startColumn),l,k)}_acceptDeleteRange(t){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return;const r=t.startLineNumber-this._startLineNumber,l=t.endLineNumber-this._startLineNumber;if(l<0){const k=l-r;this._startLineNumber-=k;return}if(!(r>=this._tokens.length)){if(r<0&&l>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(r===l){this._tokens[r]=i.ContiguousTokensEditing.delete(this._tokens[r],t.startColumn-1,t.endColumn-1);return}if(r>=0)if(this._tokens[r]=i.ContiguousTokensEditing.deleteEnding(this._tokens[r],t.startColumn-1),l<this._tokens.length){const k=i.ContiguousTokensEditing.deleteBeginning(this._tokens[l],t.endColumn-1);this._tokens[r]=i.ContiguousTokensEditing.append(this._tokens[r],k),this._tokens.splice(r+1,l-r)}else this._tokens[r]=i.ContiguousTokensEditing.append(this._tokens[r],null),this._tokens=this._tokens.slice(0,r+1);else{const k=-r;this._startLineNumber-=k,this._tokens[l]=i.ContiguousTokensEditing.deleteBeginning(this._tokens[l],t.endColumn-1),this._tokens=this._tokens.slice(l)}}}_acceptInsertText(t,r,l){if(r===0&&l===0)return;const k=t.lineNumber-this._startLineNumber;if(k<0){this._startLineNumber+=r;return}if(!(k>=this._tokens.length)){if(r===0){this._tokens[k]=i.ContiguousTokensEditing.insert(this._tokens[k],t.column-1,l);return}this._tokens[k]=i.ContiguousTokensEditing.deleteEnding(this._tokens[k],t.column-1),this._tokens[k]=i.ContiguousTokensEditing.insert(this._tokens[k],t.column-1,l),this._insertLines(t.lineNumber,r)}}_insertLines(t,r){if(r===0)return;const l=[];for(let k=0;k<r;k++)l[k]=null;this._tokens=L.arrayInsert(this._tokens,t,l)}}e.ContiguousMultilineTokens=h}),define(W[9],j([0,1,7,17]),function(p,e,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class w{static deserialize(i){let h=0;const n=(0,L.readUInt32BE)(i,h);h+=4;const t=[];for(let r=0;r<n;r++)h=y.ContiguousMultilineTokens.deserialize(i,h,t);return t}constructor(){this._tokens=[]}add(i,h){if(this._tokens.length>0){const n=this._tokens[this._tokens.length-1];if(n.endLineNumber+1===i){n.appendLineTokens(h);return}}this._tokens.push(new y.ContiguousMultilineTokens(i,[h]))}finalize(){return this._tokens}serialize(){const i=this._serializeSize(),h=new Uint8Array(i);return this._serialize(h),h}_serializeSize(){let i=0;i+=4;for(let h=0;h<this._tokens.length;h++)i+=this._tokens[h].serializeSize();return i}_serialize(i){let h=0;(0,L.writeUInt32BE)(i,this._tokens.length,h),h+=4;for(let n=0;n<this._tokens.length;n++)h=this._tokens[n].serialize(i,h)}}e.ContiguousMultilineTokensBuilder=w}),define(W[19],j([0,1,20,3,21,31]),function(p,e,L,y,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(c){return c===47||c===92}e.isPathSeparator=i;function h(c){return c.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=h;function n(c){return c.indexOf("/")===-1&&(c=h(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=n;function t(c,P=L.posix.sep){if(!c)return"";const m=c.length,u=c.charCodeAt(0);if(i(u)){if(i(c.charCodeAt(1))&&!i(c.charCodeAt(2))){let M=3;const D=M;for(;M<m&&!i(c.charCodeAt(M));M++);if(D!==M&&!i(c.charCodeAt(M+1))){for(M+=1;M<m;M++)if(i(c.charCodeAt(M)))return c.slice(0,M+1).replace(/[\\/]/g,P)}}return P}else if(R(u)&&c.charCodeAt(1)===58)return i(c.charCodeAt(2))?c.slice(0,2)+P:c.slice(0,2);let v=c.indexOf("://");if(v!==-1){for(v+=3;v<m;v++)if(i(c.charCodeAt(v)))return c.slice(0,v+1)}return""}e.getRoot=t;function r(c){if(!y.isWindows||!c||c.length<5)return!1;let P=c.charCodeAt(0);if(P!==92||(P=c.charCodeAt(1),P!==92))return!1;let m=2;const u=m;for(;m<c.length&&(P=c.charCodeAt(m),P!==92);m++);return!(u===m||(P=c.charCodeAt(m+1),isNaN(P)||P===92))}e.isUNC=r;const l=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(c,P=y.isWindows){const m=P?l:k;return!(!c||c.length===0||/^\s+$/.test(c)||(m.lastIndex=0,m.test(c))||P&&T.test(c)||c==="."||c===".."||P&&c[c.length-1]==="."||P&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=o;function d(c,P,m){const u=c===P;return!m||u?u:!c||!P?!1:(0,w.equalsIgnoreCase)(c,P)}e.isEqual=d;function S(c,P,m,u=L.sep){if(c===P)return!0;if(!c||!P||P.length>c.length)return!1;if(m){if(!(0,w.startsWithIgnoreCase)(c,P))return!1;if(P.length===c.length)return!0;let M=P.length;return P.charAt(P.length-1)===u&&M--,c.charAt(M)===u}return P.charAt(P.length-1)!==u&&(P+=u),c.indexOf(P)===0}e.isEqualOrParent=S;function R(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=R;function N(c,P){return y.isWindows&&c.endsWith(":")&&(c+=L.sep),(0,L.isAbsolute)(c)||(c=(0,L.join)(P,c)),c=(0,L.normalize)(c),y.isWindows?(c=(0,w.rtrim)(c,L.sep),c.endsWith(":")&&(c+=L.sep)):(c=(0,w.rtrim)(c,L.sep),c||(c=L.sep)),c}e.sanitizeFilePath=N;function q(c){const P=(0,L.normalize)(c);return y.isWindows?c.length>3?!1:z(P)&&(c.length===2||P.charCodeAt(2)===92):P===L.posix.sep}e.isRootOrDriveLetter=q;function z(c,P=y.isWindows){return P?R(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=z;function a(c){return z(c)?c[0]:void 0}e.getDriveLetter=a;function f(c,P,m){return P.length>c.length?-1:c===P?0:(m&&(c=c.toLowerCase(),P=P.toLowerCase()),c.indexOf(P))}e.indexOfPath=f;function _(c){const P=c.split(":");let m,u,v;for(const M of P){const D=Number(M);(0,C.isNumber)(D)?u===void 0?u=D:v===void 0&&(v=D):m=m?[m,M].join(":"):M}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:u!==void 0?u:void 0,column:v!==void 0?v:u!==void 0?1:void 0}}e.parseLineAndColumnAware=_;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function A(c,P,m=8){let u="";for(let M=0;M<m;M++)u+=E.charAt(Math.floor(Math.random()*E.length));let v;return P?v=`${P}-${u}`:v=u,c?(0,L.join)(c,v):v}e.randomPath=A}),define(W[22],j([0,1,4,3,10]),function(p,e,L,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(t){t.inMemory="inmemory",t.vscode="vscode",t.internal="private",t.walkThrough="walkThrough",t.walkThroughSnippet="walkThroughSnippet",t.http="http",t.https="https",t.file="file",t.mailto="mailto",t.untitled="untitled",t.data="data",t.command="command",t.vscodeRemote="vscode-remote",t.vscodeRemoteResource="vscode-remote-resource",t.vscodeUserData="vscode-userdata",t.vscodeCustomEditor="vscode-custom-editor",t.vscodeNotebookCell="vscode-notebook-cell",t.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",t.vscodeNotebookCellOutput="vscode-notebook-cell-output",t.vscodeInteractive="vscode-interactive",t.vscodeInteractiveInput="vscode-interactive-input",t.vscodeSettings="vscode-settings",t.vscodeWorkspaceTrust="vscode-workspace-trust",t.vscodeTerminal="vscode-terminal",t.webviewPanel="webview-panel",t.vscodeWebview="vscode-webview",t.extension="extension",t.vscodeFileResource="vscode-file",t.tmp="tmp",t.vsls="vsls",t.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class i{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r){this._remoteResourcesPath=`${r}/${C.vscodeRemoteResource}`}set(r,l,k){this._hosts[r]=l,this._ports[r]=k}setConnectionToken(r,l){this._connectionTokens[r]=l}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(S){return L.onUnexpectedError(S),r}const l=r.authority;let k=this._hosts[l];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const T=this._ports[l],o=this._connectionTokens[l];let d=`path=${encodeURIComponent(r.path)}`;return typeof o=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(o)}`),w.URI.from({scheme:y.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${k}:${T}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new i,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{asBrowserUri(r){const l=this.toUri(r,p);return this.uriToBrowserUri(l)}uriToBrowserUri(r){return r.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===C.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${C.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?r.with({scheme:C.vscodeFileResource,authority:r.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const l=this.toUri(r,p);return this.uriToFileUri(l)}uriToFileUri(r){return r.scheme===C.vscodeFileResource?r.with({scheme:C.file,authority:r.authority!==h.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,l){return w.URI.isUri(r)?r:w.URI.parse(l.toUrl(r))}}h.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new h;var n;(function(t){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);t.CoopAndCoep=Object.freeze(r.get("3"));const l="vscode-coi";function k(o){let d;typeof o=="string"?d=new URL(o).searchParams:o instanceof URL?d=o.searchParams:w.URI.isUri(o)&&(d=new URL(o.toString(!0)).searchParams);const S=d?.get(l);if(!!S)return r.get(S)}t.getHeadersFromQuery=k;function T(o,d,S){if(!globalThis.crossOriginIsolated)return;const R=d&&S?"3":S?"2":"1";o instanceof URLSearchParams?o.set(l,R):o[l]=R}t.addSearchParam=T})(n=e.COI||(e.COI={}))}),define(W[11],j([0,1,19,22,20,3,21,10]),function(p,e,L,y,w,C,i,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function n(T){return(0,h.uriToFsPath)(T,!0)}e.originalFSPath=n;class t{constructor(o){this._ignorePathCasing=o}compare(o,d,S=!1){return o===d?0:(0,i.compare)(this.getComparisonKey(o,S),this.getComparisonKey(d,S))}isEqual(o,d,S=!1){return o===d?!0:!o||!d?!1:this.getComparisonKey(o,S)===this.getComparisonKey(d,S)}getComparisonKey(o,d=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,d,S=!1){if(o.scheme===d.scheme){if(o.scheme===y.Schemas.file)return L.isEqualOrParent(n(o),n(d),this._ignorePathCasing(o))&&o.query===d.query&&(S||o.fragment===d.fragment);if((0,e.isEqualAuthority)(o.authority,d.authority))return L.isEqualOrParent(o.path,d.path,this._ignorePathCasing(o),"/")&&o.query===d.query&&(S||o.fragment===d.fragment)}return!1}joinPath(o,...d){return h.URI.joinPath(o,...d)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let d;return o.scheme===y.Schemas.file?d=h.URI.file(w.dirname(n(o))).path:(d=w.posix.dirname(o.path),o.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),d="/")),o.with({path:d})}normalizePath(o){if(!o.path.length)return o;let d;return o.scheme===y.Schemas.file?d=h.URI.file(w.normalize(n(o))).path:d=w.posix.normalize(o.path),o.with({path:d})}relativePath(o,d){if(o.scheme!==d.scheme||!(0,e.isEqualAuthority)(o.authority,d.authority))return;if(o.scheme===y.Schemas.file){const N=w.relative(n(o),n(d));return C.isWindows?L.toSlashes(N):N}let S=o.path||"/";const R=d.path||"/";if(this._ignorePathCasing(o)){let N=0;for(const q=Math.min(S.length,R.length);N<q&&!(S.charCodeAt(N)!==R.charCodeAt(N)&&S.charAt(N).toLowerCase()!==R.charAt(N).toLowerCase());N++);S=R.substr(0,N)+S.substr(N)}return w.posix.relative(S,R)}resolvePath(o,d){if(o.scheme===y.Schemas.file){const S=h.URI.file(w.resolve(n(o),d));return o.with({authority:S.authority,path:S.path})}return d=L.toPosixPath(d),o.with({path:w.posix.resolve(o.path,d)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,d){return o===d||o!==void 0&&d!==void 0&&(0,i.equalsIgnoreCase)(o,d)}hasTrailingPathSeparator(o,d=w.sep){if(o.scheme===y.Schemas.file){const S=n(o);return S.length>L.getRoot(S).length&&S[S.length-1]===d}else{const S=o.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,d=w.sep){return(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,d=w.sep){let S=!1;if(o.scheme===y.Schemas.file){const R=n(o);S=R!==void 0&&R.length===L.getRoot(R).length&&R[R.length-1]===d}else{d="/";const R=o.path;S=R.length===1&&R.charCodeAt(R.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path+"/"}):o}}e.ExtUri=t,e.extUri=new t(()=>!1),e.extUriBiasedIgnorePathCase=new t(T=>T.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new t(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(T,o){const d=[];for(let S=0;S<T.length;S++){const R=o(T[S]);T.some((N,q)=>q===S?!1:(0,e.isEqualOrParent)(R,o(N)))||d.push(T[S])}return d}e.distinctParents=r;var l;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function o(d){const S=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(q=>{const[z,a]=q.split(":");z&&a&&S.set(z,a)});const N=d.path.substring(0,d.path.indexOf(";"));return N&&S.set(T.META_DATA_MIME,N),S}T.parseMetaData=o})(l=e.DataUri||(e.DataUri={}));function k(T,o,d){if(o){let S=T.path;return S&&S[0]!==w.posix.sep&&(S=w.posix.sep+S),T.with({scheme:d,authority:o,path:S})}return T.with({scheme:d})}e.toLocalResource=k}),define(W[12],j([0,1,32,4,23,2,11,3,15]),function(p,e,L,y,w,C,i,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function t(I){return!!I&&typeof I.then=="function"}e.isThenable=t;function r(I){const s=new L.CancellationTokenSource,g=I(s.token),b=new Promise((O,U)=>{const G=s.token.onCancellationRequested(()=>{G.dispose(),s.dispose(),U(new y.CancellationError)});Promise.resolve(g).then(Y=>{G.dispose(),s.dispose(),O(Y)},Y=>{G.dispose(),s.dispose(),U(Y)})});return new class{cancel(){s.cancel()}then(O,U){return b.then(O,U)}catch(O){return this.then(void 0,O)}finally(O){return b.finally(O)}}}e.createCancelablePromise=r;function l(I,s,g){return new Promise((b,O)=>{const U=s.onCancellationRequested(()=>{U.dispose(),b(g)});I.then(b,O).finally(()=>U.dispose())})}e.raceCancellation=l;function k(I,s){return new Promise((g,b)=>{const O=s.onCancellationRequested(()=>{O.dispose(),b(new y.CancellationError)});I.then(g,b).finally(()=>O.dispose())})}e.raceCancellationError=k;async function T(I){let s=-1;const g=I.map((O,U)=>O.then(G=>(s=U,G))),b=await Promise.race(g);return I.forEach((O,U)=>{U!==s&&O.cancel()}),b}e.raceCancellablePromises=T;function o(I,s,g){let b;const O=setTimeout(()=>{b?.(void 0),g?.()},s);return Promise.race([I.finally(()=>clearTimeout(O)),new Promise(U=>b=U)])}e.raceTimeout=o;function d(I){return new Promise((s,g)=>{const b=I();t(b)?b.then(s,g):s(b)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(s){if(this.activePromise){if(this.queuedPromiseFactory=s,!this.queuedPromise){const g=()=>{this.queuedPromise=null;const b=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,b};this.queuedPromise=new Promise(b=>{this.activePromise.then(g,g).then(b)})}return new Promise((g,b)=>{this.queuedPromise.then(g,b)})}return this.activePromise=s(),new Promise((g,b)=>{this.activePromise.then(O=>{this.activePromise=null,g(O)},O=>{this.activePromise=null,b(O)})})}}e.Throttler=S;class R{constructor(){this.current=Promise.resolve(null)}queue(s){return this.current=this.current.then(()=>s(),()=>s())}}e.Sequencer=R;class N{constructor(){this.promiseMap=new Map}queue(s,g){const O=(this.promiseMap.get(s)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.promiseMap.get(s)===O&&this.promiseMap.delete(s)});return this.promiseMap.set(s,O),O}}e.SequencerByKey=N;const q=(I,s)=>{let g=!0;const b=setTimeout(()=>{g=!1,s()},I);return{isTriggered:()=>g,dispose:()=>{clearTimeout(b),g=!1}}},z=I=>{let s=!0;return queueMicrotask(()=>{s&&(s=!1,I())}),{isTriggered:()=>s,dispose:()=>{s=!1}}};class a{constructor(s){this.defaultDelay=s,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(s,g=this.defaultDelay){this.task=s,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,U)=>{this.doResolve=O,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}}));const b=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=g===n.MicrotaskDelay?z(b):q(g,b),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class f{constructor(s){this.delayer=new a(s),this.throttler=new S}trigger(s,g){return this.delayer.trigger(()=>this.throttler.queue(s),g)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class _{constructor(){this._isOpen=!1,this._promise=new Promise((s,g)=>{this._completePromise=s})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class E extends _{constructor(s){super(),this._timeout=setTimeout(()=>this.open(),s)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function A(I,s){return s?new Promise((g,b)=>{const O=setTimeout(()=>{U.dispose(),g()},I),U=s.onCancellationRequested(()=>{clearTimeout(O),U.dispose(),b(new y.CancellationError)})}):r(g=>A(I,g))}e.timeout=A;function c(I,s=0){const g=setTimeout(I,s);return(0,C.toDisposable)(()=>clearTimeout(g))}e.disposableTimeout=c;function P(I){const s=[];let g=0;const b=I.length;function O(){return g<b?I[g++]():null}function U(G){G!=null&&s.push(G);const Y=O();return Y?Y.then(U):Promise.resolve(s)}return Promise.resolve(null).then(U)}e.sequence=P;function m(I,s=b=>!!b,g=null){let b=0;const O=I.length,U=()=>{if(b>=O)return Promise.resolve(g);const G=I[b++];return Promise.resolve(G()).then(Q=>s(Q)?Promise.resolve(Q):U())};return U()}e.first=m;function u(I,s=b=>!!b,g=null){if(I.length===0)return Promise.resolve(g);let b=I.length;const O=()=>{b=-1;for(const U of I)U.cancel?.()};return new Promise((U,G)=>{for(const Y of I)Y.then(Q=>{--b>=0&&s(Q)?(O(),U(Q)):b===0&&U(g)}).catch(Q=>{--b>=0&&(O(),G(Q))})})}e.firstParallel=u;class v{constructor(s){this._size=0,this.maxDegreeOfParalellism=s,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(s){return this._size++,new Promise((g,b)=>{this.outstandingPromises.push({factory:s,c:g,e:b}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const s=this.outstandingPromises.shift();this.runningPromises++;const g=s.factory();g.then(s.c,s.e),g.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=v;class M extends v{constructor(){super(1)}}e.Queue=M;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const s=new V;return this.drainers.add(s),s.p}isDrained(){for(const[,s]of this.queues)if(s.size>0)return!1;return!0}queueFor(s,g=i.extUri){const b=g.getComparisonKey(s);let O=this.queues.get(b);return O||(O=new M,w.Event.once(O.onDrained)(()=>{O?.dispose(),this.queues.delete(b),this.onDidQueueDrain()}),this.queues.set(b,O)),O}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const s of this.drainers)s.complete();this.drainers.clear()}dispose(){for(const[,s]of this.queues)s.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class K{constructor(s,g){this._token=-1,typeof s=="function"&&typeof g=="number"&&this.setIfNotSet(s,g)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(s,g){this.cancel(),this._token=setTimeout(()=>{this._token=-1,s()},g)}setIfNotSet(s,g){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,s()},g))}}e.TimeoutTimer=K;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(s,g){this.cancel(),this._token=setInterval(()=>{s()},g)}}e.IntervalTimer=$;class B{constructor(s,g){this.timeoutToken=-1,this.runner=s,this.timeout=g,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(s=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,s)}get delay(){return this.timeout}set delay(s){this.timeout=s}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class F{constructor(s,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.runner=s,this.timeout=g,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(s=this.timeout){s%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${s}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(s/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class Z extends B{constructor(s,g){super(s,g),this.units=[]}work(s){this.units.push(s),this.isScheduled()||this.schedule()}doRun(){const s=this.units;this.units=[],this.runner?.(s)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Z;class x extends C.Disposable{constructor(s,g){super(),this.options=s,this.handler=g,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(s){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+s.length>this.options.maxBufferedWork)return!1}else if(this.pending+s.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const g of s)this.pendingWork.push(g);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=I=>{(0,h.setTimeout0)(()=>{if(s)return;const g=Date.now()+15;I(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,g-Date.now())}}))});let s=!1;return{dispose(){s||(s=!0)}}}:e.runWhenIdle=(I,s)=>{const g=requestIdleCallback(I,typeof s=="number"?{timeout:s}:void 0);let b=!1;return{dispose(){b||(b=!0,cancelIdleCallback(g))}}}}();class ee{constructor(s){this._didRun=!1,this._executor=()=>{try{this._value=s()}catch(g){this._error=g}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ee;async function te(I,s,g){let b;for(let O=0;O<g;O++)try{return await I()}catch(U){b=U,await A(s)}throw b}e.retry=te;class ne{hasPending(s){return this._pending?typeof s=="number"?this._pending.taskId===s:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(s,g,b){return this._pending={taskId:s,cancel:()=>b?.(),promise:g},g.then(()=>this.donePending(s),()=>this.donePending(s)),g}donePending(s){this._pending&&s===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const s=this._next;this._next=void 0,s.run().then(s.promiseResolve,s.promiseReject)}}setNext(s){if(this._next)this._next.run=s;else{let g,b;const O=new Promise((U,G)=>{g=U,b=G});this._next={run:s,promise:O,promiseResolve:g,promiseReject:b}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=ne;class ie{constructor(s,g=()=>Date.now()){this.interval=s,this.nowFn=g,this.lastIncrementTime=0,this.value=0}increment(){const s=this.nowFn();return s-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=s,this.value=0),this.value++,this.value}}e.IntervalCounter=ie;class V{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((s,g)=>{this.completeCallback=s,this.errorCallback=g})}complete(s){return new Promise(g=>{this.completeCallback(s),this.resolved=!0,g()})}error(s){return new Promise(g=>{this.errorCallback(s),this.rejected=!0,g()})}cancel(){new Promise(s=>{this.errorCallback(new y.CancellationError),this.rejected=!0,s()})}}e.DeferredPromise=V;var re;(function(I){async function s(b){let O;const U=await Promise.all(b.map(G=>G.then(Y=>Y,Y=>{O||(O=Y)})));if(typeof O<"u")throw O;return U}I.settled=s;function g(b){return new Promise(async(O,U)=>{try{await b(O,U)}catch(G){U(G)}})}I.withAsyncBody=g})(re=e.Promises||(e.Promises={}));var X;(function(I){I[I.Initial=0]="Initial",I[I.DoneOK=1]="DoneOK",I[I.DoneError=2]="DoneError"})(X||(X={}));class H{static fromArray(s){return new H(g=>{g.emitMany(s)})}static fromPromise(s){return new H(async g=>{g.emitMany(await s)})}static fromPromises(s){return new H(async g=>{await Promise.all(s.map(async b=>g.emitOne(await b)))})}static merge(s){return new H(async g=>{await Promise.all(s.map(async b=>{for await(const O of b)g.emitOne(O)}))})}constructor(s){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const g={emitOne:b=>this.emitOne(b),emitMany:b=>this.emitMany(b),reject:b=>this.reject(b)};try{await Promise.resolve(s(g)),this.resolve()}catch(b){this.reject(b)}finally{g.emitOne=void 0,g.emitMany=void 0,g.reject=void 0}})}[Symbol.asyncIterator](){let s=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(s<this._results.length)return{done:!1,value:this._results[s++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(s,g){return new H(async b=>{for await(const O of s)b.emitOne(g(O))})}map(s){return H.map(this,s)}static filter(s,g){return new H(async b=>{for await(const O of s)g(O)&&b.emitOne(O)})}filter(s){return H.filter(this,s)}static coalesce(s){return H.filter(s,g=>!!g)}coalesce(){return H.coalesce(this)}static async toPromise(s){const g=[];for await(const b of s)g.push(b);return g}toPromise(){return H.toPromise(this)}emitOne(s){this._state===0&&(this._results.push(s),this._onStateChanged.fire())}emitMany(s){this._state===0&&(this._results=this._results.concat(s),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(s){this._state===0&&(this._state=2,this._error=s,this._onStateChanged.fire())}}H.EMPTY=H.fromArray([]),e.AsyncIterableObject=H;class J extends H{constructor(s,g){super(g),this._source=s}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function se(I){const s=new L.CancellationTokenSource,g=I(s.token);return new J(s,async b=>{const O=s.token.onCancellationRequested(()=>{O.dispose(),s.dispose(),b.reject(new y.CancellationError)});try{for await(const U of g){if(s.token.isCancellationRequested)return;b.emitOne(U)}O.dispose(),s.dispose()}catch(U){O.dispose(),s.dispose(),b.reject(U)}})}e.createCancelableAsyncIterable=se}),define(W[24],j([0,1,13]),function(p,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(C){return this===C}};function y(C,i){return new L.TokenizationResult([new L.Token(0,"",C)],i)}e.nullTokenize=y;function w(C,i){const h=new Uint32Array(2);return h[0]=0,h[1]=(C<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new L.EncodedTokenizationResult(h,i===null?e.NullState:i)}e.nullTokenizeEncoded=w}),define(W[25],j([0,1,18,12,4,2,3,33,5,13,24,9,6]),function(p,e,L,y,w,C,i,h,n,t,r,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextModelTokenization=e.TokenizationStateStore=e.ContiguousGrowingArray=void 0;var T;(function(z){z[z.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(T||(T={}));class o{constructor(a){this._default=a,this._store=[]}get(a){return a<this._store.length?this._store[a]:this._default}set(a,f){for(;a>=this._store.length;)this._store[this._store.length]=this._default;this._store[a]=f}delete(a,f){f===0||a>=this._store.length||this._store.splice(a,f)}insert(a,f){if(f===0||a>=this._store.length)return;const _=[];for(let E=0;E<f;E++)_[E]=this._default;this._store=L.arrayInsert(this._store,a,_)}}e.ContiguousGrowingArray=o;class d{get invalidLineStartIndex(){return this._firstLineNeedsTokenization}constructor(a,f){this.tokenizationSupport=a,this.initialState=f,this._lineBeginState=new o(null),this._lineNeedsTokenization=new o(!0),this._firstLineNeedsTokenization=0,this._lineBeginState.set(0,this.initialState)}markMustBeTokenized(a){this._lineNeedsTokenization.set(a,!0),this._firstLineNeedsTokenization=Math.min(this._firstLineNeedsTokenization,a)}getBeginState(a){return this._lineBeginState.get(a)}setEndState(a,f,_){if(this._lineNeedsTokenization.set(f,!1),this._firstLineNeedsTokenization=f+1,f===a-1)return!1;const E=this._lineBeginState.get(f+1);if(E===null||!_.equals(E))return this._lineBeginState.set(f+1,_),this.markMustBeTokenized(f+1),!0;let A=f+1;for(;A<a&&!this._lineNeedsTokenization.get(A);)A++;return this._firstLineNeedsTokenization=A,!1}applyEdits(a,f){this.markMustBeTokenized(a.startLineNumber-1),this._lineBeginState.delete(a.startLineNumber,a.endLineNumber-a.startLineNumber),this._lineNeedsTokenization.delete(a.startLineNumber,a.endLineNumber-a.startLineNumber),this._lineBeginState.insert(a.startLineNumber,f),this._lineNeedsTokenization.insert(a.startLineNumber,f)}updateTokensUntilLine(a,f,_,E){const A=a.getLanguageId(),c=a.getLineCount(),P=E-1;for(let m=this.invalidLineStartIndex;m<=P;m++){const u=a.getLineContent(m+1),v=this.getBeginState(m),M=N(f,A,this.tokenizationSupport,u,!0,v);_.add(m+1,M.tokens),this.setEndState(c,m,M.endState),m=this.invalidLineStartIndex-1}}isTokenizationComplete(a){return this.invalidLineStartIndex>=a.getLineCount()}}e.TokenizationStateStore=d;class S extends C.Disposable{constructor(a,f,_){super(),this._textModel=a,this._tokenizationPart=f,this._languageIdCodec=_,this._tokenizationStateStore=null,this._defaultBackgroundTokenizer=null,this.backgroundTokenizer=this._register(new C.MutableDisposable),this._register(t.TokenizationRegistry.onDidChange(E=>{const A=this._textModel.getLanguageId();E.changedLanguages.indexOf(A)!==-1&&(this._resetTokenizationState(),this._tokenizationPart.clearTokens())})),this._resetTokenizationState()}handleDidChangeContent(a){if(a.isFlush){this._resetTokenizationState();return}if(this._tokenizationStateStore)for(let f=0,_=a.changes.length;f<_;f++){const E=a.changes[f],[A]=(0,n.countEOL)(E.text);this._tokenizationStateStore.applyEdits(E.range,A)}this._defaultBackgroundTokenizer?.handleChanges()}handleDidChangeAttached(){this._defaultBackgroundTokenizer?.handleChanges()}handleDidChangeLanguage(a){this._resetTokenizationState(),this._tokenizationPart.clearTokens()}_resetTokenizationState(){const[a,f]=R(this._textModel,this._tokenizationPart);if(a&&f?this._tokenizationStateStore=new d(a,f):this._tokenizationStateStore=null,this.backgroundTokenizer.clear(),this._defaultBackgroundTokenizer=null,this._tokenizationStateStore){const _={setTokens:E=>{this._tokenizationPart.setTokens(E)},backgroundTokenizationFinished:()=>{this._tokenizationPart.handleBackgroundTokenizationFinished()},setEndState:(E,A)=>{if(!A)throw new w.BugIndicatingError;const c=this._tokenizationStateStore?.invalidLineStartIndex;c!==void 0&&E-1>=c&&this._tokenizationStateStore?.setEndState(this._textModel.getLineCount(),E-1,A)}};a&&a.createBackgroundTokenizer&&(this.backgroundTokenizer.value=a.createBackgroundTokenizer(this._textModel,_)),this.backgroundTokenizer.value||(this.backgroundTokenizer.value=this._defaultBackgroundTokenizer=new q(this._textModel,this._tokenizationStateStore,_,this._languageIdCodec),this._defaultBackgroundTokenizer.handleChanges())}}tokenizeViewport(a,f){const _=new l.ContiguousMultilineTokensBuilder;this._heuristicallyTokenizeViewport(_,a,f),this._tokenizationPart.setTokens(_.finalize()),this._defaultBackgroundTokenizer?.checkFinished()}reset(){this._resetTokenizationState(),this._tokenizationPart.clearTokens()}forceTokenization(a){const f=new l.ContiguousMultilineTokensBuilder;this._tokenizationStateStore?.updateTokensUntilLine(this._textModel,this._languageIdCodec,f,a),this._tokenizationPart.setTokens(f.finalize()),this._defaultBackgroundTokenizer?.checkFinished()}getTokenTypeIfInsertingCharacter(a,f){if(!this._tokenizationStateStore)return 0;this.forceTokenization(a.lineNumber);const _=this._tokenizationStateStore.getBeginState(a.lineNumber-1);if(!_)return 0;const E=this._textModel.getLanguageId(),A=this._textModel.getLineContent(a.lineNumber),c=A.substring(0,a.column-1)+f+A.substring(a.column-1),P=N(this._languageIdCodec,E,this._tokenizationStateStore.tokenizationSupport,c,!0,_),m=new k.LineTokens(P.tokens,c,this._languageIdCodec);if(m.getCount()===0)return 0;const u=m.findTokenIndexAtOffset(a.column-1);return m.getStandardTokenType(u)}tokenizeLineWithEdit(a,f,_){const E=a.lineNumber,A=a.column;if(!this._tokenizationStateStore)return null;this.forceTokenization(E);const c=this._tokenizationStateStore.getBeginState(E-1);if(!c)return null;const P=this._textModel.getLineContent(E),m=P.substring(0,A-1)+_+P.substring(A-1+f),u=this._textModel.getLanguageIdAtPosition(E,0),v=N(this._languageIdCodec,u,this._tokenizationStateStore.tokenizationSupport,m,!0,c);return new k.LineTokens(v.tokens,m,this._languageIdCodec)}isCheapToTokenize(a){if(!this._tokenizationStateStore)return!0;const f=this._tokenizationStateStore.invalidLineStartIndex+1;return a>f?!1:a<f||this._textModel.getLineLength(a)<2048}_heuristicallyTokenizeViewport(a,f,_){if(!this._tokenizationStateStore||_<=this._tokenizationStateStore.invalidLineStartIndex)return;if(f<=this._tokenizationStateStore.invalidLineStartIndex){this._tokenizationStateStore.updateTokensUntilLine(this._textModel,this._languageIdCodec,a,_);return}let E=this.guessStartState(f);const A=this._textModel.getLanguageId();for(let c=f;c<=_;c++){const P=this._textModel.getLineContent(c),m=N(this._languageIdCodec,A,this._tokenizationStateStore.tokenizationSupport,P,!0,E);a.add(c,m.tokens),E=m.endState}this.backgroundTokenizer.value?.requestTokens(f,_+1)}guessStartState(a){let f=this._textModel.getLineFirstNonWhitespaceColumn(a);const _=[];let E=null;for(let P=a-1;f>1&&P>=1;P--){const m=this._textModel.getLineFirstNonWhitespaceColumn(P);if(m!==0&&m<f&&(_.push(this._textModel.getLineContent(P)),f=m,E=this._tokenizationStateStore.getBeginState(P-1),E))break}E||(E=this._tokenizationStateStore.initialState),_.reverse();const A=this._textModel.getLanguageId();let c=E;for(const P of _)c=N(this._languageIdCodec,A,this._tokenizationStateStore.tokenizationSupport,P,!1,c).endState;return c}}e.TextModelTokenization=S;function R(z,a){if(z.isTooLargeForTokenization())return[null,null];const f=t.TokenizationRegistry.get(a.getLanguageId());if(!f)return[null,null];let _;try{_=f.getInitialState()}catch(E){return(0,w.onUnexpectedError)(E),[null,null]}return[f,_]}function N(z,a,f,_,E,A){let c=null;if(f)try{c=f.tokenizeEncoded(_,E,A.clone())}catch(P){(0,w.onUnexpectedError)(P)}return c||(c=(0,r.nullTokenizeEncoded)(z.encodeLanguageId(a),A)),k.LineTokens.convertToEndOffset(c.tokens,_.length),c}class q{constructor(a,f,_,E){this._textModel=a,this._stateStore=f,this._backgroundTokenStore=_,this._languageIdCodec=E,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,y.runWhenIdle)(a=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(a)}))}_backgroundTokenizeWithDeadline(a){const f=Date.now()+a.timeRemaining(),_=()=>{this._isDisposed||!this._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<f?(0,i.setTimeout0)(_):this._beginBackgroundTokenization())};_()}_backgroundTokenizeForAtLeast1ms(){const a=this._textModel.getLineCount(),f=new l.ContiguousMultilineTokensBuilder,_=h.StopWatch.create(!1);do if(_.elapsed()>1||this._tokenizeOneInvalidLine(f)>=a)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(f.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._stateStore?this._stateStore.invalidLineStartIndex<this._textModel.getLineCount():!1}_tokenizeOneInvalidLine(a){if(!this._stateStore||!this._hasLinesToTokenize())return this._textModel.getLineCount()+1;const f=this._stateStore.invalidLineStartIndex+1;return this._stateStore.updateTokensUntilLine(this._textModel,this._languageIdCodec,a,f),f}checkFinished(){this._isDisposed||this._stateStore.isTokenizationComplete(this._textModel)&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(a,f){for(let _=a;_<f;_++)this._stateStore.markMustBeTokenized(_-1)}}}),define(W[26],j([0,1,23,2,8,13]),function(p,e,L,y,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class i extends y.Disposable{constructor(n,t,r,l){super(),this._grammar=n,this._initialState=t,this._containsEmbeddedLanguages=r,this._createBackgroundTokenizer=l,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new L.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}getInitialState(){return this._initialState}tokenize(n,t,r){throw new Error("Not supported!")}createBackgroundTokenizer(n,t){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(n,t)}tokenizeEncoded(n,t,r){const l=this._grammar.tokenizeLine2(n,r,500);if(l.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${n.substring(0,100)}`),new C.EncodedTokenizationResult(l.tokens,r);if(this._containsEmbeddedLanguages){const T=this._seenLanguages,o=l.tokens;for(let d=0,S=o.length>>>1;d<S;d++){const R=o[(d<<1)+1],N=w.TokenMetadata.getLanguageId(R);T[N]||(T[N]=!0,this._onDidEncounterLanguage.fire(N))}}let k;return r.equals(l.ruleStack)?k=r:k=l.ruleStack,new C.EncodedTokenizationResult(l.tokens,k)}}e.TextMateTokenizationSupport=i}),define(W[27],j([0,1,11]),function(p,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class y{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(C){if(this._scopeNameToLanguageRegistration[C.scopeName]){const i=this._scopeNameToLanguageRegistration[C.scopeName];L.isEqual(i.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${i.location.toString()}.
New grammar file: ${C.location.toString()}`)}this._scopeNameToLanguageRegistration[C.scopeName]=C}getGrammarDefinition(C){return this._scopeNameToLanguageRegistration[C]||null}}e.TMScopeRegistry=y}),define(W[28],j([0,1,2,27]),function(p,e,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class w extends L.Disposable{constructor(i,h,n,t){super(),this._host=i,this._initialState=n.INITIAL,this._scopeRegistry=new y.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new n.Registry({onigLib:t,loadGrammar:async r=>{const l=this._scopeRegistry.getGrammarDefinition(r);if(!l)return this._host.logTrace(`No grammar found for scope ${r}`),null;const k=l.location;try{const T=await this._host.readFile(k);return n.parseRawGrammar(T,k.path)}catch(T){return this._host.logError(`Unable to load and parse grammar for scope ${r} from ${k}`,T),null}},getInjections:r=>{const l=r.split(".");let k=[];for(let T=1;T<=l.length;T++){const o=l.slice(0,T).join(".");k=[...k,...this._injections[o]||[]]}return k}}));for(const r of h){if(this._scopeRegistry.register(r),r.injectTo){for(const l of r.injectTo){let k=this._injections[l];k||(this._injections[l]=k=[]),k.push(r.scopeName)}if(r.embeddedLanguages)for(const l of r.injectTo){let k=this._injectedEmbeddedLanguages[l];k||(this._injectedEmbeddedLanguages[l]=k=[]),k.push(r.embeddedLanguages)}}r.language&&this._languageToScope.set(r.language,r.scopeName)}}has(i){return this._languageToScope.has(i)}setTheme(i,h){this._grammarRegistry.setTheme(i,h)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(i,h){const n=this._languageToScope.get(i);if(typeof n!="string")throw new Error(e.missingTMGrammarErrorMessage);const t=this._scopeRegistry.getGrammarDefinition(n);if(!t)throw new Error(e.missingTMGrammarErrorMessage);const r=t.embeddedLanguages;if(this._injectedEmbeddedLanguages[n]){const T=this._injectedEmbeddedLanguages[n];for(const o of T)for(const d of Object.keys(o))r[d]=o[d]}const l=Object.keys(r).length>0;let k;try{k=await this._grammarRegistry.loadGrammarWithConfiguration(n,h,{embeddedLanguages:r,tokenTypes:t.tokenTypes,balancedBracketSelectors:t.balancedBracketSelectors,unbalancedBracketSelectors:t.unbalancedBracketSelectors})}catch(T){throw T.message&&T.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):T}return{languageId:i,grammar:k,initialState:this._initialState,containsEmbeddedLanguages:l}}}e.TMGrammarFactory=w}),define(W[29],j([0,1,34,25,35,9,5,6,26,12]),function(p,e,L,y,w,C,i,h,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class r extends L.MirrorTextModel{constructor(T,o,d,S,R,N,q){super(T,o,d,S),this.tokenizeDebouncer=new t.RunOnceScheduler(()=>this._tokenize(),10),this._tokenizationStateStore=null,this._worker=R,this._languageId=N,this._encodedLanguageId=q,this._isDisposed=!1,this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(T,o){this._languageId=T,this._encodedLanguageId=o,this._resetTokenization()}onEvents(T){if(super.onEvents(T),this._tokenizationStateStore)for(let o=0;o<T.changes.length;o++){const d=T.changes[o],[S]=(0,i.countEOL)(d.text);this._tokenizationStateStore.applyEdits(d.range,S)}this.tokenizeDebouncer.schedule()}retokenize(T,o){if(this._tokenizationStateStore){for(let d=T;d<o;d++)this._tokenizationStateStore.markMustBeTokenized(d-1);this.tokenizeDebouncer.schedule()}}_resetTokenization(){this._tokenizationStateStore=null;const T=this._languageId,o=this._encodedLanguageId;this._worker.getOrCreateGrammar(T,o).then(d=>{if(!(this._isDisposed||T!==this._languageId||o!==this._encodedLanguageId||!d)){if(d.grammar){const S=new n.TextMateTokenizationSupport(d.grammar,d.initialState,!1);this._tokenizationStateStore=new y.TokenizationStateStore(S,S.getInitialState())}else this._tokenizationStateStore=null;this._tokenize()}})}_tokenize(){if(this._isDisposed||!this._tokenizationStateStore)return;const T=new Date().getTime();for(;;){const o=new C.ContiguousMultilineTokensBuilder,d=this._lines.length;let S=0;const R=new l;for(;this._tokenizationStateStore.invalidLineStartIndex<d;){const z=this._tokenizationStateStore.invalidLineStartIndex;if(S++,S>200)break;const a=this._lines[z],f=this._tokenizationStateStore.getBeginState(z),_=this._tokenizationStateStore.tokenizationSupport.tokenizeEncoded(a,!0,f);if(this._tokenizationStateStore.setEndState(d,z,_.endState)){const A=(0,w.diffStateStacksRefEq)(f,_.endState);R.setState(z+1,A)}if(h.LineTokens.convertToEndOffset(_.tokens,a.length),o.add(z+1,_.tokens),new Date().getTime()-T>20)break}if(S===0)break;const N=R.getStateDeltas();if(this._worker.setTokensAndStates(this._uri,this._versionId,o.serialize(),N),new Date().getTime()-T>20){setTimeout(()=>this._tokenize(),3);return}}}}e.TextMateWorkerModel=r;class l{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(T,o){T===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(o):this._stateDeltas.push({startLineNumber:T,stateDeltas:[o]}),this._lastStartLineNumber=T}getStateDeltas(){return this._stateDeltas}}}),define(W[36],j([0,1,10,28,29]),function(p,e,L,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class C{constructor(n,t){this.createData=t,this._models=Object.create(null),this._grammarCache=[],this._host=n.host;const r=t.grammarDefinitions.map(l=>({location:L.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors}));this._grammarFactory=this._loadTMGrammarFactory(r)}async _loadTMGrammarFactory(n){const t=this.createData.textmateMainUri,r=await new Promise((d,S)=>{p([t],d,S)}),l=await new Promise((d,S)=>{p([this.createData.onigurumaMainUri],d,S)}),T=await(await fetch(this.createData.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(T);const o=Promise.resolve({createOnigScanner:d=>l.createOnigScanner(d),createOnigString:d=>l.createOnigString(d)});return new y.TMGrammarFactory({logTrace:d=>{},logError:(d,S)=>console.error(d,S),readFile:d=>this._host.readFile(d)},n,r,o)}acceptNewModel(n){const t=L.URI.revive(n.uri),r=t.toString();this._models[r]=new w.TextMateWorkerModel(t,n.lines,n.EOL,n.versionId,this,n.languageId,n.encodedLanguageId)}acceptModelChanged(n,t){this._models[n].onEvents(t)}retokenize(n,t,r){this._models[n].retokenize(t,r)}acceptModelLanguageChanged(n,t,r){this._models[n].onLanguageId(t,r)}acceptRemovedModel(n){this._models[n]&&(this._models[n].dispose(),delete this._models[n])}async acceptTheme(n,t){(await this._grammarFactory)?.setTheme(n,t)}async getOrCreateGrammar(n,t){const r=await this._grammarFactory;return r?(this._grammarCache[t]||(this._grammarCache[t]=r.createGrammar(n,t)),this._grammarCache[t]):Promise.resolve(null)}setTokensAndStates(n,t,r,l){this._host.setTokensAndStates(n,t,r,l)}}e.TextMateTokenizationWorker=C;function i(h,n){return new C(h,n)}e.create=i})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/22a808587994126e19125c6a1a03c00b990223f4/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
